-- THIS FILE IS CREATED BY ANI K FOR MIGRATION FROM RPM VERSION 6.0 TO RPM VERSION 6.1
-- THIS IS CLEAN ONE SHOT VERSION OF migration_50_to_52.sql, AND CONTAINS MULTIPLE MIGRATIONS OF ONE TABLE IN ONE
-- USER SHOULD USE THIS FILE TO UPGRADE THE DATABASE FROM RPM VERSION 6.0 TO RPM VERSION 6.1

--DO NOT CHANGE THIS FILE UPDATE YOUR MODIFICATIONS IN migration_50_to_52.sql, AND I WILL UPDATE THIS FILLE!

--THERE ARE SOME STEPS TO FOLLOW TO DO THE MIGARTION FROM 6000 TO 6100 WHICH ARE INCLUDED IN STEPS_FOR_MIGRATION_FROM_6000_TO_6100.doc

-- BEFORE DOING A BUILD WITH NEW CODE, THIS MIGRATION SCRIPT HAS TO BE RUN 

-- REPLACE DBNAME with the name of the database you are running this script against, USERNAME with username YOU are using to connect to the database, and USERPASSWD with your password
CONNECT TO DBNAME USER USERNAME USING USERPASSWD;  

-- REPLACE DBSCHEMA with the schema of your database
SET CURRENT SCHEMA DBSCHEMA;





-- DROP ALL THE TRIGGERS BEFORE RUNNING THIS MIGRATION FILE USING DROP_TRIGGERS.sql in DDL FOLDER IN SOURCE SAFE


-- TMT_CHARGECODES


DROP INDEX TCHCD_ENID_XU;
DROP INDEX TCHCD_RK_CU;                
DROP INDEX TCHCD_ACCC_CU;
DROP INDEX TCHAODE_NID_XX;


CREATE TABLE TEMP_TMT_CHARGECODES  (
		  LEVEL_ID INTEGER NOT NULL ,
		  TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		  MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		  CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  ELEMENT_ID CHAR(32) ,
		  ELEMENT_NAME CHAR(50) ,
		  PARENT_ID CHAR(32) ,
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'I',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  BILLABLE SMALLINT WITH DEFAULT 0,
		  RANK VARCHAR(128) NOT NULL ,
		  CAPITAL_EXPENSE SMALLINT  WITH DEFAULT 0,
		  ASSOCIATE_CHARGECODE_ID CHAR(32),
		  DESCRIPTION VARCHAR(2048),
		  CAPITAL_EXPENSE_ID CHAR(32),
		  STAGE_ID INTEGER,
		  EXTERNAL_IDENTIFIER VARCHAR(32))
		IN ALL32K INDEX IN TS_INDEX ;

ALTER TABLE TEMP_TMT_CHARGECODES PCTFREE 30;

INSERT INTO TEMP_TMT_CHARGECODES
(
  LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  BILLABLE,
  RANK,
  CAPITAL_EXPENSE,
  ASSOCIATE_CHARGECODE_ID,
  DESCRIPTION,
  CAPITAL_EXPENSE_ID
)
SELECT
  LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  BILLABLE,
  RANK,
  CAPITAL_EXPENSE,
  ASSOCIATE_CHARGECODE_ID,
  DESCRIPTION,
  CAPITAL_EXPENSE_ID
FROM TMT_CHARGECODES;


RENAME TABLE TMT_CHARGECODES TO OLD_TMT_CHARGECODES;
RENAME TABLE TEMP_TMT_CHARGECODES TO TMT_CHARGECODES;

CREATE UNIQUE INDEX TCHCD_ENID_XU ON TMT_CHARGECODES
		(ELEMENT_ID ASC,
		 PARENT_ID ASC)
		INCLUDE (ELEMENT_NAME ASC) ;


CREATE UNIQUE INDEX TCHCD_RK_CU ON TMT_CHARGECODES
	(RANK ASC) INCLUDE(TYPE_ID,LEVEL_ID) 
	CLUSTER MINPCTUSED 10 
	PCTFREE 30;                

CREATE INDEX TCHCD_ACCC_CU ON TMT_CHARGECODES
		(ASSOCIATE_CHARGECODE_ID ASC);

CREATE INDEX TCHAODE_NID_XX ON TMT_CHARGECODES(PARENT_ID) MINPCTUSED 10 PCTFREE 30;        



DELETE FROM TMT_CHARGECODES WHERE RANK LIKE '!!!!!!!3%';

INSERT INTO TMT_CHARGECODES(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,BILLABLE,RANK,CAPITAL_EXPENSE,ASSOCIATE_CHARGECODE_ID,DESCRIPTION,CAPITAL_EXPENSE_ID, STAGE_ID, EXTERNAL_IDENTIFIER) VALUES(0,64,0,0,0,'CUSTOM_CHARGE_CODES_FOLDER______','Custom Charge Codes',null,'PMO_SYSTEM','I','2001-02-06 11:52:48.555001',0,'!!!!!!!3',0,null,null,null, 6800, 'Custom Charge Codes');

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 11 WHERE ELEMENT_ID = 'EXPENSE_HOURS';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 12 WHERE ELEMENT_ID = 'EXPENSE_AVERAGE_COST';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 13 WHERE ELEMENT_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 14 WHERE ELEMENT_ID = 'EXPENSE_LABOR';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 14 WHERE ELEMENT_ID = 'EXPENSE_CONTRACTOR_LABOR';

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 21 WHERE ELEMENT_ID = 'CAPITAL_HOURS';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 22 WHERE ELEMENT_ID = 'CAPITAL_AVERAGE_COST';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 23 WHERE ELEMENT_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 24 WHERE ELEMENT_ID = 'CAPITAL_LABOR';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 24 WHERE ELEMENT_ID = 'CAPITAL_CONTRACTOR_LABOR';

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 31 WHERE ELEMENT_ID = 'BENEFIT_HOURS';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 32 WHERE ELEMENT_ID = 'BENEFIT_AVERAGE_RATE';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 33 WHERE ELEMENT_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 34 WHERE ELEMENT_ID = 'BILLABLE_BENEFIT_LABOR';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 34 WHERE ELEMENT_ID = 'BENEFIT_CONTRACTOR_LABOR';

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 10 WHERE ELEMENT_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';

UPDATE TMT_CHARGECODES SET STAGE_ID = 6801 WHERE STAGE_ID IS NULL AND TYPE_ID = 8;

-- TASK_ASSIGNMENTS



DROP INDEX TKASG_GID_XX; 
DROP INDEX TKASG_OID_BF_XX; 
DROP INDEX TKASG_PJRID_CX; 
DROP INDEX TKASG_PJTRID_BF_CX; 
DROP INDEX TKASG_RID_XX;
DROP INDEX TKASG_TAID_XX;
DROP INDEX TKASG_TRID_RT_XX;

CREATE TABLE NEW_TASK_ASSIGNMENTS  (
	TSK_ASSIGNMENT_ID CHAR(32) NOT NULL WITH DEFAULT ' ' , 
	RES_ASSIGNMENT_ID CHAR(32) NOT NULL WITH DEFAULT ' ' , 
	PROJECT_ID CHAR(32) NOT NULL WITH DEFAULT ' ' , 
	TASK_ID CHAR(32) NOT NULL WITH DEFAULT ' ' , 
	RESOURCE_ID CHAR(32) , 
	RESOURCE_TYPE CHAR(1) NOT NULL WITH DEFAULT '0' , 
	ACCEPTED_DATE DATE , 
	ESTIMATE INTEGER NOT NULL WITH DEFAULT 0 , 
	BEST INTEGER NOT NULL WITH DEFAULT 0 , 
	BIT_FLAG CHAR(1) NOT NULL WITH DEFAULT '0' , 
	ASSIGN_STRING VARCHAR(8192) , 
	SD SMALLINT , 
	FD SMALLINT , 
	START_DT TIMESTAMP , 
	FINISH_DT TIMESTAMP , 
	DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	REGULAR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	SPECIAL_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE1_START TIMESTAMP , 
	BASELINE1_FINISH TIMESTAMP , 
	BASELINE1_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE1_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE1_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE1_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE2_START TIMESTAMP , 
	BASELINE2_FINISH TIMESTAMP , 
	BASELINE2_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE2_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE2_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE2_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE3_START TIMESTAMP , 
	BASELINE3_FINISH TIMESTAMP , 
	BASELINE3_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE3_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE3_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE3_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	B_REGULAR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	B_SPECIAL_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	B_REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	B_SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	PLANNED_START TIMESTAMP , 
	PLANNED_FINISH TIMESTAMP , 
	PLANNED_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	PLANNED_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	PLANNED_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	PLANNED_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	PROPOSED_START TIMESTAMP , 
	PROPOSED_FINISH TIMESTAMP , 
	PROPOSED_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	PROPOSED_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	PROPOSED_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	PROPOSED_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	SCHED_START TIMESTAMP , 
	SCHED_FINISH TIMESTAMP , 
	SCHED_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	SCHED_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	SCHED_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	SCHED_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	FORECAST_START TIMESTAMP , 
	FORECAST_FINISH TIMESTAMP , 
	FORECAST_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	ETC BIGINT NOT NULL WITH DEFAULT 0 , 
	FORECAST_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	FORECAST_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_START TIMESTAMP , 
	ACTUAL_FINISH TIMESTAMP , 
	ACTUAL_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	REGULAR_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	SPECIAL_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	BILLABLE SMALLINT NOT NULL WITH DEFAULT 1 , 
	BILLABLE_WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	BILLABLE_REGULAR_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	BILLABLE_SPECIAL_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	ACTUAL_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	MILESTONE_PERCENT SMALLINT NOT NULL WITH DEFAULT 0 , 
	LAST_SUBMITTED DATE , 
	BASELINE_WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	ACTIVITY_COUNT SMALLINT NOT NULL WITH DEFAULT 0 , 
	T_UNIT SMALLINT NOT NULL WITH DEFAULT 0 , 
	C_EFFORT INTEGER NOT NULL WITH DEFAULT 0 , 
	C_UNIT SMALLINT NOT NULL WITH DEFAULT 0 , 
	C_OCCURRENCE SMALLINT NOT NULL WITH DEFAULT 0 , 
	C_CONTOUR INTEGER NOT NULL WITH DEFAULT 0 , 
	CONTOUR_TYPE INTEGER NOT NULL WITH DEFAULT 0 , 
	UNITS_MSP INTEGER NOT NULL WITH DEFAULT 10000 , 
	BAK_START_DT TIMESTAMP , 
	BAK_FINISH_DT TIMESTAMP , 
	BAK_WORK INTEGER NOT NULL WITH DEFAULT 0 , 
	BAK_ASSIGN_STRING VARCHAR(8192) , 
	TIMECODE2_ID CHAR(32) , 
	PROJECT_ASSIGNMENT_ID VARCHAR(32) , 
	TABLE_TYPE SMALLINT NOT NULL WITH DEFAULT 0 , 
	ROLLUP_BITS INTEGER NOT NULL WITH DEFAULT 1052679 , 
	UNRESOLVED_START TIMESTAMP , 
	UNRESOLVED_FINISH TIMESTAMP , 
	UNRESOLVED_DURATION INTEGER NOT NULL WITH DEFAULT 0 , 
	ESTIMATION_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ESTIMATION_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ESTIMATION_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE1_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	SCHED_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	FORECAST_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	PLANNED_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	PROPOSED_LABOR_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	LEVEL_START TIMESTAMP , 
	LEVEL_FINISH TIMESTAMP , 
	LEVEL_EFFORT BIGINT WITH DEFAULT 0 , 
	CONSIDER SMALLINT NOT NULL WITH DEFAULT 0 , 
	LEVEL_ASSIGN_STRING VARCHAR(8192) , 
	CAPITAL_EXPENSE SMALLINT WITH DEFAULT 0 , 
	BASELINE3_SCH_FLAG SMALLINT NOT NULL WITH DEFAULT 0 , 
	RATES_EDITED SMALLINT WITH DEFAULT 0 , 
	TIMECODE_1_ID VARCHAR(32) , 
	TIMECODE_2_ID VARCHAR(32) , 
	ASSIGNMENT_DELAY BIGINT WITH DEFAULT 0 , 
	REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP , 
	ASSIGN_UNITS INTEGER NOT NULL WITH DEFAULT 0 , 
	LAST_SCHED_MIN INTEGER NOT NULL WITH DEFAULT 0 , 
	RATE_ADJUSTMENT INTEGER WITH DEFAULT 10000 , 
	REC_STATUS CHAR(1) , 
	REC_USER CHAR(32) , 
	LABOR_COST_CC_ID CHAR(32) , 
	LABOR_REVENUE_CC_ID CHAR(32) , 
	DEFAULT_LABOR_FLAG CHAR(1) NOT NULL WITH DEFAULT 'N' , 
	COST_CENTER_BITS INTEGER NOT NULL WITH DEFAULT 1 , 
	CREDIT_COUNT SMALLINT NOT NULL WITH DEFAULT 0,
	BAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BCWS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BCWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ACWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	EV_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	EAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTRACT_ID CHAR(32))   
IN ALL32K INDEX IN TS_INDEX ; 
ALTER TABLE NEW_TASK_ASSIGNMENTS PCTFREE 30;

-- Transfer data
INSERT INTO NEW_TASK_ASSIGNMENTS (
	ACCEPTED_DATE,            
	ACTIVITY_COUNT,           
	ACTUAL_DURATION,          
	ACTUAL_FINISH,            
	ACTUAL_LABOR_COST,        
	ACTUAL_LABOR_REVENUE,     
	ACTUAL_LABOR_SAVING,      
	ACTUAL_START,             
	ASSIGNMENT_DELAY,         
	ASSIGN_STRING,            
	ASSIGN_UNITS,             
	BAK_ASSIGN_STRING,        
	BAK_FINISH_DT,            
	BAK_START_DT,             
	BAK_WORK,                 
	BASELINE1_DURATION,       
	BASELINE1_FINISH,         
	BASELINE1_LABOR_COST,     
	BASELINE1_LABOR_REVENUE,  
	BASELINE1_LABOR_SAVING,   
	BASELINE1_START,          
	BASELINE1_WORK,           
	BASELINE2_DURATION,       
	BASELINE2_FINISH,         
	BASELINE2_LABOR_COST,     
	BASELINE2_LABOR_REVENUE,  
	BASELINE2_START,          
	BASELINE2_WORK,           
	BASELINE3_DURATION,       
	BASELINE3_FINISH,         
	BASELINE3_LABOR_COST,     
	BASELINE3_LABOR_REVENUE,  
	BASELINE3_SCH_FLAG,       
	BASELINE3_START,          
	BASELINE3_WORK,           
	BASELINE_WORK_TODATE,     
	BEST,                     
	BILLABLE,                 
	BILLABLE_REGULAR_TODATE,  
	BILLABLE_SPECIAL_TODATE,  
	BILLABLE_WORK_TODATE,     
	BIT_FLAG,                 
	B_REGULAR_COST,           
	B_REGULAR_RATE,           
	B_SPECIAL_COST,           
	B_SPECIAL_RATE,           
	CAPITAL_EXPENSE,          
	CONSIDER,                 
	CONTOUR_TYPE,            
	C_CONTOUR,                
	C_EFFORT,                 
	C_OCCURRENCE,             
	C_UNIT,        
	DURATION,                 
	ESTIMATE,                 
	ESTIMATION_LABOR_COST,    
	ESTIMATION_LABOR_REVENUE, 
	ESTIMATION_LABOR_SAVING,  
	ETC,                      
	FD,                       
	FINISH_DT,                
	FORECAST_DURATION,        
	FORECAST_FINISH,          
	FORECAST_LABOR_COST,      
	FORECAST_LABOR_REVENUE,   
	FORECAST_LABOR_SAVING,    
	FORECAST_START,      
	LAST_SCHED_MIN,           
	LAST_SUBMITTED,           
	LEVEL_ASSIGN_STRING,      
	LEVEL_EFFORT,             
	LEVEL_FINISH,             
	LEVEL_START,              
	MILESTONE_PERCENT,        
	PLANNED_DURATION,         
	PLANNED_FINISH,           
	PLANNED_LABOR_COST,       
	PLANNED_LABOR_REVENUE,    
	PLANNED_LABOR_SAVING,     
	PLANNED_START,            
	PLANNED_WORK,             
	PROJECT_ASSIGNMENT_ID,    
	PROJECT_ID,               
	PROPOSED_DURATION,        
	PROPOSED_FINISH,          
	PROPOSED_LABOR_COST,      
	PROPOSED_LABOR_REVENUE,   
	PROPOSED_LABOR_SAVING,    
	PROPOSED_START,           
	PROPOSED_WORK,            
	RATES_EDITED,             
	RATE_ADJUSTMENT,          
	REC_DATETIME,             
	REC_STATUS,               
	REC_USER,                 
	REGULAR_COST,             
	REGULAR_RATE,             
	REGULAR_TODATE,           
	RESOURCE_ID,              
	RESOURCE_TYPE,            
	RES_ASSIGNMENT_ID,        
	ROLLUP_BITS,              
	SCHED_DURATION,           
	SCHED_FINISH,             
	SCHED_LABOR_COST,         
	SCHED_LABOR_REVENUE,      
	SCHED_LABOR_SAVING,       
	SCHED_START,              
	SCHED_WORK,               
	SD,                       
	SPECIAL_COST,             
	SPECIAL_RATE,             
	SPECIAL_TODATE,           
	START_DT,                 
	TABLE_TYPE,               
	TASK_ID,                  
	TIMECODE2_ID,             
	TIMECODE_1_ID,            
	TIMECODE_2_ID,            
	TSK_ASSIGNMENT_ID,        
	T_UNIT,                   
	UNITS_MSP,                
	UNRESOLVED_DURATION,      
	UNRESOLVED_FINISH,        
	UNRESOLVED_START,         
	WORK_TODATE,
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC )   
SELECT 	ACCEPTED_DATE,            
	ACTIVITY_COUNT,           
	ACTUAL_DURATION,          
	ACTUAL_FINISH,            
	ACTUAL_LABOR_COST,        
	ACTUAL_LABOR_REVENUE,     
	ACTUAL_LABOR_SAVING,      
	ACTUAL_START,             
	ASSIGNMENT_DELAY,         
	ASSIGN_STRING,            
	ASSIGN_UNITS,             
	BAK_ASSIGN_STRING,        
	BAK_FINISH_DT,            
	BAK_START_DT,             
	BAK_WORK,                 
	BASELINE1_DURATION,       
	BASELINE1_FINISH,         
	BASELINE1_LABOR_COST,     
	BASELINE1_LABOR_REVENUE,  
	BASELINE1_LABOR_SAVING,   
	BASELINE1_START,          
	BASELINE1_WORK,           
	BASELINE2_DURATION,       
	BASELINE2_FINISH,         
	BASELINE2_LABOR_COST,     
	BASELINE2_LABOR_REVENUE,  
	BASELINE2_START,          
	BASELINE2_WORK,           
	BASELINE3_DURATION,       
	BASELINE3_FINISH,         
	BASELINE3_LABOR_COST,     
	BASELINE3_LABOR_REVENUE,  
	BASELINE3_SCH_FLAG,       
	BASELINE3_START,          
	BASELINE3_WORK,           
	BASELINE_WORK_TODATE,     
	BEST,                     
	BILLABLE,                 
	BILLABLE_REGULAR_TODATE,  
	BILLABLE_SPECIAL_TODATE,  
	BILLABLE_WORK_TODATE,     
	BIT_FLAG,                 
	B_REGULAR_COST,           
	B_REGULAR_RATE,           
	B_SPECIAL_COST,           
	B_SPECIAL_RATE,           
	CAPITAL_EXPENSE,          
	CONSIDER,                 
	CONTOUR_TYPE,        
	C_CONTOUR,                
	C_EFFORT,                 
	C_OCCURRENCE,             
	C_UNIT,          
	DURATION,                 
	ESTIMATE,                 
	ESTIMATION_LABOR_COST,    
	ESTIMATION_LABOR_REVENUE, 
	ESTIMATION_LABOR_SAVING,  
	ETC,                      
	FD,                       
	FINISH_DT,                
	FORECAST_DURATION,        
	FORECAST_FINISH,          
	FORECAST_LABOR_COST,      
	FORECAST_LABOR_REVENUE,   
	FORECAST_LABOR_SAVING,    
	FORECAST_START,     
	LAST_SCHED_MIN,           
	LAST_SUBMITTED,           
	LEVEL_ASSIGN_STRING,      
	LEVEL_EFFORT,             
	LEVEL_FINISH,             
	LEVEL_START,              
	MILESTONE_PERCENT,        
	PLANNED_DURATION,         
	PLANNED_FINISH,           
	PLANNED_LABOR_COST,       
	PLANNED_LABOR_REVENUE,    
	PLANNED_LABOR_SAVING,     
	PLANNED_START,            
	PLANNED_WORK,             
	PROJECT_ASSIGNMENT_ID,    
	PROJECT_ID,               
	PROPOSED_DURATION,        
	PROPOSED_FINISH,          
	PROPOSED_LABOR_COST,      
	PROPOSED_LABOR_REVENUE,   
	PROPOSED_LABOR_SAVING,    
	PROPOSED_START,           
	PROPOSED_WORK,            
	RATES_EDITED,             
	RATE_ADJUSTMENT,          
	REC_DATETIME,             
	REC_STATUS,               
	REC_USER,                 
	REGULAR_COST,             
	REGULAR_RATE,             
	REGULAR_TODATE,           
	RESOURCE_ID,              
	RESOURCE_TYPE,            
	RES_ASSIGNMENT_ID,        
	ROLLUP_BITS,              
	SCHED_DURATION,           
	SCHED_FINISH,             
	SCHED_LABOR_COST,         
	SCHED_LABOR_REVENUE,      
	SCHED_LABOR_SAVING,       
	SCHED_START,              
	SCHED_WORK,               
	SD,                       
	SPECIAL_COST,             
	SPECIAL_RATE,             
	SPECIAL_TODATE,           
	START_DT,                 
	TABLE_TYPE,               
	TASK_ID,                  
	TIMECODE2_ID,             
	TIMECODE_1_ID,            
	TIMECODE_2_ID,            
	TSK_ASSIGNMENT_ID,        
	T_UNIT,                   
	UNITS_MSP,                
	UNRESOLVED_DURATION,      
	UNRESOLVED_FINISH,        
	UNRESOLVED_START,         
	WORK_TODATE, 
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC 
FROM TASK_ASSIGNMENTS; 	

-- Rename tables
RENAME TABLE TASK_ASSIGNMENTS TO OLD_TASK_ASSIGNMENTS;
RENAME TABLE NEW_TASK_ASSIGNMENTS TO TASK_ASSIGNMENTS;

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE INDEX TKASG_GID_XX ON TASK_ASSIGNMENTS 
	(RES_ASSIGNMENT_ID ASC);

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE INDEX TKASG_OID_BF_XX ON TASK_ASSIGNMENTS 
	(PROJECT_ASSIGNMENT_ID ASC,
	BIT_FLAG ASC);

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE INDEX TKASG_PJRID_CX ON TASK_ASSIGNMENTS 
	(PROJECT_ID ASC,
	RESOURCE_ID ASC,
	BIT_FLAG ASC)
	PCTFREE 30 ;

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE INDEX TKASG_PJTRID_BF_CX ON TASK_ASSIGNMENTS 
	(PROJECT_ID ASC,
	TASK_ID ASC,
	RESOURCE_ID ASC,
	BIT_FLAG ASC)
	PCTFREE 30 CLUSTER ;

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE INDEX TKASG_RID_XX ON TASK_ASSIGNMENTS 
	(RESOURCE_ID ASC);

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE UNIQUE INDEX TKASG_TAID_XX ON TASK_ASSIGNMENTS 
	(TSK_ASSIGNMENT_ID ASC)
	INCLUDE (BIT_FLAG ASC) ;

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

CREATE INDEX TKASG_TRID_RT_XX ON TASK_ASSIGNMENTS 
	(TASK_ID ASC,
	RESOURCE_ID ASC,
	RESOURCE_TYPE ASC);
	
-- IF SUCCESSFUL DROP TABLE OLD_TASK_ASSIGNMENTS;

	
UPDATE TASK_ASSIGNMENTS SET LABOR_COST_CC_ID = 'EXPENSE_LABOR' WHERE CAPITAL_EXPENSE = 0;
UPDATE TASK_ASSIGNMENTS SET LABOR_COST_CC_ID = 'CAPITAL_LABOR' WHERE CAPITAL_EXPENSE = 1;
UPDATE TASK_ASSIGNMENTS SET LABOR_REVENUE_CC_ID = 'BILLABLE_BENEFIT_LABOR' WHERE BILLABLE = 1;
UPDATE TASK_ASSIGNMENTS SET LABOR_REVENUE_CC_ID = NULL WHERE BILLABLE = 0;


-- BUDGETS



DROP INDEX BDGTS_EBCID_CU;
DROP INDEX BDGTS_BID_XX;
DROP INDEX BDGTS_CID_XX;
DROP INDEX BUDGET_CHRGEID_XXX;

CREATE TABLE BUDGETS2 (
	PROJECT_ID CHAR(32) NOT NULL,
	ELEMENT_ID CHAR(32) NOT NULL,
	CHARGECODE_ID CHAR(32) NOT NULL,
	BUDGET_ID CHAR(32) NOT NULL,
	ASSOCIATE_BUDGET_ID CHAR(32),
	TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
	CREATED_BY CHAR(32) NOT NULL,
	REC_USER CHAR(32) NOT NULL ,
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
	REC_DATETIME TIMESTAMP WITH DEFAULT CURRENT TIMESTAMP,
	TOTAL_ESTIMATION_PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	TOTAL_BUDGET_PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	PROB_PERCENT INTEGER WITH DEFAULT 10000,
	PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	PAID_TODATE DECIMAL (18,2) WITH DEFAULT 0.00,
	AUTO_FLAG SMALLINT NOT NULL WITH DEFAULT 1,
	ACTUAL_EDITED SMALLINT NOT NULL WITH DEFAULT 1,
	ROLLUP_BITS INTEGER NOT NULL WITH DEFAULT 0,
	TIMEPHASED_BITS INTEGER NOT NULL WITH DEFAULT 0,
	TIMEPHASED_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
	DATAFIELD_1 INTEGER,
	DATAFIELD_2 INTEGER,
	TXT_FIELD_01 VARCHAR(1024),
	TXT_FIELD_02 VARCHAR(1024),
	TXT_FIELD_03 VARCHAR(1024),
	TXT_FIELD_04 VARCHAR(1024),
	TXT_FIELD_05 VARCHAR(1024),
	TXT_FIELD_06 VARCHAR(1024),
	TXT_FIELD_07 VARCHAR(1024),
	TXT_FIELD_08 VARCHAR(1024),
	TXT_FIELD_09 VARCHAR(1024),
	TXT_FIELD_10 VARCHAR(1024),
	TOLERANCE INTEGER WITH DEFAULT 10000,
	ESTIMATED_ACTUAL_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_ETC_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PAID_TODATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PAID_TODATE_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PROB_AMOUNT_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BASELINE3_SCH_FLAG SMALLINT DEFAULT 0 NOT NULL,
	BASELINE3_EST_FLAG SMALLINT DEFAULT 0 NOT NULL,
	DATAFIELD_3 INTEGER,
	DATAFIELD_4 INTEGER,
	ACTUAL_TIMEPHASED_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
	CAPITAL_EXPENSE SMALLINT NOT NULL WITH DEFAULT 0,                      
	BILLABLE SMALLINT NOT NULL WITH DEFAULT 1,                             
	COST_CENTER_BITS INTEGER NOT NULL WITH DEFAULT 0,                      
	CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,                      
	LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,                       
	ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,            
	ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,             
	ESTIMATED_CHARGED_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,      
	ESTIMATED_LEDGER_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CONTINGENCY_ETC_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00        
)
IN ALL32K INDEX IN TS_INDEX ;
ALTER TABLE BUDGETS2 PCTFREE 30;

ALTER TABLE BUDGETS2 VOLATILE CARDINALITY;

CREATE UNIQUE INDEX BDGTS_EBCID_CU ON BUDGETS2 (PROJECT_ID ASC, ELEMENT_ID ASC, CHARGECODE_ID ASC) INCLUDE(BUDGET_ID, ASSOCIATE_BUDGET_ID) CLUSTER MINPCTUSED 10 PCTFREE 30;

CREATE UNIQUE INDEX BDGTS_BID_XX ON BUDGETS2 (BUDGET_ID ASC) INCLUDE(PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, ASSOCIATE_BUDGET_ID);

CREATE INDEX BDGTS_CID_XX ON BUDGETS2 (PROJECT_ID, CHARGECODE_ID ASC);

CREATE INDEX BUDGET_CHRGEID_XXX ON BUDGETS (CHARGECODE_ID) MINPCTUSED 10 PCTFREE 30;
INSERT INTO BUDGETS2 (TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG,
CONTINGENCY_BASELINE1,
	CONTINGENCY_BASELINE2,
	CONTINGENCY_BASELINE3,
	CONTINGENCY_TOTAL,
	CONTINGENCY_BUDGET,
	CONTINGENCY_ETC,
	CONTINGENCY_ETC_TOTAL)
SELECT TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG,
CONTINGENCY_BASELINE1,
	CONTINGENCY_BASELINE2,
	CONTINGENCY_BASELINE3,
	CONTINGENCY_TOTAL,
	CONTINGENCY_BUDGET,
	CONTINGENCY_ETC,
	CONTINGENCY_ETC_TOTAL FROM BUDGETS;

RENAME BUDGETS TO BUDGETS1;
RENAME BUDGETS2 TO BUDGETS;

-- IF SUCCESSFULl DROP TABLE BUDGETS1;


UPDATE BUDGETS B SET (B.CAPITAL_EXPENSE, B.BILLABLE) = (SELECT CC.CAPITAL_EXPENSE, CC.BILLABLE FROM TMT_CHARGECODES CC WHERE CC.ELEMENT_ID = B.CHARGECODE_ID)
WHERE EXISTS (select C.* from TMT_CHARGECODES C WHERE  B.CHARGECODE_ID=C.ELEMENT_ID);

UPDATE BUDGETS 
SET CAPITAL_EXPENSE = 10
WHERE CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';


-- PROJECT_DETAILS

ALTER TABLE PROJECT_DETAILS ADD COLUMN DLV_BUDGET_SETTING_BITS SMALLINT NOT NULL WITH DEFAULT 0;
ALTER TABLE PROJECT_DETAILS ADD COLUMN OPPORTUNITY_TRACKING_NUMBER VARCHAR(255);
ALTER TABLE PROJECT_DETAILS ADD COLUMN OPPORTUNITY_OWNER VARCHAR(255);
ALTER TABLE PROJECT_DETAILS ADD COLUMN CONTRACT_TYPE VARCHAR(100);
ALTER TABLE PROJECT_DETAILS ADD COLUMN CONTACT_NUMBER VARCHAR(100);
ALTER TABLE PROJECT_DETAILS ADD COLUMN CUSTOMER_NUMBER VARCHAR(100);

ALTER TABLE PROJECT_DETAILS ADD COLUMN OPPORTUNITY_NAME VARCHAR(255);
ALTER TABLE PROJECT_DETAILS ADD COLUMN EXPECTED_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00;
ALTER TABLE PROJECT_DETAILS ADD COLUMN EXPECTED_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00;
ALTER TABLE PROJECT_DETAILS ADD COLUMN EXPECTED_PAYBACK_PERIOD INTEGER NOT NULL WITH DEFAULT 0;
ALTER TABLE PROJECT_DETAILS ADD COLUMN EXPECTED_PAYBACK_MONTH INTEGER NOT NULL WITH DEFAULT 0;
ALTER TABLE PROJECT_DETAILS ADD COLUMN PURSUIT_START DATE;
ALTER TABLE PROJECT_DETAILS ADD COLUMN PURSUIT_FINISH DATE;
ALTER TABLE PROJECT_DETAILS ADD COLUMN FORECAST_CLOSED DATE;

ALTER TABLE PROJECT_DETAILS ADD COLUMN ATTACHMENT_VIEW_BITS INTEGER WITH DEFAULT 0;

ALTER TABLE PROJECT_DETAILS ADD COLUMN SCENARIO_USER_ID char(32);
ALTER TABLE PROJECT_DETAILS ADD COLUMN RUP_HOME_PATH   VARCHAR(512);



UPDATE PROJECT_DETAILS p 
SET (OPPORTUNITY_NAME, EXPECTED_COST, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH, PURSUIT_START, PURSUIT_FINISH, FORECAST_CLOSED) =
(SELECT OPPORTUNITY_NAME, EXPECTED_COST, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH, PURSUIT_START, PURSUIT_FINISH, FORECAST_CLOSED from tmt_wbs w where w.element_id = p.project_id)
WHERE EXISTS(SELECT W1.PROJECT_ID FROM TMT_WBS W1 WHERE W1.ELEMENT_ID = P.PROJECT_ID);

UPDATE PROJECT_DETAILS SET DLV_BUDGET_SETTING_BITS = BUDGET_SETTING_BITS;



-- TMT_WBS

DROP INDEX TWBSX_EID_XU; 
DROP INDEX TWBSX_FC_XX;
DROP INDEX TWBSX_NID_XX; 
DROP INDEX TWBSX_PJID_XX;
DROP INDEX TWBSX_RK_CU;
DROP INDEX TWBSX_TPID_XX;
DROP INDEX TWBSX_LV_XXXX;
DROP INDEX WBS_POOLID;

CREATE TABLE TMT_WBS2(
		RANK VARCHAR(192) NOT NULL ,
		WBS_CODE VARCHAR(255) ,
		PROJECT_ID CHAR(32) ,
		PARENT_ID CHAR(32) ,
		ELEMENT_ID CHAR(32) ,
		TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		LEVEL_ID INTEGER NOT NULL WITH DEFAULT 0,
		MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		ELEMENT_NAME VARCHAR(255) ,
		REF_CODE VARCHAR(50) ,
		PRIORITY SMALLINT WITH DEFAULT 500,
		PUBLISHED CHAR(1) NOT NULL WITH DEFAULT '0',
		PUBLISHED_BY CHAR(32) ,
		T_PARENT_ID CHAR(32) ,
		T_RANK VARCHAR(192) ,
		CONSTRAINT_TYPE INTEGER WITH DEFAULT 0,
		CONSTRAINT_DT TIMESTAMP ,
		CURRENCY_ID INTEGER WITH DEFAULT 0,
		CALENDAR_ID CHAR(32) ,
		MINUTE_PER_DAY SMALLINT WITH DEFAULT 480,
		MINUTE_PER_WEEK SMALLINT WITH DEFAULT 2400,
		METHOD INTEGER WITH DEFAULT 0,
		BUFFER_PERCENT SMALLINT NOT NULL WITH DEFAULT 0,
		START_FINISH_FLAG CHAR(1) WITH DEFAULT '0',
		START_FINISH_DATE DATE ,
		SD SMALLINT NOT NULL WITH DEFAULT 11,
		FD SMALLINT NOT NULL WITH DEFAULT 12,
		START_DT TIMESTAMP ,
		FINISH_DT TIMESTAMP ,
		BASELINE1_START TIMESTAMP ,
		BASELINE1_FINISH TIMESTAMP ,
		BASELINE2_START TIMESTAMP ,
		BASELINE2_FINISH TIMESTAMP ,
		BASELINE3_START TIMESTAMP ,
		BASELINE3_FINISH TIMESTAMP ,
		PLANNED_START TIMESTAMP ,
		PLANNED_FINISH TIMESTAMP ,
		PROPOSED_START TIMESTAMP ,
		PROPOSED_FINISH TIMESTAMP ,
		SCHED_START TIMESTAMP ,
		SCHED_FINISH TIMESTAMP ,
		FORECAST_START TIMESTAMP ,
		FORECAST_FINISH TIMESTAMP ,
		ACTUAL_START TIMESTAMP ,
		ACTUAL_FINISH TIMESTAMP ,
		UNRESOLVED_DURATION INTEGER WITH DEFAULT 0,
		DURATION INTEGER WITH DEFAULT 0,
		PLANNED_DURATION INTEGER WITH DEFAULT 0,
		PROPOSED_DURATION INTEGER WITH DEFAULT 0,
		SCHED_DURATION INTEGER WITH DEFAULT 0,
		FORECAST_DURATION INTEGER WITH DEFAULT 0,
		ACTUAL_DURATION INTEGER WITH DEFAULT 0,
		BASELINE1_DURATION INTEGER WITH DEFAULT 0,
		BASELINE2_DURATION INTEGER WITH DEFAULT 0,
		BASELINE3_DURATION INTEGER WITH DEFAULT 0,
		VARIANCE INTEGER WITH DEFAULT 0,
		FORECAST_VARIANCE INTEGER WITH DEFAULT 0,
		ACTUAL_VARIANCE INTEGER WITH DEFAULT 0,
		BASELINE1_VARIANCE INTEGER WITH DEFAULT 0,
		PLANNED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		PROPOSED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		SCHED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		FORECAST_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		ACTUAL_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		BASELINE1_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		BASELINE2_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		BASELINE3_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		WORK_TODATE BIGINT NOT NULL WITH DEFAULT 0,
		ETC BIGINT NOT NULL WITH DEFAULT 0,
		CREATED_BY CHAR(32) ,
		CREATED_DT TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		PROBABILITY INTEGER WITH DEFAULT 100,
		STAGE_ID INTEGER WITH DEFAULT 740,
		MILESTONE_PERCENT SMALLINT NOT NULL WITH DEFAULT 0,
		REC_USER CHAR(32) ,
		REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		LAST_WF_TYPE VARCHAR(110) ,
		LAST_WF_BY CHAR(50) ,
		LAST_WF_DT TIMESTAMP ,
		MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		REVISION_IMPACT INTEGER WITH DEFAULT 137,
		REVISION_TYPE INTEGER WITH DEFAULT 920,
		REVISION_HISTORY VARCHAR(255) WITH DEFAULT 'CREATED',
		CLOSED_BY CHAR(32) ,
		TOOLTIP_DESCR VARCHAR(255) WITH DEFAULT NULL,
		TOTAL_SLACK INTEGER ,
		FREE_SLACK INTEGER ,
		CRITICAL CHAR(1) ,
		ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		DEPENDENCIES VARCHAR(8192) ,
		ROLLUP_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		EV_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		CRI_COUNT INTEGER WITH DEFAULT 0,
		DOC_COUNT INTEGER WITH DEFAULT 0,
		MSP_ID INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE_WORK_TODATE BIGINT NOT NULL WITH DEFAULT 0,
		ASSIGN_COUNT SMALLINT NOT NULL WITH DEFAULT 0,
		ASSIGN_NAMES VARCHAR(2048) ,
		RTF_BITS INTEGER DEFAULT 0,
		LAST_CHECKIN TIMESTAMP ,
		BAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BCWS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BCWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ACWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		TRANSFER_FLAG CHAR(1),
		EFFORT_DRIVEN SMALLINT DEFAULT 1 NOT NULL,
		BUBBLE_COLOR SMALLINT NOT NULL WITH DEFAULT 0,
		BUBBLE_PUBLISHED_DT TIMESTAMP,
		A_CRI_COUNT SMALLINT WITH DEFAULT 0,
		TASK_TYPE SMALLINT NOT NULL WITH DEFAULT 10,
		FS_CODE VARCHAR(50),
		FS_STATE SMALLINT NOT NULL WITH DEFAULT 0,
		FS_LABOR_CODE VARCHAR(50),
		EV_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		REC_FLAGS INTEGER NOT NULL WITH DEFAULT 0,
		ROLLUP_BITS INTEGER NOT NULL WITH DEFAULT 0,
		UNRESOLVED_START TIMESTAMP,
		UNRESOLVED_FINISH TIMESTAMP,
		PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		R_PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		R_PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		EARLY_START TIMESTAMP ,
		LATE_START TIMESTAMP ,
		EARLY_FINISH TIMESTAMP ,
		LATE_FINISH TIMESTAMP ,
		LEVEL_INDEX INTEGER WITH DEFAULT 0,
		CALC_PRIORITY SMALLINT WITH DEFAULT 500,
		LEVEL_CONFLICT VARCHAR (4096),
		LEVEL_START TIMESTAMP ,
		LEVEL_FINISH TIMESTAMP ,
		LEVEL_DURATION INTEGER WITH DEFAULT 0,
		SCORECARD_COUNT INTEGER WITH DEFAULT 0,
		FINISH_START_DATE DATE,
		TOTAL_DURATION BIGINT NOT NULL WITH DEFAULT 0,
		PREVIOUS_WKF_STEP VARCHAR(150),
		DEPEND_FLAG CHARACTER(1) NOT NULL WITH DEFAULT '0',
		START_FINISH_DURATION INTEGER WITH DEFAULT 0,
		CONVERTED_SCORE BIGINT WITH DEFAULT 0,
		CONVERTED_WEIGHT BIGINT WITH DEFAULT 1,
		TIMEPHASED_BITS INTEGER NOT NULL WITH DEFAULT 0,
		ESTIMATED_BASELINE1_START DATE,
		ESTIMATED_BASELINE1_FINISH DATE,
		ESTIMATED_BASELINE2_START DATE,
		ESTIMATED_BASELINE2_FINISH DATE,
		ESTIMATED_BASELINE3_START DATE,
		ESTIMATED_BASELINE3_FINISH DATE,
		ESTIMATED_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_actual_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_etc DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_actual_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_etc DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE1_EST_DT TIMESTAMP,
		BASELINE2_EST_DT TIMESTAMP,
		BASELINE3_EST_DT TIMESTAMP,
		BASELINE1_SCH_DT TIMESTAMP,
		BASELINE2_SCH_DT TIMESTAMP,
		BASELINE3_SCH_DT TIMESTAMP,
		CUSTOM_INT_1 INTEGER DEFAULT 0,
		SUBPROJECT_COUNT INTEGER DEFAULT 0,
		ESTIMATED_BASELINE1_DURATION INTEGER DEFAULT 0 NOT NULL,
		ESTIMATED_BASELINE2_DURATION INTEGER DEFAULT 0 NOT NULL,
		ESTIMATED_BASELINE3_DURATION INTEGER DEFAULT 0 NOT NULL,
		TIMECODE_1_ID VARCHAR(32),
		TIMECODE_2_ID VARCHAR(32),
		RISK_EXPOSURE INTEGER NOT NULL WITH DEFAULT 0,
		CONSEQUENSE_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EAC_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EV_ETC_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		LEVEL_STATE INTEGER WITH DEFAULT 0,
		LEVEL_CONSTRAINT_TYPE INTEGER WITH DEFAULT 0,
		LEVEL_CONSTRAINT_DT VARCHAR(26),
		WORK_PERCENT SMALLINT WITH DEFAULT 0,
		MP_STATUS_DT TIMESTAMP,
		REFERENCE_NUMBER BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20),
		ASSET_ID CHAR(32), 
		ASSET_NAME VARCHAR(50), 
		FINANCIAL_CATEGORY INTEGER DEFAULT 6501,
		POOL_ID CHAR(32),
		ASSET_FLAG INTEGER WITH DEFAULT 0,
		BASELINE3_START_VARIANCE INTEGER WITH DEFAULT 0,
		BASELINE3_FINISH_VARIANCE INTEGER WITH DEFAULT 0,
		ELEMENT_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
		BASELINE_FLAG SMALLINT WITH DEFAULT 0,                        
		CHARGED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,      
		R_CHARGED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,    
		S_CHARGED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,    
		LEDGER_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		R_LEDGER_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,     
		S_LEDGER_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,     
		ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,   
		R_ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
		S_ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
		ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,    
		R_ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,  
		S_ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,  
		BCWS_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		BCWP_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		ACWP_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		TIME_VARIANCE INTEGER NOT NULL WITH DEFAULT 0,
		EXTERNAL_ID VARCHAR(50))
 	IN TS_TMT_WBS INDEX IN IND_WBS ;
 ALTER TABLE TMT_WBS2 PCTFREE 30;

 ALTER TABLE TMT_WBS2 VOLATILE CARDINALITY;

CREATE UNIQUE INDEX TWBSX_EID_XU ON TMT_WBS2
	(ELEMENT_ID ASC)
	INCLUDE
	(ELEMENT_NAME ASC,
	PRIORITY ASC) ;

CREATE INDEX TWBSX_FC_XX ON TMT_WBS2
	(FS_CODE ASC);

CREATE INDEX TWBSX_NID_XX ON TMT_WBS2
	(PARENT_ID ASC);

CREATE INDEX TWBSX_PJID_XX ON TMT_WBS2
	(PROJECT_ID ASC);

CREATE UNIQUE INDEX TWBSX_RK_CU ON TMT_WBS2
	(RANK ASC)
	INCLUDE
	(ELEMENT_ID ASC,
	TYPE_ID ASC)
	CLUSTER MINPCTUSED 10 PCTFREE 30;

CREATE INDEX TWBSX_TPID_XX ON TMT_WBS2
	(T_PARENT_ID ASC);

CREATE INDEX TWBSX_LV_XXXX ON TMT_WBS2
	(PROJECT_ID,LEVEL_STATE ASC);
	
CREATE INDEX WBS_POOLID ON TMT_WBS2
 (POOL_ID ASC, 
 PROJECT_ID ASC, 
 ELEMENT_ID ASC);	


INSERT INTO TMT_WBS2 (ELEMENT_FLAG,
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
EV_ETC,
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE,
EXTERNAL_ID)
(SELECT ELEMENT_FLAG,
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
EV_ETC,
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE, EXTERNAL_ID FROM TMT_WBS);

RENAME TMT_WBS TO TMT_WBS1;
RENAME TMT_WBS2 TO TMT_WBS;

-- IF SUCCESSFULL DROP TABLE TMT_WBS1;

UPDATE TMT_WBS SET BCWS_FORECAST = BCWS, BCWP_FORECAST = BCWP, ACWP_FORECAST = ACWP;

UPDATE TMT_WBS w SET w.BASELINE_FLAG = 3
WHERE w.PROJECT_ID IN (
	SELECT wp.ELEMENT_ID
	FROM TMT_WBS wp
	WHERE wp.PROJECT_ID = w.PROJECT_ID
		AND wp.BASELINE2_SCH_DT IS NOT NULL
		AND wp.BASELINE2_SCH_DT = w.BASELINE2_SCH_DT
		AND wp.TYPE_ID IN (1,154))
AND w.BASELINE2_SCH_DT IS NOT NULL
AND w.TYPE_ID NOT IN (1,154)
AND w.BASELINE_FLAG = 0;

UPDATE TMT_WBS w SET w.BASELINE_FLAG = 2
WHERE w.PROJECT_ID IN (
	SELECT wp.ELEMENT_ID
	FROM TMT_WBS wp
	WHERE wp.PROJECT_ID = w.PROJECT_ID
		AND wp.BASELINE1_SCH_DT IS NOT NULL
		AND wp.BASELINE1_SCH_DT = w.BASELINE3_SCH_DT
		AND wp.TYPE_ID IN (1,154))
AND w.BASELINE3_SCH_DT IS NOT NULL
AND w.TYPE_ID NOT IN (1,154)
AND w.BASELINE_FLAG = 0;

UPDATE TMT_WBS w SET w.BASELINE_FLAG = 4
WHERE w.PROJECT_ID IN (
	SELECT wp.ELEMENT_ID
	FROM TMT_WBS wp
	WHERE wp.PROJECT_ID = w.PROJECT_ID
		AND wp.BASELINE1_SCH_DT IS NOT NULL
		AND wp.BASELINE1_SCH_DT <>w.BASELINE1_SCH_DT
		AND wp.TYPE_ID IN (1,154))
AND w.BASELINE1_SCH_DT IS NOT NULL
AND w.TYPE_ID NOT IN (1,154)
AND w.BASELINE_FLAG = 0;


update tmt_wbs w set start_finish_date = (select p.start_finish_date from tmt_wbs p where p.element_id = w.project_id)
where start_finish_date is null;


-- HISTORY_WBS


DROP INDEX HSWBS_EID_RDT_CX;
DROP INDEX HSWBS_HID_XX; 
DROP INDEX HSWBS_RK_XX; 

 CREATE TABLE HISTORY_WBS2(
		HISTORY_ID CHAR(32) ,
		RANK VARCHAR(192) NOT NULL ,
		WBS_CODE VARCHAR(255) ,
		PROJECT_ID CHAR(32) ,
		PARENT_ID CHAR(32) ,
		ELEMENT_ID CHAR(32) ,
		TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		LEVEL_ID INTEGER NOT NULL WITH DEFAULT 0,
		MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		ELEMENT_NAME VARCHAR(255) ,
		REF_CODE VARCHAR(50) ,
		PRIORITY SMALLINT WITH DEFAULT 500,
		PUBLISHED CHAR(1) NOT NULL WITH DEFAULT '0',
		PUBLISHED_BY CHAR(32) ,
		T_PARENT_ID CHAR(32) ,
		T_RANK VARCHAR(192) ,
		CONSTRAINT_TYPE INTEGER WITH DEFAULT 0,
		CONSTRAINT_DT TIMESTAMP ,
		CURRENCY_ID INTEGER WITH DEFAULT 0,
		CALENDAR_ID CHAR(32) ,
		MINUTE_PER_DAY SMALLINT WITH DEFAULT 480,
		MINUTE_PER_WEEK SMALLINT WITH DEFAULT 2400,
		METHOD INTEGER WITH DEFAULT 0,
		BUFFER_PERCENT SMALLINT NOT NULL WITH DEFAULT 0,
		START_FINISH_FLAG CHAR(1) WITH DEFAULT '0',
		START_FINISH_DATE DATE ,
		SD SMALLINT NOT NULL WITH DEFAULT 11,
		FD SMALLINT NOT NULL WITH DEFAULT 12,
		START_DT TIMESTAMP ,
		FINISH_DT TIMESTAMP ,
		BASELINE1_START TIMESTAMP ,
		BASELINE1_FINISH TIMESTAMP ,
		BASELINE2_START TIMESTAMP ,
		BASELINE2_FINISH TIMESTAMP ,
		BASELINE3_START TIMESTAMP ,
		BASELINE3_FINISH TIMESTAMP ,
		PLANNED_START TIMESTAMP ,
		PLANNED_FINISH TIMESTAMP ,
		PROPOSED_START TIMESTAMP ,
		PROPOSED_FINISH TIMESTAMP ,
		SCHED_START TIMESTAMP ,
		SCHED_FINISH TIMESTAMP ,
		FORECAST_START TIMESTAMP ,
		FORECAST_FINISH TIMESTAMP ,
		ACTUAL_START TIMESTAMP ,
		ACTUAL_FINISH TIMESTAMP ,
		UNRESOLVED_DURATION INTEGER WITH DEFAULT 0,
		DURATION INTEGER WITH DEFAULT 0,
		PLANNED_DURATION INTEGER WITH DEFAULT 0,
		PROPOSED_DURATION INTEGER WITH DEFAULT 0,
		SCHED_DURATION INTEGER WITH DEFAULT 0,
		FORECAST_DURATION INTEGER WITH DEFAULT 0,
		ACTUAL_DURATION INTEGER WITH DEFAULT 0,
		BASELINE1_DURATION INTEGER WITH DEFAULT 0,
		BASELINE2_DURATION INTEGER WITH DEFAULT 0,
		BASELINE3_DURATION INTEGER WITH DEFAULT 0,
		VARIANCE INTEGER WITH DEFAULT 0,
		FORECAST_VARIANCE INTEGER WITH DEFAULT 0,
		ACTUAL_VARIANCE INTEGER WITH DEFAULT 0,
		BASELINE1_VARIANCE INTEGER WITH DEFAULT 0,
		PLANNED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		PROPOSED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		SCHED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		FORECAST_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		ACTUAL_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		BASELINE1_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		BASELINE2_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		BASELINE3_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		WORK_TODATE BIGINT NOT NULL WITH DEFAULT 0,
		ETC BIGINT NOT NULL WITH DEFAULT 0,
		CREATED_BY CHAR(32) ,
		CREATED_DT TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		PROBABILITY INTEGER WITH DEFAULT 100,
		STAGE_ID INTEGER WITH DEFAULT 740,
		MILESTONE_PERCENT SMALLINT NOT NULL WITH DEFAULT 0,
		REC_USER CHAR(32) ,
		REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		LAST_WF_TYPE VARCHAR(110),
		LAST_WF_BY CHAR(50) ,
		LAST_WF_DT TIMESTAMP ,
		MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		REVISION_IMPACT INTEGER WITH DEFAULT 137,
		REVISION_TYPE INTEGER WITH DEFAULT 920,
		REVISION_HISTORY VARCHAR(255) WITH DEFAULT 'CREATED',
		CLOSED_BY CHAR(32) ,
		TOOLTIP_DESCR VARCHAR(255) WITH DEFAULT NULL,
		TOTAL_SLACK INTEGER ,
		FREE_SLACK INTEGER ,
		CRITICAL CHAR(1) ,
		ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		DEPENDENCIES VARCHAR(8192) ,
		ROLLUP_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		EV_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		CRI_COUNT INTEGER WITH DEFAULT 0,
		DOC_COUNT INTEGER WITH DEFAULT 0,
		MSP_ID INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE_WORK_TODATE BIGINT NOT NULL WITH DEFAULT 0,
		ASSIGN_COUNT SMALLINT NOT NULL WITH DEFAULT 0,
		ASSIGN_NAMES VARCHAR(2048) ,
		RTF_BITS INTEGER DEFAULT 0,
		LAST_CHECKIN TIMESTAMP ,
		BAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BCWS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BCWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ACWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		TRANSFER_FLAG CHAR(1),
		EFFORT_DRIVEN SMALLINT DEFAULT 1 NOT NULL,
		BUBBLE_COLOR SMALLINT NOT NULL WITH DEFAULT 0,
		BUBBLE_PUBLISHED_DT TIMESTAMP,
		A_CRI_COUNT SMALLINT WITH DEFAULT 0,
		TASK_TYPE SMALLINT NOT NULL WITH DEFAULT 10,
		FS_CODE VARCHAR(50),
		FS_STATE SMALLINT NOT NULL WITH DEFAULT 0,
		FS_LABOR_CODE VARCHAR(50),
		EV_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		REC_FLAGS INTEGER NOT NULL WITH DEFAULT 0,
		ROLLUP_BITS INTEGER NOT NULL WITH DEFAULT 0,
		UNRESOLVED_START TIMESTAMP,
		UNRESOLVED_FINISH TIMESTAMP,
		PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
	 R_PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		R_PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		EARLY_START TIMESTAMP ,
		LATE_START TIMESTAMP ,
		EARLY_FINISH TIMESTAMP ,
		LATE_FINISH TIMESTAMP ,
		LEVEL_INDEX INTEGER WITH DEFAULT 0,
		CALC_PRIORITY SMALLINT WITH DEFAULT 500,
		LEVEL_CONFLICT VARCHAR (4096) ,
		LEVEL_START TIMESTAMP ,
		LEVEL_FINISH TIMESTAMP ,
		LEVEL_DURATION INTEGER WITH DEFAULT 0,
		SCORECARD_COUNT INTEGER WITH DEFAULT 0,
		FINISH_START_DATE DATE,
		TOTAL_DURATION BIGINT NOT NULL WITH DEFAULT 0,
		PREVIOUS_WKF_STEP VARCHAR(150),
		DEPEND_FLAG CHARACTER(1) NOT NULL WITH DEFAULT '0',
		START_FINISH_DURATION INTEGER WITH DEFAULT 0,
		CONVERTED_SCORE BIGINT WITH DEFAULT 0,
		CONVERTED_WEIGHT BIGINT WITH DEFAULT 1,
		TIMEPHASED_BITS INTEGER NOT NULL WITH DEFAULT 0,
		ESTIMATED_BASELINE1_START DATE,
		ESTIMATED_BASELINE1_FINISH DATE,
		ESTIMATED_BASELINE2_START DATE,
		ESTIMATED_BASELINE2_FINISH DATE,
		ESTIMATED_BASELINE3_START DATE,
		ESTIMATED_BASELINE3_FINISH DATE,
		ESTIMATED_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_actual_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_etc DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_actual_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_etc DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE1_EST_DT TIMESTAMP,
		BASELINE2_EST_DT TIMESTAMP,
		BASELINE3_EST_DT TIMESTAMP,
		BASELINE1_SCH_DT TIMESTAMP,
		BASELINE2_SCH_DT TIMESTAMP,
		BASELINE3_SCH_DT TIMESTAMP,
		CUSTOM_INT_1 INTEGER DEFAULT 0,
		SUBPROJECT_COUNT INTEGER DEFAULT 0 ,
		ESTIMATED_BASELINE1_DURATION INTEGER DEFAULT 0 NOT NULL,
		ESTIMATED_BASELINE2_DURATION INTEGER DEFAULT 0 NOT NULL,
		ESTIMATED_BASELINE3_DURATION INTEGER DEFAULT 0 NOT NULL,
		TIMECODE_1_ID VARCHAR(32),
		TIMECODE_2_ID VARCHAR(32),
		RISK_EXPOSURE INTEGER NOT NULL WITH DEFAULT 0,
		CONSEQUENSE_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EAC_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EV_ETC_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		LEVEL_STATE INTEGER WITH DEFAULT 0,
		LEVEL_CONSTRAINT_TYPE INTEGER WITH DEFAULT 0,
		LEVEL_CONSTRAINT_DT VARCHAR(26),
		WORK_PERCENT SMALLINT WITH DEFAULT 0,
		MP_STATUS_DT TIMESTAMP,
		REFERENCE_NUMBER BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20),
		ASSET_ID CHAR(32), 
		ASSET_NAME VARCHAR(50), 
		FINANCIAL_CATEGORY INTEGER DEFAULT 6501,
		POOL_ID CHAR(32),
		ASSET_FLAG INTEGER WITH DEFAULT 0,
		BASELINE3_START_VARIANCE INTEGER WITH DEFAULT 0,
		BASELINE3_FINISH_VARIANCE INTEGER WITH DEFAULT 0,
		ELEMENT_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
		BASELINE_FLAG SMALLINT WITH DEFAULT 0,                        
		CHARGED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,      
		R_CHARGED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,    
		S_CHARGED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,    
		LEDGER_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		R_LEDGER_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,     
		S_LEDGER_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,     
		ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,   
		R_ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
		S_ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
		ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,    
		R_ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,  
		S_ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,  
		BCWS_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		BCWP_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		ACWP_FORECAST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,       
		TIME_VARIANCE INTEGER NOT NULL WITH DEFAULT 0,
		EXTERNAL_ID VARCHAR(50))
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE HISTORY_WBS2 PCTFREE 30;

CREATE INDEX HSWBS_EID_RDT_CX ON HISTORY_WBS2
	(ELEMENT_ID ASC,
	REC_DATETIME ASC)
	CLUSTER MINPCTUSED 10 PCTFREE 30;

CREATE INDEX HSWBS_HID_XX ON HISTORY_WBS2
	(HISTORY_ID ASC);

CREATE INDEX HSWBS_RK_XX ON HISTORY_WBS2
	(RANK ASC)
	PCTFREE 30 ;

INSERT INTO HISTORY_WBS2 (ELEMENT_FLAG,
EV_ETC,
HISTORY_ID, 
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE,
EXTERNAL_ID)
(SELECT ELEMENT_FLAG,
EV_ETC,
HISTORY_ID, 
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE, EXTERNAL_ID FROM HISTORY_WBS);

RENAME HISTORY_WBS TO HISTORY_WBS1;
RENAME HISTORY_WBS2 TO HISTORY_WBS;


-- IF SUCCESSFUL DROP TABLE HISTORY_WBS1;


-- TMT_CLIENTS



DROP INDEX TCLIENT_ENID_XU;
DROP INDEX TCLIENT_RK_CU;                
DROP INDEX TCLI_NID_XX;

CREATE TABLE TEMP_TMT_CLIENTS(
 		  LEVEL_ID INTEGER NOT NULL ,
		  TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		  MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		  CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  ELEMENT_ID CHAR(32) ,
		  ELEMENT_NAME VARCHAR(255) ,
		  PARENT_ID CHAR(32) ,
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  LABEL VARCHAR(50) ,
		  DESCRIPTION VARCHAR(4096) ,
		  DEFAULT_FLAG CHAR(1) ,
		  RANK VARCHAR(128) NOT NULL ,
		  DOMAIN_ID CHAR(32) ,
		  MANAGER_ID CHAR(32) ,
		  COMPANY_NAME VARCHAR(50) ,
		  ADDRESS VARCHAR(255) ,
		  PHONE VARCHAR(25) ,
		  FAX VARCHAR(25) ,
		  WEBSITE VARCHAR(255) ,
		  CONTACT_NAME VARCHAR(50) ,
		  OTHER_LOCATION VARCHAR(255) ,
		  YEAR_IN_BUSINESS INTEGER ,
		  CLIENT_MORE_100_EMPLOYEES INTEGER ,
		  CLIENT_MORE_1000_EMPLOYEES INTEGER ,
		  CLIENT_MORE_10000_EMPLOYEES INTEGER ,
		  NUMBER_EMPLOYEES INTEGER ,
		  ANNUAL_REVENUES DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  BILLING_ADDRESS VARCHAR(255) ,
		  BILLING_PHONE VARCHAR(25) ,
		  BILLING_FAX VARCHAR(25) ,
		  BILLING_EMAIL VARCHAR(50) ,
		  EQUAL_OPPORTUNITY CHAR(1) ,
		  MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		  MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		  REVISION_IMPACT INTEGER WITH DEFAULT 137,
		  REVISION_TYPE INTEGER WITH DEFAULT 920,
		  REVISION_HISTORY VARCHAR(2048) WITH DEFAULT 'CREATED',
		  PUBLIC_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		  COMPANY_BACKGROUND VARCHAR(3000) ,
		  OWNERSHIP VARCHAR(3000) ,
		  SERVICES_OFFERED VARCHAR(3000) ,
		  SERVICES_SPECIALIZED VARCHAR(3000) ,
		  INDUSTRIES_SERVED VARCHAR(3000) ,
		  HIGHLIGHT VARCHAR(3000) ,
		  LOCATION_SERVED VARCHAR(3000),
		  LOCAL CHAR(1) NOT NULL WITH DEFAULT 'N',
		  RTF_BITS SMALLINT DEFAULT 0,
		  DOC_COUNT INTEGER  WITH DEFAULT 0,
		  CURRENCY_ID INTEGER NOT NULL WITH DEFAULT 0,
		  STAGE_ID INTEGER,              
		  EXTERNAL_IDENTIFIER VARCHAR(32)
)
		  IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE TEMP_TMT_CLIENTS PCTFREE 30;

INSERT INTO TEMP_TMT_CLIENTS
( LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  LABEL,
  DESCRIPTION,
  DEFAULT_FLAG,
  RANK,
  DOMAIN_ID,
  MANAGER_ID,
  COMPANY_NAME,
  ADDRESS,
  PHONE,
  FAX,
  WEBSITE,
  CONTACT_NAME,
  OTHER_LOCATION,
  YEAR_IN_BUSINESS,
  CLIENT_MORE_100_EMPLOYEES,
  CLIENT_MORE_1000_EMPLOYEES,
  CLIENT_MORE_10000_EMPLOYEES,
  NUMBER_EMPLOYEES,
  ANNUAL_REVENUES,
  BILLING_ADDRESS,
  BILLING_PHONE,
  BILLING_FAX,
  BILLING_EMAIL,
  EQUAL_OPPORTUNITY,
  MAJOR_REVISION,
  MINOR_REVISION,
  REVISION_IMPACT,
  REVISION_TYPE,
  REVISION_HISTORY,
  PUBLIC_FLAG,
  COMPANY_BACKGROUND,
  OWNERSHIP,
  SERVICES_OFFERED,
  SERVICES_SPECIALIZED,
  INDUSTRIES_SERVED,
  HIGHLIGHT,
  LOCATION_SERVED,
  LOCAL,
  RTF_BITS,
  DOC_COUNT)
SELECT 
 LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  LABEL,
  DESCRIPTION,
  DEFAULT_FLAG,
  RANK,
  DOMAIN_ID,
  MANAGER_ID,
  COMPANY_NAME,
  ADDRESS,
  PHONE,
  FAX,
  WEBSITE,
  CONTACT_NAME,
  OTHER_LOCATION,
  YEAR_IN_BUSINESS,
  CLIENT_MORE_100_EMPLOYEES,
  CLIENT_MORE_1000_EMPLOYEES,
  CLIENT_MORE_10000_EMPLOYEES,
  NUMBER_EMPLOYEES,
  ANNUAL_REVENUES,
  BILLING_ADDRESS,
  BILLING_PHONE,
  BILLING_FAX,
  BILLING_EMAIL,
  EQUAL_OPPORTUNITY,
  MAJOR_REVISION,
  MINOR_REVISION,
  REVISION_IMPACT,
  REVISION_TYPE,
  REVISION_HISTORY,
  PUBLIC_FLAG,
  COMPANY_BACKGROUND,
  OWNERSHIP,
  SERVICES_OFFERED,
  SERVICES_SPECIALIZED,
  INDUSTRIES_SERVED,
  HIGHLIGHT,
  LOCATION_SERVED,
  LOCAL,
  RTF_BITS,
  DOC_COUNT
FROM TMT_CLIENTS;

RENAME TABLE TMT_CLIENTS TO OLD_TMT_CLIENTS;
RENAME TABLE TEMP_TMT_CLIENTS TO TMT_CLIENTS;

CREATE UNIQUE INDEX TCLIENT_ENID_XU ON TMT_CLIENTS
		(ELEMENT_ID ASC,
		 PARENT_ID ASC)
		INCLUDE (ELEMENT_NAME ASC) ;

CREATE UNIQUE INDEX TCLIENT_RK_CU ON TMT_CLIENTS
	(RANK ASC) 
	INCLUDE(TYPE_ID,LEVEL_ID) 
	CLUSTER MINPCTUSED 10 
	PCTFREE 30;                

CREATE INDEX TCLI_NID_XX ON TMT_CLIENTS(PARENT_ID) MINPCTUSED 10 PCTFREE 30;   

-- IF SUCCESSFUL DROP TABLE OLD_TMT_CLIENTS;
INSERT INTO TMT_CLIENTS(ELEMENT_ID, LEVEL_ID, TYPE_ID, MAX_RANK, CHILD_COUNT, RANK, LOCAL, ELEMENT_NAME, DEFAULT_FLAG, REC_USER) VALUES('PMOFFICE_DEFAULT_COST_CENTER____', 0, 229, 0, 0, '0000000/', 'N', 'RPM', 'Y', 'PMO_SUPERVISOR');
UPDATE TMT_CLIENTS SET DEFAULT_FLAG = 'N';
UPDATE TMT_CLIENTS SET DEFAULT_FLAG = 'Y' WHERE TYPE_ID = 229 AND RANK = (SELECT MIN(RANK) FROM TMT_CLIENTS WHERE TYPE_ID = 229);
UPDATE TMT_CLIENTS SET STAGE_ID = 6901 WHERE STAGE_ID IS NULL AND TYPE_ID IN (229, 326);
               

DELETE FROM TMT_CLIENTS WHERE RANK LIKE '0000!!!1%';
INSERT INTO TMT_CLIENTS(ELEMENT_ID, LEVEL_ID, TYPE_ID, MAX_RANK, CHILD_COUNT, RANK, LOCAL, ELEMENT_NAME, REC_USER, STAGE_ID, EXTERNAL_IDENTIFIER) VALUES('CUSTOM_CLIENT___________________', 0, 64, 0, 0, '0000!!!1', 'N', 'Custom Clients', 'PMO_SUPERVISOR', 6900, 'Custom Clients');


-- HISTORY_CLIENTS


DROP INDEX HSCLX_EID_RDT_CX;
DROP INDEX HSCLX_HID_XX;
DROP INDEX HSCLX_RK_XX; 


CREATE TABLE TEMP_HISTORY_CLIENTS  (
		  HISTORY_ID CHAR(32) ,
		  LEVEL_ID INTEGER NOT NULL ,
		  TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		  MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		  CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  ELEMENT_ID CHAR(32) ,
		  ELEMENT_NAME VARCHAR(255) ,
		  PARENT_ID CHAR(32) ,
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  LABEL VARCHAR(50) ,
		  DESCRIPTION VARCHAR(4096) ,
		  DEFAULT_FLAG CHAR(1) ,
		  RANK VARCHAR(128) NOT NULL ,
		  DOMAIN_ID CHAR(32) ,
		  MANAGER_ID CHAR(32) ,
		  COMPANY_NAME VARCHAR(50) ,
		  ADDRESS VARCHAR(255) ,
		  PHONE VARCHAR(25) ,
		  FAX VARCHAR(25) ,
		  WEBSITE VARCHAR(255) ,
		  CONTACT_NAME VARCHAR(50) ,
		  OTHER_LOCATION VARCHAR(255) ,
		  YEAR_IN_BUSINESS INTEGER ,
		  CLIENT_MORE_100_EMPLOYEES INTEGER ,
		  CLIENT_MORE_1000_EMPLOYEES INTEGER ,
		  CLIENT_MORE_10000_EMPLOYEES INTEGER ,
		  NUMBER_EMPLOYEES INTEGER ,
		  ANNUAL_REVENUES DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  BILLING_ADDRESS VARCHAR(255) ,
		  BILLING_PHONE VARCHAR(25) ,
		  BILLING_FAX VARCHAR(25) ,
		  BILLING_EMAIL VARCHAR(50) ,
		  EQUAL_OPPORTUNITY CHAR(1) ,
		  MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		  MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		  REVISION_IMPACT INTEGER WITH DEFAULT 137,
		  REVISION_TYPE INTEGER WITH DEFAULT 920,
		  REVISION_HISTORY VARCHAR(2048) ,
		  PUBLIC_FLAG CHAR(1) NOT NULL WITH DEFAULT '0',
		  COMPANY_BACKGROUND VARCHAR(3000) ,
		  OWNERSHIP VARCHAR(3000) ,
		  SERVICES_OFFERED VARCHAR(3000) ,
		  SERVICES_SPECIALIZED VARCHAR(3000) ,
		  INDUSTRIES_SERVED VARCHAR(3000) ,
		  HIGHLIGHT VARCHAR(3000) ,
		  LOCATION_SERVED VARCHAR(3000) ,
		  LOCAL CHAR(1) NOT NULL WITH DEFAULT 'N',
		  RTF_BITS SMALLINT DEFAULT 0 ,
		  DOC_COUNT INTEGER  WITH DEFAULT 0,
		  CURRENCY_ID INTEGER NOT NULL WITH DEFAULT 0,
		  STAGE_ID INTEGER,              
		  EXTERNAL_IDENTIFIER VARCHAR(32))
		  IN ALL32K INDEX IN TS_INDEX ;

 ALTER TABLE TEMP_HISTORY_CLIENTS PCTFREE 30;

INSERT INTO TEMP_HISTORY_CLIENTS
(
	HISTORY_ID,
	LEVEL_ID,
	TYPE_ID,
	MAX_RANK,
	CHILD_COUNT,
	DELETED_COUNT,
	ELEMENT_ID,
	ELEMENT_NAME,
	PARENT_ID,
	REC_USER,
	REC_STATUS,
	REC_DATETIME,
	LABEL,
	DESCRIPTION,
	DEFAULT_FLAG,
	RANK,
	DOMAIN_ID,
	MANAGER_ID,
	COMPANY_NAME,
	ADDRESS,
	PHONE,
	FAX,
	WEBSITE,
	CONTACT_NAME,
	OTHER_LOCATION,
	YEAR_IN_BUSINESS,
	CLIENT_MORE_100_EMPLOYEES,
	CLIENT_MORE_1000_EMPLOYEES,
	CLIENT_MORE_10000_EMPLOYEES,
	NUMBER_EMPLOYEES,
	ANNUAL_REVENUES,
	BILLING_ADDRESS,
	BILLING_PHONE,
	BILLING_FAX,
	BILLING_EMAIL,
	EQUAL_OPPORTUNITY,
	MAJOR_REVISION,
	MINOR_REVISION,
	REVISION_IMPACT,
	REVISION_TYPE,
	REVISION_HISTORY,
	PUBLIC_FLAG,
	COMPANY_BACKGROUND,
	OWNERSHIP,
	SERVICES_OFFERED,
	SERVICES_SPECIALIZED,
	INDUSTRIES_SERVED,
	HIGHLIGHT,
	LOCATION_SERVED,
	LOCAL,
	RTF_BITS,
	DOC_COUNT
)
SELECT 
	HISTORY_ID,
	LEVEL_ID,
	TYPE_ID,
	MAX_RANK,
	CHILD_COUNT,
	DELETED_COUNT,
	ELEMENT_ID,
	ELEMENT_NAME,
	PARENT_ID,
	REC_USER,
	REC_STATUS,
	REC_DATETIME,
	LABEL,
	DESCRIPTION,
	DEFAULT_FLAG,
	RANK,
	DOMAIN_ID,
	MANAGER_ID,
	COMPANY_NAME,
	ADDRESS,
	PHONE,
	FAX,
	WEBSITE,
	CONTACT_NAME,
	OTHER_LOCATION,
	YEAR_IN_BUSINESS,
	CLIENT_MORE_100_EMPLOYEES,
	CLIENT_MORE_1000_EMPLOYEES,
	CLIENT_MORE_10000_EMPLOYEES,
	NUMBER_EMPLOYEES,
	ANNUAL_REVENUES,
	BILLING_ADDRESS,
	BILLING_PHONE,
	BILLING_FAX,
	BILLING_EMAIL,
	EQUAL_OPPORTUNITY,
	MAJOR_REVISION,
	MINOR_REVISION,
	REVISION_IMPACT,
	REVISION_TYPE,
	REVISION_HISTORY,
	PUBLIC_FLAG,
	COMPANY_BACKGROUND,
	OWNERSHIP,
	SERVICES_OFFERED,
	SERVICES_SPECIALIZED,
	INDUSTRIES_SERVED,
	HIGHLIGHT,
	LOCATION_SERVED,
	LOCAL,
	RTF_BITS,
	DOC_COUNT
FROM 
HISTORY_CLIENTS;

RENAME TABLE HISTORY_CLIENTS TO OLD_HISTORY_CLIENTS;
RENAME TABLE TEMP_HISTORY_CLIENTS TO HISTORY_CLIENTS;

CREATE INDEX HSCLX_EID_RDT_CX ON HISTORY_CLIENTS
		(ELEMENT_ID ASC,
		 REC_DATETIME ASC)
		CLUSTER
		 MINPCTUSED 10
		 PCTFREE 30;

CREATE INDEX HSCLX_HID_XX ON HISTORY_CLIENTS
		(HISTORY_ID ASC);


CREATE  INDEX HSCLX_RK_XX ON HISTORY_CLIENTS
	(RANK ASC)  
	MINPCTUSED 10 
	PCTFREE 30;                                                   


-- IF SUCCESSFUL DROP TABLE OLD_HISTORY_CLIENTS;


-- TMT_POOLS

ALTER TABLE TMT_POOLS ADD COLUMN COST_CENTER_ID CHAR(32);
ALTER TABLE TMT_POOLS ADD COLUMN EXTERNAL_REFERENCE CHAR(32);

UPDATE TMT_POOLS SET COST_CENTER_ID = (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE DEFAULT_FLAG = 'Y');

CREATE INDEX TPOOL_EXTREF_XX ON TMT_POOLS (EXTERNAL_REFERENCE ASC);

-- HISTORY_POOLS


ALTER TABLE HISTORY_POOLS ADD COLUMN COST_CENTER_ID CHAR(32);

ALTER TABLE HISTORY_POOLS ADD COLUMN EXTERNAL_REFERENCE CHAR(32);



-- RESOURCE_COST_CENTERS

CREATE TABLE RESOURCE_COST_CENTERS  (
		  ELEMENT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
		  RESOURCE_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
		  COST_CENTER_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
		  START_DATE DATE,
		  FINISH_DATE DATE,
		  REC_USER CHAR(32) NOT NULL WITH DEFAULT 'PMO_SUPERVISOR',
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'U',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP)
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE RESOURCE_COST_CENTERS PCTFREE 30;

 ALTER TABLE RESOURCE_COST_CENTERS VOLATILE CARDINALITY;

CREATE UNIQUE INDEX RCC_RID_CCID_DT ON RESOURCE_COST_CENTERS
		(RESOURCE_ID ASC,
		COST_CENTER_ID ASC,
		START_DATE ASC) PCTFREE 30 ;

INSERT INTO RESOURCE_COST_CENTERS SELECT GET_UNIQUE_ID(), R.RESOURCE_ID, P.COST_CENTER_ID, '1899-12-31', '2300-12-30', 'PMO_SUPERVISOR', 'U', CURRENT TIMESTAMP
FROM RESOURCES R, TMT_POOLS P
WHERE R.RESOURCE_ID = P.ELEMENT_ID;




-- SUMMARY_TIMESHEETS


DROP INDEX SMRTS_RPJID_CX;
DROP INDEX SMRTS_TAID_WF_XU;
DROP INDEX SMRTS_WF_RDT_XX; 

CREATE TABLE NEW_SUMMARY_TIMESHEETS (
	PROJECT_ID CHAR(32) NOT NULL WITH DEFAULT '' , 
	RESOURCE_ID CHAR(32) , 
	TSK_ASSIGNMENT_ID CHAR(32) NOT NULL , 
	WEEK_OF DATE NOT NULL , 
	MONDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	MONDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	TUESDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	TUESDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	WEDNESDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	WEDNESDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	THURSDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	THURSDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	FRIDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	FRIDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	SATURDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	SATURDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	SUNDAY_REGULAR INTEGER NOT NULL WITH DEFAULT 0 , 
	SUNDAY_SPECIAL INTEGER NOT NULL WITH DEFAULT 0 , 
	WEEKLY_REGULAR_TOTAL INTEGER NOT NULL WITH DEFAULT 0 , 
	WEEKLY_SPECIAL_TOTAL INTEGER NOT NULL WITH DEFAULT 0 , 
	WEEKLY_BILLABLE_REGULAR_TOTAL INTEGER NOT NULL WITH DEFAULT 0 , 
	WEEKLY_BILLABLE_SPECIAL_TOTAL INTEGER NOT NULL WITH DEFAULT 0 , 
	TOTAL_SCHED_EFFORT BIGINT NOT NULL WITH DEFAULT 0 , 
	BASELINE_EFFORT_WEEK BIGINT NOT NULL WITH DEFAULT 0 , 
	WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	BILLABLE_WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	ETC BIGINT NOT NULL WITH DEFAULT 0 , 
	MILESTONE_PERCENT INTEGER NOT NULL WITH DEFAULT 0 , 
	BASELINE_REGULAR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE_SPECIAL_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE_REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BASELINE_SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_REGULAR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_SPECIAL_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACTUAL_SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	SYSTEM_EXCHANGE_RATE DECIMAL(18,3) NOT NULL WITH DEFAULT 1.000 , 
	REC_USER CHAR(32) NOT NULL , 
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'U' , 
	REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP , 
	TIMECODE_1_ID VARCHAR(32) , 
	TIMECODE_2_ID VARCHAR(32) , 
	ACTIVITY_ID VARCHAR(32) , 
	NOTES VARCHAR(255) , 
	BASELINE_WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0 , 
	PDA_FLAG CHAR(1) WITH DEFAULT 'P' , 
	MONTH1_REGULAR_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH1_SPECIAL_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH2_REGULAR_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH2_SPECIAL_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH1_B_REGULAR_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH1_B_SPECIAL_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH2_B_REGULAR_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	MONTH2_B_SPECIAL_HRS INTEGER NOT NULL WITH DEFAULT 0 , 
	DEPARTMENT_ID CHAR(32) , 
	COST_CENTER_BITS INTEGER NOT NULL WITH DEFAULT 0 ,
	BAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BCWS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	BCWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	ACWP DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 , 
	EV_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 ,
	EAC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00 ) 
IN SUM_TMSHEETS INDEX IN IND_SUM_TS ; 
ALTER TABLE SUMMARY_TIMESHEETS PCTFREE 30;

-- Transfer data

INSERT INTO NEW_SUMMARY_TIMESHEETS (
	ACTIVITY_ID,                   
	ACTUAL_REGULAR_COST,           
	ACTUAL_REGULAR_RATE,           
	ACTUAL_SPECIAL_COST,           
	ACTUAL_SPECIAL_RATE,           
	BASELINE_EFFORT_WEEK,          
	BASELINE_REGULAR_COST,         
	BASELINE_REGULAR_RATE,         
	BASELINE_SPECIAL_COST,         
	BASELINE_SPECIAL_RATE,         
	BASELINE_WORK_TODATE,          
	BILLABLE_WORK_TODATE,          
	DEPARTMENT_ID,                 
	ETC,                           
	FRIDAY_REGULAR,                
	FRIDAY_SPECIAL,                
	MILESTONE_PERCENT,             
	MONDAY_REGULAR,                
	MONDAY_SPECIAL,                
	MONTH1_B_REGULAR_HRS,          
	MONTH1_B_SPECIAL_HRS,          
	MONTH1_REGULAR_HRS,            
	MONTH1_SPECIAL_HRS,            
	MONTH2_B_REGULAR_HRS,          
	MONTH2_B_SPECIAL_HRS,          
	MONTH2_REGULAR_HRS,            
	MONTH2_SPECIAL_HRS,            
	NOTES,                         
	PDA_FLAG,                      
	PROJECT_ID,                    
	REC_DATETIME,                  
	REC_STATUS,                    
	REC_USER,                      
	RESOURCE_ID,                   
	SATURDAY_REGULAR,              
	SATURDAY_SPECIAL,              
	SUNDAY_REGULAR,                
	SUNDAY_SPECIAL,                
	SYSTEM_EXCHANGE_RATE,          
	THURSDAY_REGULAR,              
	THURSDAY_SPECIAL,              
	TIMECODE_1_ID,                 
	TIMECODE_2_ID,                 
	TOTAL_SCHED_EFFORT,            
	TSK_ASSIGNMENT_ID,             
	TUESDAY_REGULAR,               
	TUESDAY_SPECIAL,               
	WEDNESDAY_REGULAR,             
	WEDNESDAY_SPECIAL,             
	WEEKLY_BILLABLE_REGULAR_TOTAL, 
	WEEKLY_BILLABLE_SPECIAL_TOTAL, 
	WEEKLY_REGULAR_TOTAL,          
	WEEKLY_SPECIAL_TOTAL,          
	WEEK_OF,                       
	WORK_TODATE,                   
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC )   
SELECT 	ACTIVITY_ID,                   
	ACTUAL_REGULAR_COST,           
	ACTUAL_REGULAR_RATE,           
	ACTUAL_SPECIAL_COST,           
	ACTUAL_SPECIAL_RATE,           
	BASELINE_EFFORT_WEEK,          
	BASELINE_REGULAR_COST,         
	BASELINE_REGULAR_RATE,         
	BASELINE_SPECIAL_COST,         
	BASELINE_SPECIAL_RATE,         
	BASELINE_WORK_TODATE,          
	BILLABLE_WORK_TODATE,          
	DEPARTMENT_ID,                 
	ETC,                           
	FRIDAY_REGULAR,                
	FRIDAY_SPECIAL,                
	MILESTONE_PERCENT,             
	MONDAY_REGULAR,                
	MONDAY_SPECIAL,                
	MONTH1_B_REGULAR_HRS,          
	MONTH1_B_SPECIAL_HRS,          
	MONTH1_REGULAR_HRS,            
	MONTH1_SPECIAL_HRS,            
	MONTH2_B_REGULAR_HRS,          
	MONTH2_B_SPECIAL_HRS,          
	MONTH2_REGULAR_HRS,            
	MONTH2_SPECIAL_HRS,            
	NOTES,                         
	PDA_FLAG,                      
	PROJECT_ID,                    
	REC_DATETIME,                  
	REC_STATUS,                    
	REC_USER,                      
	RESOURCE_ID,                   
	SATURDAY_REGULAR,              
	SATURDAY_SPECIAL,              
	SUNDAY_REGULAR,                
	SUNDAY_SPECIAL,                
	SYSTEM_EXCHANGE_RATE,          
	THURSDAY_REGULAR,              
	THURSDAY_SPECIAL,              
	TIMECODE_1_ID,                 
	TIMECODE_2_ID,                 
	TOTAL_SCHED_EFFORT,            
	TSK_ASSIGNMENT_ID,             
	TUESDAY_REGULAR,               
	TUESDAY_SPECIAL,               
	WEDNESDAY_REGULAR,             
	WEDNESDAY_SPECIAL,             
	WEEKLY_BILLABLE_REGULAR_TOTAL, 
	WEEKLY_BILLABLE_SPECIAL_TOTAL, 
	WEEKLY_REGULAR_TOTAL,          
	WEEKLY_SPECIAL_TOTAL,          
	WEEK_OF,                       
	WORK_TODATE,                   
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC
FROM SUMMARY_TIMESHEETS; 

-- Rename tables
RENAME TABLE SUMMARY_TIMESHEETS TO OLD_SUMMARY_TIMESHEETS;
RENAME TABLE NEW_SUMMARY_TIMESHEETS TO SUMMARY_TIMESHEETS;

-- DDL Statements for indexes on Table SUMMARY_TIMESHEETS
CREATE INDEX SMRTS_RPJID_CX ON SUMMARY_TIMESHEETS 
	(RESOURCE_ID ASC,
	PROJECT_ID ASC)
	PCTFREE 30 CLUSTER ;

-- DDL Statements for indexes on Table SUMMARY_TIMESHEETS
CREATE UNIQUE INDEX SMRTS_TAID_WF_XU ON SUMMARY_TIMESHEETS 
	(TSK_ASSIGNMENT_ID ASC,
	WEEK_OF ASC)
	PCTFREE 30 ;

-- DDL Statements for indexes on Table SUMMARY_TIMESHEETS
CREATE INDEX SMRTS_WF_RDT_XX ON SUMMARY_TIMESHEETS 
	(WEEK_OF ASC,
	REC_DATETIME ASC)
	PCTFREE 30 ;
	
	
	
-- IF SUCCESSFUL DROP TABLE OLD_SUMMARY_TIMESHEETS;

-- PROJECT_COST_CENTERS


CREATE TABLE PROJECT_COST_CENTERS  (
	ELEMENT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	PROJECT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	RESOURCE_ID CHAR(32),
	COST_CENTER_ID CHAR(32),
	START_DATE DATE,
	FINISH_DATE DATE,
	DEFAULT_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
	ACTUAL_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	COST_CHARGE_PERCENT INTEGER NOT NULL WITH DEFAULT 10000,
	MAX_COST_CHARGE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	COST_CHARGE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ACTUAL_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REVENUE_CHARGE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	MAX_REVENUE_CHARGE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REVENUE_CHARGE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,

	LABOR_COST_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LABOR_REVENUE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,

	NON_LABOR_COST_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	NON_LABOR_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	NON_LABOR_REVENUE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	NON_LABOR_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,

	WS_COST_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	WS_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	WS_REVENUE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,
	WS_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LABOR_PERCENT INTEGER NOT NULL WITH DEFAULT 0,                     
	LABOR_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,             
	LABOR_FLAG SMALLINT WITH DEFAULT 0,                                
	EXPENSE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,                   
	EXPENSE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,           
	EXPENSE_FLAG SMALLINT WITH DEFAULT 0,                              
	CAPITAL_PERCENT INTEGER NOT NULL WITH DEFAULT 0,                   
	CAPITAL_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,           
	CAPITAL_FLAG SMALLINT WITH DEFAULT 0,                              
	BASELINE1_LABOR_PERCENT INTEGER NOT NULL WITH DEFAULT 0,           
	BASELINE1_LABOR_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,   
	BASELINE1_EXPENSE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,         
	BASELINE1_EXPENSE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
	BASELINE1_CAPITAL_PERCENT INTEGER NOT NULL WITH DEFAULT 0,         
	BASELINE1_CAPITAL_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
	BASELINE2_LABOR_PERCENT INTEGER NOT NULL WITH DEFAULT 0,           
	BASELINE2_LABOR_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,   
	BASELINE2_EXPENSE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,         
	BASELINE2_EXPENSE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
	BASELINE2_CAPITAL_PERCENT INTEGER NOT NULL WITH DEFAULT 0,         
	BASELINE2_CAPITAL_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
	BASELINE3_LABOR_PERCENT INTEGER NOT NULL WITH DEFAULT 0,           
	BASELINE3_LABOR_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,   
	BASELINE3_EXPENSE_PERCENT INTEGER NOT NULL WITH DEFAULT 0,         
	BASELINE3_EXPENSE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00, 
	BASELINE3_CAPITAL_PERCENT INTEGER NOT NULL WITH DEFAULT 0,         
	BASELINE3_CAPITAL_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REC_USER CHAR(32) NOT NULL WITH DEFAULT 'PMO_SUPERVISOR',
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'U',
	REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP)
	IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE PROJECT_COST_CENTERS PCTFREE 30;

 ALTER TABLE PROJECT_COST_CENTERS VOLATILE CARDINALITY;

CREATE UNIQUE INDEX PCC_RID_CCID_DT ON PROJECT_COST_CENTERS
		(PROJECT_ID ASC,
		RESOURCE_ID ASC,
		COST_CENTER_ID ASC) PCTFREE 30 ;
		
CREATE UNIQUE INDEX PCC_EID_XX ON PROJECT_COST_CENTERS
		(ELEMENT_ID ASC) PCTFREE 30 ;

INSERT INTO PROJECT_COST_CENTERS(ELEMENT_ID, PROJECT_ID, COST_CENTER_ID, COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT, LABOR_COST_PERCENT, LABOR_REVENUE_PERCENT, NON_LABOR_COST_PERCENT, NON_LABOR_REVENUE_PERCENT, WS_COST_PERCENT, WS_REVENUE_PERCENT, DEFAULT_FLAG)
(SELECT GET_UNIQUE_ID(), PROJECT_ID, (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE DEFAULT_FLAG = 'Y'), 0, 0, 10000, 10000, 10000, 10000,10000, 10000, 63
FROM PROJECT_DETAILS);



UPDATE PROJECT_COST_CENTERS PCC
SET (LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT) = 
(SELECT LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT FROM PROJECT_COSTBACK PC
WHERE PC.PROJECT_ID = PCC.PROJECT_ID AND PC.COST_CENTER_ID = PCC.COST_CENTER_ID)
WHERE PCC.COST_CENTER_ID IS NOT NULL AND PCC.RESOURCE_ID IS NULL
	AND EXISTS (SELECT PC1.PROJECT_ID FROM PROJECT_COSTBACK PC1 
	WHERE PC1.PROJECT_ID = PCC.PROJECT_ID AND PC1.COST_CENTER_ID = PCC.COST_CENTER_ID);



INSERT INTO PROJECT_COST_CENTERS (element_id, project_id, cost_center_id, LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT) 
(SELECT costback_id, project_id, cost_center_id, LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT FROM PROJECT_COSTBACK PC
WHERE NOT EXISTS (SELECT PCC.PROJECT_ID FROM PROJECT_COST_CENTERS PCC 
	WHERE PCC.RESOURCE_ID IS NULL AND PCC.PROJECT_ID = PC.PROJECT_ID 
	AND PCC.COST_CENTER_ID = PC.COST_CENTER_ID));




-- PROJECT_RECONCILIATION


CREATE TABLE PROJECT_RECONCILIATION  (
	ELEMENT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	PROJECT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	RESOURCE_ID CHAR(32),
	FOREIGN_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	FOREIGN_TABLE SMALLINT NOT NULL WITH DEFAULT 0,
	FOREIGN_DATE DATE,
	TYPE_ID SMALLINT NOT NULL WITH DEFAULT 0,
	COST_CENTER_ID CHAR(32),
	DEFAULT_LABOR_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
	REGULAR_TOTAL_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REGULAR_DEFAULT_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REGULAR_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	SPECIAL_TOTAL_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	SPECIAL_DEFAULT_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	SPECIAL_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	TAX1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	TAX2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ADJ_REGULAR_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ADJ_REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ADJ_SPECIAL_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ADJ_SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ADJ_TAX1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ADJ_TAX2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LEDGER_REGULAR_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LEDGER_REGULAR_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LEDGER_SPECIAL_QUANTITY DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LEDGER_SPECIAL_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LEDGER_TAX1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	LEDGER_TAX2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	CHARGE_DATE DATE,
	RECONCILIATION_DATE DATE,
	DESCRIPTION VARCHAR(255),
	REC_USER CHAR(32) NOT NULL WITH DEFAULT 'PMO_SUPERVISOR',
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'U',
	REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
	WEEK_OF DATE,       
	CONTRACT_ID CHAR(32))
	IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE PROJECT_RECONCILIATION PCTFREE 30;


 ALTER TABLE PROJECT_RECONCILIATION VOLATILE CARDINALITY;

CREATE UNIQUE INDEX PRC_PID_FID_DT ON PROJECT_RECONCILIATION
	(PROJECT_ID ASC,
	FOREIGN_ID ASC,
	FOREIGN_DATE ASC,
	COST_CENTER_ID ASC,
	TYPE_ID ASC)
    	CLUSTER 
    	MINPCTUSED 10 
    	PCTFREE 30;	

CREATE UNIQUE INDEX PRCSX_EID_XU ON PROJECT_RECONCILIATION
	(ELEMENT_ID ASC);
		
		
		
-- TMT_COSTS

ALTER TABLE TMT_COSTS ADD COLUMN COST_CENTER_BITS INTEGER NOT NULL WITH DEFAULT 0;

-- PROJECT_STATE_DEF

ALTER TABLE PROJECT_STATE_DEF ADD COLUMN ELEMENT_ID CHAR(32) NOT NULL DEFAULT '';
ALTER TABLE PROJECT_STATE_DEF ADD COLUMN PARENT_ID CHAR(32);
ALTER TABLE PROJECT_STATE_DEF ADD COLUMN WBS_PARENT_ID VARCHAR(32);
ALTER TABLE PROJECT_STATE_DEF ADD COLUMN EXPIRE_DAYS INTEGER;
ALTER TABLE PROJECT_STATE_DEF ADD COLUMN CHILD_COUNT INTEGER WITH DEFAULT 0;

UPDATE PROJECT_STATE_DEF
SET ELEMENT_ID = GET_UNIQUE_ID(),
PARENT_ID = PROJECT_ID;


DROP INDEX DEF_STATE_XU;

CREATE UNIQUE INDEX DEF_STATE_XU ON PROJECT_STATE_DEF
		(ELEMENT_ID, PARENT_ID);
		
		
-- STATE_TASK_NEXT_STATE_CNFG		
		
CREATE TABLE STATE_TASK_NEXT_STATE_CNFG  (
	PROJECT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	STAGE_ID INTEGER NOT NULL WITH DEFAULT 0,
	NEXT_STAGE_ID INTEGER NOT NULL WITH DEFAULT 0,
	POSITIVE_RESPONSE INTEGER NOT NULL WITH DEFAULT 0,
	NEGATIVE_RESPONSE INTEGER NOT NULL WITH DEFAULT 0,
	PRIORITY INTEGER NOT NULL WITH DEFAULT 0,
	REC_USER CHAR(32) NOT NULL WITH DEFAULT 'PMO_SUPERVISOR',
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'U',
	REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP
) IN ALL32K INDEX IN TS_INDEX ;
ALTER TABLE STATE_TASK_NEXT_STATE_CNFG PCTFREE 30;

CREATE UNIQUE INDEX NEXT_STATE_CNFG_XU ON STATE_TASK_NEXT_STATE_CNFG
		(PROJECT_ID ASC, STAGE_ID ASC, NEXT_STAGE_ID ASC);	
		
		
-- TMT_WORKFLOWS
		
ALTER TABLE TMT_WORKFLOWS ADD COLUMN STATE_CHANGE_WKF VARCHAR(32);


-- TASK_DAY_OF_YEAR

ALTER TABLE TASK_DAY_OF_YEAR ADD COLUMN TABLE_TYPE SMALLINT WITH DEFAULT 1;

UPDATE TASK_DAY_OF_YEAR SET TABLE_TYPE = 3 WHERE EXISTS (SELECT c.ELEMENT_ID FROM TMT_CRI c WHERE PROJECT_ID = c.PROJECT_ID AND TASK_ID = c.ELEMENT_ID);

-- LEVEL_TASK_DAY_OF_YEAR

ALTER TABLE LEVEL_TASK_DAY_OF_YEAR ADD COLUMN TABLE_TYPE SMALLINT WITH DEFAULT 1;



-- TMT_CALENDARS

ALTER TABLE TMT_CALENDARS ADD COLUMN START_DATE DATE NOT NULL WITH DEFAULT CURRENT DATE;


-- HISTORY_CALENDARS


CREATE TABLE HISTORY_CALENDARS (ELEMENT_ID Char(32) NOT NULL,
		  START_DATE DATE NOT NULL WITH DEFAULT CURRENT DATE,
		  WEEKLY_MIN SMALLINT NOT NULL WITH DEFAULT 0,
		  MONDAY_STATUS Char(1) NOT NULL WITH DEFAULT '1',
		  TUESDAY_STATUS Char(1) NOT NULL WITH DEFAULT '1',
		  WEDNESDAY_STATUS Char(1) NOT NULL WITH DEFAULT '1',
		  THURSDAY_STATUS Char(1) NOT NULL WITH DEFAULT '1',
		  FRIDAY_STATUS Char(1) NOT NULL WITH DEFAULT '1',
		  SATURDAY_STATUS Char(1) NOT NULL WITH DEFAULT '0',
		  SUNDAY_STATUS Char(1) NOT NULL WITH DEFAULT '0',
		  MONDAY_MIN SMALLINT NOT NULL WITH DEFAULT 480,
		  TUESDAY_MIN SMALLINT NOT NULL WITH DEFAULT 480,
		  WEDNESDAY_MIN SMALLINT NOT NULL WITH DEFAULT 480,
		  THURSDAY_MIN SMALLINT NOT NULL WITH DEFAULT 480,
		  FRIDAY_MIN SMALLINT NOT NULL WITH DEFAULT 480,
		  SATURDAY_MIN SMALLINT NOT NULL WITH DEFAULT 0,
		  SUNDAY_MIN SMALLINT NOT NULL WITH DEFAULT 0,
		  MONDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000',
		  TUESDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000',
		  WEDNESDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000',
		  THURSDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000',
		  FRIDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000',
		  SATURDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000000000000000000000000000000000000000000000000000',
		  SUNDAY_BIT Char(36) FOR BIT DATA NOT NULL WITH DEFAULT x'000000000000000000000000000000000000000000000000000000000000000000000000',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  REC_STATUS Char(1) NOT NULL WITH DEFAULT 'I',
		  REC_USER Char(32) )
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE HISTORY_CALENDARS PCTFREE 30;

 ALTER TABLE HISTORY_CALENDARS VOLATILE CARDINALITY;

-- DDL Statements for indexes on Table HISTORY_CALENDARS

CREATE UNIQUE INDEX H_ENID ON HISTORY_CALENDARS
		(ELEMENT_ID ASC, START_DATE ASC) ;
		
		
		
		
-- RESOURCES

ALTER TABLE RESOURCES ADD COLUMN ASSIGNED_PLUGINS BIGINT NOT NULL WITH DEFAULT 0;

			
			
-- HISTORY_RESOURCES

ALTER TABLE HISTORY_RESOURCES ADD COLUMN ASSIGNED_PLUGINS BIGINT NOT NULL WITH DEFAULT 0;


-- CURRENCY_EXCHANGES

CREATE TABLE CURRENCY_EXCHANGES  (
	ELEMENT_ID CHAR(32) NOT NULL WITH DEFAULT ' ',
	CURRENCY_ID INTEGER NOT NULL WITH DEFAULT 0,
	START_DATE DATE,
	FINISH_DATE DATE,
	EXCHANGE_RATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	REC_USER CHAR(32) NOT NULL WITH DEFAULT 'PMO_SUPERVISOR',
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'I',
	REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP
) IN ALL32K INDEX IN TS_INDEX ;
ALTER TABLE CURRENCY_EXCHANGES PCTFREE 30;

ALTER TABLE CURRENCY_EXCHANGES VOLATILE CARDINALITY;

CREATE UNIQUE INDEX CURRENCY_EXC_CID ON CURRENCY_EXCHANGES
		(CURRENCY_ID ASC,
		ELEMENT_ID ASC) PCTFREE 30;

INSERT INTO CURRENCY_EXCHANGES SELECT GET_UNIQUE_ID(), ELEMENT_ID, '1899-12-31', '2300-12-30', decimal(ELEMENT_NAME, 20, 4), 'PMO_SUPERVISOR', 'U', CURRENT TIMESTAMP
FROM TMT_DATAFIELDS
WHERE TYPE_ID = 37 AND LEVEL_ID = 2;




		
-- TMT_DATAFIELDS



INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(1,141,20,20,0,null,6700,'Contract Type',2,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c',null);
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6701,'1',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0001','Straight Amount');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6702,'2',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0002','Straight Amount with Max');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6703,'3',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0003','Monthly Fixed');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6704,'4',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0004','One-time Fixed');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6705,'5',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0005','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6706,'6',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0006','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6707,'7',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0007','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6708,'8',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0008','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6709,'9',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c0009','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6710,'10',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000:','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6711,'11',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000;','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6712,'12',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000<','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6713,'13',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000=','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6714,'14',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000>','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6715,'15',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000?','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6716,'16',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000@','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6717,'17',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000A','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6718,'18',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000B','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6719,'19',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000C','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6720,'20',6700,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000c000D','');




INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(1,142,20,20,0,null,6800,'Charge Code Stage',2,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d',null);
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6801,'1',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0001','Active');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6802,'2',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0002','Non-posting');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6803,'3',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0003','Inactivated');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6804,'4',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0004','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6805,'5',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0005','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6806,'6',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0006','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6807,'7',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0007','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6808,'8',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0008','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6809,'9',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d0009','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6810,'10',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000:','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6811,'11',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000;','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6812,'12',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000<','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6813,'13',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000=','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6814,'14',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000>','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6815,'15',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000?','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6816,'16',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000@','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6817,'17',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000A','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6818,'18',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000B','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6819,'19',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000C','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6820,'20',6800,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000d000D','');


INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(1,143,20,20,0,null,6900,'Cost Center Stage',2,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e',null);
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6901,'1',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0001','Open');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6902,'2',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0002','Locked');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6903,'3',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0003','Non-posting');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6904,'4',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0004','Posting');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6905,'5',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0005','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6906,'6',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0006','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6907,'7',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0007','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6908,'8',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0008','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6909,'9',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e0009','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6910,'10',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000:','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6911,'11',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000;','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6912,'12',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000<','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6913,'13',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000=','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6914,'14',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000>','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6915,'15',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000?','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6916,'16',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000@','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6917,'17',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000A','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6918,'18',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000B','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6919,'19',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000C','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6920,'20',6900,'PMO_SUPERVISOR','O','2003-03-25 09:57:12.109000','00000001000e000D','');




UPDATE TMT_DATAFIELDS SET DESCRIPTION = 'None' WHERE ELEMENT_ID = 6501;
UPDATE TMT_DATAFIELDS SET ELEMENT_NAME = 'Scope Elements Revision Type' WHERE ELEMENT_ID = 4725;
UPDATE TMT_DATAFIELDS SET ELEMENT_NAME = 'Scope Elements' WHERE ELEMENT_ID = 719;

-- TMT_CRI

UPDATE TMT_CRI 
SET ESTIMATED_START = CURRENT TIMESTAMP
WHERE ESTIMATED_START IS NULL;

CREATE TABLE TMT_CRI_BKUP  (
		RANK VARCHAR(192) NOT NULL WITH DEFAULT '',
		PARENT_RANK VARCHAR(192) NOT NULL WITH DEFAULT '',
		TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		LEVEL_ID INTEGER NOT NULL WITH DEFAULT 0,
		PROJECT_ID CHAR(32) ,
		PARENT_ID CHAR(32) ,
		PARENT_TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		ELEMENT_ID CHAR(32) ,
		MAX_RANK BIGINT NOT NULL WITH DEFAULT 0,
		CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		ELEMENT_NAME VARCHAR(255) ,
		TRANSFERRED CHAR(1) ,
		STAGE_ID INTEGER WITH DEFAULT 786,
		CREATED_BY CHAR(32) ,
		CREATED_DATETIME TIMESTAMP ,
		REFERENCE_NUMBER BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20),
		EXTERNAL_REFERENCE CHAR(32) ,
		PRIORITY_ID SMALLINT WITH DEFAULT 500,
		PROPOSED_BY CHAR(32) ,
		PROPOSED_DATETIME TIMESTAMP ,
		IMPACT_LEVEL_ID INTEGER NOT NULL WITH DEFAULT 0,
		SD SMALLINT NOT NULL WITH DEFAULT 11,
		FD SMALLINT NOT NULL WITH DEFAULT 12,
		START_DATETIME TIMESTAMP ,
		FINISH_DATETIME TIMESTAMP ,
		PLANNED_START TIMESTAMP ,
		PLANNED_FINISH TIMESTAMP ,
		PLANNED_EFFORT BIGINT NOT NULL WITH DEFAULT 0,
		PLANNED_DURATION INTEGER WITH DEFAULT 0 ,
		ESTIMATED_START TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		ESTIMATED_FINISH TIMESTAMP,
		MITIGATION_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		SCOPE_RANK_ID SMALLINT WITH DEFAULT 0,
		SCHEDULE_RANK_ID SMALLINT WITH DEFAULT 0,
		COST_RANK_ID SMALLINT WITH DEFAULT 0,
		QUALITY_RANK_ID SMALLINT WITH DEFAULT 0,
		PROBABILITY_RANK_ID SMALLINT WITH DEFAULT 0,
		PRECISION_RANK_ID SMALLINT WITH DEFAULT 0,
		EXPOSURE_ID INTEGER ,
		CONSEQUENSE_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		PROBABILITY_COST DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		APPROVED_DATETIME TIMESTAMP ,
		APPROVED_START TIMESTAMP ,
		APPROVED_FINISH TIMESTAMP ,
		APPROVED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		CLOSED_BY CHAR(32) ,
		CLOSED_DATETIME TIMESTAMP ,
		PLANNING_UNIT CHAR(1) ,
		PLANNING_TYPE INTEGER ,
		ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE1_DATETIME TIMESTAMP ,
		BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE2_DATETIME TIMESTAMP ,
		BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		BASELINE3_DATETIME TIMESTAMP ,
		S_ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE1_DATETIME TIMESTAMP ,
		S_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE2_DATETIME TIMESTAMP ,
		S_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_BASELINE3_DATETIME TIMESTAMP ,
		R_ESTIMATION_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_CURRENT_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_FORECAST_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE1_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE2_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_BASELINE3_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		LAST_WF_TYPE VARCHAR(110) ,
		LAST_WF_BY CHAR(32) ,
		LAST_WF_DATETIME TIMESTAMP ,
		MAX_REV_REACHED CHAR(1) NOT NULL WITH DEFAULT 'N',
		MAX_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		MAJOR_REVISION SMALLINT NOT NULL WITH DEFAULT 0,
		MINOR_REVISION SMALLINT NOT NULL WITH DEFAULT 1,
		REVISION_IMPACT INTEGER NOT NULL WITH DEFAULT 137,
		REVISION_TYPE INTEGER NOT NULL WITH DEFAULT 4726,
		REVISION_HISTORY VARCHAR(255) WITH DEFAULT 'CREATED',
		TOOLTIP_DESCRIPTION VARCHAR(255) WITH DEFAULT NULL,
		STATUS_ID INTEGER WITH DEFAULT 316,
		PUBLISHED CHAR(1) NOT NULL WITH DEFAULT 'N',
		SHARED CHAR(1) NOT NULL WITH DEFAULT 'N',
		IMPACT_RANK_ID SMALLINT WITH DEFAULT 1,
		ASSIGN_NAMES VARCHAR(2048) ,
		ASSIGN_COUNT SMALLINT WITH DEFAULT 0,
		REC_USER CHAR(32) ,
		RTF_BITS SMALLINT DEFAULT 0,
		LAST_CHECKIN TIMESTAMP ,
		REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
		REC_DATETIME TIMESTAMP WITH DEFAULT CURRENT TIMESTAMP,
		LAST_TRANSFER_DT TIMESTAMP,
		WBS_ID VARCHAR(32),
		STAGE_LAST_DT TIMESTAMP WITH DEFAULT CURRENT TIMESTAMP,
		SCORE SMALLINT WITH DEFAULT 0,
		WEIGHT SMALLINT WITH DEFAULT 1,
		CONVERTED_SCORE BIGINT WITH DEFAULT 0,
		CONVERTED_WEIGHT BIGINT WITH DEFAULT 1,
		SCORECARD_ID CHAR(32),
		PUBLISHED_DT TIMESTAMP,
		PRIORITY SMALLINT WITH DEFAULT 500,
		ETC BIGINT NOT NULL WITH DEFAULT 0,
		MILESTONE_PERCENT SMALLINT WITH DEFAULT 0,
		PERCENT_COMPLETE SMALLINT WITH DEFAULT 0,
		REC_FLAGS INTEGER NOT NULL WITH DEFAULT 0,
		ROLLUP_BITS INTEGER NOT NULL WITH DEFAULT 0,
		WBS_ASSIGNED INTEGER NOT NULL WITH DEFAULT 0,
		DURATION INTEGER NOT NULL WITH DEFAULT 0,
		ACTUAL_START TIMESTAMP,
		ACTUAL_FINISH TIMESTAMP,
		ACTUAL_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		SCHED_START TIMESTAMP,
		SCHED_FINISH TIMESTAMP,
		SCHED_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		PROPOSED_START TIMESTAMP,
		PROPOSED_FINISH TIMESTAMP,
		PROPOSED_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		FORECAST_START TIMESTAMP,
		FORECAST_FINISH TIMESTAMP,
		FORECAST_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE1_START TIMESTAMP,
		BASELINE1_FINISH TIMESTAMP,
		BASELINE1_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE1_EFFORT INTEGER NOT NULL WITH DEFAULT 0,
		UNRESOLVED_START TIMESTAMP,
		UNRESOLVED_FINISH TIMESTAMP,
		UNRESOLVED_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		CONSTRAINT_DT TIMESTAMP,
		CONSTRAINT_TYPE INTEGER NOT NULL WITH DEFAULT 0,
		S_ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ACTUAL_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATION_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE_WORK_TODATE INTEGER NOT NULL WITH DEFAULT 0,
		SCHED_EFFORT INTEGER NOT NULL WITH DEFAULT 0,
		FORECAST_EFFORT INTEGER NOT NULL WITH DEFAULT 0,
		PROPOSED_EFFORT INTEGER NOT NULL WITH DEFAULT 0,
		VARIANCE INTEGER NOT NULL WITH DEFAULT 0,
		ACTUAL_VARIANCE INTEGER NOT NULL WITH DEFAULT 0,
		FORECAST_VARIANCE INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE1_VARIANCE INTEGER NOT NULL WITH DEFAULT 0,
		CLIENT_ID CHAR(32),
		CLIENT_NAME VARCHAR(50),
		REASSIGN_COUNT SMALLINT WITH DEFAULT 0,
		DUPLICATE_REF_ID VARCHAR(50),
		OCCURED_DATETIME TIMESTAMP,
		DOC_COUNT INTEGER WITH DEFAULT 0,
		PROPOSED_BY_NAME VARCHAR(100),
		CLOSED_BY_NAME VARCHAR(100),
		ESTIMATED_DURATION INTEGER WITH DEFAULT 0,
		ESTIMATED_EFFORT BIGINT WITH DEFAULT 0,
		HIGH_ESTIMATED_START TIMESTAMP,
		HIGH_ESTIMATED_FINISH TIMESTAMP,
		HIGH_ESTIMATED_DURATION INTEGER WITH DEFAULT 0,
		HIGH_ESTIMATED_EFFORT BIGINT WITH DEFAULT 0,
		LOW_ESTIMATED_START TIMESTAMP,
		LOW_ESTIMATED_FINISH TIMESTAMP,
		LOW_ESTIMATED_DURATION INTEGER WITH DEFAULT 0,
		LOW_ESTIMATED_EFFORT BIGINT WITH DEFAULT 0,
		APPROVED_EFFORT BIGINT WITH DEFAULT 0,
		APPROVED_DURATION INTEGER WITH DEFAULT 0,
		ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		HIGH_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_HIGH_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_HIGH_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		LOW_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_LOW_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_LOW_ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		APPROVED_BY CHAR(32),
		APPROVED_BY_NAME VARCHAR(100),
		R_APPROVED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EXPECTED_REVENUE DECIMAL(18, 2) WITH DEFAULT 0.00,
		EXPECTED_MARGIN DECIMAL(18, 2) WITH DEFAULT 0.00,
		PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		R_PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_PLANNED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		R_PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_PROPOSED_BUDGET DECIMAL(18, 2) WITH DEFAULT 0.00,
		EXPECTED_COST DECIMAL(18, 2) WITH DEFAULT 0.00,
		S_APPROVED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		SCORECARD_COUNT INTEGER WITH DEFAULT 0,
		BASELINE2_START TIMESTAMP,
		BASELINE2_FINISH TIMESTAMP,
		BASELINE2_DURATION INTEGER NOT NULL WITH DEFAULT 0,
		BASELINE2_EFFORT INTEGER NOT NULL WITH DEFAULT 0,
		CHANGE_TO_TASK SMALLINT WITH DEFAULT 0,
		APPROVED_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		APPROVED_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		TARGET_DATE DATE,
		ESTIMATED_REVENUE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_SAVING DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		TOTAL_DURATION BIGINT NOT NULL WITH DEFAULT 0,
		DUPLICATE_KEY INTEGER,
		PREVIOUS_WKF_STEP VARCHAR(150),
		PRIVATE CHAR(1) WITH DEFAULT 'N',
		VISIBLE_AT_PARENT CHAR(1) WITH DEFAULT 'Y',
		TIMEPHASED_BITS INTEGER NOT NULL WITH DEFAULT 0,
		APPROVED_IMPACT_LEVEL_ID INTEGER WITH DEFAULT 0,
		ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		S_ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_ACTUAL_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		ESTIMATED_HOURS_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_ACTUAL_HOURS DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		R_ESTIMATED_HOURS_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		EXPECTED_PAYBACK_PERIOD INTEGER WITH DEFAULT 0,
		EXPECTED_PAYBACK_MONTH INTEGER WITH DEFAULT 0,
		ASSET_ID CHAR(32),
		ASSET_NAME VARCHAR(50),
		FINANCIAL_CATEGORY INTEGER DEFAULT 6501,
		ASSET_FLAG INTEGER WITH DEFAULT 0,
		DEFAULT_COL CHAR(1) NOT NULL WITH DEFAULT 'N',
		TEMPLATED CHAR(1) NOT NULL WITH DEFAULT 'N',
		T_PARENT_ID   VARCHAR(32),
		T_RANK   VARCHAR(192),
		ELEMENT_FLAG SMALLINT NOT NULL WITH DEFAULT 0)
		IN ALL32K INDEX IN TS_INDEX ;

ALTER TABLE TMT_CRI_BKUP PCTFREE 30;

INSERT INTO TMT_CRI_BKUP SELECT * FROM TMT_CRI;

DROP INDEX TCRIX_ENID_XU;
DROP INDEX TCRIX_NVID_RK_XX;
DROP INDEX TCRIX_PJNWBID_XX;
DROP INDEX TCRIX_PRK_RK_CX;
DROP INDEX TCRIX_RK_XU;
DROP INDEX TCRIX_TPID_XX;

RENAME TABLE TMT_CRI TO TMT_CRI_OLD;
RENAME TABLE TMT_CRI_BKUP TO TMT_CRI;

CREATE UNIQUE INDEX TCRIX_ENID_XU ON TMT_CRI
		(ELEMENT_ID ASC,
		PARENT_ID ASC);

CREATE INDEX TCRIX_NVID_RK_XX ON TMT_CRI
		(PARENT_ID ASC,
		LEVEL_ID ASC,
		RANK ASC);

CREATE INDEX TCRIX_PJNWBID_XX ON TMT_CRI
		(PROJECT_ID ASC,
		PARENT_ID ASC,
		WBS_ID ASC)
		PCTFREE 30 ;

CREATE INDEX TCRIX_PRK_RK_CX ON TMT_CRI
		(PARENT_RANK ASC,
		RANK ASC)
		CLUSTER
		MINPCTUSED 10
		PCTFREE 30;

CREATE UNIQUE INDEX TCRIX_RK_XU ON TMT_CRI
		(RANK ASC)
		PCTFREE 30 ;

CREATE INDEX TCRIX_TPID_XX ON TMT_CRI
		(T_PARENT_ID ASC);

-- IF SUCCESSFUL DROP TEMPORARY TABLES.
--DROP TABLE TMT_CRI_OLD;

-- ACTIVITIES

ALTER TABLE ACTIVITIES ADD COLUMN TYPE_ID SMALLINT NOT NULL WITH DEFAULT 0;	
ALTER TABLE ACTIVITIES ADD COLUMN SHOW_STEP CHAR(1) WITH DEFAULT 'Y';

UPDATE ACTIVITIES SET SHOW_STEP = 'N' WHERE TYPE_ID = 330;
UPDATE ACTIVITIES SET TYPE_ID = 212 WHERE TYPE_ID <> 330;

DROP INDEX ACTVT_EID_XX;
CREATE INDEX ACTVT_EID_XX ON ACTIVITIES
		(ELEMENT_ID ASC, TYPE_ID ASC)
		PCTFREE 30 ;




-- DETAIL_TIMESHEETS

ALTER TABLE DETAIL_TIMESHEETS ADD COLUMN CREDIT_WEEK_OF DATE;

CREATE INDEX DTTSH_AID_CW_XY ON DETAIL_TIMESHEETS
		(ACTIVITY_ID ASC, CREDIT_WEEK_OF ASC)
		PCTFREE 30 ;
	



-- RESOURCE_ASSIGNMENTS

UPDATE RESOURCE_ASSIGNMENTS SET RESOURCE_ID = PROFILE_ID WHERE PROFILE_ID IS NOT NULL AND RESOURCE_TYPE = '1';

UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NULL WHERE PROFILE_ID IS NOT NULL AND RESOURCE_TYPE = '1';


-- TMT_CONTRACTS


 CREATE TABLE TMT_CONTRACTS  (
		  LEVEL_ID INTEGER NOT NULL ,
		  TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
		  MAX_RANK INTEGER NOT NULL WITH DEFAULT 0,
		  CHILD_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  DELETED_COUNT INTEGER NOT NULL WITH DEFAULT 0,
		  ELEMENT_ID CHAR(32),
		  RANK VARCHAR(128) NOT NULL,
		  ELEMENT_NAME VARCHAR(255),
		  PARENT_ID CHAR(32) ,
		  CONTRACT_TYPE INTEGER NOT NULL WITH DEFAULT 6701,
		  CLIENT_ID CHAR(32) NOT NULL,
		  MAX_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  CURRENCY_ID INTEGER NOT NULL WITH DEFAULT 219,
		  CHARGED_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  LAST_CHARGED_DATE DATE,
		  EXTERNAL_REFERENCE CHAR(32),		  		  
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'I',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP,
		  DESCRIPTION VARCHAR(2048))
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE TMT_CONTRACTS PCTFREE 30;

CREATE UNIQUE INDEX TCONTR_ENID_XU ON TMT_CONTRACTS
		(ELEMENT_ID ASC,
		 PARENT_ID ASC)
		INCLUDE (ELEMENT_NAME ASC)
		 MINPCTUSED 10
		 PCTFREE 30;

CREATE UNIQUE INDEX TCONTR_RK_CU ON TMT_CONTRACTS
		(RANK ASC)
		CLUSTER
		 MINPCTUSED 10
		 PCTFREE 30;


INSERT INTO TMT_CONTRACTS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION, CLIENT_ID) VALUES(-1,0,0,1,0,null,null,null,'PMO_SYSTEM','I','2000-10-09 00:08:58.676001','0000',null, ' ');



-- CONTRACT_BREAKDOWN

CREATE TABLE CONTRACT_BREAKDOWN  (
		  ELEMENT_ID CHAR(32),
		  CONTRACT_ID CHAR(32),
		  CHARGE_DATE DATE NOT NULL WITH DEFAULT CURRENT DATE,
		  CHARGE_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
		  REC_USER CHAR(32) ,
		  REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'I',
		  REC_DATETIME TIMESTAMP NOT NULL WITH DEFAULT CURRENT TIMESTAMP)
		 IN ALL32K INDEX IN TS_INDEX ;
 ALTER TABLE CONTRACT_BREAKDOWN PCTFREE 30;

CREATE INDEX TCONTR_BDENID_XU ON CONTRACT_BREAKDOWN
		(ELEMENT_ID ASC)
		 MINPCTUSED 10
		 PCTFREE 30;

CREATE INDEX TCONTR_BDID_XU ON CONTRACT_BREAKDOWN
		(CONTRACT_ID ASC,
		 CHARGE_DATE ASC)
		 MINPCTUSED 10
		 PCTFREE 30;




-- TMT_SETTINGS

UPDATE TMT_SETTINGS
SET ELEMENT_NAME = '6.5.2.22', DESCRIPTION = '6.5.2.22'
WHERE ELEMENT_ID = 'CLIENT_BUILD_NUMBER';

UPDATE TMT_SETTINGS
SET DESCRIPTION = '6.5.2.22'
WHERE ELEMENT_ID = 'SERVER_BUILD_NUMBER';


UPDATE TMT_SETTINGS
SET ELEMENT_NAME = '6.1.0.0'
WHERE ELEMENT_ID = 'CLIENT_VERSION_NUMBER';

UPDATE TMT_SETTINGS
SET DESCRIPTION = '6.1.0.0'
WHERE ELEMENT_ID = 'APPLICATION_VERSION';

INSERT INTO TMT_SETTINGS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,RANK) 
VALUES(0,1,0,0,0,'RUP_HOME_PATH',null,null,'PMO_SUPERVISOR','I','0000000o');

UPDATE TMT_SETTINGS set MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1 where RANK = '0000';


-- TMT_WORKFLOW_CYCLES

UPDATE TMT_WORKFLOW_CYCLES 
SET ELEMENT_NAME = 'Scope Element Folder' 
WHERE ELEMENT_ID = 'EXCEPTION FOLDER';


-- TMT_DOCUMENTS

ALTER TABLE TMT_DOCUMENTS ADD COLUMN RUP_LINK CHAR(1) NOT NULL WITH DEFAULT '0';

--HISTORY_DOCUMENTS

ALTER TABLE HISTORY_DOCUMENTS ADD COLUMN RUP_LINK CHAR(1) NOT NULL WITH DEFAULT '0';

--TMT_SCORECARDS_DEF_AST

ALTER TABLE TMT_SCORECARDS_DEF_AST ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;


-- TMT_SCORECARDS_DEF_CRI
 
ALTER TABLE TMT_SCORECARDS_DEF_CRI ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;

-- TMT_SCORECARDS_DEF_RES

ALTER TABLE TMT_SCORECARDS_DEF_RES ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;

-- TMT_SCORECARDS_DEF_WBS

ALTER TABLE TMT_SCORECARDS_DEF_WBS ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;



-- TMT_ASSIGNED_SCORECARDS

ALTER TABLE TMT_ASSIGNED_SCORECARDS ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;

-- HISTORY_ASSIGNED_SCORECARDS

ALTER TABLE HISTORY_ASSIGNED_SCORECARDS ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;

-- TMT_PUBLISHED_SCORECARDS

ALTER TABLE TMT_PUBLISHED_SCORECARDS ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;

-- HISTORY_PUBLISHED_SCORECARDS

ALTER TABLE HISTORY_PUBLISHED_SCORECARDS ADD COLUMN REPORT_FLAG SMALLINT WITH DEFAULT 0;


--Description:  	Fix the RANK in all TMT tables, WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK)).

UPDATE TMT_ASSETS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));               
UPDATE TMT_ASSET_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));     
UPDATE TMT_ASSET_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_ASSIGNED_SCORECARDS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));  
UPDATE TMT_CALENDARS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_CHARGECODES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));          
UPDATE TMT_CLIENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_CLIENT_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));    
UPDATE TMT_CLIENT_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));     
UPDATE TMT_COMPETENCIES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));         
UPDATE TMT_CONTACTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));             
UPDATE TMT_CONTRACTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_COSTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                
UPDATE TMT_COST_CENTERS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));         
UPDATE TMT_CRI SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                  
UPDATE TMT_CRI_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));       
UPDATE TMT_DATAFIELDS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));           
UPDATE TMT_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_DOCUMENT_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));  
UPDATE TMT_DOMAINS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_FACTORS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_GEOGRAPHIES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));          
UPDATE TMT_GLOBAL_SECURITY SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_NAB SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                  
UPDATE TMT_ORGANIZATIONS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));        
UPDATE TMT_POOLS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                
UPDATE TMT_POOL_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_POOL_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));       
UPDATE TMT_PORTFOLIOS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));           
UPDATE TMT_PUBLISHED_SCORECARDS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK)); 
UPDATE TMT_REPORT_SECURITY SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_RESOURCE_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCENARIOS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_SCORECARDS_DEF_AST SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCORECARDS_DEF_CRI SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCORECARDS_DEF_RES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCORECARDS_DEF_WBS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SETTINGS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));             
UPDATE TMT_TIMECODES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_VENDORS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_VENDOR_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));    
UPDATE TMT_VENDOR_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));     
UPDATE TMT_WBS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                  
UPDATE TMT_WBS_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));       
UPDATE TMT_WORKFLOWS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_WORKFLOW_CYCLES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK)); 




-- CREATE ALL TRIGGERS WHEN EVERYTHING SUCCEEDS USING TRIGGERS.sql IN DDL FOLDER IN SOURCE SAFE AND DROP ALL THE TEMPORARY TABLES CREATED DURING MIGRATION WHICH ARE AS FOLLOWS
























