-- REPLACE DBNAME with the name of the database you are running this script against, USERNAME with username YOU are using to connect to the database, and USERPASSWD with your password
CONNECT TO DBNAME USER USERNAME USING USERPASSWD;  

-- REPLACE DBSCHEMA with the schema of your database
SET CURRENT SCHEMA DBSCHEMA;


-- BUDGETS



DROP INDEX BDGTS_EBCID_CU;
DROP INDEX BDGTS_BID_XX;
DROP INDEX BDGTS_CID_XX;
DROP INDEX BUDGET_CHRGEID_XXX;



CREATE TABLE BUDGETS2 (
	PROJECT_ID CHAR(32) NOT NULL,
	ELEMENT_ID CHAR(32) NOT NULL,
	CHARGECODE_ID CHAR(32) NOT NULL,
	BUDGET_ID CHAR(32) NOT NULL,
	ASSOCIATE_BUDGET_ID CHAR(32),
	TYPE_ID INTEGER NOT NULL WITH DEFAULT 0,
	CREATED_BY CHAR(32) NOT NULL,
	REC_USER CHAR(32) NOT NULL ,
	REC_STATUS CHAR(1) NOT NULL WITH DEFAULT 'O',
	REC_DATETIME TIMESTAMP WITH DEFAULT CURRENT TIMESTAMP,
	TOTAL_ESTIMATION_PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	TOTAL_BUDGET_PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	PROB_PERCENT INTEGER WITH DEFAULT 10000,
	PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET_BASELINE1 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET_BASELINE2 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET_BASELINE3 DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BUDGET DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ACTUAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ETC DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	PAID_TODATE DECIMAL (18,2) WITH DEFAULT 0.00,
	AUTO_FLAG SMALLINT NOT NULL WITH DEFAULT 1,
	ACTUAL_EDITED SMALLINT NOT NULL WITH DEFAULT 1,
	ROLLUP_BITS INTEGER NOT NULL WITH DEFAULT 0,
	TIMEPHASED_BITS INTEGER NOT NULL WITH DEFAULT 0,
	TIMEPHASED_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
	DATAFIELD_1 INTEGER,
	DATAFIELD_2 INTEGER,
	TXT_FIELD_01 VARCHAR(1024),
	TXT_FIELD_02 VARCHAR(1024),
	TXT_FIELD_03 VARCHAR(1024),
	TXT_FIELD_04 VARCHAR(1024),
	TXT_FIELD_05 VARCHAR(1024),
	TXT_FIELD_06 VARCHAR(1024),
	TXT_FIELD_07 VARCHAR(1024),
	TXT_FIELD_08 VARCHAR(1024),
	TXT_FIELD_09 VARCHAR(1024),
	TXT_FIELD_10 VARCHAR(1024),
	TOLERANCE INTEGER WITH DEFAULT 10000,
	ESTIMATED_ACTUAL_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_ETC_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PAID_TODATE DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PAID_TODATE_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PROB_AMOUNT DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	ESTIMATED_PROB_AMOUNT_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,
	BASELINE3_SCH_FLAG SMALLINT DEFAULT 0 NOT NULL,
	BASELINE3_EST_FLAG SMALLINT DEFAULT 0 NOT NULL,
	DATAFIELD_3 INTEGER,
	DATAFIELD_4 INTEGER,
	ACTUAL_TIMEPHASED_FLAG SMALLINT NOT NULL WITH DEFAULT 0,
	CAPITAL_EXPENSE SMALLINT NOT NULL WITH DEFAULT 0,                      
	BILLABLE SMALLINT NOT NULL WITH DEFAULT 1,                             
	COST_CENTER_BITS INTEGER NOT NULL WITH DEFAULT 0,                      
	CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,                      
	LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,                       
	ESTIMATED_CHARGED DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,            
	ESTIMATED_LEDGER DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,             
	ESTIMATED_CHARGED_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00,      
	ESTIMATED_LEDGER_TOTAL DECIMAL(18,2) NOT NULL WITH DEFAULT 0.00   
)
IN ALL32K INDEX IN TS_INDEX ;
ALTER TABLE BUDGETS2 PCTFREE 30;

ALTER TABLE BUDGETS2 VOLATILE CARDINALITY;

CREATE UNIQUE INDEX BDGTS_EBCID_CU ON BUDGETS2 (PROJECT_ID ASC, ELEMENT_ID ASC, CHARGECODE_ID ASC) INCLUDE(BUDGET_ID, ASSOCIATE_BUDGET_ID) CLUSTER MINPCTUSED 10 PCTFREE 30;

CREATE UNIQUE INDEX BDGTS_BID_XX ON BUDGETS2 (BUDGET_ID ASC) INCLUDE(PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, ASSOCIATE_BUDGET_ID);

CREATE INDEX BDGTS_CID_XX ON BUDGETS2 (PROJECT_ID, CHARGECODE_ID ASC);

CREATE INDEX BUDGET_CHRGEID_XXX ON BUDGETS2 (CHARGECODE_ID) MINPCTUSED 10 PCTFREE 30; 


INSERT INTO BUDGETS2 (TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG)
SELECT TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG FROM BUDGETS;

RENAME BUDGETS TO BUDGETS1;
RENAME BUDGETS2 TO BUDGETS;

UPDATE BUDGETS 
SET CAPITAL_EXPENSE = 10
WHERE CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';


-- IF SUCCESSFULl DROP TABLE BUDGETS1;


-- TMT_COST_CENTERS

DROP TABLE TMT_COST_CENTERS;


--RECREATE TRIGGERS USING TRIGGERS.sql IN DDL FOLDER IN SOURCE SAFE
