/*****************************************************************************************/

Prompt == FUNCTION SP_I_ACT ==
CREATE OR REPLACE FUNCTION SP_I_ACT
(
     p_name VARCHAR2
   , p_tsk_assignment_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_week_of DATE;
   h_name VARCHAR2(100);
   h_rec_user VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ACT(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_tsk_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ACT', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ACT(28) : activities.sql(31) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_tsk_assignment_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_ACT', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_ACT(33) : activities.sql(36) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ACT', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_ACT(36) : activities.sql(39) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_tsk_assignment_id := p_tsk_assignment_id;
   h_type_id := p_type_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT PROJECT_ID INTO h_project_id
      FROM TASK_ASSIGNMENTS 
      WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ACT', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ACT(56) : activities.sql(59) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_ACT', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_ACT(63) : activities.sql(66) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ACT', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_ACT(66) : activities.sql(69) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_tsk_assignment_id
            , True);
   End If;
   
   h_uniqueID := SYS_GUID();
   BEGIN
      INSERT INTO ACTIVITIES(
      ELEMENT_ID,
      TSK_ASSIGNMENT_ID,
      ELEMENT_NAME,
      TYPE_ID,
      REC_USER)
      VALUES( h_uniqueID,
      h_tsk_assignment_id,
      h_name,
      h_type_id,
      h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ACT', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ACT(95) : activities.sql(98) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_TIMESHEET_ACTIVITY Then
         BEGIN
            UPDATE TASK_ASSIGNMENTS 
            SET ACTIVITY_COUNT = ACTIVITY_COUNT + 1
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ACT', 115+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ACT(116) : activities.sql(119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TASK_ASSIGNMENTS 
            SET CREDIT_COUNT = CREDIT_COUNT + 1
            WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ACT', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ACT(135) : activities.sql(138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --BEGIN_SQL
   -- INSERT INTO DETAIL_TIMESHEETS (
   --  ACTIVITY_ID, WEEK_OF,
   --  BILLABLE, REC_USER, REC_DATETIME )
   -- SELECT  HOST(h_uniqueID), ST.WEEK_OF,
   --  TA.BILLABLE, HOST(h_rec_user), SC_NOW
   -- FROM SUMMARY_TIMESHEETS ST
   -- JOIN TASK_ASSIGNMENTS TA
   --  ON TA.PROJECT_ID = ST.PROJECT_ID
   --  AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
   -- WHERE ST.PROJECT_ID = HOST(h_project_id)
   --  AND ST.TSK_ASSIGNMENT_ID = HOST(h_tsk_assignment_id);
   --END_SQL;
   
   --if (SC_NODATA) SC_STATE = 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ACT', 158+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ACT(159) : activities.sql(162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ACT', 165+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ACT(166) : activities.sql(169) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ACT', 177+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ACT(178) : activities.sql(181) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ACT;
ALTER FUNCTION SP_I_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ACT ==
CREATE OR REPLACE FUNCTION SP_U_ACT
(
     p_id VARCHAR2
   , p_tsk_assignment_id VARCHAR2
   , p_name VARCHAR2
   , p_billable PLS_INTEGER
   , p_timecode_1_id VARCHAR2
   , p_timecode_1_name VARCHAR2
   , p_timecode_2_id VARCHAR2
   , p_timecode_2_name VARCHAR2
   , p_sched_work PLS_INTEGER
   , p_etc PLS_INTEGER
   , p_milestone_percent PLS_INTEGER
   , p_edpercent PLS_INTEGER
   , p_week_of VARCHAR2
   , p_monday_regular PLS_INTEGER
   , p_monday_special PLS_INTEGER
   , p_tuesday_regular PLS_INTEGER
   , p_tuesday_special PLS_INTEGER
   , p_wednesday_regular PLS_INTEGER
   , p_wednesday_special PLS_INTEGER
   , p_thursday_regular PLS_INTEGER
   , p_thursday_special PLS_INTEGER
   , p_friday_regular PLS_INTEGER
   , p_friday_special PLS_INTEGER
   , p_saturday_regular PLS_INTEGER
   , p_saturday_special PLS_INTEGER
   , p_sunday_regular PLS_INTEGER
   , p_sunday_special PLS_INTEGER
   , p_notes VARCHAR2
   , p_pda_flag VARCHAR2
   , p_etc_modified VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_work_todate PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ACT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_billable), 'NULL')
          || ', ' || '''' || p_timecode_1_id || ''''
          || ', ' || '''' || p_timecode_1_name || ''''
          || ', ' || '''' || p_timecode_2_id || ''''
          || ', ' || '''' || p_timecode_2_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_sched_work), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_milestone_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_edpercent), 'NULL')
          || ', ' || '''' || p_week_of || ''''
          || ', ' || COALESCE(TO_CHAR(p_monday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_monday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_special), 'NULL')
          || ', ' || '''' || p_notes || ''''
          || ', ' || '''' || p_pda_flag || ''''
          || ', ' || '''' || p_etc_modified || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACT', 77+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ACT(78) : activities.sql(275) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) AND ((p_week_of IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ACT', 82+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ACT(83) : activities.sql(280) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ACT(86) : activities.sql(283) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   --check existence
   BEGIN
      SELECT REC_STATUS
      INTO h_rec_status
      FROM DETAIL_TIMESHEETS
      WHERE ACTIVITY_ID = p_id
      AND WEEK_OF = TO_DATE(SubStr(p_week_of, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 105+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(106) : activities.sql(303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --go insert
      BEGIN
         INSERT INTO DETAIL_TIMESHEETS (
         ACTIVITY_ID,
         WEEK_OF,
         BILLABLE,
         MONDAY_REGULAR,
         MONDAY_SPECIAL,
         TUESDAY_REGULAR,
         TUESDAY_SPECIAL,
         WEDNESDAY_REGULAR,
         WEDNESDAY_SPECIAL,
         THURSDAY_REGULAR,
         THURSDAY_SPECIAL,
         FRIDAY_REGULAR,
         FRIDAY_SPECIAL,
         SATURDAY_REGULAR,
         SATURDAY_SPECIAL,
         SUNDAY_REGULAR,
         SUNDAY_SPECIAL,
         PDA_FLAG,
         REC_USER,
         NOTES)
         VALUES (
         p_id,
         p_week_of,
         p_billable,
         p_monday_regular,
         p_monday_special,
         p_tuesday_regular,
         p_tuesday_special,
         p_wednesday_regular,
         p_wednesday_special,
         p_thursday_regular,
         p_thursday_special,
         p_friday_regular,
         p_friday_special,
         p_saturday_regular,
         p_saturday_special,
         p_sunday_regular,
         p_sunday_special,
         CASE WHEN p_pda_flag IS NOT NULL THEN p_pda_flag ELSE 'P' END,
         p_rec_user,
         p_notes );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(166) : activities.sql(363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE DETAIL_TIMESHEETS SET
         BILLABLE = p_billable,
         MONDAY_REGULAR = p_monday_regular,
         MONDAY_SPECIAL = p_monday_special,
         TUESDAY_REGULAR = p_tuesday_regular,
         TUESDAY_SPECIAL = p_tuesday_special,
         WEDNESDAY_REGULAR = p_wednesday_regular,
         WEDNESDAY_SPECIAL = p_wednesday_special,
         THURSDAY_REGULAR = p_thursday_regular,
         THURSDAY_SPECIAL = p_thursday_special,
         FRIDAY_REGULAR = p_friday_regular,
         FRIDAY_SPECIAL = p_friday_special,
         SATURDAY_REGULAR = p_saturday_regular,
         SATURDAY_SPECIAL = p_saturday_special,
         SUNDAY_REGULAR = p_sunday_regular,
         SUNDAY_SPECIAL = p_sunday_special,
         PDA_FLAG = CASE WHEN p_pda_flag IS NOT NULL THEN p_pda_flag ELSE 'P' END,
         REC_USER = p_rec_user,
         REC_STATUS = 'U',
         NOTES = p_notes
         WHERE ACTIVITY_ID = p_id
         AND WEEK_OF = TO_DATE(SubStr(p_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 203+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(204) : activities.sql(401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT
      COALESCE( SUM(MONDAY_REGULAR + MONDAY_SPECIAL + TUESDAY_REGULAR + TUESDAY_SPECIAL + WEDNESDAY_REGULAR + WEDNESDAY_SPECIAL + THURSDAY_REGULAR + THURSDAY_SPECIAL + FRIDAY_REGULAR + FRIDAY_SPECIAL + SATURDAY_REGULAR + SATURDAY_SPECIAL + SUNDAY_REGULAR + SUNDAY_SPECIAL), 0)
      INTO
      h_work_todate
      FROM DETAIL_TIMESHEETS
      WHERE ACTIVITY_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 222+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(223) : activities.sql(420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE ACTIVITIES 
      SET ELEMENT_NAME = p_name,
      BILLABLE = p_billable,
      TIMECODE_1_ID = p_timecode_1_id,
      TIMECODE_1_NAME = p_timecode_1_name,
      TIMECODE_2_ID = p_timecode_2_id,
      TIMECODE_2_NAME = p_timecode_2_name,
      EFFORT_ASSIGNMENT = p_sched_work,
      WORK_TODATE = h_work_todate,
      ETC = p_etc,
      ETC_MODIFIED = p_etc_modified,
      MILESTONE_PERCENT = p_milestone_percent,
      EDPERCENT = p_edpercent,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 254+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(255) : activities.sql(452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO ACTIVITIES(
         ELEMENT_ID,
         TSK_ASSIGNMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         BILLABLE,
         TIMECODE_1_ID,
         TIMECODE_1_NAME,
         TIMECODE_2_ID,
         TIMECODE_2_NAME,
         EFFORT_ASSIGNMENT,
         WORK_TODATE,
         ETC,
         ETC_MODIFIED,
         MILESTONE_PERCENT,
         EDPERCENT,
         REC_USER,
         REC_STATUS )
         VALUES(
         p_id,
         p_tsk_assignment_id,
         p_name,
         PMO_CNST.SC_TIMESHEET_ACTIVITY,
         p_billable,
         p_timecode_1_id,
         p_timecode_1_name,
         p_timecode_2_id,
         p_timecode_2_name,
         p_sched_work,
         h_work_todate,
         p_etc,
         p_etc_modified,
         p_milestone_percent,
         p_edpercent,
         p_rec_user,
         'I');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(308) : activities.sql(505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ACT', 314+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ACT(315) : activities.sql(512) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 321+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(322) : activities.sql(519) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT', 333+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT(334) : activities.sql(531) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ACT;
ALTER FUNCTION SP_U_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_TS_DETAIL ==
CREATE OR REPLACE FUNCTION SP_U_TS_DETAIL
(
     p_id VARCHAR2
   , p_tsk_assignment_id VARCHAR2
   , p_billable PLS_INTEGER
   , p_week_of VARCHAR2
   , p_monday_regular PLS_INTEGER
   , p_monday_special PLS_INTEGER
   , p_tuesday_regular PLS_INTEGER
   , p_tuesday_special PLS_INTEGER
   , p_wednesday_regular PLS_INTEGER
   , p_wednesday_special PLS_INTEGER
   , p_thursday_regular PLS_INTEGER
   , p_thursday_special PLS_INTEGER
   , p_friday_regular PLS_INTEGER
   , p_friday_special PLS_INTEGER
   , p_saturday_regular PLS_INTEGER
   , p_saturday_special PLS_INTEGER
   , p_sunday_regular PLS_INTEGER
   , p_sunday_special PLS_INTEGER
   , p_pda_flag VARCHAR2
   , p_notes VARCHAR2
   , p_credit_week_of VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_week_of DATE;
   h_credit_week_of DATE;
   h_billable PLS_INTEGER := 0;
   h_work_todate PLS_INTEGER := 0;
   h_monday_regular PLS_INTEGER := 0;
   h_monday_special PLS_INTEGER := 0;
   h_tuesday_regular PLS_INTEGER := 0;
   h_tuesday_special PLS_INTEGER := 0;
   h_wednesday_regular PLS_INTEGER := 0;
   h_wednesday_special PLS_INTEGER := 0;
   h_thursday_regular PLS_INTEGER := 0;
   h_thursday_special PLS_INTEGER := 0;
   h_friday_regular PLS_INTEGER := 0;
   h_friday_special PLS_INTEGER := 0;
   h_saturday_regular PLS_INTEGER := 0;
   h_saturday_special PLS_INTEGER := 0;
   h_sunday_regular PLS_INTEGER := 0;
   h_sunday_special PLS_INTEGER := 0;
   h_total_week PLS_INTEGER := 0;
   h_credit_hrs PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_update PLS_INTEGER := 0;
   h_pda_flag VARCHAR2(1);
   h_notes VARCHAR2(255);
   h_actual_regular_cost NUMBER := 0;
   h_actual_regular_rate NUMBER := 0;
   h_credit_regular_cost NUMBER := 0;
   h_credit_regular_rate NUMBER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TS_DETAIL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TS_DETAIL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TS_DETAIL(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_tsk_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_billable), 'NULL')
          || ', ' || '''' || p_week_of || ''''
          || ', ' || COALESCE(TO_CHAR(p_monday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_monday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tuesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_wednesday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_thursday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_friday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_saturday_special), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_regular), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sunday_special), 'NULL')
          || ', ' || '''' || p_pda_flag || ''''
          || ', ' || '''' || p_notes || ''''
          || ', ' || '''' || p_credit_week_of || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 89+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TS_DETAIL(90) : activities.sql(637) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) AND ((p_week_of IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TS_DETAIL', 94+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TS_DETAIL(95) : activities.sql(642) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_TS_DETAIL(98) : activities.sql(645) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_tsk_assignment_id := p_tsk_assignment_id;
   h_week_of := p_week_of;
   h_credit_week_of := p_credit_week_of;
   h_billable := p_billable;
   h_monday_regular := p_monday_regular;
   h_monday_special := p_monday_special;
   h_tuesday_regular := p_tuesday_regular;
   h_tuesday_special := p_tuesday_special;
   h_wednesday_regular := p_wednesday_regular;
   h_wednesday_special := p_wednesday_special;
   h_thursday_regular := p_thursday_regular;
   h_thursday_special := p_thursday_special;
   h_friday_regular := p_friday_regular;
   h_friday_special := p_friday_special;
   h_saturday_regular := p_saturday_regular;
   h_saturday_special := p_saturday_special;
   h_sunday_regular := p_sunday_regular;
   h_sunday_special := p_sunday_special;
   h_pda_flag := p_pda_flag;
   h_notes := p_notes;
   h_rec_user := p_rec_user;
   
   h_total_week := Coalesce(h_monday_regular, 0) + Coalesce(h_monday_special, 0) + Coalesce(
                         h_tuesday_regular, 0) + Coalesce(h_tuesday_special, 0) + Coalesce(
                         h_wednesday_regular, 0) + Coalesce(h_wednesday_special, 0) + Coalesce(
                         h_thursday_regular, 0) + Coalesce(h_thursday_special, 0) + Coalesce(
                         h_friday_regular, 0) + Coalesce(h_friday_special, 0) + Coalesce(
                         h_saturday_regular, 0) + Coalesce(h_saturday_special, 0) + Coalesce(
                         h_sunday_regular, 0) + Coalesce(h_sunday_special, 0);
   
   If (p_credit_week_of IS NOT NULL) Then
      BEGIN
         SELECT COUNT(ACT.ELEMENT_ID) INTO h_count
         FROM ACTIVITIES ACT, DETAIL_TIMESHEETS DT 
         WHERE ACT.TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND ACT.TYPE_ID = PMO_CNST.SC_TIMESHEET_ACTIVITY 
         AND DT.ACTIVITY_ID = ACT.ELEMENT_ID AND DT.WEEK_OF = h_week_of;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(146) : activities.sql(693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_DETAIL', 152+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_DETAIL(153) : activities.sql(700) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.STEPS_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 155+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_TS_DETAIL(156) : activities.sql(703) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.STEPS_NOT_FOUND, h_tsk_assignment_id
               , True);
      End If;
      
      If PMO_ORASTD.strcmp(h_credit_week_of, h_week_of) >= 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_DETAIL', 163+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_DETAIL(164) : activities.sql(711) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CREDIT_WEEK_LATER_WEEKOF), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 166+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_TS_DETAIL(167) : activities.sql(714) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CREDIT_WEEK_LATER_WEEKOF, h_id, True);
      End If;
      
      -- credit check if the same rates for the credit week and week of
      BEGIN
         SELECT PROJECT_ID, RESOURCE_ID, ACTUAL_REGULAR_COST, ACTUAL_REGULAR_RATE, WEEKLY_REGULAR_TOTAL + WEEKLY_SPECIAL_TOTAL
         INTO h_project_id, h_res_id, h_credit_regular_cost, h_credit_regular_rate, h_work_todate 
         FROM SUMMARY_TIMESHEETS 
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND WEEK_OF = h_credit_week_of;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(184) : activities.sql(731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_DETAIL', 190+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_DETAIL(191) : activities.sql(738) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 193+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_TS_DETAIL(194) : activities.sql(741) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
      Else
         BEGIN
            SELECT COALESCE(SUM(d.MONDAY_REGULAR + d.MONDAY_SPECIAL + d.TUESDAY_REGULAR + d.TUESDAY_SPECIAL 
            + d.WEDNESDAY_REGULAR + d.WEDNESDAY_SPECIAL + d.THURSDAY_REGULAR + d.THURSDAY_SPECIAL 
            + d.FRIDAY_REGULAR + d.FRIDAY_SPECIAL + d.SATURDAY_REGULAR + d.SATURDAY_SPECIAL 
            + d.SUNDAY_REGULAR + d.SUNDAY_SPECIAL), 0)
            INTO h_credit_hrs 
            FROM ACTIVITIES a, DETAIL_TIMESHEETS d 
            WHERE a.TSK_ASSIGNMENT_ID = h_tsk_assignment_id 
            AND a.TYPE_ID = PMO_CNST.SC_TIMESHEET_CREDIT 
            AND a.ELEMENT_ID = d.ACTIVITY_ID 
            AND d.CREDIT_WEEK_OF = h_credit_week_of;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(215) : activities.sql(762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_work_todate := Coalesce(h_work_todate, 0) - Coalesce(h_credit_hrs, 0);
         
         If Coalesce(h_work_todate, 0) < Coalesce(h_total_week, 0) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_DETAIL', 223+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_DETAIL(224) : activities.sql(771) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CREDIT_DIFFRENT_HOURS_RATES), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 226+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_TS_DETAIL(227) : activities.sql(774) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CREDIT_DIFFRENT_HOURS_RATES, h_id, True);
         End If;
      End If;
      
      BEGIN
         SELECT ACTUAL_REGULAR_COST, ACTUAL_REGULAR_RATE
         INTO h_actual_regular_cost, h_actual_regular_rate 
         FROM SUMMARY_TIMESHEETS 
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND WEEK_OF = h_week_of;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(244) : activities.sql(791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) OR Coalesce(h_credit_regular_cost, 0) <> Coalesce(
            h_actual_regular_cost, 0) OR Coalesce(h_credit_regular_rate, 0) <> Coalesce(
            h_actual_regular_rate, 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TS_DETAIL', 252+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TS_DETAIL(253) : activities.sql(800) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CREDIT_DIFFRENT_HOURS_RATES), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TS_DETAIL', 255+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_TS_DETAIL(256) : activities.sql(803) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CREDIT_DIFFRENT_HOURS_RATES, h_id, True);
      End If;
   End If;
   
   If Coalesce(h_total_week, 0) = 0 Then
      BEGIN
         DELETE FROM DETAIL_TIMESHEETS
         WHERE ACTIVITY_ID = h_id AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 275+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(276) : activities.sql(823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM ACTIVITIES
         WHERE ELEMENT_ID = h_id AND SHOW_STEP = 'N';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 293+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(294) : activities.sql(841) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_update := 1;
      End If;
   Else
      BEGIN
         UPDATE DETAIL_TIMESHEETS 
         SET BILLABLE = h_billable,
         MONDAY_REGULAR = h_monday_regular,
         MONDAY_SPECIAL = h_monday_special,
         TUESDAY_REGULAR = h_tuesday_regular,
         TUESDAY_SPECIAL = h_tuesday_special,
         WEDNESDAY_REGULAR = h_wednesday_regular,
         WEDNESDAY_SPECIAL = h_wednesday_special,
         THURSDAY_REGULAR = h_thursday_regular,
         THURSDAY_SPECIAL = h_thursday_special,
         FRIDAY_REGULAR = h_friday_regular,
         FRIDAY_SPECIAL = h_friday_special,
         SATURDAY_REGULAR = h_saturday_regular,
         SATURDAY_SPECIAL = h_saturday_special,
         SUNDAY_REGULAR = h_sunday_regular,
         SUNDAY_SPECIAL = h_sunday_special,
         PDA_FLAG = CASE WHEN h_pda_flag IS NOT NULL THEN h_pda_flag ELSE 'P' END,
         CREDIT_WEEK_OF = h_credit_week_of, 
         REC_USER = h_rec_user,
         REC_STATUS = 'U',
         NOTES = h_notes
         WHERE ACTIVITY_ID = h_id AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 335+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(336) : activities.sql(883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO DETAIL_TIMESHEETS (ACTIVITY_ID, WEEK_OF, BILLABLE,
            MONDAY_REGULAR, MONDAY_SPECIAL, 
            TUESDAY_REGULAR, TUESDAY_SPECIAL,
            WEDNESDAY_REGULAR, WEDNESDAY_SPECIAL,
            THURSDAY_REGULAR, THURSDAY_SPECIAL,
            FRIDAY_REGULAR, FRIDAY_SPECIAL,
            SATURDAY_REGULAR, SATURDAY_SPECIAL,
            SUNDAY_REGULAR, SUNDAY_SPECIAL,
            PDA_FLAG, 
            CREDIT_WEEK_OF, 
            REC_USER, NOTES)
            VALUES (h_id, h_week_of, h_billable,
            h_monday_regular, h_monday_special,
            h_tuesday_regular, h_tuesday_special,
            h_wednesday_regular, h_wednesday_special,
            h_thursday_regular, h_thursday_special,
            h_friday_regular, h_friday_special,
            h_saturday_regular, h_saturday_special,
            h_sunday_regular, h_sunday_special,
            CASE WHEN h_pda_flag IS NOT NULL THEN h_pda_flag ELSE 'P' END,
            h_credit_week_of, 
            h_rec_user, h_notes);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 374+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(375) : activities.sql(922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_update, 0) = 0 Then
      BEGIN
         SELECT
         COALESCE(SUM(MONDAY_REGULAR + MONDAY_SPECIAL + TUESDAY_REGULAR + TUESDAY_SPECIAL 
         + WEDNESDAY_REGULAR + WEDNESDAY_SPECIAL + THURSDAY_REGULAR + THURSDAY_SPECIAL 
         + FRIDAY_REGULAR + FRIDAY_SPECIAL + SATURDAY_REGULAR + SATURDAY_SPECIAL 
         + SUNDAY_REGULAR + SUNDAY_SPECIAL), 0)
         INTO
         h_work_todate
         FROM DETAIL_TIMESHEETS
         WHERE ACTIVITY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 398+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(399) : activities.sql(946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE ACTIVITIES 
         SET BILLABLE = h_billable,
         WORK_TODATE = h_work_todate,
         REC_USER = h_rec_user,
         REC_STATUS = 'U'
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 420+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(421) : activities.sql(968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TS_DETAIL', 427+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TS_DETAIL(428) : activities.sql(975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 434+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(435) : activities.sql(982) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TS_DETAIL', 446+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TS_DETAIL(447) : activities.sql(994) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TS_DETAIL;
ALTER FUNCTION SP_U_TS_DETAIL COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ACT_NAME ==
CREATE OR REPLACE FUNCTION SP_U_ACT_NAME
(
     p_id VARCHAR2
   , p_tsk_assignment_id VARCHAR2
   , p_name VARCHAR2
   , p_timecode_1_id VARCHAR2
   , p_timecode_1_name VARCHAR2
   , p_timecode_2_id VARCHAR2
   , p_timecode_2_name VARCHAR2
   , p_sched_work PLS_INTEGER
   , p_etc PLS_INTEGER
   , p_milestone_percent PLS_INTEGER
   , p_edpercent PLS_INTEGER
   , p_etc_modified VARCHAR2
   , p_show_step VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_name VARCHAR2(100);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_1_name VARCHAR2(100);
   h_timecode_2_id VARCHAR2(32);
   h_timecode_2_name VARCHAR2(100);
   h_etc_modified VARCHAR2(1);
   h_show_step VARCHAR2(1);
   h_sched_work PLS_INTEGER := 0;
   h_etc PLS_INTEGER := 0;
   h_milestone_percent PLS_INTEGER := 0;
   h_edpercent PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ACT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ACT_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ACT_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_timecode_1_id || ''''
          || ', ' || '''' || p_timecode_1_name || ''''
          || ', ' || '''' || p_timecode_2_id || ''''
          || ', ' || '''' || p_timecode_2_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_sched_work), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_milestone_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_edpercent), 'NULL')
          || ', ' || '''' || p_etc_modified || ''''
          || ', ' || '''' || p_show_step || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACT_NAME', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ACT_NAME(55) : activities.sql(1065) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ACT_NAME', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ACT_NAME(60) : activities.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACT_NAME', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ACT_NAME(63) : activities.sql(1073) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_tsk_assignment_id := p_tsk_assignment_id;
   h_name := p_name;
   h_timecode_1_id := p_timecode_1_id;
   h_timecode_1_name := p_timecode_1_name;
   h_timecode_2_id := p_timecode_2_id;
   h_timecode_2_name := p_timecode_2_name;
   h_sched_work := p_sched_work;
   h_etc := p_etc;
   h_milestone_percent := p_milestone_percent;
   h_edpercent := p_edpercent;
   h_etc_modified := p_etc_modified;
   h_rec_user := p_rec_user;
   If (p_show_step IS NULL) Then
      h_show_step := 'N';
   Else
      h_show_step := p_show_step;
   End If;
   
   BEGIN
      UPDATE ACTIVITIES 
      SET	ELEMENT_NAME = h_name,
      TIMECODE_1_ID = h_timecode_1_id,
      TIMECODE_1_NAME = h_timecode_1_name,
      TIMECODE_2_ID = h_timecode_2_id,
      TIMECODE_2_NAME = h_timecode_2_name,
      EFFORT_ASSIGNMENT = h_sched_work,
      ETC = h_etc,
      ETC_MODIFIED = h_etc_modified,
      MILESTONE_PERCENT = h_milestone_percent,
      EDPERCENT = h_edpercent,
      SHOW_STEP = h_show_step,
      REC_USER = h_rec_user,
      REC_STATUS = 'U'
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_NAME', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_NAME(113) : activities.sql(1123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --if( SC_NODATA )
   --{
   --    BEGIN_SQL
   --        INSERT INTO ACTIVITIES(ELEMENT_ID, TSK_ASSIGNMENT_ID, ELEMENT_NAME, TYPE_ID,
   --            TIMECODE_1_ID, TIMECODE_1_NAME,
   --            TIMECODE_2_ID, TIMECODE_2_NAME,
   --            EFFORT_ASSIGNMENT, ETC, ETC_MODIFIED,
   --            MILESTONE_PERCENT, EDPERCENT,
   --SHOW_STEP, REC_USER, REC_STATUS)
   --        VALUES(HOST(h_id), HOST(h_tsk_assignment_id), HOST(h_name), SC_TIMESHEET_ACTIVITY,
   --            HOST(h_timecode_1_id), HOST(h_timecode_1_name),
   --            HOST(h_timecode_2_id), HOST(h_timecode_2_name),
   --            HOST(h_sched_work), HOST(h_etc), HOST(h_etc_modified), HOST(h_milestone_percent), HOST(h_edpercent),
   --HOST(h_show_step), HOST(h_rec_user), 'I');
   --    END_SQL;
   --}
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ACT_NAME', 139+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ACT_NAME(140) : activities.sql(1150) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_NAME', 146+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_NAME(147) : activities.sql(1157) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_NAME', 158+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_NAME(159) : activities.sql(1169) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ACT_NAME;
ALTER FUNCTION SP_U_ACT_NAME COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_D_ACT ==
CREATE OR REPLACE FUNCTION SP_D_ACT
(
     p_id VARCHAR2
   , p_week_of VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ACT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ACT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ACT(26) : activities.sql(1211) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_week_of := p_week_of;
   
   BEGIN
      SELECT TSK_ASSIGNMENT_ID, TYPE_ID 
      INTO h_tsk_assignment_id, h_type_id
      FROM ACTIVITIES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(43) : activities.sql(1228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_count := 0;
      BEGIN
         SELECT COUNT('X') INTO h_count FROM DUAL WHERE EXISTS (
         SELECT 'X' FROM TIMESHEET_APPROVAL_STATUS s, SUMMARY_TIMESHEETS st
         WHERE st.TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND st.WEEK_OF <= h_week_of
         AND s.ELEMENT_ID = st.PROJECT_ID AND s.RESOURCE_ID = st.RESOURCE_ID AND s.WEEK_OF = st.WEEK_OF
         AND s.CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_SUBMITTED,PMO_CNST.SC_APV_STATE_RM_APPROVED,PMO_CNST.SC_APV_STATE_PM_APPROVED));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(62) : activities.sql(1247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ACT', 68+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ACT(69) : activities.sql(1254) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.TS_APPROVAL_ERROR), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ACT', 71+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_ACT(72) : activities.sql(1257) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.TS_APPROVAL_ERROR, h_id, True);
      Else
         BEGIN
            DELETE FROM DETAIL_TIMESHEETS
            WHERE ACTIVITY_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 88+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(89) : activities.sql(1274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM ACTIVITIES
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 106+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(107) : activities.sql(1292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --The broker assume there is always one default activity record in the database
         --Which is only false when the WorkToDate is greater than 0
         --Hide the problem for now!
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            If Coalesce(h_type_id, 0) = PMO_CNST.SC_TIMESHEET_ACTIVITY Then
               BEGIN
                  UPDATE TASK_ASSIGNMENTS 
                  SET ACTIVITY_COUNT = (SELECT COUNT(ELEMENT_ID) FROM ACTIVITIES
                  WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id
                  AND TSK_ASSIGNMENT_ID <> ELEMENT_ID) 
                  WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 132+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(133) : activities.sql(1318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TASK_ASSIGNMENTS 
                  SET CREDIT_COUNT = CREDIT_COUNT - 1
                  WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 151+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(152) : activities.sql(1337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ACT', 161+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ACT(162) : activities.sql(1347) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 168+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(169) : activities.sql(1354) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ACT', 180+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ACT(181) : activities.sql(1366) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ACT;
ALTER FUNCTION SP_D_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_S_ACT ==
CREATE OR REPLACE FUNCTION SP_S_ACT
(
     p_tsk_assignment_id VARCHAR2
   , p_week_of VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_tsk_assignment_id VARCHAR2(32);
   h_name VARCHAR2(100);
   h_week_of DATE;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ0 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ACT(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ACT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ACT(32) : activities.sql(1414) : ' || SYSTIMESTAMP);
   END IF; 

   h_tsk_assignment_id := p_tsk_assignment_id;
   h_week_of := p_week_of;
   
   If Coalesce(p_bitflag, 0) = 0 Then
      OPEN SELECT_READ0 FOR SELECT
      0 as LEVEL_ID, 0 as TYPE_ID, 0 as SCHED_WORK, 0 as MILESTONE_PERCENT,
      h_tsk_assignment_id || 'SAF' as ELEMENT_ID, '' as ELEMENT_NAME,
      0 as CHILD_COUNT, h_tsk_assignment_id as TSK_ASSIGNMENT_ID,
      0 as DELETED_COUNT, 0 as EDPERCENT, 0 as ETC, 0 as REMAINING,
      '' as TIMECODE_1_ID, '' as TIMECODE_1_NAME, '' as TIMECODE_2_ID, '' as TIMECODE_2_NAME,
      0 as WORK_TODATE, 0 as EDPCOMPLETED, 0 as PERCENT_SPENT,
      TO_DATE(SubStr(h_week_of, 1, 10)) as WEEK_OF,
      0 as MONDAY_REGULAR, 0 as MONDAY_SPECIAL, 0 as TUESDAY_REGULAR, 0 as TUESDAY_SPECIAL,
      0 as WEDNESDAY_REGULAR, 0 as WEDNESDAY_SPECIAL, 0 as THURSDAY_REGULAR, 0 as THURSDAY_SPECIAL,
      0 as FRIDAY_REGULAR, 0 AS FRIDAY_SPECIAL, 0 as SATURDAY_REGULAR, 0 as SATURDAY_SPECIAL,
      0 as SUNDAY_REGULAR, 0 as SUNDAY_SPECIAL, '' as REC_USER, 'U' as REC_STATUS,
      TO_TIMESTAMP('1899-12-30 8:00:00') as REC_DATETIME,
      TO_DATE(SubStr(h_week_of, 1, 10)) AS CREDIT_WEEK_OF,
      '' as NOTES,
      TO_TIMESTAMP('1899-12-30 8:00:00') as CREATED_DT,
      1 as BILLABLE, 'P' as PDA_FLAG, 'N' as ETC_MODIFIED, 'N' as SHOW_STEP
      FROM DUAL
      UNION
      SELECT
      1 AS LEVEL_ID, ACT.TYPE_ID, ACT.EFFORT_ASSIGNMENT AS SCHED_WORK,
      ACT.MILESTONE_PERCENT as MILESTONE_PERCENT , ACT.ELEMENT_ID as ELEMENT_ID, ACT.ELEMENT_NAME  as ELEMENT_NAME,
      0 AS CHILD_COUNT, ACT.TSK_ASSIGNMENT_ID  as TSK_ASSIGNMENT_ID, 0 AS DELETED_COUNT, ACT.EDPERCENT as EDPERCENT,
      ACT.ETC  as ETC, ACT.EFFORT_ASSIGNMENT - ACT.WORK_TODATE AS REMAINING, ACT.TIMECODE_1_ID AS TIMECODE_1_ID,
      ACT.TIMECODE_1_NAME AS TIMECODE_1_NAME, ACT.TIMECODE_2_ID AS TIMECODE_2_ID, ACT.TIMECODE_2_NAME AS TIMECODE_2_NAME,
      ACT.WORK_TODATE AS WORK_TODATE, CASE WHEN ACT.MILESTONE_PERCENT = 100 THEN 0 ELSE 1 END AS EDPCOMPLETED,
      0 AS PERCENT_SPENT,COALESCE(DT.WEEK_OF,TO_DATE(SubStr(h_week_of, 1, 10))) AS WEEK_OF,
      DT.MONDAY_REGULAR AS MONDAY_REGULAR, DT.MONDAY_SPECIAL AS MONDAY_SPECIAL,
      DT.TUESDAY_REGULAR AS TUESDAY_REGULAR, DT.TUESDAY_SPECIAL AS TUESDAY_SPECIAL, DT.WEDNESDAY_REGULAR AS WEDNESDAY_REGULAR,
      DT.WEDNESDAY_SPECIAL AS WEDNESDAY_SPECIAL, DT.THURSDAY_REGULAR AS THURSDAY_REGULAR, DT.THURSDAY_SPECIAL AS THURSDAY_SPECIAL,
      DT.FRIDAY_REGULAR AS FRIDAY_REGULAR, DT.FRIDAY_SPECIAL AS FRIDAY_SPECIAL, DT.SATURDAY_REGULAR AS SATURDAY_REGULAR,
      DT.SATURDAY_SPECIAL AS SATURDAY_SPECIAL, DT.SUNDAY_REGULAR AS SUNDAY_REGULAR,
      DT.SUNDAY_SPECIAL AS SUNDAY_SPECIAL, DT.REC_USER AS REC_USER, DT.REC_STATUS AS REC_STATUS,
      TO_DATE(SubStr(DT.REC_DATETIME, 1, 10)) AS REC_DATETIME,
      DT.CREDIT_WEEK_OF,
      DT.NOTES AS NOTES,
      ACT.REC_DATETIME AS CREATED_DT,
      ACT.BILLABLE AS BILLABLE,
      DT.PDA_FLAG AS PDA_FLAG, ACT.ETC_MODIFIED AS ETC_MODIFIED, ACT.SHOW_STEP
      FROM ACTIVITIES ACT
      LEFT OUTER JOIN DETAIL_TIMESHEETS DT ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
      WHERE ACT.TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND (ACT.SHOW_STEP = 'Y' OR DT.ACTIVITY_ID IS NOT NULL)
      ORDER BY LEVEL_ID, CREATED_DT;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ACT', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ACT(84) : activities.sql(1466) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ0;
   ElsIf Coalesce(p_bitflag, 0) = 1 Then
      OPEN SELECT_READ1 FOR SELECT 1 AS LEVEL_ID, ACT.TYPE_ID, ACT.EFFORT_ASSIGNMENT AS SCHED_WORK,
      ACT.MILESTONE_PERCENT, ACT.ELEMENT_ID, ACT.ELEMENT_NAME,
      0 AS CHILD_COUNT, ACT.TSK_ASSIGNMENT_ID, 0 AS DELETED_COUNT, ACT.EDPERCENT,
      ACT.ETC, ACT.EFFORT_ASSIGNMENT - ACT.WORK_TODATE AS REMAINING, ACT.TIMECODE_1_ID,
      ACT.TIMECODE_1_NAME, ACT.TIMECODE_2_ID, ACT.TIMECODE_2_NAME, ACT.WORK_TODATE,
      CASE WHEN ACT.MILESTONE_PERCENT = 100 THEN 0 ELSE 1 END AS EDPCOMPLETED,
      0 AS PERCENT_SPENT,
      COALESCE(DT.WEEK_OF, TO_DATE(SubStr(h_week_of, 1, 10))) AS WEEK_OF,
      DT.MONDAY_REGULAR,
      DT.MONDAY_SPECIAL, DT.TUESDAY_REGULAR, DT.TUESDAY_SPECIAL, DT.WEDNESDAY_REGULAR,
      DT.WEDNESDAY_SPECIAL, DT.THURSDAY_REGULAR, DT.THURSDAY_SPECIAL, DT.FRIDAY_REGULAR,
      DT.FRIDAY_SPECIAL, DT.SATURDAY_REGULAR, DT.SATURDAY_SPECIAL, DT.SUNDAY_REGULAR,
      DT.SUNDAY_SPECIAL, DT.REC_USER, DT.REC_STATUS, DT.REC_DATETIME, 
      DT.CREDIT_WEEK_OF,
      DT.NOTES,
      ACT.REC_DATETIME AS CREATED_DT, ACT.BILLABLE, DT.PDA_FLAG, ACT.ETC_MODIFIED, ACT.SHOW_STEP
      FROM ACTIVITIES ACT
      LEFT JOIN DETAIL_TIMESHEETS DT
      ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
      WHERE ACT.TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND ACT.SHOW_STEP = 'Y'
      ORDER BY LEVEL_ID, CREATED_DT;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ACT', 110+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ACT(111) : activities.sql(1493) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ1;
   ElsIf Coalesce(p_bitflag, 0) = 2 Then
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ACT', 124+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ACT(125) : activities.sql(1507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ACT', 131+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ACT(132) : activities.sql(1514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.STEPS_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ACT', 134+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_ACT(135) : activities.sql(1517) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.STEPS_NOT_FOUND, h_tsk_assignment_id
               , True);
      End If;
      
      OPEN SELECT_READ2 FOR SELECT
      0 as LEVEL_ID, 0 as TYPE_ID, 0 as SCHED_WORK, 0 as MILESTONE_PERCENT,
      h_tsk_assignment_id || 'SAF' as ELEMENT_ID, '' as ELEMENT_NAME,
      0 as CHILD_COUNT, h_tsk_assignment_id as TSK_ASSIGNMENT_ID,
      0 as DELETED_COUNT, 0 as EDPERCENT, 0 as ETC, 0 as REMAINING,
      '' as TIMECODE_1_ID, '' as TIMECODE_1_NAME, '' as TIMECODE_2_ID, '' as TIMECODE_2_NAME,
      0 as WORK_TODATE, 0 as EDPCOMPLETED, 0 as PERCENT_SPENT,
      TO_DATE(SubStr(h_week_of, 1, 10)) as WEEK_OF,
      0 as MONDAY_REGULAR, 0 as MONDAY_SPECIAL, 0 as TUESDAY_REGULAR, 0 as TUESDAY_SPECIAL,
      0 as WEDNESDAY_REGULAR, 0 as WEDNESDAY_SPECIAL, 0 as THURSDAY_REGULAR, 0 as THURSDAY_SPECIAL,
      0 as FRIDAY_REGULAR, 0 AS FRIDAY_SPECIAL, 0 as SATURDAY_REGULAR, 0 as SATURDAY_SPECIAL,
      0 as SUNDAY_REGULAR, 0 as SUNDAY_SPECIAL, '' as REC_USER, 'U' as REC_STATUS,
      TO_TIMESTAMP('1899-12-30 8:00:00') as REC_DATETIME,
      TO_DATE(SubStr(h_week_of, 1, 10)) AS CREDIT_WEEK_OF,
      '' as NOTES,
      TO_TIMESTAMP('1899-12-30 8:00:00') as CREATED_DT,
      1 as BILLABLE, 'P' as PDA_FLAG, 'N' as ETC_MODIFIED, 'N' as SHOW_STEP
      FROM DUAL
      UNION
      SELECT
      1 AS LEVEL_ID, ACT.TYPE_ID, ACT.EFFORT_ASSIGNMENT AS SCHED_WORK,
      ACT.MILESTONE_PERCENT as MILESTONE_PERCENT , ACT.ELEMENT_ID as ELEMENT_ID, ACT.ELEMENT_NAME  as ELEMENT_NAME,
      0 AS CHILD_COUNT, ACT.TSK_ASSIGNMENT_ID  as TSK_ASSIGNMENT_ID, 0 AS DELETED_COUNT, ACT.EDPERCENT as EDPERCENT,
      ACT.ETC  as ETC, ACT.EFFORT_ASSIGNMENT - ACT.WORK_TODATE AS REMAINING, ACT.TIMECODE_1_ID AS TIMECODE_1_ID,
      ACT.TIMECODE_1_NAME AS TIMECODE_1_NAME, ACT.TIMECODE_2_ID AS TIMECODE_2_ID, ACT.TIMECODE_2_NAME AS TIMECODE_2_NAME,
      ACT.WORK_TODATE AS WORK_TODATE, CASE WHEN ACT.MILESTONE_PERCENT = 100 THEN 0 ELSE 1 END AS EDPCOMPLETED,
      0 AS PERCENT_SPENT,COALESCE(DT.WEEK_OF,TO_DATE(SubStr(h_week_of, 1, 10))) AS WEEK_OF,
      DT.MONDAY_REGULAR AS MONDAY_REGULAR, DT.MONDAY_SPECIAL AS MONDAY_SPECIAL,
      DT.TUESDAY_REGULAR AS TUESDAY_REGULAR, DT.TUESDAY_SPECIAL AS TUESDAY_SPECIAL, DT.WEDNESDAY_REGULAR AS WEDNESDAY_REGULAR,
      DT.WEDNESDAY_SPECIAL AS WEDNESDAY_SPECIAL, DT.THURSDAY_REGULAR AS THURSDAY_REGULAR, DT.THURSDAY_SPECIAL AS THURSDAY_SPECIAL,
      DT.FRIDAY_REGULAR AS FRIDAY_REGULAR, DT.FRIDAY_SPECIAL AS FRIDAY_SPECIAL, DT.SATURDAY_REGULAR AS SATURDAY_REGULAR,
      DT.SATURDAY_SPECIAL AS SATURDAY_SPECIAL, DT.SUNDAY_REGULAR AS SUNDAY_REGULAR,
      DT.SUNDAY_SPECIAL AS SUNDAY_SPECIAL, DT.REC_USER AS REC_USER, DT.REC_STATUS AS REC_STATUS,
      TO_DATE(SubStr(DT.REC_DATETIME, 1, 10)) AS REC_DATETIME,
      DT.CREDIT_WEEK_OF,
      DT.NOTES AS NOTES,
      ACT.REC_DATETIME AS CREATED_DT,
      ACT.BILLABLE AS BILLABLE,
      DT.PDA_FLAG AS PDA_FLAG, ACT.ETC_MODIFIED AS ETC_MODIFIED, ACT.SHOW_STEP
      FROM ACTIVITIES ACT
      LEFT OUTER JOIN DETAIL_TIMESHEETS DT ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
      WHERE ACT.TSK_ASSIGNMENT_ID = h_tsk_assignment_id AND (TYPE_ID = PMO_CNST.SC_TIMESHEET_ACTIVITY OR DT.ACTIVITY_ID IS NOT NULL)
      ORDER BY LEVEL_ID, CREATED_DT;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ACT', 185+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ACT(186) : activities.sql(1568) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ACT', 194+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ACT(195) : activities.sql(1577) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ACT', 206+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ACT(207) : activities.sql(1589) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ACT;
ALTER FUNCTION SP_S_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ACT_ETC ==
CREATE OR REPLACE FUNCTION SP_U_ACT_ETC
(
     p_tsk_assignment_id VARCHAR2
   , p_etc_diff PLS_INTEGER
   , p_sched_work PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_ea NUMBER := 0;
   h_ratio NUMBER := 0;
-- Declare Cursors
      CURSOR C_ETC IS
         SELECT ELEMENT_ID, EFFORT_ASSIGNMENT
         FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id
         FOR UPDATE OF ETC;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ACT_ETC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ACT_ETC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ACT_ETC(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_etc_diff), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sched_work), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACT_ETC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ACT_ETC(30) : activities.sql(1635) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C_ETC;
   
   LOOP
      FETCH C_ETC INTO h_id, h_ea;
      IF C_ETC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_ratio := Coalesce(h_ea, 0) / Coalesce(p_sched_work, 0);
      
      BEGIN
         UPDATE ACTIVITIES
         SET ETC = ETC + (p_etc_diff * h_ratio)
         WHERE CURRENT OF C_ETC;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_ETC', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_ETC(62) : activities.sql(1667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_ETC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_ETC', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_ETC(76) : activities.sql(1681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ACT_ETC', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ACT_ETC(82) : activities.sql(1687) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_tsk_assignment_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_ETC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_ETC(89) : activities.sql(1694) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_ETC', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_ETC(101) : activities.sql(1706) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ACT_ETC;
ALTER FUNCTION SP_U_ACT_ETC COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ACT_MP ==
CREATE OR REPLACE FUNCTION SP_U_ACT_MP
(
     p_tsk_assignment_id VARCHAR2
   , p_milestone_percent_diff PLS_INTEGER
   , p_sched_work PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_ea NUMBER := 0;
   h_ratio NUMBER := 0;
-- Declare Cursors
      CURSOR C_MP IS
         SELECT ELEMENT_ID, EFFORT_ASSIGNMENT
         FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id
         AND TYPE_ID = PMO_CNST.SC_TIMESHEET_ACTIVITY
         FOR UPDATE OF MILESTONE_PERCENT;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ACT_MP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ACT_MP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ACT_MP(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_milestone_percent_diff), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_sched_work), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACT_MP', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ACT_MP(31) : activities.sql(1753) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C_MP;
   
   LOOP
      FETCH C_MP INTO h_id, h_ea;
      IF C_MP%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_ratio := Coalesce(h_ea, 0) / Coalesce(p_sched_work, 0);
      
      BEGIN
         UPDATE ACTIVITIES
         SET MILESTONE_PERCENT = MILESTONE_PERCENT + (p_milestone_percent_diff * h_ratio)
         WHERE CURRENT OF C_MP;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_MP', 62+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_MP(63) : activities.sql(1785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_MP ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_MP', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_MP(77) : activities.sql(1799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ACT_MP', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ACT_MP(83) : activities.sql(1805) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_tsk_assignment_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_MP', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_MP(90) : activities.sql(1812) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACT_MP', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACT_MP(102) : activities.sql(1824) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ACT_MP;
ALTER FUNCTION SP_U_ACT_MP COMPILE DEBUG;

