/****************************************************************************************/

Prompt == FUNCTION SP_U_RES_STATUS ==
CREATE OR REPLACE FUNCTION SP_U_RES_STATUS
(
     p_resource_id VARCHAR2
   , p_project_id VARCHAR2
   , p_rec_status VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR C_PID IS
         SELECT TA.PROJECT_ID 
         FROM TASK_ASSIGNMENTS TA, TMT_WBS P 
         WHERE TA.RESOURCE_ID = p_resource_id
         AND TA.TABLE_TYPE = 1
         AND TA.TASK_ID <> TA.PROJECT_ID
         AND TA.BIT_FLAG = '2' 
         AND P.ELEMENT_ID = TA.PROJECT_ID
         AND P.PROJECT_ID = TA.PROJECT_ID
         AND P.PUBLISHED = '1'
         AND P.REC_STATUS <> 'D'
         GROUP BY TA.PROJECT_ID;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_STATUS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_STATUS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_STATUS(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_status || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_STATUS', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_STATUS(36) : approval_ts.sql(39) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) OR (p_rec_status IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_STATUS', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_STATUS(41) : approval_ts.sql(44) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_STATUS', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_STATUS(44) : approval_ts.sql(47) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Update user record
   If (p_project_id IS NOT NULL) Then
      --Update user record
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET REC_STATUS = p_rec_status, REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id AND PROJECT_ID = p_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_STATUS', 64+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_STATUS(65) : approval_ts.sql(68) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Update user record
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET REC_STATUS = p_rec_status, REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_STATUS', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_STATUS(84) : approval_ts.sql(87) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_rec_status := p_rec_status;
   If PMO_ORASTD.strcmp(h_rec_status, 'U') = 0 Then
      If (p_project_id IS NOT NULL) Then
         h_project_id := p_project_id;
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      Else
         OPEN C_PID;
         
         LOOP
            FETCH C_PID INTO h_project_id;
            IF C_PID%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         END LOOP;
         
         BEGIN
            CLOSE C_PID ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_STATUS', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_STATUS(120) : approval_ts.sql(123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_STATUS', 131+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_STATUS(132) : approval_ts.sql(135) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_STATUS', 138+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_STATUS(139) : approval_ts.sql(142) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_STATUS', 150+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_STATUS(151) : approval_ts.sql(154) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_STATUS;
ALTER FUNCTION SP_U_RES_STATUS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_RES_STATUS ==
CREATE OR REPLACE FUNCTION SP_S_RES_STATUS
(
     p_resource_id VARCHAR2
   , p_project_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR C_TA0 IS
         SELECT REC_STATUS, REC_USER FROM TASK_ASSIGNMENTS
         WHERE RESOURCE_ID = p_resource_id AND REC_STATUS = 'E';

      CURSOR C_TA1 IS
         SELECT REC_STATUS, REC_USER FROM TASK_ASSIGNMENTS
         WHERE RESOURCE_ID = p_resource_id AND PROJECT_ID = p_project_id
         AND REC_STATUS = 'E';

      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RES_STATUS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RES_STATUS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RES_STATUS(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_STATUS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RES_STATUS(34) : approval_ts.sql(204) : ' || SYSTIMESTAMP);
   END IF; 

   --SC_CHAR(h_resource_id, SC_H_ID);
   --SC_CHAR(h_weekof, SC_H_DATE);
   
   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_RES_STATUS', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_RES_STATUS(42) : approval_ts.sql(212) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_STATUS', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_STATUS(45) : approval_ts.sql(215) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_resource_id), resource_id, ind_s_status->resource_id);
   --InitializeHost(SC_PARAM(h_weekof), weekof, ind_s_status->weekof);
   
   If (p_project_id IS NULL) Then
      OPEN C_TA0;
      
      FETCH C_TA0 INTO h_rec_status, h_rec_user;
      IF C_TA0%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         h_rec_user := NULL;
      End If;
      
      BEGIN
         CLOSE C_TA0 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_STATUS', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_STATUS(75) : approval_ts.sql(245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      OPEN C_TA1;
      
      FETCH C_TA1 INTO h_rec_status, h_rec_user;
      IF C_TA1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         -- check copy level lock
         BEGIN
            SELECT W.REC_USER, W.REC_STATUS INTO h_rec_user, h_rec_status
            FROM PROJECT_DETAILS PD, TMT_WBS W
            WHERE PD.PROJECT_ID = p_project_id
            AND W.PROJECT_ID = PD.PROJECT_ID
            AND W.ELEMENT_ID = PD.PROJECT_ID
            AND PD.LEVEL_LOCK > 0
            AND W.REC_STATUS = 'L';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_STATUS', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_STATUS(105) : approval_ts.sql(275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_rec_user := NULL;
         End If;
      End If;
      
      BEGIN
         CLOSE C_TA1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_STATUS', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_STATUS(123) : approval_ts.sql(293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_rec_user IS NOT NULL) Then
      OPEN SELECT_READ1 FOR SELECT 0, h_rec_status, FULL_NAME
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_STATUS', 133+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_STATUS(134) : approval_ts.sql(304) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ1;
   Else
      OPEN SELECT_READ2 FOR SELECT 0, 'V', '' FROM DUAL;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_STATUS', 139+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_STATUS(140) : approval_ts.sql(310) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_STATUS', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_STATUS(149) : approval_ts.sql(319) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_STATUS', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_STATUS(161) : approval_ts.sql(331) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RES_STATUS;
ALTER FUNCTION SP_S_RES_STATUS COMPILE DEBUG;

