Prompt == FUNCTION FC_SMP_MOVE_UP_ASSET ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_UP_ASSET
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_ASSET IS
         SELECT RANK
         FROM TMT_ASSETS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_UP_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_UP_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_UP_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_ASSET', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_UP_ASSET(36) : asset_func.sql(37) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_ASSET', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_ASSET(50) : asset_func.sql(51) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_ASSET;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_ASSET INTO h_cur_rank;
      IF MVUP_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(PARENT_RANK, h_len +5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_ASSET', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_ASSET(102) : asset_func.sql(103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_ASSET', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_ASSET(126) : asset_func.sql(127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_ASSET', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_ASSET(141) : asset_func.sql(142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_ASSET', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_ASSET(174) : asset_func.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_ASSET', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_ASSET(194) : asset_func.sql(195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --return new rank of moved item
   h_new_rank := h_target_rank;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_ASSET', 202+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_UP_ASSET(203) : asset_func.sql(204) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_ASSET', 206+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_UP_ASSET(207) : asset_func.sql(208) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_UP_ASSET;
ALTER FUNCTION FC_SMP_MOVE_UP_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_SMP_MOVE_DOWN_ASSET ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_DOWN_ASSET
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_ASSET IS
         SELECT RANK
         FROM TMT_ASSETS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_DOWN_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_DOWN_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_DOWN_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_ASSET', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_DOWN_ASSET(36) : asset_func.sql(252) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_ASSET', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_ASSET(50) : asset_func.sql(266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_ASSET;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_ASSET INTO h_cur_rank;
      IF MVDOWN_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(PARENT_RANK, h_len +5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_ASSET', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_ASSET(101) : asset_func.sql(317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_ASSET', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_ASSET(123) : asset_func.sql(339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_ASSET', 137+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_ASSET(138) : asset_func.sql(354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_ASSET', 170+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_ASSET(171) : asset_func.sql(387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_ASSET', 190+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_ASSET(191) : asset_func.sql(407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --return new rank of moved item
   h_new_rank := h_target_rank;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_ASSET', 199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DOWN_ASSET(200) : asset_func.sql(416) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_ASSET', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DOWN_ASSET(204) : asset_func.sql(420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_DOWN_ASSET;
ALTER FUNCTION FC_SMP_MOVE_DOWN_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_SMP_MOVE_DIF_ASSET ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_DIF_ASSET
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
-- Declare Cursors
      CURSOR MVDIF_ASSET IS
         SELECT RANK
         FROM TMT_ASSETS
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || '%'
         AND LEVEL_ID = h_target_level AND RANK >= h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_DIF_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_DIF_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_DIF_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_ASSET', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_DIF_ASSET(43) : asset_func.sql(471) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(56) : asset_func.sql(484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDIF_ASSET;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVDIF_ASSET INTO h_cur_rank;
      IF MVDIF_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_len := Coalesce(Length(h_next_rank), 0);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(PARENT_RANK, h_len+5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(109) : asset_func.sql(537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
         PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
         ELSE PARENT_ID END,
         LEVEL_ID = CASE WHEN h_next_rank = h_source_rank
         THEN LEVEL_ID - h_source_level + h_target_level ELSE LEVEL_ID END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(136) : asset_func.sql(564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDIF_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 150+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(151) : asset_func.sql(579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_target_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(171) : asset_func.sql(599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_ASSETS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(186) : asset_func.sql(614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_ASSETS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_target_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(205) : asset_func.sql(633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(220) : asset_func.sql(648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || h_rankBase64
      INTO h_new_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 238+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(239) : asset_func.sql(667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_len := Coalesce(Length(h_next_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_next_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_next_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET PARENT_RANK = h_prefix || 
      CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(PARENT_RANK, h_len+5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
      WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
      AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 277+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(278) : asset_func.sql(706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
      PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
      ELSE PARENT_ID END
      WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
      AND RANK LIKE h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 302+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(303) : asset_func.sql(731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 335+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(336) : asset_func.sql(764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_ASSET', 355+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_ASSET(356) : asset_func.sql(784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_ASSET', 361+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DIF_ASSET(362) : asset_func.sql(790) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_ASSET', 365+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DIF_ASSET(366) : asset_func.sql(794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_DIF_ASSET;
ALTER FUNCTION FC_SMP_MOVE_DIF_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_AST ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_AST
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_AST(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_AST(23) : asset_func.sql(825) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_AST', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_AST(27) : asset_func.sql(829) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST(48) : asset_func.sql(850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST(56) : asset_func.sql(858) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST(75) : asset_func.sql(877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST(80) : asset_func.sql(882) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST(84) : asset_func.sql(886) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_AST;
ALTER FUNCTION FC_U_ITEM_NAME_AST COMPILE DEBUG;

