/*****************************************************************************************/

Prompt == FUNCTION SP_S_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION SP_S_ATTRIBUTE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ATTRIBUTE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ATTRIBUTE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ATTRIBUTE(20) : attributes.sql(23) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   
   OPEN SELECT_READ1 FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
   DELETED_COUNT, REC_STATUS, 0 AS MULTI_SELECT,WEIGHT, '' AS DESCRIPTION,INPUT_TYPE
   FROM TMT_WBS_ATTRIBUTES
   WHERE PARENT_ID IS Null and TYPE_ID <> 0
   UNION
   SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
   DELETED_COUNT, REC_STATUS, 0 AS MULTI_SELECT,WEIGHT, '' AS DESCRIPTION,INPUT_TYPE
   FROM TMT_CRI_ATTRIBUTES
   WHERE PARENT_ID IS Null and TYPE_ID <> 0
   ORDER BY TYPE_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ATTRIBUTE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ATTRIBUTE(36) : attributes.sql(39) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN SELECT_READ1;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ATTRIBUTE', 42+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ATTRIBUTE(43) : attributes.sql(46) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ATTRIBUTE', 54+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ATTRIBUTE(55) : attributes.sql(58) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ATTRIBUTE;
ALTER FUNCTION SP_S_ATTRIBUTE COMPILE DEBUG;

/***********************************************************************/

/*  Insert a new attribute                                              */

/***********************************************************************/

Prompt == FUNCTION SP_I_ATR ==
CREATE OR REPLACE FUNCTION SP_I_ATR
(
     p_table_type PLS_INTEGER
   , p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := 0;
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ATR(29) : attributes.sql(107) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := p_table_type;
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_I_ATR(h_table_type, h_name, h_parent_id, h_type_id, h_rec_user, h_uniqueID);
   
   h_table_type := getAttributeTable(Coalesce(h_table_type, 0));
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
      CASE h_table_type
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 59+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(60) : attributes.sql(138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 80+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(81) : attributes.sql(159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 101+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(102) : attributes.sql(180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 122+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(123) : attributes.sql(201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 143+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(144) : attributes.sql(222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
            BEGIN
               UPDATE TMT_ASSET_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 164+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(165) : attributes.sql(243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES SET
               TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS,
               MULTI_SELECT = '1'
               WHERE ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 185+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(186) : attributes.sql(264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ATR', 195+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ATR(196) : attributes.sql(274) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 202+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(203) : attributes.sql(281) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ATR', 214+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ATR(215) : attributes.sql(293) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ATR;
ALTER FUNCTION SP_I_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ATR ==
CREATE OR REPLACE FUNCTION SP_U_ATR
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_weight PLS_INTEGER
   , p_input_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_description VARCHAR2(255);
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_weight PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_input_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ATR', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ATR(37) : attributes.sql(346) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_table_type := p_table_type;
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_name := p_name;
   h_description := p_description;
   h_weight := p_weight;
   h_input_type := p_input_type;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_ATR(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                              , h_input_type, h_rec_user);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) 
         OR (PMO_DB2M.SC_STATE = PMO_CNST.RECORD_NOT_FOUND) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ATR', 59+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ATR(60) : attributes.sql(369) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ATR', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ATR(67) : attributes.sql(376) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ATR', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ATR(79) : attributes.sql(388) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ATR;
ALTER FUNCTION SP_U_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_ATR_MS ==
CREATE OR REPLACE FUNCTION SP_U_ATR_MS
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_multi_select PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_multi_select PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ATR_MS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ATR_MS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ATR_MS(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_multi_select), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ATR_MS', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ATR_MS(28) : attributes.sql(432) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_table_type IS NULL)) OR ((p_id IS NULL)) OR ((p_multi_select IS NULL)) 
         OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ATR_MS', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ATR_MS(34) : attributes.sql(438) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ATR_MS', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ATR_MS(37) : attributes.sql(441) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   h_multi_select := p_multi_select;
   h_table_type := p_table_type;
   
   PMO_DB2M.SC_STATE := FC_U_ATR_MS(h_table_type, h_id, h_parent_id, h_multi_select, h_rec_user);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ATR_MS', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ATR_MS(57) : attributes.sql(461) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ATR_MS', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ATR_MS(64) : attributes.sql(468) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ATR_MS', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ATR_MS(76) : attributes.sql(480) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ATR_MS;
ALTER FUNCTION SP_U_ATR_MS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_ATR ==
CREATE OR REPLACE FUNCTION SP_D_ATR
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := 0;
   h_del_flag VARCHAR2(1);
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ATR(29) : attributes.sql(525) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_table_type IS NULL)) OR ((p_id IS NULL)) OR ((p_del_flag IS NULL)) 
         OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ATR(35) : attributes.sql(531) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ATR(38) : attributes.sql(534) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   h_table_type := p_table_type;
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_del_flag := p_del_flag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_D_ATR(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ATR', 53+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ATR(54) : attributes.sql(550) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ATR', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ATR(61) : attributes.sql(557) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ATR', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ATR(73) : attributes.sql(569) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ATR;
ALTER FUNCTION SP_D_ATR COMPILE DEBUG;

/*****************************************************************************************/

/*****************************************************************************************/

Prompt == FUNCTION SP_UN_ATR ==
CREATE OR REPLACE FUNCTION SP_UN_ATR
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_dt TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UN_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UN_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_UN_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_ATR', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UN_ATR(27) : attributes.sql(614) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_table_type IS NULL)) OR ((p_id IS NULL)) OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UN_ATR', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UN_ATR(32) : attributes.sql(619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UN_ATR(35) : attributes.sql(622) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Get a unique id
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   h_type_id := getAttributeTable(Coalesce(p_table_type, 0));
   CASE h_type_id
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         If (h_parent_id IS NULL) Then
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_WBS_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 58+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(59) : attributes.sql(646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_WBS_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 71+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(72) : attributes.sql(659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 89+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(90) : attributes.sql(677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 106+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(107) : attributes.sql(694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user WHERE REC_DATETIME = h_dt AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 123+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(124) : attributes.sql(711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         If (h_parent_id IS NULL) Then
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_CRI_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 139+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(140) : attributes.sql(727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_CRI_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 152+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(153) : attributes.sql(740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 170+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(171) : attributes.sql(758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 187+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(188) : attributes.sql(775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user WHERE REC_DATETIME = h_dt AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 204+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(205) : attributes.sql(792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      WHEN PMO_CNST.SC_DOCUMENT THEN
         If (h_parent_id IS NULL) Then
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_DOCUMENT_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(220) : attributes.sql(807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_DOCUMENT_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 232+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(233) : attributes.sql(820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 250+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(251) : attributes.sql(838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(268) : attributes.sql(855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user WHERE REC_DATETIME = h_dt AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 284+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(285) : attributes.sql(872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      WHEN PMO_CNST.SC_POOLS THEN
         If (h_parent_id IS NULL) Then
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_POOL_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 299+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(300) : attributes.sql(887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_POOL_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 312+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(313) : attributes.sql(900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 330+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(331) : attributes.sql(918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 347+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(348) : attributes.sql(935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user WHERE REC_DATETIME = h_dt AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 364+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(365) : attributes.sql(952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      WHEN PMO_CNST.SC_CLIENTS THEN
         If (h_parent_id IS NULL) Then
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_CLIENT_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 379+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(380) : attributes.sql(967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT RANK, REC_DATETIME INTO h_rank, h_dt FROM TMT_CLIENT_ATTRIBUTES WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 392+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(393) : attributes.sql(980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 410+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(411) : attributes.sql(998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 427+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(428) : attributes.sql(1015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user WHERE REC_DATETIME = h_dt AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 444+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(445) : attributes.sql(1032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UN_ATR', 453+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UN_ATR(454) : attributes.sql(1041) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 460+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(461) : attributes.sql(1048) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_ATR', 472+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_ATR(473) : attributes.sql(1060) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UN_ATR;
ALTER FUNCTION SP_UN_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_A_ATR ==
CREATE OR REPLACE FUNCTION SP_A_ATR
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ATR', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ATR(25) : attributes.sql(1101) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_table_type IS NULL)) OR ((p_element_id IS NULL)) OR ((p_id IS NULL)) 
         OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_ATR', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_ATR(31) : attributes.sql(1107) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ATR', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ATR(34) : attributes.sql(1110) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_table_type := p_table_type;
   
   PMO_DB2M.SC_STATE := FC_A_ATR(h_table_type, h_element_id, h_id, h_rec_user);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ATR', 47+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ATR(48) : attributes.sql(1124) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ATR', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ATR(55) : attributes.sql(1131) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ATR', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ATR(67) : attributes.sql(1143) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ATR;
ALTER FUNCTION SP_A_ATR COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************************************
    The function is used to unassign an attribute-- Yi Oct.07,2002
    Case 1: Remove a default attribute from the bottom window in Project Description View;
            p_element_id=project_id, p_attr_id=attribute_id, tabletype=selected Table
    Case 2: Remove an attribute from the bottom window in other Description View;
            p_element_id=element_id, p_attr_id=attribute_id, TableType=viewtype
    Case 3: Delete an element from TableType table, p_element_id=elelment_id, p_attr_id=null, TaleType=element_type

*******************************************************************************************************************/

Prompt == FUNCTION SP_UA_ATR ==
CREATE OR REPLACE FUNCTION SP_UA_ATR
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ATR', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ATR(25) : attributes.sql(1194) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_table_type IS NULL)) OR ((p_element_id IS NULL)) OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_ATR', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_ATR(30) : attributes.sql(1199) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ATR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_ATR(33) : attributes.sql(1202) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_table_type := p_table_type;
   h_element_id := p_element_id;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_UA_ATR(h_table_type, h_element_id, h_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ATR', 47+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ATR(48) : attributes.sql(1217) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ATR', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ATR(55) : attributes.sql(1224) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ATR', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ATR(67) : attributes.sql(1236) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ATR;
ALTER FUNCTION SP_UA_ATR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ATR ==
CREATE OR REPLACE FUNCTION SP_S_ATR
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_table_name VARCHAR2(100);
   h_sql VARCHAR2(2048);
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ATR', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ATR(23) : attributes.sql(1275) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_attr_table := getAttributeTable(Coalesce(p_table_type, 0));
   
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         h_table_name := 'TMT_WBS_ATTRIBUTES';
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         h_table_name := 'TMT_CRI_ATTRIBUTES';
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         h_table_name := 'TMT_DOCUMENT_ATTRIBUTES';
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         h_table_name := 'TMT_POOL_ATTRIBUTES';
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         h_table_name := 'TMT_CLIENT_ATTRIBUTES';
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         h_table_name := 'TMT_VENDOR_ATTRIBUTES';
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         h_table_name := 'TMT_ASSET_ATTRIBUTES';
      ELSE
         NULL;
   END CASE;
   
   h_sql := 
         'SELECT T.LEVEL_ID,(CASE WHEN LOCAL=''Y'' AND LEVEL_ID = 1 THEN 1 ELSE T.TYPE_ID END) AS TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
      h_sql := h_sql || 
                  'CASE WHEN TYPE_ID IN (15, 144) THEN 0 ELSE (T.CHILD_COUNT + T.DELETED_COUNT) END AS CHILD_COUNT, ';
   Else
      h_sql := h_sql || 'CASE WHEN TYPE_ID IN (15, 144) THEN 0 ELSE T.CHILD_COUNT END AS CHILD_COUNT, ';
   End If;
   
   h_sql := h_sql || 
                  'T.DELETED_COUNT, T.REC_STATUS, T.MULTI_SELECT, T.WEIGHT, T.DESCRIPTION, T.LOCAL, T.INPUT_TYPE FROM ';
   
   h_sql := h_sql || h_table_name;
   h_sql := h_sql || ' T ';
   
   -- Execute Select Statement
   If (p_id IS NULL) Then
      h_sql := h_sql || 'WHERE T.PARENT_ID IS NULL ';
      
      If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) <> 1) Then
         h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      End If;
      
      h_sql := h_sql || 'AND LOCAL = ''N'' AND LEVEL_ID > -1 ';
   Else
      If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2 OR Coalesce(p_bitflag, 0) = 3) Then
         h_sql := h_sql || ' WHERE T.PARENT_ID IS NULL ';
         h_sql := h_sql || 
                  ' AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') AND LOCAL = ''N'' AND LEVEL_ID > -1 ';
         h_sql := h_sql || ' UNION ALL ';
         h_sql := h_sql || 
                  'SELECT 0 AS LEVEL_ID, W.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
         h_sql := h_sql || 'CASE WHEN T.TYPE_ID IN (15, 144) THEN 0 ELSE T.CHILD_COUNT END AS CHILD_COUNT, ';
         h_sql := h_sql || 
                  'T.DELETED_COUNT, T.REC_STATUS, T.MULTI_SELECT, T.WEIGHT, T.DESCRIPTION, T.LOCAL, T.INPUT_TYPE FROM ';
         h_sql := h_sql || h_table_name;
         h_sql := h_sql || ' T, TMT_WBS W WHERE T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' AND T.LOCAL =''Y'' AND T.LEVEL_ID = 1 ';
         h_sql := h_sql || ' AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         h_sql := h_sql || ' AND W.PROJECT_ID = T.ELEMENT_ID AND W.ELEMENT_ID = T.ELEMENT_ID ';
      Else
         If Coalesce(p_bitflag, 0) = 5 Then
            h_sql := h_sql || 'WHERE (T.ELEMENT_ID = ''';
            h_sql := h_sql || h_id;
         Else
            h_sql := h_sql || 'WHERE (T.PARENT_ID = ''';
            h_sql := h_sql || h_id;
            h_sql := h_sql || ''' ';
            h_sql := h_sql || 'OR T.ELEMENT_ID = ''';
            h_sql := h_sql || h_id;
         End If;
         
         --h_sql.strcat("WHERE (T.PARENT_ID = '");
         --h_sql.strcat(h_id);
         --h_sql.strcat("' ");
         --h_sql.strcat("OR T.ELEMENT_ID = '");
         --h_sql.strcat(h_id);
         h_sql := h_sql || ''' ) AND TYPE_ID IN  (15, 55, 56, 144, 146, 147) ';
         
         If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 0) Then
            h_sql := h_sql || ' AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         End If;
      End If;
   End If;
   h_sql := h_sql || 'ORDER BY RANK ';
   
   --trace_printf("\n h_sql:%s",(char *) h_sql);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ATR', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ATR(127) : attributes.sql(1379) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ATR', 129+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ATR(130) : attributes.sql(1382) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ATR', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ATR(137) : attributes.sql(1389) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ATR', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ATR(149) : attributes.sql(1401) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ATR;
ALTER FUNCTION SP_S_ATR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_A_ATR ==
CREATE OR REPLACE FUNCTION SP_S_A_ATR
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_table_name VARCHAR2(100);
   h_rank VARCHAR2(200);
   tempStr VARCHAR2(99);
   h_attr_table PLS_INTEGER := 0;
   h_rnk_sql VARCHAR2(2048);
   h_sql VARCHAR2(2048);
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_ATTRID PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_ATR', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_ATR(32) : attributes.sql(1449) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_ATR', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_ATR(37) : attributes.sql(1454) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_ATR', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_ATR(40) : attributes.sql(1457) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   tempStr := TO_CHAR(Coalesce(p_table_type, 0));
   
   h_id := p_id;
   h_project_id := '';
   
   h_attr_table := getAttributeTable(Coalesce(p_table_type, 0));
   
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         BEGIN
            SELECT PROJECT_ID INTO h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_ATR', 64+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_ATR(65) : attributes.sql(1482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_table_name := 'TMT_WBS_ATTRIBUTES';
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         BEGIN
            SELECT PROJECT_ID INTO h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id AND PROJECT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_ATR', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_ATR(84) : attributes.sql(1501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_project_id := '';
         End If;
         
         h_table_name := 'TMT_CRI_ATTRIBUTES';
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         h_table_name := 'TMT_DOCUMENT_ATTRIBUTES';
         
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         h_table_name := 'TMT_POOL_ATTRIBUTES';
         
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         h_table_name := 'TMT_CLIENT_ATTRIBUTES';
         
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         h_table_name := 'TMT_VENDOR_ATTRIBUTES';
         
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         h_table_name := 'TMT_ASSET_ATTRIBUTES';
      ELSE
         NULL;
   END CASE;
   
   h_rnk_sql := 'SELECT RANK FROM ';
   h_rnk_sql := h_rnk_sql || h_table_name;
   h_rnk_sql := h_rnk_sql || ' WHERE ELEMENT_ID = ''';
   h_rnk_sql := h_rnk_sql || h_id;
   h_rnk_sql := h_rnk_sql || '''';
   h_rnk_sql := h_rnk_sql || ' AND TYPE_ID = ';
   h_rnk_sql := h_rnk_sql || tempStr;
   
   --trace_printf("h_rnk_sql: %s\n", (char*) h_rnk_sql);
   
   OPEN C_ATTRID FOR h_rnk_sql;
   
   FETCH C_ATTRID INTO h_rank;
   IF C_ATTRID%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE C_ATTRID;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_ATR', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_ATR(145) : attributes.sql(1562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      h_sql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
      h_sql := h_sql || 'T.LEVEL_ID AS CHILD_COUNT, ';
      h_sql := h_sql || 
                  'T.DELETED_COUNT, T.REC_STATUS, T.MULTI_SELECT, T.WEIGHT, T.DESCRIPTION, F.ELEMENT_NAME AS FATHER_NAME, GF.ELEMENT_NAME AS GRAND_FATHER_NAME, T.ELEMENT_ID AS WBS_ORIGINAL_ID, T.LOCAL AS LOCAL, T.INPUT_TYPE FROM ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' T LEFT OUTER JOIN ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' F ON F.ELEMENT_ID = T.PARENT_ID ';
      h_sql := h_sql || ' LEFT OUTER JOIN ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' GF ON GF.ELEMENT_ID = F.PARENT_ID ';
      h_sql := h_sql || ' WHERE SUBSTR(''';
      h_sql := h_sql || h_rank;
      h_sql := h_sql || ''',1, CASE WHEN LENGTH(T.RANK) > LENGTH(''';
      h_sql := h_sql || h_rank;
      h_sql := h_sql || ''') THEN 1 ELSE LENGTH (T.RANK) END ) = T.RANK ';
      h_sql := h_sql || 'AND (T.RANK LIKE SUBSTR(''';
      h_sql := h_sql || h_rank;
      h_sql := h_sql || ''', 1, 8) || ''%'') ';
      h_sql := h_sql || 'AND T.TYPE_ID IN (15, 55, 56, 144, 146, 147) ';
      h_sql := h_sql || 'ORDER BY T.RANK DESC ';
   Else
      h_sql := 
            'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, 0 AS CHILD_COUNT, ';
      h_sql := h_sql || 'T.DELETED_COUNT, T.REC_STATUS, T.MULTI_SELECT, T.WEIGHT, T2.DESCRIPTION, ';
      h_sql := h_sql || 
                  'T.ELEMENT_NAME AS ATTRIBUTE_NAME, F.ELEMENT_NAME AS FATHER_NAME, GF.ELEMENT_NAME AS GRAND_FATHER_NAME, T2.ELEMENT_ID AS WBS_ORIGINAL_ID ,T.LOCAL AS LOCAL, T.INPUT_TYPE FROM ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' T JOIN ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' T2 ON T2.PARENT_ID = T.ELEMENT_ID AND T2.LEVEL_ID > 1 ';
      h_sql := h_sql || '  JOIN ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' F ON F.ELEMENT_ID = T.PARENT_ID ';
      h_sql := h_sql || ' JOIN ';
      h_sql := h_sql || h_table_name;
      h_sql := h_sql || ' GF ON GF.ELEMENT_ID = F.PARENT_ID AND GF.TYPE_ID IN (56, 147) ';
      h_sql := h_sql || ' WHERE T2.ELEMENT_ID = ''';
      h_sql := h_sql || h_id;
      h_sql := h_sql || ''' ';
      
      If PMO_ORASTD.strcmp(h_id, h_project_id) = 0 Then
         h_sql := h_sql || ' AND T2.TYPE_ID = ';
         h_sql := h_sql || tempStr;
      End If;
      h_sql := h_sql || ' AND T.LEVEL_ID > 1 AND T.TYPE_ID IN (15, 55, 56, 144, 146, 147) ';
      
      h_sql := h_sql || ' AND F.TYPE_ID IN (146,55) ';
      h_sql := h_sql || ' AND GF.TYPE_ID IN (56) ';
      
      If Coalesce(p_table_type, 0) = PMO_CNST.SC_RESOURCE Then
         h_sql := h_sql || 'UNION ALL  ';
         
         h_sql := h_sql || 
                  'SELECT T.LEVEL_ID, P.TYPE_ID, T.RANK, P.PARENT_ID, T.PARENT_ID AS ELEMENT_ID, '''' AS ELEMENT_NAME, 0 AS CHILD_COUNT, ';
         h_sql := h_sql || ' T.DELETED_COUNT, T.REC_STATUS, T.MULTI_SELECT, T.WEIGHT, '''' AS DESCRIPTION, ';
         h_sql := h_sql || 
                  ' '''' AS ATTRIBUTE_NAME, case when GP.ELEMENT_NAME is null then '''' else P.ELEMENT_NAME  end AS FATHER_NAME, case when GP.ELEMENT_NAME is null then P.ELEMENT_NAME else GP.ELEMENT_NAME end AS GRAND_FATHER_NAME, ';
         h_sql := h_sql || ' '''' AS WBS_ORIGINAL_ID ,T.LOCAL AS LOCAL, T.INPUT_TYPE ';
         h_sql := h_sql || ' FROM TMT_WBS_ATTRIBUTES  T, TMT_WBS_ATTRIBUTES  P ';
         h_sql := h_sql || ' LEFT JOIN TMT_WBS_ATTRIBUTES  GP ON  GP.ELEMENT_ID = P.PARENT_ID ';
         h_sql := h_sql || ' WHERE T.TYPE_ID = 13 ';
         h_sql := h_sql || ' AND P.ELEMENT_ID = T.PARENT_ID ';
         h_sql := h_sql || ' AND P.TYPE_ID IN  (55,56,146) ';
         h_sql := h_sql || ' AND T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
      End If;
      h_sql := h_sql || 'ORDER BY RANK ';
   End If;
   
   --trace_printf("\n h_sql:%s", (char *)h_sql);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_ATR', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_ATR(225) : attributes.sql(1642) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_ATR', 227+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_ATR(228) : attributes.sql(1645) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_ATR', 235+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_ATR(236) : attributes.sql(1653) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_ATR', 247+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_ATR(248) : attributes.sql(1665) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_ATR;
ALTER FUNCTION SP_S_A_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_HISTORY ==
CREATE OR REPLACE FUNCTION SP_U_HISTORY
(
     p_element_id VARCHAR2
   , p_change_brief VARCHAR2
   , p_change_rank VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_HISTORY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_HISTORY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_HISTORY(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_change_brief || ''''
          || ', ' || '''' || p_change_rank || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_HISTORY', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_HISTORY(21) : attributes.sql(1702) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_HISTORY', 24+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_HISTORY(25) : attributes.sql(1706) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_HISTORY', 31+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_HISTORY(32) : attributes.sql(1713) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_HISTORY', 43+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_HISTORY(44) : attributes.sql(1725) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_HISTORY;
ALTER FUNCTION SP_U_HISTORY COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_ATR ==
CREATE OR REPLACE FUNCTION SP_M_ATR
(
     p_table_type PLS_INTEGER
   , p_parent_id VARCHAR2
   , p_source_id VARCHAR2
   , p_target_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ATR', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_ATR(28) : attributes.sql(1769) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ATR', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ATR(36) : attributes.sql(1777) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ATR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ATR(39) : attributes.sql(1780) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_table_type := p_table_type;
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_M_ATR(h_table_type, h_parent_id, h_source_id, h_target_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_ATR', 53+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_ATR(54) : attributes.sql(1795) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ATR', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ATR(61) : attributes.sql(1802) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ATR', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ATR(73) : attributes.sql(1814) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_ATR;
ALTER FUNCTION SP_M_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_PROJ_ATR ==
CREATE OR REPLACE FUNCTION SP_M_PROJ_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_PROJ_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_PROJ_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_PROJ_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_PROJ_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_PROJ_ATR(29) : attributes.sql(1859) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_PROJ_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_PROJ_ATR(35) : attributes.sql(1865) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_PROJ_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_PROJ_ATR(38) : attributes.sql(1868) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   h_element_id := h_source_id;
   h_table_type := 1;
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_PROJ_ATR', 58+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_PROJ_ATR(59) : attributes.sql(1889) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_PROJ_ATR', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_PROJ_ATR(62) : attributes.sql(1892) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_PROJ_ATR', 67+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_PROJ_ATR(68) : attributes.sql(1898) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_PROJ_ATR', 74+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_PROJ_ATR(75) : attributes.sql(1905) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_PROJ_ATR', 86+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_PROJ_ATR(87) : attributes.sql(1917) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_PROJ_ATR;
ALTER FUNCTION SP_M_PROJ_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_DEL_ATR ==
CREATE OR REPLACE FUNCTION SP_M_DEL_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_DEL_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_DEL_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_DEL_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DEL_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_DEL_ATR(29) : attributes.sql(1962) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DEL_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DEL_ATR(35) : attributes.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DEL_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_DEL_ATR(38) : attributes.sql(1971) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 2;
   
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DEL_ATR', 60+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DEL_ATR(61) : attributes.sql(1994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DEL_ATR', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_DEL_ATR(64) : attributes.sql(1997) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_DEL_ATR', 69+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_DEL_ATR(70) : attributes.sql(2003) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DEL_ATR', 76+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DEL_ATR(77) : attributes.sql(2010) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DEL_ATR', 88+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DEL_ATR(89) : attributes.sql(2022) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_DEL_ATR;
ALTER FUNCTION SP_M_DEL_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_TASK_ATR ==
CREATE OR REPLACE FUNCTION SP_M_TASK_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_TASK_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_TASK_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_TASK_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_TASK_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_TASK_ATR(29) : attributes.sql(2067) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_TASK_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_TASK_ATR(35) : attributes.sql(2073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_TASK_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_TASK_ATR(38) : attributes.sql(2076) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 3;
   
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_TASK_ATR', 60+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_TASK_ATR(61) : attributes.sql(2099) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_TASK_ATR', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_TASK_ATR(64) : attributes.sql(2102) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_TASK_ATR', 69+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_TASK_ATR(70) : attributes.sql(2108) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_TASK_ATR', 76+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_TASK_ATR(77) : attributes.sql(2115) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_TASK_ATR', 88+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_TASK_ATR(89) : attributes.sql(2127) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_TASK_ATR;
ALTER FUNCTION SP_M_TASK_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_RISK_ATR ==
CREATE OR REPLACE FUNCTION SP_M_RISK_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_RISK_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_RISK_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_RISK_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_RISK_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_RISK_ATR(29) : attributes.sql(2172) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_RISK_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_RISK_ATR(35) : attributes.sql(2178) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_RISK_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_RISK_ATR(38) : attributes.sql(2181) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 5;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_RISK_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_RISK_ATR(60) : attributes.sql(2203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_RISK_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_RISK_ATR(63) : attributes.sql(2206) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_RISK_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_RISK_ATR(69) : attributes.sql(2212) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_RISK_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_RISK_ATR(76) : attributes.sql(2219) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_RISK_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_RISK_ATR(88) : attributes.sql(2231) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_RISK_ATR;
ALTER FUNCTION SP_M_RISK_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_CR_ATR ==
CREATE OR REPLACE FUNCTION SP_M_CR_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CR_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CR_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CR_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CR_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CR_ATR(29) : attributes.sql(2276) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_CR_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_CR_ATR(35) : attributes.sql(2282) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CR_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_CR_ATR(38) : attributes.sql(2285) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 4;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_CR_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_CR_ATR(60) : attributes.sql(2307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CR_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_CR_ATR(63) : attributes.sql(2310) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CR_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CR_ATR(69) : attributes.sql(2316) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CR_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CR_ATR(76) : attributes.sql(2323) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CR_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CR_ATR(88) : attributes.sql(2335) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CR_ATR;
ALTER FUNCTION SP_M_CR_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_ISS_ATR ==
CREATE OR REPLACE FUNCTION SP_M_ISS_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_ISS_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_ISS_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_ISS_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ISS_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_ISS_ATR(29) : attributes.sql(2380) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ISS_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ISS_ATR(35) : attributes.sql(2386) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ISS_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ISS_ATR(38) : attributes.sql(2389) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 6;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ISS_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ISS_ATR(60) : attributes.sql(2411) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ISS_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ISS_ATR(63) : attributes.sql(2414) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_ISS_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_ISS_ATR(69) : attributes.sql(2420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ISS_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ISS_ATR(76) : attributes.sql(2427) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ISS_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ISS_ATR(88) : attributes.sql(2439) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_ISS_ATR;
ALTER FUNCTION SP_M_ISS_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_POOL_ATR ==
CREATE OR REPLACE FUNCTION SP_M_POOL_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_POOL_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_POOL_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_POOL_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_POOL_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_POOL_ATR(29) : attributes.sql(2484) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_POOL_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_POOL_ATR(35) : attributes.sql(2490) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_POOL_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_POOL_ATR(38) : attributes.sql(2493) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 11;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_POOL_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_POOL_ATR(60) : attributes.sql(2515) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_POOL_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_POOL_ATR(63) : attributes.sql(2518) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_POOL_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_POOL_ATR(69) : attributes.sql(2524) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_POOL_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_POOL_ATR(76) : attributes.sql(2531) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_POOL_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_POOL_ATR(88) : attributes.sql(2543) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_POOL_ATR;
ALTER FUNCTION SP_M_POOL_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_DOC_ATR ==
CREATE OR REPLACE FUNCTION SP_M_DOC_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_DOC_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_DOC_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_DOC_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DOC_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_DOC_ATR(29) : attributes.sql(2588) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DOC_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DOC_ATR(35) : attributes.sql(2594) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DOC_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_DOC_ATR(38) : attributes.sql(2597) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 14;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DOC_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DOC_ATR(60) : attributes.sql(2619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DOC_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_DOC_ATR(63) : attributes.sql(2622) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_DOC_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_DOC_ATR(69) : attributes.sql(2628) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DOC_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DOC_ATR(76) : attributes.sql(2635) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DOC_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DOC_ATR(88) : attributes.sql(2647) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_DOC_ATR;
ALTER FUNCTION SP_M_DOC_ATR COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_M_REQ_ATR ==
CREATE OR REPLACE FUNCTION SP_M_REQ_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_REQ_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_REQ_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_REQ_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_REQ_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_REQ_ATR(29) : attributes.sql(2692) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_REQ_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_REQ_ATR(35) : attributes.sql(2698) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_REQ_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_REQ_ATR(38) : attributes.sql(2701) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := 213;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_REQ_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_REQ_ATR(60) : attributes.sql(2723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_REQ_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_REQ_ATR(63) : attributes.sql(2726) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_REQ_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_REQ_ATR(69) : attributes.sql(2732) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_REQ_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_REQ_ATR(76) : attributes.sql(2739) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_REQ_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_REQ_ATR(88) : attributes.sql(2751) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_REQ_ATR;
ALTER FUNCTION SP_M_REQ_ATR COMPILE DEBUG;

Prompt == FUNCTION SP_M_CLIENT_ATR ==
CREATE OR REPLACE FUNCTION SP_M_CLIENT_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CLIENT_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CLIENT_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CLIENT_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CLIENT_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CLIENT_ATR(29) : attributes.sql(2794) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_CLIENT_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_CLIENT_ATR(35) : attributes.sql(2800) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CLIENT_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_CLIENT_ATR(38) : attributes.sql(2803) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := PMO_CNST.SC_CLIENTS;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_CLIENT_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_CLIENT_ATR(60) : attributes.sql(2825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CLIENT_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_CLIENT_ATR(63) : attributes.sql(2828) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CLIENT_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CLIENT_ATR(69) : attributes.sql(2834) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT_ATR(76) : attributes.sql(2841) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT_ATR(88) : attributes.sql(2853) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CLIENT_ATR;
ALTER FUNCTION SP_M_CLIENT_ATR COMPILE DEBUG;

Prompt == FUNCTION SP_M_ASSET_ATR ==
CREATE OR REPLACE FUNCTION SP_M_ASSET_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_ASSET_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_ASSET_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_ASSET_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ASSET_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_ASSET_ATR(29) : attributes.sql(2896) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ASSET_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ASSET_ATR(35) : attributes.sql(2902) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ASSET_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ASSET_ATR(38) : attributes.sql(2905) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := PMO_CNST.SC_ASSETS;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ASSET_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ASSET_ATR(60) : attributes.sql(2927) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ASSET_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ASSET_ATR(63) : attributes.sql(2930) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_ASSET_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_ASSET_ATR(69) : attributes.sql(2936) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET_ATR(76) : attributes.sql(2943) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET_ATR(88) : attributes.sql(2955) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_ASSET_ATR;
ALTER FUNCTION SP_M_ASSET_ATR COMPILE DEBUG;

Prompt == FUNCTION SP_M_VENDOR_ATR ==
CREATE OR REPLACE FUNCTION SP_M_VENDOR_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_VENDOR_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_VENDOR_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_VENDOR_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_VENDOR_ATR(29) : attributes.sql(2998) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR_ATR(35) : attributes.sql(3004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR_ATR(38) : attributes.sql(3007) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := PMO_CNST.SC_VENDORS;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR_ATR(60) : attributes.sql(3029) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR_ATR(63) : attributes.sql(3032) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_VENDOR_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_VENDOR_ATR(69) : attributes.sql(3038) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR_ATR(76) : attributes.sql(3045) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR_ATR(88) : attributes.sql(3057) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_VENDOR_ATR;
ALTER FUNCTION SP_M_VENDOR_ATR COMPILE DEBUG;

Prompt == FUNCTION SP_M_SRVREQ_ATR ==
CREATE OR REPLACE FUNCTION SP_M_SRVREQ_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_SRVREQ_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_SRVREQ_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_SRVREQ_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_SRVREQ_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_SRVREQ_ATR(29) : attributes.sql(3100) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_SRVREQ_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_SRVREQ_ATR(35) : attributes.sql(3106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_SRVREQ_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_SRVREQ_ATR(38) : attributes.sql(3109) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := PMO_CNST.SC_CRI_SERVICE_REQUEST;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_SRVREQ_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_SRVREQ_ATR(60) : attributes.sql(3131) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_SRVREQ_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_SRVREQ_ATR(63) : attributes.sql(3134) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_SRVREQ_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_SRVREQ_ATR(69) : attributes.sql(3140) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_SRVREQ_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_SRVREQ_ATR(76) : attributes.sql(3147) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_SRVREQ_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_SRVREQ_ATR(88) : attributes.sql(3159) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_SRVREQ_ATR;
ALTER FUNCTION SP_M_SRVREQ_ATR COMPILE DEBUG;

Prompt == FUNCTION SP_M_DEF_ATR ==
CREATE OR REPLACE FUNCTION SP_M_DEF_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_DEF_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_DEF_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_DEF_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DEF_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_DEF_ATR(29) : attributes.sql(3202) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DEF_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DEF_ATR(35) : attributes.sql(3208) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DEF_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_DEF_ATR(38) : attributes.sql(3211) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := PMO_CNST.SC_CRI_DEFECT;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_DEF_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_DEF_ATR(60) : attributes.sql(3233) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_DEF_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_DEF_ATR(63) : attributes.sql(3236) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_DEF_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_DEF_ATR(69) : attributes.sql(3242) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DEF_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DEF_ATR(76) : attributes.sql(3249) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_DEF_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_DEF_ATR(88) : attributes.sql(3261) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_DEF_ATR;
ALTER FUNCTION SP_M_DEF_ATR COMPILE DEBUG;

Prompt == FUNCTION SP_M_ACT_ITM_ATR ==
CREATE OR REPLACE FUNCTION SP_M_ACT_ITM_ATR
(
     p_table_type PLS_INTEGER
   , p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := 0;
   h_source_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_ACT_ITM_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_ACT_ITM_ATR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_ACT_ITM_ATR(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ACT_ITM_ATR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_ACT_ITM_ATR(29) : attributes.sql(3304) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If ((p_source_id IS NULL)) OR ((p_target_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ACT_ITM_ATR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ACT_ITM_ATR(35) : attributes.sql(3310) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ACT_ITM_ATR', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ACT_ITM_ATR(38) : attributes.sql(3313) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Parse parameters to local variables
   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_element_id := h_source_id;
   h_table_type := PMO_CNST.SC_CRI_ACTION_ITEM;
   If (BITAND(Coalesce(h_bitflag, 0), 4)) = 4 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   PMO_DB2M.SC_STATE := FC_M_ATR_DEF(h_table_type, h_target_id, h_source_id, h_bitflag, h_rec_user
                                  , h_element_id);
   
   If PMO_DB2M.SC_STATE = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_ACT_ITM_ATR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_ACT_ITM_ATR(60) : attributes.sql(3335) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ACT_ITM_ATR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_ACT_ITM_ATR(63) : attributes.sql(3338) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARENT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_ACT_ITM_ATR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_ACT_ITM_ATR(69) : attributes.sql(3344) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ACT_ITM_ATR', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ACT_ITM_ATR(76) : attributes.sql(3351) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ACT_ITM_ATR', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ACT_ITM_ATR(88) : attributes.sql(3363) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_ACT_ITM_ATR;
ALTER FUNCTION SP_M_ACT_ITM_ATR COMPILE DEBUG;

