Prompt == FUNCTION FC_SMP_MOVE_UP_CLN ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_UP_CLN
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CLN IS
         SELECT RANK
         FROM TMT_CLIENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_UP_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_UP_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_UP_CLN(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_CLN', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_UP_CLN(36) : client_func.sql(37) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(50) : client_func.sql(51) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CLN;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_CLN INTO h_cur_rank;
      IF MVUP_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(PARENT_RANK, h_len +5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(102) : client_func.sql(103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(126) : client_func.sql(127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(141) : client_func.sql(142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(174) : client_func.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_UP_CLN', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_UP_CLN(194) : client_func.sql(195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --return new rank of moved item
   h_new_rank := h_target_rank;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_CLN', 202+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_UP_CLN(203) : client_func.sql(204) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_UP_CLN', 206+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_UP_CLN(207) : client_func.sql(208) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_UP_CLN;
ALTER FUNCTION FC_SMP_MOVE_UP_CLN COMPILE DEBUG;

Prompt == FUNCTION FC_SMP_MOVE_DOWN_CLN ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_DOWN_CLN
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CLN IS
         SELECT RANK
         FROM TMT_CLIENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_DOWN_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_DOWN_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_DOWN_CLN(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_CLN', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_DOWN_CLN(36) : client_func.sql(252) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(50) : client_func.sql(266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CLN;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_CLN INTO h_cur_rank;
      IF MVDOWN_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(PARENT_RANK, h_len +5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(101) : client_func.sql(317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(123) : client_func.sql(339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 137+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(138) : client_func.sql(354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 170+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(171) : client_func.sql(387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DOWN_CLN', 190+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DOWN_CLN(191) : client_func.sql(407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --return new rank of moved item
   h_new_rank := h_target_rank;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_CLN', 199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DOWN_CLN(200) : client_func.sql(416) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DOWN_CLN', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DOWN_CLN(204) : client_func.sql(420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_DOWN_CLN;
ALTER FUNCTION FC_SMP_MOVE_DOWN_CLN COMPILE DEBUG;

Prompt == FUNCTION FC_SMP_MOVE_DIF_CLN ==
CREATE OR REPLACE FUNCTION FC_SMP_MOVE_DIF_CLN
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_new_rank IN OUT NOCOPY VARCHAR2
   , h_prefix IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
-- Declare Cursors
      CURSOR MVDIF_CLN IS
         SELECT RANK
         FROM TMT_CLIENTS
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || '%'
         AND LEVEL_ID = h_target_level AND RANK >= h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SMP_MOVE_DIF_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SMP_MOVE_DIF_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_SMP_MOVE_DIF_CLN(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_new_rank || ''''
          || ', ' || '''' || h_prefix || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_CLN', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SMP_MOVE_DIF_CLN(43) : client_func.sql(471) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(56) : client_func.sql(484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDIF_CLN;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVDIF_CLN INTO h_cur_rank;
      IF MVDIF_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_len := Coalesce(Length(h_next_rank), 0);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = h_prefix || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(PARENT_RANK, h_len+5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
         WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
         AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(109) : client_func.sql(537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
         PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
         ELSE PARENT_ID END,
         LEVEL_ID = CASE WHEN h_next_rank = h_source_rank
         THEN LEVEL_ID - h_source_level + h_target_level ELSE LEVEL_ID END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(136) : client_func.sql(564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDIF_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 150+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(151) : client_func.sql(579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_target_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_CLIENTS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(171) : client_func.sql(599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(186) : client_func.sql(614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENTS
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_target_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(205) : client_func.sql(633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 219+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(220) : client_func.sql(648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || h_rankBase64
      INTO h_new_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 238+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(239) : client_func.sql(667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_len := Coalesce(Length(h_next_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_next_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_next_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = h_prefix || 
      CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(PARENT_RANK, h_len+5, LENGTH(PARENT_RANK)-h_len-4) || h_extend_rank END
      WHERE (SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK)- 3, 4 ) <> h_extend_rank)
      AND PARENT_RANK LIKE h_prefix || h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 277+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(278) : client_func.sql(706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
      PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
      ELSE PARENT_ID END
      WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
      AND RANK LIKE h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 302+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(303) : client_func.sql(731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET PARENT_RANK = SUBSTR(PARENT_RANK, 1, LENGTH(PARENT_RANK) - 4)
      WHERE PARENT_RANK LIKE h_prefix || SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(PARENT_RANK, LENGTH(PARENT_RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 335+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(336) : client_func.sql(764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SMP_MOVE_DIF_CLN', 355+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SMP_MOVE_DIF_CLN(356) : client_func.sql(784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_CLN', 361+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DIF_CLN(362) : client_func.sql(790) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SMP_MOVE_DIF_CLN', 365+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SMP_MOVE_DIF_CLN(366) : client_func.sql(794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SMP_MOVE_DIF_CLN;
ALTER FUNCTION FC_SMP_MOVE_DIF_CLN COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_CLN ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_CLN
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_CLN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_CLN'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_CLN(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_CLN(23) : client_func.sql(825) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_CLN', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_CLN(27) : client_func.sql(829) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN(48) : client_func.sql(850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN(56) : client_func.sql(858) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN(75) : client_func.sql(877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN(80) : client_func.sql(882) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN(84) : client_func.sql(886) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_CLN;
ALTER FUNCTION FC_U_ITEM_NAME_CLN COMPILE DEBUG;

