/**
 * Copyright 2000 Systemcorp - All rights reserved. Made in Canada.
 *

 * Description:
 *
 * Author: Tudor Toma
 * Revision: 42
 * Date: 7/31/00 6:18p
 *
 **/

/***************************************************************************************************

***************************************************************************************************/

Prompt == FUNCTION POPULATE_TMP_CDY ==
CREATE OR REPLACE FUNCTION POPULATE_TMP_CDY
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , h_calendar_id IN OUT NOCOPY VARCHAR2
   , h_start_D IN OUT NOCOPY DATE
   , h_finish_D IN OUT NOCOPY DATE
   , sh_h_duration PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_duration PLS_INTEGER := sh_h_duration;
   h_current_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_monday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_thursday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_wednesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_tuesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_friday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_saturday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_sunday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_exception_date DATE;
   h_dayofyear DATE;
   h_SD DATE;
   h_FD DATE;
   h_rank VARCHAR2(200);
   h_current_daynumber PLS_INTEGER := 0;
   h_current_min PLS_INTEGER := 0;
   h_current_weekday PLS_INTEGER := 0;
   h_friday_min PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_monday_min PLS_INTEGER := 0;
   h_saturday_min PLS_INTEGER := 0;
   h_sunday_min PLS_INTEGER := 0;
   h_thursday_min PLS_INTEGER := 0;
   h_tuesday_min PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_wednesday_min PLS_INTEGER := 0;
   h_week_iso PLS_INTEGER := 0;
   h_month_iso PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_c_year PLS_INTEGER := 0;
   h_start_year PLS_INTEGER := 0;
   h_start_month PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_end_month PLS_INTEGER := 0;
   h_c_duration PLS_INTEGER := 0;
   iSF PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_EXCEPTS IS
         SELECT EXCEPTION_DATE, EXCEPTION_MIN, EXCEPTION_BIT
         FROM CALENDAR_EXCEPTIONS
         WHERE CALENDAR_ID IN
         (
         SELECT ELEMENT_ID FROM TMT_CALENDARS
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR( h_rank, 1, LENGTH(RANK) ) = RANK
         )
         AND EXCEPTION_DATE BETWEEN TO_DATE(SubStr(TO_DATE(SubStr(h_SD, 1, 10)), 1, 10)) AND TO_DATE(SubStr(TO_DATE(SubStr(h_FD, 1, 10)), 1, 10));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('POPULATE_TMP_CDY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('POPULATE_TMP_CDY'), '-- ' || SYSTIMESTAMP, ':r := POPULATE_TMP_CDY(' || 
       '''' || h_element_id || ''''
          || ', ' || '''' || h_calendar_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_D || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_D || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_duration), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_TMP_CDY', 68+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: POPULATE_TMP_CDY(69) : cplan2.sql(86) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_SD := h_start_D;
   h_FD := h_finish_D;
   
   If ((h_SD IS NULL)) OR (Coalesce(Length(h_SD), 0) = 0) Then
      BEGIN
         SELECT TO_DATE(SYSDATE) INTO h_SD FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(86) : cplan2.sql(103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If ((h_FD IS NOT NULL)) AND (Coalesce(Length(h_FD), 0) >= 10) Then
      -- Assuming the start_date and finish_date are in good format
      BEGIN
         SELECT PMO_ORASTD.DAYS(TO_DATE(SubStr(h_FD, 1, 10))) - PMO_ORASTD.DAYS(TO_DATE(SubStr(h_SD, 1, 10))) INTO h_duration FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(102) : cplan2.sql(119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_duration, 0) < 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_TMP_CDY', 108+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: POPULATE_TMP_CDY(109) : cplan2.sql(126) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.F_DATE_EARLIER_THAN_S_DATE;
      End If;
      
      iSF := 1;
   ElsIf Coalesce(h_duration, 0) = 0 Then
      BEGIN
         SELECT SETTING_VALUE INTO h_duration FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CPLAN_PROJECT_CALENDAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(124) : cplan2.sql(141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_duration IS NULL)) OR (Coalesce(h_duration, 0) = 0) Then
         h_duration := 1200;
      End If;
   End If;
   
   If Coalesce(Length(h_calendar_id), 0) = 0 Then
      BEGIN
         SELECT
         RTRIM(RANK),
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT
         INTO
         h_rank,
         h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit
         FROM TMT_CALENDARS WHERE ELEMENT_ID IS Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(151) : cplan2.sql(168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT
         RTRIM(RANK),
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT
         INTO
         h_rank,
         h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit
         FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(172) : cplan2.sql(189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            SELECT
            RTRIM(RANK),
            MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN,
            MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT
            INTO
            h_rank,
            h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min,
            h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit
            FROM TMT_CALENDARS WHERE ELEMENT_ID IS Null;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 193+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(194) : cplan2.sql(211) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   -- ********************************************************************
   -- Insert records day by day
   -- ********************************************************************
   
   -- Get start_date (weekday value)
   BEGIN
      SELECT PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_SD, 1, 10))) INTO h_current_weekday FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 213+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(214) : cplan2.sql(231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_current_daynumber := 0;
   h_c_duration := 0;
   
   h_dayofyear := h_SD;
   
   LOOP
      If (iSF = 0) AND (Coalesce(h_c_duration, 0) >= Coalesce(h_duration, 0)) Then
         EXIT;
      ElsIf PMO_ORASTD.strncmp(h_FD, h_dayofyear, 10) <= 0 Then
         EXIT;
      End If;
      
      CASE h_current_weekday
         
         WHEN 1 THEN
            h_current_bit := h_sunday_bit;
            h_current_min := Coalesce(h_sunday_min, 0);
         
         WHEN 2 THEN
            h_current_bit := h_monday_bit;
            h_current_min := Coalesce(h_monday_min, 0);
         
         WHEN 3 THEN
            h_current_bit := h_tuesday_bit;
            h_current_min := Coalesce(h_tuesday_min, 0);
         
         WHEN 4 THEN
            h_current_bit := h_wednesday_bit;
            h_current_min := Coalesce(h_wednesday_min, 0);
         
         WHEN 5 THEN
            h_current_bit := h_thursday_bit;
            h_current_min := Coalesce(h_thursday_min, 0);
         
         WHEN 6 THEN
            h_current_bit := h_friday_bit;
            h_current_min := Coalesce(h_friday_min, 0);
         
         WHEN 7 THEN
            h_current_bit := h_saturday_bit;
            h_current_min := Coalesce(h_saturday_min, 0);
         ELSE
            NULL;
      END CASE;
      
      -- insert into DayOfYear Table
      BEGIN
         SELECT  TO_DATE(SubStr(h_SD, 1, 10)) + h_current_daynumber      INTO h_dayofyear FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 272+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(273) : cplan2.sql(290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_current_min, 0) > 0 Then
         BEGIN
            SELECT PMO_ORASTD.WEEK_ISO(h_dayofyear), PMO_ORASTD.MONTH(h_dayofyear)  INTO h_week_iso, h_month_iso
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 287+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(288) : cplan2.sql(305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
            BEGIN
               INSERT INTO PMO_TMP_CDY( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
               VALUES(h_element_id, h_dayofyear, h_current_weekday, h_current_min, h_current_bit, PMO_ORASTD.WEEK_ISO(h_dayofyear), 1, PMO_ORASTD.YEAR(h_dayofyear)+1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 306+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(307) : cplan2.sql(324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
            BEGIN
               INSERT INTO PMO_TMP_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
               VALUES(h_element_id, h_dayofyear, h_current_weekday, h_current_min, h_current_bit, PMO_ORASTD.WEEK_ISO(h_dayofyear), 12, PMO_ORASTD.YEAR(h_dayofyear)-1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 324+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(325) : cplan2.sql(342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_TMP_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
               VALUES(h_element_id, h_dayofyear, h_current_weekday, h_current_min, h_current_bit, PMO_ORASTD.WEEK_ISO(h_dayofyear), PMO_ORASTD.MONTH(h_dayofyear), PMO_ORASTD.YEAR(h_dayofyear));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 342+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(343) : cplan2.sql(360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_c_duration := Coalesce(h_c_duration, 0) + 1;
      End If;
      
      h_current_weekday := Coalesce(h_current_weekday, 0) + 1;
      
      If Coalesce(h_current_weekday, 0) = 8 Then
         h_current_weekday := 1;
      End If;
      
      h_current_daynumber := Coalesce(h_current_daynumber, 0) + 1;
   END LOOP;
   -- end of while loop
   
   If ((h_FD IS NULL)) Then
      h_FD := h_dayofyear;
   End If;
   
   -- ********************************************************************
   -- Insert exceptions
   -- ********************************************************************
   If Coalesce(Length(h_calendar_id), 0) > 0 Then
      -- if there are exception...
      
      OPEN C_EXCEPTS;
      
      LOOP
         FETCH C_EXCEPTS INTO h_exception_date, h_current_min, h_current_bit;
         IF C_EXCEPTS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If Coalesce(h_current_min, 0) > 0 Then
            BEGIN
               SELECT PMO_ORASTD.WEEK_ISO(h_exception_date), PMO_ORASTD.MONTH(h_exception_date)
               INTO h_week_iso, h_month_iso
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 395+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(396) : cplan2.sql(413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
               --removed ASSIGNED_MIN from insertion
               BEGIN
                  INSERT INTO PMO_TMP_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
                  VALUES(h_element_id, h_exception_date, h_current_weekday, h_current_min, h_current_bit, PMO_ORASTD.WEEK_ISO(h_exception_date), 1, PMO_ORASTD.YEAR(h_exception_date)+1);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 415+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(416) : cplan2.sql(433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
               BEGIN
                  INSERT INTO PMO_TMP_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
                  VALUES(h_element_id, h_exception_date, h_current_weekday, h_current_min, h_current_bit, PMO_ORASTD.WEEK_ISO(h_exception_date), 12, PMO_ORASTD.YEAR(h_exception_date)-1);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 433+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(434) : cplan2.sql(451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PMO_TMP_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
                  VALUES(h_element_id, h_exception_date, PMO_ORASTD.DAYOFWEEK(h_exception_date), h_current_min, h_current_bit, PMO_ORASTD.WEEK_ISO(h_exception_date), PMO_ORASTD.MONTH(h_exception_date), PMO_ORASTD.YEAR(h_exception_date));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 451+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(452) : cplan2.sql(469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf Coalesce(h_current_min, 0) = 0 Then
            BEGIN
               DELETE FROM PMO_TMP_CDY WHERE ELEMENT_ID = h_element_id AND DAY_YEAR = TO_DATE(SubStr(h_exception_date, 1, 10));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 469+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(470) : cplan2.sql(487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_EXCEPTS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_TMP_CDY', 484+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_TMP_CDY(485) : cplan2.sql(502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_start_D IS NULL) Then
      h_start_D := h_SD;
   End If;
   If (h_finish_D IS NULL) Then
      h_finish_D := h_FD;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_TMP_CDY', 498+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: POPULATE_TMP_CDY(499) : cplan2.sql(516) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION POPULATE_TMP_CDY;
ALTER FUNCTION POPULATE_TMP_CDY COMPILE DEBUG;

Prompt == FUNCTION FC_CONTOUR_DAY ==
CREATE OR REPLACE FUNCTION FC_CONTOUR_DAY
(
     h_res_id IN OUT NOCOPY VARCHAR2
   , h_start_DT IN OUT NOCOPY TIMESTAMP
   , h_finish_DT IN OUT NOCOPY TIMESTAMP
   , sh_h_bitflag PLS_INTEGER
   , sh_h_work PLS_INTEGER
   , sh_h_unit PLS_INTEGER
   , sh_h_contour PLS_INTEGER
   , sh_h_occurrence PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_work PLS_INTEGER := sh_h_work;
   h_unit PLS_INTEGER := sh_h_unit;
   h_contour PLS_INTEGER := sh_h_contour;
   h_occurrence PLS_INTEGER := sh_h_occurrence;
   h_dayofyear DATE;
   h_every PLS_INTEGER := 0;
   h_day PLS_INTEGER := 0;
   h_dayofweek PLS_INTEGER := 0;
   h_dayofmonth PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_week PLS_INTEGER := 0;
   h_c_week PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_temp_stmt VARCHAR2(1999);
   CONTOUR1DAY PMO_ARRAYS.PLS_INTEGER_M7 := PMO_ARRAYS.PLS_INTEGER_M7_Zeros;
   i_every PLS_INTEGER NOT NULL := Coalesce(h_every, 0);
   i_previous PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CONTOUR_DAY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CONTOUR_DAY'), '-- ' || SYSTIMESTAMP, ':r := FC_CONTOUR_DAY(' || 
       '''' || h_res_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_work), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_unit), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_contour), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_occurrence), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONTOUR_DAY', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CONTOUR_DAY(45) : cplan2.sql(569) : ' || SYSTIMESTAMP);
   END IF; 

   CONTOUR1DAY(1) := 0;
   CONTOUR1DAY(2) := 1;
   CONTOUR1DAY(3) := 2;
   CONTOUR1DAY(4) := 4;
   CONTOUR1DAY(5) := 8;
   CONTOUR1DAY(6) := 16;
   CONTOUR1DAY(7) := 32;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CONTOUR_DAY';
   PMO_DB2M.SC_STATE := 0;
   
   --  h_temp_stmt.strcpy("");
   h_every := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_contour, 0), PMO_CNST.SC_0001F000)), 12);
   h_dayofyear := SubStr(h_start_DT, 1, 10);
   
   CASE h_bitflag
      WHEN 1 THEN
         -- Daily, every X days
         If Coalesce(h_every, 0) > 1 Then
            WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
               If i_every = Coalesce(h_every, 0) Then
                  BEGIN
                     INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 81+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(82) : cplan2.sql(606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  i_every := 1;
               Else
                  i_every := i_every + 1;
               End If;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                  INTO h_dayofyear
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 100+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(101) : cplan2.sql(625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
         Else
            WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
               BEGIN
                  INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 119+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(120) : cplan2.sql(644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                  INTO h_dayofyear
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 134+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(135) : cplan2.sql(659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
         End If;
         
      WHEN 2 THEN
         -- Weekly, every X week on Mo, We
         If (BITAND(Coalesce(h_contour, 0), PMO_CNST.SC_0000007F)) = 0 Then
            If Coalesce(h_every, 0) > 1 Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK(h_dayofyear)
                  INTO h_week
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 155+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(156) : cplan2.sql(680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               i_previous := Coalesce(h_week, 0);
               
               WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
                  If i_previous = Coalesce(h_week, 0) Then
                     BEGIN
                        INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 175+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(176) : cplan2.sql(700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                        INTO h_dayofyear
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 190+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(191) : cplan2.sql(715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT PMO_ORASTD.WEEK(h_dayofyear)
                        INTO h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 205+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(206) : cplan2.sql(730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_temp_var := 7 * (Coalesce(h_every, 0) - 1);
                     BEGIN
                        SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + h_temp_var     
                        INTO h_dayofyear
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 221+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(222) : cplan2.sql(746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT PMO_ORASTD.WEEK(h_dayofyear)
                        INTO h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 236+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(237) : cplan2.sql(761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     i_previous := Coalesce(h_week, 0);
                  End If;
                  --trace_printf("h_dayofyear: %s, h_week: %d, i_previous: %d, h_temp_var: %d\n", h_dayofyear,h_week,i_previous,h_temp_var);
               END LOOP;
            Else
               WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
                  BEGIN
                     INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 258+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(259) : cplan2.sql(783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                     INTO h_dayofyear
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 273+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(274) : cplan2.sql(798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               END LOOP;
            End If;
         Else
            If Coalesce(h_every, 0) > 1 Then
               BEGIN
                  SELECT PMO_ORASTD.DAYOFWEEK(h_dayofyear), PMO_ORASTD.WEEK(h_dayofyear)
                  INTO h_dayofweek, h_week
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 291+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(292) : cplan2.sql(816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               i_previous := Coalesce(h_week, 0);
               
               WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
                  If i_previous = Coalesce(h_week, 0) Then
                     If (BITAND(Coalesce(h_contour, 0), CONTOUR1DAY(Coalesce(h_dayofweek, 0) + 1))) > 0 Then
                        BEGIN
                           INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 312+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(313) : cplan2.sql(837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                        INTO h_dayofyear
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 328+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(329) : cplan2.sql(853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT PMO_ORASTD.DAYOFWEEK(h_dayofyear), PMO_ORASTD.WEEK(h_dayofyear)
                        INTO h_dayofweek, h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 343+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(344) : cplan2.sql(868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_temp_var := 7 * (Coalesce(h_every, 0) - 1);
                     BEGIN
                        SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + h_temp_var     
                        INTO h_dayofyear
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 359+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(360) : cplan2.sql(884) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT PMO_ORASTD.DAYOFWEEK(h_dayofyear), PMO_ORASTD.WEEK(h_dayofyear)
                        INTO h_dayofweek, h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 374+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(375) : cplan2.sql(899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     i_previous := Coalesce(h_week, 0);
                  End If;
                  --trace_printf("h_dayofyear: %s, h_week: %d, i_previous: %d, h_dayofyear: %d, h_temp_var: %d\n", h_dayofyear,h_week,i_previous,h_dayofyear,h_temp_var);
               END LOOP;
            Else
               BEGIN
                  SELECT PMO_ORASTD.DAYOFWEEK(h_dayofyear)
                  INTO h_dayofweek
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 393+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(394) : cplan2.sql(918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
                  If (BITAND(Coalesce(h_contour, 0), CONTOUR1DAY(Coalesce(h_dayofweek, 0) + 1))) > 0 Then
                     BEGIN
                        INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 412+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(413) : cplan2.sql(937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  BEGIN
                     SELECT TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                     INTO h_dayofyear
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 428+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(429) : cplan2.sql(953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     SELECT PMO_ORASTD.DAYOFWEEK(h_dayofyear)
                     INTO h_dayofweek
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 443+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(444) : cplan2.sql(968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               END LOOP;
            End If;
         End If;
         
         
      WHEN 3 THEN
         -- Monthly(C), The Day 6 every X months
         h_dayofmonth := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_contour, 0), PMO_CNST.SC_00000F80)), 7);
         
         If Coalesce(h_every, 0) > 1 Then
            WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
               BEGIN
                  SELECT PMO_ORASTD.DAY(h_dayofyear), PMO_ORASTD.MONTH(h_dayofyear), TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                  INTO h_day, h_month, h_dayofyear
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 468+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(469) : cplan2.sql(993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If ((Coalesce(h_month, 0) MOD Coalesce(h_every, 0)) = 0) AND (Coalesce(h_dayofmonth, 0) = Coalesce(
                                       h_day, 0)) Then
                  BEGIN
                     INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 487+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(488) : cplan2.sql(1012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
         Else
            WHILE PMO_ORASTD.strncmp(h_dayofyear, h_finish_DT, 10) <= 0 LOOP
               BEGIN
                  SELECT PMO_ORASTD.DAY(h_dayofyear), PMO_ORASTD.MONTH(h_dayofyear), TO_DATE(SubStr(h_dayofyear, 1, 10)) + 1     
                  INTO h_day, h_month, h_dayofyear
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 505+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(506) : cplan2.sql(1030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_temp_var := CONTOUR1DAY(Coalesce(h_dayofweek, 0) + 1);
               
               If Coalesce(h_dayofmonth, 0) = Coalesce(h_day, 0) Then
                  BEGIN
                     INSERT INTO PMO_CONTOUR_DAY VALUES(h_dayofyear);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CONTOUR_DAY', 525+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CONTOUR_DAY(526) : cplan2.sql(1050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
         End If;
         
         
      WHEN 4 THEN
         -- Monthly(B), First/Second/Third/Forth/Last Monday every X months
         
         h_c_week := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_contour, 0), PMO_CNST.SC_00000F80)), 7);
         -- First/Second/Third/Forth/Last
         --          sprintf(h_min, "%d", 7 * (h_week - 1) + 1);
         
         /*if ( h_every > 1)
                     {
                         while ( strncmp(h_dayofyear,h_finish_DT,10) <= 0 )
                         {
                             BEGIN_SQL
                                 SELECT MONTH(HOST(h_dayofyear)), WEEK(HOST(h_dayofyear)), DATE(HOST(h_dayofyear)) + 1 DAYS
                                 INTO HOST(h_month), HOST(h_week), HOST(h_dayofyear)
                                 FROM DUAL;
                             END_SQL;
         
                             h_temp_var = CONTOUR1DAY[h_dayofweek];
         trace_printf("1. h_dayofweek: %d, h_temp_var: %d\n", h_dayofweek,h_temp_var);
                             if (((h_month % h_every) == 0)  ((h_contour  h_temp_var) == 0))
                             {
                                 BEGIN_SQL
                                     INSERT INTO session.PMO_CONTOUR_DAY VALUES(HOST(h_dayofyear));
                                 END_SQL_NOCHECK;
                             }
                         }
                     }
                     else
                     {
                         while ( strncmp(h_dayofyear,h_finish_DT,10) <= 0 )
                         {
                             BEGIN_SQL
                                 SELECT DAYOFWEEK(HOST(h_dayofyear)), DATE(HOST(h_dayofyear)) + 1 DAYS
                                 INTO HOST(h_dayofweek), HOST(h_dayofyear)
                                 FROM DUAL;
                             END_SQL;
         
                             h_temp_var = CONTOUR1DAY[h_dayofweek];
         trace_printf("1. h_dayofweek: %d, h_temp_var: %d\n", h_dayofweek,h_temp_var);
         
                             if ((h_contour  h_temp_var) == 0)
                             {
                                 BEGIN_SQL
                                     INSERT INTO session.PMO_CONTOUR_DAY VALUES(HOST(h_dayofyear));
                                 END_SQL_NOCHECK;
                             }
                         }
                     }*/
         
         
      WHEN 5 THEN
         -- Monthly, Mo, We, Fr  on Week1, Week4 every X months
         
         
         NULL;
      WHEN 6 THEN
         -- Monthly, The Day 6 of Jan, Mar, Apr, Nov  Dec
         h_day := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_contour, 0), PMO_CNST.SC_1FFE0000)), 17);
         -- Jan, Mar, Apr, Nov  Dec
         
         If Coalesce(h_day, 0) > 0 Then
            -- empty
            NULL;
         End If;
         
         
      WHEN 7 THEN
         -- Yearly, The First/Second/Third/Forth/Last Mondy of July, August, Decembre
         h_day := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_contour, 0), PMO_CNST.SC_1FFE0000)), 17);
         -- July, August, Decembre
         
         If Coalesce(h_day, 0) > 0 Then
            -- empty
            NULL;
         End If;
         
         
      WHEN 8 THEN
         -- Yearly, Mo, We, Fr  on Week1, Week4 on Jan, June, July  Dec
         
         NULL;
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CONTOUR_DAY', 620+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CONTOUR_DAY(621) : cplan2.sql(1145) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CONTOUR_DAY;
ALTER FUNCTION FC_CONTOUR_DAY COMPILE DEBUG;

--*********************************************************************************************************************

/* search insert appoiments from OUTLOOK

  eunit  =  0 = MINUTE (default), 1= h, 2 = d, 3 = w,           applies to effort
  unit   =  0 = h/d, 3= h/w, 4=h/m, 1= d/w, 2= d/m, 5= w/m,     applies to work

  contour structure: ---------------------------------------------------------------------------------------------------------------------------------------------------------------------
   bitflag  = 0 - ASP
            = 1 - Daily         -- contour3
            = 2 - Weekly        -- contour3{, contur1}, {amount falg}
            = 3 - Monthly(C)    -- contour3{, contur2}
            = 4 - Monthly(B)    -- contour3{, contur2}
            = 5 - Monthly(A)    -- contour3{, contur2 | contour2Countour1}
            = 6 - Yearly(C)     -- contour2, contur4
            = 7 - Yearly(B)     -- contour2, contur4, contur1(only one day)
            = 8 - Yearly(A)     -- contour2, contur4, contur1(many days)

  contur1:  DAY:    bits 0-6    0=Su, 1=Mo, 2=Tu, 3=We, 4=Th, 5=Fr, 6=Sa,
  contur2:  WEEK:   bits 7-11   A) 7=week1, 8=week2, 8=week3, 9=week4
                                B) 1-First/2-Second/3-Third/4-Fourth/5-Last
                                C) The Day 1 to 31
  contour3:     EVRY:   bits 12-16  EVRY 1 to 31 day / week / month
  contour4:     MONTH:  bits 17-28  17 = Jan, 18 = Feb, ... 28 = Dec

  2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
  8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
                                                -------------
                                                S F T W T M S
                                      ---------
                                      w1 to w4  A(7 days from the 1st)
                                      5 4 3 2 1 B(Last, Fourth, Third, Second, First)
                                      31 .... 1 C(The Day 6)
                            ----------
                            31 ........ 1 (Day)
                            31 ........ 1 (week)
                            12 ........ 1 (month)
  -------------------------
  D N O S A J J M A M F J (Month)
*/

--************************************************************************************************************************

Prompt == FUNCTION SP_I_OUTLOOK_TASK ==
CREATE OR REPLACE FUNCTION SP_I_OUTLOOK_TASK
(
     p_task_name VARCHAR2
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_effort PLS_INTEGER
   , p_eunit PLS_INTEGER
   , p_start_time VARCHAR2
   , p_finish_time VARCHAR2
   , p_work PLS_INTEGER
   , p_unit PLS_INTEGER
   , p_bitflag PLS_INTEGER
   , p_contour PLS_INTEGER
   , p_occurrence PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_res_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_start_DT TIMESTAMP;
   h_finish_DT TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_finish_time VARCHAR2(8);
   h_task_name VARCHAR2(255);
   h_dayofyear DATE;
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_work PLS_INTEGER := 0;
   h_occurrence PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_eunit PLS_INTEGER := 0;
   h_unit PLS_INTEGER := 0;
   h_contour PLS_INTEGER := 0;
   h_ieflag PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_assign_string VARCHAR2(8192);
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_OUTLOOK_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_OUTLOOK_TASK'), '-- ' || SYSTIMESTAMP, ':r := SP_I_OUTLOOK_TASK(' || 
       '''' || p_task_name || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_effort), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_eunit), 'NULL')
          || ', ' || '''' || p_start_time || ''''
          || ', ' || '''' || p_finish_time || ''''
          || ', ' || COALESCE(TO_CHAR(p_work), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_unit), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_contour), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_occurrence), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_OUTLOOK_TASK', 65+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_OUTLOOK_TASK(66) : cplan2.sql(1262) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Parse parameters to local variables
   h_task_name := p_task_name;
   h_start_DT := p_start_date;
   h_finish_DT := p_finish_date;
   h_start_time := p_start_time;
   h_finish_time := p_finish_time;
   h_res_id := p_rec_user;
   
   h_effort := p_effort;
   -- total effort for period
   h_work := p_work;
   -- amount for countour
   h_occurrence := p_occurrence;
   -- occurrence
   h_eunit := p_eunit;
   h_unit := p_unit;
   h_bitflag := p_bitflag;
   h_contour := p_contour;
   
   h_assign_string := '';
   
   BEGIN
      SELECT ELEMENT_ID INTO h_project_id
      FROM TMT_WBS
      WHERE POOL_ID = h_res_id AND TYPE_ID = PMO_CNST.SC_RESOURCE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(102) : cplan2.sql(1298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_type_id := PMO_CNST.SC_OUTLOOK_TASK;
      h_ieflag := 0;
      h_temp_sc_state := FC_I_WBS_MSP(h_task_name, h_project_id, h_type_id, h_res_id, h_ieflag, h_task_id);
      
      If Coalesce(h_temp_sc_state, 0) = 0 Then
         BEGIN
            SELECT RES_ASSIGNMENT_ID INTO h_res_assignment_id
            FROM RESOURCE_ASSIGNMENTS
            WHERE PROJECT_ID  = h_project_id
            AND ELEMENT_ID  = h_task_id
            AND RESOURCE_ID = h_res_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 124+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(125) : cplan2.sql(1321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_tsk_assignment_id := SYS_GUID();
            h_assign_string := TO_CHAR(Coalesce(h_effort, 0)) || ',';
            
            h_bitID := PMO_CNST.SC_ZERO_BIT;
            
            If (h_start_time IS NULL) OR (h_finish_time IS NULL) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_OUTLOOK_TASK', 137+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_OUTLOOK_TASK(138) : cplan2.sql(1334) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_task_name || '''');
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_OUTLOOK_TASK', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_I_OUTLOOK_TASK(141) : cplan2.sql(1337) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_task_name, True);
            End If;
            
            PMO_STPU.filldayStruct(h_start_time, h_finish_time, h_bitID);
            
            If PMO_ORASTD.strncmp(h_start_DT, h_finish_DT, 10) = 0 Then
               BEGIN
                  INSERT INTO TASK_DAY_OF_YEAR (
                  PROJECT_ID,
                  TASK_ID,
                  RESOURCE_ID,
                  TSK_ASSIGNMENT_ID,
                  PARENT_ID,
                  DAY_YEAR,
                  SCHED_MIN,
                  BIT_SCHED,
                  BIT_FLAG)
                  VALUES(
                  h_project_id,
                  h_task_id,
                  h_res_id,
                  h_tsk_assignment_id,
                  h_tsk_assignment_id,
                  TO_DATE(SubStr(h_start_DT, 1, 10)),
                  h_effort,
                  h_bitID,
                  '2');
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 179+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(180) : cplan2.sql(1376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               null_return := FC_CONTOUR_DAY(h_res_id, h_start_DT, h_finish_DT, h_bitflag, h_work, h_unit
                              , h_contour, h_occurrence);
               
               BEGIN
                  INSERT INTO TASK_DAY_OF_YEAR (
                  PROJECT_ID,
                  TASK_ID,
                  RESOURCE_ID,
                  TSK_ASSIGNMENT_ID,
                  PARENT_ID,
                  DAY_YEAR,
                  SCHED_MIN,
                  BIT_SCHED,
                  BIT_FLAG)
                  SELECT
                  h_project_id,
                  h_task_id,
                  h_res_id,
                  h_tsk_assignment_id,
                  h_tsk_assignment_id,
                  DAY_YEAR,
                  h_work,
                  h_bitID,
                  '2'
                  FROM PMO_CONTOUR_DAY;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 219+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(220) : cplan2.sql(1416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               INSERT INTO TASK_ASSIGNMENTS(
               TSK_ASSIGNMENT_ID,
               RES_ASSIGNMENT_ID,
               TASK_ID,
               PROJECT_ID,
               SD,
               FD,
               START_DT,
               FINISH_DT,
               DURATION,
               PROPOSED_START,
               PROPOSED_FINISH,
               PROPOSED_WORK,
               SCHED_START,
               SCHED_FINISH,
               SCHED_WORK,
               BEST,
               BIT_FLAG,
               ETC,
               BAK_START_DT,
               BAK_FINISH_DT,
               BAK_WORK,
               RESOURCE_ID,
               RESOURCE_TYPE,
               PROJECT_ASSIGNMENT_ID,
               T_UNIT,
               C_EFFORT,
               C_UNIT,
               C_CONTOUR,
               CONTOUR_TYPE,
               ASSIGN_STRING,
               BAK_ASSIGN_STRING,
               TABLE_TYPE )
               VALUES(
               h_tsk_assignment_id,
               h_res_assignment_id,
               h_task_id,
               h_project_id,
               PMO_CNST.SC_SS,
               PMO_CNST.SC_SF,
               h_start_DT,
               h_finish_DT,
               h_effort,
               h_start_DT,
               h_finish_DT,
               h_effort,
               h_start_DT,
               h_finish_DT,
               h_effort,
               h_effort,
               '2',
               h_effort,
               h_start_DT,
               h_finish_DT,
               h_effort,
               h_res_id,
               '0',
               NULL,
               h_eunit,
               h_work,
               h_unit,
               h_contour,
               h_bitflag,
               h_assign_string,
               h_assign_string,
               1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 302+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(303) : cplan2.sql(1499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_temp_var := 0;
            h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_tsk_assignment_id, h_temp_var, 0, 0);
            
            null_return := FC_Rollup(h_project_id);
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_OUTLOOK_TASK', 316+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_OUTLOOK_TASK(317) : cplan2.sql(1513) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 324+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(325) : cplan2.sql(1521) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_OUTLOOK_TASK', 336+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_OUTLOOK_TASK(337) : cplan2.sql(1533) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_OUTLOOK_TASK;
ALTER FUNCTION SP_I_OUTLOOK_TASK COMPILE DEBUG;

--************************************************************************************************************************

Prompt == FUNCTION SP_D_OUTLOOK_TASK ==
CREATE OR REPLACE FUNCTION SP_D_OUTLOOK_TASK
(
     p_tsk_assignment_id VARCHAR2
   , p_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_ieflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_OUTLOOK_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_OUTLOOK_TASK'), '-- ' || SYSTIMESTAMP, ':r := SP_D_OUTLOOK_TASK(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_OUTLOOK_TASK', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_OUTLOOK_TASK(27) : cplan2.sql(1576) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Parse parameters to local variables
   h_res_id := p_rec_user;
   
   BEGIN
      SELECT PROJECT_ID, TASK_ID INTO h_project_id, h_task_id
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_OUTLOOK_TASK', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_OUTLOOK_TASK(45) : cplan2.sql(1594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If (p_date IS NULL) Then
         h_rec_status := 'Q';
         h_ieflag := 1;
         
         PMO_DB2M.SC_STATE := FC_D_WBS_MSP(h_task_id, h_project_id, h_rec_status, h_res_id, h_ieflag);
      Else
         BEGIN
            DELETE FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = p_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(p_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_OUTLOOK_TASK', 71+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_OUTLOOK_TASK(72) : cplan2.sql(1621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_temp_var := 0;
            h_tsk_assignment_id := p_tsk_assignment_id;
            h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_tsk_assignment_id, h_temp_var, 0, 0);
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_OUTLOOK_TASK', 85+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_OUTLOOK_TASK(86) : cplan2.sql(1635) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_OUTLOOK_TASK', 93+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_OUTLOOK_TASK(94) : cplan2.sql(1643) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_OUTLOOK_TASK', 105+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_OUTLOOK_TASK(106) : cplan2.sql(1655) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_OUTLOOK_TASK;
ALTER FUNCTION SP_D_OUTLOOK_TASK COMPILE DEBUG;

--************************************************************************************************************************

Prompt == FUNCTION SP_U_OUTLOOK_TA ==
CREATE OR REPLACE FUNCTION SP_U_OUTLOOK_TA
(
     p_tsk_assignment_id VARCHAR2
   , p_start_time VARCHAR2
   , p_finish_time VARCHAR2
   , p_work PLS_INTEGER
   , p_old_date VARCHAR2
   , p_new_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_project_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_start_time VARCHAR2(8);
   h_finish_time VARCHAR2(8);
   h_dayofyear DATE;
   h_work PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_OUTLOOK_TA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_OUTLOOK_TA'), '-- ' || SYSTIMESTAMP, ':r := SP_U_OUTLOOK_TA(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_start_time || ''''
          || ', ' || '''' || p_finish_time || ''''
          || ', ' || COALESCE(TO_CHAR(p_work), 'NULL')
          || ', ' || '''' || p_old_date || ''''
          || ', ' || '''' || p_new_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_OUTLOOK_TA', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_OUTLOOK_TA(37) : cplan2.sql(1708) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Parse parameters to local variables
   h_start_time := p_start_time;
   h_finish_time := p_finish_time;
   --    InitializeHost(SC_PARAM(h_res_id),        p_rec_user,     ind_u_outlook->p_rec_user);
   
   BEGIN
      SELECT PROJECT_ID INTO h_project_id
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_TA', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_TA(57) : cplan2.sql(1728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_bitID := PMO_CNST.SC_ZERO_BIT;
      PMO_STPU.filldayStruct(h_start_time, h_finish_time, h_bitID);
      
      If ((p_old_date IS NULL)) AND ((p_new_date IS NULL)) Then
         -- Update all days
         BEGIN
            UPDATE TASK_DAY_OF_YEAR SET
            BIT_SCHED = h_bitID,
            SCHED_MIN = p_work
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_TA', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_TA(84) : cplan2.sql(1755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_temp_var := 0;
            h_tsk_assignment_id := p_tsk_assignment_id;
            h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_tsk_assignment_id, h_temp_var, 0, 0);
         End If;
      ElsIf ((p_old_date IS NOT NULL)) AND ((p_new_date IS NULL)) Then
         -- Update one day
         BEGIN
            UPDATE TASK_DAY_OF_YEAR SET
            BIT_SCHED = h_bitID,
            SCHED_MIN = p_work
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = p_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(p_old_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_TA', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_TA(113) : cplan2.sql(1784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf ((p_old_date IS NOT NULL)) AND ((p_new_date IS NOT NULL)) Then
         -- Update one day
         BEGIN
            UPDATE TASK_DAY_OF_YEAR SET
            DAY_YEAR  = TO_DATE(SubStr(p_new_date, 1, 10)),
            BIT_SCHED = h_bitID,
            SCHED_MIN = p_work
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = p_tsk_assignment_id
            AND DAY_YEAR = TO_DATE(SubStr(p_old_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_TA', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_TA(137) : cplan2.sql(1808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_OUTLOOK_TA', 142+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_OUTLOOK_TA(143) : cplan2.sql(1814) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_tsk_assignment_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_OUTLOOK_TA', 145+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_OUTLOOK_TA(146) : cplan2.sql(1817) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_tsk_assignment_id
               , True);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_OUTLOOK_TA', 153+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_OUTLOOK_TA(154) : cplan2.sql(1825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_tsk_assignment_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_TA', 161+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_TA(162) : cplan2.sql(1833) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_TA', 173+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_TA(174) : cplan2.sql(1845) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_OUTLOOK_TA;
ALTER FUNCTION SP_U_OUTLOOK_TA COMPILE DEBUG;

--************************************************************************************************************************

Prompt == FUNCTION SP_U_OUTLOOK_SD ==
CREATE OR REPLACE FUNCTION SP_U_OUTLOOK_SD
(
     p_tsk_assignment_id VARCHAR2
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_start_DT TIMESTAMP;
   h_finish_DT TIMESTAMP;
   h_dayofyear DATE;
   h_bitflag PLS_INTEGER := 0;
   h_work PLS_INTEGER := 0;
   h_occurrence PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_eunit PLS_INTEGER := 0;
   h_unit PLS_INTEGER := 0;
   h_contour PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_assign_string VARCHAR2(8192);
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_OUTLOOK_SD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_OUTLOOK_SD'), '-- ' || SYSTIMESTAMP, ':r := SP_U_OUTLOOK_SD(' || 
       '''' || p_tsk_assignment_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_OUTLOOK_SD', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_OUTLOOK_SD(43) : cplan2.sql(1904) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Parse parameters to local variables
   h_start_DT := p_start_date;
   h_finish_DT := p_finish_date;
   h_res_id := p_rec_user;
   
   h_assign_string := '';
   
   BEGIN
      SELECT PROJECT_ID, TASK_ID, TO_DATE(SubStr(SCHED_START, 1, 10)), T_UNIT, C_UNIT, C_CONTOUR, CONTOUR_TYPE
      INTO h_project_id, h_task_id, h_dayofyear, h_eunit, h_unit, h_contour, h_bitflag
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(66) : cplan2.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT SCHED_MIN, BIT_SCHED INTO h_work, h_bitID
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = p_tsk_assignment_id
         AND DAY_YEAR = h_dayofyear;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(84) : cplan2.sql(1945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            DELETE FROM TASK_DAY_OF_YEAR
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = p_tsk_assignment_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(104) : cplan2.sql(1965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_tsk_assignment_id := p_tsk_assignment_id;
         h_assign_string := TO_CHAR(Coalesce(h_effort, 0)) || ',';
         
         If PMO_ORASTD.strncmp(h_start_DT, h_finish_DT, 10) = 0 Then
            BEGIN
               INSERT INTO TASK_DAY_OF_YEAR (
               PROJECT_ID,
               TASK_ID,
               RESOURCE_ID,
               TSK_ASSIGNMENT_ID,
               PARENT_ID,
               DAY_YEAR,
               SCHED_MIN,
               BIT_SCHED,
               BIT_FLAG)
               VALUES(
               h_project_id,
               h_task_id,
               h_res_id,
               h_tsk_assignment_id,
               h_tsk_assignment_id,
               TO_DATE(SubStr(h_start_DT, 1, 10)),
               h_effort,
               h_bitID,
               '2');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 143+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(144) : cplan2.sql(2005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            null_return := FC_CONTOUR_DAY(h_res_id, h_start_DT, h_finish_DT, h_bitflag, h_work, h_unit
                              , h_contour, h_occurrence);
            
            BEGIN
               INSERT INTO TASK_DAY_OF_YEAR (
               PROJECT_ID,
               TASK_ID,
               RESOURCE_ID,
               TSK_ASSIGNMENT_ID,
               PARENT_ID,
               DAY_YEAR,
               SCHED_MIN,
               BIT_SCHED,
               BIT_FLAG)
               SELECT
               h_project_id,
               h_task_id,
               h_res_id,
               h_tsk_assignment_id,
               h_tsk_assignment_id,
               DAY_YEAR,
               h_work,
               h_bitID,
               '2'
               FROM PMO_CONTOUR_DAY;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 183+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(184) : cplan2.sql(2045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_temp_var := 0;
         h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_tsk_assignment_id, h_temp_var, 0, 0);
         
         null_return := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_OUTLOOK_SD', 197+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_OUTLOOK_SD(198) : cplan2.sql(2059) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_tsk_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_tsk_assignment_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 205+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(206) : cplan2.sql(2067) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_OUTLOOK_SD', 217+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_OUTLOOK_SD(218) : cplan2.sql(2079) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_OUTLOOK_SD;
ALTER FUNCTION SP_U_OUTLOOK_SD COMPILE DEBUG;

--************************************************************************************************************************

Prompt == FUNCTION SP_CDY_MIGRATION ==
CREATE OR REPLACE FUNCTION SP_CDY_MIGRATION RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_calendar_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CDY0 IS
         SELECT DISTINCT c.PARENT_ID, cdy.ELEMENT_ID, c.ELEMENT_ID, c.TYPE_ID
         FROM TMT_CALENDARS c JOIN CALENDAR_DAY_OF_YEAR cdy ON cdy.ELEMENT_ID = c.ELEMENT_ID
         WHERE NOT EXISTS (SELECT * FROM CALENDAR_EXCEPTIONS e WHERE e.CALENDAR_ID = c.ELEMENT_ID)
         ORDER BY c.PARENT_ID;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CDY_MIGRATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CDY_MIGRATION'), '-- ' || SYSTIMESTAMP, ':r := SP_CDY_MIGRATION();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CDY_MIGRATION', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CDY_MIGRATION(25) : cplan2.sql(2120) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_temp_id := NULL;
   
   OPEN C_CDY0;
   
   LOOP
      FETCH C_CDY0 INTO h_parent_id, h_element_id, h_calendar_id, h_type_id;
      IF C_CDY0%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_count := 0;
      BEGIN
         SELECT COUNT(ELEMENT_ID) INTO h_count
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 55+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(56) : cplan2.sql(2151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         h_temp_id := h_parent_id;
      End If;
      
      If PMO_ORASTD.strcmp(h_parent_id, h_temp_id) <> 0 Then
         h_temp_id := h_parent_id;
         
         BEGIN
            UPDATE CALENDAR_DAY_OF_YEAR SET ELEMENT_ID = h_parent_id WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(80) : cplan2.sql(2175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
            BEGIN
               UPDATE RESOURCES SET CALENDAR_ID = h_parent_id WHERE RESOURCE_ID = h_calendar_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 97+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(98) : cplan2.sql(2193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET CALENDAR_ID = h_parent_id WHERE ELEMENT_ID = h_calendar_id AND TYPE_ID = h_type_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 114+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(115) : cplan2.sql(2210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
            BEGIN
               UPDATE RESOURCES SET CALENDAR_ID = h_parent_id WHERE RESOURCE_ID = h_calendar_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 133+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(134) : cplan2.sql(2229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET CALENDAR_ID = h_parent_id WHERE ELEMENT_ID = h_calendar_id AND TYPE_ID = h_type_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 150+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(151) : cplan2.sql(2246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            DELETE FROM CALENDAR_DAY_OF_YEAR WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(169) : cplan2.sql(2264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_CDY0 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 183+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(184) : cplan2.sql(2279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CDY_MIGRATION', 189+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CDY_MIGRATION(190) : cplan2.sql(2285) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_temp_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_temp_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 197+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(198) : cplan2.sql(2293) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CDY_MIGRATION', 209+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CDY_MIGRATION(210) : cplan2.sql(2305) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CDY_MIGRATION;
ALTER FUNCTION SP_CDY_MIGRATION COMPILE DEBUG;

