/****************************************************************************************/

Prompt == FUNCTION SP_U_CURRENCY ==
CREATE OR REPLACE FUNCTION SP_U_CURRENCY
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_description VARCHAR2(255);
   h_name VARCHAR2(100);
   h_rec_status VARCHAR2(1);
   h_broker_type PLS_INTEGER := 0;
   h_id_int PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CURRENCY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CURRENCY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CURRENCY(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CURRENCY', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CURRENCY(28) : currency.sql(31) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_name := p_name;
   h_description := p_description;
   h_rec_user := p_rec_user;
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CURRENCY', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CURRENCY(38) : currency.sql(41) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CURRENCY', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CURRENCY(41) : currency.sql(44) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   h_broker_type := 90;
   
   h_id_int := TO_NUMBER(h_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CURRENCY', 48+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CURRENCY(49) : currency.sql(52) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DATAFIELDS' || '''' || ' ID: ' || COALESCE(TO_CHAR(h_id_int), 'NULL'));
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DATAFIELDS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id_int; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id_int, True); 
   END;
   
   BEGIN
      UPDATE TMT_DATAFIELDS 
      SET	ELEMENT_NAME = h_name,
      DESCRIPTION = h_description,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id_int;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(78) : currency.sql(81) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         BEGIN
            UPDATE CHANGE_LOG SET MODIF_DATE_TIME = SYSTIMESTAMP WHERE BROKER_TYPE = h_broker_type;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 96+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(97) : currency.sql(100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         PMO_DB2M.SC_STATE := 0;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CURRENCY', 107+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CURRENCY(108) : currency.sql(111) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(TO_CHAR(h_id_int), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id_int, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 114+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(115) : currency.sql(118) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CURRENCY', 126+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CURRENCY(127) : currency.sql(130) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CURRENCY;
ALTER FUNCTION SP_U_CURRENCY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_FS_CURRENCY ==
CREATE OR REPLACE FUNCTION SP_U_FS_CURRENCY
(
     p_fs_code VARCHAR2
   , p_exchange_rate VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_fs_code VARCHAR2(50);
   h_exchange_rate VARCHAR2(18);
   h_rec_user VARCHAR2(32);
   h_broker_type PLS_INTEGER := 0;
   h_id_int PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CURRENCY IS
         SELECT * FROM (SELECT ELEMENT_ID FROM TMT_DATAFIELDS
         WHERE TYPE_ID = 37 AND REC_STATUS = 'D'
         ORDER BY RANK ) WHERE ROWNUM<=1;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FS_CURRENCY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FS_CURRENCY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FS_CURRENCY(' || 
       '''' || p_fs_code || ''''
          || ', ' || '''' || p_exchange_rate || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_CURRENCY', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FS_CURRENCY(29) : currency.sql(175) : ' || SYSTIMESTAMP);
   END IF; 

   h_fs_code := p_fs_code;
   h_exchange_rate := p_exchange_rate;
   h_rec_user := p_rec_user;
   
   If (h_fs_code IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FS_CURRENCY', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FS_CURRENCY(38) : currency.sql(184) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_CURRENCY', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FS_CURRENCY(41) : currency.sql(187) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   h_broker_type := 90;
   
   --InitializeHost(SC_PARAM(h_fs_code), fs_code, ind_u_fs_currency->fs_code);
   BEGIN
      SELECT ELEMENT_ID INTO h_id_int
      FROM TMT_DATAFIELDS
      WHERE DESCRIPTION = h_fs_code
      AND TYPE_ID = 37;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(59) : currency.sql(205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      OPEN C_CURRENCY;
      
      FETCH C_CURRENCY INTO h_id_int;
      IF C_CURRENCY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_CURRENCY ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(82) : currency.sql(228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE TMT_DATAFIELDS 
         SET	ELEMENT_NAME = h_exchange_rate,
         DESCRIPTION = h_fs_code,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id_int;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(107) : currency.sql(253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            BEGIN
               UPDATE CHANGE_LOG SET MODIF_DATE_TIME = SYSTIMESTAMP WHERE BROKER_TYPE = h_broker_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 125+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(126) : currency.sql(272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            PMO_DB2M.SC_STATE := 0;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FS_CURRENCY', 137+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FS_CURRENCY(138) : currency.sql(284) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(TO_CHAR(h_id_int), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id_int, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(145) : currency.sql(291) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_CURRENCY', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_CURRENCY(157) : currency.sql(303) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FS_CURRENCY;
ALTER FUNCTION SP_U_FS_CURRENCY COMPILE DEBUG;

-- Insert exchange row in currency_exchanges

Prompt == FUNCTION SP_I_EXCHANGE ==
CREATE OR REPLACE FUNCTION SP_I_EXCHANGE
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_start_date DATE;
   h_current_date DATE;
   h_max_SD DATE;
   h_min_SD DATE;
   h_max_FD DATE;
   h_min_FD DATE;
   h_id_int PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_EXCHANGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_EXCHANGE'), '-- ' || SYSTIMESTAMP, ':r := SP_I_EXCHANGE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EXCHANGE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_EXCHANGE(27) : currency.sql(346) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_rec_user := p_rec_user;
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_EXCHANGE', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_EXCHANGE(35) : currency.sql(354) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EXCHANGE', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_EXCHANGE(38) : currency.sql(357) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id_int := TO_NUMBER(h_id);
   
   BEGIN
      SELECT START_DATE INTO h_current_date
      FROM FISCAL_CALENDAR
      WHERE TO_DATE(SYSDATE) BETWEEN START_DATE AND FINISH_DATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(55) : currency.sql(374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MIN(START_DATE), MAX(START_DATE), MIN(FINISH_DATE), MAX(FINISH_DATE)
      INTO h_min_SD, h_max_SD, h_min_FD, h_max_FD
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(71) : currency.sql(390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strncmp(h_max_SD, h_current_date, 10) < 0 Then
      h_start_date := h_current_date;
   Else
      BEGIN
         SELECT MIN(START_DATE) INTO h_start_date
         FROM FISCAL_CALENDAR
         WHERE START_DATE > TO_DATE(SubStr(h_max_SD, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(89) : currency.sql(408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE CURRENCY_EXCHANGES
      SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1    
      WHERE CURRENCY_ID = h_id_int
      AND START_DATE = h_max_SD;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(110) : currency.sql(429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_id := SYS_GUID();
   h_id := h_id;
   BEGIN
      INSERT INTO CURRENCY_EXCHANGES (ELEMENT_ID, CURRENCY_ID, START_DATE, FINISH_DATE, REC_USER)
      VALUES (h_id, h_id_int, h_start_date, h_max_FD, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 129+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(130) : currency.sql(449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_EXCHANGE', 135+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_EXCHANGE(136) : currency.sql(455) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 142+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(143) : currency.sql(462) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EXCHANGE', 154+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EXCHANGE(155) : currency.sql(474) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_EXCHANGE;
ALTER FUNCTION SP_I_EXCHANGE COMPILE DEBUG;

-- Insert exchange row in currency_exchanges

Prompt == FUNCTION SP_S_EXCHANGE ==
CREATE OR REPLACE FUNCTION SP_S_EXCHANGE
(
     p_id VARCHAR2
   , p_year PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_year PLS_INTEGER := 0;
   h_id_int PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CSCUREXC PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CSCUREXC_Y PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_EXCHANGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_EXCHANGE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_EXCHANGE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_year), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EXCHANGE', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_EXCHANGE(29) : currency.sql(519) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_year := p_year;
   h_rec_user := p_rec_user;
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_EXCHANGE', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_EXCHANGE(38) : currency.sql(528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EXCHANGE', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_EXCHANGE(41) : currency.sql(531) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id_int := TO_NUMBER(h_id);
   
   If Coalesce(h_year, 0) = 0 Then
      OPEN CSCUREXC FOR SELECT 0 AS LEVEL_ID, PMO_CNST.SC_CURRENCY AS TYPE_ID, h_id AS PARENT_ID,
      ELEMENT_ID, 0 AS CHILD_COUNT, '' AS ELEMENT_NAME, START_DATE,
      CASE WHEN FINISH_DATE = TO_DATE(SubStr(TO_DATE('2300-12-30'), 1, 10)) THEN NuLL ELSE FINISH_DATE END AS FINISH_DATE,
      EXCHANGE_RATE
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int
      ORDER BY START_DATE;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EXCHANGE', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_EXCHANGE(57) : currency.sql(547) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CSCUREXC;
   Else
      OPEN CSCUREXC_Y FOR SELECT 0 AS LEVEL_ID, PMO_CNST.SC_CURRENCY AS TYPE_ID, h_id AS PARENT_ID,
      ELEMENT_ID, 0 AS CHILD_COUNT, '' AS ELEMENT_NAME, START_DATE,
      CASE WHEN FINISH_DATE = TO_DATE(SubStr(TO_DATE('2300-12-30'), 1, 10)) THEN NuLL ELSE FINISH_DATE END AS FINISH_DATE,
      EXCHANGE_RATE
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int
      AND PMO_ORASTD.YEAR(START_DATE) <= h_year
      AND PMO_ORASTD.YEAR(FINISH_DATE) >= h_year
      ORDER BY START_DATE;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EXCHANGE', 70+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_EXCHANGE(71) : currency.sql(561) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CSCUREXC_Y;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EXCHANGE', 78+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EXCHANGE(79) : currency.sql(569) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EXCHANGE', 90+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EXCHANGE(91) : currency.sql(581) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_EXCHANGE;
ALTER FUNCTION SP_S_EXCHANGE COMPILE DEBUG;

-- update exchange start date

Prompt == FUNCTION SP_U_EXCHANGE_START ==
CREATE OR REPLACE FUNCTION SP_U_EXCHANGE_START
(
     p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_start_date DATE;
   h_old_start_date DATE;
   h_min_SD DATE;
   h_max_SD DATE;
   h_min_FD DATE;
   h_max_FD DATE;
   h_rec_user VARCHAR2(32);
   h_id_int PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EXCHANGE_START') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EXCHANGE_START'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EXCHANGE_START(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_START', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EXCHANGE_START(29) : currency.sql(626) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_id IS NULL) OR (p_start_date IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_EXCHANGE_START', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_EXCHANGE_START(35) : currency.sql(632) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_START', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_START(38) : currency.sql(635) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_start_date := p_start_date;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT START_DATE, CURRENCY_ID INTO h_old_start_date, h_id_int
      FROM CURRENCY_EXCHANGES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(59) : currency.sql(656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXCHANGE_START', 65+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXCHANGE_START(66) : currency.sql(663) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_START', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_START(69) : currency.sql(666) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      SELECT START_DATE INTO h_start_date
      FROM FISCAL_CALENDAR
      WHERE TO_DATE(SubStr(h_start_date, 1, 10)) BETWEEN START_DATE AND FINISH_DATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(84) : currency.sql(681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   BEGIN
      SELECT MAX(START_DATE), COUNT(CURRENCY_ID) INTO h_max_SD, h_count
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int
      AND START_DATE < TO_DATE(SubStr(h_old_start_date, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(101) : currency.sql(698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXCHANGE_START', 107+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXCHANGE_START(108) : currency.sql(705) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.EXCHANGE_RATE_EXIST), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_START', 110+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_START(111) : currency.sql(708) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.EXCHANGE_RATE_EXIST, h_id, True);
   End If;
   
   If PMO_ORASTD.strncmp(h_start_date, h_old_start_date, 10) < 0 Then
      If PMO_ORASTD.strncmp(h_start_date, h_max_SD, 10) > 0 Then
         BEGIN
            UPDATE CURRENCY_EXCHANGES
            SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1    
            WHERE CURRENCY_ID = h_id_int
            AND START_DATE = h_max_SD;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 132+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(133) : currency.sql(730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE CURRENCY_EXCHANGES
            SET START_DATE = TO_DATE(SubStr(h_start_date, 1, 10))
            WHERE CURRENCY_ID = h_id_int
            AND START_DATE = TO_DATE(SubStr(h_old_start_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(153) : currency.sql(750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --          RETURN_ERROR(CURESCC03, "new start date is too small", h_id);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXCHANGE_START', 159+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXCHANGE_START(160) : currency.sql(757) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.EXCHANGE_RATE_EXIST), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_START', 162+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_START(163) : currency.sql(760) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.EXCHANGE_RATE_EXIST, h_id, True);
      End If;
   ElsIf PMO_ORASTD.strncmp(h_start_date, h_old_start_date, 10) > 0 Then
      h_count := 0;
      BEGIN
         SELECT MIN(START_DATE), COUNT(CURRENCY_ID) INTO h_min_SD, h_count
         FROM CURRENCY_EXCHANGES
         WHERE CURRENCY_ID = h_id_int
         AND START_DATE > TO_DATE(SubStr(h_old_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(180) : currency.sql(777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) 
            OR (PMO_ORASTD.strncmp(h_start_date, h_min_SD, 10) < 0) Then
         BEGIN
            UPDATE CURRENCY_EXCHANGES
            SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1    
            WHERE CURRENCY_ID = h_id_int
            AND START_DATE = TO_DATE(SubStr(h_max_SD, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 201+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(202) : currency.sql(799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE CURRENCY_EXCHANGES
            SET START_DATE = TO_DATE(SubStr(h_start_date, 1, 10))
            WHERE CURRENCY_ID = h_id_int
            AND START_DATE = TO_DATE(SubStr(h_old_start_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 221+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(222) : currency.sql(819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf PMO_ORASTD.strncmp(h_start_date, h_min_SD, 10) >= 0 Then
         --          RETURN_ERROR(CURESCC03, "new start date is too big", h_id);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXCHANGE_START', 228+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXCHANGE_START(229) : currency.sql(826) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.EXCHANGE_RATE_EXIST), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_START', 231+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_START(232) : currency.sql(829) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.EXCHANGE_RATE_EXIST, h_id, True);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EXCHANGE_START', 238+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EXCHANGE_START(239) : currency.sql(836) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 245+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(246) : currency.sql(843) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_START', 257+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_START(258) : currency.sql(855) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EXCHANGE_START;
ALTER FUNCTION SP_U_EXCHANGE_START COMPILE DEBUG;

-- update exchange rate

Prompt == FUNCTION SP_U_EXCHANGE_RATE ==
CREATE OR REPLACE FUNCTION SP_U_EXCHANGE_RATE
(
     p_id VARCHAR2
   , p_exchange_rate NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rate NUMBER := 0.00;
   h_exchange_rate VARCHAR2(18);
   h_start_date DATE;
   h_min_SD DATE;
   h_max_SD DATE;
   h_min_FD DATE;
   h_max_FD DATE;
   h_rec_user VARCHAR2(32);
   h_id_int PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EXCHANGE_RATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EXCHANGE_RATE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EXCHANGE_RATE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_exchange_rate), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_RATE', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EXCHANGE_RATE(30) : currency.sql(901) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_EXCHANGE_RATE', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_EXCHANGE_RATE(36) : currency.sql(907) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_RATE', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_RATE(39) : currency.sql(910) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_rate := p_exchange_rate;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT START_DATE, CURRENCY_ID INTO h_start_date, h_id_int
      FROM CURRENCY_EXCHANGES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_RATE', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_RATE(60) : currency.sql(931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXCHANGE_RATE', 66+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXCHANGE_RATE(67) : currency.sql(938) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXCHANGE_RATE', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXCHANGE_RATE(70) : currency.sql(941) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      UPDATE CURRENCY_EXCHANGES
      SET EXCHANGE_RATE = h_rate
      WHERE CURRENCY_ID = h_id_int AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_RATE', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_RATE(89) : currency.sql(960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   BEGIN
      SELECT EXCHANGE_RATE INTO h_rate
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int
      AND START_DATE = (SELECT MAX(START_DATE) FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int AND EXCHANGE_RATE > 0);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_RATE', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_RATE(107) : currency.sql(978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_rate, 0) = 0.00) Then
      h_rate := 1.00;
   End If;
   
   h_exchange_rate := TO_CHAR(h_rate, 'FM999999999999999999.99');
   h_exchange_rate := h_exchange_rate;
   BEGIN
      UPDATE TMT_DATAFIELDS
      SET ELEMENT_NAME = h_exchange_rate
      WHERE ELEMENT_ID = h_id_int;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_RATE', 131+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_RATE(132) : currency.sql(1003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EXCHANGE_RATE', 137+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EXCHANGE_RATE(138) : currency.sql(1009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_RATE', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_RATE(145) : currency.sql(1016) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXCHANGE_RATE', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXCHANGE_RATE(157) : currency.sql(1028) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EXCHANGE_RATE;
ALTER FUNCTION SP_U_EXCHANGE_RATE COMPILE DEBUG;

-- delete exchange

Prompt == FUNCTION SP_D_EXCHANGE ==
CREATE OR REPLACE FUNCTION SP_D_EXCHANGE
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_min_SD DATE;
   h_max_SD DATE;
   h_min_FD DATE;
   h_max_FD DATE;
   h_rec_user VARCHAR2(32);
   h_id_int PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_rate NUMBER := 0.00;
   h_exchange_rate VARCHAR2(18);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_EXCHANGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_EXCHANGE'), '-- ' || SYSTIMESTAMP, ':r := SP_D_EXCHANGE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EXCHANGE', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_EXCHANGE(29) : currency.sql(1073) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_EXCHANGE', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_EXCHANGE(35) : currency.sql(1079) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EXCHANGE', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_EXCHANGE(38) : currency.sql(1082) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT START_DATE, FINISH_DATE, CURRENCY_ID 
      INTO h_start_date, h_finish_date, h_id_int
      FROM CURRENCY_EXCHANGES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(59) : currency.sql(1103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_EXCHANGE', 65+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_EXCHANGE(66) : currency.sql(1110) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EXCHANGE', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_EXCHANGE(69) : currency.sql(1113) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      SELECT MAX(START_DATE), COUNT(CURRENCY_ID) INTO h_max_SD, h_count
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int
      AND START_DATE < TO_DATE(SubStr(h_start_date, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(85) : currency.sql(1129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR ((h_max_SD IS NULL)) OR (Coalesce(
         h_count, 0) = 0) Then
      BEGIN
         SELECT MIN(START_DATE), COUNT(CURRENCY_ID) INTO h_min_SD, h_count
         FROM CURRENCY_EXCHANGES
         WHERE CURRENCY_ID = h_id_int
         AND START_DATE > TO_DATE(SubStr(h_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(103) : currency.sql(1147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR ((h_min_SD IS NULL)) OR (Coalesce(
            h_count, 0) = 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_EXCHANGE', 110+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_EXCHANGE(111) : currency.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_LAST_EXCHANGE), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EXCHANGE', 113+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_EXCHANGE(114) : currency.sql(1158) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE_LAST_EXCHANGE, h_id, True);
      End If;
      
      BEGIN
         UPDATE CURRENCY_EXCHANGES
         SET START_DATE = TO_DATE(SubStr(h_start_date, 1, 10))
         WHERE CURRENCY_ID = h_id_int
         AND START_DATE = h_min_SD;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(134) : currency.sql(1178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM CURRENCY_EXCHANGES WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(151) : currency.sql(1195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE CURRENCY_EXCHANGES
         SET FINISH_DATE = TO_DATE(SubStr(h_finish_date, 1, 10))
         WHERE CURRENCY_ID = h_id_int
         AND START_DATE = h_max_SD;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(171) : currency.sql(1215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM CURRENCY_EXCHANGES WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(188) : currency.sql(1232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT EXCHANGE_RATE INTO h_rate
      FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int
      AND START_DATE = (SELECT MAX(START_DATE) FROM CURRENCY_EXCHANGES
      WHERE CURRENCY_ID = h_id_int AND EXCHANGE_RATE > 0);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 205+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(206) : currency.sql(1250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_rate, 0) = 0.00) Then
      h_rate := 1.00;
   End If;
   
   h_exchange_rate := TO_CHAR(h_rate, 'FM999999999999999999.99');
   h_exchange_rate := h_exchange_rate;
   BEGIN
      UPDATE TMT_DATAFIELDS
      SET ELEMENT_NAME = h_exchange_rate
      WHERE ELEMENT_ID = h_id_int;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(231) : currency.sql(1275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_EXCHANGE', 236+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_EXCHANGE(237) : currency.sql(1281) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 243+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(244) : currency.sql(1288) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EXCHANGE', 255+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EXCHANGE(256) : currency.sql(1300) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_EXCHANGE;
ALTER FUNCTION SP_D_EXCHANGE COMPILE DEBUG;

