/*****************************************************************************************/

-- Copy Assignments

/*****************************************************************************************/

Prompt == FUNCTION FC_CRI_ASSIGNMENTS ==
CREATE OR REPLACE FUNCTION FC_CRI_ASSIGNMENTS
(
     h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_currency_id PLS_INTEGER
   , h_target_date IN OUT NOCOPY TIMESTAMP
   , h_source_date IN OUT NOCOPY TIMESTAMP
   , h_cur_date IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , sh_h_c_participants PLS_INTEGER := 0
) RETURN PLS_INTEGER
AS
   h_currency_id PLS_INTEGER := sh_h_currency_id;
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_c_participants PLS_INTEGER := Coalesce(sh_h_c_participants, 0);
   h_cur_id VARCHAR2(32);
   h_new_id VARCHAR2(32);
   h_assign_id VARCHAR2(32);
   h_old_tsk_assign_id VARCHAR2(32);
   h_role_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_rate_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_id1 VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_dt1 TIMESTAMP;
   h_dt2 TIMESTAMP;
   h_dt10 TIMESTAMP;
   h_dt11 TIMESTAMP;
   h_dayofyear DATE;
   h_old_name VARCHAR2(255);
   h_full_name VARCHAR2(255);
   h_assign_string VARCHAR2(8192);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_2_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_min VARCHAR2(19);
   h_null_str VARCHAR2(1);
   h_temp_res_cost NUMBER := 0;
   h_per_week PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_consider PLS_INTEGER := 0;
   h_occurrence PLS_INTEGER := 0;
   h_contour PLS_INTEGER := 0;
   h_work PLS_INTEGER := 0;
   h_eunit PLS_INTEGER := 0;
   h_unit PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_best PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_element_type PLS_INTEGER := 0;
   h_assign_status PLS_INTEGER := 0;
   h_n3 PLS_INTEGER := 0;
   h_n4 PLS_INTEGER := 0;
   h_n11 PLS_INTEGER := 0;
   h_update PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_minutes PLS_INTEGER := 0;
   h_julian_day PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_reg_cost NUMBER := 0;
   h_reg_sale NUMBER := 0;
   h_spec_cost NUMBER := 0;
   h_spec_sale NUMBER := 0;
   h_rate_echange NUMBER := 0;
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_percent_units PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_delay PLS_INTEGER := 0;
   h_planned_work PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_proposed_work PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
   h_labor_cost_cc_id VARCHAR2(32);
   h_labor_revenue_cc_id VARCHAR2(32);
   i_max_min PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C4R IS
         SELECT RA.ELEMENT_ID, RA.ELEMENT_TYPE, RA.ASSIGN_STATUS, RA.WORK_LOCATION, RA.RES_ASSIGNMENT_ID, RA.PARTICIPANT,
         case when T.WBS_ID is null then RA.SECURITY_ID else RA.CRI_SECURITY_ID end as SECURITY_ID,
         TA.TSK_ASSIGNMENT_ID,TA.PROJECT_ASSIGNMENT_ID,TA.RESOURCE_TYPE,TA.RESOURCE_ID,
         TA.PROPOSED_START, TA.ASSIGNMENT_DELAY,
         TA.UNITS_MSP,TA.C_EFFORT, TA.T_UNIT, TA.C_UNIT, TA.C_CONTOUR, TA.CONTOUR_TYPE,
         CASE WHEN TA.PROJECT_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID THEN 1 ELSE 0 END AS PA_FLAG,
         TA.PLANNED_WORK, TA.SCHED_WORK, TA.UNRESOLVED_START, TA.UNRESOLVED_DURATION,
         TA.PROPOSED_WORK, TA.PROPOSED_WORK, TA.BILLABLE, TA.CAPITAL_EXPENSE, TA.TABLE_TYPE, TA.TIMECODE_1_ID, TA.TIMECODE_2_ID,
         'NOTNULL32' as WBS_ID, TA.LABOR_COST_CC_ID, TA.LABOR_REVENUE_CC_ID
         FROM TMT_CRI T JOIN TASK_ASSIGNMENTS TA
         ON TA.PROJECT_ID = T.PROJECT_ID
         AND T.ELEMENT_ID = TA.TASK_ID
         JOIN RESOURCE_ASSIGNMENTS RA ON RA.RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID
         WHERE T.PROJECT_ID = h_source_project_id
         AND T.LEVEL_ID > 1
         AND T.RANK LIKE h_source_rank || '%'
         ORDER BY RESOURCE_TYPE DESC, RESOURCE_ID, PA_FLAG, PROPOSED_START;

      CURSOR C_DELAY1 IS
         SELECT r.DAY_YEAR
         FROM CALENDAR_DAY_OF_YEAR r
         WHERE r.ELEMENT_ID = h_res_id AND r.DAY_YEAR > TO_DATE(SubStr(h_target_date, 1, 10));

      CURSOR C_DELAY0 IS
         SELECT p.DAY_YEAR
         FROM PMO_TMP_CDY p
         WHERE p.DAY_YEAR > TO_DATE(SubStr(h_target_date, 1, 10));

      CURSOR CSKILL1 IS
         SELECT SKILL_ID, PROFICIENCY_LEVEL_ID, EXPERIENCE_ID
         FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID = h_res_id;

      CURSOR CSKILL0 IS
         SELECT SKILL_ID, PROFICIENCY_LEVEL_ID, EXPERIENCE_ID
         FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID = h_old_tsk_assign_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CRI_ASSIGNMENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CRI_ASSIGNMENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_CRI_ASSIGNMENTS(' || 
       '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_currency_id), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_target_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_source_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_cur_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_c_participants), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_ASSIGNMENTS', 148+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CRI_ASSIGNMENTS(149) : defaults.sql(156) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_COPY_PROF';
   PMO_DB2M.SC_STATE := 0;
   
   h_n11 := 0;
   --trace_printf("h_source_project_id: %s; h_source_rank: %s, h_target_date: %s\n", h_source_project_id, h_source_rank,h_target_date);
   
   h_prj_assignment_id := NULL;
   --trace_printf("h_prj_assignment_id: %d:%s; h_source_type: %d\n", h_prj_assignment_id_Ind,h_prj_assignment_id, h_source_type);
   
   h_dayofyear := SubStr(h_target_date, 1, 10);
   h_temp_var := FC_LoadProjectCalendar(h_project_id, h_dayofyear);
   
   BEGIN
      SELECT MINUTE_PER_DAY INTO h_min_per_day FROM PMO_TMP_MIN_MAX;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 172+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(173) : defaults.sql(180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_min_per_day: %d\n",SC_STATE,h_min_per_day);//trace_flush();
   
   h_temp_sc_state := FC_DECLARE_PMO_TMP_SEARCH();
   
   h_consider := h_c_participants;
   
   BEGIN
      SELECT PMO_ORASTD.TODECIMAL(ELEMENT_NAME, 18, 4) INTO h_rate_echange FROM TMT_DATAFIELDS WHERE ELEMENT_ID = h_currency_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 190+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(191) : defaults.sql(198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- copy Task Assignments
   
   OPEN C4R;
   
   LOOP
      FETCH C4R INTO
      h_cur_id, h_type, h_element_type, h_assign_status, h_assign_id, h_participant,
      h_security_id, h_old_tsk_assign_id, h_prj_assignment_id, h_res_type,
      h_res_id, h_start_date, h_delay,
      h_percent_units,h_work, h_eunit, h_unit, h_contour, h_bitflag,
      h_count, h_planned_work, h_sched_work, h_dt10, h_duration,
      h_proposed_work, h_best, h_billable, h_capital_expense, h_table_type,
      h_timecode_1_id, h_timecode_2_id, h_wbs_id, h_labor_cost_cc_id, h_labor_revenue_cc_id;
      IF C4R%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n");
      --trace_printf("SC_STATE: %d, h_assign_id: %s, h_res_type: %s, h_start_date: %s, h_delay: %d\n", SC_STATE,h_assign_id,h_res_type,h_start_date,h_delay,h_percent_units);
      --trace_printf("h_unit: %d, h_work: %d, h_percent_units: %d\n", h_unit,h_work,h_percent_units);
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      --trace_printf("h_old_tsk_assign_id00: %s; h_effort: %d\n", h_old_tsk_assign_id, h_effort);
      If Coalesce(h_delay, 0) = 0 Then
         h_start_date := h_target_date;
      Else
         If (SubStr(h_res_type, 1, 1) = '0') Then
            OPEN C_DELAY1;
            
            WHILE Coalesce(h_delay, 0) > 0 LOOP
               FETCH C_DELAY1 INTO h_dayofyear;
               IF C_DELAY1%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_ASSIGNMENTS', 238+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_ASSIGNMENTS(239) : defaults.sql(246) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_CNST.RECORD_NOT_FOUND;
               End If;
                           h_delay := Coalesce(h_delay, 0) - 1;
            END LOOP;
            
            BEGIN
               CLOSE C_DELAY1;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 253+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(254) : defaults.sql(261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            OPEN C_DELAY0;
            
            WHILE Coalesce(h_delay, 0) > 0 LOOP
               FETCH C_DELAY0 INTO h_dayofyear;
               IF C_DELAY0%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_ASSIGNMENTS', 270+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_ASSIGNMENTS(271) : defaults.sql(278) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_CNST.RECORD_NOT_FOUND;
               End If;
                           h_delay := Coalesce(h_delay, 0) - 1;
            END LOOP;
            
            BEGIN
               CLOSE C_DELAY0;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 285+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(286) : defaults.sql(293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_dayofyear, 1, 10)), PMO_ORASTD.TIME(h_target_date))
            INTO h_start_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 301+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(302) : defaults.sql(309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("********** h_start_date: %d %s\n", h_start_date_Ind,h_start_date);
      
      If (h_start_date IS NOT NULL) Then
         --GENERATES A NEW RESOURCE_ASSIGNMENT ID
         h_new_id := SYS_GUID();
         --trace_printf("h_participant: %d, h_security_id: %s, h_new_id: %s\n",h_participant,h_security_id,h_new_id);
         
         h_effort := (Coalesce(h_planned_work, 0) + Coalesce(h_sched_work, 0));
         --trace_printf("h_old_tsk_assign_id01: %s; h_effort: %d\n", h_old_tsk_assign_id, h_effort);
         If Coalesce(h_effort, 0) > 0 Then
            h_finish_date := '';
         Else
            h_finish_date := h_start_date;
         End If;
         
         --GET ROLE_ID
         If SubStr(h_res_type, 1, 1) = '1' Then
            BEGIN
               SELECT ROLE_ID INTO h_role_id FROM PROFILES WHERE PROFILE_ID = h_res_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 331+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(332) : defaults.sql(339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("h_prj_assignment_id: %d:%s; h_effort: %d\n", h_prj_assignment_id_Ind,h_prj_assignment_id, h_effort);
            
            If FC_findProfile(h_project_id, h_prj_assignment_id, h_res_id, h_new_id, h_start_date, h_effort
                  , h_finish_date) <> 0 Then
               --trace_printf("A_1 h_start_date: %d %s, h_finish_date: %d %s\n", h_start_date_Ind,h_start_date, h_finish_date_Ind,h_finish_date);
               --PROFILE #
               BEGIN
                  SELECT RATE_ID INTO h_rate_id FROM TMT_COMPETENCIES WHERE ELEMENT_ID = h_role_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 349+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(350) : defaults.sql(357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT COALESCE( MAX( PROF_NUMBER), 0) + 1 INTO h_n3
                  FROM PROFILES WHERE PROJECT_ID = h_project_id AND ROLE_ID = h_role_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 363+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(364) : defaults.sql(371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --INSERT NEW PROFILE
               BEGIN
                  INSERT INTO PROFILES( PROFILE_ID, PROJECT_ID, ROLE_ID, PROF_NUMBER, PROFILE_NAME)
                  SELECT
                  h_new_id,
                  h_project_id,
                  h_role_id,
                  h_n3,
                  PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(TCP.ELEMENT_NAME), ', '), RTRIM(TC.ELEMENT_NAME)), '('), RTRIM(TO_CHAR(h_n3))), ')')
                  FROM TMT_COMPETENCIES TC, TMT_COMPETENCIES TCP
                  WHERE TC.ELEMENT_ID = h_role_id AND TCP.ELEMENT_ID = TC.PARENT_ID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 389+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(390) : defaults.sql(397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("SC_STATE: %d, h_new_id: %s; h_n3: %d\n", SC_STATE,h_new_id, h_n3);
               
               --NEW ASSIGNMENT SKILLS
               If SubStr(h_res_type, 1, 1) = '1' Then
                  OPEN CSKILL1;
                  
                  LOOP
                     FETCH CSKILL1 INTO h_id1, h_n3, h_n4;
                     IF CSKILL1%FOUND THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                     If PMO_DB2M.SC_STATE <> 0 Then
                        EXIT;
                     End If;
                     
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGN_SKILLS( RES_ASSIGNMENT_ID,SKILL_ID,PROFICIENCY_LEVEL_ID, EXPERIENCE_ID)
                        VALUES( h_new_id, h_id1, h_n3, h_n4);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 423+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(424) : defaults.sql(431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  END LOOP;
                  
                  BEGIN
                     CLOSE CSKILL1 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 437+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(438) : defaults.sql(445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  --NEW ASSIGNMENT ROLE
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGN_ROLES(RES_ASSIGNMENT_ID,ROLE_ID,PROFICIENCY_LEVEL_ID, EXPERIENCE_ID, PRIMARY_ROLE)
                     SELECT h_new_id, ROLE_ID, PROFICIENCY_LEVEL_ID, EXPERIENCE_ID, PRIMARY_ROLE
                     FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID = h_res_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 457+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(458) : defaults.sql(465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  OPEN CSKILL0;
                  
                  LOOP
                     FETCH CSKILL0 INTO h_id1, h_n3, h_n4;
                     IF CSKILL0%FOUND THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                     If PMO_DB2M.SC_STATE <> 0 Then
                        EXIT;
                     End If;
                     
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGN_SKILLS( RES_ASSIGNMENT_ID,SKILL_ID,PROFICIENCY_LEVEL_ID, EXPERIENCE_ID)
                        VALUES( h_new_id, h_id1, h_n3, h_n4);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 488+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(489) : defaults.sql(496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  END LOOP;
                  
                  BEGIN
                     CLOSE CSKILL0 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 502+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(503) : defaults.sql(510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  --NEW ASSIGNMENT ROLE
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGN_ROLES(RES_ASSIGNMENT_ID,ROLE_ID,PROFICIENCY_LEVEL_ID, EXPERIENCE_ID, PRIMARY_ROLE)
                     SELECT h_new_id, ROLE_ID, PROFICIENCY_LEVEL_ID, EXPERIENCE_ID, PRIMARY_ROLE
                     FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID = h_old_tsk_assign_id AND ROLE_ID <> h_role_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 522+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(523) : defaults.sql(530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            h_new_id := h_res_id;
         End If;
         
         --INSERT A NEW RESOURCE_ASSIGNMENT
         h_temp_var := FC_findTask(h_cur_id, h_id, h_wbs_id);
         --trace_printf("h_cur_id: %s, h_id: %s, h_wbs_id: %s\n", h_cur_id, h_id,h_wbs_id);
         
         --trace_printf("1_* h_temp_var: %d, h_prj_assignment_id: %d:%s, h_tsk_assignment_id: %d:%s\n",h_temp_var,h_prj_assignment_id_Ind,h_prj_assignment_id,h_tsk_assignment_id_Ind,h_tsk_assignment_id);
         --trace_printf("h_new_id: %d:%s, h_res_id: %d:%s\n",h_new_id_Ind,h_new_id,h_res_id_Ind,h_res_id);
         If Coalesce(h_temp_var, 0) = 0 Then
            h_tsk_assignment_id := SYS_GUID();
            
            h_update := 0;
            
            If (h_prj_assignment_id IS NOT NULL) Then
               h_n11 := 1;
               -- Project assignments exists
            End If;
            
            If SubStr(h_res_type, 1, 1) = '1' Then
               BEGIN
                  SELECT PROFILE_NAME || ';' INTO h_full_name FROM PROFILES WHERE PROFILE_ID = h_new_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 557+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(558) : defaults.sql(565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT NICK_NAME || ';' INTO h_full_name FROM RESOURCES WHERE RESOURCE_ID = h_new_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 570+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(571) : defaults.sql(578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            --trace_printf("2_* h_update: %d, h_full_name: %d:%s\n",h_update,h_full_name_Ind,h_full_name);
            
            If Coalesce(h_update, 0) = 0 Then
               --trace_printf("h_table_type: %d, h_type: %d, h_new_id: %s, h_participant: %d, h_security_id: %s\n",h_table_type,h_type,h_new_id,h_participant,h_security_id);
               --there is no need to double check the securoty id to be responsible of any cri element, the resultset fo the fetch will dtermine the if
               /*BEGIN_SQL
                                       SELECT RESOURCE_ID,RES_ASSIGNMENT_ID INTO HOST(h_id1), HOST(h_assign_id)
                                       FROM RESOURCE_ASSIGNMENTS
                                       WHERE PROJECT_ID = HOST(h_project_id) AND ELEMENT_ID = HOST(h_id) AND SECURITY_ID IN ('SCTASKRESPONSIBLE', 'SCRISKRESPONSIBLE', 'SCISSUERESPONSIBLE', 'SCREQUIREMENTRESPONSIBLE','SCCHANGEREQUESTRESPONSIBLE', 'SCDEFECTRESPONSIBLE','SCSERVICEREQUESTRESPONSIBLE','SCDELIVERABLEMANAGER');
                                   END_SQL;*/
               BEGIN
                  SELECT RES_ASSIGNMENT_ID INTO h_assign_id
                  FROM RESOURCE_ASSIGNMENTS
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id AND RESOURCE_ID  = h_new_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 595+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(596) : defaults.sql(603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("SC_STATE: %d, h_id1: %s, h_assign_id: %s\n", SC_STATE,h_id1,h_assign_id);
               If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  BEGIN
                     SELECT NICK_NAME || ';' INTO h_old_name FROM RESOURCES WHERE RESOURCE_ID = h_new_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 609+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(610) : defaults.sql(617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     UPDATE TMT_CRI SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_name, h_full_name)
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 627+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(628) : defaults.sql(635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("SC_STATE: %d, h_old_name: %s, h_full_name: %s\n", SC_STATE,h_old_name,h_full_name);
                  
                  h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_id1, h_res_type);
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS SET
                     PARTICIPANT     = PMO_STPU.BIT_OR(PARTICIPANT,PMO_CNST.SC_TEAMMEMBER),
                     REC_STATUS      = 'U',
                     REC_DATETIME    = h_cur_date
                     WHERE RES_ASSIGNMENT_ID = h_assign_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 651+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(652) : defaults.sql(659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  h_temp_sc_state := FC_AFTER_REPLACE_RES_ASSIGN(h_project_id, h_new_id, h_res_type);
               Else
                  BEGIN
                     UPDATE TMT_CRI SET ASSIGN_NAMES = ASSIGN_NAMES || h_full_name
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 671+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(672) : defaults.sql(679) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("SC_STATE: %d, h_full_name: %s\n", SC_STATE,h_full_name);
                  
                  h_assign_id := SYS_GUID();
                  
                  h_temp_bitflag := 1;
                  h_temp_var := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_new_id, h_type, h_participant, h_security_id
                                     , h_res_type, h_temp_bitflag);
                  
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(
                     RES_ASSIGNMENT_ID,
                     ELEMENT_ID,
                     ELEMENT_TYPE,
                     PROJECT_ID,
                     RESOURCE_TYPE,
                     RESOURCE_ID,
                     ASSIGN_STATUS,
                     WORK_LOCATION,
                     PARTICIPANT,
                     SECURITY_ID,
                     REC_STATUS,
                     REC_DATETIME,TABLE_TYPE)
                     VALUES(
                     h_assign_id,
                     h_id,
                     h_type,
                     h_project_id,
                     h_res_type,
                     h_new_id,
                     h_element_type,
                     h_assign_status,
                     h_participant,
                     h_security_id,
                     'U',
                     h_cur_date,h_table_type);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 720+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(721) : defaults.sql(728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            --trace_printf("h_type: %d, h_duration: %d, h_effort: %d, h_res_type: %s, h_dt11: %s\n",h_type,h_duration,h_effort,h_res_type,h_dt11);
            --trace_printf("h_old_tsk_assign_id: %s, h_dt10: %s\n",h_old_tsk_assign_id,h_dt10);
            If (Coalesce(h_effort, 0) > 0) AND (SubStr(h_res_type, 1, 1) = '1') Then
               null_return := FC_INI_ASSIGN_STR(1);
               -- create temp table PMO_ASSIGN_STR
               h_assign_string := '';
               
               h_julian_day := 0;
               h_bitflag := 0;
               
               h_total := Coalesce(h_effort, 0);
               h_minutes := Coalesce(h_effort, 0);
               h_dt1 := h_start_date;
               h_dt2 := h_finish_date;
               
               WHILE Coalesce(h_minutes, 0) > 0 LOOP
                  h_minutes := FC_getNextDate(h_bitflag, h_dt1, h_minutes, h_dt2, h_bitID);
                  
                  If (Coalesce(h_bitflag, 0) = 0) AND (PMO_ORASTD.strcmp(h_start_date, h_dt1) <> 0) Then
                     h_start_date := h_dt1;
                  End If;
                  
                  If Coalesce(h_minutes, 0) < 0 Then
                     EXIT;
                  ElsIf Coalesce(h_minutes, 0) > 0 Then
                     --trace_printf("3_* h_prj_assignment_id: %d:%s, h_tsk_assignment_id: %d:%s\n",h_prj_assignment_id_Ind,h_prj_assignment_id,h_tsk_assignment_id_Ind,h_tsk_assignment_id);
                     If (h_prj_assignment_id IS NULL) Then
                        BEGIN
                           INSERT INTO TASK_DAY_OF_YEAR( PROJECT_ID, TASK_ID, RESOURCE_ID, TSK_ASSIGNMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED, BIT_FLAG, TABLE_TYPE )
                           VALUES( h_project_id, h_id, h_new_id, h_tsk_assignment_id, h_tsk_assignment_id, TO_DATE(SubStr(h_dt1, 1, 10)), h_minutes, h_bitID, '0', PMO_CNST.SC_TABLE_CRI );
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 767+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(768) : defaults.sql(775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     Else
                        BEGIN
                           INSERT INTO TASK_DAY_OF_YEAR( PROJECT_ID, TASK_ID, RESOURCE_ID, TSK_ASSIGNMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED, BIT_FLAG, TABLE_TYPE )
                           VALUES( h_project_id, h_id, h_new_id, h_tsk_assignment_id, h_prj_assignment_id, TO_DATE(SubStr(h_dt1, 1, 10)), h_minutes, h_bitID, '0', PMO_CNST.SC_TABLE_CRI );
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 785+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(786) : defaults.sql(793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                     
                     BEGIN
                        SELECT PMO_ORASTD.JULIAN_DAY(h_dt1) INTO h_julian_day FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 799+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(800) : defaults.sql(807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     If isNotProjectType(Coalesce(h_type, 0)) <> 0 Then
                        h_temp_var := FC_ASSIGN_STRING(h_julian_day, h_minutes);
                     End If;
                     
                     If Coalesce(h_minutes, 0) > i_max_min Then
                        i_max_min := Coalesce(h_minutes, 0);
                     End If;
                  End If;
                  
                  If Coalesce(h_total, 0) = 0 Then
                     EXIT;
                  ElsIf Coalesce(h_total, 0) < Coalesce(h_minutes, 0) Then
                     h_minutes := Coalesce(h_total, 0);
                  Else
                     h_total := Coalesce(h_total, 0) - Coalesce(h_minutes, 0);
                     h_minutes := Coalesce(h_total, 0);
                  End If;
                  h_bitflag := Coalesce(h_bitflag, 0) + 1;
                  
                  BEGIN
                     SELECT TO_DATE(SubStr(h_dt1, 1, 10)) + 1      INTO h_dt1
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 832+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(833) : defaults.sql(840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  --This call is to fix the start date..
                  h_temp_bitflag := 0;
                  h_temp_var := FC_GET_DT(h_dt1, h_temp_bitflag);
               END LOOP;
               
               If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                  h_assign_string := NULL;
               Else
                  h_temp_var := FC_GET_ASSIGN_STR(h_assign_string, 0);
                  -- get the final assign string
               End If;
            End If;
            
            --trace_printf("h_update: %d, h_prj_assignment_id: %d:%s, h_tsk_assignment_id: %d:%s\n",h_update,h_prj_assignment_id_Ind,h_prj_assignment_id,h_tsk_assignment_id_Ind,h_tsk_assignment_id);
            --trace_printf("A_3 h_start_date: %d %s, h_finish_date: %d %s,h_res_type: %s\n", h_start_date_Ind,h_start_date, h_finish_date_Ind,h_finish_date,h_res_type);
            
            If Coalesce(h_update, 0) = 0 Then
               If SubStr(h_res_type, 1, 1) = '0' Then
                  h_temp_res_cost := 0.00;
                  h_occurrence := 0;
                  
                  If (Coalesce(h_contour, 0) = 0) AND (Coalesce(h_unit, 0) <> 10000) Then
                     h_work := 0;
                  End If;
                  
                  h_temp_var := FC_CALC_DURATION(h_start_date, h_finish_date, 0, 0, Coalesce(h_consider, 0), Coalesce(
                               h_bitflag, 0), Coalesce(h_contour, 0), Coalesce(h_occurrence, 0)
                               , Coalesce(h_min_per_day, 0), Coalesce(h_per_week, 0), h_work
                               , h_effort, h_duration);
                  
                  If (Coalesce(h_percent_units, 0) > 0) AND (Coalesce(h_percent_units, 0) <> 10000) Then
                     h_unit := 100;
                     h_work := Coalesce(h_percent_units, 0);
                  End If;
                  --trace_printf("h_bitflag: %d, h_consider: %d, h_effort: %d, h_percent_units: %d, h_work: %d, h_unit: %d\n",h_bitflag,h_consider,h_effort,h_percent_units,h_work,h_unit);
                  --trace_printf("h_start_date: %d %s, h_finish_date: %d %s, h_duration: %d\n", h_start_date_Ind,h_start_date, h_finish_date_Ind,h_finish_date,h_duration);
                  
                  h_bitflag := (PMO_FUNC.BIT_OR(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_28));
                  -- set do not rollup
                  h_temp_var := FC_SEARCH_2(h_tsk_assignment_id, h_project_id, h_id, h_res_id, h_temp_res_cost, h_type
                          , h_null_str, h_null_str, h_null_str, h_null_str, h_start_date
                          , h_finish_date, h_duration, h_effort, h_work, h_eunit, h_unit
                          , h_occurrence, h_consider, h_res_type, h_occurrence, h_bitflag, h_contour
                          , h_occurrence, h_update, h_min_per_day, h_priority, h_rec_user, 0, 0
                          , 0.00, 0.00);
                  --trace_printf("*** FC_SEARCH_2: h_temp_var: %d\n",h_temp_var);
               Else
                  --trace_printf("i_max_min: %d, h_percent_units: %d, h_min_per_day: %d\n",i_max_min,h_percent_units,h_min_per_day);
                  If i_max_min > 0 Then
                     h_percent_units := Trunc((i_max_min / Coalesce(h_min_per_day, 0)) * 10000.00);
                  End If;
                  --trace_printf("** h_percent_units: %d, h_start_date: %d %s, h_finish_date: %d %s\n",h_percent_units,h_start_date_Ind,h_start_date,h_finish_date_Ind,h_finish_date);
                  
                  If (h_rate_id IS NOT NULL) Then
                     BEGIN
                        SELECT REGULAR_COST * h_rate_echange, SPECIAL_COST * h_rate_echange, REGULAR_SALE * h_rate_echange, SPECIAL_SALE * h_rate_echange
                        INTO h_reg_cost, h_spec_cost, h_reg_sale, h_spec_sale
                        FROM RATES WHERE RATE_ID = h_rate_id;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 901+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(902) : defaults.sql(909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        INSERT INTO TASK_ASSIGNMENTS(
                        TSK_ASSIGNMENT_ID, RES_ASSIGNMENT_ID, TASK_ID, PROJECT_ID, RESOURCE_ID,RESOURCE_TYPE,
                        SD, FD, START_DT, FINISH_DT, DURATION, UNITS_MSP,
                        PLANNED_START, PLANNED_FINISH, PLANNED_WORK, ETC, PLANNED_DURATION,
                        PROPOSED_START, PROPOSED_FINISH, PROPOSED_WORK, PROPOSED_DURATION,
                        ASSIGN_STRING, BEST, BIT_FLAG, TABLE_TYPE, PROJECT_ASSIGNMENT_ID,
                        REGULAR_COST, SPECIAL_COST, REGULAR_RATE, SPECIAL_RATE, BILLABLE, CAPITAL_EXPENSE, TIMECODE_1_ID, TIMECODE_2_ID,
                        LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID)
                        VALUES (h_tsk_assignment_id, h_assign_id, h_id, h_project_id, h_new_id, '1',
                        PMO_CNST.SC_NS, PMO_CNST.SC_NF, h_start_date, h_finish_date, h_effort, h_percent_units,
                        h_start_date, h_finish_date, h_effort, h_effort, h_effort,
                        h_start_date, h_finish_date, h_effort,  h_effort,
                        h_assign_string, h_best, '0', h_table_type, h_prj_assignment_id,
                        h_reg_cost, h_spec_cost, h_reg_sale, h_spec_sale,
                        h_billable, h_capital_expense,h_timecode_1_id, h_timecode_2_id,
                        h_labor_cost_cc_id, h_labor_revenue_cc_id);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 933+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(934) : defaults.sql(941) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_reg_cost := 0.00;
                     h_reg_sale := 0.00;
                     
                     BEGIN
                        INSERT INTO TASK_ASSIGNMENTS(
                        TSK_ASSIGNMENT_ID, RES_ASSIGNMENT_ID, TASK_ID, PROJECT_ID, RESOURCE_ID,RESOURCE_TYPE,
                        SD, FD, START_DT, FINISH_DT, DURATION, UNITS_MSP,
                        PLANNED_START, PLANNED_FINISH, PLANNED_WORK, ETC, PLANNED_DURATION,
                        PROPOSED_START, PROPOSED_FINISH, PROPOSED_WORK, PROPOSED_DURATION,
                        ASSIGN_STRING, BEST, BIT_FLAG, TABLE_TYPE, PROJECT_ASSIGNMENT_ID, BILLABLE, CAPITAL_EXPENSE,
                        TIMECODE_1_ID, TIMECODE_2_ID, LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID )
                        VALUES(h_tsk_assignment_id, h_assign_id, h_id, h_project_id, h_new_id, '1',
                        PMO_CNST.SC_NS, PMO_CNST.SC_NF, h_start_date, h_finish_date, h_effort,h_percent_units,
                        h_start_date, h_finish_date, h_effort, h_effort,  h_effort,
                        h_start_date, h_finish_date, h_effort, h_effort,
                        h_assign_string, h_best, '0', h_table_type, h_prj_assignment_id, h_billable, h_capital_expense,
                        h_timecode_1_id, h_timecode_2_id, h_labor_cost_cc_id, h_labor_revenue_cc_id);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 965+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(966) : defaults.sql(973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  If isTask(Coalesce(h_type, 0)) <> 0 Then
                     h_temp_sc_state := FC_UPDATE_LABOR_BUDGET(h_project_id, h_id, h_tsk_assignment_id, h_rec_user);
                     
                     h_tph_delete := 0;
                     h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_id, h_tsk_assignment_id, h_start_date
                                          , h_finish_date, h_reg_cost, h_reg_sale, h_tph_delete
                                          , h_capital_expense, h_billable);
                  End If;
               End If;
            Else
               BEGIN
                  SELECT PLANNED_WORK + h_effort,
                  CASE WHEN TO_DATE(SubStr(h_start_date, 1, 10)) < TO_DATE(SubStr(PLANNED_START, 1, 10)) THEN h_start_date ELSE PLANNED_START END,
                  CASE WHEN TO_DATE(SubStr(h_finish_date, 1, 10)) < TO_DATE(SubStr(PLANNED_FINISH, 1, 10)) THEN h_finish_date ELSE PLANNED_FINISH END
                  INTO h_effort, h_start_date, h_finish_date
                  FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 993+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(994) : defaults.sql(1001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TASK_ASSIGNMENTS SET UNITS_MSP = h_percent_units,
                  START_DT = h_start_date, FINISH_DT = h_finish_date, DURATION = h_effort,
                  PLANNED_START = h_start_date, PLANNED_FINISH = h_finish_date,
                  PLANNED_WORK = h_effort, PLANNED_DURATION = h_effort,
                  PROPOSED_START = h_start_date, PROPOSED_FINISH = h_finish_date,
                  PROPOSED_WORK = h_effort, PROPOSED_DURATION = h_effort
                  WHERE TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 1016+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(1017) : defaults.sql(1024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C4R ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_ASSIGNMENTS', 1033+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_ASSIGNMENTS(1034) : defaults.sql(1041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_ASSIGNMENTS', 1039+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_ASSIGNMENTS(1040) : defaults.sql(1047) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CRI_ASSIGNMENTS;
ALTER FUNCTION FC_CRI_ASSIGNMENTS COMPILE DEBUG;

/*********************************************************************/

-- flag

-- 1 set as default

-- 2 cancel default

/*********************************************************************/

Prompt == FUNCTION SP_U_DEFAULT_CRI ==
CREATE OR REPLACE FUNCTION SP_U_DEFAULT_CRI
(
     p_id VARCHAR2
   , p_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_old_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_bit_flag1 VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DEFAULT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DEFAULT_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DEFAULT_CRI(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEFAULT_CRI', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DEFAULT_CRI(28) : defaults.sql(1093) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, PROJECT_ID, TYPE_ID, DEFAULT_COL
      INTO h_rank, h_project_id, h_type_id, h_rec_status
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(44) : defaults.sql(1109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEFAULT_CRI', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEFAULT_CRI(51) : defaults.sql(1116) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEFAULT_CRI', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEFAULT_CRI(54) : defaults.sql(1119) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   h_bit_flag1 := p_flag;
   If (SubStr(h_bit_flag1, 1, 1) = '1') AND NOT (isPureCRIDeliv(Coalesce(h_type_id, 0))) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEFAULT_CRI', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEFAULT_CRI(62) : defaults.sql(1127) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DEFAULT_CRI_ITEM), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEFAULT_CRI', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEFAULT_CRI(65) : defaults.sql(1130) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DEFAULT_CRI_ITEM, p_id, True);
   End If;
   
   If (SubStr(h_bit_flag1, 1, 1) = '1') AND (SubStr(h_rec_status, 1, 1) = 'Y') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEFAULT_CRI', 71+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEFAULT_CRI(72) : defaults.sql(1137) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_DEFAULT), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEFAULT_CRI', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEFAULT_CRI(75) : defaults.sql(1140) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_DEFAULT, p_id, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT PROJECT_ID, ELEMENT_ID, TYPE_ID INTO h_project_id, h_old_id, h_type_id
      FROM PMO_DEFAULTS
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = p_id AND TYPE_ID = h_type_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(93) : defaults.sql(1158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_type_id: %d, h_old_id: %d %s, h_id: %d %s\n", SC_STATE,h_type_id,h_old_id_Ind,h_old_id,h_id_Ind,h_id);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_bit_flag1, 1, 1) = '1' Then
         If PMO_ORASTD.strcmp(h_old_id, h_id) <> PMO_CNST.SC_MATCH Then
            BEGIN
               UPDATE PMO_DEFAULTS
               SET ELEMENT_ID  = h_id, REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_old_id AND TYPE_ID = h_type_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 115+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(116) : defaults.sql(1181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf SubStr(h_bit_flag1, 1, 1) = '2' Then
         BEGIN
            DELETE FROM PMO_DEFAULTS
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_old_id AND TYPE_ID = h_type_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(135) : defaults.sql(1200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf SubStr(h_bit_flag1, 1, 1) = '1' Then
      h_temp_var := 0;
      BEGIN
         SELECT ELEMENT_ID INTO h_old_id
         FROM PMO_DEFAULTS
         WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(152) : defaults.sql(1217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_project_id: %s, h_type_id: %d\n", SC_STATE,h_project_id,h_type_id);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE PMO_DEFAULTS
            SET ELEMENT_ID  = h_id, REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE PROJECT_ID = h_project_id AND TYPE_ID = h_type_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(173) : defaults.sql(1238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI SET DEFAULT_COL = 'N' WHERE ELEMENT_ID  = h_old_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 189+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(190) : defaults.sql(1255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO PMO_DEFAULTS (PROJECT_ID, ELEMENT_ID, TYPE_ID, REC_USER)
            VALUES (h_project_id, h_id, h_type_id, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 207+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(208) : defaults.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   --trace_printf("1__* SC_STATE: %d\n", SC_STATE);
   
   If SubStr(h_bit_flag1, 1, 1) = '1' Then
      BEGIN
         UPDATE TMT_CRI SET DEFAULT_COL = 'Y' WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 228+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(229) : defaults.sql(1294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI SET DEFAULT_COL = 'N' WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 245+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(246) : defaults.sql(1311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DEFAULT_CRI', 252+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DEFAULT_CRI(253) : defaults.sql(1318) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 260+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(261) : defaults.sql(1326) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_CRI', 272+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_CRI(273) : defaults.sql(1338) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DEFAULT_CRI;
ALTER FUNCTION SP_U_DEFAULT_CRI COMPILE DEBUG;

--****************************************************************************

Prompt == FUNCTION FC_U_TEMPLATE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_TEMPLATE_DOC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_bit_flag1 IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_var PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_TEMPLATE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_TEMPLATE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_TEMPLATE_DOC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_bit_flag1 || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_TEMPLATE_DOC(27) : defaults.sql(1381) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --  SC_CHAR(h_id1, SC_H_ID);
   
   BEGIN
      SELECT RANK, PUBLISHED, T_PARENT_ID INTO h_rank, h_rec_status, h_t_parent_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(43) : defaults.sql(1397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_rank: %s, h_rec_status: %s\n", SC_STATE,h_rank,h_rec_status);
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_DOC(51) : defaults.sql(1405) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (SubStr(h_bit_flag1, 1, 1) = '1') AND (SubStr(h_rec_status, 1, 1) = 'Y') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_DOC(58) : defaults.sql(1412) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_ALREADY_TEMPLATED;
   End If;
   
   --Get the parent rank
   If (h_parent_id IS NOT NULL) Then
      BEGIN
         SELECT RANK INTO h_parent_rank FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(74) : defaults.sql(1428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_parent_rank: %s\n", SC_STATE,h_parent_rank);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_DOC(82) : defaults.sql(1436) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_ALREADY_DELETED;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute UPDATE
      If SubStr(h_bit_flag1, 1, 1) = '1' Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            PUBLISHED   = 'Y',
            T_PARENT_ID = h_parent_id,
            T_RANK      = RTRIM(h_parent_rank) || h_rankBase64
            WHERE RANK = h_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 108+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(109) : defaults.sql(1463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("U_Y_* SC_STATE: %d\n", SC_STATE);
         
         /*BEGIN_SQL
                         UPDATE TMT_CRI SET
                             CHILD_COUNT = CHILD_COUNT - 1
                         WHERE ELEMENT_ID = HOST(h_id1);
                     END_SQL;*/
      Else
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            PUBLISHED   = 'N',
            T_PARENT_ID = NULL,
            T_RANK      = NULL
            WHERE RANK = h_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(137) : defaults.sql(1491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("U_N_* SC_STATE: %d\n", SC_STATE);
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE
            ELEMENT_ID = h_t_parent_id AND TYPE_ID = PMO_CNST.SC_TMP_FOLDER1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(156) : defaults.sql(1510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         PUBLISHED = 'N',
         T_PARENT_ID = NULL,
         T_RANK = NULL
         WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 177+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(178) : defaults.sql(1532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("U_N_** SC_STATE: %d\n", SC_STATE);
      
      BEGIN
         UPDATE TMT_DOCUMENTS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE
         ELEMENT_ID = h_t_parent_id AND TYPE_ID = PMO_CNST.SC_TMP_FOLDER1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_DOC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_DOC(197) : defaults.sql(1551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_DOC', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_DOC(204) : defaults.sql(1558) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_TEMPLATE_DOC;
ALTER FUNCTION FC_U_TEMPLATE_DOC COMPILE DEBUG;

--****************************************************************************

Prompt == FUNCTION FC_U_TEMPLATE_CRI ==
CREATE OR REPLACE FUNCTION FC_U_TEMPLATE_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_bit_flag1 IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_var PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_TEMPLATE_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_TEMPLATE_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_TEMPLATE_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_bit_flag1 || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_TEMPLATE_CRI(27) : defaults.sql(1595) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --  SC_CHAR(h_id1, SC_H_ID);
   
   BEGIN
      SELECT RANK, TEMPLATED, T_PARENT_ID INTO h_rank, h_rec_status, h_t_parent_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(43) : defaults.sql(1611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_rank: %s, h_rec_status: %s\n", SC_STATE,h_rank,h_rec_status);
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_CRI', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_CRI(51) : defaults.sql(1619) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (SubStr(h_bit_flag1, 1, 1) = '1') AND (SubStr(h_rec_status, 1, 1) = 'Y') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_CRI', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_CRI(58) : defaults.sql(1626) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_ALREADY_TEMPLATED;
   End If;
   
   --Get the parent rank
   If (h_parent_id IS NOT NULL) Then
      BEGIN
         SELECT RANK INTO h_parent_rank FROM TMT_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(74) : defaults.sql(1642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_parent_rank: %s\n", SC_STATE,h_parent_rank);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_CRI', 81+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_CRI(82) : defaults.sql(1650) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_ALREADY_DELETED;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute UPDATE
      If SubStr(h_bit_flag1, 1, 1) = '1' Then
         BEGIN
            UPDATE TMT_CRI SET
            TEMPLATED = 'Y',
            T_PARENT_ID = h_parent_id,
            T_RANK = RTRIM(h_parent_rank) || h_rankBase64
            WHERE RANK = h_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 108+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(109) : defaults.sql(1677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("U_Y_* SC_STATE: %d\n", SC_STATE);
         
         /*BEGIN_SQL
                         UPDATE TMT_CRI SET
                             CHILD_COUNT = CHILD_COUNT - 1
                         WHERE ELEMENT_ID = HOST(h_id1);
                     END_SQL;*/
      Else
         BEGIN
            UPDATE TMT_CRI SET
            TEMPLATED = 'N',
            T_PARENT_ID = NULL,
            T_RANK = NULL
            WHERE RANK = h_rank;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(137) : defaults.sql(1705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("U_N_* SC_STATE: %d\n", SC_STATE);
         
         BEGIN
            UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT - 1 WHERE
            ELEMENT_ID = h_t_parent_id AND TYPE_ID = PMO_CNST.SC_TMP_FOLDER1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(156) : defaults.sql(1724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      BEGIN
         UPDATE TMT_CRI SET
         TEMPLATED = 'N',
         T_PARENT_ID = NULL,
         T_RANK = NULL
         WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 177+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(178) : defaults.sql(1746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("U_N_** SC_STATE: %d\n", SC_STATE);
      
      BEGIN
         UPDATE TMT_CRI SET CHILD_COUNT = CHILD_COUNT - 1 WHERE
         ELEMENT_ID = h_t_parent_id AND TYPE_ID = PMO_CNST.SC_TMP_FOLDER1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TEMPLATE_CRI', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TEMPLATE_CRI(197) : defaults.sql(1765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TEMPLATE_CRI', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_TEMPLATE_CRI(204) : defaults.sql(1772) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_TEMPLATE_CRI;
ALTER FUNCTION FC_U_TEMPLATE_CRI COMPILE DEBUG;

/*********************************************************************/

-- flag

-- 1 set as templeted

-- 2 cancel templeted

/*********************************************************************/

Prompt == FUNCTION SP_U_TEMPLATE ==
CREATE OR REPLACE FUNCTION SP_U_TEMPLATE
(
     p_table PLS_INTEGER
   , p_id VARCHAR2
   , p_flag VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bit_flag1 VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TEMPLATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TEMPLATE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TEMPLATE(' || 
       COALESCE(TO_CHAR(p_table), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_flag || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TEMPLATE', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TEMPLATE(28) : defaults.sql(1818) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_bit_flag1 := p_flag;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   h_table_type := p_table;
   --trace_printf("h_table_type: %d, h_bit_flag1: %s,\n",h_table_type,h_bit_flag1);
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_TEMPLATE_CRI(h_id, h_bit_flag1, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         PMO_DB2M.SC_STATE := FC_U_TEMPLATE_DOC(h_id, h_bit_flag1, h_parent_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_RES THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_POL THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_AST THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_VDR THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_CLN THEN
         NULL;
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         NULL;
      ELSE
         NULL;
   END CASE;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TEMPLATE', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TEMPLATE(85) : defaults.sql(1875) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TEMPLATE', 92+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TEMPLATE(93) : defaults.sql(1883) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TEMPLATE', 104+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TEMPLATE(105) : defaults.sql(1895) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TEMPLATE;
ALTER FUNCTION SP_U_TEMPLATE COMPILE DEBUG;

