/****************************************************************************************/

Prompt == FUNCTION SP_I_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_I_DOMAIN
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_I_DOMAIN(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_DOMAIN', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_DOMAIN(27) : domains.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_LONG(h_level);
   /*****HERVE *****SC_LONG(h_broker_type);*/
   
   /*****HERVE *****h_broker_type= 34;*/
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Validate parent_id
   If (p_parent_id IS NULL) Then
      -- Get the max sibling level from the root
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_DOMAINS', h_max_rank);
      
      --Get Base 64
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      -- insert-select
      BEGIN
         INSERT INTO TMT_DOMAINS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID,
         p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_DOMAINS WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(64) : domains.sql(67) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      /*****HERVE *****if( SC_SUCCESS)*/
      -- {
      /*****HERVE *****UPDATE_CHANGE_LOG_NULL(h_broker_type);*/
      -- if (SC_NODATA)
      -- SC_STATE=0;
      -- }
   Else
      -- Validate parent_id
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_DOMAIN', 78+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_DOMAIN(79) : domains.sql(82) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOMAINS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOMAINS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      -- Get next sibling count
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOMAINS', h_parent_id, h_max_rank);
      
      --Get Base 64
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      -- insert-select
      BEGIN
         INSERT INTO TMT_DOMAINS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID,
         p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_DOMAINS WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(113) : domains.sql(116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      /*****HERVE *****if( SC_SUCCESS)*/
      --{
      --  UPDATE_CHANGE_LOG_LEVEL(TMT_DOMAINS,h_broker_type, h_parent_id);
      --if (SC_NODATA)
      --    SC_STATE=0;
      --}
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_DOMAIN', 126+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_DOMAIN(127) : domains.sql(130) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 133+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(134) : domains.sql(137) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_DOMAIN', 145+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_DOMAIN(146) : domains.sql(149) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_DOMAIN;
ALTER FUNCTION SP_I_DOMAIN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_U_DOMAIN
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DOMAIN(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOMAIN', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DOMAIN(24) : domains.sql(189) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   /*****HERVE *****SC_LONG(h_broker_type);*/
   
   /*****HERVE *****h_broker_type= 34;*/
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DOMAIN', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DOMAIN(35) : domains.sql(200) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DOMAIN', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DOMAIN(38) : domains.sql(203) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_DOMAIN', 44+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_DOMAIN(45) : domains.sql(210) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOMAINS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOMAINS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   /**************************HERVE changes for ORACLE ***************************/
   --BEGIN_SQL
   --  UPDATE TMT_DOMAINS SET
   --      (ELEMENT_NAME, DESCRIPTION, REC_STATUS, REC_DATETIME, REC_USER) =
   --      (HOST_DB(name, ind_u_domain)/*:*name:ind_u_domain->name*/, HOST_DB(description, ind_u_domain)/*:*description:ind_u_domain->description*/, 'U', SC_NOW, HOST_DB(rec_user, ind_u_domain)/*:*rec_user:ind_u_domain->rec_user*/)
   --  WHERE ELEMENT_ID = HOST_DB(id, ind_u_domain)/*:*id*/;
   --END_SQL;
   /***************************HERVE changes for ORACLE ***************************/
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_DOMAINS SET
      ELEMENT_NAME = p_name,
      DESCRIPTION  = p_description,
      REC_STATUS   = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(83) : domains.sql(248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_DOMAINS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_DOMAINS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(101) : domains.sql(266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*****HERVE *****if( SC_SUCCESS)*/
   --{
   --    if(h_update > 0)
   --     {
   --    UPDATE_CHANGE_LOG_NULL(h_broker_type);
   --     if (SC_NODATA)
   --       SC_STATE=0;
   --      }
   --}
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DOMAIN', 116+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DOMAIN(117) : domains.sql(282) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 123+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(124) : domains.sql(289) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DOMAIN', 135+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DOMAIN(136) : domains.sql(301) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DOMAIN;
ALTER FUNCTION SP_U_DOMAIN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_D_DOMAIN
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC2 IS
         SELECT ELEMENT_ID
         FROM TMT_DOMAINS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%'
         AND TYPE_ID = PMO_CNST.SC_RESOURCE;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_D_DOMAIN(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_DOMAIN', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_DOMAIN(34) : domains.sql(351) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   h_rec_status := p_del_flag;
   
   -- Validate parent id
   If ((p_parent_id IS NULL)) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOMAINS
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND REC_STATUS NOT IN ('L','D');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(58) : domains.sql(375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOMAINS
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND REC_STATUS NOT IN ('L','D');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(78) : domains.sql(395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOMAIN', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOMAIN(86) : domains.sql(403) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_DOMAIN', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_DOMAIN(89) : domains.sql(406) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True);
   End If;
   
   OPEN CC2;
   
   FETCH CC2 INTO h_exists;
   IF CC2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   
   BEGIN
      CLOSE CC2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(117) : domains.sql(434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      If (Coalesce(h_dependency_count, 0) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOMAIN', 124+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOMAIN(125) : domains.sql(442) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_DOMAIN', 127+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_DOMAIN(128) : domains.sql(445) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE_RECORD, p_id, True);
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_DOMAIN', 132+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_DOMAIN(133) : domains.sql(450) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_DOMAIN', 135+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_DOMAIN(136) : domains.sql(453) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
      End If;
   End If;
   
   -- Execute Delete Statement
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOLS
         SET DOMAIN_ID = NuLL
         WHERE DOMAIN_ID IN (SELECT ELEMENT_ID FROM TMT_DOMAINS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 170+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(171) : domains.sql(488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Delete Tree
      BEGIN
         DELETE FROM TMT_DOMAINS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(189) : domains.sql(506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_DOMAINS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 210+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(211) : domains.sql(528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOMAINS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 229+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(230) : domains.sql(547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_DOMAINS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 250+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(251) : domains.sql(568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOMAINS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 269+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(270) : domains.sql(587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      -- Update Parent's Hierarchy Info
      If (p_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_DOMAINS
            SET CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(294) : domains.sql(611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOMAINS
            SET CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(314) : domains.sql(631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- Lock Tree
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOMAINS SET
         REC_STATUS   = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 349+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(350) : domains.sql(667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_DOMAIN', 356+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_DOMAIN(357) : domains.sql(674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 363+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(364) : domains.sql(681) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_DOMAIN', 375+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_DOMAIN(376) : domains.sql(693) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_DOMAIN;
ALTER FUNCTION SP_D_DOMAIN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_DOMAIN ==
CREATE OR REPLACE FUNCTION SP_S_DOMAIN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_DOMAIN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_DOMAIN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_DOMAIN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOMAIN', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_DOMAIN(20) : domains.sql(729) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_sql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
   h_sql := h_sql || 
                  'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_DOMAINS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 11) AS CHILD_COUNT, ';
   h_sql := h_sql || 'T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION ';
   h_sql := h_sql || 'FROM TMT_DOMAINS T ';
   
   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      h_sql := h_sql || 'WHERE T.PARENT_ID IS NULL ';
      h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      h_sql := h_sql || 'AND T.TYPE_ID <> 0 ';
      h_sql := h_sql || 'AND T.TYPE_ID <> 11 ORDER BY RANK ';
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_DOMAIN', 39+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_DOMAIN(40) : domains.sql(749) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOMAINS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOMAINS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         h_sql := h_sql || 'WHERE T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
      Else
         h_sql := h_sql || 'WHERE (T.PARENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
         h_sql := h_sql || 'OR T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''') ';
      End If;
      
      If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
         h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      End If;
      
      h_sql := h_sql || 'AND T.TYPE_ID <> 11 ORDER BY RANK ';
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOMAIN', 71+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_DOMAIN(72) : domains.sql(781) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_DOMAIN', 74+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_DOMAIN(75) : domains.sql(784) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOMAIN', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOMAIN(83) : domains.sql(792) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_DOMAIN', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_DOMAIN(95) : domains.sql(804) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_DOMAIN;
ALTER FUNCTION SP_S_DOMAIN COMPILE DEBUG;

