/****************************************************************************************/

Prompt == FUNCTION SP_I_FAC ==
CREATE OR REPLACE FUNCTION SP_I_FAC
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_current_datetime TIMESTAMP;
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_FAC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_FAC'), '-- ' || SYSTIMESTAMP, ':r := SP_I_FAC(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_FAC(30) : factors.sql(33) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_FAC', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_FAC(35) : factors.sql(38) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_FAC(38) : factors.sql(41) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(55) : factors.sql(58) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_parent_id := p_parent_id;
   
   BEGIN
      SELECT RTRIM(RANK), RTRIM(RANK), LEVEL_ID + 1, REC_STATUS
      INTO h_parent_rank, h_rank, h_level_id, h_rec_status
      FROM TMT_CRI WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(72) : factors.sql(75) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT RTRIM(PARENT_RANK), RTRIM(RANK), LEVEL_ID + 1, REC_STATUS
         INTO h_parent_rank, h_rank, h_level_id, h_rec_status
         FROM TMT_FACTORS WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'U', 'O');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(88) : factors.sql(91) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_FAC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_FAC(94) : factors.sql(97) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_parent_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_I_FAC(97) : factors.sql(100) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_parent_id, True);
      End If;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_FAC', 102+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_FAC(103) : factors.sql(106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAC', 105+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_I_FAC(106) : factors.sql(109) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_FACTORS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_FACTORS(PARENT_RANK, RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, ELEMENT_NAME, REC_USER)
         VALUES(h_parent_rank, RTRIM(h_rank) || h_rankBase64, h_parent_id, h_uniqueID, p_type_id, h_level_id, p_name, p_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(127) : factors.sql(130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_FAC', 133+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_FAC(134) : factors.sql(137) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_I_FAC(137) : factors.sql(140) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
      End If;
      
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_FACTORS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_FACTORS(PARENT_RANK, RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, ELEMENT_NAME, REC_USER)
         VALUES(h_parent_rank, '0000' || h_rankBase64, h_parent_id, h_uniqueID, p_type_id, 0, p_name, p_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 157+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(158) : factors.sql(161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_FAC', 164+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_FAC(165) : factors.sql(168) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 171+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(172) : factors.sql(175) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAC', 183+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAC(184) : factors.sql(187) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_FAC;
ALTER FUNCTION SP_I_FAC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_FAC ==
CREATE OR REPLACE FUNCTION SP_U_FAC
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_migration_cost NUMBER
   , p_priority PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_old_migration_cost NUMBER := 0.00;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FAC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FAC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FAC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_migration_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FAC(29) : factors.sql(232) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FAC', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FAC(34) : factors.sql(237) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAC', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FAC(37) : factors.sql(240) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT TYPE_ID, RANK, COALESCE(MITIGATION_COST, 0.00), REC_STATUS
      INTO h_type_id, h_rank, h_old_migration_cost, h_rec_status
      FROM TMT_FACTORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAC', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAC(54) : factors.sql(257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FAC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FAC(60) : factors.sql(263) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FAC(63) : factors.sql(266) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FAC', 68+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FAC(69) : factors.sql(272) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAC', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FAC(72) : factors.sql(275) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FACTOR Then
      BEGIN
         UPDATE TMT_FACTORS SET
         ELEMENT_NAME = p_name,
         DESCRIPTION = p_description,
         MITIGATION_COST = p_migration_cost,
         PRIORITY = p_priority,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAC', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAC(98) : factors.sql(301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI T
         SET T.MITIGATION_COST = (SELECT COALESCE(SUM(MITIGATION_COST), 0.00)
         FROM TMT_FACTORS
         WHERE PARENT_ID = T.ELEMENT_ID
         AND TYPE_ID = PMO_CNST.SC_FACTOR
         AND REC_STATUS IN ('I', 'O', 'U')),
         T.REC_DATETIME = SYSTIMESTAMP
         WHERE RANK = (SELECT RTRIM(PARENT_RANK) FROM TMT_FACTORS WHERE ELEMENT_ID = p_id );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAC', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAC(122) : factors.sql(325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_FACTORS SET
         ELEMENT_NAME = p_name,
         DESCRIPTION = p_description,
         PRIORITY = p_priority,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAC', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAC(146) : factors.sql(349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FAC', 152+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FAC(153) : factors.sql(356) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAC', 159+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAC(160) : factors.sql(363) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAC', 171+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAC(172) : factors.sql(375) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FAC;
ALTER FUNCTION SP_U_FAC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_DELETE_FAC ==
CREATE OR REPLACE FUNCTION FC_DELETE_FAC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(8000);
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_FAC PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DELETE_FAC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DELETE_FAC'), '-- ' || SYSTIMESTAMP, ':r := FC_DELETE_FAC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_FAC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DELETE_FAC(24) : factors.sql(415) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_FAC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_FAC(31) : factors.sql(422) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS FROM TMT_FACTORS WHERE PARENT_ID = ''' || h_parent_id || ''' ';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS FROM TMT_FACTORS WHERE ELEMENT_ID = ''' || h_id 
            || ''' AND PARENT_ID = ''' || h_parent_id || ''' ';
   End If;
   
   OPEN C_FAC FOR h_xsql;
   
   LOOP
      FETCH C_FAC INTO h_rank, h_rec_status;
      IF C_FAC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_FACTORS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(82) : factors.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If Coalesce(Length(h_rank), 0) = 8 Then
            BEGIN
               UPDATE TMT_FACTORS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 102+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(103) : factors.sql(494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_FACTORS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 121+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(122) : factors.sql(513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If Coalesce(Length(h_rank), 0) = 8 Then
            BEGIN
               UPDATE TMT_FACTORS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 142+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(143) : factors.sql(534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT PARENT_ID INTO h_parent_id
               FROM TMT_FACTORS
               WHERE RANK = SUBSTR(h_rank, 1, 8);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 157+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(158) : factors.sql(549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_FACTORS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(177) : factors.sql(568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --Update risk
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_CRI
            WHERE ELEMENT_ID=h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 193+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(194) : factors.sql(585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- factor type is always the first level in tmt_factors, factor can't have
         -- another factor as its child
         BEGIN
            UPDATE TMT_CRI T
            SET T.MITIGATION_COST = (SELECT COALESCE(SUM(MITIGATION_COST), 0.00)
            FROM TMT_FACTORS
            WHERE PARENT_ID = T.ELEMENT_ID
            AND TYPE_ID = PMO_CNST.SC_FACTOR
            AND REC_STATUS IN ('I', 'O', 'U')),
            T.REC_DATETIME = SYSTIMESTAMP,
            T.REC_USER = h_rec_user
            WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(T.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(T.RANK) END) = T.RANK 
            AND (T.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
            AND T.TYPE_ID = PMO_CNST.SC_RISK
            AND T.REC_STATUS IN ('I', 'O', 'U');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 223+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(224) : factors.sql(615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI T
            SET T.ESTIMATED_BUDGET = (SELECT COALESCE(SUM(MITIGATION_COST), 0.00)
            FROM TMT_FACTORS
            WHERE PARENT_ID = T.ELEMENT_ID
            AND TYPE_ID = PMO_CNST.SC_FACTOR
            AND REC_STATUS IN ('I', 'O', 'U'))
            WHERE T.ELEMENT_ID=h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 246+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(247) : factors.sql(638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_FAC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_FAC', 261+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_FAC(262) : factors.sql(653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_FAC', 268+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_FAC(269) : factors.sql(660) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DELETE_FAC;
ALTER FUNCTION FC_DELETE_FAC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_COPY_FAC ==
CREATE OR REPLACE FUNCTION FC_COPY_FAC
(
     h_source_id IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_uniqueID VARCHAR2(32);
   h_mitigation_cost NUMBER := 0.00;
   h_child_count PLS_INTEGER := 0;
   h_deleted_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   prev_level_id PLS_INTEGER;
   t_max_rank PLS_INTEGER;
-- Declare Cursors
      CURSOR C_FACTOR IS
         SELECT RTRIM(RANK)
         FROM TMT_FACTORS
         WHERE PARENT_ID = h_source_id AND LEVEL_ID = 0
         ORDER BY RANK;

      CURSOR C_FACTOR1 IS
         SELECT ELEMENT_NAME, LEVEL_ID, TYPE_ID, CHILD_COUNT, MAX_RANK,
         DELETED_COUNT, MITIGATION_COST, DESCRIPTION, RANK
         FROM TMT_FACTORS
         WHERE RANK LIKE h_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COPY_FAC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COPY_FAC'), '-- ' || SYSTIMESTAMP, ':r := FC_COPY_FAC(' || 
       '''' || h_source_id || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COPY_FAC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COPY_FAC(46) : factors.sql(716) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_source_id IS NULL) OR (h_target_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COPY_FAC', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_COPY_FAC(53) : factors.sql(723) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT RTRIM(RANK), RTRIM(PARENT_RANK) INTO h_rank, h_parent_rank
      FROM TMT_FACTORS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(68) : factors.sql(738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         SELECT RTRIM(RANK), RTRIM(PARENT_RANK) INTO h_rank, h_parent_rank
         FROM TMT_FACTORS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(84) : factors.sql(754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         OPEN C_FACTOR;
         
         LOOP
            FETCH C_FACTOR INTO h_rank;
            IF C_FACTOR%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            OPEN C_FACTOR1;
            
            LOOP
               FETCH C_FACTOR1
               INTO h_element_name, h_level_id, h_type_id, h_child_count, h_max_rank,
               h_deleted_count, h_mitigation_cost,
               h_description, h_rank;
               IF C_FACTOR1
               %FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If Coalesce(h_level_id, 0) = 0 Then
                  t_max_rank := CASE WHEN Coalesce(h_max_rank, 0) > 32767 THEN BITAND(Coalesce(
                                                                             h_max_rank, 0), 65535) - 65536 ELSE BITAND(Coalesce(
                                                                             h_max_rank, 0), 65535) END;
                  PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_FACTORS', h_max_rank);
                  PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
                  
                  BEGIN
                     SELECT RTRIM(RANK) INTO h_parent_rank
                     FROM TMT_CRI WHERE ELEMENT_ID = h_target_id;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 136+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(137) : factors.sql(807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  --strcpy(h_rank, h_rankBase64);
                  h_rank := h_rankBase64;
                  --strcpy(h_parent_id, h_target_id);
                  h_parent_id := h_target_id;
                  h_max_rank := t_max_rank;
                  prev_level_id := CASE WHEN Coalesce(h_level_id, 0) > 32767 THEN BITAND(Coalesce(
                                                                                h_level_id, 0), 65535) - 65536 ELSE BITAND(Coalesce(
                                                                                h_level_id, 0), 65535) END;
               ElsIf Coalesce(h_level_id, 0) > prev_level_id Then
                  h_rank := SubStr(SubStr(h_rankBase64, 1, Coalesce(Length(h_rankBase64), 0)), 1, 200);
                  --strcpy(h_parent_id, h_uniqueID);
                  h_parent_id := h_uniqueID;
                  prev_level_id := CASE WHEN Coalesce(h_level_id, 0) > 32767 THEN BITAND(Coalesce(
                                                                                h_level_id, 0), 65535) - 65536 ELSE BITAND(Coalesce(
                                                                                h_level_id, 0), 65535) END;
               ElsIf Coalesce(h_level_id, 0) < prev_level_id Then
                  h_rank := SubStr(SubStr(h_rankBase64, 1, Coalesce(Length(h_rankBase64), 0)), 1, 200);
                  
                  BEGIN
                     SELECT ELEMENT_ID, RANK INTO h_parent_id, h_parent_rank
                     FROM TMT_CRI
                     WHERE RANK = SUBSTR(h_rank, 1, LENGTH(h_rank) - 4);
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 169+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(170) : factors.sql(840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  prev_level_id := CASE WHEN Coalesce(h_level_id, 0) > 32767 THEN BITAND(Coalesce(
                                                                                h_level_id, 0), 65535) - 65536 ELSE BITAND(Coalesce(
                                                                                h_level_id, 0), 65535) END;
               Else
                  h_rank := SubStr(SubStr(h_rankBase64, 1, Coalesce(Length(h_rankBase64), 0)), 1, 200);
                  NULL;
               End If;
               
               h_uniqueID := SYS_GUID();
               
               BEGIN
                  INSERT INTO TMT_FACTORS(PARENT_RANK, RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, MAX_RANK,
                  ELEMENT_NAME, DELETED_COUNT, MITIGATION_COST,
                  DESCRIPTION, CHILD_COUNT, REC_USER)
                  VALUES(h_parent_rank, h_rank, h_parent_id, h_uniqueID, h_type_id, h_level_id, h_max_rank,
                  h_element_name, h_deleted_count, h_mitigation_cost,
                  h_description, h_child_count, h_rec_user);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 200+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(201) : factors.sql(871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
            
            BEGIN
               CLOSE C_FACTOR1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 214+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(215) : factors.sql(885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         
         BEGIN
            CLOSE C_FACTOR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COPY_FAC', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COPY_FAC(229) : factors.sql(899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COPY_FAC', 237+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COPY_FAC(238) : factors.sql(908) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COPY_FAC;
ALTER FUNCTION FC_COPY_FAC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_FAC ==
CREATE OR REPLACE FUNCTION SP_D_FAC
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_current_datetime TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_FAC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_FAC'), '-- ' || SYSTIMESTAMP, ':r := SP_D_FAC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_FAC(27) : factors.sql(945) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   h_rec_status := p_del_flag;
   
   If ((p_id IS NULL)) OR ((p_parent_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_FAC', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_FAC(40) : factors.sql(958) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_FAC(43) : factors.sql(961) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_FAC', 47+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_FAC(48) : factors.sql(966) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_FACTORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      IF h_rec_status = 'X' THEN 
         EXECUTE IMMEDIATE 'SELECT a.REC_STATUS FROM ' || 'TMT_FACTORS' || ' a 
         WHERE a.ELEMENT_ID = :i AND LENGTH(a.RANK) > 4 AND NOT a.REC_STATUS = '' L '' AND NOT EXISTS 
         (SELECT b.REC_STATUS 
                  FROM TMT_ORGANIZATIONS b 
                 WHERE b.REC_STATUS = '' L '' AND instr(b.RANK, a.RANK) = 1)' 
            INTO h_rec_status 
            Using h_id; 
      ELSE 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS FROM ' || 'TMT_FACTORS' || ' 
              WHERE ELEMENT_ID = :i AND REC_STATUS NOT IN (''L'',''D'') ' 
            INTO h_rec_status 
            Using h_id; 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True); 
      WHEN OTHERS THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id , True); 
   END;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_FAC', 73+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_FAC(74) : factors.sql(992) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAC', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_FAC(77) : factors.sql(995) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
   End If;
   
   -- Execute Delete Statement
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      PMO_DB2M.SC_STATE := FC_DELETE_FAC(h_id, h_parent_id, h_rec_user);
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_FAC', 87+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_FAC(88) : factors.sql(1006) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAC', 90+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_FAC(91) : factors.sql(1009) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_FACTORS
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(106) : factors.sql(1024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      If Coalesce(Length(h_rank), 0) = 8 Then
         BEGIN
            UPDATE TMT_FACTORS
            SET CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(128) : factors.sql(1046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_FACTORS
            SET CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(148) : factors.sql(1066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 161+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(162) : factors.sql(1080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Lock Tree
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_FACTORS
         SET REC_STATUS = p_del_flag/**del_flag*/,
         REC_DATETIME = h_current_datetime,
         REC_USER = p_rec_user/**rec_user:ind_d_fac->rec_user*/
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(197) : factors.sql(1115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update risk
      If Coalesce(Length(h_rank), 0) > 8 Then
         BEGIN
            SELECT PARENT_ID INTO h_parent_id
            FROM TMT_FACTORS
            WHERE RANK = SUBSTR(h_rank, 1, 8);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(214) : factors.sql(1132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID=h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 229+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(230) : factors.sql(1148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- factor type is always the first level in tmt_factors, factor can't have
      -- another factor as its child
      BEGIN
         UPDATE TMT_CRI T
         SET T.MITIGATION_COST = (SELECT SUM(MITIGATION_COST)
         FROM TMT_FACTORS
         WHERE PARENT_ID = T.ELEMENT_ID
         AND TYPE_ID = PMO_CNST.SC_FACTOR
         AND REC_STATUS IN ('I', 'O', 'U')),
         T.REC_DATETIME = SYSTIMESTAMP,
         T.REC_USER = p_rec_user/**rec_user:ind_d_fac->rec_user*/
         WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(T.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(T.RANK) END) = T.RANK 
         AND (T.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
         AND T.TYPE_ID = PMO_CNST.SC_RISK
         AND T.REC_STATUS IN ('I', 'O', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 259+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(260) : factors.sql(1178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI T
         SET T.ESTIMATED_BUDGET = (SELECT SUM(MITIGATION_COST)
         FROM TMT_FACTORS
         WHERE PARENT_ID = T.ELEMENT_ID
         AND TYPE_ID = PMO_CNST.SC_FACTOR
         AND REC_STATUS IN ('I', 'O', 'U'))
         WHERE T.ELEMENT_ID=h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 282+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(283) : factors.sql(1201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_FAC', 288+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_FAC(289) : factors.sql(1207) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 295+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(296) : factors.sql(1214) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAC', 307+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAC(308) : factors.sql(1226) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_FAC;
ALTER FUNCTION SP_D_FAC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_FAC ==
CREATE OR REPLACE FUNCTION SP_S_FAC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66674A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66674B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_FAC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_FAC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_FAC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_FAC(23) : factors.sql(1265) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_FAC', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_FAC(28) : factors.sql(1270) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FAC(31) : factors.sql(1273) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 1) Then
      OPEN C66674A FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_FACTORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.MITIGATION_COST,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_TRIGGER THEN NuLL ELSE T.PRIORITY END AS PRIORITY
      FROM TMT_FACTORS T
      WHERE (T.PARENT_ID = p_id OR T.ELEMENT_ID = p_id)
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAC', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FAC(46) : factors.sql(1288) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66674A;
   Else
      OPEN C66674B FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_FACTORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.MITIGATION_COST,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_TRIGGER THEN NuLL ELSE T.PRIORITY END AS PRIORITY
      FROM TMT_FACTORS T
      WHERE (T.PARENT_ID = p_id/*HOST(h_id)*/ OR T.ELEMENT_ID = p_id/*HOST(h_id)*/)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FAC(58) : factors.sql(1300) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66674B;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FAC', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FAC(67) : factors.sql(1309) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FAC', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FAC(79) : factors.sql(1321) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_FAC;
ALTER FUNCTION SP_S_FAC COMPILE DEBUG;

