/*****************************************************************************************/

Prompt == FUNCTION SP_I_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_I_FAV_ACT
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_FAV_ACT(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAV_ACT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_FAV_ACT(25) : favoriteactivities.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_parent_id IS NULL)) AND ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_FAV_ACT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_FAV_ACT(30) : favoriteactivities.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_FAV_ACT', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_FAV_ACT(33) : favoriteactivities.sql(36) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_project_id := p_parent_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_FAV_ACT', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_FAV_ACT(40) : favoriteactivities.sql(43) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_project_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_project_id, True); 
   END;
   
   h_resource_id := p_rec_user;
   BEGIN 
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_resource_id; 
      IF SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') THEN 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True); 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_resource_id, True); 
   END;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO FAVORITE_ACTIVITIES( ELEMENT_ID, ELEMENT_NAME, PROJECT_ID, RESOURCE_ID, REC_USER)
      VALUES( h_uniqueID, p_name, h_project_id, h_resource_id, h_resource_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAV_ACT', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAV_ACT(77) : favoriteactivities.sql(80) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_FAV_ACT', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_FAV_ACT(83) : favoriteactivities.sql(86) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAV_ACT', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAV_ACT(90) : favoriteactivities.sql(93) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_FAV_ACT', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_FAV_ACT(102) : favoriteactivities.sql(105) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_FAV_ACT;
ALTER FUNCTION SP_I_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_U_FAV_ACT
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_timecode_1_id VARCHAR2
   , p_timecode_2_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FAV_ACT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_timecode_1_id || ''''
          || ', ' || '''' || p_timecode_2_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAV_ACT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FAV_ACT(25) : favoriteactivities.sql(146) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FAV_ACT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FAV_ACT(30) : favoriteactivities.sql(151) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAV_ACT', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FAV_ACT(33) : favoriteactivities.sql(154) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --SC_CHAR(h_timecode_1_id, SC_H_ID);
   --SC_CHAR(h_timecode_1_name, SC_H_NAME);
   --SC_CHAR(h_timecode_2_id, SC_H_ID);
   --SC_CHAR(h_timecode_2_name, SC_H_NAME);
   
   h_id := p_id;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM FAVORITE_ACTIVITIES WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(54) : favoriteactivities.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FAV_ACT', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FAV_ACT(61) : favoriteactivities.sql(182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAV_ACT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FAV_ACT(64) : favoriteactivities.sql(185) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FAV_ACT', 69+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FAV_ACT(70) : favoriteactivities.sql(191) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FAV_ACT', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FAV_ACT(73) : favoriteactivities.sql(194) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   End If;
   
   /*
       if(IsNotNullSpParam(ind_u_fav_act, timecode_1_id))
       {
           InitializeHost(SC_PARAM(h_timecode_1_id), timecode_1_id, ind_u_fav_act->timecode_1_id);
   
           BEGIN_SQL
               SELECT ELEMENT_NAME INTO HOST(h_timecode_1_name)
               FROM TMT_TIMECODES WHERE ELEMENT_ID = HOST(h_timecode_1_id) AND REC_STATUS NOT IN ( 'D', 'A');
           END_SQL;
   
           if (!SC_SUCCESS){RETURN_ERROR(RECORD_NOT_FOUND, h_timecode_1_id);}
   
           if(IsNotNullSpParam(ind_u_fav_act, timecode_2_id))
           {
               InitializeHost(SC_PARAM(h_timecode_2_id), timecode_2_id, ind_u_fav_act->timecode_2_id);
   
               BEGIN_SQL
                   SELECT ELEMENT_NAME INTO HOST(h_timecode_2_name)
                   FROM TMT_TIMECODES WHERE ELEMENT_ID = HOST(h_timecode_2_id) AND REC_STATUS NOT IN ( 'D', 'A');
               END_SQL;
   
               if (!SC_SUCCESS){RETURN_ERROR(RECORD_NOT_FOUND, h_timecode_2_id);}
           }
   
           BEGIN_SQL
               UPDATE FAVORITE_ACTIVITIES SET
                   ELEMENT_NAME = :*name:ind_u_fav_act->name,
                   TIMECODE_1_ID = :*timecode_1_id:ind_u_fav_act->timecode_1_id,
                   TIMECODE_2_ID = :*timecode_2_id:ind_u_fav_act->timecode_2_id,
                   REC_USER = :*rec_user:ind_u_fav_act->rec_user,
                   REC_STATUS = 'U'
               WHERE ELEMENT_ID = HOST(h_id);
           END_SQL;
   
       }
       else
       {
           RETURN_INVALID(ELEMENT_ID_REQUIRED);
       }
       */
   
   BEGIN
      UPDATE FAVORITE_ACTIVITIES SET
      ELEMENT_NAME = p_name,
      TIMECODE_1_ID = p_timecode_1_id,
      TIMECODE_2_ID = p_timecode_2_id,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(137) : favoriteactivities.sql(258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FAV_ACT', 142+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FAV_ACT(143) : favoriteactivities.sql(264) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 149+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(150) : favoriteactivities.sql(271) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FAV_ACT', 161+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FAV_ACT(162) : favoriteactivities.sql(283) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FAV_ACT;
ALTER FUNCTION SP_U_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_D_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_D_FAV_ACT
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_FAV_ACT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAV_ACT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_FAV_ACT(22) : favoriteactivities.sql(321) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_FAV_ACT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_FAV_ACT(27) : favoriteactivities.sql(326) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_FAV_ACT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_FAV_ACT(30) : favoriteactivities.sql(329) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      BEGIN
         DELETE FROM FAVORITE_ACTIVITIES WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 49+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(50) : favoriteactivities.sql(349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --should never come into here.
      BEGIN
         UPDATE FAVORITE_ACTIVITIES SET
         REC_STATUS = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(72) : favoriteactivities.sql(371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_FAV_ACT', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_FAV_ACT(79) : favoriteactivities.sql(378) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(86) : favoriteactivities.sql(385) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_FAV_ACT', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_FAV_ACT(98) : favoriteactivities.sql(397) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_FAV_ACT;
ALTER FUNCTION SP_D_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_S_FAV_ACT ==
CREATE OR REPLACE FUNCTION SP_S_FAV_ACT
(
     p_project_id VARCHAR2
   , p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66674C PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_FAV_ACT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_FAV_ACT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_FAV_ACT(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAV_ACT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_FAV_ACT(22) : favoriteactivities.sql(435) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_project_id IS NULL)) AND ((p_resource_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_FAV_ACT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_FAV_ACT(27) : favoriteactivities.sql(440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAV_ACT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FAV_ACT(30) : favoriteactivities.sql(443) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --SC_CHAR(h_project_id, SC_H_ID);
   --SC_CHAR(h_resource_id, SC_H_ID);
   --InitializeHost(SC_PARAM(h_project_id), project_id, ind_s_fav_act->project_id);
   --InitializeHost(SC_PARAM(h_resource_id), resource_id, ind_s_fav_act->resource_id);
   
   /**HALEH*/
   /*BEGIN_SQL
           OPEN C66674C;
       END_SQL;*/
   /**HALEH*/
   
   OPEN C66674C FOR SELECT FA.ELEMENT_ID, 212 AS TYPE_ID, FA.ELEMENT_NAME, FA.RESOURCE_ID, RSC.FULL_NAME, FA.PROJECT_ID, FA.TIMECODE_1_ID, TC1.ELEMENT_NAME AS TIMECODE_1_NAME, FA.TIMECODE_2_ID,
   TC2.ELEMENT_NAME AS TIMECODE_2_NAME, FA.REC_USER, FA.REC_STATUS, FA.REC_DATETIME
   FROM FAVORITE_ACTIVITIES FA LEFT JOIN TMT_TIMECODES TC1 ON TC1.ELEMENT_ID = FA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TC2 ON TC2.ELEMENT_ID = FA.TIMECODE_2_ID
   LEFT JOIN RESOURCES RSC ON RSC.RESOURCE_ID = FA.RESOURCE_ID
   WHERE FA.PROJECT_ID = p_project_id
   AND FA.RESOURCE_ID = p_resource_id
   ORDER BY FA.REC_DATETIME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FAV_ACT', 54+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_FAV_ACT(55) : favoriteactivities.sql(468) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66674C;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FAV_ACT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FAV_ACT(64) : favoriteactivities.sql(477) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FAV_ACT', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FAV_ACT(76) : favoriteactivities.sql(489) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_FAV_ACT;
ALTER FUNCTION SP_S_FAV_ACT COMPILE DEBUG;

/*****************************************************************************************/

