/****************************************************************************************/

Prompt == FUNCTION SP_I_GEO ==
CREATE OR REPLACE FUNCTION SP_I_GEO
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_I_GEO(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_GEO', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_GEO(27) : geographies.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_uniqueID := SYS_GUID();
   
   If (p_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_GEOGRAPHIES', h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_GEOGRAPHIES(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_GEOGRAPHIES WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_GEO', 51+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_GEO(52) : geographies.sql(55) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_GEO', 58+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_GEO(59) : geographies.sql(62) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GEOGRAPHIES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_GEOGRAPHIES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_GEOGRAPHIES', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_GEOGRAPHIES(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_GEOGRAPHIES WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_GEO', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_GEO(87) : geographies.sql(90) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_GEO', 93+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_GEO(94) : geographies.sql(97) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_GEO', 100+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_GEO(101) : geographies.sql(104) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_GEO', 112+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_GEO(113) : geographies.sql(116) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_GEO;
ALTER FUNCTION SP_I_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_GEO ==
CREATE OR REPLACE FUNCTION SP_U_GEO
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_U_GEO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_GEO', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_GEO(24) : geographies.sql(156) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_GEO', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_GEO(29) : geographies.sql(161) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_GEO', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_GEO(32) : geographies.sql(164) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_GEO', 40+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_GEO(41) : geographies.sql(173) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GEOGRAPHIES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_GEOGRAPHIES' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_GEOGRAPHIES SET
      ELEMENT_NAME = p_name,
      DESCRIPTION  = p_description,
      REC_STATUS   = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_GEO', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_GEO(70) : geographies.sql(202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_GEOGRAPHIES WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_GEOGRAPHIES WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_GEO', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_GEO(88) : geographies.sql(220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_GEO', 94+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_GEO(95) : geographies.sql(227) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_GEO', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_GEO(102) : geographies.sql(234) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_GEO', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_GEO(114) : geographies.sql(246) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_GEO;
ALTER FUNCTION SP_U_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_GEO ==
CREATE OR REPLACE FUNCTION SP_D_GEO
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC1 IS
         SELECT ELEMENT_ID FROM TMT_GEOGRAPHIES
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND DEFAULT_FLAG = 'Y';

      CURSOR CC2 IS
         SELECT ELEMENT_ID FROM TMT_GEOGRAPHIES
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND TYPE_ID = PMO_CNST.SC_RESOURCE;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_D_GEO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_GEO(36) : geographies.sql(298) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_rec_status := p_del_flag;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_GEO', 43+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_GEO(44) : geographies.sql(306) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GEOGRAPHIES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      IF h_rec_status = 'X' THEN 
         EXECUTE IMMEDIATE 'SELECT a.REC_STATUS FROM ' || 'TMT_GEOGRAPHIES' || ' a 
         WHERE a.ELEMENT_ID = :i AND LENGTH(a.RANK) > 4 AND NOT a.REC_STATUS = '' L '' AND NOT EXISTS 
         (SELECT b.REC_STATUS 
                  FROM TMT_ORGANIZATIONS b 
                 WHERE b.REC_STATUS = '' L '' AND instr(b.RANK, a.RANK) = 1)' 
            INTO h_rec_status 
            Using h_id; 
      ELSE 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS FROM ' || 'TMT_GEOGRAPHIES' || ' 
              WHERE ELEMENT_ID = :i AND REC_STATUS NOT IN (''L'',''D'') ' 
            INTO h_rec_status 
            Using h_id; 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True); 
      WHEN OTHERS THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id , True); 
   END;
   
   If ((p_parent_id IS NULL)) Then
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_GEOGRAPHIES WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(77) : geographies.sql(339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_GEO', 85+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_GEO(86) : geographies.sql(348) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GEOGRAPHIES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_GEOGRAPHIES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_GEO', 98+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_GEO(99) : geographies.sql(361) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 101+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_GEO(102) : geographies.sql(364) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_GEOGRAPHIES WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(115) : geographies.sql(377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN CC1;
   
   FETCH CC1 INTO h_exists;
   IF CC1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_default_count := 1;
   Else
      h_default_count := 0;
   End If;
   
   BEGIN
      CLOSE CC1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(144) : geographies.sql(406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CC2;
   
   FETCH CC2 INTO h_exists;
   IF CC2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   
   BEGIN
      CLOSE CC2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 171+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(172) : geographies.sql(434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      If (Coalesce(h_default_count, 0) <> 0) OR (Coalesce(h_dependency_count, 0) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_GEO', 179+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_GEO(180) : geographies.sql(442) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 182+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_GEO(183) : geographies.sql(445) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE_RECORD, p_id, True);
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_GEO', 187+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_GEO(188) : geographies.sql(450) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 190+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_GEO(191) : geographies.sql(453) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
      End If;
   End If;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      If Coalesce(h_default_count, 0) = 0 Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            DELETE FROM TMT_GEOGRAPHIES WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 223+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(224) : geographies.sql(486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_rec_status, 1, 1) = 'D' Then
            If (p_parent_id IS NULL) Then
               BEGIN
                  UPDATE TMT_GEOGRAPHIES SET DELETED_COUNT = DELETED_COUNT - 1
                  WHERE ELEMENT_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 243+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(244) : geographies.sql(506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_GEOGRAPHIES SET DELETED_COUNT = DELETED_COUNT - 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 261+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(262) : geographies.sql(524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If (p_parent_id IS NULL) Then
               BEGIN
                  UPDATE TMT_GEOGRAPHIES SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 281+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(282) : geographies.sql(544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_GEOGRAPHIES SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 299+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(300) : geographies.sql(562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_GEO', 307+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_GEO(308) : geographies.sql(570) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 310+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_GEO(311) : geographies.sql(573) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id, True);
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_GEO', 317+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_GEO(318) : geographies.sql(580) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 320+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_GEO(321) : geographies.sql(583) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      If Coalesce(h_default_count, 0) = 0 Then
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_GEOGRAPHIES SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 340+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(341) : geographies.sql(603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_GEOGRAPHIES SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 358+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(359) : geographies.sql(621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_GEOGRAPHIES SET
            REC_STATUS   = p_del_flag,
            REC_DATETIME = SYSTIMESTAMP,/*HOST(h_current_datetime),*/
            REC_USER     = p_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 393+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(394) : geographies.sql(656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_GEO', 399+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_GEO(400) : geographies.sql(662) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_GEO', 402+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_GEO(403) : geographies.sql(665) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id, True);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_GEO', 409+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_GEO(410) : geographies.sql(672) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 416+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(417) : geographies.sql(679) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_GEO', 428+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_GEO(429) : geographies.sql(691) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_GEO;
ALTER FUNCTION SP_D_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_GEO ==
CREATE OR REPLACE FUNCTION SP_S_GEO
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_default_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(8000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_S_GEO(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_GEO', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_GEO(22) : geographies.sql(729) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_sql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
   h_sql := h_sql || 
                  '(SELECT COUNT(C.ELEMENT_ID) FROM TMT_GEOGRAPHIES C WHERE C.PARENT_ID = T.ELEMENT_ID AND C.TYPE_ID NOT IN (13, 228)) AS CHILD_COUNT, ';
   h_sql := h_sql || 'T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, ';
   h_sql := h_sql || ''''' AS CREATED_BY, '''' AS CREATED_BY_NAME, ';
   h_sql := h_sql || ''''' AS CREATED_DATETIME, 0 AS PROFICIENCY_LEVEL_ID, 0 AS PREFERENCE_LEVEL_ID, ';
   h_sql := h_sql || 
                  '0.00 AS REGULAR_COST, 0.00 AS REGULAR_SALE, 0.00 AS SPECIAL_COST, 0.00 AS SPECIAL_SALE,';
   h_sql := h_sql || '0 AS EXPERIENCE_ID, '''' AS LAST_USED_DATETIME, '''' AS LAST_USED_LOCATION, ';
   h_sql := h_sql || 'T.DEFAULT_FLAG, '''' AS FS_CODE ';
   h_sql := h_sql || 'FROM TMT_GEOGRAPHIES T ';
   
   If ((p_id IS NULL)) Then
      h_sql := h_sql || 'WHERE T.PARENT_ID IS NULL ';
      h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      h_sql := h_sql || 'AND T.TYPE_ID NOT IN (0, 13, 228) ORDER BY RANK ';
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_GEO', 45+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_GEO(46) : geographies.sql(753) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GEOGRAPHIES' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_GEOGRAPHIES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         h_sql := h_sql || 'WHERE T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
      Else
         h_sql := h_sql || 'WHERE (T.PARENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' ';
         h_sql := h_sql || 'OR T.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''') ';
      End If;
      
      If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
         h_sql := h_sql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      End If;
      
      h_sql := h_sql || 'AND T.TYPE_ID NOT IN (13, 288) ORDER BY RANK ';
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_GEO', 77+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_GEO(78) : geographies.sql(785) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_GEO', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_GEO(81) : geographies.sql(788) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_GEO', 87+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_GEO(88) : geographies.sql(795) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_GEO', 99+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_GEO(100) : geographies.sql(807) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_GEO;
ALTER FUNCTION SP_S_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_RES_GEO ==
CREATE OR REPLACE FUNCTION SP_A_RES_GEO
(
     p_id VARCHAR2
   , p_geo_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_geo_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_RES_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_RES_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_A_RES_GEO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_geo_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_RES_GEO', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_RES_GEO(26) : geographies.sql(849) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_geo_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_RES_GEO', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_RES_GEO(31) : geographies.sql(854) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_RES_GEO', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_RES_GEO(34) : geographies.sql(857) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_id;
   h_geo_id := p_geo_id;
   h_rec_user := p_rec_user;
   
   -- the geo already assigned to the resource
   BEGIN
      SELECT ELEMENT_ID INTO h_id
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_resource_id AND PARENT_ID = h_geo_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(56) : geographies.sql(879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_RES_GEO', 61+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_RES_GEO(62) : geographies.sql(885) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_RES_GEO', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_RES_GEO(65) : geographies.sql(888) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, True);
   End If;
   
   -- there is another geo already assigned to the resource
   BEGIN
      SELECT PARENT_ID INTO h_id
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(81) : geographies.sql(904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         DELETE FROM TMT_GEOGRAPHIES
         WHERE ELEMENT_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(100) : geographies.sql(923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_GEOGRAPHIES
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(120) : geographies.sql(943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_GEOGRAPHIES', h_geo_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_GEOGRAPHIES(RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
      SELECT RTRIM(Rank) || h_rankBase64, h_geo_id, h_resource_id,
      PMO_CNST.SC_RESOURCE, LEVEL_ID + 1, h_rec_user
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_geo_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(146) : geographies.sql(969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_RES_GEO', 151+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_RES_GEO(152) : geographies.sql(975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 158+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(159) : geographies.sql(982) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_GEO', 170+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_GEO(171) : geographies.sql(994) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_RES_GEO;
ALTER FUNCTION SP_A_RES_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_RES_GEO ==
CREATE OR REPLACE FUNCTION SP_UA_RES_GEO
(
     p_id VARCHAR2
   , p_geo_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_geo_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_RES_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_RES_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_RES_GEO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_geo_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_RES_GEO', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_RES_GEO(22) : geographies.sql(1032) : ' || SYSTIMESTAMP);
   END IF; 

   h_resource_id := p_id;
   h_geo_id := p_geo_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      DELETE FROM TMT_GEOGRAPHIES
      WHERE PARENT_ID = h_geo_id AND ELEMENT_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_RES_GEO', 41+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_RES_GEO(42) : geographies.sql(1052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE TMT_GEOGRAPHIES
         SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_geo_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_RES_GEO', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_RES_GEO(62) : geographies.sql(1072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_RES_GEO', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_RES_GEO(69) : geographies.sql(1079) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_RES_GEO', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_RES_GEO(76) : geographies.sql(1086) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_RES_GEO', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_RES_GEO(88) : geographies.sql(1098) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_RES_GEO;
ALTER FUNCTION SP_UA_RES_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_RES_A_GEO ==
CREATE OR REPLACE FUNCTION SP_S_RES_A_GEO
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66671B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RES_A_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RES_A_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RES_A_GEO(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_A_GEO', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RES_A_GEO(29) : geographies.sql(1143) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_RES_A_GEO', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_RES_A_GEO(34) : geographies.sql(1148) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_A_GEO', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_A_GEO(37) : geographies.sql(1151) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_A_GEO', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_A_GEO(56) : geographies.sql(1170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_bitflag, 0) = 2 Then
      OPEN C66671A FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.PARENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_GEOGRAPHIES T1
      WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
      AND T1.TYPE_ID NOT IN (0, 13)
      AND T1.REC_STATUS IN ('I', 'U', 'O')
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_A_GEO', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_A_GEO(72) : geographies.sql(1186) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66671A;
   Else
      OPEN C66671B FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.PARENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_GEOGRAPHIES T1
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_id)
      AND T1.TYPE_ID < 5000
      AND T1.TYPE_ID <> 0
      AND T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_A_GEO', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_A_GEO(87) : geographies.sql(1201) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66671B;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_A_GEO', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_A_GEO(96) : geographies.sql(1210) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_A_GEO', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_A_GEO(108) : geographies.sql(1222) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RES_A_GEO;
ALTER FUNCTION SP_S_RES_A_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_GEO ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_GEO
(
     p_id VARCHAR2
   , p_geo_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_geo_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_GEO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_geo_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_GEO', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_GEO(26) : geographies.sql(1264) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_geo_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_GEO', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_GEO(31) : geographies.sql(1269) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_GEO', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_GEO(34) : geographies.sql(1272) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_id;
   h_geo_id := p_geo_id;
   h_rec_user := p_rec_user;
   
   -- the geo already assigned to the resource
   BEGIN
      SELECT ELEMENT_ID INTO h_id
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_resource_id AND PARENT_ID = h_geo_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(56) : geographies.sql(1294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_ASSET_GEO', 61+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_ASSET_GEO(62) : geographies.sql(1300) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_GEO', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_GEO(65) : geographies.sql(1303) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, True);
   End If;
   
   -- there is another geo already assigned to the resource
   BEGIN
      SELECT PARENT_ID INTO h_id
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(81) : geographies.sql(1319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         DELETE FROM TMT_GEOGRAPHIES
         WHERE ELEMENT_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(100) : geographies.sql(1338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_GEOGRAPHIES
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(120) : geographies.sql(1358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_GEOGRAPHIES', h_geo_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_GEOGRAPHIES(RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
      SELECT RTRIM(Rank) || h_rankBase64, h_geo_id, h_resource_id,
      PMO_CNST.SC_ASSETS, LEVEL_ID + 1, h_rec_user
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_geo_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(146) : geographies.sql(1384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_GEO', 151+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_GEO(152) : geographies.sql(1390) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 158+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(159) : geographies.sql(1397) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_GEO', 170+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_GEO(171) : geographies.sql(1409) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_GEO;
ALTER FUNCTION SP_A_ASSET_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_GEO ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_GEO
(
     p_id VARCHAR2
   , p_geo_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_geo_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_GEO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_geo_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_GEO', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_GEO(22) : geographies.sql(1447) : ' || SYSTIMESTAMP);
   END IF; 

   h_resource_id := p_id;
   h_geo_id := p_geo_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      DELETE FROM TMT_GEOGRAPHIES
      WHERE PARENT_ID = h_geo_id AND ELEMENT_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_GEO', 41+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_GEO(42) : geographies.sql(1467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE TMT_GEOGRAPHIES
         SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_geo_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_GEO', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_GEO(62) : geographies.sql(1487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_GEO', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_GEO(69) : geographies.sql(1494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_GEO', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_GEO(76) : geographies.sql(1501) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_GEO', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_GEO(88) : geographies.sql(1513) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_GEO;
ALTER FUNCTION SP_UA_ASSET_GEO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_GEO ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_GEO
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671AA PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66671BA PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_GEO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_GEO'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_GEO(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_GEO', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_GEO(29) : geographies.sql(1558) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_GEO', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_GEO(34) : geographies.sql(1563) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_GEO', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_GEO(37) : geographies.sql(1566) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_GEO', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_GEO(56) : geographies.sql(1585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_bitflag, 0) = 2 Then
      OPEN C66671AA FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.PARENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_GEOGRAPHIES T1
      WHERE (SUBSTR(h_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
      AND T1.TYPE_ID NOT IN (0, 13)
      AND T1.REC_STATUS IN ('I', 'U', 'O')
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_GEO', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_GEO(72) : geographies.sql(1601) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66671AA;
   Else
      OPEN C66671BA FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.PARENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_GEOGRAPHIES T1
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_GEOGRAPHIES
      WHERE ELEMENT_ID = h_id)
      AND T1.TYPE_ID < 5000
      AND T1.TYPE_ID <> 0
      AND T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_GEO', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_GEO(87) : geographies.sql(1616) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66671BA;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_GEO', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_GEO(96) : geographies.sql(1625) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_GEO', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_GEO(108) : geographies.sql(1637) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_GEO;
ALTER FUNCTION SP_S_ASSET_A_GEO COMPILE DEBUG;

