/****************************************************************************************/

Prompt == FUNCTION SP_I_NAB ==
CREATE OR REPLACE FUNCTION SP_I_NAB
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_NAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_NAB'), '-- ' || SYSTIMESTAMP, ':r := SP_I_NAB(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_NAB', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_NAB(27) : nab.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_uniqueID := SYS_GUID();
   
   If (p_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_NAB', h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_NAB(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID,p_name , p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_NAB WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_NAB', 51+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_NAB(52) : nab.sql(55) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_NAB', 58+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_NAB(59) : nab.sql(62) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_NAB' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_NAB' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_NAB', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_NAB(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name , p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_NAB WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_NAB', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_NAB(87) : nab.sql(90) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_NAB', 93+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_NAB(94) : nab.sql(97) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_NAB', 100+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_NAB(101) : nab.sql(104) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_NAB', 112+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_NAB(113) : nab.sql(116) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_NAB;
ALTER FUNCTION SP_I_NAB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_NAB ==
CREATE OR REPLACE FUNCTION SP_U_NAB
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_host_name VARCHAR2
   , p_port PLS_INTEGER
   , p_channel VARCHAR2
   , p_flag VARCHAR2
   , p_admin_name VARCHAR2
   , p_admin_phone VARCHAR2
   , p_admin_e_mail VARCHAR2
   , p_description VARCHAR2
   , p_reserved VARCHAR2
   , p_web_server_path VARCHAR2
   , p_user_notes VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_NAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_NAB'), '-- ' || SYSTIMESTAMP, ':r := SP_U_NAB(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_host_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_port), 'NULL')
          || ', ' || '''' || p_channel || ''''
          || ', ' || '''' || p_flag || ''''
          || ', ' || '''' || p_admin_name || ''''
          || ', ' || '''' || p_admin_phone || ''''
          || ', ' || '''' || p_admin_e_mail || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_reserved || ''''
          || ', ' || '''' || p_web_server_path || ''''
          || ', ' || '''' || p_user_notes || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NAB', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_NAB(43) : nab.sql(175) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_NAB', 47+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_NAB(48) : nab.sql(180) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NAB', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_NAB(51) : nab.sql(183) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   --SC_LONG(h_update);
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_NAB', 60+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_NAB(61) : nab.sql(193) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_NAB' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_NAB' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_NAB SET
      ELEMENT_NAME = p_name,
      HOST_NAME = p_host_name,
      PORT = p_port,
      CHANNEL = p_channel,
      FLAG = p_flag,
      ADMIN_NAME = p_admin_name,
      ADMIN_PHONE = p_admin_phone,
      ADMIN_E_MAIL = p_admin_e_mail,
      DESCRIPTION = p_description,
      RESERVED = p_reserved,
      WEB_SERVER_PATH = p_web_server_path,
      USER_NOTES = p_user_notes,
      REC_USER = p_rec_user,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NAB', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NAB(100) : nab.sql(232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(p_flag, 1, 1) = '1' Then
      BEGIN
         UPDATE TMT_NAB SET
         FLAG = '0'
         WHERE ELEMENT_ID <> p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NAB', 119+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NAB(120) : nab.sql(252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_NAB', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_NAB(130) : nab.sql(262) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NAB', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NAB(137) : nab.sql(269) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NAB', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NAB(149) : nab.sql(281) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_NAB;
ALTER FUNCTION SP_U_NAB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_NAB ==
CREATE OR REPLACE FUNCTION SP_D_NAB
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_NAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_NAB'), '-- ' || SYSTIMESTAMP, ':r := SP_D_NAB(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NAB', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_NAB(24) : nab.sql(321) : ' || SYSTIMESTAMP);
   END IF; 

   --SC_LONG(h_default_count);
   
   --InitializeHost(SC_PARAM(h_id), id, ind_d_nab->id);
   h_rec_status := p_del_flag;
   
   If ((p_parent_id IS NULL)) Then
      BEGIN
         SELECT RANK, REC_STATUS INTO h_rank, h_rec_status
         FROM TMT_NAB WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 41+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(42) : nab.sql(339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --strcpy(h_rec_status, "");
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_NAB', 51+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_NAB(52) : nab.sql(349) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_NAB' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_NAB' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_NAB', 64+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_NAB(65) : nab.sql(362) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NAB', 67+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_NAB(68) : nab.sql(365) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      BEGIN
         SELECT RANK, REC_STATUS INTO h_rank, h_rec_status
         FROM TMT_NAB WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(82) : nab.sql(379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(p_del_flag, 1, 1) = '?' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_NAB', 89+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_NAB(90) : nab.sql(387) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NAB', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_NAB(93) : nab.sql(390) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
   End If;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_NAB WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(124) : nab.sql(421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         --MCR_UPDATE_TMT_NAB(DELETED_COUNT);
         /****HERVE ******/
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_NAB SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 145+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(146) : nab.sql(443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_NAB SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 163+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(164) : nab.sql(461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         --MCR_UPDATE_TMT_NAB(CHILD_COUNT);
         /*****HERVE ******/
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_NAB SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 185+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(186) : nab.sql(483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_NAB SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 203+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(204) : nab.sql(501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_NAB', 212+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_NAB(213) : nab.sql(510) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NAB', 215+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_NAB(216) : nab.sql(513) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      If (p_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_NAB SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 234+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(235) : nab.sql(532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_NAB SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 252+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(253) : nab.sql(550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_NAB SET
         REC_STATUS   = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 287+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(288) : nab.sql(585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_NAB', 294+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_NAB(295) : nab.sql(592) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 301+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(302) : nab.sql(599) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NAB', 313+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NAB(314) : nab.sql(611) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_NAB;
ALTER FUNCTION SP_D_NAB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_NAB ==
CREATE OR REPLACE FUNCTION SP_S_NAB
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_NAB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_NAB'), '-- ' || SYSTIMESTAMP, ':r := SP_S_NAB(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_NAB', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_NAB(25) : nab.sql(652) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_default_id, SC_H_ID);
   --SC_CHAR(h_rank, SC_H_FULL_RANK);
   --PmoString h_sql(SC_H_X_LONG_DESC);
   
   If ((p_id IS NULL)) Then
      OPEN C6667A FOR SELECT
      T.ELEMENT_ID, T.TYPE_ID, T.ELEMENT_NAME, T.PARENT_ID,
      T.REC_STATUS, HOST_NAME, PORT, CHANNEL, FLAG, ADMIN_NAME, ADMIN_PHONE, ADMIN_E_MAIL, DESCRIPTION, RESERVED,
      T.WEB_SERVER_PATH, T.USER_NOTES
      FROM TMT_NAB T
      WHERE T.PARENT_ID IS NuLL
      AND T.ELEMENT_ID IS NOT NuLL
      AND T.REC_STATUS <> 'D'
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_NAB', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_NAB(44) : nab.sql(671) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667A;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_NAB', 49+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_NAB(50) : nab.sql(677) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_NAB' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_NAB' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      OPEN C6667B FOR SELECT
      T.ELEMENT_ID, T.TYPE_ID, T.ELEMENT_NAME, T.PARENT_ID,
      T.REC_STATUS, HOST_NAME, PORT, CHANNEL, FLAG, ADMIN_NAME, ADMIN_PHONE, ADMIN_E_MAIL, DESCRIPTION, RESERVED,
      T.WEB_SERVER_PATH, T.USER_NOTES
      FROM TMT_NAB T
      WHERE T.PARENT_ID = h_id
      AND T.REC_STATUS <> 'D'
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_NAB', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_NAB(70) : nab.sql(697) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667B;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_NAB', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_NAB(78) : nab.sql(705) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_NAB', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_NAB(90) : nab.sql(717) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_NAB;
ALTER FUNCTION SP_S_NAB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_XML_MONITOR ==
CREATE OR REPLACE FUNCTION SP_S_XML_MONITOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667Z PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_XML_MONITOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_XML_MONITOR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_XML_MONITOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_XML_MONITOR', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_XML_MONITOR(20) : nab.sql(753) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C6667Z FOR SELECT
   FXM.MESSAGE_ID AS ELEMENT_ID,
   FXM.MSG_TYPE AS TYPE_ID,
   TW.ELEMENT_NAME,
   TW.FS_CODE,
   FXM.STATE,
   R.FULL_NAME AS PROJECT_MANAGER,
   R.WORK_PHONE AS CONTACT_NUMBER,
   FXM.DESTINATION_QUEUE,
   FXM.ELEMENT_ID AS WBS_ID,
   FXM.PROJECT_ID,
   '(' || PRJ.FS_CODE || ') ' || PRJ.ELEMENT_NAME AS PROJECT_NAME,
   FXM.REC_DATETIME
   FROM FS_XML_MONITOR FXM
   LEFT OUTER JOIN TMT_WBS TW ON TW.ELEMENT_ID = FXM.ELEMENT_ID
   LEFT OUTER JOIN TMT_WBS PRJ ON PRJ.ELEMENT_ID = TW.PROJECT_ID
   LEFT OUTER JOIN PROJECT_ASSIGNMENTS RA ON RA.PROJECT_ID = PRJ.ELEMENT_ID AND BITAND(RA.PARTICIPANT, 1) = 1
   LEFT OUTER JOIN RESOURCES R ON R.RESOURCE_ID = RA.RESOURCE_ID
   ORDER BY FXM.REC_DATETIME, PRJ.ELEMENT_NAME DESC;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_XML_MONITOR', 42+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_XML_MONITOR(43) : nab.sql(776) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C6667Z;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_XML_MONITOR', 50+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_XML_MONITOR(51) : nab.sql(784) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_XML_MONITOR', 62+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_XML_MONITOR(63) : nab.sql(796) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_XML_MONITOR;
ALTER FUNCTION SP_S_XML_MONITOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_FS_SEND ==
CREATE OR REPLACE FUNCTION SP_FS_SEND
(
     p_msg_id PLS_INTEGER
   , p_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FS_SEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FS_SEND'), '-- ' || SYSTIMESTAMP, ':r := SP_FS_SEND(' || 
       COALESCE(TO_CHAR(p_msg_id), 'NULL')
          || ', ' || '''' || p_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FS_SEND', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FS_SEND(20) : nab.sql(832) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_msg_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_FS_SEND', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_FS_SEND(25) : nab.sql(837) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FS_SEND', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_FS_SEND(28) : nab.sql(840) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_id
      FROM PENDING_MONITOR
      WHERE ELEMENT_ID = TO_CHAR(p_msg_id);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FS_SEND', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FS_SEND(43) : nab.sql(855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO PENDING_MONITOR( ELEMENT_ID, SOURCE )
         VALUES( TO_CHAR(p_msg_id), p_flag);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FS_SEND', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FS_SEND(62) : nab.sql(874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE PENDING_MONITOR
         SET SOURCE = p_flag
         WHERE ELEMENT_ID = TO_CHAR(p_msg_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FS_SEND', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FS_SEND(81) : nab.sql(893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_FS_SEND', 87+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_FS_SEND(88) : nab.sql(900) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(TO_CHAR(p_msg_id), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_msg_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FS_SEND', 94+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FS_SEND(95) : nab.sql(907) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FS_SEND', 106+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FS_SEND(107) : nab.sql(919) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FS_SEND;
ALTER FUNCTION SP_FS_SEND COMPILE DEBUG;

