/*###########################################*/

Prompt == FUNCTION SP_U_EXPERIENCE ==
CREATE OR REPLACE FUNCTION SP_U_EXPERIENCE
(
     p_resource_id VARCHAR2
   , p_experience VARCHAR2
   , p_achivements VARCHAR2
   , p_passions VARCHAR2
   , p_summarySkills VARCHAR2
   , p_miscellaneous VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EXPERIENCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EXPERIENCE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EXPERIENCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_experience || ''''
          || ', ' || '''' || p_achivements || ''''
          || ', ' || '''' || p_passions || ''''
          || ', ' || '''' || p_summarySkills || ''''
          || ', ' || '''' || p_miscellaneous || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXPERIENCE', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EXPERIENCE(28) : res_back.sql(31) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 41+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(42) : res_back.sql(45) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXPERIENCE', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXPERIENCE(49) : res_back.sql(52) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXPERIENCE', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXPERIENCE(52) : res_back.sql(55) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXPERIENCE', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXPERIENCE(57) : res_back.sql(60) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXPERIENCE', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXPERIENCE(60) : res_back.sql(63) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE RESOURCES
         SET EXPERIENCE_TXT =p_experience,
         ACHIVEMENTS   =p_achivements,
         PASSIONS =p_passions,
         SUMMARY_SKILLS=p_summarySkills,
         MISCELLANEOUS =p_miscellaneous
         WHERE RESOURCE_ID =p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(82) : res_back.sql(85) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EXPERIENCE', 88+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EXPERIENCE(89) : res_back.sql(92) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 95+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(96) : res_back.sql(99) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXPERIENCE', 107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXPERIENCE(108) : res_back.sql(111) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EXPERIENCE;
ALTER FUNCTION SP_U_EXPERIENCE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_I_BGINDUSTRYEXP
(
     p_name VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_I_BGINDUSTRYEXP(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BGINDUSTRYEXP', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_BGINDUSTRYEXP(23) : res_back.sql(150) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(37) : res_back.sql(164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_BGINDUSTRYEXP', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_BGINDUSTRYEXP(44) : res_back.sql(171) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BGINDUSTRYEXP', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_BGINDUSTRYEXP(47) : res_back.sql(174) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_BGINDUSTRYEXP', 51+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_BGINDUSTRYEXP(52) : res_back.sql(179) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BGINDUSTRYEXP', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_BGINDUSTRYEXP(55) : res_back.sql(182) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_INDUSTRY_EXPERIENCE(EXPERIENCE_ID, RESOURCE_ID, CLASSIFICATION)
         VALUES(h_uniqueID, p_resource_id,    p_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(76) : res_back.sql(203) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_BGINDUSTRYEXP', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_BGINDUSTRYEXP(83) : res_back.sql(210) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(90) : res_back.sql(217) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BGINDUSTRYEXP', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BGINDUSTRYEXP(102) : res_back.sql(229) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_BGINDUSTRYEXP;
ALTER FUNCTION SP_I_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_U_BGINDUSTRYEXP
(
     p_id VARCHAR2
   , p_classif_id VARCHAR2
   , p_industry PLS_INTEGER
   , p_proflevel PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_BGINDUSTRYEXP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_classif_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_industry), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_proflevel), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BGINDUSTRYEXP', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_BGINDUSTRYEXP(23) : res_back.sql(268) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE RESOURCE_INDUSTRY_EXPERIENCE SET
      CLASSIFICATION = p_classif_id,
      INDUSTRY_ID = p_industry,
      PROF_LEVEL = p_proflevel
      WHERE EXPERIENCE_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BGINDUSTRYEXP', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BGINDUSTRYEXP(43) : res_back.sql(288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_BGINDUSTRYEXP', 48+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_BGINDUSTRYEXP(49) : res_back.sql(294) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BGINDUSTRYEXP', 55+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BGINDUSTRYEXP(56) : res_back.sql(301) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BGINDUSTRYEXP', 67+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BGINDUSTRYEXP(68) : res_back.sql(313) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_BGINDUSTRYEXP;
ALTER FUNCTION SP_U_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_D_BGINDUSTRYEXP
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_D_BGINDUSTRYEXP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_BGINDUSTRYEXP', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_BGINDUSTRYEXP(21) : res_back.sql(350) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      DELETE FROM RESOURCE_INDUSTRY_EXPERIENCE WHERE EXPERIENCE_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BGINDUSTRYEXP', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BGINDUSTRYEXP(36) : res_back.sql(365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_BGINDUSTRYEXP', 41+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_BGINDUSTRYEXP(42) : res_back.sql(371) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BGINDUSTRYEXP', 48+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BGINDUSTRYEXP(49) : res_back.sql(378) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BGINDUSTRYEXP', 60+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BGINDUSTRYEXP(61) : res_back.sql(390) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_BGINDUSTRYEXP;
ALTER FUNCTION SP_D_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_BGINDUSTRYEXP ==
CREATE OR REPLACE FUNCTION SP_S_BGINDUSTRYEXP
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_BGINDUSTRYEXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_BGINDUSTRYEXP'), '-- ' || SYSTIMESTAMP, ':r := SP_S_BGINDUSTRYEXP(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BGINDUSTRYEXP', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_BGINDUSTRYEXP(20) : res_back.sql(426) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), id, ind_s_bgindustryexp->id);
   
   OPEN C6667 FOR SELECT EXPERIENCE_ID AS ELEMENT_ID, 98 AS TYPE_ID, CLASSIFICATION AS ELEMENT_NAME, RESOURCE_ID, INDUSTRY_ID, PROF_LEVEL
   FROM RESOURCE_INDUSTRY_EXPERIENCE WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BGINDUSTRYEXP', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_BGINDUSTRYEXP(32) : res_back.sql(438) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C6667;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BGINDUSTRYEXP', 39+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BGINDUSTRYEXP(40) : res_back.sql(446) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BGINDUSTRYEXP', 51+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BGINDUSTRYEXP(52) : res_back.sql(458) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_BGINDUSTRYEXP;
ALTER FUNCTION SP_S_BGINDUSTRYEXP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_I_EMPLYMENTHIST
(
     p_title VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_I_EMPLYMENTHIST(' || 
       '''' || p_title || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EMPLYMENTHIST', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_EMPLYMENTHIST(23) : res_back.sql(497) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(37) : res_back.sql(511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EMPLYMENTHIST', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EMPLYMENTHIST(44) : res_back.sql(518) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EMPLYMENTHIST', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_EMPLYMENTHIST(47) : res_back.sql(521) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EMPLYMENTHIST', 51+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EMPLYMENTHIST(52) : res_back.sql(526) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EMPLYMENTHIST', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_EMPLYMENTHIST(55) : res_back.sql(529) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_EMPLOYMENT_HISTORY (EMPLOYMENT_ID, RESOURCE_ID, TITLE)
         VALUES (h_uniqueID, p_resource_id, p_title);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(76) : res_back.sql(550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_EMPLYMENTHIST', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_EMPLYMENTHIST(83) : res_back.sql(557) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(90) : res_back.sql(564) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EMPLYMENTHIST', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EMPLYMENTHIST(102) : res_back.sql(576) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_EMPLYMENTHIST;
ALTER FUNCTION SP_I_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_U_EMPLYMENTHIST
(
     p_id VARCHAR2
   , p_company_id VARCHAR2
   , p_title VARCHAR2
   , p_salary NUMBER
   , p_start VARCHAR2
   , p_end VARCHAR2
   , p_location VARCHAR2
   , p_descr VARCHAR2
   , p_resp VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EMPLYMENTHIST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_company_id || ''''
          || ', ' || '''' || p_title || ''''
          || ', ' || COALESCE(TO_CHAR(p_salary), 'NULL')
          || ', ' || '''' || p_start || ''''
          || ', ' || '''' || p_end || ''''
          || ', ' || '''' || p_location || ''''
          || ', ' || '''' || p_descr || ''''
          || ', ' || '''' || p_resp || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLYMENTHIST', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EMPLYMENTHIST(34) : res_back.sql(626) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT EMPLOYMENT_ID INTO h_exists FROM RESOURCE_EMPLOYMENT_HISTORY WHERE EMPLOYMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(47) : res_back.sql(639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Statement
      BEGIN
         UPDATE RESOURCE_EMPLOYMENT_HISTORY SET COMPANY_ID = p_company_id,
         TITLE = p_title, SALARY = p_salary,
         START_DATE = p_start, END_DATE = p_end,
         LOCATION = p_location, DESCRIPTION = p_descr,
         RESPONSIBILITIES = p_resp WHERE EMPLOYMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(70) : res_back.sql(662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLYMENTHIST', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLYMENTHIST(76) : res_back.sql(668) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLYMENTHIST', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EMPLYMENTHIST(79) : res_back.sql(671) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EMPLYMENTHIST', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EMPLYMENTHIST(85) : res_back.sql(677) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(92) : res_back.sql(684) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLYMENTHIST', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLYMENTHIST(104) : res_back.sql(696) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EMPLYMENTHIST;
ALTER FUNCTION SP_U_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_D_EMPLYMENTHIST
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_D_EMPLYMENTHIST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EMPLYMENTHIST', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_EMPLYMENTHIST(21) : res_back.sql(733) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Delete Statement
   BEGIN
      DELETE FROM RESOURCE_EMPLOYMENT_HISTORY WHERE EMPLOYMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EMPLYMENTHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EMPLYMENTHIST(37) : res_back.sql(749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_EMPLYMENTHIST', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_EMPLYMENTHIST(43) : res_back.sql(755) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EMPLYMENTHIST', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EMPLYMENTHIST(50) : res_back.sql(762) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EMPLYMENTHIST', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EMPLYMENTHIST(62) : res_back.sql(774) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_EMPLYMENTHIST;
ALTER FUNCTION SP_D_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_EMPLYMENTHIST ==
CREATE OR REPLACE FUNCTION SP_S_EMPLYMENTHIST
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_EMPLYMENTHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_EMPLYMENTHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_S_EMPLYMENTHIST(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EMPLYMENTHIST', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_EMPLYMENTHIST(20) : res_back.sql(810) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), id, ind_s_emplymenthist->id);
   
   --Return a resultset
   
   OPEN C66671 FOR SELECT EMPLOYMENT_ID AS ELEMENT_ID, 99 AS TYPE_ID, TITLE AS ELEMENT_NAME, RESOURCE_ID, COMPANY_ID, SALARY, START_DATE, END_DATE, LOCATION, DESCRIPTION, RESPONSIBILITIES
   FROM RESOURCE_EMPLOYMENT_HISTORY WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EMPLYMENTHIST', 33+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_EMPLYMENTHIST(34) : res_back.sql(824) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66671;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EMPLYMENTHIST', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EMPLYMENTHIST(42) : res_back.sql(832) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EMPLYMENTHIST', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EMPLYMENTHIST(54) : res_back.sql(844) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_EMPLYMENTHIST;
ALTER FUNCTION SP_S_EMPLYMENTHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_I_PROJHIST
(
     p_prjname VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PROJHIST(' || 
       '''' || p_prjname || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJHIST', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PROJHIST(23) : res_back.sql(883) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(37) : res_back.sql(897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_PROJHIST', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_PROJHIST(44) : res_back.sql(904) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJHIST', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_PROJHIST(47) : res_back.sql(907) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_PROJHIST', 51+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_PROJHIST(52) : res_back.sql(912) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJHIST', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_PROJHIST(55) : res_back.sql(915) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_PROJECT_HISTORY (RES_PROJECT_ID, RESOURCE_ID, PROJECT_NAME)
         VALUES (h_uniqueID, p_resource_id, p_prjname);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(76) : res_back.sql(936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PROJHIST', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PROJHIST(83) : res_back.sql(943) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(90) : res_back.sql(950) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJHIST', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJHIST(102) : res_back.sql(962) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PROJHIST;
ALTER FUNCTION SP_I_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_U_PROJHIST
(
     p_prjhistid VARCHAR2
   , p_client VARCHAR2
   , p_classif_id VARCHAR2
   , p_industry_id PLS_INTEGER
   , p_prjname VARCHAR2
   , p_start VARCHAR2
   , p_end VARCHAR2
   , p_prjlen VARCHAR2
   , p_timespent VARCHAR2
   , p_role VARCHAR2
   , p_descr VARCHAR2
   , p_resp VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJHIST(' || 
       '''' || p_prjhistid || ''''
          || ', ' || '''' || p_client || ''''
          || ', ' || '''' || p_classif_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_industry_id), 'NULL')
          || ', ' || '''' || p_prjname || ''''
          || ', ' || '''' || p_start || ''''
          || ', ' || '''' || p_end || ''''
          || ', ' || '''' || p_prjlen || ''''
          || ', ' || '''' || p_timespent || ''''
          || ', ' || '''' || p_role || ''''
          || ', ' || '''' || p_descr || ''''
          || ', ' || '''' || p_resp || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJHIST', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJHIST(39) : res_back.sql(1017) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE RESOURCE_PROJECT_HISTORY SET CLIENT = p_client, CLASSIFICATION = p_classif_id,
      INDUSTRY_ID = p_industry_id, PROJECT_NAME = p_prjname,
      START_DATE = p_start, END_DATE = p_end,
      PROJECT_LENGTH = p_prjlen, TIME_SPENT = p_timespent,
      ROLE = p_role, DESCRIPTION = p_descr,
      RESPONSIBILITIES = p_resp
      WHERE RES_PROJECT_ID   = p_prjhistid;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJHIST', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJHIST(61) : res_back.sql(1039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJHIST', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJHIST(67) : res_back.sql(1045) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_prjhistid || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_prjhistid, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJHIST', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJHIST(74) : res_back.sql(1052) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJHIST', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJHIST(86) : res_back.sql(1064) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJHIST;
ALTER FUNCTION SP_U_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_D_PROJHIST
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_D_PROJHIST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PROJHIST', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_PROJHIST(21) : res_back.sql(1101) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Delete Statement
   BEGIN
      DELETE FROM RESOURCE_PROJECT_HISTORY WHERE RES_PROJECT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJHIST', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJHIST(37) : res_back.sql(1117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_PROJHIST', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_PROJHIST(43) : res_back.sql(1123) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJHIST', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJHIST(50) : res_back.sql(1130) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJHIST', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJHIST(62) : res_back.sql(1142) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_PROJHIST;
ALTER FUNCTION SP_D_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_PROJHIST ==
CREATE OR REPLACE FUNCTION SP_S_PROJHIST
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PROJHIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PROJHIST'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PROJHIST(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJHIST', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PROJHIST(20) : res_back.sql(1178) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), id, ind_s_projhist->id);
   
   --Return a resultset
   
   OPEN C66672 FOR SELECT RES_PROJECT_ID AS ELEMENT_ID, 101 AS TYPE_ID, PROJECT_NAME AS ELEMENT_NAME, RESOURCE_ID, CLIENT, CLASSIFICATION, INDUSTRY_ID, START_DATE, END_DATE, PROJECT_LENGTH, TIME_SPENT, ROLE, DESCRIPTION, RESPONSIBILITIES
   FROM RESOURCE_PROJECT_HISTORY WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJHIST', 33+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJHIST(34) : res_back.sql(1192) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66672;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJHIST', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJHIST(42) : res_back.sql(1200) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJHIST', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJHIST(54) : res_back.sql(1212) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PROJHIST;
ALTER FUNCTION SP_S_PROJHIST COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_I_EDUCATION
(
     p_spec VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_I_EDUCATION(' || 
       '''' || p_spec || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EDUCATION', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_EDUCATION(23) : res_back.sql(1251) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(37) : res_back.sql(1265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EDUCATION', 43+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EDUCATION(44) : res_back.sql(1272) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EDUCATION', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_EDUCATION(47) : res_back.sql(1275) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_EDUCATION', 51+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_EDUCATION(52) : res_back.sql(1280) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_EDUCATION', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_EDUCATION(55) : res_back.sql(1283) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_EDUCATION (EDUCATION_ID, RESOURCE_ID, SPECIALIZATION)
         VALUES (h_uniqueID, p_resource_id, p_spec);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(76) : res_back.sql(1304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_EDUCATION', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_EDUCATION(83) : res_back.sql(1311) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 90+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(91) : res_back.sql(1319) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_EDUCATION', 102+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_EDUCATION(103) : res_back.sql(1331) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_EDUCATION;
ALTER FUNCTION SP_I_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_U_EDUCATION
(
     p_id VARCHAR2
   , p_org VARCHAR2
   , p_degree VARCHAR2
   , p_spec VARCHAR2
   , p_grad VARCHAR2
   , p_grad_date VARCHAR2
   , p_appointed VARCHAR2
   , p_appointed_date VARCHAR2
   , p_honors VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_edu_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EDUCATION(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_org || ''''
          || ', ' || '''' || p_degree || ''''
          || ', ' || '''' || p_spec || ''''
          || ', ' || '''' || p_grad || ''''
          || ', ' || '''' || p_grad_date || ''''
          || ', ' || '''' || p_appointed || ''''
          || ', ' || '''' || p_appointed_date || ''''
          || ', ' || '''' || p_honors || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EDUCATION', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EDUCATION(34) : res_back.sql(1381) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT EDUCATION_ID INTO h_edu_id FROM RESOURCE_EDUCATION WHERE EDUCATION_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(47) : res_back.sql(1394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Insert Statement
      BEGIN
         UPDATE RESOURCE_EDUCATION SET ORGANIZATION = p_org, DEGREE = p_degree,
         SPECIALIZATION = p_spec, GRADUATION = p_grad,
         GRADUATION_DATE = p_grad_date, APPOINTED = p_appointed,
         APPOINTED_DATE  = p_appointed_date, HONORS_AWARDS  = p_honors
         WHERE EDUCATION_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(70) : res_back.sql(1417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EDUCATION', 75+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EDUCATION(76) : res_back.sql(1423) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EDUCATION', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EDUCATION(79) : res_back.sql(1426) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EDUCATION', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EDUCATION(85) : res_back.sql(1432) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 92+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(93) : res_back.sql(1440) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EDUCATION', 104+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EDUCATION(105) : res_back.sql(1452) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EDUCATION;
ALTER FUNCTION SP_U_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_D_EDUCATION
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_edu_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_D_EDUCATION(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EDUCATION', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_EDUCATION(22) : res_back.sql(1490) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), id, 0);
   
   BEGIN
      SELECT EDUCATION_ID INTO h_edu_id FROM RESOURCE_EDUCATION WHERE EDUCATION_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 38+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(39) : res_back.sql(1507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Delete Statement
      BEGIN
         DELETE FROM RESOURCE_EDUCATION WHERE EDUCATION_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(58) : res_back.sql(1526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_EDUCATION', 63+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_EDUCATION(64) : res_back.sql(1532) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_EDUCATION', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_EDUCATION(67) : res_back.sql(1535) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_EDUCATION', 72+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_EDUCATION(73) : res_back.sql(1541) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 79+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(80) : res_back.sql(1548) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_EDUCATION', 91+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_EDUCATION(92) : res_back.sql(1560) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_EDUCATION;
ALTER FUNCTION SP_D_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_EDUCATION ==
CREATE OR REPLACE FUNCTION SP_S_EDUCATION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_type_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66673 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_EDUCATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_EDUCATION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_EDUCATION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EDUCATION', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_EDUCATION(21) : res_back.sql(1597) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), id, 0);
   h_type_id := '102';
   
   --Return a resultset
   
   OPEN C66673 FOR SELECT EDUCATION_ID AS ELEMENT_ID, h_type_id AS TYPE_ID, SPECIALIZATION AS ELEMENT_NAME, RESOURCE_ID, ORGANIZATION, DEGREE, GRADUATION, GRADUATION_DATE, APPOINTED, APPOINTED_DATE, HONORS_AWARDS
   FROM RESOURCE_EDUCATION WHERE RESOURCE_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_EDUCATION', 34+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_EDUCATION(35) : res_back.sql(1611) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66673;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EDUCATION', 42+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EDUCATION(43) : res_back.sql(1619) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_EDUCATION', 54+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_EDUCATION(55) : res_back.sql(1631) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_EDUCATION;
ALTER FUNCTION SP_S_EDUCATION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RESLOCPREF ==
CREATE OR REPLACE FUNCTION SP_U_RESLOCPREF
(
     p_resource_id VARCHAR2
   , p_reloc VARCHAR2
   , p_reloc_duration VARCHAR2
   , p_reloc1 VARCHAR2
   , p_reloc2 VARCHAR2
   , p_reloc3 VARCHAR2
   , p_travel VARCHAR2
   , p_duration VARCHAR2
   , p_travel_dest1 VARCHAR2
   , p_travel_dest2 VARCHAR2
   , p_travel_dest3 VARCHAR2
   , p_passport VARCHAR2
   , p_passport_exp VARCHAR2
   , p_visa1 VARCHAR2
   , p_visa_exp1 VARCHAR2
   , p_visa2 VARCHAR2
   , p_visa_exp2 VARCHAR2
   , p_visa3 VARCHAR2
   , p_visa_exp3 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RESLOCPREF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RESLOCPREF'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RESLOCPREF(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_reloc || ''''
          || ', ' || '''' || p_reloc_duration || ''''
          || ', ' || '''' || p_reloc1 || ''''
          || ', ' || '''' || p_reloc2 || ''''
          || ', ' || '''' || p_reloc3 || ''''
          || ', ' || '''' || p_travel || ''''
          || ', ' || '''' || p_duration || ''''
          || ', ' || '''' || p_travel_dest1 || ''''
          || ', ' || '''' || p_travel_dest2 || ''''
          || ', ' || '''' || p_travel_dest3 || ''''
          || ', ' || '''' || p_passport || ''''
          || ', ' || '''' || p_passport_exp || ''''
          || ', ' || '''' || p_visa1 || ''''
          || ', ' || '''' || p_visa_exp1 || ''''
          || ', ' || '''' || p_visa2 || ''''
          || ', ' || '''' || p_visa_exp2 || ''''
          || ', ' || '''' || p_visa3 || ''''
          || ', ' || '''' || p_visa_exp3 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RESLOCPREF', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RESLOCPREF(54) : res_back.sql(1701) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(68) : res_back.sql(1715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RESLOCPREF', 74+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RESLOCPREF(75) : res_back.sql(1722) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RESLOCPREF', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RESLOCPREF(78) : res_back.sql(1725) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RESLOCPREF', 82+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RESLOCPREF(83) : res_back.sql(1730) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RESLOCPREF', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RESLOCPREF(86) : res_back.sql(1733) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Statement
      BEGIN
         UPDATE RESOURCES SET WILLING_RELOC = p_reloc, RELOC_DURATION = p_reloc_duration, WORK_RELOC_1 = p_reloc1,
         WORK_RELOC_2 = p_reloc2, WORK_RELOC_3 = p_reloc3,
         WILLING_TRAVEL = p_travel, TRAVEL_DURATION = p_duration,
         TRAVEL_DEST_1 = p_travel_dest1, TRAVEL_DEST_2 = p_travel_dest2,
         TRAVEL_DEST_3 = p_travel_dest3,
         PASPORT_VALID = p_passport, PASPORT_EXPIRATION = p_passport_exp,
         COUNTRY_VISA_1  = p_visa1,VISA_EXPIRES_1 = p_visa_exp1,
         COUNTRY_VISA_2  = p_visa2,VISA_EXPIRES_2 = p_visa_exp2,
         COUNTRY_VISA_3  = p_visa3,VISA_EXPIRES_3 = p_visa_exp3
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(112) : res_back.sql(1759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RESLOCPREF', 118+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RESLOCPREF(119) : res_back.sql(1766) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 125+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(126) : res_back.sql(1773) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESLOCPREF', 137+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESLOCPREF(138) : res_back.sql(1785) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RESLOCPREF;
ALTER FUNCTION SP_U_RESLOCPREF COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_I_RESREADINESS
(
     p_languageid VARCHAR2
   , p_resource_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_I_RESREADINESS(' || 
       '''' || p_languageid || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_RESREADINESS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_RESREADINESS(23) : res_back.sql(1824) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 38+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(39) : res_back.sql(1840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_RESREADINESS', 45+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_RESREADINESS(46) : res_back.sql(1847) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_RESREADINESS', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_RESREADINESS(49) : res_back.sql(1850) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   ElsIf SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_RESREADINESS', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_RESREADINESS(54) : res_back.sql(1855) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_RESREADINESS', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_RESREADINESS(57) : res_back.sql(1858) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Get a unique SC_H_REVISION byte id
      h_uniqueID := SYS_GUID();
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO RESOURCE_READINESS (READINESS_ID, RESOURCE_ID, LANGUAGE_ID)
         VALUES (h_uniqueID, p_resource_id, Trunc(p_languageid));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(78) : res_back.sql(1879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_RESREADINESS', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_RESREADINESS(85) : res_back.sql(1886) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(92) : res_back.sql(1893) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_RESREADINESS', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_RESREADINESS(104) : res_back.sql(1905) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_RESREADINESS;
ALTER FUNCTION SP_I_RESREADINESS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_U_RESREADINESS
(
     p_id VARCHAR2
   , p_languageid VARCHAR2
   , p_readid PLS_INTEGER
   , p_speakid PLS_INTEGER
   , p_writeid PLS_INTEGER
   , p_default_language VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_read_level PLS_INTEGER := 0;
   h_speak_level PLS_INTEGER := 0;
   h_write_level PLS_INTEGER := 0;
   h_language_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_default_language VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RESREADINESS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_languageid || ''''
          || ', ' || COALESCE(TO_CHAR(p_readid), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_speakid), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_writeid), 'NULL')
          || ', ' || '''' || p_default_language || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RESREADINESS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RESREADINESS(34) : res_back.sql(1955) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_language_id := p_languageid;
   h_default_language := p_default_language;
   h_rec_user := p_rec_user;
   h_read_level := p_readid;
   h_speak_level := p_speakid;
   h_write_level := p_writeid;
   
   --Execute Update Statement
   BEGIN
      UPDATE RESOURCE_READINESS
      SET LANGUAGE_ID = Trunc(h_language_id),
      READ_LEVEL = h_read_level,
      SPEAK_LEVEL = h_speak_level,
      WRITE_LEVEL = h_write_level,
      DEFAULT_LANGUAGE = h_default_language
      WHERE READINESS_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESREADINESS', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESREADINESS(64) : res_back.sql(1985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RESREADINESS', 70+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RESREADINESS(71) : res_back.sql(1992) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESREADINESS', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESREADINESS(78) : res_back.sql(1999) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RESREADINESS', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RESREADINESS(90) : res_back.sql(2011) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RESREADINESS;
ALTER FUNCTION SP_U_RESREADINESS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_D_RESREADINESS
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_D_RESREADINESS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RESREADINESS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_RESREADINESS(21) : res_back.sql(2048) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Delete Statement
   BEGIN
      DELETE FROM RESOURCE_READINESS WHERE READINESS_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RESREADINESS', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RESREADINESS(37) : res_back.sql(2064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_RESREADINESS', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_RESREADINESS(43) : res_back.sql(2070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RESREADINESS', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RESREADINESS(50) : res_back.sql(2077) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RESREADINESS', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RESREADINESS(62) : res_back.sql(2089) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_RESREADINESS;
ALTER FUNCTION SP_D_RESREADINESS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_RESREADINESS ==
CREATE OR REPLACE FUNCTION SP_S_RESREADINESS
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66675 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RESREADINESS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RESREADINESS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RESREADINESS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESREADINESS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RESREADINESS(21) : res_back.sql(2126) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   
   --Return a resultset
   
   OPEN C66675 FOR SELECT READINESS_ID AS ELEMENT_ID, 104 AS TYPE_ID, LANGUAGE_ID AS ELEMENT_NAME,
   LANGUAGE_ID, RESOURCE_ID, READ_LEVEL, SPEAK_LEVEL, WRITE_LEVEL, DEFAULT_LANGUAGE
   FROM RESOURCE_READINESS
   WHERE RESOURCE_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESREADINESS', 32+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RESREADINESS(33) : res_back.sql(2138) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66675;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESREADINESS', 40+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESREADINESS(41) : res_back.sql(2146) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESREADINESS', 52+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESREADINESS(53) : res_back.sql(2158) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RESREADINESS;
ALTER FUNCTION SP_S_RESREADINESS COMPILE DEBUG;

