Prompt == FUNCTION FC_U_RTF_CRI ==
CREATE OR REPLACE FUNCTION FC_U_RTF_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_text IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_table_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_clob_locator CLOB;
   h_rtf_bit PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RTF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RTF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RTF_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_text || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_table_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CRI', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RTF_CRI(24) : rtf_func.sql(25) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CRI', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CRI(31) : rtf_func.sql(32) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT PROJECT_ID
      INTO h_parent_id
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(47) : rtf_func.sql(48) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CRI', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CRI(54) : rtf_func.sql(55) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT CLOB_DATA
      INTO h_clob_locator
      FROM CRI_RTF
      WHERE ELEMENT_ID = h_id
      AND BIT_FLAG = h_bitflag;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(71) : rtf_func.sql(72) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO CRI_RTF (
         PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
         VALUES (
         h_parent_id, h_id, h_bitflag, h_text );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(92) : rtf_func.sql(93) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_text IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CRI
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(112) : rtf_func.sql(113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      UPDATE CRI_RTF SET
              CLOB_DATA = NULL
         WHERE ELEMENT_ID = H_ID AND BIT_FLAG = H_BITFLAG;

      BEGIN
         UPDATE CRI_RTF
         SET CLOB_DATA = h_text
         WHERE ELEMENT_ID = h_id AND BIT_FLAG = h_bitflag;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(136) : rtf_func.sql(137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_text IS NOT NULL)) AND ((h_clob_locator IS NULL)) Then
         BEGIN
            UPDATE TMT_CRI
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(156) : rtf_func.sql(157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf ((h_text IS NULL)) AND ((h_clob_locator IS NOT NULL)) Then
         BEGIN
            UPDATE TMT_CRI
            SET RTF_BITS = RTF_BITS - h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(175) : rtf_func.sql(176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RTF_BITS INTO h_rtf_bit
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id
         AND WBS_ID = ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(194) : rtf_func.sql(195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = h_rtf_bit
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CRI', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CRI(213) : rtf_func.sql(214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CRI', 220+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CRI(221) : rtf_func.sql(222) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CRI', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CRI(225) : rtf_func.sql(226) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RTF_CRI;
ALTER FUNCTION FC_U_RTF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_RTF_WBS ==
CREATE OR REPLACE FUNCTION FC_U_RTF_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_text IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_table_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_clob_locator CLOB;
   h_rtf_bit PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RTF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RTF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RTF_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_text || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_table_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_WBS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RTF_WBS(24) : rtf_func.sql(258) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_WBS', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_WBS(31) : rtf_func.sql(265) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT PROJECT_ID
      INTO h_parent_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(47) : rtf_func.sql(281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_WBS', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_WBS(54) : rtf_func.sql(288) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT CLOB_DATA
      INTO h_clob_locator
      FROM WBS_RTF
      WHERE ELEMENT_ID = h_id
      AND BIT_FLAG = h_bitflag;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(71) : rtf_func.sql(305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO WBS_RTF (
         PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
         VALUES (
         h_parent_id, h_id, h_bitflag, h_text );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(92) : rtf_func.sql(326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_text IS NOT NULL) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(112) : rtf_func.sql(346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      UPDATE WBS_RTF SET
              CLOB_DATA = NULL
         WHERE ELEMENT_ID = H_ID AND BIT_FLAG = H_BITFLAG;

      BEGIN
         UPDATE WBS_RTF
         SET CLOB_DATA = h_text
         WHERE ELEMENT_ID = h_id AND BIT_FLAG = h_bitflag;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(136) : rtf_func.sql(370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_text IS NOT NULL)) AND ((h_clob_locator IS NULL)) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(156) : rtf_func.sql(390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf ((h_text IS NULL)) AND ((h_clob_locator IS NOT NULL)) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = RTF_BITS - h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(175) : rtf_func.sql(409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RTF_BITS INTO h_rtf_bit
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id
         AND WBS_ID = ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(194) : rtf_func.sql(428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = h_rtf_bit
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_WBS', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_WBS(213) : rtf_func.sql(447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_WBS', 220+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_WBS(221) : rtf_func.sql(455) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_WBS', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_WBS(225) : rtf_func.sql(459) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RTF_WBS;
ALTER FUNCTION FC_U_RTF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_U_RTF_DOC ==
CREATE OR REPLACE FUNCTION FC_U_RTF_DOC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_text IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_table_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_clob_locator CLOB;
   h_rtf_bit PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RTF_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RTF_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RTF_DOC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_text || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_table_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RTF_DOC(24) : rtf_func.sql(491) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_DOC', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_DOC(31) : rtf_func.sql(498) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT PROJECT_ID
      INTO h_parent_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(47) : rtf_func.sql(514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_DOC(54) : rtf_func.sql(521) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT CLOB_DATA
      INTO h_clob_locator
      FROM DOC_RTF
      WHERE ELEMENT_ID = h_id
      AND BIT_FLAG = h_bitflag;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(71) : rtf_func.sql(538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO DOC_RTF (
         PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
         VALUES (
         h_parent_id, h_id, h_bitflag, h_text );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(92) : rtf_func.sql(559) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_text IS NOT NULL) Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(112) : rtf_func.sql(579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      UPDATE DOC_RTF SET
              CLOB_DATA = NULL
         WHERE ELEMENT_ID = H_ID AND BIT_FLAG = H_BITFLAG;

      BEGIN
         UPDATE DOC_RTF
         SET CLOB_DATA = h_text
         WHERE ELEMENT_ID = h_id AND BIT_FLAG = h_bitflag;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(136) : rtf_func.sql(603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_text IS NOT NULL)) AND ((h_clob_locator IS NULL)) Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(156) : rtf_func.sql(623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf ((h_text IS NULL)) AND ((h_clob_locator IS NOT NULL)) Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET RTF_BITS = RTF_BITS - h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(175) : rtf_func.sql(642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RTF_BITS INTO h_rtf_bit
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id
         AND WBS_ID = ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(194) : rtf_func.sql(661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = h_rtf_bit
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_DOC', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_DOC(213) : rtf_func.sql(680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_DOC', 220+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_DOC(221) : rtf_func.sql(688) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_DOC', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_DOC(225) : rtf_func.sql(692) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RTF_DOC;
ALTER FUNCTION FC_U_RTF_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_RTF_CLIENTS ==
CREATE OR REPLACE FUNCTION FC_U_RTF_CLIENTS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_text IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_table_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_clob_locator CLOB;
   h_rtf_bit PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RTF_CLIENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RTF_CLIENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RTF_CLIENTS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_text || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_table_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CLIENTS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RTF_CLIENTS(24) : rtf_func.sql(724) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CLIENTS', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CLIENTS(31) : rtf_func.sql(731) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT ELEMENT_ID
      INTO h_parent_id
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(47) : rtf_func.sql(747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CLIENTS', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CLIENTS(54) : rtf_func.sql(754) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT CLOB_DATA
      INTO h_clob_locator
      FROM CLIENT_RTF
      WHERE ELEMENT_ID = h_id
      AND BIT_FLAG = h_bitflag;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(71) : rtf_func.sql(771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO CLIENT_RTF (
         PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
         VALUES (
         h_parent_id, h_id, h_bitflag, h_text );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(92) : rtf_func.sql(792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_text IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CLIENTS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(112) : rtf_func.sql(812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      UPDATE CLIENT_RTF SET
              CLOB_DATA = NULL
         WHERE ELEMENT_ID = H_ID AND BIT_FLAG = H_BITFLAG;

      BEGIN
         UPDATE CLIENT_RTF
         SET CLOB_DATA = h_text
         WHERE ELEMENT_ID = h_id AND BIT_FLAG = h_bitflag;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(136) : rtf_func.sql(836) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_text IS NOT NULL)) AND ((h_clob_locator IS NULL)) Then
         BEGIN
            UPDATE TMT_CLIENTS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(156) : rtf_func.sql(856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf ((h_text IS NULL)) AND ((h_clob_locator IS NOT NULL)) Then
         BEGIN
            UPDATE TMT_CLIENTS
            SET RTF_BITS = RTF_BITS - h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(175) : rtf_func.sql(875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RTF_BITS INTO h_rtf_bit
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id
         AND WBS_ID = ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(194) : rtf_func.sql(894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = h_rtf_bit
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_CLIENTS', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_CLIENTS(213) : rtf_func.sql(913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CLIENTS', 220+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CLIENTS(221) : rtf_func.sql(921) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_CLIENTS', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_CLIENTS(225) : rtf_func.sql(925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RTF_CLIENTS;
ALTER FUNCTION FC_U_RTF_CLIENTS COMPILE DEBUG;

Prompt == FUNCTION FC_U_RTF_ASSETS ==
CREATE OR REPLACE FUNCTION FC_U_RTF_ASSETS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_text IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_table_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_clob_locator CLOB;
   h_rtf_bit PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RTF_ASSETS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RTF_ASSETS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RTF_ASSETS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_text || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_table_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_ASSETS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RTF_ASSETS(24) : rtf_func.sql(957) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_ASSETS', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_ASSETS(31) : rtf_func.sql(964) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT ELEMENT_ID
      INTO h_parent_id
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(47) : rtf_func.sql(980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_ASSETS', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_ASSETS(54) : rtf_func.sql(987) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   BEGIN
      SELECT CLOB_DATA
      INTO h_clob_locator
      FROM ASSET_RTF
      WHERE ELEMENT_ID = h_id
      AND BIT_FLAG = h_bitflag;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(71) : rtf_func.sql(1004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO ASSET_RTF (
         PARENT_ID, ELEMENT_ID, BIT_FLAG, CLOB_DATA )
         VALUES (
         h_parent_id, h_id, h_bitflag, h_text );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(92) : rtf_func.sql(1025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_text IS NOT NULL) Then
         BEGIN
            UPDATE TMT_ASSETS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 111+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(112) : rtf_func.sql(1045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      UPDATE ASSET_RTF SET
              CLOB_DATA = NULL
         WHERE ELEMENT_ID = H_ID AND BIT_FLAG = H_BITFLAG;

      BEGIN
         UPDATE ASSET_RTF
         SET CLOB_DATA = h_text
         WHERE ELEMENT_ID = h_id AND BIT_FLAG = h_bitflag;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(136) : rtf_func.sql(1069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_text IS NOT NULL)) AND ((h_clob_locator IS NULL)) Then
         BEGIN
            UPDATE TMT_ASSETS
            SET RTF_BITS = RTF_BITS + h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(156) : rtf_func.sql(1089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf ((h_text IS NULL)) AND ((h_clob_locator IS NOT NULL)) Then
         BEGIN
            UPDATE TMT_ASSETS
            SET RTF_BITS = RTF_BITS - h_bitflag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(175) : rtf_func.sql(1108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RTF_BITS INTO h_rtf_bit
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id
         AND WBS_ID = ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(194) : rtf_func.sql(1127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_WBS
            SET RTF_BITS = h_rtf_bit
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RTF_ASSETS', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RTF_ASSETS(213) : rtf_func.sql(1146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_ASSETS', 220+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_ASSETS(221) : rtf_func.sql(1154) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RTF_ASSETS', 224+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RTF_ASSETS(225) : rtf_func.sql(1158) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RTF_ASSETS;
ALTER FUNCTION FC_U_RTF_ASSETS COMPILE DEBUG;

