Prompt == FUNCTION FC_U_NAME_SCD ==
CREATE OR REPLACE FUNCTION FC_U_NAME_SCD
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_NAME_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_NAME_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_U_NAME_SCD(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NAME_SCD', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_NAME_SCD(18) : scd_func.sql(19) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PROJECT_ID INTO h_project_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NAME_SCD', 30+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NAME_SCD(31) : scd_func.sql(32) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NAME_SCD', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_NAME_SCD(38) : scd_func.sql(39) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS SET
      ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NAME_SCD', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NAME_SCD(57) : scd_func.sql(58) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_PUBLISHED_SCORECARDS SET
      ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NAME_SCD', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NAME_SCD(76) : scd_func.sql(77) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NAME_SCD', 81+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_NAME_SCD(82) : scd_func.sql(83) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NAME_SCD', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_NAME_SCD(86) : scd_func.sql(87) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_NAME_SCD;
ALTER FUNCTION FC_U_NAME_SCD COMPILE DEBUG;

Prompt == FUNCTION FC_VALID_TYPE_SC ==
CREATE OR REPLACE FUNCTION FC_VALID_TYPE_SC
(
     sh_h_parent_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VALID_TYPE_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VALID_TYPE_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_VALID_TYPE_SC(' || 
       COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_SC', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VALID_TYPE_SC(14) : scd_func.sql(109) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_SC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_SC(19) : scd_func.sql(114) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_SC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_SC(23) : scd_func.sql(118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_VALID_TYPE_SC;
ALTER FUNCTION FC_VALID_TYPE_SC COMPILE DEBUG;

Prompt == FUNCTION FC_VALID_TYPE_WBS_SC ==
CREATE OR REPLACE FUNCTION FC_VALID_TYPE_WBS_SC
(
     sh_h_parent_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VALID_TYPE_WBS_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VALID_TYPE_WBS_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_VALID_TYPE_WBS_SC(' || 
       COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_WBS_SC', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VALID_TYPE_WBS_SC(14) : scd_func.sql(140) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_VALID_TYPE_SC(h_parent_type_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_WBS_SC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_WBS_SC(19) : scd_func.sql(145) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_WBS_SC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_WBS_SC(23) : scd_func.sql(149) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_VALID_TYPE_WBS_SC;
ALTER FUNCTION FC_VALID_TYPE_WBS_SC COMPILE DEBUG;

Prompt == FUNCTION FC_VALID_TYPE_CRI_SC ==
CREATE OR REPLACE FUNCTION FC_VALID_TYPE_CRI_SC
(
     sh_h_parent_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VALID_TYPE_CRI_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VALID_TYPE_CRI_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_VALID_TYPE_CRI_SC(' || 
       COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI_SC', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VALID_TYPE_CRI_SC(14) : scd_func.sql(171) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_VALID_TYPE_SC(h_parent_type_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI_SC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_CRI_SC(19) : scd_func.sql(176) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_CRI_SC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_CRI_SC(23) : scd_func.sql(180) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_VALID_TYPE_CRI_SC;
ALTER FUNCTION FC_VALID_TYPE_CRI_SC COMPILE DEBUG;

Prompt == FUNCTION FC_VALID_TYPE_RES_SC ==
CREATE OR REPLACE FUNCTION FC_VALID_TYPE_RES_SC
(
     sh_h_parent_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_VALID_TYPE_RES_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_VALID_TYPE_RES_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_VALID_TYPE_RES_SC(' || 
       COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_RES_SC', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_VALID_TYPE_RES_SC(14) : scd_func.sql(202) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_VALID_TYPE_SC(h_parent_type_id);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_RES_SC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_RES_SC(19) : scd_func.sql(207) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_VALID_TYPE_RES_SC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_VALID_TYPE_RES_SC(23) : scd_func.sql(211) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_VALID_TYPE_RES_SC;
ALTER FUNCTION FC_VALID_TYPE_RES_SC COMPILE DEBUG;

Prompt == FUNCTION FC_INSERT_SC ==
CREATE OR REPLACE FUNCTION FC_INSERT_SC
(
     sh_h_foreign_table PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_parent_type_id PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_SC(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_SC', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_SC(43) : scd_func.sql(262) : ' || SYSTIMESTAMP);
   END IF; 

   PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSIGNED_SCORECARDS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   h_rank := SubStr(h_rank || h_rankBase64, 1, 200);
   
   BEGIN
      INSERT INTO TMT_ASSIGNED_SCORECARDS (
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
      TYPE_ID, LEVEL_ID,
      RANK, PROJECT_ID, PARENT_RANK, PARENT_TYPE_ID,
      REC_USER, CREATED_BY, ASSIGN_NAMES)
      VALUES (
      h_parent_id, h_element_id, h_name,
      h_type_id, h_level_id,
      h_rank, h_project_id, h_parent_rank, h_parent_type_id,
      h_rec_user, h_rec_user, h_full_name || ';');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_SC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_SC(71) : scd_func.sql(290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_SC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_SC(77) : scd_func.sql(296) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_SC;
ALTER FUNCTION FC_INSERT_SC COMPILE DEBUG;

Prompt == FUNCTION FC_INSERT_WBS_SC ==
CREATE OR REPLACE FUNCTION FC_INSERT_WBS_SC
(
     sh_h_foreign_table PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_parent_type_id PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_WBS_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_WBS_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_WBS_SC(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_WBS_SC', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_WBS_SC(41) : scd_func.sql(345) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_INSERT_SC(h_foreign_table, h_project_id, h_name, h_element_id, h_level_id
                                  , h_parent_id, h_foreign_id, h_parent_rank, h_type_id
                                  , h_parent_type_id, h_rank, h_full_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_WBS_SC', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_WBS_SC(49) : scd_func.sql(353) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_WBS_SC;
ALTER FUNCTION FC_INSERT_WBS_SC COMPILE DEBUG;

Prompt == FUNCTION FC_INSERT_CRI_SC ==
CREATE OR REPLACE FUNCTION FC_INSERT_CRI_SC
(
     sh_h_foreign_table PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_parent_type_id PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_CRI_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_CRI_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_CRI_SC(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI_SC', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_CRI_SC(41) : scd_func.sql(402) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_INSERT_SC(h_foreign_table, h_project_id, h_name, h_element_id, h_level_id
                                  , h_parent_id, h_foreign_id, h_parent_rank, h_type_id
                                  , h_parent_type_id, h_rank, h_full_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_CRI_SC', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_CRI_SC(49) : scd_func.sql(410) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_CRI_SC;
ALTER FUNCTION FC_INSERT_CRI_SC COMPILE DEBUG;

Prompt == FUNCTION FC_INSERT_RES_SC ==
CREATE OR REPLACE FUNCTION FC_INSERT_RES_SC
(
     sh_h_foreign_table PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_level_id PLS_INTEGER
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , h_parent_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_parent_type_id PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_level_id PLS_INTEGER := sh_h_level_id;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_type_id PLS_INTEGER := sh_h_parent_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_RES_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_RES_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_RES_SC(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level_id), 'NULL')
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || '''' || h_parent_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_parent_type_id), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_RES_SC', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_RES_SC(41) : scd_func.sql(459) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_INSERT_SC(h_foreign_table, h_project_id, h_name, h_element_id, h_level_id
                                  , h_parent_id, h_foreign_id, h_parent_rank, h_type_id
                                  , h_parent_type_id, h_rank, h_full_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_RES_SC', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_RES_SC(49) : scd_func.sql(467) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_RES_SC;
ALTER FUNCTION FC_INSERT_RES_SC COMPILE DEBUG;

Prompt == FUNCTION FC_I_ATTACH_SC ==
CREATE OR REPLACE FUNCTION FC_I_ATTACH_SC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_full_name VARCHAR2(255);
   h_transfer_flag VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_temp_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ATTACH_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ATTACH_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ATTACH_SC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ATTACH_SC(45) : scd_func.sql(520) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   
   BEGIN
      SELECT NICK_NAME INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(63) : scd_func.sql(538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID
      INTO h_parent_rank, h_rank, h_temp_project_id, h_level_id, h_parent_type_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(79) : scd_func.sql(554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_SC(85) : scd_func.sql(560) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_project_id IS NULL) Then
      h_project_id := h_temp_project_id;
   End If;
   
   -- verify type_id of the parent
   PMO_DB2M.SC_STATE := FC_VALID_TYPE_SC(h_parent_type_id);
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      h_element_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_SC(99) : scd_func.sql(574) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(116) : scd_func.sql(591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_SC(123) : scd_func.sql(598) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(143) : scd_func.sql(618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   
   PMO_DB2M.SC_STATE := FC_INSERT_SC(h_foreign_table, h_project_id, h_name, h_element_id, h_level_id
                                  , h_parent_id, h_foreign_id, h_parent_rank, h_type_id
                                  , h_parent_type_id, h_rank, h_full_name, h_rec_user);
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 157+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_SC(158) : scd_func.sql(633) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   --    h_temp_sc_state = GetSecurityID(h_host_table,h_type_id,SC_RESPONSIBLE_GROUP,SC_PARAM(h_security_id));
   --
   --    getUniqueID(h_assign_id);
   --    BEGIN_SQL
   --        INSERT INTO RESOURCE_ASSIGNMENTS(
   --            RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
   --            PARTICIPANT,
   --            SECURITY_ID,
   --            RESOURCE_TYPE, REC_USER,TABLE_TYPE)
   --        VALUES(
   --            HOST(h_assign_id), HOST(h_project_id), HOST(h_uniqueID), HOST(h_type_id), HOST(h_rec_user),
   --                        CASE WHEN HOST(h_host_table) = SC_TABLE_SCD        THEN SC_SCORECARD_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_TASK            THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_MILESTONE       THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_REQUIREMENT     THEN SC_REQUIREMENT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_CHANGE_REQUEST  THEN SC_CHANGE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_DEFECT          THEN SC_DEFECT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_SERVICE_REQUEST THEN SC_SERVICE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_ISSUE           THEN SC_ISSUE_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_RISK            THEN SC_RISK_RESPONSIBLE
   --                 WHEN HOST(h_type_id) = SC_CRI_ACTION_ITEM     THEN SC_ACTION_ITEM_RESPONSIBLE
   --                             else SC_DLV_MANAGER END,
   --                        HOST(h_security_id),
   --            '0', HOST(h_rec_user),HOST(h_host_table));
   --    END_SQL;
   
   If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   h_history_id := SYS_GUID();
   BEGIN
      INSERT INTO HISTORY_ASSIGNED_SCORECARDS
      SELECT h_history_id, A.* FROM TMT_ASSIGNED_SCORECARDS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 207+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(208) : scd_func.sql(683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_ASSIGNED_SCORECARDS
      SET REC_STATUS = 'U'
      WHERE HISTORY_ID = h_history_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(227) : scd_func.sql(702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET REVISION_HISTORY = Null
      WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_SC', 245+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_SC(246) : scd_func.sql(721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_SC(252) : scd_func.sql(727) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_SC', 255+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_SC(256) : scd_func.sql(731) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ATTACH_SC;
ALTER FUNCTION FC_I_ATTACH_SC COMPILE DEBUG;

Prompt == FUNCTION FC_I_ATTACH_WBS_SC ==
CREATE OR REPLACE FUNCTION FC_I_ATTACH_WBS_SC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_full_name VARCHAR2(255);
   h_transfer_flag VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_temp_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ATTACH_WBS_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ATTACH_WBS_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ATTACH_WBS_SC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ATTACH_WBS_SC(45) : scd_func.sql(784) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   
   BEGIN
      SELECT NICK_NAME INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(63) : scd_func.sql(802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID
      INTO h_parent_rank, h_rank, h_temp_project_id, h_level_id, h_parent_type_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(79) : scd_func.sql(818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_SC(85) : scd_func.sql(824) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_project_id IS NULL) Then
      h_project_id := h_temp_project_id;
   End If;
   
   -- verify type_id of the parent
   PMO_DB2M.SC_STATE := FC_VALID_TYPE_WBS_SC(h_parent_type_id);
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      h_element_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_SC(99) : scd_func.sql(838) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(116) : scd_func.sql(855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_SC(123) : scd_func.sql(862) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_WBS
         SET SCORECARD_COUNT = SCORECARD_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(143) : scd_func.sql(882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   
   PMO_DB2M.SC_STATE := FC_INSERT_WBS_SC(h_foreign_table, h_project_id, h_name, h_element_id
                                      , h_level_id, h_parent_id, h_foreign_id, h_parent_rank
                                      , h_type_id, h_parent_type_id, h_rank, h_full_name
                                      , h_rec_user);
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 158+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_SC(159) : scd_func.sql(898) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   --    h_temp_sc_state = GetSecurityID(h_host_table,h_type_id,SC_RESPONSIBLE_GROUP,SC_PARAM(h_security_id));
   --
   --    getUniqueID(h_assign_id);
   --    BEGIN_SQL
   --        INSERT INTO RESOURCE_ASSIGNMENTS(
   --            RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
   --            PARTICIPANT,
   --            SECURITY_ID,
   --            RESOURCE_TYPE, REC_USER,TABLE_TYPE)
   --        VALUES(
   --            HOST(h_assign_id), HOST(h_project_id), HOST(h_uniqueID), HOST(h_type_id), HOST(h_rec_user),
   --                        CASE WHEN HOST(h_host_table) = SC_TABLE_SCD        THEN SC_SCORECARD_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_TASK            THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_MILESTONE       THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_REQUIREMENT     THEN SC_REQUIREMENT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_CHANGE_REQUEST  THEN SC_CHANGE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_DEFECT          THEN SC_DEFECT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_SERVICE_REQUEST THEN SC_SERVICE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_ISSUE           THEN SC_ISSUE_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_RISK            THEN SC_RISK_RESPONSIBLE
   --                 WHEN HOST(h_type_id) = SC_CRI_ACTION_ITEM     THEN SC_ACTION_ITEM_RESPONSIBLE
   --                             else SC_DLV_MANAGER END,
   --                        HOST(h_security_id),
   --            '0', HOST(h_rec_user),HOST(h_host_table));
   --    END_SQL;
   
   If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   h_history_id := SYS_GUID();
   BEGIN
      INSERT INTO HISTORY_ASSIGNED_SCORECARDS
      SELECT h_history_id, A.* FROM TMT_ASSIGNED_SCORECARDS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 208+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(209) : scd_func.sql(948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_ASSIGNED_SCORECARDS
      SET REC_STATUS = 'U'
      WHERE HISTORY_ID = h_history_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(228) : scd_func.sql(967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET REVISION_HISTORY = Null
      WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_WBS_SC', 246+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_WBS_SC(247) : scd_func.sql(986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 252+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_SC(253) : scd_func.sql(992) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_WBS_SC', 256+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_WBS_SC(257) : scd_func.sql(996) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ATTACH_WBS_SC;
ALTER FUNCTION FC_I_ATTACH_WBS_SC COMPILE DEBUG;

Prompt == FUNCTION FC_I_ATTACH_CRI_SC ==
CREATE OR REPLACE FUNCTION FC_I_ATTACH_CRI_SC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_full_name VARCHAR2(255);
   h_transfer_flag VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_temp_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ATTACH_CRI_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ATTACH_CRI_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ATTACH_CRI_SC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ATTACH_CRI_SC(45) : scd_func.sql(1049) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CRI';
   
   BEGIN
      SELECT NICK_NAME INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(63) : scd_func.sql(1067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID
      INTO h_parent_rank, h_rank, h_temp_project_id, h_level_id, h_parent_type_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(79) : scd_func.sql(1083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI_SC(85) : scd_func.sql(1089) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_project_id IS NULL) Then
      h_project_id := h_temp_project_id;
   End If;
   
   -- verify type_id of the parent
   PMO_DB2M.SC_STATE := FC_VALID_TYPE_CRI_SC(h_parent_type_id);
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      h_element_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI_SC(99) : scd_func.sql(1103) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(116) : scd_func.sql(1120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI_SC(123) : scd_func.sql(1127) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CRI
         SET SCORECARD_COUNT = SCORECARD_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(143) : scd_func.sql(1147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   
   PMO_DB2M.SC_STATE := FC_INSERT_CRI_SC(h_foreign_table, h_project_id, h_name, h_element_id
                                      , h_level_id, h_parent_id, h_foreign_id, h_parent_rank
                                      , h_type_id, h_parent_type_id, h_rank, h_full_name
                                      , h_rec_user);
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 158+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI_SC(159) : scd_func.sql(1163) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   --    h_temp_sc_state = GetSecurityID(h_host_table,h_type_id,SC_RESPONSIBLE_GROUP,SC_PARAM(h_security_id));
   --
   --    getUniqueID(h_assign_id);
   --    BEGIN_SQL
   --        INSERT INTO RESOURCE_ASSIGNMENTS(
   --            RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
   --            PARTICIPANT,
   --            SECURITY_ID,
   --            RESOURCE_TYPE, REC_USER,TABLE_TYPE)
   --        VALUES(
   --            HOST(h_assign_id), HOST(h_project_id), HOST(h_uniqueID), HOST(h_type_id), HOST(h_rec_user),
   --                        CASE WHEN HOST(h_host_table) = SC_TABLE_SCD        THEN SC_SCORECARD_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_TASK            THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_MILESTONE       THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_REQUIREMENT     THEN SC_REQUIREMENT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_CHANGE_REQUEST  THEN SC_CHANGE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_DEFECT          THEN SC_DEFECT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_SERVICE_REQUEST THEN SC_SERVICE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_ISSUE           THEN SC_ISSUE_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_RISK            THEN SC_RISK_RESPONSIBLE
   --                 WHEN HOST(h_type_id) = SC_CRI_ACTION_ITEM     THEN SC_ACTION_ITEM_RESPONSIBLE
   --                             else SC_DLV_MANAGER END,
   --                        HOST(h_security_id),
   --            '0', HOST(h_rec_user),HOST(h_host_table));
   --    END_SQL;
   
   If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   h_history_id := SYS_GUID();
   BEGIN
      INSERT INTO HISTORY_ASSIGNED_SCORECARDS
      SELECT h_history_id, A.* FROM TMT_ASSIGNED_SCORECARDS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 208+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(209) : scd_func.sql(1213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_ASSIGNED_SCORECARDS
      SET REC_STATUS = 'U'
      WHERE HISTORY_ID = h_history_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(228) : scd_func.sql(1232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET REVISION_HISTORY = Null
      WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_CRI_SC', 246+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_CRI_SC(247) : scd_func.sql(1251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 252+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI_SC(253) : scd_func.sql(1257) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_CRI_SC', 256+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_CRI_SC(257) : scd_func.sql(1261) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ATTACH_CRI_SC;
ALTER FUNCTION FC_I_ATTACH_CRI_SC COMPILE DEBUG;

Prompt == FUNCTION FC_I_ATTACH_RES_SC ==
CREATE OR REPLACE FUNCTION FC_I_ATTACH_RES_SC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_full_name VARCHAR2(255);
   h_transfer_flag VARCHAR2(1);
   h_history_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_temp_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_parent_type_id PLS_INTEGER := 0;
   h_assign_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ATTACH_RES_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ATTACH_RES_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ATTACH_RES_SC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ATTACH_RES_SC(45) : scd_func.sql(1314) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'RES';
   
   BEGIN
      SELECT NICK_NAME INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(63) : scd_func.sql(1332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID
      INTO h_parent_rank, h_rank, h_temp_project_id, h_level_id, h_parent_type_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_parent_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(79) : scd_func.sql(1348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_RES_SC(85) : scd_func.sql(1354) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_project_id IS NULL) Then
      h_project_id := h_temp_project_id;
   End If;
   
   -- verify type_id of the parent
   PMO_DB2M.SC_STATE := FC_VALID_TYPE_RES_SC(h_parent_type_id);
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      h_element_id := h_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_RES_SC(99) : scd_func.sql(1368) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(116) : scd_func.sql(1385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 122+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_RES_SC(123) : scd_func.sql(1392) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET SCORECARD_COUNT = SCORECARD_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(143) : scd_func.sql(1412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   
   PMO_DB2M.SC_STATE := FC_INSERT_RES_SC(h_foreign_table, h_project_id, h_name, h_element_id
                                      , h_level_id, h_parent_id, h_foreign_id, h_parent_rank
                                      , h_type_id, h_parent_type_id, h_rank, h_full_name
                                      , h_rec_user);
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 158+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_RES_SC(159) : scd_func.sql(1428) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   --    h_temp_sc_state = GetSecurityID(h_host_table,h_type_id,SC_RESPONSIBLE_GROUP,SC_PARAM(h_security_id));
   --
   --    getUniqueID(h_assign_id);
   --    BEGIN_SQL
   --        INSERT INTO RESOURCE_ASSIGNMENTS(
   --            RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
   --            PARTICIPANT,
   --            SECURITY_ID,
   --            RESOURCE_TYPE, REC_USER,TABLE_TYPE)
   --        VALUES(
   --            HOST(h_assign_id), HOST(h_project_id), HOST(h_uniqueID), HOST(h_type_id), HOST(h_rec_user),
   --                        CASE WHEN HOST(h_host_table) = SC_TABLE_SCD        THEN SC_SCORECARD_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_TASK            THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_MILESTONE       THEN SC_TASK_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_REQUIREMENT     THEN SC_REQUIREMENT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_CHANGE_REQUEST  THEN SC_CHANGE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_DEFECT          THEN SC_DEFECT_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_SERVICE_REQUEST THEN SC_SERVICE_REQUEST_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_ISSUE           THEN SC_ISSUE_RESPONSIBLE
   --                             WHEN HOST(h_type_id) = SC_CRI_RISK            THEN SC_RISK_RESPONSIBLE
   --                 WHEN HOST(h_type_id) = SC_CRI_ACTION_ITEM     THEN SC_ACTION_ITEM_RESPONSIBLE
   --                             else SC_DLV_MANAGER END,
   --                        HOST(h_security_id),
   --            '0', HOST(h_rec_user),HOST(h_host_table));
   --    END_SQL;
   
   If Coalesce(h_type_id, 0) <> PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   h_history_id := SYS_GUID();
   BEGIN
      INSERT INTO HISTORY_ASSIGNED_SCORECARDS
      SELECT h_history_id, A.* FROM TMT_ASSIGNED_SCORECARDS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 208+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(209) : scd_func.sql(1478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_ASSIGNED_SCORECARDS
      SET REC_STATUS = 'U'
      WHERE HISTORY_ID = h_history_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(228) : scd_func.sql(1497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET REVISION_HISTORY = Null
      WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ATTACH_RES_SC', 246+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ATTACH_RES_SC(247) : scd_func.sql(1516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 252+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_RES_SC(253) : scd_func.sql(1522) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ATTACH_RES_SC', 256+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ATTACH_RES_SC(257) : scd_func.sql(1526) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ATTACH_RES_SC;
ALTER FUNCTION FC_I_ATTACH_RES_SC COMPILE DEBUG;

Prompt == FUNCTION FC_DELETE_SC ==
CREATE OR REPLACE FUNCTION FC_DELETE_SC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_xsql VARCHAR2(5999);
   h_active_flag VARCHAR2(1);
   h_current_timestamp TIMESTAMP;
   h_current_rank VARCHAR2(200);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_source_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_converted_score NUMBER(19) := 0;
   h_converted_weight NUMBER(19) := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_parent_rank VARCHAR2(32);
   h_prefix VARCHAR2(255);
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_SC PMO_DB2M.REF_CURSOR;

      CURSOR C_SC_COUNT IS
         SELECT SUBSTR(PARENT_RANK, 1, 3), SUBSTR(PARENT_RANK, 5, LENGTH(PARENT_RANK)-4),
         PUBLISHED_DT, ACTIVE, CONVERTED_SCORE, CONVERTED_WEIGHT
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_rank || '%' AND LEVEL_ID = 2
         UNION ALL
         SELECT SUBSTR(C.PARENT_RANK, 1, 3), SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)-4),
         C.PUBLISHED_DT, C.ACTIVE, C.CONVERTED_SCORE, C.CONVERTED_WEIGHT
         FROM TMT_ASSIGNED_SCORECARDS C, TMT_ASSIGNED_SCORECARDS P
         WHERE C.RANK LIKE h_rank || '%' AND C.LEVEL_ID > 2
         AND P.ELEMENT_ID = C.PARENT_ID
         AND C.PARENT_RANK <> P.PARENT_RANK;

      CURSOR C_WORKFLOW IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DELETE_SC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DELETE_SC'), '-- ' || SYSTIMESTAMP, ':r := FC_DELETE_SC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_SC', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DELETE_SC(56) : scd_func.sql(1590) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_SC', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_SC(61) : scd_func.sql(1595) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   If (h_id IS NULL) Then
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID, PROJECT_ID, PARENT_RANK, SUBSTR(PARENT_RANK, 1, 3) FROM TMT_ASSIGNED_SCORECARDS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID, PROJECT_ID, PARENT_RANK, SUBSTR(PARENT_RANK, 1, 3) FROM TMT_ASSIGNED_SCORECARDS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   h_xsql := SubStr(h_xsql || '  ', 1, 5999);
   
   OPEN C_SC FOR h_xsql;
   
   LOOP
      FETCH C_SC INTO h_rank, h_rec_status, h_parent_type_id, h_project_id, h_parent_rank, h_prefix;
      IF C_SC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- UPDATE CHILD_COUNT
      
      OPEN C_SC_COUNT;
      
      LOOP
         FETCH C_SC_COUNT INTO h_target_parent_rank, h_source_parent_rank,
         h_current_timestamp, h_active_flag, h_converted_score, h_converted_weight;
         IF C_SC_COUNT%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If PMO_ORASTD.strcmp(h_target_parent_rank, 'WBS') = PMO_CNST.SC_MATCH Then
            If ((h_current_timestamp IS NOT NULL)) AND (PMO_ORASTD.strcmp(h_active_flag
                  , '1') = PMO_CNST.SC_MATCH) Then
               BEGIN
                  UPDATE TMT_WBS
                  SET SCORECARD_COUNT  = SCORECARD_COUNT - 1,
                  CONVERTED_SCORE  = CONVERTED_SCORE - h_converted_score,
                  CONVERTED_WEIGHT = CASE WHEN CONVERTED_WEIGHT - h_converted_weight = 0 THEN 1 ELSE CONVERTED_WEIGHT - h_converted_weight END
                  WHERE RANK = h_source_parent_rank;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 124+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(125) : scd_func.sql(1659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_WBS
                  SET SCORECARD_COUNT  = SCORECARD_COUNT - 1
                  WHERE RANK = h_source_parent_rank;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 143+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(144) : scd_func.sql(1678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf PMO_ORASTD.strcmp(h_target_parent_rank, 'CRI') = PMO_CNST.SC_MATCH Then
            BEGIN
               UPDATE TMT_CRI
               SET SCORECARD_COUNT  = SCORECARD_COUNT - 1,
               CONVERTED_SCORE  = CONVERTED_SCORE - h_converted_score,
               CONVERTED_WEIGHT = CASE WHEN CONVERTED_WEIGHT - h_converted_weight = 0 THEN 1 ELSE CONVERTED_WEIGHT - h_converted_weight END
               WHERE RANK = h_source_parent_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 165+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(166) : scd_func.sql(1700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf PMO_ORASTD.strcmp(h_target_parent_rank, 'RES') = PMO_CNST.SC_MATCH Then
            BEGIN
               UPDATE TMT_POOLS
               SET SCORECARD_COUNT  = SCORECARD_COUNT - 1
               WHERE RANK = h_source_parent_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 184+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(185) : scd_func.sql(1719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf PMO_ORASTD.strcmp(h_target_parent_rank, 'AST') = PMO_CNST.SC_MATCH Then
            BEGIN
               UPDATE TMT_ASSETS
               SET SCORECARD_COUNT  = SCORECARD_COUNT - 1,
               CONVERTED_SCORE  = CONVERTED_SCORE - h_converted_score,
               CONVERTED_WEIGHT = CASE WHEN CONVERTED_WEIGHT - h_converted_weight = 0 THEN 1 ELSE CONVERTED_WEIGHT - h_converted_weight END
               WHERE RANK = h_source_parent_rank;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 205+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(206) : scd_func.sql(1740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE C_SC_COUNT ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 222+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(223) : scd_func.sql(1757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --PARENT IN TMT_ASSIGNEND_SCORECARDS
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_ASSIGNED_SCORECARDS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 243+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(244) : scd_func.sql(1778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSIGNED_SCORECARDS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 262+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(263) : scd_func.sql(1797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      COMMIT;
      
      --WORKFLOW
      
      OPEN C_WORKFLOW;
      
      LOOP
         FETCH C_WORKFLOW INTO h_current_rank;
         IF C_WORKFLOW%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_current_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_current_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_current_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_current_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(315) : scd_func.sql(1849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_current_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 334+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(335) : scd_func.sql(1869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE C_WORKFLOW ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 350+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(351) : scd_func.sql(1885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM HISTORY_PUBLISHED_SCORECARDS
         WHERE SCORECARD_ID IN (
         SELECT DISTINCT ELEMENT_ID
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 371+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(372) : scd_func.sql(1906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_PUBLISHED_SCORECARDS
         WHERE SCORECARD_ID IN (
         SELECT DISTINCT ELEMENT_ID
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 392+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(393) : scd_func.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM HISTORY_ASSIGNED_SCORECARDS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 423+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(424) : scd_func.sql(1958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 442+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(443) : scd_func.sql(1977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 460+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(461) : scd_func.sql(1995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   If PMO_ORASTD.strcmp(h_prefix, 'WBS') = PMO_CNST.SC_MATCH Then
      --Safwan: Reusing Rank for something else, its original value is not valid past this condition.
      BEGIN
         SELECT RANK , SUBSTR(h_parent_rank,5,LENGTH(h_parent_rank) - 4)
         INTO h_project_rank, h_current_rank
         FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(480) : scd_func.sql(2014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strcmp(h_project_rank, h_current_rank) = PMO_CNST.SC_MATCH Then
         --Updating Project
         
         BEGIN
            UPDATE PROJECT_DETAILS SET
            (   SCOPE_SCORE, SCOPE_WEIGHT, SCHEDULE_SCORE,
            SCHEDULE_WEIGHT, QUALITY_SCORE, QUALITY_WEIGHT,
            BENEFIT_SCORE, BENEFIT_WEIGHT, COST_SCORE, COST_WEIGHT) =
            (
            SELECT
            SUM(H.SCOPE_SCORE), SUM(H.SCOPE_WEIGHT),
            SUM(H.SCHEDULE_SCORE), SUM(H.SCHEDULE_WEIGHT),
            SUM(H.QUALITY_SCORE), SUM(H.QUALITY_WEIGHT),
            SUM(H.BENEFIT_SCORE), SUM(H.BENEFIT_WEIGHT),
            SUM(H.COST_SCORE), SUM(H.COST_WEIGHT)
            FROM TMT_ASSIGNED_SCORECARDS A
            JOIN HISTORY_ASSIGNED_SCORECARDS H
            ON H.ELEMENT_ID = A.ELEMENT_ID
            AND H.MAJOR_REVISION = A.MAJOR_REVISION
            WHERE A.PARENT_RANK = h_parent_rank AND A.ACTIVE = '1'
            AND A.TYPE_ID = PMO_CNST.SC_SCORECARD
            )
            WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 517+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(518) : scd_func.sql(2052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   BEGIN
      CLOSE C_SC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_SC', 532+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_SC(533) : scd_func.sql(2067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_SC', 538+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_SC(539) : scd_func.sql(2073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DELETE_SC;
ALTER FUNCTION FC_DELETE_SC COMPILE DEBUG;

Prompt == FUNCTION FC_D_SCD_BY_RANK ==
CREATE OR REPLACE FUNCTION FC_D_SCD_BY_RANK
(
     sh_h_foreign_table PLS_INTEGER
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_prefix VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ass_sc IS
         SELECT ELEMENT_ID, PARENT_ID
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE PARENT_RANK = h_prefix || RTRIM(h_rank)
         AND TYPE_ID <> PMO_CNST.SC_CUSTOM_FOLDER;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SCD_BY_RANK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SCD_BY_RANK'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SCD_BY_RANK(' || 
       COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SCD_BY_RANK', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SCD_BY_RANK(29) : scd_func.sql(2110) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_sc_state := GetPrefixName(Coalesce(h_foreign_table, 0), h_prefix);
   
   OPEN C_ass_sc;
   
   FETCH C_ass_sc INTO h_id, h_parent_id;
   IF C_ass_sc%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
      PMO_DB2M.SC_STATE := FC_DELETE_SC(h_id, h_parent_id, h_rec_user);
      
      FETCH C_ass_sc INTO h_id, h_parent_id;
      IF C_ass_sc%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   END LOOP;
   
   BEGIN
      CLOSE C_ass_sc ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SCD_BY_RANK', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SCD_BY_RANK(62) : scd_func.sql(2143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SCD_BY_RANK', 67+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SCD_BY_RANK(68) : scd_func.sql(2149) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SCD_BY_RANK;
ALTER FUNCTION FC_D_SCD_BY_RANK COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_SCD ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_SCD
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_SCD(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_SCD', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_SCD(24) : scd_func.sql(2181) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_SCD', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_SCD(28) : scd_func.sql(2185) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_SCD', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_SCD(32) : scd_func.sql(2189) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_SCD;
ALTER FUNCTION FC_U_ATTACHMENT_SCD COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_SCD ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_SCD
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_SCD(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_SCD', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_SCD(31) : scd_func.sql(2228) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(47) : scd_func.sql(2244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(67) : scd_func.sql(2264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(89) : scd_func.sql(2286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(108) : scd_func.sql(2305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(132) : scd_func.sql(2329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(151) : scd_func.sql(2348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(174) : scd_func.sql(2371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(193) : scd_func.sql(2390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(219) : scd_func.sql(2416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_SCD', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_SCD(238) : scd_func.sql(2435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_SCD', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_SCD(248) : scd_func.sql(2445) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_SCD', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_SCD(252) : scd_func.sql(2449) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_SCD;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_SCD COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_SCD ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_SCD
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_SCD IS
         SELECT RANK
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_SCD(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_SCD', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_SCD(36) : scd_func.sql(2493) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_SCD', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_SCD(50) : scd_func.sql(2507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_SCD;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_SCD INTO h_cur_rank;
      IF MVUP_SCD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_SCD(h_target_project_id, h_source_project_id, h_cur_rank
                                         , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_SCD', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_SCD(104) : scd_func.sql(2561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_SCD ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_SCD', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_SCD(119) : scd_func.sql(2576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_SCD', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_SCD(152) : scd_func.sql(2609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_SCD', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_SCD(158) : scd_func.sql(2615) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_SCD', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_SCD(162) : scd_func.sql(2619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_SCD;
ALTER FUNCTION FC_MOVE_UP_SCD COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_SCD ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_SCD
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_SCD IS
         SELECT RANK
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_SCD(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_SCD', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_SCD(36) : scd_func.sql(2663) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_SCD', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_SCD(50) : scd_func.sql(2677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_SCD;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_SCD INTO h_cur_rank;
      IF MVDOWN_SCD%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_SCD(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_SCD', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_SCD(102) : scd_func.sql(2729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_SCD ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_SCD', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_SCD(117) : scd_func.sql(2744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_SCD', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_SCD(150) : scd_func.sql(2777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_SCD', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_SCD(156) : scd_func.sql(2783) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_SCD', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_SCD(160) : scd_func.sql(2787) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_SCD;
ALTER FUNCTION FC_MOVE_DOWN_SCD COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_SCD ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_SCD
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_SCD(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_SCD', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_SCD(46) : scd_func.sql(2841) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_SCD', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_SCD(107) : scd_func.sql(2902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_SCD', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_SCD(127) : scd_func.sql(2922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_SCD', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_SCD(142) : scd_func.sql(2937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = h_rec_user,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_SCD', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_SCD(180) : scd_func.sql(2975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_SCD(h_target_project_id, h_source_project_id, h_rankBase64
                                         , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_SCD', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_SCD(211) : scd_func.sql(3006) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_SCD', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_SCD(218) : scd_func.sql(3013) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_SCD', 221+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_SCD(222) : scd_func.sql(3017) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_SCD;
ALTER FUNCTION FC_MOVE_APPEND_SCD COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_SCD ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_SCD
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_SCD'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_SCD(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_SCD(50) : scd_func.sql(3075) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, PARENT_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(71) : scd_func.sql(3096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(79) : scd_func.sql(3104) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(87) : scd_func.sql(3112) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      PARENT_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_ASSIGNED_SCORECARDS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(107) : scd_func.sql(3132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(115) : scd_func.sql(3140) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(124) : scd_func.sql(3149) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(132) : scd_func.sql(3157) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(151) : scd_func.sql(3176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE RANK LIKE h_current_rank || '%'
         AND PARENT_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(167) : scd_func.sql(3192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(185) : scd_func.sql(3210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE RANK LIKE h_current_rank || '%' AND PARENT_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(201) : scd_func.sql(3226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(209) : scd_func.sql(3234) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE RANK LIKE h_current_rank || '%' AND PARENT_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(225) : scd_func.sql(3250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_ASSIGNED_SCORECARDS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(243) : scd_func.sql(3268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_ASSIGNED_SCORECARDS
               WHERE RANK LIKE h_current_rank || '%'
               AND PARENT_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(259) : scd_func.sql(3284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(267) : scd_func.sql(3292) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(281) : scd_func.sql(3306) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(288) : scd_func.sql(3313) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(301) : scd_func.sql(3326) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_SCD(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_SCD(h_project_id, h_source_project_id, h_target_level
                                      , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(330) : scd_func.sql(3355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_SCD(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank
                                        , h_target_parent_id, h_source_id, h_target_type_id
                                        , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_SCD(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
         
         BEGIN
            UPDATE TMT_ASSIGNED_SCORECARDS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 357+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(358) : scd_func.sql(3383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSIGNED_SCORECARDS
            SET DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_target_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 376+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(377) : scd_func.sql(3402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 393+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(394) : scd_func.sql(3419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 408+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(409) : scd_func.sql(3434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_SCD(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_SCD(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank, h_target_id
                                        , h_source_id, h_target_type_id, h_rec_user, h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_SCD(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
      
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 443+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(444) : scd_func.sql(3469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSIGNED_SCORECARDS
         SET DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_target_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_SCD', 462+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_SCD(463) : scd_func.sql(3488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 473+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(474) : scd_func.sql(3499) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_SCD', 477+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_SCD(478) : scd_func.sql(3503) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_SCD;
ALTER FUNCTION FC_M_ATTACH_SCD COMPILE DEBUG;

