/****************************************************************************************/

Prompt == FUNCTION SP_S_SCENARIO_NAME ==
CREATE OR REPLACE FUNCTION SP_S_SCENARIO_NAME
(
     p_ids VARCHAR2
   , p_bigflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ViewSName PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      ViewSName_ND PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SCENARIO_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SCENARIO_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SCENARIO_NAME(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_bigflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO_NAME', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SCENARIO_NAME(24) : scenarios.sql(27) : ' || SYSTIMESTAMP);
   END IF; 

   --Vardan added the following code to cleanup a table "tmt_scenarios" from the deleted projects in WBS
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM Lev_D_scenarios_1';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM Lev_D_scenarios_2';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM Lev_D_scenarios_3';
   PMO_DB2M.SC_STATE := 0;
   BEGIN
      INSERT INTO Lev_D_scenarios_1
      (ELEMENT_ID,PARENT_ID) 
      SELECT S.ELEMENT_ID,S.PARENT_ID 
      FROM TMT_SCENARIOS S
      WHERE NOT EXISTS (SELECT PROJECT_ID FROM PROJECT_DETAILS WHERE PROJECT_ID = S.ELEMENT_ID)
      AND S.PARENT_ID IS NOT NuLL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(56) : scenarios.sql(59) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO Lev_D_scenarios_2
      SELECT PARENT_ID 
      FROM Lev_D_scenarios_1
      GROUP BY PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(76) : scenarios.sql(79) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM TMT_SCENARIOS 
      WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM Lev_D_scenarios_1)
      AND PARENT_ID IS NOT NuLL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(95) : scenarios.sql(98) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO Lev_D_scenarios_3 
      (PARENT_ID)
      SELECT QS.PARENT_ID 
      FROM Lev_D_scenarios_2 QS
      WHERE NOT EXISTS (SELECT PARENT_ID FROM TMT_SCENARIOS WHERE PARENT_ID = QS.PARENT_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(116) : scenarios.sql(119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      DELETE FROM TMT_SCENARIOS
      WHERE SCENARIO_ID IN (SELECT PARENT_ID FROM Lev_D_scenarios_3)
      AND PARENT_ID IS NuLL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 133+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(134) : scenarios.sql(137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM Lev_scenario_name';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO Lev_scenario_name 				
      SELECT  0				 AS LEVEL_ID
      ,	P.TYPE_ID
      ,	P.RANK
      ,	P.PARENT_ID
      ,	P.ELEMENT_ID
      ,	case WHEN LENGTH(RTRIM(P.ELEMENT_NAME)) < 50 
      THEN RTRIM(P.ELEMENT_NAME) 
      ELSE substr(RTRIM(P.ELEMENT_NAME),1,49) END
      AS TO_CALCULATE
      ,	P.CHILD_COUNT
      ,	P.DELETED_COUNT
      ,	P.REC_USER	     AS SCENARIO_OWNER
      ,	A.REC_STATUS 			
      ,	R.RESOURCE_ID	 AS REC_USER		
      ,	R.FULL_NAME		 AS REC_USER_NAME
      ,	A.REC_DATETIME
      ,	COALESCE(P.TO_CALCULATE,0) AS TO_CALCULATE
      ,	case WHEN EXISTS (SELECT S2.ELEMENT_ID
      FROM TMT_SCENARIOS S1 
      JOIN TMT_SCENARIOS S2 
      ON S2.SCENARIO_ID = S1.ELEMENT_ID 
      AND S2.TYPE_ID <> PMO_CNST.SC_SCENARIO 
      AND S2.LEVEL_FINISH IS NULL 
      WHERE S1.TO_CALCULATE = 1)
      
      THEN 1 
      WHEN EXISTS	     (SELECT S2.ELEMENT_ID
      FROM TMT_SCENARIOS S1 
      JOIN TMT_SCENARIOS S2 
      ON S2.SCENARIO_ID = S1.ELEMENT_ID 
      AND S2.TYPE_ID <> PMO_CNST.SC_SCENARIO 
      AND S2.LEVEL_FINISH = S2.PROJECT_FINISH
      WHERE S1.TO_CALCULATE = 2)
      THEN 2 
      ELSE 0 END AS		CALCULATE_STATUS
      ,	case WHEN EXISTS   (SELECT S1.ELEMENT_ID
      FROM TMT_SCENARIOS S1
      WHERE P.RANK < S1.RANK
      AND LENGTH(P.RANK) < LENGTH(S1.RANK)
      AND PMO_ORASTD.LEFT(S1.RANK, LENGTH(P.RANK)) = P.RANK
      AND S1.LEVEL_FINISH IS NULL )
      THEN 1 ELSE 0 END AS CALCULATE_FLAG 
      ,	case WHEN EXISTS   (SELECT S1.ELEMENT_ID
      FROM TMT_SCENARIOS S1
      JOIN PROJECT_DETAILS DT 
      ON DT.PROJECT_ID = S1.ELEMENT_ID 
      AND DT.LEVEL_LAST_CALL_OPTION = 4 
      WHERE P.RANK < S1.RANK
      AND LENGTH(P.RANK) < LENGTH(S1.RANK)
      AND PMO_ORASTD.LEFT(S1.RANK, LENGTH(P.RANK)) = P.RANK)
      THEN 1 ELSE 0 END AS CALCULATE_OPTION
      FROM TMT_SCENARIOS A 
      JOIN RESOURCES R 
      ON R.RESOURCE_ID = A.REC_USER
      JOIN TMT_SCENARIOS P 
      ON P.RANK > A.RANK 
      AND LENGTH(P.RANK) > LENGTH(A.RANK) 
      AND PMO_ORASTD.LEFT(P.RANK, LENGTH(A.RANK)) = A.RANK 
      AND P.TYPE_ID = PMO_CNST.SC_SCENARIO
      WHERE A.RANK = '0000';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 213+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(214) : scenarios.sql(217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(REC_STATUS) INTO h_count
      FROM Lev_scenario_name;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 227+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(228) : scenarios.sql(231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      OPEN ViewSName FOR SELECT	LEVEL_ID
      ,	TYPE_ID
      ,	RANK
      ,	PARENT_ID
      ,	ELEMENT_ID
      ,	ELEMENT_NAME
      ,	CHILD_COUNT
      ,	DELETED_COUNT				
      ,	SCENARIO_OWNER
      ,	REC_STATUS 
      ,	REC_USER
      ,	REC_USER_NAME
      ,	REC_DATETIME
      ,	TO_CALCULATE					
      ,	CALCULATE_STATUS
      ,	CALCULATE_FLAG 
      ,	CALCULATE_OPTION
      FROM Lev_scenario_name 
      ORDER BY TO_CALCULATE DESC, RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO_NAME', 253+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCENARIO_NAME(254) : scenarios.sql(257) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN ViewSName;
   Else
      OPEN ViewSName_ND FOR SELECT		0				           AS LEVEL_ID
      ,	0				           AS TYPE_ID
      ,	'0000'			           AS RANK
      ,	''				           AS PARENT_ID
      ,	''				           AS ELEMENT_ID
      ,	''				           AS ELEMENT_NAME
      ,	0				           AS CHILD_COUNT
      ,	0				           AS DELETED_COUNT
      ,   ''                         AS SCENARIO_OWNER
      ,	A.REC_STATUS               AS REC_STATUS
      ,   COALESCE(R.RESOURCE_ID,'') AS REC_USER
      ,   COALESCE(R.FULL_NAME,'')   AS REC_USER_NAME
      ,   A.REC_DATETIME             AS REC_DATETIME
      ,   0                          AS TO_CALCULATE
      ,   0                          AS CALCULATE_STATUS
      ,   0                          AS CALCULATE_FLAG
      ,   0                          AS CALCULATE_OPTION
      FROM TMT_SCENARIOS A 
      JOIN RESOURCES R
      ON R.RESOURCE_ID = A.REC_USER
      WHERE A.RANK = '0000';
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO_NAME', 279+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCENARIO_NAME(280) : scenarios.sql(283) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN ViewSName_ND;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 288+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(289) : scenarios.sql(292) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO_NAME', 300+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO_NAME(301) : scenarios.sql(304) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SCENARIO_NAME;
ALTER FUNCTION SP_S_SCENARIO_NAME COMPILE DEBUG;

/****************************************************************************************
SP_S_SCENARIO:
    Display project(s) list in the Portolio Management What If Analysis
p_type_id:
    1: Portfolio Folder(s)
    2: Project Type Node(s)
p_ids:
    When p_type_id = 1: Portfolio Id(s)
    When p_type_id = 2: Project Id(s)
p_scenario_id:
    When null: do not fetch records from TMT_SCENARIOS
    When not null: do UNION all with project(s) list and record(s) from TMT_SCENARIOS
P_rec_user:
    User id: the requestor
****************************************************************************************/

Prompt == FUNCTION SP_S_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_S_SCENARIO
(
     p_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_scenario_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_scenario_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ViewScenarios PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SCENARIO(' || 
       COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || '''' || p_scenario_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SCENARIO(32) : scenarios.sql(366) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_SCENARIO', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_SCENARIO(37) : scenarios.sql(371) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCENARIO(40) : scenarios.sql(374) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --What If Scenarios Project(s) List
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WIS_PRJS';
   PMO_DB2M.SC_STATE := 0;
   
   --Work Breakdown Structure Project(s) List
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WBS_PRJS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Declare host variables
   
   -- Local variable initialization
   h_type := p_type;
   h_ids := p_ids;
   h_scenario_id := p_scenario_id;
   h_resource_id := p_rec_user;
   h_start_date := NULL;
   h_finish_date := NULL;
   
   -- Project(s) list initialization
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   h_temp_sc_state := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_resource_id);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   If h_temp_sc_state <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_SCENARIO', 80+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_SCENARIO(81) : scenarios.sql(415) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCENARIO(84) : scenarios.sql(418) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(h_temp_sc_state, True);
   End If;
   
   -- Project(s) list initialization
   If (h_scenario_id IS NOT NULL) Then
      BEGIN
         INSERT INTO PMO_WIS_PRJS (
         LEVEL_ID, 
         TYPE_ID,
         TO_CALCULATE,
         PRIORITY,
         SCENARIO_ID,
         PARENT_ID,
         ELEMENT_ID,
         REC_USER,
         REC_DATETIME,
         PROJECT_START,
         PROJECT_FINISH,
         LEVEL_START,
         LEVEL_FINISH,
         WBS_LEVEL_START,
         WBS_LEVEL_FINISH,
         ELEMENT_NAME,
         RANK, 
         SUBPROJECT_COUNT )
         SELECT  W.LEVEL_ID, 
         W.TYPE_ID,
         1,
         S.PRIORITY,
         S.SCENARIO_ID,
         W.PARENT_ID, 
         W.ELEMENT_ID,
         S.REC_USER,
         S.REC_DATETIME,
         TO_DATE(SubStr(W.START_DT, 1, 10)),                             --as PROJECT_START
         CASE WHEN TO_DATE(SubStr(W.FINISH_DT, 1, 10)) < COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))) THEN COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))) ELSE TO_DATE(SubStr(W.FINISH_DT, 1, 10)) END, --as PROJECT_FINISH
         S.LEVEL_START,                                --as LEVEL_START					   	
         S.LEVEL_FINISH,
         PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.START_DT, 1, 10)),'08:00:00'), --as WBS_LEVEL_START
         CASE WHEN TO_DATE(SubStr(W.FINISH_DT, 1, 10)) < COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))) THEN PMO_ORASTD.DB2TIMESTAMP(COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))),'17:00:00') ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.FINISH_DT, 1, 10)),'17:00:00') END, --as WBS_LEVEL_FINISH
         W.ELEMENT_NAME,
         '0001' || RTRIM(W.RANK), 
         W.SUBPROJECT_COUNT
         FROM TMT_SCENARIOS S
         JOIN TMT_WBS W ON W.ELEMENT_ID = S.ELEMENT_ID
         WHERE S.SCENARIO_ID = h_scenario_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO(142) : scenarios.sql(476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Exclude records from TMT_SCENARIOS
   -- All root project(s) + their sub project(s)
   BEGIN
      INSERT INTO PMO_WBS_PRJS(
      LEVEL_ID, 
      TYPE_ID,
      TO_CALCULATE,
      PRIORITY,
      PARENT_ID,
      ELEMENT_ID,
      REC_USER,
      REC_DATETIME,
      PROJECT_START,
      PROJECT_FINISH,
      LEVEL_START,
      WBS_LEVEL_START,
      WBS_LEVEL_FINISH,
      ELEMENT_NAME,
      RANK, 
      SUBPROJECT_COUNT )
      SELECT  W.LEVEL_ID, 
      W.TYPE_ID,
      0 AS TO_CALCULATE,
      W.PRIORITY,
      W.PARENT_ID,
      W.ELEMENT_ID,
      h_resource_id,
      SYSTIMESTAMP,
      TO_DATE(SubStr(W.START_DT, 1, 10)),                              --as PROJECT_START
      CASE WHEN TO_DATE(SubStr(W.FINISH_DT, 1, 10)) < COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))) THEN COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))) ELSE TO_DATE(SubStr(W.FINISH_DT, 1, 10)) END, --as PROJECT_FINISH
      PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.START_DT, 1, 10)),'08:00:00'),  --as LEVEL_START
      PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.START_DT, 1, 10)),'08:00:00'),  --as WBS_LEVEL_START
      CASE WHEN TO_DATE(SubStr(W.FINISH_DT, 1, 10)) < COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))) THEN PMO_ORASTD.DB2TIMESTAMP(COALESCE(W.FINISH_START_DATE,TO_DATE(SubStr(W.FINISH_DT, 1, 10))),'17:00:00') ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.FINISH_DT, 1, 10)),'17:00:00') END, --as WBS_LEVEL_FINISH
      W.ELEMENT_NAME,
      '0002' || RTRIM(W.RANK), 
      W.SUBPROJECT_COUNT
      FROM PMO_PVT_PROJECTS W
      WHERE NOT EXISTS(SELECT ELEMENT_ID FROM PMO_WIS_PRJS WHERE ELEMENT_ID = W.ELEMENT_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO', 195+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO(196) : scenarios.sql(530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   
   OPEN ViewScenarios FOR SELECT
   CASE WHEN EXISTS(SELECT ELEMENT_ID FROM PMO_WIS_PRJS WHERE ELEMENT_ID = P.PARENT_ID) THEN P.LEVEL_ID ELSE 0 END AS LEVEL_ID, 
   P.TYPE_ID,
   P.RANK,
   P.PARENT_ID,
   P.ELEMENT_ID,
   P.ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   P.REC_USER,
   P.REC_DATETIME,
   P.SUBPROJECT_COUNT, 
   P.SCENARIO_ID,
   1 AS GROUP_ID,
   P.TO_CALCULATE,
   P.PRIORITY,
   P.PROJECT_START,
   P.PROJECT_FINISH,
   COALESCE(TO_DATE(SubStr(P.LEVEL_START, 1, 10)), P.PROJECT_START) AS LEVEL_START,
   P.LEVEL_FINISH,
   P.WBS_LEVEL_START,
   P.WBS_LEVEL_FINISH,
   PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(P.LEVEL_FINISH, 1, 10)), P.PROJECT_FINISH)) - PMO_ORASTD.JULIAN_DAY(P.PROJECT_FINISH) AS LEVEL_VARIANCE,
   CASE WHEN P.LEVEL_FINISH IS NULL THEN 24 ELSE 13 END AS CALCULATE_INDICATOR
   FROM PMO_WIS_PRJS P
   
   UNION ALL
   
   SELECT
   CASE WHEN EXISTS(SELECT ELEMENT_ID FROM PMO_WBS_PRJS WHERE ELEMENT_ID = P.PARENT_ID) THEN P.LEVEL_ID ELSE 0 END AS LEVEL_ID, 
   P.TYPE_ID,
   P.RANK,
   P.PARENT_ID,
   P.ELEMENT_ID,
   P.ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   P.REC_USER,
   P.REC_DATETIME,
   P.SUBPROJECT_COUNT, 
   P.SCENARIO_ID,
   2 AS GROUP_ID,
   P.TO_CALCULATE,
   P.PRIORITY,
   P.PROJECT_START,
   P.PROJECT_FINISH,
   COALESCE(TO_DATE(SubStr(P.LEVEL_START, 1, 10)), P.PROJECT_START) AS LEVEL_START,
   P.LEVEL_FINISH,
   P.WBS_LEVEL_START,
   P.WBS_LEVEL_FINISH,
   PMO_ORASTD.JULIAN_DAY(COALESCE(TO_DATE(SubStr(P.LEVEL_FINISH, 1, 10)), P.PROJECT_FINISH)) - PMO_ORASTD.JULIAN_DAY(P.PROJECT_FINISH) AS LEVEL_VARIANCE,
   24 AS CALCULATE_INDICATOR
   FROM PMO_WBS_PRJS P
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SCENARIO', 262+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_SCENARIO(263) : scenarios.sql(597) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewScenarios;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO', 270+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO(271) : scenarios.sql(605) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SCENARIO', 282+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SCENARIO(283) : scenarios.sql(617) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SCENARIO;
ALTER FUNCTION SP_S_SCENARIO COMPILE DEBUG;

/****************************************************************************************
SP_I_SCENARIO:
    This stored procedure is for scenario type only
    For project type use SP_A_PRJ_SCENARIO
****************************************************************************************/

Prompt == FUNCTION SP_I_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_I_SCENARIO
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_I_SCENARIO(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_SCENARIO', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_SCENARIO(27) : scenarios.sql(664) : ' || SYSTIMESTAMP);
   END IF; 

   h_uniqueID := SYS_GUID();
   
   If (p_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCENARIOS', h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --fixed, vardan
      BEGIN
         INSERT INTO TMT_SCENARIOS (
         RANK,
         PARENT_ID,
         SCENARIO_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         REC_USER )
         SELECT  RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         p_parent_id,
         h_uniqueID,
         h_uniqueID,
         case WHEN LENGTH(RTRIM(p_name)) < 50 
         THEN RTRIM(p_name)
         ELSE substr(RTRIM(p_name),1,49) END AS ELEMENT_NAME,
         p_type_id,
         LEVEL_ID + 1,
         p_rec_user
         FROM TMT_SCENARIOS
         WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SCENARIO', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SCENARIO(70) : scenarios.sql(707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_SCENARIO', 76+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_SCENARIO(77) : scenarios.sql(714) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SCENARIOS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_SCENARIOS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      --trace_printf("\n\n");
      --trace_printf("\n***** SP_I_SCENARIO: h_parent_id = %s h_rec_status = %s \n\n",h_parent_id,h_rec_status);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCENARIOS', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --fixed, vardan
      BEGIN
         INSERT INTO TMT_SCENARIOS (
         RANK,
         PARENT_ID,
         SCENARIO_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         REC_USER )
         SELECT  RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         p_parent_id,
         h_uniqueID,
         h_uniqueID,
         case WHEN LENGTH(RTRIM(p_name)) < 50 
         THEN RTRIM(p_name)
         ELSE substr(RTRIM(p_name),1,49) END AS ELEMENT_NAME,
         p_type_id,
         LEVEL_ID + 1,
         p_rec_user
         FROM TMT_SCENARIOS
         WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SCENARIO', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SCENARIO(128) : scenarios.sql(765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_SCENARIO', 134+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_SCENARIO(135) : scenarios.sql(772) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SCENARIO', 141+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SCENARIO(142) : scenarios.sql(779) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SCENARIO', 153+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SCENARIO(154) : scenarios.sql(791) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_SCENARIO;
ALTER FUNCTION SP_I_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_U_SCENARIO
(
     p_id VARCHAR2
   , p_scenario_id VARCHAR2
   , p_name VARCHAR2
   , p_to_calculate PLS_INTEGER
   , p_priority PLS_INTEGER
   , p_level_start VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_scenario_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
   h_update PLS_INTEGER := 0;
   h_S TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_scenario_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_to_calculate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || '''' || p_level_start || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SCENARIO', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SCENARIO(34) : scenarios.sql(841) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_scenario_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SCENARIO', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SCENARIO(39) : scenarios.sql(846) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SCENARIO', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SCENARIO(42) : scenarios.sql(849) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_scenario_id := p_scenario_id;
   h_rec_user := p_rec_user;
   
   -- >>> security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user0
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCENARIO', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCENARIO(62) : scenarios.sql(869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0
         , h_rec_user) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SCENARIO', 69+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SCENARIO(70) : scenarios.sql(877) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SCENARIO', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SCENARIO(73) : scenarios.sql(880) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   Else
      BEGIN
         UPDATE TMT_SCENARIOS S SET (
         S.PROJECT_START,
         S.PROJECT_FINISH,
         S.LEVEL_FINISH ) = (
         SELECT  PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(START_FINISH_DATE, 1, 10)), PMO_ORASTD.TIME(START_DT)),
         CASE WHEN FINISH_START_DATE IS NULL THEN FINISH_DT ELSE PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(FINISH_START_DATE, 1, 10)), PMO_ORASTD.TIME(FINISH_DT)) END,
         LEVEL_FINISH
         FROM TMT_WBS
         WHERE ELEMENT_ID = S.ELEMENT_ID )
         WHERE S.SCENARIO_ID = h_scenario_id
         AND S.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCENARIO', 98+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCENARIO(99) : scenarios.sql(906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (p_level_start IS NULL) Then
         h_S := NULL;
      Else
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_level_start, 1, 10)), PMO_ORASTD.TIME(START_DT))
            INTO h_S
            FROM TMT_WBS
            WHERE ELEMENT_ID = p_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCENARIO', 117+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCENARIO(118) : scenarios.sql(925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET
         TO_CALCULATE = p_to_calculate,
         PRIORITY = p_priority,
         LEVEL_START = h_S,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE SCENARIO_ID = h_scenario_id
         AND ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCENARIO', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCENARIO(144) : scenarios.sql(951) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SCENARIO', 150+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SCENARIO(151) : scenarios.sql(958) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCENARIO', 157+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCENARIO(158) : scenarios.sql(965) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCENARIO', 169+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCENARIO(170) : scenarios.sql(977) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SCENARIO;
ALTER FUNCTION SP_U_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_D_SCENARIO
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC2 IS
         SELECT ELEMENT_ID
         FROM TMT_SCENARIOS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_D_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_SCENARIO(36) : scenarios.sql(1029) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_rec_status := p_del_flag;
   h_rec_user := p_rec_user;
   
   -- >>> security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user
      FROM TMT_SCENARIOS 
      WHERE RANK = '0000';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(54) : scenarios.sql(1047) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT REC_USER INTO h_rec_user0
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(69) : scenarios.sql(1062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0
         , h_rec_user) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_SCENARIO', 76+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_SCENARIO(77) : scenarios.sql(1070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 79+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(80) : scenarios.sql(1073) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_SCENARIO', 84+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_SCENARIO(85) : scenarios.sql(1078) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SCENARIOS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         IF h_rec_status = 'X' THEN 
            EXECUTE IMMEDIATE 'SELECT a.REC_STATUS FROM ' || 'TMT_SCENARIOS' || ' a 
            WHERE a.ELEMENT_ID = :i AND LENGTH(a.RANK) > 4 AND NOT a.REC_STATUS = '' L '' AND NOT EXISTS 
            (SELECT b.REC_STATUS 
                     FROM TMT_ORGANIZATIONS b 
                    WHERE b.REC_STATUS = '' L '' AND instr(b.RANK, a.RANK) = 1)' 
               INTO h_rec_status 
               Using h_id; 
         ELSE 
            EXECUTE IMMEDIATE 'SELECT REC_STATUS FROM ' || 'TMT_SCENARIOS' || ' 
                 WHERE ELEMENT_ID = :i AND REC_STATUS NOT IN (''L'',''D'') ' 
               INTO h_rec_status 
               Using h_id; 
         END IF; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True); 
         WHEN OTHERS THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id , True); 
      END;
      
      If ((p_parent_id IS NULL)) Then
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_SCENARIOS
            WHERE ELEMENT_ID = p_id
            AND PARENT_ID IS NULL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(121) : scenarios.sql(1114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_rec_status := '';
      Else
         h_parent_id := p_parent_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_SCENARIO', 129+1) THEN 
            LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_SCENARIO(130) : scenarios.sql(1123) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SCENARIOS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
         END IF; 
         BEGIN 
            EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_SCENARIOS' || ' WHERE ELEMENT_ID = :i' 
               INTO h_rec_status 
               Using h_parent_id; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
         END;
         
         If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_SCENARIO', 142+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_SCENARIO(143) : scenarios.sql(1136) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 145+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(146) : scenarios.sql(1139) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
         End If;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_SCENARIOS
            WHERE ELEMENT_ID = p_id
            AND PARENT_ID = p_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(162) : scenarios.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN CC2;
      
      FETCH CC2 INTO h_exists;
      IF CC2%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_dependency_count := 1;
      Else
         h_dependency_count := 0;
      End If;
      
      BEGIN
         CLOSE CC2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 190+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(191) : scenarios.sql(1184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(p_del_flag, 1, 1) = '?' Then
         If (Coalesce(h_default_count, 0) <> 0) OR (Coalesce(h_dependency_count, 0) <> 0) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_SCENARIO', 198+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_SCENARIO(199) : scenarios.sql(1192) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 201+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(202) : scenarios.sql(1195) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE_RECORD, p_id, True);
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_SCENARIO', 206+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_SCENARIO(207) : scenarios.sql(1200) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 209+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(210) : scenarios.sql(1203) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
         End If;
      End If;
      
      If SubStr(p_del_flag, 1, 1) = 'X' Then
         If Coalesce(h_default_count, 0) = 0 Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
            	End If; 
            END;
            
            -- trace_printf("\n SP_D_SCENARIO - 1 -  p_del_flag= %s h_id %s h_rank %s h_dependency_count %d ",
            -- h_rec_status,h_id,h_rank,h_dependency_count);
            -- trace_flush();
            
            BEGIN
               UPDATE PROJECT_DETAILS PD 
               SET		PD.LEVEL_LOCK = 0
               ,	PD.LEVEL_LAST_CALL_OPTION = 0
               ,	PD.SCENARIO_NAME = ''
               ,	PD.SCENARIO_USER_ID = ''
               ,	PD.SCENARIO_DATETIME = NULL
               WHERE PD.PROJECT_ID IN
               (SELECT t.ELEMENT_ID
               FROM TMT_SCENARIOS t
               WHERE t.RANK LIKE h_rank || '%'
               AND t.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 257+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(258) : scenarios.sql(1251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_SCENARIOS WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 274+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(275) : scenarios.sql(1268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If SubStr(h_rec_status, 1, 1) = 'D' Then
               If (p_parent_id IS NULL) Then
                  BEGIN
                     UPDATE TMT_SCENARIOS SET DELETED_COUNT = DELETED_COUNT - 1
                     WHERE ELEMENT_ID IS NULL;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 294+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(295) : scenarios.sql(1288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TMT_SCENARIOS SET DELETED_COUNT = DELETED_COUNT - 1
                     WHERE ELEMENT_ID = h_parent_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 312+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(313) : scenarios.sql(1306) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               If (p_parent_id IS NULL) Then
                  BEGIN
                     UPDATE TMT_SCENARIOS SET CHILD_COUNT = CHILD_COUNT - 1
                     WHERE ELEMENT_ID IS NULL;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 332+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(333) : scenarios.sql(1326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     UPDATE TMT_SCENARIOS SET CHILD_COUNT = CHILD_COUNT - 1
                     WHERE ELEMENT_ID = h_parent_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 350+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(351) : scenarios.sql(1344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_SCENARIO', 358+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_SCENARIO(359) : scenarios.sql(1352) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 361+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(362) : scenarios.sql(1355) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id, True);
         End If;
      Else
         If SubStr(h_rec_status, 1, 1) = 'D' Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_SCENARIO', 368+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_SCENARIO(369) : scenarios.sql(1362) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 371+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(372) : scenarios.sql(1365) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
         End If;
         
         If Coalesce(h_default_count, 0) = 0 Then
            If (p_parent_id IS NULL) Then
               BEGIN
                  UPDATE TMT_SCENARIOS SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID IS NULL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 391+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(392) : scenarios.sql(1385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_SCENARIOS SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 409+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(410) : scenarios.sql(1403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
            	End If; 
            END;
            
            BEGIN
               UPDATE TMT_SCENARIOS SET
               REC_STATUS   = p_del_flag,
               REC_DATETIME = SYSTIMESTAMP,
               REC_USER     = p_rec_user
               WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 445+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(446) : scenarios.sql(1439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_SCENARIO', 451+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_SCENARIO(452) : scenarios.sql(1445) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SCENARIO', 454+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_D_SCENARIO(455) : scenarios.sql(1448) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id, True);
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_SCENARIO', 462+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_SCENARIO(463) : scenarios.sql(1456) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 469+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(470) : scenarios.sql(1463) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SCENARIO', 481+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SCENARIO(482) : scenarios.sql(1475) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_SCENARIO;
ALTER FUNCTION SP_D_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_PRJ_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_A_PRJ_SCENARIO
(
     p_id VARCHAR2
   , p_scenario_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_scenario_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   ok PLS_INTEGER;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_PRJ_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_PRJ_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_A_PRJ_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_scenario_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PRJ_SCENARIO', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_PRJ_SCENARIO(29) : scenarios.sql(1520) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_scenario_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_PRJ_SCENARIO', 33+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_PRJ_SCENARIO(34) : scenarios.sql(1525) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PRJ_SCENARIO', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_PRJ_SCENARIO(37) : scenarios.sql(1528) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_project_id := p_id;
   h_scenario_id := p_scenario_id;
   h_rec_user := p_rec_user;
   
   -- >>> security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user
      FROM TMT_SCENARIOS 
      WHERE RANK = '0000';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(57) : scenarios.sql(1548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT REC_USER INTO h_rec_user0
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(72) : scenarios.sql(1563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_PRJ_SCENARIO', 78+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_PRJ_SCENARIO(79) : scenarios.sql(1570) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PRJ_SCENARIO', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_PRJ_SCENARIO(82) : scenarios.sql(1573) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   End If;
   
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0
         , h_rec_user) <> 0 Then
      BEGIN
         DELETE FROM TMT_SCENARIOS 
         WHERE SCENARIO_ID = h_scenario_id
         AND ELEMENT_ID = h_scenario_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(103) : scenarios.sql(1594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_PRJ_SCENARIO', 108+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_PRJ_SCENARIO(109) : scenarios.sql(1600) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PRJ_SCENARIO', 111+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_PRJ_SCENARIO(112) : scenarios.sql(1603) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   Else
      ok := 1;
      
      BEGIN
         SELECT ELEMENT_ID INTO h_id
         FROM TMT_SCENARIOS
         WHERE SCENARIO_ID = h_scenario_id
         AND PARENT_ID = h_scenario_id
         AND ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(130) : scenarios.sql(1621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_PRJ_SCENARIO', 136+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_PRJ_SCENARIO(137) : scenarios.sql(1628) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PRJ_SCENARIO', 139+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_A_PRJ_SCENARIO(140) : scenarios.sql(1631) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, True);
      End If;
      
      /*
              // >>> security checking (case when given project is already included in the forain scenario)
              if (strncmp(h_rec_user,"PMO_SUPERVISOR",14) != 0)
              {
                  BEGIN_SQL
                      SELECT COUNT(ELEMENT_ID) INTO HOST(h_count)
                          FROM TMT_SCENARIOS
                          WHERE ELEMENT_ID = HOST(h_project_id)
                          AND REC_USER <> HOST(h_rec_user);
                  END_SQL;
      
                  if (h_count > 0)
                  {
                      ok = 0;
      
                      BEGIN_SQL
                          DELETE FROM TMT_SCENARIOS 
                          WHERE SCENARIO_ID = HOST(h_scenario_id)
                          AND ELEMENT_ID = HOST(h_scenario_id);
                      END_SQL;
      
                      trace_printf("\n\n");
                      trace_printf("\n SP_A_PRJ_SCENARIO: escape here (3): h_project_id= %s h_rec_user = %s \n\n",h_project_id,h_rec_user);
      
                      RETURN_INVALID(MARKED_AS_UNAVAILABLE);
                  }
              }
              // <<< security checking 
      
              if(ok)
              {
      		*/
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCENARIOS', h_scenario_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --trace_printf("\n\n");
      --trace_printf("\n***** SP_A_PRJ_SCENARIO: h_project_id= %s h_scenario_id= %s h_id= %s h_rec_user= %s \n\n",
      --h_project_id,h_scenario_id,h_id,h_rec_user);
      
      BEGIN
         INSERT INTO TMT_SCENARIOS (
         RANK,
         SCENARIO_ID,
         PARENT_ID,
         ELEMENT_ID,
         TYPE_ID,
         LEVEL_ID,
         REC_USER)
         SELECT  RTRIM(S.RANK) || h_rankBase64,
         h_scenario_id,
         h_scenario_id,
         h_project_id,
         PMO_CNST.SC_PROJECT,
         LEVEL_ID + 1,
         h_rec_user
         FROM TMT_SCENARIOS S
         WHERE S.ELEMENT_ID = h_scenario_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 211+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(212) : scenarios.sql(1703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_SCENARIOS S SET (
            S.TYPE_ID,
            S.ELEMENT_NAME,
            S.TO_CALCULATE,
            S.PRIORITY,
            S.PROJECT_START,
            S.PROJECT_FINISH,
            S.LEVEL_START,
            S.LEVEL_FINISH ) = (
            SELECT  W.TYPE_ID,
            case WHEN LENGTH(RTRIM(W.ELEMENT_NAME)) < 50 
            THEN RTRIM(W.ELEMENT_NAME)
            ELSE substr(RTRIM(W.ELEMENT_NAME),1,49) END AS ELEMENT_NAME,
            0,
            W.PRIORITY,
            W.START_DT,
            W.FINISH_DT,
            PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.START_DT, 1, 10)),'08:00:00'),
            PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(W.FINISH_DT, 1, 10)),'17:00:00')
            FROM TMT_WBS W
            WHERE W.ELEMENT_ID = S.ELEMENT_ID )
            WHERE S.SCENARIO_ID = h_scenario_id
            AND S.ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 251+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(252) : scenarios.sql(1743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      -- }
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_PRJ_SCENARIO', 260+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_PRJ_SCENARIO(261) : scenarios.sql(1752) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 267+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(268) : scenarios.sql(1759) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PRJ_SCENARIO', 279+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PRJ_SCENARIO(280) : scenarios.sql(1771) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_PRJ_SCENARIO;
ALTER FUNCTION SP_A_PRJ_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_PRJ_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_UA_PRJ_SCENARIO
(
     p_id VARCHAR2
   , p_scenario_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_scenario_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_PRJ_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_PRJ_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_PRJ_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_scenario_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_PRJ_SCENARIO', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_PRJ_SCENARIO(23) : scenarios.sql(1810) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_id;
   h_scenario_id := p_scenario_id;
   h_rec_user := p_rec_user;
   -- >>> security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user
      FROM TMT_SCENARIOS 
      WHERE RANK = '0000';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PRJ_SCENARIO', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PRJ_SCENARIO(40) : scenarios.sql(1827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT REC_USER INTO h_rec_user0
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PRJ_SCENARIO', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PRJ_SCENARIO(55) : scenarios.sql(1842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0
         , h_rec_user) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_PRJ_SCENARIO', 62+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_PRJ_SCENARIO(63) : scenarios.sql(1850) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_PRJ_SCENARIO', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_PRJ_SCENARIO(66) : scenarios.sql(1853) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   Else
      BEGIN
         DELETE FROM TMT_SCENARIOS
         WHERE SCENARIO_ID = h_scenario_id
         AND PARENT_ID = h_scenario_id
         AND ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PRJ_SCENARIO', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PRJ_SCENARIO(85) : scenarios.sql(1872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE TMT_SCENARIOS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_scenario_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PRJ_SCENARIO', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PRJ_SCENARIO(105) : scenarios.sql(1892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_PRJ_SCENARIO', 112+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_PRJ_SCENARIO(113) : scenarios.sql(1900) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PRJ_SCENARIO', 119+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PRJ_SCENARIO(120) : scenarios.sql(1907) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PRJ_SCENARIO', 131+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PRJ_SCENARIO(132) : scenarios.sql(1919) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_PRJ_SCENARIO;
ALTER FUNCTION SP_UA_PRJ_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_ISOUT_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_ISOUT_SCENARIO
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      CISOS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISOUT_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISOUT_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_ISOUT_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_SCENARIO', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISOUT_SCENARIO(20) : scenarios.sql(1955) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NOT NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ISOUT_SCENARIO', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ISOUT_SCENARIO(25) : scenarios.sql(1960) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_SCENARIO', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_SCENARIO(28) : scenarios.sql(1963) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   OPEN CISOS FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_SCENARIOS
   WHERE RANK = '0000';
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_SCENARIO', 36+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_SCENARIO(37) : scenarios.sql(1972) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CISOS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_SCENARIO', 44+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_SCENARIO(45) : scenarios.sql(1980) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_SCENARIO', 56+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_SCENARIO(57) : scenarios.sql(1992) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISOUT_SCENARIO;
ALTER FUNCTION SP_ISOUT_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_CKOUT_SCENARIO
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_SCENARIO', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_SCENARIO(20) : scenarios.sql(2028) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CKOUT_SCENARIO', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CKOUT_SCENARIO(25) : scenarios.sql(2033) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_SCENARIO', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_SCENARIO(28) : scenarios.sql(2036) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_rec_user := p_rec_user;
   
   BEGIN
      UPDATE TMT_SCENARIOS SET
      REC_USER = h_rec_user,
      REC_STATUS = 'O',
      REC_DATETIME = SYSTIMESTAMP
      WHERE RANK = '0000'
      AND REC_STATUS <> 'O';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_SCENARIO', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_SCENARIO(52) : scenarios.sql(2060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_CHECKOUT;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_SCENARIO', 61+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_SCENARIO(62) : scenarios.sql(2070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_rec_user, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_SCENARIO', 68+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_SCENARIO(69) : scenarios.sql(2077) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_SCENARIO', 80+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_SCENARIO(81) : scenarios.sql(2089) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_SCENARIO;
ALTER FUNCTION SP_CKOUT_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_CKIN_SCENARIO
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
   checkedInByMe PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_SCENARIO(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_SCENARIO', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_SCENARIO(22) : scenarios.sql(2127) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CKIN_SCENARIO', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CKIN_SCENARIO(27) : scenarios.sql(2132) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_SCENARIO', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_SCENARIO(30) : scenarios.sql(2135) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_rec_user := p_rec_user;
   
   -- >>> security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user0
      FROM TMT_SCENARIOS 
      WHERE RANK = '0000';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_SCENARIO', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_SCENARIO(48) : scenarios.sql(2153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strncmp(h_rec_user0
         , 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0, h_rec_user) <> 0 Then
      checkedInByMe := 0;
   Else
      checkedInByMe := 1;
      NULL;
   End If;
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SCENARIOS';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_SCENARIOS (
      ELEMENT_ID,
      RANK,
      LEVEL_ID,
      PROJECT_START,
      PRIORITY )
      SELECT  P.ELEMENT_ID,
      RTRIM(P.RANK),
      P.LEVEL_ID,
      P.START_FINISH_DATE,
      P.PRIORITY
      FROM TMT_SCENARIOS S
      JOIN TMT_WBS F
      ON F.ELEMENT_ID = S.ELEMENT_ID
      JOIN TMT_WBS P
      ON F.RANK < P.RANK
      AND LENGTH(F.RANK) < LENGTH(P.RANK)
      AND PMO_ORASTD.LEFT(P.RANK, LENGTH(F.RANK)) = F.RANK
      AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_SCENARIO', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_SCENARIO(93) : scenarios.sql(2198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --fixing a bug,vardan added this
   If checkedInByMe <> 0 Then
      BEGIN
         UPDATE PROJECT_DETAILS SET
         LEVEL_LOCK = 0 WHERE LEVEL_LOCK = 10;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_SCENARIO', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_SCENARIO(112) : scenarios.sql(2217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET
         REC_USER = h_rec_user,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK = '0000';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_SCENARIO', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_SCENARIO(133) : scenarios.sql(2238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_SCENARIO', 139+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_SCENARIO(140) : scenarios.sql(2245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_rec_user, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_SCENARIO', 147+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_SCENARIO(148) : scenarios.sql(2253) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_SCENARIO', 159+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_SCENARIO(160) : scenarios.sql(2265) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_SCENARIO;
ALTER FUNCTION SP_CKIN_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_RUN_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_RUN_SCENARIO
(
     p_scenario_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_scenario_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_start_finish_date DATE;
   h_priority PLS_INTEGER := 0;
   PRINT_OPTION PLS_INTEGER := 0;
   PRINT_OPTION_BASIC PLS_INTEGER := 0;
   PRINT_OPTION_MORETHAN_BASIC PLS_INTEGER := 0;
   PRINT_OPTION_EVEN_MORETHAN_BAS PLS_INTEGER := 0;
   PRINT_UPDATE_OPTION PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
   print_alltraces PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR Lev_test_0 IS
         SELECT  ELEMENT_ID
         ,	PROJECT_START
         ,   PRIORITY          
         FROM PMO_SCENARIOS;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RUN_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RUN_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_RUN_SCENARIO(' || 
       '''' || p_scenario_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RUN_SCENARIO', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RUN_SCENARIO(41) : scenarios.sql(2322) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_scenario_id IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_RUN_SCENARIO', 45+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_RUN_SCENARIO(46) : scenarios.sql(2327) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RUN_SCENARIO', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_RUN_SCENARIO(49) : scenarios.sql(2330) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   PRINT_OPTION := 0;
   PRINT_OPTION_BASIC := 1;
   PRINT_OPTION_MORETHAN_BASIC := 0;
   PRINT_OPTION_EVEN_MORETHAN_BAS := 0;
   PRINT_UPDATE_OPTION := 0;
   
   h_scenario_id := p_scenario_id;
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SCENARIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- >>> security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user
      FROM TMT_SCENARIOS 
      WHERE RANK = '0000';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(78) : scenarios.sql(2359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT  RTRIM(RANK)
      ,   case WHEN LENGTH(RTRIM(ELEMENT_NAME)) < 50 
      THEN RTRIM(ELEMENT_NAME) 
      ELSE substr(RTRIM(ELEMENT_NAME),1,49) END
      ,   REC_USER 
      INTO    h_rank
      ,   h_element_name
      ,   h_rec_user0
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(100) : scenarios.sql(2381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   -- <<< security checking
   
   -- >>> security checking
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0
         , h_rec_user) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_RUN_SCENARIO', 109+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_RUN_SCENARIO(110) : scenarios.sql(2391) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RUN_SCENARIO', 112+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_RUN_SCENARIO(113) : scenarios.sql(2394) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   End If;
   -- <<< security checking
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT SYSTIMESTAMP INTO h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(127) : scenarios.sql(2408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 0  
         WHERE TO_CALCULATE <> 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(146) : scenarios.sql(2427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 1, 
         LEVEL_FINISH = NULL  
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(166) : scenarios.sql(2447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO PMO_SCENARIOS (
      ELEMENT_ID,
      RANK,
      LEVEL_ID,
      PROJECT_START,
      PRIORITY)
      SELECT  P.ELEMENT_ID,
      RTRIM(P.RANK),
      P.LEVEL_ID,
      TO_DATE(SubStr(S.LEVEL_START, 1, 10)),
      S.PRIORITY
      FROM TMT_SCENARIOS S
      JOIN TMT_WBS P ON P.ELEMENT_ID = S.ELEMENT_ID
      WHERE S.RANK LIKE h_rank || '%'
      AND S.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(198) : scenarios.sql(2479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_SCENARIOS (
      ELEMENT_ID,
      RANK,
      LEVEL_ID,
      PROJECT_START,
      PRIORITY )
      SELECT  P.ELEMENT_ID,
      RTRIM(P.RANK),
      P.LEVEL_ID,
      COALESCE(TO_DATE(SubStr(R.LEVEL_START, 1, 10)), P.START_FINISH_DATE),
      P.PRIORITY
      FROM PMO_SCENARIOS R
      JOIN TMT_WBS P
      ON R.RANK < P.RANK
      AND LENGTH(R.RANK) < LENGTH(P.RANK)
      AND PMO_ORASTD.LEFT(P.RANK, LENGTH(R.RANK)) = R.RANK
      AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
      WHERE NOT EXISTS(
      SELECT ELEMENT_ID
      FROM PMO_SCENARIOS
      WHERE ELEMENT_ID = P.ELEMENT_ID );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 234+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(235) : scenarios.sql(2516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If print_alltraces <> 0 Then
      OPEN Lev_test_0;
      
      LOOP
         FETCH Lev_test_0
         INTO  h_element_id
         , h_start_finish_date
         , h_priority;
         IF Lev_test_0
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
      END LOOP;
      
      BEGIN
         CLOSE Lev_test_0 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(269) : scenarios.sql(2550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   PMO_DB2M.SC_STATE := levelResourcesForProject('', h_element_name, 4, 0, '', h_rec_user, Coalesce(
                                              PRINT_OPTION, 0), Coalesce(PRINT_OPTION_BASIC, 0)
                                              , Coalesce(PRINT_OPTION_MORETHAN_BASIC, 0), Coalesce(
                                              PRINT_OPTION_EVEN_MORETHAN_BAS, 0), Coalesce(
                                              PRINT_UPDATE_OPTION, 0));
   
   If PMO_DB2M.SC_STATE <> 0 AND PMO_DB2M.SC_STATE <> PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC Then
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 0  
         WHERE TO_CALCULATE <> 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 294+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(295) : scenarios.sql(2576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_RUN_SCENARIO', 300+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_RUN_SCENARIO(301) : scenarios.sql(2582) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_scenario_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RUN_SCENARIO', 303+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_RUN_SCENARIO(304) : scenarios.sql(2585) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_scenario_id, True);
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC Then
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 0  
         WHERE TO_CALCULATE <> 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 323+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(324) : scenarios.sql(2605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --This is relocated into "levelResourcesForProject"
      --SC_STATE = FC_TIMEPHASE_LEVELED();
      
      BEGIN
         UPDATE PROJECT_DETAILS PD SET 
         PD.SCENARIO_NAME = case WHEN LENGTH(RTRIM(h_element_name)) < 50 
         THEN RTRIM(h_element_name) 
         ELSE substr(RTRIM(h_element_name),1,49) END
         ,   PD.SCENARIO_USER_ID = h_rec_user
         ,   PD.SCENARIO_DATETIME = h_current_datetime  
         WHERE PD.PROJECT_ID IN (SELECT ELEMENT_ID 
         FROM PMO_SCENARIOS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 350+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(351) : scenarios.sql(2632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCENARIOS S SET (
         S.LEVEL_START
         ,   S.LEVEL_FINISH) = (
         SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(temp.LEVEL_START, 1, 10)),'08:00:00')
         ,   PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(temp.LEVEL_FINISH, 1, 10)),'17:00:00')
         FROM PMO_SCENARIOS temp
         WHERE temp.ELEMENT_ID = S.ELEMENT_ID)
         WHERE S.SCENARIO_ID = h_scenario_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 374+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(375) : scenarios.sql(2656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_RUN_SCENARIO', 382+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_RUN_SCENARIO(383) : scenarios.sql(2664) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_rec_user, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 390+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(391) : scenarios.sql(2672) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RUN_SCENARIO', 402+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RUN_SCENARIO(403) : scenarios.sql(2684) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RUN_SCENARIO;
ALTER FUNCTION SP_RUN_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_ADOPT_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_ADOPT_SCENARIO
(
     p_scenario_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_scenario_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_element_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_rec_user0 VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_start_finish_date DATE;
   h_finish_start_date DATE;
   h_start_dt TIMESTAMP;
   h_finish_dt TIMESTAMP;
   h_priority PLS_INTEGER := 0;
   PRINT_OPTION PLS_INTEGER := 0;
   PRINT_OPTION_BASIC PLS_INTEGER := 0;
   PRINT_OPTION_MORETHAN_BASIC PLS_INTEGER := 0;
   PRINT_OPTION_EVEN_MORETHAN_BAS PLS_INTEGER := 0;
   PRINT_UPDATE_OPTION PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
   print_alltraces PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR Lev_test_1 IS
         SELECT ELEMENT_NAME
         , ELEMENT_ID
         , START_DT
         , FINISH_DT
         , PRIORITY
         , TO_DATE(SubStr(START_FINISH_DATE, 1, 10))
         , TO_DATE(SubStr(FINISH_START_DATE, 1, 10))
         FROM TMT_WBS
         WHERE (TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3))
         AND PROJECT_ID IN (SELECT ELEMENT_ID FROM TMT_SCENARIOS S WHERE S.TO_CALCULATE = 1);

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ADOPT_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ADOPT_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_ADOPT_SCENARIO(' || 
       '''' || p_scenario_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ADOPT_SCENARIO', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ADOPT_SCENARIO(50) : scenarios.sql(2750) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_scenario_id IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ADOPT_SCENARIO', 54+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ADOPT_SCENARIO(55) : scenarios.sql(2755) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ADOPT_SCENARIO', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ADOPT_SCENARIO(58) : scenarios.sql(2758) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   PRINT_OPTION := 0;
   PRINT_OPTION_BASIC := 1;
   PRINT_OPTION_MORETHAN_BASIC := 0;
   PRINT_OPTION_EVEN_MORETHAN_BAS := 0;
   PRINT_UPDATE_OPTION := 0;
   
   h_scenario_id := p_scenario_id;
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SCENARIOS';
   PMO_DB2M.SC_STATE := 0;
   -- <<< security checking
   BEGIN
      SELECT REC_USER INTO h_rec_user
      FROM TMT_SCENARIOS 
      WHERE RANK = '0000';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(86) : scenarios.sql(2786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   -- >>> security checking
   
   BEGIN
      SELECT  RTRIM(RANK)
      ,   case WHEN LENGTH(RTRIM(ELEMENT_NAME)) < 50 
      THEN RTRIM(ELEMENT_NAME) 
      ELSE substr(RTRIM(ELEMENT_NAME),1,49) END
      ,   REC_USER 
      INTO    h_rank
      ,   h_element_name
      ,   h_rec_user0
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 108+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(109) : scenarios.sql(2809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- >>> security checking
   If PMO_ORASTD.strncmp(h_rec_user, 'PMO_SUPERVISOR', 14) <> 0 AND PMO_ORASTD.strcmp(h_rec_user0
         , h_rec_user) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ADOPT_SCENARIO', 117+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ADOPT_SCENARIO(118) : scenarios.sql(2818) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ADOPT_SCENARIO', 120+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ADOPT_SCENARIO(121) : scenarios.sql(2821) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, True);
   End If;
   -- <<< security checking
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT SYSTIMESTAMP INTO h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(136) : scenarios.sql(2836) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 0  
         WHERE TO_CALCULATE <> 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(155) : scenarios.sql(2855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 2 
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 173+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(174) : scenarios.sql(2874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         INSERT INTO PMO_SCENARIOS 
         (ELEMENT_ID,PRIORITY)
         SELECT P.ELEMENT_ID,S.PRIORITY 
         FROM TMT_SCENARIOS S
         JOIN TMT_WBS P ON P.ELEMENT_ID = S.ELEMENT_ID
         WHERE S.TO_CALCULATE = 2 
         AND S.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 195+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(196) : scenarios.sql(2896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      PMO_DB2M.SC_STATE := levelResourcesForProject('', h_element_name, 6, 0, '', h_rec_user, Coalesce(
                                              PRINT_OPTION, 0), Coalesce(PRINT_OPTION_BASIC, 0)
                                              , Coalesce(PRINT_OPTION_MORETHAN_BASIC, 0), Coalesce(
                                              PRINT_OPTION_EVEN_MORETHAN_BAS, 0), Coalesce(
                                              PRINT_UPDATE_OPTION, 0));
      
      If PMO_DB2M.SC_STATE <> 0 AND PMO_DB2M.SC_STATE <> PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC Then
         BEGIN
            UPDATE TMT_SCENARIOS SET 
            TO_CALCULATE = 0  
            WHERE TO_CALCULATE <> 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 220+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(221) : scenarios.sql(2921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ADOPT_SCENARIO', 226+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ADOPT_SCENARIO(227) : scenarios.sql(2927) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_scenario_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ADOPT_SCENARIO', 229+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ADOPT_SCENARIO(230) : scenarios.sql(2930) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_scenario_id, True);
      End If;
      
      BEGIN
         UPDATE TMT_SCENARIOS SET 
         TO_CALCULATE = 0  
         WHERE TO_CALCULATE <> 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(249) : scenarios.sql(2949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = 0 Then
         BEGIN
            UPDATE PROJECT_DETAILS PD SET 
            PD.SCENARIO_NAME = case WHEN LENGTH(RTRIM(h_element_name)) < 50 
            THEN RTRIM(h_element_name) 
            ELSE substr(RTRIM(h_element_name),1,49) END
            ,	PD.SCENARIO_USER_ID = h_rec_user
            ,	PD.SCENARIO_DATETIME = h_current_datetime  
            WHERE PD.PROJECT_ID IN (SELECT ELEMENT_ID 
            FROM PMO_SCENARIOS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 273+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(274) : scenarios.sql(2974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If print_alltraces <> 0 Then
            --for testing purpose only
            
            OPEN Lev_test_1;
            
            LOOP
               FETCH Lev_test_1
               INTO  h_element_name
               , h_element_id
               , h_start_dt
               , h_finish_dt	
               , h_priority
               , h_start_finish_date
               , h_finish_start_date;
               IF Lev_test_1
               %FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
            END LOOP;
            
            BEGIN
               CLOSE Lev_test_1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 313+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(314) : scenarios.sql(3014) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ADOPT_SCENARIO', 324+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ADOPT_SCENARIO(325) : scenarios.sql(3025) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_rec_user, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 332+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(333) : scenarios.sql(3033) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ADOPT_SCENARIO', 344+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ADOPT_SCENARIO(345) : scenarios.sql(3045) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ADOPT_SCENARIO;
ALTER FUNCTION SP_ADOPT_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_DEMAND_SUPPLY_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_DEMAND_SUPPLY_SCENARIO
(
     p_scenario_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_scenario_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_init_type PLS_INTEGER := 0;
   h_ids VARCHAR2(8192);
   h_start_date DATE;
   h_finish_date DATE;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPDSL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DEMAND_SUPPLY_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DEMAND_SUPPLY_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_DEMAND_SUPPLY_SCENARIO(' || 
       '''' || p_scenario_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DEMAND_SUPPLY_SCENARIO', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DEMAND_SUPPLY_SCENARIO(30) : scenarios.sql(3091) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_scenario_id IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_DEMAND_SUPPLY_SCENARIO', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_DEMAND_SUPPLY_SCENARIO(35) : scenarios.sql(3096) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DEMAND_SUPPLY_SCENARIO', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_DEMAND_SUPPLY_SCENARIO(38) : scenarios.sql(3099) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_scenario_id := p_scenario_id;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   BEGIN
      SELECT RTRIM(RANK) INTO h_rank 
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEMAND_SUPPLY_SCENARIO', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEMAND_SUPPLY_SCENARIO(59) : scenarios.sql(3120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_DATE(SubStr(MAX(COALESCE(LEVEL_FINISH, SYSTIMESTAMP)), 1, 10))  
      INTO h_start_date, h_finish_date
      FROM TMT_SCENARIOS
      WHERE SCENARIO_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEMAND_SUPPLY_SCENARIO', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEMAND_SUPPLY_SCENARIO(75) : scenarios.sql(3136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PVT_ROOT_PROJECTS (
      ELEMENT_ID,
      RANK )
      SELECT  P.ELEMENT_ID,
      RTRIM(P.RANK)
      FROM TMT_SCENARIOS S
      JOIN TMT_WBS P ON P.ELEMENT_ID = S.ELEMENT_ID
      WHERE S.RANK LIKE h_rank || '%'
      AND S.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEMAND_SUPPLY_SCENARIO', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEMAND_SUPPLY_SCENARIO(100) : scenarios.sql(3161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_PVT_ROOT_PROJECTS
      WHERE ELEMENT_ID IN (
      SELECT B.ELEMENT_ID
      FROM PMO_PVT_ROOT_PROJECTS A, PMO_PVT_ROOT_PROJECTS B
      WHERE A.RANK < B.RANK
      AND LENGTH(A.RANK) < LENGTH(B.RANK)
      AND PMO_ORASTD.LEFT(B.RANK, LENGTH(A.RANK)) = A.RANK );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEMAND_SUPPLY_SCENARIO', 122+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEMAND_SUPPLY_SCENARIO(123) : scenarios.sql(3184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROFILES(h_init_type, h_ids, h_start_date, h_finish_date
                                          , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_PRF;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_COMPET;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_LEV_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPDSL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   0 AS RESOURCE_WORK_LOCATION,
   0 AS RESOURCE_STATUS1,
   0 AS RESOURCE_STATUS2,
   R.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.PROFILE_NAME AS DEFAULT_NAME__T,
   R.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   R.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_PROFILES R
   ON R.PROFILE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   2 AS TYPE_ID,
   R.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
   R.STATUS1_ID AS RESOURCE_STATUS1,
   R.STATUS2_ID AS RESOURCE_STATUS2,
   C.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.FULL_NAME AS DEFAULT_NAME__T,
   C.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   C.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROF_RES_IDS C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   LEFT JOIN (	PMO_PVT_PROJECTS P
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID )
   ON P.ELEMENT_ID = M.PROJECT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DEMAND_SUPPLY_SCENARIO', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_DEMAND_SUPPLY_SCENARIO(248) : scenarios.sql(3309) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPDSL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEMAND_SUPPLY_SCENARIO', 255+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEMAND_SUPPLY_SCENARIO(256) : scenarios.sql(3317) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEMAND_SUPPLY_SCENARIO', 267+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEMAND_SUPPLY_SCENARIO(268) : scenarios.sql(3329) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DEMAND_SUPPLY_SCENARIO;
ALTER FUNCTION SP_DEMAND_SUPPLY_SCENARIO COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_RES_UTIL_SCENARIO ==
CREATE OR REPLACE FUNCTION SP_RES_UTIL_SCENARIO
(
     p_scenario_id VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_scenario_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_init_type PLS_INTEGER := 0;
   h_ids VARCHAR2(8192);
   h_start_date DATE;
   h_finish_date DATE;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CRUS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RES_UTIL_SCENARIO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RES_UTIL_SCENARIO'), '-- ' || SYSTIMESTAMP, ':r := SP_RES_UTIL_SCENARIO(' || 
       '''' || p_scenario_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RES_UTIL_SCENARIO', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RES_UTIL_SCENARIO(33) : scenarios.sql(3378) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_scenario_id IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_RES_UTIL_SCENARIO', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_RES_UTIL_SCENARIO(38) : scenarios.sql(3383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RES_UTIL_SCENARIO', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_RES_UTIL_SCENARIO(41) : scenarios.sql(3386) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_scenario_id := p_scenario_id;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   BEGIN
      SELECT RTRIM(RANK) INTO h_rank
      FROM TMT_SCENARIOS
      WHERE ELEMENT_ID = h_scenario_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(63) : scenarios.sql(3408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PVT_ROOT_PROJECTS (
      ELEMENT_ID,
      RANK )
      SELECT  P.ELEMENT_ID,
      RTRIM(P.RANK)
      FROM TMT_SCENARIOS S
      JOIN TMT_WBS P ON P.ELEMENT_ID = S.ELEMENT_ID
      WHERE S.RANK LIKE h_rank || '%'
      AND S.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(88) : scenarios.sql(3433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PMO_PVT_ROOT_PROJECTS
      WHERE ELEMENT_ID IN (
      SELECT B.ELEMENT_ID
      FROM PMO_PVT_ROOT_PROJECTS A, PMO_PVT_ROOT_PROJECTS B
      WHERE A.RANK < B.RANK
      AND LENGTH(A.RANK) < LENGTH(B.RANK)
      AND PMO_ORASTD.LEFT(B.RANK, LENGTH(A.RANK)) = A.RANK );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(111) : scenarios.sql(3456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES('');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(131) : scenarios.sql(3476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES('');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 154+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(155) : scenarios.sql(3500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES('');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 174+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(175) : scenarios.sql(3520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_LEV_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN CRUS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME,
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION,
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_STATUS1,
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_STATUS2,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_COMPETENCY,
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEO,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORG,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER,
   
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ID,
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME,
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_REF_NUMBER,
   COALESCE(P.REF_CODE,'') AS PROJECT_REF_CODE,
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY,
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_START_DT,
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_FINISH_DT,
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER,
   COALESCE(P.PRIORITY,0) AS STATUS_PRIORITY,
   COALESCE(P.STAGE_ID,0) AS STATUS_STAGE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS STATUS_PERCENT_COMPLETE,
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS STATUS_PERCENT_SPENT,
   
   COALESCE(M.FISCAL_YEAR,0) AS RESOURCE_YEAR,
   Trunc((COALESCE(M.FISCAL_MONTH,0)-1)/3+1) AS RESOURCE_QUARTER,
   COALESCE(M.FISCAL_MONTH,0) AS RESOURCE_MONTH,
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS RESOURCE_CALENDAR,
   COALESCE(M.PLANNED_MIN,0)/60.0 AS RESOURCE_PROPOSED,
   COALESCE(M.SCHED_MIN,0)/60.0 AS RESOURCE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_ACTUAL,
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS RESOURCE_BILLABLE_PROPOSED,
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS RESOURCE_BILLABLE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_BILLABLE_ACTUAL,
   COALESCE(ATTR.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS ATTRIBUTES
   
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID
   ORDER BY    RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID,
   PROJECT_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RES_UTIL_SCENARIO', 249+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_RES_UTIL_SCENARIO(250) : scenarios.sql(3595) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CRUS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 257+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(258) : scenarios.sql(3603) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RES_UTIL_SCENARIO', 269+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RES_UTIL_SCENARIO(270) : scenarios.sql(3615) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RES_UTIL_SCENARIO;
ALTER FUNCTION SP_RES_UTIL_SCENARIO COMPILE DEBUG;

