/**
 * Copyright 2000 Systemcorp - All rights reserved. Made in Canada.
 *
 * Description:
 *
 * $Author: Tudor $
 * $Revision: 34 $
 * $Date: 1/7/2001 3:01p $
 *
 * $Log: /PMOffice2000/PMOCStoredProcs/security.cpp $
 *
 **/

--BOOL_RETURN_CODE FC_MIG_SECURITY();

/*###########################################*/

Prompt == FUNCTION SP_I_SECURITY ==
CREATE OR REPLACE FUNCTION SP_I_SECURITY
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_parent_id CHAR(32);
   h_rec_status VARCHAR2(1);
   h_name VARCHAR2(100);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_I_SECURITY(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_SECURITY', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_SECURITY(29) : security.sql(47) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_SECURITY', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_SECURITY(36) : security.sql(54) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_SECURITY', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_SECURITY(39) : security.sql(57) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   Else
      -- Validate parent_id
      h_type := p_type;
      h_parent_id := p_parent_id;
      h_name := p_name;
      h_rec_user := p_rec_user;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_SECURITY', 48+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_SECURITY(49) : security.sql(67) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GLOBAL_SECURITY' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_GLOBAL_SECURITY' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      -- Get next sibling count
      PMODEFINES.PMO_GET_MAX_RANK('TMT_GLOBAL_SECURITY', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      
      BEGIN
         INSERT INTO TMT_GLOBAL_SECURITY (PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2, RANK, REC_USER, REC_DATETIME, SECURITY_GROUP)
         SELECT ELEMENT_ID, h_uniqueID, h_name, h_type, (LEVEL_ID + 1),
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2, RTRIM(RANK) || h_rankBase64, h_rec_user, SYSTIMESTAMP, SECURITY_GROUP
         FROM TMT_GLOBAL_SECURITY WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SECURITY', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SECURITY(88) : security.sql(106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_SECURITY', 94+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_SECURITY(95) : security.sql(113) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SECURITY', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SECURITY(102) : security.sql(120) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_SECURITY', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_SECURITY(114) : security.sql(132) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_SECURITY;
ALTER FUNCTION SP_I_SECURITY COMPILE DEBUG;

/*******************************************************************************/

Prompt == FUNCTION SP_U_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_SECURITY
(
     p_id CHAR
   , p_int_1 PLS_INTEGER
   , p_int_2 PLS_INTEGER
   , p_int_3 PLS_INTEGER
   , p_int_4 PLS_INTEGER
   , p_int_5 PLS_INTEGER
   , p_int_6 PLS_INTEGER
   , p_int_7 PLS_INTEGER
   , p_int_8 PLS_INTEGER
   , p_int_9 PLS_INTEGER
   , p_int_10 PLS_INTEGER
   , p_int_11 PLS_INTEGER
   , p_int_12 PLS_INTEGER
   , p_int_13 PLS_INTEGER
   , p_int_14 PLS_INTEGER
   , p_int_15 PLS_INTEGER
   , p_int_16 PLS_INTEGER
   , p_int_17 PLS_INTEGER
   , p_int_18 PLS_INTEGER
   , p_int_19 PLS_INTEGER
   , p_int_20 PLS_INTEGER
   , p_int_21 PLS_INTEGER
   , p_int_22 PLS_INTEGER
   , p_int_23 PLS_INTEGER
   , p_int_24 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_int_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_4), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_5), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_6), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_7), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_8), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_9), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_10), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_11), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_12), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_13), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_14), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_15), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_16), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_17), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_18), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_19), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_20), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_21), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_22), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_23), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_24), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SECURITY', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SECURITY(65) : security.sql(213) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SECURITY', 70+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SECURITY(71) : security.sql(219) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SECURITY', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SECURITY(74) : security.sql(222) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET INT_1   = p_int_1,
      INT_2   = p_int_2,
      INT_3   = p_int_3,
      INT_4   = p_int_4,
      INT_5   = p_int_5,
      INT_6   = p_int_6,
      INT_7   = p_int_7,
      INT_8   = p_int_8,
      INT_9   = p_int_9,
      INT_10  = p_int_10,
      INT_11  = p_int_11,
      INT_12  = p_int_12,
      INT_13  = p_int_13,
      INT_14  = p_int_14,
      INT_15  = p_int_15,
      INT_16  = p_int_16,
      INT_17  = p_int_17,
      INT_18  = p_int_18,
      INT_19  = p_int_19,
      INT_20  = p_int_20,
      INT_21  = p_int_21,
      INT_22  = p_int_22,
      INT_23  = p_int_23,
      INT_24  = p_int_24
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECURITY', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECURITY(117) : security.sql(265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SECURITY', 122+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SECURITY(123) : security.sql(271) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECURITY', 129+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECURITY(130) : security.sql(278) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECURITY', 141+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECURITY(142) : security.sql(290) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SECURITY;
ALTER FUNCTION SP_U_SECURITY COMPILE DEBUG;

/*******************************************************************************/

Prompt == FUNCTION SP_U_NTF_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_NTF_SECURITY
(
     p_id CHAR
   , p_noti1 PLS_INTEGER
   , p_noti2 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_NTF_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_NTF_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_NTF_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_noti1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_noti2), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NTF_SECURITY', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_NTF_SECURITY(21) : security.sql(327) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_NTF_SECURITY', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_NTF_SECURITY(27) : security.sql(333) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NTF_SECURITY', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_NTF_SECURITY(30) : security.sql(336) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET NOTI_1 = p_noti1,
      NOTI_2 = p_noti2
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NTF_SECURITY', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NTF_SECURITY(51) : security.sql(357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_NTF_SECURITY', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_NTF_SECURITY(57) : security.sql(363) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NTF_SECURITY', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NTF_SECURITY(64) : security.sql(370) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NTF_SECURITY', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NTF_SECURITY(76) : security.sql(382) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_NTF_SECURITY;
ALTER FUNCTION SP_U_NTF_SECURITY COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_SECU_NAME ==
CREATE OR REPLACE FUNCTION SP_U_SECU_NAME
(
     p_id CHAR
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SECU_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SECU_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SECU_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SECU_NAME', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SECU_NAME(21) : security.sql(419) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SECU_NAME', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SECU_NAME(29) : security.sql(427) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SECU_NAME', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SECU_NAME(32) : security.sql(430) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_SECU_NAME', 38+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_SECU_NAME(39) : security.sql(437) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_GLOBAL_SECURITY' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_GLOBAL_SECURITY' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET ELEMENT_NAME = p_name
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECU_NAME', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECU_NAME(65) : security.sql(463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SECU_NAME', 70+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SECU_NAME(71) : security.sql(469) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECU_NAME', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECU_NAME(78) : security.sql(476) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SECU_NAME', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SECU_NAME(90) : security.sql(488) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SECU_NAME;
ALTER FUNCTION SP_U_SECU_NAME COMPILE DEBUG;

/* ********************************************************************************************************************************** */

/* h_bitflag = 0  id = null                then returs all levels
                = 1  id = null             then returs level 1
                = 1  id = NOT null     then returs level 2
                = 3  id = null then return all the levels and all the securities includeing deleted items
*/

/* ********************************************************************************************************************************** */

Prompt == FUNCTION SP_S_SECURITY ==
CREATE OR REPLACE FUNCTION SP_S_SECURITY
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id CHAR(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667c PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667d PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667e PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      REFRESH_SEC PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SECURITY(37) : security.sql(549) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      OPEN C6667a FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE TYPE_ID > 0 AND REC_STATUS <>'D'
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(56) : security.sql(568) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667a;
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      If (p_id IS NULL) Then
         OPEN C6667b FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2
         FROM TMT_GLOBAL_SECURITY
         WHERE TYPE_ID > 0 AND LEVEL_ID = 0
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(70) : security.sql(582) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667b;
      Else
         OPEN C6667c FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
         INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
         INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
         INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
         NOTI_1, NOTI_2
         FROM TMT_GLOBAL_SECURITY
         WHERE (ELEMENT_ID = h_id OR PARENT_ID = h_id) AND REC_STATUS <>'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 82+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(83) : security.sql(595) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667c;
      End If;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      OPEN C6667d FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE REC_STATUS <>'D' ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(96) : security.sql(608) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667d;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      OPEN C6667e FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE TYPE_ID > 0
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 108+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(109) : security.sql(621) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667e;
   ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_REFRESH Then
      OPEN REFRESH_SEC FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT,
      INT_1, INT_2, INT_3, INT_4, INT_5, INT_6, INT_7, INT_8,
      INT_9, INT_10, INT_11, INT_12, INT_13, INT_14, INT_15, INT_16,
      INT_17, INT_18, INT_19, INT_20, INT_21, INT_22, INT_23, INT_24,
      NOTI_1, NOTI_2
      FROM TMT_GLOBAL_SECURITY
      WHERE ELEMENT_ID = h_id
      AND REC_STATUS <>'D'
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SECURITY', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SECURITY(123) : security.sql(635) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN REFRESH_SEC;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SECURITY', 131+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SECURITY(132) : security.sql(644) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SECURITY', 143+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SECURITY(144) : security.sql(656) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SECURITY;
ALTER FUNCTION SP_S_SECURITY COMPILE DEBUG;

/************************************************************************************************************************************/

Prompt == FUNCTION SP_D_SECURITY ==
CREATE OR REPLACE FUNCTION SP_D_SECURITY
(
     p_id CHAR
   , p_parent_id CHAR
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_D_SECURITY(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SECURITY', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_SECURITY(22) : security.sql(694) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      --      FC_MIG_SECURITY();
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_SECURITY', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_SECURITY(31) : security.sql(703) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_SECURITY', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_SECURITY(34) : security.sql(706) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET REC_STATUS = 'D'
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(53) : security.sql(725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_GLOBAL_SECURITY
      SET CHILD_COUNT = CHILD_COUNT - 1,
      DELETED_COUNT = DELETED_COUNT + 1
      WHERE ELEMENT_ID = p_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(73) : security.sql(745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_SECURITY', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_SECURITY(79) : security.sql(751) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(86) : security.sql(758) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_SECURITY', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_SECURITY(98) : security.sql(770) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_SECURITY;
ALTER FUNCTION SP_D_SECURITY COMPILE DEBUG;

/************************************************************************************************************************************/

Prompt == FUNCTION FC_U_ASSIGNED_SECURITY ==
CREATE OR REPLACE FUNCTION FC_U_ASSIGNED_SECURITY
(
     sh_h_table PLS_INTEGER
   , h_assign_id IN OUT NOCOPY VARCHAR2
   , h_security_id IN OUT NOCOPY CHAR
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_res_assignment_id VARCHAR2(32);
   h_temp_res_assignment_id VARCHAR2(32);
   h_temp_security_id VARCHAR2(32);
   h_wbs_security_id VARCHAR2(32);
   h_participant PLS_INTEGER := 0;
   h_temp_participant PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_resource_name VARCHAR2(255);
   h_element_type PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
   h_resource_type PLS_INTEGER := 0;
   h_transfed_cri PLS_INTEGER := 0;
   h_security_group PLS_INTEGER := 0;
   h_cri_table PLS_INTEGER := 0;
   h_cri_element_type PLS_INTEGER := 0;
   h_temp_res_type VARCHAR2(1);
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_assignment_count PLS_INTEGER := 0;
   h_created_by VARCHAR2(32);
   h_full_name VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ASSIGNED_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ASSIGNED_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ASSIGNED_SECURITY(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_assign_id || ''''
          || ', ' || '''' || h_security_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ASSIGNED_SECURITY(43) : security.sql(829) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_res_assignment_id := h_assign_id;
   
   BEGIN
      SELECT ra.PARTICIPANT, ra.ELEMENT_ID, ra.ELEMENT_TYPE,
      CASE WHEN ra.RESOURCE_TYPE = '0' THEN 0 ELSE 1 END,
      CASE WHEN ra.CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END,
      ra.RESOURCE_ID,
      ra.PROJECT_ID, ra.TABLE_TYPE
      INTO h_participant, h_element_id, h_element_type,
      h_resource_type,
      h_transfed_cri, h_resource_id, h_project_id, h_table_type
      FROM RESOURCE_ASSIGNMENTS ra
      WHERE ra.RES_ASSIGNMENT_ID = h_res_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(67) : security.sql(853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1_ SC_STATE: %d, a_temp_id: %s, a_res_assignment_id: %s\n",SC_STATE,a_temp_id,a_res_assignment_id);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --Validate tsk_assignment_id
      BEGIN
         SELECT TA.RES_ASSIGNMENT_ID INTO h_res_assignment_id
         FROM TASK_ASSIGNMENTS TA
         WHERE TA.TSK_ASSIGNMENT_ID = h_res_assignment_id
         AND EXISTS( SELECT * FROM RESOURCE_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = TA.RES_ASSIGNMENT_ID);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(87) : security.sql(873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 93+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(94) : security.sql(880) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_res_assignment_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(97) : security.sql(883) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_res_assignment_id
               , False);
      End If;
      
      BEGIN
         SELECT ra.PARTICIPANT, ra.ELEMENT_ID, ra.ELEMENT_TYPE,
         CASE WHEN ra.RESOURCE_TYPE = '0' THEN 0 ELSE 1 END,
         CASE WHEN ra.CRI_SECURITY_ID IS NuLL THEN 0 ELSE 1 END,
         ra.RESOURCE_ID,
         ra.PROJECT_ID, ra.TABLE_TYPE
         INTO h_participant, h_element_id, h_element_type, h_resource_type,
         h_transfed_cri, h_resource_id, h_project_id, h_table_type
         FROM RESOURCE_ASSIGNMENTS ra
         WHERE ra.RES_ASSIGNMENT_ID = h_res_assignment_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(119) : security.sql(905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 125+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(126) : security.sql(912) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_res_assignment_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 128+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(129) : security.sql(915) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_res_assignment_id
               , False);
      End If;
   End If;
   
   If ((h_table_type IS NULL)) OR (Coalesce(h_table_type, 0) = 0) Then
      h_table_type := GetTable(Coalesce(h_element_type, 0));
   End If;
   
   --Retrive participant name for updating AssignNames field
   If Coalesce(h_resource_type, 0) = 0 Then
      BEGIN
         SELECT NICK_NAME INTO h_resource_name
         FROM RESOURCES
         WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(152) : security.sql(938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("4_ SC_STATE: %d, a_temp_id: %s\n",SC_STATE,a_temp_id);
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 158+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(159) : security.sql(945) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 161+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(162) : security.sql(948) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_resource_id, False);
      End If;
   ElsIf Coalesce(h_resource_type, 0) = 1 Then
      BEGIN
         SELECT PROFILE_NAME INTO h_resource_name
         FROM PROFILES
         WHERE PROFILE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(177) : security.sql(963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 183+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(184) : security.sql(970) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 186+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(187) : security.sql(973) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_resource_id, False);
      End If;
   End If;
   
   If (Coalesce(h_resource_type, 0) > 1) OR ((h_resource_name IS NULL)) Then
      h_resource_name := '';
   End If;
   
   CASE h_table_type
      WHEN PMO_CNST.SC_TABLE_SCD THEN
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_ASSIGNED_SCORECARDS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 208+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(209) : security.sql(995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_POL THEN
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_POOLS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(226) : security.sql(1012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(243) : security.sql(1029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 259+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(260) : security.sql(1046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_POL_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 276+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(277) : security.sql(1063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_RES_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(294) : security.sql(1080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_AST_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(311) : security.sql(1097) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_CLN_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 327+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(328) : security.sql(1114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN PMO_CNST.SC_TABLE_VDR_DOC THEN
         BEGIN
            SELECT AUTHOR_ID INTO h_created_by
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 344+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(345) : security.sql(1131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      ELSE
         BEGIN
            SELECT CREATED_BY INTO h_created_by
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 361+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(362) : security.sql(1148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
   END CASE;
   
   --trace_printf("5_ SC_STATE: %d, h_created_by: %s\n",SC_STATE,h_created_by);
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 370+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(371) : security.sql(1157) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 373+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(374) : security.sql(1160) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_element_id, False);
   End If;
   
   BEGIN
      SELECT SECURITY_GROUP INTO h_security_group
      FROM TMT_GLOBAL_SECURITY
      WHERE ELEMENT_ID = h_security_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 388+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(389) : security.sql(1175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 395+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(396) : security.sql(1182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_security_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 398+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(399) : security.sql(1185) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_security_id, False);
   End If;
   
   If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
      h_security_group := PMO_FUNC.BIT_OR(Coalesce(h_security_group, 0), PMO_CNST.SC_TEAMMEMBER);
   End If;
   
   If Coalesce(h_transfed_cri, 0) = 1 Then
      h_cri_element_type := FC_MIRROR_TYPE(h_element_type);
   End If;
   
   If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
      --trace_printf("Change from response security\n");
      -- Change from response security to a non-response security
      If (BITAND(Coalesce(h_security_group, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) = 0 Then
         --trace_printf("Change from response security to a non-response security\n");
         If PMO_ORASTD.strcmp(h_created_by, h_resource_id) = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 418+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(419) : security.sql(1205) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE_MANAGER), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 421+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(422) : security.sql(1208) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_DELETE_MANAGER, h_resource_id
                  , False);
         Else
            If Coalesce(h_transfed_cri, 0) = 0 Then
               h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
            Else
               h_cri_table := PMO_CNST.SC_TABLE_WBS;
               h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
               
               h_cri_table := PMO_CNST.SC_TABLE_CRI;
               h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_temp_security_id);
            End If;
            
            -- Look for creator
            BEGIN
               SELECT RES_ASSIGNMENT_ID, PARTICIPANT
               INTO h_temp_res_assignment_id, h_temp_participant
               FROM RESOURCE_ASSIGNMENTS
               WHERE ELEMENT_ID = h_element_id AND RESOURCE_ID = h_created_by;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 451+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(452) : security.sql(1238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               If isProjectType(Coalesce(h_element_type, 0)) <> 0 Then
                  If (BITAND(Coalesce(h_temp_participant, 0), PMO_CNST.SC_AFFECTED)) = PMO_CNST.SC_AFFECTED Then
                     h_temp_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_AFFECTED, PMO_CNST.SC_MANAGER);
                  Else
                     h_temp_participant := PMO_CNST.SC_MANAGER;
                  End If;
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = h_temp_participant,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 479+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(480) : security.sql(1266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf isTask(Coalesce(h_element_type, 0)) <> 0 Then
                  If (BITAND(Coalesce(h_temp_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
                     h_temp_participant := PMO_FUNC.BIT_OR(PMO_CNST.SC_TEAMMEMBER, PMO_CNST.SC_TASK_RESPONSIBLE);
                  Else
                     h_temp_participant := PMO_CNST.SC_TASK_RESPONSIBLE;
                  End If;
                  
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_temp_participant,
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 506+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(507) : security.sql(1293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     -- for transfered cri participant field contains two responsible bit
                     h_temp_participant := PMO_FUNC.BIT_OR(Coalesce(h_temp_participant, 0), GetParticipantBitValue(
                                               Coalesce(h_cri_element_type, 0)));
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_temp_participant,
                        CRI_SECURITY_ID = h_temp_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 530+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(531) : security.sql(1317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               ElsIf (BITAND(Coalesce(
                     h_security_group, 0), PMO_CNST.SC_RESOURCE_MANAGER)) = PMO_CNST.SC_RESOURCE_MANAGER Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = PMO_CNST.SC_RESOURCE_MANAGER,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 552+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(553) : security.sql(1339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 573+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(574) : security.sql(1360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_temp_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 594+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(595) : security.sql(1381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_temp_res_assignment_id);
               
               BEGIN
                  SELECT NICK_NAME INTO h_full_name
                  FROM RESOURCES
                  WHERE RESOURCE_ID = h_created_by;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 612+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(613) : security.sql(1399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 619+1) THEN 
                     LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(620) : security.sql(1406) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_created_by || '''');
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 622+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(623) : security.sql(1409) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_created_by, False);
               End If;
               --trace_printf("h_full_name: %d, %s\n", h_full_name_Ind, h_full_name);
               If Coalesce(Length(h_full_name), 0) > 0 Then
                  h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_table_type);
                  
                  If Coalesce(h_transfed_cri, 0) = 1 Then
                     If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                        h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     Else
                        h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     End If;
                     
                     h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_cri_table);
                  End If;
               End If;
            Else
               If isProjectType(Coalesce(h_element_type, 0)) <> 0 Then
                  h_temp_participant := PMO_CNST.SC_MANAGER;
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                     RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                     VALUES (SYS_GUID(), h_project_id, h_element_id, h_element_type,'0',
                     h_created_by, PMO_CNST.SC_MANAGER, h_temp_security_id, h_rec_user, h_table_type, SYSTIMESTAMP);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 665+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(666) : security.sql(1452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf isTask(Coalesce(h_element_type, 0)) <> 0 Then
                  h_temp_participant := PMO_CNST.SC_TASK_RESPONSIBLE;
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     h_temp_participant := GetParticipantBitValue(Coalesce(h_element_type, 0));
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (SYS_GUID(),h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant,h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 695+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(696) : security.sql(1482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_temp_participant := PMO_FUNC.BIT_OR(Coalesce(h_temp_participant, 0), GetParticipantBitValue(
                                               Coalesce(h_cri_element_type, 0)));
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,CRI_SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (SYS_GUID(),h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant,h_wbs_security_id, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 717+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(718) : security.sql(1504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               ElsIf Coalesce(h_element_type, 0) = PMO_CNST.SC_POOLS Then
                  h_temp_participant := PMO_CNST.SC_RESOURCE_MANAGER;
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                     RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                     VALUES (SYS_GUID(),h_project_id,h_element_id,h_element_type,'0',
                     h_created_by, PMO_CNST.SC_RESOURCE_MANAGER, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 746+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(747) : security.sql(1533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  h_temp_participant := BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_CLEAR_PARTICIPANT);
                  h_temp_res_type := '0';
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_created_by, h_element_type
                                          , h_temp_participant, h_temp_security_id, h_temp_res_type
                                          , h_temp_bitflag);
                  
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (SYS_GUID(),h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 775+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(776) : security.sql(1562) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID,PROJECT_ID,ELEMENT_ID,ELEMENT_TYPE,RESOURCE_TYPE,
                        RESOURCE_ID,PARTICIPANT,SECURITY_ID,CRI_SECURITY_ID,REC_USER,TABLE_TYPE,REC_DATETIME)
                        VALUES (SYS_GUID(),h_project_id,h_element_id,h_element_type,'0',
                        h_created_by, h_temp_participant, h_wbs_security_id, h_temp_security_id, h_rec_user, h_table_type,SYSTIMESTAMP);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 795+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(796) : security.sql(1582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               BEGIN
                  SELECT NICK_NAME INTO h_full_name
                  FROM RESOURCES
                  WHERE RESOURCE_ID = h_created_by;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 812+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(813) : security.sql(1599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_ASSIGNED_SECURITY', 818+1) THEN 
                     LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_ASSIGNED_SECURITY(819) : security.sql(1605) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_created_by || '''');
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 821+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(822) : security.sql(1608) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_created_by, False);
               End If;
               
               --trace_printf("h_full_name1: %d, %s\n", h_full_name_Ind, h_full_name);
               If Coalesce(Length(h_full_name), 0) > 0 Then
                  h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_table_type);
                  
                  If Coalesce(h_transfed_cri, 0) = 1 Then
                     If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                        h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     Else
                        h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     End If;
                     
                     h_temp_sc_state := FC_U_NAMES(h_element_id, h_full_name, h_resource_id, h_cri_table);
                  End If;
               End If;
            End If;
         End If;
         
         -- update current row
         If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
            h_temp_participant := PMO_CNST.SC_TEAMMEMBER;
         Else
            h_temp_participant := PMO_CNST.SC_PARTICIPANT;
         End If;
         
         If Coalesce(h_transfed_cri, 0) = 0 Then
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET PARTICIPANT = h_temp_participant,
               SECURITY_ID = h_security_id
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 866+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(867) : security.sql(1653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
               h_cri_table := PMO_CNST.SC_TABLE_WBS;
               If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_wbs_security_id);
               Else
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_wbs_security_id);
               End If;
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PARTICIPANT = h_temp_participant,
                  CRI_SECURITY_ID = h_security_id,
                  SECURITY_ID = h_wbs_security_id
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 897+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(898) : security.sql(1684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_cri_table := PMO_CNST.SC_TABLE_CRI;
               If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_wbs_security_id);
               Else
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_wbs_security_id);
               End If;
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS
                  SET PARTICIPANT = h_temp_participant,
                  CRI_SECURITY_ID = h_wbs_security_id,
                  SECURITY_ID = h_security_id
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 927+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(928) : security.sql(1714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
      Else
         --trace_printf("Change from response security to a another response security\n");
         If (Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI) AND (Coalesce(h_transfed_cri, 0) = 1) Then
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET CRI_SECURITY_ID = h_security_id
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 951+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(952) : security.sql(1738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET SECURITY_ID = h_security_id
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 970+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(971) : security.sql(1757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
      End If;
   Else
      --trace_printf("Change from a non-response\n");
      If (BITAND(Coalesce(h_security_group, 0), PMO_CNST.SC_MANAGER_RESPONSIBLE)) > 0 Then
         --trace_printf("Change from a non-response to a response security\n");
         BEGIN
            SELECT RES_ASSIGNMENT_ID, PARTICIPANT
            INTO h_temp_res_assignment_id, h_temp_participant
            FROM RESOURCE_ASSIGNMENTS
            WHERE ELEMENT_ID = h_element_id
            AND BITAND(PARTICIPANT, PMO_CNST.SC_MANAGER_RESPONSIBLE) > 0
            AND RES_ASSIGNMENT_ID <> h_res_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 994+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(995) : security.sql(1781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND ((h_temp_res_assignment_id IS NOT NULL)) Then
            BEGIN
               SELECT COUNT(*) INTO h_assignment_count
               FROM TASK_ASSIGNMENTS
               WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1010+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1011) : security.sql(1797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_assignment_count, 0) > 0 Then
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = CASE WHEN h_element_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_AFFECTED ELSE PMO_CNST.SC_TEAMMEMBER END,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1035+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1036) : security.sql(1822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  h_cri_table := PMO_CNST.SC_TABLE_WBS;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_wbs_security_id);
                  
                  h_cri_table := PMO_CNST.SC_TABLE_CRI;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                  
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = CASE WHEN h_element_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_AFFECTED ELSE PMO_CNST.SC_TEAMMEMBER END,
                     CRI_SECURITY_ID = h_temp_security_id,
                     SECURITY_ID = h_wbs_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1064+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1065) : security.sql(1851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_temp_security_id);
               Else
                  h_cri_table := PMO_CNST.SC_TABLE_WBS;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_wbs_security_id);
                  
                  h_cri_table := PMO_CNST.SC_TABLE_CRI;
                  h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_PARTICIPANT_GROUP, h_temp_security_id);
               End If;
               
               If isProjectType(Coalesce(h_element_type, 0)) <> 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = PMO_CNST.SC_CO_MANAGER,
                     SECURITY_ID = 'SCCOMANAGER'
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1099+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1100) : security.sql(1886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (BITAND(Coalesce(
                     h_security_group, 0), PMO_CNST.SC_RESOURCE_MANAGER)) = PMO_CNST.SC_RESOURCE_MANAGER Then
                  -- if no assignment, then delete the old responsible
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = PMO_CNST.SC_PARTICIPANT,
                     SECURITY_ID = h_temp_security_id
                     WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1121+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1122) : security.sql(1908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  -- if no assignment, then delete the old responsible
                  If Coalesce(h_transfed_cri, 0) = 0 Then
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = PMO_CNST.SC_PARTICIPANT,
                        SECURITY_ID = h_temp_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1143+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1144) : security.sql(1930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = PMO_CNST.SC_PARTICIPANT,
                        CRI_SECURITY_ID = h_temp_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_temp_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1164+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1165) : security.sql(1951) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            End If;
            
            h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_temp_res_assignment_id);
            
            -- update current row
            If (BITAND(Coalesce(h_temp_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
               h_temp_participant := Coalesce(h_temp_participant, 0) - PMO_CNST.SC_TEAMMEMBER;
            End If;
            
            If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
               h_participant := PMO_FUNC.BIT_OR(Coalesce(h_temp_participant, 0), PMO_CNST.SC_TEAMMEMBER);
               
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = h_participant,
                     SECURITY_ID = h_security_id
                     WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1198+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1199) : security.sql(1985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
                     h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1224+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1225) : security.sql(2011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_wbs_security_id,
                        SECURITY_ID = h_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1249+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1250) : security.sql(2036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            Else
               h_participant := Coalesce(h_temp_participant, 0);
               If Coalesce(h_transfed_cri, 0) = 0 Then
                  BEGIN
                     UPDATE RESOURCE_ASSIGNMENTS
                     SET PARTICIPANT = h_participant,
                     SECURITY_ID = h_security_id
                     WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1273+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1274) : security.sql(2060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
                     h_cri_table := PMO_CNST.SC_TABLE_WBS;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_security_id,
                        SECURITY_ID = h_wbs_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1299+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1300) : security.sql(2086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_cri_table := PMO_CNST.SC_TABLE_CRI;
                     h_temp_sc_state := GetSecurityID(Coalesce(h_cri_table, 0), Coalesce(h_cri_element_type, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_wbs_security_id);
                     
                     BEGIN
                        UPDATE RESOURCE_ASSIGNMENTS
                        SET PARTICIPANT = h_participant,
                        CRI_SECURITY_ID = h_wbs_security_id,
                        SECURITY_ID = h_security_id
                        WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1324+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1325) : security.sql(2111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            End If;
            h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
            
            --trace_printf("h_full_name2: %d, %s\n", h_resource_name_Ind, h_resource_name);
            h_temp_sc_state := FC_U_NAMES(h_element_id, h_resource_name, h_resource_id, h_table_type);
            
            If Coalesce(h_transfed_cri, 0) = 1 Then
               If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                  h_cri_table := PMO_CNST.SC_TABLE_CRI;
               Else
                  h_cri_table := PMO_CNST.SC_TABLE_WBS;
               End If;
               
               h_temp_sc_state := FC_U_NAMES(h_element_id, h_resource_name, h_resource_id, h_cri_table);
            End If;
         Else
            -- can't find responsible
            NULL;
         End If;
      Else
         --trace_printf("Change from a non-response to another non-response security\n");
         If (Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI) AND (Coalesce(h_transfed_cri, 0) = 1) Then
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET CRI_SECURITY_ID = h_security_id,
               PARTICIPANT = h_security_group
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1367+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1368) : security.sql(2154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE RESOURCE_ASSIGNMENTS
               SET SECURITY_ID = h_security_id,
               PARTICIPANT = h_security_group
               WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ASSIGNED_SECURITY', 1387+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ASSIGNED_SECURITY(1388) : security.sql(2174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN(h_res_assignment_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ASSIGNED_SECURITY', 1397+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ASSIGNED_SECURITY(1398) : security.sql(2184) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ASSIGNED_SECURITY;
ALTER FUNCTION FC_U_ASSIGNED_SECURITY COMPILE DEBUG;

