/********************************************************************************/

Prompt == FUNCTION FC_GET_WEEKOF ==
CREATE OR REPLACE FUNCTION FC_GET_WEEKOF
(
     h_weekof IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_start_day PLS_INTEGER := 0;
   h_dayofweek PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_WEEKOF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_WEEKOF'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_WEEKOF(' || 
       COALESCE(NULLIF('''' || h_weekof || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_WEEKOF', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_WEEKOF(15) : settings.sql(18) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT SETTING_VALUE + 1, PMO_ORASTD.DAYOFWEEK(h_weekof) 
      INTO h_start_day, h_dayofweek 
      FROM TMT_SETTINGS 
      WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_WEEKOF', 30+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_WEEKOF(31) : settings.sql(34) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_start_day, 0) = 0 Then
      h_start_day := 6;
   End If;
   
   If (Coalesce(h_dayofweek, 0) - Coalesce(h_start_day, 0)) >= 0 Then
      h_start_day := Coalesce(h_dayofweek, 0) - Coalesce(h_start_day, 0);
      BEGIN
         SELECT (TO_DATE(SubStr(h_weekof, 1, 10)) - h_start_day     )  INTO  h_weekof FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_WEEKOF', 49+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_WEEKOF(50) : settings.sql(53) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_start_day := 7 + Coalesce(h_dayofweek, 0) - Coalesce(h_start_day, 0);
      BEGIN
         SELECT (TO_DATE(SubStr(h_weekof, 1, 10)) - h_start_day     )  INTO  h_weekof FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_WEEKOF', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_WEEKOF(64) : settings.sql(67) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_WEEKOF', 69+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_WEEKOF(70) : settings.sql(73) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_WEEKOF;
ALTER FUNCTION FC_GET_WEEKOF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_WEEKOF ==
CREATE OR REPLACE FUNCTION SP_S_WEEKOF
(
     p_weekof VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_weekof DATE;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WEEKOF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WEEKOF'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WEEKOF(' || 
       '''' || p_weekof || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WEEKOF', 15+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WEEKOF(16) : settings.sql(99) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_weekof IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WEEKOF', 23+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WEEKOF(24) : settings.sql(107) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WEEKOF', 26+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WEEKOF(27) : settings.sql(110) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_weekof := p_weekof;
   
   PMO_DB2M.SC_STATE := FC_GET_WEEKOF(h_weekof);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_S_WEEKOF', 36+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_S_WEEKOF(37) : settings.sql(120) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(NULLIF('''' || h_weekof || '''',''''''), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_weekof, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 44+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(45) : settings.sql(128) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WEEKOF', 56+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WEEKOF(57) : settings.sql(140) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WEEKOF;
ALTER FUNCTION SP_S_WEEKOF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SETTING ==
CREATE OR REPLACE FUNCTION SP_U_SETTING
(
     p_id VARCHAR2
   , p_setting_values PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_go PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_fiscal_start_year PLS_INTEGER := 0;
   h_fiscal_finish_year PLS_INTEGER := 0;
   h_max_fiscal_year PLS_INTEGER := 0;
   h_min_fiscal_year PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_generate_fiscal_cal_flag PLS_INTEGER := 0;
   h_fiscal_calendar_type PLS_INTEGER := 0;
   fiscal_calendar PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SETTING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SETTING'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SETTING(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_setting_values), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SETTING(35) : settings.sql(191) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SETTING', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SETTING(42) : settings.sql(198) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SETTING(45) : settings.sql(201) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT
      CASE WHEN RTRIM(h_id) = 'TIMESHEET_START_WEEKDAY' THEN 1 ELSE 0 END,
      CASE WHEN RTRIM(h_id) = 'TIMESHEET_START_WEEKDAY' THEN COUNT(TSK_ASSIGNMENT_ID) ELSE 0 END
      INTO
      h_go,
      h_count
      FROM SUMMARY_TIMESHEETS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(65) : settings.sql(221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (Coalesce(h_go, 0) = 1) AND (Coalesce(h_count, 0) > 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SETTING', 70+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SETTING(71) : settings.sql(227) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SETTING(74) : settings.sql(230) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id, True);
   End If;
   
   BEGIN
      SELECT
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN 1 ELSE 0 END,
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN COUNT(ELEMENT_ID) ELSE 0 END
      INTO
      h_go,
      h_count
      FROM TMT_WBS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(93) : settings.sql(249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (Coalesce(h_go, 0) = 1) AND (Coalesce(h_count, 0) > 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SETTING', 98+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SETTING(99) : settings.sql(255) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING', 101+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SETTING(102) : settings.sql(258) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id, True);
   End If;
   
   BEGIN
      SELECT
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN 1 ELSE 0 END,
      CASE WHEN RTRIM(h_id) = 'SYSTEM_DEFAULT_CURRENCY' THEN COUNT(RESOURCE_ID) ELSE 0 END
      INTO
      h_go,
      h_count
      FROM RESOURCES WHERE RESOURCE_ID <> 'PMO_SUPERVISOR';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 120+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(121) : settings.sql(277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (Coalesce(h_go, 0) = 1) AND (Coalesce(h_count, 0) > 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_SETTING', 126+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_SETTING(127) : settings.sql(283) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING', 129+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SETTING(130) : settings.sql(286) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_SETTING', 135+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_SETTING(136) : settings.sql(292) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SETTINGS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_SETTINGS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS
      SET SETTING_VALUE = p_setting_values,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP,
      REC_USER      = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(164) : settings.sql(320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- publish fiscal_calendar table
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_START_YEAR', 17) = 0) AND (Coalesce(
         p_setting_values, 0) > 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_finish_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(182) : settings.sql(338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(p_setting_values, 0) Then
         h_fiscal_start_year := Coalesce(p_setting_values, 0);
         fiscal_calendar := 1;
         PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
      End If;
   ElsIf (PMO_ORASTD.strncmp(h_id, 'FISCAL_FINISH_YEAR', 18) = 0) AND (Coalesce(
         p_setting_values, 0) > 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_start_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 203+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(204) : settings.sql(360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_fiscal_start_year, 0) > 0) AND (Coalesce(h_fiscal_start_year, 0) <= Coalesce(
             p_setting_values, 0)) Then
         h_fiscal_finish_year := Coalesce(p_setting_values, 0);
         fiscal_calendar := 1;
         PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
      End If;
   End If;
   
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_PERIOD', 13) = 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_calendar_type
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 227+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(228) : settings.sql(384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- auto generate fiscal calendar
      If Coalesce(h_fiscal_calendar_type, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
         BEGIN
            DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 246+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(247) : settings.sql(403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_start_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 261+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(262) : settings.sql(418) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_start_year, 0) > 0 Then
            BEGIN
               SELECT SETTING_VALUE INTO h_fiscal_finish_year
               FROM TMT_SETTINGS
               WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 277+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(278) : settings.sql(434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
               fiscal_calendar := 1;
               PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
            End If;
         End If;
      End If;
   End If;
   
   If (PMO_ORASTD.strncmp(h_id, 'GENERATE_FISCAL_CALENDAR_FLAG', 29) = 0) Then
      If Coalesce(p_setting_values, 0) = PMO_CNST.SC_FIRST_DAY Then
         BEGIN
            UPDATE TMT_SETTINGS
            SET SETTING_VALUE = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR
            WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(307) : settings.sql(463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(p_setting_values, 0) > PMO_CNST.SC_FIRST_SATURDAY Then
         BEGIN
            UPDATE TMT_SETTINGS
            SET SETTING_VALUE = CASE WHEN SETTING_VALUE =  PMO_CNST.SC_NORMAL_FISCAL_CALENDAR
            THEN PMO_CNST.SC_445_FISCAL_CALENDAR ELSE SETTING_VALUE END
            WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 326+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(327) : settings.sql(483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 344+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(345) : settings.sql(501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_start_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 359+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(360) : settings.sql(516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fiscal_start_year, 0) > 0 Then
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_finish_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(376) : settings.sql(532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
            fiscal_calendar := 1;
            PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
         End If;
      End If;
   End If;
   
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_CALENDAR_TYPE', 20) = 0) Then
      If Coalesce(p_setting_values, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
         If Coalesce(p_setting_values, 0) <> PMO_CNST.SC_NORMAL_FISCAL_CALENDAR Then
            BEGIN
               UPDATE TMT_SETTINGS
               SET SETTING_VALUE = CASE WHEN SETTING_VALUE = PMO_CNST.SC_FIRST_DAY THEN PMO_CNST.SC_FIRST_SUNDAY ELSE SETTING_VALUE END
               WHERE ELEMENT_ID = 'GENERATE_FISCAL_CALENDAR_FLAG';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 404+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(405) : settings.sql(561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SETTINGS
               SET SETTING_VALUE = CASE WHEN SETTING_VALUE > PMO_CNST.SC_FIRST_SATURDAY THEN PMO_CNST.SC_FIRST_DAY ELSE SETTING_VALUE END
               WHERE ELEMENT_ID = 'GENERATE_FISCAL_CALENDAR_FLAG';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 423+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(424) : settings.sql(580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 441+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(442) : settings.sql(598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_start_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 456+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(457) : settings.sql(613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_start_year, 0) > 0 Then
            BEGIN
               SELECT SETTING_VALUE INTO h_fiscal_finish_year
               FROM TMT_SETTINGS
               WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 472+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(473) : settings.sql(629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
               fiscal_calendar := 1;
               PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SETTING', 486+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SETTING(487) : settings.sql(643) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 493+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(494) : settings.sql(650) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING', 505+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING(506) : settings.sql(662) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SETTING;
ALTER FUNCTION SP_U_SETTING COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_SETTING_DESC ==
CREATE OR REPLACE FUNCTION SP_U_SETTING_DESC
(
     p_id VARCHAR2
   , p_descr VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_fiscal_start_year PLS_INTEGER := 0;
   h_fiscal_finish_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SETTING_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SETTING_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SETTING_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_descr || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING_DESC', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SETTING_DESC(22) : settings.sql(700) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_SETTING_DESC', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_SETTING_DESC(27) : settings.sql(705) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SETTING_DESC', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_SETTING_DESC(30) : settings.sql(708) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   h_id := p_id;
   
   BEGIN
      UPDATE TMT_SETTINGS
      SET DESCRIPTION = p_descr,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(53) : settings.sql(731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_ORASTD.strncmp(h_id, 'FISCAL_CALENDAR_CLOSEST_TO_DATE', 31) = 0) Then
      BEGIN
         DELETE FROM FISCAL_CALENDAR WHERE 1 = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(71) : settings.sql(749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_start_year
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(86) : settings.sql(764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fiscal_start_year, 0) > 0 Then
         BEGIN
            SELECT SETTING_VALUE INTO h_fiscal_finish_year
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(102) : settings.sql(780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_fiscal_finish_year, 0) >= Coalesce(h_fiscal_start_year, 0) Then
            PMO_DB2M.SC_STATE := FC_EXTEND_FISCAL_CALENDAR(h_fiscal_start_year, h_fiscal_finish_year);
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SETTING_DESC', 113+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SETTING_DESC(114) : settings.sql(792) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 120+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(121) : settings.sql(799) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SETTING_DESC', 132+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SETTING_DESC(133) : settings.sql(811) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SETTING_DESC;
ALTER FUNCTION SP_U_SETTING_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_SETTING ==
CREATE OR REPLACE FUNCTION SP_S_SETTING
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_id VARCHAR2(32);
   h_ts_count PLS_INTEGER := 0;
   h_timephase_count PLS_INTEGER := 0;
   h_cur_count PLS_INTEGER := 0;
   h_clearance_level_1 PLS_INTEGER := 0;
   h_clearance_level_2 PLS_INTEGER := 0;
   h_clearance_level_3 PLS_INTEGER := 0;
   h_clearance_level_4 PLS_INTEGER := 0;
   h_clearance_level_5 PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_SUMMARY_TS IS
         SELECT TSK_ASSIGNMENT_ID FROM SUMMARY_TIMESHEETS
          WHERE ROWNUM <= 1;

      CURSOR C_TIMEPHASE IS
         SELECT PROJECT_ID
         FROM PROJECT_BUDGET_BREAKDOWN
          WHERE ROWNUM <= 1;

      CURSOR C_TP_DELTA IS
         SELECT PROJECT_ID
         FROM TIMEPHASED_DELTA
          WHERE ROWNUM <= 1;

      CURSOR C_RESOURCES IS
         SELECT RESOURCE_ID FROM RESOURCES WHERE  ROWNUM <= 1 AND  RESOURCE_ID = 'PMO_SUPERVISOR';

      CURSOR C_PROJECTS IS
         SELECT ELEMENT_ID FROM TMT_WBS WHERE  ROWNUM <= 1 AND  TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);

      -- Resultset Cursor Declaration
      C6667r PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667c PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667d PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_SETTING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_SETTING'), '-- ' || SYSTIMESTAMP, ':r := SP_S_SETTING(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 62+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_SETTING(63) : settings.sql(890) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If Coalesce(p_bitflag, 0) = 100 Then
      --Check if timesheet exists
      
      OPEN C_SUMMARY_TS;
      
      FETCH C_SUMMARY_TS INTO h_temp_id;
      IF C_SUMMARY_TS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_ts_count := 1;
      Else
         h_ts_count := 0;
      End If;
      
      BEGIN
         CLOSE C_SUMMARY_TS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(94) : settings.sql(921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Check if timephase exists
      
      OPEN C_TIMEPHASE;
      
      FETCH C_TIMEPHASE INTO h_temp_id;
      IF C_TIMEPHASE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_timephase_count := 1;
      Else
         h_timephase_count := 0;
      End If;
      
      BEGIN
         CLOSE C_TIMEPHASE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(124) : settings.sql(951) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_timephase_count, 0) = 0 Then
         OPEN C_TP_DELTA;
         
         FETCH C_TP_DELTA INTO h_temp_id;
         IF C_TP_DELTA%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_timephase_count := 1;
         Else
            h_timephase_count := 0;
         End If;
         
         BEGIN
            CLOSE C_TP_DELTA ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(153) : settings.sql(980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --Check if resource exists
      
      OPEN C_RESOURCES;
      
      FETCH C_RESOURCES INTO h_temp_id;
      IF C_RESOURCES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_cur_count := 1;
      Else
         h_cur_count := 0;
      End If;
      
      BEGIN
         CLOSE C_RESOURCES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(184) : settings.sql(1011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_cur_count, 0) = 0 Then
         --Check if project exists
         
         OPEN C_PROJECTS;
         
         FETCH C_PROJECTS INTO h_temp_id;
         IF C_PROJECTS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_cur_count := 1;
         Else
            h_cur_count := 0;
         End If;
         
         BEGIN
            CLOSE C_PROJECTS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(215) : settings.sql(1042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_ts_count := 1;
      h_cur_count := 1;
      h_timephase_count := 1;
   End If;
   
   --  h_ts_count = 0;
   --  h_cur_count = 0;
   --  h_timephase_count = 0;
   
   -- Execute Select Statement
   If Coalesce(p_bitflag, 0) = 13 Then
      --res defalut security (tudor)
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_1 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_1';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 240+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(241) : settings.sql(1068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_2 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_2';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 252+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(253) : settings.sql(1080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_3 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_3';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 264+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(265) : settings.sql(1092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_4 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_4';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(277) : settings.sql(1104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_5 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_5';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 288+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(289) : settings.sql(1116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C6667r FOR SELECT 0 AS LEVEL_ID, 0 AS TYPE_ID, '' AS RANK, '' AS PARENT_ID, p_id AS ELEMENT_ID,
      h_clearance_level_1 AS CLEARANCE_LEVEL_1, h_clearance_level_2 AS CLEARANCE_LEVEL_2 ,
      h_clearance_level_3 AS CLEARANCE_LEVEL_3, h_clearance_level_4 AS CLEARANCE_LEVEL_4,
      h_clearance_level_5 AS CLEARANCE_LEVEL_5,
      0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME
      FROM DUAL;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(301) : settings.sql(1128) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667r;
   ElsIf (p_id IS NULL) Then
      If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
         OPEN C6667a FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID IS NuLL AND TYPE_ID <> 0 AND REC_STATUS NOT IN ('D', 'L', 'A')
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 313+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(314) : settings.sql(1141) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667a;
      Else
         OPEN C6667b FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID IS NuLL AND TYPE_ID <> 0
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 325+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(326) : settings.sql(1153) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667b;
      End If;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_SETTING', 332+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_SETTING(333) : settings.sql(1160) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SETTINGS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_SETTINGS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
         OPEN C6667c FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID = h_id OR ELEMENT_ID = h_id AND REC_STATUS NOT in ('D', 'L', 'A')
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 352+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(353) : settings.sql(1180) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667c;
      Else
         OPEN C6667d FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID,
         ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REC_STATUS, REC_DATETIME, SETTING_VALUE, DESCRIPTION,
         h_ts_count AS TIMESHEET_COUNT, h_timephase_count AS TIMEPHASE_COUNT,
         h_cur_count AS CURRENCY_COUNT
         FROM TMT_SETTINGS
         WHERE PARENT_ID = h_id OR ELEMENT_ID = h_id
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_SETTING', 364+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_SETTING(365) : settings.sql(1192) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667d;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 374+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(375) : settings.sql(1202) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_SETTING', 386+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_SETTING(387) : settings.sql(1214) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_SETTING;
ALTER FUNCTION SP_S_SETTING COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_PASS_MASK ==
CREATE OR REPLACE FUNCTION SP_U_PASS_MASK
(
     p_id VARCHAR2
   , p_mask VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PASS_MASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PASS_MASK'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PASS_MASK(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_mask || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PASS_MASK', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PASS_MASK(21) : settings.sql(1251) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PASS_MASK', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PASS_MASK(26) : settings.sql(1256) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PASS_MASK', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PASS_MASK(29) : settings.sql(1259) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_PASS_MASK', 37+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_PASS_MASK(38) : settings.sql(1268) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_SETTINGS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_SETTINGS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_SETTINGS SET
      DESCRIPTION = p_mask,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PASS_MASK', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PASS_MASK(67) : settings.sql(1297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PASS_MASK', 72+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PASS_MASK(73) : settings.sql(1303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PASS_MASK', 79+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PASS_MASK(80) : settings.sql(1310) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PASS_MASK', 91+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PASS_MASK(92) : settings.sql(1322) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PASS_MASK;
ALTER FUNCTION SP_U_PASS_MASK COMPILE DEBUG;

/****************************************************************************************
* Update Resource defalut security
****************************************************************************************/

Prompt == FUNCTION SP_U_RES_DEFSECU ==
CREATE OR REPLACE FUNCTION SP_U_RES_DEFSECU
(
     p_id VARCHAR2
   , p_clearance_level_1 PLS_INTEGER
   , p_clearance_level_2 PLS_INTEGER
   , p_clearance_level_3 PLS_INTEGER
   , p_clearance_level_4 PLS_INTEGER
   , p_clearance_level_5 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_DEFSECU') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_DEFSECU'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_DEFSECU(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_4), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_clearance_level_5), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_DEFSECU', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_DEFSECU(27) : settings.sql(1367) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Update Resource defalut security
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_1
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_1';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(44) : settings.sql(1384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_2
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_2';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(62) : settings.sql(1402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_3
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_3';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(80) : settings.sql(1420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_4
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_4';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(98) : settings.sql(1438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SETTINGS SET SETTING_VALUE = p_clearance_level_5
      WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_5';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(116) : settings.sql(1456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_DEFSECU', 121+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_DEFSECU(122) : settings.sql(1462) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_rec_user, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 128+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(129) : settings.sql(1469) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_DEFSECU', 140+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_DEFSECU(141) : settings.sql(1481) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_DEFSECU;
ALTER FUNCTION SP_U_RES_DEFSECU COMPILE DEBUG;

/****************************************************************************************
* select fiscal_calendar for a given year
****************************************************************************************/

Prompt == FUNCTION SP_S_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION SP_S_FISCAL_CALENDAR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_timephase_count PLS_INTEGER := 0;
   h_timephase_start_year PLS_INTEGER := 0;
   h_timephase_finish_year PLS_INTEGER := 0;
   h_delta_count PLS_INTEGER := 0;
   h_delta_start_year PLS_INTEGER := 0;
   h_delta_finish_year PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_FISCAL_ALL PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_FISCAL_CAL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_FISCAL_CALENDAR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FISCAL_CALENDAR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_FISCAL_CALENDAR(34) : settings.sql(1533) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   h_id := p_id;
   
   If Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_timephase_start_year, h_timephase_finish_year, h_timephase_count
         FROM PROJECT_BUDGET_BREAKDOWN;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(51) : settings.sql(1550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_delta_start_year, h_delta_finish_year, h_delta_count
         FROM TIMEPHASED_DELTA;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(66) : settings.sql(1565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_delta_start_year, 0) > 0) AND (Coalesce(h_delta_start_year, 0) < Coalesce(
             h_timephase_start_year, 0)) Then
         h_timephase_start_year := Coalesce(h_delta_start_year, 0);
      End If;
      
      If Coalesce(h_delta_finish_year, 0) < Coalesce(h_timephase_finish_year, 0) Then
         h_timephase_finish_year := Coalesce(h_delta_finish_year, 0);
      End If;
      
      --      h_timephase_start_year = 0;
      --      h_timephase_finish_year = 0;
   Else
      h_timephase_start_year := 0;
      h_timephase_finish_year := 9999;
   End If;
   
   -- Validate id
   If (p_id IS NULL) Then
      OPEN C_FISCAL_ALL FOR SELECT RTRIM(TO_CHAR(FISCAL_YEAR)) || RTRIM(TO_CHAR(FISCAL_MONTH)) AS ELEMENT_ID, '' AS ELEMENT_NAME,
      CASE WHEN FISCAL_YEAR BETWEEN h_timephase_start_year AND h_timephase_finish_year THEN 1 ELSE 0 END AS TYPE_ID,
      FISCAL_YEAR, FISCAL_MONTH, START_DATE, FINISH_DATE
      FROM FISCAL_CALENDAR
      WHERE START_DATE IS NOT NuLL AND FINISH_DATE IS NOT NuLL
      ORDER BY FISCAL_YEAR, FISCAL_MONTH;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FISCAL_CALENDAR', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FISCAL_CALENDAR(96) : settings.sql(1595) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_FISCAL_ALL;
   Else
      OPEN C_FISCAL_CAL FOR SELECT RTRIM(TO_CHAR(FISCAL_YEAR)) || RTRIM(TO_CHAR(FISCAL_MONTH)) AS ELEMENT_ID, '' AS ELEMENT_NAME,
      CASE WHEN FISCAL_YEAR BETWEEN h_timephase_start_year AND h_timephase_finish_year THEN 1 ELSE 0 END AS TYPE_ID,
      FISCAL_YEAR, FISCAL_MONTH, START_DATE, FINISH_DATE
      FROM FISCAL_CALENDAR
      WHERE FISCAL_YEAR = Trunc(SUBSTR(h_id, 1, 4))
      OR (FISCAL_YEAR = Trunc(SUBSTR(h_id, 1, 4))-1 AND FISCAL_MONTH > 9)
      OR (FISCAL_YEAR = Trunc(SUBSTR(h_id, 1, 4))+1 AND FISCAL_MONTH = 1)
      ORDER BY FISCAL_YEAR, FISCAL_MONTH;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FISCAL_CALENDAR', 108+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FISCAL_CALENDAR(109) : settings.sql(1608) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_FISCAL_CAL;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 117+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(118) : settings.sql(1617) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FISCAL_CALENDAR', 129+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FISCAL_CALENDAR(130) : settings.sql(1629) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_FISCAL_CALENDAR;
ALTER FUNCTION SP_S_FISCAL_CALENDAR COMPILE DEBUG;

/****************************************************************************************
* update start_date in fiscal_calendar for a given year and month
****************************************************************************************/

Prompt == FUNCTION SP_U_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION SP_U_FISCAL_CALENDAR
(
     p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FISCAL_CALENDAR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FISCAL_CALENDAR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FISCAL_CALENDAR(24) : settings.sql(1671) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   --  if ((IsNullSpParam(ind_u_fiscal_calendar, p_id)) || (IsNullSpParam(ind_u_fiscal_calendar, p_start_date)))
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FISCAL_CALENDAR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FISCAL_CALENDAR(33) : settings.sql(1680) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FISCAL_CALENDAR', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FISCAL_CALENDAR(36) : settings.sql(1683) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_id := p_id;
   h_start_date := p_start_date;
   
   BEGIN
      SELECT Trunc(SUBSTR(h_id, 1, 4)), Trunc(SUBSTR(h_id, 5, LENGTH(h_id)-4))
      INTO h_year, h_month
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(54) : settings.sql(1701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- update previous month
   If Coalesce(h_month, 0) = 1 Then
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1     
         WHERE FISCAL_YEAR = h_year - 1 AND FISCAL_MONTH = 12;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(75) : settings.sql(1722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1     
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month - 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(94) : settings.sql(1741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- build finish_date by start_date of the next month
   If Coalesce(h_month, 0) = 12 Then
      BEGIN
         SELECT START_DATE INTO h_finish_date
         FROM FISCAL_CALENDAR
         WHERE FISCAL_YEAR = h_year + 1 AND FISCAL_MONTH = 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(112) : settings.sql(1759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT START_DATE INTO h_finish_date
         FROM FISCAL_CALENDAR
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month + 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(127) : settings.sql(1774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR ((h_finish_date IS NULL)) Then
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET START_DATE = h_start_date,
         FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) + 28     
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(149) : settings.sql(1796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET START_DATE = h_start_date,
         FINISH_DATE = TO_DATE(SubStr(h_finish_date, 1, 10)) - 1     
         WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(169) : settings.sql(1816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FISCAL_CALENDAR', 179+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FISCAL_CALENDAR(180) : settings.sql(1827) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 186+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(187) : settings.sql(1834) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FISCAL_CALENDAR', 198+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FISCAL_CALENDAR(199) : settings.sql(1846) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FISCAL_CALENDAR;
ALTER FUNCTION SP_U_FISCAL_CALENDAR COMPILE DEBUG;

/****************************************************************************************
* update start_date and finish_date in fiscal_calendar to null
****************************************************************************************/

Prompt == FUNCTION SP_RESET_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION SP_RESET_FISCAL_CALENDAR
(
     p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_fiscal_calendar_type PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_timephase_count PLS_INTEGER := 0;
   h_timephase_start_year PLS_INTEGER := 0;
   h_timephase_finish_year PLS_INTEGER := 0;
   h_delta_count PLS_INTEGER := 0;
   h_delta_start_year PLS_INTEGER := 0;
   h_delta_finish_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RESET_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RESET_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := SP_RESET_FISCAL_CALENDAR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESET_FISCAL_CALENDAR', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RESET_FISCAL_CALENDAR(27) : settings.sql(1891) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --  SC_LONG(h_generate_fiscal_calendar_flag);
   
   -- Validate id
   BEGIN
      SELECT SETTING_VALUE INTO h_fiscal_calendar_type
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(44) : settings.sql(1908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- manually generate fiscal calendar
   If Coalesce(h_fiscal_calendar_type, 0) = PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_timephase_start_year, h_timephase_finish_year, h_timephase_count
         FROM PROJECT_BUDGET_BREAKDOWN;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(61) : settings.sql(1925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COALESCE(MAX(BUDGET_YEAR), 0), COALESCE(MIN(BUDGET_YEAR), 0), COUNT(BUDGET_YEAR)
         INTO h_delta_start_year, h_delta_finish_year, h_delta_count
         FROM TIMEPHASED_DELTA;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(76) : settings.sql(1940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_delta_start_year, 0) > 0) AND (Coalesce(h_delta_start_year, 0) < Coalesce(
             h_timephase_start_year, 0)) Then
         h_timephase_start_year := Coalesce(h_delta_start_year, 0);
      End If;
      
      If Coalesce(h_delta_finish_year, 0) < Coalesce(h_timephase_finish_year, 0) Then
         h_timephase_finish_year := Coalesce(h_delta_finish_year, 0);
      End If;
      
      --      h_timephase_start_year = 0;
      --      h_timephase_finish_year = 0;
      
      BEGIN
         UPDATE FISCAL_CALENDAR
         SET START_DATE = NuLL,
         FINISH_DATE = NuLL
         WHERE FISCAL_YEAR < h_timephase_start_year
         OR FISCAL_YEAR > h_timephase_finish_year;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(109) : settings.sql(1973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_RESET_FISCAL_CALENDAR', 119+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_RESET_FISCAL_CALENDAR(120) : settings.sql(1984) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 126+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(127) : settings.sql(1991) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESET_FISCAL_CALENDAR', 138+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESET_FISCAL_CALENDAR(139) : settings.sql(2003) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RESET_FISCAL_CALENDAR;
ALTER FUNCTION SP_RESET_FISCAL_CALENDAR COMPILE DEBUG;

-- For Internal use by FC_EXTEND_FISCAL_CALENDAR, hence the static

Prompt == FUNCTION EXTEND_FISCAL_CAL ==
CREATE OR REPLACE FUNCTION EXTEND_FISCAL_CAL
(
     sh_min_fiscal_year PLS_INTEGER
   , sh_max_fiscal_year PLS_INTEGER
   , sh_generate_fiscal_cal_flag PLS_INTEGER
   , sh_fiscal_calendar_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   min_fiscal_year PLS_INTEGER := Coalesce(sh_min_fiscal_year, 0);
   max_fiscal_year PLS_INTEGER := Coalesce(sh_max_fiscal_year, 0);
   generate_fiscal_cal_flag PLS_INTEGER := Coalesce(sh_generate_fiscal_cal_flag, 0);
   fiscal_calendar_type PLS_INTEGER := Coalesce(sh_fiscal_calendar_type, 0);
   h_fiscal_month PLS_INTEGER := 0;
   h_generate_fiscal_cal_flag PLS_INTEGER := 0;
   h_closest_to_date DATE;
   h_year PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_week PLS_INTEGER := 0;
   h_fiscal_year_flag PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('EXTEND_FISCAL_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('EXTEND_FISCAL_CAL'), '-- ' || SYSTIMESTAMP, ':r := EXTEND_FISCAL_CAL(' || 
       COALESCE(TO_CHAR(sh_min_fiscal_year), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_max_fiscal_year), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_generate_fiscal_cal_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_fiscal_calendar_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'EXTEND_FISCAL_CAL', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: EXTEND_FISCAL_CAL(33) : settings.sql(2052) : ' || SYSTIMESTAMP);
   END IF; 

   h_generate_fiscal_cal_flag := generate_fiscal_cal_flag;
   
   -- FISCAL_YEAR_FLAG
   -- 0: fiscal year is the first month's year (fiscal starts on the current year)
   -- 1: fiscal year is the first month's year + 1 (fiscal starts on the previous year)
   BEGIN
      SELECT SETTING_VALUE INTO h_fiscal_year_flag
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_YEAR_FLAG';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(51) : settings.sql(2070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_fiscal_year_flag := 0;
   End If;
   
   min_fiscal_year := min_fiscal_year - Coalesce(h_fiscal_year_flag, 0);
   max_fiscal_year := max_fiscal_year - Coalesce(h_fiscal_year_flag, 0);
   
   If min_fiscal_year <= max_fiscal_year Then
      If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
             h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
         BEGIN
            SELECT RTRIM(SUBSTR(DESCRIPTION, 5, LENGTH(DESCRIPTION)-4)) INTO h_closest_to_date
            FROM TMT_SETTINGS
            WHERE ELEMENT_ID = 'FISCAL_CALENDAR_CLOSEST_TO_DATE';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(76) : settings.sql(2095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_generate_fiscal_cal_flag, 0);
         h_count := Coalesce(h_count, 0) - PMO_CNST.SC_SUNDAY_CLOSEST_TO + 1;
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_fiscal_month
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'FISCAL_PERIOD';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(95) : settings.sql(2114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_year := min_fiscal_year;
      
      WHILE Coalesce(h_year, 0) <= max_fiscal_year LOOP
         If (fiscal_calendar_type = PMO_CNST.SC_445_FISCAL_CALENDAR) 
               OR (fiscal_calendar_type = PMO_CNST.SC_454_FISCAL_CALENDAR) 
               OR (fiscal_calendar_type = PMO_CNST.SC_544_FISCAL_CALENDAR) Then
            If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
                  h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
               BEGIN
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || h_closest_to_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || h_closest_to_date, 1, 10)))
                  INTO h_start_date, h_week
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 117+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(118) : settings.sql(2137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) -
                  (CASE WHEN (h_week-h_count)>3 THEN (h_week-h_count-7)
                  WHEN (h_week-h_count)<-3 THEN (h_week-h_count+7)
                  ELSE (h_week-h_count) END)     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 135+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(136) : settings.sql(2155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + 1     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 150+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(151) : settings.sql(2170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year)) || '-' || RTRIM(TO_CHAR(h_fiscal_month+1)) || '-01', 1, 10))
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 165+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(166) : settings.sql(2185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + MOD((7-PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_start_date, 1, 10)))+h_generate_fiscal_cal_flag), 7)     
                  INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 180+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(181) : settings.sql(2200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         h_month := 1;
         h_week := 0;
         WHILE Coalesce(h_month, 0) < 13 LOOP
            If fiscal_calendar_type = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR Then
               --trace_printf("h_year: %d, %d\n", h_year_Ind, h_year);
               --trace_printf("h_month: %d, %d\n", h_month_Ind, h_month);
               --trace_printf("h_fiscal_month: %d, %d\n", h_fiscal_month_Ind, h_fiscal_month);
               -- VERIFY: Why not just insert value instead of select from dual
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH)
                  SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year + Trunc((h_month+h_fiscal_month)/13))) || '-' || RTRIM(TO_CHAR(CASE WHEN MOD(h_month+h_fiscal_month, 12)=0 THEN 12 ELSE MOD(h_month+h_fiscal_month, 12) END)) || '-01', 1, 10)),
                  TO_DATE(SubStr(RTRIM(TO_CHAR(h_year + Trunc((h_month+h_fiscal_month+1)/13))) || '-' || RTRIM(TO_CHAR(CASE WHEN MOD(h_month+h_fiscal_month+1, 12)=0 THEN 12 ELSE MOD(h_month+h_fiscal_month+1, 12) END)) || '-01', 1, 10)) - 1     ,
                  (h_year+h_fiscal_year_flag), h_month
                  FROM DUAL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 211+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(212) : settings.sql(2231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf fiscal_calendar_type = PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (FISCAL_YEAR, FISCAL_MONTH)
                  VALUES((h_year+h_fiscal_year_flag), h_month);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 229+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(230) : settings.sql(2249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               CASE h_month
                  WHEN 1 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_544_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 2 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_454_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 3 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_445_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 4 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_544_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 5 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_454_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 6 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_445_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 7 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_544_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 8 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_454_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 9 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_445_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 10 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_544_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 11 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_454_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  WHEN 12 THEN
                     h_week := CASE WHEN (fiscal_calendar_type = PMO_CNST.SC_445_FISCAL_CALENDAR) THEN 5 ELSE 4 END;
                  
                  ELSE
                     h_week := 4;
               END CASE;
               
               --trace_printf("h_year1: %d, %d\n", h_year_Ind, h_year);
               --trace_printf("h_month1: %d, %d\n", h_month_Ind, h_month);
               --trace_printf("h_week1: %d, %d\n", h_week_Ind, h_week);
               If Coalesce(h_month, 0) < 12 Then
                  BEGIN
                     SELECT TO_DATE(SubStr(h_start_date, 1, 10)) + (h_week*7 - 1)      INTO h_finish_date
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 288+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(289) : settings.sql(2308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  If (Coalesce(h_generate_fiscal_cal_flag, 0) >= PMO_CNST.SC_SUNDAY_CLOSEST_TO) AND (Coalesce(
                        h_generate_fiscal_cal_flag, 0) <= PMO_CNST.SC_SATURDAY_CLOSEST_TO) Then
                     BEGIN
                        SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || h_closest_to_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || h_closest_to_date, 1, 10)))
                        INTO h_finish_date, h_week
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 305+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(306) : settings.sql(2325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) -
                        (CASE WHEN (h_week-h_count)>3 THEN (h_week-h_count-7)
                        WHEN (h_week-h_count)<-3 THEN (h_week-h_count+7)
                        ELSE (h_week-h_count) END)     
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 323+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(324) : settings.sql(2343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        SELECT TO_DATE(SubStr(RTRIM(TO_CHAR(h_year+1)) || '-' || RTRIM(TO_CHAR(h_fiscal_month+1)) || '-01', 1, 10))
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 338+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(339) : settings.sql(2358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + (MOD((7-PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_finish_date, 1, 10)))+h_generate_fiscal_cal_flag), 7)-1)     
                        INTO h_finish_date
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 353+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(354) : settings.sql(2373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               BEGIN
                  INSERT INTO FISCAL_CALENDAR (START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH)
                  VALUES (TO_DATE(SubStr(h_start_date, 1, 10)), TO_DATE(SubStr(h_finish_date, 1, 10)), (h_year+h_fiscal_year_flag), h_month);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 373+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(374) : settings.sql(2393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + 1      INTO h_start_date
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 387+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(388) : settings.sql(2407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            -- start at the 1st sunday (1) (monday (2), tuesday (3), ...) of the month
            If (fiscal_calendar_type = PMO_CNST.SC_NORMAL_FISCAL_CALENDAR) AND (Coalesce(
                  h_generate_fiscal_cal_flag, 0) > 0) Then
               BEGIN
                  UPDATE FISCAL_CALENDAR
                  SET START_DATE = START_DATE + MOD((7-PMO_ORASTD.DAYOFWEEK(START_DATE)+h_generate_fiscal_cal_flag), 7)     ,
                  FINISH_DATE = FINISH_DATE + MOD((6-PMO_ORASTD.DAYOFWEEK(FINISH_DATE)+h_generate_fiscal_cal_flag), 7)     
                  WHERE FISCAL_YEAR = h_year AND FISCAL_MONTH = h_month;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'EXTEND_FISCAL_CAL', 411+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: EXTEND_FISCAL_CAL(412) : settings.sql(2431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            h_month := Coalesce(h_month, 0) + 1;
         END LOOP;
         h_year := Coalesce(h_year, 0) + 1;
      END LOOP;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'EXTEND_FISCAL_CAL', 423+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: EXTEND_FISCAL_CAL(424) : settings.sql(2443) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION EXTEND_FISCAL_CAL;
ALTER FUNCTION EXTEND_FISCAL_CAL COMPILE DEBUG;

/*$Func************************************************************************

	  update start_date and finish_date in fiscal_calendar to null

	  Description        Will extend the FISCAL_CALENDAR table with rows
						 from start_date-50 to finish_date+201 years. If
						 the fiscal calendar type is set to manual then this
						 function will insert rows into the FISCAL_CALENDAR
						 table for the year, month combinations but the
						 start and finish dates of the entries will be NULL.
						 These are expected to be entered by the system
						 administrator before the dates can be used.

	  Revision History

		 Sep 21, 2004    Vladimir Schneider
						 Changed to extend 50 years before start and 200
						 years after finish. This eliminates the need for
						 the code to extend it dynamically. The table is per
						 application and takes only 12 rows per year.

*******************************************************************************/

Prompt == FUNCTION FC_EXTEND_FISCAL_CALENDAR ==
CREATE OR REPLACE FUNCTION FC_EXTEND_FISCAL_CALENDAR
(
     sh_h_fiscal_start_year PLS_INTEGER
   , sh_h_fiscal_finish_year PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_fiscal_start_year PLS_INTEGER := sh_h_fiscal_start_year;
   h_fiscal_finish_year PLS_INTEGER := sh_h_fiscal_finish_year;
   h_max_fiscal_year PLS_INTEGER := 0;
   h_min_fiscal_year PLS_INTEGER := 0;
   h_generate_fiscal_cal_flag PLS_INTEGER := 0;
   h_fiscal_calendar_type PLS_INTEGER := 0;
   extend_fiscal_calendar PLS_INTEGER NOT NULL := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_EXTEND_FISCAL_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_EXTEND_FISCAL_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := FC_EXTEND_FISCAL_CALENDAR(' || 
       COALESCE(TO_CHAR(sh_h_fiscal_start_year), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_fiscal_finish_year), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXTEND_FISCAL_CALENDAR', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_EXTEND_FISCAL_CALENDAR(23) : settings.sql(2497) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT SETTING_VALUE INTO h_generate_fiscal_cal_flag
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'GENERATE_FISCAL_CALENDAR_FLAG';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(36) : settings.sql(2510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_fiscal_calendar_type
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_CALENDAR_TYPE';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(51) : settings.sql(2525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COALESCE(MAX(FISCAL_YEAR), 0), COALESCE(MIN(FISCAL_YEAR), 0)
      INTO h_max_fiscal_year, h_min_fiscal_year
      FROM FISCAL_CALENDAR
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(67) : settings.sql(2541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_fiscal_start_year IS NULL) Then
      BEGIN
         SELECT PMO_ORASTD.YEAR(TO_DATE(SYSDATE)) INTO h_fiscal_start_year FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(81) : settings.sql(2555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   extend_fiscal_calendar := 1;
   If (h_fiscal_finish_year IS NULL) Then
      If Coalesce(h_fiscal_calendar_type, 0) <> PMO_CNST.SC_MANUALLY_FISCAL_CALENDAR Then
         h_fiscal_finish_year := h_fiscal_start_year;
         --h_fiscal_start_year -= 10;
         --h_fiscal_finish_year += 10;
      Else
         extend_fiscal_calendar := 0;
      End If;
   End If;
   
   If Coalesce(h_max_fiscal_year, 0) = 0 Then
      h_max_fiscal_year := Coalesce(h_fiscal_finish_year, 0) - 1;
      h_min_fiscal_year := Coalesce(h_fiscal_finish_year, 0) + 1;
   End If;
   
   If extend_fiscal_calendar = 1 Then
      If Coalesce(h_fiscal_start_year, 0) - 50 < Coalesce(h_min_fiscal_year, 0) Then
         If Coalesce(h_fiscal_start_year, 0) < Coalesce(h_min_fiscal_year, 0) Then
            BEGIN
               UPDATE TMT_SETTINGS
               SET SETTING_VALUE = h_fiscal_start_year
               WHERE ELEMENT_ID = 'FISCAL_START_YEAR';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 119+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(120) : settings.sql(2594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         PMO_DB2M.SC_STATE := EXTEND_FISCAL_CAL(Coalesce(h_fiscal_start_year, 0) - 50, Coalesce(
                                       h_min_fiscal_year, 0) - 1, Coalesce(
                                       h_generate_fiscal_cal_flag, 0), Coalesce(
                                       h_fiscal_calendar_type, 0));
         
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXTEND_FISCAL_CALENDAR', 132+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_EXTEND_FISCAL_CALENDAR(133) : settings.sql(2607) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_DB2M.SC_STATE;
         End If;
      End If;
      
      If Coalesce(h_fiscal_finish_year, 0) + 201 > Coalesce(h_max_fiscal_year, 0) Then
         If Coalesce(h_fiscal_finish_year, 0) > Coalesce(h_max_fiscal_year, 0) Then
            BEGIN
               UPDATE TMT_SETTINGS
               SET SETTING_VALUE = h_fiscal_finish_year
               WHERE ELEMENT_ID = 'FISCAL_FINISH_YEAR';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_EXTEND_FISCAL_CALENDAR', 154+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_EXTEND_FISCAL_CALENDAR(155) : settings.sql(2629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_max_fiscal_year, 0) < Coalesce(h_min_fiscal_year, 0) - 1 Then
            -- calendar already contains rows up to and including h_min_fiscal_year-1
            h_max_fiscal_year := Coalesce(h_min_fiscal_year, 0) - 1;
         End If;
         
         -- we need the calendar extended 1 year beyond the fiscal_finish_year
         -- now it is 200 years beyond
         null_return := EXTEND_FISCAL_CAL(Coalesce(h_max_fiscal_year, 0) + 1, Coalesce(
                                 h_fiscal_finish_year, 0) + 201, Coalesce(
                                 h_generate_fiscal_cal_flag, 0), Coalesce(
                                 h_fiscal_calendar_type, 0));
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_EXTEND_FISCAL_CALENDAR', 174+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_EXTEND_FISCAL_CALENDAR(175) : settings.sql(2649) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_EXTEND_FISCAL_CALENDAR;
ALTER FUNCTION FC_EXTEND_FISCAL_CALENDAR COMPILE DEBUG;

