/****************************************************************************************/

Prompt == FUNCTION SP_I_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_I_TIMECODE
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_I_TIMECODE(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_TIMECODE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_TIMECODE(27) : timecodes.sql(30) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Validate parent_id
   If (p_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_TIMECODES', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_TIMECODES WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(54) : timecodes.sql(57) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_TIMECODE', 60+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_TIMECODE(61) : timecodes.sql(64) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_TIMECODES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_TIMECODES', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
         SELECT RTRIM(Rank) || h_rankBase64, p_parent_id, h_uniqueID, p_name, p_type_id, LEVEL_ID + 1, p_rec_user
         FROM TMT_TIMECODES WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(89) : timecodes.sql(92) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_TIMECODE', 95+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_TIMECODE(96) : timecodes.sql(99) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 102+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(103) : timecodes.sql(106) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_TIMECODE', 114+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_TIMECODE(115) : timecodes.sql(118) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_TIMECODE;
ALTER FUNCTION SP_I_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_U_TIMECODE
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TIMECODE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TIMECODE(23) : timecodes.sql(157) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_TIMECODE', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_TIMECODE(31) : timecodes.sql(165) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TIMECODE', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_TIMECODE(34) : timecodes.sql(168) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_TIMECODE', 40+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_TIMECODE(41) : timecodes.sql(175) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_TIMECODES' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_TIMECODES SET
      ELEMENT_NAME = p_name,
      DESCRIPTION = p_description,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMECODE', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMECODE(71) : timecodes.sql(205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TIMECODE', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TIMECODE(77) : timecodes.sql(211) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMECODE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMECODE(84) : timecodes.sql(218) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMECODE', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMECODE(96) : timecodes.sql(230) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TIMECODE;
ALTER FUNCTION SP_U_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_D_TIMECODE
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CC1 IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND DEFAULT_FLAG = 'Y';

      CURSOR CC2 IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_D_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TIMECODE', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_TIMECODE(34) : timecodes.sql(280) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   h_rec_status := p_del_flag;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_TIMECODE', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_TIMECODE(43) : timecodes.sql(289) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      IF h_rec_status = 'X' THEN 
         EXECUTE IMMEDIATE 'SELECT a.REC_STATUS FROM ' || 'TMT_TIMECODES' || ' a 
         WHERE a.ELEMENT_ID = :i AND LENGTH(a.RANK) > 4 AND NOT a.REC_STATUS = '' L '' AND NOT EXISTS 
         (SELECT b.REC_STATUS 
                  FROM TMT_ORGANIZATIONS b 
                 WHERE b.REC_STATUS = '' L '' AND instr(b.RANK, a.RANK) = 1)' 
            INTO h_rec_status 
            Using h_id; 
      ELSE 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS FROM ' || 'TMT_TIMECODES' || ' 
              WHERE ELEMENT_ID = :i AND REC_STATUS NOT IN (''L'',''D'') ' 
            INTO h_rec_status 
            Using h_id; 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True); 
      WHEN OTHERS THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id , True); 
   END;
   
   -- Validate parent id
   If ((p_parent_id IS NULL)) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_TIMECODES WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(78) : timecodes.sql(324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --strcpy( h_rec_status, "");
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_TIMECODE', 86+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_TIMECODE(87) : timecodes.sql(333) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_TIMECODES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_TIMECODE', 99+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_TIMECODE(100) : timecodes.sql(346) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TIMECODE', 102+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_TIMECODE(103) : timecodes.sql(349) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_TIMECODES WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(117) : timecodes.sql(363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN CC1;
   
   FETCH CC1 INTO h_exists;
   IF CC1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_default_count := 1;
   Else
      h_default_count := 0;
   End If;
   
   BEGIN
      CLOSE CC1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(146) : timecodes.sql(392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CC2;
   FETCH CC2 INTO h_exists;
   IF CC2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   BEGIN
      CLOSE CC2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 170+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(171) : timecodes.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   --remove favorite activities
   BEGIN
      DELETE FROM FAVORITE_ACTIVITIES FA
      WHERE FA.TIMECODE_1_ID IN (SELECT ELEMENT_ID FROM TMT_TIMECODES
      WHERE RANK LIKE h_rank || '%')
      OR FA.TIMECODE_2_ID IN (SELECT ELEMENT_ID FROM TMT_TIMECODES
      WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 205+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(206) : timecodes.sql(452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Delete Statement
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      If Coalesce(h_default_count, 0) = 0 Then
         -- Delete Tree
         BEGIN
            DELETE FROM TMT_TIMECODES WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(227) : timecodes.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Update Parent's Hierarchy Info
         If SubStr(h_rec_status, 1, 1) = 'D' Then
            If (p_parent_id IS NULL) Then
               BEGIN
                  UPDATE TMT_TIMECODES SET DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 246+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(247) : timecodes.sql(493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_TIMECODES SET DELETED_COUNT = DELETED_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 263+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(264) : timecodes.sql(510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If (p_parent_id IS NULL) Then
               BEGIN
                  UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 282+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(283) : timecodes.sql(529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 299+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(300) : timecodes.sql(546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_TIMECODE', 307+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_TIMECODE(308) : timecodes.sql(554) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TIMECODE', 310+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_TIMECODE(311) : timecodes.sql(557) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id, True);
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_TIMECODE', 317+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_TIMECODE(318) : timecodes.sql(564) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TIMECODE', 320+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_TIMECODE(321) : timecodes.sql(567) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      If Coalesce(h_default_count, 0) = 0 Then
         -- Update Parent's Hierarchy Info
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1 WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 340+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(341) : timecodes.sql(587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_TIMECODES SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1 WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(358) : timecodes.sql(604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         -- Lock Tree
         BEGIN
            UPDATE TMT_TIMECODES SET
            REC_STATUS = p_del_flag,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = p_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I','U');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 380+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(381) : timecodes.sql(627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_TIMECODE', 386+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_TIMECODE(387) : timecodes.sql(633) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEFAULT_CHILD_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_TIMECODE', 389+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_TIMECODE(390) : timecodes.sql(636) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DEFAULT_CHILD_EXISTS, p_id, True);
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_TIMECODE', 395+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_TIMECODE(396) : timecodes.sql(642) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 403+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(404) : timecodes.sql(650) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_TIMECODE', 415+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_TIMECODE(416) : timecodes.sql(662) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_TIMECODE;
ALTER FUNCTION SP_D_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_S_TIMECODE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      refresh_tc PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C6667B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_TIMECODE(27) : timecodes.sql(705) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      OPEN C6667A FOR SELECT
      TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME,
      (SELECT COUNT(ELEMENT_ID) FROM TMT_TIMECODES WHERE PARENT_ID = TC.ELEMENT_ID AND REC_STATUS NOT in ('D', 'L', 'A') AND TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER)) AS CHILD_COUNT,
      TC.DELETED_COUNT, TC.REC_STATUS, TC.DEFAULT_FLAG, TC.DESCRIPTION, TC.FS_CODE
      FROM TMT_TIMECODES TC
      WHERE TC.PARENT_ID IS NuLL
      AND TC.REC_STATUS NOT in ('D', 'L', 'A')
      AND TC.TYPE_ID IN ( PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER )       -- 159 is the type_id of special time_codes Time codes I and Time code II
      ORDER BY TC.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_TIMECODE(42) : timecodes.sql(720) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C6667A;
   Else
      h_id := p_id;
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         OPEN refresh_tc FOR SELECT
         TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME,
         (SELECT COUNT(ELEMENT_ID) FROM TMT_TIMECODES WHERE PARENT_ID = TC.ELEMENT_ID AND REC_STATUS NOT in ('D', 'L', 'A') AND TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER)) AS CHILD_COUNT,
         TC.DELETED_COUNT, TC.REC_STATUS, TC.DEFAULT_FLAG, TC.DESCRIPTION, TC.FS_CODE
         FROM TMT_TIMECODES TC
         WHERE TC.ELEMENT_ID = h_id
         AND TC.REC_STATUS NOT in ('D', 'L', 'A')
         AND TC.TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER )  -- 159 is the type_id of special time_codes Time codes I and Time code II --NOT IN (0, 1, 2, 3, 4, 5, 6, 35, 36, 37, 38, 39, 40, 58, 59, 60)
         ORDER BY TC.RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_TIMECODE(59) : timecodes.sql(737) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN refresh_tc;
      Else
         OPEN C6667B FOR SELECT
         TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME,
         (SELECT COUNT(ELEMENT_ID) FROM TMT_TIMECODES WHERE PARENT_ID = TC.ELEMENT_ID AND REC_STATUS NOT in ('D', 'L', 'A') AND TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER)) AS CHILD_COUNT,
         TC.DELETED_COUNT, TC.REC_STATUS, TC.DEFAULT_FLAG, TC.DESCRIPTION, TC.FS_CODE
         FROM TMT_TIMECODES TC
         WHERE ( TC.PARENT_ID = h_id
         OR TC.ELEMENT_ID = h_id)
         AND TC.REC_STATUS NOT in ('D', 'L', 'A')
         AND TC.TYPE_ID IN ( PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY, PMO_CNST.SC_FOLDER )  -- 159 is the type_id of special time_codes Time codes I and Time code II --NOT IN (0, 1, 2, 3, 4, 5, 6, 35, 36, 37, 38, 39, 40, 58, 59, 60)
         ORDER BY TC.RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_TIMECODE', 73+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_TIMECODE(74) : timecodes.sql(752) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C6667B;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TIMECODE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TIMECODE(84) : timecodes.sql(762) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_TIMECODE', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_TIMECODE(96) : timecodes.sql(774) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_TIMECODE;
ALTER FUNCTION SP_S_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CB_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_CB_TIMECODE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   z_task_flag PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
-- Declare Cursors
      CURSOR CC_A IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

      CURSOR CC_B IS
         SELECT ELEMENT_ID FROM TMT_TIMECODES
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_project_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CB_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CB_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_CB_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CB_TIMECODE(30) : timecodes.sql(820) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NOT NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CB_TIMECODE', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CB_TIMECODE(35) : timecodes.sql(825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CB_TIMECODE(38) : timecodes.sql(828) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID, PROJECT_ID
      INTO h_type_id, h_project_id
      FROM TMT_WBS WHERE ELEMENT_ID = h_id AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(57) : timecodes.sql(847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CB_TIMECODE', 63+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CB_TIMECODE(64) : timecodes.sql(854) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CB_TIMECODE(67) : timecodes.sql(857) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, p_id, True);
   End If;
   
   h_sql := 'SELECT T.ELEMENT_ID, T.ELEMENT_NAME FROM TMT_TIMECODES T ';
   
   -- Get id's rank
   OPEN CC_A;
   FETCH CC_A INTO h_exists;
   IF CC_A%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      z_task_flag := 1;
   Else
      z_task_flag := 0;
   End If;
   BEGIN
      CLOSE CC_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(96) : timecodes.sql(886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(z_task_flag, 0) = 1 Then
      h_sql := h_sql || 'WHERE T.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = ''';
      h_sql := h_sql || h_id;
      h_sql := h_sql || ''') ';
      h_sql := h_sql || 'AND T.TYPE_ID = 7 ';
   Else
      If isNotProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         OPEN CC_B;
         FETCH CC_B INTO h_exists;
         IF CC_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_sql := h_sql || 'WHERE T.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = ''';
            h_sql := h_sql || h_project_id;
            h_sql := h_sql || ''') ';
            h_sql := h_sql || 'AND T.TYPE_ID = 7 ';
         End If;
         BEGIN
            CLOSE CC_B ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(130) : timecodes.sql(920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_sql := h_sql || 'WHERE T.TYPE_ID = 7 ';
      End If;
   End If;
   
   h_sql := h_sql || 'ORDER BY T.RANK ';
   
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 142+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CB_TIMECODE(143) : timecodes.sql(933) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_TIMECODE', 145+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CB_TIMECODE(146) : timecodes.sql(936) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 152+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(153) : timecodes.sql(943) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_TIMECODE', 164+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_TIMECODE(165) : timecodes.sql(955) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CB_TIMECODE;
ALTER FUNCTION SP_CB_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_TC_WBS ==
CREATE OR REPLACE FUNCTION SP_UA_TC_WBS
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_TC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_TC_WBS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_TC_WBS(21) : timecodes.sql(992) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank FROM TMT_WBS WHERE ELEMENT_ID = p_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(32) : timecodes.sql(1003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   --remove favorite activities
   BEGIN
      DELETE FROM FAVORITE_ACTIVITIES
      WHERE PROJECT_ID IN ( SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%')
      AND ( TIMECODE_1_ID = p_id OR TIMECODE_2_ID = p_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(65) : timecodes.sql(1036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Delete Statement
   BEGIN
      DELETE FROM TMT_TIMECODES
      WHERE PARENT_ID = p_id
      AND ELEMENT_ID IN ( SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(85) : timecodes.sql(1056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      -- Update the parent CHILD_COUNT field
      BEGIN
         UPDATE TMT_TIMECODES SET
         CHILD_COUNT = ( SELECT COUNT(*) FROM TMT_TIMECODES WHERE PARENT_ID = p_id)
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(106) : timecodes.sql(1077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_TC_WBS', 112+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_TC_WBS(113) : timecodes.sql(1084) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 119+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(120) : timecodes.sql(1091) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_WBS', 131+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_WBS(132) : timecodes.sql(1103) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_TC_WBS;
ALTER FUNCTION SP_UA_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_WBS_A_TC ==
CREATE OR REPLACE FUNCTION SP_S_WBS_A_TC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rank_timecode VARCHAR2(200);
   h_sql VARCHAR2(2048);
-- Declare Cursors
      -- Resultset Cursor Declaration
      resultSet1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet3 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet4 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WBS_A_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WBS_A_TC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WBS_A_TC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WBS_A_TC(35) : timecodes.sql(1154) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WBS_A_TC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WBS_A_TC(43) : timecodes.sql(1162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(46) : timecodes.sql(1165) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(60) : timecodes.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 4) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = 'TIMECODE_1';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(77) : timecodes.sql(1196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet1 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID,
      T1.ELEMENT_NAME, CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1, TMT_TIMECODES C
      WHERE
      T1.TYPE_ID = PMO_CNST.SC_TIMECODE
      AND T1.REC_STATUS in ('I', 'U', 'O')
      AND T1.RANK LIKE h_rank_timecode || '%'
      AND C.ELEMENT_ID = h_id
      AND C.PARENT_ID = T1.ELEMENT_ID
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(94) : timecodes.sql(1213) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet1;
   ElsIf ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 3) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = 'TIMECODE_2';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(109) : timecodes.sql(1228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet2 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID,
      T1.ELEMENT_ID, T1.ELEMENT_NAME, CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1, TMT_TIMECODES C
      WHERE
      T1.TYPE_ID = PMO_CNST.SC_TIMECODE
      AND T1.REC_STATUS in ('I', 'U', 'O')
      AND T1.RANK LIKE h_rank_timecode || '%'
      AND C.ELEMENT_ID = h_id
      AND C.PARENT_ID = T1.ELEMENT_ID
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 125+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(126) : timecodes.sql(1245) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet2;
   ElsIf ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(141) : timecodes.sql(1260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet3 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      T1.LEVEL_ID AS CHILD_COUNT, T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE (SUBSTR(h_rank_timecode, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank_timecode) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_rank_timecode, 1, 8) || '%')) AND
      T1.TYPE_ID IN (PMO_CNST.SC_TIMECODE, PMO_CNST.SC_TIMECODE_CATEGORY,PMO_CNST.SC_FOLDER) AND
      T1.REC_STATUS IN ( 'I', 'U', 'O')
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 154+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(155) : timecodes.sql(1274) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet3;
   Else
      OPEN resultSet4 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      T1.LEVEL_ID AS CHILD_COUNT, T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id) AND
      T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_TC', 165+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_TC(166) : timecodes.sql(1285) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet4;
   End If;
   
   --Return a resultset
   --select_read(h_sql, S66673, C66673);
   --trace_printf(h_sql);//trace_flush();
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 177+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(178) : timecodes.sql(1297) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_TC', 189+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_TC(190) : timecodes.sql(1309) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WBS_A_TC;
ALTER FUNCTION SP_S_WBS_A_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_TC_CRI ==
CREATE OR REPLACE FUNCTION SP_A_TC_CRI
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_cri_rank VARCHAR2(200);
   h_element_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_tc_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CRI IS
         SELECT ELEMENT_ID, TYPE_ID FROM TMT_CRI
         WHERE RANK LIKE h_cri_rank || '%'
         ORDER BY RANK;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_TC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_TC_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_A_TC_CRI(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_CRI', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_TC_CRI(36) : timecodes.sql(1361) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_CRI', 40+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_CRI(41) : timecodes.sql(1366) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_CRI', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_TC_CRI(44) : timecodes.sql(1369) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   /*****HERVE ******/
   
   --Validate WBS element id
   h_element_id := p_element_id;
   
   BEGIN
      SELECT RANK INTO h_cri_rank FROM TMT_CRI WHERE ELEMENT_ID = h_element_id AND REC_STATUS IN ( 'I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(63) : timecodes.sql(1388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_CRI', 69+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_CRI(70) : timecodes.sql(1395) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_element_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_CRI', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_TC_CRI(73) : timecodes.sql(1398) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_element_id, True);
   End If;
   
   BEGIN
      SELECT COUNT(*) INTO h_count FROM TMT_CRI WHERE RANK LIKE h_cri_rank || '%';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(86) : timecodes.sql(1411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_id := p_id;
   BEGIN
      SELECT RTRIM(RANK), MAX_RANK, LEVEL_ID + 1
      INTO h_tc_rank, h_max_rank, h_level_id
      FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(102) : timecodes.sql(1427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_CRI', 108+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_CRI(109) : timecodes.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_CRI', 111+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_TC_CRI(112) : timecodes.sql(1437) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   OPEN C_CRI;
   LOOP
      FETCH C_CRI INTO h_element_id, h_type_id;
      IF C_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_max_rank := Coalesce(h_max_rank, 0) + 1;
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      --strcpy( h_rank, h_tc_rank);
      h_rank := h_tc_rank;
      h_rank := SubStr(h_rank || h_rankBase64, 1, 200);
      
      --Validate assignment existence
      BEGIN
         SELECT ELEMENT_ID INTO h_exists FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(146) : timecodes.sql(1471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
            VALUES( h_rank, h_id, h_element_id, h_type_id, h_level_id, p_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 164+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(165) : timecodes.sql(1490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_count := Coalesce(h_count, 0) - 1;
      End If;
   END LOOP;
   --end of while
   
   BEGIN
      CLOSE C_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 182+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(183) : timecodes.sql(1508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_TIMECODES SET
      MAX_RANK = MAX_RANK + h_count,
      CHILD_COUNT = CHILD_COUNT + h_count
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 202+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(203) : timecodes.sql(1528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_TC_CRI', 208+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_TC_CRI(209) : timecodes.sql(1534) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 215+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(216) : timecodes.sql(1541) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_CRI', 227+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_CRI(228) : timecodes.sql(1553) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_TC_CRI;
ALTER FUNCTION SP_A_TC_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_TC_CRI ==
CREATE OR REPLACE FUNCTION SP_UA_TC_CRI
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_TC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_TC_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_TC_CRI(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_TC_CRI', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_TC_CRI(20) : timecodes.sql(1589) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank FROM TMT_CRI WHERE ELEMENT_ID = p_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 30+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(31) : timecodes.sql(1600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   -- Execute Delete Statement
   BEGIN
      DELETE FROM TMT_TIMECODES
      WHERE PARENT_ID = p_id
      AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CRI WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(64) : timecodes.sql(1633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE TMT_TIMECODES SET
         CHILD_COUNT = (SELECT COUNT(*) FROM TMT_TIMECODES WHERE PARENT_ID = p_id)
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(84) : timecodes.sql(1653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_TC_CRI', 90+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_TC_CRI(91) : timecodes.sql(1660) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 97+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(98) : timecodes.sql(1667) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_TC_CRI', 109+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_TC_CRI(110) : timecodes.sql(1679) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_TC_CRI;
ALTER FUNCTION SP_UA_TC_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CRI_A_TC ==
CREATE OR REPLACE FUNCTION SP_S_CRI_A_TC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rank_timecode VARCHAR2(200);
   h_sql VARCHAR2(2048);
-- Declare Cursors
      -- Resultset Cursor Declaration
      resultSet5 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      resultSet6 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CRI_A_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CRI_A_TC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CRI_A_TC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CRI_A_TC(29) : timecodes.sql(1724) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Execute Select Statement
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CRI_A_TC', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CRI_A_TC(37) : timecodes.sql(1732) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_TC(40) : timecodes.sql(1735) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_CRI WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(54) : timecodes.sql(1749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      -- LOCATE modification
      BEGIN
         SELECT RANK INTO h_rank_timecode
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(71) : timecodes.sql(1766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN resultSet5 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE (SUBSTR(h_rank_timecode, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank_timecode) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_rank_timecode, 1, 8) || '%')) AND
      T1.TYPE_ID = PMO_CNST.SC_TIMECODE AND
      T1.REC_STATUS IN ('I', 'U', 'O')
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_TC(86) : timecodes.sql(1781) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet5;
   Else
      -- LOCATE modification
      
      OPEN resultSet6 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      1 AS CHILD_COUNT, T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION
      FROM TMT_TIMECODES T1
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id) AND
      T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_TC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_TC(99) : timecodes.sql(1794) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN resultSet6;
   End If;
   
   --Return a resultset
   --select_read(h_sql, S66674, C66674);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 110+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(111) : timecodes.sql(1806) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_TC', 122+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_TC(123) : timecodes.sql(1818) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CRI_A_TC;
ALTER FUNCTION SP_S_CRI_A_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_FS_TIMECODE ==
CREATE OR REPLACE FUNCTION SP_U_FS_TIMECODE
(
     p_id VARCHAR2
   , p_fs_code VARCHAR2
   , p_element_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FS_TIMECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FS_TIMECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FS_TIMECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_fs_code || ''''
          || ', ' || '''' || p_element_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FS_TIMECODE', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FS_TIMECODE(33) : timecodes.sql(1867) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Update
   BEGIN
      SELECT ELEMENT_ID INTO h_uniqueID
      FROM TMT_TIMECODES WHERE FS_CODE = p_fs_code;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(46) : timecodes.sql(1880) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      If Coalesce(p_id, 0) = -1 Then
         h_uniqueID := SYS_GUID();
      Else
         h_uniqueID := p_id;
      End If;
      
      If (p_parent_id IS NULL) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_TIMECODES', h_max_rank);
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_TIMECODES(FS_CODE, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
            SELECT p_fs_code, RTRIM(COALESCE(RANK, '')) || h_rankBase64, p_parent_id, h_uniqueID, p_element_name, p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_TIMECODES WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(76) : timecodes.sql(1910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_parent_id := p_parent_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_FS_TIMECODE', 82+1) THEN 
            LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_FS_TIMECODE(83) : timecodes.sql(1917) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_TIMECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
         END IF; 
         BEGIN 
            EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_TIMECODES' || ' WHERE ELEMENT_ID = :i' 
               INTO h_rec_status 
               Using h_parent_id; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
         END;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_TIMECODES', h_parent_id, h_max_rank);
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_TIMECODES(FS_CODE, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER)
            SELECT p_fs_code, RTRIM(Rank) || h_rankBase64, p_parent_id, h_uniqueID, p_element_name, p_type_id, LEVEL_ID + 1, p_rec_user FROM TMT_TIMECODES WHERE ELEMENT_ID = p_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(111) : timecodes.sql(1945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Execute Update
      BEGIN
         UPDATE TMT_TIMECODES SET
         ELEMENT_NAME = p_element_name,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(134) : timecodes.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FS_TIMECODE', 140+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FS_TIMECODE(141) : timecodes.sql(1975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 147+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(148) : timecodes.sql(1982) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FS_TIMECODE', 159+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FS_TIMECODE(160) : timecodes.sql(1994) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FS_TIMECODE;
ALTER FUNCTION SP_U_FS_TIMECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_A_TC_WBS ==
CREATE OR REPLACE FUNCTION FC_A_TC_WBS
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_exists VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_wbs_rank VARCHAR2(200);
   h_tc_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_WBS IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_A_TC_WBS(' || 
       '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_TC_WBS(34) : timecodes.sql(2044) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --Validate WBS element id
   BEGIN
      SELECT RANK INTO h_wbs_rank
      FROM TMT_WBS WHERE ELEMENT_ID = h_element_id AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(49) : timecodes.sql(2059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_WBS(55) : timecodes.sql(2065) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Validate TIME CODE element id
   BEGIN
      SELECT RTRIM(RANK), MAX_RANK, LEVEL_ID + 1
      INTO h_tc_rank, h_max_rank, h_level_id
      FROM TMT_TIMECODES WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(71) : timecodes.sql(2081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_WBS(77) : timecodes.sql(2087) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   h_count := 0;
   OPEN C_WBS;
   LOOP
      FETCH C_WBS INTO h_element_id, h_type_id;
      IF C_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_max_rank := Coalesce(h_max_rank, 0) + 1;
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      --strcpy( h_rank, h_tc_rank );
      h_rank := h_tc_rank;
      h_rank := SubStr(h_rank || h_rankBase64, 1, 200);
      
      --Validate assignment existence
      BEGIN
         SELECT ELEMENT_ID INTO h_exists FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(111) : timecodes.sql(2121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER )
            VALUES( h_rank, h_id, h_element_id, h_type_id, h_level_id, h_rec_user );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 128+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(129) : timecodes.sql(2139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_WBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(145) : timecodes.sql(2155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_TIMECODES SET
      MAX_RANK = MAX_RANK + h_count,
      CHILD_COUNT = CHILD_COUNT + h_count
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_TC_WBS', 164+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_TC_WBS(165) : timecodes.sql(2175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_TC_WBS', 170+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_TC_WBS(171) : timecodes.sql(2181) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_TC_WBS;
ALTER FUNCTION FC_A_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_TC_WBS ==
CREATE OR REPLACE FUNCTION SP_A_TC_WBS
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_A_TC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_WBS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_TC_WBS(22) : timecodes.sql(2213) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_element_id IS NULL)) OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_TC_WBS', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_TC_WBS(27) : timecodes.sql(2218) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_TC_WBS', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_TC_WBS(30) : timecodes.sql(2221) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_A_TC_WBS(h_element_id, h_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_TC_WBS', 43+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_TC_WBS(44) : timecodes.sql(2235) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_WBS', 50+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_WBS(51) : timecodes.sql(2242) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_TC_WBS', 62+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_TC_WBS(63) : timecodes.sql(2254) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_TC_WBS;
ALTER FUNCTION SP_A_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_FS_TC_WBS ==
CREATE OR REPLACE FUNCTION SP_A_FS_TC_WBS
(
     p_element_id VARCHAR2
   , p_fs_code VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_FS_TC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_FS_TC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_A_FS_TC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_fs_code || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_FS_TC_WBS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_FS_TC_WBS(22) : timecodes.sql(2292) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_fs_code IS NULL)) OR ((p_element_id IS NULL)) OR ((p_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_FS_TC_WBS', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_FS_TC_WBS(27) : timecodes.sql(2297) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_fs_code || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_FS_TC_WBS', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_FS_TC_WBS(30) : timecodes.sql(2300) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_fs_code, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_id
      FROM TMT_TIMECODES
      WHERE FS_CODE = p_fs_code;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_FS_TC_WBS', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_FS_TC_WBS(50) : timecodes.sql(2320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_DB2M.SC_STATE := FC_A_TC_WBS(h_element_id, h_id, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_FS_TC_WBS', 59+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_FS_TC_WBS(60) : timecodes.sql(2330) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_fs_code || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_fs_code, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_FS_TC_WBS', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_FS_TC_WBS(67) : timecodes.sql(2337) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_FS_TC_WBS', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_FS_TC_WBS(79) : timecodes.sql(2349) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_FS_TC_WBS;
ALTER FUNCTION SP_A_FS_TC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_A_WBS_TC ==
CREATE OR REPLACE FUNCTION FC_A_WBS_TC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_wbs_id VARCHAR2(32);
   h_tc_id VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
-- Declare Cursors
      CURSOR C_WBSi IS
         SELECT * FROM (SELECT TW.ELEMENT_ID
         FROM TMT_WBS TW JOIN TMT_TIMECODES TC ON TC.ELEMENT_ID = TW.ELEMENT_ID
         WHERE TW.RANK LIKE (SUBSTR(h_rank, 1, 8)) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(TW.RANK)) = TW.RANK
         AND TW.RANK < h_rank
         ORDER BY TW.RANK DESC
         ) WHERE ROWNUM<=1;

      CURSOR C_TC IS
         SELECT PARENT_ID
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_wbs_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_WBS_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_WBS_TC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_WBS_TC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TC', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_WBS_TC(38) : timecodes.sql(2403) : ' || SYSTIMESTAMP);
   END IF; 

   --get most closed parent element which has timecode(s)
   
   OPEN C_WBSi;
   
   FETCH C_WBSi INTO h_wbs_id;
   IF C_WBSi%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND ((h_wbs_id IS NOT NULL)) Then
      --fetch all the timecodes that parent_id has
      
      OPEN C_TC;
      
      LOOP
         FETCH C_TC INTO h_tc_id;
         IF C_TC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT P.MAX_RANK + 1 INTO h_max_rank
            FROM TMT_TIMECODES C JOIN TMT_TIMECODES P ON P.ELEMENT_ID = C.PARENT_ID
            WHERE C.PARENT_ID = h_tc_id
            AND C.ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 78+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(79) : timecodes.sql(2444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               SELECT MAX_RANK+1 INTO h_max_rank
               FROM TMT_TIMECODES
               WHERE ELEMENT_ID = h_tc_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 93+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(94) : timecodes.sql(2459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
            
            --insert into timecodes
            BEGIN
               INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER )
               SELECT
               RTRIM(RANK) || h_rankBase64,
               h_tc_id,
               h_id,
               h_type_id,
               LEVEL_ID + 1,
               REC_USER
               FROM TMT_TIMECODES WHERE ELEMENT_ID = h_tc_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 121+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(122) : timecodes.sql(2487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update timecode's max_rank and child_count
            BEGIN
               UPDATE TMT_TIMECODES SET
               MAX_RANK = MAX_RANK + 1,
               CHILD_COUNT = CHILD_COUNT + 1
               WHERE ELEMENT_ID = h_tc_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 142+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(143) : timecodes.sql(2508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      --end of while
      
      BEGIN
         CLOSE C_TC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(159) : timecodes.sql(2524) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      CLOSE C_WBSi ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_WBS_TC', 172+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_WBS_TC(173) : timecodes.sql(2538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_WBS_TC', 178+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_WBS_TC(179) : timecodes.sql(2544) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_WBS_TC;
ALTER FUNCTION FC_A_WBS_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_C_WBS_TC ==
CREATE OR REPLACE FUNCTION FC_C_WBS_TC
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_wbs_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_tc_id VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
-- Declare Cursors
      CURSOR C_TCi IS
         SELECT PARENT_ID
         FROM TMT_TIMECODES
         WHERE ELEMENT_ID = h_wbs_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_WBS_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_WBS_TC'), '-- ' || SYSTIMESTAMP, ':r := FC_C_WBS_TC(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_wbs_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_WBS_TC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_WBS_TC(28) : timecodes.sql(2582) : ' || SYSTIMESTAMP);
   END IF; 

   --fetch all the timecodes that parent_id has
   
   OPEN C_TCi;
   
   LOOP
      FETCH C_TCi INTO h_tc_id;
      IF C_TCi%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      BEGIN
         SELECT P.MAX_RANK + 1 INTO h_max_rank
         FROM TMT_TIMECODES C JOIN TMT_TIMECODES P ON P.ELEMENT_ID = C.PARENT_ID
         WHERE C.PARENT_ID = h_tc_id
         AND C.ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(57) : timecodes.sql(2611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            SELECT MAX_RANK + 1 INTO h_max_rank
            FROM TMT_TIMECODES
            WHERE ELEMENT_ID = h_tc_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 71+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(72) : timecodes.sql(2626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --insert into timecodes
         BEGIN
            INSERT INTO TMT_TIMECODES( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER )
            SELECT
            RTRIM(RANK) || h_rankBase64,
            h_tc_id,
            h_id,
            h_type_id,
            LEVEL_ID + 1,
            REC_USER
            FROM TMT_TIMECODES WHERE ELEMENT_ID = h_tc_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(100) : timecodes.sql(2654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update timecode's max_rank and child_count
         BEGIN
            UPDATE TMT_TIMECODES SET
            MAX_RANK = MAX_RANK + 1,
            CHILD_COUNT = CHILD_COUNT + 1
            WHERE ELEMENT_ID = h_tc_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(121) : timecodes.sql(2675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   --end of while
   
   BEGIN
      CLOSE C_TCi ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_WBS_TC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_WBS_TC(137) : timecodes.sql(2691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_WBS_TC', 142+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_WBS_TC(143) : timecodes.sql(2697) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_WBS_TC;
ALTER FUNCTION FC_C_WBS_TC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_WBS_TC ==
CREATE OR REPLACE FUNCTION SP_A_WBS_TC
(
     p_element_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_WBS_TC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_WBS_TC'), '-- ' || SYSTIMESTAMP, ':r := SP_A_WBS_TC(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TC', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_WBS_TC(20) : timecodes.sql(2727) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_WBS_TC', 24+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_WBS_TC(25) : timecodes.sql(2732) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_WBS_TC', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_WBS_TC(28) : timecodes.sql(2735) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   BEGIN
      SELECT RANK, TYPE_ID
      INTO h_rank, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TC(48) : timecodes.sql(2755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_DB2M.SC_STATE := FC_A_WBS_TC(h_element_id, h_rank, h_type_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_WBS_TC', 57+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_WBS_TC(58) : timecodes.sql(2765) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TC', 64+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TC(65) : timecodes.sql(2772) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_WBS_TC', 76+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_WBS_TC(77) : timecodes.sql(2784) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_WBS_TC;
ALTER FUNCTION SP_A_WBS_TC COMPILE DEBUG;

