/****************************************************************************************/

Prompt == FUNCTION SP_WELCOME_VIEW ==
CREATE OR REPLACE FUNCTION SP_WELCOME_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_resource_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WELCOME_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WELCOME_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_WELCOME_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WELCOME_VIEW(23) : views_welcome.sql(26) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_ids IS NULL) OR (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WELCOME_VIEW', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WELCOME_VIEW(28) : views_welcome.sql(31) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_WELCOME_VIEW(31) : views_welcome.sql(34) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_ids;
   h_type := p_type;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_WELCOME_PAGE';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --Workflow Due
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WR.ELEMENT_ID) INTO h_count
      FROM WORKFLOW_REPLIES WR
      JOIN TMT_WORKFLOWS WF ON WF.ELEMENT_ID = WR.ELEMENT_ID
      AND WF.EXPIRES_DATE < (SYSTIMESTAMP + 7     )
      AND WF.END_CYCLE = '0'
      AND WF.TYPE_ID <> 85
      WHERE WR.RESOURCE_ID = h_resource_id
      AND WR.REPLY_TYPE <> PMO_CNST.SC_HIDEN_REPLY
      AND WR.REPLY_STATUS = 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(71) : views_welcome.sql(74) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 1, 'Workfow Due', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(89) : views_welcome.sql(92) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Workflow Late
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WR.ELEMENT_ID) INTO h_count
      FROM WORKFLOW_REPLIES WR
      JOIN TMT_WORKFLOWS WF ON WF.ELEMENT_ID = WR.ELEMENT_ID
      AND WF.EXPIRES_DATE < SYSTIMESTAMP
      AND WF.END_CYCLE = '0'
      AND WF.TYPE_ID <> 85
      WHERE WR.RESOURCE_ID = h_resource_id
      AND WR.REPLY_TYPE <> PMO_CNST.SC_HIDEN_REPLY
      AND WR.REPLY_STATUS = 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(113) : views_welcome.sql(116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 2, 'Workflow Late', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(131) : views_welcome.sql(134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Workflow Closed-Continue
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WF.ELEMENT_ID) INTO h_count
      FROM TMT_WORKFLOWS WF
      WHERE WF.AUTHOR_ID = h_resource_id
      AND WF.END_CYCLE = '0'
      AND WF.WKF_STATUS = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 150+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(151) : views_welcome.sql(154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 3, 'Workflow Closed-Continue', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(169) : views_welcome.sql(172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Unread Notification
   h_count := 0;
   
   BEGIN
      SELECT COUNT(WR.ELEMENT_ID) INTO h_count
      FROM WORKFLOW_REPLIES WR
      JOIN TMT_WORKFLOWS WF ON WF.ELEMENT_ID = WR.ELEMENT_ID
      AND WF.TYPE_ID = 85
      WHERE WR.RESOURCE_ID = h_resource_id
      AND WR.REPLY_TYPE <> PMO_CNST.SC_HIDEN_REPLY
      AND WR.REPLY_STATUS = 0
      AND WR.MARKED_READ = '0';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 191+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(192) : views_welcome.sql(195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 4, 'Unread Notification', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(210) : views_welcome.sql(213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.VARIANCE <> 0
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(231) : views_welcome.sql(234) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 101, 'Project(s) Has Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 248+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(249) : views_welcome.sql(252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Schedule Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.BASELINE1_VARIANCE <> 0
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 269+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(270) : views_welcome.sql(273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 102, 'Project(s) Has Schedule Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 287+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(288) : views_welcome.sql(291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Forecast Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.FORECAST_VARIANCE <> 0
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 308+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(309) : views_welcome.sql(312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 103, 'Project(s) Has Forecast Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 326+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(327) : views_welcome.sql(330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Effort Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.WORK_TODATE + W.ETC <> W.SCHED_EFFORT + W.PLANNED_EFFORT
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 347+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(348) : views_welcome.sql(351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 104, 'Project(s) Has Effort Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 365+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(366) : views_welcome.sql(369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Scheduled Effort Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.BASELINE1_EFFORT > 0 AND W.BASELINE1_EFFORT <> W.SCHED_EFFORT
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 386+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(387) : views_welcome.sql(390) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 105, 'Project(s) Has Scheduled Effort Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 404+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(405) : views_welcome.sql(408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Forecast Effort Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.FORECAST_EFFORT <> W.SCHED_EFFORT
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 425+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(426) : views_welcome.sql(429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 106, 'Project(s) Has Forecast Effort Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 443+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(444) : views_welcome.sql(447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Budget Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.ESTIMATION_BUDGET <> W.CURRENT_BUDGET
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 464+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(465) : views_welcome.sql(468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 107, 'Project(s) Has Budget Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 482+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(483) : views_welcome.sql(486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Scheduled Budget Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.BASELINE1_BUDGET > 0 AND W.BASELINE1_BUDGET <> W.CURRENT_BUDGET
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 503+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(504) : views_welcome.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 108, 'Project(s) Has Scheduled Budget Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 521+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(522) : views_welcome.sql(525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project(s) Has Forecast Budget Variance
   h_count := 0;
   
   BEGIN
      SELECT COUNT(W.ELEMENT_ID) INTO h_count
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      AND W.FORECAST_BUDGET <> W.CURRENT_BUDGET
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 542+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(543) : views_welcome.sql(546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 109, 'Project(s) Has Forecast Budget Variance', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 560+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(561) : views_welcome.sql(564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Timesheet(s) To Approve
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 110, 'Timesheet(s) To Approve', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 581+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(582) : views_welcome.sql(585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Expense(s) To Approve
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 111, 'Expense(s) To Approve', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 602+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(603) : views_welcome.sql(606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project Workflow States
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      SELECT 112, RTRIM(W.ELEMENT_NAME) || ' - ' || RTRIM(WF.ELEMENT_NAME), 0
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS W ON W.ELEMENT_ID = PA.PROJECT_ID
      JOIN TMT_WORKFLOWS WF ON WF.PARENT_ID = W.ELEMENT_ID
      AND WF.END_CYCLE = '0'
      WHERE PA.RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 628+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(629) : views_welcome.sql(632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Late Task(s)
   h_count := 0;
   
   BEGIN
      SELECT COUNT(TA.TSK_ASSIGNMENT_ID) INTO h_count
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.WORK_TODATE = 0
      AND TA.SCHED_START < (SYSTIMESTAMP - 7     );
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 648+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(649) : views_welcome.sql(652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 201, 'Late Task(s)', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 666+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(667) : views_welcome.sql(670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Potential Late Task(s)
   h_count := 0;
   
   BEGIN
      SELECT COUNT(TA.TSK_ASSIGNMENT_ID) INTO h_count
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.WORK_TODATE > 0
      AND TA.SCHED_FINISH > TA.PROPOSED_FINISH;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 686+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(687) : views_welcome.sql(690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 202, 'Potential Late Task(s)', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 704+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(705) : views_welcome.sql(708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Timesheet(s) Due
   h_count := 0;
   
   BEGIN
      SELECT COUNT(ST.WEEK_OF) INTO h_count
      FROM TASK_ASSIGNMENTS TA
      JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND WEEK_OF < (TO_DATE(SYSDATE) - 7     )
      AND (WEEKLY_REGULAR_TOTAL + WEEKLY_SPECIAL_TOTAL) = 0
      WHERE TA.RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 725+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(726) : views_welcome.sql(729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 203, 'Timesheet(s) Due', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 743+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(744) : views_welcome.sql(747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Favorite
   h_count := 0;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 300, 'Favorite: Systemcorp-www.systemcorp.com', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 764+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(765) : views_welcome.sql(768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_WELCOME_PAGE( TYPE_ID, DESCRIPTION, ITEM_COUNT )
      VALUES( 300, 'Favorite: IBM-www.ibm.com', h_count );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 782+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(783) : views_welcome.sql(786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --=====================================================================
   -- Return Result Set
   --=====================================================================
   h_xsql := 'SELECT * FROM PMO_WELCOME_PAGE ORDER BY TYPE_ID ';
   
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 794+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WELCOME_VIEW(795) : views_welcome.sql(798) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WELCOME_VIEW', 797+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_WELCOME_VIEW(798) : views_welcome.sql(801) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 805+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(806) : views_welcome.sql(809) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WELCOME_VIEW', 817+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WELCOME_VIEW(818) : views_welcome.sql(821) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WELCOME_VIEW;
ALTER FUNCTION SP_WELCOME_VIEW COMPILE DEBUG;

