Prompt == FUNCTION FC_U_ATTACHMENT_PRTF ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_PRTF
(
     h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_PRTF(' || 
       '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_PRTF', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_PRTF(18) : wbs_func.sql(19) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_PRTF', 21+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_PRTF(22) : wbs_func.sql(23) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_PRTF', 25+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_PRTF(26) : wbs_func.sql(27) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_PRTF;
ALTER FUNCTION FC_U_ATTACHMENT_PRTF COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DIF_PRTF ==
CREATE OR REPLACE FUNCTION FC_MOVE_DIF_PRTF
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_parent_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_parent_type_id PLS_INTEGER := sh_h_target_parent_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
-- Declare Cursors
      CURSOR MVDIF_PRTF IS
         SELECT RANK
         FROM TMT_PORTFOLIOS
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || '%'
         AND LEVEL_ID = h_target_level AND RANK >= h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DIF_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DIF_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DIF_PRTF(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_parent_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DIF_PRTF', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DIF_PRTF(47) : wbs_func.sql(82) : ' || SYSTIMESTAMP);
   END IF; 

   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- REMOVE EXTERNAL DEPENDENCIES
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(106) : wbs_func.sql(141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(122) : wbs_func.sql(157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDIF_PRTF;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVDIF_PRTF INTO h_cur_rank;
      IF MVDIF_PRTF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_len := Coalesce(Length(h_next_rank), 0);
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_cur_rank, h_next_rank, h_len);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
         PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
         ELSE PARENT_ID END,
         LEVEL_ID = CASE WHEN h_next_rank = h_source_rank
         THEN LEVEL_ID - h_source_level + h_target_level ELSE LEVEL_ID END
         WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 177+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(178) : wbs_func.sql(213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDIF_PRTF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(193) : wbs_func.sql(228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(212) : wbs_func.sql(247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_PORTFOLIOS
      WHERE ELEMENT_ID = h_target_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(227) : wbs_func.sql(262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || h_rankBase64
      INTO h_cur_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 244+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(245) : wbs_func.sql(280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_len := Coalesce(Length(h_next_rank), 0);
   
   PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_cur_rank, h_next_rank, h_len);
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_next_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_next_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
       || h_extend_rank
      ELSE RTRIM(h_cur_rank)
       || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
      PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
      ELSE PARENT_ID END
      WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 284+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(285) : wbs_func.sql(320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES T1
         SET T1.RANK = SUBSTR(T1.RANK, 1, LENGTH(T1.RANK) - 4),
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_CRI_ATTRIBUTES T2 WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_CRI_ATTRIBUTES T2 WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
         AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 312+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(313) : wbs_func.sql(348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
         AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DIF_PRTF', 332+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DIF_PRTF(333) : wbs_func.sql(368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DIF_PRTF', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DIF_PRTF(340) : wbs_func.sql(375) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DIF_PRTF', 343+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DIF_PRTF(344) : wbs_func.sql(379) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DIF_PRTF;
ALTER FUNCTION FC_MOVE_DIF_PRTF COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_PRTF ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_PRTF
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_PRTF IS
         SELECT RANK
         FROM TMT_PORTFOLIOS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_PRTF(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_PRTF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_PRTF(32) : wbs_func.sql(419) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(46) : wbs_func.sql(433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_PRTF;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_PRTF INTO h_cur_rank;
      IF MVUP_PRTF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_cur_rank, h_next_rank, h_len);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 98+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(99) : wbs_func.sql(486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_PRTF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(114) : wbs_func.sql(501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_PRTF', 146+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_PRTF(147) : wbs_func.sql(534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_PRTF', 152+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_PRTF(153) : wbs_func.sql(540) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_PRTF', 156+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_PRTF(157) : wbs_func.sql(544) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_PRTF;
ALTER FUNCTION FC_MOVE_UP_PRTF COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_PRTF ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_PRTF
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_PRTF IS
         SELECT RANK
         FROM TMT_PORTFOLIOS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_PRTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_PRTF'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_PRTF(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_PRTF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_PRTF(32) : wbs_func.sql(584) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(46) : wbs_func.sql(598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_PRTF;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_PRTF INTO h_cur_rank;
      IF MVDOWN_PRTF%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_PRTF(h_next_rank, h_cur_rank, h_len);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE PMO_ORASTD.LOCATE(h_extend_rank, RANK) = 0 AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(97) : wbs_func.sql(649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_PRTF ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(112) : wbs_func.sql(664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_PRTF', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_PRTF(145) : wbs_func.sql(697) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_PRTF', 150+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_PRTF(151) : wbs_func.sql(703) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_PRTF', 154+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_PRTF(155) : wbs_func.sql(707) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_PRTF;
ALTER FUNCTION FC_MOVE_DOWN_PRTF COMPILE DEBUG;

/*****************************************************************************************/

-- This function generates the inherited security list for assigned elements in the child

-- and parent list of the element with element_id. The list will be stored in temporary

-- table TMP_INHERIT_SECURITY (project_id, element_id, rank, security_id, security_ids).

-- Pass 0 to h_table_type if you already insert all necessary rows in the temporary table.

/*****************************************************************************************/

Prompt == FUNCTION FC_INHERIT_SECURITY ==
CREATE OR REPLACE FUNCTION FC_INHERIT_SECURITY
(
     sh_h_table_type PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_security_id VARCHAR2(32);
   h_security_ids VARCHAR2(3199);
   h_count PLS_INTEGER := 0;
   i PLS_INTEGER;
   j PLS_INTEGER;
-- Declare Cursors
      CURSOR C_INHERIT_SECURITY IS
         SELECT DISTINCT ELEMENT_ID, RANK, CASE WHEN SECURITY_ID IS NuLL THEN '' ELSE RTRIM(SECURITY_ID) END
         FROM TMP_INHERIT_SECURITY
         WHERE 1 = 1
         ORDER BY RANK;

      CURSOR C_PARENT_SECURITY IS
         SELECT * FROM (SELECT CASE WHEN SECURITY_IDS IS NuLL THEN '' ELSE SECURITY_IDS END, ID_COUNT
         FROM TMP_PARENT_SECURITY
         WHERE (SUBSTR(h_cur_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_cur_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_cur_rank, 1, 8) || '%'))
         ORDER BY RANK DESC
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INHERIT_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INHERIT_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := FC_INHERIT_SECURITY(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INHERIT_SECURITY(42) : wbs_func.sql(769) : ' || SYSTIMESTAMP);
   END IF; 

   h_cur_rank := '';
   -- create this template table to solve read dirty values problem
   -- Once we have the reason of this problem, this table can be dropped.
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM TMP_PARENT_SECURITY';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 62+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(63) : wbs_func.sql(790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(70) : wbs_func.sql(797) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_WBS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D'
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(97) : wbs_func.sql(824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_CRI
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(112) : wbs_func.sql(839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(119) : wbs_func.sql(846) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, COALESCE(R.CRI_SECURITY_ID, R.SECURITY_ID)
         FROM TMT_CRI W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 1
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(146) : wbs_func.sql(873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(161) : wbs_func.sql(888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 167+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(168) : wbs_func.sql(895) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 1
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 194+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(195) : wbs_func.sql(922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_RES) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_RES_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(211) : wbs_func.sql(938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 217+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(218) : wbs_func.sql(945) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_RESOURCE_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 244+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(245) : wbs_func.sql(972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_POL) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_POL_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 260+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(261) : wbs_func.sql(988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 267+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(268) : wbs_func.sql(995) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_POOL_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 294+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(295) : wbs_func.sql(1022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_AST) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_AST_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 310+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(311) : wbs_func.sql(1038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 317+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(318) : wbs_func.sql(1045) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_ASSET_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 344+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(345) : wbs_func.sql(1072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_VDR) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_VDR_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 360+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(361) : wbs_func.sql(1088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 367+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(368) : wbs_func.sql(1095) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_VENDOR_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 394+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(395) : wbs_func.sql(1122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN) OR (Coalesce(
                h_table_type, 0) = PMO_CNST.SC_TABLE_CLN_DOC) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 410+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(411) : wbs_func.sql(1138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 417+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(418) : wbs_func.sql(1145) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_CLIENT_DOCUMENTS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 0
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 444+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(445) : wbs_func.sql(1172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_SCD Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 459+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(460) : wbs_func.sql(1187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 466+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(467) : wbs_func.sql(1194) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT h_project_id, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_ASSIGNED_SCORECARDS W, RESOURCE_ASSIGNMENTS R
         WHERE W.RANK LIKE h_cur_rank || '%'
         AND W.PROJECT_ID = h_project_id
         AND W.REC_STATUS <> 'D' AND W.LEVEL_ID > 1
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 493+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(494) : wbs_func.sql(1221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(Length(h_cur_rank), 0) > 8 Then
      BEGIN
         INSERT INTO TMP_INHERIT_SECURITY (PROJECT_ID, ELEMENT_ID, RANK, SECURITY_ID)
         SELECT W.PROJECT_ID, W.ELEMENT_ID, W.RANK, R.SECURITY_ID
         FROM TMT_WBS W, RESOURCE_ASSIGNMENTS R
         WHERE (SUBSTR(h_cur_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_cur_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK 
         AND (W.RANK LIKE SUBSTR(h_cur_rank, 1, 8) || '%'))
         AND W.REC_STATUS <> 'D'
         AND R.PROJECT_ID = W.PROJECT_ID
         AND R.ELEMENT_ID = W.ELEMENT_ID
         AND R.RESOURCE_ID = h_resource_id
         AND NOT EXISTS(SELECT T.ELEMENT_ID FROM TMP_INHERIT_SECURITY T
         WHERE T.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 522+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(523) : wbs_func.sql(1250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN C_INHERIT_SECURITY;
   
   LOOP
      FETCH C_INHERIT_SECURITY INTO h_id, h_cur_rank, h_security_id;
      IF C_INHERIT_SECURITY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      --trace_printf("h_cur_rank: %s\n", h_cur_rank);
      --trace_printf("h_security_id: %s\n", h_security_id);
      h_count := 0;
      
      OPEN C_PARENT_SECURITY;
      
      FETCH C_PARENT_SECURITY INTO h_security_ids, h_count;
      IF C_PARENT_SECURITY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d\n", SC_STATE);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         h_security_ids := '';
         h_count := 0;
      End If;
      --trace_printf("h_security_ids: %s\n", h_security_ids);
      --trace_printf("h_count00: %d\n", h_count);
      
      BEGIN
         CLOSE C_PARENT_SECURITY ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 570+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(571) : wbs_func.sql(1298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         j := Coalesce(h_count, 0) * 32 - Coalesce(Length(h_security_ids), 0);
         i := 0;
         WHILE i < j LOOP
            h_security_ids := SubStr(h_security_ids || ' ', 1, 3199);
            i := i + 1;
         END LOOP;
      End If;
      
      If Coalesce(Length(h_security_id), 0) > 0 Then
         h_count := Coalesce(h_count, 0) + 1;
      End If;
      --trace_printf("h_count: %d\n", h_count);
      
      BEGIN
         UPDATE TMP_INHERIT_SECURITY
         SET SECURITY_IDS = h_security_ids || h_security_id,
         ID_COUNT = h_count
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 604+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(605) : wbs_func.sql(1332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMP_PARENT_SECURITY (RANK, ELEMENT_ID, ID_COUNT, SECURITY_IDS)
         VALUES (h_cur_rank, h_id, h_count, h_security_ids || h_security_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 622+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(623) : wbs_func.sql(1350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_INHERIT_SECURITY ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INHERIT_SECURITY', 635+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INHERIT_SECURITY(636) : wbs_func.sql(1363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INHERIT_SECURITY', 641+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INHERIT_SECURITY(642) : wbs_func.sql(1369) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INHERIT_SECURITY;
ALTER FUNCTION FC_INHERIT_SECURITY COMPILE DEBUG;

