CREATE OR REPLACE PACKAGE BODY PMODEFINES AS

PROCEDURE PMO_RETURN_STATUS(state IN PLS_INTEGER, host_id IN VARCHAR2, ISSTOREPROC__ IN BOOLEAN) AS
BEGIN
   IF ISSTOREPROC__ = TRUE THEN
   PMO_DB2M.CURRENT_ID := host_id;
   PMO_DB2M.CURRENT_STATE := state;
   RAISE PMO_DB2M.RETURN_ERROR_EXCEPTION;
   ELSE
	   PMO_DB2M.SC_STATE := state;
   END IF;
END;

FUNCTION PMO_RETURN_ERROR(state IN PLS_INTEGER, host_id IN VARCHAR2, ISSTOREPROC__ IN BOOLEAN) RETURN PLS_INTEGER AS
BEGIN
   IF ISSTOREPROC__ = TRUE THEN
   PMO_DB2M.CURRENT_ID := host_id;
   PMO_DB2M.CURRENT_STATE := state;
   RAISE PMO_DB2M.RETURN_ERROR_EXCEPTION;
   ELSE
	   PMO_DB2M.SC_STATE := state;
	   RETURN state;
   END IF;
END;
PROCEDURE PMO_RETURN_ERROR_SP(state IN PLS_INTEGER, host_id IN VARCHAR2, ISSTOREPROC__ IN BOOLEAN) AS
BEGIN
   IF ISSTOREPROC__ = TRUE THEN
   PMO_DB2M.CURRENT_ID := host_id;
   PMO_DB2M.CURRENT_STATE := state;
   RAISE PMO_DB2M.RETURN_ERROR_EXCEPTION;
   ELSE
	   PMO_DB2M.SC_STATE := state;
	   --RETURN state;
   END IF;
END;

FUNCTION PMO_RETURN_INVALID(state IN PLS_INTEGER, ISSTOREPROC__ IN BOOLEAN) RETURN PLS_INTEGER AS
BEGIN
   IF ISSTOREPROC__ = TRUE THEN
		PMO_DB2M.CURRENT_ID := PMO_CNST.INVALID;
		PMO_DB2M.CURRENT_STATE := state;
		RAISE PMO_DB2M.RETURN_ERROR_EXCEPTION;
   ELSE
		PMO_DB2M.SC_STATE := state;
		RETURN state;
   END IF;
END;
PROCEDURE PMO_RETURN_INVALID_SP(state IN PLS_INTEGER, ISSTOREPROC__ IN BOOLEAN) AS
BEGIN
   IF ISSTOREPROC__ = TRUE THEN
		PMO_DB2M.CURRENT_ID := PMO_CNST.INVALID;
		PMO_DB2M.CURRENT_STATE := state;
		RAISE PMO_DB2M.RETURN_ERROR_EXCEPTION;
   ELSE
		PMO_DB2M.SC_STATE := state;
		--RETURN state;
   END IF;
END;

PROCEDURE PMO_GET_ROOT_MAX_RANK(tableName IN VARCHAR2, hostVar OUT NOCOPY PLS_INTEGER) AS
BEGIN
   EXECUTE IMMEDIATE 'UPDATE ' || tableName || ' SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID IS NULL
         RETURNING MAX_RANK INTO :r'
      Using OUT hostVar;
END;

PROCEDURE PMO_GET_MAX_RANK(tableName IN VARCHAR2, id IN CHAR, hostVar OUT NOCOPY PLS_INTEGER) AS
BEGIN
   EXECUTE IMMEDIATE 'UPDATE ' || tableName || ' SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = :i
         RETURNING MAX_RANK INTO :r'
      Using IN id, OUT hostVar;
END;

PROCEDURE PMO_GET_UNIQUE_MAX_RANK(tableName IN VARCHAR2, id IN VARCHAR2, ora_type IN PLS_INTEGER, hostVar OUT NOCOPY PLS_INTEGER) AS
BEGIN
   EXECUTE IMMEDIATE 'UPDATE ' || tableName || ' SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = :i AND TYPE_ID = :t
         RETURNING MAX_RANK INTO :r'
      Using IN id, IN ora_type, OUT hostVar;
END;

FUNCTION PMO_SELECT_READ(h_myStmt LONG) RETURN PMO_DB2M.REF_CURSOR AS
   out_cursor PMO_DB2M.REF_CURSOR;
BEGIN
   OPEN out_cursor FOR h_myStmt;

   RETURN out_cursor;
END;


END;
/


