

DROP TABLE PMO_PVT_ASSIGNMENTS;
DROP TABLE PMO_PVT_FISCAL_CALENDAR;
DROP TABLE PMO_PVT_PARENTS;
DROP TABLE PMO_PVT_PROJECTS;
DROP TABLE PMO_PVT_RESOURCES;
DROP TABLE PMO_PVT_TASKS;
DROP TABLE PMO_PVT_TIMESHEETS;
DROP TABLE PMO_PVT_UTILIZATION;
DROP TABLE PMO_PVT_WORK_MONTHLY;
DROP TABLE PMO_PVT_WORK_WEEKLY;

Prompt ==  PMO_PVT_ASSIGNMENTS == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_ASSIGNMENTS
(
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	TASK_ID VARCHAR2(32) DEFAULT ' ',
	RESOURCE_TYPE NUMBER(5) DEFAULT 0,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ',
	RES_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ',
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ',
	BILLABLE NUMBER(5) DEFAULT 0,
	LEVEL_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	LEVEL_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	START_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	FINISH_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE3_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE3_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	PROPOSED_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	PROPOSED_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	UNRESOLVED_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	UNRESOLVED_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	ACTUAL_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	ACTUAL_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_WORK NUMBER(19) DEFAULT 0,
	BASELINE3_WORK NUMBER(19) DEFAULT 0,
	PLANNED_WORK NUMBER(19) DEFAULT 0,
	SCHED_WORK NUMBER(19) DEFAULT 0,
	WORK_TODATE NUMBER(19) DEFAULT 0,
	BILLABLE_WORK_TODATE NUMBER(19) DEFAULT 0,
	ACTIVITY_COUNT NUMBER(5) DEFAULT 0,
	SECURITY_ID CHAR(32) DEFAULT ' ',
	SECURITY_NAME VARCHAR2(50) DEFAULT ' ',
	REPLACE_ID VARCHAR2(32) DEFAULT ' ',
	COMPETENCY_ID VARCHAR2(32) DEFAULT ' ',
	COMPETENCY_NAME VARCHAR2(100) DEFAULT ' ',
	ROLE_ID VARCHAR2(32) DEFAULT ' ',
	ROLE_NAME VARCHAR2(100) DEFAULT ' ',
	REGULAR_COST NUMBER(18,2) DEFAULT 0.00,
	REGULAR_RATE NUMBER(18,2) DEFAULT 0.00,
	SPECIAL_COST NUMBER(18,2) DEFAULT 0.00,
	SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00,
	TD_BASELINE_MIN NUMBER(19) DEFAULT 0,
	TD_PLANNED_MIN NUMBER(19) DEFAULT 0,
	TD_SCHED_MIN NUMBER(19) DEFAULT 0,
	TD_ACTUAL_MIN NUMBER(19) DEFAULT 0,
	YTD_BASELINE_MIN NUMBER(19) DEFAULT 0,
	YTD_PLANNED_MIN NUMBER(19) DEFAULT 0,
	YTD_SCHED_MIN NUMBER(19) DEFAULT 0,
	YTD_ACTUAL_MIN NUMBER(19) DEFAULT 0
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_FISCAL_CALENDAR == (C:\PMORACLE\DATABASE\CSP\OTF_CDY.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_FISCAL_CALENDAR
(
	FISCAL_YEAR NUMBER(5) DEFAULT 0,
	FISCAL_MONTH NUMBER(5) DEFAULT 0,
	FISCAL_MONTH_START DATE DEFAULT '1899-01-01',
	FISCAL_MONTH_FINISH DATE DEFAULT '1899-01-01',
	FISCAL_WEEK NUMBER(5) DEFAULT 0,
	FISCAL_WEEK_START DATE DEFAULT '1899-01-01',
	FISCAL_WEEK_FINISH DATE DEFAULT '1899-01-01',
	FISCAL_DATE DATE DEFAULT '1899-01-01',
	FISCAL_DATE_DOW NUMBER(5) DEFAULT 0
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_PARENTS == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_PARENTS
(
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	PARENT_ID VARCHAR2(32) DEFAULT ' ',
	PARENT_NAME VARCHAR2(255) DEFAULT ' ',
	START_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	FINISH_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000'
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_PROJECTS == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_PROJECTS
(
	RANK VARCHAR2(192) DEFAULT ' ',
	WBS_CODE VARCHAR2(255) DEFAULT ' ',
	PROJECT_TYPE NUMBER(10) DEFAULT 0,
	TYPE_ID NUMBER(10) DEFAULT 0,
	LEVEL_ID NUMBER(10) DEFAULT 0,
	PARENT_ID VARCHAR2(32) DEFAULT ' ',
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ',
	ELEMENT_NAME VARCHAR2(255) DEFAULT ' ',
	START_FINISH_DATE DATE DEFAULT '1899-01-01',
	FINISH_START_DATE DATE DEFAULT '1899-01-01',
	LEVEL_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	LEVEL_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	START_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	FINISH_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE3_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE3_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	PROPOSED_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	PROPOSED_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	UNRESOLVED_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	UNRESOLVED_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	ACTUAL_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	ACTUAL_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	WS_BASELINE1_EFFORT NUMBER(19) DEFAULT 0,
	WS_BASELINE3_EFFORT NUMBER(19) DEFAULT 0,
	WS_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	WS_ACTUAL_EFFORT NUMBER(19) DEFAULT 0,
	WS_ETC_EFFORT NUMBER(19) DEFAULT 0,
	BASELINE1_EFFORT NUMBER(19) DEFAULT 0,
	BASELINE3_EFFORT NUMBER(19) DEFAULT 0,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0,
	SCHED_EFFORT NUMBER(19) DEFAULT 0,
	WORK_TODATE NUMBER(19) DEFAULT 0,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 0,
	STAGE_ID NUMBER(10) DEFAULT 0,
	BUBBLE_COLOR NUMBER(10) DEFAULT 0,
	REFERENCE_NUMBER NUMBER(19) DEFAULT 0,
	REF_CODE VARCHAR2(32) DEFAULT ' ',
	FS_CODE VARCHAR2(50) DEFAULT ' ',
	OPPORTUNITY_NAME VARCHAR2(50) DEFAULT ' ',
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	ASSET_ID VARCHAR2(32) DEFAULT ' ',
	ASSET_NAME VARCHAR2(50) DEFAULT ' ',
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 0,
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	MANAGER_ID VARCHAR2(32) DEFAULT ' ',
	MANAGER_NAME VARCHAR2(100) DEFAULT ' ',
	INIT_DISCOUNT_RATE NUMBER(18,2) DEFAULT 0.00,
	SUBPROJECT_COUNT NUMBER(10) DEFAULT 0,
	TD_BASELINE_MIN NUMBER(19) DEFAULT 0,
	TD_PLANNED_MIN NUMBER(19) DEFAULT 0,
	TD_SCHED_MIN NUMBER(19) DEFAULT 0,
	TD_ACTUAL_MIN NUMBER(19) DEFAULT 0,
	YTD_BASELINE_MIN NUMBER(19) DEFAULT 0,
	YTD_PLANNED_MIN NUMBER(19) DEFAULT 0,
	YTD_SCHED_MIN NUMBER(19) DEFAULT 0,
	YTD_ACTUAL_MIN NUMBER(19) DEFAULT 0
) ON COMMIT PRESERVE ROWS;


Prompt ==  PMO_PVT_RESOURCES == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_RESOURCES
(
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ',
	FULL_NAME VARCHAR2(100) DEFAULT ' ',
	NICK_NAME VARCHAR2(100) DEFAULT ' ',
	LOGON_NAME VARCHAR2(100) DEFAULT ' ',
	FIRST_NAME VARCHAR2(35) DEFAULT ' ',
	MIDDLE_NAME VARCHAR2(35) DEFAULT ' ',
	LAST_NAME VARCHAR2(35) DEFAULT ' ',
	E_MAIL_ADDRESS VARCHAR2(255) DEFAULT ' ',
	ACTIVE VARCHAR2(1) DEFAULT ' ',
	EFFECTIVE_DATE DATE DEFAULT '1899-01-01',
	DISCONTINUE_DATE DATE DEFAULT '1899-01-01',
	WORK_LOCATION NUMBER(10) DEFAULT 0,
	STATUS1_ID NUMBER(10) DEFAULT 0,
	STATUS2_ID NUMBER(10) DEFAULT 0,
	MAXDAYHRS NUMBER(5) DEFAULT 0,
	MASK_EMPLOYEE_INFO NUMBER(5) DEFAULT 0,
	FS_CODE VARCHAR2(50) DEFAULT ' ',
	COUNTRY_CODE VARCHAR2(10) DEFAULT ' ',
	COMPANY_CODE VARCHAR2(10) DEFAULT ' ',
	DIVISION_CODE VARCHAR2(10) DEFAULT ' ',
	DEPARTMENT_CODE VARCHAR2(10) DEFAULT ' ',
	EMPLOYEE_CODE VARCHAR2(10) DEFAULT ' ',
	CUSTOM_01 VARCHAR2(50) DEFAULT ' ',
	CUSTOM_02 VARCHAR2(50) DEFAULT ' ',
	CUSTOM_03 VARCHAR2(50) DEFAULT ' ',
	CUSTOM_04 VARCHAR2(50) DEFAULT ' ',
	CUSTOM_05 VARCHAR2(50) DEFAULT ' ',
	USER_GROUP_ID VARCHAR2(32) DEFAULT ' ',
	USER_GROUP_NAME VARCHAR2(32) DEFAULT ' ',
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	RATE_ID VARCHAR2(32) DEFAULT ' ',
	REGULAR_COST NUMBER(18,2) DEFAULT 0.00,
	REGULAR_RATE NUMBER(18,2) DEFAULT 0.00,
	SPECIAL_COST NUMBER(18,2) DEFAULT 0.00,
	SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00,
	POOL_ID VARCHAR2(32) DEFAULT ' ',
	POOL_NAME VARCHAR2(100) DEFAULT ' ',
	POOL_MANAGER_ID VARCHAR2(32) DEFAULT ' ',
	POOL_MANAGER_NAME VARCHAR2(100) DEFAULT ' ',
	ORGANIZATION_ID VARCHAR2(32) DEFAULT ' ',
	ORGANIZATION_NAME VARCHAR2(100) DEFAULT ' ',
	GEOGRAPHY_ID VARCHAR2(32) DEFAULT ' ',
	GEOGRAPHY_NAME VARCHAR2(100) DEFAULT ' ',
	PRIMARY_COMPETENCY_ID VARCHAR2(32) DEFAULT ' ',
	PRIMARY_COMPETENCY_NAME VARCHAR2(100) DEFAULT ' ',
	PRIMARY_PROFICIENCY_ID VARCHAR2(32) DEFAULT ' ',
	PRIMARY_PROFICIENCY_NAME VARCHAR2(100) DEFAULT ' '
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_TASKS == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_TASKS
(
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	RANK VARCHAR2(192) DEFAULT ' ',
	WBS_CODE VARCHAR2(255) DEFAULT ' ',
	TYPE_ID NUMBER(10) DEFAULT 0,
	PARENT_ID VARCHAR2(32) DEFAULT ' ',
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ',
	ELEMENT_NAME VARCHAR2(255) DEFAULT ' ',
	LEVEL_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	LEVEL_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	START_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	FINISH_DT TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE3_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE3_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	PROPOSED_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	PROPOSED_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	UNRESOLVED_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	UNRESOLVED_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	ACTUAL_START TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	ACTUAL_FINISH TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	BASELINE1_EFFORT NUMBER(19) DEFAULT 0,
	BASELINE3_EFFORT NUMBER(19) DEFAULT 0,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0,
	SCHED_EFFORT NUMBER(19) DEFAULT 0,
	WORK_TODATE NUMBER(19) DEFAULT 0,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 0,
	STAGE_ID NUMBER(10) DEFAULT 0,
	REFERENCE_NUMBER NUMBER(19) DEFAULT 0,
	REF_CODE VARCHAR2(32) DEFAULT ' ',
	FS_CODE VARCHAR2(50) DEFAULT ' ',
	TD_BASELINE_MIN NUMBER(19) DEFAULT 0,
	TD_PLANNED_MIN NUMBER(19) DEFAULT 0,
	TD_SCHED_MIN NUMBER(19) DEFAULT 0,
	TD_ACTUAL_MIN NUMBER(19) DEFAULT 0,
	YTD_BASELINE_MIN NUMBER(19) DEFAULT 0,
	YTD_PLANNED_MIN NUMBER(19) DEFAULT 0,
	YTD_SCHED_MIN NUMBER(19) DEFAULT 0,
	YTD_ACTUAL_MIN NUMBER(19) DEFAULT 0
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_TIMESHEETS == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_TIMESHEETS
(
	FISCAL_YEAR NUMBER(5) DEFAULT 0,
	FISCAL_MONTH NUMBER(5) DEFAULT 0,
	FISCAL_MONTH_START DATE DEFAULT '1899-01-01',
	FISCAL_MONTH_FINISH DATE DEFAULT '1899-01-01',
	FISCAL_WEEK NUMBER(5) DEFAULT 0,
	FISCAL_WEEK_START DATE DEFAULT '1899-01-01',
	FISCAL_WEEK_FINISH DATE DEFAULT '1899-01-01',
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ',
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	TASK_ID VARCHAR2(32) DEFAULT ' ',
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ',
	TIMECODE_1_ID VARCHAR2(32) DEFAULT ' ',
	TIMECODE_2_ID VARCHAR2(32) DEFAULT ' ',
	NOTES VARCHAR2(255) DEFAULT ' ',
	AVAILABLE_MIN NUMBER(19) DEFAULT 0,
	PLANNED_MIN NUMBER(19) DEFAULT 0,
	SCHED_MIN NUMBER(19) DEFAULT 0,
	ACTUAL_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_PLANNED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_SCHED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_ACTUAL_MIN NUMBER(19) DEFAULT 0,
	ETC NUMBER(19) DEFAULT 0,
	MILESTONE_PERCENT NUMBER(19) DEFAULT 0,
	BASELINE_MIN NUMBER(19) DEFAULT 0,
	BASELINE_REGULAR_COST NUMBER(18,2) DEFAULT 0.00,
	BASELINE_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00,
	BASELINE_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00,
	BASELINE_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_REGULAR_COST NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00,
	SUNDAY_REGULAR NUMBER(19) DEFAULT 0,
	MONDAY_REGULAR NUMBER(19) DEFAULT 0,
	TUESDAY_REGULAR NUMBER(19) DEFAULT 0,
	WEDNESDAY_REGULAR NUMBER(19) DEFAULT 0,
	THURSDAY_REGULAR NUMBER(19) DEFAULT 0,
	FRIDAY_REGULAR NUMBER(19) DEFAULT 0,
	SATURDAY_REGULAR NUMBER(19) DEFAULT 0,
	SUNDAY_SPECIAL NUMBER(19) DEFAULT 0,
	MONDAY_SPECIAL NUMBER(19) DEFAULT 0,
	TUESDAY_SPECIAL NUMBER(19) DEFAULT 0,
	WEDNESDAY_SPECIAL NUMBER(19) DEFAULT 0,
	THURSDAY_SPECIAL NUMBER(19) DEFAULT 0,
	FRIDAY_SPECIAL NUMBER(19) DEFAULT 0,
	SATURDAY_SPECIAL NUMBER(19) DEFAULT 0,
	TIMECODE_1_NAME VARCHAR2(50) DEFAULT ' ',
	TIMECODE_2_NAME VARCHAR2(50) DEFAULT ' ',
	WEEK_MY_STATUS NUMBER(5) DEFAULT 0,
	WEEK_MANAGER_ID VARCHAR2(32) DEFAULT ' ',
	WEEK_MANAGER_NAME VARCHAR2(100) DEFAULT ' ',
	WEEK_MANAGER_STATUS NUMBER(5) DEFAULT 0,
	WEEK_STATUS_DATE TIMESTAMP DEFAULT '1899-01-01 12:00:00.000000',
	WEEK_STATUS_NOTE VARCHAR2(1024) DEFAULT ' '
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_UTILIZATION == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_UTILIZATION
(
	FISCAL_YEAR NUMBER(5) DEFAULT 0,
	FISCAL_MONTH NUMBER(5) DEFAULT 0,
	FISCAL_MONTH_START DATE DEFAULT '1899-01-01',
	FISCAL_MONTH_FINISH DATE DEFAULT '1899-01-01',
	FISCAL_WEEK NUMBER(5) DEFAULT 0,
	FISCAL_WEEK_START DATE DEFAULT '1899-01-01',
	FISCAL_WEEK_FINISH DATE DEFAULT '1899-01-01',
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ',
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	TASK_ID VARCHAR2(32) DEFAULT ' ',
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ',
	AVAILABLE_MIN NUMBER(19) DEFAULT 0,
	BASELINE_MIN NUMBER(19) DEFAULT 0,
	PLANNED_MIN NUMBER(19) DEFAULT 0,
	SCHED_MIN NUMBER(19) DEFAULT 0,
	ACTUAL_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_PLANNED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_SCHED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_ACTUAL_MIN NUMBER(19) DEFAULT 0
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_WORK_MONTHLY == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_WORK_MONTHLY
(
	FISCAL_YEAR NUMBER(5) DEFAULT 0,
	FISCAL_MONTH NUMBER(5) DEFAULT 0,
	FISCAL_MONTH_START DATE DEFAULT '1899-01-01',
	FISCAL_MONTH_FINISH DATE DEFAULT '1899-01-01',
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ',
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	TASK_ID VARCHAR2(32) DEFAULT ' ',
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ',
	AVAILABLE_MIN NUMBER(19) DEFAULT 0,
	BASELINE_MIN NUMBER(19) DEFAULT 0,
	PLANNED_MIN NUMBER(19) DEFAULT 0,
	SCHED_MIN NUMBER(19) DEFAULT 0,
	ACTUAL_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_PLANNED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_SCHED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_ACTUAL_MIN NUMBER(19) DEFAULT 0
) ON COMMIT PRESERVE ROWS;

Prompt ==  PMO_PVT_WORK_WEEKLY == (C:\PMORACLE\DATABASE\CSP\PIVOTS_FUNC.CPP)
CREATE GLOBAL TEMPORARY TABLE PMO_PVT_WORK_WEEKLY
(
	FISCAL_YEAR NUMBER(5) DEFAULT 0,
	FISCAL_MONTH NUMBER(5) DEFAULT 0,
	FISCAL_MONTH_START DATE DEFAULT '1899-01-01',
	FISCAL_MONTH_FINISH DATE DEFAULT '1899-01-01',
	FISCAL_WEEK NUMBER(5) DEFAULT 0,
	FISCAL_WEEK_START DATE DEFAULT '1899-01-01',
	FISCAL_WEEK_FINISH DATE DEFAULT '1899-01-01',
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ',
	PROJECT_ID VARCHAR2(32) DEFAULT ' ',
	TASK_ID VARCHAR2(32) DEFAULT ' ',
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ',
	TIMECODE_1_ID VARCHAR2(32) DEFAULT ' ',
	TIMECODE_2_ID VARCHAR2(32) DEFAULT ' ',
	NOTES VARCHAR2(255) DEFAULT ' ',
	AVAILABLE_MIN NUMBER(19) DEFAULT 0,
	PLANNED_MIN NUMBER(19) DEFAULT 0,
	SCHED_MIN NUMBER(19) DEFAULT 0,
	ACTUAL_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_PLANNED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_SCHED_MIN NUMBER(19) DEFAULT 0,
	BILLABLE_ACTUAL_MIN NUMBER(19) DEFAULT 0,
	ETC NUMBER(19) DEFAULT 0,
	MILESTONE_PERCENT NUMBER(19) DEFAULT 0,
	BASELINE_MIN NUMBER(19) DEFAULT 0,
	BASELINE_REGULAR_COST NUMBER(18,2) DEFAULT 0.00,
	BASELINE_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00,
	BASELINE_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00,
	BASELINE_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_REGULAR_COST NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00,
	SUNDAY_REGULAR NUMBER(19) DEFAULT 0,
	MONDAY_REGULAR NUMBER(19) DEFAULT 0,
	TUESDAY_REGULAR NUMBER(19) DEFAULT 0,
	WEDNESDAY_REGULAR NUMBER(19) DEFAULT 0,
	THURSDAY_REGULAR NUMBER(19) DEFAULT 0,
	FRIDAY_REGULAR NUMBER(19) DEFAULT 0,
	SATURDAY_REGULAR NUMBER(19) DEFAULT 0,
	SUNDAY_SPECIAL NUMBER(19) DEFAULT 0,
	MONDAY_SPECIAL NUMBER(19) DEFAULT 0,
	TUESDAY_SPECIAL NUMBER(19) DEFAULT 0,
	WEDNESDAY_SPECIAL NUMBER(19) DEFAULT 0,
	THURSDAY_SPECIAL NUMBER(19) DEFAULT 0,
	FRIDAY_SPECIAL NUMBER(19) DEFAULT 0,
	SATURDAY_SPECIAL NUMBER(19) DEFAULT 0
) ON COMMIT PRESERVE ROWS;
