
-- **************************************************************************
-- PURPOSE:Migrate from 6.0 to 6.1
-- **************************************************************************
connect owner/ownerpass
set echo on
SET AUTOCOMMIT ON
spool logs/step2.log

ALTER SESSION SET NLS_DATE_FORMAT='YYYY-MM-DD';

ALTER SESSION SET NLS_TIMESTAMP_FORMAT ='YYYY-MM-DD HH24:MI:SS.FF6';
COMMIT WORK;

@oraddl/Sequences.sql


------------------------------------------------------------------------


-- TMT_CHARGECODES


DROP INDEX TCHCD_ENID_XU;
DROP INDEX TCHCD_RK_CU;                
DROP INDEX TCHCD_ACCC_CU;
DROP INDEX TCHAODE_NID_XX;

DROP TABLE TEMP_TMT_CHARGECODES;

CREATE TABLE TEMP_TMT_CHARGECODES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 0,
	RANK VARCHAR2(128) NOT NULL,
	CAPITAL_EXPENSE NUMBER(5) DEFAULT 0,
	ASSOCIATE_CHARGECODE_ID VARCHAR2(32),
	DESCRIPTION VARCHAR2(2048),
	CAPITAL_EXPENSE_ID VARCHAR2(32),
	STAGE_ID NUMBER(10),
	EXTERNAL_IDENTIFIER VARCHAR2(32)
);



INSERT INTO TEMP_TMT_CHARGECODES
(
  LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  BILLABLE,
  RANK,
  CAPITAL_EXPENSE,
  ASSOCIATE_CHARGECODE_ID,
  DESCRIPTION,
  CAPITAL_EXPENSE_ID
)
SELECT
  LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  BILLABLE,
  RANK,
  CAPITAL_EXPENSE,
  ASSOCIATE_CHARGECODE_ID,
  DESCRIPTION,
  CAPITAL_EXPENSE_ID
FROM TMT_CHARGECODES;

DROP TABLE OLD_TMT_CHARGECODES;
ALTER TABLE TMT_CHARGECODES RENAME TO OLD_TMT_CHARGECODES;
ALTER TABLE TEMP_TMT_CHARGECODES RENAME TO TMT_CHARGECODES;


DROP INDEX TCHCD_ENID_XU;
CREATE UNIQUE INDEX TCHCD_ENID_XU ON TMT_CHARGECODES (ELEMENT_ID ASC,PARENT_ID ASC) ;
DROP INDEX TCHCD_RK_CU;
CREATE UNIQUE INDEX TCHCD_RK_CU ON TMT_CHARGECODES (RANK ASC)  PCTFREE = 30;
DROP INDEX TCHCD_ACCC_CU;
CREATE  INDEX TCHCD_ACCC_CU ON TMT_CHARGECODES (ASSOCIATE_CHARGECODE_ID ASC) ;
DROP INDEX TCHAODE_NID_XX;
CREATE  INDEX TCHAODE_NID_XX ON TMT_CHARGECODES (PARENT_ID)  PCTFREE = 30;

DELETE FROM TMT_CHARGECODES WHERE RANK LIKE '!!!!!!!3%';

INSERT INTO TMT_CHARGECODES(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,BILLABLE,RANK,CAPITAL_EXPENSE,ASSOCIATE_CHARGECODE_ID,DESCRIPTION,CAPITAL_EXPENSE_ID, STAGE_ID, EXTERNAL_IDENTIFIER) VALUES(0,64,0,0,0,'CUSTOM_CHARGE_CODES_FOLDER______','Custom Charge Codes',null,'PMO_SYSTEM','I', TIMESTAMP '2001-02-06 11:52:48.555001',0,'!!!!!!!3',0,null,null,null, 6800, 'Custom Charge Codes');


UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 11 WHERE ELEMENT_ID = 'EXPENSE_HOURS';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 12 WHERE ELEMENT_ID = 'EXPENSE_AVERAGE_COST';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 13 WHERE ELEMENT_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 14 WHERE ELEMENT_ID = 'EXPENSE_LABOR';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 14 WHERE ELEMENT_ID = 'EXPENSE_CONTRACTOR_LABOR';

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 21 WHERE ELEMENT_ID = 'CAPITAL_HOURS';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 22 WHERE ELEMENT_ID = 'CAPITAL_AVERAGE_COST';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 23 WHERE ELEMENT_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 24 WHERE ELEMENT_ID = 'CAPITAL_LABOR';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 24 WHERE ELEMENT_ID = 'CAPITAL_CONTRACTOR_LABOR';

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 31 WHERE ELEMENT_ID = 'BENEFIT_HOURS';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 32 WHERE ELEMENT_ID = 'BENEFIT_AVERAGE_RATE';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 33 WHERE ELEMENT_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 34 WHERE ELEMENT_ID = 'BILLABLE_BENEFIT_LABOR';
UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 34 WHERE ELEMENT_ID = 'BENEFIT_CONTRACTOR_LABOR';

UPDATE TMT_CHARGECODES SET CAPITAL_EXPENSE = 10 WHERE ELEMENT_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';

UPDATE TMT_CHARGECODES SET STAGE_ID = 6801 WHERE STAGE_ID IS NULL AND TYPE_ID = 8;

-- TASK_ASSIGNMENTS



DROP INDEX TKASG_GID_XX; 
DROP INDEX TKASG_OID_BF_XX; 
DROP INDEX TKASG_PJRID_CX; 
DROP INDEX TKASG_PJTRID_BF_CX; 
DROP INDEX TKASG_RID_XX;
DROP INDEX TKASG_TAID_XX;
DROP INDEX TKASG_TRID_RT_XX;

DROP TABLE NEW_TASK_ASSIGNMENTS;

CREATE TABLE NEW_TASK_ASSIGNMENTS (
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RES_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	TASK_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32),
	RESOURCE_TYPE VARCHAR2(1) DEFAULT '0' NOT NULL,
	ACCEPTED_DATE DATE,
	ESTIMATE NUMBER(10) DEFAULT 0 NOT NULL,
	BEST NUMBER(10) DEFAULT 0 NOT NULL,
	BIT_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	ASSIGN_STRING VARCHAR2(4000),
	SD NUMBER(5),
	FD NUMBER(5),
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_START TIMESTAMP,
	BASELINE3_FINISH TIMESTAMP,
	BASELINE3_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PLANNED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PLANNED_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	PLANNED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	SCHED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	FORECAST_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	REGULAR_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	SPECIAL_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 1 NOT NULL,
	BILLABLE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE_REGULAR_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE_SPECIAL_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	LAST_SUBMITTED DATE,
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	ACTIVITY_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	T_UNIT NUMBER(5) DEFAULT 0 NOT NULL,
	C_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	C_UNIT NUMBER(5) DEFAULT 0 NOT NULL,
	C_OCCURRENCE NUMBER(5) DEFAULT 0 NOT NULL,
	C_CONTOUR NUMBER(10) DEFAULT 0 NOT NULL,
	CONTOUR_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	UNITS_MSP NUMBER(10) DEFAULT 10000 NOT NULL,
	BAK_START_DT TIMESTAMP,
	BAK_FINISH_DT TIMESTAMP,
	BAK_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BAK_ASSIGN_STRING VARCHAR2(4000),
	TIMECODE2_ID VARCHAR2(32),
	PROJECT_ASSIGNMENT_ID VARCHAR2(32),
	TABLE_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 1052679 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATION_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_START TIMESTAMP,
	LEVEL_FINISH TIMESTAMP,
	LEVEL_EFFORT NUMBER(19) DEFAULT 0,
	CONSIDER NUMBER(5) DEFAULT 0 NOT NULL,
	LEVEL_ASSIGN_STRING VARCHAR2(4000),
	CAPITAL_EXPENSE NUMBER(5) DEFAULT 0,
	BASELINE3_SCH_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	RATES_EDITED NUMBER(5) DEFAULT 0,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	ASSIGNMENT_DELAY NUMBER(19) DEFAULT 0,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	ASSIGN_UNITS NUMBER(10) DEFAULT 0 NOT NULL,
	LAST_SCHED_MIN NUMBER(10) DEFAULT 0 NOT NULL,
	RATE_ADJUSTMENT NUMBER(10) DEFAULT 10000,
	REC_STATUS VARCHAR2(1),
	REC_USER VARCHAR2(32),
	LABOR_COST_CC_ID VARCHAR2(32),
	LABOR_REVENUE_CC_ID VARCHAR2(32),
	DEFAULT_LABOR_FLAG VARCHAR2(1) DEFAULT 'N' NOT NULL,
	COST_CENTER_BITS NUMBER(10) DEFAULT 1 NOT NULL,
	CREDIT_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTRACT_ID VARCHAR2(32)
);


-- Transfer data
INSERT INTO NEW_TASK_ASSIGNMENTS (
	ACCEPTED_DATE,            
	ACTIVITY_COUNT,           
	ACTUAL_DURATION,          
	ACTUAL_FINISH,            
	ACTUAL_LABOR_COST,        
	ACTUAL_LABOR_REVENUE,     
	ACTUAL_LABOR_SAVING,      
	ACTUAL_START,             
	ASSIGNMENT_DELAY,         
	ASSIGN_STRING,            
	ASSIGN_UNITS,             
	BAK_ASSIGN_STRING,        
	BAK_FINISH_DT,            
	BAK_START_DT,             
	BAK_WORK,                 
	BASELINE1_DURATION,       
	BASELINE1_FINISH,         
	BASELINE1_LABOR_COST,     
	BASELINE1_LABOR_REVENUE,  
	BASELINE1_LABOR_SAVING,   
	BASELINE1_START,          
	BASELINE1_WORK,           
	BASELINE2_DURATION,       
	BASELINE2_FINISH,         
	BASELINE2_LABOR_COST,     
	BASELINE2_LABOR_REVENUE,  
	BASELINE2_START,          
	BASELINE2_WORK,           
	BASELINE3_DURATION,       
	BASELINE3_FINISH,         
	BASELINE3_LABOR_COST,     
	BASELINE3_LABOR_REVENUE,  
	BASELINE3_SCH_FLAG,       
	BASELINE3_START,          
	BASELINE3_WORK,           
	BASELINE_WORK_TODATE,     
	BEST,                     
	BILLABLE,                 
	BILLABLE_REGULAR_TODATE,  
	BILLABLE_SPECIAL_TODATE,  
	BILLABLE_WORK_TODATE,     
	BIT_FLAG,                 
	B_REGULAR_COST,           
	B_REGULAR_RATE,           
	B_SPECIAL_COST,           
	B_SPECIAL_RATE,           
	CAPITAL_EXPENSE,          
	CONSIDER,                 
	CONTOUR_TYPE,            
	C_CONTOUR,                
	C_EFFORT,                 
	C_OCCURRENCE,             
	C_UNIT,        
	DURATION,                 
	ESTIMATE,                 
	ESTIMATION_LABOR_COST,    
	ESTIMATION_LABOR_REVENUE, 
	ESTIMATION_LABOR_SAVING,  
	ETC,                      
	FD,                       
	FINISH_DT,                
	FORECAST_DURATION,        
	FORECAST_FINISH,          
	FORECAST_LABOR_COST,      
	FORECAST_LABOR_REVENUE,   
	FORECAST_LABOR_SAVING,    
	FORECAST_START,      
	LAST_SCHED_MIN,           
	LAST_SUBMITTED,           
	LEVEL_ASSIGN_STRING,      
	LEVEL_EFFORT,             
	LEVEL_FINISH,             
	LEVEL_START,              
	MILESTONE_PERCENT,        
	PLANNED_DURATION,         
	PLANNED_FINISH,           
	PLANNED_LABOR_COST,       
	PLANNED_LABOR_REVENUE,    
	PLANNED_LABOR_SAVING,     
	PLANNED_START,            
	PLANNED_WORK,             
	PROJECT_ASSIGNMENT_ID,    
	PROJECT_ID,               
	PROPOSED_DURATION,        
	PROPOSED_FINISH,          
	PROPOSED_LABOR_COST,      
	PROPOSED_LABOR_REVENUE,   
	PROPOSED_LABOR_SAVING,    
	PROPOSED_START,           
	PROPOSED_WORK,            
	RATES_EDITED,             
	RATE_ADJUSTMENT,          
	REC_DATETIME,             
	REC_STATUS,               
	REC_USER,                 
	REGULAR_COST,             
	REGULAR_RATE,             
	REGULAR_TODATE,           
	RESOURCE_ID,              
	RESOURCE_TYPE,            
	RES_ASSIGNMENT_ID,        
	ROLLUP_BITS,              
	SCHED_DURATION,           
	SCHED_FINISH,             
	SCHED_LABOR_COST,         
	SCHED_LABOR_REVENUE,      
	SCHED_LABOR_SAVING,       
	SCHED_START,              
	SCHED_WORK,               
	SD,                       
	SPECIAL_COST,             
	SPECIAL_RATE,             
	SPECIAL_TODATE,           
	START_DT,                 
	TABLE_TYPE,               
	TASK_ID,                  
	TIMECODE2_ID,             
	TIMECODE_1_ID,            
	TIMECODE_2_ID,            
	TSK_ASSIGNMENT_ID,        
	T_UNIT,                   
	UNITS_MSP,                
	UNRESOLVED_DURATION,      
	UNRESOLVED_FINISH,        
	UNRESOLVED_START,         
	WORK_TODATE,
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC )   
SELECT 	ACCEPTED_DATE,            
	ACTIVITY_COUNT,           
	ACTUAL_DURATION,          
	ACTUAL_FINISH,            
	ACTUAL_LABOR_COST,        
	ACTUAL_LABOR_REVENUE,     
	ACTUAL_LABOR_SAVING,      
	ACTUAL_START,             
	ASSIGNMENT_DELAY,         
	ASSIGN_STRING,            
	ASSIGN_UNITS,             
	BAK_ASSIGN_STRING,        
	BAK_FINISH_DT,            
	BAK_START_DT,             
	BAK_WORK,                 
	BASELINE1_DURATION,       
	BASELINE1_FINISH,         
	BASELINE1_LABOR_COST,     
	BASELINE1_LABOR_REVENUE,  
	BASELINE1_LABOR_SAVING,   
	BASELINE1_START,          
	BASELINE1_WORK,           
	BASELINE2_DURATION,       
	BASELINE2_FINISH,         
	BASELINE2_LABOR_COST,     
	BASELINE2_LABOR_REVENUE,  
	BASELINE2_START,          
	BASELINE2_WORK,           
	BASELINE3_DURATION,       
	BASELINE3_FINISH,         
	BASELINE3_LABOR_COST,     
	BASELINE3_LABOR_REVENUE,  
	BASELINE3_SCH_FLAG,       
	BASELINE3_START,          
	BASELINE3_WORK,           
	BASELINE_WORK_TODATE,     
	BEST,                     
	BILLABLE,                 
	BILLABLE_REGULAR_TODATE,  
	BILLABLE_SPECIAL_TODATE,  
	BILLABLE_WORK_TODATE,     
	BIT_FLAG,                 
	B_REGULAR_COST,           
	B_REGULAR_RATE,           
	B_SPECIAL_COST,           
	B_SPECIAL_RATE,           
	CAPITAL_EXPENSE,          
	CONSIDER,                 
	CONTOUR_TYPE,        
	C_CONTOUR,                
	C_EFFORT,                 
	C_OCCURRENCE,             
	C_UNIT,          
	DURATION,                 
	ESTIMATE,                 
	ESTIMATION_LABOR_COST,    
	ESTIMATION_LABOR_REVENUE, 
	ESTIMATION_LABOR_SAVING,  
	ETC,                      
	FD,                       
	FINISH_DT,                
	FORECAST_DURATION,        
	FORECAST_FINISH,          
	FORECAST_LABOR_COST,      
	FORECAST_LABOR_REVENUE,   
	FORECAST_LABOR_SAVING,    
	FORECAST_START,     
	LAST_SCHED_MIN,           
	LAST_SUBMITTED,           
	LEVEL_ASSIGN_STRING,      
	LEVEL_EFFORT,             
	LEVEL_FINISH,             
	LEVEL_START,              
	MILESTONE_PERCENT,        
	PLANNED_DURATION,         
	PLANNED_FINISH,           
	PLANNED_LABOR_COST,       
	PLANNED_LABOR_REVENUE,    
	PLANNED_LABOR_SAVING,     
	PLANNED_START,            
	PLANNED_WORK,             
	PROJECT_ASSIGNMENT_ID,    
	PROJECT_ID,               
	PROPOSED_DURATION,        
	PROPOSED_FINISH,          
	PROPOSED_LABOR_COST,      
	PROPOSED_LABOR_REVENUE,   
	PROPOSED_LABOR_SAVING,    
	PROPOSED_START,           
	PROPOSED_WORK,            
	RATES_EDITED,             
	RATE_ADJUSTMENT,          
	REC_DATETIME,             
	REC_STATUS,               
	REC_USER,                 
	REGULAR_COST,             
	REGULAR_RATE,             
	REGULAR_TODATE,           
	RESOURCE_ID,              
	RESOURCE_TYPE,            
	RES_ASSIGNMENT_ID,        
	ROLLUP_BITS,              
	SCHED_DURATION,           
	SCHED_FINISH,             
	SCHED_LABOR_COST,         
	SCHED_LABOR_REVENUE,      
	SCHED_LABOR_SAVING,       
	SCHED_START,              
	SCHED_WORK,               
	SD,                       
	SPECIAL_COST,             
	SPECIAL_RATE,             
	SPECIAL_TODATE,           
	START_DT,                 
	TABLE_TYPE,               
	TASK_ID,                  
	TIMECODE2_ID,             
	TIMECODE_1_ID,            
	TIMECODE_2_ID,            
	TSK_ASSIGNMENT_ID,        
	T_UNIT,                   
	UNITS_MSP,                
	UNRESOLVED_DURATION,      
	UNRESOLVED_FINISH,        
	UNRESOLVED_START,         
	WORK_TODATE, 
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC 
FROM TASK_ASSIGNMENTS; 	

-- Rename tables
DROP TABLE OLD_TASK_ASSIGNMENTS;
ALTER TABLE TASK_ASSIGNMENTS RENAME TO OLD_TASK_ASSIGNMENTS;
ALTER TABLE NEW_TASK_ASSIGNMENTS RENAME TO TASK_ASSIGNMENTS;

-- DDL Statements for indexes on Table TASK_ASSIGNMENTS

DROP INDEX TKASG_GID_XX;
CREATE  INDEX TKASG_GID_XX ON TASK_ASSIGNMENTS (RES_ASSIGNMENT_ID ASC) ;
DROP INDEX TKASG_OID_BF_XX;
CREATE  INDEX TKASG_OID_BF_XX ON TASK_ASSIGNMENTS (PROJECT_ASSIGNMENT_ID ASC,BIT_FLAG ASC) ;
DROP INDEX TKASG_PJRID_CX;
CREATE  INDEX TKASG_PJRID_CX ON TASK_ASSIGNMENTS (PROJECT_ID ASC,RESOURCE_ID ASC,BIT_FLAG ASC)  PCTFREE = 30;
DROP INDEX TKASG_PJTRID_BF_CX;
CREATE  INDEX TKASG_PJTRID_BF_CX ON TASK_ASSIGNMENTS (PROJECT_ID ASC,TASK_ID ASC,RESOURCE_ID ASC,BIT_FLAG ASC)  PCTFREE = 30;
DROP INDEX TKASG_RID_XX;
CREATE  INDEX TKASG_RID_XX ON TASK_ASSIGNMENTS (RESOURCE_ID ASC) ;
DROP INDEX TKASG_TAID_XX;
CREATE UNIQUE INDEX TKASG_TAID_XX ON TASK_ASSIGNMENTS (TSK_ASSIGNMENT_ID ASC) ;
DROP INDEX TKASG_TRID_RT_XX;
CREATE  INDEX TKASG_TRID_RT_XX ON TASK_ASSIGNMENTS (TASK_ID ASC,RESOURCE_ID ASC,RESOURCE_TYPE ASC) ;

	
-- IF SUCCESSFUL DROP TABLE OLD_TASK_ASSIGNMENTS;

	
UPDATE TASK_ASSIGNMENTS SET LABOR_COST_CC_ID = 'EXPENSE_LABOR' WHERE CAPITAL_EXPENSE = 0;
UPDATE TASK_ASSIGNMENTS SET LABOR_COST_CC_ID = 'CAPITAL_LABOR' WHERE CAPITAL_EXPENSE = 1;
UPDATE TASK_ASSIGNMENTS SET LABOR_REVENUE_CC_ID = 'BILLABLE_BENEFIT_LABOR' WHERE BILLABLE = 1;
UPDATE TASK_ASSIGNMENTS SET LABOR_REVENUE_CC_ID = NULL WHERE BILLABLE = 0;


-- BUDGETS



DROP INDEX BDGTS_EBCID_CU;
DROP INDEX BDGTS_BID_XX;
DROP INDEX BDGTS_CID_XX;

DROP TABLE BUDGETS2;

CREATE TABLE BUDGETS2 (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	CHARGECODE_ID VARCHAR2(32) NOT NULL,
	BUDGET_ID VARCHAR2(32) NOT NULL,
	ASSOCIATE_BUDGET_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32) ,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	TOTAL_ESTIMATION_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_BUDGET_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROB_PERCENT NUMBER(10) DEFAULT 10000,
	PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PAID_TODATE NUMBER(18,2) DEFAULT 0.00,
	AUTO_FLAG NUMBER(5) DEFAULT 1 NOT NULL,
	ACTUAL_EDITED NUMBER(5) DEFAULT 1 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	DATAFIELD_1 NUMBER(10),
	DATAFIELD_2 NUMBER(10),
	TXT_FIELD_01 VARCHAR2(1024),
	TXT_FIELD_02 VARCHAR2(1024),
	TXT_FIELD_03 VARCHAR2(1024),
	TXT_FIELD_04 VARCHAR2(1024),
	TXT_FIELD_05 VARCHAR2(1024),
	TXT_FIELD_06 VARCHAR2(1024),
	TXT_FIELD_07 VARCHAR2(1024),
	TXT_FIELD_08 VARCHAR2(1024),
	TXT_FIELD_09 VARCHAR2(1024),
	TXT_FIELD_10 VARCHAR2(1024),
	TOLERANCE NUMBER(10) DEFAULT 10000,
	ESTIMATED_ACTUAL_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID_TODATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID_TODATE_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PROB_AMOUNT_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_SCH_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	BASELINE3_EST_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	DATAFIELD_3 NUMBER(10),
	DATAFIELD_4 NUMBER(10),
	ACTUAL_TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	CAPITAL_EXPENSE NUMBER(5) DEFAULT 0 NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 1 NOT NULL,
	COST_CENTER_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CHARGED_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_LEDGER_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_ETC_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL
);


DROP INDEX BDGTS_EBCID_CU;
CREATE UNIQUE INDEX BDGTS_EBCID_CU ON BUDGETS2 (PROJECT_ID ASC,ELEMENT_ID ASC,CHARGECODE_ID ASC)  PCTFREE = 30;
DROP INDEX BDGTS_BID_XX;
CREATE UNIQUE INDEX BDGTS_BID_XX ON BUDGETS2 (BUDGET_ID ASC) ;
DROP INDEX BDGTS_CID_XX;
CREATE  INDEX BDGTS_CID_XX ON BUDGETS2 (PROJECT_ID,CHARGECODE_ID ASC) ;
DROP INDEX BUDGET_CHRGEID_XXX;
CREATE  INDEX BUDGET_CHRGEID_XXX ON BUDGETS2 (CHARGECODE_ID)  PCTFREE = 30;

INSERT INTO BUDGETS2 (TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG,
CONTINGENCY_BASELINE1,
	CONTINGENCY_BASELINE2,
	CONTINGENCY_BASELINE3,
	CONTINGENCY_TOTAL,
	CONTINGENCY_BUDGET,
	CONTINGENCY_ETC,
	CONTINGENCY_ETC_TOTAL)
SELECT TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG,
CONTINGENCY_BASELINE1,
	CONTINGENCY_BASELINE2,
	CONTINGENCY_BASELINE3,
	CONTINGENCY_TOTAL,
	CONTINGENCY_BUDGET,
	CONTINGENCY_ETC,
	CONTINGENCY_ETC_TOTAL FROM BUDGETS;

DROP TABLE BUDGETS1;
ALTER TABLE BUDGETS RENAME TO BUDGETS1;
ALTER TABLE BUDGETS2 RENAME TO BUDGETS;

-- IF SUCCESSFULl DROP TABLE BUDGETS1;


UPDATE BUDGETS B SET (B.CAPITAL_EXPENSE, B.BILLABLE) = (SELECT CC.CAPITAL_EXPENSE, CC.BILLABLE FROM TMT_CHARGECODES CC WHERE CC.ELEMENT_ID = B.CHARGECODE_ID)
WHERE EXISTS (select C.* from TMT_CHARGECODES C WHERE  B.CHARGECODE_ID=C.ELEMENT_ID);


UPDATE BUDGETS 
SET CAPITAL_EXPENSE = 10
WHERE CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';


-- PROJECT_DETAILS

ALTER TABLE PROJECT_DETAILS ADD DLV_BUDGET_SETTING_BITS NUMBER(5) DEFAULT 0 NOT NULL;
ALTER TABLE PROJECT_DETAILS ADD OPPORTUNITY_TRACKING_NUMBER VARCHAR2(255);
ALTER TABLE PROJECT_DETAILS ADD OPPORTUNITY_OWNER VARCHAR2(255);
ALTER TABLE PROJECT_DETAILS ADD CONTRACT_TYPE VARCHAR2(100);
ALTER TABLE PROJECT_DETAILS ADD CONTACT_NUMBER VARCHAR2(100);
ALTER TABLE PROJECT_DETAILS ADD CUSTOMER_NUMBER VARCHAR2(100);

ALTER TABLE PROJECT_DETAILS ADD OPPORTUNITY_NAME VARCHAR2(255);
ALTER TABLE PROJECT_DETAILS ADD EXPECTED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL;
ALTER TABLE PROJECT_DETAILS ADD EXPECTED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL;
ALTER TABLE PROJECT_DETAILS ADD EXPECTED_PAYBACK_PERIOD NUMBER(10) DEFAULT 0 NOT NULL;
ALTER TABLE PROJECT_DETAILS ADD EXPECTED_PAYBACK_MONTH NUMBER(10) DEFAULT 0 NOT NULL;
ALTER TABLE PROJECT_DETAILS ADD PURSUIT_START DATE;
ALTER TABLE PROJECT_DETAILS ADD PURSUIT_FINISH DATE;
ALTER TABLE PROJECT_DETAILS ADD FORECAST_CLOSED DATE;

ALTER TABLE PROJECT_DETAILS ADD ATTACHMENT_VIEW_BITS NUMBER(10) DEFAULT 0;

ALTER TABLE PROJECT_DETAILS ADD SCENARIO_USER_ID VARCHAR2(32);
ALTER TABLE PROJECT_DETAILS ADD RUP_HOME_PATH   VARCHAR2(512);



UPDATE PROJECT_DETAILS p 
SET (OPPORTUNITY_NAME, EXPECTED_COST, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH, PURSUIT_START, PURSUIT_FINISH, FORECAST_CLOSED) =
(SELECT OPPORTUNITY_NAME, EXPECTED_COST, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH, PURSUIT_START, PURSUIT_FINISH, FORECAST_CLOSED from tmt_wbs w where w.element_id = p.project_id)
WHERE EXISTS(SELECT W1.PROJECT_ID FROM TMT_WBS W1 WHERE W1.ELEMENT_ID = P.PROJECT_ID);

UPDATE PROJECT_DETAILS SET DLV_BUDGET_SETTING_BITS = BUDGET_SETTING_BITS;



-- TMT_WBS

DROP INDEX TWBSX_EID_XU; 
DROP INDEX TWBSX_FC_XX;
DROP INDEX TWBSX_NID_XX; 
DROP INDEX TWBSX_PJID_XX;
DROP INDEX TWBSX_RK_CU;
DROP INDEX TWBSX_TPID_XX;
DROP INDEX TWBSX_LV_XXXX;
DROP INDEX WBS_POOLID;

DROP TABLE TMT_WBS2;

CREATE TABLE TMT_WBS2 (
	RANK VARCHAR2(192) NOT NULL,
	WBS_CODE VARCHAR2(255),
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	REF_CODE VARCHAR2(50),
	PRIORITY NUMBER(5) DEFAULT 500,
	PUBLISHED VARCHAR2(1) DEFAULT '0' NOT NULL,
	PUBLISHED_BY VARCHAR2(32),
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	CONSTRAINT_DT TIMESTAMP,
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	CALENDAR_ID VARCHAR2(32),
	MINUTE_PER_DAY NUMBER(5) DEFAULT 480,
	MINUTE_PER_WEEK NUMBER(5) DEFAULT 2400,
	METHOD NUMBER(10) DEFAULT 0,
	BUFFER_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	START_FINISH_FLAG VARCHAR2(1) DEFAULT '0',
	START_FINISH_DATE DATE,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE3_START TIMESTAMP,
	BASELINE3_FINISH TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0,
	DURATION NUMBER(10) DEFAULT 0,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0,
	SCHED_DURATION NUMBER(10) DEFAULT 0,
	FORECAST_DURATION NUMBER(10) DEFAULT 0,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0,
	BASELINE3_DURATION NUMBER(10) DEFAULT 0,
	VARIANCE NUMBER(10) DEFAULT 0,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	ACTUAL_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE3_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	CREATED_DT TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	PROBABILITY NUMBER(10) DEFAULT 100,
	STAGE_ID NUMBER(10) DEFAULT 740,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(2048) DEFAULT 'CREATED',
	CLOSED_BY VARCHAR2(32),
	TOOLTIP_DESCR VARCHAR2(255) DEFAULT NULL,
	TOTAL_SLACK NUMBER(10),
	FREE_SLACK NUMBER(10),
	CRITICAL VARCHAR2(1),
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPENDENCIES CLOB DEFAULT EMPTY_CLOB(),
	ROLLUP_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	EV_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	CRI_COUNT NUMBER(10) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	MSP_ID NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ASSIGN_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	RTF_BITS NUMBER(10) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TRANSFER_FLAG VARCHAR2(1),
	EFFORT_DRIVEN NUMBER(5) DEFAULT 1 NOT NULL,
	BUBBLE_COLOR NUMBER(5) DEFAULT 0 NOT NULL,
	BUBBLE_PUBLISHED_DT TIMESTAMP,
	A_CRI_COUNT NUMBER(5) DEFAULT 0,
	TASK_TYPE NUMBER(5) DEFAULT 10 NOT NULL,
	FS_CODE VARCHAR2(50),
	FS_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	FS_LABOR_CODE VARCHAR2(50),
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EARLY_START TIMESTAMP,
	LATE_START TIMESTAMP,
	EARLY_FINISH TIMESTAMP,
	LATE_FINISH TIMESTAMP,
	LEVEL_INDEX NUMBER(10) DEFAULT 0,
	CALC_PRIORITY NUMBER(5) DEFAULT 500,
	LEVEL_CONFLICT VARCHAR2(4000),
	LEVEL_START TIMESTAMP,
	LEVEL_FINISH TIMESTAMP,
	LEVEL_DURATION NUMBER(10) DEFAULT 0,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	FINISH_START_DATE DATE,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	PREVIOUS_WKF_STEP VARCHAR2(150),
	DEPEND_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	START_FINISH_DURATION NUMBER(10) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE1_START DATE,
	ESTIMATED_BASELINE1_FINISH DATE,
	ESTIMATED_BASELINE2_START DATE,
	ESTIMATED_BASELINE2_FINISH DATE,
	ESTIMATED_BASELINE3_START DATE,
	ESTIMATED_BASELINE3_FINISH DATE,
	ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_EST_DT TIMESTAMP,
	BASELINE2_EST_DT TIMESTAMP,
	BASELINE3_EST_DT TIMESTAMP,
	BASELINE1_SCH_DT TIMESTAMP,
	BASELINE2_SCH_DT TIMESTAMP,
	BASELINE3_SCH_DT TIMESTAMP,
	CUSTOM_INT_1 NUMBER(10) DEFAULT 0,
	SUBPROJECT_COUNT NUMBER(10) DEFAULT 0,
	ESTIMATED_BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE3_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	RISK_EXPOSURE NUMBER(10) DEFAULT 0 NOT NULL,
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_STATE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_DT VARCHAR2(26),
	WORK_PERCENT NUMBER(5) DEFAULT 0,
	MP_STATUS_DT TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	POOL_ID VARCHAR2(32),
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	BASELINE3_START_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE3_FINISH_VARIANCE NUMBER(10) DEFAULT 0,
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	BASELINE_FLAG NUMBER(5) DEFAULT 0,
	CHARGED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CHARGED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CHARGED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_LEDGER_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_LEDGER_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TIME_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	EXTERNAL_ID VARCHAR2(50)
);


DROP INDEX TWBSX_EID_XU;
CREATE UNIQUE INDEX TWBSX_EID_XU ON TMT_WBS2 (ELEMENT_ID ASC) ;
DROP INDEX TWBSX_FC_XX;
CREATE  INDEX TWBSX_FC_XX ON TMT_WBS2 (FS_CODE ASC) ;
DROP INDEX TWBSX_NID_XX;
CREATE  INDEX TWBSX_NID_XX ON TMT_WBS2 (PARENT_ID ASC) ;
DROP INDEX TWBSX_PJID_XX;
CREATE  INDEX TWBSX_PJID_XX ON TMT_WBS2 (PROJECT_ID ASC,ELEMENT_ID ASC) ;
DROP INDEX TWBSX_RK_CU;
CREATE UNIQUE INDEX TWBSX_RK_CU ON TMT_WBS2 (RANK ASC)  PCTFREE = 30;
DROP INDEX TWBSX_TPID_XX;
CREATE  INDEX TWBSX_TPID_XX ON TMT_WBS2 (T_PARENT_ID ASC) ;
DROP INDEX TWBSX_LV_XXXX;
CREATE  INDEX TWBSX_LV_XXXX ON TMT_WBS2 (PROJECT_ID,LEVEL_STATE ASC) ;
DROP INDEX WBS_POOLID;
CREATE  INDEX WBS_POOLID ON TMT_WBS2 (POOL_ID ASC,PROJECT_ID ASC,ELEMENT_ID ASC) ;
DROP INDEX TWBSX_STG_XX;
CREATE  INDEX TWBSX_STG_XX ON TMT_WBS2 (PROJECT_ID ASC,STAGE_ID ASC) ;


INSERT INTO TMT_WBS2 (ELEMENT_FLAG,
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
EV_ETC,
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE,
EXTERNAL_ID)
(SELECT ELEMENT_FLAG,
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
EV_ETC,
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE, EXTERNAL_ID FROM TMT_WBS);

DROP TABLE TMT_WBS1;
ALTER TABLE TMT_WBS RENAME TO TMT_WBS1;
ALTER TABLE TMT_WBS2 RENAME TO TMT_WBS;

-- IF SUCCESSFULL DROP TABLE TMT_WBS1;

UPDATE TMT_WBS SET BCWS_FORECAST = BCWS, BCWP_FORECAST = BCWP, ACWP_FORECAST = ACWP;

UPDATE TMT_WBS w SET w.BASELINE_FLAG = 3
WHERE w.PROJECT_ID IN (
	SELECT wp.ELEMENT_ID
	FROM TMT_WBS wp
	WHERE wp.PROJECT_ID = w.PROJECT_ID
		AND wp.BASELINE2_SCH_DT IS NOT NULL
		AND wp.BASELINE2_SCH_DT = w.BASELINE2_SCH_DT
		AND wp.TYPE_ID IN (1,154))
AND w.BASELINE2_SCH_DT IS NOT NULL
AND w.TYPE_ID NOT IN (1,154)
AND w.BASELINE_FLAG = 0;

UPDATE TMT_WBS w SET w.BASELINE_FLAG = 2
WHERE w.PROJECT_ID IN (
	SELECT wp.ELEMENT_ID
	FROM TMT_WBS wp
	WHERE wp.PROJECT_ID = w.PROJECT_ID
		AND wp.BASELINE1_SCH_DT IS NOT NULL
		AND wp.BASELINE1_SCH_DT = w.BASELINE3_SCH_DT
		AND wp.TYPE_ID IN (1,154))
AND w.BASELINE3_SCH_DT IS NOT NULL
AND w.TYPE_ID NOT IN (1,154)
AND w.BASELINE_FLAG = 0;

UPDATE TMT_WBS w SET w.BASELINE_FLAG = 4
WHERE w.PROJECT_ID IN (
	SELECT wp.ELEMENT_ID
	FROM TMT_WBS wp
	WHERE wp.PROJECT_ID = w.PROJECT_ID
		AND wp.BASELINE1_SCH_DT IS NOT NULL
		AND wp.BASELINE1_SCH_DT <>w.BASELINE1_SCH_DT
		AND wp.TYPE_ID IN (1,154))
AND w.BASELINE1_SCH_DT IS NOT NULL
AND w.TYPE_ID NOT IN (1,154)
AND w.BASELINE_FLAG = 0;


update tmt_wbs w set start_finish_date = (select p.start_finish_date from tmt_wbs p where p.element_id = w.project_id)
where start_finish_date is null;


-- HISTORY_WBS


DROP INDEX HSWBS_EID_RDT_CX;
DROP INDEX HSWBS_HID_XX; 
DROP INDEX HSWBS_RK_XX; 

DROP TABLE HISTORY_WBS2;

CREATE TABLE HISTORY_WBS2 (
	HISTORY_ID VARCHAR2(32),
	RANK VARCHAR2(192) NOT NULL,
	WBS_CODE VARCHAR2(255),
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	REF_CODE VARCHAR2(50),
	PRIORITY NUMBER(5) DEFAULT 500,
	PUBLISHED VARCHAR2(1) DEFAULT '0' NOT NULL,
	PUBLISHED_BY VARCHAR2(32),
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	CONSTRAINT_DT TIMESTAMP,
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	CALENDAR_ID VARCHAR2(32),
	MINUTE_PER_DAY NUMBER(5) DEFAULT 480,
	MINUTE_PER_WEEK NUMBER(5) DEFAULT 2400,
	METHOD NUMBER(10) DEFAULT 0,
	BUFFER_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	START_FINISH_FLAG VARCHAR2(1) DEFAULT '0',
	START_FINISH_DATE DATE,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE3_START TIMESTAMP,
	BASELINE3_FINISH TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0,
	DURATION NUMBER(10) DEFAULT 0,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0,
	SCHED_DURATION NUMBER(10) DEFAULT 0,
	FORECAST_DURATION NUMBER(10) DEFAULT 0,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0,
	BASELINE3_DURATION NUMBER(10) DEFAULT 0,
	VARIANCE NUMBER(10) DEFAULT 0,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	ACTUAL_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE3_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	CREATED_DT TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	PROBABILITY NUMBER(10) DEFAULT 100,
	STAGE_ID NUMBER(10) DEFAULT 740,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(2048) DEFAULT 'CREATED',
	CLOSED_BY VARCHAR2(32),
	TOOLTIP_DESCR VARCHAR2(255) DEFAULT NULL,
	TOTAL_SLACK NUMBER(10),
	FREE_SLACK NUMBER(10),
	CRITICAL VARCHAR2(1),
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPENDENCIES CLOB DEFAULT EMPTY_CLOB(),
	ROLLUP_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	EV_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	CRI_COUNT NUMBER(10) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	MSP_ID NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ASSIGN_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	RTF_BITS NUMBER(10) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TRANSFER_FLAG VARCHAR2(1),
	EFFORT_DRIVEN NUMBER(5) DEFAULT 1 NOT NULL,
	BUBBLE_COLOR NUMBER(5) DEFAULT 0 NOT NULL,
	BUBBLE_PUBLISHED_DT TIMESTAMP,
	A_CRI_COUNT NUMBER(5) DEFAULT 0,
	TASK_TYPE NUMBER(5) DEFAULT 10 NOT NULL,
	FS_CODE VARCHAR2(50),
	FS_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	FS_LABOR_CODE VARCHAR2(50),
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EARLY_START TIMESTAMP,
	LATE_START TIMESTAMP,
	EARLY_FINISH TIMESTAMP,
	LATE_FINISH TIMESTAMP,
	LEVEL_INDEX NUMBER(10) DEFAULT 0,
	CALC_PRIORITY NUMBER(5) DEFAULT 500,
	LEVEL_CONFLICT VARCHAR2(4000),
	LEVEL_START TIMESTAMP,
	LEVEL_FINISH TIMESTAMP,
	LEVEL_DURATION NUMBER(10) DEFAULT 0,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	FINISH_START_DATE DATE,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	PREVIOUS_WKF_STEP VARCHAR2(150),
	DEPEND_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	START_FINISH_DURATION NUMBER(10) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE1_START DATE,
	ESTIMATED_BASELINE1_FINISH DATE,
	ESTIMATED_BASELINE2_START DATE,
	ESTIMATED_BASELINE2_FINISH DATE,
	ESTIMATED_BASELINE3_START DATE,
	ESTIMATED_BASELINE3_FINISH DATE,
	ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_EST_DT TIMESTAMP,
	BASELINE2_EST_DT TIMESTAMP,
	BASELINE3_EST_DT TIMESTAMP,
	BASELINE1_SCH_DT TIMESTAMP,
	BASELINE2_SCH_DT TIMESTAMP,
	BASELINE3_SCH_DT TIMESTAMP,
	CUSTOM_INT_1 NUMBER(10) DEFAULT 0,
	SUBPROJECT_COUNT NUMBER(10) DEFAULT 0,
	ESTIMATED_BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE3_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	RISK_EXPOSURE NUMBER(10) DEFAULT 0 NOT NULL,
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_STATE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_DT VARCHAR2(26),
	WORK_PERCENT NUMBER(5) DEFAULT 0,
	MP_STATUS_DT TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	POOL_ID VARCHAR2(32),
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	BASELINE3_START_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE3_FINISH_VARIANCE NUMBER(10) DEFAULT 0,
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	BASELINE_FLAG NUMBER(5) DEFAULT 0,
	CHARGED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CHARGED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CHARGED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_LEDGER_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_LEDGER_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TIME_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	EXTERNAL_ID VARCHAR2(50)
);


DROP INDEX HSWBS_EID_RDT_CX;
CREATE  INDEX HSWBS_EID_RDT_CX ON HISTORY_WBS2 (ELEMENT_ID ASC,REC_DATETIME ASC)  PCTFREE = 30;
DROP INDEX HSWBS_HID_XX;
CREATE  INDEX HSWBS_HID_XX ON HISTORY_WBS2 (HISTORY_ID ASC) ;
DROP INDEX HSWBS_RK_XX;
CREATE  INDEX HSWBS_RK_XX ON HISTORY_WBS2 (RANK ASC)  PCTFREE = 30;


INSERT INTO HISTORY_WBS2 (ELEMENT_FLAG,
EV_ETC,
HISTORY_ID, 
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE,
EXTERNAL_ID)
(SELECT ELEMENT_FLAG,
EV_ETC,
HISTORY_ID, 
RANK, 
WBS_CODE,
PROJECT_ID, 
PARENT_ID,
ELEMENT_ID, 
TYPE_ID, 
LEVEL_ID,
MAX_RANK,
CHILD_COUNT,
DELETED_COUNT, 
ELEMENT_NAME,
REF_CODE,
PRIORITY,
PUBLISHED,
PUBLISHED_BY,
T_PARENT_ID,
T_RANK,
CONSTRAINT_TYPE,
CONSTRAINT_DT, 
CURRENCY_ID,
CALENDAR_ID,
MINUTE_PER_DAY,
MINUTE_PER_WEEK,
METHOD,
BUFFER_PERCENT,
START_FINISH_FLAG,
START_FINISH_DATE,
SD,
FD,
START_DT,
FINISH_DT,
BASELINE1_START,
BASELINE1_FINISH, 
BASELINE2_START,
BASELINE2_FINISH, 
BASELINE3_START,
BASELINE3_FINISH, 
PLANNED_START, 
PLANNED_FINISH,
PROPOSED_START,
PROPOSED_FINISH,
SCHED_START,
SCHED_FINISH,
FORECAST_START,
FORECAST_FINISH,
ACTUAL_START,
ACTUAL_FINISH, 
UNRESOLVED_DURATION, 
DURATION,
PLANNED_DURATION, 
PROPOSED_DURATION,
SCHED_DURATION,
FORECAST_DURATION,
ACTUAL_DURATION,
BASELINE1_DURATION,
BASELINE2_DURATION,
BASELINE3_DURATION,
VARIANCE,
FORECAST_VARIANCE,
ACTUAL_VARIANCE,
BASELINE1_VARIANCE,
PLANNED_EFFORT,
PROPOSED_EFFORT,
SCHED_EFFORT,
FORECAST_EFFORT,
ACTUAL_EFFORT, 
BASELINE1_EFFORT, 
BASELINE2_EFFORT, 
BASELINE3_EFFORT, 
WORK_TODATE,
ETC,
CREATED_BY, 
CREATED_DT, 
PROBABILITY,
STAGE_ID,
MILESTONE_PERCENT,
REC_USER,
REC_STATUS, 
REC_DATETIME,
LAST_WF_TYPE,
LAST_WF_BY, 
LAST_WF_DT, 
MAJOR_REVISION,
MINOR_REVISION,
REVISION_IMPACT,
REVISION_TYPE, 
REVISION_HISTORY, 
CLOSED_BY,
TOOLTIP_DESCR, 
TOTAL_SLACK,
FREE_SLACK, 
CRITICAL,
ESTIMATION_TOTAL, 
ESTIMATION_BUDGET,
CURRENT_BUDGET,
FORECAST_BUDGET,
ACTUAL_BUDGET, 
BASELINE1_BUDGET, 
BASELINE2_BUDGET, 
BASELINE3_BUDGET, 
R_ESTIMATION_TOTAL,
R_ESTIMATION_BUDGET, 
R_CURRENT_BUDGET, 
R_FORECAST_BUDGET,
R_ACTUAL_BUDGET,
R_BASELINE1_BUDGET,
R_BASELINE2_BUDGET,
R_BASELINE3_BUDGET,
S_ESTIMATION_TOTAL,
S_ESTIMATION_BUDGET, 
S_CURRENT_BUDGET, 
S_FORECAST_BUDGET,
S_ACTUAL_BUDGET,
S_BASELINE1_BUDGET,
S_BASELINE2_BUDGET,
S_BASELINE3_BUDGET,
DEPENDENCIES,
ROLLUP_FLAG,
EV_FLAG, 
CRI_COUNT,
DOC_COUNT,
MSP_ID,
BASELINE_WORK_TODATE,
ASSIGN_COUNT,
ASSIGN_NAMES,
RTF_BITS,
LAST_CHECKIN,
BAC,
EAC,
BCWS, 
BCWP, 
ACWP, 
TRANSFER_FLAG, 
EFFORT_DRIVEN, 
BUBBLE_COLOR,
BUBBLE_PUBLISHED_DT, 
A_CRI_COUNT,
TASK_TYPE,
FS_CODE, 
FS_STATE,
FS_LABOR_CODE, 
REC_FLAGS,
ROLLUP_BITS,
UNRESOLVED_START, 
UNRESOLVED_FINISH,
PLANNED_BUDGET,
R_PLANNED_BUDGET, 
S_PLANNED_BUDGET, 
PROPOSED_BUDGET,
R_PROPOSED_BUDGET,
S_PROPOSED_BUDGET,
EARLY_START,
LATE_START, 
EARLY_FINISH,
LATE_FINISH,
LEVEL_INDEX,
CALC_PRIORITY, 
LEVEL_CONFLICT,
LEVEL_START,
LEVEL_FINISH,
LEVEL_DURATION,
SCORECARD_COUNT,
FINISH_START_DATE,
TOTAL_DURATION,
PREVIOUS_WKF_STEP,
DEPEND_FLAG,
START_FINISH_DURATION,
CONVERTED_SCORE,
CONVERTED_WEIGHT, 
TIMEPHASED_BITS,
ESTIMATED_BASELINE1_START, 
ESTIMATED_BASELINE1_FINISH,
ESTIMATED_BASELINE2_START, 
ESTIMATED_BASELINE2_FINISH,
ESTIMATED_BASELINE3_START, 
ESTIMATED_BASELINE3_FINISH,
ESTIMATED_BASELINE1_BUDGET,
ESTIMATED_BASELINE2_BUDGET,
ESTIMATED_BASELINE3_BUDGET,
R_ESTIMATED_BASELINE1_BUDGET, 
R_ESTIMATED_BASELINE2_BUDGET, 
R_ESTIMATED_BASELINE3_BUDGET, 
S_ESTIMATED_BASELINE1_BUDGET, 
S_ESTIMATED_BASELINE2_BUDGET, 
S_ESTIMATED_BASELINE3_BUDGET, 
ESTIMATED_ACTUAL, 
ESTIMATED_ETC, 
R_ESTIMATED_ACTUAL,
R_ESTIMATED_ETC,
S_ESTIMATED_ACTUAL,
S_ESTIMATED_ETC,
ESTIMATED_HOURS,
ESTIMATED_ACTUAL_HOURS, 
ESTIMATED_HOURS_ETC, 
R_ESTIMATED_HOURS,
R_ESTIMATED_ACTUAL_HOURS,
R_ESTIMATED_HOURS_ETC,
ESTIMATED_HOURS_BASELINE1, 
ESTIMATED_HOURS_BASELINE2, 
ESTIMATED_HOURS_BASELINE3, 
R_ESTIMATED_HOURS_BASELINE1,
R_ESTIMATED_HOURS_BASELINE2,
R_ESTIMATED_HOURS_BASELINE3,
BASELINE1_EST_DT, 
BASELINE2_EST_DT, 
BASELINE3_EST_DT, 
BASELINE1_SCH_DT, 
BASELINE2_SCH_DT, 
BASELINE3_SCH_DT, 
CUSTOM_INT_1,
SUBPROJECT_COUNT, 
ESTIMATED_BASELINE1_DURATION, 
ESTIMATED_BASELINE2_DURATION, 
ESTIMATED_BASELINE3_DURATION, 
TIMECODE_1_ID, 
TIMECODE_2_ID, 
RISK_EXPOSURE, 
CONSEQUENSE_COST, 
EAC_FORECAST,
EV_ETC_FORECAST,
LEVEL_STATE,
LEVEL_CONSTRAINT_TYPE,
LEVEL_CONSTRAINT_DT, 
WORK_PERCENT,
MP_STATUS_DT,
REFERENCE_NUMBER, 
ASSET_ID,
ASSET_NAME, 
FINANCIAL_CATEGORY,
POOL_ID, 
ASSET_FLAG, 
BASELINE3_START_VARIANCE,
BASELINE3_FINISH_VARIANCE, EXTERNAL_ID FROM HISTORY_WBS);

DROP TABLE HISTORY_WBS1;
ALTER TABLE HISTORY_WBS RENAME TO HISTORY_WBS1;
ALTER TABLE HISTORY_WBS2 RENAME TO HISTORY_WBS;


-- IF SUCCESSFUL DROP TABLE HISTORY_WBS1;


-- TMT_CLIENTS



DROP INDEX TCLIENT_ENID_XU;
DROP INDEX TCLIENT_RK_CU;                
DROP INDEX TCLI_NID_XX;

DROP TABLE TEMP_TMT_CLIENTS;

CREATE TABLE TEMP_TMT_CLIENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(2048) DEFAULT 'CREATED',
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	RTF_BITS NUMBER(5) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	CURRENCY_ID NUMBER(10) DEFAULT 0 NOT NULL,
	STAGE_ID NUMBER(10),
	EXTERNAL_IDENTIFIER VARCHAR2(32)
);

 
INSERT INTO TEMP_TMT_CLIENTS
( LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  LABEL,
  DESCRIPTION,
  DEFAULT_FLAG,
  RANK,
  DOMAIN_ID,
  MANAGER_ID,
  COMPANY_NAME,
  ADDRESS,
  PHONE,
  FAX,
  WEBSITE,
  CONTACT_NAME,
  OTHER_LOCATION,
  YEAR_IN_BUSINESS,
  CLIENT_MORE_100_EMPLOYEES,
  CLIENT_MORE_1000_EMPLOYEES,
  CLIENT_MORE_10000_EMPLOYEES,
  NUMBER_EMPLOYEES,
  ANNUAL_REVENUES,
  BILLING_ADDRESS,
  BILLING_PHONE,
  BILLING_FAX,
  BILLING_EMAIL,
  EQUAL_OPPORTUNITY,
  MAJOR_REVISION,
  MINOR_REVISION,
  REVISION_IMPACT,
  REVISION_TYPE,
  REVISION_HISTORY,
  PUBLIC_FLAG,
  COMPANY_BACKGROUND,
  OWNERSHIP,
  SERVICES_OFFERED,
  SERVICES_SPECIALIZED,
  INDUSTRIES_SERVED,
  HIGHLIGHT,
  LOCATION_SERVED,
  LOCAL,
  RTF_BITS,
  DOC_COUNT)
SELECT 
 LEVEL_ID,
  TYPE_ID,
  MAX_RANK,
  CHILD_COUNT,
  DELETED_COUNT,
  ELEMENT_ID,
  ELEMENT_NAME,
  PARENT_ID,
  REC_USER,
  REC_STATUS,
  REC_DATETIME,
  LABEL,
  DESCRIPTION,
  DEFAULT_FLAG,
  RANK,
  DOMAIN_ID,
  MANAGER_ID,
  COMPANY_NAME,
  ADDRESS,
  PHONE,
  FAX,
  WEBSITE,
  CONTACT_NAME,
  OTHER_LOCATION,
  YEAR_IN_BUSINESS,
  CLIENT_MORE_100_EMPLOYEES,
  CLIENT_MORE_1000_EMPLOYEES,
  CLIENT_MORE_10000_EMPLOYEES,
  NUMBER_EMPLOYEES,
  ANNUAL_REVENUES,
  BILLING_ADDRESS,
  BILLING_PHONE,
  BILLING_FAX,
  BILLING_EMAIL,
  EQUAL_OPPORTUNITY,
  MAJOR_REVISION,
  MINOR_REVISION,
  REVISION_IMPACT,
  REVISION_TYPE,
  REVISION_HISTORY,
  PUBLIC_FLAG,
  COMPANY_BACKGROUND,
  OWNERSHIP,
  SERVICES_OFFERED,
  SERVICES_SPECIALIZED,
  INDUSTRIES_SERVED,
  HIGHLIGHT,
  LOCATION_SERVED,
  LOCAL,
  RTF_BITS,
  DOC_COUNT
FROM TMT_CLIENTS;

DROP TABLE OLD_TMT_CLIENTS;
ALTER TABLE TMT_CLIENTS RENAME TO OLD_TMT_CLIENTS;
ALTER TABLE TEMP_TMT_CLIENTS RENAME TO TMT_CLIENTS;

DROP INDEX TCLIENT_ENID_XU;
CREATE UNIQUE INDEX TCLIENT_ENID_XU ON TMT_CLIENTS (ELEMENT_ID ASC,PARENT_ID ASC) ;
DROP INDEX TCLIENT_RK_CU;
CREATE UNIQUE INDEX TCLIENT_RK_CU ON TMT_CLIENTS (RANK ASC)  PCTFREE = 30;
DROP INDEX TCLI_NID_XX;
CREATE  INDEX TCLI_NID_XX ON TMT_CLIENTS (PARENT_ID)  PCTFREE = 30;

-- IF SUCCESSFUL DROP TABLE OLD_TMT_CLIENTS;

INSERT INTO TMT_CLIENTS(ELEMENT_ID, LEVEL_ID, TYPE_ID, MAX_RANK, CHILD_COUNT, RANK, LOCAL, ELEMENT_NAME, DEFAULT_FLAG, REC_USER) VALUES('PMOFFICE_DEFAULT_COST_CENTER____', 0, 229, 0, 0, '0000000/', 'N', 'RPM', 'Y', 'PMO_SUPERVISOR');

UPDATE TMT_CLIENTS SET DEFAULT_FLAG = 'N';
UPDATE TMT_CLIENTS SET DEFAULT_FLAG = 'Y' WHERE TYPE_ID = 229 AND RANK = (SELECT MIN(RANK) FROM TMT_CLIENTS WHERE TYPE_ID = 229);
UPDATE TMT_CLIENTS SET STAGE_ID = 6901 WHERE STAGE_ID IS NULL AND TYPE_ID IN (229, 326);
               

DELETE FROM TMT_CLIENTS WHERE RANK LIKE '0000!!!1%';
INSERT INTO TMT_CLIENTS(ELEMENT_ID, LEVEL_ID, TYPE_ID, MAX_RANK, CHILD_COUNT, RANK, LOCAL, ELEMENT_NAME, REC_USER, STAGE_ID, EXTERNAL_IDENTIFIER) VALUES('CUSTOM_CLIENT___________________', 0, 64, 0, 0, '0000!!!1', 'N', 'Custom Clients', 'PMO_SUPERVISOR', 6900, 'Custom Clients');


-- HISTORY_CLIENTS


DROP INDEX HSCLX_EID_RDT_CX;
DROP INDEX HSCLX_HID_XX;
DROP INDEX HSCLX_RK_XX; 


DROP TABLE TEMP_HISTORY_CLIENTS;

CREATE TABLE TEMP_HISTORY_CLIENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(2048),
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	RTF_BITS NUMBER(5) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	CURRENCY_ID NUMBER(10) DEFAULT 0 NOT NULL,
	STAGE_ID NUMBER(10),
	EXTERNAL_IDENTIFIER VARCHAR2(32)
);



INSERT INTO TEMP_HISTORY_CLIENTS
(
	HISTORY_ID,
	LEVEL_ID,
	TYPE_ID,
	MAX_RANK,
	CHILD_COUNT,
	DELETED_COUNT,
	ELEMENT_ID,
	ELEMENT_NAME,
	PARENT_ID,
	REC_USER,
	REC_STATUS,
	REC_DATETIME,
	LABEL,
	DESCRIPTION,
	DEFAULT_FLAG,
	RANK,
	DOMAIN_ID,
	MANAGER_ID,
	COMPANY_NAME,
	ADDRESS,
	PHONE,
	FAX,
	WEBSITE,
	CONTACT_NAME,
	OTHER_LOCATION,
	YEAR_IN_BUSINESS,
	CLIENT_MORE_100_EMPLOYEES,
	CLIENT_MORE_1000_EMPLOYEES,
	CLIENT_MORE_10000_EMPLOYEES,
	NUMBER_EMPLOYEES,
	ANNUAL_REVENUES,
	BILLING_ADDRESS,
	BILLING_PHONE,
	BILLING_FAX,
	BILLING_EMAIL,
	EQUAL_OPPORTUNITY,
	MAJOR_REVISION,
	MINOR_REVISION,
	REVISION_IMPACT,
	REVISION_TYPE,
	REVISION_HISTORY,
	PUBLIC_FLAG,
	COMPANY_BACKGROUND,
	OWNERSHIP,
	SERVICES_OFFERED,
	SERVICES_SPECIALIZED,
	INDUSTRIES_SERVED,
	HIGHLIGHT,
	LOCATION_SERVED,
	LOCAL,
	RTF_BITS,
	DOC_COUNT
)
SELECT 
	HISTORY_ID,
	LEVEL_ID,
	TYPE_ID,
	MAX_RANK,
	CHILD_COUNT,
	DELETED_COUNT,
	ELEMENT_ID,
	ELEMENT_NAME,
	PARENT_ID,
	REC_USER,
	REC_STATUS,
	REC_DATETIME,
	LABEL,
	DESCRIPTION,
	DEFAULT_FLAG,
	RANK,
	DOMAIN_ID,
	MANAGER_ID,
	COMPANY_NAME,
	ADDRESS,
	PHONE,
	FAX,
	WEBSITE,
	CONTACT_NAME,
	OTHER_LOCATION,
	YEAR_IN_BUSINESS,
	CLIENT_MORE_100_EMPLOYEES,
	CLIENT_MORE_1000_EMPLOYEES,
	CLIENT_MORE_10000_EMPLOYEES,
	NUMBER_EMPLOYEES,
	ANNUAL_REVENUES,
	BILLING_ADDRESS,
	BILLING_PHONE,
	BILLING_FAX,
	BILLING_EMAIL,
	EQUAL_OPPORTUNITY,
	MAJOR_REVISION,
	MINOR_REVISION,
	REVISION_IMPACT,
	REVISION_TYPE,
	REVISION_HISTORY,
	PUBLIC_FLAG,
	COMPANY_BACKGROUND,
	OWNERSHIP,
	SERVICES_OFFERED,
	SERVICES_SPECIALIZED,
	INDUSTRIES_SERVED,
	HIGHLIGHT,
	LOCATION_SERVED,
	LOCAL,
	RTF_BITS,
	DOC_COUNT
FROM 
HISTORY_CLIENTS;

DROP TABLE OLD_HISTORY_CLIENTS;
ALTER TABLE HISTORY_CLIENTS RENAME TO OLD_HISTORY_CLIENTS;
ALTER TABLE TEMP_HISTORY_CLIENTS RENAME TO HISTORY_CLIENTS;

DROP INDEX HSCLX_EID_RDT_CX;
CREATE  INDEX HSCLX_EID_RDT_CX ON HISTORY_CLIENTS (ELEMENT_ID ASC,REC_DATETIME ASC)  PCTFREE = 30;
DROP INDEX HSCLX_HID_XX;
CREATE  INDEX HSCLX_HID_XX ON HISTORY_CLIENTS (HISTORY_ID ASC) ;
DROP INDEX HSCLX_RK_XX;
CREATE  INDEX HSCLX_RK_XX ON HISTORY_CLIENTS (RANK ASC)  PCTFREE = 30;


-- IF SUCCESSFUL DROP TABLE OLD_HISTORY_CLIENTS;


-- TMT_POOLS

ALTER TABLE TMT_POOLS ADD COST_CENTER_ID VARCHAR2(32);
ALTER TABLE TMT_POOLS ADD EXTERNAL_REFERENCE VARCHAR2(32);

UPDATE TMT_POOLS SET COST_CENTER_ID = (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE DEFAULT_FLAG = 'Y');

DROP INDEX TPOOL_EXTREF_XX;
CREATE  INDEX TPOOL_EXTREF_XX ON TMT_POOLS (EXTERNAL_REFERENCE ASC) ;
DROP INDEX POOL_USRGROUP_XXX;
CREATE  INDEX POOL_USRGROUP_XXX ON TMT_POOLS (USER_GROUP_ID)  PCTFREE = 30;

-- HISTORY_POOLS


ALTER TABLE HISTORY_POOLS ADD COST_CENTER_ID VARCHAR2(32);

ALTER TABLE HISTORY_POOLS ADD EXTERNAL_REFERENCE VARCHAR2(32);



-- RESOURCE_COST_CENTERS

DROP TABLE RESOURCE_COST_CENTERS;

CREATE TABLE RESOURCE_COST_CENTERS (
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	COST_CENTER_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	START_DATE DATE,
	FINISH_DATE DATE,
	REC_USER VARCHAR2(32) DEFAULT 'PMO_SUPERVISOR' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);


DROP INDEX RCC_RID_CCID_DT;
CREATE UNIQUE INDEX RCC_RID_CCID_DT ON RESOURCE_COST_CENTERS (RESOURCE_ID ASC,COST_CENTER_ID ASC,START_DATE ASC)  PCTFREE = 30;


INSERT INTO RESOURCE_COST_CENTERS SELECT SYS_GUID(), R.RESOURCE_ID, P.COST_CENTER_ID,  DATE '1899-12-31',  DATE '2300-12-30', 'PMO_SUPERVISOR', 'U', SYSTIMESTAMP
FROM RESOURCES R, TMT_POOLS P
WHERE R.RESOURCE_ID = P.ELEMENT_ID;

-- SUMMARY_TIMESHEETS


DROP INDEX SMRTS_RPJID_CX;
DROP INDEX SMRTS_TAID_WF_XU;
DROP INDEX SMRTS_WF_RDT_XX; 

DROP TABLE NEW_SUMMARY_TIMESHEETS;

CREATE TABLE NEW_SUMMARY_TIMESHEETS (
	PROJECT_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32),
	TSK_ASSIGNMENT_ID VARCHAR2(32) NOT NULL,
	WEEK_OF DATE,
	MONDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	MONDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	TUESDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	TUESDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEDNESDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	WEDNESDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	THURSDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	THURSDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	FRIDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	FRIDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	SATURDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	SATURDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	SUNDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	SUNDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_REGULAR_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_SPECIAL_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_BILLABLE_REGULAR_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_BILLABLE_SPECIAL_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	TOTAL_SCHED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE_EFFORT_WEEK NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	MILESTONE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SYSTEM_EXCHANGE_RATE NUMBER(18,3) DEFAULT 1.000 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	ACTIVITY_ID VARCHAR2(32),
	NOTES VARCHAR2(255),
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PDA_FLAG VARCHAR2(1) DEFAULT 'P',
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH1_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH1_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH1_B_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH1_B_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_B_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_B_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	DEPARTMENT_ID VARCHAR2(32),
	COST_CENTER_BITS NUMBER(10) DEFAULT 0 NOT NULL
);


-- Transfer data

INSERT INTO NEW_SUMMARY_TIMESHEETS (
	ACTIVITY_ID,                   
	ACTUAL_REGULAR_COST,           
	ACTUAL_REGULAR_RATE,           
	ACTUAL_SPECIAL_COST,           
	ACTUAL_SPECIAL_RATE,           
	BASELINE_EFFORT_WEEK,          
	BASELINE_REGULAR_COST,         
	BASELINE_REGULAR_RATE,         
	BASELINE_SPECIAL_COST,         
	BASELINE_SPECIAL_RATE,         
	BASELINE_WORK_TODATE,          
	BILLABLE_WORK_TODATE,          
	DEPARTMENT_ID,                 
	ETC,                           
	FRIDAY_REGULAR,                
	FRIDAY_SPECIAL,                
	MILESTONE_PERCENT,             
	MONDAY_REGULAR,                
	MONDAY_SPECIAL,                
	MONTH1_B_REGULAR_HRS,          
	MONTH1_B_SPECIAL_HRS,          
	MONTH1_REGULAR_HRS,            
	MONTH1_SPECIAL_HRS,            
	MONTH2_B_REGULAR_HRS,          
	MONTH2_B_SPECIAL_HRS,          
	MONTH2_REGULAR_HRS,            
	MONTH2_SPECIAL_HRS,            
	NOTES,                         
	PDA_FLAG,                      
	PROJECT_ID,                    
	REC_DATETIME,                  
	REC_STATUS,                    
	REC_USER,                      
	RESOURCE_ID,                   
	SATURDAY_REGULAR,              
	SATURDAY_SPECIAL,              
	SUNDAY_REGULAR,                
	SUNDAY_SPECIAL,                
	SYSTEM_EXCHANGE_RATE,          
	THURSDAY_REGULAR,              
	THURSDAY_SPECIAL,              
	TIMECODE_1_ID,                 
	TIMECODE_2_ID,                 
	TOTAL_SCHED_EFFORT,            
	TSK_ASSIGNMENT_ID,             
	TUESDAY_REGULAR,               
	TUESDAY_SPECIAL,               
	WEDNESDAY_REGULAR,             
	WEDNESDAY_SPECIAL,             
	WEEKLY_BILLABLE_REGULAR_TOTAL, 
	WEEKLY_BILLABLE_SPECIAL_TOTAL, 
	WEEKLY_REGULAR_TOTAL,          
	WEEKLY_SPECIAL_TOTAL,          
	WEEK_OF,                       
	WORK_TODATE,                   
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC )   
SELECT 	ACTIVITY_ID,                   
	ACTUAL_REGULAR_COST,           
	ACTUAL_REGULAR_RATE,           
	ACTUAL_SPECIAL_COST,           
	ACTUAL_SPECIAL_RATE,           
	BASELINE_EFFORT_WEEK,          
	BASELINE_REGULAR_COST,         
	BASELINE_REGULAR_RATE,         
	BASELINE_SPECIAL_COST,         
	BASELINE_SPECIAL_RATE,         
	BASELINE_WORK_TODATE,          
	BILLABLE_WORK_TODATE,          
	DEPARTMENT_ID,                 
	ETC,                           
	FRIDAY_REGULAR,                
	FRIDAY_SPECIAL,                
	MILESTONE_PERCENT,             
	MONDAY_REGULAR,                
	MONDAY_SPECIAL,                
	MONTH1_B_REGULAR_HRS,          
	MONTH1_B_SPECIAL_HRS,          
	MONTH1_REGULAR_HRS,            
	MONTH1_SPECIAL_HRS,            
	MONTH2_B_REGULAR_HRS,          
	MONTH2_B_SPECIAL_HRS,          
	MONTH2_REGULAR_HRS,            
	MONTH2_SPECIAL_HRS,            
	NOTES,                         
	PDA_FLAG,                      
	PROJECT_ID,                    
	REC_DATETIME,                  
	REC_STATUS,                    
	REC_USER,                      
	RESOURCE_ID,                   
	SATURDAY_REGULAR,              
	SATURDAY_SPECIAL,              
	SUNDAY_REGULAR,                
	SUNDAY_SPECIAL,                
	SYSTEM_EXCHANGE_RATE,          
	THURSDAY_REGULAR,              
	THURSDAY_SPECIAL,              
	TIMECODE_1_ID,                 
	TIMECODE_2_ID,                 
	TOTAL_SCHED_EFFORT,            
	TSK_ASSIGNMENT_ID,             
	TUESDAY_REGULAR,               
	TUESDAY_SPECIAL,               
	WEDNESDAY_REGULAR,             
	WEDNESDAY_SPECIAL,             
	WEEKLY_BILLABLE_REGULAR_TOTAL, 
	WEEKLY_BILLABLE_SPECIAL_TOTAL, 
	WEEKLY_REGULAR_TOTAL,          
	WEEKLY_SPECIAL_TOTAL,          
	WEEK_OF,                       
	WORK_TODATE,                   
	BAC, 
	BCWS, 
	BCWP, 
	ACWP, 
	EV_ETC, 
	EAC
FROM SUMMARY_TIMESHEETS; 

-- Rename tables
DROP TABLE OLD_SUMMARY_TIMESHEETS;
ALTER TABLE SUMMARY_TIMESHEETS RENAME TO OLD_SUMMARY_TIMESHEETS;
ALTER TABLE NEW_SUMMARY_TIMESHEETS RENAME TO SUMMARY_TIMESHEETS;

-- DDL Statements for indexes on Table SUMMARY_TIMESHEETS
DROP INDEX SMRTS_RPJID_CX;
CREATE  INDEX SMRTS_RPJID_CX ON SUMMARY_TIMESHEETS (RESOURCE_ID ASC,PROJECT_ID ASC)  PCTFREE = 30;
DROP INDEX SMRTS_TAID_WF_XU;
CREATE UNIQUE INDEX SMRTS_TAID_WF_XU ON SUMMARY_TIMESHEETS (TSK_ASSIGNMENT_ID ASC,WEEK_OF ASC)  PCTFREE = 30;
DROP INDEX SMRTS_WF_RDT_XX;
CREATE  INDEX SMRTS_WF_RDT_XX ON SUMMARY_TIMESHEETS (WEEK_OF ASC,REC_DATETIME ASC)  PCTFREE = 30;
	
	
-- IF SUCCESSFUL DROP TABLE OLD_SUMMARY_TIMESHEETS;

-- PROJECT_COST_CENTERS

--DROP TABLE PROJECT_COST_CENTERS;

CREATE TABLE PROJECT_COST_CENTERS (
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32),
	COST_CENTER_ID VARCHAR2(32),
	START_DATE DATE,
	FINISH_DATE DATE,
	DEFAULT_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	ACTUAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	COST_CHARGE_PERCENT NUMBER(10) DEFAULT 10000 NOT NULL,
	MAX_COST_CHARGE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	COST_CHARGE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REVENUE_CHARGE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_REVENUE_CHARGE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REVENUE_CHARGE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LABOR_COST_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LABOR_REVENUE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	NON_LABOR_COST_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	NON_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	NON_LABOR_REVENUE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	NON_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	WS_COST_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	WS_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	WS_REVENUE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	WS_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LABOR_FLAG NUMBER(5) DEFAULT 0,
	EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_FLAG NUMBER(5) DEFAULT 0,
	CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_FLAG NUMBER(5) DEFAULT 0,
	BASELINE1_LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_USER VARCHAR2(32) DEFAULT 'PMO_SUPERVISOR' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);


		
--???CREATE UNIQUE INDEX PCC_EID_XX ON PROJECT_COST_CENTERS
--		(ELEMENT_ID ASC) PCTFREE 30 ;



DROP INDEX PCC_RID_CCID_DT;
CREATE UNIQUE INDEX PCC_RID_CCID_DT ON PROJECT_COST_CENTERS (PROJECT_ID ASC,RESOURCE_ID ASC,COST_CENTER_ID ASC)  PCTFREE = 30;



INSERT INTO PROJECT_COST_CENTERS(ELEMENT_ID, PROJECT_ID, COST_CENTER_ID, COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT, LABOR_COST_PERCENT, LABOR_REVENUE_PERCENT, NON_LABOR_COST_PERCENT, NON_LABOR_REVENUE_PERCENT, WS_COST_PERCENT, WS_REVENUE_PERCENT, DEFAULT_FLAG)
(SELECT SYS_GUID(), PROJECT_ID, (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE DEFAULT_FLAG = 'Y'), 0, 0, 10000, 10000, 10000, 10000,10000, 10000, 63
FROM PROJECT_DETAILS);



UPDATE PROJECT_COST_CENTERS PCC
SET (LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT) = 
(SELECT LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT FROM PROJECT_COSTBACK PC
WHERE PC.PROJECT_ID = PCC.PROJECT_ID AND PC.COST_CENTER_ID = PCC.COST_CENTER_ID)
WHERE PCC.COST_CENTER_ID IS NOT NULL AND PCC.RESOURCE_ID IS NULL
	AND EXISTS (SELECT PC1.PROJECT_ID FROM PROJECT_COSTBACK PC1 
	WHERE PC1.PROJECT_ID = PCC.PROJECT_ID AND PC1.COST_CENTER_ID = PCC.COST_CENTER_ID);



INSERT INTO PROJECT_COST_CENTERS (element_id, project_id, cost_center_id, LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT) 
(SELECT costback_id, project_id, cost_center_id, LABOR_PERCENT, LABOR_AMOUNT, LABOR_FLAG, EXPENSE_PERCENT, EXPENSE_AMOUNT, EXPENSE_FLAG,
CAPITAL_PERCENT, CAPITAL_AMOUNT, CAPITAL_FLAG, 
BASELINE1_LABOR_PERCENT, BASELINE1_LABOR_AMOUNT,
BASELINE1_EXPENSE_PERCENT, BASELINE1_EXPENSE_AMOUNT, 
BASELINE1_CAPITAL_PERCENT, BASELINE1_CAPITAL_AMOUNT,
BASELINE2_LABOR_PERCENT, BASELINE2_LABOR_AMOUNT,
BASELINE2_EXPENSE_PERCENT, BASELINE2_EXPENSE_AMOUNT, 
BASELINE2_CAPITAL_PERCENT, BASELINE2_CAPITAL_AMOUNT,
BASELINE3_LABOR_PERCENT, BASELINE3_LABOR_AMOUNT,
BASELINE3_EXPENSE_PERCENT, BASELINE3_EXPENSE_AMOUNT, 
BASELINE3_CAPITAL_PERCENT, BASELINE3_CAPITAL_AMOUNT FROM PROJECT_COSTBACK PC
WHERE NOT EXISTS (SELECT PCC.PROJECT_ID FROM PROJECT_COST_CENTERS PCC 
	WHERE PCC.RESOURCE_ID IS NULL AND PCC.PROJECT_ID = PC.PROJECT_ID 
	AND PCC.COST_CENTER_ID = PC.COST_CENTER_ID));




-- PROJECT_RECONCILIATION

--DROP TABLE PROJECT_RECONCILIATION;

CREATE TABLE PROJECT_RECONCILIATION (
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32),
	FOREIGN_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	FOREIGN_TABLE NUMBER(5) DEFAULT 0 NOT NULL,
	FOREIGN_DATE DATE,
	TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	COST_CENTER_ID VARCHAR2(32),
	DEFAULT_LABOR_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	REGULAR_TOTAL_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_DEFAULT_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_TOTAL_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_DEFAULT_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TAX1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TAX2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ADJ_REGULAR_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ADJ_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ADJ_SPECIAL_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ADJ_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ADJ_TAX1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ADJ_TAX2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_REGULAR_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_SPECIAL_QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_TAX1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER_TAX2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CHARGE_DATE DATE,
	RECONCILIATION_DATE DATE,
	DESCRIPTION VARCHAR2(255),
	REC_USER VARCHAR2(32) DEFAULT 'PMO_SUPERVISOR' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	WEEK_OF DATE,
	CONTRACT_ID VARCHAR2(32)
);



DROP INDEX PRC_PID_FID_DT;
CREATE UNIQUE INDEX PRC_PID_FID_DT ON PROJECT_RECONCILIATION (PROJECT_ID ASC,FOREIGN_ID ASC,FOREIGN_DATE ASC,COST_CENTER_ID ASC,TYPE_ID ASC)  PCTFREE = 30;
DROP INDEX PRCSX_EID_XU;
CREATE UNIQUE INDEX PRCSX_EID_XU ON PROJECT_RECONCILIATION (ELEMENT_ID ASC) ;
		
		
		
-- TMT_COSTS

ALTER TABLE TMT_COSTS ADD COST_CENTER_BITS NUMBER(10) DEFAULT 0 NOT NULL;

-- PROJECT_STATE_DEF

ALTER TABLE PROJECT_STATE_DEF ADD ELEMENT_ID VARCHAR2(32) ;
ALTER TABLE PROJECT_STATE_DEF ADD PARENT_ID VARCHAR2(32);
ALTER TABLE PROJECT_STATE_DEF ADD WBS_PARENT_ID VARCHAR2(32);
ALTER TABLE PROJECT_STATE_DEF ADD EXPIRE_DAYS NUMBER(10);
ALTER TABLE PROJECT_STATE_DEF ADD CHILD_COUNT NUMBER(10) DEFAULT 0;

UPDATE PROJECT_STATE_DEF
SET ELEMENT_ID = SYS_GUID(),
PARENT_ID = PROJECT_ID;



DROP INDEX DEF_STATE_XU;
CREATE UNIQUE INDEX DEF_STATE_XU ON PROJECT_STATE_DEF (PROJECT_ID ASC,ELEMENT_TYPE ASC,STAGE_ID ASC) ;
		
		
-- STATE_TASK_NEXT_STATE_CNFG		
		
--DROP TABLE STATE_TASK_NEXT_STATE_CNFG;

CREATE TABLE STATE_TASK_NEXT_STATE_CNFG (
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	STAGE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	NEXT_STAGE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	POSITIVE_RESPONSE NUMBER(10) DEFAULT 0 NOT NULL,
	NEGATIVE_RESPONSE NUMBER(10) DEFAULT 0 NOT NULL,
	PRIORITY NUMBER(10) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32) DEFAULT 'PMO_SUPERVISOR' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);



DROP INDEX NEXT_STATE_CNFG_XU;
CREATE UNIQUE INDEX NEXT_STATE_CNFG_XU ON STATE_TASK_NEXT_STATE_CNFG (PROJECT_ID ASC,STAGE_ID ASC,NEXT_STAGE_ID ASC) ;
		
		
-- TMT_WORKFLOWS
		
ALTER TABLE TMT_WORKFLOWS ADD STATE_CHANGE_WKF VARCHAR2(32);


-- TASK_DAY_OF_YEAR

ALTER TABLE TASK_DAY_OF_YEAR ADD TABLE_TYPE NUMBER(5) DEFAULT 1;

UPDATE TASK_DAY_OF_YEAR SET TABLE_TYPE = 3 WHERE EXISTS (SELECT c.ELEMENT_ID FROM TMT_CRI c WHERE PROJECT_ID = c.PROJECT_ID AND TASK_ID = c.ELEMENT_ID);

-- LEVEL_TASK_DAY_OF_YEAR

ALTER TABLE LEVEL_TASK_DAY_OF_YEAR ADD TABLE_TYPE NUMBER(5) DEFAULT 1;



-- TMT_CALENDARS

ALTER TABLE TMT_CALENDARS ADD START_DATE DATE DEFAULT SYSDATE NOT NULL;


-- HISTORY_CALENDARS

--DROP TABLE HISTORY_CALENDARS;

CREATE TABLE HISTORY_CALENDARS (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	START_DATE DATE DEFAULT SYSDATE NOT NULL,
	WEEKLY_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	MONDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	TUESDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	WEDNESDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	THURSDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	FRIDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	SATURDAY_STATUS VARCHAR2(1) DEFAULT '0' NOT NULL,
	SUNDAY_STATUS VARCHAR2(1) DEFAULT '0' NOT NULL,
	MONDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	TUESDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	WEDNESDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	THURSDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	FRIDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	SATURDAY_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	SUNDAY_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	MONDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	TUESDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	WEDNESDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	THURSDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	FRIDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	SATURDAY_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	SUNDAY_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_USER VARCHAR2(32)
);

-- DDL Statements for indexes on Table HISTORY_CALENDARS

DROP INDEX H_ENID;
CREATE UNIQUE INDEX H_ENID ON HISTORY_CALENDARS (ELEMENT_ID ASC,START_DATE ASC) ;
		
		
		
-- RESOURCES

ALTER TABLE RESOURCES ADD ASSIGNED_PLUGINS NUMBER(19) DEFAULT 0 NOT NULL;

			
			
-- HISTORY_RESOURCES

ALTER TABLE HISTORY_RESOURCES ADD ASSIGNED_PLUGINS NUMBER(19) DEFAULT 0 NOT NULL;


-- CURRENCY_EXCHANGES
--DROP TABLE CURRENCY_EXCHANGES;

CREATE TABLE CURRENCY_EXCHANGES (
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	CURRENCY_ID NUMBER(10) DEFAULT 0 NOT NULL,
	START_DATE DATE,
	FINISH_DATE DATE,
	EXCHANGE_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_USER VARCHAR2(32) DEFAULT 'PMO_SUPERVISOR' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

DROP INDEX CURRENCY_EXC_CID;
CREATE UNIQUE INDEX CURRENCY_EXC_CID ON CURRENCY_EXCHANGES (CURRENCY_ID ASC,ELEMENT_ID ASC)  PCTFREE = 30;


INSERT INTO CURRENCY_EXCHANGES SELECT SYS_GUID(), ELEMENT_ID,  DATE '1899-12-31',  DATE '2300-12-30', PMO_ORASTD.TODECIMAL(ELEMENT_NAME, 20, 4), 'PMO_SUPERVISOR', 'U', SYSTIMESTAMP
FROM TMT_DATAFIELDS
WHERE TYPE_ID = 37 AND LEVEL_ID = 2;



		
-- TMT_DATAFIELDS


INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(1,141,20,20,0,null,6700,'Contract Type',2,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c',null);
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6701,'1',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0001','Straight Amount');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6702,'2',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0002','Straight Amount with Max');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6703,'3',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0003','Monthly Fixed');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6704,'4',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0004','One-time Fixed');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6705,'5',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0005','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6706,'6',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0006','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6707,'7',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0007','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6708,'8',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0008','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6709,'9',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c0009','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6710,'10',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000:','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6711,'11',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000;','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6712,'12',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000<','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6713,'13',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000=','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6714,'14',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000>','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6715,'15',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000?','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6716,'16',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000@','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6717,'17',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000A','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6718,'18',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000B','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6719,'19',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000C','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,141,0,0,0,null,6720,'20',6700,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000c000D','');



INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(1,142,20,20,0,null,6800,'Charge Code Stage',2,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d',null);
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6801,'1',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0001','Active');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6802,'2',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0002','Non-posting');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6803,'3',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0003','Inactivated');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6804,'4',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0004','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6805,'5',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0005','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6806,'6',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0006','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6807,'7',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0007','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6808,'8',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0008','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6809,'9',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d0009','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6810,'10',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000:','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6811,'11',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000;','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6812,'12',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000<','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6813,'13',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000=','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6814,'14',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000>','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6815,'15',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000?','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6816,'16',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000@','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6817,'17',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000A','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6818,'18',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000B','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6819,'19',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000C','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,142,0,0,0,null,6820,'20',6800,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000d000D','');



INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(1,143,20,20,0,null,6900,'Cost Center Stage',2,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e',null);
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6901,'1',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0001','Open');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6902,'2',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0002','Locked');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6903,'3',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0003','Non-posting');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6904,'4',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0004','Posting');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6905,'5',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0005','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6906,'6',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0006','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6907,'7',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0007','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6908,'8',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0008','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6909,'9',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e0009','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6910,'10',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000:','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6911,'11',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000;','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6912,'12',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000<','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6913,'13',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000=','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6914,'14',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000>','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6915,'15',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000?','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6916,'16',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000@','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6917,'17',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000A','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6918,'18',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000B','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6919,'19',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000C','');
INSERT INTO TMT_DATAFIELDS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,POSITION,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION) VALUES(2,143,0,0,0,null,6920,'20',6900,'PMO_SUPERVISOR','O', TIMESTAMP '2003-03-25 09:57:12.109000','00000001000e000D','');




UPDATE TMT_DATAFIELDS SET DESCRIPTION = 'None' WHERE ELEMENT_ID = 6501;
UPDATE TMT_DATAFIELDS SET ELEMENT_NAME = 'Scope Elements Revision Type' WHERE ELEMENT_ID = 4725;
UPDATE TMT_DATAFIELDS SET ELEMENT_NAME = 'Scope Elements' WHERE ELEMENT_ID = 719;

-- TMT_CRI

UPDATE TMT_CRI 
SET ESTIMATED_START = SYSTIMESTAMP
WHERE ESTIMATED_START IS NULL;

DROP TABLE TMT_CRI_BKUP;

CREATE TABLE TMT_CRI_BKUP (
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	TRANSFERRED VARCHAR2(1),
	STAGE_ID NUMBER(10) DEFAULT 786,
	CREATED_BY VARCHAR2(32),
	CREATED_DATETIME TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	EXTERNAL_REFERENCE VARCHAR2(32),
	PRIORITY_ID NUMBER(5) DEFAULT 500,
	PROPOSED_BY VARCHAR2(32),
	PROPOSED_DATETIME TIMESTAMP,
	IMPACT_LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DATETIME TIMESTAMP,
	FINISH_DATETIME TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_START TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	ESTIMATED_FINISH TIMESTAMP,
	MITIGATION_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 0,
	SCHEDULE_RANK_ID NUMBER(5) DEFAULT 0,
	COST_RANK_ID NUMBER(5) DEFAULT 0,
	QUALITY_RANK_ID NUMBER(5) DEFAULT 0,
	PROBABILITY_RANK_ID NUMBER(5) DEFAULT 0,
	PRECISION_RANK_ID NUMBER(5) DEFAULT 0,
	EXPOSURE_ID NUMBER(10),
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROBABILITY_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_DATETIME TIMESTAMP,
	APPROVED_START TIMESTAMP,
	APPROVED_FINISH TIMESTAMP,
	APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CLOSED_BY VARCHAR2(32),
	CLOSED_DATETIME TIMESTAMP,
	PLANNING_UNIT VARCHAR2(1),
	PLANNING_TYPE NUMBER(10),
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_DATETIME TIMESTAMP,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_DATETIME TIMESTAMP,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_DATETIME TIMESTAMP,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_DATETIME TIMESTAMP,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_DATETIME TIMESTAMP,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_DATETIME TIMESTAMP,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(32),
	LAST_WF_DATETIME TIMESTAMP,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137 NOT NULL,
	REVISION_TYPE NUMBER(10) DEFAULT 4726 NOT NULL,
	REVISION_HISTORY VARCHAR2(2048) DEFAULT 'CREATED',
	TOOLTIP_DESCRIPTION VARCHAR2(255) DEFAULT NULL,
	STATUS_ID NUMBER(10) DEFAULT 316,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	SHARED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	IMPACT_RANK_ID NUMBER(5) DEFAULT 1,
	ASSIGN_NAMES VARCHAR2(2048),
	ASSIGN_COUNT NUMBER(5) DEFAULT 0,
	REC_USER VARCHAR2(32),
	RTF_BITS NUMBER(5) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	LAST_TRANSFER_DT TIMESTAMP,
	WBS_ID VARCHAR2(32),
	STAGE_LAST_DT TIMESTAMP DEFAULT SYSTIMESTAMP,
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	SCORECARD_ID VARCHAR2(32),
	PUBLISHED_DT TIMESTAMP,
	PRIORITY NUMBER(5) DEFAULT 500,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0,
	PERCENT_COMPLETE NUMBER(5) DEFAULT 0,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	WBS_ASSIGNED NUMBER(10) DEFAULT 0 NOT NULL,
	DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	SCHED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	FORECAST_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	CONSTRAINT_DT TIMESTAMP,
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	CLIENT_ID VARCHAR2(32),
	CLIENT_NAME VARCHAR2(50),
	REASSIGN_COUNT NUMBER(5) DEFAULT 0,
	DUPLICATE_REF_ID VARCHAR2(50),
	OCCURED_DATETIME TIMESTAMP,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	PROPOSED_BY_NAME VARCHAR2(100),
	CLOSED_BY_NAME VARCHAR2(100),
	ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	HIGH_ESTIMATED_START TIMESTAMP,
	HIGH_ESTIMATED_FINISH TIMESTAMP,
	HIGH_ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	HIGH_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	LOW_ESTIMATED_START TIMESTAMP,
	LOW_ESTIMATED_FINISH TIMESTAMP,
	LOW_ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	LOW_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	APPROVED_EFFORT NUMBER(19) DEFAULT 0,
	APPROVED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_BY VARCHAR2(32),
	APPROVED_BY_NAME VARCHAR2(100),
	R_APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_REVENUE NUMBER(18,2) DEFAULT 0.00,
	EXPECTED_MARGIN NUMBER(18,2) DEFAULT 0.00,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EXPECTED_COST NUMBER(18,2) DEFAULT 0.00,
	S_APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	CHANGE_TO_TASK NUMBER(5) DEFAULT 0,
	APPROVED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TARGET_DATE DATE,
	ESTIMATED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	DUPLICATE_KEY NUMBER(10),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	APPROVED_IMPACT_LEVEL_ID NUMBER(10) DEFAULT 0,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_PAYBACK_PERIOD NUMBER(10) DEFAULT 0,
	EXPECTED_PAYBACK_MONTH NUMBER(10) DEFAULT 0,
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	DEFAULT_COL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	TEMPLATED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL
);



INSERT INTO TMT_CRI_BKUP SELECT * FROM TMT_CRI;

DROP INDEX TCRIX_ENID_XU;
DROP INDEX TCRIX_NVID_RK_XX;
DROP INDEX TCRIX_PJNWBID_XX;
DROP INDEX TCRIX_PRK_RK_CX;
DROP INDEX TCRIX_RK_XU;
DROP INDEX TCRIX_TPID_XX;

DROP TABLE TMT_CRI_OLD;
ALTER TABLE TMT_CRI RENAME TO TMT_CRI_OLD;
ALTER TABLE TMT_CRI_BKUP RENAME TO TMT_CRI;

DROP INDEX TCRIX_ENID_XU;
CREATE UNIQUE INDEX TCRIX_ENID_XU ON TMT_CRI (ELEMENT_ID ASC,PARENT_ID ASC) ;
DROP INDEX TCRIX_NVID_RK_XX;
CREATE  INDEX TCRIX_NVID_RK_XX ON TMT_CRI (PARENT_ID ASC,LEVEL_ID ASC,RANK ASC) ;
DROP INDEX TCRIX_PJNWBID_XX;
CREATE  INDEX TCRIX_PJNWBID_XX ON TMT_CRI (PROJECT_ID ASC,PARENT_ID ASC,WBS_ID ASC)  PCTFREE = 30;
DROP INDEX TCRIX_PRK_RK_CX;
CREATE  INDEX TCRIX_PRK_RK_CX ON TMT_CRI (PARENT_RANK ASC,RANK ASC)  PCTFREE = 30;
DROP INDEX TCRIX_TPID_XX;
CREATE  INDEX TCRIX_TPID_XX ON TMT_CRI (T_PARENT_ID ASC) ;
DROP INDEX TCRIX_RK_XU;
CREATE UNIQUE INDEX TCRIX_RK_XU ON TMT_CRI (RANK ASC)  PCTFREE = 30;
DROP INDEX CRI_CLIENT_XXX;
CREATE  INDEX CRI_CLIENT_XXX ON TMT_CRI (CLIENT_ID)  PCTFREE = 30;
DROP INDEX CRI_DUP_XXX;
CREATE  INDEX CRI_DUP_XXX ON TMT_CRI (DUPLICATE_KEY)  PCTFREE = 30;
DROP INDEX CRI_SCR_XXX;
CREATE  INDEX CRI_SCR_XXX ON TMT_CRI (SCORECARD_ID)  PCTFREE = 30;


-- IF SUCCESSFUL DROP TEMPORARY TABLES.
--DROP TABLE TMT_CRI_OLD;

-- ACTIVITIES

ALTER TABLE ACTIVITIES ADD TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL;	
ALTER TABLE ACTIVITIES ADD SHOW_STEP VARCHAR2(1) DEFAULT 'Y';

UPDATE ACTIVITIES SET SHOW_STEP = 'N' WHERE TYPE_ID = 330;
UPDATE ACTIVITIES SET TYPE_ID = 212 WHERE TYPE_ID <> 330;

DROP INDEX ACTVT_EID_XX;

DROP INDEX ACTVT_EID_XX;
CREATE  INDEX ACTVT_EID_XX ON ACTIVITIES (ELEMENT_ID ASC,TYPE_ID ASC)  PCTFREE = 30;
DROP INDEX ACTVT_TAID_CX;
CREATE  INDEX ACTVT_TAID_CX ON ACTIVITIES (TSK_ASSIGNMENT_ID ASC)  PCTFREE = 30;




-- DETAIL_TIMESHEETS

ALTER TABLE DETAIL_TIMESHEETS ADD CREDIT_WEEK_OF DATE;

DROP INDEX DTTSH_AID_WF_XU;
CREATE UNIQUE INDEX DTTSH_AID_WF_XU ON DETAIL_TIMESHEETS (ACTIVITY_ID ASC,WEEK_OF ASC) ;
DROP INDEX DTTSH_AID_CW_XY;
CREATE  INDEX DTTSH_AID_CW_XY ON DETAIL_TIMESHEETS (ACTIVITY_ID ASC,CREDIT_WEEK_OF ASC)  PCTFREE = 30;
	



-- RESOURCE_ASSIGNMENTS

UPDATE RESOURCE_ASSIGNMENTS SET RESOURCE_ID = PROFILE_ID WHERE PROFILE_ID IS NOT NULL AND RESOURCE_TYPE = '1';

UPDATE RESOURCE_ASSIGNMENTS SET PROFILE_ID = NULL WHERE PROFILE_ID IS NOT NULL AND RESOURCE_TYPE = '1';


-- TMT_CONTRACTS


CREATE TABLE TMT_CONTRACTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	RANK VARCHAR2(128) NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	CONTRACT_TYPE NUMBER(10) DEFAULT 6701 NOT NULL,
	CLIENT_ID VARCHAR2(32) NOT NULL,
	MAX_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENCY_ID NUMBER(10) DEFAULT 219 NOT NULL,
	CHARGED_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LAST_CHARGED_DATE DATE,
	EXTERNAL_REFERENCE VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DESCRIPTION VARCHAR2(2048)
);

DROP INDEX TCONTR_ENID_XU;
CREATE UNIQUE INDEX TCONTR_ENID_XU ON TMT_CONTRACTS (ELEMENT_ID ASC,PARENT_ID ASC)  PCTFREE = 30;
DROP INDEX TCONTR_RK_CU;
CREATE UNIQUE INDEX TCONTR_RK_CU ON TMT_CONTRACTS (RANK ASC)  PCTFREE = 30;


INSERT INTO TMT_CONTRACTS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,REC_DATETIME,RANK,DESCRIPTION, CLIENT_ID) VALUES(-1,0,0,1,0,null,null,null,'PMO_SYSTEM','I', TIMESTAMP '2000-10-09 00:08:58.676001','0000',null, ' ');


-- CONTRACT_BREAKDOWN

CREATE TABLE CONTRACT_BREAKDOWN (
	ELEMENT_ID VARCHAR2(32),
	CONTRACT_ID VARCHAR2(32),
	CHARGE_DATE DATE DEFAULT SYSDATE NOT NULL,
	CHARGE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

DROP INDEX TCONTR_BDENID_XU;
CREATE  INDEX TCONTR_BDENID_XU ON CONTRACT_BREAKDOWN (ELEMENT_ID ASC)  PCTFREE = 30;
DROP INDEX TCONTR_BDID_XU;
CREATE  INDEX TCONTR_BDID_XU ON CONTRACT_BREAKDOWN (CONTRACT_ID ASC,CHARGE_DATE ASC)  PCTFREE = 30;


-- TMT_SETTINGS

UPDATE TMT_SETTINGS
SET ELEMENT_NAME = '6.5.2.22', DESCRIPTION = '6.5.2.22'
WHERE ELEMENT_ID = 'CLIENT_BUILD_NUMBER';

UPDATE TMT_SETTINGS
SET DESCRIPTION = '6.5.2.22'
WHERE ELEMENT_ID = 'SERVER_BUILD_NUMBER';


UPDATE TMT_SETTINGS
SET ELEMENT_NAME = '6.1.0.0'
WHERE ELEMENT_ID = 'CLIENT_VERSION_NUMBER';

UPDATE TMT_SETTINGS
SET DESCRIPTION = '6.1.0.0'
WHERE ELEMENT_ID = 'APPLICATION_VERSION';

INSERT INTO TMT_SETTINGS(LEVEL_ID,TYPE_ID,MAX_RANK,CHILD_COUNT,DELETED_COUNT,ELEMENT_ID,ELEMENT_NAME,PARENT_ID,REC_USER,REC_STATUS,RANK) 
VALUES(0,1,0,0,0,'RUP_HOME_PATH',null,null,'PMO_SUPERVISOR','I','0000000o');

UPDATE TMT_SETTINGS set MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1 where RANK = '0000';


-- TMT_WORKFLOW_CYCLES

UPDATE TMT_WORKFLOW_CYCLES 
SET ELEMENT_NAME = 'Scope Element Folder' 
WHERE ELEMENT_ID = 'EXCEPTION FOLDER';


-- TMT_DOCUMENTS

ALTER TABLE TMT_DOCUMENTS ADD RUP_LINK VARCHAR2(1) DEFAULT '0' NOT NULL;

--HISTORY_DOCUMENTS

ALTER TABLE HISTORY_DOCUMENTS ADD RUP_LINK VARCHAR2(1) DEFAULT '0' NOT NULL;

--TMT_SCORECARDS_DEF_AST

ALTER TABLE TMT_SCORECARDS_DEF_AST ADD REPORT_FLAG NUMBER(5) DEFAULT 0;


-- TMT_SCORECARDS_DEF_CRI
 
ALTER TABLE TMT_SCORECARDS_DEF_CRI ADD REPORT_FLAG NUMBER(5) DEFAULT 0;

-- TMT_SCORECARDS_DEF_RES

ALTER TABLE TMT_SCORECARDS_DEF_RES ADD REPORT_FLAG NUMBER(5) DEFAULT 0;

-- TMT_SCORECARDS_DEF_WBS

ALTER TABLE TMT_SCORECARDS_DEF_WBS ADD REPORT_FLAG NUMBER(5) DEFAULT 0;



-- TMT_ASSIGNED_SCORECARDS

ALTER TABLE TMT_ASSIGNED_SCORECARDS ADD REPORT_FLAG NUMBER(5) DEFAULT 0;

-- HISTORY_ASSIGNED_SCORECARDS

ALTER TABLE HISTORY_ASSIGNED_SCORECARDS ADD REPORT_FLAG NUMBER(5) DEFAULT 0;

-- TMT_PUBLISHED_SCORECARDS

ALTER TABLE TMT_PUBLISHED_SCORECARDS ADD REPORT_FLAG NUMBER(5) DEFAULT 0;

-- HISTORY_PUBLISHED_SCORECARDS

ALTER TABLE HISTORY_PUBLISHED_SCORECARDS ADD REPORT_FLAG NUMBER(5) DEFAULT 0;



--Description:  	Fix the RANK in all TMT tables, WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK)).

UPDATE TMT_ASSETS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));               
UPDATE TMT_ASSET_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));     
UPDATE TMT_ASSET_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_ASSIGNED_SCORECARDS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));  
UPDATE TMT_CALENDARS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_CHARGECODES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));          
UPDATE TMT_CLIENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_CLIENT_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));    
UPDATE TMT_CLIENT_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));     
UPDATE TMT_COMPETENCIES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));         
UPDATE TMT_CONTACTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));             
UPDATE TMT_CONTRACTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_COSTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                
UPDATE TMT_COST_CENTERS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));         
UPDATE TMT_CRI SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                  
UPDATE TMT_CRI_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));       
UPDATE TMT_DATAFIELDS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));           
UPDATE TMT_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_DOCUMENT_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));  
UPDATE TMT_DOMAINS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_FACTORS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_GEOGRAPHIES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));          
UPDATE TMT_GLOBAL_SECURITY SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_NAB SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                  
UPDATE TMT_ORGANIZATIONS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));        
UPDATE TMT_POOLS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                
UPDATE TMT_POOL_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_POOL_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));       
UPDATE TMT_PORTFOLIOS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));           
UPDATE TMT_PUBLISHED_SCORECARDS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK)); 
UPDATE TMT_REPORT_SECURITY SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));      
UPDATE TMT_RESOURCE_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCENARIOS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_SCORECARDS_DEF_AST SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCORECARDS_DEF_CRI SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCORECARDS_DEF_RES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SCORECARDS_DEF_WBS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));   
UPDATE TMT_SETTINGS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));             
UPDATE TMT_TIMECODES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_VENDORS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));              
UPDATE TMT_VENDOR_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));    
UPDATE TMT_VENDOR_DOCUMENTS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));     
UPDATE TMT_WBS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));                  
UPDATE TMT_WBS_ATTRIBUTES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));       
UPDATE TMT_WORKFLOWS SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK));            
UPDATE TMT_WORKFLOW_CYCLES SET RANK = RTRIM(RANK) WHERE LENGTH(RANK) <> LENGTH(RTRIM(RANK)); 




-- CREATE ALL TRIGGERS WHEN EVERYTHING SUCCEEDS USING TRIGGERS.sql IN DDL FOLDER IN SOURCE SAFE AND DROP ALL THE TEMPORARY TABLES CREATED DURING MIGRATION WHICH ARE AS FOLLOWS




------------------------------------------------------------------------
--end of migration_from_6.0_to_6.1
------------------------------------------------------------------------

--create triggers at this point and compile

--@oraddl/Sequences.sql
@oraddl/triggers.sql
@utils/recompile

------------------------------------------------------------------------
--migration_sp_6.0_to_6.1
------------------------------------------------------------------------


var r refcursor;
exec :r:= SP_MIG_CONTINGENCY(null, 0, 'PMO_SUPERVISOR');
print :r;

--var r refcursor;
exec :r:= SP_T_COST_CENTER_2_CLIENT(0);
print :r;

--var r refcursor;
exec :r:= SP_ROLLUP_COST_CENTER(null, 1, 'PMO_SUPERVISOR');
print :r;


------------------------------------------------------------------------
--Drop triggers and sequences
------------------------------------------------------------------------

@utils/DropPMOTrig.sql

DROP INDEX BDGTS_EBCID_CU;
DROP INDEX BDGTS_BID_XX;
DROP INDEX BDGTS_CID_XX;
DROP INDEX BUDGET_CHRGEID_XXX;

DROP TABLE BUDGETS4;

CREATE TABLE BUDGETS4 (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	CHARGECODE_ID VARCHAR2(32) NOT NULL,
	BUDGET_ID VARCHAR2(32) NOT NULL,
	ASSOCIATE_BUDGET_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	TOTAL_ESTIMATION_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_BUDGET_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROB_PERCENT NUMBER(10) DEFAULT 10000,
	PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PAID_TODATE NUMBER(18,2) DEFAULT 0.00,
	AUTO_FLAG NUMBER(5) DEFAULT 1 NOT NULL,
	ACTUAL_EDITED NUMBER(5) DEFAULT 1 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	DATAFIELD_1 NUMBER(10),
	DATAFIELD_2 NUMBER(10),
	TXT_FIELD_01 VARCHAR2(1024),
	TXT_FIELD_02 VARCHAR2(1024),
	TXT_FIELD_03 VARCHAR2(1024),
	TXT_FIELD_04 VARCHAR2(1024),
	TXT_FIELD_05 VARCHAR2(1024),
	TXT_FIELD_06 VARCHAR2(1024),
	TXT_FIELD_07 VARCHAR2(1024),
	TXT_FIELD_08 VARCHAR2(1024),
	TXT_FIELD_09 VARCHAR2(1024),
	TXT_FIELD_10 VARCHAR2(1024),
	TOLERANCE NUMBER(10) DEFAULT 10000,
	ESTIMATED_ACTUAL_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID_TODATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID_TODATE_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PROB_AMOUNT_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_SCH_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	BASELINE3_EST_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	DATAFIELD_3 NUMBER(10),
	DATAFIELD_4 NUMBER(10),
	ACTUAL_TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	CAPITAL_EXPENSE NUMBER(5) DEFAULT 0 NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 1 NOT NULL,
	COST_CENTER_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CHARGED NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_LEDGER NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CHARGED_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_LEDGER_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL
);

DROP INDEX BDGTS_EBCID_CU;
CREATE UNIQUE INDEX BDGTS_EBCID_CU ON BUDGETS4 (PROJECT_ID ASC,ELEMENT_ID ASC,CHARGECODE_ID ASC)  PCTFREE = 30;
DROP INDEX BDGTS_BID_XX;
CREATE UNIQUE INDEX BDGTS_BID_XX ON BUDGETS4 (BUDGET_ID ASC) ;
DROP INDEX BDGTS_CID_XX;
CREATE  INDEX BDGTS_CID_XX ON BUDGETS4 (PROJECT_ID,CHARGECODE_ID ASC) ;
DROP INDEX BUDGET_CHRGEID_XXX;
CREATE  INDEX BUDGET_CHRGEID_XXX ON BUDGETS4 (CHARGECODE_ID)  PCTFREE = 30;

INSERT INTO BUDGETS4 (TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG)
SELECT TYPE_ID, 
PROJECT_ID,
ELEMENT_ID,
CHARGECODE_ID, 
BUDGET_ID, 
ASSOCIATE_BUDGET_ID, 
CREATED_BY,
REC_USER,
REC_STATUS,
REC_DATETIME,
TOTAL_ESTIMATION_PROB_AMOUNT,
TOTAL_BUDGET_PROB_AMOUNT,
PROB_PERCENT,
PROB_AMOUNT, 
ESTIMATED_BASELINE1, 
ESTIMATED_BASELINE2, 
ESTIMATED_BASELINE3, 
ESTIMATED_TOTAL, 
ESTIMATED_BUDGET,
ESTIMATED_ACTUAL,
ESTIMATED_ETC, 
BUDGET_BASELINE1,
BUDGET_BASELINE2,
BUDGET_BASELINE3,
BUDGET,
ACTUAL,
ETC, 
PAID_TODATE, 
AUTO_FLAG, 
ACTUAL_EDITED, 
ROLLUP_BITS, 
TIMEPHASED_BITS, 
TIMEPHASED_FLAG, 
DATAFIELD_1, 
DATAFIELD_2, 
TXT_FIELD_01,
TXT_FIELD_02,
TXT_FIELD_03,
TXT_FIELD_04,
TXT_FIELD_05,
TXT_FIELD_06,
TXT_FIELD_07,
TXT_FIELD_08,
TXT_FIELD_09,
TXT_FIELD_10,
TOLERANCE, 
ESTIMATED_ACTUAL_TOTAL,
ESTIMATED_ETC_TOTAL, 
ESTIMATED_PAID_TODATE, 
ESTIMATED_PAID_TODATE_TOTAL, 
ESTIMATED_PROB_AMOUNT, 
ESTIMATED_PROB_AMOUNT_TOTAL, 
BASELINE3_SCH_FLAG,
BASELINE3_EST_FLAG,
DATAFIELD_3, 
DATAFIELD_4, 
ACTUAL_TIMEPHASED_FLAG FROM BUDGETS;

DROP TABLE BUDGETS3;
ALTER TABLE BUDGETS RENAME TO BUDGETS3;
ALTER TABLE BUDGETS4 RENAME TO BUDGETS;

-- IF SUCCESSFULl DROP TABLE BUDGETS1;


-- TMT_COST_CENTERS

DROP TABLE TMT_COST_CENTERS;


--RECREATE TRIGGERS USING TRIGGERS.sql IN DDL FOLDER IN SOURCE SAFE

COMMIT WORK;

@oraddl/Sequences.sql
@oraddl/triggers.sql


@utils/recompile

 
spool off;
exit;
