-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_TRACKED ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_TRACKED
(
     p_asset_id VARCHAR2
   , p_tracked_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_tracked_flag VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_TRACKED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_TRACKED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_TRACKED(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_tracked_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TRACKED', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_TRACKED(23) : assets.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_TRACKED', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_TRACKED(28) : assets.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TRACKED', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_TRACKED(31) : assets.sql(36) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_asset_id := p_asset_id;
   h_rec_user := p_rec_user;
   h_tracked_flag := p_tracked_flag;
   
   /*  if (strncmp(h_tracked_flag, "N", 1) == 0)
       {
           InitializeHost(SC_PARAM(h_count), 0);
           BEGIN_SQL
               SELECT COUNT(CHARGECODE_ID) INTO HOST(h_count)
               FROM BUDGETS
               WHERE CHARGECODE_ID = HOST(h_asset_id);
           END_SQL;
   
           if (h_count > 0)
           {
               RETURN_ERROR(ELEMENT_IS_USED, h_asset_id);
           }
   
           InitializeHost(SC_PARAM(h_count), 0);
           BEGIN_SQL
               SELECT COUNT(PROJECT_ID) INTO HOST(h_count)
               FROM PROJECT_CHARGEBACK
               WHERE PROJECT_ID = HOST(h_asset_id);
           END_SQL;
   
           if (h_count > 0)
           {
               RETURN_ERROR(ELEMENT_IS_USED, h_asset_id);
           }
   
           BEGIN_SQL
               DELETE FROM TMT_CHARGECODES WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL;
       }
   */
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_ASSETS
      SET TRACKED_FLAG = h_tracked_flag,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TRACKED', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TRACKED(88) : assets.sql(93) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_TRACKED', 93+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_TRACKED(94) : assets.sql(99) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_asset_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TRACKED', 100+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TRACKED(101) : assets.sql(106) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TRACKED', 112+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TRACKED(113) : assets.sql(118) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_TRACKED;
ALTER FUNCTION SP_U_ASSET_TRACKED COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_CIE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_description VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_asset_more_100_employees PLS_INTEGER
   , p_asset_more_1000_employees PLS_INTEGER
   , p_asset_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_asset_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_asset_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_asset_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CIE', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_CIE(43) : assets.sql(177) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_CIE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_CIE(47) : assets.sql(181) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CIE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CIE(54) : assets.sql(188) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CIE', 65+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CIE(66) : assets.sql(200) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_CIE;
ALTER FUNCTION SP_U_ASSET_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_BKG ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_BKG', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_BKG(43) : assets.sql(259) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_BKG', 46+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_BKG(47) : assets.sql(263) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_BKG', 53+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_BKG(54) : assets.sql(270) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_BKG', 65+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_BKG(66) : assets.sql(282) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_BKG;
ALTER FUNCTION SP_U_ASSET_BKG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_CPLAN', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_CPLAN(19) : assets.sql(317) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_CPLAN', 26+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_CPLAN(27) : assets.sql(325) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_CPLAN', 38+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_CPLAN(39) : assets.sql(337) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_CPLAN;
ALTER FUNCTION SP_S_ASSET_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_ASSET ==
CREATE OR REPLACE FUNCTION SP_CKOUT_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_ASSET(22) : assets.sql(375) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(27) : assets.sql(380) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_ASSET(30) : assets.sql(383) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(36) : assets.sql(389) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_ASSET(39) : assets.sql(392) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_rec_user, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(57) : assets.sql(410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(63) : assets.sql(416) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_ASSET(66) : assets.sql(419) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id2, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(80) : assets.sql(433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 87+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(88) : assets.sql(441) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 90+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_ASSET(91) : assets.sql(444) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_OUT, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 97+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(98) : assets.sql(451) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 100+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_ASSET(101) : assets.sql(454) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_ASSET', 107+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_ASSET(108) : assets.sql(461) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_ASSET', 110+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_ASSET(111) : assets.sql(464) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id2, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES
         SET REC_STATUS = 'O',
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(133) : assets.sql(486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'O',
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(154) : assets.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_ASSET', 160+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_ASSET(161) : assets.sql(514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 167+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(168) : assets.sql(521) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_ASSET', 179+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_ASSET(180) : assets.sql(533) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_ASSET;
ALTER FUNCTION SP_CKOUT_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_ASSET ==
CREATE OR REPLACE FUNCTION SP_CKIN_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_table_type PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_converted_score NUMBER(19) := 0;
   h_depreciation_start DATE;
   h_depreciation_finish DATE;
   h_depreciation_amount NUMBER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = h_id;

      CURSOR CH1P IS
         SELECT MINOR_REVISION
         FROM HISTORY_ASSETS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = p_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_ASSET(44) : assets.sql(593) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(49) : assets.sql(598) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_ASSET(52) : assets.sql(601) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT TYPE_ID, REC_STATUS, CONVERTED_SCORE
      INTO h_type_id, h_rec_status, h_converted_score
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(74) : assets.sql(623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 79+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(80) : assets.sql(629) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 82+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_ASSET(83) : assets.sql(632) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM RESOURCES
         WHERE RESOURCE_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(97) : assets.sql(646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 104+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(105) : assets.sql(654) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 107+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_ASSET(108) : assets.sql(657) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 114+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(115) : assets.sql(664) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 117+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_ASSET(118) : assets.sql(667) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_IN, h_id, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_ASSET', 124+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_ASSET(125) : assets.sql(674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_ASSET', 127+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_ASSET(128) : assets.sql(677) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      --InitializeHost(SC_PARAM(h_bitflag), *p_bitflag, ind_ckout_asset->p_bitflag);
      h_bitflag := p_bitflag;
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 159+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(160) : assets.sql(709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(178) : assets.sql(727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(191) : assets.sql(740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 213+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(214) : assets.sql(763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(236) : assets.sql(785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 255+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(256) : assets.sql(805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES SELECT h_uniqueID, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 277+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(278) : assets.sql(827) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES
            SET REVISION_HISTORY = Null
            WHERE RESOURCE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(297) : assets.sql(846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      
      -- build depreciation columns
      h_count := 0;
      BEGIN
         SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT), COUNT(ASSET_ID)
         INTO h_depreciation_start, h_depreciation_finish, h_depreciation_amount, h_count
         FROM ASSET_DEPRECIATION
         WHERE ASSET_ID = h_id AND DEPRECIATION_DATE IS NOT NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 325+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(326) : assets.sql(875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         BEGIN
            UPDATE TMT_ASSETS
            SET DEPRECIATION_START = NULL,
            DEPRECIATION_FINISH = NULL,
            DEPRECIABLE_LIFE = CASE WHEN DEPRECIABLE_LIFE = 36 AND DEPRECIATION_METHOD = 1 THEN 36 ELSE 0 END,
            TOTAL_DEPRECIATION = 0.00
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(349) : assets.sql(898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSETS
            SET DEPRECIATION_START = h_depreciation_start,
            DEPRECIATION_FINISH = h_depreciation_finish,
            DEPRECIABLE_LIFE = (PMO_ORASTD.YEAR(h_depreciation_finish) - PMO_ORASTD.YEAR(h_depreciation_start)) * 12
            + (PMO_ORASTD.MONTH(h_depreciation_finish) - PMO_ORASTD.MONTH(h_depreciation_start) + 1),
            TOTAL_DEPRECIATION = h_depreciation_amount
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 371+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(372) : assets.sql(921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 395+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(396) : assets.sql(945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = p_id
            AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 415+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(416) : assets.sql(965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 428+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(429) : assets.sql(978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = p_id
               AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 452+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(453) : assets.sql(1002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = p_id
               AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 475+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(476) : assets.sql(1025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = p_id
               AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 495+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(496) : assets.sql(1045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_ASSETS SELECT h_uniqueID, A.* FROM TMT_ASSETS A WHERE A.ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 517+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(518) : assets.sql(1067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 536+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(537) : assets.sql(1086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_ASSETS';
         --SC_STATE = FC_D_REVISION(h_id,h_bitflag_revision,h_table_name);
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
      
      If Coalesce(h_converted_score, 0) = -1 Then
         h_table_type := PMO_CNST.SC_TABLE_AST;
         h_rec_user := p_rec_user;
         
         PMO_DB2M.SC_STATE := FC_CHECK_IN_ALL_SC(h_table_type, h_id, h_bitflag, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_ASSET', 556+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_ASSET(557) : assets.sql(1106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 563+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(564) : assets.sql(1113) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_ASSET', 575+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_ASSET(576) : assets.sql(1125) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_ASSET;
ALTER FUNCTION SP_CKIN_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_ASSET ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_ASSET', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_ASSET(20) : assets.sql(1161) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_ASSET', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_ASSET(25) : assets.sql(1166) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_ASSET', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_ASSET(28) : assets.sql(1169) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_ASSETS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(43) : assets.sql(1184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_ASSET', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_ASSET(49) : assets.sql(1190) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_ASSET', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_ASSET(52) : assets.sql(1193) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_ASSETS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_ASSETS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_ASSETS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(75) : assets.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_ASSET', 80+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_ASSET(81) : assets.sql(1222) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_ASSET', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_ASSET(84) : assets.sql(1225) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_UNDO_CHECKOUT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_ASSET', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_ASSET(90) : assets.sql(1231) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(97) : assets.sql(1238) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_ASSET', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_ASSET(109) : assets.sql(1250) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_ASSET;
ALTER FUNCTION SP_UCKOUT_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_REVISION(27) : assets.sql(1293) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_REVISION(33) : assets.sql(1299) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_REVISION(36) : assets.sql(1302) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_id), p_id, ind_u_rev->p_id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_ASSET_REVISION', 43+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_ASSET_REVISION(44) : assets.sql(1310) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_ASSETS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_REVISION', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_REVISION(71) : assets.sql(1337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_REVISION', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_REVISION(77) : assets.sql(1343) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_REVISION', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_REVISION(84) : assets.sql(1350) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_REVISION', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_REVISION(96) : assets.sql(1362) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_REVISION;
ALTER FUNCTION SP_U_ASSET_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_ASSETS)
*                           id = ELEMENT_ID in TMT_ASSETS table, select from HISTORY_ASSETS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_ASSETS table, select from HISTORY_ASSETS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_REVISION(24) : assets.sql(1411) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(29) : assets.sql(1416) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(32) : assets.sql(1419) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(53) : assets.sql(1440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(59) : assets.sql(1446) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(62) : assets.sql(1449) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, D.DESCRIPTION AS STAGE_NAME,'
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_ASSETS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID JOIN TMT_DATAFIELDS D ON D.ELEMENT_ID = T.STATUS_ID WHERE T.ELEMENT_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID
         INTO h_rank, h_level_id, h_parent_id
         FROM HISTORY_ASSETS
         WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(88) : assets.sql(1475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 93+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(94) : assets.sql(1481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(97) : assets.sql(1484) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, D.DESCRIPTION AS STAGE_NAME, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_ASSETS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID JOIN TMT_DATAFIELDS D ON D.ELEMENT_ID = T.STATUS_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, '''' AS STAGE_NAME, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''' ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(132) : assets.sql(1519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 137+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(138) : assets.sql(1525) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 140+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(141) : assets.sql(1528) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(154) : assets.sql(1541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_REVISION', 159+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_REVISION(160) : assets.sql(1547) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 162+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(163) : assets.sql(1550) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, '''' AS STAGE_NAME, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 177+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(178) : assets.sql(1565) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_REVISION', 180+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_REVISION(181) : assets.sql(1568) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 188+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(189) : assets.sql(1576) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_REVISION', 200+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_REVISION(201) : assets.sql(1588) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_REVISION;
ALTER FUNCTION SP_S_ASSET_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_ASSET ==
CREATE OR REPLACE FUNCTION SP_M_ASSET
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_target_rank VARCHAR2(200);
   h_prefix VARCHAR2(200);
   h_target_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_M_ASSET(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_ASSET', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_ASSET(43) : assets.sql(1647) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := p_target;
   h_source_id := p_source;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   h_prefix := 'AST#';
   
   If (BITAND(Coalesce(h_bitflag, 0), 4)) > 0 Then
      h_bitflag := Coalesce(h_bitflag, 0) - 4;
   End If;
   
   BEGIN
      SELECT PARENT_ID, RANK, LEVEL_ID
      INTO h_source_parent_id, h_source_rank, h_source_level
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(67) : assets.sql(1671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_target_id IS NULL) Then
      BEGIN
         SELECT PARENT_ID, RANK, LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_ASSETS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(84) : assets.sql(1688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARENT_ID, RANK,LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(100) : assets.sql(1704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      If (((h_target_parent_id IS NULL)) AND ((h_source_parent_id IS NULL))) OR (PMO_ORASTD.strcmp(
            h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH) Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_UP_ASSET(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                          , h_prefix, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_DOWN_ASSET(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                            , h_prefix, h_rec_user);
         End If;
      Else
         PMO_DB2M.SC_STATE := FC_SMP_MOVE_DIF_ASSET(h_target_level, h_source_level, h_target_rank
                                           , h_source_rank, h_target_parent_id, h_new_rank, h_prefix
                                           , h_rec_user);
         
         BEGIN
            UPDATE TMT_ASSETS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(135) : assets.sql(1739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --update source hierarchy
      If (h_source_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_ASSETS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 156+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(157) : assets.sql(1761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_target_id IS NULL) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_ASSETS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := 0;
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      Else
         PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSETS', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := Coalesce(h_target_level, 0) + 1;
         h_level_id := Coalesce(h_level_id, 0);
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      End If;
      
      h_len := Coalesce(Length(h_source_rank), 0);
      h_len := Coalesce(h_len, 0);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_source_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_source_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PARENT_RANK = 'AST#' || h_rank || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len+4 THEN ''
         ELSE SUBSTR(PARENT_RANK, h_len + 5, LENGTH(PARENT_RANK)-h_len-4) END
         WHERE PARENT_RANK LIKE 'AST#' || h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 211+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(212) : assets.sql(1816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET LEVEL_ID = LEVEL_ID + h_level_id - h_source_level,
         RANK = h_rank || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len + 1, LENGTH(RANK)-h_len) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 237+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(238) : assets.sql(1842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_ASSET', 248+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_ASSET(249) : assets.sql(1853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 255+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(256) : assets.sql(1860) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_ASSET', 267+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_ASSET(268) : assets.sql(1872) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_ASSET;
ALTER FUNCTION SP_M_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_NAME ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_NAME', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_NAME(26) : assets.sql(1914) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_NAME', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_NAME(34) : assets.sql(1922) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_NAME', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_NAME(37) : assets.sql(1925) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT TYPE_ID INTO h_type_id
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(56) : assets.sql(1944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_NAME', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_NAME(63) : assets.sql(1951) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_NAME', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_NAME(66) : assets.sql(1954) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_AST;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(87) : assets.sql(1975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
      BEGIN
         UPDATE TMT_CHARGECODES
         SET ELEMENT_NAME = h_name
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(107) : assets.sql(1995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET ASSET_NAME = h_name
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSETS
         WHERE PARENT_ID = h_id AND TYPE_ID NOT IN (PMO_CNST.SC_ASSETS, PMO_CNST.SC_FOLDER));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(127) : assets.sql(2015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CRI
         SET ASSET_NAME = h_name
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSETS
         WHERE PARENT_ID = h_id AND TYPE_ID NOT IN (PMO_CNST.SC_ASSETS, PMO_CNST.SC_FOLDER));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 146+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(147) : assets.sql(2035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_AST_DOC(h_host_table, h_id, h_name, h_rec_user, h_error_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_NAME', 155+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_NAME(156) : assets.sql(2044) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 162+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(163) : assets.sql(2051) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_NAME', 174+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_NAME(175) : assets.sql(2063) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_NAME;
ALTER FUNCTION SP_U_ASSET_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_ASSET_DOC ==
CREATE OR REPLACE FUNCTION FC_I_ASSET_DOC
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rankBase64 VARCHAR2(8);
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ASSET_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ASSET_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ASSET_DOC(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ASSET_DOC(21) : assets.sql(2100) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_ASSET_DOCUMENTS
      (ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      REC_USER, RANK, PARENT_RANK)
      VALUES
      (h_uniqueID, h_uniqueID, h_name, PMO_CNST.SC_CUSTOM_FOLDER, 0,
      h_rec_user, h_rankBase64, 'AST#' || h_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET_DOC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET_DOC(46) : assets.sql(2125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET_DOC', 51+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ASSET_DOC(52) : assets.sql(2131) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ASSET_DOC;
ALTER FUNCTION FC_I_ASSET_DOC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_ASSET ==
CREATE OR REPLACE FUNCTION FC_I_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_I_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_ASSET(33) : assets.sql(2174) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate parent_id
   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_ASSETS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1
         INTO h_rank, h_level_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(55) : assets.sql(2196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_ASSETS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
         TYPE_ID, LEVEL_ID, REC_USER, CREATED_BY, DEPRECIABLE_LIFE, DATE_ACQUIRED)
         VALUES(h_rank, h_parent_id, h_element_id, h_name,
         h_type_id, h_level_id, h_rec_user, h_rec_user, 36, TO_DATE(SYSDATE));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(75) : assets.sql(2216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSETS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1
         INTO h_rank, h_level_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(95) : assets.sql(2236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_ASSETS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
         TYPE_ID, LEVEL_ID, REC_USER, CREATED_BY, DEPRECIABLE_LIFE, DATE_ACQUIRED)
         VALUES (h_rank, h_parent_id, h_element_id, h_name,
         h_type_id, h_level_id, h_rec_user, h_rec_user, 36, TO_DATE(SYSDATE));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(115) : assets.sql(2256) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_table_type, 0) <> PMO_CNST.SC_TABLE_AST Then
      BEGIN
         UPDATE TMT_ASSETS
         SET CHILD_COUNT = CHILD_COUNT -1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(136) : assets.sql(2277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
         h_temp_sc_state := FC_I_ASSET_DOC(h_name, h_element_id, h_rank, h_rec_user);
      End If;
      
      h_rate_id := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_ASSETS
         SELECT h_rate_id, A.*
         FROM TMT_ASSETS A
         WHERE A.ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 161+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(162) : assets.sql(2303) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_ASSETS
         SET REC_STATUS = 'U'
         WHERE HISTORY_ID = h_rate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(181) : assets.sql(2322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSETS
         SET REVISION_HISTORY = Null
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_ASSET', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_ASSET(200) : assets.sql(2341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_ASSET', 206+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_ASSET(207) : assets.sql(2348) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_ASSET;
ALTER FUNCTION FC_I_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_ASSET ==
CREATE OR REPLACE FUNCTION SP_I_ASSET
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_local VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ASSET(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ASSET(34) : assets.sql(2392) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   h_table_type := PMO_CNST.SC_TABLE_AST;
   
   h_uniqueID := SYS_GUID();
   PMO_DB2M.SC_STATE := FC_I_ASSET(h_table_type, h_uniqueID, h_name, h_parent_id, h_type_id
                                , h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ASSET', 49+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ASSET(50) : assets.sql(2408) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET', 56+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET(57) : assets.sql(2415) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET', 68+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET(69) : assets.sql(2427) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ASSET;
ALTER FUNCTION SP_I_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_MERGE_ASSET ==
CREATE OR REPLACE FUNCTION FC_MERGE_ASSET
(
     h_target IN OUT NOCOPY VARCHAR2
   , h_source IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MERGE_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MERGE_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_MERGE_ASSET(' || 
       '''' || h_target || ''''
          || ', ' || '''' || h_source || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_ASSET', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MERGE_ASSET(20) : assets.sql(2463) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   --validate source
   BEGIN
      SELECT ELEMENT_NAME INTO h_name
      FROM TMT_ASSETS WHERE ELEMENT_ID = h_source;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(35) : assets.sql(2478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_MERGE_ASSET', 41+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_MERGE_ASSET(42) : assets.sql(2485) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_source || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_ASSET', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_ASSET(45) : assets.sql(2488) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_source, False);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_NAME = h_name,
      ELEMENT_ID   = h_source,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_target;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(68) : assets.sql(2511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'FC_MERGE_ASSET', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: FC_MERGE_ASSET(74) : assets.sql(2517) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_target || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_target, False);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(81) : assets.sql(2524) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_ASSET', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_ASSET(93) : assets.sql(2536) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_MERGE_ASSET;
ALTER FUNCTION FC_MERGE_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_MERGE_ASSET ==
CREATE OR REPLACE FUNCTION SP_MERGE_ASSET
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target VARCHAR2(32);
   h_source VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_MERGE_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_MERGE_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_MERGE_ASSET(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_ASSET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_MERGE_ASSET(22) : assets.sql(2574) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   h_target := p_target;
   h_source := p_source;
   h_rec_user := p_rec_user;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_ASSET', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_MERGE_ASSET(32) : assets.sql(2584) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN FC_MERGE_ASSET(h_target, h_source, h_rec_user);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_ASSET', 39+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_ASSET(40) : assets.sql(2592) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_ASSET', 51+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_ASSET(52) : assets.sql(2604) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_MERGE_ASSET;
ALTER FUNCTION SP_MERGE_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_ROLLUP_ASSET ==
CREATE OR REPLACE FUNCTION FC_ROLLUP_ASSET RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_prev_parent_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_SD PLS_INTEGER := 0;
   h_FD PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ROLLUP_ASSET IS
         SELECT TA.ELEMENT_ID, TA.PARENT_ID, TA.TYPE_ID, TA.REC_STATUS
         FROM TMT_ASSETS TA, PMO_ASSET_VIEW T
         WHERE TA.PARENT_ID = T.ASSET_ID
         AND T.TYPE_ID = PMO_CNST.SC_ASSETS
         AND TA.REC_STATUS IN ('I', 'U', 'D', 'O')
         AND TA.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
         ORDER BY TA.PARENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ROLLUP_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ROLLUP_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_ROLLUP_ASSET();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_ASSET', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ROLLUP_ASSET(29) : assets.sql(2649) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_prev_parent_id := 'YY';
   
   OPEN C_ROLLUP_ASSET;
   
   LOOP
      FETCH C_ROLLUP_ASSET INTO h_id, h_parent_id, h_type_id, h_rec_status;
      IF C_ROLLUP_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') = 0 Then
         h_prev_parent_id := h_parent_id;
      ElsIf PMO_ORASTD.strcmp(h_prev_parent_id, h_parent_id) <> 0 Then
         h_count := 0;
         BEGIN
            SELECT MIN(ACTIVITY_START), MAX(ACTIVITY_FINISH), COUNT(PARENT_ID)
            INTO h_start_date, h_finish_date, h_count
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id
            AND TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 65+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(66) : assets.sql(2686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) Then
            BEGIN
               UPDATE TMT_ASSETS
               SET ACTIVITY_START = NuLL,
               SD = 0,
               ACTIVITY_FINISH = NuLL,
               FD = 0,
               CAPITAL_SCHED_COST = 0.00,
               CAPITAL_ACTUAL_COST = 0.00,
               CAPITAL_COST_ETC = 0.00,
               EXPENSE_SCHED_COST = 0.00,
               EXPENSE_ACTUAL_COST = 0.00,
               EXPENSE_COST_ETC = 0.00,
               CAPITAL_SCHED_HOURS = 0,
               CAPITAL_ACTUAL_HOURS = 0,
               CAPITAL_HOURS_ETC = 0,
               EXPENSE_SCHED_HOURS = 0,
               EXPENSE_ACTUAL_HOURS = 0,
               EXPENSE_HOURS_ETC = 0
               WHERE ELEMENT_ID = h_prev_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 100+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(101) : assets.sql(2721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT MAX(SD) INTO h_SD
               FROM TMT_ASSETS
               WHERE PARENT_ID = h_prev_parent_id
               AND ACTIVITY_START = h_start_date;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 116+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(117) : assets.sql(2737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT MAX(FD) INTO h_FD
               FROM TMT_ASSETS
               WHERE PARENT_ID = h_prev_parent_id
               AND ACTIVITY_FINISH = h_finish_date;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 132+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(133) : assets.sql(2753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            /*          BEGIN_SQL
                            UPDATE TMT_ASSETS
                            SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
                                CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
                                EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
                                CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
                                EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
                                (SELECT MIN(ACTIVITY_START), COALESCE(MAX(SD), 0), MAX(ACTIVITY_FINISH), COALESCE(MAX(FD), 0),
                                    COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
                                    COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
                                    COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
                                    COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
                                FROM TMT_ASSETS
                                WHERE PARENT_ID = HOST(h_prev_parent_id))
                            WHERE ELEMENT_ID = HOST(h_prev_parent_id);
                        END_SQL_NOCHECK;
            */
            BEGIN
               UPDATE TMT_ASSETS
               SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
               CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
               EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
               CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
               EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
               (SELECT h_start_date, h_SD, h_finish_date, h_FD,
               COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
               COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
               COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
               COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
               FROM TMT_ASSETS
               WHERE PARENT_ID = h_prev_parent_id)
               WHERE ELEMENT_ID = h_prev_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 179+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(180) : assets.sql(2800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_prev_parent_id := h_parent_id;
      End If;
      
      If PMO_ORASTD.strncmp(h_rec_status, 'D', 1) = 0 Then
         BEGIN
            DELETE FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 202+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(203) : assets.sql(2823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSETS
            SET (CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC) =
            (SELECT COALESCE(SUM(B.BUDGET), 0.00), COALESCE(SUM(B.ACTUAL), 0.00), COALESCE(SUM(ETC), 0.00)
            FROM BUDGETS B, TMT_CHARGECODES C
            WHERE B.ELEMENT_ID = h_id
            AND B.CHARGECODE_ID = C.ELEMENT_ID
            AND C.CAPITAL_EXPENSE IN (PMO_CNST.SC_CAPITAL, PMO_CNST.SC_CAPITAL_LABOR))
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 226+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(227) : assets.sql(2847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC) =
            (SELECT COALESCE(SUM(B.BUDGET), 0.00), COALESCE(SUM(B.ACTUAL), 0.00), COALESCE(SUM(ETC), 0.00)
            FROM BUDGETS B, TMT_CHARGECODES C
            WHERE B.ELEMENT_ID = h_id
            AND B.CHARGECODE_ID = C.ELEMENT_ID
            AND C.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_EXPENSE_LABOR))
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 250+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(251) : assets.sql(2871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC) =
            (SELECT COALESCE(SUM(B.BUDGET * 60), 0), COALESCE(SUM(B.ACTUAL * 60), 0), COALESCE(SUM(ETC * 60), 0)
            FROM BUDGETS B
            WHERE B.ELEMENT_ID = h_id
            AND B.CHARGECODE_ID = 'CAPITAL_HOURS')
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 273+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(274) : assets.sql(2894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
            (SELECT COALESCE(SUM(B.BUDGET * 60), 0), COALESCE(SUM(B.ACTUAL * 60), 0), COALESCE(SUM(ETC * 60), 0)
            FROM BUDGETS B
            WHERE B.ELEMENT_ID = h_id
            AND B.CHARGECODE_ID = 'EXPENSE_HOURS')
            WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(297) : assets.sql(2917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If isWBSType(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE TMT_ASSETS
               SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, REC_STATUS) =
               (SELECT TO_DATE(SubStr(START_DT, 1, 10)), SD, TO_DATE(SubStr(FINISH_DT, 1, 10)), FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, 'X'
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_id)
               WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 321+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(322) : assets.sql(2942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_ASSETS
               SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, REC_STATUS) =
               (SELECT TO_DATE(SubStr(START_DATETIME, 1, 10)), SD, TO_DATE(SubStr(FINISH_DATETIME, 1, 10)), FD, FINANCIAL_CATEGORY,
               ELEMENT_NAME, TYPE_ID, 'X'
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_id)
               WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 345+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(346) : assets.sql(2966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_ROLLUP_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 360+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(361) : assets.sql(2981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') <> 0 Then
      h_count := 0;
      BEGIN
         SELECT MIN(ACTIVITY_START), MAX(ACTIVITY_FINISH), COUNT(PARENT_ID)
         INTO h_start_date, h_finish_date, h_count
         FROM TMT_ASSETS
         WHERE PARENT_ID = h_prev_parent_id
         AND TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 379+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(380) : assets.sql(3000) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) Then
         BEGIN
            UPDATE TMT_ASSETS
            SET ACTIVITY_START = NuLL,
            SD = 0,
            ACTIVITY_FINISH = NuLL,
            FD = 0,
            CAPITAL_SCHED_COST = 0.00,
            CAPITAL_ACTUAL_COST = 0.00,
            CAPITAL_COST_ETC = 0.00,
            EXPENSE_SCHED_COST = 0.00,
            EXPENSE_ACTUAL_COST = 0.00,
            EXPENSE_COST_ETC = 0.00,
            CAPITAL_SCHED_HOURS = 0,
            CAPITAL_ACTUAL_HOURS = 0,
            CAPITAL_HOURS_ETC = 0,
            EXPENSE_SCHED_HOURS = 0,
            EXPENSE_ACTUAL_HOURS = 0,
            EXPENSE_HOURS_ETC = 0
            WHERE ELEMENT_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 414+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(415) : assets.sql(3035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT MAX(SD) INTO h_SD
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id
            AND ACTIVITY_START = h_start_date;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 430+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(431) : assets.sql(3051) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT MAX(FD) INTO h_FD
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id
            AND ACTIVITY_FINISH = h_finish_date;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 446+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(447) : assets.sql(3067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         /*      BEGIN_SQL
                     UPDATE TMT_ASSETS
                     SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
                         CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
                         EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
                         CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
                         EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
                         (SELECT MIN(ACTIVITY_START), COALESCE(MAX(SD), 0), MAX(ACTIVITY_FINISH), COALESCE(MAX(FD), 0),
                             COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
                             COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
                             COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
                             COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
                         FROM TMT_ASSETS
                         WHERE PARENT_ID = HOST(h_prev_parent_id))
                     WHERE ELEMENT_ID = HOST(h_prev_parent_id);
                 END_SQL_NOCHECK;
         */
         
         BEGIN
            UPDATE TMT_ASSETS
            SET (ACTIVITY_START, SD, ACTIVITY_FINISH, FD,
            CAPITAL_SCHED_COST, CAPITAL_ACTUAL_COST, CAPITAL_COST_ETC,
            EXPENSE_SCHED_COST, EXPENSE_ACTUAL_COST, EXPENSE_COST_ETC,
            CAPITAL_SCHED_HOURS, CAPITAL_ACTUAL_HOURS, CAPITAL_HOURS_ETC,
            EXPENSE_SCHED_HOURS, EXPENSE_ACTUAL_HOURS, EXPENSE_HOURS_ETC) =
            (SELECT h_start_date, h_SD, h_finish_date, h_FD,
            COALESCE(SUM(CAPITAL_SCHED_COST), 0), COALESCE(SUM(CAPITAL_ACTUAL_COST), 0), COALESCE(SUM(CAPITAL_COST_ETC), 0),
            COALESCE(SUM(EXPENSE_SCHED_COST), 0), COALESCE(SUM(EXPENSE_ACTUAL_COST), 0), COALESCE(SUM(EXPENSE_COST_ETC), 0),
            COALESCE(SUM(CAPITAL_SCHED_HOURS), 0), COALESCE(SUM(CAPITAL_ACTUAL_HOURS), 0), COALESCE(SUM(CAPITAL_HOURS_ETC),0 ),
            COALESCE(SUM(EXPENSE_SCHED_HOURS), 0), COALESCE(SUM(EXPENSE_ACTUAL_HOURS), 0), COALESCE(SUM(EXPENSE_HOURS_ETC), 0)
            FROM TMT_ASSETS
            WHERE PARENT_ID = h_prev_parent_id)
            WHERE ELEMENT_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_ASSET', 494+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_ASSET(495) : assets.sql(3115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_ASSET', 502+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ROLLUP_ASSET(503) : assets.sql(3123) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ROLLUP_ASSET;
ALTER FUNCTION FC_ROLLUP_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET ==
CREATE OR REPLACE FUNCTION SP_S_ASSET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672A PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET(24) : assets.sql(3157) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If (h_id IS NULL) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE T.PARENT_ID IS NULL AND T.RANK <> '0000';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(51) : assets.sql(3184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE ( T.PARENT_ID = h_id OR T.ELEMENT_ID = h_id )
         AND T.RANK <> '0000';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(72) : assets.sql(3205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   OPEN C66672A FOR SELECT
   T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME,
   T.DOC_COUNT, T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
   T.REVISION_HISTORY, T.CATEGORY_ID, T.STATUS_ID, T.MAKE, T.MODEL, T.QUANTITY,
   T.QUANTITY_USED, T.QUANTITY-QUANTITY_USED AS QUANTITY_REM, T.MODEL_NUMBER,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.DATE_ACQUIRED, T.DATE_SOLD, T.PURCHASE_PRICE,
   T.DEPRECIATION_METHOD, T.DEPRECIATION_START, T.DEPRECIATION_FINISH,
   T.DEPRECIABLE_LIFE,
   T.SALVAGE_VALUE, T.CAPITAL_VALUE, T.CURRENT_VALUE, T.NEXT_SCHED_MAINT,
   T.DESCRIPTION, T.TOTAL_MAINTENANCE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0) AS TOTAL_DEPRECIATION,
   T.RTF_BITS, T.LICENCE_EXPIRY_DATE, T.WARRANTY_EXPIRY_DATE,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   T.ACTIVITY_START, T.ACTIVITY_FINISH, T.SD, T.FD,
   T.CAPITAL_SCHED_HOURS, T.CAPITAL_SCHED_COST,
   T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_ACTUAL_COST,
   T.CAPITAL_HOURS_ETC, T.CAPITAL_COST_ETC,
   T.EXPENSE_SCHED_HOURS, T.EXPENSE_SCHED_COST,
   T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_ACTUAL_COST,
   T.EXPENSE_HOURS_ETC, T.EXPENSE_COST_ETC
   FROM PMO_ASSET_VIEW V, TMT_ASSETS T, RESOURCES R
   WHERE T.ELEMENT_ID = V.ASSET_ID
   AND R.RESOURCE_ID = T.REC_USER
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET', 106+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET(107) : assets.sql(3240) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66672A;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 115+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(116) : assets.sql(3249) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET', 127+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET(128) : assets.sql(3261) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET;
ALTER FUNCTION SP_S_ASSET COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_CLEANS_AST_BY_NAME ==
CREATE OR REPLACE FUNCTION FC_CLEANS_AST_BY_NAME
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_model VARCHAR2(255);
   h_model_number VARCHAR2(255);
   h_serial_number VARCHAR2(255);
   h_contractor VARCHAR2(255);
   h_approved PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR all_ast_curs IS
         SELECT V.ASSET_ID, A.ELEMENT_NAME, A.MODEL, A.MODEL_NUMBER, A.SERIAL_NUMBER, A.CONTACTOR
         FROM PMO_ASSET_VIEW V, TMT_ASSETS A
         WHERE V.ASSET_ID = A.ELEMENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_AST_BY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_AST_BY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_AST_BY_NAME(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_AST_BY_NAME', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_AST_BY_NAME(27) : assets.sql(3304) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_ast_curs;
   
   LOOP
      h_element_name := NULL;
      h_model := NULL;
      h_model_number := NULL;
      h_serial_number := NULL;
      h_contractor := NULL;
      
      FETCH all_ast_curs
      INTO h_element_id, h_element_name, h_model, h_model_number, h_serial_number, h_contractor;
      IF all_ast_curs
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         If FC_FIND_KEYWORD(h_model, h_search_option) = 0 Then
            If FC_FIND_KEYWORD(h_model_number, h_search_option) = 0 Then
               If FC_FIND_KEYWORD(h_serial_number, h_search_option) = 0 Then
                  If FC_FIND_KEYWORD(h_contractor, h_search_option) = 0 Then
                     h_approved := 0;
                  End If;
               End If;
            End If;
         End If;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_ASSET_VIEW
            WHERE ASSET_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_AST_BY_NAME', 81+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_AST_BY_NAME(82) : assets.sql(3359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_ast_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_AST_BY_NAME', 96+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_AST_BY_NAME(97) : assets.sql(3374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_AST_BY_NAME', 103+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_AST_BY_NAME(104) : assets.sql(3381) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_AST_BY_NAME;
ALTER FUNCTION FC_CLEANS_AST_BY_NAME COMPILE DEBUG;

/************************************************************
format for p_given_date:
    {date_option(first character)}[start_date],[finish_date]

date_option                 meaning
--------------------------------------------------------
1   SC_DATE_ACQUIRED                            Date Acquired
2   SC_DATE_SOLD                                Sold Date
3   SC_DEPRECIATION_DATE                        Depreciation Date
4   SC_WARRANTY_EXPIRY_DATE                     Warranty Expiry Date
5   SC_LICENCE_EXPIRY_DATE                      Licence Expiry Date
6   SC_NEXT_SCHED_MAINT                         Next Scheduled Maintenance

bitflag:
0   normal select
5   refresh node (SC_REFRESH)
6   assigned elements (wbs and cri) (SC_ASSIGNED_CHILD)

************************************************************/

Prompt == FUNCTION SP_ASSET_VIEW ==
CREATE OR REPLACE FUNCTION SP_ASSET_VIEW
(
     p_id VARCHAR2
   , p_keywords VARCHAR2
   , p_attribute_ids VARCHAR2
   , p_status_ids VARCHAR2
   , p_category_ids VARCHAR2
   , p_location_ids VARCHAR2
   , p_organization_ids VARCHAR2
   , p_user_ids VARCHAR2
   , p_given_date VARCHAR2
   , p_and_or_flag PLS_INTEGER
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_str VARCHAR2(49);
   h_id VARCHAR2(32);
   h_keywords VARCHAR2(8000);
   h_attribute_ids VARCHAR2(8000);
   h_status_ids VARCHAR2(8000);
   h_category_ids VARCHAR2(8000);
   h_location_ids VARCHAR2(8000);
   h_organization_ids VARCHAR2(8000);
   h_user_ids VARCHAR2(8000);
   h_given_date VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_date_option_str VARCHAR2(1);
   h_start_date DATE;
   h_finish_date DATE;
   h_pos PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_with_search PLS_INTEGER := 0;
   h_search_by_name_condition VARCHAR2(8000);
   h_search_by_status_condition VARCHAR2(8000);
   h_search_by_category_condition VARCHAR2(8000);
   h_search_by_date_condition VARCHAR2(255);
   h_search_by_location_condition VARCHAR2(8000);
   h_search_by_org_condition VARCHAR2(8000);
   h_search_by_user_condition VARCHAR2(8000);
   h_search_by_attr_condition VARCHAR2(8000);
   h_logical_operator VARCHAR2(255);
   h_fieldName VARCHAR2(255);
   h_search_option PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_number_of_attributes PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CAchild PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66672B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_VIEW(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_keywords || ''''
          || ', ' || '''' || p_attribute_ids || ''''
          || ', ' || '''' || p_status_ids || ''''
          || ', ' || '''' || p_category_ids || ''''
          || ', ' || '''' || p_location_ids || ''''
          || ', ' || '''' || p_organization_ids || ''''
          || ', ' || '''' || p_user_ids || ''''
          || ', ' || '''' || p_given_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_and_or_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_VIEW', 76+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_VIEW(77) : assets.sql(3486) : ' || SYSTIMESTAMP);
   END IF; 

   h_with_search := 0;
   h_id := '';
   h_keywords := '';
   h_attribute_ids := '';
   h_status_ids := '';
   h_category_ids := '';
   h_location_ids := '';
   h_organization_ids := '';
   h_user_ids := '';
   h_given_date := '';
   h_rec_user := '';
   h_bitflag := 0;
   h_date_option_str := '';
   
   h_search_option := 0;
   h_temp_sc_state := 0;
   h_search_by_name_condition := '';
   h_search_by_status_condition := '';
   h_search_by_category_condition := '';
   h_search_by_location_condition := '';
   h_search_by_org_condition := '';
   h_search_by_user_condition := '';
   h_search_by_date_condition := '';
   h_search_by_attr_condition := '';
   
   h_logical_operator := ' AND ';
   
   h_fieldName := '';
   
   h_start_date := '';
   h_finish_date := '';
   h_pos := 0;
   
   h_id := p_id;
   h_keywords := p_keywords;
   h_attribute_ids := p_attribute_ids;
   h_status_ids := p_status_ids;
   h_category_ids := p_category_ids;
   h_location_ids := p_location_ids;
   h_organization_ids := p_organization_ids;
   h_user_ids := p_user_ids;
   h_given_date := p_given_date;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      -- build search by name or attribute name condition
      h_search_by_name_condition := '';
      If (h_keywords IS NOT NULL) Then
         h_fieldName := 'A.ELEMENT_NAME(C),A.MODEL(C),A.MODEL_NUMBER(C),A.SERIAL_NUMBER(C),A.CONTACTOR(C)';
         h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
         
         If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
            h_keywords := NULL;
            
            null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_AST, h_search_by_name_condition
                                    , h_attribute_ids, h_number_of_attributes);
            
            If Coalesce(h_number_of_attributes, 0) = 0 Then
               h_number_of_attributes := 1;
               h_attribute_ids := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
            End If;
            h_search_by_name_condition := NULL;
         Else
            If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
               h_keywords := NULL;
               h_search_by_name_condition := NULL;
            Else
               h_keywords := h_search_by_name_condition;
            End If;
         End If;
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_name_condition:%s \n", h_search_by_name_condition);
      End If;
      
      -- filter by status_id
      If (h_status_ids IS NOT NULL) Then
         h_search_by_status_condition := SubStr(' (A.STATUS_ID IN (', 1, 8000);
         h_search_by_status_condition := SubStr(h_search_by_status_condition || h_status_ids, 1, 8000);
         h_search_by_status_condition := SubStr(h_search_by_status_condition || ') AND A.TYPE_ID <> 64) '
                                                                       , 1, 8000);
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_status_condition:%s \n", h_search_by_status_condition);
      End If;
      
      -- filter by category_id
      If (h_category_ids IS NOT NULL) Then
         h_search_by_category_condition := SubStr(' (A.CATEGORY_ID IN (', 1, 8000);
         h_search_by_category_condition := SubStr(h_search_by_category_condition || h_category_ids, 1, 8000);
         h_search_by_category_condition := SubStr(h_search_by_category_condition || ') AND A.TYPE_ID <> 64) '
                                                                           , 1, 8000);
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_category_condition:%s \n", h_search_by_category_condition);
      End If;
      
      -- filter by date
      If (h_given_date IS NOT NULL) Then
         h_start_date := NULL;
         h_finish_date := NULL;
         
         BEGIN
            SELECT SUBSTR(h_given_date, 1, 1), SUBSTR(h_given_date, 2, LENGTH(h_given_date)-1)
            INTO h_date_option_str, h_given_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 198+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(199) : assets.sql(3608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT PMO_ORASTD.LOCATE(',', h_given_date)
            INTO h_pos
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(214) : assets.sql(3623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT substr(h_given_date, 1, h_pos-1), substr(h_given_date, h_pos + 1, length(h_given_date) - h_pos)
            INTO h_start_date, h_finish_date
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(229) : assets.sql(3638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_DATE_ACQUIRED, 1) = 0 Then
            h_fieldName := SubStr(' A.DATE_ACQUIRED ', 1, 255);
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_NEXT_SCHED_MAINT, 1) = 0 Then
            h_fieldName := SubStr(' A.NEXT_SCHED_MAINT ', 1, 255);
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_DEPRECIATION_DATE, 1) = 0 Then
            h_fieldName := SubStr(' A.DEPRECIATION_START ', 1, 255);
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_LICENCE_EXPIRY_DATE, 1) = 0 Then
            h_fieldName := SubStr(' A.LICENCE_EXPIRY_DATE ', 1, 255);
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_WARRANTY_EXPIRY_DATE, 1) = 0 Then
            h_fieldName := SubStr(' A.WARRANTY_EXPIRY_DATE ', 1, 255);
         ElsIf PMO_ORASTD.strncmp(h_date_option_str, PMO_CNST.SC_DATE_SOLD, 1) = 0 Then
            h_fieldName := SubStr(' A.DATE_SOLD ', 1, 255);
         End If;
         
         If (Coalesce(Length(h_start_date), 0) > 0) AND (Coalesce(Length(h_finish_date), 0) > 0) Then
            h_search_by_date_condition := SubStr(' (', 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_fieldName, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ' >= PMO_ORASTD.DB2DATE('''
                                                                   , 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_start_date, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ''') AND ', 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_fieldName, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ' <= PMO_ORASTD.DB2DATE('''
                                                                   , 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_finish_date, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ''')) ', 1, 255);
         ElsIf (Coalesce(Length(h_start_date), 0) = 0) AND (Coalesce(Length(h_finish_date), 0) > 0) Then
            h_search_by_date_condition := SubStr(' (', 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_fieldName, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ' <= PMO_ORASTD.DB2DATE('''
                                                                   , 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_finish_date, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ''')) ', 1, 255);
         ElsIf (Coalesce(Length(h_start_date), 0) > 0) AND (Coalesce(Length(h_finish_date), 0) = 0) Then
            h_search_by_date_condition := SubStr(' (', 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_fieldName, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ' >= PMO_ORASTD.DB2DATE('''
                                                                   , 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || h_start_date, 1, 255);
            h_search_by_date_condition := SubStr(h_search_by_date_condition || ''')) ', 1, 255);
         End If;
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_date_condition:%s \n", h_search_by_date_condition);
      End If;
      
      -- filter by location
      h_search_by_location_condition := NULL;
      If (h_location_ids IS NOT NULL) Then
         h_search_by_location_condition := SubStr(
                                         ' JOIN TMT_GEOGRAPHIES G ON A.ELEMENT_ID = G.ELEMENT_ID AND G.PARENT_ID IN ('
                                         , 1, 8000);
         h_search_by_location_condition := SubStr(h_search_by_location_condition || h_location_ids, 1, 8000);
         h_search_by_location_condition := SubStr(h_search_by_location_condition || ') ', 1, 8000);
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_location_condition:%s \n", h_search_by_location_condition);
      End If;
      
      -- filter by organizations
      If (h_organization_ids IS NOT NULL) Then
         h_search_by_org_condition := SubStr(' JOIN ASSET_ORGANIZATIONS org ON A.ELEMENT_ID = org.ASSET_ID '
                                    , 1, 8000);
         h_search_by_org_condition := SubStr(h_search_by_org_condition || ' AND org.ORGANIZATION_ID IN ('
                                                                 , 1, 8000);
         h_search_by_org_condition := SubStr(h_search_by_org_condition || h_organization_ids, 1, 8000);
         h_search_by_org_condition := SubStr(h_search_by_org_condition || ') ', 1, 8000);
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_org_condition:%s \n", h_search_by_org_condition);
      End If;
      
      -- filter by users
      If (h_user_ids IS NOT NULL) Then
         h_search_by_user_condition := SubStr(' JOIN ASSET_RESOURCES res ON A.ELEMENT_ID = res.ASSET_ID '
                                     , 1, 8000);
         h_search_by_user_condition := SubStr(h_search_by_user_condition || ' AND RES.RESOURCE_ID IN ('
                                                                   , 1, 8000);
         h_search_by_user_condition := SubStr(h_search_by_user_condition || h_user_ids, 1, 8000);
         h_search_by_user_condition := SubStr(h_search_by_user_condition || ') ', 1, 8000);
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         --trace_printf(" h_search_by_user_condition:%s \n", h_search_by_user_condition);
      End If;
      
      -- filter by attribute
      If (h_attribute_ids IS NOT NULL) Then
         h_number_of_attributes := 1;
         
         h_search_by_attr_condition := SubStr(' DELETE FROM PMO_ASSET_VIEW A ', 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || 
                                                                   ' WHERE (SELECT COUNT(DISTINCT(PA.ELEMENT_ID)) '
                                                                   , 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || 
                                                                   '    FROM TMT_ASSET_ATTRIBUTES PA, TMT_ASSET_ATTRIBUTES CA '
                                                                   , 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || 
                                                                   '    WHERE CA.ELEMENT_ID = A.ASSET_ID '
                                                                   , 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || '        AND PA.ELEMENT_ID IN ('
                                                                   , 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || h_attribute_ids, 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || ') ', 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || 
                                                                   '        AND SUBSTR(CA.RANK, 1, CASE WHEN LENGTH(CA.RANK) < LENGTH(PA.RANK) THEN 1 ELSE LENGTH(PA.RANK) END) = PA.RANK '
                                                                   , 1, 8000);
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || '    ) < ', 1, 8000);
         
         h_temp_str := TO_CHAR(Coalesce(h_number_of_attributes, 0));
         h_search_by_attr_condition := SubStr(h_search_by_attr_condition || h_temp_str, 1, 8000);
         
         h_with_search := (PMO_FUNC.BIT_OR(Coalesce(h_with_search, 0), 1));
         
         --trace_printf(" h_search_by_attr_condition, :%s \n", (char *)h_search_by_attr_condition);
      End If;
      
      If Coalesce(h_with_search, 0) = 0 Then
         If (h_id IS NULL) Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID)
               SELECT A.ELEMENT_ID, A.TYPE_ID, A.LEVEL_ID
               FROM TMT_ASSETS A
               WHERE A.PARENT_ID IS NULL
               AND A.RANK <> '0000';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 369+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(370) : assets.sql(3779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID)
               SELECT A.ELEMENT_ID, A.TYPE_ID, A.LEVEL_ID
               FROM TMT_ASSETS A
               WHERE A.PARENT_ID = h_id
               AND A.RANK <> '0000'
               AND TYPE_ID IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 391+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(392) : assets.sql(3801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_id IS NULL) Then
            h_sql := ' INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID) ';
            h_sql := h_sql || ' SELECT A.ELEMENT_ID, A.TYPE_ID, 0 AS LEVEL_ID ';
            h_sql := h_sql || ' FROM TMT_ASSETS A ';
            
            If Coalesce(Length(h_search_by_location_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_location_condition;
            End If;
            
            If Coalesce(Length(h_search_by_org_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_org_condition;
            End If;
            
            If Coalesce(Length(h_search_by_user_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_user_condition;
            End If;
            
            h_sql := h_sql || ' WHERE A.RANK <> ''0000'' ';
            h_sql := h_sql || ' AND A.TYPE_ID = ';
            h_sql := h_sql || TO_CHAR(PMO_CNST.SC_ASSETS);
            
            If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_name_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_status_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_status_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_category_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_category_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_date_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_date_condition;
               h_sql := h_sql || ') ';
            End If;
         Else
            BEGIN
               SELECT A.RANK, A.LEVEL_ID
               INTO h_rank, h_level_id
               FROM TMT_ASSETS A
               WHERE A.ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 457+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(458) : assets.sql(3867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_sql := ' INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID) ';
            h_sql := h_sql || ' SELECT A.ELEMENT_ID, A.TYPE_ID, ';
            h_sql := h_sql || TO_CHAR(Coalesce(h_level_id, 0) + 1);
            h_sql := h_sql || ' AS LEVEL_ID ';
            h_sql := h_sql || ' FROM TMT_ASSETS A ';
            
            If Coalesce(Length(h_search_by_location_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_location_condition;
            End If;
            
            If Coalesce(Length(h_search_by_org_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_org_condition;
            End If;
            
            If Coalesce(Length(h_search_by_user_condition), 0) > 0 Then
               h_sql := h_sql || h_search_by_user_condition;
            End If;
            
            h_sql := h_sql || ' WHERE substr(RANK, 1, case when length(RANK) > length (''';
            h_sql := h_sql || h_rank;
            h_sql := h_sql || ''') then length (''';
            h_sql := h_sql || h_rank;
            h_sql := h_sql || ''') else 1 end) = ''';
            h_sql := h_sql || h_rank;
            h_sql := h_sql || '''';
            h_sql := h_sql || ' AND A.TYPE_ID = ';
            h_sql := h_sql || TO_CHAR(PMO_CNST.SC_ASSETS);
            
            If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_name_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_status_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_status_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_category_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_category_condition;
               h_sql := h_sql || ') ';
            End If;
            
            If Coalesce(Length(h_search_by_date_condition), 0) > 0 Then
               h_sql := h_sql || h_logical_operator;
               h_sql := h_sql || '(';
               h_sql := h_sql || h_search_by_date_condition;
               h_sql := h_sql || ') ';
            End If;
         End If;
         
         --trace_printf(" h_sql, :%s \n", (char *)h_sql);
         
         BEGIN
            EXECUTE IMMEDIATE h_sql;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 533+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(534) : assets.sql(3943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
               END IF; 
            END;
         END;
      End If;
      
      -- filter by attributes
      If (h_attribute_ids IS NOT NULL) Then
         BEGIN
            EXECUTE IMMEDIATE h_search_by_attr_condition;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 554+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(555) : assets.sql(3964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  LFILE.FPUT('AllTrace',                         'SQL : ' || h_search_by_attr_condition);
               END IF; 
            END;
         END;
      End If;
      
      If (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
            h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
         h_temp_sc_state := FC_CLEANS_AST_BY_NAME(h_search_option);
      End If;
   End If;
   
   If ((h_id IS NOT NULL)) OR (Coalesce(h_bitflag, 0) = PMO_CNST.SC_REFRESH) OR (Coalesce(
         h_bitflag, 0) = PMO_CNST.SC_ASSIGNED_CHILD) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, LEVEL_ID)
         SELECT A.ELEMENT_ID, A.TYPE_ID, A.LEVEL_ID
         FROM TMT_ASSETS A
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 584+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(585) : assets.sql(3994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   If Coalesce(h_bitflag, 0) = PMO_CNST.SC_ASSIGNED_CHILD Then
      OPEN CAchild FOR SELECT
      T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME,
      T.DOC_COUNT, T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      T.REVISION_HISTORY, T.CATEGORY_ID, T.STATUS_ID, T.MAKE, T.MODEL, T.QUANTITY,
      T.QUANTITY_USED, T.QUANTITY-QUANTITY_USED AS QUANTITY_REM, T.MODEL_NUMBER,
      T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.DATE_ACQUIRED, T.DATE_SOLD, T.PURCHASE_PRICE,
      T.DEPRECIATION_METHOD,
      T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
      T.SALVAGE_VALUE, T.CAPITAL_VALUE, T.CURRENT_VALUE,
      T.TRACKED_FLAG,
      TO_DATE(SYSDATE) AS NEXT_SCHED_MAINT,
      T.DESCRIPTION, T.FINANCIAL_CATEGORY,
      0.00 AS TOTAL_MAINTENANCE,
      0.00 AS TOTAL_DEPRECIATION,
      T.RTF_BITS, T.LICENCE_EXPIRY_DATE, T.WARRANTY_EXPIRY_DATE,
      T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
      T.ACTIVITY_START, T.ACTIVITY_FINISH, T.SD, T.FD,
      T.CAPITAL_SCHED_HOURS, T.CAPITAL_SCHED_COST,
      T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_ACTUAL_COST,
      T.CAPITAL_HOURS_ETC, T.CAPITAL_COST_ETC,
      T.EXPENSE_SCHED_HOURS, T.EXPENSE_SCHED_COST,
      T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_ACTUAL_COST,
      T.EXPENSE_HOURS_ETC, T.EXPENSE_COST_ETC,
      0.00 AS MAINTENANCE_ESTIMATED,
      0.00 AS MAINTENANCE_TODATE,
      0.00 AS DEPRECIATION_TODATE,
      0.00 AS CROSS_CHARGE_ESTIMATED,
      0.00 AS CROSS_CHARGE_TODATE,
      T.CREATED_BY, T.CREATED_DATETIME
      FROM PMO_ASSET_VIEW V, TMT_ASSETS T, RESOURCES R
      WHERE T.PARENT_ID = V.ASSET_ID AND T.TYPE_ID <> PMO_CNST.SC_ASSETS
      AND R.RESOURCE_ID = T.REC_USER
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_VIEW', 628+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_VIEW(629) : assets.sql(4038) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CAchild;
   Else
      OPEN C66672B FOR SELECT
      V.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, R.FULL_NAME AS REC_USER_NAME,
      T.DOC_COUNT, T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      T.REVISION_HISTORY, T.CATEGORY_ID, T.STATUS_ID, T.MAKE, T.MODEL, T.QUANTITY,
      T.QUANTITY_USED, T.QUANTITY-QUANTITY_USED AS QUANTITY_REM, T.MODEL_NUMBER,
      T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.DATE_ACQUIRED, T.DATE_SOLD, T.PURCHASE_PRICE,
      T.DEPRECIATION_METHOD,
      T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
      T.SALVAGE_VALUE, T.CAPITAL_VALUE, T.CURRENT_VALUE,
      T.TRACKED_FLAG,
      (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
      WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
      T.DESCRIPTION, T.FINANCIAL_CATEGORY,
      T.TOTAL_MAINTENANCE,
      T.TOTAL_DEPRECIATION,
      T.RTF_BITS, T.LICENCE_EXPIRY_DATE, T.WARRANTY_EXPIRY_DATE,
      T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
      T.ACTIVITY_START, T.ACTIVITY_FINISH, T.SD, T.FD,
      T.CAPITAL_SCHED_HOURS, T.CAPITAL_SCHED_COST,
      T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_ACTUAL_COST,
      T.CAPITAL_HOURS_ETC, T.CAPITAL_COST_ETC,
      T.EXPENSE_SCHED_HOURS, T.EXPENSE_SCHED_COST,
      T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_ACTUAL_COST,
      T.EXPENSE_HOURS_ETC, T.EXPENSE_COST_ETC,
      T.TOTAL_EST_MAINTENANCE AS MAINTENANCE_ESTIMATED,
      COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
      WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0) AS MAINTENANCE_TODATE,
      COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
      WHERE ASSET_ID = T.ELEMENT_ID AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0) AS DEPRECIATION_TODATE,
      T.ESTIMATED_CROSS_CHARGE AS CROSS_CHARGE_ESTIMATED,
      T.ACTUAL_CROSS_CHARGE AS CROSS_CHARGE_TODATE,
      T.CREATED_BY, T.CREATED_DATETIME
      FROM PMO_ASSET_VIEW V, TMT_ASSETS T, RESOURCES R
      WHERE T.ELEMENT_ID = V.ASSET_ID
      AND R.RESOURCE_ID = T.REC_USER
      AND T.TYPE_ID IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_VIEW', 671+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_VIEW(672) : assets.sql(4081) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66672B;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 680+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(681) : assets.sql(4090) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_VIEW', 692+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_VIEW(693) : assets.sql(4102) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_VIEW;
ALTER FUNCTION SP_ASSET_VIEW COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_FINANCIAL ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_FINANCIAL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672F PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_FINANCIAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_FINANCIAL'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_FINANCIAL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_FINANCIAL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_FINANCIAL(22) : assets.sql(4140) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_ASSET_FINANCIAL', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_ASSET_FINANCIAL(31) : assets.sql(4149) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_FINANCIAL', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_FINANCIAL(34) : assets.sql(4152) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   OPEN C66672F FOR SELECT TO_CHAR(T.FINANCIAL_CATEGORY) AS ELEMENT_ID, '' AS ELEMEMNT_NAME, T.FINANCIAL_CATEGORY AS TYPE_ID,
   T.FINANCIAL_CATEGORY,
   SUM(T.CAPITAL_SCHED_HOURS) AS CAPITAL_SCHED_HOURS,
   SUM(T.CAPITAL_SCHED_COST) AS CAPITAL_SCHED_COST,
   SUM(T.CAPITAL_ACTUAL_HOURS) AS CAPITAL_ACTUAL_HOURS,
   SUM(T.CAPITAL_ACTUAL_COST) AS CAPITAL_ACTUAL_COST,
   SUM(T.CAPITAL_HOURS_ETC) AS CAPITAL_HOURS_ETC,
   SUM(T.CAPITAL_COST_ETC) AS CAPITAL_COST_ETC,
   SUM(T.EXPENSE_SCHED_HOURS) AS EXPENSE_SCHED_HOURS,
   SUM(T.EXPENSE_SCHED_COST) AS EXPENSE_SCHED_COST,
   SUM(T.EXPENSE_ACTUAL_HOURS) AS EXPENSE_ACTUAL_HOURS,
   SUM(T.EXPENSE_ACTUAL_COST) AS EXPENSE_ACTUAL_COST,
   SUM(T.EXPENSE_HOURS_ETC) AS EXPENSE_HOURS_ETC,
   SUM(T.EXPENSE_COST_ETC) AS EXPENSE_COST_ETC
   FROM TMT_ASSETS T
   WHERE T.PARENT_ID = h_id
   AND T.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
   AND T.FINANCIAL_CATEGORY NOT IN (PMO_CNST.SC_NONE_FINANCIAL_CATEGORY, 0)
   GROUP BY T.FINANCIAL_CATEGORY;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_FINANCIAL', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_FINANCIAL(59) : assets.sql(4177) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66672F;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_FINANCIAL', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_FINANCIAL(68) : assets.sql(4186) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_FINANCIAL', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_FINANCIAL(80) : assets.sql(4198) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_FINANCIAL;
ALTER FUNCTION SP_S_ASSET_FINANCIAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_DOC_ASSET ==
CREATE OR REPLACE FUNCTION FC_D_DOC_ASSET
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      CURSOR c_all_child IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_ASSETS
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_ASSET(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_ASSET', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_ASSET(30) : assets.sql(4244) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_host_table := PMO_CNST.SC_TABLE_AST;
   h_del_flag := 'X';
   h_null_id := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
      PMO_DB2M.SC_STATE := FC_D_DOC_AST_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
   Else
      OPEN c_all_child;
      
      FETCH c_all_child INTO h_id, h_type_id;
      IF c_all_child%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_ASSETS Then
            PMO_DB2M.SC_STATE := FC_D_DOC_AST_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
         End If;
         
         FETCH c_all_child INTO h_id, h_type_id;
         IF c_all_child%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      END LOOP;
      
      BEGIN
         CLOSE c_all_child ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_ASSET', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_ASSET(74) : assets.sql(4288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_ASSET', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_ASSET(81) : assets.sql(4295) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_ASSET;
ALTER FUNCTION FC_D_DOC_ASSET COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting assets and Resources:
    if exists(resource assignments)
        cannot delete assets
        cannot delete resource
    else
        do delete assets and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_ASSET ==
CREATE OR REPLACE FUNCTION SP_D_ASSET
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_found_cri VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_null_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DEP_ASSET IS
         SELECT PRED_ID FROM ASSET_DEPENDENCIES
         WHERE SUCC_ID = h_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ASSET(38) : assets.sql(4350) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ASSET', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ASSET(45) : assets.sql(4357) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET(48) : assets.sql(4360) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT RANK, TYPE_ID INTO h_rank, h_type_id
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(67) : assets.sql(4379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET', 73+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET(74) : assets.sql(4386) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET(77) : assets.sql(4389) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      SELECT COUNT(ELEMENT_ID) INTO h_count
      FROM TMT_ASSETS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
      AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(94) : assets.sql(4406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET', 100+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET(101) : assets.sql(4413) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSET_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET', 103+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET(104) : assets.sql(4416) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSET_IS_USED, h_id, True);
   End If;
   
   BEGIN
      SELECT COUNT(CHARGECODE_ID) INTO h_count
      FROM BUDGETS
      WHERE CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_ASSETS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID = PMO_CNST.SC_ASSETS);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 120+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(121) : assets.sql(4433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET', 127+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET(128) : assets.sql(4440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSET_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET', 130+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET(131) : assets.sql(4443) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSET_IS_USED, h_id, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      PMO_DB2M.SC_STATE := FC_D_DOC_ASSET(h_id, h_rank, h_type_id, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      
      BEGIN
         DELETE FROM TMT_ASSETS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(165) : assets.sql(4477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMO_DB2M.SC_STATE := FC_D_DOC_ASSET(h_id, h_rank, h_type_id, h_rec_user);
      
      BEGIN
         DELETE FROM TMT_ASSETS WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(184) : assets.sql(4496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_AST;
   PMO_DB2M.SC_STATE := FC_D_SCD_BY_RANK(h_host_table, h_rank, h_rec_user);
   
   If (h_parent_id IS NOT NULL) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET CHILD_COUNT = CHILD_COUNT - 1,
         DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(209) : assets.sql(4521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN C_DEP_ASSET;
   
   LOOP
      FETCH C_DEP_ASSET INTO h_pred_id;
      IF C_DEP_ASSET%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE TMT_ASSETS SET QUANTITY_USED = QUANTITY_USED - 1
         WHERE ELEMENT_ID = h_pred_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 240+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(241) : assets.sql(4553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_DEP_ASSET ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 253+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(254) : assets.sql(4566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ASSET', 259+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ASSET(260) : assets.sql(4572) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 266+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(267) : assets.sql(4579) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET', 278+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET(279) : assets.sql(4591) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ASSET;
ALTER FUNCTION SP_D_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_ORG ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_ORG
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66673A PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66673B PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_ORG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_ORG'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_ORG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_ORG(25) : assets.sql(4632) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_ORG', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_ORG(30) : assets.sql(4637) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_ORG(33) : assets.sql(4640) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      OPEN C66673A FOR SELECT TORG.LEVEL_ID, TORG.TYPE_ID, TORG.RANK, TORG.PARENT_ID,
      TORG.ELEMENT_ID, TORG.ELEMENT_NAME, TORG.LEVEL_ID AS CHILD_COUNT, TORG.DESCRIPTION, TORG.REC_STATUS, TORG.REC_USER, TORG.REC_DATETIME
      FROM TMT_ORGANIZATIONS TORG
      WHERE ((RANK >= SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'), 1, 8) AND RANK <= (SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) 
      AND SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      OR ((RANK >= SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id), 1, 8) AND RANK <= (SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id)) 
      AND SUBSTR((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_ORGANIZATIONS WHERE ELEMENT_ID = p_id)) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      ORDER BY RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_ORG(48) : assets.sql(4655) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673A;
   Else
      OPEN C66673B FOR SELECT TORG.LEVEL_ID, TORG.TYPE_ID, TORG.RANK, TORG.PARENT_ID,
      ASSET_ORG_ID AS ELEMENT_ID, AO.ORGANIZATION_ID, TORG.ELEMENT_NAME, 0 AS CHILD_COUNT, TORG.DESCRIPTION, TORG.REC_STATUS, TORG.REC_USER, TORG.REC_DATETIME
      FROM ASSET_ORGANIZATIONS AO, TMT_ORGANIZATIONS TORG
      WHERE AO.ASSET_ID = p_id AND AO.ORGANIZATION_ID = TORG.ELEMENT_ID
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_ORG', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_ORG(58) : assets.sql(4665) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673B;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_ORG', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_ORG(67) : assets.sql(4674) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_ORG', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_ORG(79) : assets.sql(4686) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_ORG;
ALTER FUNCTION SP_S_ASSET_A_ORG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_ORG ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_ORG
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_org_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_ORG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_ORG'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_ORG(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_ORG', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_ORG(23) : assets.sql(4725) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_ORG', 27+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_ORG(28) : assets.sql(4730) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_ORG', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_ORG(31) : assets.sql(4733) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_asset_id := p_asset_id;
   h_org_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      DELETE FROM ASSET_ORGANIZATIONS WHERE ASSET_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(52) : assets.sql(4754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO ASSET_ORGANIZATIONS(ASSET_ORG_ID, ORGANIZATION_ID, ASSET_ID, REC_STATUS, REC_USER)
      VALUES(h_uniqueID, h_org_id, h_asset_id, 'U', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(72) : assets.sql(4774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_ORG', 77+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_ORG(78) : assets.sql(4780) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 84+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(85) : assets.sql(4787) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_ORG', 96+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_ORG(97) : assets.sql(4799) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_ORG;
ALTER FUNCTION SP_A_ASSET_ORG COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_ORG ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_ORG
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_ORG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_ORG'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_ORG(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_ORG', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_ORG(19) : assets.sql(4834) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Delete Statement
   BEGIN
      DELETE FROM ASSET_ORGANIZATIONS WHERE ASSET_ORG_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_ORG', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_ORG(35) : assets.sql(4850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_ORG', 40+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_ORG(41) : assets.sql(4856) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_ORG', 47+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_ORG(48) : assets.sql(4863) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_ORG', 59+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_ORG(60) : assets.sql(4875) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_ORG;
ALTER FUNCTION SP_UA_ASSET_ORG COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_RES ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_RES
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66673ARES PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66673BRES PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_RES(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_RES(25) : assets.sql(4916) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_RES', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_RES(30) : assets.sql(4921) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_RES(33) : assets.sql(4924) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      OPEN C66673ARES FOR SELECT TPL.LEVEL_ID, TPL.TYPE_ID, TPL.RANK, TPL.PARENT_ID,
      TPL.ELEMENT_ID, TPL.ELEMENT_NAME, TPL.LEVEL_ID AS CHILD_COUNT, TPL.DESCRIPTION, TPL.REC_STATUS, TPL.REC_USER, TPL.REC_DATETIME
      FROM TMT_POOLS TPL
      WHERE ((RANK >= SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'), 1, 8) AND RANK <= (SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) 
      AND SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA'),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = 'C25B49FE0C8740C59D01FDB9158C56FA')) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      OR ((RANK >= SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id), 1, 8) AND RANK <= (SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id)) 
      AND SUBSTR((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id),1, CASE WHEN LENGTH(RANK) > LENGTH((SELECT RANK FROM TMT_POOLS WHERE ELEMENT_ID = p_id)) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
      ORDER BY RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 49+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_RES(50) : assets.sql(4941) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673ARES;
   Else
      OPEN C66673BRES FOR SELECT TPL.LEVEL_ID, TPL.TYPE_ID, TPL.RANK, TPL.PARENT_ID,
      ASSET_RES_ID AS ELEMENT_ID, AO.RESOURCE_ID, TPL.ELEMENT_NAME, 0 AS CHILD_COUNT, TPL.DESCRIPTION, TPL.REC_STATUS, TPL.REC_USER, TPL.REC_DATETIME
      FROM ASSET_RESOURCES AO, TMT_POOLS TPL
      WHERE AO.ASSET_ID = p_id AND AO.RESOURCE_ID = TPL.ELEMENT_ID
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_RES', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_RES(60) : assets.sql(4951) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66673BRES;
   End If;
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_RES', 69+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_RES(70) : assets.sql(4961) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_RES', 81+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_RES(82) : assets.sql(4973) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_RES;
ALTER FUNCTION SP_S_ASSET_A_RES COMPILE DEBUG;

/******************************************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_RES ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_RES
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_RES(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_RES', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_RES(20) : assets.sql(5009) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_RES', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_RES(25) : assets.sql(5014) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_RES', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_RES(28) : assets.sql(5017) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      INSERT INTO ASSET_RESOURCES(ASSET_RES_ID, RESOURCE_ID,  ASSET_ID, REC_STATUS,  REC_USER )
      VALUES(h_uniqueID, p_id, p_asset_id, 'U', p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_RES', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_RES(48) : assets.sql(5037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_RES', 53+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_RES(54) : assets.sql(5043) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_RES', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_RES(61) : assets.sql(5050) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_RES', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_RES(73) : assets.sql(5062) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_RES;
ALTER FUNCTION SP_A_ASSET_RES COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_RES ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_RES
(
     p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_RES(' || 
       '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_RES', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_RES(19) : assets.sql(5097) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Delete Statement
   BEGIN
      DELETE FROM ASSET_RESOURCES WHERE ASSET_RES_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_RES', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_RES(35) : assets.sql(5113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_RES', 40+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_RES(41) : assets.sql(5119) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_RES', 47+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_RES(48) : assets.sql(5126) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_RES', 59+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_RES(60) : assets.sql(5138) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_RES;
ALTER FUNCTION SP_UA_ASSET_RES COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_A_ASSET_DEPEND ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_DEPEND
(
     succ_id001 VARCHAR2
   , pred_id001 VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_DEPEND(' || 
       '''' || succ_id001 || ''''
          || ', ' || '''' || pred_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_DEPEND(23) : assets.sql(5177) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If ((pred_id001 IS NULL)) OR ((succ_id001 IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_ASSET_DEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_ASSET_DEPEND(30) : assets.sql(5184) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_DEPEND(33) : assets.sql(5187) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate succ_id
   h_succ_id := succ_id001;
   BEGIN
      SELECT  ELEMENT_ID, REC_STATUS
      INTO h_succ_id, h_rec_status
      FROM TMT_ASSETS WHERE ELEMENT_ID = succ_id001/**succ_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(53) : assets.sql(5207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(60) : assets.sql(5214) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_DEPEND(63) : assets.sql(5217) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 68+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(69) : assets.sql(5223) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_DEPEND(72) : assets.sql(5226) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id
            , True);
   End If;
   
   -- validate pred_id
   h_pred_id := pred_id001;
   BEGIN
      SELECT ELEMENT_ID
      INTO h_pred_id
      FROM TMT_ASSETS WHERE ELEMENT_ID = pred_id001/**pred_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(90) : assets.sql(5244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(97) : assets.sql(5251) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_DEPEND(100) : assets.sql(5254) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_pred_id, True);
   End If;
   
   -- Insert
   BEGIN
      INSERT INTO ASSET_DEPENDENCIES (DEPEND_ID, PRED_ID, SUCC_ID, REC_USER)
      VALUES(h_uniqueID, h_pred_id, h_succ_id, rec_user001/**rec_user:ind_i_depend->rec_user*/);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(119) : assets.sql(5273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS SET QUANTITY_USED = QUANTITY_USED + 1
      WHERE ELEMENT_ID = h_pred_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(137) : assets.sql(5291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_DEPEND', 143+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_DEPEND(144) : assets.sql(5298) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_DEPEND', 146+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_DEPEND(147) : assets.sql(5301) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_uniqueID, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_DEPEND', 152+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_DEPEND(153) : assets.sql(5307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 159+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(160) : assets.sql(5314) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_DEPEND', 171+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_DEPEND(172) : assets.sql(5326) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_DEPEND;
ALTER FUNCTION SP_A_ASSET_DEPEND COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_DEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_DEPEND
(
     succ_id001 VARCHAR2
   , depend_id001 VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_DEPEND(' || 
       '''' || succ_id001 || ''''
          || ', ' || '''' || depend_id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_DEPEND', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_DEPEND(22) : assets.sql(5364) : ' || SYSTIMESTAMP);
   END IF; 

   If (depend_id001 IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_ASSET_DEPEND', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_ASSET_DEPEND(27) : assets.sql(5369) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_DEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_ASSET_DEPEND(30) : assets.sql(5372) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   --InitializeHost(SC_PARAM(h_depend_id), depend_id, ind_ua_depend->depend_id);
   h_depend_id := depend_id001;
   BEGIN
      SELECT PRED_ID, SUCC_ID INTO h_pred_id, h_succ_id
      FROM ASSET_DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(49) : assets.sql(5391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_ASSET_DEPEND', 55+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_ASSET_DEPEND(56) : assets.sql(5398) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_DEPEND', 58+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_ASSET_DEPEND(59) : assets.sql(5401) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   -- Delete
   BEGIN
      DELETE FROM ASSET_DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(77) : assets.sql(5419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS SET QUANTITY_USED = QUANTITY_USED -1
      WHERE ELEMENT_ID = h_pred_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(95) : assets.sql(5437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_DEPEND', 100+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_DEPEND(101) : assets.sql(5443) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 107+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(108) : assets.sql(5450) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_DEPEND', 119+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_DEPEND(120) : assets.sql(5462) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_DEPEND;
ALTER FUNCTION SP_UA_ASSET_DEPEND COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_S_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_MAINTENANCE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_MAINTENANCE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_MAINTENANCE(21) : assets.sql(5499) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_MAINTENANCE', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_MAINTENANCE(27) : assets.sql(5505) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_MAINTENANCE(30) : assets.sql(5508) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_type_id := '1';
   
   h_sql := 
         'SELECT ELEMENT_ID, ASSET_ID, DESCRIPTION AS ELEMENT_NAME, MAINTENANCE_DATE, PERFORMED_BY, ESTIMATED_COST, COST, ';
   h_sql := h_sql || 'REC_STATUS, REC_DATETIME, ';
   h_sql := h_sql || h_type_id;
   h_sql := h_sql || ' AS TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM ASSET_MAINTENANCE ';
   
   h_id := p_id;
   If (((p_bitflag IS NOT NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_MAINTENANCE', 48+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_MAINTENANCE(49) : assets.sql(5527) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      h_sql := h_sql || 'WHERE ASSET_ID = ''';
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_MAINTENANCE', 61+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_MAINTENANCE(62) : assets.sql(5540) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'ASSET_MAINTENANCE' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'ASSET_MAINTENANCE' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      h_sql := h_sql || 'WHERE ELEMENT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   h_sql := h_sql || '''';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 77+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_MAINTENANCE(78) : assets.sql(5556) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_MAINTENANCE', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_MAINTENANCE(81) : assets.sql(5559) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_MAINTENANCE', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_MAINTENANCE(89) : assets.sql(5567) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_MAINTENANCE', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_MAINTENANCE(101) : assets.sql(5579) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_MAINTENANCE;
ALTER FUNCTION SP_S_ASSET_MAINTENANCE COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_I_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_I_ASSET_MAINTENANCE
(
     p_description VARCHAR2
   , p_asset_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ASSET_MAINTENANCE(' || 
       '''' || p_description || ''''
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET_MAINTENANCE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ASSET_MAINTENANCE(24) : assets.sql(5619) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_ASSET_MAINTENANCE', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_ASSET_MAINTENANCE(30) : assets.sql(5625) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET_MAINTENANCE', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_ASSET_MAINTENANCE(33) : assets.sql(5628) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate asset_id
   h_asset_id := p_asset_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_ASSET_MAINTENANCE', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_ASSET_MAINTENANCE(43) : assets.sql(5638) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_asset_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_asset_id, True); 
   END;
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO ASSET_MAINTENANCE (ELEMENT_ID, ASSET_ID, DESCRIPTION, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_asset_id,
      p_description,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_MAINTENANCE', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_MAINTENANCE(77) : assets.sql(5672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ASSET_MAINTENANCE', 82+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ASSET_MAINTENANCE(83) : assets.sql(5678) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_MAINTENANCE', 89+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_MAINTENANCE(90) : assets.sql(5685) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_MAINTENANCE', 101+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_MAINTENANCE(102) : assets.sql(5697) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ASSET_MAINTENANCE;
ALTER FUNCTION SP_I_ASSET_MAINTENANCE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_MAINTENANCE
(
     p_element_id VARCHAR2
   , p_description VARCHAR2
   , p_date VARCHAR2
   , p_performed_by VARCHAR2
   , p_cost NUMBER
   , p_estimated_cost NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_old_actual NUMBER := 0;
   h_actual NUMBER := 0;
   h_old_estimated NUMBER := 0;
   h_estimated NUMBER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_MAINTENANCE(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_date || ''''
          || ', ' || '''' || p_performed_by || ''''
          || ', ' || COALESCE(TO_CHAR(p_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_cost), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_MAINTENANCE', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_MAINTENANCE(34) : assets.sql(5747) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_MAINTENANCE', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_MAINTENANCE(40) : assets.sql(5753) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_MAINTENANCE', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_MAINTENANCE(43) : assets.sql(5756) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate asset_id
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   h_actual := p_cost;
   h_estimated := p_estimated_cost;
   
   BEGIN
      SELECT ASSET_ID, ESTIMATED_COST, COST
      INTO h_asset_id, h_old_estimated, h_old_actual
      FROM ASSET_MAINTENANCE
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(67) : assets.sql(5780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_MAINTENANCE', 73+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_MAINTENANCE(74) : assets.sql(5787) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_MAINTENANCE', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_MAINTENANCE(77) : assets.sql(5790) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE ASSET_MAINTENANCE
      SET DESCRIPTION = p_description,
      PERFORMED_BY = p_performed_by,
      MAINTENANCE_DATE = p_date,
      ESTIMATED_COST = h_estimated,
      COST = h_actual,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(104) : assets.sql(5817) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_actual, 0) <> Coalesce(h_old_actual, 0)) OR (Coalesce(h_estimated, 0) <> Coalesce(
                                      h_old_estimated, 0)) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET TOTAL_MAINTENANCE = TOTAL_MAINTENANCE + h_actual - h_old_actual,
         TOTAL_EST_MAINTENANCE = TOTAL_EST_MAINTENANCE + h_estimated - h_old_estimated
         WHERE ELEMENT_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(126) : assets.sql(5839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_MAINTENANCE', 132+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_MAINTENANCE(133) : assets.sql(5846) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 139+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(140) : assets.sql(5853) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_MAINTENANCE', 151+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_MAINTENANCE(152) : assets.sql(5865) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_MAINTENANCE;
ALTER FUNCTION SP_U_ASSET_MAINTENANCE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_ASSET_MAINTENANCE ==
CREATE OR REPLACE FUNCTION SP_D_ASSET_MAINTENANCE
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_actual NUMBER := 0;
   h_estimated NUMBER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ASSET_MAINTENANCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ASSET_MAINTENANCE'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ASSET_MAINTENANCE(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_MAINTENANCE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ASSET_MAINTENANCE(26) : assets.sql(5907) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If ((p_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ASSET_MAINTENANCE', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ASSET_MAINTENANCE(32) : assets.sql(5913) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_MAINTENANCE', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET_MAINTENANCE(35) : assets.sql(5916) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   BEGIN
      SELECT ASSET_ID, ESTIMATED_COST, COST
      INTO h_asset_id, h_estimated, h_actual
      FROM ASSET_MAINTENANCE
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(55) : assets.sql(5936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_ASSET_MAINTENANCE', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_ASSET_MAINTENANCE(62) : assets.sql(5943) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_MAINTENANCE', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET_MAINTENANCE(65) : assets.sql(5946) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
   End If;
   
   BEGIN
      DELETE FROM ASSET_MAINTENANCE
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(83) : assets.sql(5964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_actual, 0) > 0.00) OR (Coalesce(h_estimated, 0) > 0.00) Then
      BEGIN
         UPDATE TMT_ASSETS
         SET TOTAL_MAINTENANCE = TOTAL_MAINTENANCE - h_actual,
         TOTAL_EST_MAINTENANCE = TOTAL_EST_MAINTENANCE - h_estimated
         WHERE ELEMENT_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(104) : assets.sql(5985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ASSET_MAINTENANCE', 110+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ASSET_MAINTENANCE(111) : assets.sql(5992) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 117+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(118) : assets.sql(5999) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_MAINTENANCE', 129+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_MAINTENANCE(130) : assets.sql(6011) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ASSET_MAINTENANCE;
ALTER FUNCTION SP_D_ASSET_MAINTENANCE COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_S_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_DEPRECIATION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_DEPRECIATION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_DEPRECIATION(21) : assets.sql(6048) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_DEPRECIATION', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_DEPRECIATION(27) : assets.sql(6054) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_DEPRECIATION(30) : assets.sql(6057) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_type_id := '1';
   
   h_sql := 'SELECT ELEMENT_ID, ASSET_ID, DEPRECIATION_DATE AS ELEMENT_NAME,  DEPRECIATION_AMOUNT, ';
   h_sql := h_sql || 'REC_STATUS, REC_DATETIME, ';
   h_sql := h_sql || h_type_id;
   h_sql := h_sql || ' AS TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM ASSET_DEPRECIATION ';
   
   h_id := p_id;
   If (((p_bitflag IS NOT NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_DEPRECIATION', 47+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_DEPRECIATION(48) : assets.sql(6075) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      h_sql := h_sql || 'WHERE ASSET_ID = ''';
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_ASSET_DEPRECIATION', 60+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_ASSET_DEPRECIATION(61) : assets.sql(6088) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'ASSET_DEPRECIATION' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'ASSET_DEPRECIATION' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      h_sql := h_sql || 'WHERE ELEMENT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   h_sql := h_sql || '''';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 76+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_DEPRECIATION(77) : assets.sql(6104) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_DEPRECIATION', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_DEPRECIATION(80) : assets.sql(6107) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_DEPRECIATION', 86+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_DEPRECIATION(87) : assets.sql(6114) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_DEPRECIATION', 98+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_DEPRECIATION(99) : assets.sql(6126) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_DEPRECIATION;
ALTER FUNCTION SP_S_ASSET_DEPRECIATION COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_I_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_I_ASSET_DEPRECIATION
(
     p_depreciation_date VARCHAR2
   , p_asset_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_depreciation_start TIMESTAMP;
   h_depreciation_finish TIMESTAMP;
   h_depreciation_amount NUMBER := 0.00;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_I_ASSET_DEPRECIATION(' || 
       '''' || p_depreciation_date || ''''
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET_DEPRECIATION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_ASSET_DEPRECIATION(27) : assets.sql(6169) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_ASSET_DEPRECIATION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_ASSET_DEPRECIATION(33) : assets.sql(6175) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_ASSET_DEPRECIATION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_ASSET_DEPRECIATION(36) : assets.sql(6178) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate asset_id
   h_asset_id := p_asset_id;
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO ASSET_DEPRECIATION (ELEMENT_ID, ASSET_ID, DEPRECIATION_DATE, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_asset_id,
      p_depreciation_date,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_DEPRECIATION', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_DEPRECIATION(67) : assets.sql(6209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /*  BEGIN_SQL
           SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT)
           INTO HOST(h_depreciation_start), HOST(h_depreciation_finish), HOST(h_depreciation_amount)
           FROM ASSET_DEPRECIATION
           WHERE ASSET_ID = HOST(h_asset_id);
       END_SQL;
   
       BEGIN_SQL
           UPDATE TMT_ASSETS
           SET DEPRECIATION_START = HOST(h_depreciation_start),
               DEPRECIATION_FINISH = HOST(h_depreciation_finish),
               DEPRECIABLE_LIFE = (YEAR(HOST(h_depreciation_finish)) - YEAR(HOST(h_depreciation_start))) * 12
                   + (MONTH(HOST(h_depreciation_finish)) - MONTH(HOST(h_depreciation_start)) + 1),
               TOTAL_DEPRECIATION = HOST(h_depreciation_amount)
           WHERE ELEMENT_ID = HOST(h_asset_id);
       END_SQL;
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_ASSET_DEPRECIATION', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_ASSET_DEPRECIATION(90) : assets.sql(6232) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_DEPRECIATION', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_DEPRECIATION(97) : assets.sql(6239) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_ASSET_DEPRECIATION', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_ASSET_DEPRECIATION(109) : assets.sql(6251) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_ASSET_DEPRECIATION;
ALTER FUNCTION SP_I_ASSET_DEPRECIATION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_DEPRECIATION
(
     p_element_id VARCHAR2
   , p_depreciation_date VARCHAR2
   , p_depreciation_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_depreciation_date TIMESTAMP;
   h_depreciation_start TIMESTAMP;
   h_depreciation_finish TIMESTAMP;
   h_depreciation_amount NUMBER := 0.00;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_DEPRECIATION(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_depreciation_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_depreciation_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_DEPRECIATION', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_DEPRECIATION(29) : assets.sql(6296) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate asset_id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_DEPRECIATION', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_DEPRECIATION(35) : assets.sql(6302) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_DEPRECIATION', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_DEPRECIATION(38) : assets.sql(6305) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   --  SC_LONG(h_depreciable_life);
   
   -- Validate asset_id
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   h_depreciation_date := p_depreciation_date;
   h_depreciation_amount := p_depreciation_amount;
   
   /*  BEGIN_SQL
           SELECT ASSET_ID INTO HOST(h_asset_id)
           FROM ASSET_DEPRECIATION
           WHERE ELEMENT_ID = HOST(h_element_id);
       END_SQL;
   
       if (SC_NODATA)
       {
           RETURN_ERROR(RECORD_NOT_FOUND, h_element_id);
       }
   */
   --Execute Insert Statement
   BEGIN
      UPDATE ASSET_DEPRECIATION
      SET DEPRECIATION_DATE = h_depreciation_date,
      DEPRECIATION_AMOUNT = h_depreciation_amount,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DEPRECIATION', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DEPRECIATION(82) : assets.sql(6349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   /*  BEGIN_SQL
           SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT)
           INTO HOST(h_depreciation_start), HOST(h_depreciation_finish), HOST(h_depreciation_amount)
           FROM ASSET_DEPRECIATION
           WHERE ASSET_ID = HOST(h_asset_id);
       END_SQL;
   
       BEGIN_SQL
           UPDATE TMT_ASSETS
           SET DEPRECIATION_START = HOST(h_depreciation_start),
               DEPRECIATION_FINISH = HOST(h_depreciation_finish),
               DEPRECIABLE_LIFE = (YEAR(HOST(h_depreciation_finish)) - YEAR(HOST(h_depreciation_start))) * 12
                   + (MONTH(HOST(h_depreciation_finish)) - MONTH(HOST(h_depreciation_start)) + 1),
               TOTAL_DEPRECIATION = HOST(h_depreciation_amount)
           WHERE ELEMENT_ID = HOST(h_asset_id);
       END_SQL;
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_DEPRECIATION', 107+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_DEPRECIATION(108) : assets.sql(6375) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DEPRECIATION', 114+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DEPRECIATION(115) : assets.sql(6382) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DEPRECIATION', 126+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DEPRECIATION(127) : assets.sql(6394) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_DEPRECIATION;
ALTER FUNCTION SP_U_ASSET_DEPRECIATION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_ASSET_DEPRECIATION ==
CREATE OR REPLACE FUNCTION SP_D_ASSET_DEPRECIATION
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_depreciation_start TIMESTAMP;
   h_depreciation_finish TIMESTAMP;
   h_depreciation_amount NUMBER := 0.00;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_ASSET_DEPRECIATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_ASSET_DEPRECIATION'), '-- ' || SYSTIMESTAMP, ':r := SP_D_ASSET_DEPRECIATION(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_DEPRECIATION', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_ASSET_DEPRECIATION(28) : assets.sql(6438) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If ((p_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_ASSET_DEPRECIATION', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_ASSET_DEPRECIATION(34) : assets.sql(6444) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_ASSET_DEPRECIATION', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_ASSET_DEPRECIATION(37) : assets.sql(6447) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   /*  BEGIN_SQL
           SELECT ASSET_ID INTO HOST(h_asset_id)
           FROM ASSET_DEPRECIATION
           WHERE ELEMENT_ID = HOST(h_element_id);
       END_SQL;
   
       if (SC_NODATA)
       {
           RETURN_ERROR(RECORD_NOT_FOUND, h_element_id);
       }
   */
   BEGIN
      DELETE FROM ASSET_DEPRECIATION
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_DEPRECIATION', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_DEPRECIATION(70) : assets.sql(6480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   /*  InitializeHost(SC_PARAM(h_count), 0);
       BEGIN_SQL
           SELECT MIN(DEPRECIATION_DATE), MAX(DEPRECIATION_DATE), SUM(DEPRECIATION_AMOUNT), COUNT(ASSET_ID)
           INTO HOST(h_depreciation_start), HOST(h_depreciation_finish), HOST(h_depreciation_amount), HOST(h_count)
           FROM ASSET_DEPRECIATION
           WHERE ASSET_ID = HOST(h_asset_id);
       END_SQL;
   
       if (h_count == 0)
       {
           BEGIN_SQL
               UPDATE TMT_ASSETS
               SET DEPRECIATION_START = SC_NULL,
                   DEPRECIATION_FINISH = SC_NULL,
                   DEPRECIABLE_LIFE = 0,
                   TOTAL_DEPRECIATION = 0.00
               WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL;
       }
       else
       {
           BEGIN_SQL
               UPDATE TMT_ASSETS
               SET DEPRECIATION_START = HOST(h_depreciation_start),
                   DEPRECIATION_FINISH = HOST(h_depreciation_finish),
                   DEPRECIABLE_LIFE = (YEAR(HOST(h_depreciation_finish)) - YEAR(HOST(h_depreciation_start))) * 12
                       + (MONTH(HOST(h_depreciation_finish)) - MONTH(HOST(h_depreciation_start)) + 1),
                   TOTAL_DEPRECIATION = HOST(h_depreciation_amount)
               WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL;
       }
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_ASSET_DEPRECIATION', 111+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_ASSET_DEPRECIATION(112) : assets.sql(6522) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_DEPRECIATION', 118+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_DEPRECIATION(119) : assets.sql(6529) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_ASSET_DEPRECIATION', 130+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_ASSET_DEPRECIATION(131) : assets.sql(6541) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_ASSET_DEPRECIATION;
ALTER FUNCTION SP_D_ASSET_DEPRECIATION COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_U_ASSET_DESC ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_DESC
(
     p_id VARCHAR2
   , p_category_id PLS_INTEGER
   , p_status_id PLS_INTEGER
   , p_quantity PLS_INTEGER
   , p_make VARCHAR2
   , p_model VARCHAR2
   , p_model_number VARCHAR2
   , p_serial_number VARCHAR2
   , p_barcode_number VARCHAR2
   , p_date_sold VARCHAR2
   , p_next_sched_maint VARCHAR2
   , p_description VARCHAR2
   , p_salvage_value NUMBER
   , p_current_value NUMBER
   , p_capital_value NUMBER
   , p_total_maint NUMBER
   , p_total_dep NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_DESC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_category_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_status_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_quantity), 'NULL')
          || ', ' || '''' || p_make || ''''
          || ', ' || '''' || p_model || ''''
          || ', ' || '''' || p_model_number || ''''
          || ', ' || '''' || p_serial_number || ''''
          || ', ' || '''' || p_barcode_number || ''''
          || ', ' || '''' || p_date_sold || ''''
          || ', ' || '''' || p_next_sched_maint || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_salvage_value), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_current_value), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_value), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_total_maint), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_total_dep), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_DESC', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_DESC(51) : assets.sql(6608) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_DESC', 58+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_DESC(59) : assets.sql(6616) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_DESC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_DESC(62) : assets.sql(6619) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_id), p_id, ind_u_asset_desc->p_id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_ASSET_DESC', 69+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_ASSET_DESC(70) : assets.sql(6627) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   UPDATE TMT_ASSETS SET
           DESCRIPTION = NULL
      WHERE ELEMENT_ID = P_ID;

   BEGIN
      UPDATE TMT_ASSETS SET
      CATEGORY_ID =        p_category_id,
      STATUS_ID =          p_status_id,
      QUANTITY =           p_quantity,
      MAKE =               p_make,
      MODEL =              p_model,
      MODEL_NUMBER  =     p_model_number,
      SERIAL_NUMBER =      p_serial_number,
      BARCODE_NUMBER =     p_barcode_number,
      DATE_SOLD =          p_date_sold,
      DESCRIPTION =        p_description,
      REC_DATETIME =       SYSTIMESTAMP,
      REC_USER     =       p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DESC', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DESC(111) : assets.sql(6668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_DESC', 116+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_DESC(117) : assets.sql(6674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DESC', 123+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DESC(124) : assets.sql(6681) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_DESC', 135+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_DESC(136) : assets.sql(6693) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_DESC;
ALTER FUNCTION SP_U_ASSET_DESC COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_U_ASSET_PRICE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_PRICE
(
     p_id VARCHAR2
   , p_depreciable_life PLS_INTEGER
   , p_depreciation_method PLS_INTEGER
   , p_date_acquired VARCHAR2
   , p_purchase_price NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_date_acquired DATE;
   h_depreciation_start DATE;
   h_depreciation_finish DATE;
   h_depreciation_date DATE;
   h_purchase_price NUMBER := 0;
   h_depreciation_amount NUMBER := 0;
   h_depreciable_life PLS_INTEGER := 0;
   h_depreciation_method PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_acquired_year PLS_INTEGER := 0;
   h_acquired_month PLS_INTEGER := 0;
   AssetLife PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_PRICE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_PRICE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_PRICE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_depreciable_life), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_depreciation_method), 'NULL')
          || ', ' || '''' || p_date_acquired || ''''
          || ', ' || COALESCE(TO_CHAR(p_purchase_price), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_PRICE', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_PRICE(40) : assets.sql(6749) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   -- asset life number of months
   -- 0: manually, 1: linear
   
   -- Validate asset_id
   h_asset_id := p_id;
   h_rec_user := p_rec_user;
   h_date_acquired := p_date_acquired;
   h_purchase_price := p_purchase_price;
   h_depreciable_life := p_depreciable_life;
   h_depreciation_method := p_depreciation_method;
   
   -- Validate id
   If (h_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_PRICE', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_PRICE(58) : assets.sql(6767) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_PRICE', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_PRICE(61) : assets.sql(6770) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If (h_date_acquired IS NULL) Then
      BEGIN
         SELECT TO_DATE(SYSDATE)
         INTO h_date_acquired
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(77) : assets.sql(6786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT PMO_ORASTD.YEAR(h_date_acquired), PMO_ORASTD.MONTH(h_date_acquired)
      INTO h_acquired_year, h_acquired_month
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(93) : assets.sql(6802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET DEPRECIABLE_LIFE    = h_depreciable_life,
      DEPRECIATION_METHOD = h_depreciation_method,
      DATE_ACQUIRED       = h_date_acquired,
      PURCHASE_PRICE      = h_purchase_price,
      REC_DATETIME        = SYSTIMESTAMP,
      REC_USER            = h_rec_user
      WHERE ELEMENT_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(117) : assets.sql(6826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_depreciable_life, 0) > 0) AND (Coalesce(h_depreciation_method, 0) > 0) Then
      h_depreciation_amount := Coalesce(h_purchase_price, 0) / Coalesce(h_depreciable_life, 0);
      
      BEGIN
         DELETE FROM ASSET_DEPRECIATION
         WHERE ASSET_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(138) : assets.sql(6847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   AssetLife := Coalesce(h_depreciable_life, 0);
   WHILE (AssetLife > 0) AND (Coalesce(h_depreciation_method, 0) > 0) LOOP
      If Coalesce(h_acquired_month, 0) = 12 Then
         h_acquired_year := Coalesce(h_acquired_year, 0) + 1;
         h_acquired_month := 0;
      End If;
      
      h_depreciation_date := TO_CHAR(Coalesce(h_acquired_year, 0)) || '-' || TO_CHAR((Coalesce(
                       h_acquired_month, 0) + 1)) || '-01';
      h_uniqueID := SYS_GUID();
      
      h_depreciation_date := h_depreciation_date;
      
      If AssetLife = Coalesce(h_depreciable_life, 0) Then
         BEGIN
            SELECT (TO_DATE(SubStr(h_depreciation_date, 1, 10)) - 1    )
            INTO h_depreciation_start
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(168) : assets.sql(6877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         INSERT INTO ASSET_DEPRECIATION (ELEMENT_ID, ASSET_ID, DEPRECIATION_DATE,
         DEPRECIATION_AMOUNT, REC_STATUS, REC_DATETIME, REC_USER)
         VALUES (h_uniqueID, h_asset_id, (TO_DATE(SubStr(h_depreciation_date, 1, 10)) - 1    ),
         h_depreciation_amount, 'I', SYSTIMESTAMP, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(189) : assets.sql(6898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_acquired_month := Coalesce(h_acquired_month, 0) + 1;
      AssetLife := AssetLife - 1;
   END LOOP;
   
   -- Move in sp_ckin_asset
   /*  if (h_depreciation_method > 0)
       {
           if (h_depreciable_life > 0)
           {
               BEGIN_SQL
                   SELECT (DATE(HOST(h_depreciation_date)) - 1 DAY)
                   INTO HOST(h_depreciation_finish)
                   FROM DUAL;
               END_SQL;
   
               // Execute Update Statement
               BEGIN_SQL
                   UPDATE TMT_ASSETS
                   SET DEPRECIABLE_LIFE    = HOST(h_depreciable_life),
                       DEPRECIATION_METHOD = HOST(h_depreciation_method),
                       DEPRECIATION_START  = HOST(h_depreciation_start),
                       DEPRECIATION_FINISH = HOST(h_depreciation_finish),
                       DATE_ACQUIRED       = HOST(h_date_acquired),
                       PURCHASE_PRICE      = HOST(h_purchase_price),
                       REC_DATETIME        = SC_NOW,
                       REC_USER            = HOST(h_rec_user)
                   WHERE ELEMENT_ID = HOST(h_asset_id);
               END_SQL;
           }
           else
           {
               // Execute Update Statement
               BEGIN_SQL
                   UPDATE TMT_ASSETS
                   SET
   //                  DEPRECIABLE_LIFE    = HOST(h_depreciable_life),
                       DEPRECIATION_METHOD = HOST(h_depreciation_method),
   //                  DEPRECIATION_START  = SC_NULL,
   //                  DEPRECIATION_FINISH = SC_NULL,
                       DATE_ACQUIRED       = HOST(h_date_acquired),
                       PURCHASE_PRICE      = HOST(h_purchase_price),
                       REC_DATETIME        = SC_NOW,
                       REC_USER            = HOST(h_rec_user)
                   WHERE ELEMENT_ID = HOST(h_asset_id);
               END_SQL;
           }
       }
       else
       {
           // Execute Update Statement
           BEGIN_SQL
               UPDATE TMT_ASSETS SET
   //              DEPRECIABLE_LIFE =   HOST(h_depreciable_life),
                   DEPRECIATION_METHOD =HOST(h_depreciation_method),
                   DATE_ACQUIRED =      HOST(h_date_acquired),
                   PURCHASE_PRICE =     HOST(h_purchase_price),
                   REC_DATETIME =       SC_NOW,
                   REC_USER     =       HOST(h_rec_user)
               WHERE ELEMENT_ID = HOST(h_asset_id);
           END_SQL;
       }
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_PRICE', 256+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_PRICE(257) : assets.sql(6966) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 263+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(264) : assets.sql(6973) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_PRICE', 275+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_PRICE(276) : assets.sql(6985) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_PRICE;
ALTER FUNCTION SP_U_ASSET_PRICE COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_U_ASSET_CONTACTOR ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_CONTACTOR
(
     p_id VARCHAR2
   , p_licence_expiry_date VARCHAR2
   , p_warranty_expiry_date VARCHAR2
   , p_contactor VARCHAR2
   , p_contactor_phone VARCHAR2
   , p_contactor_email VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_licence_expiry_date DATE;
   h_warranty_expiry_date DATE;
   h_contactor VARCHAR2(255);
   h_contactor_phone VARCHAR2(255);
   h_contactor_email VARCHAR2(255);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_CONTACTOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_CONTACTOR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_CONTACTOR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_licence_expiry_date || ''''
          || ', ' || '''' || p_warranty_expiry_date || ''''
          || ', ' || '''' || p_contactor || ''''
          || ', ' || '''' || p_contactor_phone || ''''
          || ', ' || '''' || p_contactor_email || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CONTACTOR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_CONTACTOR(34) : assets.sql(7035) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_CONTACTOR', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_CONTACTOR(42) : assets.sql(7043) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CONTACTOR', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_CONTACTOR(45) : assets.sql(7046) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_licence_expiry_date := p_licence_expiry_date;
   h_warranty_expiry_date := p_warranty_expiry_date;
   h_contactor := p_contactor;
   h_contactor_phone := p_contactor_phone;
   h_contactor_email := p_contactor_email;
   h_rec_user := p_rec_user;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_ASSETS
      SET LICENCE_EXPIRY_DATE = h_licence_expiry_date,
      WARRANTY_EXPIRY_DATE = h_warranty_expiry_date,
      CONTACTOR = h_contactor,
      CONTACTOR_PHONE = h_contactor_phone,
      CONTACTOR_EMAIL = h_contactor_email,
      REC_DATETIME =       SYSTIMESTAMP,
      REC_USER     =       h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CONTACTOR', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CONTACTOR(79) : assets.sql(7080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_CONTACTOR', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_CONTACTOR(85) : assets.sql(7086) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CONTACTOR', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CONTACTOR(92) : assets.sql(7093) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CONTACTOR', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CONTACTOR(104) : assets.sql(7105) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_CONTACTOR;
ALTER FUNCTION SP_U_ASSET_CONTACTOR COMPILE DEBUG;

/***********************************************************************************/

Prompt == FUNCTION SP_S_ASSET_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_ASSET_A_DEPEND
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66672ADEPEND PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C66672ADEPEND2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSET_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSET_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSET_A_DEPEND(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSET_A_DEPEND(28) : assets.sql(7149) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSET_A_DEPEND', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSET_A_DEPEND(33) : assets.sql(7154) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_DEPEND(36) : assets.sql(7157) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_id), p_id, ind_s_asset_a_depend->p_id);
   h_id := p_id;
   
   --if( !(IsNullSpParam(ind_s_asset_a_depend, p_bitflag))  (*p_bitflag == 1))
   If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_ASSET_A_DEPEND', 48+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_ASSET_A_DEPEND(49) : assets.sql(7170) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      OPEN C66672ADEPEND FOR SELECT DEPEND_ID AS ELEMENT_ID, TA.ELEMENT_NAME, TA.REC_USER, TA.REC_DATETIME, TA.REC_STATUS, TA.QUANTITY - TA.QUANTITY_USED, TYPE_ID, 0 AS CHILD_COUNT ,
      MODEL, MODEL_NUMBER, SERIAL_NUMBER, BARCODE_NUMBER
      FROM TMT_ASSETS TA, ASSET_DEPENDENCIES AD
      WHERE TA.ELEMENT_ID = AD.PRED_ID AND
      AD.SUCC_ID = p_id
      ORDER BY TA.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_DEPEND(67) : assets.sql(7188) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66672ADEPEND;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_ASSET_A_DEPEND', 71+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_ASSET_A_DEPEND(72) : assets.sql(7193) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSETS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSETS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      OPEN C66672ADEPEND2 FOR SELECT DEPEND_ID AS ELEMENT_ID, TA.ELEMENT_NAME, TA.REC_USER, TA.REC_DATETIME, TA.REC_STATUS, TA.QUANTITY - TA.QUANTITY_USED, TYPE_ID, 0 AS CHILD_COUNT ,
      MODEL, MODEL_NUMBER, SERIAL_NUMBER, BARCODE_NUMBER
      FROM TMT_ASSETS TA, ASSET_DEPENDENCIES AD
      WHERE TA.ELEMENT_ID = AD.SUCC_ID AND
      AD.PRED_ID = p_id
      ORDER BY TA.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSET_A_DEPEND', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSET_A_DEPEND(90) : assets.sql(7211) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C66672ADEPEND2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_DEPEND', 98+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_DEPEND(99) : assets.sql(7220) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSET_A_DEPEND', 110+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSET_A_DEPEND(111) : assets.sql(7232) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSET_A_DEPEND;
ALTER FUNCTION SP_S_ASSET_A_DEPEND COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION SP_ASSET_REPORT ==
CREATE OR REPLACE FUNCTION SP_ASSET_REPORT
(
     p_report_type PLS_INTEGER
   , p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(4000);
   h_attr_str VARCHAR2(8192);
   h_res_str VARCHAR2(8192);
   h_org_str VARCHAR2(8192);
   h_temp_attr_str VARCHAR2(154);
   h_xsql VARCHAR2(29999);
   h_c_project_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_user_name VARCHAR2(100);
   h_temp_str VARCHAR2(100);
   h_id VARCHAR2(32);
   h_sep1 VARCHAR2(1);
   h_sep2 VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_report_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C_ISSID PMO_DB2M.REF_CURSOR;

      CURSOR ISS_ATTR IS
         SELECT
         RTRIM(c.ELEMENT_NAME) || h_sep1 || 
         RTRIM(b.ELEMENT_NAME) || h_sep1 || 
         RTRIM(a.ELEMENT_NAME)
         FROM TMT_ASSET_ATTRIBUTES d
         JOIN TMT_ASSET_ATTRIBUTES c ON c.ELEMENT_ID = d.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES b ON b.ELEMENT_ID = c.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES a ON a.ELEMENT_ID = b.PARENT_ID
         WHERE d.ELEMENT_ID = h_id;

      CURSOR ISS_RES IS
         SELECT  FULL_NAME
         FROM  ASSET_RESOURCES, RESOURCES
         WHERE ASSET_ID = h_id AND ASSET_RESOURCES.RESOURCE_ID = RESOURCES.RESOURCE_ID;

      CURSOR ISS_ORG IS
         SELECT  RTRIM(ELEMENT_NAME)
         FROM  ASSET_ORGANIZATIONS, TMT_ORGANIZATIONS
         WHERE ASSET_ID = h_id AND ASSET_ORGANIZATIONS.ORGANIZATION_ID = TMT_ORGANIZATIONS.ELEMENT_ID;

      -- Resultset Cursor Declaration
      C_ISS_RESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_REPORT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_REPORT'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_REPORT(' || 
       COALESCE(TO_CHAR(p_report_type), 'NULL')
          || ', ' || '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_REPORT', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_REPORT(65) : assets.sql(7313) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --Temporary table declaration
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_ASSETS';
   PMO_DB2M.SC_STATE := 0;
   
   h_report_type := p_report_type;
   h_type := p_type;
   
   h_sep1 := SubStr(',', 1, 1);
   h_sep1 := ',';
   
   h_sep2 := Chr(9);
   --  h_sep2[0] = SC_TAB_CHAR ;  h_sep2[1] = SC_NULL_CHAR;
   
   h_temp_str := '228';
   
   h_attr_str := '';
   h_res_str := '';
   h_org_str := '';
   
   h_xsql := 'select ELEMENT_ID, TYPE_ID from tmt_assets where type_id = 228 and rank like ''0000%''  ';
   
   OPEN C_ISSID FOR h_xsql;
   
   LOOP
      FETCH C_ISSID INTO h_id, h_report_type;
      IF C_ISSID%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      --Attributes
      
      OPEN ISS_ATTR;
      
      LOOP
         FETCH ISS_ATTR INTO h_temp_attr_str;
         IF ISS_ATTR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_attr_str := h_attr_str || h_temp_attr_str;
         h_attr_str := h_attr_str || h_sep2;
      END LOOP;
      
      BEGIN
         CLOSE ISS_ATTR ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(132) : assets.sql(7380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Resources
      
      OPEN ISS_RES;
      
      LOOP
         FETCH ISS_RES INTO h_temp_attr_str;
         IF ISS_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_res_str := h_res_str || h_temp_attr_str;
         h_res_str := h_res_str || ';';
      END LOOP;
      
      BEGIN
         CLOSE ISS_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(164) : assets.sql(7412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Orgs
      
      OPEN ISS_ORG;
      
      LOOP
         FETCH ISS_ORG INTO h_temp_attr_str;
         IF ISS_ORG%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_org_str := h_org_str || h_temp_attr_str;
         h_org_str := h_org_str || ';';
         
         --          trace_printf("1. %s\n", h_temp_attr_str);
      END LOOP;
      
      BEGIN
         CLOSE ISS_ORG ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 197+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(198) : assets.sql(7446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_ASSETS (ASSET_ID, ASSET_TYPE, ASSET_ATTR, ASSET_RES, ASSET_ORG)
         VALUES (h_id, h_report_type, h_attr_str, h_res_str, h_org_str);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 215+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(216) : assets.sql(7464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_attr_str := '';
      h_res_str := '';
      h_org_str := '';
   END LOOP;
   
   BEGIN
      CLOSE C_ISSID ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 233+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(234) : assets.sql(7482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(ASSET_ID) INTO h_count FROM PMO_TMP_ASSETS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 246+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(247) : assets.sql(7495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_ISS_RESULT FOR SELECT
   0 AS LEVEL_ID,
   T.TYPE_ID,
   T.RANK,
   T.PARENT_ID,
   T.ELEMENT_ID,
   T.ELEMENT_NAME,
   T.CHILD_COUNT,
   T.DELETED_COUNT,
   T. REC_STATUS,
   T.REC_USER,
   T.REC_DATETIME,
   TI.ASSET_ATTR,
   TI.ASSET_RES,
   TI.ASSET_ORG,
   MAKE, MODEL, QUANTITY, QUANTITY_USED, QUANTITY-QUANTITY_USED AS QUANTITY_REM,
   MODEL_NUMBER, SERIAL_NUMBER, BARCODE_NUMBER , DATE_ACQUIRED, DATE_SOLD, PURCHASE_PRICE ,
   DEPRECIATION_METHOD, DEPRECIATION_START, DEPRECIATION_FINISH,
   DEPRECIABLE_LIFE,
   SALVAGE_VALUE, CAPITAL_VALUE, CURRENT_VALUE,
   NEXT_SCHED_MAINT , DESCRIPTION, TOTAL_MAINTENANCE,
   (SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)) AS TOTAL_DEPRECIATION
   FROM TMT_ASSETS T,  PMO_TMP_ASSETS TI
   WHERE TI.ASSET_ID = T.ELEMENT_ID
   ORDER BY T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_REPORT', 278+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_REPORT(279) : assets.sql(7527) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_ISS_RESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 286+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(287) : assets.sql(7535) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_REPORT', 298+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_REPORT(299) : assets.sql(7547) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_REPORT;
ALTER FUNCTION SP_ASSET_REPORT COMPILE DEBUG;

/**************************************************************************************************/

Prompt == FUNCTION SP_S_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_S_BUDGET_BREAKDOWN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_BUDGET_BREAKDOWN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_BUDGET_BREAKDOWN(21) : assets.sql(7584) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_BUDGET_BREAKDOWN', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_BUDGET_BREAKDOWN(27) : assets.sql(7590) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_BUDGET_BREAKDOWN(30) : assets.sql(7593) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_type_id := TO_CHAR(Coalesce(p_bitflag, 0));
   
   -- THE FOLLOWING CODE REFERS TO THE BUDGET_BREAKDOWN : TEMPORARY COMMENTED
   
   --h_sql.strcpy("SELECT ELEMENT_ID, BUDGET_ID, BREAKDOWN_DATE AS ELEMENT_NAME,  BREAKDOWN_AMOUNT, ");
   --h_sql.strcat("REC_STATUS, REC_DATETIME, TYPE_ID, REC_USER ");
   --h_sql.strcat("FROM BUDGET_BREAKDOWN ");
   
   --InitializeHost(SC_PARAM(h_id), p_id, ind_s_budget_breakdown->p_id);
   --InitializeHost(SC_PARAM(h_id),p_id,ind_s_budget_breakdown->p_id);
   
   --if( ( (IsNotNullSpParam(ind_s_budget_breakdown, p_bitflag)))  (*p_bitflag == 2))
   --{
   --  //VALIDATE_EXISTENCE(BUDGETS, h_id, h_rec_status);
   --  h_sql.strcat("WHERE BUDGET_ID = '");
   --}
   --else
   --{
   --  //VALIDATE_EXISTENCE(BUDGET_BREAKDOWN, h_id, h_rec_status);
   --  h_sql.strcat("WHERE BUDGET_ID = '");
   --}
   --h_sql.strcat(h_id);
   --h_sql.strcat("' AND TYPE_ID = ");
   --h_sql.strcat(h_type_id);
   --h_sql.strcat(" ORDER BY BREAKDOWN_DATE");
   
   --trace_printf("%s", (char*)h_sql);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 64+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_BUDGET_BREAKDOWN(65) : assets.sql(7628) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_BUDGET_BREAKDOWN', 67+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_BUDGET_BREAKDOWN(68) : assets.sql(7631) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BUDGET_BREAKDOWN', 76+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BUDGET_BREAKDOWN(77) : assets.sql(7640) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_BUDGET_BREAKDOWN', 88+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_BUDGET_BREAKDOWN(89) : assets.sql(7652) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_S_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_I_BUDGET_BREAKDOWN
(
     p_breakdown_date VARCHAR2
   , p_budget_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_budget_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_I_BUDGET_BREAKDOWN(' || 
       '''' || p_breakdown_date || ''''
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BUDGET_BREAKDOWN', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_BUDGET_BREAKDOWN(24) : assets.sql(7692) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate budget_id
   If (p_budget_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_BUDGET_BREAKDOWN', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_BUDGET_BREAKDOWN(30) : assets.sql(7698) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_BUDGET_BREAKDOWN', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_BUDGET_BREAKDOWN(33) : assets.sql(7701) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate budget_id
   --InitializeHost(SC_PARAM(h_budget_id), p_budget_id, ind_i_budget_breakdown->p_budget_id);
   h_budget_id := p_budget_id;
   --VALIDATE_RECORD(BUDGETS, h_budget_id, h_rec_status);
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- THE FOLLOWING CODE REFERS TO BUDGET_BREAKDOWN TABLE :TEMPORARY COMMENTED
   
   --Execute Insert Statement
   --BEGIN_SQL
   --  INSERT INTO BUDGET_BREAKDOWN (ELEMENT_ID, BUDGET_ID, BREAKDOWN_DATE, TYPE_ID, REC_STATUS, REC_DATETIME, REC_USER)
   --  VALUES (
   --      HOST(h_uniqueID),
   --      HOST_DB(p_budget_id,ind_i_budget_breakdown),
   --      HOST_DB(p_breakdown_date,ind_i_budget_breakdown),
   --      HOST_DB(p_type_id,ind_i_budget_breakdown),
   --      'I',
   --      SC_NOW,
   --      HOST_DB(p_rec_user,ind_i_budget_breakdown));
   --END_SQL;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_BUDGET_BREAKDOWN', 64+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_BUDGET_BREAKDOWN(65) : assets.sql(7733) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BUDGET_BREAKDOWN', 71+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BUDGET_BREAKDOWN(72) : assets.sql(7740) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_BUDGET_BREAKDOWN', 83+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_BUDGET_BREAKDOWN(84) : assets.sql(7752) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_I_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_U_BUDGET_BREAKDOWN
(
     p_element_id VARCHAR2
   , p_breakdown_date VARCHAR2
   , p_breakdown_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_BUDGET_BREAKDOWN(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_breakdown_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_breakdown_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BUDGET_BREAKDOWN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_BUDGET_BREAKDOWN(23) : assets.sql(7791) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate budget_id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_BUDGET_BREAKDOWN', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_BUDGET_BREAKDOWN(29) : assets.sql(7797) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BUDGET_BREAKDOWN', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_BUDGET_BREAKDOWN(32) : assets.sql(7800) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate budget_id
   --InitializeHost(SC_PARAM(h_element_id), p_element_id, ind_u_budget_breakdown->p_element_id);
   h_element_id := p_element_id;
   --VALIDATE_RECORD(BUDGET_BREAKDOWN, h_element_id, h_rec_status);
   
   --Execute Insert Statement
   --BEGIN_SQL
   --  UPDATE BUDGET_BREAKDOWN SET
   --      BREAKDOWN_DATE = HOST_DB(p_breakdown_date,ind_u_budget_breakdown),
   --      BREAKDOWN_AMOUNT = HOST_DB(p_breakdown_amount,ind_u_budget_breakdown),
   --      REC_STATUS = 'I',
   --      REC_DATETIME = SC_NOW,
   --      REC_USER = HOST_DB(p_rec_user,ind_u_budget_breakdown)
   --  WHERE ELEMENT_ID = HOST_DB(p_element_id,ind_u_budget_breakdown);
   --END_SQL;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_BUDGET_BREAKDOWN', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_BUDGET_BREAKDOWN(57) : assets.sql(7825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET_BREAKDOWN', 63+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET_BREAKDOWN(64) : assets.sql(7832) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET_BREAKDOWN', 75+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET_BREAKDOWN(76) : assets.sql(7844) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_U_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_BUDGET_BREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_D_BUDGET_BREAKDOWN
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_BUDGET_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_BUDGET_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_D_BUDGET_BREAKDOWN(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_BUDGET_BREAKDOWN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_BUDGET_BREAKDOWN(23) : assets.sql(7883) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If ((p_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_BUDGET_BREAKDOWN', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_BUDGET_BREAKDOWN(29) : assets.sql(7889) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_BUDGET_BREAKDOWN', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_BUDGET_BREAKDOWN(32) : assets.sql(7892) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_element_id), p_element_id, ind_d_budget_breakdown->p_element_id);
   h_element_id := p_element_id;
   --BEGIN_SQL
   --  DELETE FROM BUDGET_BREAKDOWN WHERE ELEMENT_ID = HOST_DB(p_element_id,ind_d_budget_breakdown);
   --END_SQL;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_BUDGET_BREAKDOWN', 45+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_BUDGET_BREAKDOWN(46) : assets.sql(7906) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BUDGET_BREAKDOWN', 52+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BUDGET_BREAKDOWN(53) : assets.sql(7913) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_BUDGET_BREAKDOWN', 64+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_BUDGET_BREAKDOWN(65) : assets.sql(7925) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_BUDGET_BREAKDOWN;
ALTER FUNCTION SP_D_BUDGET_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_S_PROJECT_DISCOUNT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
   h_type_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PROJECT_DISCOUNT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PROJECT_DISCOUNT(21) : assets.sql(7962) : ' || SYSTIMESTAMP);
   END IF; 

   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PROJECT_DISCOUNT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PROJECT_DISCOUNT(27) : assets.sql(7968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJECT_DISCOUNT(30) : assets.sql(7971) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_type_id := TO_CHAR(Coalesce(p_bitflag, 0));
   
   h_sql := 'SELECT ELEMENT_ID, PROJECT_ID, DISCOUNT_DATE AS ELEMENT_NAME,  DISCOUNT_PERCENT, ';
   h_sql := h_sql || 'REC_STATUS, REC_DATETIME, TYPE_ID, REC_USER ';
   h_sql := h_sql || 'FROM PROJECT_DISCOUNT ';
   
   --InitializeHost(SC_PARAM(h_id), p_id, ind_s_project_discount->p_id);
   h_id := p_id;
   
   If (((p_bitflag IS NOT NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      h_sql := h_sql || 'WHERE PROJECT_ID = ''';
   Else
      h_sql := h_sql || 'WHERE PROJECT_ID = ''';
   End If;
   h_sql := h_sql || h_id;
   h_sql := h_sql || ''' ORDER BY DISCOUNT_DATE';
   
   --  trace_printf("%s", (char*)h_sql);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJECT_DISCOUNT(56) : assets.sql(7997) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJECT_DISCOUNT', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJECT_DISCOUNT(59) : assets.sql(8000) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJECT_DISCOUNT', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJECT_DISCOUNT(68) : assets.sql(8009) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJECT_DISCOUNT', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJECT_DISCOUNT(80) : assets.sql(8021) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PROJECT_DISCOUNT;
ALTER FUNCTION SP_S_PROJECT_DISCOUNT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_I_PROJECT_DISCOUNT
(
     p_discount_date VARCHAR2
   , p_project_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PROJECT_DISCOUNT(' || 
       '''' || p_discount_date || ''''
          || ', ' || '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJECT_DISCOUNT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PROJECT_DISCOUNT(24) : assets.sql(8061) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate project_id
   If (p_project_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_PROJECT_DISCOUNT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_PROJECT_DISCOUNT(30) : assets.sql(8067) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PROJECT_DISCOUNT', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_PROJECT_DISCOUNT(33) : assets.sql(8070) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate project_id
   --InitializeHost(SC_PARAM(h_project_id), p_project_id, ind_i_project_discount->p_project_id);
   h_project_id := p_project_id;
   --VALIDATE_RECORD(PROJECTS, h_project_id, h_rec_status);
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO PROJECT_DISCOUNT (ELEMENT_ID, PROJECT_ID, DISCOUNT_DATE, TYPE_ID, REC_STATUS, REC_DATETIME, REC_USER)
      VALUES (
      h_uniqueID,
      p_project_id,
      p_discount_date,
      p_type_id,
      'I',
      SYSTIMESTAMP,
      p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJECT_DISCOUNT', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJECT_DISCOUNT(69) : assets.sql(8106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PROJECT_DISCOUNT', 74+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PROJECT_DISCOUNT(75) : assets.sql(8112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJECT_DISCOUNT', 81+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJECT_DISCOUNT(82) : assets.sql(8119) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PROJECT_DISCOUNT', 93+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PROJECT_DISCOUNT(94) : assets.sql(8131) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PROJECT_DISCOUNT;
ALTER FUNCTION SP_I_PROJECT_DISCOUNT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_U_PROJECT_DISCOUNT
(
     p_element_id VARCHAR2
   , p_discount_date VARCHAR2
   , p_discount_percent NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJECT_DISCOUNT(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_discount_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_discount_percent), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJECT_DISCOUNT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJECT_DISCOUNT(23) : assets.sql(8170) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate project_id
   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PROJECT_DISCOUNT', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PROJECT_DISCOUNT(29) : assets.sql(8176) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJECT_DISCOUNT', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJECT_DISCOUNT(32) : assets.sql(8179) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate project_id
   h_element_id := p_element_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_PROJECT_DISCOUNT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_PROJECT_DISCOUNT(43) : assets.sql(8190) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'PROJECT_DISCOUNT' || '''' || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'PROJECT_DISCOUNT' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_element_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True); 
   END;
   
   --Execute Insert Statement
   BEGIN
      UPDATE PROJECT_DISCOUNT SET
      DISCOUNT_DATE = p_discount_date,
      DISCOUNT_PERCENT = p_discount_percent,
      REC_STATUS = 'I',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJECT_DISCOUNT', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJECT_DISCOUNT(73) : assets.sql(8220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJECT_DISCOUNT', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJECT_DISCOUNT(79) : assets.sql(8226) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJECT_DISCOUNT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJECT_DISCOUNT(86) : assets.sql(8233) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJECT_DISCOUNT', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJECT_DISCOUNT(98) : assets.sql(8245) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJECT_DISCOUNT;
ALTER FUNCTION SP_U_PROJECT_DISCOUNT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_PROJECT_DISCOUNT ==
CREATE OR REPLACE FUNCTION SP_D_PROJECT_DISCOUNT
(
     p_element_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_PROJECT_DISCOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_PROJECT_DISCOUNT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_PROJECT_DISCOUNT(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PROJECT_DISCOUNT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_PROJECT_DISCOUNT(23) : assets.sql(8284) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If ((p_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_PROJECT_DISCOUNT', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_PROJECT_DISCOUNT(29) : assets.sql(8290) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PROJECT_DISCOUNT', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_PROJECT_DISCOUNT(32) : assets.sql(8293) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   
   BEGIN
      DELETE FROM PROJECT_DISCOUNT WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJECT_DISCOUNT', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJECT_DISCOUNT(53) : assets.sql(8314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_PROJECT_DISCOUNT', 58+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_PROJECT_DISCOUNT(59) : assets.sql(8320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJECT_DISCOUNT', 65+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJECT_DISCOUNT(66) : assets.sql(8327) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PROJECT_DISCOUNT', 77+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PROJECT_DISCOUNT(78) : assets.sql(8339) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_PROJECT_DISCOUNT;
ALTER FUNCTION SP_D_PROJECT_DISCOUNT COMPILE DEBUG;

/*
SELECT a.BUDGET_ID, a.BREAKDOWN_dATE,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=236) AS TYPE1,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=237) AS TYPE2,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=338) AS TYPE3,
(SELECT SUM(BREAKDOWN_AMOUNT) FROM budget_breakdown WHERE BUDGET_ID=a.BUDGET_ID AND BREAKDOWN_DATE=a.BREAKDOWN_DATE AND TYPE_ID=239) AS TYPE4
FROM budget_breakdown a
WHERE BUDGET_ID = '0B796C6FD1EA405493A794EC53C6FA86'
GROUP BY a.BUDGET_ID,a.BREAKDOWN_dATE
*/

/*************************************************************************************************/

Prompt == FUNCTION FC_CLEANS_PMO_NAME_LIST ==
CREATE OR REPLACE FUNCTION FC_CLEANS_PMO_NAME_LIST
(
     sh_h_search_option PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_search_option PLS_INTEGER := sh_h_search_option;
   h_element_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_model VARCHAR2(255);
   h_model_number VARCHAR2(255);
   h_serial_number VARCHAR2(255);
   h_contractor VARCHAR2(255);
   h_approved PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR all_cln_curs IS
         SELECT V.ELEMENT_ID, V.ELEMENT_NAME
         FROM PMO_NAME_LIST V;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEANS_PMO_NAME_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEANS_PMO_NAME_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEANS_PMO_NAME_LIST(' || 
       COALESCE(TO_CHAR(sh_h_search_option), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_PMO_NAME_LIST', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEANS_PMO_NAME_LIST(26) : assets.sql(8392) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN all_cln_curs;
   
   LOOP
      h_element_name := NULL;
      
      FETCH all_cln_curs
      INTO h_element_id, h_element_name;
      IF all_cln_curs
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_approved := 1;
      
      h_approved := 1;
      
      If FC_FIND_KEYWORD(h_element_name, h_search_option) = 0 Then
         h_approved := 0;
      End If;
      
      If Coalesce(h_approved, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_NAME_LIST
            WHERE ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PMO_NAME_LIST', 68+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PMO_NAME_LIST(69) : assets.sql(8435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE all_cln_curs;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEANS_PMO_NAME_LIST', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEANS_PMO_NAME_LIST(84) : assets.sql(8450) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEANS_PMO_NAME_LIST', 90+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEANS_PMO_NAME_LIST(91) : assets.sql(8457) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEANS_PMO_NAME_LIST;
ALTER FUNCTION FC_CLEANS_PMO_NAME_LIST COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_SELECT_WBS_NAME ==
CREATE OR REPLACE FUNCTION FC_SELECT_WBS_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_keywords IN OUT NOCOPY VARCHAR2
   , h_attribute_ids IN OUT NOCOPY VARCHAR2
   , h_type_ids IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sql VARCHAR2(2048);
   h_search_by_name_condition VARCHAR2(8000);
   h_fieldName VARCHAR2(255);
   h_search_option PLS_INTEGER := 0;
   h_number_of_attributes PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SELECT_WBS_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SELECT_WBS_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_SELECT_WBS_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_keywords || ''''
          || ', ' || '''' || h_attribute_ids || ''''
          || ', ' || '''' || h_type_ids || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_WBS_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SELECT_WBS_NAME(28) : assets.sql(8495) : ' || SYSTIMESTAMP);
   END IF; 

   h_search_by_name_condition := '';
   If (h_keywords IS NOT NULL) Then
      h_fieldName := 'T.ELEMENT_NAME(C)';
      h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
      
      If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
         h_keywords := NULL;
         
         null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_WBS, h_search_by_name_condition
                                    , h_attribute_ids, h_number_of_attributes);
         
         If Coalesce(h_number_of_attributes, 0) = 0 Then
            h_number_of_attributes := 1;
            h_attribute_ids := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
         End If;
         h_search_by_name_condition := NULL;
      Else
         If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
            h_keywords := NULL;
            h_search_by_name_condition := NULL;
         Else
            h_keywords := h_search_by_name_condition;
         End If;
      End If;
      
      --trace_printf(" h_search_by_name_condition:%s \n", h_search_by_name_condition);
   End If;
   h_sql := 
         'INSERT INTO PMO_NAME_LIST(LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT) ';
   h_sql := h_sql || 
                  ' SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,  T.ELEMENT_NAME, 0 AS CHILD_COUNT ';
   h_sql := h_sql || ' FROM TMT_WBS T';
   h_sql := h_sql || ' WHERE T.TYPE_ID IN (';
   h_sql := h_sql || h_type_ids;
   h_sql := h_sql || ')';
   
   If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
      h_sql := h_sql || ' AND (';
      h_sql := h_sql || h_search_by_name_condition;
      h_sql := h_sql || ' ) ';
   End If;
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SELECT_WBS_NAME', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SELECT_WBS_NAME(85) : assets.sql(8552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   If (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
         h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
      h_temp_sc_state := FC_CLEANS_PMO_NAME_LIST(h_search_option);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_WBS_NAME', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SELECT_WBS_NAME(97) : assets.sql(8564) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SELECT_WBS_NAME;
ALTER FUNCTION FC_SELECT_WBS_NAME COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_SELECT_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION FC_SELECT_CLIENT_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_keywords IN OUT NOCOPY VARCHAR2
   , h_attribute_ids IN OUT NOCOPY VARCHAR2
   , h_type_ids IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_sql VARCHAR2(2048);
   h_search_by_name_condition VARCHAR2(8000);
   h_fieldName VARCHAR2(255);
   h_search_option PLS_INTEGER := 0;
   h_number_of_attributes PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SELECT_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SELECT_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_SELECT_CLIENT_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_keywords || ''''
          || ', ' || '''' || h_attribute_ids || ''''
          || ', ' || '''' || h_type_ids || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_CLIENT_NAME', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SELECT_CLIENT_NAME(28) : assets.sql(8602) : ' || SYSTIMESTAMP);
   END IF; 

   h_search_by_name_condition := '';
   If (h_keywords IS NOT NULL) Then
      h_fieldName := 'C.ELEMENT_NAME(C)';
      h_search_option := FC_PARSE_SEARCH_STR(h_keywords, h_fieldName, h_search_by_name_condition);
      
      If Coalesce(h_search_option, 0) = PMO_CNST.SC_FIND_ATTRIBUTE_NAME Then
         h_keywords := NULL;
         
         null_return := FC_FIND_ATTR_BY_NAME(PMO_CNST.SC_TABLE_CLN, h_search_by_name_condition
                                    , h_attribute_ids, h_number_of_attributes);
         
         If Coalesce(h_number_of_attributes, 0) = 0 Then
            h_number_of_attributes := 1;
            h_attribute_ids := PMO_CNST.SC_EMPTY_ATTRIBUTE_ID;
         End If;
         h_search_by_name_condition := NULL;
      Else
         If Coalesce(Length(h_search_by_name_condition), 0) = 0 Then
            h_keywords := NULL;
            h_search_by_name_condition := NULL;
         Else
            h_keywords := h_search_by_name_condition;
         End If;
      End If;
      
      --trace_printf(" h_search_by_name_condition:%s \n", h_search_by_name_condition);
   End If;
   
   h_sql := 
         ' INSERT INTO PMO_NAME_LIST(LEVEL_ID, TYPE_ID, RANK, PARENT_ID,    ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT) ';
   h_sql := h_sql || 
                  ' SELECT 0 AS LEVEL_ID, C.TYPE_ID, C.RANK, C.PARENT_ID, C.ELEMENT_ID,  C.ELEMENT_NAME, 0 AS CHILD_COUNT ';
   h_sql := h_sql || ' FROM TMT_CLIENTS C ';
   h_sql := h_sql || ' WHERE C.TYPE_ID = ';
   h_sql := h_sql || TO_CHAR(PMO_CNST.SC_CLIENTS);
   
   If Coalesce(Length(h_search_by_name_condition), 0) > 0 Then
      h_sql := h_sql || ' AND (';
      h_sql := h_sql || h_search_by_name_condition;
      h_sql := h_sql || ' ) ';
   End If;
   
   BEGIN
      EXECUTE IMMEDIATE h_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SELECT_CLIENT_NAME', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SELECT_CLIENT_NAME(85) : assets.sql(8659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_sql);
         END IF; 
      END;
   END;
   
   If (Coalesce(Length(h_search_by_name_condition), 0) > 0) AND (Coalesce(
         h_search_option, 0) <> PMO_CNST.SC_FIND_ATTRIBUTE_NAME) Then
      h_temp_sc_state := FC_CLEANS_PMO_NAME_LIST(h_search_option);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SELECT_CLIENT_NAME', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SELECT_CLIENT_NAME(97) : assets.sql(8671) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SELECT_CLIENT_NAME;
ALTER FUNCTION FC_SELECT_CLIENT_NAME COMPILE DEBUG;

/**************************************************************************************
returns a flat list of elements with a specified type and search criteria
the current code (April 12, 2004) supports WBS and CLIENTS elements only
**************************************************************************************/

Prompt == FUNCTION SP_VIEW_NAME ==
CREATE OR REPLACE FUNCTION SP_VIEW_NAME
(
     p_table_type PLS_INTEGER
   , p_id VARCHAR2
   , p_keywords VARCHAR2
   , p_attribute_ids VARCHAR2
   , p_type_ids VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_keywords VARCHAR2(8000);
   h_attribute_ids VARCHAR2(8000);
   h_type_ids VARCHAR2(8000);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      name_recset PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_VIEW_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_VIEW_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_VIEW_NAME(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_keywords || ''''
          || ', ' || '''' || p_attribute_ids || ''''
          || ', ' || '''' || p_type_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VIEW_NAME', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_VIEW_NAME(38) : assets.sql(8722) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := p_table_type;
   h_id := p_id;
   h_keywords := p_keywords;
   h_attribute_ids := p_attribute_ids;
   h_type_ids := p_type_ids;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NAME_LIST';
   PMO_DB2M.SC_STATE := 0;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      If (h_type_ids IS NULL) Then
         h_type_ids := PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      End If;
      h_temp_sc_state := FC_SELECT_WBS_NAME(h_id, h_keywords, h_attribute_ids, h_type_ids, h_rec_user);
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN Then
      h_temp_sc_state := FC_SELECT_CLIENT_NAME(h_id, h_keywords, h_attribute_ids, h_type_ids, h_rec_user);
   End If;
   
   OPEN name_recset FOR SELECT *FROM PMO_NAME_LIST
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VIEW_NAME', 64+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_VIEW_NAME(65) : assets.sql(8749) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN name_recset;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VIEW_NAME', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VIEW_NAME(73) : assets.sql(8757) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VIEW_NAME', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VIEW_NAME(85) : assets.sql(8769) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_VIEW_NAME;
ALTER FUNCTION SP_VIEW_NAME COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION SP_A_ASSET_PROJECT ==
CREATE OR REPLACE FUNCTION SP_A_ASSET_PROJECT
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_name VARCHAR2(255);
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_ASSET_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_ASSET_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_A_ASSET_PROJECT(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_ASSET_PROJECT(33) : assets.sql(8818) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 37+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(38) : assets.sql(8823) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_PROJECT(41) : assets.sql(8826) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_project_id := p_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN Then
      BEGIN
         SELECT PROJECT_ID INTO h_id
         FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 62+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(63) : assets.sql(8848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         h_id := SYS_GUID();
         
         BEGIN
            INSERT INTO PROJECT_CHARGEBACK(CHARGEBACK_ID, PROJECT_ID, CLIENT_ID, CREATED_BY, REC_USER)
            VALUES(h_id, h_asset_id, h_project_id, h_rec_user, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(84) : assets.sql(8869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 89+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(90) : assets.sql(8875) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 92+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_PROJECT(93) : assets.sql(8878) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_asset_id
               , True);
      End If;
   Else
      BEGIN
         SELECT ELEMENT_ID INTO h_id
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(109) : assets.sql(8894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            SELECT ELEMENT_NAME INTO h_name
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_asset_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 124+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(125) : assets.sql(8910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(132) : assets.sql(8917) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 134+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_PROJECT(135) : assets.sql(8920) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_asset_id, True);
         End If;
         
         h_parent_id := 'ASSET_CONVERTED_CC_FOLDER';
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_parent_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            TYPE_ID, LEVEL_ID, REC_USER, REC_STATUS)
            SELECT RTRIM(RANK) || h_rankBase64, h_parent_id, h_asset_id, h_name,
            PMO_CNST.SC_CHARGECODE, LEVEL_ID + 1, h_rec_user, 'D'
            FROM TMT_CHARGECODES
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(161) : assets.sql(8946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT ELEMENT_ID INTO h_id
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(179) : assets.sql(8964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            SELECT TYPE_ID INTO h_type_id
            FROM TMT_WBS
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 195+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(196) : assets.sql(8981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 202+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(203) : assets.sql(8988) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 205+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_PROJECT(206) : assets.sql(8991) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_project_id, True);
         End If;
         
         h_id := SYS_GUID();
         
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CAPITAL_EXPENSE,
            CHARGECODE_ID, TOLERANCE, TIMEPHASED_FLAG, ACTUAL_TIMEPHASED_FLAG, CREATED_BY, REC_USER)
            VALUES(h_id, h_project_id, h_project_id, h_type_id, h_capital_expense,
            h_asset_id, 10000, 1, 1, h_rec_user, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 227+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(228) : assets.sql(9013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_ASSET_PROJECT', 233+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_ASSET_PROJECT(234) : assets.sql(9019) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_ASSET_PROJECT', 236+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_A_ASSET_PROJECT(237) : assets.sql(9022) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_project_id
               , True);
      End If;
   End If;
   
   BEGIN
      INSERT INTO ASSET_CROSS_CHARGE(CROSS_CHARGE_ID, ASSET_ID, PROJECT_CLIENT_ID, REC_USER, REC_STATUS)
      VALUES(h_id, h_asset_id, h_project_id, h_rec_user, 'I');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 256+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(257) : assets.sql(9042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_ASSET_PROJECT', 262+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_ASSET_PROJECT(263) : assets.sql(9048) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 269+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(270) : assets.sql(9055) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_ASSET_PROJECT', 281+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_ASSET_PROJECT(282) : assets.sql(9067) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_ASSET_PROJECT;
ALTER FUNCTION SP_A_ASSET_PROJECT COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION SP_UA_ASSET_PROJECT ==
CREATE OR REPLACE FUNCTION SP_UA_ASSET_PROJECT
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(319);
   h_parent_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
   h_name VARCHAR2(255);
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_ASSET_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_ASSET_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_ASSET_PROJECT(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_PROJECT', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_ASSET_PROJECT(34) : assets.sql(9117) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_asset_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_ASSET_PROJECT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_ASSET_PROJECT(39) : assets.sql(9122) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_PROJECT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_ASSET_PROJECT(42) : assets.sql(9125) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_ids := p_id;
   h_rec_user := p_rec_user;
   
   --strncpy(h_project_id, h_ids, 32);
   --h_project_id[32] = '\0';
   
   h_project_id := SubStr(SubStr(h_ids, 1, 32), 1, 32);
   h_project_id := h_project_id;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CLN Then
      BEGIN
         SELECT CHARGEBACK_ID INTO h_budget_id
         FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(70) : assets.sql(9153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_ASSET_PROJECT', 76+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_ASSET_PROJECT(77) : assets.sql(9160) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_PROJECT', 79+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_UA_ASSET_PROJECT(80) : assets.sql(9163) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_asset_id, True);
      End If;
      
      BEGIN
         DELETE FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 98+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(99) : assets.sql(9182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PROJECT_CHARGEBACK_BREAKDOWN
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(118) : assets.sql(9201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT BUDGET_ID INTO h_budget_id
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(135) : assets.sql(9218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_ASSET_PROJECT', 141+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_ASSET_PROJECT(142) : assets.sql(9225) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_ASSET_PROJECT', 144+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_UA_ASSET_PROJECT(145) : assets.sql(9228) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_asset_id, True);
      End If;
      
      BEGIN
         DELETE FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(165) : assets.sql(9248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CHARGECODE_ID = h_asset_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(185) : assets.sql(9268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_DELETE_BUDGET_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(205) : assets.sql(9288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      null_return := FC_Rollup(h_project_id);
   End If;
   
   BEGIN
      UPDATE TMT_ASSETS
      SET ESTIMATED_CROSS_CHARGE = ESTIMATED_CROSS_CHARGE - (SELECT ESTIMATED_BUDGET FROM ASSET_CROSS_CHARGE
      WHERE CROSS_CHARGE_ID = h_budget_id),
      ACTUAL_CROSS_CHARGE = ACTUAL_CROSS_CHARGE - (SELECT ESTIMATED_ACTUAL FROM ASSET_CROSS_CHARGE
      WHERE CROSS_CHARGE_ID = h_budget_id)
      WHERE ELEMENT_ID = h_asset_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 229+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(230) : assets.sql(9313) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM ASSET_CROSS_CHARGE
      WHERE CROSS_CHARGE_ID = h_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 247+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(248) : assets.sql(9331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_ASSET_PROJECT', 257+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_ASSET_PROJECT(258) : assets.sql(9341) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_asset_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 264+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(265) : assets.sql(9348) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_ASSET_PROJECT', 276+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_ASSET_PROJECT(277) : assets.sql(9360) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_ASSET_PROJECT;
ALTER FUNCTION SP_UA_ASSET_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PBB_ASSET ==
CREATE OR REPLACE FUNCTION SP_S_PBB_ASSET
(
     p_asset_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_element_name VARCHAR2(255);
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_PBBA1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_PBBA2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PBB_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PBB_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PBB_ASSET(' || 
       '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PBB_ASSET(28) : assets.sql(9404) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_asset_id IS NULL) OR (p_budget_year IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PBB_ASSET', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PBB_ASSET(33) : assets.sql(9409) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB_ASSET(36) : assets.sql(9412) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_asset_id := p_asset_id;
   h_budget_year := p_budget_year;
   
   BEGIN
      SELECT ELEMENT_NAME INTO h_element_name
      FROM TMT_ASSETS
      WHERE ELEMENT_ID = h_asset_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB_ASSET', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB_ASSET(54) : assets.sql(9430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_PBB_ASSET', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_PBB_ASSET(61) : assets.sql(9437) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB_ASSET(64) : assets.sql(9440) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_asset_id, True);
   End If;
   
   If Coalesce(h_budget_year, 0) = 0 Then
      OPEN C_PBBA1 FOR SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.BUDGET_YEAR), '') || COALESCE(TO_CHAR(PBB.BUDGET_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      B.ESTIMATED_BUDGET, B.ESTIMATED_ACTUAL, B.ESTIMATED_PAID_TODATE AS ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.BUDGET_TYPE, W.PROJECT_ID,
      PBB.BUDGET_YEAR, B.CHARGECODE_ID, B.BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      PBB.ELEMENT_ID AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 0 AS TABLE_TYPE_ID
      FROM BUDGETS B JOIN TMT_WBS W ON W.ELEMENT_ID = B.PROJECT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.BUDGET_ID
      LEFT JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.CHARGECODE_ID = B.CHARGECODE_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID AND PBB.PROJECT_ID = PBB.ELEMENT_ID
      AND PBB.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      WHERE B.CHARGECODE_ID = h_asset_id
      
      UNION ALL
      
      SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.ENTRY_YEAR), '') || COALESCE(TO_CHAR(PBB.ENTRY_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      ACC.ESTIMATED_BUDGET, ACC.ESTIMATED_ACTUAL, ACC.ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.ENTRY_TYPE AS BUDGET_TYPE, W.ELEMENT_ID AS PROJECT_ID,
      PBB.ENTRY_YEAR AS BUDGET_YEAR, B.CLIENT_ID AS CHARGECODE_ID, B.CHARGEBACK_ID AS BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      '' AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 1 AS TABLE_TYPE_ID
      FROM PROJECT_CHARGEBACK B JOIN TMT_CLIENTS W ON W.ELEMENT_ID = B.CLIENT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.CHARGEBACK_ID
      LEFT JOIN PROJECT_CHARGEBACK_BREAKDOWN PBB ON PBB.CLIENT_ID = B.CLIENT_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID
      WHERE B.PROJECT_ID = h_asset_id
      
      ORDER BY TABLE_TYPE_ID, RANK, BUDGET_YEAR, BUDGET_TYPE;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 118+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB_ASSET(119) : assets.sql(9495) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PBBA1;
   Else
      OPEN C_PBBA2 FOR SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.BUDGET_YEAR), '') || COALESCE(TO_CHAR(PBB.BUDGET_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      B.ESTIMATED_BUDGET, B.ESTIMATED_ACTUAL, B.ESTIMATED_PAID_TODATE AS ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.BUDGET_TYPE, W.PROJECT_ID,
      h_budget_year AS BUDGET_YEAR, B.CHARGECODE_ID, B.BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      PBB.ELEMENT_ID AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 0 AS TABLE_TYPE_ID
      FROM BUDGETS B JOIN TMT_WBS W ON W.ELEMENT_ID = B.PROJECT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.BUDGET_ID
      LEFT JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.CHARGECODE_ID = B.CHARGECODE_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID AND PBB.PROJECT_ID = PBB.ELEMENT_ID
      AND PBB.BUDGET_YEAR = h_budget_year
      AND PBB.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      WHERE B.CHARGECODE_ID = h_asset_id
      
      UNION ALL
      
      SELECT
      (W.ELEMENT_ID || h_asset_id || COALESCE(TO_CHAR(PBB.ENTRY_YEAR), '') || COALESCE(TO_CHAR(PBB.ENTRY_TYPE), '')) AS ELEMENT_ID,
      h_asset_id AS ORIGINAL_ID,
      ACC.START_DATE, ACC.FINISH_DATE, ACC.QUANTITY, ACC.ASSET_CHARGE_TYPE, ACC.UNIT_PRICE,
      ACC.ESTIMATED_BUDGET, ACC.ESTIMATED_ACTUAL, ACC.ESTIMATED_PAID,
      W.ELEMENT_NAME, W.TYPE_ID, PBB.ENTRY_TYPE AS BUDGET_TYPE, W.ELEMENT_ID AS PROJECT_ID,
      h_budget_year AS BUDGET_YEAR, B.CLIENT_ID AS CHARGECODE_ID, B.CHARGEBACK_ID AS BUDGET_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      h_element_name AS CHARGECODE_NAME,
      '' AS ASSOCIATE_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
      0 AS AUTO_FLAG,
      PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT,
      PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
      PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT,
      PBB.MONTH_10_AMOUNT, PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT,
      PBB.TOTAL_AMOUNT AS YEAR_AMOUNT, W.RANK AS RANK, 1 AS TABLE_TYPE_ID
      FROM PROJECT_CHARGEBACK B JOIN TMT_CLIENTS W ON W.ELEMENT_ID = B.CLIENT_ID
      JOIN ASSET_CROSS_CHARGE ACC ON ACC.CROSS_CHARGE_ID = B.CHARGEBACK_ID
      LEFT JOIN PROJECT_CHARGEBACK_BREAKDOWN PBB ON PBB.CLIENT_ID = B.CLIENT_ID
      AND PBB.PROJECT_ID = B.PROJECT_ID
      AND PBB.ENTRY_YEAR = h_budget_year
      WHERE B.PROJECT_ID = h_asset_id
      
      ORDER BY TABLE_TYPE_ID, RANK, BUDGET_TYPE;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB_ASSET', 173+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB_ASSET(174) : assets.sql(9550) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_PBBA2;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB_ASSET', 182+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB_ASSET(183) : assets.sql(9559) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB_ASSET', 194+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB_ASSET(195) : assets.sql(9571) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PBB_ASSET;
ALTER FUNCTION SP_S_PBB_ASSET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_CROSS_CHARGE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_CROSS_CHARGE
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_float_quantity NUMBER
   , p_charge_type PLS_INTEGER
   , p_unit_price NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_asset_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_type_id PLS_INTEGER := 0;
   h_float_quantity NUMBER := 0;
   h_table_type PLS_INTEGER := 0;
   h_unit_price NUMBER := 0.00;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_CROSS_CHARGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_CROSS_CHARGE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_CROSS_CHARGE(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_float_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_charge_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_unit_price), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CROSS_CHARGE', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_CROSS_CHARGE(41) : assets.sql(9628) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_asset_id IS NULL)) OR ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_CROSS_CHARGE', 45+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_CROSS_CHARGE(46) : assets.sql(9633) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CROSS_CHARGE', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_CROSS_CHARGE(49) : assets.sql(9636) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --  InitializeHost(SC_PARAM(h_budget_id), p_id, ind_u_cross_charge->p_id);
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_id := p_id;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_type_id := p_charge_type;
   h_float_quantity := p_float_quantity;
   h_unit_price := p_unit_price;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_CLIENTS Then
      BEGIN
         SELECT CHARGEBACK_ID INTO h_budget_id
         FROM PROJECT_CHARGEBACK
         WHERE PROJECT_ID = h_asset_id
         AND CLIENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(77) : assets.sql(9664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT BUDGET_ID INTO h_budget_id
         FROM BUDGETS
         WHERE PROJECT_ID = h_id
         AND CHARGECODE_ID = h_asset_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(93) : assets.sql(9680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_CROSS_CHARGE', 100+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_CROSS_CHARGE(101) : assets.sql(9688) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_CROSS_CHARGE', 103+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_CROSS_CHARGE(104) : assets.sql(9691) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_asset_id, True);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE ASSET_CROSS_CHARGE
      SET START_DATE = h_start_date,
      FINISH_DATE = h_finish_date,
      QUANTITY = h_float_quantity,
      ASSET_CHARGE_TYPE  = h_type_id,
      UNIT_PRICE  = h_unit_price,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE CROSS_CHARGE_ID = h_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 129+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(130) : assets.sql(9717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_CROSS_CHARGE', 135+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_CROSS_CHARGE(136) : assets.sql(9723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_budget_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 142+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(143) : assets.sql(9730) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_CROSS_CHARGE', 154+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_CROSS_CHARGE(155) : assets.sql(9742) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_CROSS_CHARGE;
ALTER FUNCTION SP_U_ASSET_CROSS_CHARGE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASSET_TIMEPHASE ==
CREATE OR REPLACE FUNCTION SP_U_ASSET_TIMEPHASE
(
     p_table_type PLS_INTEGER
   , p_asset_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_id VARCHAR2
   , p_budget_type PLS_INTEGER
   , p_month_01_amount NUMBER
   , p_month_02_amount NUMBER
   , p_month_03_amount NUMBER
   , p_month_04_amount NUMBER
   , p_month_05_amount NUMBER
   , p_month_06_amount NUMBER
   , p_month_07_amount NUMBER
   , p_month_08_amount NUMBER
   , p_month_09_amount NUMBER
   , p_month_10_amount NUMBER
   , p_month_11_amount NUMBER
   , p_month_12_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_asset_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_total_amount NUMBER := 0;
   h_old_total_amount NUMBER := 0;
   h_budget_type PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_budget_id VARCHAR2(32);
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASSET_TIMEPHASE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASSET_TIMEPHASE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASSET_TIMEPHASE(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_01_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_02_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_03_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_04_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_05_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_06_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_07_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_08_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_09_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_10_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_11_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_12_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TIMEPHASE', 58+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASSET_TIMEPHASE(59) : assets.sql(9817) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_asset_id IS NULL) OR (p_budget_year IS NULL) OR (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASSET_TIMEPHASE', 63+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASSET_TIMEPHASE(64) : assets.sql(9822) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TIMEPHASE', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_TIMEPHASE(67) : assets.sql(9825) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_table_type := p_table_type;
   h_asset_id := p_asset_id;
   h_budget_year := p_budget_year;
   h_budget_type := p_budget_type;
   h_id := p_id;
   
   If Coalesce(h_budget_year, 0) <> 0 Then
      h_total_amount := Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                           p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                           p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                           p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                           p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                           p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0);
      
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_CLIENTS Then
         BEGIN
            SELECT CHARGEBACK_ID INTO h_budget_id
            FROM PROJECT_CHARGEBACK
            WHERE PROJECT_ID = h_asset_id
            AND CLIENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(100) : assets.sql(9858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_TIMEPHASE', 106+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_TIMEPHASE(107) : assets.sql(9865) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TIMEPHASE', 109+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_TIMEPHASE(110) : assets.sql(9868) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
         End If;
         
         BEGIN
            SELECT TOTAL_AMOUNT INTO h_old_total_amount
            FROM PROJECT_CHARGEBACK_BREAKDOWN
            WHERE PROJECT_ID = h_asset_id
            AND CLIENT_ID = h_id
            AND ENTRY_YEAR = h_budget_year
            AND ENTRY_TYPE = h_budget_type;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 127+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(128) : assets.sql(9886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_old_total_amount := 0.00;
            h_uniqueID := SYS_GUID();
            
            BEGIN
               INSERT INTO PROJECT_CHARGEBACK_BREAKDOWN (
               CHARGEBACK_ID, PROJECT_ID, CLIENT_ID,
               ENTRY_TYPE, ENTRY_YEAR,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT,
               MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT,
               MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               VALUES (h_uniqueID, h_asset_id, h_id,
               h_budget_type, h_budget_year,
               p_month_01_amount, p_month_02_amount,
               p_month_03_amount, p_month_04_amount,
               p_month_05_amount, p_month_06_amount,
               p_month_07_amount, p_month_08_amount,
               p_month_09_amount, p_month_10_amount,
               p_month_11_amount, p_month_12_amount,
               h_total_amount);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 166+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(167) : assets.sql(9925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_CHARGEBACK_BREAKDOWN
               SET MONTH_01_AMOUNT = p_month_01_amount,
               MONTH_02_AMOUNT = p_month_02_amount,
               MONTH_03_AMOUNT = p_month_03_amount,
               MONTH_04_AMOUNT = p_month_04_amount,
               MONTH_05_AMOUNT = p_month_05_amount,
               MONTH_06_AMOUNT = p_month_06_amount,
               MONTH_07_AMOUNT = p_month_07_amount,
               MONTH_08_AMOUNT = p_month_08_amount,
               MONTH_09_AMOUNT = p_month_09_amount,
               MONTH_10_AMOUNT = p_month_10_amount,
               MONTH_11_AMOUNT = p_month_11_amount,
               MONTH_12_AMOUNT = p_month_12_amount,
               TOTAL_AMOUNT = h_total_amount
               WHERE PROJECT_ID = h_asset_id
               AND CLIENT_ID = h_id
               AND ENTRY_YEAR = h_budget_year
               AND ENTRY_TYPE = h_budget_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 200+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(201) : assets.sql(9959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         -- once we add enough columns in project_chargeback table.
         -- The following three columns can be removed from ASSET_CROSS_CHARGE.
         If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_BUDGET = ESTIMATED_BUDGET - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 223+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(224) : assets.sql(9982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ESTIMATED_CROSS_CHARGE = ESTIMATED_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(243) : assets.sql(10001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_ACTUAL = ESTIMATED_ACTUAL - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 261+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(262) : assets.sql(10020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ACTUAL_CROSS_CHARGE = ACTUAL_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(281) : assets.sql(10039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_PAID_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_PAID = ESTIMATED_PAID - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 299+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(300) : assets.sql(10058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         BEGIN
            SELECT BUDGET_ID INTO h_budget_id
            FROM BUDGETS
            WHERE PROJECT_ID = h_id
            AND CHARGECODE_ID = h_asset_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 316+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(317) : assets.sql(10075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("h_budget_id: %s\n", h_budget_id);
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASSET_TIMEPHASE', 324+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASSET_TIMEPHASE(325) : assets.sql(10083) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASSET_TIMEPHASE', 327+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASSET_TIMEPHASE(328) : assets.sql(10086) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
         End If;
         
         BEGIN
            SELECT TOTAL_AMOUNT INTO h_old_total_amount
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_id
            AND ELEMENT_ID = h_id
            AND BUDGET_YEAR = h_budget_year
            AND CHARGECODE_ID = h_asset_id
            AND BUDGET_TYPE = h_budget_type;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 346+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(347) : assets.sql(10105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_BUDGET_BREAKDOWN (
               ELEMENT_ID, PROJECT_ID, CHARGECODE_ID,
               BUDGET_YEAR, BUDGET_TYPE,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT,
               MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT,
               MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               VALUES (h_id, h_id, h_asset_id,
               h_budget_year, h_budget_type,
               p_month_01_amount, p_month_02_amount,
               p_month_03_amount, p_month_04_amount,
               p_month_05_amount, p_month_06_amount,
               p_month_07_amount, p_month_08_amount,
               p_month_09_amount, p_month_10_amount,
               p_month_11_amount, p_month_12_amount,
               h_total_amount);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 382+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(383) : assets.sql(10141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_BUDGET_BREAKDOWN
               SET MONTH_01_AMOUNT = p_month_01_amount,
               MONTH_02_AMOUNT = p_month_02_amount,
               MONTH_03_AMOUNT = p_month_03_amount,
               MONTH_04_AMOUNT = p_month_04_amount,
               MONTH_05_AMOUNT = p_month_05_amount,
               MONTH_06_AMOUNT = p_month_06_amount,
               MONTH_07_AMOUNT = p_month_07_amount,
               MONTH_08_AMOUNT = p_month_08_amount,
               MONTH_09_AMOUNT = p_month_09_amount,
               MONTH_10_AMOUNT = p_month_10_amount,
               MONTH_11_AMOUNT = p_month_11_amount,
               MONTH_12_AMOUNT = p_month_12_amount,
               TOTAL_AMOUNT = h_total_amount
               WHERE PROJECT_ID = h_id
               AND ELEMENT_ID = h_id
               AND BUDGET_YEAR = h_budget_year
               AND CHARGECODE_ID = h_asset_id
               AND BUDGET_TYPE = h_budget_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 417+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(418) : assets.sql(10176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_BUDGET = ESTIMATED_BUDGET - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(439) : assets.sql(10197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET ESTIMATED_BUDGET = ESTIMATED_BUDGET - h_old_total_amount + h_total_amount
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 457+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(458) : assets.sql(10216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ESTIMATED_CROSS_CHARGE = ESTIMATED_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 476+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(477) : assets.sql(10235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_ACTUAL = ESTIMATED_ACTUAL - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 495+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(496) : assets.sql(10254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET ESTIMATED_ACTUAL = ESTIMATED_ACTUAL - h_old_total_amount + h_total_amount
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 514+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(515) : assets.sql(10273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET ACTUAL_CROSS_CHARGE = ACTUAL_CROSS_CHARGE - h_old_total_amount + h_total_amount
               WHERE ELEMENT_ID = h_asset_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 533+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(534) : assets.sql(10292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_PAID_BUDGET Then
            BEGIN
               UPDATE ASSET_CROSS_CHARGE
               SET ESTIMATED_PAID = ESTIMATED_PAID - h_old_total_amount + h_total_amount
               WHERE CROSS_CHARGE_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 552+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(553) : assets.sql(10311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET ESTIMATED_PAID_TODATE = ESTIMATED_PAID_TODATE - h_old_total_amount + h_total_amount
               WHERE BUDGET_ID = h_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 571+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(572) : assets.sql(10330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         null_return := FC_Rollup(h_id);
      End If;
   Else
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASSET_TIMEPHASE', 584+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASSET_TIMEPHASE(585) : assets.sql(10343) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_asset_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_asset_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 591+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(592) : assets.sql(10350) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASSET_TIMEPHASE', 603+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASSET_TIMEPHASE(604) : assets.sql(10362) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASSET_TIMEPHASE;
ALTER FUNCTION SP_U_ASSET_TIMEPHASE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_LOAD_ASSET_ATTR ==
CREATE OR REPLACE FUNCTION SP_LOAD_ASSET_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_resource_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      LoadAttr PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      LoadAssAttr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOAD_ASSET_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOAD_ASSET_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_LOAD_ASSET_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOAD_ASSET_ATTR(28) : assets.sql(10406) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOAD_ASSET_ATTR', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOAD_ASSET_ATTR(33) : assets.sql(10411) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ASSET_ATTR(36) : assets.sql(10414) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   --ATTRIBUTES
   If ((h_ids IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_ids, 'SYSTEM_ATTRIBUTES', 17) = 0) Then
      OPEN LoadAttr FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT,
      DELETED_COUNT, REC_STATUS, DESCRIPTION
      FROM TMT_ASSET_ATTRIBUTES
      WHERE RANK > '0000'
      AND RANK < 'qqqqqqqq'
      AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ASSET_ATTR(57) : assets.sql(10435) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadAttr;
   Else
      OPEN LoadAssAttr FOR SELECT A.LEVEL_ID, A.TYPE_ID, A.RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT,
      A.DELETED_COUNT, A.REC_STATUS, A.DESCRIPTION
      FROM TMT_ASSET_ATTRIBUTES A, TMT_ASSETS T
      WHERE A.RANK > '0000'
      AND A.RANK < 'qqqqqqqq'
      AND A.ELEMENT_ID = T.ELEMENT_ID
      ORDER BY A.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOAD_ASSET_ATTR', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOAD_ASSET_ATTR(69) : assets.sql(10447) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN LoadAssAttr;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ASSET_ATTR', 77+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ASSET_ATTR(78) : assets.sql(10456) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOAD_ASSET_ATTR', 89+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOAD_ASSET_ATTR(90) : assets.sql(10468) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOAD_ASSET_ATTR;
ALTER FUNCTION SP_LOAD_ASSET_ATTR COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset bubble and asset general/health pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_BUBBLE ==
CREATE OR REPLACE FUNCTION SP_ASSET_BUBBLE
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_temp_str VARCHAR2(100);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ViewsAssetBubble PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_BUBBLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_BUBBLE'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_BUBBLE(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_BUBBLE', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_BUBBLE(48) : assets.sql(10536) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_BUBBLE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_BUBBLE(53) : assets.sql(10541) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_BUBBLE', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_BUBBLE(56) : assets.sql(10544) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If (h_ids IS NULL) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(88) : assets.sql(10576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := PMO_STPU.strnpcpy(32, 32, Coalesce(h_count, 0) * 32+1, h_ids);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 108+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(109) : assets.sql(10597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
               SELECT T.ELEMENT_ID, T.TYPE_ID
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 133+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(134) : assets.sql(10622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   OPEN ViewsAssetBubble FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   T.ELEMENT_ID AS ASSET_ID,
   
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   (T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_TODATE,
   
   (T.EXPENSE_SCHED_COST - T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_FORECAST,
   
   COALESCE((SELECT SUM(ESTIMATED_BUDGET) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ESTIMATED_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_ACTUAL) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ACTUAL_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_PAID) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS PAID_CROSS_CHARGE,
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
   T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   (SELECT A.ELEMENT_NAME FROM TMT_GEOGRAPHIES AP, TMT_GEOGRAPHIES A
   WHERE AP.ELEMENT_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.PARENT_ID) AS GEOGRAPHY,
   
   (SELECT A.ELEMENT_NAME FROM ASSET_ORGANIZATIONS AP, TMT_ORGANIZATIONS A
   WHERE AP.ASSET_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.ORGANIZATION_ID) AS ORGANIZATION,
   
   '' AS ATTRIBUTE_INFO,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   
   T.CONVERTED_WEIGHT AS RATING, T.CONVERTED_SCORE AS SCORE,
   CASE WHEN T.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP, TMT_ASSETS T
   WHERE T.ELEMENT_ID = TMP.ASSET_ID
   
   UNION ALL --SINGLE ATTRIBUTES
   
   SELECT
   2 AS LEVEL_ID, 212 AS TYPE_ID, (P.RANK || '0000qq1#' || A.RANK) AS RANK, P.ELEMENT_ID AS PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   'S' || CHR(10) || RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || RTRIM(COALESCE(AP.DESCRIPTION,'')) || CHR(13) AS ATTRIBUTE_INFO,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   0 AS RATING, 0 AS SCORE, 0.00 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSET_ATTRIBUTES AP ON AP.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_ASSET_ATTRIBUTES A ON A.ELEMENT_ID = AP.PARENT_ID AND A.TYPE_ID = 144
   JOIN TMT_ASSET_ATTRIBUTES PA ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_ASSET_ATTRIBUTES GPA ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   UNION ALL --Multi_select ATTRIBUTES
   
   SELECT
   2 AS LEVEL_ID, 214 AS TYPE_ID, (P.RANK || '0000qq2#' || A.RANK) AS RANK, P.ELEMENT_ID AS PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   'M' || CHR(10) || RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || RTRIM(COALESCE(AP.DESCRIPTION,'')) || CHR(13) AS ATTRIBUTE_INFO,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   0 AS RATING, 0 AS SCORE, 0.00 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSET_ATTRIBUTES AP ON AP.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_ASSET_ATTRIBUTES A ON A.ELEMENT_ID = AP.PARENT_ID AND A.TYPE_ID = 15
   JOIN TMT_ASSET_ATTRIBUTES PA ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_ASSET_ATTRIBUTES GPA ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (P.RANK || '0000qq3#' || C.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, C.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   C.ELEMENT_NAME AS ATTRIBUTE_INFO,
   
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT,
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL -- Scorecard (category)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.RANK || '0000qq3#' || C.RANK || G.RANK) AS RANK, G.PARENT_ID, G.ELEMENT_ID, G.ELEMENT_NAME,
   G.CHILD_COUNT, G.DELETED_COUNT, G.REC_STATUS, G.REC_USER, G.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   '' AS GEOGRAPHY, '' AS ORGANIZATION,
   '' AS ATTRIBUTE_INFO,
   
   G.ORIGINAL_ID AS SCORECARD_ID, G.PUBLISHED_DT AS UPDATED_DT,
   G.CONVERTED_WEIGHT AS RATING, G.CONVERTED_SCORE AS SCORE,
   CASE WHEN G.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(G.CONVERTED_SCORE,18,2)/G.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   G.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   JOIN TMT_PUBLISHED_SCORECARDS G
   ON G.PROJECT_ID = P.ELEMENT_ID
   AND G.SCORECARD_ID = P.ELEMENT_ID
   AND G.TYPE_ID = PMO_CNST.SC_CATEGORY1
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_BUBBLE', 419+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_BUBBLE(420) : assets.sql(10908) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsAssetBubble;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 427+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(428) : assets.sql(10916) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_BUBBLE', 439+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_BUBBLE(440) : assets.sql(10928) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_BUBBLE;
ALTER FUNCTION SP_ASSET_BUBBLE COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset bubble and asset general/health pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_SCD ==
CREATE OR REPLACE FUNCTION SP_ASSET_SCD
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_temp_str VARCHAR2(100);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_estimated_baseline1_budget NUMBER := 0;
   h_estimated_baseline3_budget NUMBER := 0;
   h_estimated_actual_budget NUMBER := 0;
   h_estimated_etc_budget NUMBER := 0;
   h_estimated_baseline1_revenue NUMBER := 0;
   h_estimated_baseline3_revenue NUMBER := 0;
   h_estimated_actual_revenue NUMBER := 0;
   h_estimated_etc_revenue NUMBER := 0;
   h_estimated_effort NUMBER := 0;
   h_estimated_baseline1_effort NUMBER := 0;
   h_estimated_baseline3_effort NUMBER := 0;
   h_estimated_actual_effort NUMBER := 0;
   h_estimated_etc_effort NUMBER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ViewsAssetSCD PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_SCD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_SCD'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_SCD(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_SCD', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_SCD(48) : assets.sql(10996) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_SCD', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_SCD(53) : assets.sql(11001) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_SCD', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_SCD(56) : assets.sql(11004) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_type := p_type;
   h_ids := p_ids;
   h_resource_id := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If (h_ids IS NULL) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
         SELECT T.ELEMENT_ID, T.TYPE_ID
         FROM TMT_ASSETS T
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(88) : assets.sql(11036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := PMO_STPU.strnpcpy(32, 32, Coalesce(h_count, 0) * 32+1, h_ids);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 108+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(109) : assets.sql(11057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID)
               SELECT T.ELEMENT_ID, T.TYPE_ID
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 133+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(134) : assets.sql(11082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   OPEN ViewsAssetSCD FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   T.ELEMENT_ID AS ASSET_ID,
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   (T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_TODATE,
   
   (T.EXPENSE_SCHED_COST - T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_FORECAST,
   
   COALESCE((SELECT SUM(ESTIMATED_BUDGET) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ESTIMATED_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_ACTUAL) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ACTUAL_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_PAID) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS PAID_CROSS_CHARGE,
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   T.NEXT_SCHED_MAINT, T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   '' AS SCORECARD_ID, TO_TIMESTAMP('1899-12-30 8:00:00') AS UPDATED_DT,
   T.CONVERTED_WEIGHT AS RATING, T.CONVERTED_SCORE AS SCORE,
   CASE WHEN T.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(T.CONVERTED_SCORE,18,2)/T.CONVERTED_WEIGHT)*10000) ELSE 0.00 END AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP, TMT_ASSETS T
   WHERE T.ELEMENT_ID = TMP.ASSET_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   2 AS LEVEL_ID, S.TYPE_ID, (P.RANK || '0000qq3#' || C.RANK) AS RANK, S.PARENT_ID, S.ELEMENT_ID, C.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   S.ORIGINAL_ID AS SCORECARD_ID, S.PUBLISHED_DT AS UPDATED_DT,
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL -- Scorecard (category)
   
   SELECT
   3 AS LEVEL_ID, 223 AS TYPE_ID, (P.RANK || '0000qq3#' || C.RANK || G.RANK) AS RANK, G.PARENT_ID, G.ELEMENT_ID, G.ELEMENT_NAME,
   G.CHILD_COUNT, G.DELETED_COUNT, G.REC_STATUS, G.REC_USER, G.REC_DATETIME,
   P.ELEMENT_ID AS ASSET_ID,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   G.ORIGINAL_ID AS SCORECARD_ID, G.PUBLISHED_DT AS UPDATED_DT,
   G.CONVERTED_WEIGHT AS RATING, G.CONVERTED_SCORE AS SCORE,
   CASE WHEN G.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(G.CONVERTED_SCORE,18,2)/G.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   G.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW TMP
   JOIN TMT_ASSETS P ON P.ELEMENT_ID = TMP.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   JOIN TMT_PUBLISHED_SCORECARDS G
   ON G.PROJECT_ID = P.ELEMENT_ID
   AND G.SCORECARD_ID = P.ELEMENT_ID
   AND G.TYPE_ID = PMO_CNST.SC_CATEGORY1
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_SCD', 309+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_SCD(310) : assets.sql(11258) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ViewsAssetSCD;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 317+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(318) : assets.sql(11266) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_SCD', 329+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_SCD(330) : assets.sql(11278) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_SCD;
ALTER FUNCTION SP_ASSET_SCD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_BUILD_ASSET_ATTRS ==
CREATE OR REPLACE FUNCTION FC_BUILD_ASSET_ATTRS
(
     h_ids IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_asset_id VARCHAR2(32);
   h_prev_parent_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
   null_return LONG;
-- Declare Cursors
      CURSOR CAST_A IS
         SELECT  AST.ASSET_ID,
         RTRIM(CASE
         WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
         WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
         WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
         WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
         END || 
         RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
         RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
         GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
         RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13))
         FROM PMO_ASSET_VIEW AST
         JOIN TMT_ASSET_ATTRIBUTES P
         ON P.ELEMENT_ID = AST.ASSET_ID
         JOIN TMT_ASSET_ATTRIBUTES A
         ON A.ELEMENT_ID = P.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES PA
         ON PA.ELEMENT_ID = A.PARENT_ID
         JOIN TMT_ASSET_ATTRIBUTES GPA
         ON GPA.ELEMENT_ID = PA.PARENT_ID
         ORDER BY ASSET_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BUILD_ASSET_ATTRS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BUILD_ASSET_ATTRS'), '-- ' || SYSTIMESTAMP, ':r := FC_BUILD_ASSET_ATTRS(' || 
       '''' || h_ids || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_ASSET_ATTRS', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BUILD_ASSET_ATTRS(46) : assets.sql(11340) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   If (h_ids IS NULL) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
         SELECT ELEMENT_ID, TYPE_ID, RANK, ELEMENT_NAME
         FROM TMT_ASSETS
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(70) : assets.sql(11364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := PMO_STPU.strnpcpy(32, 32, Coalesce(h_count, 0) * 32+1, h_ids);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 90+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(91) : assets.sql(11385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
               SELECT T.ELEMENT_ID, T.TYPE_ID, T.RANK, T.ELEMENT_NAME
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 115+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(116) : assets.sql(11410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   null_return := FC_ROLLUP_ASSET();
   
   -- Build attribute list
   h_prev_parent_id := 'YY';
   
   OPEN CAST_A;
   
   LOOP
      FETCH CAST_A INTO h_asset_id, h_c_attr;
      IF CAST_A%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') = 0 Then
         h_prev_parent_id := h_asset_id;
         h_p_attr := h_c_attr;
      ElsIf PMO_ORASTD.strcmp(h_prev_parent_id, h_asset_id) = 0 Then
         h_p_attr := h_p_attr || h_c_attr;
      Else
         UPDATE PMO_ASSET_VIEW SET
                 ATTRIBUTES = NULL
            WHERE ASSET_ID = H_PREV_PARENT_ID;

         BEGIN
            UPDATE PMO_ASSET_VIEW
            SET ATTRIBUTES = h_p_attr
            WHERE ASSET_ID = h_prev_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(168) : assets.sql(11462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_prev_parent_id := h_asset_id;
         h_p_attr := h_c_attr;
      End If;
   END LOOP;
   BEGIN
      CLOSE CAST_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 184+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(185) : assets.sql(11479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_prev_parent_id, 'YY') <> 0 Then
      UPDATE PMO_ASSET_VIEW SET
              ATTRIBUTES = NULL
         WHERE ASSET_ID = H_PREV_PARENT_ID;

      BEGIN
         UPDATE PMO_ASSET_VIEW
         SET ATTRIBUTES = h_p_attr
         WHERE ASSET_ID = h_prev_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_ASSET_ATTRS', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_ASSET_ATTRS(209) : assets.sql(11503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_ASSET_ATTRS', 215+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_ASSET_ATTRS(216) : assets.sql(11510) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BUILD_ASSET_ATTRS;
ALTER FUNCTION FC_BUILD_ASSET_ATTRS COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset maintenance financial pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_MAINT_PIVOTS ==
CREATE OR REPLACE FUNCTION SP_ASSET_MAINT_PIVOTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_asset_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      MAINT_PIVOT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_MAINT_PIVOTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_MAINT_PIVOTS'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_MAINT_PIVOTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_MAINT_PIVOTS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_MAINT_PIVOTS(38) : assets.sql(11562) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_MAINT_PIVOTS', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_MAINT_PIVOTS(43) : assets.sql(11567) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_MAINT_PIVOTS', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_MAINT_PIVOTS(46) : assets.sql(11570) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If (p_start_date IS NULL) Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If (p_finish_date IS NULL) Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   null_return := FC_BUILD_ASSET_ATTRS(h_ids);
   
   OPEN MAINT_PIVOT FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0) AS MAINTENANCE_TODATE,
   
   
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0) AS MAINTENANCE_FORECAST,
   
   COALESCE((SELECT SUM(ESTIMATED_BUDGET) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ESTIMATED_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_ACTUAL) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS ACTUAL_CROSS_CHARGE,
   
   COALESCE((SELECT SUM(ESTIMATED_PAID) FROM ASSET_CROSS_CHARGE
   WHERE ASSET_ID = T.ELEMENT_ID), 0.00) AS PAID_CROSS_CHARGE,
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
   T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   T.FINANCIAL_CATEGORY,
   T.EXPENSE_SCHED_COST, T.EXPENSE_ACTUAL_COST, T.EXPENSE_COST_ETC,
   T.EXPENSE_SCHED_HOURS, T.EXPENSE_ACTUAL_HOURS, T.EXPENSE_HOURS_ETC,
   T.CAPITAL_SCHED_COST, T.CAPITAL_ACTUAL_COST, T.CAPITAL_COST_ETC,
   T.CAPITAL_SCHED_HOURS, T.CAPITAL_ACTUAL_HOURS, T.CAPITAL_HOURS_ETC,
   P.ATTRIBUTES,
   
   (SELECT A.ELEMENT_NAME FROM TMT_GEOGRAPHIES AP, TMT_GEOGRAPHIES A
   WHERE AP.ELEMENT_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.PARENT_ID) AS GEOGRAPHY,
   
   (SELECT A.ELEMENT_NAME FROM ASSET_ORGANIZATIONS AP, TMT_ORGANIZATIONS A
   WHERE AP.ASSET_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.ORGANIZATION_ID) AS ORGANIZATION,
   
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, TMT_ASSETS T
   WHERE T.ELEMENT_ID = P.ASSET_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   1 AS LEVEL_ID, S.TYPE_ID, (T.RANK || '0000' || C.RANK) AS RANK, T.ELEMENT_ID AS PARENT_ID, S.ELEMENT_ID, C.ELEMENT_NAME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE,
   0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   0 AS FINANCIAL_CATEGORY,
   0.00 AS EXPENSE_SCHED_COST,
   0.00 AS EXPENSE_ACTUAL_COST,
   0.00 AS EXPENSE_COST_ETC,
   0.00 AS EXPENSE_SCHED_HOURS,
   0.00 AS EXPENSE_ACTUAL_HOURS,
   0.00 AS EXPENSE_HOURS_ETC,
   0.00 AS CAPITAL_SCHED_COST,
   0.00 AS CAPITAL_ACTUAL_COST,
   0.00 AS CAPITAL_COST_ETC,
   0.00 AS CAPITAL_SCHED_HOURS,
   0.00 AS CAPITAL_ACTUAL_HOURS,
   0.00 AS CAPITAL_HOURS_ETC,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P
   JOIN TMT_ASSETS T ON T.ELEMENT_ID = P.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = T.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL   -- maintenances
   
   SELECT
   1 AS LEVEL_ID, P.TYPE_ID, (P.RANK || '0001') AS RANK, P.ASSET_ID AS PARENT_ID, '' AS ELEMENT_ID, P.ASSET_NAME AS ELEMENT_NAME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE,
   0.00 AS DEPRECIATION_REMAINING,
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   SUM(T.EXPENSE_ACTUAL_COST) AS MAINTENANCE_TODATE,
   SUM(T.EXPENSE_SCHED_COST) AS MAINTENANCE_FORECAST,
   0.00 AS ESTIMATED_CROSS_CHARGE,
   0.00 AS ACTUAL_CROSS_CHARGE,
   0.00 AS PAID_CROSS_CHARGE,
   
   AST.CATEGORY_ID, AST.MODEL, AST.MODEL_NUMBER, AST.STATUS_ID, 0.00 AS CONVERTED_SCORE,
   AST.SERIAL_NUMBER, AST.BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   AST.CONTACTOR, AST.CONTACTOR_PHONE, AST.CONTACTOR_EMAIL,
   
   T.FINANCIAL_CATEGORY,
   SUM(T.EXPENSE_SCHED_COST) AS EXPENSE_SCHED_COST,
   SUM(T.EXPENSE_ACTUAL_COST) AS EXPENSE_ACTUAL_COST,
   SUM(T.EXPENSE_COST_ETC) AS EXPENSE_COST_ETC,
   SUM(T.EXPENSE_SCHED_HOURS) AS EXPENSE_SCHED_HOURS,
   SUM(T.EXPENSE_ACTUAL_HOURS) AS EXPENSE_ACTUAL_HOURS,
   SUM(T.EXPENSE_HOURS_ETC) AS EXPENSE_HOURS_ETC,
   SUM(T.CAPITAL_SCHED_COST) AS CAPITAL_SCHED_COST,
   SUM(T.CAPITAL_ACTUAL_COST) AS CAPITAL_ACTUAL_COST,
   SUM(T.CAPITAL_COST_ETC) AS CAPITAL_COST_ETC,
   SUM(T.CAPITAL_SCHED_HOURS) AS CAPITAL_SCHED_HOURS,
   SUM(T.CAPITAL_ACTUAL_HOURS) AS CAPITAL_ACTUAL_HOURS,
   SUM(T.CAPITAL_HOURS_ETC) AS CAPITAL_HOURS_ETC,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, TMT_ASSETS T, TMT_ASSETS AST
   WHERE T.PARENT_ID = P.ASSET_ID
   AND T.TYPE_ID NOT IN (PMO_CNST.SC_FOLDER, PMO_CNST.SC_ASSETS)
   AND AST.ELEMENT_ID = P.ASSET_ID
   GROUP BY P.TYPE_ID, P.RANK, P.ASSET_ID, P.ASSET_NAME,
   T.FINANCIAL_CATEGORY, AST.CATEGORY_ID, AST.MODEL,
   AST.MODEL_NUMBER, AST.STATUS_ID, AST.SERIAL_NUMBER, AST.BARCODE_NUMBER,
   AST.CONTACTOR, AST.CONTACTOR_PHONE, AST.CONTACTOR_EMAIL
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_MAINT_PIVOTS', 264+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_MAINT_PIVOTS(265) : assets.sql(11789) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN MAINT_PIVOT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_MAINT_PIVOTS', 272+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_MAINT_PIVOTS(273) : assets.sql(11797) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_MAINT_PIVOTS', 284+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_MAINT_PIVOTS(285) : assets.sql(11809) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_MAINT_PIVOTS;
ALTER FUNCTION SP_ASSET_MAINT_PIVOTS COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset cross charge financial pivot

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_CC_PIVOTS ==
CREATE OR REPLACE FUNCTION SP_ASSET_CC_PIVOTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_asset_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CBBMONTH PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_CC_PIVOTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_CC_PIVOTS'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_CC_PIVOTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_CC_PIVOTS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_CC_PIVOTS(38) : assets.sql(11867) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_CC_PIVOTS', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_CC_PIVOTS(43) : assets.sql(11872) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_CC_PIVOTS', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_CC_PIVOTS(46) : assets.sql(11875) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If (p_start_date IS NULL) Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If (p_finish_date IS NULL) Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   null_return := FC_BUILD_ASSET_ATTRS(h_ids);
   
   OPEN CBBMONTH FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID, P.RANK, T.PARENT_ID, T.ELEMENT_ID, P.ASSET_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   
   
   T.DEPRECIATION_START, T.DEPRECIATION_FINISH, T.DEPRECIABLE_LIFE,
   TO_DATE(SYSDATE) AS CURRENT_DATE,
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_TODATE,
   
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE > TO_DATE(SYSDATE)), 0.00) AS DEPRECIATION_REMAINING,
   
   T.PURCHASE_PRICE AS INITIAL_COST,
   T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST AS CAPITAL_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID
   AND DEPRECIATION_DATE <= TO_DATE(SYSDATE)), 0)) AS CURRENT_VALUE,
   (T.PURCHASE_PRICE + T.CAPITAL_ACTUAL_COST -
   COALESCE((SELECT SUM(DEPRECIATION_AMOUNT) FROM ASSET_DEPRECIATION
   WHERE ASSET_ID = T.ELEMENT_ID), 0)) AS SALVAGE_VALUE,
   
   (T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID
   AND MAINTENANCE_DATE <= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_TODATE,
   
   (T.EXPENSE_SCHED_COST - T.EXPENSE_ACTUAL_COST +
   COALESCE((SELECT SUM(ESTIMATED_COST) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND COST <= 0
   AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)), 0)) AS MAINTENANCE_FORECAST,
   
   
   
   
   T.CATEGORY_ID, T.MODEL, T.MODEL_NUMBER, T.STATUS_ID, T.CONVERTED_SCORE,
   T.SERIAL_NUMBER, T.BARCODE_NUMBER, T.QUANTITY,
   T.WARRANTY_EXPIRY_DATE, T.LICENCE_EXPIRY_DATE,
   (SELECT MIN(MAINTENANCE_DATE) FROM ASSET_MAINTENANCE
   WHERE ASSET_ID = T.ELEMENT_ID AND MAINTENANCE_DATE >= TO_DATE(SYSDATE)) AS NEXT_SCHED_MAINT,
   T.DATE_SOLD,
   T.DATE_ACQUIRED,
   T.CONTACTOR, T.CONTACTOR_PHONE, T.CONTACTOR_EMAIL,
   
   P.ATTRIBUTES,
   
   (SELECT A.ELEMENT_NAME FROM TMT_GEOGRAPHIES AP, TMT_GEOGRAPHIES A
   WHERE AP.ELEMENT_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.PARENT_ID) AS GEOGRAPHY,
   
   (SELECT A.ELEMENT_NAME FROM ASSET_ORGANIZATIONS AP, TMT_ORGANIZATIONS A
   WHERE AP.ASSET_ID = T.ELEMENT_ID
   AND A.ELEMENT_ID = AP.ORGANIZATION_ID) AS ORGANIZATION,
   
   PMO_ORASTD.YEAR(h_finish_date) AS PROJECT_YEAR,
   
   '' AS PROJECT_CLIENT_ID,
   '' AS PROJECT_CLIENT_NAME,
   0 AS CROSS_CHARGE_QUANTITY, 0 AS CROSS_CHARGE_CATEGORY,
   TO_DATE('1899-12-30') AS CROSS_CHARGE_START, TO_DATE('1899-12-30') AS CROSS_CHARGE_FINISH,
   0.00 AS CROSS_CHARGE_UNIT_PRICE,
   
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, TMT_ASSETS T
   WHERE T.ELEMENT_ID = P.ASSET_ID
   
   UNION ALL -- Scorecards
   
   SELECT
   1 AS LEVEL_ID, S.TYPE_ID, (T.RANK || '00000000' || C.RANK) AS RANK, T.ELEMENT_ID AS PARENT_ID, S.ELEMENT_ID, P.ASSET_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE,
   0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   0 AS PROJECT_YEAR,
   S.ELEMENT_ID AS PROJECT_CLIENT_ID,
   C.ELEMENT_NAME AS PROJECT_CLIENT_NAME,
   
   0 AS CROSS_CHARGE_QUANTITY, 0 AS CROSS_CHARGE_CATEGORY,
   TO_DATE('1899-12-30') AS CROSS_CHARGE_START, TO_DATE('1899-12-30') AS CROSS_CHARGE_FINISH,
   0.00 AS CROSS_CHARGE_UNIT_PRICE,
   
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   
   S.CONVERTED_WEIGHT AS RATING, S.CONVERTED_SCORE AS SCORE,
   CASE WHEN S.CONVERTED_WEIGHT = 0 THEN 0
   ELSE PMO_ORASTD.TODECIMAL((PMO_ORASTD.TODECIMAL(S.CONVERTED_SCORE,18,2)/S.CONVERTED_WEIGHT*100.00),5,2) END AS RATING_SCORE,
   S.MAJOR_REVISION AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P
   JOIN TMT_ASSETS T ON T.ELEMENT_ID = P.ASSET_ID
   JOIN TMT_ASSIGNED_SCORECARDS C
   ON C.PROJECT_ID = T.ELEMENT_ID
   AND C.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND C.MAJOR_REVISION > 0
   AND C.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS PS
   ON PS.PROJECT_ID = C.PROJECT_ID
   AND PS.ELEMENT_ID = C.ELEMENT_ID
   AND PS.PARENT_RANK LIKE 'AST#' || '%'
   JOIN HISTORY_PUBLISHED_SCORECARDS S
   ON S.PROJECT_ID = C.PROJECT_ID
   AND S.ELEMENT_ID = C.ELEMENT_ID
   AND S.MAJOR_REVISION = C.MAJOR_REVISION
   
   UNION ALL       -- timephase (assigned project)
   
   SELECT
   1 AS LEVEL_ID, W.TYPE_ID, RTRIM(P.RANK) || '00000001' || RTRIM(W.RANK) || TO_CHAR(PBB.BUDGET_YEAR) AS RANK, W.PARENT_ID, W.ELEMENT_ID, P.ASSET_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   PBB.BUDGET_YEAR AS PROJECT_YEAR,
   PBB.PROJECT_ID AS PROJECT_CLIENT_ID,
   W.ELEMENT_NAME AS PROJECT_CLIENT_NAME,
   
   ACC.QUANTITY AS CROSS_CHARGE_QUANTITY, ACC.ASSET_CHARGE_TYPE AS CROSS_CHARGE_CATEGORY,
   ACC.START_DATE AS CROSS_CHARGE_START, ACC.FINISH_DATE AS CROSS_CHARGE_FINISH,
   ACC.UNIT_PRICE AS CROSS_CHARGE_UNIT_PRICE,
   
   PBB.BUDGET_TYPE,
   PBB.MONTH_01_AMOUNT AS AMOUNT_01,
   PBB.MONTH_02_AMOUNT AS AMOUNT_02,
   PBB.MONTH_03_AMOUNT AS AMOUNT_03,
   PBB.MONTH_04_AMOUNT AS AMOUNT_04,
   PBB.MONTH_05_AMOUNT AS AMOUNT_05,
   PBB.MONTH_06_AMOUNT AS AMOUNT_06,
   PBB.MONTH_07_AMOUNT AS AMOUNT_07,
   PBB.MONTH_08_AMOUNT AS AMOUNT_08,
   PBB.MONTH_09_AMOUNT AS AMOUNT_09,
   PBB.MONTH_10_AMOUNT AS AMOUNT_10,
   PBB.MONTH_11_AMOUNT AS AMOUNT_11,
   PBB.MONTH_12_AMOUNT AS AMOUNT_12,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, ASSET_CROSS_CHARGE ACC, TMT_WBS W, PROJECT_BUDGET_BREAKDOWN PBB
   WHERE ACC.ASSET_ID = P.ASSET_ID
   AND W.PROJECT_ID = ACC.PROJECT_CLIENT_ID
   AND W.ELEMENT_ID = ACC.PROJECT_CLIENT_ID
   AND PBB.PROJECT_ID = ACC.PROJECT_CLIENT_ID
   AND PBB.ELEMENT_ID = ACC.PROJECT_CLIENT_ID
   AND PBB.CHARGECODE_ID = P.ASSET_ID
   AND PBB.BUDGET_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10)))
   AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
   
   UNION ALL       -- timephase (assigned clients)
   
   SELECT
   1 AS LEVEL_ID, W.TYPE_ID, RTRIM(P.RANK) || '00000002' || RTRIM(W.RANK) || TO_CHAR(PBB.ENTRY_YEAR) AS RANK, W.PARENT_ID, W.ELEMENT_ID, P.ASSET_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   
   TO_DATE('1899-12-30') AS DEPRECIATION_START, TO_DATE('1899-12-30') AS DEPRECIATION_FINISH, 0 AS DEPRECIABLE_LIFE,
   TO_DATE('1899-12-30') AS CURRENT_DATE,
   0.00 AS DEPRECIATION_TODATE, 0.00 AS DEPRECIATION_REMAINING,
   
   0.00 AS INITIAL_COST,
   0.00 AS CAPITAL_VALUE,
   0.00 AS CURRENT_VALUE,
   0.00 AS SALVAGE_VALUE,
   
   0.00 AS MAINTENANCE_TODATE,
   0.00 AS MAINTENANCE_FORECAST,
   
   
   0 AS CATEGORY_ID, '' AS MODEL, '' AS MODEL_NUMBER, 0 AS STATUS_ID, 0 AS CONVERTED_SCORE,
   '' AS SERIAL_NUMBER, '' AS BARCODE_NUMBER, 0 AS QUANTITY,
   TO_DATE('1899-12-30') AS WARRANTY_EXPIRY_DATE, TO_DATE('1899-12-30') AS LICENCE_EXPIRY_DATE,
   TO_DATE('1899-12-30') AS NEXT_SCHED_MAINT, TO_DATE('1899-12-30') AS DATE_SOLD,
   TO_DATE('1899-12-30') AS DATE_ACQUIRED,
   '' AS CONTACTOR, '' AS CONTACTOR_PHONE, '' AS CONTACTOR_EMAIL,
   
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS GEOGRAPHY,
   '' AS ORGANIZATION,
   
   PBB.ENTRY_YEAR AS PROJECT_YEAR,
   PBB.PROJECT_ID AS PROJECT_CLIENT_ID,
   W.ELEMENT_NAME AS PROJECT_CLIENT_NAME,
   
   ACC.QUANTITY AS CROSS_CHARGE_QUANTITY, ACC.ASSET_CHARGE_TYPE AS CROSS_CHARGE_CATEGORY,
   ACC.START_DATE AS CROSS_CHARGE_START, ACC.FINISH_DATE AS CROSS_CHARGE_FINISH,
   ACC.UNIT_PRICE AS CROSS_CHARGE_UNIT_PRICE,
   
   PBB.ENTRY_TYPE AS BUDGET_TYPE,
   PBB.MONTH_01_AMOUNT AS AMOUNT_01,
   PBB.MONTH_02_AMOUNT AS AMOUNT_02,
   PBB.MONTH_03_AMOUNT AS AMOUNT_03,
   PBB.MONTH_04_AMOUNT AS AMOUNT_04,
   PBB.MONTH_05_AMOUNT AS AMOUNT_05,
   PBB.MONTH_06_AMOUNT AS AMOUNT_06,
   PBB.MONTH_07_AMOUNT AS AMOUNT_07,
   PBB.MONTH_08_AMOUNT AS AMOUNT_08,
   PBB.MONTH_09_AMOUNT AS AMOUNT_09,
   PBB.MONTH_10_AMOUNT AS AMOUNT_10,
   PBB.MONTH_11_AMOUNT AS AMOUNT_11,
   PBB.MONTH_12_AMOUNT AS AMOUNT_12,
   0 AS RATING, 0 AS SCORE,
   0 AS RATING_SCORE,
   0 AS SCORECARD_VERSION
   FROM PMO_ASSET_VIEW P, PROJECT_CHARGEBACK_BREAKDOWN PBB, TMT_CLIENTS W, ASSET_CROSS_CHARGE ACC
   WHERE PBB.PROJECT_ID = P.ASSET_ID
   AND PBB.ENTRY_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10)))
   AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
   AND W.ELEMENT_ID = PBB.CLIENT_ID
   AND ACC.ASSET_ID = P.ASSET_ID
   AND ACC.PROJECT_CLIENT_ID = W.ELEMENT_ID
   
   ORDER BY RANK, PROJECT_YEAR, BUDGET_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_CC_PIVOTS', 355+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_CC_PIVOTS(356) : assets.sql(12185) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CBBMONTH;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_CC_PIVOTS', 363+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_CC_PIVOTS(364) : assets.sql(12193) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_CC_PIVOTS', 375+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_CC_PIVOTS(376) : assets.sql(12205) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_CC_PIVOTS;
ALTER FUNCTION SP_ASSET_CC_PIVOTS COMPILE DEBUG;

/****************************************************************************************/

-- This sp is used for asset deprciation pivot. It has to be used with SP_ASSET_CC_PIVOTS.

/****************************************************************************************/

Prompt == FUNCTION SP_ASSET_DEPR_PIVOTS ==
CREATE OR REPLACE FUNCTION SP_ASSET_DEPR_PIVOTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_asset_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_total PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CDEPRPIVOT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSET_DEPR_PIVOTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSET_DEPR_PIVOTS'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSET_DEPR_PIVOTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_DEPR_PIVOTS', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSET_DEPR_PIVOTS(36) : assets.sql(12261) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSET_DEPR_PIVOTS', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSET_DEPR_PIVOTS(41) : assets.sql(12266) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_DEPR_PIVOTS', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_DEPR_PIVOTS(44) : assets.sql(12269) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If (p_start_date IS NULL) Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If (p_finish_date IS NULL) Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_ASSET_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPR_MAINT';
   PMO_DB2M.SC_STATE := 0;
   
   If (h_ids IS NULL) Then
      BEGIN
         INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
         SELECT ELEMENT_ID, TYPE_ID, RANK, ELEMENT_NAME
         FROM TMT_ASSETS
         WHERE TYPE_ID = PMO_CNST.SC_ASSETS
         AND TRACKED_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(92) : assets.sql(12317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := PMO_STPU.strnpcpy(32, 32, Coalesce(h_count, 0) * 32+1, h_ids);
         h_id := h_id;
         
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSETS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 112+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(113) : assets.sql(12338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               INSERT INTO PMO_ASSET_VIEW (ASSET_ID, TYPE_ID, RANK, ASSET_NAME)
               SELECT T.ELEMENT_ID, T.TYPE_ID, T.RANK, T.ELEMENT_NAME
               FROM TMT_ASSETS T
               WHERE T.TYPE_ID = PMO_CNST.SC_ASSETS
               AND T.TRACKED_FLAG = 'Y'
               AND T.RANK LIKE h_rank || '%'
               AND NOT EXISTS(SELECT V.ASSET_ID FROM PMO_ASSET_VIEW V
               WHERE V.ASSET_ID = T.ELEMENT_ID);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 137+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(138) : assets.sql(12363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 3, PBB.BUDGET_YEAR, FC.FISCAL_MONTH,
      CASE WHEN FC.FISCAL_MONTH = 1 THEN PBB.MONTH_01_AMOUNT
      WHEN FC.FISCAL_MONTH = 2 THEN PBB.MONTH_02_AMOUNT
      WHEN FC.FISCAL_MONTH = 3 THEN PBB.MONTH_03_AMOUNT
      WHEN FC.FISCAL_MONTH = 4 THEN PBB.MONTH_04_AMOUNT
      WHEN FC.FISCAL_MONTH = 5 THEN PBB.MONTH_05_AMOUNT
      WHEN FC.FISCAL_MONTH = 6 THEN PBB.MONTH_06_AMOUNT
      WHEN FC.FISCAL_MONTH = 7 THEN PBB.MONTH_07_AMOUNT
      WHEN FC.FISCAL_MONTH = 8 THEN PBB.MONTH_08_AMOUNT
      WHEN FC.FISCAL_MONTH = 9 THEN PBB.MONTH_09_AMOUNT
      WHEN FC.FISCAL_MONTH = 10 THEN PBB.MONTH_10_AMOUNT
      WHEN FC.FISCAL_MONTH = 11 THEN PBB.MONTH_11_AMOUNT
      ELSE PBB.MONTH_12_AMOUNT END
      FROM PMO_ASSET_VIEW P, TMT_ASSETS C, TMT_WBS W, BUDGETS B, TMT_CHARGECODES CC,
      PROJECT_BUDGET_BREAKDOWN PBB, FISCAL_CALENDAR FC
      WHERE C.PARENT_ID = P.ASSET_ID
      AND C.TYPE_ID NOT IN (PMO_CNST.SC_ASSETS, PMO_CNST.SC_FOLDER)
      AND (C.EXPENSE_ACTUAL_COST + C.CAPITAL_ACTUAL_COST) > 0
      AND W.ELEMENT_ID = C.ELEMENT_ID
      AND B.PROJECT_ID = W.PROJECT_ID
      AND B.ELEMENT_ID = W.ELEMENT_ID
      AND B.CHARGECODE_ID = CC.ELEMENT_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      AND CC.ELEMENT_ID NOT IN ('EXPENSE_HOURS', 'CAPITAL_HOURS')
      AND PBB.PROJECT_ID = W.PROJECT_ID
      AND PBB.CHARGECODE_ID = CC.ELEMENT_ID
      AND PBB.ELEMENT_ID = C.ELEMENT_ID
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND PBB.BUDGET_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10)))
      AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
      AND PBB.BUDGET_YEAR = FC.FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 189+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(190) : assets.sql(12415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 1, FC.FISCAL_YEAR, FC.FISCAL_MONTH, DEPR.DEPRECIATION_AMOUNT
      FROM PMO_ASSET_VIEW P, ASSET_DEPRECIATION DEPR, FISCAL_CALENDAR FC
      WHERE DEPR.ASSET_ID = P.ASSET_ID
      AND DEPR.DEPRECIATION_DATE BETWEEN FC.START_DATE AND FC.FINISH_DATE
      AND FC.FISCAL_YEAR BETWEEN PMO_ORASTD.YEAR(h_start_date) AND PMO_ORASTD.YEAR(h_finish_date);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(212) : assets.sql(12437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 2, FC.FISCAL_YEAR, FC.FISCAL_MONTH, MAINT.ESTIMATED_COST
      FROM PMO_ASSET_VIEW P, ASSET_MAINTENANCE MAINT, FISCAL_CALENDAR FC
      WHERE MAINT.ASSET_ID = P.ASSET_ID
      AND MAINT.MAINTENANCE_DATE BETWEEN FC.START_DATE AND FC.FINISH_DATE
      AND FC.FISCAL_YEAR BETWEEN PMO_ORASTD.YEAR(h_start_date) AND PMO_ORASTD.YEAR(h_finish_date);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 233+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(234) : assets.sql(12459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DEPR_MAINT (ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH, MONTHLY_AMOUNT)
      SELECT P.ASSET_ID, 3, FC.FISCAL_YEAR, FC.FISCAL_MONTH, MAINT.COST
      FROM PMO_ASSET_VIEW P, ASSET_MAINTENANCE MAINT, FISCAL_CALENDAR FC
      WHERE MAINT.ASSET_ID = P.ASSET_ID
      AND MAINT.MAINTENANCE_DATE BETWEEN FC.START_DATE AND FC.FINISH_DATE
      AND FC.FISCAL_YEAR BETWEEN PMO_ORASTD.YEAR(h_start_date) AND PMO_ORASTD.YEAR(h_finish_date);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 255+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(256) : assets.sql(12481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CDEPRPIVOT FOR SELECT ASSET_ID, TYPE_ID, FISCAL_YEAR AS DEPRECIATION_YEAR,
   FISCAL_MONTH AS DEPRECIATION_MONTH,
   SUM(MONTHLY_AMOUNT) AS DEPRECIATION_AMOUNT
   FROM PMO_DEPR_MAINT
   GROUP BY ASSET_ID, TYPE_ID, FISCAL_YEAR, FISCAL_MONTH;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSET_DEPR_PIVOTS', 266+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ASSET_DEPR_PIVOTS(267) : assets.sql(12492) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CDEPRPIVOT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 274+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(275) : assets.sql(12500) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSET_DEPR_PIVOTS', 286+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSET_DEPR_PIVOTS(287) : assets.sql(12512) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSET_DEPR_PIVOTS;
ALTER FUNCTION SP_ASSET_DEPR_PIVOTS COMPILE DEBUG;

