/***************************************************************************************/

Prompt == FUNCTION FC_C_LOCAL_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTR_WBSA
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_old_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_multi_select VARCHAR2(1);
   h_description VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_parent_level_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CWBS0011 IS
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_WBS_ATTRIBUTES
         WHERE (RANK LIKE h_rank || '%' AND LEVEL_ID > 1
         AND (TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE,PMO_CNST.SC_CLASSIFICATION,PMO_CNST.SC_CATEGORY1,PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS,PMO_CNST.SC_CATEGORY1_MS)
         OR ELEMENT_ID = h_old_project_id))
         
         UNION
         
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_project_id AND LOCAL = 'N'
         
         ORDER BY LOCAL,RANK;

      CURSOR CWBS0011a IS
         SELECT  MAX_RANK+1,CHILD_COUNT + 1 ,LEVEL_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id
         ORDER BY LEVEL_ID ASC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTR_WBSA(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTR_WBSA(58) : attr2.sql(61) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_old_project_id AND LEVEL_ID = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(71) : attr2.sql(74) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_WBSA(78) : attr2.sql(81) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   --  trace_printf("ppppppppppp111-------->h_rank:%s\n",h_rank);
   --  trace_printf("ppppppppppp222-------->h_old_project_id:%s\n",h_old_project_id);
   
   OPEN CWBS0011;
   
   LOOP
      FETCH CWBS0011 INTO h_temp_rank,h_old_element_id, h_name, h_parent_id, h_multi_select, h_description, h_type_id,h_level_id,h_local,h_parent_name,h_input_type;
      IF CWBS0011%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      If SubStr(h_local, 1, 1) = 'N' Then
         h_element_id := h_new_project_id;
      Else
         If PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_element_id := h_new_project_id;
         Else
            h_uniqueID := SYS_GUID();
            h_element_id := h_uniqueID;
         End If;
         --IF CURRENT ITEM IS DIRECTLY UNDER PROJECT RECORD,PARENT_ID WILL BE NEW PROJECT
         --otherwise it must be in our temorary table
         If PMO_ORASTD.strcmp(h_parent_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_parent_id := h_new_project_id;
         Else
            BEGIN
               SELECT NEW_ELEMENT_ID INTO h_parent_id FROM PMO_COPY_DEFAULT_ATTRIBUTE WHERE OLD_ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(121) : attr2.sql(124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      OPEN CWBS0011a;
      
      FETCH CWBS0011a INTO  h_max_rank,h_child_count,h_parent_level_id;
      IF CWBS0011a%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET MAX_RANK =  h_max_rank,
         CHILD_COUNT = h_child_count
         WHERE ELEMENT_ID = h_parent_id AND level_id = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(152) : attr2.sql(155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         CLOSE CWBS0011a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(165) : attr2.sql(168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, MULTI_SELECT,DESCRIPTION, LOCAL, REC_USER,PARENT_NAME,INPUT_TYPE)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_element_id, h_name, h_type_id,
         h_level_id,h_multi_select,h_description, h_local, h_rec_user,h_parent_name,h_input_type
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id AND LEVEL_ID = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(188) : attr2.sql(191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_local, 1, 1) = 'Y' AND (PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) <> 0) Then
         BEGIN
            INSERT INTO PMO_COPY_DEFAULT_ATTRIBUTE(OLD_ELEMENT_ID, NEW_ELEMENT_ID,TYPE_ID) VALUES(h_old_element_id,h_element_id,h_type_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(206) : attr2.sql(209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CWBS0011;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_WBSA', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_WBSA(220) : attr2.sql(223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_WBSA(226) : attr2.sql(229) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_WBSA', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_WBSA(230) : attr2.sql(233) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTR_WBSA;
ALTER FUNCTION FC_C_LOCAL_ATTR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_LOCAL_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTR_CRIA
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_old_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_multi_select VARCHAR2(1);
   h_description VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_parent_level_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CCRI0011 IS
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_CRI_ATTRIBUTES
         WHERE (RANK LIKE h_rank || '%' AND LEVEL_ID > 1
         AND (TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE,PMO_CNST.SC_CLASSIFICATION,PMO_CNST.SC_CATEGORY1,PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS,PMO_CNST.SC_CATEGORY1_MS)
         OR ELEMENT_ID = h_old_project_id))
         
         UNION
         
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_project_id AND LOCAL = 'N'
         
         ORDER BY LOCAL,RANK;

      CURSOR CCRI0011a IS
         SELECT  MAX_RANK+1,CHILD_COUNT + 1 ,LEVEL_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id
         ORDER BY LEVEL_ID ASC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTR_CRIA(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTR_CRIA(58) : attr2.sql(301) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_old_project_id AND LEVEL_ID = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(71) : attr2.sql(314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_CRIA(78) : attr2.sql(321) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   --  trace_printf("ppppppppppp111-------->h_rank:%s\n",h_rank);
   --  trace_printf("ppppppppppp222-------->h_old_project_id:%s\n",h_old_project_id);
   
   OPEN CCRI0011;
   
   LOOP
      FETCH CCRI0011 INTO h_temp_rank,h_old_element_id, h_name, h_parent_id, h_multi_select, h_description, h_type_id,h_level_id,h_local,h_parent_name,h_input_type;
      IF CCRI0011%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      If SubStr(h_local, 1, 1) = 'N' Then
         h_element_id := h_new_project_id;
      Else
         If PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_element_id := h_new_project_id;
         Else
            h_uniqueID := SYS_GUID();
            h_element_id := h_uniqueID;
         End If;
         --IF CURRENT ITEM IS DIRECTLY UNDER PROJECT RECORD,PARENT_ID WILL BE NEW PROJECT
         --otherwise it must be in our temorary table
         If PMO_ORASTD.strcmp(h_parent_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_parent_id := h_new_project_id;
         Else
            BEGIN
               SELECT NEW_ELEMENT_ID INTO h_parent_id FROM PMO_COPY_DEFAULT_ATTRIBUTE WHERE OLD_ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(121) : attr2.sql(364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      OPEN CCRI0011a;
      
      FETCH CCRI0011a INTO  h_max_rank,h_child_count,h_parent_level_id;
      IF CCRI0011a%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET MAX_RANK =  h_max_rank,
         CHILD_COUNT = h_child_count
         WHERE ELEMENT_ID = h_parent_id AND level_id = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(152) : attr2.sql(395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         CLOSE CCRI0011a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(165) : attr2.sql(408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, MULTI_SELECT,DESCRIPTION, LOCAL, REC_USER,PARENT_NAME,INPUT_TYPE)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_element_id, h_name, h_type_id,
         h_level_id,h_multi_select,h_description, h_local, h_rec_user,h_parent_name,h_input_type
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id AND LEVEL_ID = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(188) : attr2.sql(431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_local, 1, 1) = 'Y' AND (PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) <> 0) Then
         BEGIN
            INSERT INTO PMO_COPY_DEFAULT_ATTRIBUTE(OLD_ELEMENT_ID, NEW_ELEMENT_ID,TYPE_ID) VALUES(h_old_element_id,h_element_id,h_type_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(206) : attr2.sql(449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CCRI0011;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_CRIA', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_CRIA(220) : attr2.sql(463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_CRIA(226) : attr2.sql(469) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_CRIA', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_CRIA(230) : attr2.sql(473) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTR_CRIA;
ALTER FUNCTION FC_C_LOCAL_ATTR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_LOCAL_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTR_DOCUMENT
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_old_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_multi_select VARCHAR2(1);
   h_description VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_parent_level_id PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CDC0011 IS
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE (RANK LIKE h_rank || '%' AND LEVEL_ID > 1
         AND (TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE,PMO_CNST.SC_CLASSIFICATION,PMO_CNST.SC_CATEGORY1,PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS,PMO_CNST.SC_CATEGORY1_MS)
         OR ELEMENT_ID = h_old_project_id))
         
         UNION
         
         SELECT RANK,ELEMENT_ID,ELEMENT_NAME,PARENT_ID ,MULTI_SELECT,DESCRIPTION,TYPE_ID,LEVEL_ID,LOCAL,PARENT_NAME,INPUT_TYPE
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_project_id AND LOCAL = 'N'
         
         ORDER BY LOCAL,RANK;

      CURSOR CDC0011a IS
         SELECT  MAX_RANK+1,CHILD_COUNT + 1 ,LEVEL_ID
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id
         ORDER BY LEVEL_ID ASC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTR_DOCUMENT(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTR_DOCUMENT(58) : attr2.sql(541) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_old_project_id AND LEVEL_ID = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(71) : attr2.sql(554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_DOCUMENT(78) : attr2.sql(561) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   --  trace_printf("ppppppppppp111-------->h_rank:%s\n",h_rank);
   --  trace_printf("ppppppppppp222-------->h_old_project_id:%s\n",h_old_project_id);
   
   OPEN CDC0011;
   
   LOOP
      FETCH CDC0011 INTO h_temp_rank,h_old_element_id, h_name, h_parent_id, h_multi_select, h_description, h_type_id,h_level_id,h_local,h_parent_name,h_input_type;
      IF CDC0011%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      If SubStr(h_local, 1, 1) = 'N' Then
         h_element_id := h_new_project_id;
      Else
         If PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_element_id := h_new_project_id;
         Else
            h_uniqueID := SYS_GUID();
            h_element_id := h_uniqueID;
         End If;
         --IF CURRENT ITEM IS DIRECTLY UNDER PROJECT RECORD,PARENT_ID WILL BE NEW PROJECT
         --otherwise it must be in our temorary table
         If PMO_ORASTD.strcmp(h_parent_id, h_old_project_id) = PMO_CNST.SC_MATCH Then
            h_parent_id := h_new_project_id;
         Else
            BEGIN
               SELECT NEW_ELEMENT_ID INTO h_parent_id FROM PMO_COPY_DEFAULT_ATTRIBUTE WHERE OLD_ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 120+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(121) : attr2.sql(604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      OPEN CDC0011a;
      
      FETCH CDC0011a INTO  h_max_rank,h_child_count,h_parent_level_id;
      IF CDC0011a%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET MAX_RANK =  h_max_rank,
         CHILD_COUNT = h_child_count
         WHERE ELEMENT_ID = h_parent_id AND level_id = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(152) : attr2.sql(635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         CLOSE CDC0011a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(165) : attr2.sql(648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, MULTI_SELECT,DESCRIPTION, LOCAL, REC_USER,PARENT_NAME,INPUT_TYPE)
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_element_id, h_name, h_type_id,
         h_level_id,h_multi_select,h_description, h_local, h_rec_user,h_parent_name,h_input_type
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_parent_id AND LEVEL_ID = h_parent_level_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(188) : attr2.sql(671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_local, 1, 1) = 'Y' AND (PMO_ORASTD.strcmp(h_old_element_id, h_old_project_id) <> 0) Then
         BEGIN
            INSERT INTO PMO_COPY_DEFAULT_ATTRIBUTE(OLD_ELEMENT_ID, NEW_ELEMENT_ID,TYPE_ID) VALUES(h_old_element_id,h_element_id,h_type_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(206) : attr2.sql(689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE CDC0011;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_LOCAL_ATTR_DOCUMENT', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_LOCAL_ATTR_DOCUMENT(220) : attr2.sql(703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 225+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_DOCUMENT(226) : attr2.sql(709) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTR_DOCUMENT', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTR_DOCUMENT(230) : attr2.sql(713) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTR_DOCUMENT;
ALTER FUNCTION FC_C_LOCAL_ATTR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_DEFAULT_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CWBS0010 IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES A
         WHERE ELEMENT_ID = h_project_id AND LEVEL_ID > 1
         AND TYPE_ID = h_type
         AND ( PARENT_ID NOT IN
         (SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES B
         WHERE ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND TYPE_ID = h_type));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_WBSA', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTR_WBSA(43) : attr2.sql(766) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   --Define cursor on  default attributes to get the attribute_id
   
   OPEN CWBS0010;
   
   LOOP
      FETCH CWBS0010 INTO h_attr_id;
      IF CWBS0010%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,DESCRIPTION)
         SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, A.LEVEL_ID + 1, A.LOCAL,
         h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME,B.DESCRIPTION
         FROM TMT_WBS_ATTRIBUTES A ,TMT_WBS_ATTRIBUTES B
         WHERE A.ELEMENT_ID = h_attr_id
         AND A.ELEMENT_ID = B.PARENT_ID
         AND B.ELEMENT_ID = h_project_id
         AND B.TYPE_ID = h_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_WBSA', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_WBSA(87) : attr2.sql(810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CWBS0010;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_WBSA', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_WBSA(100) : attr2.sql(823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_A_DEFAULT SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_WBSA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_WBSA(106) : attr2.sql(829) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_WBSA', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_WBSA(110) : attr2.sql(833) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTR_WBSA;
ALTER FUNCTION FC_A_DEFAULT_ATTR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_DEFAULT_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CCRI0010 IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES A
         WHERE ELEMENT_ID = h_project_id AND LEVEL_ID > 1
         AND TYPE_ID = h_type
         AND ( PARENT_ID NOT IN
         (SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES B
         WHERE ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND TYPE_ID = h_type));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_CRIA', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTR_CRIA(43) : attr2.sql(886) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   --Define cursor on  default attributes to get the attribute_id
   
   OPEN CCRI0010;
   
   LOOP
      FETCH CCRI0010 INTO h_attr_id;
      IF CCRI0010%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,DESCRIPTION)
         SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, A.LEVEL_ID + 1, A.LOCAL,
         h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME,B.DESCRIPTION
         FROM TMT_CRI_ATTRIBUTES A ,TMT_CRI_ATTRIBUTES B
         WHERE A.ELEMENT_ID = h_attr_id
         AND A.ELEMENT_ID = B.PARENT_ID
         AND B.ELEMENT_ID = h_project_id
         AND B.TYPE_ID = h_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_CRIA', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_CRIA(87) : attr2.sql(930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CCRI0010;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_CRIA', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_CRIA(100) : attr2.sql(943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_A_DEFAULT SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_CRIA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_CRIA(106) : attr2.sql(949) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_CRIA', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_CRIA(110) : attr2.sql(953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTR_CRIA;
ALTER FUNCTION FC_A_DEFAULT_ATTR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CDC0010 IS
         SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES A
         WHERE ELEMENT_ID = h_project_id AND LEVEL_ID > 1
         AND TYPE_ID = h_type
         AND ( PARENT_ID NOT IN
         (SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES B
         WHERE ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND TYPE_ID = h_type));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_DOCUMENT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTR_DOCUMENT(43) : attr2.sql(1006) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   --Define cursor on  default attributes to get the attribute_id
   
   OPEN CDC0010;
   
   LOOP
      FETCH CDC0010 INTO h_attr_id;
      IF CDC0010%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,DESCRIPTION)
         SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, A.LEVEL_ID + 1, A.LOCAL,
         h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME,B.DESCRIPTION
         FROM TMT_DOCUMENT_ATTRIBUTES A ,TMT_DOCUMENT_ATTRIBUTES B
         WHERE A.ELEMENT_ID = h_attr_id
         AND A.ELEMENT_ID = B.PARENT_ID
         AND B.ELEMENT_ID = h_project_id
         AND B.TYPE_ID = h_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_DOCUMENT', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_DOCUMENT(87) : attr2.sql(1050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CDC0010;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DEFAULT_ATTR_DOCUMENT', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DEFAULT_ATTR_DOCUMENT(100) : attr2.sql(1063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_A_DEFAULT SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_DOCUMENT', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_DOCUMENT(106) : attr2.sql(1069) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTR_DOCUMENT', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTR_DOCUMENT(110) : attr2.sql(1073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT;
ALTER FUNCTION FC_A_DEFAULT_ATTR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_A_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_ATTR_WBS_1 IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND TYPE_ID = h_type AND LOCAL = 'N'
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id  AND TYPE_ID = h_type AND LEVEL_ID >1 AND LOCAL = 'N' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_WBSA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTR_WBSA(41) : attr2.sql(1124) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_WBSA(h_project_id, h_element_id, h_type_id, h_rec_user);
   --Define cursor on  global attributes
   
   OPEN CA_ATTR_WBS_1;
   
   LOOP
      FETCH CA_ATTR_WBS_1 INTO h_attr_id;
      IF CA_ATTR_WBS_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_WBSA', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_WBSA(83) : attr2.sql(1166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_ATTR_WBS_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_WBSA', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_WBSA(96) : attr2.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_WBSA', 101+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_WBSA(102) : attr2.sql(1185) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_WBSA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_WBSA(106) : attr2.sql(1189) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTR_WBSA;
ALTER FUNCTION FC_C_A_ATTR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_A_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_ATTR_CRI_1 IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND TYPE_ID = h_type AND LOCAL = 'N'
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id  AND TYPE_ID = h_type AND LEVEL_ID >1 AND LOCAL = 'N' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_CRIA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTR_CRIA(41) : attr2.sql(1240) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_CRIA(h_project_id, h_element_id, h_type_id, h_rec_user);
   --Define cursor on  global attributes
   
   OPEN CA_ATTR_CRI_1;
   
   LOOP
      FETCH CA_ATTR_CRI_1 INTO h_attr_id;
      IF CA_ATTR_CRI_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_CRIA', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_CRIA(83) : attr2.sql(1282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_ATTR_CRI_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_CRIA', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_CRIA(96) : attr2.sql(1295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_CRIA', 101+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_CRIA(102) : attr2.sql(1301) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_CRIA', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_CRIA(106) : attr2.sql(1305) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTR_CRIA;
ALTER FUNCTION FC_C_A_ATTR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_A_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_ATTR_DC_1 IS
         SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND TYPE_ID = h_type AND LOCAL = 'N'
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id  AND TYPE_ID = h_type AND LEVEL_ID >1 AND LOCAL = 'N' );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_DOCUMENT', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTR_DOCUMENT(41) : attr2.sql(1356) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_DOCUMENT(h_project_id, h_element_id, h_type_id, h_rec_user);
   --Define cursor on  global attributes
   
   OPEN CA_ATTR_DC_1;
   
   LOOP
      FETCH CA_ATTR_DC_1 INTO h_attr_id;
      IF CA_ATTR_DC_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_DOCUMENT', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_DOCUMENT(83) : attr2.sql(1398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_ATTR_DC_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_A_ATTR_DOCUMENT', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_A_ATTR_DOCUMENT(96) : attr2.sql(1411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_DOCUMENT', 101+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_DOCUMENT(102) : attr2.sql(1417) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTR_DOCUMENT', 105+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTR_DOCUMENT(106) : attr2.sql(1421) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTR_DOCUMENT;
ALTER FUNCTION FC_C_A_ATTR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ALL_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_All_ATTR_WBS_1 IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND LEVEL_ID >1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTR_WBSA(41) : attr2.sql(1472) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   --trace_printf(" h_element_id:%s \n",h_element_id);
   --trace_printf(" h_old_element_id:%s \n",h_old_element_id);
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT OLD_ELEMENT_ID INTO h_temp_id
         FROM PMO_COPY_DEFAULT_ATTRIBUTE
         WHERE OLD_ELEMENT_ID = h_old_project_id
         AND NEW_ELEMENT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(62) : attr2.sql(1493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_WBSA(h_project_id, h_element_id, h_old_element_id, h_type
                                      , h_rec_user);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_WBSA(70) : attr2.sql(1501) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   --Define cursor on  global attributes
   
   OPEN CA_All_ATTR_WBS_1;
   
   LOOP
      FETCH CA_All_ATTR_WBS_1 INTO h_attr_id;
      IF CA_All_ATTR_WBS_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("1--------->h_attr_id:%s\n",h_attr_id);
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            SELECT NEW_ELEMENT_ID INTO h_attr_id
            FROM PMO_COPY_DEFAULT_ATTRIBUTE
            WHERE OLD_ELEMENT_ID = h_attr_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(102) : attr2.sql(1533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2********>h_attr_id:%s\n",h_attr_id);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_WBS_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 128+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(129) : attr2.sql(1560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_All_ATTR_WBS_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_WBSA', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_WBSA(142) : attr2.sql(1573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 147+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_WBSA(148) : attr2.sql(1579) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_WBSA', 151+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_WBSA(152) : attr2.sql(1583) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTR_WBSA;
ALTER FUNCTION FC_A_ALL_ATTR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ALL_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_All_ATTR_CRI_1 IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND LEVEL_ID >1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTR_CRIA(41) : attr2.sql(1634) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   --trace_printf(" h_element_id:%s \n",h_element_id);
   --trace_printf(" h_old_element_id:%s \n",h_old_element_id);
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT OLD_ELEMENT_ID INTO h_temp_id
         FROM PMO_COPY_DEFAULT_ATTRIBUTE
         WHERE OLD_ELEMENT_ID = h_old_project_id
         AND NEW_ELEMENT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(62) : attr2.sql(1655) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_CRIA(h_project_id, h_element_id, h_old_element_id, h_type
                                      , h_rec_user);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_CRIA(70) : attr2.sql(1663) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   --Define cursor on  global attributes
   
   OPEN CA_All_ATTR_CRI_1;
   
   LOOP
      FETCH CA_All_ATTR_CRI_1 INTO h_attr_id;
      IF CA_All_ATTR_CRI_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("1--------->h_attr_id:%s\n",h_attr_id);
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            SELECT NEW_ELEMENT_ID INTO h_attr_id
            FROM PMO_COPY_DEFAULT_ATTRIBUTE
            WHERE OLD_ELEMENT_ID = h_attr_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 101+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(102) : attr2.sql(1695) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2********>h_attr_id:%s\n",h_attr_id);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_CRI_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 128+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(129) : attr2.sql(1722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_All_ATTR_CRI_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_CRIA', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_CRIA(142) : attr2.sql(1735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 147+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_CRIA(148) : attr2.sql(1741) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_CRIA', 151+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_CRIA(152) : attr2.sql(1745) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTR_CRIA;
ALTER FUNCTION FC_A_ALL_ATTR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ALL_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
   h_temp_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_type PLS_INTEGER := 0;
   h_input_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CA_All_ATTR_DC_1 IS
         SELECT PARENT_ID, INPUT_TYPE, DESCRIPTION
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_old_element_id AND LEVEL_ID >1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTR_DOCUMENT(42) : attr2.sql(1797) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   --trace_printf(" h_element_id:%s \n",h_element_id);
   --trace_printf(" h_old_element_id:%s \n",h_old_element_id);
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
      BEGIN
         SELECT OLD_ELEMENT_ID INTO h_temp_id
         FROM PMO_COPY_DEFAULT_ATTRIBUTE
         WHERE OLD_ELEMENT_ID = h_old_project_id
         AND NEW_ELEMENT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 62+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(63) : attr2.sql(1818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_old_element_id, h_type
                                          , h_rec_user);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_DOCUMENT(71) : attr2.sql(1826) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   --Define cursor on  global attributes
   
   OPEN CA_All_ATTR_DC_1;
   
   LOOP
      FETCH CA_All_ATTR_DC_1 INTO h_attr_id, h_input_type, h_description;
      IF CA_All_ATTR_DC_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("1--------->h_attr_id:%s\n",h_attr_id);
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      If PMO_ORASTD.strcmp(h_project_id, h_old_project_id) <> PMO_CNST.SC_MATCH Then
         BEGIN
            SELECT NEW_ELEMENT_ID INTO h_attr_id
            FROM PMO_COPY_DEFAULT_ATTRIBUTE
            WHERE OLD_ELEMENT_ID = h_attr_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 102+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(103) : attr2.sql(1858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2********>h_attr_id:%s\n",h_attr_id);
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_attr_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES
         (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME,
         INPUT_TYPE, DESCRIPTION)
         SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, h_attr_id, h_element_id, h_type, LEVEL_ID + 1, LOCAL,
         h_rec_user, ELEMENT_NAME, PARENT_NAME, h_input_type, h_description
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_attr_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(131) : attr2.sql(1886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE CA_All_ATTR_DC_1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ALL_ATTR_DOCUMENT', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ALL_ATTR_DOCUMENT(144) : attr2.sql(1899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("FC_c_attr SC_STATE:%d ",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 149+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_DOCUMENT(150) : attr2.sql(1905) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTR_DOCUMENT', 153+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTR_DOCUMENT(154) : attr2.sql(1909) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTR_DOCUMENT;
ALTER FUNCTION FC_A_ALL_ATTR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_M_A_ATTR_WBSA ==
CREATE OR REPLACE FUNCTION FC_M_A_ATTR_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
-- Declare Cursors
      CURSOR MAATR_ATR_WBS IS
         SELECT PARENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_project_id
         AND LEVEL_ID > 1
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_A_ATTR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_A_ATTR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_M_A_ATTR_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_WBSA', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_A_ATTR_WBSA(31) : attr2.sql(1950) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      delete FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND LOCAL = 'Y';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_WBSA', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_WBSA(47) : attr2.sql(1966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MAATR_ATR_WBS;
   
   LOOP
      FETCH MAATR_ATR_WBS INTO h_attr_id;
      IF MAATR_ATR_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      --      trace_printf("1pp   > h_attr_id: %s \n",h_attr_id);
      PMO_DB2M.SC_STATE := FC_A_ATR(h_type_id, h_element_id, h_attr_id, h_rec_user);
   END LOOP;
   
   BEGIN
      CLOSE MAATR_ATR_WBS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_WBSA', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_WBSA(77) : attr2.sql(1996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_WBSA', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_A_ATTR_WBSA(83) : attr2.sql(2002) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_A_ATTR_WBSA;
ALTER FUNCTION FC_M_A_ATTR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_M_A_ATTR_CRIA ==
CREATE OR REPLACE FUNCTION FC_M_A_ATTR_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
-- Declare Cursors
      CURSOR MAATR_ATR_CRI IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_project_id
         AND LEVEL_ID > 1
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_A_ATTR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_A_ATTR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_M_A_ATTR_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_CRIA', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_A_ATTR_CRIA(31) : attr2.sql(2043) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      delete FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND LOCAL = 'Y';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_CRIA', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_CRIA(47) : attr2.sql(2059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MAATR_ATR_CRI;
   
   LOOP
      FETCH MAATR_ATR_CRI INTO h_attr_id;
      IF MAATR_ATR_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      --      trace_printf("1pp   > h_attr_id: %s \n",h_attr_id);
      PMO_DB2M.SC_STATE := FC_A_ATR(h_type_id, h_element_id, h_attr_id, h_rec_user);
   END LOOP;
   
   BEGIN
      CLOSE MAATR_ATR_CRI;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_CRIA', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_CRIA(77) : attr2.sql(2089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_CRIA', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_A_ATTR_CRIA(83) : attr2.sql(2095) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_A_ATTR_CRIA;
ALTER FUNCTION FC_M_A_ATTR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_M_A_ATTR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_M_A_ATTR_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_id VARCHAR2(32);
-- Declare Cursors
      CURSOR MAATR_ATR_DC IS
         SELECT PARENT_ID
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_project_id
         AND LEVEL_ID > 1
         AND PARENT_ID NOT IN
         (SELECT PARENT_ID FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_element_id);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_A_ATTR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_A_ATTR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_M_A_ATTR_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_DOCUMENT', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_A_ATTR_DOCUMENT(31) : attr2.sql(2136) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      delete FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND LOCAL = 'Y';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_DOCUMENT', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_DOCUMENT(47) : attr2.sql(2152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MAATR_ATR_DC;
   
   LOOP
      FETCH MAATR_ATR_DC INTO h_attr_id;
      IF MAATR_ATR_DC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      --      trace_printf("1pp   > h_attr_id: %s \n",h_attr_id);
      PMO_DB2M.SC_STATE := FC_A_ATR(h_type_id, h_element_id, h_attr_id, h_rec_user);
   END LOOP;
   
   BEGIN
      CLOSE MAATR_ATR_DC;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_A_ATTR_DOCUMENT', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_A_ATTR_DOCUMENT(77) : attr2.sql(2182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_A_ATTR_DOCUMENT', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_A_ATTR_DOCUMENT(83) : attr2.sql(2188) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_A_ATTR_DOCUMENT;
ALTER FUNCTION FC_M_A_ATTR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_PROJECT_NAME_WBSA ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_NAME_WBSA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_NAME_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_NAME_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_NAME_WBSA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_WBSA', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_NAME_WBSA(17) : attr2.sql(2215) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   BEGIN
      UPDATE TMT_WBS_ATTRIBUTES
      SET ELEMENT_NAME=h_new_name,REC_USER=h_rec_user
      WHERE ELEMENT_ID=h_project_id AND TYPE_ID = PMO_CNST.SC_CATEGORY1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJECT_NAME_WBSA', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJECT_NAME_WBSA(35) : attr2.sql(2233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_WBSA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_WBSA(41) : attr2.sql(2239) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_WBSA', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_WBSA(45) : attr2.sql(2243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_NAME_WBSA;
ALTER FUNCTION FC_U_PROJECT_NAME_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_PROJECT_NAME_CRIA ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_NAME_CRIA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_NAME_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_NAME_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_NAME_CRIA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_CRIA', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_NAME_CRIA(17) : attr2.sql(2270) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   BEGIN
      UPDATE TMT_CRI_ATTRIBUTES
      SET ELEMENT_NAME=h_new_name,REC_USER=h_rec_user
      WHERE ELEMENT_ID=h_project_id AND TYPE_ID = PMO_CNST.SC_CATEGORY1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJECT_NAME_CRIA', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJECT_NAME_CRIA(35) : attr2.sql(2288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_CRIA', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_CRIA(41) : attr2.sql(2294) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_CRIA', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_CRIA(45) : attr2.sql(2298) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_NAME_CRIA;
ALTER FUNCTION FC_U_PROJECT_NAME_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_PROJECT_NAME_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_NAME_DOCUMENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_NAME_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_NAME_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_NAME_DOCUMENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_DOCUMENT', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_NAME_DOCUMENT(17) : attr2.sql(2325) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   BEGIN
      UPDATE TMT_DOCUMENT_ATTRIBUTES
      SET ELEMENT_NAME=h_new_name,REC_USER=h_rec_user
      WHERE ELEMENT_ID=h_project_id AND TYPE_ID = PMO_CNST.SC_CATEGORY1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJECT_NAME_DOCUMENT', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJECT_NAME_DOCUMENT(35) : attr2.sql(2343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_DOCUMENT', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_DOCUMENT(41) : attr2.sql(2349) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_NAME_DOCUMENT', 44+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_NAME_DOCUMENT(45) : attr2.sql(2353) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_NAME_DOCUMENT;
ALTER FUNCTION FC_U_PROJECT_NAME_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_WBSA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_WBSA', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_WBSA(22) : attr2.sql(2385) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_WBS_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(44) : attr2.sql(2407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_WBS_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(76) : attr2.sql(2439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_WBS_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 96+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(97) : attr2.sql(2460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_WBS_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(116) : attr2.sql(2479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_WBSA', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_WBSA(134) : attr2.sql(2497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_WBSA', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_WBSA(145) : attr2.sql(2508) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_WBSA', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_WBSA(149) : attr2.sql(2512) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_WBSA;
ALTER FUNCTION FC_UA_ATR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_CRIA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CRIA', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_CRIA(22) : attr2.sql(2544) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_CRI_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(44) : attr2.sql(2566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_CRI_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(76) : attr2.sql(2598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_CRI_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 96+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(97) : attr2.sql(2619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_CRI_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(116) : attr2.sql(2638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CRIA', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CRIA(134) : attr2.sql(2656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CRIA', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CRIA(145) : attr2.sql(2667) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CRIA', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CRIA(149) : attr2.sql(2671) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_CRIA;
ALTER FUNCTION FC_UA_ATR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_DOCUMENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_link_doc VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_DOCUMENT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_DOCUMENT(24) : attr2.sql(2705) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 45+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(46) : attr2.sql(2727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_DOCUMENT_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 77+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(78) : attr2.sql(2759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_DOCUMENT_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 98+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(99) : attr2.sql(2780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(118) : attr2.sql(2799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT LINK_DOC, BLOB_ID INTO h_link_doc, h_blob_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(133) : attr2.sql(2814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_link_doc, 1, 1) = 'P' AND ((h_blob_id IS NOT NULL)) Then
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE PARENT_ID = h_attribute_id
            AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE BLOB_ID = h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(153) : attr2.sql(2834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_DOCUMENT', 170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_DOCUMENT(171) : attr2.sql(2852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_DOCUMENT', 182+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_DOCUMENT(183) : attr2.sql(2864) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_DOCUMENT', 186+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_DOCUMENT(187) : attr2.sql(2868) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_DOCUMENT;
ALTER FUNCTION FC_UA_ATR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_POOL
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_POOL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_POOL(22) : attr2.sql(2900) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_POOL_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(44) : attr2.sql(2922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_POOL_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(76) : attr2.sql(2954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_POOL_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 96+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(97) : attr2.sql(2975) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_POOL_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(116) : attr2.sql(2994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_POOL', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_POOL(134) : attr2.sql(3012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_POOL', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_POOL(145) : attr2.sql(3023) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_POOL', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_POOL(149) : attr2.sql(3027) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_POOL;
ALTER FUNCTION FC_UA_ATR_POOL COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_CLIENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_CLIENT(22) : attr2.sql(3059) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_CLIENT_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(44) : attr2.sql(3081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_CLIENT_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(76) : attr2.sql(3113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_CLIENT_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 96+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(97) : attr2.sql(3134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_CLIENT_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(116) : attr2.sql(3153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_CLIENT', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_CLIENT(134) : attr2.sql(3171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CLIENT', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CLIENT(145) : attr2.sql(3182) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_CLIENT', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_CLIENT(149) : attr2.sql(3186) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_CLIENT;
ALTER FUNCTION FC_UA_ATR_CLIENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_VENDOR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_VENDOR', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_VENDOR(22) : attr2.sql(3218) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_VENDOR_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(44) : attr2.sql(3240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_VENDOR_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(76) : attr2.sql(3272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_VENDOR_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 96+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(97) : attr2.sql(3293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_VENDOR_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(116) : attr2.sql(3312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_VENDOR', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_VENDOR(134) : attr2.sql(3330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_VENDOR', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_VENDOR(145) : attr2.sql(3341) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_VENDOR', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_VENDOR(149) : attr2.sql(3345) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_VENDOR;
ALTER FUNCTION FC_UA_ATR_VENDOR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_UA_ATR_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_ASSET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR_ASSET(22) : attr2.sql(3377) : ' || SYSTIMESTAMP);
   END IF; 

   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   If (h_attribute_id IS NULL) Then
      If isProjectType(Coalesce(h_table_type, 0)) <> 0 Then
         --if project deleted we have to delete all the related record
         --in all attribute tables
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_ASSET_ATTRIBUTES
            WHERE ELEMENT_ID =h_id AND LEVEL_ID = 1;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 43+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(44) : attr2.sql(3399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            -- delete the project record and all it's children
            BEGIN
               DELETE FROM TMT_ASSET_ATTRIBUTES
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 75+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(76) : attr2.sql(3431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --update local_category's child_count
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               h_parent_id := PMO_CNST.SC_LOCAL_CATEGORY_ID;
               BEGIN
                  UPDATE TMT_ASSET_ATTRIBUTES
                  SET CHILD_COUNT = CHILD_COUNT-1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 96+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(97) : attr2.sql(3452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         DELETE FROM TMT_ASSET_ATTRIBUTES WHERE ELEMENT_ID =h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(116) : attr2.sql(3471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         DELETE FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID =h_id AND PARENT_ID = h_attribute_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_ATR_ASSET', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_ATR_ASSET(134) : attr2.sql(3489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_ASSET', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_ASSET(145) : attr2.sql(3500) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR_ASSET', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR_ASSET(149) : attr2.sql(3504) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR_ASSET;
ALTER FUNCTION FC_UA_ATR_ASSET COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_D_ATR_WBSA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_WBSA(26) : attr2.sql(3540) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(40) : attr2.sql(3554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(55) : attr2.sql(3569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_WBSA(63) : attr2.sql(3577) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_WBS_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(107) : attr2.sql(3621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_WBS_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(134) : attr2.sql(3648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_WBS_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(154) : attr2.sql(3668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(173) : attr2.sql(3687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_WBS_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(191) : attr2.sql(3705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(213) : attr2.sql(3727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(232) : attr2.sql(3746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(255) : attr2.sql(3769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_WBSA', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_WBSA(275) : attr2.sql(3789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_WBSA(286) : attr2.sql(3800) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_WBSA', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_WBSA(290) : attr2.sql(3804) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_WBSA;
ALTER FUNCTION FC_D_ATR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_D_ATR_CRIA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_CRIA(26) : attr2.sql(3840) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(40) : attr2.sql(3854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(55) : attr2.sql(3869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CRIA(63) : attr2.sql(3877) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_CRI_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(107) : attr2.sql(3921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_CRI_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(134) : attr2.sql(3948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_CRI_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(154) : attr2.sql(3968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(173) : attr2.sql(3987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_CRI_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(191) : attr2.sql(4005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(213) : attr2.sql(4027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CRI_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(232) : attr2.sql(4046) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(255) : attr2.sql(4069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CRIA', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CRIA(275) : attr2.sql(4089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CRIA(286) : attr2.sql(4100) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CRIA', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CRIA(290) : attr2.sql(4104) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_CRIA;
ALTER FUNCTION FC_D_ATR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_D_ATR_DOCUMENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_DOCUMENT(26) : attr2.sql(4140) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(40) : attr2.sql(4154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(55) : attr2.sql(4169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_DOCUMENT(63) : attr2.sql(4177) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_DOCUMENT_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(107) : attr2.sql(4221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_DOCUMENT_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(134) : attr2.sql(4248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(154) : attr2.sql(4268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(173) : attr2.sql(4287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_DOCUMENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(191) : attr2.sql(4305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(213) : attr2.sql(4327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(232) : attr2.sql(4346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(255) : attr2.sql(4369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_DOCUMENT', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_DOCUMENT(275) : attr2.sql(4389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_DOCUMENT(286) : attr2.sql(4400) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_DOCUMENT', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_DOCUMENT(290) : attr2.sql(4404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_DOCUMENT;
ALTER FUNCTION FC_D_ATR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_D_ATR_POOL
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_POOL(26) : attr2.sql(4440) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(40) : attr2.sql(4454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(55) : attr2.sql(4469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_POOL(63) : attr2.sql(4477) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_POOL_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(107) : attr2.sql(4521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_POOL_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(134) : attr2.sql(4548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_POOL_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(154) : attr2.sql(4568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(173) : attr2.sql(4587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_POOL_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(191) : attr2.sql(4605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(213) : attr2.sql(4627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_POOL_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(232) : attr2.sql(4646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(255) : attr2.sql(4669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_POOL', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_POOL(275) : attr2.sql(4689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_POOL(286) : attr2.sql(4700) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_POOL', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_POOL(290) : attr2.sql(4704) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_POOL;
ALTER FUNCTION FC_D_ATR_POOL COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_ATR_CLIENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_CLIENT(26) : attr2.sql(4740) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(40) : attr2.sql(4754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(55) : attr2.sql(4769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CLIENT(63) : attr2.sql(4777) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_CLIENT_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(107) : attr2.sql(4821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_CLIENT_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(134) : attr2.sql(4848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_CLIENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(154) : attr2.sql(4868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(173) : attr2.sql(4887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_CLIENT_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(191) : attr2.sql(4905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(213) : attr2.sql(4927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CLIENT_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(232) : attr2.sql(4946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(255) : attr2.sql(4969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_CLIENT', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_CLIENT(275) : attr2.sql(4989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CLIENT(286) : attr2.sql(5000) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_CLIENT', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_CLIENT(290) : attr2.sql(5004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_CLIENT;
ALTER FUNCTION FC_D_ATR_CLIENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_D_ATR_VENDOR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_VENDOR(26) : attr2.sql(5040) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(40) : attr2.sql(5054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(55) : attr2.sql(5069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_VENDOR(63) : attr2.sql(5077) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_VENDOR_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(107) : attr2.sql(5121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_VENDOR_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(134) : attr2.sql(5148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_VENDOR_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(154) : attr2.sql(5168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(173) : attr2.sql(5187) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_VENDOR_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(191) : attr2.sql(5205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(213) : attr2.sql(5227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(232) : attr2.sql(5246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(255) : attr2.sql(5269) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_VENDOR', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_VENDOR(275) : attr2.sql(5289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_VENDOR(286) : attr2.sql(5300) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_VENDOR', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_VENDOR(290) : attr2.sql(5304) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_VENDOR;
ALTER FUNCTION FC_D_ATR_VENDOR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_D_ATR_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_exists VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_updateFlag PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR_ASSET(26) : attr2.sql(5340) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(40) : attr2.sql(5354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(55) : attr2.sql(5369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_ASSET(63) : attr2.sql(5377) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      h_updateFlag := 0;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES P
         SET P.REC_STATUS = 'X', P.REC_DATETIME = SYSTIMESTAMP, P.REC_USER = h_rec_user
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND EXISTS(SELECT C.ELEMENT_ID FROM TMT_ASSET_ATTRIBUTES C
         WHERE C.RANK LIKE h_rank || '%'
         AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
         AND C.LEVEL_ID > P.LEVEL_ID
         AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(107) : attr2.sql(5421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_count := 1;
         
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES P
            SET P.CHILD_COUNT = 0,
            P.DELETED_COUNT = (SELECT COUNT(C.ELEMENT_ID) FROM TMT_ASSET_ATTRIBUTES C
            WHERE C.PARENT_ID = P.ELEMENT_ID AND C.REC_STATUS = 'X')
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(134) : attr2.sql(5448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_ASSET_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'X'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(154) : attr2.sql(5468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES
            SET REC_STATUS = 'D'
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'X';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(173) : attr2.sql(5487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TMT_ASSET_ATTRIBUTES
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(191) : attr2.sql(5505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_parent_id IS NOT NULL) Then
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSET_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 212+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(213) : attr2.sql(5527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_ASSET_ATTRIBUTES
               SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(232) : attr2.sql(5546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      h_updateFlag := 1;
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(255) : attr2.sql(5569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET REC_STATUS = h_del_flag, REC_DATETIME = SYSTIMESTAMP, REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_ATR_ASSET', 274+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_ATR_ASSET(275) : attr2.sql(5589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_ASSET(286) : attr2.sql(5600) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR_ASSET', 289+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR_ASSET(290) : attr2.sql(5604) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR_ASSET;
ALTER FUNCTION FC_D_ATR_ASSET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_A_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_A_ATR_WBSA
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_attr_type_id PLS_INTEGER := 0;
   h_attr_rank VARCHAR2(200);
   h_assigned_attr PLS_INTEGER := 0;
   h_attr_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_WBSA(33) : attr2.sql(5647) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(39) : attr2.sql(5653) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   --trace_printf("\n h_type_id:%d", h_type_id);
   --trace_printf("\n h_element_id:%s", h_element_id);
   --trace_printf("\n h_id:%s", h_id);
   --trace_printf("\n h_type:%d", h_type);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- RULES: June 08, 2004
      -- 1- user can select classification to assign to a user (classification can be any type - single or multiple)
      -- 2- user can not assign a classification and also its attribute.
      
      -- h_id contains the attribute_id or classification_id
      
      BEGIN
         SELECT RANK, TYPE_ID, PARENT_ID
         INTO h_attr_rank, h_attr_type_id, h_attr_parent_id
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(71) : attr2.sql(5685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_attr_rank:%s", h_attr_rank);
      --trace_printf("\n h_attr_type_id:%d", h_attr_type_id);
      --trace_printf("\n h_attr_parent_id:%s", h_attr_parent_id);
      
      -- 55  classification multi-select attr
      -- 146 classification single-select attr
      If (Coalesce(h_attr_type_id, 0) = 55) OR (Coalesce(h_attr_type_id, 0) = 146) Then
         h_assigned_attr := 0;
         -- check for any assigned attributes belongs to this classification
         BEGIN
            SELECT 1 INTO h_assigned_attr
            FROM DUAL
            WHERE EXISTS(
            SELECT ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES
            WHERE ELEMENT_ID = h_element_id
            AND PARENT_ID IN (
            SELECT ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES
            WHERE RANK LIKE h_attr_rank || '%%'
            AND TYPE_ID IN (15, 144)));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 102+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(103) : attr2.sql(5717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_assigned_attr, 0) = 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 109+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(110) : attr2.sql(5724) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
         End If;
      ElsIf (Coalesce(h_attr_type_id, 0) = 15) OR (Coalesce(h_attr_type_id, 0) = 144) Then
         -- check for assigned classification
         BEGIN
            SELECT 1 INTO h_assigned_attr
            FROM DUAL
            WHERE EXISTS(
            SELECT ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES
            WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_attr_parent_id);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 128+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(129) : attr2.sql(5743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_assigned_attr, 0) = 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 135+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(136) : attr2.sql(5750) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
         End If;
      End If;
   End If;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 153+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(154) : attr2.sql(5768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 160+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(161) : attr2.sql(5775) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_WBS_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 179+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(180) : attr2.sql(5794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 186+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(187) : attr2.sql(5801) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   BEGIN
      INSERT INTO TMT_WBS_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_WBSA', 204+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_WBSA(205) : attr2.sql(5819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 210+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(211) : attr2.sql(5825) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_WBSA', 214+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_WBSA(215) : attr2.sql(5829) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_WBSA;
ALTER FUNCTION FC_A_ATR_WBSA COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_A_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_A_ATR_CRIA
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_CRIA(29) : attr2.sql(5868) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(35) : attr2.sql(5874) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CRIA', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CRIA(55) : attr2.sql(5894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(61) : attr2.sql(5900) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_CRI_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CRIA', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CRIA(80) : attr2.sql(5919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(89) : attr2.sql(5928) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_CRI_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CRIA', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CRIA(108) : attr2.sql(5947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 113+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(114) : attr2.sql(5953) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CRIA', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CRIA(118) : attr2.sql(5957) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_CRIA;
ALTER FUNCTION FC_A_ATR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_A_ATR_DOCUMENT
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
   h_blob_id VARCHAR2(32);
   h_link_doc VARCHAR2(1);
-- Declare Cursors
      CURSOR ATTR_CUR IS
         SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE BLOB_ID = h_blob_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_DOCUMENT(37) : attr2.sql(6004) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(43) : attr2.sql(6010) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(63) : attr2.sql(6030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(69) : attr2.sql(6036) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')), LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_DOCUMENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(85) : attr2.sql(6052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(94) : attr2.sql(6061) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT LINK_DOC, BLOB_ID INTO h_link_doc, h_blob_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(110) : attr2.sql(6077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (SubStr(h_link_doc, 1, 1) = 'P') AND ((h_blob_id IS NOT NULL)) Then
      OPEN ATTR_CUR;
      
      LOOP
         FETCH ATTR_CUR INTO h_element_id;
         IF ATTR_CUR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_DOCUMENT_ATTRIBUTES (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
            VALUES(h_rank || h_rankBase64, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 145+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(146) : attr2.sql(6113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE ATTR_CUR;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(160) : attr2.sql(6127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENT_ATTRIBUTES', h_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_DOCUMENT_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
         VALUES(h_rank || h_rankBase64, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_DOCUMENT', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_DOCUMENT(181) : attr2.sql(6148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 187+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(188) : attr2.sql(6155) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_DOCUMENT', 191+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_DOCUMENT(192) : attr2.sql(6159) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_DOCUMENT;
ALTER FUNCTION FC_A_ATR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_A_ATR_POOL
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_POOL(29) : attr2.sql(6198) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(35) : attr2.sql(6204) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_POOL_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_POOL', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_POOL(55) : attr2.sql(6224) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(61) : attr2.sql(6230) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_POOL_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_POOL_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_POOL', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_POOL(80) : attr2.sql(6249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(89) : attr2.sql(6258) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_POOL_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_POOL', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_POOL(108) : attr2.sql(6277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 113+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(114) : attr2.sql(6283) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_POOL', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_POOL(118) : attr2.sql(6287) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_POOL;
ALTER FUNCTION FC_A_ATR_POOL COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_A_ATR_CLIENT
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_CLIENT(29) : attr2.sql(6326) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(35) : attr2.sql(6332) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CLIENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CLIENT', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CLIENT(55) : attr2.sql(6352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(61) : attr2.sql(6358) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENT_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_CLIENT_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CLIENT', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CLIENT(80) : attr2.sql(6377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(89) : attr2.sql(6386) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_CLIENT_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_CLIENT', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_CLIENT(108) : attr2.sql(6405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 113+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(114) : attr2.sql(6411) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_CLIENT', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_CLIENT(118) : attr2.sql(6415) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_CLIENT;
ALTER FUNCTION FC_A_ATR_CLIENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_A_ATR_VENDOR
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_VENDOR(29) : attr2.sql(6454) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(35) : attr2.sql(6460) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_VENDOR_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_VENDOR', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_VENDOR(55) : attr2.sql(6480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(61) : attr2.sql(6486) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDOR_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_VENDOR_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_VENDOR', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_VENDOR(80) : attr2.sql(6505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(89) : attr2.sql(6514) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_VENDOR_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_VENDOR', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_VENDOR(108) : attr2.sql(6533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 113+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(114) : attr2.sql(6539) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_VENDOR', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_VENDOR(118) : attr2.sql(6543) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_VENDOR;
ALTER FUNCTION FC_A_ATR_VENDOR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_A_ATR_ASSET
(
     sh_h_type_id PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rankBase64 VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_parent_name VARCHAR2(100);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_description VARCHAR2(255);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR_ASSET(29) : attr2.sql(6582) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_type_id IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(35) : attr2.sql(6588) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   
   h_type := getAttributeType(Coalesce(h_type_id, 0));
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_ASSET_ATTRIBUTES
      WHERE ELEMENT_ID = h_element_id AND PARENT_ID = h_id
      AND TYPE_ID = h_type;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_ASSET', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_ASSET(55) : attr2.sql(6608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(61) : attr2.sql(6614) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ASSIGNMENT_ALREADY_EXISTS;
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSET_ATTRIBUTES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT RTRIM( COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, DESCRIPTION,LOCAL,ELEMENT_NAME,PARENT_NAME
      INTO h_rank, h_level_id, h_description, h_local,h_element_name,h_parent_name
      FROM TMT_ASSET_ATTRIBUTES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_ASSET', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_ASSET(80) : attr2.sql(6633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      --      trace_printf(" RECORD_NOT_FOUND");
      --      trace_printf(" h_id :%s \n ",h_id);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(89) : attr2.sql(6642) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
      --RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      INSERT INTO TMT_ASSET_ATTRIBUTES ( RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER,ELEMENT_NAME,PARENT_NAME)
      VALUES( h_rank, h_id, h_element_id, h_type, h_level_id, h_local, h_rec_user,h_element_name,h_parent_name);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_ATR_ASSET', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_ATR_ASSET(108) : attr2.sql(6661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --  trace_printf("m_a_atr 1 >SC_STATE :%d \n",SC_STATE);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 113+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(114) : attr2.sql(6667) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR_ASSET', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR_ASSET(118) : attr2.sql(6671) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR_ASSET;
ALTER FUNCTION FC_A_ATR_ASSET COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_WBSA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_WBSA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_WBSA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_WBSA(37) : attr2.sql(6718) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(58) : attr2.sql(6739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(65) : attr2.sql(6746) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(91) : attr2.sql(6772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(110) : attr2.sql(6791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(117) : attr2.sql(6798) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(143) : attr2.sql(6824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(179) : attr2.sql(6860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_WBS_ATTRIBUTES P, TMT_WBS_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(219) : attr2.sql(6900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_WBS_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_WBSA', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_WBSA(243) : attr2.sql(6924) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(255) : attr2.sql(6936) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_WBSA', 258+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_WBSA(259) : attr2.sql(6940) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_WBSA;
ALTER FUNCTION FC_U_ATR_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_CRIA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_CRIA
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_CRIA(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_CRIA(37) : attr2.sql(6987) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(57) : attr2.sql(7007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 63+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(64) : attr2.sql(7014) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(88) : attr2.sql(7038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT TYPE_ID INTO h_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_id AND TRANSFER_FLAG IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(103) : attr2.sql(7053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
            INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
            FROM TMT_CRI_ATTRIBUTES
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID = h_parent_id
            AND TYPE_ID = h_type;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(122) : attr2.sql(7072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
            INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
            FROM TMT_CRI_ATTRIBUTES
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(139) : attr2.sql(7089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 146+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(147) : attr2.sql(7097) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE RANK = h_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(170) : attr2.sql(7120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 205+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(206) : attr2.sql(7156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_CRI_ATTRIBUTES P, TMT_CRI_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 245+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(246) : attr2.sql(7196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_CRI_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CRIA', 269+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CRIA(270) : attr2.sql(7220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 281+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(282) : attr2.sql(7232) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CRIA', 285+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CRIA(286) : attr2.sql(7236) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_CRIA;
ALTER FUNCTION FC_U_ATR_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_DOCUMENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_blob_id VARCHAR2(32);
   h_link_doc VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_DOCUMENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_DOCUMENT(39) : attr2.sql(7285) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(61) : attr2.sql(7307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 67+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(68) : attr2.sql(7314) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(94) : attr2.sql(7340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(113) : attr2.sql(7359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 119+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(120) : attr2.sql(7366) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         SELECT LINK_DOC, BLOB_ID INTO h_link_doc, h_blob_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(135) : attr2.sql(7381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_link_doc, 1, 1) = 'P' AND ((h_blob_id IS NOT NULL)) Then
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET ELEMENT_NAME = h_name,
            DESCRIPTION = h_description,
            WEIGHT = h_weight,
            INPUT_TYPE = h_input_type,
            REC_USER = h_rec_user
            WHERE PARENT_ID = h_parent_id
            AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS)
            AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE BLOB_ID = h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(162) : attr2.sql(7408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES
            SET ELEMENT_NAME = h_name,
            DESCRIPTION = h_description,
            WEIGHT = h_weight,
            INPUT_TYPE = h_input_type,
            REC_USER = h_rec_user
            WHERE ELEMENT_ID = h_id
            AND PARENT_ID = h_parent_id
            AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(188) : attr2.sql(7434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 224+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(225) : attr2.sql(7471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_DOCUMENT_ATTRIBUTES P, TMT_DOCUMENT_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 264+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(265) : attr2.sql(7511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_DOCUMENT_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_DOCUMENT', 288+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_DOCUMENT(289) : attr2.sql(7535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 300+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(301) : attr2.sql(7547) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_DOCUMENT', 304+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_DOCUMENT(305) : attr2.sql(7551) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_DOCUMENT;
ALTER FUNCTION FC_U_ATR_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_POOL ==
CREATE OR REPLACE FUNCTION FC_U_ATR_POOL
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_POOL(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_POOL(37) : attr2.sql(7598) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(58) : attr2.sql(7619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(65) : attr2.sql(7626) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(91) : attr2.sql(7652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(110) : attr2.sql(7671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(117) : attr2.sql(7678) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(143) : attr2.sql(7704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(179) : attr2.sql(7740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_POOL_ATTRIBUTES P, TMT_POOL_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(219) : attr2.sql(7780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_POOL_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_POOL', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_POOL(243) : attr2.sql(7804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(255) : attr2.sql(7816) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_POOL', 258+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_POOL(259) : attr2.sql(7820) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_POOL;
ALTER FUNCTION FC_U_ATR_POOL COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_CLIENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_CLIENT
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_CLIENT(37) : attr2.sql(7867) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(58) : attr2.sql(7888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(65) : attr2.sql(7895) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(91) : attr2.sql(7921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(110) : attr2.sql(7940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(117) : attr2.sql(7947) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(143) : attr2.sql(7973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(179) : attr2.sql(8009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_CLIENT_ATTRIBUTES P, TMT_CLIENT_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(219) : attr2.sql(8049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_CLIENT_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_CLIENT', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_CLIENT(243) : attr2.sql(8073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(255) : attr2.sql(8085) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_CLIENT', 258+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_CLIENT(259) : attr2.sql(8089) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_CLIENT;
ALTER FUNCTION FC_U_ATR_CLIENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_VENDOR ==
CREATE OR REPLACE FUNCTION FC_U_ATR_VENDOR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_VENDOR(37) : attr2.sql(8136) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(58) : attr2.sql(8157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(65) : attr2.sql(8164) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(91) : attr2.sql(8190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(110) : attr2.sql(8209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(117) : attr2.sql(8216) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(143) : attr2.sql(8242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(179) : attr2.sql(8278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_VENDOR_ATTRIBUTES P, TMT_VENDOR_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(219) : attr2.sql(8318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_VENDOR_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_VENDOR', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_VENDOR(243) : attr2.sql(8342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(255) : attr2.sql(8354) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_VENDOR', 258+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_VENDOR(259) : attr2.sql(8358) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_VENDOR;
ALTER FUNCTION FC_U_ATR_VENDOR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_ASSET ==
CREATE OR REPLACE FUNCTION FC_U_ATR_ASSET
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_old_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_old_input_type PLS_INTEGER := 0;
   h_flag PLS_INTEGER;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_ASSET(37) : attr2.sql(8405) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_type := getAttributeType(Coalesce(h_table_type, 0));
   
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), RTRIM(RANK), TYPE_ID, INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_rank, h_type_id, h_old_input_type, h_count
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(58) : attr2.sql(8426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 64+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(65) : attr2.sql(8433) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(91) : attr2.sql(8459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RTRIM(ELEMENT_NAME), TYPE_ID, RTRIM(RANK), INPUT_TYPE, CHILD_COUNT + DELETED_COUNT
         INTO h_old_name, h_type_id, h_rank, h_old_input_type, h_count
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(110) : attr2.sql(8478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 116+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(117) : attr2.sql(8485) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         WEIGHT = h_weight,
         INPUT_TYPE = h_input_type,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id
         AND TYPE_ID IN (h_type, PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
         PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 142+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(143) : attr2.sql(8511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If Coalesce(h_old_input_type, 0) <> Coalesce(h_input_type, 0) Then
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES
         SET DESCRIPTION = '',
         INPUT_TYPE = h_input_type
         WHERE RANK LIKE h_rank || '%'
         AND ELEMENT_ID <> h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(179) : attr2.sql(8547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --if we update element_name maybe we need to update parent_name of it's children
   If PMO_ORASTD.strcmp(h_old_name, h_name) <> PMO_CNST.SC_MATCH Then
      If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1) OR (Coalesce(
              h_type_id, 0) = PMO_CNST.SC_CATEGORY1_MS)) AND (Coalesce(h_count, 0) > 0) Then
         h_flag := 1;
      ElsIf (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS) OR (Coalesce(
                h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION_MS) Then
         h_flag := 1;
      Else
         h_flag := 0;
         NULL;
      End If;
      
      If h_flag = 1 Then
         --update parent name for attributes under the updated element
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES C
            SET C.parent_name = (SELECT PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat(RTRIM(GP.ELEMENT_NAME), ','), RTRIM(P.ELEMENT_NAME))
            FROM TMT_ASSET_ATTRIBUTES P, TMT_ASSET_ATTRIBUTES GP
            WHERE C.PARENT_ID = P.ELEMENT_ID AND P.PARENT_ID = GP.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 218+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(219) : attr2.sql(8587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- for assigned item update parent_name and element_name
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES C
            SET (C.ELEMENT_NAME, C.PARENT_NAME) = (SELECT P.ELEMENT_NAME, P.PARENT_NAME
            FROM TMT_ASSET_ATTRIBUTES P
            WHERE C.PARENT_ID = P.ELEMENT_ID)
            WHERE C.RANK LIKE h_rank || '%'
            AND C.TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE, PMO_CNST.SC_CLASSIFICATION, PMO_CNST.SC_CATEGORY1,
            PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS, PMO_CNST.SC_CLASSIFICATION_MS, PMO_CNST.SC_CATEGORY1_MS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_ASSET', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_ASSET(243) : attr2.sql(8611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(255) : attr2.sql(8623) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_ASSET', 258+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_ASSET(259) : attr2.sql(8627) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_ASSET;
ALTER FUNCTION FC_U_ATR_ASSET COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_WBSA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_WBSA
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_WBSA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_WBSA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_WBSA(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_WBSA(23) : attr2.sql(8660) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_WBS_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(51) : attr2.sql(8688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_WBS_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(66) : attr2.sql(8703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_WBS_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(86) : attr2.sql(8723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_WBSA(93) : attr2.sql(8730) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_WBSA', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_WBSA(120) : attr2.sql(8757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_WBSA(127) : attr2.sql(8764) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_WBSA', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_WBSA(132) : attr2.sql(8769) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_WBSA;
ALTER FUNCTION FC_U_ATR_MS_WBSA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_CRIA ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_CRIA
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_CRIA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_CRIA'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_CRIA(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_CRIA(23) : attr2.sql(8802) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_CRI_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(51) : attr2.sql(8830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_CRI_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(66) : attr2.sql(8845) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_CRI_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(86) : attr2.sql(8865) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CRIA(93) : attr2.sql(8872) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CRIA', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CRIA(120) : attr2.sql(8899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CRIA(127) : attr2.sql(8906) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CRIA', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CRIA(132) : attr2.sql(8911) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_CRIA;
ALTER FUNCTION FC_U_ATR_MS_CRIA COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_DOCUMENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_DOCUMENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_DOCUMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_DOCUMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_DOCUMENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_DOCUMENT(23) : attr2.sql(8944) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(51) : attr2.sql(8972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(66) : attr2.sql(8987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_DOCUMENT_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(86) : attr2.sql(9007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_DOCUMENT(93) : attr2.sql(9014) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_DOCUMENT', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_DOCUMENT(120) : attr2.sql(9041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_DOCUMENT(127) : attr2.sql(9048) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_DOCUMENT', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_DOCUMENT(132) : attr2.sql(9053) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_DOCUMENT;
ALTER FUNCTION FC_U_ATR_MS_DOCUMENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_POOL ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_POOL
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_POOL(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_POOL(23) : attr2.sql(9086) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_POOL_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(51) : attr2.sql(9114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_POOL_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(66) : attr2.sql(9129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_POOL_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(86) : attr2.sql(9149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_POOL(93) : attr2.sql(9156) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_POOL_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_POOL', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_POOL(120) : attr2.sql(9183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_POOL(127) : attr2.sql(9190) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_POOL', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_POOL(132) : attr2.sql(9195) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_POOL;
ALTER FUNCTION FC_U_ATR_MS_POOL COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_CLIENT ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_CLIENT(23) : attr2.sql(9228) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_CLIENT_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(51) : attr2.sql(9256) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_CLIENT_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(66) : attr2.sql(9271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_CLIENT_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(86) : attr2.sql(9291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CLIENT(93) : attr2.sql(9298) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_CLIENT_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_CLIENT', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_CLIENT(120) : attr2.sql(9325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CLIENT(127) : attr2.sql(9332) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_CLIENT', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_CLIENT(132) : attr2.sql(9337) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_CLIENT;
ALTER FUNCTION FC_U_ATR_MS_CLIENT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_VENDOR ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_VENDOR
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_VENDOR(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_VENDOR(23) : attr2.sql(9370) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_VENDOR_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(51) : attr2.sql(9398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_VENDOR_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(66) : attr2.sql(9413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_VENDOR_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(86) : attr2.sql(9433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_VENDOR(93) : attr2.sql(9440) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_VENDOR_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_VENDOR', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_VENDOR(120) : attr2.sql(9467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_VENDOR(127) : attr2.sql(9474) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_VENDOR', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_VENDOR(132) : attr2.sql(9479) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_VENDOR;
ALTER FUNCTION FC_U_ATR_MS_VENDOR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS_ASSET ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS_ASSET
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_temp_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS_ASSET(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS_ASSET(23) : attr2.sql(9512) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_ASSET_ATTRIBUTES 
         SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
         WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
         WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
         WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
         ELSE TYPE_ID END, 
         MULTI_SELECT = TO_CHAR(h_lmulti_select),
         REC_USER = h_rec_user
         WHERE (ELEMENT_ID = h_id AND PARENT_ID IS NuLL) OR PARENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 50+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(51) : attr2.sql(9540) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id
         FROM TMT_ASSET_ATTRIBUTES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(66) : attr2.sql(9555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            SELECT CASE WHEN EXISTS (SELECT C.ELEMENT_ID
            FROM TMT_ASSET_ATTRIBUTES C
            WHERE C.RANK LIKE h_rank || '%'
            AND C.LEVEL_ID = h_level_id + 2
            GROUP BY C.ELEMENT_ID
            HAVING COUNT( C.ELEMENT_ID) > 1) THEN '1' ELSE '0' END INTO h_temp_flag
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 85+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(86) : attr2.sql(9575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (SubStr(h_temp_flag, 1, 1) = '1') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 92+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_ASSET(93) : attr2.sql(9582) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.ELEMENT_IS_USED;
         End If;
         
         BEGIN
            UPDATE TMT_ASSET_ATTRIBUTES 
            SET TYPE_ID = CASE WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1 AND h_lmulti_select = 1 THEN PMO_CNST.SC_CATEGORY1_MS
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION AND h_lmulti_select = 1 THEN PMO_CNST.SC_CLASSIFICATION_MS
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE AND h_lmulti_select = 1 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS
            WHEN TYPE_ID = PMO_CNST.SC_CATEGORY1_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CATEGORY1
            WHEN TYPE_ID = PMO_CNST.SC_CLASSIFICATION_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_CLASSIFICATION
            WHEN TYPE_ID = PMO_CNST.SC_SYSTEM_ATTRIBUTE_MS AND h_lmulti_select = 0 THEN PMO_CNST.SC_SYSTEM_ATTRIBUTE
            ELSE TYPE_ID END, 
            MULTI_SELECT = TO_CHAR(h_lmulti_select), 
            REC_USER = h_rec_user
            WHERE (ELEMENT_ID = h_id AND PARENT_ID = h_parent_id) OR PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ATR_MS_ASSET', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ATR_MS_ASSET(120) : attr2.sql(9609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_ASSET(127) : attr2.sql(9616) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS_ASSET', 131+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS_ASSET(132) : attr2.sql(9621) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS_ASSET;
ALTER FUNCTION FC_U_ATR_MS_ASSET COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_LOCAL_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_C_LOCAL_ATTRIBUTE
(
     h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_new_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_LOCAL_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_LOCAL_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_C_LOCAL_ATTRIBUTE(' || 
       '''' || h_old_project_id || ''''
          || ', ' || '''' || h_new_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTRIBUTE', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_LOCAL_ATTRIBUTE(17) : attr2.sql(9648) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_C_LOCAL_ATTR_WBSA(h_old_project_id, h_new_project_id, h_rec_user);
   PMO_DB2M.SC_STATE := FC_C_LOCAL_ATTR_CRIA(h_old_project_id, h_new_project_id, h_rec_user);
   PMO_DB2M.SC_STATE := FC_C_LOCAL_ATTR_DOCUMENT(h_old_project_id, h_new_project_id, h_rec_user);
   
   --  SC_STATE = FC_C_LOCAL_ATTR_CLIENT(SC_PARAM(h_old_project_id),SC_PARAM(h_new_project_id),SC_PARAM(h_rec_user));
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTRIBUTE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTRIBUTE(27) : attr2.sql(9658) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_LOCAL_ATTRIBUTE', 30+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_LOCAL_ATTRIBUTE(31) : attr2.sql(9662) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_LOCAL_ATTRIBUTE;
ALTER FUNCTION FC_C_LOCAL_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION getAttributeTable ==
CREATE OR REPLACE FUNCTION getAttributeTable
(
     sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := Coalesce(sh_h_type_id, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('getAttributeTable') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('getAttributeTable'), '-- ' || SYSTIMESTAMP, ':r := getAttributeTable(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: getAttributeTable(14) : attr2.sql(9686) : ' || SYSTIMESTAMP);
   END IF; 

   If (isProjectType(h_type_id)) <> 0 OR (h_type_id = PMO_CNST.SC_RESOURCE) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 18+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(19) : attr2.sql(9691) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_WBS;
   ElsIf isWBSDeliv(h_type_id) <> 0 OR isCRIRespDeliv(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 23+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(24) : attr2.sql(9696) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_WBS;
   ElsIf isWBSTask(h_type_id) <> 0 OR isCRIRespTask(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(29) : attr2.sql(9701) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_WBS;
   ElsIf isPureCRIDeliv(h_type_id) <> 0 OR isCRIConvertTask(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(34) : attr2.sql(9706) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_CRI;
   ElsIf (h_type_id = PMO_CNST.SC_DOCUMENT) OR (h_type_id = PMO_CNST.SC_WP_LINK) 
         OR (h_type_id = PMO_CNST.SC_WORK_INPUT) OR (h_type_id = PMO_CNST.SC_SOFTWARE) 
         OR (h_type_id = PMO_CNST.SC_LINK) OR (h_type_id = PMO_CNST.SC_NOTE_MINUTES) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(41) : attr2.sql(9713) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_DOC_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_POOLS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(46) : attr2.sql(9718) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_POL_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_CLIENTS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(51) : attr2.sql(9723) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_CLN_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_ASSETS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(56) : attr2.sql(9728) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_AST_ATTR;
   ElsIf h_type_id = PMO_CNST.SC_VENDORS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(61) : attr2.sql(9733) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TABLE_VDR_ATTR;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeTable', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeTable(66) : attr2.sql(9738) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN h_type_id;
      NULL;
   End If;
END;
/
SHOW ERRORS FUNCTION getAttributeTable;
ALTER FUNCTION getAttributeTable COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION getAttributeType ==
CREATE OR REPLACE FUNCTION getAttributeType
(
     sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := Coalesce(sh_h_type_id, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('getAttributeType') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('getAttributeType'), '-- ' || SYSTIMESTAMP, ':r := getAttributeType(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: getAttributeType(14) : attr2.sql(9764) : ' || SYSTIMESTAMP);
   END IF; 

   If isProjectType(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 18+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(19) : attr2.sql(9769) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_PROJECT;
   ElsIf isWBSDeliv(h_type_id) <> 0 OR isCRIRespDeliv(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 23+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(24) : attr2.sql(9774) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_DELIVERABLE;
   ElsIf isWBSTask(h_type_id) <> 0 OR isCRIRespTask(h_type_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(29) : attr2.sql(9779) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_TASK;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_CHANGE_REQUEST) 
         OR (h_type_id = PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(35) : attr2.sql(9785) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_CHANGE_REQUEST;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_ISSUE) OR (h_type_id = PMO_CNST.SC_CRI_ISSUE_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(40) : attr2.sql(9790) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_ISSUE;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_REQUIREMENT) 
         OR (h_type_id = PMO_CNST.SC_CRI_REQUIREMENT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(46) : attr2.sql(9796) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_REQUIREMENT;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_RISK) OR (h_type_id = PMO_CNST.SC_CRI_RISK_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(51) : attr2.sql(9801) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_RISK;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_DEFECT) OR (h_type_id = PMO_CNST.SC_CRI_DEFECT_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(56) : attr2.sql(9806) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_DEFECT;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_SERVICE_REQUEST) 
         OR (h_type_id = PMO_CNST.SC_CRI_SERVICE_REQUEST_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(62) : attr2.sql(9812) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_SERVICE_REQUEST;
   ElsIf (h_type_id = PMO_CNST.SC_CRI_ACTION_ITEM) 
         OR (h_type_id = PMO_CNST.SC_CRI_ACTION_ITEM_TASK) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(68) : attr2.sql(9818) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CRI_ACTION_ITEM;
   ElsIf (h_type_id = PMO_CNST.SC_DOCUMENT) OR (h_type_id = PMO_CNST.SC_WP_LINK) 
         OR (h_type_id = PMO_CNST.SC_WORK_INPUT) OR (h_type_id = PMO_CNST.SC_SOFTWARE) 
         OR (h_type_id = PMO_CNST.SC_LINK) OR (h_type_id = PMO_CNST.SC_NOTE_MINUTES) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(75) : attr2.sql(9825) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_DOCUMENT;
   ElsIf h_type_id = PMO_CNST.SC_POOLS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 79+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(80) : attr2.sql(9830) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_POOLS;
   ElsIf h_type_id = PMO_CNST.SC_CLIENTS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(85) : attr2.sql(9835) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_CLIENTS;
   ElsIf h_type_id = PMO_CNST.SC_ASSETS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(90) : attr2.sql(9840) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_ASSETS;
   ElsIf h_type_id = PMO_CNST.SC_VENDORS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(95) : attr2.sql(9845) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.SC_VENDORS;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'getAttributeType', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: getAttributeType(100) : attr2.sql(9850) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN h_type_id;
      NULL;
   End If;
END;
/
SHOW ERRORS FUNCTION getAttributeType;
ALTER FUNCTION getAttributeType COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_DEFAULT_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_A_DEFAULT_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DEFAULT_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DEFAULT_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DEFAULT_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTRIBUTE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DEFAULT_ATTRIBUTE(21) : attr2.sql(9883) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_WBSA(h_project_id, h_element_id, h_type_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_CRIA(h_project_id, h_element_id, h_type_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTR_DOCUMENT(h_project_id, h_element_id, h_type_id, h_rec_user);
         --case SC_CLIENTS :
         --    SC_STATE =FC_A_DEFAULT_ATTR_CLIENT(SC_PARAM(h_project_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
         --    break;
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTRIBUTE', 43+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTRIBUTE(44) : attr2.sql(9906) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DEFAULT_ATTRIBUTE', 47+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DEFAULT_ATTRIBUTE(48) : attr2.sql(9910) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DEFAULT_ATTRIBUTE;
ALTER FUNCTION FC_A_DEFAULT_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_C_A_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_C_A_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_A_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_A_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_C_A_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTRIBUTE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_A_ATTRIBUTE(23) : attr2.sql(9943) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_WBSA(h_project_id, h_element_id, h_old_element_id, h_type_id
                                      , h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_CRIA(h_project_id, h_element_id, h_old_element_id, h_type_id
                                      , h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_C_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_old_element_id, h_type_id
                                          , h_rec_user);
         
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTRIBUTE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTRIBUTE(47) : attr2.sql(9967) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_A_ATTRIBUTE', 50+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_A_ATTRIBUTE(51) : attr2.sql(9971) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_A_ATTRIBUTE;
ALTER FUNCTION FC_C_A_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_A_ALL_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_A_ALL_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_old_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_old_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ALL_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ALL_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ALL_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_old_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_old_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTRIBUTE', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ALL_ATTRIBUTE(25) : attr2.sql(10006) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTR_WBSA(h_project_id, h_old_project_id, h_element_id
                                        , h_old_element_id, h_type_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTR_CRIA(h_project_id, h_old_project_id, h_element_id
                                        , h_old_element_id, h_type_id, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ALL_ATTR_DOCUMENT(h_project_id, h_old_project_id, h_element_id
                                            , h_old_element_id, h_type_id, h_rec_user);
         
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTRIBUTE', 48+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTRIBUTE(49) : attr2.sql(10030) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ALL_ATTRIBUTE', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ALL_ATTRIBUTE(53) : attr2.sql(10034) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ALL_ATTRIBUTE;
ALTER FUNCTION FC_A_ALL_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_PROJECT_CATEGORY_NAME ==
CREATE OR REPLACE FUNCTION FC_U_PROJECT_CATEGORY_NAME
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_new_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJECT_CATEGORY_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJECT_CATEGORY_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJECT_CATEGORY_NAME(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_new_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_CATEGORY_NAME', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJECT_CATEGORY_NAME(17) : attr2.sql(10061) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_U_PROJECT_NAME_WBSA(h_project_id, h_new_name, h_rec_user);
   PMO_DB2M.SC_STATE := FC_U_PROJECT_NAME_CRIA(h_project_id, h_new_name, h_rec_user);
   PMO_DB2M.SC_STATE := FC_U_PROJECT_NAME_DOCUMENT(h_project_id, h_new_name, h_rec_user);
   
   --  SC_STATE = FC_U_PROJECT_NAME_CLIENT(SC_PARAM(h_project_id),SC_PARAM(h_new_name),SC_PARAM(h_rec_user));
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_CATEGORY_NAME', 26+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_CATEGORY_NAME(27) : attr2.sql(10071) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJECT_CATEGORY_NAME', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJECT_CATEGORY_NAME(32) : attr2.sql(10076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJECT_CATEGORY_NAME;
ALTER FUNCTION FC_U_PROJECT_CATEGORY_NAME COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE ==
CREATE OR REPLACE FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_type PLS_INTEGER
   , sh_h_new_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_type PLS_INTEGER := sh_h_old_type;
   h_new_type PLS_INTEGER := sh_h_new_type;
   h_attribute_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_AFTER_CHANGE_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_AFTER_CHANGE_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_AFTER_CHANGE_TYPE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_new_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_AFTER_CHANGE_TYPE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_AFTER_CHANGE_TYPE(24) : attr2.sql(10110) : ' || SYSTIMESTAMP);
   END IF; 

   h_attribute_id := NULL;
   
   PMO_DB2M.SC_STATE := FC_UA_ATR(h_old_type, h_element_id, h_attribute_id, h_rec_user);
   PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_element_id, h_new_type, h_rec_user);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_AFTER_CHANGE_TYPE', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_AFTER_CHANGE_TYPE(32) : attr2.sql(10118) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_AFTER_CHANGE_TYPE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_AFTER_CHANGE_TYPE(36) : attr2.sql(10122) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE;
ALTER FUNCTION FC_U_ATR_AFTER_CHANGE_TYPE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_D_ATR ==
CREATE OR REPLACE FUNCTION FC_D_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_updateFlag PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_D_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_ATR(24) : attr2.sql(10156) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_WBSA(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_CRIA(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_DOCUMENT(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_POOL(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_CLIENT(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_ASSET(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_D_ATR_VENDOR(h_table_type, h_id, h_parent_id, h_del_flag, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR(59) : attr2.sql(10191) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_ATR', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_ATR(63) : attr2.sql(10195) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_ATR;
ALTER FUNCTION FC_D_ATR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_ATR ==
CREATE OR REPLACE FUNCTION FC_UA_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attribute_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_parent_id VARCHAR2(32);
   h_del_flag VARCHAR2(1);
   h_local VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attribute_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_ATR(25) : attr2.sql(10230) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   -- if(IsNullParam(h_attribute_id) this means that we want to unassign all
   -- wbs or cri item with  h_id from attributes table
   -- else
   -- we only unassign this object from current attribute
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_WBSA(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_CRIA(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_DOCUMENT(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_POOL(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_CLIENT(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_ASSET(h_table_type, h_id, h_attribute_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_UA_ATR_VENDOR(h_table_type, h_id, h_attribute_id, h_rec_user);
         
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR', 61+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR(62) : attr2.sql(10267) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_ATR', 65+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_ATR(66) : attr2.sql(10271) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_ATR;
ALTER FUNCTION FC_UA_ATR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_U_ATR ==
CREATE OR REPLACE FUNCTION FC_U_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , sh_h_input_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_weight PLS_INTEGER := sh_h_weight;
   h_input_type PLS_INTEGER := sh_h_input_type;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_input_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR(31) : attr2.sql(10312) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   If ((h_table_type IS NULL)) OR ((h_id IS NULL)) OR ((h_rec_user IS NULL)) Then
      --RETURN_INVALID(ELEMENT_ID_REQUIRED);
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR(39) : attr2.sql(10320) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_WBSA(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                   , h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_CRIA(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                   , h_input_type, h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_DOCUMENT(h_table_type, h_id, h_parent_id, h_name, h_description
                                       , h_weight, h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_POOL(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                   , h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_CLIENT(h_table_type, h_id, h_parent_id, h_name, h_description
                                     , h_weight, h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_ASSET(h_table_type, h_id, h_parent_id, h_name, h_description, h_weight
                                    , h_input_type, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_VENDOR(h_table_type, h_id, h_parent_id, h_name, h_description
                                     , h_weight, h_input_type, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 77+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR(78) : attr2.sql(10359) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR', 81+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR(82) : attr2.sql(10363) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR;
ALTER FUNCTION FC_U_ATR COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_A_ATR ==
CREATE OR REPLACE FUNCTION FC_A_ATR
(
     sh_h_table_type PLS_INTEGER
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_attr_table PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_ATR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_ATR'), '-- ' || SYSTIMESTAMP, ':r := FC_A_ATR(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_ATR(22) : attr2.sql(10395) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_table_type IS NULL)) OR ((h_element_id IS NULL)) OR ((h_id IS NULL)) 
         OR ((h_rec_user IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR(28) : attr2.sql(10401) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   -- Declare host variables
   PMO_DB2M.SC_STATE := 0;
   h_type_id := h_table_type;
   
   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      h_type_id := PMO_CNST.SC_PROJECT;
   ElsIf (isTask(Coalesce(h_type_id, 0))) <> 0 AND (Coalesce(
         h_attr_table, 0) = PMO_CNST.SC_TABLE_WBS) Then
      h_type_id := PMO_CNST.SC_TASK;
   ElsIf ((isWBSDeliv(Coalesce(h_type_id, 0))) <> 0 OR (isCRIDeliv(Coalesce(h_type_id, 0))) <> 0) 
         AND (Coalesce(h_attr_table, 0) = PMO_CNST.SC_TABLE_WBS) Then
      h_type_id := PMO_CNST.SC_DELIVERABLE;
   End If;
   
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_WBSA(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_CRIA(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_DOCUMENT(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_POOL(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_CLIENT(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_ASSET(h_type_id, h_element_id, h_id, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_A_ATR_VENDOR(h_type_id, h_element_id, h_id, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 74+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR(75) : attr2.sql(10448) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_ATR', 78+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_ATR(79) : attr2.sql(10452) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_ATR;
ALTER FUNCTION FC_A_ATR COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_U_ATR_MS ==
CREATE OR REPLACE FUNCTION FC_U_ATR_MS
(
     sh_h_table_type PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_lmulti_select PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_lmulti_select PLS_INTEGER := sh_h_lmulti_select;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATR_MS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATR_MS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATR_MS(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_lmulti_select), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATR_MS(24) : attr2.sql(10486) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_table_type, 0));
   
   PMO_DB2M.SC_STATE := 0;
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_WBSA(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_CRIA(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_DOCUMENT(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_POL_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_POOL(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_CLN_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_CLIENT(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_AST_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_ASSET(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      WHEN PMO_CNST.SC_TABLE_VDR_ATTR THEN
         PMO_DB2M.SC_STATE := FC_U_ATR_MS_VENDOR(h_id, h_parent_id, h_lmulti_select, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS', 56+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS(57) : attr2.sql(10519) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATR_MS', 60+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATR_MS(61) : attr2.sql(10523) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATR_MS;
ALTER FUNCTION FC_U_ATR_MS COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_M_ASS_ATTR_WBS ==
CREATE OR REPLACE FUNCTION FC_M_ASS_ATTR_WBS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MAATR_WBS IS
         SELECT ELEMENT_ID ,TYPE_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_source_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ASS_ATTR_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ASS_ATTR_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ASS_ATTR_WBS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_WBS', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ASS_ATTR_WBS(29) : attr2.sql(10562) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN MAATR_WBS;
   
   LOOP
      FETCH  MAATR_WBS INTO h_element_id,h_type_id;
      IF MAATR_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      --  trace_printf("2pp > h_element_id:%s\n",h_element_id);
      -- Declare host variables
      PMO_DB2M.SC_STATE := 0;
      h_table_type := h_type_id;
      --      trace_printf("1 type_id :%d \n",h_type_id);
      --      trace_printf("1  h_table_type :%d \n",h_table_type);
      
      h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
      
      --      trace_printf("2 type_id :%d \n",h_type_id);
      --      trace_printf("2  h_table_type :%d \n",h_table_type);
      CASE h_attr_table
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_WBSA(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_CRIA(h_project_id, h_element_id, h_table_type, h_rec_user);
            
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   END LOOP;
   BEGIN
      CLOSE MAATR_WBS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ASS_ATTR_WBS', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ASS_ATTR_WBS(82) : attr2.sql(10615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_WBS', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_WBS(88) : attr2.sql(10621) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_WBS', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_WBS(92) : attr2.sql(10625) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ASS_ATTR_WBS;
ALTER FUNCTION FC_M_ASS_ATTR_WBS COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_M_ASS_ATTR_CRI ==
CREATE OR REPLACE FUNCTION FC_M_ASS_ATTR_CRI
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MAATR_CRI IS
         SELECT ELEMENT_ID ,TYPE_ID
         FROM TMT_CRI
         WHERE RANK LIKE h_source_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ASS_ATTR_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ASS_ATTR_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ASS_ATTR_CRI(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_CRI', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ASS_ATTR_CRI(29) : attr2.sql(10664) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN MAATR_CRI;
   
   LOOP
      FETCH  MAATR_CRI INTO h_element_id,h_type_id;
      IF MAATR_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      --  trace_printf("2pp > h_element_id:%s\n",h_element_id);
      -- Declare host variables
      PMO_DB2M.SC_STATE := 0;
      h_table_type := h_type_id;
      --      trace_printf("1 type_id :%d \n",h_type_id);
      --      trace_printf("1  h_table_type :%d \n",h_table_type);
      
      h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
      
      --      trace_printf("2 type_id :%d \n",h_type_id);
      --      trace_printf("2  h_table_type :%d \n",h_table_type);
      CASE h_attr_table
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_WBSA(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_CRIA(h_project_id, h_element_id, h_table_type, h_rec_user);
            
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   END LOOP;
   BEGIN
      CLOSE MAATR_CRI;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ASS_ATTR_CRI', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ASS_ATTR_CRI(82) : attr2.sql(10717) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_CRI', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_CRI(88) : attr2.sql(10723) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_CRI', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_CRI(92) : attr2.sql(10727) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ASS_ATTR_CRI;
ALTER FUNCTION FC_M_ASS_ATTR_CRI COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_M_ASS_ATTR_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ASS_ATTR_DOC
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_attr_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_local VARCHAR2(1);
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_attr_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MAATR_DOC IS
         SELECT ELEMENT_ID ,TYPE_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ASS_ATTR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ASS_ATTR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ASS_ATTR_DOC(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ASS_ATTR_DOC(29) : attr2.sql(10766) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN MAATR_DOC;
   
   LOOP
      FETCH  MAATR_DOC INTO h_element_id,h_type_id;
      IF MAATR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      --  trace_printf("2pp > h_element_id:%s\n",h_element_id);
      PMO_DB2M.SC_STATE := 0;
      h_table_type := h_type_id;
      --      trace_printf("1 type_id :%d \n",h_type_id);
      --      trace_printf("1  h_table_type :%d \n",h_table_type);
      
      h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
      
      --      trace_printf("2 type_id :%d \n",h_type_id);
      --      trace_printf("2  h_table_type :%d \n",h_table_type);
      CASE h_attr_table
         
         WHEN PMO_CNST.SC_TABLE_WBS THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_WBSA(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         WHEN PMO_CNST.SC_TABLE_CRI THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_CRIA(h_project_id, h_element_id, h_table_type, h_rec_user);
            
         
         WHEN PMO_CNST.SC_TABLE_DOC_ATTR THEN
            PMO_DB2M.SC_STATE := FC_M_A_ATTR_DOCUMENT(h_project_id, h_element_id, h_table_type, h_rec_user);
         
         ELSE
            PMO_DB2M.SC_STATE := 0;
      END CASE;
   END LOOP;
   BEGIN
      CLOSE MAATR_DOC;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ASS_ATTR_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ASS_ATTR_DOC(81) : attr2.sql(10818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_DOC(87) : attr2.sql(10824) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ASS_ATTR_DOC', 90+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ASS_ATTR_DOC(91) : attr2.sql(10828) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ASS_ATTR_DOC;
ALTER FUNCTION FC_M_ASS_ATTR_DOC COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_CRI_LOCAL_ATTR ==
CREATE OR REPLACE FUNCTION FC_UA_CRI_LOCAL_ATTR
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_parent_id VARCHAR2(32);
   h_number_of_local_attr PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR attr_parent IS
         SELECT PARENT_ID
         FROM TMT_CRI_ATTRIBUTES
         WHERE  ROWNUM <= 1 AND  LOCAL = 'Y'
         AND ELEMENT_ID = h_element_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_CRI_LOCAL_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_CRI_LOCAL_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_CRI_LOCAL_ATTR(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_CRI_LOCAL_ATTR', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_CRI_LOCAL_ATTR(29) : attr2.sql(10867) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   OPEN attr_parent;
   
   FETCH attr_parent INTO h_parent_id;
   IF attr_parent%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   BEGIN
      CLOSE attr_parent ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_CRI_LOCAL_ATTR', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_CRI_LOCAL_ATTR(50) : attr2.sql(10888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_number_of_local_attr := 0;
   BEGIN
      SELECT COUNT(*) 
      INTO h_number_of_local_attr
      FROM TMT_CRI_ATTRIBUTES
      WHERE LOCAL = 'Y'
      AND ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_CRI_LOCAL_ATTR', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_CRI_LOCAL_ATTR(68) : attr2.sql(10906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_number_of_local_attr, 0) > 0 Then
      BEGIN
         DELETE FROM TMT_CRI_ATTRIBUTES
         WHERE LOCAL = 'Y'
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_CRI_LOCAL_ATTR', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_CRI_LOCAL_ATTR(88) : attr2.sql(10926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         Update TMT_CRI_ATTRIBUTES
         set CHILD_COUNT = CHILD_COUNT - h_number_of_local_attr
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UA_CRI_LOCAL_ATTR', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UA_CRI_LOCAL_ATTR(107) : attr2.sql(10945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_CRI_LOCAL_ATTR', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_CRI_LOCAL_ATTR(117) : attr2.sql(10955) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_CRI_LOCAL_ATTR', 120+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_CRI_LOCAL_ATTR(121) : attr2.sql(10959) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_CRI_LOCAL_ATTR;
ALTER FUNCTION FC_UA_CRI_LOCAL_ATTR COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_UA_LOCAL_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_UA_LOCAL_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_attr_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UA_LOCAL_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UA_LOCAL_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_UA_LOCAL_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_LOCAL_ATTRIBUTE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UA_LOCAL_ATTRIBUTE(21) : attr2.sql(10990) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   h_attr_table := getAttributeTable(Coalesce(h_type_id, 0));
   
   -- this function just support unassigning cri local default attributes (it may extend to support for other tables)
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         PMO_DB2M.SC_STATE := FC_UA_CRI_LOCAL_ATTR(h_project_id, h_element_id, h_type_id, h_rec_user);
      
      ELSE
         PMO_DB2M.SC_STATE := 0;
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_LOCAL_ATTRIBUTE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_LOCAL_ATTRIBUTE(36) : attr2.sql(11005) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UA_LOCAL_ATTRIBUTE', 39+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UA_LOCAL_ATTRIBUTE(40) : attr2.sql(11009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UA_LOCAL_ATTRIBUTE;
ALTER FUNCTION FC_UA_LOCAL_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_CRI_REASSIGN_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_CRI_REASSIGN_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , sh_h_target_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := sh_h_target_type;
   h_attr_source_type_id PLS_INTEGER := 0;
   h_attr_target_type_id PLS_INTEGER := 0;
   h_classification_id VARCHAR2(32);
   h_insert_attribute PLS_INTEGER := 0;
   h_attribute_id VARCHAR2(32);
   h_multi_select VARCHAR2(1);
   h_local VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
-- Declare Cursors
      CURSOR cri_config_attr IS
         SELECT A.PARENT_ID, A.LOCAL
         FROM TMT_CRI_ATTRIBUTES A
         WHERE A.ELEMENT_ID = h_project_id 
         AND A.LEVEL_ID > 1
         AND A.TYPE_ID = h_attr_target_type_id
         AND (A.PARENT_ID NOT IN (
         SELECT B.PARENT_ID
         FROM TMT_CRI_ATTRIBUTES B
         WHERE  B.ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND  B.TYPE_ID = h_attr_source_type_id));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CRI_REASSIGN_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CRI_REASSIGN_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_CRI_REASSIGN_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_REASSIGN_ATTRIBUTE', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CRI_REASSIGN_ATTRIBUTE(46) : attr2.sql(11065) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_source_type_id := getAttributeType(Coalesce(h_source_type, 0));
   h_attr_target_type_id := getAttributeType(Coalesce(h_target_type, 0));
   
   -- select all defined local/default attributes for the target type
   -- that are not assigned yet
   
   OPEN cri_config_attr;
   
   LOOP
      FETCH cri_config_attr INTO h_attribute_id, h_local;
      IF cri_config_attr%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      BEGIN
         SELECT A.PARENT_ID, COALESCE(clf.MULTI_SELECT, '')
         INTO h_classification_id, h_multi_select
         FROM TMT_CRI_ATTRIBUTES A, TMT_CRI_ATTRIBUTES clf
         WHERE A.ELEMENT_ID = h_attribute_id
         AND clf.ELEMENT_ID = A.PARENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_REASSIGN_ATTRIBUTE', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_REASSIGN_ATTRIBUTE(81) : attr2.sql(11100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_insert_attribute := 0;
      If PMO_ORASTD.strncmp(h_multi_select, '0', 1) = 0 Then
         h_insert_attribute := 1;
      Else
         -- a single select attribute is encountered
         -- check to see if another attribute with the same category is already assigend to element or not
         BEGIN
            SELECT COUNT(*)
            INTO h_insert_attribute
            FROM TMT_CRI_ATTRIBUTES B, TMT_CRI_ATTRIBUTES clf
            WHERE B.ELEMENT_ID = h_element_id
            AND B.PARENT_ID = clf.ELEMENT_ID 
            AND clf.PARENT_ID = h_classification_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_REASSIGN_ATTRIBUTE', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_REASSIGN_ATTRIBUTE(105) : attr2.sql(11124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_insert_attribute, 0) <> 0 Then
            h_insert_attribute := 0;
         Else
            h_insert_attribute := 1;
         End If;
      End If;
      
      If Coalesce(h_insert_attribute, 0) <> 0 Then
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CRI_ATTRIBUTES', h_attribute_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         BEGIN
            INSERT INTO TMT_CRI_ATTRIBUTES
            (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME, DESCRIPTION)
            SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attribute_id, h_element_id, h_attr_target_type_id, A.LEVEL_ID + 1, A.LOCAL,
            h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME, B.DESCRIPTION
            FROM TMT_CRI_ATTRIBUTES A ,TMT_CRI_ATTRIBUTES B
            WHERE A.ELEMENT_ID = h_attribute_id
            AND A.ELEMENT_ID = B.PARENT_ID
            AND B.ELEMENT_ID = h_project_id
            AND B.TYPE_ID = h_attr_target_type_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_REASSIGN_ATTRIBUTE', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_REASSIGN_ATTRIBUTE(141) : attr2.sql(11160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- if type is changed then update assigned attribute to the new type
         BEGIN
            UPDATE TMT_CRI_ATTRIBUTES 
            SET TYPE_ID = h_attr_target_type_id
            WHERE ELEMENT_ID = h_element_id
            AND TYPE_ID = h_attr_source_type_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_REASSIGN_ATTRIBUTE', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_REASSIGN_ATTRIBUTE(162) : attr2.sql(11181) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE cri_config_attr ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CRI_REASSIGN_ATTRIBUTE', 176+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CRI_REASSIGN_ATTRIBUTE(177) : attr2.sql(11196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_REASSIGN_ATTRIBUTE', 185+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_REASSIGN_ATTRIBUTE(186) : attr2.sql(11205) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CRI_REASSIGN_ATTRIBUTE', 189+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CRI_REASSIGN_ATTRIBUTE(190) : attr2.sql(11209) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CRI_REASSIGN_ATTRIBUTE;
ALTER FUNCTION FC_CRI_REASSIGN_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION FC_WBS_REASSIGN_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_WBS_REASSIGN_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , sh_h_target_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := sh_h_target_type;
   h_attr_source_type_id PLS_INTEGER := 0;
   h_attr_target_type_id PLS_INTEGER := 0;
   h_classification_id VARCHAR2(32);
   h_insert_attribute PLS_INTEGER := 0;
   h_attribute_id VARCHAR2(32);
   h_multi_select VARCHAR2(1);
   h_local VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
-- Declare Cursors
      CURSOR wbs_config_attr IS
         SELECT A.PARENT_ID, A.LOCAL
         FROM TMT_WBS_ATTRIBUTES A
         WHERE A.ELEMENT_ID = h_project_id 
         AND A.LEVEL_ID > 1
         AND A.TYPE_ID = h_attr_target_type_id
         AND (A.PARENT_ID NOT IN (
         SELECT B.PARENT_ID
         FROM TMT_WBS_ATTRIBUTES B
         WHERE B.ELEMENT_ID = h_element_id
         AND A.PARENT_ID = B.PARENT_ID
         AND B.TYPE_ID = h_attr_source_type_id));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_REASSIGN_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_REASSIGN_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_REASSIGN_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_REASSIGN_ATTRIBUTE', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_REASSIGN_ATTRIBUTE(46) : attr2.sql(11265) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_source_type_id := getAttributeType(Coalesce(h_source_type, 0));
   h_attr_target_type_id := getAttributeType(Coalesce(h_target_type, 0));
   
   -- select all defined local/default attributes for the target type
   -- that are not assigned yet
   
   OPEN wbs_config_attr;
   
   LOOP
      FETCH wbs_config_attr INTO h_attribute_id, h_local;
      IF wbs_config_attr%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      BEGIN
         SELECT A.PARENT_ID, COALESCE(clf.MULTI_SELECT, '')
         INTO h_classification_id, h_multi_select
         FROM TMT_WBS_ATTRIBUTES A, TMT_WBS_ATTRIBUTES clf
         WHERE A.ELEMENT_ID = h_attribute_id
         AND clf.ELEMENT_ID = A.PARENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_REASSIGN_ATTRIBUTE', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_REASSIGN_ATTRIBUTE(81) : attr2.sql(11300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_insert_attribute := 0;
      If PMO_ORASTD.strncmp(h_multi_select, '0', 1) = 0 Then
         h_insert_attribute := 1;
      Else
         -- a single select attribute is encountered
         -- check to see if another attribute with the same category is already assigend to element or not
         BEGIN
            SELECT COUNT(*)
            INTO h_insert_attribute
            FROM TMT_WBS_ATTRIBUTES B, TMT_WBS_ATTRIBUTES clf
            WHERE B.ELEMENT_ID = h_element_id
            AND B.PARENT_ID = clf.ELEMENT_ID 
            AND clf.PARENT_ID = h_classification_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_REASSIGN_ATTRIBUTE', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_REASSIGN_ATTRIBUTE(105) : attr2.sql(11324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_insert_attribute, 0) <> 0 Then
            h_insert_attribute := 0;
         Else
            h_insert_attribute := 1;
         End If;
         
      End If;
      
      If Coalesce(h_insert_attribute, 0) <> 0 Then
         PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS_ATTRIBUTES', h_attribute_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         BEGIN
            INSERT INTO TMT_WBS_ATTRIBUTES
            (RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, LOCAL, REC_USER, ELEMENT_NAME, PARENT_NAME, DESCRIPTION)
            SELECT RTRIM( COALESCE(A.RANK, '')) || h_rankBase64, h_attribute_id, h_element_id, h_attr_target_type_id, A.LEVEL_ID + 1, A.LOCAL,
            h_rec_user, A.ELEMENT_NAME, A.PARENT_NAME, B.DESCRIPTION
            FROM TMT_WBS_ATTRIBUTES A, TMT_WBS_ATTRIBUTES B
            WHERE A.ELEMENT_ID = h_attribute_id
            AND A.ELEMENT_ID = B.PARENT_ID
            AND B.ELEMENT_ID = h_project_id
            AND B.TYPE_ID = h_attr_target_type_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_REASSIGN_ATTRIBUTE', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_REASSIGN_ATTRIBUTE(141) : attr2.sql(11360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- if type is changed then update assigned attribute to the new type
         BEGIN
            UPDATE TMT_WBS_ATTRIBUTES 
            SET TYPE_ID = h_attr_target_type_id
            WHERE ELEMENT_ID = h_attribute_id
            AND TYPE_ID = h_attr_source_type_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_REASSIGN_ATTRIBUTE', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_REASSIGN_ATTRIBUTE(162) : attr2.sql(11381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE wbs_config_attr ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_REASSIGN_ATTRIBUTE', 176+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_REASSIGN_ATTRIBUTE(177) : attr2.sql(11396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_REASSIGN_ATTRIBUTE', 185+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_REASSIGN_ATTRIBUTE(186) : attr2.sql(11405) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_REASSIGN_ATTRIBUTE', 189+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_REASSIGN_ATTRIBUTE(190) : attr2.sql(11409) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_WBS_REASSIGN_ATTRIBUTE;
ALTER FUNCTION FC_WBS_REASSIGN_ATTRIBUTE COMPILE DEBUG;

/***************************************************************************************/

/*
	task: This function reassign default/local attributes 
	where to use: 
		- when converting a type to another type 
		- when move a cri element to another project
	rules:
		1- default attributes can be Local (defined in project level) or global (defined in system admin globally)
		2- for converting element type
			2-1- keep assigned local/global attrinutes of source element and just update the type to target type
			2-2- if there are defined local/global attributes for the target type
				2-2-1- if attribute element is already assigned do nothing
				2-2-2- if attribute element is not assigned yet
					2-2-2-1- if attribute element belongs to a single attribute category do nothing
					2-2-2-2- if attribute element belongs to a multiple attribute category then add it to element attributes set
		3- for moving or copying elements from one project to anoter project 
*/

Prompt == FUNCTION FC_REASSIGN_ATTRIBUTE ==
CREATE OR REPLACE FUNCTION FC_REASSIGN_ATTRIBUTE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_source_type PLS_INTEGER
   , sh_h_target_type PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_source_type PLS_INTEGER := sh_h_source_type;
   h_target_type PLS_INTEGER := sh_h_target_type;
   h_attr_table PLS_INTEGER := 0;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_REASSIGN_ATTRIBUTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_REASSIGN_ATTRIBUTE'), '-- ' || SYSTIMESTAMP, ':r := FC_REASSIGN_ATTRIBUTE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_source_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REASSIGN_ATTRIBUTE', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_REASSIGN_ATTRIBUTE(25) : attr2.sql(11461) : ' || SYSTIMESTAMP);
   END IF; 

   h_attr_table := getAttributeTable(Coalesce(h_source_type, 0));
   CASE h_attr_table
      WHEN PMO_CNST.SC_TABLE_WBS THEN
         null_return := FC_WBS_REASSIGN_ATTRIBUTE(h_project_id, h_element_id, h_source_type, h_target_type
                                         , h_rec_user);
         
      
      WHEN PMO_CNST.SC_TABLE_CRI THEN
         null_return := FC_CRI_REASSIGN_ATTRIBUTE(h_project_id, h_element_id, h_source_type, h_target_type
                                         , h_rec_user);
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REASSIGN_ATTRIBUTE', 42+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_REASSIGN_ATTRIBUTE(43) : attr2.sql(11479) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_REASSIGN_ATTRIBUTE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_REASSIGN_ATTRIBUTE(47) : attr2.sql(11483) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_REASSIGN_ATTRIBUTE;
ALTER FUNCTION FC_REASSIGN_ATTRIBUTE COMPILE DEBUG;


