/*****************************************************************************************/

Prompt == FUNCTION SP_S_A_BUDGET ==
CREATE OR REPLACE FUNCTION SP_S_A_BUDGET
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ_ALL PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_asset_ALL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_BUDGET(30) : budgets.sql(33) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_BUDGET', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_BUDGET(35) : budgets.sql(38) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(38) : budgets.sql(41) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_element_id;
   h_table_type := p_table_type;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(59) : budgets.sql(62) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_A_BUDGET', 65+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_A_BUDGET(66) : budgets.sql(69) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 68+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(69) : budgets.sql(72) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
      End If;
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(84) : budgets.sql(87) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_A_BUDGET', 90+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_A_BUDGET(91) : budgets.sql(94) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(94) : budgets.sql(97) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
      End If;
   Else
      BEGIN
         SELECT ELEMENT_ID INTO h_project_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(109) : budgets.sql(112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_A_BUDGET', 115+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_A_BUDGET(116) : budgets.sql(119) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(119) : budgets.sql(122) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
      End If;
   End If;
   
   If (Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS) OR (Coalesce(
             h_table_type, 0) = PMO_CNST.SC_TABLE_CRI) Then
      OPEN SELECT_READ_ALL FOR SELECT B.BUDGET_ID AS ELEMENT_ID, B.CHARGECODE_ID AS ORIGINAL_ID,
      CC.ELEMENT_NAME AS ELEMENT_NAME, 31 AS TYPE_ID,
      B.CAPITAL_EXPENSE, B.BILLABLE,
      B.ASSOCIATE_BUDGET_ID, AB.CAPITAL_EXPENSE AS ASSOCIATE_BUDGET_TYPE,
      ACC.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME,
      B.AUTO_FLAG, B.ACTUAL_EDITED, B.TIMEPHASED_FLAG, B.ACTUAL_TIMEPHASED_FLAG,
      B.PROJECT_ID,
      B.TOTAL_ESTIMATION_PROB_AMOUNT, B.TOTAL_BUDGET_PROB_AMOUNT,
      B.PROB_PERCENT, B.PROB_AMOUNT, B.ESTIMATED_PROB_AMOUNT,
      B.ESTIMATED_PROB_AMOUNT_TOTAL,
      B.ESTIMATED_BASELINE1, B.ESTIMATED_BASELINE2, B.ESTIMATED_BASELINE3,
      B.ESTIMATED_TOTAL, B.ESTIMATED_BUDGET,
      B.ESTIMATED_ACTUAL_TOTAL, B.ESTIMATED_ACTUAL,
      B.ESTIMATED_ETC_TOTAL, B.ESTIMATED_ETC,
      B.ESTIMATED_PAID_TODATE_TOTAL, B.ESTIMATED_PAID_TODATE,
      B.BUDGET_BASELINE1, B.BUDGET_BASELINE2, B.BUDGET_BASELINE3,
      B.BUDGET, B.ACTUAL, B.ETC,
      B.CHARGED, B.LEDGER,
      B.ESTIMATED_CHARGED, B.ESTIMATED_LEDGER,
      B.ESTIMATED_CHARGED_TOTAL, B.ESTIMATED_LEDGER_TOTAL,
      B.PAID_TODATE,
      B.TXT_FIELD_01, B.TXT_FIELD_02, B.TXT_FIELD_03, B.TXT_FIELD_04, B.TXT_FIELD_05,
      B.TXT_FIELD_06, B.TXT_FIELD_07, B.TXT_FIELD_08, B.TXT_FIELD_09, B.TXT_FIELD_10,
      B.DATAFIELD_1, B.DATAFIELD_2, B.DATAFIELD_3, B.DATAFIELD_4,
      B.TOLERANCE
      FROM BUDGETS B
      JOIN TMT_CHARGECODES CC
      ON B.CHARGECODE_ID = CC.ELEMENT_ID
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      LEFT JOIN TMT_CHARGECODES ACC
      ON AB.CHARGECODE_ID = ACC.ELEMENT_ID
      WHERE B.PROJECT_ID = h_project_id
      AND B.ELEMENT_ID = h_element_id
      ORDER BY CC.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 162+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(163) : budgets.sql(166) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ_ALL;
   Else
      OPEN SELECT_asset_ALL FOR SELECT B.BUDGET_ID AS ELEMENT_ID, B.CHARGECODE_ID AS ORIGINAL_ID,
      W.ELEMENT_NAME AS ELEMENT_NAME, W.TYPE_ID,
      PMO_CNST.SC_EXPENSE AS CAPITAL_EXPENSE, PMO_CNST.SC_BILLABLE_NO AS BILLABLE,
      B.ASSOCIATE_BUDGET_ID, PMO_CNST.SC_EXPENSE AS ASSOCIATE_BUDGET_TYPE,
      '' AS ASSOCIATED_CHARGECODE_NAME,
      B.AUTO_FLAG, B.ACTUAL_EDITED, B.TIMEPHASED_FLAG, B.ACTUAL_TIMEPHASED_FLAG,
      B.PROJECT_ID,
      B.TOTAL_ESTIMATION_PROB_AMOUNT, B.TOTAL_BUDGET_PROB_AMOUNT,
      B.PROB_PERCENT, B.PROB_AMOUNT, B.ESTIMATED_PROB_AMOUNT,
      B.ESTIMATED_PROB_AMOUNT_TOTAL,
      B.ESTIMATED_BASELINE1, B.ESTIMATED_BASELINE2, B.ESTIMATED_BASELINE3,
      B.ESTIMATED_TOTAL, B.ESTIMATED_BUDGET,
      B.ESTIMATED_ACTUAL_TOTAL, B.ESTIMATED_ACTUAL,
      B.ESTIMATED_ETC_TOTAL, B.ESTIMATED_ETC,
      B.ESTIMATED_PAID_TODATE_TOTAL, B.ESTIMATED_PAID_TODATE,
      B.BUDGET_BASELINE1, B.BUDGET_BASELINE2, B.BUDGET_BASELINE3,
      B.BUDGET, B.ACTUAL, B.ETC,
      B.CHARGED, B.LEDGER,
      B.ESTIMATED_CHARGED, B.ESTIMATED_LEDGER,
      B.ESTIMATED_CHARGED_TOTAL, B.ESTIMATED_LEDGER_TOTAL,
      B.PAID_TODATE,
      B.TXT_FIELD_01, B.TXT_FIELD_02, B.TXT_FIELD_03, B.TXT_FIELD_04, B.TXT_FIELD_05,
      B.TXT_FIELD_06, B.TXT_FIELD_07, B.TXT_FIELD_08, B.TXT_FIELD_09, B.TXT_FIELD_10,
      B.DATAFIELD_1, B.DATAFIELD_2, B.DATAFIELD_3, B.DATAFIELD_4,
      B.TOLERANCE
      FROM BUDGETS B, TMT_WBS W
      WHERE B.CHARGECODE_ID = h_element_id
      AND W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      ORDER BY W.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_BUDGET', 197+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_BUDGET(198) : budgets.sql(201) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_asset_ALL;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 206+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(207) : budgets.sql(210) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_BUDGET', 218+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_BUDGET(219) : budgets.sql(222) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_BUDGET;
ALTER FUNCTION SP_S_A_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_A_BUDGET ==
CREATE OR REPLACE FUNCTION SP_A_BUDGET
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_chargecode_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_system_chargecode PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_A_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_chargecode_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_BUDGET', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_BUDGET(34) : budgets.sql(272) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_table_type IS NULL) OR (p_element_id IS NULL) OR (p_chargecode_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_BUDGET', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_BUDGET(39) : budgets.sql(277) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_BUDGET', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_BUDGET(42) : budgets.sql(280) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_table_type := p_table_type;
   h_element_id := p_element_id;
   h_chargecode_id := p_chargecode_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID, TYPE_ID
         INTO h_project_id, h_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(64) : budgets.sql(302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PROJECT_ID, TYPE_ID
         INTO h_project_id, h_type_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(80) : budgets.sql(318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_BUDGET', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_BUDGET(87) : budgets.sql(325) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_BUDGET', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_BUDGET(90) : budgets.sql(328) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
   End If;
   
   BEGIN
      SELECT BUDGET_ID
      INTO h_exists
      FROM BUDGETS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_chargecode_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(108) : budgets.sql(346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_system_chargecode := 0;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT CASE WHEN CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN 1 ELSE 0 END
         INTO h_system_chargecode
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_chargecode_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(126) : budgets.sql(364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         --trace_printf("\n System chargecode");
         h_uniqueID := h_exists;
      Else
         --trace_printf("\n no System chargecode");
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_BUDGET', 136+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_BUDGET(137) : budgets.sql(375) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_exists || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_BUDGET', 139+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_A_BUDGET(140) : budgets.sql(378) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_exists
               , True);
      End If;
   End If;
   
   If Coalesce(h_system_chargecode, 0) = 0 Then
      BEGIN
         SELECT CAPITAL_EXPENSE, ASSOCIATE_CHARGECODE_ID, BILLABLE
         INTO h_capital_expense, h_associate_chargecode_id, h_billable
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_chargecode_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(159) : budgets.sql(397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_BUDGET', 164+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_BUDGET(165) : budgets.sql(403) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_BUDGET', 167+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_A_BUDGET(168) : budgets.sql(406) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
      End If;
      
      h_uniqueID := SYS_GUID();
      
      If (h_associate_chargecode_id IS NOT NULL) Then
         BEGIN
            SELECT BUDGET_ID
            INTO h_associate_budget_id
            FROM BUDGETS
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = h_associate_chargecode_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(189) : budgets.sql(427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND ((h_associate_budget_id IS NOT NULL)) Then
            BEGIN
               UPDATE BUDGETS
               SET ASSOCIATE_BUDGET_ID = h_uniqueID
               WHERE BUDGET_ID = h_associate_budget_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 208+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(209) : budgets.sql(447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_associate_budget_id := NULL;
         End If;
      Else
         h_associate_budget_id := NULL;
      End If;
      
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CHARGECODE_ID,
         CAPITAL_EXPENSE, BILLABLE, ASSOCIATE_BUDGET_ID, TOLERANCE, CREATED_BY, REC_USER)
         VALUES(h_uniqueID, h_project_id, h_element_id, h_type_id, h_chargecode_id,
         h_capital_expense, h_billable, h_associate_budget_id, 10000, h_rec_user, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 234+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(235) : budgets.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_BUDGET', 241+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_BUDGET(242) : budgets.sql(480) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 248+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(249) : budgets.sql(487) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_BUDGET', 260+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_BUDGET(261) : budgets.sql(499) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_BUDGET;
ALTER FUNCTION SP_A_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_UA_BUDGET ==
CREATE OR REPLACE FUNCTION SP_UA_BUDGET
(
     p_table_type PLS_INTEGER
   , p_element_id VARCHAR2
   , p_budget_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_system_chargecode PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_BUDGET', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_BUDGET(38) : budgets.sql(553) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_table_type IS NULL) OR (p_element_id IS NULL) OR (p_budget_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_BUDGET', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_BUDGET(43) : budgets.sql(558) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_BUDGET', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_BUDGET(46) : budgets.sql(561) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_table_type := p_table_type;
   h_element_id := p_element_id;
   h_budget_id := p_budget_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID, RANK, PARENT_ID
         INTO h_project_id, h_rank, h_parent_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(68) : budgets.sql(583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PROJECT_ID, RANK, PARENT_ID
         INTO h_project_id, h_rank, h_parent_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(84) : budgets.sql(599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_BUDGET', 90+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_BUDGET(91) : budgets.sql(606) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_BUDGET', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_BUDGET(94) : budgets.sql(609) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_element_id, True);
   End If;
   
   BEGIN
      SELECT CHARGECODE_ID, CAPITAL_EXPENSE
      INTO h_chargecode_id, h_capital_expense
      FROM BUDGETS
      WHERE BUDGET_ID = h_budget_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(110) : budgets.sql(625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_BUDGET', 116+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_BUDGET(117) : budgets.sql(632) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_BUDGET', 119+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_BUDGET(120) : budgets.sql(635) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_budget_id, True);
   End If;
   
   If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR) OR (Coalesce(
             h_capital_expense, 0) = PMO_CNST.SC_CAPITAL_LABOR) OR (Coalesce(
             h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_LABOR) Then
      h_count := 0;
      BEGIN
         SELECT COUNT(TSK_ASSIGNMENT_ID) INTO h_count
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID = h_element_id
         AND (LABOR_COST_CC_ID = h_chargecode_id
         OR LABOR_REVENUE_CC_ID = h_chargecode_id);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(142) : budgets.sql(657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_BUDGET', 148+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_BUDGET(149) : budgets.sql(664) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_IS_USED), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_BUDGET', 151+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_UA_BUDGET(152) : budgets.sql(667) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ELEMENT_IS_USED, h_budget_id, True);
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
   PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_WBS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_DELETE_BUDGET_BIT)
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 176+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(177) : budgets.sql(692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM BUDGETS B
         WHERE B.CHARGECODE_ID = h_chargecode_id
         AND B.ELEMENT_ID IN (SELECT W.ELEMENT_ID FROM TMT_WBS W
         WHERE RANK LIKE h_rank || '%')
         AND (B.BUDGET + B.ETC + B.ESTIMATED_BUDGET + B.ESTIMATED_ETC + B.ESTIMATED_ACTUAL 
         + B.ESTIMATED_TOTAL + B.ESTIMATED_ACTUAL_TOTAL + B.ESTIMATED_ETC_TOTAL) = 0
         AND (B.ASSOCIATE_BUDGET_ID IS NuLL OR
         COALESCE((SELECT (A.BUDGET + A.ETC + A.ESTIMATED_BUDGET + A.ESTIMATED_ETC + A.ESTIMATED_ACTUAL
         + B.ESTIMATED_TOTAL + B.ESTIMATED_ACTUAL_TOTAL + B.ESTIMATED_ETC_TOTAL)
         FROM BUDGETS A
         WHERE A.BUDGET_ID = B.ASSOCIATE_BUDGET_ID), 0) = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(205) : budgets.sql(720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If (h_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CRI
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_DELETE_BUDGET_BIT)
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(225) : budgets.sql(740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM BUDGETS B
         WHERE B.CHARGECODE_ID = h_chargecode_id
         AND B.ELEMENT_ID IN (SELECT W.ELEMENT_ID FROM TMT_CRI W
         WHERE RANK LIKE h_rank || '%')
         AND (B.BUDGET + B.ETC + B.ESTIMATED_BUDGET + B.ESTIMATED_ETC + B.ESTIMATED_ACTUAL
         + B.ESTIMATED_TOTAL + B.ESTIMATED_ACTUAL_TOTAL + B.ESTIMATED_ETC_TOTAL) = 0
         AND (B.ASSOCIATE_BUDGET_ID IS NuLL OR
         COALESCE((SELECT (A.BUDGET + A.ETC + A.ESTIMATED_BUDGET + A.ESTIMATED_ETC + A.ESTIMATED_ACTUAL
         + B.ESTIMATED_TOTAL + B.ESTIMATED_ACTUAL_TOTAL + B.ESTIMATED_ETC_TOTAL)
         FROM BUDGETS A
         WHERE A.BUDGET_ID = B.ASSOCIATE_BUDGET_ID), 0) = 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 252+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(253) : budgets.sql(768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   Else
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REC_STATUS = 'D'
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 276+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(277) : budgets.sql(792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_BUDGET', 286+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_BUDGET(287) : budgets.sql(802) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_budget_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 293+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(294) : budgets.sql(809) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_BUDGET', 305+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_BUDGET(306) : budgets.sql(821) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_BUDGET;
ALTER FUNCTION SP_UA_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_ASSOCIATE_BUDGET ==
CREATE OR REPLACE FUNCTION SP_ASSOCIATE_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_associate_budget_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_associate_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_old_capital_expense PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_budget NUMBER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ASSOCIATE_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ASSOCIATE_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_ASSOCIATE_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || '''' || p_associate_budget_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ASSOCIATE_BUDGET(33) : budgets.sql(870) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_table_type IS NULL) OR (p_budget_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_ASSOCIATE_BUDGET', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_ASSOCIATE_BUDGET(38) : budgets.sql(875) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(41) : budgets.sql(878) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_table_type := p_table_type;
   h_budget_id := p_budget_id;
   h_associate_budget_id := p_associate_budget_id;
   h_rec_user := p_rec_user;
   
   If (h_associate_budget_id IS NOT NULL) Then
      BEGIN
         SELECT CHARGECODE_ID INTO h_associate_chargecode_id
         FROM BUDGETS
         WHERE BUDGET_ID = h_associate_budget_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(62) : budgets.sql(899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 68+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(69) : budgets.sql(906) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 71+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(72) : budgets.sql(909) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_budget_id, True);
      End If;
   Else
      h_associate_chargecode_id := NULL;
   End If;
   
   -- Client control worksheet values
   BEGIN
      SELECT ELEMENT_ID, ASSOCIATE_BUDGET_ID, CAPITAL_EXPENSE, BUDGET + ETC
      INTO h_element_id, h_associate_budget_id, h_capital_expense, h_budget
      FROM BUDGETS
      WHERE BUDGET_ID = h_budget_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(92) : budgets.sql(929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 98+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(99) : budgets.sql(936) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 101+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(102) : budgets.sql(939) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_budget_id, True);
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT TYPE_ID INTO h_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(118) : budgets.sql(955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT TYPE_ID INTO h_type_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(133) : budgets.sql(970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (Coalesce(h_budget, 0) <> 0.00) AND (isDeliv(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(
             Coalesce(h_type_id, 0)) <> 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 141+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(142) : budgets.sql(979) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_budget_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 144+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(145) : budgets.sql(982) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_budget_id
            , True);
   End If;
   
   -- remove the old association
   If (h_associate_budget_id IS NOT NULL) Then
      -- Client control worksheet values
      BEGIN
         SELECT BUDGET + ETC
         INTO h_budget
         FROM BUDGETS
         WHERE BUDGET_ID = h_associate_budget_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 164+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(165) : budgets.sql(1002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_budget, 0) <> 0.00) AND (isDeliv(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(
             Coalesce(h_type_id, 0)) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 172+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(173) : budgets.sql(1010) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 175+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(176) : budgets.sql(1013) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
               , True);
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ASSOCIATE_BUDGET_ID = NuLL,
         AUTO_FLAG = PMO_CNST.SC_AUTO_REV_NONE
         WHERE BUDGET_ID = h_associate_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(197) : budgets.sql(1034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_associate_chargecode_id IS NOT NULL) Then
      -- Client control worksheet values
      BEGIN
         SELECT BUDGET_ID, ASSOCIATE_BUDGET_ID, CAPITAL_EXPENSE, BUDGET + ETC
         INTO h_id, h_associate_budget_id, h_old_capital_expense, h_budget
         FROM BUDGETS
         WHERE ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_associate_chargecode_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 216+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(217) : budgets.sql(1054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 223+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(224) : budgets.sql(1061) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_associate_chargecode_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 226+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(227) : budgets.sql(1064) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_associate_chargecode_id
               , True);
      End If;
      
      If (Coalesce(h_budget, 0) <> 0.00) AND (isDeliv(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(
             Coalesce(h_type_id, 0)) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 235+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(236) : budgets.sql(1073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 238+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(239) : budgets.sql(1076) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
               , True);
      End If;
      
      If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE Then
         If Coalesce(h_old_capital_expense, 0) <> PMO_CNST.SC_BENEFIT AND Coalesce(
               h_old_capital_expense, 0) <> PMO_CNST.SC_ELIMINATION Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 248+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(249) : budgets.sql(1086) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 251+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(252) : budgets.sql(1089) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
                  , True);
         End If;
      ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_CAPITAL Then
         If Coalesce(h_old_capital_expense, 0) <> PMO_CNST.SC_BENEFIT Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 259+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(260) : budgets.sql(1097) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 262+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(263) : budgets.sql(1100) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
                  , True);
         End If;
      ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT Then
         If Coalesce(h_old_capital_expense, 0) <> PMO_CNST.SC_EXPENSE AND Coalesce(
               h_old_capital_expense, 0) <> PMO_CNST.SC_CAPITAL Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 271+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(272) : budgets.sql(1109) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 274+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(275) : budgets.sql(1112) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
                  , True);
         End If;
      ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION Then
         If Coalesce(h_old_capital_expense, 0) <> PMO_CNST.SC_EXPENSE Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 282+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(283) : budgets.sql(1120) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 285+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(286) : budgets.sql(1123) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
                  , True);
         End If;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 292+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(293) : budgets.sql(1130) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 295+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(296) : budgets.sql(1133) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
               , True);
      End If;
      
      If (h_associate_budget_id IS NOT NULL) Then
         -- Client control worksheet values
         BEGIN
            SELECT BUDGET + ETC
            INTO h_budget
            FROM BUDGETS
            WHERE BUDGET_ID = h_associate_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(315) : budgets.sql(1152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_budget, 0) <> 0.00) AND (isDeliv(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(
               Coalesce(h_type_id, 0)) <> 0) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_ASSOCIATE_BUDGET', 322+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_ASSOCIATE_BUDGET(323) : budgets.sql(1160) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_ASSOCIATION), 'NULL') || ' ID: ' || '''' || h_associate_budget_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ASSOCIATE_BUDGET', 325+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_ASSOCIATE_BUDGET(326) : budgets.sql(1163) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_CHANGE_ASSOCIATION, h_associate_budget_id
                  , True);
         End If;
         
         BEGIN
            UPDATE BUDGETS
            SET ASSOCIATE_BUDGET_ID = NuLL,
            AUTO_FLAG = PMO_CNST.SC_AUTO_REV_NONE
            WHERE BUDGET_ID = h_associate_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 346+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(347) : budgets.sql(1184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ASSOCIATE_BUDGET_ID = h_id
         WHERE BUDGET_ID = h_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 366+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(367) : budgets.sql(1204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET ASSOCIATE_BUDGET_ID = h_budget_id
         WHERE BUDGET_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 385+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(386) : budgets.sql(1223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE BUDGETS
         SET ASSOCIATE_BUDGET_ID = NuLL,
         AUTO_FLAG = PMO_CNST.SC_AUTO_REV_NONE
         WHERE BUDGET_ID = h_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 405+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(406) : budgets.sql(1243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ASSOCIATE_BUDGET', 412+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ASSOCIATE_BUDGET(413) : budgets.sql(1250) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 419+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(420) : budgets.sql(1257) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ASSOCIATE_BUDGET', 431+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ASSOCIATE_BUDGET(432) : budgets.sql(1269) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ASSOCIATE_BUDGET;
ALTER FUNCTION SP_ASSOCIATE_BUDGET COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_BUDGET ==
CREATE OR REPLACE FUNCTION SP_U_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_auto_flag PLS_INTEGER
   , p_timephased_flag PLS_INTEGER
   , p_actual_timephased_flag PLS_INTEGER
   , p_prob_percent PLS_INTEGER
   , p_prob_amount NUMBER
   , p_estimated_prob_amount NUMBER
   , p_estimated_budget NUMBER
   , p_estimated_actual NUMBER
   , p_estimated_etc NUMBER
   , p_estimated_paid_todate NUMBER
   , p_contingency_budget NUMBER
   , p_contingency_etc NUMBER
   , p_budget NUMBER
   , p_actual NUMBER
   , p_etc NUMBER
   , p_paid_todate NUMBER
   , p_tolerance PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_budget_id VARCHAR2(32);
   h_associate_chargecode_id VARCHAR2(32);
   h_associate_budget_id VARCHAR2(32);
   h_actual NUMBER := 0.00;
   h_ce_actual NUMBER := 0.00;
   h_budget NUMBER := 0.00;
   h_old_budget NUMBER := 0.00;
   h_new_budget NUMBER := 0.00;
   h_associate_budget NUMBER := 0.00;
   h_auto_flag PLS_INTEGER := 0;
   h_new_auto_flag PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_ratio NUMBER := 0.00;
   h_actual_edited PLS_INTEGER := 0;
   h_associate_actual NUMBER := 0.00;
   h_table_type PLS_INTEGER := 0;
   changed PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_auto_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_timephased_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actual_timephased_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_prob_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_prob_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_prob_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_actual), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_estimated_paid_todate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_contingency_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_contingency_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_budget), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actual), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_etc), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_paid_todate), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_tolerance), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BUDGET', 72+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_BUDGET(73) : budgets.sql(1358) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_budget_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_BUDGET', 77+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_BUDGET(78) : budgets.sql(1363) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_BUDGET', 80+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_BUDGET(81) : budgets.sql(1366) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_table_type := p_table_type;
   h_new_auto_flag := p_auto_flag;
   h_new_budget := p_budget;
   h_budget_id := p_budget_id;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT W.PROJECT_ID, B.ELEMENT_ID, B.CHARGECODE_ID, B.ASSOCIATE_BUDGET_ID,
         B.CAPITAL_EXPENSE, B.AUTO_FLAG, B.ACTUAL_EDITED,
         B.BUDGET, B.ACTUAL
         INTO h_project_id, h_element_id, h_chargecode_id, h_associate_budget_id,
         h_capital_expense, h_auto_flag, h_actual_edited,
         h_old_budget, h_actual
         FROM BUDGETS B, TMT_WBS W
         WHERE BUDGET_ID = h_budget_id
         AND W.ELEMENT_ID = B.ELEMENT_ID
         AND W.PROJECT_ID = B.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(109) : budgets.sql(1394) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT W.PROJECT_ID, B.ELEMENT_ID, B.CHARGECODE_ID, B.ASSOCIATE_BUDGET_ID,
         B.CAPITAL_EXPENSE, B.AUTO_FLAG, B.ACTUAL_EDITED,
         B.BUDGET, B.ACTUAL
         INTO h_project_id, h_element_id, h_chargecode_id, h_associate_budget_id,
         h_capital_expense, h_auto_flag, h_actual_edited,
         h_old_budget, h_actual
         FROM BUDGETS B, TMT_CRI W
         WHERE BUDGET_ID = h_budget_id
         AND W.ELEMENT_ID = B.ELEMENT_ID
         AND W.PROJECT_ID = B.PROJECT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(131) : budgets.sql(1416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_budget := h_old_budget;
   
   If (h_associate_budget_id IS NOT NULL) Then
      If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT) OR (Coalesce(
             h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION) Then
         h_associate_chargecode_id := h_chargecode_id;
         h_associate_budget := h_budget;
         h_associate_actual := h_actual;
         
         BEGIN
            SELECT AUTO_FLAG, BUDGET, ACTUAL, ACTUAL_EDITED,
            ELEMENT_ID, CHARGECODE_ID
            INTO h_auto_flag, h_budget, h_actual, h_actual_edited,
            h_element_id, h_chargecode_id
            FROM BUDGETS
            WHERE BUDGET_ID = h_associate_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 158+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(159) : budgets.sql(1444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT BUDGET, ACTUAL, CHARGECODE_ID
            INTO h_associate_budget, h_associate_actual,h_associate_chargecode_id
            FROM BUDGETS
            WHERE BUDGET_ID = h_associate_budget_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(175) : budgets.sql(1460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(h_actual_edited, 0) = 0) Then
         h_ratio := 0.00;
         If Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
            If Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               If Coalesce(h_old_budget, 0) <> Coalesce(h_new_budget, 0) Then
                  changed := 1;
                  If ((Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT) OR (Coalesce(
                        h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION)) AND (Coalesce(
                        h_new_budget, 0) > 0.00) AND (Coalesce(h_budget, 0) > 0.00) Then
                     h_ratio := Coalesce(h_new_budget, 0) / Coalesce(h_budget, 0);
                  ElsIf (Coalesce(h_capital_expense, 0) <> PMO_CNST.SC_BENEFIT) AND (Coalesce(
                        h_capital_expense, 0) <> PMO_CNST.SC_ELIMINATION) AND (Coalesce(
                        h_new_budget, 0) > 0.00) AND (Coalesce(h_associate_budget, 0) > 0.00) Then
                     h_ratio := Coalesce(h_associate_budget, 0) / Coalesce(h_new_budget, 0);
                  End If;
               End If;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
               changed := 1;
               
               If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION Then
                  h_ratio := -1;
               Else
                  h_ratio := 1.00;
               End If;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_NONE Then
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 1
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 221+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(222) : budgets.sql(1507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf Coalesce(h_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
            If Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               changed := 1;
               If ((Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT) OR (Coalesce(
                     h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION)) AND (Coalesce(
                     h_new_budget, 0) > 0.00) AND (Coalesce(h_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_new_budget, 0) / Coalesce(h_budget, 0);
               ElsIf (Coalesce(h_capital_expense, 0) <> PMO_CNST.SC_BENEFIT) AND (Coalesce(
                     h_capital_expense, 0) <> PMO_CNST.SC_ELIMINATION) AND (Coalesce(
                     h_new_budget, 0) > 0.00) AND (Coalesce(h_associate_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_associate_budget, 0) / Coalesce(h_new_budget, 0);
               End If;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_NONE Then
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 1
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 255+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(256) : budgets.sql(1541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_RATIO Then
               changed := 1;
               If ((Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT) OR (Coalesce(
                     h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION)) AND (Coalesce(
                     h_new_budget, 0) > 0.00) AND (Coalesce(h_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_new_budget, 0) / Coalesce(h_budget, 0);
               ElsIf (Coalesce(h_capital_expense, 0) <> PMO_CNST.SC_BENEFIT) AND (Coalesce(
                     h_capital_expense, 0) <> PMO_CNST.SC_ELIMINATION) AND (Coalesce(
                     h_new_budget, 0) > 0.00) AND (Coalesce(h_associate_budget, 0) > 0.00) Then
                  h_ratio := Coalesce(h_associate_budget, 0) / Coalesce(h_new_budget, 0);
               End If;
               
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 0
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 289+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(290) : budgets.sql(1575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_new_auto_flag, 0) = PMO_CNST.SC_AUTO_REV_FLOWTHRU Then
               changed := 1;
               
               If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION Then
                  h_ratio := -1;
               Else
                  h_ratio := 1.00;
               End If;
               
               BEGIN
                  UPDATE BUDGETS
                  SET ACTUAL_EDITED = 0
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_associate_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 318+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(319) : budgets.sql(1604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         If changed = 1 Then
            PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
            PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
            
            BEGIN
               INSERT INTO TIMEPHASED_DELTA
               (ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1),
               MONTH_04_AMOUNT * (-1), MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1),
               MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1), MONTH_09_AMOUNT * (-1),
               MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
               TOTAL_AMOUNT * (-1)
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_associate_chargecode_id
               AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(358) : budgets.sql(1643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 377+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(378) : budgets.sql(1663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT+PMO_CNST.SC_ACTUAL_DELTA_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_associate_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 398+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(399) : budgets.sql(1684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_ratio, 0) > 0.00 Then
            BEGIN
               INSERT INTO TIMEPHASED_DELTA
               (ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, h_associate_chargecode_id,
               MONTH_01_AMOUNT * h_ratio,
               MONTH_02_AMOUNT * h_ratio,
               MONTH_03_AMOUNT * h_ratio,
               MONTH_04_AMOUNT * h_ratio,
               MONTH_05_AMOUNT * h_ratio,
               MONTH_06_AMOUNT * h_ratio,
               MONTH_07_AMOUNT * h_ratio,
               MONTH_08_AMOUNT * h_ratio,
               MONTH_09_AMOUNT * h_ratio,
               MONTH_10_AMOUNT * h_ratio,
               MONTH_11_AMOUNT * h_ratio,
               MONTH_12_AMOUNT * h_ratio,
               TOTAL_AMOUNT * h_ratio
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_element_id
               AND CHARGECODE_ID = h_chargecode_id
               AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 441+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(442) : budgets.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   h_actual := p_actual;
   
   If Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR Then
      If Coalesce(p_estimated_budget, 0) > 0.0 Then
         BEGIN
            UPDATE BUDGETS
            SET AUTO_FLAG       = p_auto_flag,
            ACTUAL_EDITED       = 1,
            TIMEPHASED_FLAG     = p_timephased_flag,
            ACTUAL_TIMEPHASED_FLAG  = p_actual_timephased_flag,
            PROB_PERCENT        = p_prob_percent,
            PROB_AMOUNT         = p_prob_amount,
            ESTIMATED_PROB_AMOUNT   = p_estimated_prob_amount,
            ESTIMATED_BUDGET    = p_estimated_budget,
            ESTIMATED_ACTUAL    = p_estimated_actual,
            ESTIMATED_ETC       = p_estimated_etc,
            ESTIMATED_PAID_TODATE   = p_estimated_paid_todate,
            BUDGET          = p_budget,
            ACTUAL          = h_actual,
            ETC         = p_etc,
            PAID_TODATE     = p_paid_todate,
            TOLERANCE               = p_tolerance,
            REC_USER        = p_rec_user,
            REC_STATUS      = 'U',
            REC_DATETIME        = SYSTIMESTAMP
            WHERE BUDGET_ID = h_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 485+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(486) : budgets.sql(1771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE BUDGETS
            SET AUTO_FLAG       = p_auto_flag,
            ACTUAL_EDITED       = 0,
            TIMEPHASED_FLAG     = p_timephased_flag,
            ACTUAL_TIMEPHASED_FLAG  = p_actual_timephased_flag,
            PROB_PERCENT        = p_prob_percent,
            PROB_AMOUNT         = p_prob_amount,
            ESTIMATED_PROB_AMOUNT   = p_estimated_prob_amount,
            ESTIMATED_BUDGET    = p_estimated_budget,
            ESTIMATED_ACTUAL    = p_estimated_actual,
            ESTIMATED_ETC       = p_estimated_etc,
            ESTIMATED_PAID_TODATE   = p_estimated_paid_todate,
            BUDGET          = p_budget,
            ACTUAL          = h_actual,
            ETC         = p_etc,
            PAID_TODATE     = p_paid_todate,
            TOLERANCE               = p_tolerance,
            REC_USER        = p_rec_user,
            REC_STATUS      = 'U',
            REC_DATETIME        = SYSTIMESTAMP
            WHERE BUDGET_ID = h_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 522+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(523) : budgets.sql(1808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If (h_associate_budget_id IS NOT NULL) Then
         BEGIN
            UPDATE BUDGETS
            SET AUTO_FLAG   = p_auto_flag
            WHERE BUDGET_ID = h_associate_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 543+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(544) : budgets.sql(1829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET AUTO_FLAG               = p_auto_flag,
         TIMEPHASED_FLAG         = p_timephased_flag,
         ACTUAL_TIMEPHASED_FLAG  = p_actual_timephased_flag,
         PROB_PERCENT            = p_prob_percent,
         PROB_AMOUNT             = p_prob_amount,
         ESTIMATED_PROB_AMOUNT   = p_estimated_prob_amount,
         ESTIMATED_BUDGET        = p_estimated_budget,
         ESTIMATED_ACTUAL        = p_estimated_actual,
         ESTIMATED_ETC           = p_estimated_etc,
         ESTIMATED_PAID_TODATE   = p_estimated_paid_todate,
         BUDGET                  = p_budget,
         ACTUAL                  = CASE WHEN ACTUAL_EDITED = 1 THEN h_actual ELSE ACTUAL END,
         ETC                     = p_etc,
         PAID_TODATE             = p_paid_todate,
         TOLERANCE               = p_tolerance,
         REC_USER                = p_rec_user,
         REC_STATUS              = 'U',
         REC_DATETIME            = SYSTIMESTAMP
         WHERE BUDGET_ID = h_budget_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 580+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(581) : budgets.sql(1866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_BUDGET', 587+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_BUDGET(588) : budgets.sql(1873) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_budget_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 594+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(595) : budgets.sql(1880) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_BUDGET', 606+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_BUDGET(607) : budgets.sql(1892) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_BUDGET;
ALTER FUNCTION SP_U_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TXT_BUDGET ==
CREATE OR REPLACE FUNCTION SP_U_TXT_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_txt_field_01 VARCHAR2
   , p_txt_field_02 VARCHAR2
   , p_txt_field_03 VARCHAR2
   , p_txt_field_04 VARCHAR2
   , p_txt_field_05 VARCHAR2
   , p_txt_field_06 VARCHAR2
   , p_txt_field_07 VARCHAR2
   , p_txt_field_08 VARCHAR2
   , p_txt_field_09 VARCHAR2
   , p_txt_field_10 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TXT_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TXT_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TXT_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || '''' || p_txt_field_01 || ''''
          || ', ' || '''' || p_txt_field_02 || ''''
          || ', ' || '''' || p_txt_field_03 || ''''
          || ', ' || '''' || p_txt_field_04 || ''''
          || ', ' || '''' || p_txt_field_05 || ''''
          || ', ' || '''' || p_txt_field_06 || ''''
          || ', ' || '''' || p_txt_field_07 || ''''
          || ', ' || '''' || p_txt_field_08 || ''''
          || ', ' || '''' || p_txt_field_09 || ''''
          || ', ' || '''' || p_txt_field_10 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TXT_BUDGET', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TXT_BUDGET(39) : budgets.sql(1947) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE BUDGETS SET
      TXT_FIELD_01 = p_txt_field_01,
      TXT_FIELD_02 = p_txt_field_02,
      TXT_FIELD_03 = p_txt_field_03,
      TXT_FIELD_04 = p_txt_field_04,
      TXT_FIELD_05 = p_txt_field_05,
      TXT_FIELD_06 = p_txt_field_06,
      TXT_FIELD_07 = p_txt_field_07,
      TXT_FIELD_08 = p_txt_field_08,
      TXT_FIELD_09 = p_txt_field_09,
      TXT_FIELD_10 = p_txt_field_10,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE BUDGET_ID = p_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TXT_BUDGET', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TXT_BUDGET(68) : budgets.sql(1976) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TXT_BUDGET', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TXT_BUDGET(74) : budgets.sql(1982) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_budget_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TXT_BUDGET', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TXT_BUDGET(81) : budgets.sql(1989) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TXT_BUDGET', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TXT_BUDGET(93) : budgets.sql(2001) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TXT_BUDGET;
ALTER FUNCTION SP_U_TXT_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DATAFIELD_BUDGET ==
CREATE OR REPLACE FUNCTION SP_U_DATAFIELD_BUDGET
(
     p_table_type PLS_INTEGER
   , p_budget_id VARCHAR2
   , p_datafield_1 PLS_INTEGER
   , p_datafield_2 PLS_INTEGER
   , p_datafield_3 PLS_INTEGER
   , p_datafield_4 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DATAFIELD_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DATAFIELD_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DATAFIELD_BUDGET(' || 
       COALESCE(TO_CHAR(p_table_type), 'NULL')
          || ', ' || '''' || p_budget_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_datafield_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_datafield_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_datafield_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_datafield_4), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DATAFIELD_BUDGET', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DATAFIELD_BUDGET(27) : budgets.sql(2044) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE BUDGETS SET
      DATAFIELD_1 = p_datafield_1,
      DATAFIELD_2 = p_datafield_2,
      DATAFIELD_3 = p_datafield_3,
      DATAFIELD_4 = p_datafield_4,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user,
      REC_STATUS = 'U'
      WHERE BUDGET_ID = p_budget_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DATAFIELD_BUDGET', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DATAFIELD_BUDGET(50) : budgets.sql(2067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DATAFIELD_BUDGET', 55+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DATAFIELD_BUDGET(56) : budgets.sql(2073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_budget_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_budget_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DATAFIELD_BUDGET', 62+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DATAFIELD_BUDGET(63) : budgets.sql(2080) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DATAFIELD_BUDGET', 74+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DATAFIELD_BUDGET(75) : budgets.sql(2092) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DATAFIELD_BUDGET;
ALTER FUNCTION SP_U_DATAFIELD_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_ACPT_BUDGET ==
CREATE OR REPLACE FUNCTION SP_ACPT_BUDGET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ACPT_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ACPT_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_ACPT_BUDGET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ACPT_BUDGET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ACPT_BUDGET(22) : budgets.sql(2130) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   h_id := p_id;
   
   BEGIN
      SELECT RTRIM(RANK), PROJECT_ID
      INTO h_rank, h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(40) : budgets.sql(2148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE BUDGETS
      SET BUDGET = (ACTUAL + ETC)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID IN (     SELECT ELEMENT_ID
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
      AND (ACTUAL + ETC) >= ACTUAL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(77) : budgets.sql(2185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ACPT_BUDGET', 86+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ACPT_BUDGET(87) : budgets.sql(2195) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 93+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(94) : budgets.sql(2202) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ACPT_BUDGET', 105+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ACPT_BUDGET(106) : budgets.sql(2214) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ACPT_BUDGET;
ALTER FUNCTION SP_ACPT_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_RJCT_BUDGET ==
CREATE OR REPLACE FUNCTION SP_RJCT_BUDGET
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RJCT_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RJCT_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := SP_RJCT_BUDGET(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RJCT_BUDGET', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RJCT_BUDGET(22) : budgets.sql(2252) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   h_id := p_id;
   
   BEGIN
      SELECT RTRIM(RANK), PROJECT_ID
      INTO h_rank, h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(40) : budgets.sql(2270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE BUDGETS
      SET ETC = BUDGET - ACTUAL
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID IN ( SELECT ELEMENT_ID
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
      AND (BUDGET - ACTUAL) <> ETC;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(77) : budgets.sql(2307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = 0) OR (PMO_DB2M.SC_STATE = 100) Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_RJCT_BUDGET', 86+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_RJCT_BUDGET(87) : budgets.sql(2317) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 93+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(94) : budgets.sql(2324) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RJCT_BUDGET', 105+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RJCT_BUDGET(106) : budgets.sql(2336) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RJCT_BUDGET;
ALTER FUNCTION SP_RJCT_BUDGET COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_TA_LABOR_CC ==
CREATE OR REPLACE FUNCTION FC_U_TA_LABOR_CC
(
     h_task_assignment_id IN OUT NOCOPY VARCHAR2
   , h_labor_cost_cc_id IN OUT NOCOPY VARCHAR2
   , h_labor_revenue_cc_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_planned_effort PLS_INTEGER := 0;
   h_sched_effort PLS_INTEGER := 0;
   h_SD DATE;
   h_FD DATE;
   h_actual_start TIMESTAMP;
   h_pa_timephase VARCHAR2(1);
   h_bit_flag VARCHAR2(1);
   h_reg_cost NUMBER := 0;
   h_reg_sale NUMBER := 0;
   h_p_reg_sale NUMBER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_old_billable PLS_INTEGER := 0;
   h_old_capital_expense PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_old_labor_cost_cc_id VARCHAR2(32);
   h_old_labor_revenue_cc_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_TA_LABOR_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_TA_LABOR_CC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_TA_LABOR_CC(' || 
       '''' || h_task_assignment_id || ''''
          || ', ' || '''' || h_labor_cost_cc_id || ''''
          || ', ' || '''' || h_labor_revenue_cc_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TA_LABOR_CC', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_TA_LABOR_CC(43) : budgets.sql(2395) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT  PROJECT_ID,
      PROJECT_ASSIGNMENT_ID,
      TASK_ID,
      RESOURCE_ID,
      TABLE_TYPE,
      TO_DATE(SubStr(PROPOSED_START, 1, 10)),
      TO_DATE(SubStr(PROPOSED_FINISH, 1, 10)),
      PLANNED_WORK,
      SCHED_WORK,
      LABOR_COST_CC_ID,
      LABOR_REVENUE_CC_ID,
      BILLABLE,
      CAPITAL_EXPENSE,
      REGULAR_COST,
      REGULAR_RATE ,
      ACTUAL_START
      INTO	h_project_id,
      h_prj_assignment_id,
      h_element_id,
      h_res_id,
      h_table_type,
      h_SD,
      h_FD,
      h_planned_effort,
      h_sched_effort,
      h_old_labor_cost_cc_id,
      h_old_labor_revenue_cc_id,
      h_old_billable,
      h_old_capital_expense,
      h_reg_cost,
      h_reg_sale,
      h_actual_start
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_task_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(87) : budgets.sql(2439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_TA_LABOR_CC', 93+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_TA_LABOR_CC(94) : budgets.sql(2446) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_task_assignment_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TA_LABOR_CC', 96+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_TA_LABOR_CC(97) : budgets.sql(2449) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_task_assignment_id
            , False);
   End If;
   
   If (h_actual_start IS NOT NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_TA_LABOR_CC', 104+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_TA_LABOR_CC(105) : budgets.sql(2457) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_HAS_ACTUAL), 'NULL') || ' ID: ' || '''' || h_task_assignment_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TA_LABOR_CC', 107+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_TA_LABOR_CC(108) : budgets.sql(2460) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_HAS_ACTUAL, h_task_assignment_id
            , False);
   End If;
   
   If PMO_ORASTD.strcmp(h_labor_cost_cc_id, h_old_labor_cost_cc_id) <> 0 Then
      BEGIN
         SELECT CAPITAL_EXPENSE INTO h_capital_expense
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_labor_cost_cc_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 124+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(125) : budgets.sql(2477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_U_TA_LABOR_CC', 131+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_U_TA_LABOR_CC(132) : budgets.sql(2484) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_labor_cost_cc_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TA_LABOR_CC', 134+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_TA_LABOR_CC(135) : budgets.sql(2487) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_labor_cost_cc_id
               , False);
      End If;
   Else
      h_capital_expense := h_old_capital_expense;
   End If;
   
   If (h_labor_revenue_cc_id IS NOT NULL) Then
      h_billable := PMO_CNST.SC_BILLABLE_YES;
   Else
      h_billable := PMO_CNST.SC_BILLABLE_NO;
   End If;
   
   BEGIN
      SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
      FROM PROJECT_DETAILS
      WHERE PROJECT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(160) : budgets.sql(2512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_prj_assignment_id IS NULL)) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') OR (PMO_ORASTD.strncmp(
         h_prj_assignment_id, h_task_assignment_id, 32) <> 0) Then
      h_tph_delete := -1;
      
      h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_element_id, h_task_assignment_id, h_SD
                                          , h_FD, h_reg_cost, h_reg_sale, h_tph_delete
                                          , h_old_capital_expense, h_old_billable);
   End If;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
      TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_old_labor_cost_cc_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 190+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(191) : budgets.sql(2543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- change hour/average/fte chargecodes
   If Coalesce(h_old_capital_expense, 0) <> Coalesce(h_capital_expense, 0) Then
      If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_CAPITAL_LABOR Then
         --EXPENSE_HOURS
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'EXPENSE_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(216) : budgets.sql(2568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --CAPITAL_HOURS
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'CAPITAL_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 237+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(238) : budgets.sql(2590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'CAPITAL_HOURS', PMO_CNST.SC_CAPITAL_HOUR, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(259) : budgets.sql(2611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --EXPENSE_AVERAGE_COST
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'EXPENSE_AVERAGE_COST';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(282) : budgets.sql(2634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --CAPITAL_AVERAGE_COST
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'CAPITAL_AVERAGE_COST';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 303+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(304) : budgets.sql(2656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'CAPITAL_AVERAGE_COST', PMO_CNST.SC_CAPITAL_AVERAGE_COST, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 324+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(325) : budgets.sql(2677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --EXPENSE_FULL_TIME_EQUIVALENT
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 347+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(348) : budgets.sql(2700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --CAPITAL_FULL_TIME_EQUIVALENT
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(370) : budgets.sql(2722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'CAPITAL_FULL_TIME_EQUIVALENT', PMO_CNST.SC_CAPITAL_FTE, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 390+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(391) : budgets.sql(2743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         --CAPITAL_HOURS
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'CAPITAL_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 413+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(414) : budgets.sql(2766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --EXPENSE_HOURS
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'EXPENSE_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 435+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(436) : budgets.sql(2788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'EXPENSE_HOURS', PMO_CNST.SC_EXPENSE_HOUR, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 456+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(457) : budgets.sql(2809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --CAPITAL_AVERAGE_COST
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'CAPITAL_AVERAGE_COST';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 479+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(480) : budgets.sql(2832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --EXPENSE_AVERAGE_COST
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'EXPENSE_AVERAGE_COST';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 501+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(502) : budgets.sql(2854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'EXPENSE_AVERAGE_COST', PMO_CNST.SC_EXPENSE_AVERAGE_COST, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 522+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(523) : budgets.sql(2875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --CAPITAL_FULL_TIME_EQUIVALENT
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 545+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(546) : budgets.sql(2898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --EXPENSE_FULL_TIME_EQUIVALENT
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 567+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(568) : budgets.sql(2920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'EXPENSE_FULL_TIME_EQUIVALENT', PMO_CNST.SC_EXPENSE_FTE, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 588+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(589) : budgets.sql(2941) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
      TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_labor_cost_cc_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 613+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(614) : budgets.sql(2966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
         CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
         h_labor_cost_cc_id, h_capital_expense, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 634+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(635) : budgets.sql(2987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_old_labor_revenue_cc_id IS NOT NULL) Then
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
         TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_old_labor_revenue_cc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 658+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(659) : budgets.sql(3011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_labor_revenue_cc_id IS NULL) Then
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'BENEFIT_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 681+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(682) : budgets.sql(3034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'BENEFIT_AVERAGE_RATE';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 703+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(704) : budgets.sql(3056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 725+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(726) : budgets.sql(3078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf PMO_ORASTD.strcmp(h_old_labor_revenue_cc_id, h_labor_revenue_cc_id) <> 0 Then
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = h_labor_revenue_cc_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 747+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(748) : budgets.sql(3100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               h_labor_revenue_cc_id, PMO_CNST.SC_BENEFIT_LABOR, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 768+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(769) : budgets.sql(3121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'BENEFIT_HOURS';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 791+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(792) : budgets.sql(3144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'BENEFIT_HOURS', PMO_CNST.SC_BENEFIT_HOUR, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 812+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(813) : budgets.sql(3165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'BENEFIT_AVERAGE_RATE';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 835+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(836) : budgets.sql(3188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'BENEFIT_AVERAGE_RATE', PMO_CNST.SC_BENEFIT_AVERAGE_COST, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 856+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(857) : budgets.sql(3209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE BUDGETS
            SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
            TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 879+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(880) : budgets.sql(3232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
               CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
               'BENEFIT_FULL_TIME_EQUIVALENT', PMO_CNST.SC_BENEFIT_FTE, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 900+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(901) : budgets.sql(3253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   ElsIf (h_labor_revenue_cc_id IS NOT NULL) Then
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
         TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_labor_revenue_cc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 924+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(925) : budgets.sql(3277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            h_labor_revenue_cc_id, PMO_CNST.SC_BENEFIT_LABOR, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 945+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(946) : budgets.sql(3298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
         TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 968+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(969) : budgets.sql(3321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'BENEFIT_HOURS', PMO_CNST.SC_BENEFIT_HOUR, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 989+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(990) : budgets.sql(3342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
         TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_AVERAGE_RATE';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1012+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1013) : budgets.sql(3365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'BENEFIT_AVERAGE_RATE', PMO_CNST.SC_BENEFIT_AVERAGE_COST, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1033+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1034) : budgets.sql(3386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
         TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1056+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1057) : budgets.sql(3409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'BENEFIT_FULL_TIME_EQUIVALENT', PMO_CNST.SC_BENEFIT_FTE, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1077+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1078) : budgets.sql(3430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_billable, 0) = PMO_CNST.SC_BILLABLE_YES Then
      --BILLABLE
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET CAPITAL_EXPENSE = h_capital_expense,
         BILLABLE = h_billable,
         LABOR_COST_CC_ID = h_labor_cost_cc_id,
         LABOR_REVENUE_CC_ID = h_labor_revenue_cc_id
         WHERE TSK_ASSIGNMENT_ID = h_task_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1104) : budgets.sql(3456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_prj_assignment_id IS NOT NULL) Then
         BEGIN
            SELECT BIT_FLAG, REGULAR_RATE INTO h_bit_flag, h_p_reg_sale
            FROM TASK_ASSIGNMENTS
            WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1120) : budgets.sql(3472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_bit_flag, 1, 1) = '2' Then
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET ESTIMATED_SCHED_REVENUE = (ESTIMATED_SCHED_EFFORT/60.00) * h_p_reg_sale
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1139+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1140) : budgets.sql(3492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET ESTIMATED_PLANNED_REVENUE = (ESTIMATED_PLANNED_EFFORT/60.00) * h_p_reg_sale
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1158+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1159) : budgets.sql(3511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      --NON-BILLABLE
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET CAPITAL_EXPENSE = h_capital_expense,
         BILLABLE = h_billable,
         LABOR_COST_CC_ID = h_labor_cost_cc_id,
         LABOR_REVENUE_CC_ID = h_labor_revenue_cc_id,
         BASELINE1_LABOR_REVENUE = 0.00,
         BASELINE2_LABOR_REVENUE = 0.00,
         BASELINE3_LABOR_REVENUE = 0.00,
         ESTIMATION_LABOR_REVENUE = 0.00,
         PROPOSED_LABOR_REVENUE = 0.00,
         PLANNED_LABOR_REVENUE = 0.00,
         SCHED_LABOR_REVENUE = 0.00,
         ACTUAL_LABOR_REVENUE = 0.00,
         FORECAST_LABOR_REVENUE = 0.00
         WHERE TSK_ASSIGNMENT_ID = h_task_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1193) : budgets.sql(3545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_prj_assignment_id IS NOT NULL) Then
         BEGIN
            SELECT BIT_FLAG INTO h_bit_flag
            FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1207+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1208) : budgets.sql(3560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_bit_flag, 1, 1) = '2' Then
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET ESTIMATED_SCHED_REVENUE = 0.00
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1227+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1228) : budgets.sql(3580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET ESTIMATED_PLANNED_REVENUE = 0.00
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1246+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1247) : budgets.sql(3599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   If ((h_prj_assignment_id IS NULL)) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') OR (PMO_ORASTD.strncmp(
         h_prj_assignment_id, h_task_assignment_id, 32) <> 0) Then
      h_tph_delete := 0;
      h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_element_id, h_task_assignment_id, h_SD
                                          , h_FD, h_reg_cost, h_reg_sale, h_tph_delete
                                          , h_capital_expense, h_billable);
   End If;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT+PMO_CNST.SC_UPDATE_BUDGET_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1278+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1279) : budgets.sql(3631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CRI
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT+PMO_CNST.SC_UPDATE_BUDGET_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_TA_LABOR_CC', 1298+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_TA_LABOR_CC(1299) : budgets.sql(3651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_TA_LABOR_CC', 1307+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_TA_LABOR_CC(1308) : budgets.sql(3660) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_TA_LABOR_CC;
ALTER FUNCTION FC_U_TA_LABOR_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TA_LABOR_CC ==
CREATE OR REPLACE FUNCTION SP_U_TA_LABOR_CC
(
     p_task_assignment_id VARCHAR2
   , p_labor_cost_cc_id VARCHAR2
   , p_labor_revenue_cc_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_task_assignment_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_labor_cost_cc_id VARCHAR2(32);
   h_labor_revenue_cc_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TA_LABOR_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TA_LABOR_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TA_LABOR_CC(' || 
       '''' || p_task_assignment_id || ''''
          || ', ' || '''' || p_labor_cost_cc_id || ''''
          || ', ' || '''' || p_labor_revenue_cc_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TA_LABOR_CC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TA_LABOR_CC(25) : budgets.sql(3695) : ' || SYSTIMESTAMP);
   END IF; 

   h_task_assignment_id := p_task_assignment_id;
   h_labor_cost_cc_id := p_labor_cost_cc_id;
   h_labor_revenue_cc_id := p_labor_revenue_cc_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_TA_LABOR_CC(h_task_assignment_id, h_labor_cost_cc_id
                                      , h_labor_revenue_cc_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TA_LABOR_CC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TA_LABOR_CC(37) : budgets.sql(3707) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_task_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_task_assignment_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_LABOR_CC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_LABOR_CC(44) : budgets.sql(3714) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_LABOR_CC', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_LABOR_CC(56) : budgets.sql(3726) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TA_LABOR_CC;
ALTER FUNCTION SP_U_TA_LABOR_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TA_BILLABLE ==
CREATE OR REPLACE FUNCTION SP_U_TA_BILLABLE
(
     p_task_assignment_id VARCHAR2
   , p_billable PLS_INTEGER
   , p_capital_expense PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_task_assignment_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_labor_cost_cc_id VARCHAR2(32);
   h_labor_revenue_cc_id VARCHAR2(32);
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_old_billable PLS_INTEGER := 0;
   h_old_capital_expense PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TA_BILLABLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TA_BILLABLE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TA_BILLABLE(' || 
       '''' || p_task_assignment_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_billable), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_expense), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TA_BILLABLE', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TA_BILLABLE(29) : budgets.sql(3771) : ' || SYSTIMESTAMP);
   END IF; 

   h_task_assignment_id := p_task_assignment_id;
   h_billable := p_billable;
   h_capital_expense := p_capital_expense;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT BILLABLE, CAPITAL_EXPENSE, LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID
      INTO h_old_billable, h_old_capital_expense, 
      h_labor_cost_cc_id, h_labor_revenue_cc_id
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_task_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(49) : budgets.sql(3791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TA_BILLABLE', 55+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TA_BILLABLE(56) : budgets.sql(3798) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_task_assignment_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TA_BILLABLE', 58+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_TA_BILLABLE(59) : budgets.sql(3801) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_task_assignment_id
            , True);
   End If;
   
   If Coalesce(h_old_billable, 0) <> Coalesce(h_billable, 0) Then
      If Coalesce(h_billable, 0) = PMO_CNST.SC_BILLABLE_YES Then
         h_labor_revenue_cc_id := 'BILLABLE_BENEFIT_LABOR';
      Else
         h_labor_revenue_cc_id := NULL;
      End If;
   End If;
   
   If Coalesce(h_old_capital_expense, 0) <> Coalesce(h_capital_expense, 0) Then
      If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR Then
         h_labor_cost_cc_id := 'EXPENSE_LABOR';
      Else
         h_labor_cost_cc_id := 'CAPITAL_LABOR';
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := FC_U_TA_LABOR_CC(h_task_assignment_id, h_labor_cost_cc_id
                                      , h_labor_revenue_cc_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TA_BILLABLE', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TA_BILLABLE(85) : budgets.sql(3827) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_task_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_task_assignment_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(92) : budgets.sql(3834) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_BILLABLE', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_BILLABLE(104) : budgets.sql(3846) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TA_BILLABLE;
ALTER FUNCTION SP_U_TA_BILLABLE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_TA_DEFAULT_LABOR ==
CREATE OR REPLACE FUNCTION SP_U_TA_DEFAULT_LABOR
(
     p_task_assignment_id VARCHAR2
   , p_default_labor_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_task_assignment_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_default_labor_flag VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TA_DEFAULT_LABOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TA_DEFAULT_LABOR'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TA_DEFAULT_LABOR(' || 
       '''' || p_task_assignment_id || ''''
          || ', ' || '''' || p_default_labor_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TA_DEFAULT_LABOR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TA_DEFAULT_LABOR(24) : budgets.sql(3886) : ' || SYSTIMESTAMP);
   END IF; 

   h_task_assignment_id := p_task_assignment_id;
   h_default_labor_flag := p_default_labor_flag;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT PROJECT_ID, RESOURCE_ID INTO h_project_id, h_res_id
      FROM TASK_ASSIGNMENTS
      WHERE TSK_ASSIGNMENT_ID = h_task_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_DEFAULT_LABOR', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_DEFAULT_LABOR(41) : budgets.sql(3903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_TA_DEFAULT_LABOR', 47+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_TA_DEFAULT_LABOR(48) : budgets.sql(3910) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_task_assignment_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TA_DEFAULT_LABOR', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_TA_DEFAULT_LABOR(51) : budgets.sql(3913) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_task_assignment_id
            , True);
   End If;
   
   If PMO_ORASTD.strncmp(h_default_labor_flag, 'Y', 1) = 0 Then
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET DEFAULT_LABOR_FLAG = 'N'
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_res_id
         AND DEFAULT_LABOR_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_DEFAULT_LABOR', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_DEFAULT_LABOR(74) : budgets.sql(3936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TASK_ASSIGNMENTS
      SET DEFAULT_LABOR_FLAG = h_default_labor_flag
      WHERE TSK_ASSIGNMENT_ID = h_task_assignment_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_DEFAULT_LABOR', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_DEFAULT_LABOR(94) : budgets.sql(3956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TA_DEFAULT_LABOR', 99+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TA_DEFAULT_LABOR(100) : budgets.sql(3962) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_task_assignment_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_task_assignment_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_DEFAULT_LABOR', 106+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_DEFAULT_LABOR(107) : budgets.sql(3969) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TA_DEFAULT_LABOR', 118+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TA_DEFAULT_LABOR(119) : budgets.sql(3981) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TA_DEFAULT_LABOR;
ALTER FUNCTION SP_U_TA_DEFAULT_LABOR COMPILE DEBUG;

