/****************************************************************************************
DAILY_STATUS:
    0: NON-WORKING
    1: WORKING
    2: (NOT USED)
    3: DERRIVED NON-WORKING
    4: DERRIVED NON-DEFAULT WORKING
    5: OVERRIDE NON-WORKING
    6: OVERRIDE NON-DEFAULT WORKING
****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION newCDOY ==
CREATE OR REPLACE FUNCTION newCDOY
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_day_week PLS_INTEGER
   , sh_h_min PLS_INTEGER
   , sh_h_bit RAW
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_day_week PLS_INTEGER := sh_h_day_week;
   h_min PLS_INTEGER := sh_h_min;
   h_bit RAW(36) := sh_h_bit;
   h_current_calendar_date VARCHAR2(10);
   h_diff PLS_INTEGER := 0;
   h_max_date DATE;
   h_min_dow PLS_INTEGER := 0;
   h_min_date DATE;
   h_week_iso PLS_INTEGER := 0;
   h_month_iso PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('newCDOY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('newCDOY'), '-- ' || SYSTIMESTAMP, ':r := newCDOY(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_day_week), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_min), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bit), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'newCDOY', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: newCDOY(32) : calendars.sql(46) : ' || SYSTIMESTAMP);
   END IF; 

   --Local
   
   -- get element_id's earliest scheduled date to latest scheduled date
   -- Sunday = 1, monday = 2, ..., Saturday = 7
   -- more than 7 days
   BEGIN
      SELECT COUNT(DAY_YEAR), MAX(DAY_YEAR), MIN(DAY_YEAR), PMO_ORASTD.DAYOFWEEK(MIN(DAY_YEAR))
      INTO h_diff, h_max_date, h_min_date, h_min_dow
      FROM CALENDAR_DAY_OF_YEAR
      WHERE ELEMENT_ID = h_id
      HAVING (MAX(DAY_YEAR) - MIN(DAY_YEAR)) > 7;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(52) : calendars.sql(66) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If Coalesce(h_diff, 0) = 0 Then
      BEGIN
         SELECT
         TO_DATE(SYSDATE) + (SETTING_VALUE)     ,
         TO_DATE(SYSDATE)
         INTO h_max_date, h_min_date
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'CPLAN_PROJECT_CALENDAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(70) : calendars.sql(84) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (Coalesce(h_day_week, 0) + 1) > Coalesce(h_min_dow, 0) Then
      BEGIN
         SELECT (TO_DATE(SubStr(h_min_date, 1, 10)) + ((h_day_week + 1) - h_min_dow)     )   INTO  h_current_calendar_date FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(85) : calendars.sql(99) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_day_week, 0) = Coalesce(h_min_dow, 0) Then
      --  strnpcpy(h_current_calendar_date, sizeof(h_current_calendar_date), h_min_date);
      h_current_calendar_date := h_min_date;
   Else
      BEGIN
         SELECT ( TO_DATE(SubStr(h_min_date, 1, 10)) + ((7 - h_min_dow) + (h_day_week + 1))     )  INTO  h_current_calendar_date FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(101) : calendars.sql(115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   LOOP
      BEGIN
         SELECT ( TO_DATE(SubStr(h_max_date, 1, 10)) - TO_DATE(SubStr(h_current_calendar_date, 1, 10)))  INTO  h_diff FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(116) : calendars.sql(130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_diff, 0) < 0 Then
         EXIT;
      End If;
      
      --get the specified week day's date
      BEGIN
         SELECT PMO_ORASTD.WEEK_ISO(h_current_calendar_date), PMO_ORASTD.MONTH(h_current_calendar_date)  INTO h_week_iso, h_month_iso
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(134) : calendars.sql(148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
         BEGIN
            INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
            VALUES(h_id, TO_DATE(SubStr(h_current_calendar_date, 1, 10)), h_day_week + 1, h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_current_calendar_date), 1, PMO_ORASTD.YEAR(h_current_calendar_date)+1);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(153) : calendars.sql(167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
         BEGIN
            INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
            VALUES(h_id, TO_DATE(SubStr(h_current_calendar_date, 1, 10)), h_day_week + 1, h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_current_calendar_date), 12, PMO_ORASTD.YEAR(h_current_calendar_date)-1);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(171) : calendars.sql(185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
            VALUES(h_id, TO_DATE(SubStr(h_current_calendar_date, 1, 10)), h_day_week + 1, h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_current_calendar_date), PMO_ORASTD.MONTH(h_current_calendar_date), PMO_ORASTD.YEAR(h_current_calendar_date));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(189) : calendars.sql(203) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (TO_DATE(SubStr(h_current_calendar_date, 1, 10)) + 7     )  INTO  h_current_calendar_date FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'newCDOY', 202+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: newCDOY(203) : calendars.sql(217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'newCDOY', 208+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: newCDOY(209) : calendars.sql(223) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'newCDOY', 212+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: newCDOY(213) : calendars.sql(227) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION newCDOY;
ALTER FUNCTION newCDOY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION fixCDOY ==
CREATE OR REPLACE FUNCTION fixCDOY
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_day_week PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_day_week PLS_INTEGER := sh_h_day_week;
   h_available_min PLS_INTEGER := 0;
   h_current_element_id VARCHAR2(32);
   h_current_type_id PLS_INTEGER := 0;
   h_date DATE;
   h_bit_available RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
-- Declare Cursors
      CURSOR C_CDOY_SUNDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.SUNDAY_BIT, TC.SUNDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND SUNDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_MONDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.MONDAY_BIT, TC.MONDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND MONDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_TUESDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.TUESDAY_BIT, TC.TUESDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND TUESDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_WEDNESDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.WEDNESDAY_BIT, TC.WEDNESDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND WEDNESDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_THURSDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.THURSDAY_BIT, TC.THURSDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND THURSDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_FRIDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.FRIDAY_BIT, TC.FRIDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND FRIDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_SATURDAY IS
         SELECT TC.ELEMENT_ID, TC.TYPE_ID, TC.SATURDAY_BIT, TC.SATURDAY_MIN
         FROM TMT_CALENDARS TC
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND SATURDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CDOY_EXC IS
         SELECT EXCEPTION_BIT, EXCEPTION_MIN, EXCEPTION_DATE
         FROM CALENDAR_EXCEPTIONS
         WHERE CALENDAR_RANK LIKE h_rank || '%'
         ORDER BY CALENDAR_RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('fixCDOY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('fixCDOY'), '-- ' || SYSTIMESTAMP, ':r := fixCDOY(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_day_week), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'fixCDOY', 128+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: fixCDOY(129) : calendars.sql(366) : ' || SYSTIMESTAMP);
   END IF; 

   --Local
   --SC_LONG(h_min);
   
   CASE h_day_week
      WHEN 0 THEN
         OPEN C_CDOY_SUNDAY;
         LOOP
            FETCH C_CDOY_SUNDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_SUNDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 179+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(180) : calendars.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_SUNDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(198) : calendars.sql(435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 1 THEN
         OPEN C_CDOY_MONDAY;
         LOOP
            FETCH C_CDOY_MONDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_MONDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 245+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(246) : calendars.sql(483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_MONDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 263+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(264) : calendars.sql(501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 2 THEN
         OPEN C_CDOY_TUESDAY;
         LOOP
            FETCH C_CDOY_TUESDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_TUESDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 311+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(312) : calendars.sql(549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_TUESDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(330) : calendars.sql(567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 3 THEN
         OPEN C_CDOY_WEDNESDAY;
         LOOP
            FETCH C_CDOY_WEDNESDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_WEDNESDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 377+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(378) : calendars.sql(615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_WEDNESDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 395+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(396) : calendars.sql(633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 4 THEN
         OPEN C_CDOY_THURSDAY;
         LOOP
            FETCH C_CDOY_THURSDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_THURSDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 443+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(444) : calendars.sql(681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_THURSDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 461+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(462) : calendars.sql(699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 5 THEN
         OPEN C_CDOY_FRIDAY;
         LOOP
            FETCH C_CDOY_FRIDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_FRIDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 509+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(510) : calendars.sql(747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_FRIDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 527+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(528) : calendars.sql(765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 6 THEN
         OPEN C_CDOY_SATURDAY;
         LOOP
            FETCH C_CDOY_SATURDAY INTO h_current_element_id, h_current_type_id, h_bit_available, h_available_min;
            IF C_CDOY_SATURDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit_available,
               AVAILABLE_MIN = h_available_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_WEEK = h_day_week + 1
               AND TO_DATE(SubStr(DAY_YEAR, 1, 10)) NOT IN (SELECT TO_DATE(SubStr(EXCEPTION_DATE, 1, 10)) FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 575+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(576) : calendars.sql(813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := newCDOY(h_current_element_id, h_current_type_id, h_day_week, h_available_min
                             , h_bit_available);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CDOY_SATURDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 593+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(594) : calendars.sql(831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ELSE
         NULL;
   END CASE;
   
   OPEN C_CDOY_EXC;
   LOOP
      FETCH C_CDOY_EXC INTO h_bit_available, h_available_min, h_date;
      IF C_CDOY_EXC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE CALENDAR_DAY_OF_YEAR CDOY SET
         CDOY.BIT_SCHED = h_bit_available,
         CDOY.AVAILABLE_MIN = h_available_min,
         CDOY.REC_STATUS = 'U'
         WHERE CDOY.DAY_YEAR = TO_DATE(SubStr(h_date, 1, 10))
         AND EXISTS(SELECT ELEMENT_ID FROM TMT_CALENDARS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND ELEMENT_ID = CDOY.ELEMENT_ID AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 645+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(646) : calendars.sql(883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_CDOY_EXC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 658+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(659) : calendars.sql(896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Clean up
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   BEGIN
      delete FROM CALENDAR_DAY_OF_YEAR CDOY
      WHERE CDOY.AVAILABLE_MIN = 0
      AND EXISTS(SELECT ELEMENT_ID FROM TMT_CALENDARS
      WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
      AND ELEMENT_ID = CDOY.ELEMENT_ID AND RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixCDOY', 693+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: fixCDOY(694) : calendars.sql(931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'fixCDOY', 701+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: fixCDOY(702) : calendars.sql(939) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION fixCDOY;
ALTER FUNCTION fixCDOY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION fixExcCDOY ==
CREATE OR REPLACE FUNCTION fixExcCDOY
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_date IN OUT NOCOPY DATE
   , sh_h_min PLS_INTEGER
   , sh_h_bit RAW
) RETURN PLS_INTEGER
AS
   h_min PLS_INTEGER := sh_h_min;
   h_bit RAW(36) := sh_h_bit;
   h_current_element_id VARCHAR2(32);
   h_current_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_week_iso PLS_INTEGER := 0;
   h_month_iso PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_calendar_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR C_ECDOY IS
         SELECT ELEMENT_ID, TYPE_ID, RANK
         FROM TMT_CALENDARS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('fixExcCDOY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('fixExcCDOY'), '-- ' || SYSTIMESTAMP, ':r := fixExcCDOY(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(NULLIF('''' || h_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_min), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bit), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'fixExcCDOY', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: fixExcCDOY(38) : calendars.sql(987) : ' || SYSTIMESTAMP);
   END IF; 

   --Local
   
   OPEN C_ECDOY;
   
   LOOP
      FETCH C_ECDOY INTO h_current_element_id, h_current_type_id, h_calendar_rank;
      IF C_ECDOY%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- Vladimir Schneider, vladimir@winpte.com
      -- October 14, 2004, this is to make sure parent exceptions does not blow away an
      -- exception for the same day defined at the calendar level or one of children below the parent
      h_count := 0;
      
      BEGIN
         SELECT 1
         INTO h_count
         FROM DUAL
         WHERE EXISTS(SELECT *
         FROM CALENDAR_EXCEPTIONS
         WHERE CALENDAR_RANK <= h_calendar_rank
         AND CALENDAR_RANK > h_rank
         AND CALENDAR_RANK = SUBSTR(h_calendar_rank, 1, LENGTH(CALENDAR_RANK))
         AND EXCEPTION_DATE=TO_DATE(SubStr(h_date, 1, 10)));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(78) : calendars.sql(1027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT Coalesce(h_count, 0) <> 0 Then
         BEGIN
            UPDATE CALENDAR_DAY_OF_YEAR SET
            BIT_SCHED = h_bit,
            AVAILABLE_MIN = h_min,
            REC_STATUS = 'U'
            WHERE ELEMENT_ID = h_current_element_id
            AND DAY_YEAR = TO_DATE(SubStr(h_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 100+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(101) : calendars.sql(1050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 115+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(116) : calendars.sql(1065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
               BEGIN
                  INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
                  VALUES(h_current_element_id, h_date, PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 134+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(135) : calendars.sql(1084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
               BEGIN
                  INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
                  VALUES(h_current_element_id, h_date, PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 152+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(153) : calendars.sql(1102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF)
                  VALUES(h_current_element_id, h_date, PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 170+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(171) : calendars.sql(1120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (isProjectType(Coalesce(
               h_current_type_id, 0))) <> 0 Then
            h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_ECDOY ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 191+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(192) : calendars.sql(1141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Clean up
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   BEGIN
      DELETE FROM CALENDAR_DAY_OF_YEAR CDOY
      WHERE CDOY.AVAILABLE_MIN = 0
      AND EXISTS(SELECT ELEMENT_ID FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
      AND ELEMENT_ID = CDOY.ELEMENT_ID AND RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'fixExcCDOY', 225+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: fixExcCDOY(226) : calendars.sql(1175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'fixExcCDOY', 233+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: fixExcCDOY(234) : calendars.sql(1183) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION fixExcCDOY;
ALTER FUNCTION fixExcCDOY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION reFixExcCDOY ==
CREATE OR REPLACE FUNCTION reFixExcCDOY
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_dow PLS_INTEGER
   , h_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_dow PLS_INTEGER := sh_h_dow;
   h_current_element_id VARCHAR2(32);
   h_current_type_id PLS_INTEGER := 0;
   h_min PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_week_iso PLS_INTEGER := 0;
   h_month_iso PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_reCDOY_SUNDAY IS
         SELECT ELEMENT_ID, TYPE_ID, SUNDAY_BIT, SUNDAY_MIN
         FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
         AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

      CURSOR C_reCDOY_MONDAY IS
         SELECT ELEMENT_ID, TYPE_ID, MONDAY_BIT, MONDAY_MIN
         FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE) AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

      CURSOR C_reCDOY_TUESDAY IS
         SELECT ELEMENT_ID, TYPE_ID, TUESDAY_BIT, TUESDAY_MIN
         FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE) AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

      CURSOR C_reCDOY_WEDNESDAY IS
         SELECT ELEMENT_ID, TYPE_ID, WEDNESDAY_BIT, WEDNESDAY_MIN
         FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE) AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

      CURSOR C_reCDOY_THURSDAY IS
         SELECT ELEMENT_ID, TYPE_ID, THURSDAY_BIT, THURSDAY_MIN
         FROM TMT_CALENDARS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE) AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

      CURSOR C_reCDOY_FRIDAY IS
         SELECT ELEMENT_ID, TYPE_ID, FRIDAY_BIT, FRIDAY_MIN
         FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE) AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

      CURSOR C_reCDOY_SATURDAY IS
         SELECT ELEMENT_ID, TYPE_ID, SATURDAY_BIT, SATURDAY_MIN
         FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE) AND RANK LIKE h_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('reFixExcCDOY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('reFixExcCDOY'), '-- ' || SYSTIMESTAMP, ':r := reFixExcCDOY(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_dow), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'reFixExcCDOY', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: reFixExcCDOY(65) : calendars.sql(1258) : ' || SYSTIMESTAMP);
   END IF; 

   --Local
   --trace_printf("h_rank: %s, h_dow: %d\n", h_rank,h_dow);
   
   CASE h_dow
      WHEN 0 THEN
         OPEN C_reCDOY_SUNDAY;
         LOOP
            FETCH C_reCDOY_SUNDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_SUNDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 101+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(102) : calendars.sql(1295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 116+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(117) : calendars.sql(1310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 135+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(136) : calendars.sql(1329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 153+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(154) : calendars.sql(1347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 171+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(172) : calendars.sql(1365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (isProjectType(Coalesce(
                  h_current_type_id, 0))) <> 0 Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_SUNDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 191+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(192) : calendars.sql(1385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 1 THEN
         OPEN C_reCDOY_MONDAY;
         LOOP
            FETCH C_reCDOY_MONDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_MONDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 225+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(226) : calendars.sql(1419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 240+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(241) : calendars.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 259+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(260) : calendars.sql(1453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 277+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(278) : calendars.sql(1471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 295+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(296) : calendars.sql(1489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(
                  h_current_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_MONDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(316) : calendars.sql(1509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 2 THEN
         OPEN C_reCDOY_TUESDAY;
         LOOP
            FETCH C_reCDOY_TUESDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_TUESDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 349+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(350) : calendars.sql(1543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 364+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(365) : calendars.sql(1558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 383+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(384) : calendars.sql(1577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 401+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(402) : calendars.sql(1595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 419+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(420) : calendars.sql(1613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(
                  h_current_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_TUESDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 439+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(440) : calendars.sql(1633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 3 THEN
         OPEN C_reCDOY_WEDNESDAY;
         LOOP
            FETCH C_reCDOY_WEDNESDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_WEDNESDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 473+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(474) : calendars.sql(1667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 488+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(489) : calendars.sql(1682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 507+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(508) : calendars.sql(1701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 525+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(526) : calendars.sql(1719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 543+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(544) : calendars.sql(1737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(
                  h_current_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_WEDNESDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 563+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(564) : calendars.sql(1757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 4 THEN
         OPEN C_reCDOY_THURSDAY;
         LOOP
            FETCH C_reCDOY_THURSDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_THURSDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 597+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(598) : calendars.sql(1791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 612+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(613) : calendars.sql(1806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 631+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(632) : calendars.sql(1825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 649+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(650) : calendars.sql(1843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 667+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(668) : calendars.sql(1861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(
                  h_current_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_THURSDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 687+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(688) : calendars.sql(1881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 5 THEN
         OPEN C_reCDOY_FRIDAY;
         LOOP
            FETCH C_reCDOY_FRIDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_FRIDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 721+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(722) : calendars.sql(1915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 736+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(737) : calendars.sql(1930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 755+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(756) : calendars.sql(1949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 773+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(774) : calendars.sql(1967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, TO_DATE(SubStr(h_date, 1, 10)), PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 791+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(792) : calendars.sql(1985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(
                  h_current_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_FRIDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 811+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(812) : calendars.sql(2005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 6 THEN
         OPEN C_reCDOY_SATURDAY;
         LOOP
            FETCH C_reCDOY_SATURDAY INTO h_current_element_id, h_current_type_id, h_bit, h_min;
            IF C_reCDOY_SATURDAY%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            BEGIN
               UPDATE CALENDAR_DAY_OF_YEAR SET
               BIT_SCHED = h_bit,
               AVAILABLE_MIN = h_min,
               REC_STATUS = 'U'
               WHERE ELEMENT_ID = h_current_element_id
               AND DAY_YEAR = h_date;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 845+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(846) : calendars.sql(2039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               BEGIN
                  SELECT PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date)  INTO h_week_iso, h_month_iso
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 860+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(861) : calendars.sql(2054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR( ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, h_date, PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 1, PMO_ORASTD.YEAR(h_date)+1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 879+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(880) : calendars.sql(2073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, h_date, PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), 12, PMO_ORASTD.YEAR(h_date)-1);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 897+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(898) : calendars.sql(2091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO CALENDAR_DAY_OF_YEAR(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS, WEEK_OF, MONTH_OF, YEAR_OF)
                     VALUES(h_current_element_id, h_date, PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_date, 1, 10))), h_min, h_bit, 'I', PMO_ORASTD.WEEK_ISO(h_date), PMO_ORASTD.MONTH(h_date), PMO_ORASTD.YEAR(h_date));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 915+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(916) : calendars.sql(2109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(
                  h_current_type_id, 0) <> PMO_CNST.SC_RESOURCE) Then
               h_temp_sc_state := FC_TIMEPHASE_MONTH(h_current_element_id, h_date);
            End If;
         END LOOP;
         BEGIN
            CLOSE C_reCDOY_SATURDAY ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 935+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(936) : calendars.sql(2129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ELSE
         NULL;
   END CASE;
   
   --Clean up
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   BEGIN
      DELETE FROM CALENDAR_DAY_OF_YEAR CDOY
      WHERE CDOY.AVAILABLE_MIN = 0
      AND EXISTS(SELECT ELEMENT_ID FROM TMT_CALENDARS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
      AND ELEMENT_ID = CDOY.ELEMENT_ID AND RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'reFixExcCDOY', 972+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: reFixExcCDOY(973) : calendars.sql(2166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'reFixExcCDOY', 980+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: reFixExcCDOY(981) : calendars.sql(2174) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION reFixExcCDOY;
ALTER FUNCTION reFixExcCDOY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_CAL ==
CREATE OR REPLACE FUNCTION SP_I_CAL
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_friday_status VARCHAR2(1);
   h_monday_status VARCHAR2(1);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_saturday_status VARCHAR2(1);
   h_sunday_status VARCHAR2(1);
   h_thursday_status VARCHAR2(1);
   h_tuesday_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_wednesday_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_friday_min PLS_INTEGER := 0;
   h_monday_min PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_mpw PLS_INTEGER := 0;
   h_saturday_min PLS_INTEGER := 0;
   h_sunday_min PLS_INTEGER := 0;
   h_thursday_min PLS_INTEGER := 0;
   h_tuesday_min PLS_INTEGER := 0;
   h_wednesday_min PLS_INTEGER := 0;
   h_weekly_min PLS_INTEGER := 0;
   h_monday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_tuesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_wednesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_thursday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_friday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_saturday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_sunday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CAL(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CAL', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CAL(52) : calendars.sql(2236) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Validate parent_id
   If (p_parent_id IS NULL) Then
      -- Get the max sibling level from the root
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CALENDARS', h_max_rank);
      -- Get Base 64
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      -- Retrive Parent Info
      BEGIN
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1 INTO h_rank, h_level_id
         FROM TMT_CALENDARS WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL(76) : calendars.sql(2260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Execute Insert Statement
      BEGIN
         INSERT INTO TMT_CALENDARS(RANK, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER, SATURDAY_STATUS, SUNDAY_STATUS)
         VALUES(h_rank, h_uniqueID, p_name, p_type_id, h_level_id, p_rec_user, '5', '5');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL(95) : calendars.sql(2279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- Validate parent_id
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_CAL', 102+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_CAL(103) : calendars.sql(2287) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      -- Get next sibling count
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CALENDARS', h_parent_id, h_max_rank);
      --Get Base 64
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         SELECT
         RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1,
         MONDAY_STATUS, TUESDAY_STATUS, WEDNESDAY_STATUS, THURSDAY_STATUS, FRIDAY_STATUS, SATURDAY_STATUS, SUNDAY_STATUS,
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN, WEEKLY_MIN,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT,
         MINUTES_PER_DAY, MINUTES_PER_WEEK
         INTO
         h_rank, h_level_id,
         h_monday_status, h_tuesday_status, h_wednesday_status, h_thursday_status, h_friday_status, h_saturday_status, h_sunday_status,
         h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min, h_weekly_min,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit,
         h_mpd, h_mpw
         FROM TMT_CALENDARS WHERE ELEMENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL(138) : calendars.sql(2322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Convert Day Status
      h_monday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                           Coalesce(Ascii(SubStr(h_monday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_monday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_monday_status, 1, 1)), 0), 255) END), 255));
      h_tuesday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                            Coalesce(Ascii(SubStr(h_tuesday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_tuesday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_tuesday_status, 1, 1)), 0), 255) END), 255));
      h_wednesday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                              Coalesce(Ascii(SubStr(h_wednesday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_wednesday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_wednesday_status, 1, 1)), 0), 255) END), 255));
      h_thursday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                             Coalesce(Ascii(SubStr(h_thursday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_thursday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_thursday_status, 1, 1)), 0), 255) END), 255));
      h_friday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                           Coalesce(Ascii(SubStr(h_friday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_friday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_friday_status, 1, 1)), 0), 255) END), 255));
      h_saturday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                             Coalesce(Ascii(SubStr(h_saturday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_saturday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_saturday_status, 1, 1)), 0), 255) END), 255));
      h_sunday_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                           Coalesce(Ascii(SubStr(h_sunday_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_sunday_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_sunday_status, 1, 1)), 0), 255) END), 255));
      
      --Execute Insert Statement
      BEGIN
         INSERT INTO TMT_CALENDARS(
         RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER,
         MONDAY_STATUS, TUESDAY_STATUS, WEDNESDAY_STATUS, THURSDAY_STATUS, FRIDAY_STATUS, SATURDAY_STATUS, SUNDAY_STATUS,
         MONDAY_DEFAULT_MIN, TUESDAY_DEFAULT_MIN, WEDNESDAY_DEFAULT_MIN, THURSDAY_DEFAULT_MIN, FRIDAY_DEFAULT_MIN, SATURDAY_DEFAULT_MIN, SUNDAY_DEFAULT_MIN, WEEKLY_DEFAULT_MIN,
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN, WEEKLY_MIN,
         MONDAY_DEFAULT_BIT, TUESDAY_DEFAULT_BIT, WEDNESDAY_DEFAULT_BIT, THURSDAY_DEFAULT_BIT, FRIDAY_DEFAULT_BIT, SATURDAY_DEFAULT_BIT, SUNDAY_DEFAULT_BIT,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT,
         MINUTES_PER_DAY, MINUTES_PER_WEEK)
         VALUES(
         h_rank, h_parent_id, h_uniqueID, p_name, p_type_id, h_level_id, p_rec_user,
         h_monday_status, h_tuesday_status, h_wednesday_status, h_thursday_status, h_friday_status, h_saturday_status, h_sunday_status,
         h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min, h_weekly_min,
         h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min, h_weekly_min,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit,
         h_mpd, h_mpw);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL(187) : calendars.sql(2371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CAL', 193+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CAL(194) : calendars.sql(2378) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL', 200+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL(201) : calendars.sql(2385) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL', 212+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL(213) : calendars.sql(2397) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CAL;
ALTER FUNCTION SP_I_CAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CAL_MINUTES ==
CREATE OR REPLACE FUNCTION SP_U_CAL_MINUTES
(
     p_id VARCHAR2
   , p_mpd PLS_INTEGER
   , p_mpw PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CAL_MINUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CAL_MINUTES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CAL_MINUTES(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_mpd), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_mpw), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_MINUTES', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CAL_MINUTES(23) : calendars.sql(2436) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CAL_MINUTES', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CAL_MINUTES(28) : calendars.sql(2441) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_MINUTES', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_MINUTES(31) : calendars.sql(2444) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CAL_MINUTES', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CAL_MINUTES(40) : calendars.sql(2453) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CALENDARS SET
      MINUTES_PER_DAY = p_mpd,
      MINUTES_PER_WEEK = p_mpw,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_MINUTES', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_MINUTES(70) : calendars.sql(2483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CAL_MINUTES', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CAL_MINUTES(76) : calendars.sql(2489) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_MINUTES', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_MINUTES(83) : calendars.sql(2496) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_MINUTES', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_MINUTES(95) : calendars.sql(2508) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CAL_MINUTES;
ALTER FUNCTION SP_U_CAL_MINUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CAL ==
CREATE OR REPLACE FUNCTION SP_U_CAL
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CAL(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CAL(23) : calendars.sql(2547) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CAL', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CAL(29) : calendars.sql(2553) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL(32) : calendars.sql(2556) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CAL', 40+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CAL(41) : calendars.sql(2565) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CALENDARS SET
      ELEMENT_NAME = p_name,
      DESCRIPTION = p_description,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL(71) : calendars.sql(2595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CAL', 76+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CAL(77) : calendars.sql(2601) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL(84) : calendars.sql(2608) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL(96) : calendars.sql(2620) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CAL;
ALTER FUNCTION SP_U_CAL COMPILE DEBUG;

/*************************************************************************************
DAY_WEEK:
    0: SUNDAY
    1: MONDAY
    2: TUESDAY
    3: WEDNESDAY
    4: THURSDAY
    5: FRIDAY
    6: SATURDAY

DAILY_STATUS:
    0: NON-WORKING
    1: WORKING
    2: (NOT USED)
    3: DERRIVED NON-WORKING
    4: DERRIVED NON-DEFAULT WORKING
    5: OVERRIDE NON-WORKING
    6: OVERRIDE NON-DEFAULT WORKING

BITFLAG
    2: OVERRIDE
    1: RESET
*************************************************************************************/

Prompt == FUNCTION SP_U_CAL_HOURS ==
CREATE OR REPLACE FUNCTION SP_U_CAL_HOURS
(
     p_id VARCHAR2
   , p_day_week PLS_INTEGER
   , p_from1 VARCHAR2
   , p_to1 VARCHAR2
   , p_from2 VARCHAR2
   , p_to2 VARCHAR2
   , p_from3 VARCHAR2
   , p_to3 VARCHAR2
   , p_from4 VARCHAR2
   , p_to4 VARCHAR2
   , p_from5 VARCHAR2
   , p_to5 VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_from1 VARCHAR2(8);
   h_to1 VARCHAR2(8);
   h_from2 VARCHAR2(8);
   h_to2 VARCHAR2(8);
   h_from3 VARCHAR2(8);
   h_to3 VARCHAR2(8);
   h_from4 VARCHAR2(8);
   h_to4 VARCHAR2(8);
   h_from5 VARCHAR2(8);
   h_to5 VARCHAR2(8);
   h_available_min PLS_INTEGER := 0;
   h_day_status VARCHAR2(1);
   h_child_day_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_current_calendar_date DATE;
   h_SD DATE;
   h_FD DATE;
   h_current_datetime TIMESTAMP;
   h_date DATE;
   h_pass PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_alert_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   h_min_dow PLS_INTEGER := 0;
   h_day_week PLS_INTEGER := 0;
   h_current_tc_id VARCHAR2(32);
   h_bit_available RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   null_return LONG;
-- Declare Cursors
      CURSOR C_SUNDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND SUNDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_MONDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND MONDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_TUESDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND TUESDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_WEDNESDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND WEDNESDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_THURSDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND THURSDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_FRIDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND FRIDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_SATURDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND SATURDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_SUNDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND SUNDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_MONDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND MONDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_TUESDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(SELECT ELEMENT_ID FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND TUESDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_WEDNESDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND WEDNESDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_THURSDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND THURSDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_FRIDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND FRIDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_U_SATURDAY IS
         SELECT TC.ELEMENT_ID, TC.START_DATE
         FROM TMT_CALENDARS TC
         WHERE TC.RANK LIKE h_rank || '%'
         AND NOT EXISTS(
         SELECT ELEMENT_ID
         FROM TMT_CALENDARS
         WHERE LENGTH(h_rank) < LENGTH(RANK)
         AND SATURDAY_STATUS IN ('5', '6')
         AND ((RANK >= SUBSTR(TC.RANK, 1, 8) AND RANK <= TC.RANK) 
         AND SUBSTR(TC.RANK,1, CASE WHEN LENGTH(RANK) > LENGTH(TC.RANK) THEN 1 ELSE LENGTH(RANK) END ) = RANK))
         ORDER BY RANK;

      CURSOR C_CAL_TIMEPHASE IS
         SELECT ELEMENT_ID FROM TMT_CALENDARS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND RANK LIKE h_rank || '%' ORDER BY RANK;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CAL_HOURS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CAL_HOURS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CAL_HOURS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_day_week), 'NULL')
          || ', ' || '''' || p_from1 || ''''
          || ', ' || '''' || p_to1 || ''''
          || ', ' || '''' || p_from2 || ''''
          || ', ' || '''' || p_to2 || ''''
          || ', ' || '''' || p_from3 || ''''
          || ', ' || '''' || p_to3 || ''''
          || ', ' || '''' || p_from4 || ''''
          || ', ' || '''' || p_to4 || ''''
          || ', ' || '''' || p_from5 || ''''
          || ', ' || '''' || p_to5 || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_HOURS', 260+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CAL_HOURS(261) : calendars.sql(2919) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CAL_HOURS', 266+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CAL_HOURS(267) : calendars.sql(2925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_HOURS', 269+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_HOURS(270) : calendars.sql(2928) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   --if (IsNullSpParam(ind_u_cal_hours, p_start_date))
   --{
   --    RETURN_INVALID(INVALID_PARAMS);
   --}
   
   --Validate id
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_date := p_start_date;
   
   --Retrieve related information
   BEGIN
      SELECT PARENT_ID, RANK, TYPE_ID INTO h_parent_id, h_rank, h_type_id
      FROM TMT_CALENDARS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 297+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(298) : calendars.sql(2956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CAL_HOURS', 304+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CAL_HOURS(305) : calendars.sql(2963) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_HOURS', 307+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_HOURS(308) : calendars.sql(2966) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   --trace_printf("START_ h_parent_id = %d %s, h_rank = %d %s, h_type_id = %d\n", h_parent_id_Ind,h_parent_id,h_rank_Ind,h_rank,h_type_id);
   
   --h_pass > 0 ==> there is shift(s)
   h_pass := 0;
   If ((p_from1 IS NOT NULL)) AND ((p_to1 IS NOT NULL)) Then
      h_pass := 1;
      h_from1 := p_from1;
      h_to1 := p_to1;
      PMO_STPU.filldayStruct(h_from1, h_to1, h_bit_available);
      
      If ((p_from2 IS NOT NULL)) AND ((p_to2 IS NOT NULL)) Then
         h_from2 := p_from2;
         h_to2 := p_to2;
         PMO_STPU.filldayStruct(h_from2, h_to2, h_bit_available);
         
         If ((p_from3 IS NOT NULL)) AND ((p_to3 IS NOT NULL)) Then
            h_from3 := p_from3;
            h_to3 := p_to3;
            PMO_STPU.filldayStruct(h_from3, h_to3, h_bit_available);
            
            If ((p_from4 IS NOT NULL)) AND ((p_to4 IS NOT NULL)) Then
               h_from4 := p_from4;
               h_to4 := p_to4;
               PMO_STPU.filldayStruct(h_from4, h_to4, h_bit_available);
               
               If ((p_from5 IS NOT NULL)) AND ((p_to5 IS NOT NULL)) Then
                  h_from5 := p_from5;
                  h_to5 := p_to5;
                  PMO_STPU.filldayStruct(h_from5, h_to5, h_bit_available);
               End If;
               --end of shift 5
            End If;
            --end of shift 4
         End If;
         --end of shift 3
      End If;
      --end of shift 2
   End If;
   --end of shift 1
   
   --Total working minutes per day
   h_available_min := PMO_STPU.getNumberOfBits(h_bit_available) * 5;
   BEGIN
      SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 362+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(363) : calendars.sql(3021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_available_min %d, *p_bitflag %d, *p_day_week %d\n", h_available_min,*p_bitflag,*p_day_week);
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      --Overriding Calendar Information
      If Coalesce(h_available_min, 0) > 0 Then
         --Working
         h_day_status := '6';
         h_child_day_status := '4';
      Else
         --Non-working
         h_day_status := '5';
         h_child_day_status := '3';
      End If;
      
      CASE p_day_week
         
         WHEN 0 THEN
            --Update selected calendar
            
            OPEN C_SUNDAY;
            LOOP
               FETCH C_SUNDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_SUNDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT SUNDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 407+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(408) : calendars.sql(3066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        SUNDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        SUNDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        SUNDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 433+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(434) : calendars.sql(3092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 480+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(481) : calendars.sql(3139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        case when h_pass = 1 then h_available_min else 0 end,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 527+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(528) : calendars.sql(3186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     SUNDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     SUNDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     SUNDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 555+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(556) : calendars.sql(3214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_SUNDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 569+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(570) : calendars.sql(3228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 1 THEN
            OPEN C_MONDAY;
            LOOP
               FETCH C_MONDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_MONDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT MONDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 596+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(597) : calendars.sql(3255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        MONDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        MONDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        MONDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 622+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(623) : calendars.sql(3281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 669+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(670) : calendars.sql(3328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        case when h_pass = 1 then h_available_min else 0 end,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 716+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(717) : calendars.sql(3375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     MONDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     MONDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     MONDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 744+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(745) : calendars.sql(3403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("UPDATE_1_h_pass: %d, h_current_tc_id: %d %s\n", h_pass,h_current_tc_id_Ind,h_current_tc_id);
               End If;
            END LOOP;
            BEGIN
               CLOSE C_MONDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 759+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(760) : calendars.sql(3418) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 2 THEN
            OPEN C_TUESDAY;
            LOOP
               FETCH C_TUESDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_TUESDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT TUESDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 786+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(787) : calendars.sql(3445) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        TUESDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        TUESDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        TUESDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 812+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(813) : calendars.sql(3471) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 859+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(860) : calendars.sql(3518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        MONDAY_STATUS,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        case when h_pass = 1 then h_available_min else 0 end,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 906+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(907) : calendars.sql(3565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     TUESDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     TUESDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     TUESDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 934+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(935) : calendars.sql(3593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_TUESDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 948+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(949) : calendars.sql(3607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 3 THEN
            OPEN C_WEDNESDAY;
            LOOP
               FETCH C_WEDNESDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_WEDNESDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT WEDNESDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 975+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(976) : calendars.sql(3634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        WEDNESDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        WEDNESDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        WEDNESDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1001+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1002) : calendars.sql(3660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1048+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1049) : calendars.sql(3707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        case when h_pass = 1 then h_available_min else 0 end,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1095+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1096) : calendars.sql(3754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     WEDNESDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     WEDNESDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     WEDNESDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1123+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1124) : calendars.sql(3782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_WEDNESDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1137+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1138) : calendars.sql(3796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 4 THEN
            OPEN C_THURSDAY;
            LOOP
               FETCH C_THURSDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_THURSDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT THURSDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1164+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1165) : calendars.sql(3823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        THURSDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        THURSDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        THURSDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1190+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1191) : calendars.sql(3849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1237+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1238) : calendars.sql(3896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        case when h_pass = 1 then h_available_min else 0 end,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1284+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1285) : calendars.sql(3943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     THURSDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     THURSDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     THURSDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1312+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1313) : calendars.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_THURSDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1326+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1327) : calendars.sql(3985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 5 THEN
            OPEN C_FRIDAY;
            LOOP
               FETCH C_FRIDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_FRIDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT THURSDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1353+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1354) : calendars.sql(4012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        FRIDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        FRIDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        FRIDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1379+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1380) : calendars.sql(4038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1426+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1427) : calendars.sql(4085) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        case when h_pass = 1 then h_available_min else 0 end,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1473+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1474) : calendars.sql(4132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     FRIDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     FRIDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     FRIDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1501+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1502) : calendars.sql(4160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_FRIDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1515+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1516) : calendars.sql(4174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 6 THEN
            OPEN C_SATURDAY;
            LOOP
               FETCH C_SATURDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_SATURDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT THURSDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1542+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1543) : calendars.sql(4201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        SATURDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        SATURDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                        SATURDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        WEEKLY_MIN = WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1568+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1569) : calendars.sql(4227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1615+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1616) : calendars.sql(4274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + case when h_pass = 1 then h_available_min else 0 end - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        case when h_pass = 1 then h_available_min else 0 end,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1662+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1663) : calendars.sql(4321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS SET
                     SATURDAY_BIT = case when h_pass = 1 then h_bit_available else PMO_CNST.SC_ZERO_BIT end,
                     SATURDAY_MIN = case when h_pass = 1 then h_available_min else 0 end,
                     SATURDAY_STATUS = case when ELEMENT_ID = h_id then h_day_status else h_child_day_status end,
                     START_DATE = h_date,
                     REC_STATUS = 'U',
                     REC_DATETIME = h_current_datetime,
                     REC_USER = p_rec_user
                     WHERE ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1690+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1691) : calendars.sql(4349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_SATURDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1704+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1705) : calendars.sql(4363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      --Update Weekly Minutes
      BEGIN
         UPDATE TMT_CALENDARS SET
         WEEKLY_MIN = MONDAY_MIN + TUESDAY_MIN + WEDNESDAY_MIN + THURSDAY_MIN + FRIDAY_MIN + SATURDAY_MIN + SUNDAY_MIN,
         WEEKLY_DEFAULT_MIN = MONDAY_DEFAULT_MIN + TUESDAY_DEFAULT_MIN + WEDNESDAY_DEFAULT_MIN + THURSDAY_DEFAULT_MIN + FRIDAY_DEFAULT_MIN + SATURDAY_DEFAULT_MIN + SUNDAY_DEFAULT_MIN
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1741+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1742) : calendars.sql(4400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Reset Calendar Information
      CASE p_day_week
         WHEN 0 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT SUNDAY_STATUS, SUNDAY_MIN, SUNDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1762+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1763) : calendars.sql(4421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT SUNDAY_STATUS, SUNDAY_MIN, SUNDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1778+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1779) : calendars.sql(4437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_SUNDAY;
            LOOP
               FETCH C_U_SUNDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_SUNDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT SUNDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1811+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1812) : calendars.sql(4470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        SUNDAY_BIT = h_bit_available,
                        SUNDAY_MIN = h_available_min,
                        SUNDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1837+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1838) : calendars.sql(4496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1884+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1885) : calendars.sql(4543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        h_day_status,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        h_available_min,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        h_bit_available,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1931+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1932) : calendars.sql(4590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.SUNDAY_BIT = h_bit_available,
                     TC.SUNDAY_MIN = h_available_min,
                     TC.SUNDAY_STATUS = h_day_status,
                     TC.START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1959+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1960) : calendars.sql(4618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_SUNDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1973+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1974) : calendars.sql(4632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 1 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT MONDAY_STATUS, MONDAY_MIN, MONDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 1991+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(1992) : calendars.sql(4650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT MONDAY_STATUS, MONDAY_MIN, MONDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2007+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2008) : calendars.sql(4666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_MONDAY;
            LOOP
               FETCH C_U_MONDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_MONDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT MONDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2040+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2041) : calendars.sql(4699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        MONDAY_BIT = h_bit_available,
                        MONDAY_MIN = h_available_min,
                        MONDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2066+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2067) : calendars.sql(4725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2113+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2114) : calendars.sql(4772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        h_day_status,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        h_available_min,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        h_bit_available,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2160+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2161) : calendars.sql(4819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.MONDAY_BIT = h_bit_available,
                     TC.MONDAY_MIN = h_available_min,
                     TC.MONDAY_STATUS = h_day_status,
                     START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2188+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2189) : calendars.sql(4847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_MONDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2202+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2203) : calendars.sql(4861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 2 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT TUESDAY_STATUS, TUESDAY_MIN, TUESDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2220+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2221) : calendars.sql(4879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT TUESDAY_STATUS, TUESDAY_MIN, TUESDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2236+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2237) : calendars.sql(4895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_TUESDAY;
            LOOP
               FETCH C_U_TUESDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_TUESDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT TUESDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2269+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2270) : calendars.sql(4928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        TUESDAY_BIT = h_bit_available,
                        TUESDAY_MIN = h_available_min,
                        TUESDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2295+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2296) : calendars.sql(4954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2342+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2343) : calendars.sql(5001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        MONDAY_STATUS,
                        h_day_status,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        h_available_min,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        h_bit_available,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2389+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2390) : calendars.sql(5048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.TUESDAY_BIT = h_bit_available,
                     TC.TUESDAY_MIN = h_available_min,
                     TC.TUESDAY_STATUS = h_day_status,
                     TC.START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2417+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2418) : calendars.sql(5076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_TUESDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2431+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2432) : calendars.sql(5090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 3 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT WEDNESDAY_STATUS, WEDNESDAY_MIN, WEDNESDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2449+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2450) : calendars.sql(5108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT WEDNESDAY_STATUS, WEDNESDAY_MIN, WEDNESDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2465+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2466) : calendars.sql(5124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_WEDNESDAY;
            LOOP
               FETCH C_U_WEDNESDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_WEDNESDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT WEDNESDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2498+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2499) : calendars.sql(5157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        WEDNESDAY_BIT = h_bit_available,
                        WEDNESDAY_MIN = h_available_min,
                        WEDNESDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2524+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2525) : calendars.sql(5183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2571+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2572) : calendars.sql(5230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        h_day_status,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        h_available_min,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        h_bit_available,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2618+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2619) : calendars.sql(5277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.WEDNESDAY_BIT = h_bit_available,
                     TC.WEDNESDAY_MIN = h_available_min,
                     TC.WEDNESDAY_STATUS = h_day_status,
                     TC.START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2646+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2647) : calendars.sql(5305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_WEDNESDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2660+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2661) : calendars.sql(5319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 4 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT THURSDAY_STATUS, THURSDAY_MIN, THURSDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2678+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2679) : calendars.sql(5337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT THURSDAY_STATUS, THURSDAY_MIN, THURSDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2694+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2695) : calendars.sql(5353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_THURSDAY;
            LOOP
               FETCH C_U_THURSDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_THURSDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT THURSDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2727+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2728) : calendars.sql(5386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        THURSDAY_BIT = h_bit_available,
                        THURSDAY_MIN = h_available_min,
                        THURSDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2753+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2754) : calendars.sql(5412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2800+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2801) : calendars.sql(5459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        h_day_status,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        h_available_min,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        h_bit_available,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2847+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2848) : calendars.sql(5506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.THURSDAY_BIT = h_bit_available,
                     TC.THURSDAY_MIN = h_available_min,
                     TC.THURSDAY_STATUS = h_day_status,
                     TC.START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2875+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2876) : calendars.sql(5534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_THURSDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2889+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2890) : calendars.sql(5548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 5 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT FRIDAY_STATUS, FRIDAY_MIN, FRIDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2907+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2908) : calendars.sql(5566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT FRIDAY_STATUS, FRIDAY_MIN, FRIDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2923+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2924) : calendars.sql(5582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_FRIDAY;
            LOOP
               FETCH C_U_FRIDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_FRIDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT THURSDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2956+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2957) : calendars.sql(5615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        FRIDAY_BIT = h_bit_available,
                        FRIDAY_MIN = h_available_min,
                        FRIDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 2982+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(2983) : calendars.sql(5641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3029+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3030) : calendars.sql(5688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        h_day_status,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        h_available_min,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        h_bit_available,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3076+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3077) : calendars.sql(5735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.FRIDAY_BIT = h_bit_available,
                     TC.FRIDAY_MIN = h_available_min,
                     TC.FRIDAY_STATUS = h_day_status,
                     TC.START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3104+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3105) : calendars.sql(5763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_FRIDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3118+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3119) : calendars.sql(5777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         WHEN 6 THEN
            -- Get parent info
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  SELECT SATURDAY_STATUS, SATURDAY_MIN, SATURDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID = h_parent_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3136+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3137) : calendars.sql(5795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT SATURDAY_STATUS, SATURDAY_MIN, SATURDAY_BIT
                  INTO h_day_status, h_available_min, h_bit_available
                  FROM TMT_CALENDARS
                  WHERE ELEMENT_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3152+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3153) : calendars.sql(5811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            h_day_status := Chr(BITAND(getDayStatus(CASE WHEN 
                                        Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0) > 127 THEN BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) - 256 ELSE BITAND(Coalesce(Ascii(SubStr(h_day_status, 1, 1)), 0), 255) END), 255));
            
            -- Find all children, and seperating the ones that have their own definition
            
            OPEN C_U_SATURDAY;
            LOOP
               FETCH C_U_SATURDAY INTO h_current_tc_id, h_current_calendar_date;
               IF C_U_SATURDAY%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) <> 0 Then
                  BEGIN
                     SELECT THURSDAY_MIN INTO h_min_dow FROM HISTORY_CALENDARS
                     WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3185+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3186) : calendars.sql(5844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                     BEGIN
                        UPDATE HISTORY_CALENDARS SET
                        SATURDAY_BIT = h_bit_available,
                        SATURDAY_MIN = h_available_min,
                        SATURDAY_STATUS = h_day_status,
                        WEEKLY_MIN = WEEKLY_MIN + h_available_min - h_min_dow,
                        REC_STATUS = 'U',
                        REC_DATETIME = h_current_datetime,
                        REC_USER = p_rec_user
                        WHERE ELEMENT_ID = h_current_tc_id AND START_DATE = h_date;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3211+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3212) : calendars.sql(5870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  ElsIf PMO_ORASTD.strcmp(h_date, h_current_calendar_date) > 0 Then
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        START_DATE,
                        WEEKLY_MIN,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        SATURDAY_STATUS,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        SATURDAY_MIN,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        SATURDAY_BIT,
                        SUNDAY_BIT,
                        REC_DATETIME,
                        REC_STATUS,
                        REC_USER
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3258+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3259) : calendars.sql(5917) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        INSERT INTO HISTORY_CALENDARS
                        SELECT
                        ELEMENT_ID,
                        h_date,
                        WEEKLY_MIN + h_available_min - h_min_dow,
                        MONDAY_STATUS,
                        TUESDAY_STATUS,
                        WEDNESDAY_STATUS,
                        THURSDAY_STATUS,
                        FRIDAY_STATUS,
                        h_day_status,
                        SUNDAY_STATUS,
                        MONDAY_MIN,
                        TUESDAY_MIN,
                        WEDNESDAY_MIN,
                        THURSDAY_MIN,
                        FRIDAY_MIN,
                        h_available_min,
                        SUNDAY_MIN,
                        MONDAY_BIT,
                        TUESDAY_BIT,
                        WEDNESDAY_BIT,
                        THURSDAY_BIT,
                        FRIDAY_BIT,
                        h_bit_available,
                        SUNDAY_BIT,
                        h_current_datetime,
                        'U',
                        p_rec_user
                        FROM TMT_CALENDARS
                        WHERE ELEMENT_ID = h_current_tc_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3305+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3306) : calendars.sql(5964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
               
               If PMO_ORASTD.strcmp(h_date, h_current_calendar_date) >= 0 Then
                  BEGIN
                     UPDATE TMT_CALENDARS TC SET
                     TC.SATURDAY_BIT = h_bit_available,
                     TC.SATURDAY_MIN = h_available_min,
                     TC.SATURDAY_STATUS = h_day_status,
                     TC.START_DATE = h_date,
                     TC.REC_STATUS = 'U',
                     TC.REC_DATETIME = h_current_datetime,
                     TC.REC_USER = p_rec_user
                     WHERE TC.ELEMENT_ID = h_current_tc_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3333+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3334) : calendars.sql(5992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            BEGIN
               CLOSE C_U_SATURDAY ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3347+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3348) : calendars.sql(6006) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ELSE
            NULL;
      END CASE;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      --Update weekly minutes
      BEGIN
         UPDATE TMT_CALENDARS SET
         WEEKLY_MIN = MONDAY_MIN + TUESDAY_MIN + WEDNESDAY_MIN + THURSDAY_MIN + FRIDAY_MIN + SATURDAY_MIN + SUNDAY_MIN,
         WEEKLY_DEFAULT_MIN = MONDAY_DEFAULT_MIN + TUESDAY_DEFAULT_MIN + WEDNESDAY_DEFAULT_MIN + THURSDAY_DEFAULT_MIN + FRIDAY_DEFAULT_MIN + SATURDAY_DEFAULT_MIN + SUNDAY_DEFAULT_MIN
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3385) : calendars.sql(6043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("SC_STATE: %d, h_rank: %s\n",SC_STATE,h_rank);
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (PMO_ORASTD.strcmp(h_rec_user, h_id) = 0) Then
      -- Issue alert only for personal calendar but not project calendar
      h_alert_id := 'SCPERSONALCALENDARCHANGED';
      h_temp_var := 3;
      
      null_return := FC_ISSUE_ALERT(h_alert_id, h_id, h_rec_user, h_temp_var, 0);
   End If;
   
   h_day_week := p_day_week;
   --Updating CALENDAR DAY OF YEAR
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_DB2M.SC_STATE := fixCDOY(h_id, h_rank, h_day_week);
   End If;
   
   -- The following part has to be moved to sp_s_pbb.
   -- Set flag on in this sp and fix TIMEPHASE_CALENDAR in sp_s_pbb.
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      OPEN C_CAL_TIMEPHASE;
      LOOP
         FETCH C_CAL_TIMEPHASE INTO h_project_id;
         IF C_CAL_TIMEPHASE%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            DELETE FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3432+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3433) : calendars.sql(6091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               SELECT MIN(DAY_YEAR), MAX(DAY_YEAR) INTO h_SD, h_FD
               FROM CALENDAR_DAY_OF_YEAR WHERE ELEMENT_ID = h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3447+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3448) : calendars.sql(6106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_temp_sc_state := FC_TIMEPHASE_CALENDAR(h_project_id, h_SD, h_FD);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_CAL_TIMEPHASE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3463+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3464) : calendars.sql(6122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CAL_HOURS', 3470+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CAL_HOURS(3471) : calendars.sql(6129) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3477+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3478) : calendars.sql(6136) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_HOURS', 3489+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_HOURS(3490) : calendars.sql(6148) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CAL_HOURS;
ALTER FUNCTION SP_U_CAL_HOURS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_CAL ==
CREATE OR REPLACE FUNCTION SP_D_CAL
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_exists VARCHAR2(32);
   h_dependency_count PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
-- Declare Cursors
      CURSOR CC1 IS
         SELECT ELEMENT_ID FROM TMT_CALENDARS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE);

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CAL(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CAL(32) : calendars.sql(6196) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CAL', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CAL(40) : calendars.sql(6204) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(43) : calendars.sql(6207) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_rec_status := p_del_flag;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'SP_D_CAL', 50+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: SP_D_CAL(51) : calendars.sql(6215) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      IF h_rec_status = 'X' THEN 
         EXECUTE IMMEDIATE 'SELECT a.REC_STATUS FROM ' || 'TMT_CALENDARS' || ' a 
         WHERE a.ELEMENT_ID = :i AND LENGTH(a.RANK) > 4 AND NOT a.REC_STATUS = '' L '' AND NOT EXISTS 
         (SELECT b.REC_STATUS 
                  FROM TMT_ORGANIZATIONS b 
                 WHERE b.REC_STATUS = '' L '' AND instr(b.RANK, a.RANK) = 1)' 
            INTO h_rec_status 
            Using h_id; 
      ELSE 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS FROM ' || 'TMT_CALENDARS' || ' 
              WHERE ELEMENT_ID = :i AND REC_STATUS NOT IN (''L'',''D'') ' 
            INTO h_rec_status 
            Using h_id; 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True); 
      WHEN OTHERS THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id , True); 
   END;
   
   -- Validate parent id
   If ((p_parent_id IS NULL)) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_CALENDARS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(86) : calendars.sql(6250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --strcpy(h_rec_status, "");
      h_rec_status := '';
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_D_CAL', 94+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_D_CAL(95) : calendars.sql(6259) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CAL', 106+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CAL(107) : calendars.sql(6271) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 109+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(110) : calendars.sql(6274) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      -- Find Necessary Info
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_CALENDARS WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(123) : calendars.sql(6287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CAL', 130+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CAL(131) : calendars.sql(6295) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 133+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(134) : calendars.sql(6298) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   --Check for dependencies
   OPEN CC1;
   FETCH CC1 INTO h_exists;
   IF CC1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_dependency_count := 1;
   Else
      h_dependency_count := 0;
   End If;
   BEGIN
      CLOSE CC1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(160) : calendars.sql(6324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Is deletable
   If SubStr(p_del_flag, 1, 1) = '?' Then
      If (Coalesce(h_dependency_count, 0) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CAL', 168+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CAL(169) : calendars.sql(6333) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 171+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(172) : calendars.sql(6336) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE, p_id, True);
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CAL', 176+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CAL(177) : calendars.sql(6341) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 179+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(180) : calendars.sql(6344) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
      End If;
   Else
      If (Coalesce(h_dependency_count, 0) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CAL', 186+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CAL(187) : calendars.sql(6351) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DELETE), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 189+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(190) : calendars.sql(6354) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DELETE, p_id, True);
      End If;
      --comment by paria
      /*else
                  {checkFlagStatus(del_flag, 'L');}
              */
      --end comment
   End If;
   
   -- Execute Delete Statement
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      -- Delete Tree
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         DELETE FROM CALENDAR_EXCEPTIONS WHERE CALENDAR_RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 228+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(229) : calendars.sql(6393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_CALENDARS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 245+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(246) : calendars.sql(6410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_CALENDARS SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 266+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(267) : calendars.sql(6431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CALENDARS SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 284+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(285) : calendars.sql(6449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (p_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_CALENDARS SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NuLL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 304+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(305) : calendars.sql(6469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_CALENDARS SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 322+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(323) : calendars.sql(6487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CAL', 331+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CAL(332) : calendars.sql(6496) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL', 334+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL(335) : calendars.sql(6499) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      -- Update Parent's Hierarchy Info
      If (p_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_CALENDARS SET
            CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 356+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(357) : calendars.sql(6521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CALENDARS SET
            CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 376+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(377) : calendars.sql(6541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- Lock Tree
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 391+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(392) : calendars.sql(6556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CALENDARS SET
         REC_STATUS = p_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 424+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(425) : calendars.sql(6589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CAL', 431+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CAL(432) : calendars.sql(6596) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 438+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(439) : calendars.sql(6603) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL', 450+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL(451) : calendars.sql(6615) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CAL;
ALTER FUNCTION SP_D_CAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UN_CAL ==
CREATE OR REPLACE FUNCTION SP_UN_CAL
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_deleted_datetime TIMESTAMP;
   h_current_datetime TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UN_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UN_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_UN_CAL(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_CAL', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UN_CAL(25) : calendars.sql(6656) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_UN_CAL', 32+1) THEN 
      LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_UN_CAL(33) : calendars.sql(6664) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Validate parent id
   If ((p_parent_id IS NULL)) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK, REC_DATETIME INTO h_rank, h_deleted_datetime FROM TMT_CALENDARS
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 55+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(56) : calendars.sql(6687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      BEGIN
         UPDATE TMT_CALENDARS SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(75) : calendars.sql(6706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_UN_CAL', 81+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_UN_CAL(82) : calendars.sql(6713) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK, REC_DATETIME INTO h_rank, h_deleted_datetime FROM TMT_CALENDARS
         WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(103) : calendars.sql(6734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      BEGIN
         UPDATE TMT_CALENDARS SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(122) : calendars.sql(6753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Execute Update Statement
   BEGIN
      SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(137) : calendars.sql(6768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Lock Tree
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CALENDARS SET
      REC_STATUS = 'U',
      REC_DATETIME = h_current_datetime,
      REC_USER = p_rec_user
      WHERE REC_DATETIME = PMO_ORASTD.DB2TIMESTAMP(h_deleted_datetime) AND RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 171+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(172) : calendars.sql(6803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UN_CAL', 177+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UN_CAL(178) : calendars.sql(6809) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 184+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(185) : calendars.sql(6816) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CAL', 196+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CAL(197) : calendars.sql(6828) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UN_CAL;
ALTER FUNCTION SP_UN_CAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CAL ==
CREATE OR REPLACE FUNCTION SP_S_CAL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_sql VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CAL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CAL(20) : calendars.sql(6864) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --  h_sql.strcpy(CAL_SELECT_STR);
   
   h_sql := 'SELECT TC.LEVEL_ID, TC.TYPE_ID, TC.RANK, TC.PARENT_ID, TC.ELEMENT_ID, TC.ELEMENT_NAME, '
          || '(TC.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CALENDARS WHERE PARENT_ID = TC.ELEMENT_ID AND TYPE_ID IN (0,';
   h_sql := h_sql || PMO_CNST.SC_STR_PROJECT_RESOURCE_TYPES;
   h_sql := h_sql || '))) AS CHILD_COUNT, '
          || 'TC.DELETED_COUNT, TC.REC_STATUS, TC.DESCRIPTION, TC.MINUTES_PER_DAY, TC.MINUTES_PER_WEEK, '
          || 'TC.MONDAY_STATUS, TC.TUESDAY_STATUS, TC.WEDNESDAY_STATUS, TC.THURSDAY_STATUS, TC.FRIDAY_STATUS, TC.SATURDAY_STATUS, TC.SUNDAY_STATUS, '
          || 'PMO_STPU.PRINT_TIMES(TC.MONDAY_BIT) AS MONDAY_BIT, PMO_STPU.PRINT_TIMES(TC.TUESDAY_BIT) AS TUESDAY_BIT, PMO_STPU.PRINT_TIMES(TC.WEDNESDAY_BIT) AS WEDNESDAY_BIT, '
          || 'PMO_STPU.PRINT_TIMES(TC.THURSDAY_BIT) AS THURSDAY_BIT, PMO_STPU.PRINT_TIMES(TC.FRIDAY_BIT) AS FRIDAY_BIT, '
          || 'PMO_STPU.PRINT_TIMES(TC.SATURDAY_BIT) AS SATURDAY_BIT, PMO_STPU.PRINT_TIMES(TC.SUNDAY_BIT) AS SUNDAY_BIT, '
          || 'TC.MONDAY_MIN, TC.TUESDAY_MIN, TC.WEDNESDAY_MIN, TC.THURSDAY_MIN, TC.FRIDAY_MIN, TC.SATURDAY_MIN, TC.SUNDAY_MIN, TC.WEEKLY_MIN, '
          || '0 AS BITFLAG, TC.START_DATE '
          || 'FROM TMT_CALENDARS TC ';
   
   -- Execute Select Statement
   If (p_id IS NULL) Then
      h_sql := h_sql || 'WHERE TC.PARENT_ID IS NULL ';
      h_sql := h_sql || 'AND TC.TYPE_ID NOT IN (0, ';
      h_sql := h_sql || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
      h_sql := h_sql || ', ';
      h_sql := h_sql || TO_CHAR(PMO_CNST.SC_RESOURCE);
      h_sql := h_sql || ') ';
      
      --if(!(IsNullSpParam(ind_s_cal, p_bitflag))  (*p_bitflag == 1))
      If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 1) Then
         h_sql := h_sql || 'AND TC.REC_STATUS NOT in (''A'', ''D'', ''L'') ';
      End If;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_CAL', 55+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_CAL(56) : calendars.sql(6900) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      If (p_bitflag IS NOT NULL) AND (Coalesce(p_bitflag, 0) = 2) Then
         h_sql := h_sql || 'WHERE TC.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' AND TC.REC_STATUS NOT in (''A'', ''D'', ''L'') ';
      Else
         h_sql := h_sql || 'WHERE (TC.PARENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''' OR TC.ELEMENT_ID = ''';
         h_sql := h_sql || h_id;
         h_sql := h_sql || ''') AND TC.TYPE_ID NOT IN (0, ';
         h_sql := h_sql || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
         h_sql := h_sql || ', ';
         h_sql := h_sql || TO_CHAR(PMO_CNST.SC_RESOURCE);
         h_sql := h_sql || ') ';
         --if( !(IsNullSpParam(ind_s_cal, p_bitflag))  (*p_bitflag == 1))
         If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 1) Then
            h_sql := h_sql || 'AND TC.REC_STATUS NOT in (''A'', ''D'', ''L'') ';
         End If;
      End If;
   End If;
   --h_sql.strcat(") AS RS ORDER BY RANK ");
   h_sql := h_sql || ' ORDER BY RANK ';
   --Return a resultset
   --        trace_printf(h_sql);//trace_flush();
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CAL(92) : calendars.sql(6936) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL', 94+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CAL(95) : calendars.sql(6939) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CAL', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CAL(102) : calendars.sql(6946) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CAL', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CAL(114) : calendars.sql(6958) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CAL;
ALTER FUNCTION SP_S_CAL COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_I_CAL_EXC ==
CREATE OR REPLACE FUNCTION SP_I_CAL_EXC
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CAL_EXC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CAL_EXC'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CAL_EXC(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CAL_EXC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CAL_EXC(23) : calendars.sql(7001) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent_id
   If (p_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_CAL_EXC', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_CAL_EXC(29) : calendars.sql(7007) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CAL_EXC', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_CAL_EXC(32) : calendars.sql(7010) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate parent_id
   BEGIN
      SELECT RANK INTO h_rank FROM TMT_CALENDARS WHERE ELEMENT_ID = p_parent_id AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL_EXC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL_EXC(48) : calendars.sql(7026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_CAL_EXC', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_CAL_EXC(55) : calendars.sql(7033) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_parent_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CAL_EXC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_CAL_EXC(58) : calendars.sql(7036) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_parent_id, True);
   End If;
   
   -- Get a unique id
   h_uniqueID := SYS_GUID();
   
   --Execute Insert Statement
   BEGIN
      INSERT INTO CALENDAR_EXCEPTIONS(EXCEPTION_ID, EXCEPTION_NAME, ELEMENT_TYPE, CALENDAR_ID, CALENDAR_RANK, REC_DATETIME, REC_USER)
      VALUES(h_uniqueID, p_name, p_type_id, p_parent_id, h_rank, SYSTIMESTAMP, p_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL_EXC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL_EXC(80) : calendars.sql(7058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CAL_EXC', 85+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CAL_EXC(86) : calendars.sql(7064) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL_EXC', 92+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL_EXC(93) : calendars.sql(7071) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CAL_EXC', 104+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CAL_EXC(105) : calendars.sql(7083) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CAL_EXC;
ALTER FUNCTION SP_I_CAL_EXC COMPILE DEBUG;

/****************************************************************************************
id = CALENDAR_EXCEPTION.exception_id
element_id = PROJECT OR RESOURCE ID
****************************************************************************************/

Prompt == FUNCTION SP_U_CAL_EXC ==
CREATE OR REPLACE FUNCTION SP_U_CAL_EXC
(
     p_id VARCHAR2
   , p_element_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CAL_EXC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CAL_EXC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CAL_EXC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_EXC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CAL_EXC(23) : calendars.sql(7125) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CAL_EXC', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CAL_EXC(29) : calendars.sql(7131) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_EXC', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_EXC(32) : calendars.sql(7134) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   -- Declare host variables
   
   -- Execute Update Statement
   BEGIN
      UPDATE CALENDAR_EXCEPTIONS SET
      ELEMENT_ID = p_element_id,
      EXCEPTION_NAME = p_name,
      EXCEPTION_DESCRIPTION = p_description,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE EXCEPTION_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC(57) : calendars.sql(7159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CAL_EXC', 62+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CAL_EXC(63) : calendars.sql(7165) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC', 69+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC(70) : calendars.sql(7172) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC', 81+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC(82) : calendars.sql(7184) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CAL_EXC;
ALTER FUNCTION SP_U_CAL_EXC COMPILE DEBUG;

/*************************************************************************************/

Prompt == FUNCTION SP_U_CAL_EXC_HOURS ==
CREATE OR REPLACE FUNCTION SP_U_CAL_EXC_HOURS
(
     p_id VARCHAR2
   , p_calendar_id VARCHAR2
   , p_exception_date VARCHAR2
   , p_day_week PLS_INTEGER
   , p_from1 VARCHAR2
   , p_to1 VARCHAR2
   , p_from2 VARCHAR2
   , p_to2 VARCHAR2
   , p_from3 VARCHAR2
   , p_to3 VARCHAR2
   , p_from4 VARCHAR2
   , p_to4 VARCHAR2
   , p_from5 VARCHAR2
   , p_to5 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_calendar_id VARCHAR2(32);
   h_exception_date DATE;
   h_from1 VARCHAR2(8);
   h_to1 VARCHAR2(8);
   h_from2 VARCHAR2(8);
   h_to2 VARCHAR2(8);
   h_from3 VARCHAR2(8);
   h_to3 VARCHAR2(8);
   h_from4 VARCHAR2(8);
   h_to4 VARCHAR2(8);
   h_from5 VARCHAR2(8);
   h_to5 VARCHAR2(8);
   h_available_min PLS_INTEGER := 0;
   h_day_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_pass PLS_INTEGER := 0;
   h_min PLS_INTEGER := 0;
   h_day_week PLS_INTEGER := 0;
   h_bit_available RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_rec_user VARCHAR2(32);
   h_alert_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CAL_EXC_HOURS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CAL_EXC_HOURS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CAL_EXC_HOURS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_calendar_id || ''''
          || ', ' || '''' || p_exception_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_day_week), 'NULL')
          || ', ' || '''' || p_from1 || ''''
          || ', ' || '''' || p_to1 || ''''
          || ', ' || '''' || p_from2 || ''''
          || ', ' || '''' || p_to2 || ''''
          || ', ' || '''' || p_from3 || ''''
          || ', ' || '''' || p_to3 || ''''
          || ', ' || '''' || p_from4 || ''''
          || ', ' || '''' || p_to4 || ''''
          || ', ' || '''' || p_from5 || ''''
          || ', ' || '''' || p_to5 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_EXC_HOURS', 68+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CAL_EXC_HOURS(69) : calendars.sql(7269) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If ((p_id IS NULL)) OR ((p_calendar_id IS NULL)) OR ((p_exception_date IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CAL_EXC_HOURS', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CAL_EXC_HOURS(75) : calendars.sql(7275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_EXC_HOURS', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_EXC_HOURS(78) : calendars.sql(7278) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate calendar_id
   h_calendar_id := p_calendar_id;
   h_day_week := p_day_week;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT
      RANK,
      CASE
      WHEN TYPE_ID = 27 THEN
      CASE
      WHEN h_day_week = 1 THEN SUNDAY_BIT
      WHEN h_day_week = 2 THEN MONDAY_BIT
      WHEN h_day_week = 3 THEN TUESDAY_BIT
      WHEN h_day_week = 4 THEN WEDNESDAY_BIT
      WHEN h_day_week = 5 THEN THURSDAY_BIT
      WHEN h_day_week = 6 THEN FRIDAY_BIT
      WHEN h_day_week = 7 THEN SATURDAY_BIT
      END
      ELSE
      CASE
      WHEN h_day_week = 0 THEN SUNDAY_BIT
      WHEN h_day_week = 1 THEN MONDAY_BIT
      WHEN h_day_week = 2 THEN TUESDAY_BIT
      WHEN h_day_week = 3 THEN WEDNESDAY_BIT
      WHEN h_day_week = 4 THEN THURSDAY_BIT
      WHEN h_day_week = 5 THEN FRIDAY_BIT
      WHEN h_day_week = 6 THEN SATURDAY_BIT
      END
      END,
      CASE
      WHEN TYPE_ID = 27 THEN
      CASE
      WHEN h_day_week = 1 THEN SUNDAY_MIN
      WHEN h_day_week = 2 THEN MONDAY_MIN
      WHEN h_day_week = 3 THEN TUESDAY_MIN
      WHEN h_day_week = 4 THEN WEDNESDAY_MIN
      WHEN h_day_week = 5 THEN THURSDAY_MIN
      WHEN h_day_week = 6 THEN FRIDAY_MIN
      WHEN h_day_week = 7 THEN SATURDAY_MIN
      END
      ELSE
      CASE
      WHEN h_day_week = 0 THEN SUNDAY_MIN
      WHEN h_day_week = 1 THEN MONDAY_MIN
      WHEN h_day_week = 2 THEN TUESDAY_MIN
      WHEN h_day_week = 3 THEN WEDNESDAY_MIN
      WHEN h_day_week = 4 THEN THURSDAY_MIN
      WHEN h_day_week = 5 THEN FRIDAY_MIN
      WHEN h_day_week = 6 THEN SATURDAY_MIN
      END
      END,
      TYPE_ID
      INTO h_rank, h_bit, h_min, h_type_id
      FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC_HOURS', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC_HOURS(146) : calendars.sql(7346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CAL_EXC_HOURS', 152+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CAL_EXC_HOURS(153) : calendars.sql(7353) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_calendar_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_EXC_HOURS', 155+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_EXC_HOURS(156) : calendars.sql(7356) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_calendar_id, True);
   End If;
   
   --fill time bits
   h_pass := 0;
   If ((p_from1 IS NOT NULL)) AND ((p_to1 IS NOT NULL)) Then
      h_pass := 1;
      h_from1 := p_from1;
      h_to1 := p_to1;
      PMO_STPU.filldayStruct(h_from1, h_to1, h_bit_available);
      
      If ((p_from2 IS NOT NULL)) AND ((p_to2 IS NOT NULL)) Then
         h_from2 := p_from2;
         h_to2 := p_to2;
         PMO_STPU.filldayStruct(h_from2, h_to2, h_bit_available);
         
         If ((p_from3 IS NOT NULL)) AND ((p_to3 IS NOT NULL)) Then
            h_from3 := p_from3;
            h_to3 := p_to3;
            PMO_STPU.filldayStruct(h_from3, h_to3, h_bit_available);
            
            If ((p_from4 IS NOT NULL)) AND ((p_to4 IS NOT NULL)) Then
               h_from4 := p_from4;
               h_to4 := p_to4;
               PMO_STPU.filldayStruct(h_from4, h_to4, h_bit_available);
               
               If ((p_from5 IS NOT NULL)) AND ((p_to5 IS NOT NULL)) Then
                  h_from5 := p_from5;
                  h_to5 := p_to5;
                  PMO_STPU.filldayStruct(h_from5, h_to5, h_bit_available);
               End If;
               -- end of shift 5
            End If;
            -- end of shift 5
         End If;
         -- end of shift 5
      End If;
      -- end of shift 5
   End If;
   -- end of shift 5
   h_available_min := PMO_STPU.getNumberOfBits(h_bit_available) * 5;
   
   If Coalesce(h_available_min, 0) > 0 Then
      --strcpy(h_day_status, "4");
      h_day_status := '4';
   Else
      --strcpy(h_day_status, "3");
      h_day_status := '3';
   End If;
   
   h_id := p_id;
   h_exception_date := p_exception_date;
   
   -- Execute Update Statement
   BEGIN
      UPDATE CALENDAR_EXCEPTIONS SET
      EXCEPTION_DATE = h_exception_date,
      DAY_STATUS = h_day_status,
      DEFAULT_BIT = h_bit,
      DEFAULT_MIN = h_min,
      EXCEPTION_BIT = h_bit_available,
      EXCEPTION_MIN = h_available_min,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE EXCEPTION_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC_HOURS', 232+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC_HOURS(233) : calendars.sql(7433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CAL_EXC_HOURS', 239+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CAL_EXC_HOURS(240) : calendars.sql(7440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CAL_EXC_HOURS', 242+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CAL_EXC_HOURS(243) : calendars.sql(7443) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   ElsIf PMO_ORASTD.strcmp(h_rec_user, h_calendar_id) = 0 Then
      -- Issue alert only for personal calendar but not project calendar
      h_alert_id := 'SCPERSONALCALENDARCHANGED';
      h_temp_var := 3;
      
      null_return := FC_ISSUE_ALERT(h_alert_id, h_id, h_rec_user, h_temp_var, 0);
   End If;
   
   PMO_DB2M.SC_STATE := fixExcCDOY(h_calendar_id, h_rank, h_exception_date, h_available_min
                                , h_bit_available);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CAL_EXC_HOURS', 257+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CAL_EXC_HOURS(258) : calendars.sql(7458) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC_HOURS', 264+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC_HOURS(265) : calendars.sql(7465) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CAL_EXC_HOURS', 276+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CAL_EXC_HOURS(277) : calendars.sql(7477) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CAL_EXC_HOURS;
ALTER FUNCTION SP_U_CAL_EXC_HOURS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_CAL_EXC ==
CREATE OR REPLACE FUNCTION SP_D_CAL_EXC
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_calendar_id VARCHAR2(32);
   h_dow PLS_INTEGER := 0;
   h_exception_date DATE;
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
   h_alert_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CAL_EXC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CAL_EXC'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CAL_EXC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL_EXC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CAL_EXC(30) : calendars.sql(7523) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parent id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_CAL_EXC', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_CAL_EXC(36) : calendars.sql(7529) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL_EXC', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL_EXC(39) : calendars.sql(7532) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   --SC_BITID(h_bit);
   
   h_calendar_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT RANK INTO h_rank FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL_EXC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL_EXC(59) : calendars.sql(7552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CAL_EXC', 65+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CAL_EXC(66) : calendars.sql(7559) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_calendar_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL_EXC', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL_EXC(69) : calendars.sql(7562) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_calendar_id, True);
   End If;
   
   h_id := p_id;
   BEGIN
      SELECT EXCEPTION_DATE, (PMO_ORASTD.DAYOFWEEK(EXCEPTION_DATE) - 1) INTO h_exception_date, h_dow
      FROM CALENDAR_EXCEPTIONS WHERE EXCEPTION_ID = h_id AND CALENDAR_ID = h_calendar_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL_EXC', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL_EXC(84) : calendars.sql(7577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_CAL_EXC', 90+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_CAL_EXC(91) : calendars.sql(7584) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CAL_EXC', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_CAL_EXC(94) : calendars.sql(7587) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If PMO_ORASTD.strcmp(h_rec_user, h_calendar_id) = 0 Then
      -- Issue alert only for personal calendar but not project calendar
      h_alert_id := 'SCPERSONALCALENDARCHANGED';
      h_temp_var := 3;
      
      null_return := FC_ISSUE_ALERT(h_alert_id, h_id, h_rec_user, h_temp_var, 0);
   End If;
   
   PMO_DB2M.SC_STATE := reFixExcCDOY(h_calendar_id, h_rank, h_dow, h_exception_date);
   
   If PMO_DB2M.SC_STATE = 0 Then
      BEGIN
         DELETE FROM CALENDAR_EXCEPTIONS WHERE EXCEPTION_ID = h_id AND CALENDAR_ID = h_calendar_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL_EXC', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL_EXC(122) : calendars.sql(7615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CAL_EXC', 128+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CAL_EXC(129) : calendars.sql(7622) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL_EXC', 135+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL_EXC(136) : calendars.sql(7629) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CAL_EXC', 147+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CAL_EXC(148) : calendars.sql(7641) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CAL_EXC;
ALTER FUNCTION SP_D_CAL_EXC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CAL_EXC ==
CREATE OR REPLACE FUNCTION SP_S_CAL_EXC
(
     p_calendar_id VARCHAR2
   , p_element_id VARCHAR2
   , p_start_date VARCHAR2
   , p_finish VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_calendar_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_start TIMESTAMP;
   h_finish TIMESTAMP;
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CAL_EXC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CAL_EXC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CAL_EXC(' || 
       '''' || p_calendar_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL_EXC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CAL_EXC(27) : calendars.sql(7684) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_calendar_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CAL_EXC', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CAL_EXC(35) : calendars.sql(7692) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL_EXC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CAL_EXC(38) : calendars.sql(7695) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_calendar_id := p_calendar_id;
   
   BEGIN
      SELECT RANK INTO h_rank FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CAL_EXC', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CAL_EXC(53) : calendars.sql(7710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CAL_EXC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CAL_EXC(60) : calendars.sql(7717) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_calendar_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL_EXC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CAL_EXC(63) : calendars.sql(7720) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_calendar_id, True);
   End If;
   
   -- Execute Select Statement
   /*  h_sql.strcpy("SELECT ELEMENT_ID, TYPE_ID, ELEMENT_NAME, EXCEPTION_DESCRIPTION, ELEMENT_TYPE, ORIGINAL_ID, ");
       h_sql.strcat("CALENDAR_ID, EXCEPTION_DATE, DAY_STATUS, DEFAULT_BIT, DEFAULT_MIN, EXCEPTION_BIT, EXCEPTION_MIN, ");
       h_sql.strcat("CALENDAR_RANK, REC_USER, REC_DATETIME ");
       h_sql.strcat("FROM (");
   */
   h_sql := 
         'SELECT EXCEPTION_ID AS ELEMENT_ID, 28 AS TYPE_ID, EXCEPTION_NAME AS ELEMENT_NAME, EXCEPTION_DESCRIPTION, ELEMENT_TYPE, ELEMENT_ID AS ORIGINAL_ID, ';
   h_sql := h_sql || 'CALENDAR_ID, EXCEPTION_DATE, CASE ';
   h_sql := h_sql || 'WHEN CALENDAR_ID = ''';
   h_sql := h_sql || h_calendar_id;
   h_sql := h_sql || ''' AND DAY_STATUS = ''3'' THEN ''5'' ';
   h_sql := h_sql || 'WHEN CALENDAR_ID = ''';
   h_sql := h_sql || h_calendar_id;
   h_sql := h_sql || ''' AND DAY_STATUS = ''4'' THEN ''6'' ';
   h_sql := h_sql || 'ELSE DAY_STATUS ';
   h_sql := h_sql || 
                  'END AS DAY_STATUS, PMO_STPU.PRINT_TIMES(DEFAULT_BIT) AS DEFAULT_BIT, DEFAULT_MIN, PMO_STPU.PRINT_TIMES(EXCEPTION_BIT) AS EXCEPTION_BIT, EXCEPTION_MIN, ';
   h_sql := h_sql || 'CALENDAR_RANK, REC_USER, REC_DATETIME ';
   h_sql := h_sql || 'FROM CALENDAR_EXCEPTIONS ';
   h_sql := h_sql || 'WHERE CALENDAR_RANK LIKE SUBSTR(''';
   h_sql := h_sql || h_rank;
   h_sql := h_sql || ''', 1, 8) || ''%%'' AND SUBSTR(''';
   h_sql := h_sql || h_rank;
   h_sql := h_sql || ''', 1, CASE WHEN LENGTH(CALENDAR_RANK) > LENGTH(''';
   h_sql := h_sql || h_rank;
   h_sql := h_sql || ''') THEN 1 ELSE LENGTH (CALENDAR_RANK) END) = CALENDAR_RANK ';
   
   h_sql := h_sql || 'AND (CALENDAR_RANK LIKE SUBSTR(''';
   h_sql := h_sql || h_rank;
   h_sql := h_sql || ''', 1, 8) || ''%'') ';
   
   If NOT ((p_element_id IS NULL)) Then
      h_element_id := p_element_id;
      h_sql := h_sql || 'AND ELEMENT_ID = ''';
      h_sql := h_sql || h_element_id;
      h_sql := h_sql || ''' ';
   End If;
   --comment by paria
   --if (!(IsNullSpParam(ind_s_cal_exc, start)))
   If NOT ((p_start_date IS NULL)) Then
      --comment by paria
      --InitializeHost(SC_PARAM(h_start), start, ind_s_cal_exc->start);
      h_start := p_start_date;
      h_sql := h_sql || 'AND EXCEPTION_DATE >= PMO_ORASTD.DB2DATE(''';
      h_sql := h_sql || h_start;
      h_sql := h_sql || ''') ';
   End If;
   
   If NOT ((p_finish IS NULL)) Then
      h_finish := p_finish;
      h_sql := h_sql || 'AND EXCEPTION_DATE <= PMO_ORASTD.DB2DATE(''';
      h_sql := h_sql || h_finish;
      h_sql := h_sql || ''') ';
   End If;
   
   --h_sql.strcat(") AS RS ORDER BY EXCEPTION_DATE ASC, CALENDAR_RANK DESC ");
   h_sql := h_sql || ' ORDER BY EXCEPTION_DATE ASC, CALENDAR_RANK DESC ';
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL_EXC', 127+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CAL_EXC(128) : calendars.sql(7785) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CAL_EXC', 130+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CAL_EXC(131) : calendars.sql(7788) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CAL_EXC', 138+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CAL_EXC(139) : calendars.sql(7796) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CAL_EXC', 150+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CAL_EXC(151) : calendars.sql(7808) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CAL_EXC;
ALTER FUNCTION SP_S_CAL_EXC COMPILE DEBUG;

