/****************************************************************************************/

Prompt == FUNCTION SP_I_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_I_CHARGECODE
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
   h_name VARCHAR2(100);
   h_rec_user VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CHARGECODE(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CHARGECODE', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CHARGECODE(32) : chargecodes.sql(35) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   h_billable := PMO_CNST.SC_BILLABLE_NO;
   
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   
   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CHARGECODES', h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_rankBase64 := h_rankBase64;
      
      BEGIN
         INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER, STAGE_ID)
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64, h_parent_id, h_uniqueID,
         h_name, h_type_id, LEVEL_ID + 1, h_rec_user, PMO_CNST.SC_CHARGECODE_DEFAULT_STAGE_ID
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CHARGECODE', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CHARGECODE(69) : chargecodes.sql(72) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_I_CHARGECODE', 74+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_I_CHARGECODE(75) : chargecodes.sql(78) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_rankBase64 := h_rankBase64;
      
      If PMO_ORASTD.strncmp(h_parent_id, 'SYSTEM_EXPENSE_FOLDER', 21) = 0 Then
         h_capital_expense := PMO_CNST.SC_EXPENSE_LABOR;
      ElsIf PMO_ORASTD.strncmp(h_parent_id, 'SYSTEM_CAPITAL_FOLDER', 21) = 0 Then
         h_capital_expense := PMO_CNST.SC_CAPITAL_LABOR;
      ElsIf PMO_ORASTD.strncmp(h_parent_id, 'SYSTEM_BENEFIT_FOLDER', 21) = 0 Then
         h_capital_expense := PMO_CNST.SC_BENEFIT_LABOR;
         h_billable := PMO_CNST.SC_BILLABLE_YES;
      Else
         h_capital_expense := PMO_CNST.SC_EXPENSE;
      End If;
      
      -- insert-select
      BEGIN
         INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, BILLABLE,
         ELEMENT_NAME, TYPE_ID, LEVEL_ID, CAPITAL_EXPENSE, REC_USER, STAGE_ID)
         SELECT
         RTRIM(Rank) || h_rankBase64, h_parent_id, h_uniqueID, h_billable,
         h_name, h_type_id, LEVEL_ID + 1, h_capital_expense, h_rec_user, PMO_CNST.SC_CHARGECODE_DEFAULT_STAGE_ID
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CHARGECODE', 119+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CHARGECODE(120) : chargecodes.sql(123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CHARGECODE', 126+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CHARGECODE(127) : chargecodes.sql(130) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CHARGECODE', 133+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CHARGECODE(134) : chargecodes.sql(137) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CHARGECODE', 145+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CHARGECODE(146) : chargecodes.sql(149) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CHARGECODE;
ALTER FUNCTION SP_I_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_CUSTOM_CC ==
CREATE OR REPLACE FUNCTION FC_I_CUSTOM_CC
(
     h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , h_external_identifier IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_element_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CUSTOM_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CUSTOM_CC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CUSTOM_CC(' || 
       '''' || h_uniqueID || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || '''' || h_external_identifier || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CC', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CUSTOM_CC(34) : chargecodes.sql(199) : ' || SYSTIMESTAMP);
   END IF; 

   -- can not create folder under custom charge code just we can create a change code
   h_type_id := PMO_CNST.SC_CHARGECODE;
   
   If ((h_stage_id IS NULL)) OR ((h_capital_expense IS NULL)) OR ((h_external_identifier IS NULL)) Then
      h_uniqueID := h_rec_user;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_CUSTOM_CC(43) : chargecodes.sql(208) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   --trace_printf("\n h_parent_id:%s:%d", h_parent_id);
   
   If (h_parent_id IS NULL) Then
      -- create all custom charge codes under custom folder
      h_parent_id := 'CUSTOM_CHARGE_CODES_FOLDER______';
   End If;
   
   h_uniqueID := h_external_identifier;
   -- update tmt_chargecodes for all elements with the same external reference
   BEGIN
      UPDATE TMT_CHARGECODES
      SET ELEMENT_NAME = h_name,
      STAGE_ID = h_stage_id,
      CAPITAL_EXPENSE = h_capital_expense,
      DESCRIPTION = h_description,
      REC_USER = h_rec_user
      WHERE EXTERNAL_IDENTIFIER = h_external_identifier;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CC(75) : chargecodes.sql(240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_uniqueID := SYS_GUID();
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_I_CUSTOM_CC', 83+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_I_CUSTOM_CC(84) : chargecodes.sql(249) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, False); 
      END;
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_rankBase64 := h_rankBase64;
      
      BEGIN
         INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, 
         TYPE_ID, LEVEL_ID, CAPITAL_EXPENSE, STAGE_ID, 
         EXTERNAL_IDENTIFIER, REC_USER, DESCRIPTION)
         SELECT
         RTRIM(RANK) || h_rankBase64, h_parent_id, h_uniqueID, h_name, 
         h_type_id, LEVEL_ID + 1, h_capital_expense, h_stage_id, 
         h_external_identifier, h_rec_user, h_description
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CC', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CC(119) : chargecodes.sql(284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CC', 124+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CUSTOM_CC(125) : chargecodes.sql(290) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CUSTOM_CC;
ALTER FUNCTION FC_I_CUSTOM_CC COMPILE DEBUG;

/****************************************************************************************/

-- this stored procedure is used for inserting/updating custom chargecode

-- this sp checks if any item with given external_identifier already exists then update that element

-- otherwise insert a new chargecode under charge code custome folder

--

-- contracts: following parameters can not be null

-- p_stage_id

-- p_capital_expense

-- p_external_identifier

--

-- the parent_id is null

Prompt == FUNCTION SP_I_CUSTOM_CC ==
CREATE OR REPLACE FUNCTION SP_I_CUSTOM_CC
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_capital_expense PLS_INTEGER
   , p_external_identifier VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_uniqueID VARCHAR2(32);
   h_name VARCHAR2(100);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_external_identifier VARCHAR2(32);
   h_description VARCHAR2(2048);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CUSTOM_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CUSTOM_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CUSTOM_CC(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_expense), 'NULL')
          || ', ' || '''' || p_external_identifier || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CUSTOM_CC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CUSTOM_CC(36) : chargecodes.sql(356) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_parent_id := p_parent_id;
   h_stage_id := p_stage_id;
   h_capital_expense := p_capital_expense;
   h_external_identifier := p_external_identifier;
   h_description := p_description;
   h_rec_user := p_rec_user;
   
   h_uniqueID := '';
   
   PMO_DB2M.SC_STATE := FC_I_CUSTOM_CC(h_uniqueID, h_name, h_parent_id, h_stage_id, h_capital_expense
                                    , h_external_identifier, h_description, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CUSTOM_CC', 52+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CUSTOM_CC(53) : chargecodes.sql(373) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CUSTOM_CC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CUSTOM_CC(60) : chargecodes.sql(380) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CUSTOM_CC', 71+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CUSTOM_CC(72) : chargecodes.sql(392) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CUSTOM_CC;
ALTER FUNCTION SP_I_CUSTOM_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_U_CHARGECODE
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_description VARCHAR2
   , p_capital_expense PLS_INTEGER
   , p_billable PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
   h_ass_cc_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_new_capital_expense PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
   h_new_billable PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_name VARCHAR2(100);
   h_rec_user VARCHAR2(32);
   h_description VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CHARGECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || COALESCE(TO_CHAR(p_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_billable), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CHARGECODE(37) : chargecodes.sql(445) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_name := p_name;
   h_description := p_description;
   h_new_capital_expense := p_capital_expense;
   h_new_billable := p_billable;
   
   -- Validate id
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CHARGECODE', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CHARGECODE(51) : chargecodes.sql(459) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(54) : chargecodes.sql(462) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS, CAPITAL_EXPENSE, ASSOCIATE_CHARGECODE_ID, BILLABLE
      INTO h_rec_status , h_capital_expense, h_ass_cc_id, h_billable
      FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGECODE', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGECODE(70) : chargecodes.sql(478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CHARGECODE', 76+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CHARGECODE(77) : chargecodes.sql(485) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 79+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(80) : chargecodes.sql(488) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CHARGECODE', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CHARGECODE(87) : chargecodes.sql(495) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(90) : chargecodes.sql(498) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True);
   End If;
   
   If (Coalesce(h_capital_expense, 0) = 2) AND ((Coalesce(h_new_capital_expense, 0) = 0) OR (Coalesce(
             h_new_capital_expense, 0) = 1)) AND ((h_ass_cc_id IS NOT NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CHARGECODE', 97+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CHARGECODE(98) : chargecodes.sql(506) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_CC_TYPE1), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 100+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(101) : chargecodes.sql(509) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_CC_TYPE1, h_id, True);
   End If;
   
   If (Coalesce(h_capital_expense, 0) = 0) AND (Coalesce(h_new_capital_expense, 0) = 2) 
             AND ((h_ass_cc_id IS NOT NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CHARGECODE', 108+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CHARGECODE(109) : chargecodes.sql(517) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_CC_TYPE3), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 111+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(112) : chargecodes.sql(520) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_CC_TYPE3, h_id, True);
   End If;
   
   If (Coalesce(h_capital_expense, 0) = 1) AND (Coalesce(h_new_capital_expense, 0) = 2) 
             AND ((h_ass_cc_id IS NOT NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CHARGECODE', 119+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CHARGECODE(120) : chargecodes.sql(528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_CC_TYPE2), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(123) : chargecodes.sql(531) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_CC_TYPE2, h_id, True);
   End If;
   
   h_count := 0;
   BEGIN
      SELECT COUNT(*) INTO h_count
      FROM DUAL
      WHERE EXISTS(SELECT CHARGECODE_ID FROM BUDGETS WHERE CHARGECODE_ID = h_id);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGECODE', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGECODE(139) : chargecodes.sql(547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(h_count, 0) > 0) AND ((Coalesce(h_capital_expense, 0) <> Coalesce(
             h_new_capital_expense, 0)) OR (Coalesce(h_billable, 0) <> Coalesce(
             h_new_billable, 0))) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CHARGECODE', 147+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CHARGECODE(148) : chargecodes.sql(556) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CHARGECODE_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CHARGECODE', 150+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CHARGECODE(151) : chargecodes.sql(559) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CHARGECODE_IS_USED, h_id, True);
   End If;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET ELEMENT_NAME=h_name,
      DESCRIPTION=h_description,
      CAPITAL_EXPENSE=h_new_capital_expense,
      BILLABLE = h_new_billable,
      REC_STATUS='U',
      REC_DATETIME=SYSTIMESTAMP,
      REC_USER=h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGECODE', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGECODE(176) : chargecodes.sql(584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CHARGECODE', 181+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CHARGECODE(182) : chargecodes.sql(590) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGECODE', 188+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGECODE(189) : chargecodes.sql(597) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CHARGECODE', 200+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CHARGECODE(201) : chargecodes.sql(609) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CHARGECODE;
ALTER FUNCTION SP_U_CHARGECODE COMPILE DEBUG;

/*************************************************************************************/

Prompt == FUNCTION SP_DF_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_DF_CHARGECODE
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DF_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DF_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_DF_CHARGECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DF_CHARGECODE', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DF_CHARGECODE(17) : chargecodes.sql(642) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_DF_CHARGECODE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_DF_CHARGECODE(21) : chargecodes.sql(646) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(0, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DF_CHARGECODE', 27+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DF_CHARGECODE(28) : chargecodes.sql(653) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DF_CHARGECODE', 39+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DF_CHARGECODE(40) : chargecodes.sql(665) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DF_CHARGECODE;
ALTER FUNCTION SP_DF_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

-- this procedure deletes a charge code or a chage code category,

-- contracts:

-- we can not remove a category or a charge code with external_identifier

-- we can not remove a category if it has a charge code with external_identifier as a child

-- we jusr support soft delete

Prompt == FUNCTION FC_D_CHARGECODE ==
CREATE OR REPLACE FUNCTION FC_D_CHARGECODE
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_ass_cc_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_default_count PLS_INTEGER := 0;
   h_dependency_count PLS_INTEGER := 0;
   h_current_datetime TIMESTAMP;
   h_external_identifier VARCHAR2(32);
   h_custom_cc_exists PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := FC_D_CHARGECODE(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CHARGECODE', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_CHARGECODE(28) : chargecodes.sql(719) : ' || SYSTIMESTAMP);
   END IF; 

   h_rec_status := h_del_flag;
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, ASSOCIATE_CHARGECODE_ID, REC_STATUS, EXTERNAL_IDENTIFIER
         INTO h_rank, h_ass_cc_id, h_rec_status, h_external_identifier
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 44+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(45) : chargecodes.sql(736) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, ASSOCIATE_CHARGECODE_ID, REC_STATUS, EXTERNAL_IDENTIFIER
         INTO h_rank, h_ass_cc_id, h_rec_status, h_external_identifier
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_id
         AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(62) : chargecodes.sql(753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CHARGECODE', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_CHARGECODE(70) : chargecodes.sql(761) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CHARGECODE', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_CHARGECODE(77) : chargecodes.sql(768) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   End If;
   
   If (h_external_identifier IS NOT NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CHARGECODE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_CHARGECODE(84) : chargecodes.sql(775) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_DELETE_CUSTOM_CHARGE_CO;
   Else
      -- check for children with external_identifier number
      If (h_parent_id IS NULL) Then
         h_custom_cc_exists := 0;
         BEGIN
            SELECT COUNT(*)
            INTO h_custom_cc_exists
            FROM TMT_CHARGECODES
            WHERE RANK LIKE h_rank || '%%'
            AND EXTERNAL_IDENTIFIER IS NOT Null;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 102+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(103) : chargecodes.sql(794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_custom_cc_exists, 0) > 0) AND ((h_custom_cc_exists IS NOT NULL)) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CHARGECODE', 109+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CHARGECODE(110) : chargecodes.sql(801) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_CUSTOM_CHARGE_CO;
         End If;
      End If;
   End If;
   
   -- Execute Delete Statement
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      BEGIN
         SELECT  ('D')  INTO  h_del_flag FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(127) : chargecodes.sql(818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_CHARGECODES 
         SET CHILD_COUNT = CHILD_COUNT - 1, 
         DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(149) : chargecodes.sql(840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CHARGECODES 
         SET CHILD_COUNT = CHILD_COUNT - 1, 
         DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(169) : chargecodes.sql(860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 182+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(183) : chargecodes.sql(874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CHARGECODES 
      SET REC_STATUS =  h_del_flag,                
      REC_DATETIME = h_current_datetime,
      REC_USER = h_rec_user,
      ASSOCIATE_CHARGECODE_ID = NULL
      WHERE RANK LIKE h_rank || '%'
      AND REC_STATUS IN ('I','U');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(219) : chargecodes.sql(910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET ASSOCIATE_CHARGECODE_ID = NULL
      WHERE ASSOCIATE_CHARGECODE_ID IN(
      SELECT ELEMENT_ID 
      FROM TMT_CHARGECODES
      WHERE RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 240+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(241) : chargecodes.sql(932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_ass_cc_id IS NOT NULL) Then
      BEGIN
         UPDATE TMT_CHARGECODES SET
         ASSOCIATE_CHARGECODE_ID = NuLL,
         REC_DATETIME            = h_current_datetime,
         REC_USER                = h_rec_user
         WHERE ASSOCIATE_CHARGECODE_ID = h_ass_cc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CHARGECODE', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CHARGECODE(263) : chargecodes.sql(954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CHARGECODE', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_CHARGECODE(274) : chargecodes.sql(965) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_CHARGECODE;
ALTER FUNCTION FC_D_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_D_CHARGECODE
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_del_flag VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CHARGECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CHARGECODE', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CHARGECODE(25) : chargecodes.sql(1000) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_parent_id := p_parent_id;
   h_del_flag := p_del_flag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_D_CHARGECODE(h_id, h_parent_id, h_del_flag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CHARGECODE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CHARGECODE(36) : chargecodes.sql(1011) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CHARGECODE', 42+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CHARGECODE(43) : chargecodes.sql(1018) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CHARGECODE', 54+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CHARGECODE(55) : chargecodes.sql(1030) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CHARGECODE;
ALTER FUNCTION SP_D_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UN_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_UN_CHARGECODE
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UN_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UN_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_UN_CHARGECODE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_CHARGECODE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UN_CHARGECODE(24) : chargecodes.sql(1070) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_UN_CHARGECODE', 28+1) THEN 
      LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_UN_CHARGECODE(29) : chargecodes.sql(1075) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   h_parent_id := p_parent_id;
   If ((p_parent_id IS NULL)) Then
      BEGIN
         SELECT RANK, REC_DATETIME 
         INTO h_rank, h_current_datetime 
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = p_id 
         AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(54) : chargecodes.sql(1100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CHARGECODES 
         SET CHILD_COUNT = CHILD_COUNT + 1, 
         DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(74) : chargecodes.sql(1120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_parent_id := p_parent_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_UN_CHARGECODE', 80+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_UN_CHARGECODE(81) : chargecodes.sql(1127) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      BEGIN
         SELECT RANK, REC_DATETIME 
         INTO h_rank, h_current_datetime 
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = p_id 
         AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(104) : chargecodes.sql(1150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         UPDATE TMT_CHARGECODES 
         SET CHILD_COUNT = CHILD_COUNT + 1, 
         DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(123) : chargecodes.sql(1169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CHARGECODES 
      SET REC_STATUS='U',
      REC_DATETIME=SYSTIMESTAMP,
      REC_USER = p_rec_user
      WHERE REC_DATETIME = h_current_datetime 
      AND RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 158+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(159) : chargecodes.sql(1205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UN_CHARGECODE', 164+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UN_CHARGECODE(165) : chargecodes.sql(1211) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 171+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(172) : chargecodes.sql(1218) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_CHARGECODE', 183+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_CHARGECODE(184) : chargecodes.sql(1230) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UN_CHARGECODE;
ALTER FUNCTION SP_UN_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_S_CHARGECODE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_str VARCHAR2(49);
   h_xsql VARCHAR2(4000);
   h_default_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CHARGECODE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CHARGECODE', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CHARGECODE(23) : chargecodes.sql(1269) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
   h_xsql := h_xsql || 'CASE WHEN T.TYPE_ID IN (';
   h_xsql := h_xsql || TO_CHAR(PMO_CNST.SC_CHARGECODE);
   h_xsql := h_xsql || ', 113) THEN 0 ELSE T.CHILD_COUNT END AS CHILD_COUNT, ';
   h_xsql := h_xsql || 'T.DELETED_COUNT, T.CAPITAL_EXPENSE, ';
   h_xsql := h_xsql || 'T.REC_STATUS, T.DESCRIPTION, T.ASSOCIATE_CHARGECODE_ID, T.BILLABLE, ';
   h_xsql := h_xsql || 
                    'T2.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME , T2.BILLABLE AS ASSOCIATE_BILLABLE, T2.CAPITAL_EXPENSE as ASSOCIATE_CAPITAL_EXPENSE, ';
   h_xsql := h_xsql || 
                    ' case when T.TYPE_ID = 64 THEN 0 ELSE T.STAGE_ID END AS STAGE_ID, case when T.TYPE_ID = 64 THEN '''' ELSE T.EXTERNAL_IDENTIFIER END AS EXTERNAL_IDENTIFIER ';
   h_xsql := h_xsql || 
                    'FROM TMT_CHARGECODES T LEFT JOIN TMT_CHARGECODES T2 ON T.ASSOCIATE_CHARGECODE_ID = T2.ELEMENT_ID ';
   If ((p_id IS NULL)) Then
      h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
      h_temp_str := 'AND T.TYPE_ID IN (' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' , ' 
              || TO_CHAR(PMO_CNST.SC_CHARGECODE) || ') ';
      h_xsql := h_xsql || h_temp_str;
      h_xsql := h_xsql || 'AND T.REC_STATUS NOT IN (''D'', ''L'', ''A'') ';
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_CHARGECODE', 48+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_CHARGECODE(49) : chargecodes.sql(1295) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      If Coalesce(p_bitflag, 0) = PMO_CNST.SC_REFRESH Then
         h_xsql := h_xsql || 'WHERE T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      Else
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
         h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         
         h_temp_str := 'AND T.TYPE_ID IN (' || TO_CHAR(PMO_CNST.SC_FOLDER) || ' , ' 
               || TO_CHAR(PMO_CNST.SC_CHARGECODE) || ') ';
      End If;
   End If;
   
   h_xsql := h_xsql || 'ORDER BY RANK ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CHARGECODE', 81+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CHARGECODE(82) : chargecodes.sql(1328) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CHARGECODE', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CHARGECODE(85) : chargecodes.sql(1331) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CHARGECODE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CHARGECODE(92) : chargecodes.sql(1338) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CHARGECODE', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CHARGECODE(104) : chargecodes.sql(1350) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CHARGECODE;
ALTER FUNCTION SP_S_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CB_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_CB_CHARGECODE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   z_task_flag PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
-- Declare Cursors
      CURSOR CC_A IS
         SELECT ELEMENT_ID 
         FROM TMT_CHARGECODES
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

      CURSOR CC_B IS
         SELECT ELEMENT_ID FROM TMT_CHARGECODES
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_project_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CB_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CB_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_CB_CHARGECODE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_CHARGECODE', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CB_CHARGECODE(32) : chargecodes.sql(1398) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CB_CHARGECODE', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CB_CHARGECODE(37) : chargecodes.sql(1403) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_CHARGECODE', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CB_CHARGECODE(40) : chargecodes.sql(1406) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   BEGIN
      SELECT TYPE_ID, PROJECT_ID 
      INTO h_type_id, h_project_id 
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id 
      AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_CHARGECODE', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_CHARGECODE(61) : chargecodes.sql(1427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CB_CHARGECODE', 67+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CB_CHARGECODE(68) : chargecodes.sql(1434) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_CHARGECODE', 70+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CB_CHARGECODE(71) : chargecodes.sql(1437) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_UNAVAILABLE, p_id, True);
   End If;
   
   h_sql := 'SELECT T.ELEMENT_ID, T.ELEMENT_NAME FROM TMT_CHARGECODES T ';
   
   OPEN CC_A;
   
   FETCH CC_A INTO h_exists;
   IF CC_A%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      z_task_flag := 1;
   Else
      z_task_flag := 0;
   End If;
   
   BEGIN
      CLOSE CC_A ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_CHARGECODE', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_CHARGECODE(101) : chargecodes.sql(1467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(z_task_flag, 0) = 1 Then
      h_sql := h_sql || 
                  'WHERE T.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_CHARGECODES WHERE ELEMENT_ID = ''';
      h_sql := h_sql || h_id;
      h_sql := h_sql || ''' AND T.TYPE_ID IN (';
      h_sql := h_sql || TO_CHAR(PMO_CNST.SC_CHARGECODE);
      h_sql := h_sql || ', ';
      h_sql := h_sql || TO_CHAR(PMO_CNST.SC_FOLDER);
      h_sql := h_sql || ') ';
   Else
      If isNotProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         OPEN CC_B;
         
         FETCH CC_B INTO h_exists;
         IF CC_B%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_sql := h_sql || 
                  'WHERE T.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_CHARGECODES WHERE ELEMENT_ID = ''';
            h_sql := h_sql || h_project_id;
            h_sql := h_sql || ''' AND T.TYPE_ID IN (';
            h_sql := h_sql || TO_CHAR(PMO_CNST.SC_CHARGECODE);
            h_sql := h_sql || ', ';
            h_sql := h_sql || TO_CHAR(PMO_CNST.SC_FOLDER);
            h_sql := h_sql || ') ';
         End If;
         
         BEGIN
            CLOSE CC_B ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_CHARGECODE', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_CHARGECODE(145) : chargecodes.sql(1511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_sql := h_sql || 'WHERE 1 = 2 ';
      End If;
   End If;
   h_sql := h_sql || 'ORDER BY T.RANK ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_CHARGECODE', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CB_CHARGECODE(156) : chargecodes.sql(1522) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CB_CHARGECODE', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CB_CHARGECODE(159) : chargecodes.sql(1525) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_CHARGECODE', 166+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_CHARGECODE(167) : chargecodes.sql(1533) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CB_CHARGECODE', 178+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CB_CHARGECODE(179) : chargecodes.sql(1545) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CB_CHARGECODE;
ALTER FUNCTION SP_CB_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_AVAILABLE_CC ==
CREATE OR REPLACE FUNCTION SP_AVAILABLE_CC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_AVAIL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_AVAILABLE_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_AVAILABLE_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_AVAILABLE_CC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAILABLE_CC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_AVAILABLE_CC(30) : chargecodes.sql(1591) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_AVAILABLE_CC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_AVAILABLE_CC(38) : chargecodes.sql(1599) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAILABLE_CC', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_AVAILABLE_CC(41) : chargecodes.sql(1602) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      BEGIN
         SELECT RTRIM(RANK) INTO h_rank
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAILABLE_CC', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAILABLE_CC(59) : chargecodes.sql(1620) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN SELECT_READ2 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION, T1.BILLABLE , T1.CAPITAL_EXPENSE,
      T1.ASSOCIATE_CHARGECODE_ID, T2.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME,
      T2.BILLABLE AS ASSOCIATE_BILLABLE, T2.CAPITAL_EXPENSE as ASSOCIATE_CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T1
      LEFT JOIN TMT_CHARGECODES T2 ON T2.ELEMENT_ID = T1.ASSOCIATE_CHARGECODE_ID
      WHERE T1.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, case when LENGTH(T1.RANK)>LENGTH(h_rank) then 1 else LENGTH(T1.RANK) end) = T1.RANK
      AND T1.TYPE_ID IN (PMO_CNST.SC_CHARGECODE, PMO_CNST.SC_FOLDER)
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAILABLE_CC', 75+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_AVAILABLE_CC(76) : chargecodes.sql(1637) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ2;
   Else
      If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 3) Then
         BEGIN
            SELECT PROJECT_ID INTO h_project_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAILABLE_CC', 90+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAILABLE_CC(91) : chargecodes.sql(1652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT PROJECT_ID INTO h_project_id
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAILABLE_CC', 105+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAILABLE_CC(106) : chargecodes.sql(1667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN SELECT_AVAIL FOR SELECT  C.LEVEL_ID, C.TYPE_ID, C.RANK, C.PARENT_ID, C.ELEMENT_ID, C.ELEMENT_NAME,
      CASE WHEN C.PARENT_ID IS NULL THEN 0 ELSE 1 END AS CHILD_COUNT,
      C.DELETED_COUNT, C.REC_STATUS, C.DESCRIPTION,
      C.BILLABLE, C.CAPITAL_EXPENSE, C.ASSOCIATE_CHARGECODE_ID,
      T3.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME,
      T3.BILLABLE AS ASSOCIATE_BILLABLE,
      T3.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE
      FROM BUDGETS B
      JOIN TMT_CHARGECODES C
      ON C.ELEMENT_ID = B.CHARGECODE_ID
      AND C.ELEMENT_ID <> 'PMO_PROJECT_TIMEPHASE_CALENDAR__'
      LEFT JOIN TMT_CHARGECODES T3
      ON C.ASSOCIATE_CHARGECODE_ID = T3.ELEMENT_ID
      WHERE B.PROJECT_ID = h_project_id
      AND B.ELEMENT_ID = h_project_id
      ORDER BY C.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_AVAILABLE_CC', 128+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_AVAILABLE_CC(129) : chargecodes.sql(1690) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_AVAIL;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAILABLE_CC', 137+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAILABLE_CC(138) : chargecodes.sql(1699) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_AVAILABLE_CC', 149+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_AVAILABLE_CC(150) : chargecodes.sql(1711) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_AVAILABLE_CC;
ALTER FUNCTION SP_AVAILABLE_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_CC_WBS ==
CREATE OR REPLACE FUNCTION SP_A_CC_WBS
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_type_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_CC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_CC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_A_CC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_WBS', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_CC_WBS(26) : chargecodes.sql(1753) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_element_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CC_WBS', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CC_WBS(31) : chargecodes.sql(1758) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_WBS', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CC_WBS(34) : chargecodes.sql(1761) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_A_CC_WBS', 40+1) THEN 
      LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_A_CC_WBS(41) : chargecodes.sql(1768) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_WBS
      WHERE ELEMENT_ID = p_element_id
      AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_WBS', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_WBS(62) : chargecodes.sql(1789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CC_WBS', 68+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CC_WBS(69) : chargecodes.sql(1796) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_WBS', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CC_WBS(72) : chargecodes.sql(1799) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_exists FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = p_element_id AND PARENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_WBS', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_WBS(86) : chargecodes.sql(1813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CC_WBS', 92+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CC_WBS(93) : chargecodes.sql(1820) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_WBS', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CC_WBS(96) : chargecodes.sql(1823) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, True);
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_id, h_max_rank);
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
      SELECT RTRIM(Rank) || h_rankBase64, p_id, p_element_id, h_type_id, LEVEL_ID + 1, p_rec_user
      FROM TMT_CHARGECODES 
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_WBS', 119+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_WBS(120) : chargecodes.sql(1847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_CC_WBS', 125+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_CC_WBS(126) : chargecodes.sql(1853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_WBS', 132+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_WBS(133) : chargecodes.sql(1860) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_WBS', 144+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_WBS(145) : chargecodes.sql(1872) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_CC_WBS;
ALTER FUNCTION SP_A_CC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_CC_WBS ==
CREATE OR REPLACE FUNCTION SP_UA_CC_WBS
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_CC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_CC_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_CC_WBS(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CC_WBS', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_CC_WBS(21) : chargecodes.sql(1909) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   
   BEGIN
      SELECT PROJECT_ID INTO h_project_id
      FROM TMT_WBS WHERE ELEMENT_ID = p_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_WBS', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_WBS(35) : chargecodes.sql(1923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT BUDGET_ID INTO h_id FROM BUDGETS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = p_element_id
      AND CHARGECODE_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_WBS', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_WBS(51) : chargecodes.sql(1939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UA_CC_WBS', 57+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UA_CC_WBS(58) : chargecodes.sql(1946) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CC_WBS', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_CC_WBS(61) : chargecodes.sql(1949) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
   End If;
   
   BEGIN
      DELETE FROM TMT_CHARGECODES
      WHERE PARENT_ID = p_id 
      AND ELEMENT_ID = p_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_WBS', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_WBS(80) : chargecodes.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE TMT_CHARGECODES 
         SET CHILD_COUNT = CHILD_COUNT - 1 
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_WBS', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_WBS(100) : chargecodes.sql(1988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_CC_WBS', 106+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_CC_WBS(107) : chargecodes.sql(1995) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_WBS', 113+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_WBS(114) : chargecodes.sql(2002) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_WBS', 125+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_WBS(126) : chargecodes.sql(2014) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_CC_WBS;
ALTER FUNCTION SP_UA_CC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_WBS_A_CC ==
CREATE OR REPLACE FUNCTION SP_S_WBS_A_CC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ4 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ5 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WBS_A_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WBS_A_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WBS_A_CC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_CC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WBS_A_CC(28) : chargecodes.sql(2058) : ' || SYSTIMESTAMP);
   END IF; 

   /*
       note:
       According to Richard, BMS is filtering chargecodes at project and task levels.
       Therefore, at task level, we won't see the available chargecodes at project level,
       unless it is again, assign at task level as available (From the prject level available chargecodes).
   
       e.g.
   
       System level
       100 chargecodes
   
       project level
       10 chargecodes from the System(100 chargecodes)
   
       task level
       5 chargecodes from the Project(10 chargecodes)
       */
   
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WBS_A_CC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WBS_A_CC(51) : chargecodes.sql(2081) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_CC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_CC(54) : chargecodes.sql(2084) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   BEGIN
      SELECT TYPE_ID INTO h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_CC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_CC(71) : chargecodes.sql(2101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If isNotProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      BEGIN
         SELECT PROJECT_ID INTO h_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_CC', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_CC(87) : chargecodes.sql(2117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      BEGIN
         SELECT RTRIM(RANK) INTO h_rank
         FROM TMT_CHARGECODES WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_CC', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_CC(103) : chargecodes.sql(2133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN SELECT_READ4 FOR SELECT
      T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION, T1.BILLABLE, T1.CAPITAL_EXPENSE,
      T1.ASSOCIATE_CHARGECODE_ID, T2.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME,
      T2.BILLABLE AS ASSOCIATE_BILLABLE, T2.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T1
      LEFT JOIN TMT_CHARGECODES T2
      ON T1.ASSOCIATE_CHARGECODE_ID = T2.ELEMENT_ID
      WHERE T1.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(T1.RANK)) = T1.RANK
      AND T1.TYPE_ID IN (PMO_CNST.SC_CHARGECODE , PMO_CNST.SC_FOLDER)
      AND T1.REC_STATUS <> 'D'
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_CC', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_CC(123) : chargecodes.sql(2153) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ4;
   Else
      OPEN SELECT_READ5 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION, T1.BILLABLE, T1.CAPITAL_EXPENSE,
      T1.ASSOCIATE_CHARGECODE_ID,T2.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME,
      T2.BILLABLE AS ASSOCIATE_BILLABLE, T2.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T
      JOIN TMT_CHARGECODES T1
      ON T1.ELEMENT_ID = T.PARENT_ID
      LEFT JOIN TMT_CHARGECODES T2
      ON T1.ASSOCIATE_CHARGECODE_ID = T2.ELEMENT_ID
      WHERE T.ELEMENT_ID = h_id
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_CC', 139+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_CC(140) : chargecodes.sql(2170) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ5;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_CC', 148+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_CC(149) : chargecodes.sql(2179) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_CC', 160+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_CC(161) : chargecodes.sql(2191) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WBS_A_CC;
ALTER FUNCTION SP_S_WBS_A_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_CC_CRI ==
CREATE OR REPLACE FUNCTION SP_A_CC_CRI
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_type_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_CC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_CC_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_A_CC_CRI(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_CRI', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_CC_CRI(26) : chargecodes.sql(2233) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_id IS NULL)) OR ((p_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CC_CRI', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CC_CRI(31) : chargecodes.sql(2238) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_CRI', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CC_CRI(34) : chargecodes.sql(2241) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_A_CC_CRI', 40+1) THEN 
      LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_A_CC_CRI(41) : chargecodes.sql(2248) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CHARGECODES' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CHARGECODES' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT TYPE_ID 
      INTO h_type_id 
      FROM TMT_CRI
      WHERE ELEMENT_ID = p_element_id
      AND REC_STATUS IN ('I', 'U', 'O');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_CRI', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_CRI(64) : chargecodes.sql(2271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CC_CRI', 70+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CC_CRI(71) : chargecodes.sql(2278) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_CRI', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CC_CRI(74) : chargecodes.sql(2281) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   BEGIN
      SELECT ELEMENT_ID 
      INTO h_exists 
      FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = p_element_id 
      AND PARENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_CRI', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_CRI(91) : chargecodes.sql(2298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CC_CRI', 97+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CC_CRI(98) : chargecodes.sql(2305) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CC_CRI', 100+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CC_CRI(101) : chargecodes.sql(2308) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, True);
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CHARGECODES(RANK, PARENT_ID, ELEMENT_ID, TYPE_ID, LEVEL_ID, REC_USER)
      SELECT RTRIM(Rank) || h_rankBase64, p_id, p_element_id, h_type_id, LEVEL_ID + 1, p_rec_user
      FROM TMT_CHARGECODES 
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_CRI', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_CRI(124) : chargecodes.sql(2331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_CC_CRI', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_CC_CRI(130) : chargecodes.sql(2337) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_CRI', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_CRI(137) : chargecodes.sql(2344) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CC_CRI', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CC_CRI(149) : chargecodes.sql(2356) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_CC_CRI;
ALTER FUNCTION SP_A_CC_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_CC_CRI ==
CREATE OR REPLACE FUNCTION SP_UA_CC_CRI
(
     p_element_id VARCHAR2
   , p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_CC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_CC_CRI'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_CC_CRI(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CC_CRI', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_CC_CRI(20) : chargecodes.sql(2392) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   BEGIN
      DELETE FROM TMT_CHARGECODES
      WHERE PARENT_ID = p_id 
      AND ELEMENT_ID = p_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_CRI', 37+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_CRI(38) : chargecodes.sql(2410) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE TMT_CHARGECODES 
         SET CHILD_COUNT = CHILD_COUNT - 1 
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_CRI', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_CRI(58) : chargecodes.sql(2430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_CC_CRI', 64+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_CC_CRI(65) : chargecodes.sql(2437) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_CRI', 71+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_CRI(72) : chargecodes.sql(2444) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CC_CRI', 83+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CC_CRI(84) : chargecodes.sql(2456) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_CC_CRI;
ALTER FUNCTION SP_UA_CC_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CRI_A_CC ==
CREATE OR REPLACE FUNCTION SP_S_CRI_A_CC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_type_id PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_READ6 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_READ7 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CRI_A_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CRI_A_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CRI_A_CC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_CC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CRI_A_CC(28) : chargecodes.sql(2500) : ' || SYSTIMESTAMP);
   END IF; 

   /*
       note:
       According to Richard, BMS is filtering chargecodes at project and task levels.
       Therefore, at task level, we won't see the available chargecodes at project level,
       unless it is again, assign at task level as available (From the prject level available chargecodes).
   
       e.g.
   
       System level
       100 chargecodes
   
       project level
       10 chargecodes from the System(100 chargecodes)
   
       task level
       5 chargecodes from the Project(10 chargecodes)  */
   
   -------------------------
   
   -- Execute Select Statement
   If ((p_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CRI_A_CC', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CRI_A_CC(53) : chargecodes.sql(2525) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_CC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_CC(56) : chargecodes.sql(2528) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   BEGIN
      SELECT TYPE_ID, RTRIM(RANK) 
      INTO h_type_id, h_rank
      FROM TMT_CRI 
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_CC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_CC(71) : chargecodes.sql(2543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_id := p_id;
   
   If isNotProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      --------------------------------
      BEGIN
         SELECT PROJECT_ID 
         INTO h_id 
         FROM TMT_CRI 
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_CC', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_CC(91) : chargecodes.sql(2563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   If (NOT ((p_bitflag IS NULL))) AND (Coalesce(p_bitflag, 0) = 2) Then
      OPEN SELECT_READ6 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      CASE WHEN T1.LEVEL_ID = 0 THEN 0 ELSE 1 END AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION , T1.CAPITAL_EXPENSE ,
      T1.ASSOCIATE_CHARGECODE_ID,T2.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME , T2.BILLABLE AS ASSOCIATE_BILLABLE, T2.CAPITAL_EXPENSE as ASSOCIATE_CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T1 
      LEFT JOIN TMT_CHARGECODES T2 ON T1.ASSOCIATE_CHARGECODE_ID = T2.ELEMENT_ID
      WHERE T1.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(T1.RANK)) = T1.RANK
      AND T1.ELEMENT_ID NOT LIKE  '%LABOR%'
      AND T1.TYPE_ID IN (PMO_CNST.SC_CHARGECODE, PMO_CNST.SC_FOLDER)
      AND T1.REC_STATUS <> 'D'
      ORDER BY T1.RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_CC', 109+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_CC(110) : chargecodes.sql(2582) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ6;
   Else
      OPEN SELECT_READ7 FOR SELECT T1.LEVEL_ID, T1.TYPE_ID, T1.RANK, T1.PARENT_ID, T1.ELEMENT_ID, T1.ELEMENT_NAME,
      1 AS CHILD_COUNT,
      T1.DELETED_COUNT, T1.REC_STATUS, T1.DESCRIPTION, T1.CAPITAL_EXPENSE ,
      T1.ASSOCIATE_CHARGECODE_ID,T2.ELEMENT_NAME AS ASSOCIATE_CHARGECODE_NAME , T2.BILLABLE AS ASSOCIATE_BILLABLE, T2.CAPITAL_EXPENSE as ASSOCIATE_CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T1 LEFT JOIN TMT_CHARGECODES T2 ON T1.ASSOCIATE_CHARGECODE_ID = T2.ELEMENT_ID
      WHERE T1.ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = h_id)
      AND T1.ELEMENT_ID NOT LIKE  '%LABOR%'
      AND T1.REC_STATUS in ('I', 'U', 'O')
      ORDER BY T1.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_CC', 124+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_CC(125) : chargecodes.sql(2597) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_READ7;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_CC', 132+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_CC(133) : chargecodes.sql(2605) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_CC', 144+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_CC(145) : chargecodes.sql(2617) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CRI_A_CC;
ALTER FUNCTION SP_S_CRI_A_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_AVAILABLE_ASS_CC ==
CREATE OR REPLACE FUNCTION SP_S_AVAILABLE_ASS_CC
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_AVAIL_EXP PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_AVAIL_CAP PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_AVAIL_BEN PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_AVAIL_ELI PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_AVAILABLE_ASS_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_AVAILABLE_ASS_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_AVAILABLE_ASS_CC(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_AVAILABLE_ASS_CC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_AVAILABLE_ASS_CC(31) : chargecodes.sql(2664) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(p_bitflag, 0) = PMO_CNST.SC_EXPENSE Then
      --trace_printf("\n C_AVAIL_EXP \n");
      
      OPEN C_AVAIL_EXP FOR SELECT T1.ELEMENT_ID, T1.ELEMENT_NAME
      FROM TMT_CHARGECODES T1
      WHERE T1.CAPITAL_EXPENSE IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_ELIMINATION)
      AND TYPE_ID = PMO_CNST.SC_CHARGECODE
      AND REC_STATUS <> 'D'
      AND NOT EXISTS (SELECT ASSOCIATE_CHARGECODE_ID
      FROM TMT_CHARGECODES T2
      WHERE T2.ASSOCIATE_CHARGECODE_ID = T1.ELEMENT_ID)
      ORDER BY T1.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_AVAILABLE_ASS_CC', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_AVAILABLE_ASS_CC(47) : chargecodes.sql(2680) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_AVAIL_EXP;
   ElsIf Coalesce(p_bitflag, 0) = PMO_CNST.SC_CAPITAL Then
      --trace_printf("\n C_AVAIL_CAP \n");
      
      OPEN C_AVAIL_CAP FOR SELECT T1.ELEMENT_ID, T1.ELEMENT_NAME
      FROM TMT_CHARGECODES T1
      WHERE T1.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT
      AND TYPE_ID = PMO_CNST.SC_CHARGECODE
      AND REC_STATUS <> 'D'
      AND NOT EXISTS (SELECT ASSOCIATE_CHARGECODE_ID
      FROM TMT_CHARGECODES T2
      WHERE T2.ASSOCIATE_CHARGECODE_ID = T1.ELEMENT_ID)
      ORDER BY T1.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_AVAILABLE_ASS_CC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_AVAILABLE_ASS_CC(63) : chargecodes.sql(2696) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_AVAIL_CAP;
   ElsIf Coalesce(p_bitflag, 0) = PMO_CNST.SC_BENEFIT Then
      --trace_printf("\n C_AVAIL_BEN \n");
      
      OPEN C_AVAIL_BEN FOR SELECT T1.ELEMENT_ID, T1.ELEMENT_NAME
      FROM TMT_CHARGECODES T1
      WHERE T1.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      AND TYPE_ID = PMO_CNST.SC_CHARGECODE
      AND REC_STATUS <> 'D'
      AND NOT EXISTS (SELECT ASSOCIATE_CHARGECODE_ID
      FROM TMT_CHARGECODES T2
      WHERE T2.ASSOCIATE_CHARGECODE_ID = T1.ELEMENT_ID)
      ORDER BY T1.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_AVAILABLE_ASS_CC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_AVAILABLE_ASS_CC(79) : chargecodes.sql(2712) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_AVAIL_BEN;
   ElsIf Coalesce(p_bitflag, 0) = PMO_CNST.SC_ELIMINATION Then
      --trace_printf("\n C_AVAIL_ELI \n");
      
      OPEN C_AVAIL_ELI FOR SELECT T1.ELEMENT_ID, T1.ELEMENT_NAME
      FROM TMT_CHARGECODES T1
      WHERE T1.CAPITAL_EXPENSE = PMO_CNST.SC_EXPENSE
      AND TYPE_ID = PMO_CNST.SC_CHARGECODE
      AND REC_STATUS <> 'D'
      AND NOT EXISTS (SELECT ASSOCIATE_CHARGECODE_ID
      FROM TMT_CHARGECODES T2
      WHERE T2.ASSOCIATE_CHARGECODE_ID = T1.ELEMENT_ID)
      ORDER BY T1.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_AVAILABLE_ASS_CC', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_AVAILABLE_ASS_CC(95) : chargecodes.sql(2728) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_AVAIL_ELI;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_AVAILABLE_ASS_CC', 99+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_AVAILABLE_ASS_CC(100) : chargecodes.sql(2733) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_AVAILABLE_ASS_CC', 102+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_AVAILABLE_ASS_CC(103) : chargecodes.sql(2736) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_AVAILABLE_ASS_CC', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_AVAILABLE_ASS_CC(112) : chargecodes.sql(2745) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_AVAILABLE_ASS_CC', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_AVAILABLE_ASS_CC(124) : chargecodes.sql(2757) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_AVAILABLE_ASS_CC;
ALTER FUNCTION SP_S_AVAILABLE_ASS_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_ASS_CC ==
CREATE OR REPLACE FUNCTION SP_U_ASS_CC
(
     p_id VARCHAR2
   , p_associate_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_ass_cc_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ASS_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ASS_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ASS_CC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_associate_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASS_CC', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ASS_CC(22) : chargecodes.sql(2795) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_ASS_CC', 26+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_ASS_CC(27) : chargecodes.sql(2800) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASS_CC', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASS_CC(30) : chargecodes.sql(2803) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   BEGIN
      SELECT CAPITAL_EXPENSE, ASSOCIATE_CHARGECODE_ID
      INTO h_capital_expense, h_ass_cc_id
      FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(48) : chargecodes.sql(2821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASS_CC', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASS_CC(55) : chargecodes.sql(2828) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASS_CC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASS_CC(58) : chargecodes.sql(2831) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      UPDATE TMT_CHARGECODES SET
      ASSOCIATE_CHARGECODE_ID = NULL
      WHERE ELEMENT_ID = h_ass_cc_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(77) : chargecodes.sql(2850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT ELEMENT_ID INTO h_id
      FROM TMT_CHARGECODES
      WHERE ASSOCIATE_CHARGECODE_ID = p_associate_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 91+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(92) : chargecodes.sql(2865) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_ASS_CC', 98+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_ASS_CC(99) : chargecodes.sql(2872) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_ASSIGNED), 'NULL') || ' ID: ' || '''' || p_associate_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ASS_CC', 101+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_ASS_CC(102) : chargecodes.sql(2875) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_ASSIGNED, p_associate_id
            , True);
   End If;
   
   --delete link to old associated id
   If (h_ass_cc_id IS NOT NULL) Then
      BEGIN
         UPDATE TMT_CHARGECODES SET
         ASSOCIATE_CHARGECODE_ID = NULL,
         REC_USER = p_rec_user
         WHERE ASSOCIATE_CHARGECODE_ID = h_ass_cc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 124+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(125) : chargecodes.sql(2898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Execute Update Statement
   If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT Then
      -- the second id is associeted cc id
      BEGIN
         UPDATE TMT_CHARGECODES SET
         ASSOCIATE_CHARGECODE_ID = p_associate_id,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(149) : chargecodes.sql(2922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (p_associate_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CHARGECODES SET
            ASSOCIATE_CHARGECODE_ID = p_id,
            REC_USER = p_rec_user
            WHERE ELEMENT_ID = p_associate_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 169+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(170) : chargecodes.sql(2943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      -- the first id is associeted cc id
      BEGIN
         UPDATE TMT_CHARGECODES SET
         ASSOCIATE_CHARGECODE_ID = p_id,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = p_associate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 191+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(192) : chargecodes.sql(2965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (p_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CHARGECODES SET
            ASSOCIATE_CHARGECODE_ID = p_associate_id,
            REC_USER = p_rec_user
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(213) : chargecodes.sql(2986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ASS_CC', 220+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ASS_CC(221) : chargecodes.sql(2994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 227+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(228) : chargecodes.sql(3001) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ASS_CC', 239+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ASS_CC(240) : chargecodes.sql(3013) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ASS_CC;
ALTER FUNCTION SP_U_ASS_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_LABOR_CC ==
CREATE OR REPLACE FUNCTION SP_S_LABOR_CC
(
     p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_LABOR_COST_CC PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_LABOR_B_CC PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_LABOR_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_LABOR_CC'), '-- ' || SYSTIMESTAMP, ':r := SP_S_LABOR_CC(' || 
       COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_LABOR_CC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_LABOR_CC(23) : chargecodes.sql(3052) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(p_bitflag, 0) = 0 Then
      OPEN C_LABOR_COST_CC FOR SELECT T1.ELEMENT_ID, T1.ELEMENT_NAME, T1.CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T1
      WHERE T1.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
      AND T1.REC_STATUS <> 'D'
      ORDER BY T1.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_LABOR_CC', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_LABOR_CC(33) : chargecodes.sql(3062) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_LABOR_COST_CC;
   ElsIf Coalesce(p_bitflag, 0) = 1 Then
      OPEN C_LABOR_B_CC FOR SELECT T1.ELEMENT_ID, T1.ELEMENT_NAME, T1.CAPITAL_EXPENSE
      FROM TMT_CHARGECODES T1
      WHERE T1.CAPITAL_EXPENSE = PMO_CNST.SC_BENEFIT_LABOR
      AND T1.REC_STATUS <> 'D'
      ORDER BY T1.ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_LABOR_CC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_LABOR_CC(43) : chargecodes.sql(3072) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN C_LABOR_B_CC;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_LABOR_CC', 51+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_LABOR_CC(52) : chargecodes.sql(3081) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_LABOR_CC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_LABOR_CC(64) : chargecodes.sql(3093) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_LABOR_CC;
ALTER FUNCTION SP_S_LABOR_CC COMPILE DEBUG;

/****************************************************************************************/

-- move a charge code to another category in a special position

Prompt == FUNCTION FC_M_CC_LOCATON ==
CREATE OR REPLACE FUNCTION FC_M_CC_LOCATON
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_new_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR MVDIF_CAT IS
         SELECT RANK
         FROM TMT_CHARGECODES
         WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || '%'
         AND LEVEL_ID = h_target_level 
         AND RANK >= h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_CC_LOCATON') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_CC_LOCATON'), '-- ' || SYSTIMESTAMP, ':r := FC_M_CC_LOCATON(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CC_LOCATON', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_CC_LOCATON(41) : chargecodes.sql(3152) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(54) : chargecodes.sql(3165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDIF_CAT;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVDIF_CAT INTO h_cur_rank;
      IF MVDIF_CAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_len := Coalesce(Length(h_next_rank), 0);
      
      BEGIN
         UPDATE TMT_CHARGECODES
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
         PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
         ELSE PARENT_ID END,
         LEVEL_ID = CASE WHEN h_next_rank = h_source_rank
         THEN LEVEL_ID - h_source_level + h_target_level ELSE LEVEL_ID END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(97) : chargecodes.sql(3208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDIF_CAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(112) : chargecodes.sql(3223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_target_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_CHARGECODES
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(132) : chargecodes.sql(3243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 146+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(147) : chargecodes.sql(3258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CHARGECODES
         SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = h_target_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 165+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(166) : chargecodes.sql(3277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MAX_RANK INTO h_max_rank
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(181) : chargecodes.sql(3292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      SELECT SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) - 4) || h_rankBase64
      INTO h_new_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 199+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(200) : chargecodes.sql(3311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_len := Coalesce(Length(h_next_rank), 0);
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_new_rank)
       || h_extend_rank
      ELSE RTRIM(h_new_rank)
       || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END,
      PARENT_ID = CASE WHEN RANK = h_source_rank THEN h_target_parent_id
      ELSE PARENT_ID END
      WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
      AND RANK LIKE h_next_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 226+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(227) : chargecodes.sql(3338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CC_LOCATON', 246+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CC_LOCATON(247) : chargecodes.sql(3358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CC_LOCATON', 252+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_CC_LOCATON(253) : chargecodes.sql(3364) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CC_LOCATON', 256+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_CC_LOCATON(257) : chargecodes.sql(3368) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_CC_LOCATON;
ALTER FUNCTION FC_M_CC_LOCATON COMPILE DEBUG;

/**********************************************************************************/

-- This function moves a Charge code to higher level in the same category

Prompt == FUNCTION FC_MOVE_UP_CC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_CC
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CAT IS
         SELECT RANK
         FROM TMT_CHARGECODES
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_CC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_CC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_CC(32) : chargecodes.sql(3412) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CC(46) : chargecodes.sql(3426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CAT;
   
   h_next_rank := h_source_rank;
   LOOP
      FETCH MVUP_CAT INTO h_cur_rank;
      IF MVUP_CAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE TMT_CHARGECODES
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)
         AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CC', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CC(83) : chargecodes.sql(3463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CC', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CC(98) : chargecodes.sql(3478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CC', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CC(118) : chargecodes.sql(3498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CC', 123+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CC(124) : chargecodes.sql(3504) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CC', 127+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CC(128) : chargecodes.sql(3508) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_CC;
ALTER FUNCTION FC_MOVE_UP_CC COMPILE DEBUG;

/**********************************************************************************/

-- This function moves a Charge code to lower level in the same category

Prompt == FUNCTION FC_MOVE_DOWN_CC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_CC
(
     sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CAT IS
         SELECT RANK
         FROM TMT_CHARGECODES
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_CC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_CC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_CC(32) : chargecodes.sql(3552) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CC(46) : chargecodes.sql(3566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CAT;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_CAT INTO h_cur_rank;
      IF MVDOWN_CAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      BEGIN
         UPDATE TMT_CHARGECODES
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CC', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CC(82) : chargecodes.sql(3602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CC(97) : chargecodes.sql(3617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CC(117) : chargecodes.sql(3637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CC', 122+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CC(123) : chargecodes.sql(3643) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CC', 126+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CC(127) : chargecodes.sql(3647) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_CC;
ALTER FUNCTION FC_MOVE_DOWN_CC COMPILE DEBUG;

/****************************************************************************************/

-- contracts:

-- we can not move in/out chargecodes that are belong to the system charge code folder

-- h_bitflag determine the move type

-- normal move: 4

-- move to sibling item: 5

Prompt == FUNCTION FC_M_CHARGE_CODE ==
CREATE OR REPLACE FUNCTION FC_M_CHARGE_CODE
(
     h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_level PLS_INTEGER := 0;
   h_source_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_target_rank VARCHAR2(200);
   h_target_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_CHARGE_CODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_CHARGE_CODE'), '-- ' || SYSTIMESTAMP, ':r := FC_M_CHARGE_CODE(' || 
       '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CHARGE_CODE', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_CHARGE_CODE(31) : chargecodes.sql(3698) : ' || SYSTIMESTAMP);
   END IF; 

   -- Can not move chargecode under system folders
   If (PMO_ORASTD.strncmp(h_target_id, 'SYSTEM_EXPENSE_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(
         h_target_id, 'SYSTEM_CAPITAL_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(h_target_id
         , 'SYSTEM_BENEFIT_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(h_target_id
         , 'SYSTEM_CHARGE_CODES_FOLDER', 26) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CHARGE_CODE', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_CHARGE_CODE(40) : chargecodes.sql(3707) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_CHARGE_CODE;
   End If;
   
   -- can not move out system folders
   If (PMO_ORASTD.strncmp(h_source_id, 'SYSTEM_EXPENSE_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(
         h_source_id, 'SYSTEM_CAPITAL_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(h_source_id
         , 'SYSTEM_BENEFIT_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(h_source_id
         , 'SYSTEM_BENEFIT_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(h_source_id
         , 'CUSTOM_CHARGE_CODES_FOLDER______', 32) = 0) OR (PMO_ORASTD.strncmp(h_source_id
         , 'SYSTEM_CHARGE_CODES_FOLDER', 26) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CHARGE_CODE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_CHARGE_CODE(53) : chargecodes.sql(3720) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_CHARGE_CODE;
   End If;
   
   BEGIN
      SELECT PARENT_ID, RANK, LEVEL_ID
      INTO h_source_parent_id, h_source_rank, h_source_level
      FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CHARGE_CODE', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CHARGE_CODE(69) : chargecodes.sql(3736) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- can not move out any item under sysem folders
   If (PMO_ORASTD.strncmp(h_source_parent_id, 'SYSTEM_EXPENSE_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(
         h_source_parent_id, 'SYSTEM_CAPITAL_FOLDER', 21) = 0) OR (PMO_ORASTD.strncmp(
         h_source_parent_id, 'SYSTEM_BENEFIT_FOLDER', 21) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CHARGE_CODE', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_CHARGE_CODE(79) : chargecodes.sql(3746) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_CHARGE_CODE;
   End If;
   
   If (h_target_id IS NULL) Then
      BEGIN
         SELECT PARENT_ID, RANK, LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CHARGE_CODE', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CHARGE_CODE(96) : chargecodes.sql(3763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARENT_ID, RANK,LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CHARGECODES
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CHARGE_CODE', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CHARGE_CODE(112) : chargecodes.sql(3779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      If (((h_target_parent_id IS NULL)) AND ((h_source_parent_id IS NULL))) OR (PMO_ORASTD.strcmp(
            h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH) Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_CC(h_target_level, h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_CC(h_target_level, h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         -- move sibling to another category
         PMO_DB2M.SC_STATE := FC_M_CC_LOCATON(h_target_level, h_source_level, h_target_rank, h_source_rank
                                     , h_target_parent_id, h_rec_user);
         
         BEGIN
            UPDATE TMT_CHARGECODES
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CHARGE_CODE', 144+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CHARGE_CODE(145) : chargecodes.sql(3812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --update source hierarchy
      If (h_source_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CHARGECODES
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CHARGE_CODE', 166+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CHARGE_CODE(167) : chargecodes.sql(3834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_target_id IS NULL) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CHARGECODES', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := 0;
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      Else
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CHARGECODES', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := Coalesce(h_target_level, 0) + 1;
         h_level_id := Coalesce(h_level_id, 0);
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      End If;
      
      h_len := Coalesce(Length(h_source_rank), 0);
      h_len := Coalesce(h_len, 0);
      
      --trace_printf("\n h_source_rank:(%s)", h_source_rank);
      
      BEGIN
         UPDATE TMT_CHARGECODES
         SET LEVEL_ID = LEVEL_ID + h_level_id - h_source_level,
         RANK = h_rank || CASE WHEN LENGTH(RANK) = h_len THEN '' ELSE SUBSTR(RANK, h_len + 1, LENGTH(RANK) - h_len) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id ELSE PARENT_ID END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CHARGE_CODE', 213+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CHARGE_CODE(214) : chargecodes.sql(3881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CHARGE_CODE', 223+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_CHARGE_CODE(224) : chargecodes.sql(3891) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_CHARGE_CODE;
ALTER FUNCTION FC_M_CHARGE_CODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_CHARGECODE ==
CREATE OR REPLACE FUNCTION SP_M_CHARGECODE
(
     p_target_id VARCHAR2
   , p_source_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CHARGECODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CHARGECODE'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CHARGECODE(' || 
       '''' || p_target_id || ''''
          || ', ' || '''' || p_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CHARGECODE', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CHARGECODE(25) : chargecodes.sql(3926) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := p_target_id;
   h_source_id := p_source_id;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_M_CHARGE_CODE(h_target_id, h_source_id, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CHARGECODE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CHARGECODE(36) : chargecodes.sql(3937) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_source_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CHARGECODE', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CHARGECODE(44) : chargecodes.sql(3945) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CHARGECODE', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CHARGECODE(56) : chargecodes.sql(3957) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CHARGECODE;
ALTER FUNCTION SP_M_CHARGECODE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CC_STAGE_ID ==
CREATE OR REPLACE FUNCTION SP_U_CC_STAGE_ID
(
     p_id VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_external_identifier VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_stage_id PLS_INTEGER := 0;
   h_external_identifier VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CC_STAGE_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CC_STAGE_ID'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CC_STAGE_ID(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || '''' || p_external_identifier || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CC_STAGE_ID', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CC_STAGE_ID(26) : chargecodes.sql(3999) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_stage_id := p_stage_id;
   h_external_identifier := p_external_identifier;
   h_rec_user := p_rec_user;
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CC_STAGE_ID', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CC_STAGE_ID(35) : chargecodes.sql(4008) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CC_STAGE_ID', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CC_STAGE_ID(38) : chargecodes.sql(4011) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS
      INTO h_rec_status
      FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CC_STAGE_ID', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CC_STAGE_ID(54) : chargecodes.sql(4027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CC_STAGE_ID', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CC_STAGE_ID(61) : chargecodes.sql(4034) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CC_STAGE_ID', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CC_STAGE_ID(64) : chargecodes.sql(4037) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CC_STAGE_ID', 70+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CC_STAGE_ID(71) : chargecodes.sql(4044) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CC_STAGE_ID', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CC_STAGE_ID(74) : chargecodes.sql(4047) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id, True);
   End If;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET STAGE_ID = h_stage_id,
      EXTERNAL_IDENTIFIER = h_external_identifier,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CC_STAGE_ID', 96+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CC_STAGE_ID(97) : chargecodes.sql(4070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CC_STAGE_ID', 102+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CC_STAGE_ID(103) : chargecodes.sql(4076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CC_STAGE_ID', 109+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CC_STAGE_ID(110) : chargecodes.sql(4083) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CC_STAGE_ID', 121+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CC_STAGE_ID(122) : chargecodes.sql(4095) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CC_STAGE_ID;
ALTER FUNCTION SP_U_CC_STAGE_ID COMPILE DEBUG;

