/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_DESC ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_DESC
(
     p_id VARCHAR2
   , p_label VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_label || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DESC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_DESC(23) : clients.sql(26) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_DESC', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_DESC(30) : clients.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DESC', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_DESC(33) : clients.sql(36) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_DESC', 39+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_DESC(40) : clients.sql(43) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      LABEL        = p_label,
      DESCRIPTION  = p_description,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(68) : clients.sql(71) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_DESC', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_DESC(74) : clients.sql(77) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(81) : clients.sql(84) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DESC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DESC(93) : clients.sql(96) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_DESC;
ALTER FUNCTION SP_U_CLIENT_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_PUBLIC ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_PUBLIC
(
     p_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_PUBLIC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_PUBLIC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_PUBLIC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_PUBLIC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_PUBLIC(19) : clients.sql(131) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_PUBLIC', 23+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_PUBLIC(24) : clients.sql(136) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_PUBLIC', 26+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_PUBLIC(27) : clients.sql(139) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      PUBLIC_FLAG = p_del_flag,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(48) : clients.sql(160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_PUBLIC', 53+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_PUBLIC(54) : clients.sql(166) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(61) : clients.sql(173) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_PUBLIC', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_PUBLIC(73) : clients.sql(185) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_PUBLIC;
ALTER FUNCTION SP_U_CLIENT_PUBLIC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_CIE ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_address VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_client_more_100_employees PLS_INTEGER
   , p_client_more_1000_employees PLS_INTEGER
   , p_client_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_address || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CIE', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_CIE(45) : clients.sql(246) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_CIE', 49+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_CIE(50) : clients.sql(251) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CIE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_CIE(53) : clients.sql(254) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_CIE', 59+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_CIE(60) : clients.sql(261) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      DOMAIN_ID = p_domain_id,
      COMPANY_NAME = p_company_name,
      ADDRESS = p_address,
      PHONE = p_phone,
      FAX = p_fax,
      WEBSITE = p_website,
      OTHER_LOCATION = p_other_location,
      YEAR_IN_BUSINESS = p_year_in_business,
      CLIENT_MORE_100_EMPLOYEES = p_client_more_100_employees,
      CLIENT_MORE_1000_EMPLOYEES = p_client_more_1000_employees,
      CLIENT_MORE_10000_EMPLOYEES = p_client_more_10000_employees,
      NUMBER_EMPLOYEES = p_number_employees,
      CONTACT_NAME = p_contact_name,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(99) : clients.sql(300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_CIE', 104+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_CIE(105) : clients.sql(306) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(112) : clients.sql(313) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CIE', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CIE(124) : clients.sql(325) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_CIE;
ALTER FUNCTION SP_U_CLIENT_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_BKG ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_BKG', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_BKG(45) : clients.sql(386) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_BKG', 49+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_BKG(50) : clients.sql(391) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_BKG', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_BKG(53) : clients.sql(394) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_BKG', 59+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_BKG(60) : clients.sql(401) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      ANNUAL_REVENUES = p_annual_revenues,
      BILLING_ADDRESS = p_billing_address,
      BILLING_PHONE = p_billing_phone,
      BILLING_FAX = p_billing_fax,
      BILLING_EMAIL = p_billing_email,
      EQUAL_OPPORTUNITY = p_equal_opportunity,
      COMPANY_BACKGROUND = p_company_background,
      OWNERSHIP = p_ownership,
      SERVICES_OFFERED = p_services_offered,
      SERVICES_SPECIALIZED = p_services_specialized,
      INDUSTRIES_SERVED = p_industries_served,
      HIGHLIGHT = p_highlight,
      LOCATION_SERVED = p_location_served,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(99) : clients.sql(440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_BKG', 104+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_BKG(105) : clients.sql(446) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 111+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(112) : clients.sql(453) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_BKG', 123+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_BKG(124) : clients.sql(465) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_BKG;
ALTER FUNCTION SP_U_CLIENT_BKG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      SCP661a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661aa PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661bb PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT_CPLAN(35) : clients.sql(516) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CLIENT_CPLAN', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CLIENT_CPLAN(40) : clients.sql(521) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(43) : clients.sql(524) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If ((p_id IS NULL)) Then
      If Coalesce(p_bitflag, 0) = 1 Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_001';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_001
            SELECT RANK, ELEMENT_ID
            FROM TMT_CLIENTS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_CLIENTS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(77) : clients.sql(558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 A, PMO_TMP_CLIENTS_001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 102+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(103) : clients.sql(584) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661a FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = PMO_CNST.SC_RESOURCE) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T
         JOIN PMO_TMP_CLIENTS_002 ASS ON ASS.ELEMENT_ID=T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0, 13) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 126+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(127) : clients.sql(608) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661a;
      Else
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_001';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CLIENTS_002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_001
            SELECT RANK, ELEMENT_ID
            FROM TMT_CLIENTS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_CLIENTS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND
            RA.ELEMENT_TYPE = 11 AND
            RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 159+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(160) : clients.sql(641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_CLIENTS_002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_CLIENTS_001 A, PMO_TMP_CLIENTS_001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 185+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(186) : clients.sql(667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661aa FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T JOIN PMO_TMP_CLIENTS_002 ASS ON ASS.ELEMENT_ID = T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 207+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(208) : clients.sql(689) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661aa;
      End If;
   Else
      h_id := p_id;
      
      BEGIN
         SELECT RANK, LEVEL_ID,REC_STATUS
         INTO h_rank,h_level_id,h_rec_status
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 225+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(226) : clients.sql(707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_CPLAN', 232+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_CPLAN(233) : clients.sql(714) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 235+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(236) : clients.sql(717) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
      End If;
      
      If Coalesce(p_bitflag, 0) = 1 Then
         OPEN SCP661b FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CLIENTS C WHERE C.RANK LIKE h_rank || '%'
         AND ((T.RANK >= SUBSTR(C.RANK, 1, 8) AND T.RANK <= C.RANK) 
         AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(T.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(T.RANK) END ) = T.RANK) AND TYPE_ID = PMO_CNST.SC_RESOURCE) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         '' AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_CLIENTS T
         WHERE (T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2 )
         AND T.TYPE_ID NOT IN (0, 13)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 263+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(264) : clients.sql(745) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661b;
      Else
         OPEN SCP661bb FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_CLIENTS T
         WHERE T.TYPE_ID > 0
         AND T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_CPLAN', 297+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_CPLAN(298) : clients.sql(779) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661bb;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 307+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(308) : clients.sql(789) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_CPLAN', 319+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_CPLAN(320) : clients.sql(801) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT_CPLAN;
ALTER FUNCTION SP_S_CLIENT_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_CLIENT ==
CREATE OR REPLACE FUNCTION SP_CKOUT_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_CLIENT(22) : clients.sql(839) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(27) : clients.sql(844) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(30) : clients.sql(847) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(36) : clients.sql(853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(39) : clients.sql(856) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_rec_user, True);
   End If;
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_CLIENTS 
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(55) : clients.sql(872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(62) : clients.sql(879) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(65) : clients.sql(882) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id2, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES 
         WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(80) : clients.sql(897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 87+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(88) : clients.sql(905) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 90+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(91) : clients.sql(908) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_OUT, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 97+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(98) : clients.sql(915) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 100+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(101) : clients.sql(918) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_CLIENT', 107+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_CLIENT(108) : clients.sql(925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_CLIENT', 110+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_CLIENT(111) : clients.sql(928) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id2, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES 
         SET REC_STATUS = 'O',	
         REC_USER = p_rec_user, 
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(133) : clients.sql(950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENTS SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(152) : clients.sql(969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_CLIENT', 158+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_CLIENT(159) : clients.sql(976) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 165+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(166) : clients.sql(983) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_CLIENT', 177+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_CLIENT(178) : clients.sql(995) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_CLIENT;
ALTER FUNCTION SP_CKOUT_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_CKIN_CLIENT ==
CREATE OR REPLACE FUNCTION FC_CKIN_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = h_id;

      CURSOR CH1P IS
         SELECT MINOR_REVISION
         FROM HISTORY_CLIENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_CLIENT(35) : clients.sql(1046) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, REC_STATUS 
      INTO h_type_id, h_rec_status
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(49) : clients.sql(1060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CLIENT', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_CLIENT(56) : clients.sql(1067) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS 
         INTO h_rec_status
         FROM RESOURCES 
         WHERE RESOURCE_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(71) : clients.sql(1082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CLIENT', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_CLIENT(79) : clients.sql(1090) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_DELETED;
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CLIENT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_CLIENT(86) : clients.sql(1097) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_IN;
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CLIENT', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_CLIENT(93) : clients.sql(1104) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 122+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(123) : clients.sql(1134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES 
            SET REC_STATUS = 'U', 
            REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = h_id 
            AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 143+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(144) : clients.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 156+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(157) : clients.sql(1168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES 
               SET REC_STATUS = 'U', 
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = h_id 
               AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 180+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(181) : clients.sql(1192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES 
               SET REC_STATUS = 'U', 
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, 
               MINOR_REVISION = 0 
               WHERE RESOURCE_ID = h_id 
               AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 203+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(204) : clients.sql(1215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES 
               SET REC_STATUS = 'U', 
               REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = h_id 
               AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 224+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(225) : clients.sql(1236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES 
            SELECT h_uniqueID, A.* 
            FROM RESOURCES A 
            WHERE A.RESOURCE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 249+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(250) : clients.sql(1261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES 
            SET REVISION_HISTORY = Null 
            WHERE RESOURCE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 268+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(269) : clients.sql(1280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 302+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(303) : clients.sql(1314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS 
            SET REC_STATUS = 'U', 
            REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id 
            AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 323+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(324) : clients.sql(1335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 336+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(337) : clients.sql(1348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENTS 
               SET REC_STATUS = 'U', 
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = h_id 
               AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 360+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(361) : clients.sql(1372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_CLIENTS 
               SET REC_STATUS = 'U', 
               REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, 
               MINOR_REVISION = 0 
               WHERE ELEMENT_ID = h_id 
               AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 383+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(384) : clients.sql(1395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_CLIENTS 
               SET REC_STATUS = 'U', 
               REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id 
               AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 404+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(405) : clients.sql(1416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_CLIENTS 
            SELECT h_uniqueID, A.* 
            FROM TMT_CLIENTS A 
            WHERE A.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 429+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(430) : clients.sql(1441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS 
            SET REVISION_HISTORY = Null 
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_CLIENT', 448+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_CLIENT(449) : clients.sql(1460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_CLIENTS';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_CLIENT', 463+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_CLIENT(464) : clients.sql(1475) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_CLIENT;
ALTER FUNCTION FC_CKIN_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_CLIENT ==
CREATE OR REPLACE FUNCTION SP_CKIN_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_CLIENT(22) : clients.sql(1507) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_CLIENT', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_CLIENT(27) : clients.sql(1512) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_CLIENT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_CLIENT(30) : clients.sql(1515) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_id := p_id;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_CKIN_CLIENT(h_id, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_CLIENT', 41+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_CLIENT(42) : clients.sql(1527) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 48+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(49) : clients.sql(1534) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_CLIENT', 60+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_CLIENT(61) : clients.sql(1546) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_CLIENT;
ALTER FUNCTION SP_CKIN_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_CLIENT ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_CLIENT(20) : clients.sql(1582) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CLIENT', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CLIENT(25) : clients.sql(1587) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CLIENT(28) : clients.sql(1590) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(43) : clients.sql(1605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_CLIENT', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_CLIENT(49) : clients.sql(1611) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CLIENT(52) : clients.sql(1614) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_CLIENTS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_CLIENTS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_CLIENTS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(75) : clients.sql(1637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_CLIENT', 80+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_CLIENT(81) : clients.sql(1643) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_CLIENT', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_CLIENT(84) : clients.sql(1646) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_UNDO_CHECKOUT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_CLIENT', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_CLIENT(90) : clients.sql(1652) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(97) : clients.sql(1659) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_CLIENT', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_CLIENT(109) : clients.sql(1671) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_CLIENT;
ALTER FUNCTION SP_UCKOUT_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_REVISION(27) : clients.sql(1714) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_REVISION(33) : clients.sql(1720) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_REVISION(36) : clients.sql(1723) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_CLIENT_REVISION', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_CLIENT_REVISION(43) : clients.sql(1730) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(70) : clients.sql(1757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_REVISION', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_REVISION(76) : clients.sql(1763) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(83) : clients.sql(1770) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_REVISION', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_REVISION(95) : clients.sql(1782) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_REVISION;
ALTER FUNCTION SP_U_CLIENT_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_CLIENTS)
*                           id = ELEMENT_ID in TMT_CLIENTS table, select from HISTORY_CLIENTS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_CLIENTS table, select from HISTORY_CLIENTS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT_REVISION(24) : clients.sql(1831) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(29) : clients.sql(1836) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(32) : clients.sql(1839) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(53) : clients.sql(1860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(59) : clients.sql(1866) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(62) : clients.sql(1869) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      h_sql := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_CLIENTS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID WHERE ELEMENT_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID INTO h_rank, h_level_id, h_parent_id FROM HISTORY_CLIENTS WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(85) : clients.sql(1892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 90+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(91) : clients.sql(1898) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(94) : clients.sql(1901) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 
            ' SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_CLIENTS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''' ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 128+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(129) : clients.sql(1936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 134+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(135) : clients.sql(1942) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 137+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(138) : clients.sql(1945) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(151) : clients.sql(1958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT_REVISION', 156+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT_REVISION(157) : clients.sql(1964) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 159+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(160) : clients.sql(1967) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 174+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(175) : clients.sql(1982) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT_REVISION', 177+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT_REVISION(178) : clients.sql(1985) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 185+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(186) : clients.sql(1993) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT_REVISION', 197+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT_REVISION(198) : clients.sql(2005) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT_REVISION;
ALTER FUNCTION SP_S_CLIENT_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_CLIENT_DOC ==
CREATE OR REPLACE FUNCTION FC_I_CLIENT_DOC
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rankBase64 VARCHAR2(8);
   h_max_rank PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CLIENT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CLIENT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CLIENT_DOC(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CLIENT_DOC(21) : clients.sql(2042) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CLIENT_DOCUMENTS
      (ELEMENT_ID, PROJECT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      REC_USER, RANK, PARENT_RANK)
      VALUES
      (h_uniqueID, h_uniqueID, h_name, PMO_CNST.SC_CUSTOM_FOLDER, 0,
      h_rec_user, h_rankBase64, 'CLN#' || h_rank);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT_DOC', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT_DOC(46) : clients.sql(2067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_uniqueID:%s", h_uniqueID);
   --trace_printf("\n h_name:%s", h_name);
   --trace_printf("\n h_rec_user:%s", h_rec_user);
   --trace_printf("\n h_rankBase64:%s", h_rankBase64);
   --trace_printf("\n h_rankBase64:%s", h_rankBase64);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT_DOC', 57+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CLIENT_DOC(58) : clients.sql(2079) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CLIENT_DOC;
ALTER FUNCTION FC_I_CLIENT_DOC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_I_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_CLIENT
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CLIENT(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_uniqueID || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CLIENT(29) : clients.sql(2118) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (h_uniqueID IS NULL) Then
      h_uniqueID := SYS_GUID();
   End If;
   
   -- Validate parent_id
   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENTS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(COALESCE(RANK, '')) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 53+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(54) : clients.sql(2143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_CLIENTS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         CURRENCY_ID,
         REC_USER,
         LOCAL,
         STAGE_ID)
         VALUES(
         h_rank,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         h_level_id,
         h_rec_user,
         PMO_CNST.SC_DEFAULT_CURRENCY_ID,
         h_rec_user,
         h_local,
         PMO_CNST.SC_CLIENT_DEFAULT_STAGE_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(94) : clients.sql(2183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(113) : clients.sql(2202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_CLIENTS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         CURRENCY_ID,
         REC_USER,
         LOCAL,
         STAGE_ID)
         VALUES (
         h_rank,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         h_level_id,
         h_rec_user,
         PMO_CNST.SC_DEFAULT_CURRENCY_ID,
         h_rec_user,
         h_local,
         PMO_CNST.SC_CLIENT_DEFAULT_STAGE_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(153) : clients.sql(2242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      h_temp_sc_state := FC_I_CLIENT_DOC(h_name, h_uniqueID, h_rank, h_rec_user);
   End If;
   
   h_rate_id := SYS_GUID();
   
   BEGIN
      INSERT INTO HISTORY_CLIENTS SELECT h_rate_id, A.* FROM TMT_CLIENTS A
      WHERE A.ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(178) : clients.sql(2267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE HISTORY_CLIENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(195) : clients.sql(2284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CLIENT', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CLIENT(212) : clients.sql(2301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CLIENT', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CLIENT(218) : clients.sql(2307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CLIENT;
ALTER FUNCTION FC_I_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_DOC_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_DOC_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_del_flag VARCHAR2(1);
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      CURSOR c_all_child IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_CLIENTS
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLIENT', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_CLIENT(30) : clients.sql(2347) : ' || SYSTIMESTAMP);
   END IF; 

   --Local Variables
   
   h_host_table := PMO_CNST.SC_TABLE_CLN;
   h_del_flag := 'X';
   h_null_id := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
   Else
      OPEN c_all_child;
      
      FETCH c_all_child INTO h_id, h_type_id;
      IF c_all_child%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
            PMO_DB2M.SC_STATE := FC_D_DOC_CLN_DOC(h_host_table, h_null_id, h_id, h_del_flag, h_rec_user
                                      , h_error_id);
         End If;
         
         FETCH c_all_child INTO h_id, h_type_id;
         IF c_all_child%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      END LOOP;
      
      BEGIN
         CLOSE c_all_child ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLIENT', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLIENT(74) : clients.sql(2391) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLIENT', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLIENT(81) : clients.sql(2398) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_CLIENT;
ALTER FUNCTION FC_D_DOC_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_D_CLIENT ==
CREATE OR REPLACE FUNCTION FC_D_CLIENT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_del_flag VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_local VARCHAR2(1);
   h_found_cri VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 11;
   h_count PLS_INTEGER := 0;
   h_client_id VARCHAR2(32);
   h_cri_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_default_flag VARCHAR2(1);
   h_external_identifier VARCHAR2(32);
   h_custom_client_exists PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRI_CLIENTS IS
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE  ROWNUM <= 1 AND  CLIENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');

      CURSOR CHARGEBACK_CLIENTS IS
         SELECT PROJECT_ID
         FROM PROJECT_CHARGEBACK
         WHERE  ROWNUM <= 1 AND  CLIENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');

      CURSOR DEL_CRI_CLIENTS IS
         SELECT C.ELEMENT_ID, C.TYPE_ID, C.RANK, C.PARENT_ID
         FROM TMT_CLIENTS C
         WHERE C.LOCAL = 'Y'
         AND EXISTS (SELECT 1 FROM TMT_CRI WHERE PROJECT_ID = h_project_id AND RANK LIKE h_cri_rank || '%' AND CLIENT_ID = C.ELEMENT_ID)
         AND NOT EXISTS (SELECT 1 FROM TMT_CRI WHERE PROJECT_ID = h_project_id AND RANK NOT LIKE h_cri_rank || '%' AND CLIENT_ID = C.ELEMENT_ID)
         AND NOT EXISTS (SELECT 1 FROM PROJECT_CHARGEBACK WHERE PROJECT_ID = h_project_id AND CLIENT_ID = C.ELEMENT_ID);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_D_CLIENT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_CLIENT(50) : clients.sql(2458) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("\n h_bitflag:%d", h_bitflag);
   
   If Coalesce(h_bitflag, 0) <> 2 Then
      --  h_id is ELEMENT_ID in TMT_CLIENTS
      BEGIN
         SELECT LOCAL, TYPE_ID, RANK, CHILD_COUNT, PARENT_ID, EXTERNAL_IDENTIFIER
         INTO h_local, h_type_id, h_rank, h_count, h_parent_id, h_external_identifier
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(68) : clients.sql(2476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 74+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(75) : clients.sql(2483) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      BEGIN
         SELECT DEFAULT_FLAG 
         INTO h_default_flag
         FROM TMT_CLIENTS
         WHERE RANK LIKE h_rank || '%' AND DEFAULT_FLAG = 'Y';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(91) : clients.sql(2499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 97+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(98) : clients.sql(2506) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_RECORD;
      End If;
      
      If (h_external_identifier IS NOT NULL) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 104+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(105) : clients.sql(2513) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
      Else
         -- check for children with external_identifier number
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            h_custom_client_exists := 0;
            BEGIN
               SELECT COUNT(*)
               INTO h_custom_client_exists
               FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%%'
               AND EXTERNAL_IDENTIFIER IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 123+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(124) : clients.sql(2532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_custom_client_exists, 0) > 0) AND ((h_custom_client_exists IS NOT NULL)) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 130+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(131) : clients.sql(2539) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
            End If;
         End If;
      End If;
   End If;
   
   CASE h_bitflag
      WHEN 0 THEN
         --delete called by client
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            -- check if the client is referenced in TMT_CRI
            
            OPEN CRI_CLIENTS;
            
            FETCH CRI_CLIENTS INTO h_found_cri;
            IF CRI_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               BEGIN
                  CLOSE CRI_CLIENTS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 162+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(163) : clients.sql(2571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(169) : clients.sql(2577) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            BEGIN
               CLOSE CRI_CLIENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(182) : clients.sql(2590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            
            OPEN CHARGEBACK_CLIENTS;
            
            FETCH CHARGEBACK_CLIENTS INTO h_found_cri;
            IF CHARGEBACK_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               BEGIN
                  CLOSE CHARGEBACK_CLIENTS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 206+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(207) : clients.sql(2615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 212+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(213) : clients.sql(2621) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            BEGIN
               CLOSE CHARGEBACK_CLIENTS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 225+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(226) : clients.sql(2634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 246+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(247) : clients.sql(2655) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               DELETE FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 277+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(278) : clients.sql(2686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            -- check if the client is referenced in TMT_CRI
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 293+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(294) : clients.sql(2702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 300+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(301) : clients.sql(2709) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_CHARGEBACK
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 316+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(317) : clients.sql(2725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 323+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(324) : clients.sql(2732) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 343+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(344) : clients.sql(2752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 360+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(361) : clients.sql(2769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (h_parent_id IS NOT NULL) Then
            BEGIN
               UPDATE TMT_CLIENTS
               SET CHILD_COUNT = CHILD_COUNT - 1,
               DELETED_COUNT = DELETED_COUNT + 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 382+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(383) : clients.sql(2791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         
      
      WHEN 1 THEN
         --delete project called by wbs when a project is deleted
         If SubStr(h_local, 1, 1) = 'Y' Then
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENTS WHERE RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 409+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(410) : clients.sql(2818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
            	End If; 
            END;
            BEGIN
               DELETE FROM TMT_CLIENTS
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 440+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(441) : clients.sql(2849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 461+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(462) : clients.sql(2870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 468+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(469) : clients.sql(2877) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         End If;
         
      
      WHEN 2 THEN
         --delete client called by CRI when a CRI is deleted
         --  h_id is ELEMENT_ID in TMT_CRI
         BEGIN
            SELECT RANK, PROJECT_ID INTO h_cri_rank, h_project_id
            FROM TMT_CRI
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 487+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(488) : clients.sql(2896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN DEL_CRI_CLIENTS;
         LOOP
            FETCH DEL_CRI_CLIENTS INTO h_client_id, h_type_id, h_rank, h_parent_id;
            IF DEL_CRI_CLIENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            --trace_printf("h_client_id: %s, h_type_id: %d\n",h_client_id,h_type_id);
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_client_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_client_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 521+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(522) : clients.sql(2930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_client_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 538+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(539) : clients.sql(2947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 559+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(560) : clients.sql(2968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE DEL_CRI_CLIENTS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 573+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(574) : clients.sql(2982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      WHEN 3 THEN
         --delete called by SP_U_CRI_CLIENT
         If SubStr(h_local, 1, 1) = 'Y' Then
            -- check if the client is referenced in TMT_CRI
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 591+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(592) : clients.sql(3000) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 598+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(599) : clients.sql(3007) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            -- check if the client is referenced in PROJECT_CHARGEBACK
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_CHARGEBACK
               WHERE CLIENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 614+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(615) : clients.sql(3023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 621+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(622) : clients.sql(3030) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_RECORD;
            End If;
            
            --delete all assign documents
            PMO_DB2M.SC_STATE := FC_D_DOC_CLIENT(h_id, h_rank, h_type_id, h_rec_user);
            
            BEGIN
               DELETE FROM TMT_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 641+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(642) : clients.sql(3050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_CLIENTS WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 658+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(659) : clients.sql(3067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_parent_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CLIENTS
                  SET CHILD_COUNT = CHILD_COUNT - 1,
                  DELETED_COUNT = DELETED_COUNT + 1
                  WHERE ELEMENT_ID = h_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_CLIENT', 679+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_CLIENT(680) : clients.sql(3088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 686+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(687) : clients.sql(3095) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         End If;
         
      ELSE
         NULL;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_CLIENT', 696+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_CLIENT(697) : clients.sql(3105) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_CLIENT;
ALTER FUNCTION FC_D_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_MERGE_CLIENT ==
CREATE OR REPLACE FUNCTION FC_MERGE_CLIENT
(
     h_target IN OUT NOCOPY VARCHAR2
   , h_source IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_name VARCHAR2(255);
   h_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MERGE_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MERGE_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_MERGE_CLIENT(' || 
       '''' || h_target || ''''
          || ', ' || '''' || h_source || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MERGE_CLIENT(19) : clients.sql(3134) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   --validate source
   BEGIN
      SELECT ELEMENT_NAME INTO h_name
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_target;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_CLIENT', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_CLIENT(35) : clients.sql(3150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_CLIENT(42) : clients.sql(3157) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_CRI
      SET ELEMENT_NAME = h_name,
      ELEMENT_ID   = h_target,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_source;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MERGE_CLIENT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MERGE_CLIENT(65) : clients.sql(3180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_bitflag := 0;
   PMO_DB2M.SC_STATE := FC_D_CLIENT(h_source, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MERGE_CLIENT', 73+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MERGE_CLIENT(74) : clients.sql(3189) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MERGE_CLIENT;
ALTER FUNCTION FC_MERGE_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION FC_U_CLIENT_NAME
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_CLIENT_NAME(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_CLIENT_NAME(20) : clients.sql(3219) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID INTO h_type_id
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CLIENT_NAME', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CLIENT_NAME(33) : clients.sql(3232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_CLIENT_NAME(40) : clients.sql(3239) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   h_host_table := PMO_CNST.SC_TABLE_CLN;
   
   PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN(h_host_table, h_id, h_name, h_rec_user, h_error_id);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
      PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN_DOC(h_host_table, h_id, h_name, h_rec_user, h_error_id);
      
      -- Execute Update Statement
      BEGIN
         UPDATE TMT_CRI
         SET CLIENT_NAME = RTRIM(LTRIM(h_name)),
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = h_rec_user
         WHERE CLIENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_CLIENT_NAME', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_CLIENT_NAME(69) : clients.sql(3268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_CLIENT_NAME', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_CLIENT_NAME(80) : clients.sql(3279) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_CLIENT_NAME;
ALTER FUNCTION FC_U_CLIENT_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_NAME ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_NAME', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_NAME(23) : clients.sql(3312) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_NAME', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_NAME(31) : clients.sql(3320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_NAME', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_NAME(34) : clients.sql(3323) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_CLIENT_NAME(h_id, h_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_NAME', 45+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_NAME(46) : clients.sql(3335) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_NAME', 52+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_NAME(53) : clients.sql(3342) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_NAME', 64+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_NAME(65) : clients.sql(3354) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_NAME;
ALTER FUNCTION SP_U_CLIENT_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_CURRENCY ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_CURRENCY
(
     p_id VARCHAR2
   , p_currency_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_currency_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_CURRENCY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_CURRENCY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_CURRENCY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_currency_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CURRENCY', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_CURRENCY(22) : clients.sql(3392) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_CURRENCY', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_CURRENCY(30) : clients.sql(3400) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_CURRENCY', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_CURRENCY(33) : clients.sql(3403) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_currency_id := p_currency_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET CURRENCY_ID = h_currency_id,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CURRENCY', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CURRENCY(58) : clients.sql(3428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_CURRENCY', 63+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_CURRENCY(64) : clients.sql(3434) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CURRENCY', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CURRENCY(71) : clients.sql(3441) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_CURRENCY', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_CURRENCY(83) : clients.sql(3453) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_CURRENCY;
ALTER FUNCTION SP_U_CLIENT_CURRENCY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_DEFAULT ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_DEFAULT
(
     p_id VARCHAR2
   , p_default_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_default_flag VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_DEFAULT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_DEFAULT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_DEFAULT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_default_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DEFAULT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_DEFAULT(22) : clients.sql(3491) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_DEFAULT', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_DEFAULT(30) : clients.sql(3499) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DEFAULT', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_DEFAULT(33) : clients.sql(3502) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_default_flag := p_default_flag;
   h_rec_user := p_rec_user;
   
   If PMO_ORASTD.strncmp(h_default_flag, 'Y', 1) = 0 Then
      BEGIN
         UPDATE TMT_CLIENTS
         SET DEFAULT_FLAG = 'N',
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE DEFAULT_FLAG = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DEFAULT', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DEFAULT(59) : clients.sql(3528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET DEFAULT_FLAG = h_default_flag,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DEFAULT', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DEFAULT(80) : clients.sql(3549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CLIENT_DEFAULT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CLIENT_DEFAULT(86) : clients.sql(3555) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || h_default_flag || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_DEFAULT', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_DEFAULT(89) : clients.sql(3558) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, h_default_flag, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_DEFAULT', 94+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_DEFAULT(95) : clients.sql(3564) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DEFAULT', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DEFAULT(102) : clients.sql(3571) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_DEFAULT', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_DEFAULT(114) : clients.sql(3583) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_DEFAULT;
ALTER FUNCTION SP_U_CLIENT_DEFAULT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_CLIENT ==
CREATE OR REPLACE FUNCTION SP_I_CLIENT
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CLIENT(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CLIENT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CLIENT(26) : clients.sql(3625) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   h_uniqueID := NULL;
   
   PMO_DB2M.SC_STATE := FC_I_CLIENT(h_name, h_uniqueID, h_parent_id, h_type_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CLIENT', 37+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CLIENT(38) : clients.sql(3637) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CLIENT', 44+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CLIENT(45) : clients.sql(3644) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CLIENT', 56+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CLIENT(57) : clients.sql(3656) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CLIENT;
ALTER FUNCTION SP_I_CLIENT COMPILE DEBUG;

/****************************************************************************************/

-- This stored procedure add a new custom client or update an existing one

-- contracts:

-- h_type_id, stage_id, external_identifier can not be null

Prompt == FUNCTION FC_I_CUSTOM_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_CUSTOM_CLIENT
(
     h_uniqueID IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_stage_id PLS_INTEGER
   , h_external_identifier IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_update PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR get_custom_client IS
         SELECT ELEMENT_ID 
         FROM TMT_CLIENTS
         WHERE  ROWNUM <= 1 AND  EXTERNAL_IDENTIFIER = h_external_identifier;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_CUSTOM_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_CUSTOM_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_CUSTOM_CLIENT(' || 
       '''' || h_uniqueID || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_external_identifier || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CLIENT', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_CUSTOM_CLIENT(45) : clients.sql(3723) : ' || SYSTIMESTAMP);
   END IF; 

   If ((h_stage_id IS NULL)) OR ((h_type_id IS NULL)) OR ((h_external_identifier IS NULL)) Then
      h_uniqueID := h_rec_user;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CLIENT', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_CUSTOM_CLIENT(51) : clients.sql(3729) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If (h_parent_id IS NULL) Then
      -- create all custom charge codes under custom folder
      h_parent_id := 'CUSTOM_CLIENT___________________';
   End If;
   
   --trace_printf("\n h_parent_id:%s", h_parent_id);
   --trace_printf("\n h_stage_id:%d", h_stage_id);
   --trace_printf("\n h_external_identifier:%s", h_external_identifier);
   
   -- if there is more than one client with the same external reference then
   -- just select one of them
   
   OPEN get_custom_client;
   
   FETCH get_custom_client INTO h_element_id;
   IF get_custom_client%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   h_update := 0;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_update := 1;
   End If;
   
   BEGIN
      CLOSE get_custom_client  ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 89+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(90) : clients.sql(3768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_element_id:%s", h_element_id);
   --trace_printf("\n h_update:%d", h_update);
   
   If Coalesce(h_update, 0) = 1 Then
      h_uniqueID := h_element_id;
      BEGIN
         UPDATE TMT_CLIENTS 
         SET ELEMENT_NAME = h_name,
         STAGE_ID = h_stage_id,
         EXTERNAL_IDENTIFIER = h_external_identifier  ,
         DESCRIPTION = h_description
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(117) : clients.sql(3795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_uniqueID := SYS_GUID();
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_parent_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      BEGIN
         SELECT RTRIM(Rank) || h_rankBase64, LEVEL_ID + 1, LOCAL
         INTO h_rank, h_level_id, h_local
         FROM TMT_CLIENTS 
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(137) : clients.sql(3815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n h_rank:%s", h_rank);
      --trace_printf("\n h_parent_id:%s", h_parent_id);
      --trace_printf("\n h_uniqueID:%s:%d", h_uniqueID, h_uniqueID_Ind);
      --trace_printf("\n h_name:%s", h_name);
      --trace_printf("\n h_type_id:%d", h_type_id);
      --trace_printf("\n h_level_id:%d", h_level_id);
      --trace_printf("\n h_rec_user:%s", h_rec_user);
      --trace_printf("\n h_local:%s", h_local);
      --trace_printf("\n h_stage_id:%d", h_stage_id);
      --trace_printf("\n h_external_identifier:%s", h_external_identifier);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            INSERT INTO TMT_CLIENTS(RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
            TYPE_ID, LEVEL_ID, MANAGER_ID, CURRENCY_ID,
            REC_USER, LOCAL, STAGE_ID, EXTERNAL_IDENTIFIER, DESCRIPTION)
            VALUES (h_rank, h_parent_id, h_uniqueID, h_name,
            h_type_id, h_level_id, h_rec_user, PMO_CNST.SC_DEFAULT_CURRENCY_ID,
            h_rec_user, h_local, h_stage_id, h_external_identifier, h_description);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(171) : clients.sql(3849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLIENTS Then
            h_temp_sc_state := FC_I_CLIENT_DOC(h_name, h_uniqueID, h_rank, h_rec_user);
         End If;
         
         h_rate_id := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_CLIENTS 
            SELECT h_rate_id, A.* FROM TMT_CLIENTS A
            WHERE A.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 195+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(196) : clients.sql(3874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_CLIENTS 
            SET REC_STATUS = 'U' 
            WHERE HISTORY_ID = h_rate_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(215) : clients.sql(3893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENTS 
            SET REVISION_HISTORY = Null 
            WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_CUSTOM_CLIENT', 233+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_CUSTOM_CLIENT(234) : clients.sql(3912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag := 0;
         PMO_DB2M.SC_STATE := FC_CKIN_CLIENT(h_uniqueID, h_bitflag, h_rec_user);
         
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CLIENT', 243+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_CUSTOM_CLIENT(244) : clients.sql(3922) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_CUSTOM_CLIENT', 249+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_CUSTOM_CLIENT(250) : clients.sql(3928) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_CUSTOM_CLIENT;
ALTER FUNCTION FC_I_CUSTOM_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_CUSTOM_CLIENT ==
CREATE OR REPLACE FUNCTION SP_I_CUSTOM_CLIENT
(
     p_name VARCHAR2
   , p_type_id PLS_INTEGER
   , p_parent_id VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_external_identifier VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_type_id PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_stage_id PLS_INTEGER := 0;
   h_external_identifier VARCHAR2(32);
   h_description VARCHAR2(2048);
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_CUSTOM_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_CUSTOM_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_I_CUSTOM_CLIENT(' || 
       '''' || p_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || '''' || p_external_identifier || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_CUSTOM_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_CUSTOM_CLIENT(35) : clients.sql(3973) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_type_id := p_type_id;
   h_parent_id := p_parent_id;
   h_stage_id := p_stage_id;
   h_external_identifier := p_external_identifier;
   h_description := p_description;
   h_rec_user := p_rec_user;
   
   h_uniqueID := '';
   
   PMO_DB2M.SC_STATE := FC_I_CUSTOM_CLIENT(h_uniqueID, h_parent_id, h_name, h_type_id, h_stage_id
                                        , h_external_identifier, h_description, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_CUSTOM_CLIENT', 51+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_CUSTOM_CLIENT(52) : clients.sql(3990) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CUSTOM_CLIENT', 58+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CUSTOM_CLIENT(59) : clients.sql(3997) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_CUSTOM_CLIENT', 70+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_CUSTOM_CLIENT(71) : clients.sql(4009) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_CUSTOM_CLIENT;
ALTER FUNCTION SP_I_CUSTOM_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_MERGE_CLIENT ==
CREATE OR REPLACE FUNCTION SP_MERGE_CLIENT
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_target VARCHAR2(32);
   h_source VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_MERGE_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_MERGE_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_MERGE_CLIENT(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MERGE_CLIENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_MERGE_CLIENT(22) : clients.sql(4047) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variables
   
   h_target := p_target;
   h_source := p_source;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_MERGE_CLIENT(h_target, h_source, h_rec_user);
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_MERGE_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_MERGE_CLIENT(35) : clients.sql(4060) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_target || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_target, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_CLIENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_CLIENT(42) : clients.sql(4067) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MERGE_CLIENT', 53+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MERGE_CLIENT(54) : clients.sql(4079) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_MERGE_CLIENT;
ALTER FUNCTION SP_MERGE_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_FIND ==
CREATE OR REPLACE FUNCTION SP_FIND
(
     p_name VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(4000);
   h_name VARCHAR2(255);
   h_project_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND(' || 
       '''' || p_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND(24) : clients.sql(4119) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_name := p_name;
   h_project_id := p_project_id;
   
   --Return a resultset
   h_xsql := 'SELECT ELEMENT_NAME, TYPE_ID, ELEMENT_ID ';
   h_xsql := h_xsql || 'FROM TMT_CLIENTS ';
   h_xsql := h_xsql || 'WHERE TYPE_ID = ';
   h_xsql := h_xsql || TO_CHAR(PMO_CNST.SC_CLIENTS);
   h_xsql := h_xsql || ' AND UPPER(ELEMENT_NAME) LIKE UPPER(''';
   h_xsql := h_xsql || h_name;
   h_xsql := h_xsql || '%%'') AND (LOCAL = ''N'' OR PARENT_ID = ''';
   h_xsql := h_xsql || h_project_id;
   h_xsql := h_xsql || ''') ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 43+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND(44) : clients.sql(4139) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND(47) : clients.sql(4142) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND(55) : clients.sql(4150) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND(67) : clients.sql(4162) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND;
ALTER FUNCTION SP_FIND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CLIENT ==
CREATE OR REPLACE FUNCTION SP_S_CLIENT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CSnull PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS0 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS1 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CS2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      client_refresh PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CLIENT(35) : clients.sql(4213) : ' || SYSTIMESTAMP);
   END IF; 

   h_count := 0;
   If (p_id IS NULL) Then
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENTS
         WHERE RANK LIKE 'qqqq%' AND LEVEL_ID = 1 AND CHILD_COUNT > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 49+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(50) : clients.sql(4228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN CSnull FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN h_count ELSE T.CHILD_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.STAGE_ID ELSE 0 END AS STAGE_ID, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.EXTERNAL_IDENTIFIER ELSE '' END AS EXTERNAL_IDENTIFIER
      FROM TMT_CLIENTS T 
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.PARENT_ID IS NULL
      AND T.RANK <> '0000'
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 70+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(71) : clients.sql(4249) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CSnull;
   ElsIf Coalesce(p_bitflag, 0) = 0 Then
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank,h_level_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(85) : clients.sql(4263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_CLIENT', 91+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_CLIENT(92) : clients.sql(4270) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 94+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(95) : clients.sql(4273) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENTS
         WHERE RANK LIKE 'qqqq%' AND LEVEL_ID = 0 AND CHILD_COUNT > 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(110) : clients.sql(4288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN CS0 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN h_count ELSE T.CHILD_COUNT END AS CHILD_COUNT,
      T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.STAGE_ID ELSE 0 END AS STAGE_ID, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.EXTERNAL_IDENTIFIER ELSE '' END AS EXTERNAL_IDENTIFIER
      FROM TMT_CLIENTS T 
      LEFT JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.RANK LIKE h_rank || '%' AND T.LEVEL_ID < h_level_id+2
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      AND (SUBSTR(T.RANK,1,4) <> 'qqqq' OR T.LEVEL_ID > 1 OR T.CHILD_COUNT > 0)
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 130+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(131) : clients.sql(4309) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS0;
   ElsIf Coalesce(p_bitflag, 0) = 1 Then
      OPEN CS1 FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,				
      '' AS REVISION_HISTORY, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.STAGE_ID ELSE 0 END AS STAGE_ID, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.EXTERNAL_IDENTIFIER ELSE '' END AS EXTERNAL_IDENTIFIER
      FROM TMT_CLIENTS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.PARENT_ID IS NULL
      AND T.RANK NOT IN ('0000', 'qqqq')
      AND T.REC_STATUS NOT IN ('D', 'L', 'A')
      
      UNION ALL
      
      SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.STAGE_ID ELSE 0 END AS STAGE_ID, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.EXTERNAL_IDENTIFIER ELSE '' END AS EXTERNAL_IDENTIFIER
      FROM TMT_CLIENTS T 
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = p_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 164+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(165) : clients.sql(4343) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS1;
   ElsIf Coalesce(p_bitflag, 0) = 2 Then
      OPEN CS2 FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT CHILD_COUNT FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.STAGE_ID ELSE 0 END AS STAGE_ID, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.EXTERNAL_IDENTIFIER ELSE '' END AS EXTERNAL_IDENTIFIER
      FROM TMT_CLIENTS T 
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE (T.PARENT_ID = p_id OR T.RANK = 'qqqq')
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 183+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(184) : clients.sql(4362) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CS2;
   ElsIf Coalesce(p_bitflag, 0) = 5 Then
      OPEN client_refresh FOR SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
      CASE WHEN T.RANK = 'qqqq' THEN (SELECT CHILD_COUNT FROM TMT_CLIENTS WHERE ELEMENT_ID = p_id)
      ELSE T.CHILD_COUNT END AS CHILD_COUNT,T.DELETED_COUNT, T.REC_STATUS, T.DESCRIPTION, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.DEFAULT_FLAG, T.LOCAL, T.RTF_BITS,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      T.MAJOR_REVISION, T.MINOR_REVISION, T.REVISION_IMPACT, T.REVISION_TYPE,
      '' AS REVISION_HISTORY, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.STAGE_ID ELSE 0 END AS STAGE_ID, 
      case when T.TYPE_ID IN (PMO_CNST.SC_CLIENTS, PMO_CNST.SC_DIVISION) THEN T.EXTERNAL_IDENTIFIER ELSE '' END AS EXTERNAL_IDENTIFIER
      FROM TMT_CLIENTS T 
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = p_id
      AND T.REC_STATUS NOT in ('D', 'L', 'A')
      ORDER BY T.RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CLIENT', 202+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CLIENT(203) : clients.sql(4381) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN client_refresh;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 211+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(212) : clients.sql(4390) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CLIENT', 223+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CLIENT(224) : clients.sql(4402) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CLIENT;
ALTER FUNCTION SP_S_CLIENT COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting clients and Resources:
    if exists(resource assignments)
        cannot delete clients
        cannot delete resource
    else
        do delete clients and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_CLIENT ==
CREATE OR REPLACE FUNCTION SP_D_CLIENT
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_D_CLIENT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_CLIENT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_CLIENT(24) : clients.sql(4449) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_bitflag := 0;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_D_CLIENT(h_id, h_bitflag, h_rec_user);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_CLIENT', 36+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_CLIENT(37) : clients.sql(4462) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CLIENT', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CLIENT(44) : clients.sql(4469) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_CLIENT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_CLIENT(56) : clients.sql(4481) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_CLIENT;
ALTER FUNCTION SP_D_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_M_CLIENT ==
CREATE OR REPLACE FUNCTION FC_M_CLIENT
(
     h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_local VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_parent_id VARCHAR2(32);
   h_source_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_new_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_target_rank VARCHAR2(200);
   h_target_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_prefix VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_M_CLIENT(' || 
       '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CLIENT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_CLIENT(39) : clients.sql(4536) : ' || SYSTIMESTAMP);
   END IF; 

   h_prefix := 'CLN#';
   
   If (PMO_ORASTD.strncmp(h_source_id, 'CUSTOM_CLIENT___________________', 32) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CLIENT', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_CLIENT(46) : clients.sql(4543) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
   End If;
   
   BEGIN
      SELECT PARENT_ID, RANK, LEVEL_ID
      INTO h_source_parent_id, h_source_rank, h_source_level
      FROM TMT_CLIENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(62) : clients.sql(4559) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_target_id IS NULL) Then
      BEGIN
         SELECT PARENT_ID, RANK, LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(79) : clients.sql(4576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARENT_ID, RANK,LEVEL_ID
         INTO h_target_parent_id, h_target_rank, h_target_level
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_target_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(95) : clients.sql(4592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (BITAND(Coalesce(h_bitflag, 0), 1)) = 1 Then
      If (((h_target_parent_id IS NULL)) AND ((h_source_parent_id IS NULL))) OR (PMO_ORASTD.strcmp(
            h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH) Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > PMO_CNST.SC_MATCH Then
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_UP_CLN(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                        , h_prefix, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_SMP_MOVE_DOWN_CLN(h_target_level, h_target_rank, h_source_rank, h_new_rank
                                          , h_prefix, h_rec_user);
         End If;
      Else
         PMO_DB2M.SC_STATE := FC_SMP_MOVE_DIF_CLN(h_target_level, h_source_level, h_target_rank
                                         , h_source_rank, h_target_parent_id, h_new_rank, h_prefix
                                         , h_rec_user);
         
         BEGIN
            UPDATE TMT_CLIENTS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(130) : clients.sql(4627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --update source hierarchy
      If (h_source_parent_id IS NOT NULL) Then
         BEGIN
            UPDATE TMT_CLIENTS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(152) : clients.sql(4649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_target_id IS NULL) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CLIENTS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := 0;
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      Else
         PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENTS', h_target_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         h_level_id := Coalesce(h_target_level, 0) + 1;
         h_level_id := Coalesce(h_level_id, 0);
         h_rank := h_target_rank || h_rankBase64;
         h_rank := h_rank;
      End If;
      
      h_len := Coalesce(Length(h_source_rank), 0);
      h_len := Coalesce(h_len, 0);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_source_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_source_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PARENT_RANK = 'CLN#' || h_rank || 
         CASE WHEN LENGTH(PARENT_RANK) = h_len + 4 THEN ''
         ELSE SUBSTR(PARENT_RANK, h_len + 5, LENGTH(PARENT_RANK) - h_len - 4) END
         WHERE PARENT_RANK LIKE 'CLN#' || h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 206+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(207) : clients.sql(4704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENTS
         SET LEVEL_ID = LEVEL_ID + h_level_id - h_source_level,
         RANK = h_rank || CASE WHEN LENGTH(RANK) = h_len THEN '' ELSE SUBSTR(RANK, h_len + 1, LENGTH(RANK) - h_len) END,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id ELSE PARENT_ID END,
         REC_USER     = h_rec_user,
         REC_STATUS   = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_CLIENT', 230+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_CLIENT(231) : clients.sql(4728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_CLIENT', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_CLIENT(241) : clients.sql(4738) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_CLIENT;
ALTER FUNCTION FC_M_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PUBLISH_LOCAL_CLIENT ==
CREATE OR REPLACE FUNCTION FC_PUBLISH_LOCAL_CLIENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PUBLISH_LOCAL_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PUBLISH_LOCAL_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_PUBLISH_LOCAL_CLIENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PUBLISH_LOCAL_CLIENT', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PUBLISH_LOCAL_CLIENT(20) : clients.sql(4768) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := NULL;
   h_bitflag := 4;
   PMO_DB2M.SC_STATE := FC_M_CLIENT(h_target_id, h_element_id, h_bitflag, h_rec_user);
   
   If PMO_DB2M.SC_STATE = 0 Then
      BEGIN
         UPDATE TMT_CLIENTS 
         SET CHILD_COUNT = case when CHILD_COUNT > 0 then CHILD_COUNT - 1 else 0 end
         WHERE ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PUBLISH_LOCAL_CLIENT', 41+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PUBLISH_LOCAL_CLIENT(42) : clients.sql(4790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PUBLISH_LOCAL_CLIENT', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PUBLISH_LOCAL_CLIENT(53) : clients.sql(4801) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PUBLISH_LOCAL_CLIENT;
ALTER FUNCTION FC_PUBLISH_LOCAL_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_CLIENT ==
CREATE OR REPLACE FUNCTION SP_M_CLIENT
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := SP_M_CLIENT(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_CLIENT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_CLIENT(25) : clients.sql(4836) : ' || SYSTIMESTAMP);
   END IF; 

   h_target_id := p_target;
   h_source_id := p_source;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_M_CLIENT(h_target_id, h_source_id, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_CLIENT', 35+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_CLIENT(36) : clients.sql(4847) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_source_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_source_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(44) : clients.sql(4855) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_CLIENT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_CLIENT(56) : clients.sql(4867) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_CLIENT;
ALTER FUNCTION SP_M_CLIENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CLIENT_STAGE_ID ==
CREATE OR REPLACE FUNCTION SP_U_CLIENT_STAGE_ID
(
     p_id VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_external_identifier VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_stage_id PLS_INTEGER := 0;
   h_external_identifier VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CLIENT_STAGE_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CLIENT_STAGE_ID'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CLIENT_STAGE_ID(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || '''' || p_external_identifier || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_STAGE_ID', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CLIENT_STAGE_ID(25) : clients.sql(4908) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CLIENT_STAGE_ID', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CLIENT_STAGE_ID(30) : clients.sql(4913) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CLIENT_STAGE_ID', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CLIENT_STAGE_ID(33) : clients.sql(4916) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_stage_id := p_stage_id;
   h_external_identifier := p_external_identifier;
   h_rec_user := p_rec_user;
   
   BEGIN
      UPDATE TMT_CHARGECODES
      SET STAGE_ID = h_stage_id,
      EXTERNAL_IDENTIFIER = h_external_identifier,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_STAGE_ID', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_STAGE_ID(60) : clients.sql(4943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CLIENT_STAGE_ID', 69+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CLIENT_STAGE_ID(70) : clients.sql(4953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_STAGE_ID', 76+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_STAGE_ID(77) : clients.sql(4960) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CLIENT_STAGE_ID', 88+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CLIENT_STAGE_ID(89) : clients.sql(4972) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CLIENT_STAGE_ID;
ALTER FUNCTION SP_U_CLIENT_STAGE_ID COMPILE DEBUG;

