/*****************************************************************************************/

Prompt == FUNCTION SP_U_COSTBACK ==
CREATE OR REPLACE FUNCTION SP_U_COSTBACK
(
     p_costback_id VARCHAR2
   , p_labor_percent PLS_INTEGER
   , p_labor_amount NUMBER
   , p_labor_flag PLS_INTEGER
   , p_expense_percent PLS_INTEGER
   , p_expense_amount NUMBER
   , p_expense_flag PLS_INTEGER
   , p_capital_percent PLS_INTEGER
   , p_capital_amount NUMBER
   , p_capital_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COSTBACK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COSTBACK'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COSTBACK(' || 
       '''' || p_costback_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_labor_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_labor_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_labor_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expense_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expense_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expense_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_capital_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COSTBACK', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COSTBACK(35) : cost_back.sql(38) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_costback_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_COSTBACK', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_COSTBACK(40) : cost_back.sql(43) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COSTBACK', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_COSTBACK(43) : cost_back.sql(46) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      UPDATE PROJECT_COST_CENTERS 
      SET LABOR_PERCENT       = p_labor_percent,
      LABOR_AMOUNT        = p_labor_amount,
      LABOR_FLAG			= p_labor_flag,
      EXPENSE_PERCENT     = p_expense_percent,
      EXPENSE_AMOUNT      = p_expense_amount,
      EXPENSE_FLAG        = p_expense_flag,
      CAPITAL_PERCENT     = p_capital_percent,
      CAPITAL_AMOUNT      = p_capital_amount,
      CAPITAL_FLAG        = p_capital_flag,
      REC_USER			= p_rec_user,
      REC_STATUS			= 'U',
      REC_DATETIME        = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_costback_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COSTBACK', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COSTBACK(73) : cost_back.sql(76) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COSTBACK', 78+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COSTBACK(79) : cost_back.sql(82) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_costback_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_costback_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COSTBACK', 85+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COSTBACK(86) : cost_back.sql(89) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COSTBACK', 97+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COSTBACK(98) : cost_back.sql(101) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COSTBACK;
ALTER FUNCTION SP_U_COSTBACK COMPILE DEBUG;

/*****************************************************************************************/

-- rollup actual to PROJECT_COST_CENTERS

/*****************************************************************************************/

Prompt == FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER_old ==
CREATE OR REPLACE FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER_old
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_cost_amount NUMBER
   , sh_h_revenue_amount NUMBER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_cost_amount NUMBER := sh_h_cost_amount;
   h_revenue_amount NUMBER := sh_h_revenue_amount;
   h_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_PRJ_RES_COST_CENTER_old') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_PRJ_RES_COST_CENTER_old'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_PRJ_RES_COST_CENTER_old(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_cost_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_revenue_amount), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_PRJ_RES_COST_CENTER_old', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_PRJ_RES_COST_CENTER_old(26) : cost_back.sql(147) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_COST_CENTERS
      SET ACTUAL_COST = h_cost_amount,
      ACTUAL_REVENUE = h_revenue_amount,
      COST_CHARGE_AMOUNT = CASE WHEN MAX_COST_CHARGE = 0.00
      THEN (h_cost_amount * COST_CHARGE_PERCENT / 10000.00)
      WHEN h_cost_amount > MAX_COST_CHARGE THEN MAX_COST_CHARGE
      ELSE h_cost_amount END,
      REVENUE_CHARGE_AMOUNT = CASE WHEN MAX_REVENUE_CHARGE = 0.00
      THEN (h_revenue_amount * REVENUE_CHARGE_PERCENT / 10000.00)
      WHEN h_revenue_amount > MAX_REVENUE_CHARGE THEN MAX_REVENUE_CHARGE
      ELSE h_revenue_amount END
      WHERE PROJECT_ID = h_project_id
      AND RESOURCE_ID = h_resource_id
      AND COST_CENTER_ID = h_cost_center_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER_old', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER_old(54) : cost_back.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND ((Coalesce(h_cost_amount, 0) <> 0.00) 
         OR (Coalesce(h_revenue_amount, 0) <> 0.00)) Then
      BEGIN
         INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, RESOURCE_ID, COST_CENTER_ID,
         ACTUAL_COST, ACTUAL_REVENUE, COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT,
         COST_CHARGE_AMOUNT, REVENUE_CHARGE_AMOUNT)
         VALUES(SYS_GUID(), h_project_id, h_resource_id, h_cost_center_id,
         h_cost_amount, h_revenue_amount,
         10000, 10000, h_cost_amount, 0.00);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER_old', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER_old(78) : cost_back.sql(199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 0;
      BEGIN
         SELECT COUNT(*) INTO h_bitflag
         FROM PROJECT_COST_CENTERS
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND RESOURCE_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER_old', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER_old(96) : cost_back.sql(217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
            COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
            VALUES(SYS_GUID(), h_project_id, h_cost_center_id, 0, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER_old', 115+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER_old(116) : cost_back.sql(237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_PRJ_RES_COST_CENTER_old', 123+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_PRJ_RES_COST_CENTER_old(124) : cost_back.sql(245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER_old;
ALTER FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER_old COMPILE DEBUG;

/*****************************************************************************************/

-- rollup actual to PROJECT_COST_CENTERS

/*****************************************************************************************/

Prompt == FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER ==
CREATE OR REPLACE FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_cost_center_id VARCHAR2(32);
   h_cost_amount NUMBER := 0;
   h_revenue_amount NUMBER := 0;
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PRJ_REC_CC IS
         SELECT COST_CENTER_ID,
         SUM(CASE WHEN TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR 
         THEN (REGULAR_TOTAL_QUANTITY * REGULAR_RATE + SPECIAL_TOTAL_QUANTITY * SPECIAL_RATE) ELSE 0.00 END),
         SUM(CASE WHEN TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR THEN 0.00 
         ELSE (REGULAR_TOTAL_QUANTITY * REGULAR_RATE + SPECIAL_TOTAL_QUANTITY * SPECIAL_RATE) END)
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND DEFAULT_LABOR_FLAG = 1
         GROUP BY COST_CENTER_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_PRJ_RES_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_PRJ_RES_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_PRJ_RES_COST_CENTER(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_PRJ_RES_COST_CENTER', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_PRJ_RES_COST_CENTER(36) : cost_back.sql(295) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C_PRJ_REC_CC;
   
   LOOP
      FETCH C_PRJ_REC_CC INTO h_cost_center_id, h_revenue_amount, h_cost_amount;
      IF C_PRJ_REC_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      h_cost_amount := Coalesce(h_cost_amount, 0) / 60.00;
      h_revenue_amount := Coalesce(h_revenue_amount, 0) / 60.00;
      
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET ACTUAL_COST = h_cost_amount,
         ACTUAL_REVENUE = h_revenue_amount,
         COST_CHARGE_AMOUNT = CASE WHEN MAX_COST_CHARGE = 0.00
         THEN (h_cost_amount * COST_CHARGE_PERCENT / 10000.00)
         WHEN h_cost_amount > MAX_COST_CHARGE THEN MAX_COST_CHARGE
         ELSE h_cost_amount END,
         REVENUE_CHARGE_AMOUNT = CASE WHEN MAX_REVENUE_CHARGE = 0.00
         THEN (h_revenue_amount * REVENUE_CHARGE_PERCENT / 10000.00)
         WHEN h_revenue_amount > MAX_REVENUE_CHARGE THEN MAX_REVENUE_CHARGE
         ELSE h_revenue_amount END
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND COST_CENTER_ID = h_cost_center_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER(81) : cost_back.sql(340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND ((Coalesce(h_cost_amount, 0) <> 0.00) 
            OR (Coalesce(h_revenue_amount, 0) <> 0.00)) Then
         BEGIN
            INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, RESOURCE_ID, COST_CENTER_ID,
            ACTUAL_COST, ACTUAL_REVENUE, COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT,
            COST_CHARGE_AMOUNT, REVENUE_CHARGE_AMOUNT)
            VALUES(SYS_GUID(), h_project_id, h_resource_id, h_cost_center_id,
            h_cost_amount, h_revenue_amount,
            10000, 10000, h_cost_amount, 0.00);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER(105) : cost_back.sql(364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag := 0;
         BEGIN
            SELECT COUNT(*) INTO h_bitflag
            FROM PROJECT_COST_CENTERS
            WHERE PROJECT_ID = h_project_id
            AND COST_CENTER_ID = h_cost_center_id
            AND RESOURCE_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER', 122+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER(123) : cost_back.sql(382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
               COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
               VALUES(SYS_GUID(), h_project_id, h_cost_center_id, 0, 0);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER', 142+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER(143) : cost_back.sql(402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_PRJ_REC_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_PRJ_RES_COST_CENTER', 157+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_PRJ_RES_COST_CENTER(158) : cost_back.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_PRJ_RES_COST_CENTER', 163+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_PRJ_RES_COST_CENTER(164) : cost_back.sql(423) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER;
ALTER FUNCTION FC_UPDATE_PRJ_RES_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

-- Insert labor reconciliation by assignment by week_of

/*****************************************************************************************/

Prompt == FUNCTION FC_INS_LABOR_RCCLT_BY_PERCENT ==
CREATE OR REPLACE FUNCTION FC_INS_LABOR_RCCLT_BY_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , h_foreign_date IN OUT NOCOPY DATE
   , sh_h_regular_hrs PLS_INTEGER
   , sh_h_special_hrs PLS_INTEGER
   , sh_h_regular_cost NUMBER
   , sh_h_special_cost NUMBER
   , sh_h_charge_percent PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_regular_hrs PLS_INTEGER := sh_h_regular_hrs;
   h_special_hrs PLS_INTEGER := sh_h_special_hrs;
   h_regular_cost NUMBER := sh_h_regular_cost;
   h_special_cost NUMBER := sh_h_special_cost;
   h_charge_percent PLS_INTEGER := sh_h_charge_percent;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_cost_center_id1 VARCHAR2(32);
   h_cost_percent PLS_INTEGER := 0;
   h_revenue_percent PLS_INTEGER := 0;
   h_regular_remaining NUMBER := 0;
   h_special_remaining NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INS_LABOR_RCCLT_BY_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INS_LABOR_RCCLT_BY_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_INS_LABOR_RCCLT_BY_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_foreign_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_regular_hrs), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_special_hrs), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_special_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_charge_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INS_LABOR_RCCLT_BY_PERCENT', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INS_LABOR_RCCLT_BY_PERCENT(50) : cost_back.sql(487) : ' || SYSTIMESTAMP);
   END IF; 

   h_regular_remaining := 0.00;
   h_special_remaining := 0.00;
   h_regular_remaining := Coalesce(h_regular_hrs, 0) * (1 - (Coalesce(h_charge_percent, 0) / 10000.00));
   h_special_remaining := Coalesce(h_special_hrs, 0) * (1 - (Coalesce(h_charge_percent, 0) / 10000.00));
   
   -- update total and default hours for resource's default cost center
   If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_LABOR Then
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_TOTAL_QUANTITY = h_regular_hrs,
         SPECIAL_TOTAL_QUANTITY = h_special_hrs,
         REGULAR_DEFAULT_QUANTITY = (h_regular_hrs - h_regular_remaining),
         SPECIAL_DEFAULT_QUANTITY = (h_special_hrs - h_special_remaining),
         REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         REGULAR_RATE = h_regular_cost,
         SPECIAL_RATE = h_special_cost,
         TYPE_ID = h_capital_expense,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE (h_regular_hrs - h_regular_remaining) END, 
         ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_regular_cost END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE (h_special_hrs - h_special_remaining) END, 
         ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE ELSE h_special_cost END,
         REC_DATETIME = h_rec_datetime
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_tsk_assignment_id
         AND FOREIGN_DATE = h_foreign_date
         AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND COST_CENTER_ID = h_cost_center_id
         AND DEFAULT_LABOR_FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INS_LABOR_RCCLT_BY_PERCENT', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INS_LABOR_RCCLT_BY_PERCENT(93) : cost_back.sql(530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_TOTAL_QUANTITY = h_regular_hrs,
         SPECIAL_TOTAL_QUANTITY = h_special_hrs,
         REGULAR_DEFAULT_QUANTITY = (h_regular_hrs - h_regular_remaining),
         SPECIAL_DEFAULT_QUANTITY = (h_special_hrs - h_special_remaining),
         REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         REGULAR_RATE = h_regular_cost,
         SPECIAL_RATE = h_special_cost,
         TYPE_ID = h_capital_expense,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
         ELSE (h_regular_hrs - h_regular_remaining) END, 
         ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
         ELSE h_regular_cost END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY
         ELSE (h_special_hrs - h_special_remaining) END, 
         ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE
         ELSE h_special_cost END,
         REC_DATETIME = h_rec_datetime
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_tsk_assignment_id
         AND FOREIGN_DATE = h_foreign_date
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND COST_CENTER_ID = h_cost_center_id
         AND DEFAULT_LABOR_FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INS_LABOR_RCCLT_BY_PERCENT', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INS_LABOR_RCCLT_BY_PERCENT(135) : cost_back.sql(572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
         RESOURCE_ID, FOREIGN_DATE, WEEK_OF, FOREIGN_TABLE, TYPE_ID,
         COST_CENTER_ID, DEFAULT_LABOR_FLAG,
         REGULAR_TOTAL_QUANTITY, REGULAR_DEFAULT_QUANTITY, REGULAR_RATE,
         SPECIAL_TOTAL_QUANTITY, SPECIAL_DEFAULT_QUANTITY, SPECIAL_RATE,
         ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
         ADJ_SPECIAL_QUANTITY, ADJ_SPECIAL_RATE,
         REC_DATETIME, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_tsk_assignment_id,
         h_resource_id, h_foreign_date, h_week_of, PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS, h_capital_expense,
         h_cost_center_id, 1,
         h_regular_hrs, (h_regular_hrs - h_regular_remaining), h_regular_cost,
         h_special_hrs, (h_special_hrs - h_special_remaining), h_special_cost,
         (h_regular_hrs - h_regular_remaining), h_regular_cost,
         (h_special_hrs - h_special_remaining), h_special_cost,
         h_rec_datetime, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INS_LABOR_RCCLT_BY_PERCENT', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INS_LABOR_RCCLT_BY_PERCENT(169) : cost_back.sql(606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INS_LABOR_RCCLT_BY_PERCENT', 175+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INS_LABOR_RCCLT_BY_PERCENT(176) : cost_back.sql(613) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INS_LABOR_RCCLT_BY_PERCENT;
ALTER FUNCTION FC_INS_LABOR_RCCLT_BY_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

-- Distribute remaining labor

/*****************************************************************************************/

Prompt == FUNCTION FC_DISTRIBUTE_REMAINING_LABOR ==
CREATE OR REPLACE FUNCTION FC_DISTRIBUTE_REMAINING_LABOR
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_foreign_date IN OUT NOCOPY DATE
   , sh_h_regular_cost NUMBER
   , sh_h_special_cost NUMBER
   , sh_h_capital_expense PLS_INTEGER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_regular_cost NUMBER := sh_h_regular_cost;
   h_special_cost NUMBER := sh_h_special_cost;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_cost_center_id1 VARCHAR2(32);
   h_cost_percent PLS_INTEGER := 0;
   h_revenue_percent PLS_INTEGER := 0;
   h_regular_remaining NUMBER := 0;
   h_special_remaining NUMBER := 0;
   h_week_of DATE;
-- Declare Cursors
      CURSOR C_PRJ_CC IS
         SELECT COST_CENTER_ID,
         CASE WHEN h_capital_expense = PMO_CNST.SC_BENEFIT_LABOR THEN LABOR_REVENUE_PERCENT ELSE LABOR_COST_PERCENT END
         FROM PROJECT_COST_CENTERS
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID IS NOT NuLL
         AND RESOURCE_ID IS NuLL
         AND CASE WHEN h_capital_expense = PMO_CNST.SC_BENEFIT_LABOR THEN LABOR_REVENUE_PERCENT ELSE LABOR_COST_PERCENT END > 0.00;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DISTRIBUTE_REMAINING_LABOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DISTRIBUTE_REMAINING_LABOR'), '-- ' || SYSTIMESTAMP, ':r := FC_DISTRIBUTE_REMAINING_LABOR(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_foreign_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_special_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DISTRIBUTE_REMAINING_LABOR', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DISTRIBUTE_REMAINING_LABOR(48) : cost_back.sql(675) : ' || SYSTIMESTAMP);
   END IF; 

   -- distributing the remaining to project's labor cost centers
   
   OPEN C_PRJ_CC;
   
   LOOP
      FETCH C_PRJ_CC INTO h_cost_center_id1, h_cost_percent;
      IF C_PRJ_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_LABOR Then
         BEGIN
            SELECT SUM(REGULAR_TOTAL_QUANTITY - REGULAR_DEFAULT_QUANTITY),
            SUM(SPECIAL_TOTAL_QUANTITY - SPECIAL_DEFAULT_QUANTITY), MAX(WEEK_OF)
            INTO h_regular_remaining, h_special_remaining, h_week_of
            FROM PROJECT_RECONCILIATION
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_foreign_date
            AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
            AND DEFAULT_LABOR_FLAG = 1
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DISTRIBUTE_REMAINING_LABOR', 84+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DISTRIBUTE_REMAINING_LABOR(85) : cost_back.sql(712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_regular_remaining * h_cost_percent / 10000,
            SPECIAL_QUANTITY = h_special_remaining * h_cost_percent / 10000,
            REGULAR_RATE = h_regular_cost,
            SPECIAL_RATE = h_special_cost,
            TYPE_ID = h_capital_expense,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_regular_remaining * h_cost_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_regular_cost END,
            ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY
            ELSE (SPECIAL_DEFAULT_QUANTITY + h_special_remaining * h_cost_percent / 10000) END, 
            ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE
            ELSE h_special_cost END,
            REC_DATETIME = h_rec_datetime
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_foreign_date
            AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
            AND COST_CENTER_ID = h_cost_center_id1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DISTRIBUTE_REMAINING_LABOR', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DISTRIBUTE_REMAINING_LABOR(122) : cost_back.sql(749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT SUM(REGULAR_TOTAL_QUANTITY - REGULAR_DEFAULT_QUANTITY),
            SUM(SPECIAL_TOTAL_QUANTITY - SPECIAL_DEFAULT_QUANTITY), MAX(WEEK_OF)
            INTO h_regular_remaining, h_special_remaining, h_week_of
            FROM PROJECT_RECONCILIATION
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_foreign_date
            AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
            AND DEFAULT_LABOR_FLAG = 1
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DISTRIBUTE_REMAINING_LABOR', 143+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DISTRIBUTE_REMAINING_LABOR(144) : cost_back.sql(771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_regular_remaining * h_cost_percent / 10000,
            SPECIAL_QUANTITY = h_special_remaining * h_cost_percent / 10000,
            REGULAR_RATE = h_regular_cost,
            SPECIAL_RATE = h_special_cost,
            TYPE_ID = h_capital_expense,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_regular_remaining * h_cost_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_regular_cost END,
            ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY
            ELSE (SPECIAL_DEFAULT_QUANTITY + h_special_remaining * h_cost_percent / 10000) END, 
            ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE
            ELSE h_special_cost END,
            REC_DATETIME = h_rec_datetime
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_foreign_date
            AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
            AND COST_CENTER_ID = h_cost_center_id1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DISTRIBUTE_REMAINING_LABOR', 180+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DISTRIBUTE_REMAINING_LABOR(181) : cost_back.sql(808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
            RESOURCE_ID, WEEK_OF, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
            COST_CENTER_ID, DEFAULT_LABOR_FLAG,
            REGULAR_QUANTITY, REGULAR_RATE,
            SPECIAL_QUANTITY, SPECIAL_RATE,
            ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
            ADJ_SPECIAL_QUANTITY, ADJ_SPECIAL_RATE,
            REC_DATETIME, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_tsk_assignment_id,
            h_resource_id, h_week_of, h_foreign_date, PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS, h_capital_expense,
            h_cost_center_id1, 0,
            h_regular_remaining * h_cost_percent / 10000, h_regular_cost,
            h_special_remaining * h_cost_percent / 10000, h_special_cost,
            h_regular_remaining * h_cost_percent / 10000, h_regular_cost,
            h_special_remaining * h_cost_percent / 10000, h_special_cost,
            h_rec_datetime, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DISTRIBUTE_REMAINING_LABOR', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DISTRIBUTE_REMAINING_LABOR(215) : cost_back.sql(842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_PRJ_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DISTRIBUTE_REMAINING_LABOR', 228+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DISTRIBUTE_REMAINING_LABOR(229) : cost_back.sql(856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DISTRIBUTE_REMAINING_LABOR', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DISTRIBUTE_REMAINING_LABOR(235) : cost_back.sql(862) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DISTRIBUTE_REMAINING_LABOR;
ALTER FUNCTION FC_DISTRIBUTE_REMAINING_LABOR COMPILE DEBUG;

/*****************************************************************************************/

-- Calculate default labor cost hours

/*****************************************************************************************/

Prompt == FUNCTION FC_CAL_DEFAULT_COST ==
CREATE OR REPLACE FUNCTION FC_CAL_DEFAULT_COST
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , sh_h_max_charge NUMBER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_max_charge NUMBER := sh_h_max_charge;
   h_start_date DATE;
   h_start_date1 DATE;
   h_tsk_assignment_id VARCHAR2(32);
   h_cost_center_id1 VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_regular_rate NUMBER := 0;
   h_special_rate NUMBER := 0;
   h_total_cost NUMBER := 0;
   h_current_cost NUMBER := 0;
   h_count PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C_PER_WEEK IS
         SELECT FOREIGN_DATE, SUM((REGULAR_DEFAULT_QUANTITY * REGULAR_RATE + SPECIAL_DEFAULT_QUANTITY * SPECIAL_RATE) / 60.00)
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND FOREIGN_DATE >= h_week_of
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND COST_CENTER_ID = h_cost_center_id
         AND DEFAULT_LABOR_FLAG = 1
         GROUP BY FOREIGN_DATE;

      CURSOR C_FIX_WEEK IS
         SELECT DISTINCT FOREIGN_DATE, FOREIGN_ID, REGULAR_RATE, SPECIAL_RATE, TYPE_ID
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND FOREIGN_DATE >= h_start_date
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND COST_CENTER_ID = h_cost_center_id
         AND DEFAULT_LABOR_FLAG = 1
         ORDER BY FOREIGN_DATE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CAL_DEFAULT_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CAL_DEFAULT_COST'), '-- ' || SYSTIMESTAMP, ':r := FC_CAL_DEFAULT_COST(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_max_charge), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CAL_DEFAULT_COST', 61+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CAL_DEFAULT_COST(62) : cost_back.sql(938) : ' || SYSTIMESTAMP);
   END IF; 

   h_count := 0;
   BEGIN
      SELECT SUM((REGULAR_DEFAULT_QUANTITY * REGULAR_RATE + SPECIAL_QUANTITY * SPECIAL_RATE) / 60.00),
      COUNT(PROJECT_ID)
      INTO h_total_cost, h_count
      FROM PROJECT_RECONCILIATION
      WHERE PROJECT_ID = h_project_id
      AND RESOURCE_ID = h_resource_id
      AND FOREIGN_DATE < h_week_of
      AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
      AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
      AND COST_CENTER_ID = h_cost_center_id
      AND DEFAULT_LABOR_FLAG = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_COST', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_COST(84) : cost_back.sql(960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) Then
      h_total_cost := 0.00;
   End If;
   
   If Coalesce(h_total_cost, 0) < Coalesce(h_max_charge, 0) Then
      OPEN C_PER_WEEK;
      
      h_current_cost := 0.00;
      LOOP
         FETCH C_PER_WEEK INTO h_start_date, h_current_cost;
         IF C_PER_WEEK%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If (Coalesce(h_total_cost, 0) + Coalesce(h_current_cost, 0)) > Coalesce(h_max_charge, 0) Then
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REGULAR_DEFAULT_QUANTITY = REGULAR_DEFAULT_QUANTITY * (h_max_charge - h_total_cost) / h_current_cost,
               SPECIAL_DEFAULT_QUANTITY = SPECIAL_DEFAULT_QUANTITY * (h_max_charge - h_total_cost) / h_current_cost,
               ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE (REGULAR_DEFAULT_QUANTITY * (h_max_charge - h_total_cost) / h_current_cost) END, 
               ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE (SPECIAL_DEFAULT_QUANTITY * (h_max_charge - h_total_cost) / h_current_cost) END
               WHERE PROJECT_ID = h_project_id
               AND RESOURCE_ID = h_resource_id
               AND FOREIGN_DATE = h_start_date
               AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
               AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
               AND COST_CENTER_ID = h_cost_center_id
               AND DEFAULT_LABOR_FLAG = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_COST', 132+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_COST(133) : cost_back.sql(1009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            EXIT;
         Else
            h_total_cost := Coalesce(h_total_cost, 0) + Coalesce(h_current_cost, 0);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_PER_WEEK ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_COST', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_COST(151) : cost_back.sql(1027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_start_date := h_week_of;
   End If;
   
   OPEN C_FIX_WEEK;
   
   LOOP
      FETCH C_FIX_WEEK INTO h_start_date1, h_tsk_assignment_id,
      h_regular_rate, h_special_rate, h_capital_expense;
      IF C_FIX_WEEK%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      null_return := FC_DISTRIBUTE_REMAINING_LABOR(h_project_id, h_resource_id, h_tsk_assignment_id
                                             , h_start_date1, h_regular_rate, h_special_rate
                                             , h_capital_expense, h_rec_datetime, h_rec_user);
      
   END LOOP;
   BEGIN
      CLOSE C_FIX_WEEK ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_COST', 186+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_COST(187) : cost_back.sql(1063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CAL_DEFAULT_COST', 192+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CAL_DEFAULT_COST(193) : cost_back.sql(1069) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CAL_DEFAULT_COST;
ALTER FUNCTION FC_CAL_DEFAULT_COST COMPILE DEBUG;

/*****************************************************************************************/

-- Calculate default labor revenue hours

/*****************************************************************************************/

Prompt == FUNCTION FC_CAL_DEFAULT_REVENUE ==
CREATE OR REPLACE FUNCTION FC_CAL_DEFAULT_REVENUE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , sh_h_max_charge NUMBER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_max_charge NUMBER := sh_h_max_charge;
   h_start_date DATE;
   h_start_date1 DATE;
   h_tsk_assignment_id VARCHAR2(32);
   h_cost_center_id1 VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_regular_rate NUMBER := 0;
   h_special_rate NUMBER := 0;
   h_total_cost NUMBER := 0;
   h_current_cost NUMBER := 0;
   h_count PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C_PER_WEEK_r IS
         SELECT FOREIGN_DATE, SUM((REGULAR_QUANTITY * REGULAR_RATE + SPECIAL_QUANTITY * SPECIAL_RATE) / 60.00)
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND FOREIGN_DATE >= h_week_of
         AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND COST_CENTER_ID = h_cost_center_id
         AND DEFAULT_LABOR_FLAG = 1
         GROUP BY FOREIGN_DATE;

      CURSOR C_FIX_WEEK_r IS
         SELECT DISTINCT FOREIGN_DATE, FOREIGN_ID, REGULAR_RATE, SPECIAL_RATE, TYPE_ID
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND FOREIGN_DATE >= h_start_date
         AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND COST_CENTER_ID = h_cost_center_id
         AND DEFAULT_LABOR_FLAG = 1
         ORDER BY FOREIGN_DATE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CAL_DEFAULT_REVENUE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CAL_DEFAULT_REVENUE'), '-- ' || SYSTIMESTAMP, ':r := FC_CAL_DEFAULT_REVENUE(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_max_charge), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CAL_DEFAULT_REVENUE', 61+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CAL_DEFAULT_REVENUE(62) : cost_back.sql(1145) : ' || SYSTIMESTAMP);
   END IF; 

   h_count := 0;
   BEGIN
      SELECT SUM((REGULAR_QUANTITY * REGULAR_RATE + SPECIAL_QUANTITY * SPECIAL_RATE) / 60.00),
      COUNT(PROJECT_ID)
      INTO h_total_cost, h_count
      FROM PROJECT_RECONCILIATION
      WHERE PROJECT_ID = h_project_id
      AND RESOURCE_ID = h_resource_id
      AND FOREIGN_DATE < h_week_of
      AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
      AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
      AND COST_CENTER_ID = h_cost_center_id
      AND DEFAULT_LABOR_FLAG = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_REVENUE', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_REVENUE(84) : cost_back.sql(1167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) Then
      h_total_cost := 0.00;
   End If;
   
   If Coalesce(h_total_cost, 0) < Coalesce(h_max_charge, 0) Then
      OPEN C_PER_WEEK_r;
      
      h_current_cost := 0.00;
      LOOP
         FETCH C_PER_WEEK_r INTO h_start_date, h_current_cost;
         IF C_PER_WEEK_r%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If (Coalesce(h_total_cost, 0) + Coalesce(h_current_cost, 0)) > Coalesce(h_max_charge, 0) Then
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REGULAR_DEFAULT_QUANTITY = REGULAR_DEFAULT_QUANTITY * (h_max_charge - h_total_cost) / h_current_cost,
               SPECIAL_DEFAULT_QUANTITY = SPECIAL_DEFAULT_QUANTITY * (h_max_charge - h_total_cost) / h_current_cost
               WHERE PROJECT_ID = h_project_id
               AND RESOURCE_ID = h_resource_id
               AND FOREIGN_DATE = h_start_date
               AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
               AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
               AND COST_CENTER_ID = h_cost_center_id
               AND DEFAULT_LABOR_FLAG = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_REVENUE', 130+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_REVENUE(131) : cost_back.sql(1214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            EXIT;
         Else
            h_total_cost := Coalesce(h_total_cost, 0) + Coalesce(h_current_cost, 0);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_PER_WEEK_r ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_REVENUE', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_REVENUE(149) : cost_back.sql(1232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_start_date := h_week_of;
   End If;
   
   OPEN C_FIX_WEEK_r;
   
   LOOP
      FETCH C_FIX_WEEK_r INTO h_start_date1, h_tsk_assignment_id,
      h_regular_rate, h_special_rate, h_capital_expense;
      IF C_FIX_WEEK_r%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      null_return := FC_DISTRIBUTE_REMAINING_LABOR(h_project_id, h_resource_id, h_tsk_assignment_id
                                             , h_start_date1, h_regular_rate, h_special_rate
                                             , h_capital_expense, h_rec_datetime, h_rec_user);
   END LOOP;
   BEGIN
      CLOSE C_FIX_WEEK_r ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_DEFAULT_REVENUE', 183+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_DEFAULT_REVENUE(184) : cost_back.sql(1267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CAL_DEFAULT_REVENUE', 189+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CAL_DEFAULT_REVENUE(190) : cost_back.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CAL_DEFAULT_REVENUE;
ALTER FUNCTION FC_CAL_DEFAULT_REVENUE COMPILE DEBUG;

/*****************************************************************************************/

-- rollup labor actual to PROJECT_COST_CENTERS

/*****************************************************************************************/

Prompt == FUNCTION FC_I_BY_WEEK ==
CREATE OR REPLACE FUNCTION FC_I_BY_WEEK
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_week_of IN OUT NOCOPY DATE
   , h_foreign_date IN OUT NOCOPY DATE
   , sh_h_regular_hrs PLS_INTEGER
   , sh_h_special_hrs PLS_INTEGER
   , sh_h_regular_cost NUMBER
   , sh_h_special_cost NUMBER
   , sh_h_max_charge NUMBER
   , sh_h_charge_percent PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_regular_hrs PLS_INTEGER := sh_h_regular_hrs;
   h_special_hrs PLS_INTEGER := sh_h_special_hrs;
   h_regular_cost NUMBER := sh_h_regular_cost;
   h_special_cost NUMBER := sh_h_special_cost;
   h_max_charge NUMBER := sh_h_max_charge;
   h_charge_percent PLS_INTEGER := sh_h_charge_percent;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_BY_WEEK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_BY_WEEK'), '-- ' || SYSTIMESTAMP, ':r := FC_I_BY_WEEK(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_foreign_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_regular_hrs), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_special_hrs), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_special_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_max_charge), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_charge_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_BY_WEEK', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_BY_WEEK(49) : cost_back.sql(1336) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_max_charge, 0) = 0.00) OR (Coalesce(h_charge_percent, 0) > 0) Then
      null_return := FC_INS_LABOR_RCCLT_BY_PERCENT(h_project_id, h_resource_id, h_cost_center_id
                                             , h_tsk_assignment_id, h_week_of, h_foreign_date
                                             , h_regular_hrs, h_special_hrs, h_regular_cost
                                             , h_special_cost, h_charge_percent, h_capital_expense
                                             , h_rec_datetime, h_rec_user);
      
      null_return := FC_DISTRIBUTE_REMAINING_LABOR(h_project_id, h_resource_id, h_tsk_assignment_id
                                             , h_foreign_date, h_regular_cost, h_special_cost
                                             , h_capital_expense, h_rec_datetime, h_rec_user);
   Else
      h_charge_percent := 10000;
      
      null_return := FC_INS_LABOR_RCCLT_BY_PERCENT(h_project_id, h_resource_id, h_cost_center_id
                                             , h_tsk_assignment_id, h_week_of, h_foreign_date
                                             , h_regular_hrs, h_special_hrs, h_regular_cost
                                             , h_special_cost, h_charge_percent, h_capital_expense
                                             , h_rec_datetime, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_BY_WEEK', 72+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_BY_WEEK(73) : cost_back.sql(1360) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_BY_WEEK;
ALTER FUNCTION FC_I_BY_WEEK COMPILE DEBUG;

/*****************************************************************************************/

-- rollup labor actual to PROJECT_COST_CENTERS

/*****************************************************************************************/

Prompt == FUNCTION FC_ROLLUP_LABOR_COST_CENTER ==
CREATE OR REPLACE FUNCTION FC_ROLLUP_LABOR_COST_CENTER
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_rollup_all PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rollup_all PLS_INTEGER := sh_h_rollup_all;
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_prev_resource_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_cost_center_id1 VARCHAR2(32);
   h_prev_cost_center_id VARCHAR2(32);
   h_prev_cost_center_id1 VARCHAR2(32);
   h_prev_tsk_assignment_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_cost_center_bits PLS_INTEGER := 0;
   h_prev_week_of DATE;
   h_prev_week_of1 DATE;
   h_week_of DATE;
   h_week_of1 DATE;
   h_prev_start_date DATE;
   h_start_date DATE;
   h_finish_date DATE;
   h_start_date1 DATE;
   h_finish_date1 DATE;
   h_fiscal_year PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_fiscal_year1 PLS_INTEGER := 0;
   h_fiscal_month1 PLS_INTEGER := 0;
   h_regular_hrs PLS_INTEGER := 0;
   h_special_hrs PLS_INTEGER := 0;
   h_month1_regular_hrs PLS_INTEGER := 0;
   h_month1_special_hrs PLS_INTEGER := 0;
   h_month2_regular_hrs PLS_INTEGER := 0;
   h_month2_special_hrs PLS_INTEGER := 0;
   h_b_regular_hrs PLS_INTEGER := 0;
   h_b_special_hrs PLS_INTEGER := 0;
   h_month1_b_regular_hrs PLS_INTEGER := 0;
   h_month1_b_special_hrs PLS_INTEGER := 0;
   h_month2_b_regular_hrs PLS_INTEGER := 0;
   h_month2_b_special_hrs PLS_INTEGER := 0;
   h_regular_cost NUMBER := 0;
   h_special_cost NUMBER := 0;
   h_regular_rate NUMBER := 0;
   h_special_rate NUMBER := 0;
   h_cost_amount NUMBER := 0;
   h_revenue_amount NUMBER := 0;
   h_cost_amount1 NUMBER := 0;
   h_revenue_amount1 NUMBER := 0;
   h_ws_cost_amount NUMBER := 0;
   h_ws_revenue_amount NUMBER := 0;
   h_ws_cost_amount1 NUMBER := 0;
   h_ws_revenue_amount1 NUMBER := 0;
   h_total_cost NUMBER := 0;
   h_rec_datetime TIMESTAMP;
   h_cost_charge_percent PLS_INTEGER := 0;
   h_max_cost_charge NUMBER := 0;
   h_revenue_charge_percent PLS_INTEGER := 0;
   h_max_revenue_charge NUMBER := 0;
   h_cost_charge_percent1 PLS_INTEGER := 0;
   h_max_cost_charge1 NUMBER := 0;
   h_revenue_charge_percent1 PLS_INTEGER := 0;
   h_max_revenue_charge1 NUMBER := 0;
   h_charge_percent PLS_INTEGER := 0;
   isChanged PLS_INTEGER NOT NULL := 0;
   isByPercent PLS_INTEGER NOT NULL := 0;
   isByPercent1 PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C_DELETED_TS IS
         SELECT RESOURCE_ID, COST_CENTER_ID, TYPE_ID,
         SUM((REGULAR_TOTAL_QUANTITY * REGULAR_RATE) + (SPECIAL_TOTAL_QUANTITY * SPECIAL_RATE)),
         SUM((REGULAR_DEFAULT_QUANTITY * REGULAR_RATE) + (SPECIAL_DEFAULT_QUANTITY * SPECIAL_RATE)),
         SUM((REGULAR_QUANTITY * REGULAR_RATE) + (SPECIAL_QUANTITY * SPECIAL_RATE))
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND REC_STATUS = 'X'
         AND REC_DATETIME = h_rec_datetime
         GROUP BY RESOURCE_ID, COST_CENTER_ID, TYPE_ID;

      CURSOR C_RES_CC IS
         SELECT S.MONTH1_REGULAR_HRS, S.MONTH1_SPECIAL_HRS, S.MONTH2_REGULAR_HRS, S.MONTH2_SPECIAL_HRS,
         S.MONTH1_B_REGULAR_HRS, S.MONTH1_B_SPECIAL_HRS, S.MONTH2_B_REGULAR_HRS, S.MONTH2_B_SPECIAL_HRS,
         S.ACTUAL_REGULAR_COST, S.ACTUAL_SPECIAL_COST, S.ACTUAL_REGULAR_RATE, S.ACTUAL_SPECIAL_RATE,
         S.WEEK_OF, S.TSK_ASSIGNMENT_ID, TA.CAPITAL_EXPENSE, S.RESOURCE_ID, S.COST_CENTER_BITS
         FROM SUMMARY_TIMESHEETS S, TASK_ASSIGNMENTS TA
         WHERE S.PROJECT_ID = h_project_id
         AND ((h_rollup_all = 1) OR (h_bitflag = 1 AND S.COST_CENTER_BITS > 0) OR S.RESOURCE_ID = h_resource_id)
         AND TA.PROJECT_ID = S.PROJECT_ID
         AND TA.TSK_ASSIGNMENT_ID = S.TSK_ASSIGNMENT_ID
         ORDER BY S.RESOURCE_ID, S.WEEK_OF, S.TSK_ASSIGNMENT_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ROLLUP_LABOR_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ROLLUP_LABOR_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := FC_ROLLUP_LABOR_COST_CENTER(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_rollup_all), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_LABOR_COST_CENTER', 107+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ROLLUP_LABOR_COST_CENTER(108) : cost_back.sql(1482) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_resource_id, SC_H_ID);
   
   BEGIN
      SELECT SYSTIMESTAMP INTO h_rec_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 120+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(121) : cost_back.sql(1495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PROJECT_RECONCILIATION
      SET REC_DATETIME = h_rec_datetime,
      REC_STATUS = 'X'
      WHERE PROJECT_ID = h_project_id
      AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
      AND REC_STATUS = 'D';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 142+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(143) : cost_back.sql(1517) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      isChanged := 1;
      
      OPEN C_DELETED_TS;
      
      LOOP
         FETCH C_DELETED_TS INTO h_prev_resource_id, h_cost_center_id,
         h_capital_expense, h_total_cost, h_cost_amount, h_cost_amount1;
         IF C_DELETED_TS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         h_total_cost := (Coalesce(h_total_cost, 0) / 60.0);
         h_cost_amount := (Coalesce(h_cost_amount, 0) / 60.0);
         h_cost_amount1 := (Coalesce(h_cost_amount1, 0) / 60.0);
         
         --trace_printf("h_total_cost: %d, %.2f\n", h_total_cost_Ind, h_total_cost);
         --trace_printf("h_cost_amount: %d, %.2f\n", h_cost_amount_Ind, h_cost_amount);
         --trace_printf("h_cost_amount1: %d, %.2f\n", h_cost_amount1_Ind, h_cost_amount1);
         --trace_printf("h_prev_resource_id: %d, %s\n", h_prev_resource_id_Ind, h_prev_resource_id);
         --trace_printf("h_cost_center_id: %d, %s\n", h_cost_center_id_Ind, h_cost_center_id);
         --trace_printf("h_capital_expense: %d, %d\n", h_capital_expense_Ind, h_capital_expense);
         
         If (Coalesce(h_cost_amount, 0) + Coalesce(h_cost_amount1, 0) + Coalesce(h_total_cost, 0)) > 0.0 Then
            If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR) OR (Coalesce(
                  h_capital_expense, 0) = PMO_CNST.SC_CAPITAL_LABOR) Then
               BEGIN
                  UPDATE PROJECT_COST_CENTERS
                  SET ACTUAL_COST = ACTUAL_COST - h_total_cost,
                  COST_CHARGE_AMOUNT = COST_CHARGE_AMOUNT - h_cost_amount
                  WHERE PROJECT_ID = h_project_id
                  AND RESOURCE_ID = h_prev_resource_id
                  AND COST_CENTER_ID = h_cost_center_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 196+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(197) : cost_back.sql(1571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE PROJECT_COST_CENTERS
                  SET ACTUAL_COST = ACTUAL_COST - (h_cost_amount + h_cost_amount1),
                  COST_CHARGE_AMOUNT = COST_CHARGE_AMOUNT - h_cost_amount,
                  LABOR_COST = LABOR_COST - h_cost_amount1
                  WHERE PROJECT_ID = h_project_id
                  AND COST_CENTER_ID = h_cost_center_id
                  AND RESOURCE_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 219+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(220) : cost_back.sql(1594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PROJECT_COST_CENTERS
                  SET ACTUAL_REVENUE = ACTUAL_REVENUE - h_cost_amount,
                  REVENUE_CHARGE_AMOUNT = REVENUE_CHARGE_AMOUNT - h_cost_amount
                  WHERE PROJECT_ID = h_project_id
                  AND RESOURCE_ID = h_prev_resource_id
                  AND COST_CENTER_ID = h_cost_center_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 241+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(242) : cost_back.sql(1616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE PROJECT_COST_CENTERS
                  SET ACTUAL_REVENUE = ACTUAL_REVENUE - (h_cost_amount + h_cost_amount1),
                  REVENUE_CHARGE_AMOUNT = REVENUE_CHARGE_AMOUNT - h_cost_amount,
                  LABOR_REVENUE = LABOR_REVENUE - h_cost_amount1
                  WHERE PROJECT_ID = h_project_id
                  AND COST_CENTER_ID = h_cost_center_id
                  AND RESOURCE_ID IS NuLL;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 264+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(265) : cost_back.sql(1639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_DELETED_TS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 279+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(280) : cost_back.sql(1654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND REC_STATUS = 'X'
         AND REC_DATETIME = h_rec_datetime;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 300+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(301) : cost_back.sql(1675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_resource_id IS NULL) Then
      h_resource_id := 'NotExistingID';
      h_bitflag := 1;
   Else
      h_bitflag := 0;
   End If;
   
   --trace_printf("h_bitflag: %d\n", h_bitflag);
   
   OPEN C_RES_CC;
   
   h_cost_amount := 0.00;
   h_revenue_amount := 0.00;
   h_cost_amount1 := 0.00;
   h_revenue_amount1 := 0.00;
   h_prev_cost_center_id := '';
   h_prev_start_date := '';
   h_prev_week_of := '';
   h_prev_week_of1 := '';
   h_prev_resource_id := '';
   
   LOOP
      FETCH C_RES_CC INTO h_month1_regular_hrs, h_month1_special_hrs,
      h_month2_regular_hrs, h_month2_special_hrs,
      h_month1_b_regular_hrs, h_month1_b_special_hrs,
      h_month2_b_regular_hrs, h_month2_b_special_hrs,
      h_regular_cost, h_special_cost,
      h_regular_rate, h_special_rate,
      h_week_of, h_tsk_assignment_id, h_capital_expense,
      h_resource_id, h_cost_center_bits;
      IF C_RES_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      isChanged := 1;
      
      If (PMO_ORASTD.strcmp(h_prev_resource_id, h_resource_id) <> 0) OR (PMO_ORASTD.strcmp(h_prev_week_of
            , h_week_of) <> 0) Then
         If Coalesce(Length(h_prev_resource_id), 0) > 0 Then
            If (Coalesce(h_cost_charge_percent, 0) = 0) AND (Coalesce(h_max_cost_charge, 0) > 0.00) Then
               null_return := FC_CAL_DEFAULT_COST(h_project_id, h_prev_resource_id, h_cost_center_id
                                   , h_prev_week_of, h_max_cost_charge, h_rec_datetime, h_rec_user);
            End If;
            
            If PMO_ORASTD.strcmp(h_prev_week_of, h_prev_week_of1) <> 0 Then
               If (PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) = 0) AND (Coalesce(
                     h_cost_charge_percent, 0) = 0) AND (Coalesce(h_max_cost_charge, 0) > 0.00) Then
                  null_return := FC_CAL_DEFAULT_COST(h_project_id, h_prev_resource_id, h_cost_center_id
                                   , h_prev_week_of1, h_max_cost_charge, h_rec_datetime, h_rec_user);
               ElsIf (PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) <> 0) AND ((Coalesce(
                     h_cost_charge_percent1, 0) = 0) AND (Coalesce(
                     h_max_cost_charge1, 0) > 0.00)) Then
                  null_return := FC_CAL_DEFAULT_COST(h_project_id, h_prev_resource_id, h_cost_center_id1
                                   , h_prev_week_of1, h_max_cost_charge1, h_rec_datetime
                                   , h_rec_user);
               End If;
            End If;
            
            If (Coalesce(h_revenue_charge_percent, 0) = 0) AND (Coalesce(h_max_revenue_charge, 0) > 0.00) Then
               null_return := FC_CAL_DEFAULT_REVENUE(h_project_id, h_prev_resource_id, h_cost_center_id
                                      , h_prev_week_of, h_max_revenue_charge, h_rec_datetime
                                      , h_rec_user);
            End If;
            
            If PMO_ORASTD.strcmp(h_prev_week_of, h_prev_week_of1) <> 0 Then
               If (PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) = 0) AND ((Coalesce(
                     h_revenue_charge_percent, 0) = 0) AND (Coalesce(
                     h_max_revenue_charge, 0) > 0.00)) Then
                  null_return := FC_CAL_DEFAULT_REVENUE(h_project_id, h_prev_resource_id, h_cost_center_id
                                      , h_prev_week_of1, h_max_revenue_charge, h_rec_datetime
                                      , h_rec_user);
               ElsIf (PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) <> 0) AND ((Coalesce(
                     h_revenue_charge_percent1, 0) = 0) AND (Coalesce(
                     h_max_revenue_charge1, 0) > 0.00)) Then
                  null_return := FC_CAL_DEFAULT_REVENUE(h_project_id, h_prev_resource_id, h_cost_center_id1
                                      , h_prev_week_of, h_max_revenue_charge1, h_rec_datetime
                                      , h_rec_user);
               End If;
            End If;
            
            If PMO_ORASTD.strcmp(h_prev_resource_id, h_resource_id) <> 0 Then
               null_return := FC_UPDATE_PRJ_RES_COST_CENTER(h_project_id, h_prev_resource_id, h_rec_datetime
                                             , h_rec_user);
            End If;
         End If;
         
         -- varify the week crossing two months
         BEGIN
            SELECT START_DATE, FINISH_DATE, TO_DATE(SubStr(h_week_of, 1, 10)) + 6      
            INTO h_start_date, h_finish_date, h_week_of1
            FROM FISCAL_CALENDAR
            WHERE h_week_of BETWEEN START_DATE AND FINISH_DATE;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 410+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(411) : cost_back.sql(1785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strcmp(h_week_of1, h_finish_date) > 0 Then
            BEGIN
               SELECT TO_DATE(SubStr(h_finish_date, 1, 10)) + 1      INTO h_week_of1
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 425+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(426) : cost_back.sql(1800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_week_of1 := h_week_of;
         End If;
         
         --trace_printf("h_week_of: %d, %s\n", h_week_of_Ind, h_week_of);
         --trace_printf("h_week_of1: %d, %s\n", h_week_of1_Ind, h_week_of1);
         BEGIN
            SELECT RC.COST_CENTER_ID, RC.START_DATE, RC.FINISH_DATE
            INTO h_cost_center_id, h_start_date, h_finish_date
            FROM RESOURCE_COST_CENTERS RC
            WHERE RC.RESOURCE_ID = h_resource_id
            AND h_week_of BETWEEN RC.START_DATE AND RC.FINISH_DATE;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 447+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(448) : cost_back.sql(1822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_ORASTD.strcmp(h_prev_resource_id, h_resource_id) <> 0) OR (PMO_ORASTD.strcmp(
               h_prev_cost_center_id, h_cost_center_id) <> 0) Then
            BEGIN
               SELECT COST_CHARGE_PERCENT, MAX_COST_CHARGE,
               REVENUE_CHARGE_PERCENT, MAX_REVENUE_CHARGE
               INTO h_cost_charge_percent, h_max_cost_charge,
               h_revenue_charge_percent, h_max_revenue_charge
               FROM PROJECT_COST_CENTERS
               WHERE PROJECT_ID = h_project_id
               AND RESOURCE_ID = h_resource_id
               AND COST_CENTER_ID = h_cost_center_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 469+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(470) : cost_back.sql(1844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               h_cost_charge_percent := 10000;
               h_max_cost_charge := 0.00;
               h_revenue_charge_percent := 10000;
               h_max_revenue_charge := 0.00;
               
               BEGIN
                  INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
                  RESOURCE_ID, COST_CHARGE_PERCENT, MAX_COST_CHARGE,
                  REVENUE_CHARGE_PERCENT, MAX_REVENUE_CHARGE, REC_USER)
                  VALUES (SYS_GUID(), h_project_id, h_cost_center_id,
                  h_resource_id, h_cost_charge_percent, h_max_cost_charge,
                  h_revenue_charge_percent, h_max_revenue_charge, h_rec_user);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 497+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(498) : cost_back.sql(1872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_count := 0;
               BEGIN
                  SELECT COUNT(*) INTO h_count
                  FROM PROJECT_COST_CENTERS
                  WHERE PROJECT_ID = h_project_id
                  AND COST_CENTER_ID = h_cost_center_id
                  AND RESOURCE_ID IS NuLL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 515+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(516) : cost_back.sql(1890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_count, 0) = 0 Then
                  BEGIN
                     INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
                     COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
                     VALUES(SYS_GUID(), h_project_id, h_cost_center_id, 0, 0);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 535+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(536) : cost_back.sql(1910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
         
         If PMO_ORASTD.strcmp(h_week_of, h_week_of1) <> 0 Then
            BEGIN
               SELECT RC.COST_CENTER_ID, RC.START_DATE, RC.FINISH_DATE
               INTO h_cost_center_id1, h_start_date1, h_finish_date1
               FROM RESOURCE_COST_CENTERS RC
               WHERE RC.RESOURCE_ID = h_resource_id
               AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6      BETWEEN RC.START_DATE AND RC.FINISH_DATE;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 556+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(557) : cost_back.sql(1931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_cost_center_id1 := h_cost_center_id;
         End If;
         
         --trace_printf("h_cost_center_id: %d, %s\n", h_cost_center_id_Ind, h_cost_center_id);
         --trace_printf("h_cost_center_id1: %d, %s\n", h_cost_center_id1_Ind, h_cost_center_id1);
         If PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) <> 0 Then
            If (PMO_ORASTD.strcmp(h_prev_resource_id, h_resource_id) <> 0) OR (PMO_ORASTD.strcmp(
                  h_prev_cost_center_id1, h_cost_center_id1) <> 0) Then
               BEGIN
                  SELECT COST_CHARGE_PERCENT, MAX_COST_CHARGE,
                  REVENUE_CHARGE_PERCENT, MAX_REVENUE_CHARGE
                  INTO h_cost_charge_percent1, h_max_cost_charge1,
                  h_revenue_charge_percent1, h_max_revenue_charge1
                  FROM PROJECT_COST_CENTERS
                  WHERE PROJECT_ID = h_project_id
                  AND RESOURCE_ID = h_resource_id
                  AND COST_CENTER_ID = h_cost_center_id1;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 584+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(585) : cost_back.sql(1959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
                  h_cost_charge_percent1 := 10000;
                  h_max_cost_charge1 := 0.00;
                  h_revenue_charge_percent1 := 10000;
                  h_max_revenue_charge1 := 0.00;
                  
                  BEGIN
                     INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
                     RESOURCE_ID, COST_CHARGE_PERCENT, MAX_COST_CHARGE,
                     REVENUE_CHARGE_PERCENT, MAX_REVENUE_CHARGE, REC_USER)
                     VALUES (SYS_GUID(), h_project_id, h_cost_center_id1,
                     h_resource_id, h_cost_charge_percent1, h_max_cost_charge1,
                     h_revenue_charge_percent1, h_max_revenue_charge1, h_rec_user);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 612+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(613) : cost_back.sql(1987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  h_count := 0;
                  BEGIN
                     SELECT COUNT(*) INTO h_count
                     FROM PROJECT_COST_CENTERS
                     WHERE PROJECT_ID = h_project_id
                     AND COST_CENTER_ID = h_cost_center_id1
                     AND RESOURCE_ID IS NuLL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 630+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(631) : cost_back.sql(2005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_count, 0) = 0 Then
                     BEGIN
                        INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
                        COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
                        VALUES(SYS_GUID(), h_project_id, h_cost_center_id1, 0, 0);
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 650+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(651) : cost_back.sql(2025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               End If;
            End If;
         Else
            h_cost_charge_percent1 := h_cost_charge_percent;
            h_max_cost_charge1 := h_max_cost_charge;
            h_revenue_charge_percent1 := h_revenue_charge_percent;
            h_max_revenue_charge1 := h_max_revenue_charge;
         End If;
         
         h_prev_resource_id := h_resource_id;
         h_prev_cost_center_id := h_cost_center_id;
         h_prev_cost_center_id1 := h_cost_center_id1;
         h_prev_week_of := h_week_of;
         h_prev_week_of1 := h_week_of1;
      End If;
      
      If PMO_ORASTD.strcmp(h_week_of, h_week_of1) = 0 Then
         h_regular_hrs := Coalesce(h_month1_regular_hrs, 0) + Coalesce(h_month2_regular_hrs, 0);
         h_special_hrs := Coalesce(h_month1_special_hrs, 0) + Coalesce(h_month2_special_hrs, 0);
         
         null_return := FC_I_BY_WEEK(h_project_id, h_resource_id, h_cost_center_id, h_tsk_assignment_id
                            , h_week_of, h_week_of, h_regular_hrs, h_special_hrs, h_regular_cost
                            , h_special_cost, h_max_cost_charge, h_cost_charge_percent
                            , h_capital_expense, h_rec_datetime, h_rec_user);
      Else
         h_regular_hrs := h_month1_regular_hrs;
         h_special_hrs := h_month1_special_hrs;
         null_return := FC_I_BY_WEEK(h_project_id, h_resource_id, h_cost_center_id, h_tsk_assignment_id
                            , h_week_of, h_week_of, h_regular_hrs, h_special_hrs, h_regular_cost
                            , h_special_cost, h_max_cost_charge, h_cost_charge_percent
                            , h_capital_expense, h_rec_datetime, h_rec_user);
         
         h_regular_hrs := h_month2_regular_hrs;
         h_special_hrs := h_month2_special_hrs;
         null_return := FC_I_BY_WEEK(h_project_id, h_resource_id, h_cost_center_id1, h_tsk_assignment_id
                            , h_week_of, h_week_of1, h_regular_hrs, h_special_hrs, h_regular_cost
                            , h_special_cost, h_max_cost_charge1, h_cost_charge_percent1
                            , h_capital_expense, h_rec_datetime, h_rec_user);
      End If;
      
      If ((Coalesce(h_month1_b_regular_hrs, 0) + Coalesce(h_month2_b_regular_hrs, 0)) > 0) OR ((Coalesce(
              h_month1_b_special_hrs, 0) + Coalesce(h_month2_b_special_hrs, 0)) > 0) Then
         h_capital_expense := PMO_CNST.SC_BENEFIT_LABOR;
         If PMO_ORASTD.strcmp(h_week_of, h_week_of1) = 0 Then
            h_regular_hrs := Coalesce(h_month1_b_regular_hrs, 0) + Coalesce(h_month2_b_regular_hrs, 0);
            h_special_hrs := Coalesce(h_month1_b_special_hrs, 0) + Coalesce(h_month2_b_special_hrs, 0);
            null_return := FC_I_BY_WEEK(h_project_id, h_resource_id, h_cost_center_id, h_tsk_assignment_id
                            , h_week_of, h_week_of, h_regular_hrs, h_special_hrs, h_regular_rate
                            , h_special_rate, h_max_revenue_charge, h_revenue_charge_percent
                            , h_capital_expense, h_rec_datetime, h_rec_user);
         Else
            h_regular_hrs := h_month1_b_regular_hrs;
            h_special_hrs := h_month1_b_special_hrs;
            null_return := FC_I_BY_WEEK(h_project_id, h_resource_id, h_cost_center_id, h_tsk_assignment_id
                            , h_week_of, h_week_of, h_regular_hrs, h_special_hrs, h_regular_rate
                            , h_special_rate, h_max_revenue_charge, h_revenue_charge_percent
                            , h_capital_expense, h_rec_datetime, h_rec_user);
            
            h_regular_hrs := h_month2_b_regular_hrs;
            h_special_hrs := h_month2_b_special_hrs;
            null_return := FC_I_BY_WEEK(h_project_id, h_resource_id, h_cost_center_id1, h_tsk_assignment_id
                            , h_week_of, h_week_of1, h_regular_hrs, h_special_hrs, h_regular_rate
                            , h_special_rate, h_max_revenue_charge1, h_revenue_charge_percent1
                            , h_capital_expense, h_rec_datetime, h_rec_user);
         End If;
      End If;
      
      If Coalesce(h_cost_center_bits, 0) > 0 Then
         -- convert to cost_center's currency
         BEGIN
            UPDATE SUMMARY_TIMESHEETS
            SET COST_CENTER_BITS = 0
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id
            AND WEEK_OF = h_week_of;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 740+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(741) : cost_back.sql(2115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- PROJECT_RECONCILIATION
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REC_DATETIME = h_rec_datetime
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_week_of
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 764+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(765) : cost_back.sql(2139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) <> 0 Then
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REC_DATETIME = h_rec_datetime
               WHERE PROJECT_ID = h_project_id
               AND FOREIGN_ID = h_tsk_assignment_id
               AND FOREIGN_DATE = h_week_of
               AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
               AND COST_CENTER_ID = h_cost_center_id1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 788+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(789) : cost_back.sql(2163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_RES_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_LABOR_COST_CENTER', 803+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_LABOR_COST_CENTER(804) : cost_back.sql(2178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(Length(h_prev_resource_id), 0) > 0 Then
      If (Coalesce(h_cost_charge_percent, 0) = 0) AND (Coalesce(h_max_cost_charge, 0) > 0.00) Then
         null_return := FC_CAL_DEFAULT_COST(h_project_id, h_prev_resource_id, h_prev_cost_center_id
                                   , h_prev_week_of, h_max_cost_charge, h_rec_datetime, h_rec_user);
      End If;
      
      If (PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) <> 0) AND ((Coalesce(
            h_cost_charge_percent1, 0) = 0) AND (Coalesce(h_max_cost_charge1, 0) > 0.00)) Then
         null_return := FC_CAL_DEFAULT_COST(h_project_id, h_prev_resource_id, h_cost_center_id1
                                   , h_prev_week_of, h_max_cost_charge1, h_rec_datetime, h_rec_user);
      End If;
      
      If (Coalesce(h_revenue_charge_percent, 0) = 0) AND (Coalesce(h_max_revenue_charge, 0) > 0.00) Then
         null_return := FC_CAL_DEFAULT_REVENUE(h_project_id, h_prev_resource_id, h_prev_cost_center_id
                                      , h_prev_week_of, h_max_revenue_charge, h_rec_datetime
                                      , h_rec_user);
      End If;
      
      If (PMO_ORASTD.strcmp(h_cost_center_id, h_cost_center_id1) <> 0) AND ((Coalesce(
            h_revenue_charge_percent1, 0) = 0) AND (Coalesce(h_max_revenue_charge1, 0) > 0.00)) Then
         null_return := FC_CAL_DEFAULT_REVENUE(h_project_id, h_prev_resource_id, h_cost_center_id1
                                      , h_prev_week_of, h_max_revenue_charge1, h_rec_datetime
                                      , h_rec_user);
      End If;
      
      -- fix labor related cost centers
      null_return := FC_UPDATE_PRJ_RES_COST_CENTER(h_project_id, h_prev_resource_id, h_rec_datetime
                                             , h_rec_user);
   End If;
   
   If isChanged = 0 Then
      PMO_DB2M.SC_STATE := PMO_CNST.FS_NOTHING_CHANGED;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_LABOR_COST_CENTER', 843+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ROLLUP_LABOR_COST_CENTER(844) : cost_back.sql(2218) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ROLLUP_LABOR_COST_CENTER;
ALTER FUNCTION FC_ROLLUP_LABOR_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

-- Insert invoice reconciliation

/*****************************************************************************************/

Prompt == FUNCTION FC_INSERT_INVOICE_RCCLT ==
CREATE OR REPLACE FUNCTION FC_INSERT_INVOICE_RCCLT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_invoice_date IN OUT NOCOPY DATE
   , sh_h_quantity NUMBER
   , sh_h_unit_price NUMBER
   , sh_h_tax1_amount NUMBER
   , sh_h_tax2_amount NUMBER
   , sh_h_actual_amount NUMBER
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_quantity NUMBER := sh_h_quantity;
   h_unit_price NUMBER := sh_h_unit_price;
   h_tax1_amount NUMBER := sh_h_tax1_amount;
   h_tax2_amount NUMBER := sh_h_tax2_amount;
   h_actual_amount NUMBER := sh_h_actual_amount;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_cost_center_id VARCHAR2(32);
   h_cost_percent PLS_INTEGER := 0;
   h_total_cost NUMBER := 0;
-- Declare Cursors
      CURSOR C_PRJ_CC_WS IS
         SELECT COST_CENTER_ID,
         CASE WHEN h_capital_expense IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR) THEN WS_REVENUE_PERCENT ELSE WS_COST_PERCENT END
         FROM PROJECT_COST_CENTERS
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID IS NOT NuLL
         AND RESOURCE_ID IS NuLL
         AND CASE WHEN h_capital_expense IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR) THEN WS_REVENUE_PERCENT ELSE WS_COST_PERCENT END > 0.00;

      CURSOR C_PRJ_CC1 IS
         SELECT COST_CENTER_ID,
         CASE WHEN h_capital_expense = PMO_CNST.SC_BENEFIT THEN NON_LABOR_REVENUE_PERCENT ELSE NON_LABOR_COST_PERCENT END
         FROM PROJECT_COST_CENTERS
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID IS NOT NuLL
         AND RESOURCE_ID IS NuLL
         AND CASE WHEN h_capital_expense = PMO_CNST.SC_BENEFIT THEN NON_LABOR_REVENUE_PERCENT ELSE NON_LABOR_COST_PERCENT END > 0.00;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INSERT_INVOICE_RCCLT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INSERT_INVOICE_RCCLT'), '-- ' || SYSTIMESTAMP, ':r := FC_INSERT_INVOICE_RCCLT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_invoice_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_quantity), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_unit_price), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tax1_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_tax2_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_actual_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_INVOICE_RCCLT', 65+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INSERT_INVOICE_RCCLT(66) : cost_back.sql(2298) : ' || SYSTIMESTAMP);
   END IF; 

   h_total_cost := (Coalesce(h_quantity, 0) * Coalesce(h_unit_price, 0)) + Coalesce(h_tax1_amount, 0) 
                          + Coalesce(h_tax2_amount, 0);
   
   If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT) OR (Coalesce(
             h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_LABOR) Then
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = h_quantity,
         REGULAR_RATE = h_unit_price,
         TAX1 = h_tax1_amount,
         TAX2 = h_tax2_amount,
         TYPE_ID = h_capital_expense,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE h_quantity END, 
         ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_unit_price END, 
         ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1 ELSE h_tax1_amount END, 
         ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2 ELSE h_tax2_amount END,
         REC_DATETIME = h_rec_datetime
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_element_id
         AND FOREIGN_DATE = h_invoice_date
         AND TYPE_ID IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR)
         AND FOREIGN_TABLE = h_foreign_table
         AND COST_CENTER_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(102) : cost_back.sql(2334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = h_quantity,
         REGULAR_RATE = h_unit_price,
         TAX1 = h_tax1_amount,
         TAX2 = h_tax2_amount,
         TYPE_ID = h_capital_expense,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE h_quantity END, 
         ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_unit_price END, 
         ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1 ELSE h_tax1_amount END, 
         ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2 ELSE h_tax2_amount END,
         REC_DATETIME = h_rec_datetime
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_element_id
         AND FOREIGN_DATE = h_invoice_date
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
         AND FOREIGN_TABLE = h_foreign_table
         AND COST_CENTER_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(135) : cost_back.sql(2367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND (Coalesce(h_total_cost, 0) > 0.00) Then
      BEGIN
         INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
         RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
         REGULAR_QUANTITY, REGULAR_RATE,
         TAX1, TAX2,
         ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
         ADJ_TAX1, ADJ_TAX2,
         REC_DATETIME, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_element_id,
         h_resource_id, h_invoice_date, h_foreign_table, h_capital_expense,
         h_quantity, h_unit_price,
         h_tax1_amount,
         h_tax2_amount,
         h_quantity, h_unit_price,
         h_tax1_amount,
         h_tax2_amount,
         h_rec_datetime, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(169) : cost_back.sql(2401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_foreign_table, 0) = PMO_CNST.SC_TABLE_PBB Then
      OPEN C_PRJ_CC_WS;
      
      LOOP
         FETCH C_PRJ_CC_WS INTO h_cost_center_id, h_cost_percent;
         IF C_PRJ_CC_WS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT) OR (Coalesce(
               h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_LABOR) Then
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REGULAR_QUANTITY = h_quantity * h_cost_percent / 10000.0,
               SPECIAL_QUANTITY = 0.00,
               REGULAR_RATE = h_unit_price,
               SPECIAL_RATE = 0.00,
               TAX1 = h_tax1_amount * h_cost_percent / 10000,
               TAX2 = h_tax2_amount * h_cost_percent / 10000,
               TYPE_ID = h_capital_expense,
               ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
               ELSE (h_quantity * h_cost_percent / 10000.0) END, 
               ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY 
               ELSE 0.00 END, 
               ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_unit_price END, 
               ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE ELSE 0.00 END, 
               ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1 
               ELSE (h_tax1_amount * h_cost_percent / 10000) END, 
               ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2 
               ELSE (h_tax2_amount * h_cost_percent / 10000) END,
               REC_DATETIME = h_rec_datetime
               WHERE PROJECT_ID = h_project_id
               AND FOREIGN_ID = h_element_id
               AND FOREIGN_DATE = h_invoice_date
               AND TYPE_ID IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR)
               AND FOREIGN_TABLE = h_foreign_table
               AND COST_CENTER_ID = h_cost_center_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 227+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(228) : cost_back.sql(2460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REGULAR_QUANTITY = h_quantity * h_cost_percent / 10000.0,
               SPECIAL_QUANTITY = 0.00,
               REGULAR_RATE = h_unit_price,
               SPECIAL_RATE = 0.00,
               TAX1 = h_tax1_amount * h_cost_percent / 10000,
               TAX2 = h_tax2_amount * h_cost_percent / 10000,
               TYPE_ID = h_capital_expense,
               ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
               ELSE (h_quantity * h_cost_percent / 10000.0) END, 
               ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY 
               ELSE 0.00 END, 
               ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_unit_price END, 
               ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE ELSE 0.00 END, 
               ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1 
               ELSE (h_tax1_amount * h_cost_percent / 10000) END, 
               ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2 
               ELSE (h_tax2_amount * h_cost_percent / 10000) END,
               REC_DATETIME = h_rec_datetime
               WHERE PROJECT_ID = h_project_id
               AND FOREIGN_ID = h_element_id
               AND FOREIGN_DATE = h_invoice_date
               AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
               AND FOREIGN_TABLE = h_foreign_table
               AND COST_CENTER_ID = h_cost_center_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 268+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(269) : cost_back.sql(2501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) AND (Coalesce(h_total_cost, 0) > 0.00) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               TAX1, TAX2,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_TAX1, ADJ_TAX2,
               REC_DATETIME, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id,
               h_resource_id, h_invoice_date, h_foreign_table, h_capital_expense,
               h_cost_center_id, 0,
               h_quantity * h_cost_percent / 10000.0, h_unit_price,
               h_tax1_amount * h_cost_percent / 10000,
               h_tax2_amount * h_cost_percent / 10000,
               h_quantity * h_cost_percent / 10000.0, h_unit_price,
               h_tax1_amount * h_cost_percent / 10000,
               h_tax2_amount * h_cost_percent / 10000,
               h_rec_datetime, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 304+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(305) : cost_back.sql(2537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_PRJ_CC_WS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 318+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(319) : cost_back.sql(2551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      OPEN C_PRJ_CC1;
      
      LOOP
         FETCH C_PRJ_CC1 INTO h_cost_center_id, h_cost_percent;
         IF C_PRJ_CC1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT Then
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REGULAR_QUANTITY = h_quantity * h_cost_percent / 10000.0,
               SPECIAL_QUANTITY = 0.00,
               REGULAR_RATE = h_unit_price,
               SPECIAL_RATE = 0.00,
               TAX1 = h_tax1_amount * h_cost_percent / 10000,
               TAX2 = h_tax2_amount * h_cost_percent / 10000,
               TYPE_ID = h_capital_expense,
               ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
               ELSE (h_quantity * h_cost_percent / 10000.0) END, 
               ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY 
               ELSE 0.00 END, 
               ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_unit_price END, 
               ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE ELSE 0.00 END, 
               ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1 
               ELSE (h_tax1_amount * h_cost_percent / 10000) END, 
               ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2 
               ELSE (h_tax2_amount * h_cost_percent / 10000) END,
               REC_DATETIME = h_rec_datetime
               WHERE PROJECT_ID = h_project_id
               AND FOREIGN_ID = h_element_id
               AND FOREIGN_DATE = h_invoice_date
               AND TYPE_ID = PMO_CNST.SC_BENEFIT
               AND FOREIGN_TABLE = h_foreign_table
               AND COST_CENTER_ID = h_cost_center_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 374+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(375) : cost_back.sql(2607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE PROJECT_RECONCILIATION
               SET REGULAR_QUANTITY = h_quantity * h_cost_percent / 10000.0,
               SPECIAL_QUANTITY = 0.00,
               REGULAR_RATE = h_unit_price,
               SPECIAL_RATE = 0.00,
               TAX1 = h_tax1_amount * h_cost_percent / 10000,
               TAX2 = h_tax2_amount * h_cost_percent / 10000,
               TYPE_ID = h_capital_expense,
               ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
               ELSE (h_quantity * h_cost_percent / 10000.0) END, 
               ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY 
               ELSE 0.00 END, 
               ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE ELSE h_unit_price END, 
               ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE ELSE 0.00 END, 
               ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1 
               ELSE (h_tax1_amount * h_cost_percent / 10000) END, 
               ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2 
               ELSE (h_tax2_amount * h_cost_percent / 10000) END,
               REC_DATETIME = h_rec_datetime
               WHERE PROJECT_ID = h_project_id
               AND FOREIGN_ID = h_element_id
               AND FOREIGN_DATE = h_invoice_date
               AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
               AND FOREIGN_TABLE = h_foreign_table
               AND COST_CENTER_ID = h_cost_center_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 415+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(416) : cost_back.sql(2648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               TAX1, TAX2,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_TAX1, ADJ_TAX2,
               REC_DATETIME, REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id,
               h_resource_id, h_invoice_date, h_foreign_table, h_capital_expense,
               h_cost_center_id, 0,
               h_quantity * h_cost_percent / 10000.0, h_unit_price,
               h_tax1_amount * h_cost_percent / 10000,
               h_tax2_amount * h_cost_percent / 10000,
               h_quantity * h_cost_percent / 10000.0, h_unit_price,
               h_tax1_amount * h_cost_percent / 10000,
               h_tax2_amount * h_cost_percent / 10000,
               h_rec_datetime, h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 451+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(452) : cost_back.sql(2684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_PRJ_CC1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INSERT_INVOICE_RCCLT', 465+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INSERT_INVOICE_RCCLT(466) : cost_back.sql(2698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INSERT_INVOICE_RCCLT', 472+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INSERT_INVOICE_RCCLT(473) : cost_back.sql(2705) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INSERT_INVOICE_RCCLT;
ALTER FUNCTION FC_INSERT_INVOICE_RCCLT COMPILE DEBUG;

/*****************************************************************************************/

-- rollup non-labor actual to PROJECT_COST_CENTERS

/*****************************************************************************************/

Prompt == FUNCTION FC_I_WBS_WS_ACTUAL_RCCLT ==
CREATE OR REPLACE FUNCTION FC_I_WBS_WS_ACTUAL_RCCLT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_budget_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_rec_datetime IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_budget_year PLS_INTEGER := 0;
   h_amount_01 NUMBER := 0;
   h_amount_02 NUMBER := 0;
   h_amount_03 NUMBER := 0;
   h_amount_04 NUMBER := 0;
   h_amount_05 NUMBER := 0;
   h_amount_06 NUMBER := 0;
   h_amount_07 NUMBER := 0;
   h_amount_08 NUMBER := 0;
   h_amount_09 NUMBER := 0;
   h_amount_10 NUMBER := 0;
   h_amount_11 NUMBER := 0;
   h_amount_12 NUMBER := 0;
   h_resource_id VARCHAR2(32);
   h_invoice_date DATE;
   h_quantity NUMBER := 0;
   h_unit_price NUMBER := 0;
   h_tax1_amount NUMBER := 0;
   h_tax2_amount NUMBER := 0;
   h_actual_amount NUMBER := 0;
   h_count PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C_TIMEPHASE_CC IS
         SELECT PBB.BUDGET_YEAR, PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT,
         PBB.MONTH_03_AMOUNT, PBB.MONTH_04_AMOUNT,
         PBB.MONTH_05_AMOUNT, PBB.MONTH_06_AMOUNT,
         PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT,
         PBB.MONTH_09_AMOUNT, PBB.MONTH_10_AMOUNT,
         PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT
         FROM PROJECT_BUDGET_BREAKDOWN PBB
         WHERE PBB.PROJECT_ID = h_project_id
         AND PBB.ELEMENT_ID = h_element_id
         AND PBB.CHARGECODE_ID = h_chargecode_id
         AND (
         (PBB.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
         AND h_foreign_table = PMO_CNST.SC_TABLE_BUDGETS)
         OR
         (PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET
         AND h_foreign_table = PMO_CNST.SC_TABLE_PBB)
         )
         ORDER BY PBB.BUDGET_YEAR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_WBS_WS_ACTUAL_RCCLT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_WBS_WS_ACTUAL_RCCLT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_WBS_WS_ACTUAL_RCCLT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_budget_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_rec_datetime || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_WS_ACTUAL_RCCLT', 71+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_WBS_WS_ACTUAL_RCCLT(72) : cost_back.sql(2791) : ' || SYSTIMESTAMP);
   END IF; 

   h_resource_id := NULL;
   h_quantity := 1.0;
   h_tax1_amount := 0.0;
   h_tax2_amount := 0.0;
   h_count := 0;
   
   OPEN C_TIMEPHASE_CC;
   
   LOOP
      FETCH C_TIMEPHASE_CC INTO h_budget_year, h_amount_01, h_amount_02,
      h_amount_03, h_amount_04,
      h_amount_05, h_amount_06,
      h_amount_07, h_amount_08,
      h_amount_09, h_amount_10,
      h_amount_11, h_amount_12;
      IF C_TIMEPHASE_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      h_count := Coalesce(h_count, 0) + 1;
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-01-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_01, h_tax1_amount, h_tax2_amount
                                       , h_amount_01, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-02-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_02, h_tax1_amount, h_tax2_amount
                                       , h_amount_02, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-03-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_03, h_tax1_amount, h_tax2_amount
                                       , h_amount_03, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-04-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_04, h_tax1_amount, h_tax2_amount
                                       , h_amount_04, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-05-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_05, h_tax1_amount, h_tax2_amount
                                       , h_amount_05, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-06-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_06, h_tax1_amount, h_tax2_amount
                                       , h_amount_06, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-07-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_07, h_tax1_amount, h_tax2_amount
                                       , h_amount_07, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-08-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_08, h_tax1_amount, h_tax2_amount
                                       , h_amount_08, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-09-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_09, h_tax1_amount, h_tax2_amount
                                       , h_amount_09, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-10-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_10, h_tax1_amount, h_tax2_amount
                                       , h_amount_10, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-11-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_11, h_tax1_amount, h_tax2_amount
                                       , h_amount_11, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      h_invoice_date := TO_CHAR(Coalesce(h_budget_year, 0)) || '-12-01';
      h_invoice_date := h_invoice_date;
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_budget_id, h_invoice_date
                                       , h_quantity, h_amount_12, h_tax1_amount, h_tax2_amount
                                       , h_amount_12, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
   END LOOP;
   BEGIN
      CLOSE C_TIMEPHASE_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_WS_ACTUAL_RCCLT', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_WS_ACTUAL_RCCLT(193) : cost_back.sql(2912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) = 0 Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION 
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_budget_id
         AND FOREIGN_TABLE = h_foreign_table
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_WS_ACTUAL_RCCLT', 215+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_WS_ACTUAL_RCCLT(216) : cost_back.sql(2935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION 
         SET REGULAR_QUANTITY = 0,
         REGULAR_RATE = 0,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NuLL THEN 0 ELSE ADJ_REGULAR_QUANTITY END,
         ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NuLL THEN 0 ELSE ADJ_REGULAR_RATE END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NuLL THEN 0 ELSE ADJ_SPECIAL_QUANTITY END,
         ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NuLL THEN 0 ELSE ADJ_SPECIAL_RATE END,
         ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NuLL THEN 0 ELSE ADJ_TAX1 END,
         ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NuLL THEN 0 ELSE ADJ_TAX2 END,
         LEDGER_REGULAR_QUANTITY = CASE WHEN RECONCILIATION_DATE IS NuLL THEN 0 ELSE LEDGER_REGULAR_QUANTITY END,
         LEDGER_REGULAR_RATE = CASE WHEN RECONCILIATION_DATE IS NuLL THEN 0 ELSE LEDGER_REGULAR_RATE END,
         LEDGER_SPECIAL_QUANTITY = CASE WHEN RECONCILIATION_DATE IS NuLL THEN 0 ELSE LEDGER_SPECIAL_QUANTITY END,
         LEDGER_SPECIAL_RATE = CASE WHEN RECONCILIATION_DATE IS NuLL THEN 0 ELSE LEDGER_SPECIAL_RATE END,
         LEDGER_TAX1 = CASE WHEN RECONCILIATION_DATE IS NuLL THEN 0 ELSE LEDGER_TAX1 END,
         LEDGER_TAX2 = CASE WHEN RECONCILIATION_DATE IS NuLL THEN 0 ELSE LEDGER_TAX2 END
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_ID = h_budget_id
         AND FOREIGN_TABLE = h_foreign_table;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_WS_ACTUAL_RCCLT', 249+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_WS_ACTUAL_RCCLT(250) : cost_back.sql(2969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_WS_ACTUAL_RCCLT', 255+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_WBS_WS_ACTUAL_RCCLT(256) : cost_back.sql(2975) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_WBS_WS_ACTUAL_RCCLT;
ALTER FUNCTION FC_I_WBS_WS_ACTUAL_RCCLT COMPILE DEBUG;

/*****************************************************************************************/

-- rollup non-labor actual to PROJECT_COST_CENTERS

/*****************************************************************************************/

Prompt == FUNCTION FC_ROLLUP_NONLABOR_COST_CENTER ==
CREATE OR REPLACE FUNCTION FC_ROLLUP_NONLABOR_COST_CENTER
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_rollup_all PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rollup_all PLS_INTEGER := sh_h_rollup_all;
   h_bitflag PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_budget_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_prev_resource_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_prev_cost_center_id VARCHAR2(32);
   h_invoice_date DATE;
   h_rec_datetime TIMESTAMP;
   h_cost_center_bits PLS_INTEGER := 0;
   h_quantity NUMBER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_unit_price NUMBER := 0;
   h_tax1_amount NUMBER := 0;
   h_tax2_amount NUMBER := 0;
   h_actual_amount NUMBER := 0;
   isChanged PLS_INTEGER NOT NULL := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR C_INVOICE_CC IS
         SELECT C.QUANTITY, C.UNIT_PRICE, C.TAX1_AMOUNT, C.TAX2_AMOUNT, C.ACTUAL_AMOUNT,
         TO_DATE(SubStr(C.INVOICE_DATETIME, 1, 10)), C.RESOURCE_ID, B.CAPITAL_EXPENSE,
         C.ELEMENT_ID, C.COST_CENTER_BITS
         FROM TMT_COSTS C, BUDGETS B
         WHERE C.PROJECT_ID = h_project_id
         AND ((h_rollup_all = 1) OR (C.COST_CENTER_BITS > 0))
         AND B.PROJECT_ID = C.PROJECT_ID
         AND B.BUDGET_ID = C.BUDGET_ID
         ORDER BY C.RESOURCE_ID, C.INVOICE_DATETIME;

      CURSOR C_WBS_ACTUAL_CC IS
         SELECT B.BUDGET_ID, B.ELEMENT_ID, B.CHARGECODE_ID,
         B.COST_CENTER_BITS,
         B.CAPITAL_EXPENSE
         FROM BUDGETS B, TMT_WBS W
         WHERE B.PROJECT_ID = h_project_id
         AND ((h_rollup_all = 1) OR (B.COST_CENTER_BITS > 0))
         AND B.ACTUAL_EDITED = 1
         AND CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_BENEFIT, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
         AND W.PROJECT_ID = h_project_id
         AND W.ELEMENT_ID = B.ELEMENT_ID
         AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);

      CURSOR C_WS_ACTUAL_CC IS
         SELECT B.BUDGET_ID, B.ELEMENT_ID, B.CHARGECODE_ID,
         B.COST_CENTER_BITS,
         B.CAPITAL_EXPENSE
         FROM BUDGETS B, TMT_WBS W
         WHERE B.PROJECT_ID = h_project_id
         AND ((h_rollup_all = 1) OR (B.COST_CENTER_BITS > 0))
         AND CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY, PMO_CNST.SC_BENEFIT, 
         PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_BENEFIT_LABOR)
         AND W.PROJECT_ID = h_project_id
         AND W.ELEMENT_ID = B.ELEMENT_ID
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ROLLUP_NONLABOR_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ROLLUP_NONLABOR_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := FC_ROLLUP_NONLABOR_COST_CENTER(' || 
       '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_rollup_all), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_NONLABOR_COST_CENTER', 75+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ROLLUP_NONLABOR_COST_CENTER(76) : cost_back.sql(3065) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT SYSTIMESTAMP INTO h_rec_datetime FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(87) : cost_back.sql(3076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Process invoice
   h_foreign_table := PMO_CNST.SC_TABLE_COSTS;
   
   OPEN C_INVOICE_CC;
   
   LOOP
      FETCH C_INVOICE_CC INTO h_quantity, h_unit_price,
      h_tax1_amount, h_tax2_amount,
      h_actual_amount, h_invoice_date,
      h_resource_id, h_capital_expense,
      h_element_id, h_cost_center_bits;
      IF C_INVOICE_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      isChanged := 1;
      
      null_return := FC_INSERT_INVOICE_RCCLT(h_project_id, h_resource_id, h_element_id, h_invoice_date
                                       , h_quantity, h_unit_price, h_tax1_amount, h_tax2_amount
                                       , h_actual_amount, h_capital_expense, h_foreign_table
                                       , h_rec_datetime, h_rec_user);
      
      If Coalesce(h_cost_center_bits, 0) > 0 Then
         -- convert to cost_center's currency
         BEGIN
            UPDATE TMT_COSTS
            SET COST_CENTER_BITS = 0
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(137) : cost_back.sql(3126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- PROJECT_RECONCILIATION
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REC_DATETIME = h_rec_datetime
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_element_id
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_COSTS;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 158+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(159) : cost_back.sql(3148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_INVOICE_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 172+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(173) : cost_back.sql(3162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Process actual budgets
   h_foreign_table := PMO_CNST.SC_TABLE_BUDGETS;
   
   OPEN C_WBS_ACTUAL_CC;
   
   LOOP
      FETCH C_WBS_ACTUAL_CC INTO h_budget_id, h_element_id,
      h_chargecode_id,
      h_cost_center_bits,
      h_capital_expense;
      IF C_WBS_ACTUAL_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      isChanged := 1;
      
      null_return := FC_I_WBS_WS_ACTUAL_RCCLT(h_project_id, h_budget_id, h_element_id, h_chargecode_id
                                        , h_capital_expense, h_foreign_table, h_rec_datetime
                                        , h_rec_user);
      
      If Coalesce(h_cost_center_bits, 0) > 0 Then
         -- convert to cost_center's currency
         BEGIN
            UPDATE BUDGETS
            SET COST_CENTER_BITS = 0
            WHERE PROJECT_ID = h_project_id
            AND BUDGET_ID = h_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 220+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(221) : cost_back.sql(3210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- PROJECT_RECONCILIATION
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REC_DATETIME = h_rec_datetime
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_budget_id
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_BUDGETS;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(243) : cost_back.sql(3232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_WBS_ACTUAL_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 256+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(257) : cost_back.sql(3246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Process estimated actual (WS)
   h_foreign_table := PMO_CNST.SC_TABLE_PBB;
   
   OPEN C_WS_ACTUAL_CC;
   
   LOOP
      FETCH C_WS_ACTUAL_CC INTO h_budget_id, h_element_id,
      h_chargecode_id,
      h_cost_center_bits,
      h_capital_expense;
      IF C_WS_ACTUAL_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      isChanged := 1;
      
      null_return := FC_I_WBS_WS_ACTUAL_RCCLT(h_project_id, h_budget_id, h_element_id, h_chargecode_id
                                        , h_capital_expense, h_foreign_table, h_rec_datetime
                                        , h_rec_user);
      
      If Coalesce(h_cost_center_bits, 0) > 0 Then
         -- convert to cost_center's currency
         BEGIN
            UPDATE BUDGETS
            SET COST_CENTER_BITS = 0
            WHERE PROJECT_ID = h_project_id
            AND BUDGET_ID = h_budget_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 304+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(305) : cost_back.sql(3294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- PROJECT_RECONCILIATION
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REC_DATETIME = h_rec_datetime
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_budget_id
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_BUDGETS;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 326+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(327) : cost_back.sql(3316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_WS_ACTUAL_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_NONLABOR_COST_CENTER', 340+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_NONLABOR_COST_CENTER(341) : cost_back.sql(3330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If isChanged = 0 Then
      PMO_DB2M.SC_STATE := PMO_CNST.FS_NOTHING_CHANGED;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_NONLABOR_COST_CENTER', 350+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ROLLUP_NONLABOR_COST_CENTER(351) : cost_back.sql(3340) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ROLLUP_NONLABOR_COST_CENTER;
ALTER FUNCTION FC_ROLLUP_NONLABOR_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

-- insert resource labor cost centers based on assignments start and finish dates

/*****************************************************************************************/

Prompt == FUNCTION FC_I_RES_LABOR_COST_CENTER ==
CREATE OR REPLACE FUNCTION FC_I_RES_LABOR_COST_CENTER
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_count PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_start_date1 DATE;
   h_finish_date1 DATE;
   h_start_date DATE;
   h_finish_date DATE;
-- Declare Cursors
      CURSOR C_SF_DATES IS
         SELECT RESOURCE_ID, TO_DATE(SubStr(MIN(UNRESOLVED_START), 1, 10)), TO_DATE(SubStr(MAX(UNRESOLVED_FINISH), 1, 10))
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_BITS > 0
         AND TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
         AND RESOURCE_TYPE = '0'
         GROUP BY RESOURCE_ID;

      CURSOR C_S_RES_CC IS
         SELECT COST_CENTER_ID
         FROM RESOURCE_COST_CENTERS
         WHERE RESOURCE_ID = h_resource_id
         AND (START_DATE BETWEEN h_start_date AND h_finish_date
         OR FINISH_DATE BETWEEN h_start_date AND h_finish_date
         OR h_start_date BETWEEN START_DATE AND FINISH_DATE
         OR h_finish_date BETWEEN START_DATE AND FINISH_DATE);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_RES_LABOR_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_RES_LABOR_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := FC_I_RES_LABOR_COST_CENTER(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_RES_LABOR_COST_CENTER', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_RES_LABOR_COST_CENTER(41) : cost_back.sql(3395) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN C_SF_DATES;
   
   LOOP
      FETCH C_SF_DATES INTO h_resource_id, h_start_date1, h_finish_date1;
      IF C_SF_DATES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      BEGIN
         SELECT START_DATE INTO h_start_date
         FROM FISCAL_CALENDAR
         WHERE h_start_date1 BETWEEN START_DATE AND FINISH_DATE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(68) : cost_back.sql(3422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT FINISH_DATE INTO h_finish_date
         FROM FISCAL_CALENDAR
         WHERE h_finish_date1 BETWEEN START_DATE AND FINISH_DATE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(83) : cost_back.sql(3437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_S_RES_CC;
      
      LOOP
         FETCH C_S_RES_CC INTO h_cost_center_id;
         IF C_S_RES_CC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         h_count := 0;
         BEGIN
            SELECT COUNT(PROJECT_ID) INTO h_count
            FROM PROJECT_COST_CENTERS
            WHERE PROJECT_ID = h_project_id
            AND COST_CENTER_ID = h_cost_center_id
            AND RESOURCE_ID = h_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 114+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(115) : cost_back.sql(3469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR Coalesce(h_count, 0) = 0 Then
            BEGIN
               INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID, RESOURCE_ID,
               COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
               VALUES(SYS_GUID(), h_project_id, h_cost_center_id, h_resource_id,
               10000, 10000);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(136) : cost_back.sql(3490) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_count := 0;
            BEGIN
               SELECT COUNT(PROJECT_ID) INTO h_count
               FROM PROJECT_COST_CENTERS
               WHERE PROJECT_ID = h_project_id
               AND COST_CENTER_ID = h_cost_center_id
               AND RESOURCE_ID IS NuLL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 153+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(154) : cost_back.sql(3508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR Coalesce(h_count, 0) = 0 Then
               BEGIN
                  INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
                  COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
                  VALUES(SYS_GUID(), h_project_id, h_cost_center_id, 0, 0);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 173+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(174) : cost_back.sql(3528) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_S_RES_CC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(189) : cost_back.sql(3543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET COST_CENTER_BITS = 0
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_BITS > 0
         AND TABLE_TYPE = PMO_CNST.SC_TABLE_WBS
         AND RESOURCE_ID = h_resource_id
         AND RESOURCE_TYPE = '0';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 211+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(212) : cost_back.sql(3566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE C_SF_DATES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_RES_LABOR_COST_CENTER', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_RES_LABOR_COST_CENTER(225) : cost_back.sql(3579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_RES_LABOR_COST_CENTER', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_RES_LABOR_COST_CENTER(231) : cost_back.sql(3585) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_RES_LABOR_COST_CENTER;
ALTER FUNCTION FC_I_RES_LABOR_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

-- rollup actual to PROJECT_COST_CENTERS

-- h_rollup_all:    1: rebuild all

--                  0: update changed ones

/*****************************************************************************************/

Prompt == FUNCTION FC_ROLLUP_COST_CENTER ==
CREATE OR REPLACE FUNCTION FC_ROLLUP_COST_CENTER
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_rollup_all PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rollup_all PLS_INTEGER := sh_h_rollup_all;
   h_bitflag PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_cost_amount NUMBER := 0;
   h_revenue_amount NUMBER := 0;
   h_cost_amount1 NUMBER := 0;
   h_revenue_amount1 NUMBER := 0;
   h_ws_cost_amount NUMBER := 0;
   h_ws_revenue_amount NUMBER := 0;
   h_ws_cost_amount1 NUMBER := 0;
   h_ws_revenue_amount1 NUMBER := 0;
   isChanged PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_TOTAL_ACTUAL IS
         SELECT SUM(ACTUAL), SUM(CASE WHEN ESTIMATED_ACTUAL = 0.00 
         THEN ESTIMATED_ACTUAL_TOTAL ELSE ESTIMATED_ACTUAL END), CAPITAL_EXPENSE
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY, PMO_CNST.SC_BENEFIT, 
         PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_BENEFIT_LABOR)
         GROUP BY CAPITAL_EXPENSE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ROLLUP_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ROLLUP_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := FC_ROLLUP_COST_CENTER(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_rollup_all), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_COST_CENTER', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ROLLUP_COST_CENTER(42) : cost_back.sql(3645) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_I_RES_LABOR_COST_CENTER(h_project_id, h_rec_user);
   
   BEGIN
      DELETE FROM PROJECT_RECONCILIATION
      WHERE PROJECT_ID = h_project_id
      AND REC_STATUS = 'D'
      AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_BUDGETS, PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_PBB);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(62) : cost_back.sql(3665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      isChanged := 1;
   End If;
   
   PMO_DB2M.SC_STATE := FC_ROLLUP_LABOR_COST_CENTER(h_project_id, h_resource_id, h_rollup_all
                                                 , h_rec_user);
   
   If PMO_DB2M.SC_STATE = PMO_CNST.FS_NOTHING_CHANGED Then
      PMO_DB2M.SC_STATE := 0;
   Else
      isChanged := 1;
   End If;
   
   PMO_DB2M.SC_STATE := FC_ROLLUP_NONLABOR_COST_CENTER(h_project_id, h_rollup_all, h_rec_user);
   
   If PMO_DB2M.SC_STATE = PMO_CNST.FS_NOTHING_CHANGED Then
      PMO_DB2M.SC_STATE := 0;
   Else
      isChanged := 1;
   End If;
   
   If isChanged = 1 Then
      -- fix non labor related cost centers
      
      OPEN C_TOTAL_ACTUAL;
      
      h_cost_amount := 0.00;
      h_revenue_amount := 0.00;
      h_ws_cost_amount := 0.00;
      h_ws_revenue_amount := 0.00;
      
      LOOP
         FETCH C_TOTAL_ACTUAL INTO h_cost_amount1, h_ws_cost_amount1, h_capital_expense;
         IF C_TOTAL_ACTUAL%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE) OR (Coalesce(
               h_capital_expense, 0) = PMO_CNST.SC_CAPITAL) Then
            h_cost_amount := Coalesce(h_cost_amount, 0) + Coalesce(h_cost_amount1, 0);
            h_ws_cost_amount := Coalesce(h_ws_cost_amount, 0) + Coalesce(h_ws_cost_amount1, 0);
         ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_CONTINGENCY Then
            h_cost_amount := Coalesce(h_cost_amount, 0) + Coalesce(h_cost_amount1, 0);
            h_ws_cost_amount := Coalesce(h_ws_cost_amount, 0) + Coalesce(h_ws_cost_amount1, 0);
         ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_ELIMINATION Then
            h_cost_amount := Coalesce(h_cost_amount, 0) - Coalesce(h_cost_amount1, 0);
            h_ws_cost_amount := Coalesce(h_ws_cost_amount, 0) - Coalesce(h_ws_cost_amount1, 0);
         ElsIf (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR) OR (Coalesce(
                h_capital_expense, 0) = PMO_CNST.SC_CAPITAL_LABOR) Then
            h_ws_cost_amount := Coalesce(h_ws_cost_amount, 0) + Coalesce(h_ws_cost_amount1, 0);
         ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_LABOR Then
            h_ws_revenue_amount := Coalesce(h_ws_revenue_amount, 0) + Coalesce(h_ws_cost_amount1, 0);
         ElsIf Coalesce(h_capital_expense, 0) = PMO_CNST.SC_BENEFIT Then
            h_revenue_amount := Coalesce(h_revenue_amount, 0) + Coalesce(h_cost_amount1, 0);
            h_ws_revenue_amount := Coalesce(h_ws_revenue_amount, 0) + Coalesce(h_ws_cost_amount1, 0);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_TOTAL_ACTUAL ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(138) : cost_back.sql(3741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 0;
      BEGIN
         SELECT COUNT(PROJECT_ID), SUM(ACTUAL_COST),
         SUM(CASE WHEN MAX_COST_CHARGE = 0.00 THEN (ACTUAL_COST * COST_CHARGE_PERCENT / 10000.00)
         WHEN ACTUAL_COST > MAX_COST_CHARGE THEN MAX_COST_CHARGE ELSE ACTUAL_COST END),
         SUM(ACTUAL_REVENUE),
         SUM(CASE WHEN MAX_REVENUE_CHARGE = 0.00 THEN (ACTUAL_REVENUE * REVENUE_CHARGE_PERCENT / 10000.00)
         WHEN ACTUAL_REVENUE > MAX_REVENUE_CHARGE THEN MAX_REVENUE_CHARGE ELSE ACTUAL_REVENUE END)
         INTO h_bitflag, h_cost_amount1, h_ws_cost_amount1, h_revenue_amount1, h_ws_revenue_amount1
         FROM PROJECT_COST_CENTERS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID IS NOT NuLL
         AND COST_CENTER_ID IS NOT NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 161+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(162) : cost_back.sql(3765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_bitflag, 0) = 0) Then
         h_cost_amount1 := 0.00;
         h_ws_cost_amount1 := 0.00;
         h_revenue_amount1 := 0.00;
         h_ws_revenue_amount1 := 0.00;
      End If;
      
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET ACTUAL_COST = h_cost_amount + h_cost_amount1,
         ACTUAL_REVENUE = h_revenue_amount + h_revenue_amount1,
         LABOR_COST = h_cost_amount1 - h_ws_cost_amount1,
         LABOR_REVENUE = h_revenue_amount1 - h_ws_revenue_amount1,
         NON_LABOR_COST = h_cost_amount,
         NON_LABOR_REVENUE = h_revenue_amount,
         WS_COST = h_ws_cost_amount,
         WS_REVENUE = h_ws_revenue_amount
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID IS NuLL
         AND COST_CENTER_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(197) : cost_back.sql(3800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID,
            ACTUAL_COST, COST_CHARGE_PERCENT,
            ACTUAL_REVENUE, REVENUE_CHARGE_PERCENT,
            LABOR_COST, LABOR_COST_PERCENT,
            LABOR_REVENUE, LABOR_REVENUE_PERCENT,
            NON_LABOR_COST, NON_LABOR_COST_PERCENT,
            NON_LABOR_REVENUE, NON_LABOR_REVENUE_PERCENT,
            WS_COST, WS_COST_PERCENT,
            WS_REVENUE, WS_REVENUE_PERCENT)
            VALUES(h_project_id, h_project_id,
            h_cost_amount + h_cost_amount1, 0,
            h_revenue_amount + h_revenue_amount1, 0,
            h_cost_amount1 - h_ws_cost_amount1, 0,
            h_revenue_amount1 - h_ws_revenue_amount1, 0,
            h_cost_amount, 0,
            h_revenue_amount, 0,
            h_ws_cost_amount, 0,
            h_ws_revenue_amount, 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 231+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(232) : cost_back.sql(3835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE PROJECT_COST_CENTERS P
         SET (P.ACTUAL_COST, P.COST_CHARGE_PERCENT, P.MAX_COST_CHARGE, P.COST_CHARGE_AMOUNT,
         P.ACTUAL_REVENUE, P.REVENUE_CHARGE_PERCENT, P.MAX_REVENUE_CHARGE, P.REVENUE_CHARGE_AMOUNT)
         = (SELECT COALESCE(SUM(C.ACTUAL_COST), 0.00), 0, 0.00, COALESCE(SUM(C.COST_CHARGE_AMOUNT), 0.00),
         COALESCE(SUM(C.ACTUAL_REVENUE), 0.00), 0, 0.00, COALESCE(SUM(C.REVENUE_CHARGE_AMOUNT), 0.00)
         FROM PROJECT_COST_CENTERS C
         WHERE C.PROJECT_ID = P.PROJECT_ID AND C.COST_CENTER_ID = P.COST_CENTER_ID AND C.RESOURCE_ID IS NOT NuLL)
         WHERE P.PROJECT_ID = h_project_id AND P.COST_CENTER_ID IS NOT NuLL AND P.RESOURCE_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 256+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(257) : cost_back.sql(3860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_COST_CENTERS P
         SET (P.LABOR_COST, P.LABOR_REVENUE, P.NON_LABOR_COST, P.NON_LABOR_REVENUE, P.WS_COST, P.WS_REVENUE)
         = (SELECT R.LABOR_COST * P.LABOR_COST_PERCENT / 10000.0,
         R.LABOR_REVENUE * P.LABOR_REVENUE_PERCENT / 10000.0,
         R.NON_LABOR_COST * P.NON_LABOR_COST_PERCENT / 10000.0,
         R.NON_LABOR_REVENUE * P.NON_LABOR_REVENUE_PERCENT / 10000.0,
         R.WS_COST * P.WS_COST_PERCENT / 10000.0,
         R.WS_REVENUE * P.WS_REVENUE_PERCENT / 10000.0
         FROM PROJECT_COST_CENTERS R
         WHERE R.PROJECT_ID = P.PROJECT_ID AND R.COST_CENTER_ID IS NuLL AND R.RESOURCE_ID IS NuLL)
         WHERE P.PROJECT_ID = h_project_id AND P.COST_CENTER_ID IS NOT NuLL AND P.RESOURCE_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ROLLUP_COST_CENTER', 283+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ROLLUP_COST_CENTER(284) : cost_back.sql(3887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ROLLUP_COST_CENTER', 290+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ROLLUP_COST_CENTER(291) : cost_back.sql(3894) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ROLLUP_COST_CENTER;
ALTER FUNCTION FC_ROLLUP_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

-- rollup actual to PROJECT_COST_CENTERS

-- p_bitflag:       1: rebuild all

--                  0: update changed ones

/*****************************************************************************************/

Prompt == FUNCTION SP_ROLLUP_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_ROLLUP_COST_CENTER
(
     p_project_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rollup_all PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PROJS IS
         SELECT PROJECT_ID
         FROM PROJECT_DETAILS;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ROLLUP_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ROLLUP_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_ROLLUP_COST_CENTER(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ROLLUP_COST_CENTER', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ROLLUP_COST_CENTER(27) : cost_back.sql(3939) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_rollup_all := p_bitflag;
   h_rec_user := p_rec_user;
   
   If (h_project_id IS NULL) Then
      OPEN C_PROJS;
      
      LOOP
         FETCH C_PROJS INTO h_project_id;
         IF C_PROJS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         h_resource_id := NULL;
         PMO_DB2M.SC_STATE := FC_ROLLUP_COST_CENTER(h_project_id, h_resource_id, h_rollup_all, h_rec_user);
      END LOOP;
      BEGIN
         CLOSE C_PROJS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_COST_CENTER', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_COST_CENTER(59) : cost_back.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_resource_id := NULL;
      PMO_DB2M.SC_STATE := FC_ROLLUP_COST_CENTER(h_project_id, h_resource_id, h_rollup_all, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ROLLUP_COST_CENTER', 68+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ROLLUP_COST_CENTER(69) : cost_back.sql(3981) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_COST_CENTER', 75+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_COST_CENTER(76) : cost_back.sql(3988) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_COST_CENTER', 87+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_COST_CENTER(88) : cost_back.sql(4000) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ROLLUP_COST_CENTER;
ALTER FUNCTION SP_ROLLUP_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

--

/*****************************************************************************************/

Prompt == FUNCTION SP_S_A_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_S_A_COST_CENTER
(
     p_project_id VARCHAR2
   , p_element_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rollup_all PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SELECT_PCC PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SELECT_RCC PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_COST_CENTER(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_COST_CENTER', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_COST_CENTER(34) : cost_back.sql(4054) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_id := p_element_id;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   h_rollup_all := 0;
   
   If (h_project_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_COST_CENTER', 45+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_COST_CENTER(46) : cost_back.sql(4066) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_COST_CENTER', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_COST_CENTER(49) : cost_back.sql(4069) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If (h_element_id IS NULL) Then
      h_resource_id := NULL;
      PMO_DB2M.SC_STATE := FC_ROLLUP_COST_CENTER(h_project_id, h_resource_id, h_rollup_all, h_rec_user);
      
      OPEN SELECT_PCC FOR SELECT 1 AS LEVEL_ID, PMO_CNST.SC_CLIENTS AS TYPE_ID, '00000001' AS RANK, PCC.PROJECT_ID AS PARENT_ID,
      PCC.ELEMENT_ID, C.ELEMENT_NAME AS ELEMENT_NAME,
      ((SELECT COUNT(PC.PROJECT_ID) FROM PROJECT_COST_CENTERS PC
      WHERE PC.PROJECT_ID = PCC.PROJECT_ID AND PC.COST_CENTER_ID = PCC.COST_CENTER_ID) - 1) AS CHILD_COUNT,
      PCC.PROJECT_ID, PCC.COST_CENTER_ID, C.ELEMENT_NAME AS COST_CENTER_NAME,
      PCC.RESOURCE_ID, '' AS FULL_NAME,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT) < PMO_CNST.SC_DEFAULT_LABOR_COST_BIT THEN 0 ELSE 1 END AS DEFAULT_LABOR_COST,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT) < PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT THEN 0 ELSE 1 END AS DEFAULT_LABOR_REVENUE,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B) < PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT THEN 0 ELSE 1 END AS DEFAULT_NON_LABOR_COST,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_WS_COST_BIT) < PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B THEN 0 ELSE 1 END AS DEFAULT_NON_LABOR_REVENUE,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT) < PMO_CNST.SC_DEFAULT_WS_COST_BIT THEN 0 ELSE 1 END AS DEFAULT_WS_COST,
      CASE WHEN PCC.DEFAULT_FLAG < PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT THEN 0 ELSE 1 END AS DEFAULT_WS_REVENUE,
      PCC.ACTUAL_COST, PCC.COST_CHARGE_PERCENT, PCC.MAX_COST_CHARGE, PCC.COST_CHARGE_AMOUNT,
      PCC.ACTUAL_REVENUE, PCC.REVENUE_CHARGE_PERCENT, PCC.MAX_REVENUE_CHARGE, PCC.REVENUE_CHARGE_AMOUNT,
      PCC.LABOR_COST_PERCENT, PCC.LABOR_COST, PCC.LABOR_REVENUE_PERCENT, PCC.LABOR_REVENUE,
      PCC.NON_LABOR_COST_PERCENT, PCC.NON_LABOR_COST, PCC.NON_LABOR_REVENUE_PERCENT, PCC.NON_LABOR_REVENUE,
      PCC.WS_COST_PERCENT, PCC.WS_COST, PCC.WS_REVENUE_PERCENT, PCC.WS_REVENUE,
      PCC.LABOR_PERCENT, PCC.LABOR_AMOUNT, PCC.LABOR_FLAG,
      PCC.EXPENSE_PERCENT, PCC.EXPENSE_AMOUNT, PCC.EXPENSE_FLAG,
      PCC.CAPITAL_PERCENT, PCC.CAPITAL_AMOUNT, PCC.CAPITAL_FLAG,
      PCC.BASELINE1_LABOR_PERCENT, PCC.BASELINE1_LABOR_AMOUNT,
      PCC.BASELINE1_EXPENSE_PERCENT, PCC.BASELINE1_EXPENSE_AMOUNT,
      PCC.BASELINE1_CAPITAL_PERCENT, PCC.BASELINE1_CAPITAL_AMOUNT,
      PCC.BASELINE2_LABOR_PERCENT, PCC.BASELINE2_LABOR_AMOUNT,
      PCC.BASELINE2_EXPENSE_PERCENT, PCC.BASELINE2_EXPENSE_AMOUNT,
      PCC.BASELINE2_CAPITAL_PERCENT, PCC.BASELINE2_CAPITAL_AMOUNT,
      PCC.BASELINE3_LABOR_PERCENT, PCC.BASELINE3_LABOR_AMOUNT,
      PCC.BASELINE3_EXPENSE_PERCENT, PCC.BASELINE3_EXPENSE_AMOUNT,
      PCC.BASELINE3_CAPITAL_PERCENT, PCC.BASELINE3_CAPITAL_AMOUNT
      FROM PROJECT_COST_CENTERS PCC, TMT_CLIENTS C
      WHERE PROJECT_ID = h_project_id
      AND COST_CENTER_ID IS NOT NuLL
      AND RESOURCE_ID IS NuLL
      AND C.ELEMENT_ID = PCC.COST_CENTER_ID
      ORDER BY LEVEL_ID, ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_COST_CENTER', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_COST_CENTER(94) : cost_back.sql(4114) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_PCC;
   Else
      BEGIN
         SELECT COST_CENTER_ID INTO h_cost_center_id
         FROM PROJECT_COST_CENTERS
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_COST_CENTER', 107+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_COST_CENTER(108) : cost_back.sql(4128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN SELECT_RCC FOR SELECT 1 AS LEVEL_ID, PMO_CNST.SC_CLIENTS AS TYPE_ID, '00000001' AS RANK, PCC.PROJECT_ID AS PARENT_ID,
      PCC.ELEMENT_ID, C.ELEMENT_NAME AS ELEMENT_NAME,
      1 AS CHILD_COUNT,
      PROJECT_ID, COST_CENTER_ID, C.ELEMENT_NAME AS COST_CENTER_NAME,
      RESOURCE_ID, '' AS FULL_NAME,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT) < PMO_CNST.SC_DEFAULT_LABOR_COST_BIT THEN 0 ELSE 1 END AS DEFAULT_LABOR_COST,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT) < PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT THEN 0 ELSE 1 END AS DEFAULT_LABOR_REVENUE,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B) < PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT THEN 0 ELSE 1 END AS DEFAULT_NON_LABOR_COST,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_WS_COST_BIT) < PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B THEN 0 ELSE 1 END AS DEFAULT_NON_LABOR_REVENUE,
      CASE WHEN MOD(PCC.DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT) < PMO_CNST.SC_DEFAULT_WS_COST_BIT THEN 0 ELSE 1 END AS DEFAULT_WS_COST,
      CASE WHEN PCC.DEFAULT_FLAG < PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT THEN 0 ELSE 1 END AS DEFAULT_WS_REVENUE,
      ACTUAL_COST, COST_CHARGE_PERCENT, MAX_COST_CHARGE, COST_CHARGE_AMOUNT,
      ACTUAL_REVENUE, REVENUE_CHARGE_PERCENT, MAX_REVENUE_CHARGE, REVENUE_CHARGE_AMOUNT,
      LABOR_COST_PERCENT, LABOR_COST, LABOR_REVENUE_PERCENT, LABOR_REVENUE,
      NON_LABOR_COST_PERCENT, NON_LABOR_COST, NON_LABOR_REVENUE_PERCENT, NON_LABOR_REVENUE,
      WS_COST_PERCENT, WS_COST, WS_REVENUE_PERCENT, WS_REVENUE,
      PCC.LABOR_PERCENT, PCC.LABOR_AMOUNT, PCC.LABOR_FLAG,
      PCC.EXPENSE_PERCENT, PCC.EXPENSE_AMOUNT, PCC.EXPENSE_FLAG,
      PCC.CAPITAL_PERCENT, PCC.CAPITAL_AMOUNT, PCC.CAPITAL_FLAG,
      PCC.BASELINE1_LABOR_PERCENT, PCC.BASELINE1_LABOR_AMOUNT,
      PCC.BASELINE1_EXPENSE_PERCENT, PCC.BASELINE1_EXPENSE_AMOUNT,
      PCC.BASELINE1_CAPITAL_PERCENT, PCC.BASELINE1_CAPITAL_AMOUNT,
      PCC.BASELINE2_LABOR_PERCENT, PCC.BASELINE2_LABOR_AMOUNT,
      PCC.BASELINE2_EXPENSE_PERCENT, PCC.BASELINE2_EXPENSE_AMOUNT,
      PCC.BASELINE2_CAPITAL_PERCENT, PCC.BASELINE2_CAPITAL_AMOUNT,
      PCC.BASELINE3_LABOR_PERCENT, PCC.BASELINE3_LABOR_AMOUNT,
      PCC.BASELINE3_EXPENSE_PERCENT, PCC.BASELINE3_EXPENSE_AMOUNT,
      PCC.BASELINE3_CAPITAL_PERCENT, PCC.BASELINE3_CAPITAL_AMOUNT
      FROM PROJECT_COST_CENTERS PCC, TMT_CLIENTS C
      WHERE PROJECT_ID = h_project_id
      AND PCC.ELEMENT_ID = h_element_id
      AND C.ELEMENT_ID = PCC.COST_CENTER_ID
      
      UNION ALL
      
      SELECT 2 AS LEVEL_ID, PMO_CNST.SC_RESOURCE AS TYPE_ID, '000000010001' AS RANK, h_element_id AS PARENT_ID,
      PCC.ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME,
      0 AS CHILD_COUNT,
      PROJECT_ID, COST_CENTER_ID, C.ELEMENT_NAME AS COST_CENTER_NAME,
      R.RESOURCE_ID, R.FULL_NAME,
      0 AS DEFAULT_LABOR_COST, 0 AS DEFAULT_LABOR_REVENUE,
      0 AS DEFAULT_NON_LABOR_COST, 0 AS DEFAULT_NON_LABOR_REVENUE,
      0 AS DEFAULT_WS_COST, 0 AS DEFAULT_WS_REVENUE,
      ACTUAL_COST, COST_CHARGE_PERCENT, MAX_COST_CHARGE, COST_CHARGE_AMOUNT,
      ACTUAL_REVENUE, REVENUE_CHARGE_PERCENT, MAX_REVENUE_CHARGE, REVENUE_CHARGE_AMOUNT,
      LABOR_COST_PERCENT, LABOR_COST, LABOR_REVENUE_PERCENT, LABOR_REVENUE,
      NON_LABOR_COST_PERCENT, NON_LABOR_COST, NON_LABOR_REVENUE_PERCENT, NON_LABOR_REVENUE,
      WS_COST_PERCENT, WS_COST, WS_REVENUE_PERCENT, WS_REVENUE,
      PCC.LABOR_PERCENT, PCC.LABOR_AMOUNT, PCC.LABOR_FLAG,
      PCC.EXPENSE_PERCENT, PCC.EXPENSE_AMOUNT, PCC.EXPENSE_FLAG,
      PCC.CAPITAL_PERCENT, PCC.CAPITAL_AMOUNT, PCC.CAPITAL_FLAG,
      PCC.BASELINE1_LABOR_PERCENT, PCC.BASELINE1_LABOR_AMOUNT,
      PCC.BASELINE1_EXPENSE_PERCENT, PCC.BASELINE1_EXPENSE_AMOUNT,
      PCC.BASELINE1_CAPITAL_PERCENT, PCC.BASELINE1_CAPITAL_AMOUNT,
      PCC.BASELINE2_LABOR_PERCENT, PCC.BASELINE2_LABOR_AMOUNT,
      PCC.BASELINE2_EXPENSE_PERCENT, PCC.BASELINE2_EXPENSE_AMOUNT,
      PCC.BASELINE2_CAPITAL_PERCENT, PCC.BASELINE2_CAPITAL_AMOUNT,
      PCC.BASELINE3_LABOR_PERCENT, PCC.BASELINE3_LABOR_AMOUNT,
      PCC.BASELINE3_EXPENSE_PERCENT, PCC.BASELINE3_EXPENSE_AMOUNT,
      PCC.BASELINE3_CAPITAL_PERCENT, PCC.BASELINE3_CAPITAL_AMOUNT
      FROM PROJECT_COST_CENTERS PCC, TMT_CLIENTS C, RESOURCES R
      WHERE PCC.PROJECT_ID = h_project_id
      AND PCC.COST_CENTER_ID = h_cost_center_id
      AND PCC.RESOURCE_ID IS NOT NuLL
      AND C.ELEMENT_ID = PCC.COST_CENTER_ID
      AND R.RESOURCE_ID = PCC.RESOURCE_ID
      ORDER BY LEVEL_ID, ELEMENT_NAME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_COST_CENTER', 180+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_COST_CENTER(181) : cost_back.sql(4201) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN SELECT_RCC;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_COST_CENTER', 189+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_COST_CENTER(190) : cost_back.sql(4210) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_COST_CENTER', 201+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_COST_CENTER(202) : cost_back.sql(4222) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_COST_CENTER;
ALTER FUNCTION SP_S_A_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

--

/*****************************************************************************************/

Prompt == FUNCTION SP_A_PROJ_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_A_PROJ_COST_CENTER
(
     p_project_id VARCHAR2
   , p_cost_center_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_PROJ_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_PROJ_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_A_PROJ_COST_CENTER(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_cost_center_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PROJ_COST_CENTER', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_PROJ_COST_CENTER(24) : cost_back.sql(4266) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_cost_center_id := p_cost_center_id;
   h_rec_user := p_rec_user;
   
   If ((h_project_id IS NULL)) OR ((h_cost_center_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_PROJ_COST_CENTER', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_PROJ_COST_CENTER(33) : cost_back.sql(4275) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PROJ_COST_CENTER', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_PROJ_COST_CENTER(36) : cost_back.sql(4278) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_bitflag := 0;
   BEGIN
      SELECT COUNT(COST_CENTER_ID) INTO h_bitflag
      FROM PROJECT_COST_CENTERS
      WHERE PROJECT_ID = h_project_id
      AND COST_CENTER_ID = h_cost_center_id
      AND RESOURCE_ID IS NuLL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PROJ_COST_CENTER', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PROJ_COST_CENTER(54) : cost_back.sql(4296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_bitflag, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_PROJ_COST_CENTER', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_PROJ_COST_CENTER(61) : cost_back.sql(4303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_cost_center_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_PROJ_COST_CENTER', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_PROJ_COST_CENTER(64) : cost_back.sql(4306) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_cost_center_id
            , True);
   Else
      h_element_id := SYS_GUID();
      h_element_id := h_element_id;
      
      BEGIN
         INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID, COST_CENTER_ID,
         COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT)
         VALUES(h_element_id, h_project_id, h_cost_center_id, 0, 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PROJ_COST_CENTER', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PROJ_COST_CENTER(86) : cost_back.sql(4328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_PROJ_COST_CENTER', 92+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_PROJ_COST_CENTER(93) : cost_back.sql(4335) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PROJ_COST_CENTER', 99+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PROJ_COST_CENTER(100) : cost_back.sql(4342) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_PROJ_COST_CENTER', 111+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_PROJ_COST_CENTER(112) : cost_back.sql(4354) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_PROJ_COST_CENTER;
ALTER FUNCTION SP_A_PROJ_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

--

/*****************************************************************************************/

Prompt == FUNCTION SP_UA_PROJ_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_UA_PROJ_COST_CENTER
(
     p_project_id VARCHAR2
   , p_element_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_PROJ_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_PROJ_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_PROJ_COST_CENTER(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_PROJ_COST_CENTER', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_PROJ_COST_CENTER(22) : cost_back.sql(4396) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_id := p_element_id;
   h_rec_user := p_rec_user;
   
   If ((h_project_id IS NULL)) OR ((h_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_PROJ_COST_CENTER', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_PROJ_COST_CENTER(31) : cost_back.sql(4405) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_PROJ_COST_CENTER', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_PROJ_COST_CENTER(34) : cost_back.sql(4408) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      DELETE FROM PROJECT_COST_CENTERS
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PROJ_COST_CENTER', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PROJ_COST_CENTER(52) : cost_back.sql(4426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_PROJ_COST_CENTER', 57+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_PROJ_COST_CENTER(58) : cost_back.sql(4432) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PROJ_COST_CENTER', 64+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PROJ_COST_CENTER(65) : cost_back.sql(4439) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_PROJ_COST_CENTER', 76+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_PROJ_COST_CENTER(77) : cost_back.sql(4451) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_PROJ_COST_CENTER;
ALTER FUNCTION SP_UA_PROJ_COST_CENTER COMPILE DEBUG;

/*****************************************************************************************/

--

/*****************************************************************************************/

Prompt == FUNCTION SP_U_PROJ_CC_DEFAULT ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_CC_DEFAULT
(
     p_project_id VARCHAR2
   , p_element_id VARCHAR2
   , p_default_labor_cost PLS_INTEGER
   , p_default_labor_revenue PLS_INTEGER
   , p_default_non_labor_cost PLS_INTEGER
   , p_default_non_labor_revenue PLS_INTEGER
   , p_default_ws_cost PLS_INTEGER
   , p_default_ws_revenue PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_default_flag PLS_INTEGER := 0;
   h_default_labor_cost PLS_INTEGER := 0;
   h_default_labor_revenue PLS_INTEGER := 0;
   h_default_non_labor_cost PLS_INTEGER := 0;
   h_default_non_labor_revenue PLS_INTEGER := 0;
   h_default_ws_cost PLS_INTEGER := 0;
   h_default_ws_revenue PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_CC_DEFAULT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_CC_DEFAULT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_CC_DEFAULT(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_default_labor_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_default_labor_revenue), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_default_non_labor_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_default_non_labor_revenue), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_default_ws_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_default_ws_revenue), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_CC_DEFAULT', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_CC_DEFAULT(42) : cost_back.sql(4513) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_id := p_element_id;
   h_default_labor_cost := p_default_labor_cost;
   h_default_labor_revenue := p_default_labor_revenue;
   h_default_non_labor_cost := p_default_non_labor_cost;
   h_default_non_labor_revenue := p_default_non_labor_revenue;
   h_default_ws_cost := p_default_ws_cost;
   h_default_ws_revenue := p_default_ws_revenue;
   h_rec_user := p_rec_user;
   
   If ((h_project_id IS NULL)) OR ((h_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PROJ_CC_DEFAULT', 56+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PROJ_CC_DEFAULT(57) : cost_back.sql(4528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_CC_DEFAULT', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_CC_DEFAULT(60) : cost_back.sql(4531) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_default_flag := 0;
   
   If Coalesce(h_default_labor_cost, 0) > 0 Then
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET DEFAULT_FLAG = DEFAULT_FLAG - PMO_CNST.SC_DEFAULT_LABOR_COST_BIT
         WHERE PROJECT_ID = h_project_id
         AND MOD(DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT) >= PMO_CNST.SC_DEFAULT_LABOR_COST_BIT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(83) : cost_back.sql(4554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_default_flag := PMO_FUNC.BIT_OR(Coalesce(h_default_flag, 0), PMO_CNST.SC_DEFAULT_LABOR_COST_BIT);
   End If;
   
   If Coalesce(h_default_labor_revenue, 0) > 0 Then
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET DEFAULT_FLAG = DEFAULT_FLAG - PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT
         WHERE PROJECT_ID = h_project_id
         AND MOD(DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT) >= PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(107) : cost_back.sql(4578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_default_flag := PMO_FUNC.BIT_OR(Coalesce(
                                           h_default_flag, 0), PMO_CNST.SC_DEFAULT_LABOR_REVENUE_BIT);
   End If;
   
   If Coalesce(h_default_non_labor_cost, 0) > 0 Then
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET DEFAULT_FLAG = DEFAULT_FLAG - PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT
         WHERE PROJECT_ID = h_project_id
         AND MOD(DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B) >= PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(132) : cost_back.sql(4603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_default_flag := PMO_FUNC.BIT_OR(Coalesce(
                                           h_default_flag, 0), PMO_CNST.SC_DEFAULT_NON_LABOR_COST_BIT);
   End If;
   
   If Coalesce(h_default_non_labor_revenue, 0) > 0 Then
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET DEFAULT_FLAG = DEFAULT_FLAG - PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B
         WHERE PROJECT_ID = h_project_id
         AND MOD(DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_WS_COST_BIT) >= PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 156+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(157) : cost_back.sql(4628) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_default_flag := PMO_FUNC.BIT_OR(Coalesce(
                                           h_default_flag, 0), PMO_CNST.SC_DEFAULT_NON_LABOR_REVENUE_B);
   End If;
   
   If Coalesce(h_default_ws_cost, 0) > 0 Then
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET DEFAULT_FLAG = DEFAULT_FLAG - PMO_CNST.SC_DEFAULT_WS_COST_BIT
         WHERE PROJECT_ID = h_project_id
         AND MOD(DEFAULT_FLAG, PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT) >= PMO_CNST.SC_DEFAULT_WS_COST_BIT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(182) : cost_back.sql(4653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_default_flag := PMO_FUNC.BIT_OR(Coalesce(h_default_flag, 0), PMO_CNST.SC_DEFAULT_WS_COST_BIT);
   End If;
   
   If Coalesce(h_default_ws_revenue, 0) > 0 Then
      BEGIN
         UPDATE PROJECT_COST_CENTERS
         SET DEFAULT_FLAG = DEFAULT_FLAG - PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT
         WHERE PROJECT_ID = h_project_id
         AND DEFAULT_FLAG >= PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 205+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(206) : cost_back.sql(4677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_default_flag := PMO_FUNC.BIT_OR(Coalesce(h_default_flag, 0), PMO_CNST.SC_DEFAULT_WS_REVENUE_BIT);
   End If;
   
   BEGIN
      UPDATE PROJECT_COST_CENTERS
      SET DEFAULT_FLAG = h_default_flag
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 228+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(229) : cost_back.sql(4700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_CC_DEFAULT', 234+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_CC_DEFAULT(235) : cost_back.sql(4706) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 241+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(242) : cost_back.sql(4713) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_DEFAULT', 253+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_DEFAULT(254) : cost_back.sql(4725) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_CC_DEFAULT;
ALTER FUNCTION SP_U_PROJ_CC_DEFAULT COMPILE DEBUG;

/*****************************************************************************************/

-- update project_reconciliation after change labor_cost_percent in project_cost_center

/*****************************************************************************************/

Prompt == FUNCTION FC_U_LABOR_COST_PERCENT ==
CREATE OR REPLACE FUNCTION FC_U_LABOR_COST_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_percent PLS_INTEGER
   , sh_h_percent PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_percent PLS_INTEGER := sh_h_old_percent;
   h_percent PLS_INTEGER := sh_h_percent;
   h_resource_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_foreign_date DATE;
   h_capital_expense PLS_INTEGER := 0;
   h_regular_cost NUMBER := 0;
   h_special_cost NUMBER := 0;
   h_regular_remaining NUMBER := 0;
   h_special_remaining NUMBER := 0;
-- Declare Cursors
      CURSOR C_LABOR_COST_PER IS
         SELECT RESOURCE_ID, FOREIGN_ID, 
         FOREIGN_DATE, WEEK_OF,
         MIN(REGULAR_RATE), MIN(SPECIAL_RATE), TYPE_ID,
         SUM(REGULAR_TOTAL_QUANTITY - REGULAR_DEFAULT_QUANTITY),
         SUM(SPECIAL_TOTAL_QUANTITY - SPECIAL_DEFAULT_QUANTITY)
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND DEFAULT_LABOR_FLAG = 1
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
         GROUP BY RESOURCE_ID, FOREIGN_ID, FOREIGN_DATE, WEEK_OF, TYPE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LABOR_COST_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LABOR_COST_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LABOR_COST_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_percent), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LABOR_COST_PERCENT', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LABOR_COST_PERCENT(46) : cost_back.sql(4791) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_old_percent, 0) > 0) AND (Coalesce(h_percent, 0) = 0) Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND DEFAULT_LABOR_FLAG = 0
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_COST_PERCENT', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_COST_PERCENT(69) : cost_back.sql(4814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE REGULAR_DEFAULT_QUANTITY END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE SPECIAL_DEFAULT_QUANTITY END
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_COST_PERCENT', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_COST_PERCENT(94) : cost_back.sql(4839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- distributing the remaining to project's labor cost centers
      
      OPEN C_LABOR_COST_PER;
      
      LOOP
         FETCH C_LABOR_COST_PER INTO h_resource_id, h_tsk_assignment_id, 
         h_foreign_date, h_week_of,
         h_regular_cost, h_special_cost, h_capital_expense,
         h_regular_remaining, h_special_remaining;
         IF C_LABOR_COST_PER%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_regular_remaining * h_percent / 10000,
            SPECIAL_QUANTITY = h_special_remaining * h_percent / 10000,
            REGULAR_RATE = h_regular_cost,
            SPECIAL_RATE = h_special_cost,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_regular_remaining * h_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_regular_cost END,
            ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY
            ELSE (SPECIAL_DEFAULT_QUANTITY + h_special_remaining * h_percent / 10000) END, 
            ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE
            ELSE h_special_cost END,
            TYPE_ID = h_capital_expense
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_foreign_date
            AND WEEK_OF = h_week_of
            AND TYPE_ID IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_COST_PERCENT', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_COST_PERCENT(150) : cost_back.sql(4895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, WEEK_OF, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               SPECIAL_QUANTITY, SPECIAL_RATE,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_SPECIAL_QUANTITY, ADJ_SPECIAL_RATE,
               REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_tsk_assignment_id,
               h_resource_id, h_foreign_date, h_week_of, PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS, h_capital_expense,
               h_cost_center_id, 0,
               h_regular_remaining * h_percent / 10000, h_regular_cost,
               h_special_remaining * h_percent / 10000, h_special_cost,
               h_regular_remaining * h_percent / 10000, h_regular_cost,
               h_special_remaining * h_percent / 10000, h_special_cost,
               h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_COST_PERCENT', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_COST_PERCENT(183) : cost_back.sql(4928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_LABOR_COST_PER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_COST_PERCENT', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_COST_PERCENT(197) : cost_back.sql(4942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LABOR_COST_PERCENT', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LABOR_COST_PERCENT(204) : cost_back.sql(4949) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LABOR_COST_PERCENT;
ALTER FUNCTION FC_U_LABOR_COST_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

-- update project_reconciliation after change labor_revnue_percent in project_cost_center

/*****************************************************************************************/

Prompt == FUNCTION FC_U_LABOR_REVENUE_PERCENT ==
CREATE OR REPLACE FUNCTION FC_U_LABOR_REVENUE_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_percent PLS_INTEGER
   , sh_h_percent PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_percent PLS_INTEGER := sh_h_old_percent;
   h_percent PLS_INTEGER := sh_h_percent;
   h_resource_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_week_of DATE;
   h_foreign_date DATE;
   h_capital_expense PLS_INTEGER := 0;
   h_regular_cost NUMBER := 0;
   h_special_cost NUMBER := 0;
   h_regular_remaining NUMBER := 0;
   h_special_remaining NUMBER := 0;
-- Declare Cursors
      CURSOR C_LABOR_REV_PER IS
         SELECT RESOURCE_ID, FOREIGN_ID, 
         FOREIGN_DATE, WEEK_OF,
         MIN(REGULAR_RATE), MIN(SPECIAL_RATE), TYPE_ID,
         SUM(REGULAR_TOTAL_QUANTITY - REGULAR_DEFAULT_QUANTITY),
         SUM(SPECIAL_TOTAL_QUANTITY - SPECIAL_DEFAULT_QUANTITY)
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND DEFAULT_LABOR_FLAG = 1
         AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
         GROUP BY RESOURCE_ID, FOREIGN_ID, FOREIGN_DATE, WEEK_OF, TYPE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LABOR_REVENUE_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LABOR_REVENUE_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LABOR_REVENUE_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_percent), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LABOR_REVENUE_PERCENT', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LABOR_REVENUE_PERCENT(46) : cost_back.sql(5009) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_old_percent, 0) > 0) AND (Coalesce(h_percent, 0) = 0) Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND DEFAULT_LABOR_FLAG = 0
         AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_REVENUE_PERCENT', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_REVENUE_PERCENT(69) : cost_back.sql(5032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE REGULAR_DEFAULT_QUANTITY END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE SPECIAL_DEFAULT_QUANTITY END
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
         AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_REVENUE_PERCENT', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_REVENUE_PERCENT(94) : cost_back.sql(5057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- distributing the remaining to project's labor cost centers
      
      OPEN C_LABOR_REV_PER;
      
      LOOP
         FETCH C_LABOR_REV_PER INTO h_resource_id, h_tsk_assignment_id, 
         h_foreign_date, h_week_of,
         h_regular_cost, h_special_cost, h_capital_expense,
         h_regular_remaining, h_special_remaining;
         IF C_LABOR_REV_PER%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_regular_remaining * h_percent / 10000,
            SPECIAL_QUANTITY = h_special_remaining * h_percent / 10000,
            REGULAR_RATE = h_regular_cost,
            SPECIAL_RATE = h_special_cost,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_regular_remaining * h_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_regular_cost END,
            ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY
            ELSE (SPECIAL_DEFAULT_QUANTITY + h_special_remaining * h_percent / 10000) END, 
            ADJ_SPECIAL_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_RATE
            ELSE h_special_cost END,
            TYPE_ID = h_capital_expense
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_tsk_assignment_id
            AND FOREIGN_DATE = h_foreign_date
            AND WEEK_OF = h_week_of
            AND TYPE_ID = PMO_CNST.SC_BENEFIT_LABOR
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_REVENUE_PERCENT', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_REVENUE_PERCENT(150) : cost_back.sql(5113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, WEEK_OF, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               SPECIAL_QUANTITY, SPECIAL_RATE,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_SPECIAL_QUANTITY, ADJ_SPECIAL_RATE,
               REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_tsk_assignment_id,
               h_resource_id, h_foreign_date, h_week_of, PMO_CNST.SC_TABLE_SUMMARY_TIMESHEETS, h_capital_expense,
               h_cost_center_id, 0,
               h_regular_remaining * h_percent / 10000, h_regular_cost,
               h_special_remaining * h_percent / 10000, h_special_cost,
               h_regular_remaining * h_percent / 10000, h_regular_cost,
               h_special_remaining * h_percent / 10000, h_special_cost,
               h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_REVENUE_PERCENT', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_REVENUE_PERCENT(183) : cost_back.sql(5146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_LABOR_REV_PER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LABOR_REVENUE_PERCENT', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LABOR_REVENUE_PERCENT(197) : cost_back.sql(5160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LABOR_REVENUE_PERCENT', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LABOR_REVENUE_PERCENT(204) : cost_back.sql(5167) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LABOR_REVENUE_PERCENT;
ALTER FUNCTION FC_U_LABOR_REVENUE_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

-- update project_reconciliation after change non_labor_cost_percent in project_cost_center

/*****************************************************************************************/

Prompt == FUNCTION FC_U_NON_LABOR_COST_PERCENT ==
CREATE OR REPLACE FUNCTION FC_U_NON_LABOR_COST_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_percent PLS_INTEGER
   , sh_h_percent PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_percent PLS_INTEGER := sh_h_old_percent;
   h_percent PLS_INTEGER := sh_h_percent;
   h_resource_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_invoice_date DATE;
   h_quantity NUMBER := 0;
   h_unit_price NUMBER := 0;
   h_tax1_amount NUMBER := 0;
   h_tax2_amount NUMBER := 0;
-- Declare Cursors
      CURSOR C_NLABOR_COST_PER IS
         SELECT RESOURCE_ID, FOREIGN_ID, FOREIGN_DATE,
         TYPE_ID, REGULAR_QUANTITY, REGULAR_RATE,
         TAX1, TAX2, FOREIGN_TABLE
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_BUDGETS)
         AND COST_CENTER_ID IS NuLL
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_NON_LABOR_COST_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_NON_LABOR_COST_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_NON_LABOR_COST_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_percent), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NON_LABOR_COST_PERCENT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_NON_LABOR_COST_PERCENT(43) : cost_back.sql(5224) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_old_percent, 0) > 0) AND (Coalesce(h_percent, 0) = 0) Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_BUDGETS)
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_COST_PERCENT', 64+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_COST_PERCENT(65) : cost_back.sql(5246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE 0.00 END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE 0.00 END
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_BUDGETS)
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_COST_PERCENT', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_COST_PERCENT(90) : cost_back.sql(5271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- distributing the remaining to project's labor cost centers
      
      OPEN C_NLABOR_COST_PER;
      
      LOOP
         FETCH C_NLABOR_COST_PER INTO h_resource_id, h_element_id, h_invoice_date,
         h_capital_expense, h_quantity, h_unit_price,
         h_tax1_amount, h_tax2_amount, h_foreign_table;
         IF C_NLABOR_COST_PER%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_quantity * h_percent / 10000,
            REGULAR_RATE = h_unit_price,
            TAX1 = h_tax1_amount * h_percent / 10000,
            TAX2 = h_tax2_amount * h_percent / 10000,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_quantity * h_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_unit_price END,
            ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1
            ELSE h_tax1_amount * h_percent / 10000 END, 
            ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2
            ELSE h_tax2_amount * h_percent / 10000 END, 
            TYPE_ID = h_capital_expense
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_element_id
            AND FOREIGN_DATE = h_invoice_date
            AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
            AND FOREIGN_TABLE = h_foreign_table
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_COST_PERCENT', 143+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_COST_PERCENT(144) : cost_back.sql(5325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               TAX1, TAX2,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_TAX1, ADJ_TAX2,
               REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id,
               h_resource_id, h_invoice_date, h_foreign_table, h_capital_expense,
               h_cost_center_id, 0,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_COST_PERCENT', 178+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_COST_PERCENT(179) : cost_back.sql(5360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_NLABOR_COST_PER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_COST_PERCENT', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_COST_PERCENT(193) : cost_back.sql(5374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NON_LABOR_COST_PERCENT', 199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_NON_LABOR_COST_PERCENT(200) : cost_back.sql(5381) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_NON_LABOR_COST_PERCENT;
ALTER FUNCTION FC_U_NON_LABOR_COST_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

-- update project_reconciliation after change non_labor_revenue_percent in project_cost_center

/*****************************************************************************************/

Prompt == FUNCTION FC_U_NON_LABOR_REVENUE_PERCENT ==
CREATE OR REPLACE FUNCTION FC_U_NON_LABOR_REVENUE_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_percent PLS_INTEGER
   , sh_h_percent PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_percent PLS_INTEGER := sh_h_old_percent;
   h_percent PLS_INTEGER := sh_h_percent;
   h_resource_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_invoice_date DATE;
   h_quantity NUMBER := 0;
   h_unit_price NUMBER := 0;
   h_tax1_amount NUMBER := 0;
   h_tax2_amount NUMBER := 0;
-- Declare Cursors
      CURSOR C_NLABOR_REV_PER IS
         SELECT RESOURCE_ID, FOREIGN_ID, FOREIGN_DATE,
         TYPE_ID, REGULAR_QUANTITY, REGULAR_RATE,
         TAX1, TAX2, FOREIGN_TABLE
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_BUDGETS)
         AND COST_CENTER_ID IS NuLL
         AND TYPE_ID = PMO_CNST.SC_BENEFIT;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_NON_LABOR_REVENUE_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_NON_LABOR_REVENUE_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_NON_LABOR_REVENUE_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_percent), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NON_LABOR_REVENUE_PERCENT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_NON_LABOR_REVENUE_PERCENT(43) : cost_back.sql(5438) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_old_percent, 0) > 0) AND (Coalesce(h_percent, 0) = 0) Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_BUDGETS)
         AND TYPE_ID = PMO_CNST.SC_BENEFIT
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_REVENUE_PERCENT', 64+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_REVENUE_PERCENT(65) : cost_back.sql(5460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE 0.00 END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE 0.00 END
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE IN (PMO_CNST.SC_TABLE_COSTS, PMO_CNST.SC_TABLE_BUDGETS)
         AND TYPE_ID = PMO_CNST.SC_BENEFIT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_REVENUE_PERCENT', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_REVENUE_PERCENT(90) : cost_back.sql(5485) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- distributing the remaining to project's labor cost centers
      
      OPEN C_NLABOR_REV_PER;
      
      LOOP
         FETCH C_NLABOR_REV_PER INTO h_resource_id, h_element_id, h_invoice_date,
         h_capital_expense, h_quantity, h_unit_price,
         h_tax1_amount, h_tax2_amount, h_foreign_table;
         IF C_NLABOR_REV_PER%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_quantity * h_percent / 10000,
            REGULAR_RATE = h_unit_price,
            TAX1 = h_tax1_amount * h_percent / 10000,
            TAX2 = h_tax2_amount * h_percent / 10000,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_quantity * h_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_unit_price END,
            ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1
            ELSE h_tax1_amount * h_percent / 10000 END, 
            ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2
            ELSE h_tax2_amount * h_percent / 10000 END, 
            TYPE_ID = h_capital_expense
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_element_id
            AND FOREIGN_DATE = h_invoice_date
            AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
            AND FOREIGN_TABLE = h_foreign_table
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_REVENUE_PERCENT', 143+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_REVENUE_PERCENT(144) : cost_back.sql(5539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               TAX1, TAX2,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_TAX1, ADJ_TAX2,
               REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id,
               h_resource_id, h_invoice_date, h_foreign_table, h_capital_expense,
               h_cost_center_id, 0,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_REVENUE_PERCENT', 178+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_REVENUE_PERCENT(179) : cost_back.sql(5574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_NLABOR_REV_PER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_NON_LABOR_REVENUE_PERCENT', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_NON_LABOR_REVENUE_PERCENT(193) : cost_back.sql(5588) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_NON_LABOR_REVENUE_PERCENT', 199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_NON_LABOR_REVENUE_PERCENT(200) : cost_back.sql(5595) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_NON_LABOR_REVENUE_PERCENT;
ALTER FUNCTION FC_U_NON_LABOR_REVENUE_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

-- update project_reconciliation after change ws_cost_percent in project_cost_center

/*****************************************************************************************/

Prompt == FUNCTION FC_U_WS_COST_PERCENT ==
CREATE OR REPLACE FUNCTION FC_U_WS_COST_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_percent PLS_INTEGER
   , sh_h_percent PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_percent PLS_INTEGER := sh_h_old_percent;
   h_percent PLS_INTEGER := sh_h_percent;
   h_resource_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_invoice_date DATE;
   h_quantity NUMBER := 0;
   h_unit_price NUMBER := 0;
   h_tax1_amount NUMBER := 0;
   h_tax2_amount NUMBER := 0;
-- Declare Cursors
      CURSOR C_WS_COST_PER IS
         SELECT RESOURCE_ID, FOREIGN_ID, FOREIGN_DATE,
         TYPE_ID, REGULAR_QUANTITY, REGULAR_RATE,
         TAX1, TAX2
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
         AND COST_CENTER_ID IS NuLL
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR, 
         PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_WS_COST_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_WS_COST_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_WS_COST_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_percent), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WS_COST_PERCENT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_WS_COST_PERCENT(43) : cost_back.sql(5652) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_old_percent, 0) > 0) AND (Coalesce(h_percent, 0) = 0) Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR,
         PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_COST_PERCENT', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_COST_PERCENT(66) : cost_back.sql(5675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE 0.00 END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE 0.00 END
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
         AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR,
         PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_COST_PERCENT', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_COST_PERCENT(92) : cost_back.sql(5701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- distributing the remaining to project's labor cost centers
      
      OPEN C_WS_COST_PER;
      
      LOOP
         FETCH C_WS_COST_PER INTO h_resource_id, h_element_id, h_invoice_date,
         h_capital_expense, h_quantity, h_unit_price,
         h_tax1_amount, h_tax2_amount;
         IF C_WS_COST_PER%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_quantity * h_percent / 10000,
            REGULAR_RATE = h_unit_price,
            TAX1 = h_tax1_amount * h_percent / 10000,
            TAX2 = h_tax2_amount * h_percent / 10000,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_quantity * h_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_unit_price END,
            ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1
            ELSE h_tax1_amount * h_percent / 10000 END, 
            ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2
            ELSE h_tax2_amount * h_percent / 10000 END, 
            TYPE_ID = h_capital_expense
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_element_id
            AND FOREIGN_DATE = h_invoice_date
            AND TYPE_ID IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR,
            PMO_CNST.SC_ELIMINATION, PMO_CNST.SC_CONTINGENCY)
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_COST_PERCENT', 146+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_COST_PERCENT(147) : cost_back.sql(5756) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               TAX1, TAX2,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_TAX1, ADJ_TAX2,
               REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id,
               h_resource_id, h_invoice_date, PMO_CNST.SC_TABLE_PBB, h_capital_expense,
               h_cost_center_id, 0,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_COST_PERCENT', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_COST_PERCENT(182) : cost_back.sql(5791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_WS_COST_PER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_COST_PERCENT', 195+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_COST_PERCENT(196) : cost_back.sql(5805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WS_COST_PERCENT', 202+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_WS_COST_PERCENT(203) : cost_back.sql(5812) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_WS_COST_PERCENT;
ALTER FUNCTION FC_U_WS_COST_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

-- update project_reconciliation after change non_labor_revenue_percent in project_cost_center

/*****************************************************************************************/

Prompt == FUNCTION FC_U_WS_REVENUE_PERCENT ==
CREATE OR REPLACE FUNCTION FC_U_WS_REVENUE_PERCENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_cost_center_id IN OUT NOCOPY VARCHAR2
   , sh_h_old_percent PLS_INTEGER
   , sh_h_percent PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_old_percent PLS_INTEGER := sh_h_old_percent;
   h_percent PLS_INTEGER := sh_h_percent;
   h_resource_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_invoice_date DATE;
   h_quantity NUMBER := 0;
   h_unit_price NUMBER := 0;
   h_tax1_amount NUMBER := 0;
   h_tax2_amount NUMBER := 0;
-- Declare Cursors
      CURSOR C_WS_REV_PER IS
         SELECT RESOURCE_ID, FOREIGN_ID, FOREIGN_DATE,
         TYPE_ID, REGULAR_QUANTITY, REGULAR_RATE,
         TAX1, TAX2
         FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
         AND COST_CENTER_ID IS NuLL
         AND TYPE_ID IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_WS_REVENUE_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_WS_REVENUE_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := FC_U_WS_REVENUE_PERCENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_cost_center_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_old_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_percent), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WS_REVENUE_PERCENT', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_WS_REVENUE_PERCENT(42) : cost_back.sql(5868) : ' || SYSTIMESTAMP);
   END IF; 

   If (Coalesce(h_old_percent, 0) > 0) AND (Coalesce(h_percent, 0) = 0) Then
      BEGIN
         DELETE FROM PROJECT_RECONCILIATION
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
         AND TYPE_ID IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR)
         AND CHARGE_DATE IS NuLL
         AND RECONCILIATION_DATE IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_REVENUE_PERCENT', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_REVENUE_PERCENT(64) : cost_back.sql(5890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_RECONCILIATION
         SET REGULAR_QUANTITY = 0.00,
         SPECIAL_QUANTITY = 0.00,
         ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY ELSE 0.00 END,
         ADJ_SPECIAL_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_SPECIAL_QUANTITY ELSE 0.00 END
         WHERE PROJECT_ID = h_project_id
         AND COST_CENTER_ID = h_cost_center_id
         AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
         AND TYPE_ID IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_REVENUE_PERCENT', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_REVENUE_PERCENT(89) : cost_back.sql(5915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- distributing the remaining to project's labor cost centers
      
      OPEN C_WS_REV_PER;
      
      LOOP
         FETCH C_WS_REV_PER INTO h_resource_id, h_element_id, h_invoice_date,
         h_capital_expense, h_quantity, h_unit_price,
         h_tax1_amount, h_tax2_amount;
         IF C_WS_REV_PER%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE PROJECT_RECONCILIATION
            SET REGULAR_QUANTITY = h_quantity * h_percent / 10000,
            REGULAR_RATE = h_unit_price,
            TAX1 = h_tax1_amount * h_percent / 10000,
            TAX2 = h_tax2_amount * h_percent / 10000,
            ADJ_REGULAR_QUANTITY = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_QUANTITY 
            ELSE (REGULAR_DEFAULT_QUANTITY + h_quantity * h_percent / 10000) END, 
            ADJ_REGULAR_RATE = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_REGULAR_RATE
            ELSE h_unit_price END,
            ADJ_TAX1 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX1
            ELSE h_tax1_amount * h_percent / 10000 END, 
            ADJ_TAX2 = CASE WHEN CHARGE_DATE IS NOT NuLL THEN ADJ_TAX2
            ELSE h_tax2_amount * h_percent / 10000 END, 
            TYPE_ID = h_capital_expense
            WHERE PROJECT_ID = h_project_id
            AND FOREIGN_ID = h_element_id
            AND FOREIGN_DATE = h_invoice_date
            AND TYPE_ID IN (PMO_CNST.SC_BENEFIT, PMO_CNST.SC_BENEFIT_LABOR)
            AND FOREIGN_TABLE = PMO_CNST.SC_TABLE_PBB
            AND COST_CENTER_ID = h_cost_center_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_REVENUE_PERCENT', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_REVENUE_PERCENT(143) : cost_back.sql(5969) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               INSERT INTO PROJECT_RECONCILIATION (ELEMENT_ID, PROJECT_ID, FOREIGN_ID,
               RESOURCE_ID, FOREIGN_DATE, FOREIGN_TABLE, TYPE_ID,
               COST_CENTER_ID, DEFAULT_LABOR_FLAG,
               REGULAR_QUANTITY, REGULAR_RATE,
               TAX1, TAX2,
               ADJ_REGULAR_QUANTITY, ADJ_REGULAR_RATE,
               ADJ_TAX1, ADJ_TAX2,
               REC_USER)
               VALUES(SYS_GUID(), h_project_id, h_element_id,
               h_resource_id, h_invoice_date, PMO_CNST.SC_TABLE_PBB, h_capital_expense,
               h_cost_center_id, 0,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_quantity * h_percent / 10000, h_unit_price,
               h_tax1_amount * h_percent / 10000,
               h_tax2_amount * h_percent / 10000,
               h_rec_user);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_REVENUE_PERCENT', 177+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_REVENUE_PERCENT(178) : cost_back.sql(6004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      BEGIN
         CLOSE C_WS_REV_PER ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WS_REVENUE_PERCENT', 191+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WS_REVENUE_PERCENT(192) : cost_back.sql(6018) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WS_REVENUE_PERCENT', 198+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_WS_REVENUE_PERCENT(199) : cost_back.sql(6025) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_WS_REVENUE_PERCENT;
ALTER FUNCTION FC_U_WS_REVENUE_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

--

/*****************************************************************************************/

Prompt == FUNCTION SP_U_PROJ_CC_PERCENT ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_CC_PERCENT
(
     p_project_id VARCHAR2
   , p_element_id VARCHAR2
   , p_labor_cost_percent PLS_INTEGER
   , p_labor_revenue_percent PLS_INTEGER
   , p_non_labor_cost_percent PLS_INTEGER
   , p_non_labor_revenue_percent PLS_INTEGER
   , p_ws_cost_percent PLS_INTEGER
   , p_ws_revenue_percent PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_labor_cost_percent PLS_INTEGER := 0;
   h_old_labor_cost_percent PLS_INTEGER := 0;
   h_labor_revenue_percent PLS_INTEGER := 0;
   h_old_labor_revenue_percent PLS_INTEGER := 0;
   h_non_labor_cost_percent PLS_INTEGER := 0;
   h_old_non_labor_cost_percent PLS_INTEGER := 0;
   h_non_labor_revenue_percent PLS_INTEGER := 0;
   h_old_non_labor_revenue_percen PLS_INTEGER := 0;
   h_ws_cost_percent PLS_INTEGER := 0;
   h_old_ws_cost_percent PLS_INTEGER := 0;
   h_ws_revenue_percent PLS_INTEGER := 0;
   h_old_ws_revenue_percent PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_CC_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_CC_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_CC_PERCENT(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_labor_cost_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_labor_revenue_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_non_labor_cost_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_non_labor_revenue_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_ws_cost_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_ws_revenue_percent), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_CC_PERCENT', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_CC_PERCENT(50) : cost_back.sql(6089) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_id := p_element_id;
   h_labor_cost_percent := p_labor_cost_percent;
   h_labor_revenue_percent := p_labor_revenue_percent;
   h_non_labor_cost_percent := p_non_labor_cost_percent;
   h_non_labor_revenue_percent := p_non_labor_revenue_percent;
   h_ws_cost_percent := p_ws_cost_percent;
   h_ws_revenue_percent := p_ws_revenue_percent;
   h_rec_user := p_rec_user;
   
   If Coalesce(h_labor_cost_percent, 0) > 10000 Then
      h_labor_cost_percent := 10000;
   End If;
   
   If Coalesce(h_labor_revenue_percent, 0) > 10000 Then
      h_labor_revenue_percent := 10000;
   End If;
   
   If Coalesce(h_non_labor_cost_percent, 0) > 10000 Then
      h_non_labor_cost_percent := 10000;
   End If;
   
   If Coalesce(h_non_labor_revenue_percent, 0) > 10000 Then
      h_non_labor_revenue_percent := 10000;
   End If;
   
   If Coalesce(h_ws_cost_percent, 0) > 10000 Then
      h_ws_cost_percent := 10000;
   End If;
   
   If Coalesce(h_ws_revenue_percent, 0) > 10000 Then
      h_ws_revenue_percent := 10000;
   End If;
   
   If ((h_project_id IS NULL)) OR ((h_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PROJ_CC_PERCENT', 88+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PROJ_CC_PERCENT(89) : cost_back.sql(6128) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_CC_PERCENT', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_CC_PERCENT(92) : cost_back.sql(6131) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT LABOR_COST_PERCENT, LABOR_REVENUE_PERCENT,
      NON_LABOR_COST_PERCENT, NON_LABOR_REVENUE_PERCENT,
      WS_COST_PERCENT, WS_REVENUE_PERCENT,
      COST_CENTER_ID
      INTO h_old_labor_cost_percent, h_old_labor_revenue_percent,
      h_old_non_labor_cost_percent, h_old_non_labor_revenue_percen,
      h_old_ws_cost_percent, h_old_ws_revenue_percent,
      h_cost_center_id
      FROM PROJECT_COST_CENTERS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_PERCENT', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_PERCENT(115) : cost_back.sql(6154) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   BEGIN
      SELECT COUNT(*) INTO h_count
      FROM PROJECT_COST_CENTERS
      WHERE PROJECT_ID = h_project_id
      AND COST_CENTER_ID IS NuLL
      AND RESOURCE_ID IS NuLL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_PERCENT', 132+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_PERCENT(133) : cost_back.sql(6172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) = 0 Then
      BEGIN
         INSERT INTO PROJECT_COST_CENTERS (ELEMENT_ID, PROJECT_ID,
         COST_CHARGE_PERCENT, REVENUE_CHARGE_PERCENT,
         LABOR_COST_PERCENT, LABOR_REVENUE_PERCENT,
         NON_LABOR_COST_PERCENT, NON_LABOR_REVENUE_PERCENT,
         WS_COST_PERCENT,WS_REVENUE_PERCENT)
         VALUES(h_project_id, h_project_id,
         0, 0,
         0, 0,
         0, 0,
         0, 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_PERCENT', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_PERCENT(160) : cost_back.sql(6199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE PROJECT_COST_CENTERS P
      SET (P.LABOR_COST_PERCENT, P.LABOR_COST, P.LABOR_REVENUE_PERCENT, P.LABOR_REVENUE,
      P.NON_LABOR_COST_PERCENT, P.NON_LABOR_COST, P.NON_LABOR_REVENUE_PERCENT, P.NON_LABOR_REVENUE,
      P.WS_COST_PERCENT, P.WS_COST, P.WS_REVENUE_PERCENT, P.WS_REVENUE)
      = (SELECT h_labor_cost_percent, R.LABOR_COST * h_labor_cost_percent / 10000.0,
      h_labor_revenue_percent, R.LABOR_REVENUE * h_labor_revenue_percent / 10000.0,
      h_non_labor_cost_percent, R.NON_LABOR_COST * h_non_labor_cost_percent / 10000.0,
      h_non_labor_revenue_percent, R.NON_LABOR_REVENUE * h_non_labor_revenue_percent / 10000.0,
      h_ws_cost_percent, R.WS_COST * h_ws_cost_percent / 10000.0,
      h_ws_revenue_percent, R.WS_REVENUE * h_ws_revenue_percent / 10000.0
      FROM PROJECT_COST_CENTERS R
      WHERE PROJECT_ID = h_project_id
      AND COST_CENTER_ID IS NuLL
      AND RESOURCE_ID IS NuLL)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_PERCENT', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_PERCENT(193) : cost_back.sql(6232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_old_labor_cost_percent, 0) <> Coalesce(h_labor_cost_percent, 0) Then
      h_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_U_LABOR_COST_PERCENT(h_project_id, h_cost_center_id, h_old_labor_cost_percent
                                       , h_labor_cost_percent, h_rec_user);
      PMO_DB2M.SC_STATE := Coalesce(h_temp_sc_state, 0);
   End If;
   
   If Coalesce(h_old_labor_revenue_percent, 0) <> Coalesce(h_labor_revenue_percent, 0) Then
      h_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_U_LABOR_REVENUE_PERCENT(h_project_id, h_cost_center_id
                                          , h_old_labor_revenue_percent, h_labor_revenue_percent
                                          , h_rec_user);
      PMO_DB2M.SC_STATE := Coalesce(h_temp_sc_state, 0);
   End If;
   
   If Coalesce(h_old_non_labor_cost_percent, 0) <> Coalesce(h_non_labor_cost_percent, 0) Then
      h_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_U_NON_LABOR_COST_PERCENT(h_project_id, h_cost_center_id
                                           , h_old_non_labor_cost_percent, h_non_labor_cost_percent
                                           , h_rec_user);
      PMO_DB2M.SC_STATE := Coalesce(h_temp_sc_state, 0);
      
   End If;
   
   If Coalesce(h_old_non_labor_revenue_percen, 0) <> Coalesce(h_old_non_labor_revenue_percen, 0) Then
      h_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_U_NON_LABOR_REVENUE_PERCENT(h_project_id, h_cost_center_id
                                              , h_old_non_labor_revenue_percen
                                              , h_non_labor_revenue_percent, h_rec_user);
      PMO_DB2M.SC_STATE := Coalesce(h_temp_sc_state, 0);
   End If;
   
   If Coalesce(h_old_ws_cost_percent, 0) <> Coalesce(h_ws_cost_percent, 0) Then
      h_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_U_WS_COST_PERCENT(h_project_id, h_cost_center_id, h_old_ws_cost_percent
                                    , h_ws_cost_percent, h_rec_user);
      PMO_DB2M.SC_STATE := Coalesce(h_temp_sc_state, 0);
   End If;
   
   If Coalesce(h_old_ws_revenue_percent, 0) <> Coalesce(h_ws_revenue_percent, 0) Then
      h_temp_sc_state := PMO_DB2M.SC_STATE;
      null_return := FC_U_WS_REVENUE_PERCENT(h_project_id, h_cost_center_id, h_old_ws_revenue_percent
                                       , h_ws_revenue_percent, h_rec_user);
      PMO_DB2M.SC_STATE := Coalesce(h_temp_sc_state, 0);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_CC_PERCENT', 244+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_CC_PERCENT(245) : cost_back.sql(6284) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_PERCENT', 251+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_PERCENT(252) : cost_back.sql(6291) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_PERCENT', 263+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_PERCENT(264) : cost_back.sql(6303) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_CC_PERCENT;
ALTER FUNCTION SP_U_PROJ_CC_PERCENT COMPILE DEBUG;

/*****************************************************************************************/

--

/*****************************************************************************************/

Prompt == FUNCTION SP_U_PROJ_CC_RES ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_CC_RES
(
     p_project_id VARCHAR2
   , p_element_id VARCHAR2
   , p_cost_charge_percent PLS_INTEGER
   , p_max_cost_charge NUMBER
   , p_revenue_charge_percent PLS_INTEGER
   , p_max_revenue_charge NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_cost_charge_percent PLS_INTEGER := 0;
   h_revenue_charge_percent PLS_INTEGER := 0;
   h_max_cost_charge NUMBER := 0;
   h_max_revenue_charge NUMBER := 0;
   h_rec_user VARCHAR2(32);
   h_rollup_all PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_CC_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_CC_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_CC_RES(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_cost_charge_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_max_cost_charge), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_revenue_charge_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_max_revenue_charge), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_CC_RES', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_CC_RES(37) : cost_back.sql(6360) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_id := p_element_id;
   h_cost_charge_percent := p_cost_charge_percent;
   h_max_cost_charge := p_max_cost_charge;
   h_revenue_charge_percent := p_revenue_charge_percent;
   h_max_revenue_charge := p_max_revenue_charge;
   h_rec_user := p_rec_user;
   h_rollup_all := 0;
   
   If ((h_project_id IS NULL)) OR ((h_element_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PROJ_CC_RES', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PROJ_CC_RES(51) : cost_back.sql(6374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_CC_RES', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_CC_RES(54) : cost_back.sql(6377) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT RESOURCE_ID INTO h_resource_id
      FROM PROJECT_COST_CENTERS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_RES', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_RES(70) : cost_back.sql(6393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PROJECT_COST_CENTERS P
      SET COST_CHARGE_PERCENT = h_cost_charge_percent,
      MAX_COST_CHARGE = h_max_cost_charge,
      COST_CHARGE_AMOUNT = CASE WHEN h_max_cost_charge = 0.00
      THEN (ACTUAL_COST * h_cost_charge_percent / 10000.00)
      WHEN ACTUAL_COST > h_max_cost_charge THEN h_max_cost_charge
      ELSE ACTUAL_COST END,
      REVENUE_CHARGE_PERCENT = h_revenue_charge_percent,
      MAX_REVENUE_CHARGE = h_max_revenue_charge,
      REVENUE_CHARGE_AMOUNT = CASE WHEN h_max_revenue_charge = 0.00
      THEN (ACTUAL_REVENUE * h_revenue_charge_percent / 10000.00)
      WHEN ACTUAL_REVENUE > h_max_revenue_charge THEN h_max_revenue_charge
      ELSE ACTUAL_REVENUE END
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_RES', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_RES(101) : cost_back.sql(6424) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_ROLLUP_COST_CENTER(h_project_id, h_resource_id, h_rollup_all, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_CC_RES', 108+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_CC_RES(109) : cost_back.sql(6432) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_RES', 115+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_RES(116) : cost_back.sql(6439) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_CC_RES', 127+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_CC_RES(128) : cost_back.sql(6451) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_CC_RES;
ALTER FUNCTION SP_U_PROJ_CC_RES COMPILE DEBUG;

