/* ************************************************************************************** */

Prompt == FUNCTION FC_U_PRED_WBS ==
CREATE OR REPLACE FUNCTION FC_U_PRED_WBS
(
     h_pred_id IN OUT NOCOPY VARCHAR2
   , sh_h_new_mlst_100 PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_new_mlst_100 PLS_INTEGER := sh_h_new_mlst_100;
   h_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_old_flag VARCHAR2(1);
   h_mlst_sum PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_alert_id VARCHAR2(32);
   null_return LONG;
-- Declare Cursors
      CURSOR C_FLAG1 IS
         SELECT D.SUCC_ID FROM DEPENDENCIES D JOIN TMT_WBS W
         ON D.SUCC_PROJECT_ID = W.PROJECT_ID AND D.SUCC_ID = W.ELEMENT_ID
         WHERE D.PRED_ID = h_pred_id AND W.DEPEND_FLAG <> '2';

      CURSOR CWM01 IS
         SELECT W.MILESTONE_PERCENT
         FROM DEPENDENCIES D JOIN TMT_WBS W ON D.PRED_PROJECT_ID = W.PROJECT_ID AND D.PRED_ID = W.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  D.SUCC_ID = h_succ_id AND W.MILESTONE_PERCENT < 10000;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRED_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRED_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRED_WBS(' || 
       '''' || h_pred_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_new_mlst_100), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRED_WBS', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRED_WBS(36) : dependencies.sql(39) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   --trace_printf("h_pred_id: %s, h_new_mlst_100 = %d\n", h_pred_id,h_new_mlst_100);
   If Coalesce(h_new_mlst_100, 0) = 10000 Then
      -- read all succesors from pred_id.
      
      OPEN C_FLAG1;
      
      LOOP
         FETCH C_FLAG1 INTO h_succ_id;
         IF C_FLAG1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("SC_STATE = %d, h_succ_id = %s\n", SC_STATE,h_succ_id);
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         h_alert_id := 'SCTASKREADYTOSTART';
         h_temp_var := 1;
         null_return := FC_ISSUE_ALERT(h_alert_id, h_succ_id, h_rec_user, h_temp_var, 0);
         
         BEGIN
            SELECT DEPEND_FLAG INTO h_old_flag FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 70+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(71) : dependencies.sql(74) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If SubStr(h_old_flag, 1, 1) = '0' Then
            BEGIN
               UPDATE TMT_WBS SET DEPEND_FLAG = '2' WHERE ELEMENT_ID = h_succ_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 88+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(89) : dependencies.sql(92) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("1___SC_STATE = %d\n", SC_STATE);
         Else
            -- Check if it still exists MILESTONE_PERCENT < 100
            
            OPEN CWM01;
            
            FETCH CWM01 INTO h_mlst_sum;
            IF CWM01%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = 0 Then
               h_old_flag := '1';
            Else
               h_old_flag := '2';
            End If;
            
            BEGIN
               CLOSE CWM01 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 119+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(120) : dependencies.sql(123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS SET DEPEND_FLAG = h_old_flag WHERE ELEMENT_ID = h_succ_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(137) : dependencies.sql(140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("2___SC_STATE = %d,h_old_flag: %s\n", SC_STATE,h_old_flag);
            
            If SubStr(h_old_flag, 1, 1) = '2' Then
               h_alert_id := 'SCTASKREADYTOSTART';
               h_temp_var := 2;
               null_return := FC_ISSUE_ALERT(h_alert_id, h_succ_id, h_rec_user, h_temp_var, 0);
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_FLAG1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 158+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(159) : dependencies.sql(162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS SET DEPEND_FLAG = '1' WHERE DEPEND_FLAG <> '1' AND ELEMENT_ID IN
         (SELECT SUCC_ID FROM DEPENDENCIES WHERE PRED_ID = h_pred_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRED_WBS', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRED_WBS(177) : dependencies.sql(180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("3___SC_STATE = %d\n", SC_STATE);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRED_WBS', 184+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRED_WBS(185) : dependencies.sql(188) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRED_WBS;
ALTER FUNCTION FC_U_PRED_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_SUCC_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SUCC_WBS
(
     h_succ_id IN OUT NOCOPY VARCHAR2
   , h_old_flag IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_mlst_sum PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CWM02 IS
         SELECT W.MILESTONE_PERCENT
         FROM DEPENDENCIES D JOIN TMT_WBS W ON D.PRED_PROJECT_ID = W.PROJECT_ID AND D.PRED_ID = W.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  D.SUCC_ID = h_succ_id AND W.MILESTONE_PERCENT < 10000;

      CURSOR CWM03 IS
         SELECT W.MILESTONE_PERCENT
         FROM DEPENDENCIES D JOIN TMT_WBS W ON D.PRED_PROJECT_ID = W.PROJECT_ID AND D.PRED_ID = W.ELEMENT_ID
         WHERE  ROWNUM <= 1 AND  D.SUCC_ID = h_succ_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SUCC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SUCC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SUCC_WBS(' || 
       '''' || h_succ_id || ''''
          || ', ' || '''' || h_old_flag || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUCC_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SUCC_WBS(27) : dependencies.sql(225) : ' || SYSTIMESTAMP);
   END IF; 

   --Local variable
   
   -- Check if it still exists MILESTONE_PERCENT < 100
   
   OPEN CWM02;
   
   FETCH CWM02 INTO h_mlst_sum;
   IF CWM02%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   h_mlst_sum := PMO_DB2M.SC_STATE;
   
   BEGIN
      CLOSE CWM02 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(53) : dependencies.sql(251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_succ_id: %s, h_old_flag: %s, h_mlst_sum = %d\n", h_succ_id,h_old_flag,h_mlst_sum);
   If Coalesce(h_mlst_sum, 0) <> 0 Then
      -- Check if it is the last predecessor
      
      OPEN CWM03;
      
      FETCH CWM03 INTO h_mlst_sum;
      IF CWM03%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      h_mlst_sum := PMO_DB2M.SC_STATE;
      
      BEGIN
         CLOSE CWM03 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 80+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(81) : dependencies.sql(279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("h_old_flag: %s, h_mlst_sum = %d\n", h_old_flag,h_mlst_sum);
      If Coalesce(h_mlst_sum, 0) <> 0 Then
         BEGIN
            UPDATE TMT_WBS SET DEPEND_FLAG = '0' WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 99+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(100) : dependencies.sql(298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("1___SC_STATE = %d\n", SC_STATE);
      ElsIf NOT SubStr(h_old_flag, 1, 1) = '2' Then
         BEGIN
            UPDATE TMT_WBS SET DEPEND_FLAG = '2' WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 117+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(118) : dependencies.sql(316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("2___SC_STATE = %d\n", SC_STATE);
      End If;
   ElsIf NOT SubStr(h_old_flag, 1, 1) = '1' Then
      BEGIN
         UPDATE TMT_WBS SET DEPEND_FLAG = '1' WHERE ELEMENT_ID = h_succ_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SUCC_WBS', 136+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SUCC_WBS(137) : dependencies.sql(335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("3___SC_STATE = %d\n", SC_STATE);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SUCC_WBS', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SUCC_WBS(145) : dependencies.sql(343) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SUCC_WBS;
ALTER FUNCTION FC_U_SUCC_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION CircularCheck_WBS ==
CREATE OR REPLACE FUNCTION CircularCheck_WBS
(
     sh_h_table PLS_INTEGER
   , h_succ_id IN OUT NOCOPY VARCHAR2
   , h_pred_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_count PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_pred_rank VARCHAR2(200);
   j PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('CircularCheck_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('CircularCheck_WBS'), '-- ' || SYSTIMESTAMP, ':r := CircularCheck_WBS(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_succ_id || ''''
          || ', ' || '''' || h_pred_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_WBS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: CircularCheck_WBS(22) : dependencies.sql(375) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SUCC_C_P';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRED_C';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RANK INTO h_succ_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(47) : dependencies.sql(400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK INTO h_pred_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(62) : dependencies.sql(415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_WBS
      WHERE (RANK LIKE h_succ_rank || '%' OR (SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(83) : dependencies.sql(436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PRED_C (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_WBS
      WHERE RANK LIKE h_pred_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(103) : dependencies.sql(456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      j := j + 1;
      If j > 100 Then
         --trace_printf("\nToo Many Steps!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(S.ELEMENT_ID) INTO h_count
         FROM PMO_SUCC_C_P S, PMO_PRED_C P
         WHERE S.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(126) : dependencies.sql(479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT01: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
         SELECT D.SUCC_ID, W.RANK, 0
         FROM DEPENDENCIES D, TMT_WBS W
         WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM PMO_SUCC_C_P WHERE FLAG = 0)
         AND D.SUCC_ID = W.ELEMENT_ID
         AND NOT EXISTS (SELECT P.ELEMENT_ID FROM PMO_DEPEND P WHERE P.ELEMENT_ID = D.SUCC_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(154) : dependencies.sql(507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_DEPEND
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(169) : dependencies.sql(522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT02: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(D.ELEMENT_ID) INTO h_count
         FROM PMO_DEPEND D, PMO_PRED_C P
         WHERE D.FLAG = 0 AND D.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 189+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(190) : dependencies.sql(543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT03: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_SUCC_C_P SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(213) : dependencies.sql(566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
         SELECT W.ELEMENT_ID, 0
         FROM TMT_WBS W, PMO_DEPEND D
         WHERE D.FLAG = 0 AND LEVEL_ID > -1
         AND (
         (
         SUBSTR(W.RANK, 1, CASE WHEN LENGTH(W.RANK) < LENGTH(D.RANK) THEN 1 ELSE LENGTH(D.RANK) END) = D.RANK
         AND
         D.RANK >= SUBSTR(W.RANK, 1, 8) AND D.RANK <= W.RANK
         )
         OR
         (
         SUBSTR(D.RANK, 1, CASE WHEN LENGTH(D.RANK) <= LENGTH(W.RANK) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK
         AND
         W.RANK >= SUBSTR(D.RANK, 1, 8) AND W.RANK <= D.RANK
         )
         )
         AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 246+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(247) : dependencies.sql(600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_SUCC_C_P
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 261+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(262) : dependencies.sql(615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT04: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_DEPEND SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_WBS', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_WBS(285) : dependencies.sql(638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_WBS', 291+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_WBS(292) : dependencies.sql(645) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_WBS', 296+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_WBS(297) : dependencies.sql(650) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION CircularCheck_WBS;
ALTER FUNCTION CircularCheck_WBS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION CircularCheck_CRI ==
CREATE OR REPLACE FUNCTION CircularCheck_CRI
(
     sh_h_table PLS_INTEGER
   , h_succ_id IN OUT NOCOPY VARCHAR2
   , h_pred_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_table PLS_INTEGER := sh_h_table;
   h_count PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_pred_rank VARCHAR2(200);
   j PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('CircularCheck_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('CircularCheck_CRI'), '-- ' || SYSTIMESTAMP, ':r := CircularCheck_CRI(' || 
       COALESCE(TO_CHAR(sh_h_table), 'NULL')
          || ', ' || '''' || h_succ_id || ''''
          || ', ' || '''' || h_pred_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_CRI', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: CircularCheck_CRI(22) : dependencies.sql(682) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SUCC_C_P';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRED_C';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RANK INTO h_succ_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(47) : dependencies.sql(707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK INTO h_pred_rank
      FROM TMT_CRI
      WHERE ELEMENT_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(62) : dependencies.sql(722) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_CRI
      WHERE (RANK LIKE h_succ_rank || '%' OR (SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
      AND (RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(83) : dependencies.sql(743) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PRED_C (ELEMENT_ID, FLAG)
      SELECT ELEMENT_ID, 0
      FROM TMT_CRI
      WHERE RANK LIKE h_pred_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(103) : dependencies.sql(763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      j := j + 1;
      If j > 100 Then
         --trace_printf("\nToo Many Steps!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(S.ELEMENT_ID) INTO h_count
         FROM PMO_SUCC_C_P S, PMO_PRED_C P
         WHERE S.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(126) : dependencies.sql(786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT01: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
         SELECT D.SUCC_ID, W.RANK, 0
         FROM CRIDEPENDENCIES D, TMT_CRI W
         WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM PMO_SUCC_C_P WHERE FLAG = 0)
         AND D.SUCC_ID = W.ELEMENT_ID
         AND NOT EXISTS (SELECT P.ELEMENT_ID FROM PMO_DEPEND P WHERE P.ELEMENT_ID = D.SUCC_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(154) : dependencies.sql(814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_DEPEND
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 168+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(169) : dependencies.sql(829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(D.ELEMENT_ID) INTO h_count
         FROM PMO_DEPEND D, PMO_PRED_C P
         WHERE D.FLAG = 0 AND D.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(189) : dependencies.sql(849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_SUCC_C_P SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(211) : dependencies.sql(871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
         SELECT W.ELEMENT_ID, 0
         FROM TMT_CRI W, PMO_DEPEND D
         WHERE D.FLAG = 0 AND W.LEVEL_ID > 1
         AND (
         (
         SUBSTR(W.RANK, 1, CASE WHEN LENGTH(W.RANK) < LENGTH(D.RANK) THEN 1 ELSE LENGTH(D.RANK) END) = D.RANK
         AND
         D.RANK >= SUBSTR(W.RANK, 1, 8) AND D.RANK <= W.RANK
         )
         OR
         (
         SUBSTR(D.RANK, 1, CASE WHEN LENGTH(D.RANK) <= LENGTH(W.RANK) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK
         AND
         W.RANK >= SUBSTR(D.RANK, 1, 8) AND W.RANK <= D.RANK
         )
         )
         AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 244+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(245) : dependencies.sql(905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_SUCC_C_P
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 259+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(260) : dependencies.sql(920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_DEPEND SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'CircularCheck_CRI', 281+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: CircularCheck_CRI(282) : dependencies.sql(942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_CRI', 288+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_CRI(289) : dependencies.sql(949) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'CircularCheck_CRI', 292+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: CircularCheck_CRI(293) : dependencies.sql(953) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION CircularCheck_CRI;
ALTER FUNCTION CircularCheck_CRI COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_A_DEPEND
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_dep_str VARCHAR2(8192);
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_table PLS_INTEGER := 0;
   h_pred_start_dt TIMESTAMP;
   h_pred_finish_dt TIMESTAMP;
   h_succ_start_dt TIMESTAMP;
   h_succ_finish_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_DEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_DEPEND(36) : dependencies.sql(999) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If ((predecessor_id IS NULL)) OR ((successor_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND(43) : dependencies.sql(1006) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(46) : dependencies.sql(1009) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate successor_id
   h_succ_id := successor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK, REC_STATUS, START_DT, FINISH_DT
      INTO h_succ_project_id, h_succ_type_id, h_succ_id, h_succ_rank, h_rec_status, h_succ_start_dt, h_succ_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = successor_id/**successor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(66) : dependencies.sql(1029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 72+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(73) : dependencies.sql(1036) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 75+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(76) : dependencies.sql(1039) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(82) : dependencies.sql(1045) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(85) : dependencies.sql(1048) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id
            , True);
   End If;
   
   -- validate predecessor_id
   h_pred_id := predecessor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK, START_DT, FINISH_DT
      INTO h_pred_project_id, h_pred_type_id, h_pred_id, h_pred_rank, h_pred_start_dt, h_pred_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = predecessor_id/**predecessor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(103) : dependencies.sql(1066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 109+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(110) : dependencies.sql(1073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 112+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(113) : dependencies.sql(1076) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_pred_id, True);
   End If;
   
   BEGIN
      SELECT COUNT(SUCC_ID)  INTO h_count FROM DEPENDENCIES
      WHERE SUCC_ID = h_succ_id AND PRED_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(127) : dependencies.sql(1090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND', 132+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND(133) : dependencies.sql(1096) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEPENDENCY_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 135+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(136) : dependencies.sql(1099) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.DEPENDENCY_ALREADY_EXISTS, True);
   End If;
   
   -- validate for circular dependencies
   --  if(CircularDependencyCheck(h_succ_id, h_pred_id) != 0)
   If CircularCheck_WBS(h_table, h_succ_id, h_pred_id) <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND', 144+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND(145) : dependencies.sql(1108) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CIRCULAR_DEPENDENCY), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 147+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(148) : dependencies.sql(1111) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CIRCULAR_DEPENDENCY, True);
   End If;
   
   -- Insert
   BEGIN
      INSERT INTO DEPENDENCIES (DEPEND_ID,PRED_PROJECT_ID, PRED_OBJECT_TYPE, PRED_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE, SUCC_ID, REC_USER, PRED_START_DT, PRED_FINISH_DT, SUCC_START_DT, SUCC_FINISH_DT)
      VALUES(h_uniqueID,h_pred_project_id, h_pred_type_id, h_pred_id, h_succ_project_id, h_succ_type_id, h_succ_id, rec_user001, h_pred_start_dt, h_pred_finish_dt, h_succ_start_dt, h_succ_finish_dt);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 166+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(167) : dependencies.sql(1130) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND', 173+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND(174) : dependencies.sql(1137) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND', 176+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND(177) : dependencies.sql(1140) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_uniqueID, True);
   End If;
   
   PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
   
   UPDATE TMT_WBS SET
           DEPENDENCIES = NULL
      WHERE ELEMENT_ID = H_SUCC_ID;

   BEGIN
      UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 199+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(200) : dependencies.sql(1163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_pred_project_id, h_succ_project_id) = PMO_CNST.SC_MATCH Then
      h_count := FC_Rollup(h_pred_project_id);
   Else
      h_count := FC_Rollup(h_pred_project_id);
      h_count := FC_Rollup(h_succ_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_DEPEND', 212+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_DEPEND(213) : dependencies.sql(1176) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 219+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(220) : dependencies.sql(1183) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND', 231+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND(232) : dependencies.sql(1195) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_DEPEND;
ALTER FUNCTION SP_A_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_A_DEPEND_MSP
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
   , ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_dep_str VARCHAR2(8192);
   h_pred_start_dt TIMESTAMP;
   h_pred_finish_dt TIMESTAMP;
   h_succ_start_dt TIMESTAMP;
   h_succ_finish_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_A_DEPEND_MSP(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND_MSP', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_DEPEND_MSP(33) : dependencies.sql(1244) : ' || SYSTIMESTAMP);
   END IF; 

   If ((predecessor_id IS NULL)) OR ((successor_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_DEPEND_MSP', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_DEPEND_MSP(38) : dependencies.sql(1249) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND_MSP', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND_MSP(41) : dependencies.sql(1252) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- Get Pred Info
   h_pred_id := predecessor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT INTO h_pred_project_id, h_pred_type_id, h_pred_start_dt, h_pred_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = h_pred_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(59) : dependencies.sql(1270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND_MSP', 64+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND_MSP(65) : dependencies.sql(1276) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND_MSP', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND_MSP(68) : dependencies.sql(1279) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_pred_id, True);
   End If;
   
   -- Get Succ Info
   h_succ_id := successor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT  INTO h_succ_project_id, h_succ_type_id, h_succ_start_dt, h_succ_finish_dt
      FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(84) : dependencies.sql(1295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND_MSP', 89+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND_MSP(90) : dependencies.sql(1301) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND_MSP', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND_MSP(93) : dependencies.sql(1304) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_id, True);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- Insert
   BEGIN
      INSERT INTO DEPENDENCIES (DEPEND_ID,PRED_PROJECT_ID, PRED_OBJECT_TYPE, PRED_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE, SUCC_ID, AMOUNT, REC_USER, PRED_START_DT, PRED_FINISH_DT, SUCC_START_DT, SUCC_FINISH_DT)
      VALUES(h_uniqueID,h_pred_project_id, h_pred_type_id, h_pred_id, h_succ_project_id, h_succ_type_id, h_succ_id, 0, rec_user001, h_pred_start_dt, h_pred_finish_dt, h_succ_start_dt, h_succ_finish_dt);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(115) : dependencies.sql(1326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_DEPEND_MSP', 121+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_DEPEND_MSP(122) : dependencies.sql(1333) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_DEPEND_MSP', 124+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_DEPEND_MSP(125) : dependencies.sql(1336) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_uniqueID, True);
   End If;
   
   -- Refresh successors dependencies columns
   PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
   
   UPDATE TMT_WBS SET
           DEPENDENCIES = NULL
      WHERE ELEMENT_ID = H_SUCC_ID;

   BEGIN
      UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 148+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(149) : dependencies.sql(1360) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_DEPEND_MSP', 154+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_DEPEND_MSP(155) : dependencies.sql(1366) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 161+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(162) : dependencies.sql(1373) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_DEPEND_MSP', 173+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_DEPEND_MSP(174) : dependencies.sql(1385) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_DEPEND_MSP;
ALTER FUNCTION SP_A_DEPEND_MSP COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DEPEND ==
CREATE OR REPLACE FUNCTION SP_U_DEPEND
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_amount PLS_INTEGER := 0;
   h_dep_str VARCHAR2(8192);
   h_mpd PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DEPEND(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DEPEND(33) : dependencies.sql(1434) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If (dep_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND(39) : dependencies.sql(1440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND(42) : dependencies.sql(1443) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   If ((lead_or_lag_type001 IS NULL)) OR ((lag_display_unit001 IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND', 47+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND(48) : dependencies.sql(1449) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND(51) : dependencies.sql(1452) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   BEGIN
      SELECT PRED_ID, SUCC_ID, SUCC_PROJECT_ID INTO h_pred_id, h_succ_id, h_succ_project_id
      FROM DEPENDENCIES WHERE DEPEND_ID = dep_id/**dep_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(68) : dependencies.sql(1469) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND(75) : dependencies.sql(1476) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND(78) : dependencies.sql(1479) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(91) : dependencies.sql(1492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEPEND', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEPEND(97) : dependencies.sql(1498) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND(100) : dependencies.sql(1501) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEPEND', 105+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEPEND(106) : dependencies.sql(1507) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 108+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND(109) : dependencies.sql(1510) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id
            , True);
   End If;
   
   BEGIN
      SELECT MINUTE_PER_DAY INTO h_mpd
      FROM TMT_WBS WHERE ELEMENT_ID = h_succ_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(124) : dependencies.sql(1525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEPEND', 130+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEPEND(131) : dependencies.sql(1532) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_project_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND', 133+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND(134) : dependencies.sql(1535) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_project_id
            , True);
   End If;
   
   If Coalesce(lag_display_unit001, 0) = 0 Then
      h_amount := Trunc(Coalesce(amount001, 0) * Coalesce(h_mpd, 0));
   ElsIf Coalesce(lag_display_unit001, 0) = 1 Then
      h_amount := Trunc(Coalesce(amount001, 0) * 60);
   Else
      h_amount := Trunc(Coalesce(amount001, 0));
   End If;
   
   -- Update
   BEGIN
      UPDATE DEPENDENCIES SET
      DEP_TYPE = dep_type001/**dep_type:ind_u_depend->dep_type*/,
      LEAD_OR_LAG_TYPE = lead_or_lag_type001/**lead_or_lag_type:ind_u_depend->lead_or_lag_type*/,
      AMOUNT = h_amount,
      LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_u_depend->lag_display_unit*/,
      REC_USER = rec_user001/**rec_user:ind_u_depend->rec_user*/,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE DEPEND_ID = dep_id/**dep_id*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(169) : dependencies.sql(1570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      -- Refresh successors dependencies columns
      PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
      
      UPDATE TMT_WBS SET
              DEPENDENCIES = NULL
         WHERE ELEMENT_ID = H_SUCC_ID;

      BEGIN
         UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 193+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(194) : dependencies.sql(1595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_count := FC_Rollup(h_succ_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DEPEND', 202+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DEPEND(203) : dependencies.sql(1604) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 209+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(210) : dependencies.sql(1611) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND', 221+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND(222) : dependencies.sql(1623) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DEPEND;
ALTER FUNCTION SP_U_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_U_DEPEND_MSP
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
   , ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_dep_str VARCHAR2(8192);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DEPEND_MSP(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND_MSP', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DEPEND_MSP(30) : dependencies.sql(1669) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If (dep_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND_MSP', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND_MSP(36) : dependencies.sql(1675) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND_MSP', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND_MSP(39) : dependencies.sql(1678) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   If ((lead_or_lag_type001 IS NULL)) OR ((lag_display_unit001 IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND_MSP', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND_MSP(45) : dependencies.sql(1684) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND_MSP', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND_MSP(48) : dependencies.sql(1687) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   BEGIN
      SELECT PRED_ID, SUCC_ID INTO h_pred_id, h_succ_id
      FROM DEPENDENCIES WHERE DEPEND_ID = dep_id/**dep_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(65) : dependencies.sql(1704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DEPEND_MSP', 71+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DEPEND_MSP(72) : dependencies.sql(1711) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEPEND_MSP', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEPEND_MSP(75) : dependencies.sql(1714) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   -- Update
   BEGIN
      UPDATE DEPENDENCIES SET
      DEP_TYPE = dep_type001/**dep_type:ind_u_depend->dep_type*/,
      LEAD_OR_LAG_TYPE = lead_or_lag_type001/**lead_or_lag_type:ind_u_depend->lead_or_lag_type*/,
      AMOUNT = amount001/**amount:ind_u_depend->amount*/,
      LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_u_depend->lag_display_unit*/,
      REC_USER = rec_user001/**rec_user:ind_u_depend->rec_user*/,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE DEPEND_ID = dep_id/**dep_id*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(101) : dependencies.sql(1740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      -- Refresh successors dependencies columns
      PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
      
      UPDATE TMT_WBS SET
              DEPENDENCIES = NULL
         WHERE ELEMENT_ID = H_SUCC_ID;

      BEGIN
         UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(126) : dependencies.sql(1765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DEPEND_MSP', 132+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DEPEND_MSP(133) : dependencies.sql(1772) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 139+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(140) : dependencies.sql(1779) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEPEND_MSP', 151+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEPEND_MSP(152) : dependencies.sql(1791) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DEPEND_MSP;
ALTER FUNCTION SP_U_DEPEND_MSP COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_DEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_DEPEND
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_dep_str VARCHAR2(8192);
   h_pred_project_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_DEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_DEPEND(26) : dependencies.sql(1833) : ' || SYSTIMESTAMP);
   END IF; 

   If (dep_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_DEPEND', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_DEPEND(31) : dependencies.sql(1838) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_DEPEND(34) : dependencies.sql(1841) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   h_depend_id := dep_id;
   BEGIN
      SELECT PRED_ID, SUCC_ID, PRED_PROJECT_ID, SUCC_PROJECT_ID
      INTO h_pred_id, h_succ_id, h_pred_project_id, h_succ_project_id
      FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(53) : dependencies.sql(1860) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_DEPEND', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_DEPEND(60) : dependencies.sql(1867) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_DEPEND(63) : dependencies.sql(1870) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   -- Delete
   BEGIN
      DELETE FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(81) : dependencies.sql(1888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
      
      If PMO_ORASTD.strcmp(h_dep_str, '{RS}{RF}') <> 0 Then
         UPDATE TMT_WBS SET
                 DEPENDENCIES = NULL
            WHERE ELEMENT_ID = H_SUCC_ID;

         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 105+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(106) : dependencies.sql(1913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = null WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 122+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(123) : dependencies.sql(1930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If PMO_ORASTD.strcmp(h_pred_project_id, h_succ_project_id) = PMO_CNST.SC_MATCH Then
      h_count := FC_Rollup(h_pred_project_id);
   Else
      h_count := FC_Rollup(h_pred_project_id);
      h_count := FC_Rollup(h_succ_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_DEPEND', 137+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_DEPEND(138) : dependencies.sql(1945) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(145) : dependencies.sql(1952) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND(157) : dependencies.sql(1964) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_DEPEND;
ALTER FUNCTION SP_UA_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_UA_DEPEND_MSP
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
   , ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
   h_pred_id VARCHAR2(32);
   h_dep_str VARCHAR2(8192);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_DEPEND_MSP(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND_MSP', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_DEPEND_MSP(25) : dependencies.sql(2005) : ' || SYSTIMESTAMP);
   END IF; 

   If (dep_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_DEPEND_MSP', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_DEPEND_MSP(30) : dependencies.sql(2010) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_DEPEND_MSP', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_DEPEND_MSP(33) : dependencies.sql(2013) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   h_depend_id := dep_id;
   BEGIN
      SELECT PRED_ID, SUCC_ID INTO h_pred_id, h_succ_id
      FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(51) : dependencies.sql(2031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Delete
   BEGIN
      DELETE FROM DEPENDENCIES WHERE DEPEND_ID = h_depend_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(69) : dependencies.sql(2049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
      
      If PMO_ORASTD.strcmp(h_dep_str, '{RS}{RF}') <> 0 Then
         UPDATE TMT_WBS SET
                 DEPENDENCIES = NULL
            WHERE ELEMENT_ID = H_SUCC_ID;

         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 93+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(94) : dependencies.sql(2074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS SET DEPENDENCIES = null WHERE ELEMENT_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(111) : dependencies.sql(2091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_DEPEND_MSP', 118+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_DEPEND_MSP(119) : dependencies.sql(2099) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 125+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(126) : dependencies.sql(2106) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_DEPEND_MSP', 137+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_DEPEND_MSP(138) : dependencies.sql(2118) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_DEPEND_MSP;
ALTER FUNCTION SP_UA_DEPEND_MSP COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_WBS_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_WBS_A_DEPEND
(
     id VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_dep_type PLS_INTEGER := 0;
   h_lead_or_lag_type PLS_INTEGER := 0;
   h_lag_display_unit PLS_INTEGER := 0;
   h_dep_amount NUMBER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      depCur001 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur002 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur003 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur004 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WBS_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WBS_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WBS_A_DEPEND(' || 
       '''' || id || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WBS_A_DEPEND(38) : dependencies.sql(2172) : ' || SYSTIMESTAMP);
   END IF; 

   If (id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_WBS_A_DEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_WBS_A_DEPEND(43) : dependencies.sql(2177) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(46) : dependencies.sql(2180) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := id;
   If (NOT ((bitflag001 IS NULL))) AND (Coalesce(bitflag001, 0) = 3) Then
      BEGIN
         SELECT TW.RANK, DEP.DEP_TYPE, DEP.LEAD_OR_LAG_TYPE, DEP.LAG_DISPLAY_UNIT,
         CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END
         INTO h_rank, h_dep_type, h_lead_or_lag_type, h_lag_display_unit, h_dep_amount
         FROM TMT_WBS TW JOIN DEPENDENCIES DEP ON DEP.SUCC_ID = TW.ELEMENT_ID
         WHERE DEP.DEPEND_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(67) : dependencies.sql(2201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN depCur001 FOR SELECT CASE WHEN TW.RANK = h_rank THEN h_id ELSE TW.ELEMENT_ID END AS ELEMENT_ID,
      TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, TW.LEVEL_ID AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DT AS START_DATE,
      TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME,
      CASE WHEN TW.RANK = h_rank THEN h_dep_type ELSE 0 END AS DEPENDENCY_TYPE,
      CASE WHEN TW.RANK = h_rank THEN h_lead_or_lag_type ELSE 0 END AS LEAD_OR_LAG_TYPE,
      CASE WHEN TW.RANK = h_rank THEN PMO_ORASTD.TODECIMAL(h_dep_amount, 18,2) ELSE 0.00 END AS AMOUNT,
      CASE WHEN TW.RANK = h_rank THEN h_lag_display_unit ELSE 0 END AS LAG_DISPLAY_UNIT,
      0 AS CONSTRAINT_TYPE, '' AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM TMT_WBS TW  JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE TW.ELEMENT_ID IS NOT NuLL
      AND LENGTH(TW.RANK) <= LENGTH(h_rank)
      AND (SUBSTR(h_rank, 1, CASE WHEN LENGTH(TW.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(TW.RANK) END) = TW.RANK 
      AND (TW.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
      ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(92) : dependencies.sql(2226) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur001;
   ElsIf (NOT ((bitflag001 IS NULL))) AND (Coalesce(bitflag001, 0) = 2) Then
      BEGIN
         SELECT TW.RANK, DEP.DEP_TYPE, DEP.LEAD_OR_LAG_TYPE, DEP.LAG_DISPLAY_UNIT,
         CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END
         INTO h_rank, h_dep_type, h_lead_or_lag_type, h_lag_display_unit, h_dep_amount
         FROM TMT_WBS TW JOIN DEPENDENCIES DEP ON DEP.PRED_ID = TW.ELEMENT_ID
         WHERE DEP.DEPEND_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 107+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(108) : dependencies.sql(2242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN depCur002 FOR SELECT CASE WHEN TW.RANK = h_rank THEN h_id ELSE TW.ELEMENT_ID END AS ELEMENT_ID,
      TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, TW.LEVEL_ID AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DT AS START_DATE,
      TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME,
      CASE WHEN TW.RANK = h_rank THEN h_dep_type ELSE 0 END AS DEPENDENCY_TYPE,
      CASE WHEN TW.RANK = h_rank THEN h_lead_or_lag_type ELSE 0 END AS LEAD_OR_LAG_TYPE,
      CASE WHEN TW.RANK = h_rank THEN PMO_ORASTD.TODECIMAL(h_dep_amount, 18,2) ELSE 0.00 END AS AMOUNT,
      CASE WHEN TW.RANK = h_rank THEN h_lag_display_unit ELSE 0 END AS LAG_DISPLAY_UNIT,
      0 AS CONSTRAINT_TYPE, '' AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM TMT_WBS TW  JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE TW.ELEMENT_ID IS NOT NuLL AND LENGTH(TW.RANK) <= LENGTH(h_rank) AND
      (SUBSTR(h_rank, 1, CASE WHEN LENGTH(TW.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(TW.RANK) END) = TW.RANK 
      AND (TW.RANK LIKE SUBSTR(h_rank, 1, 8) || '%'))
      ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(132) : dependencies.sql(2266) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur002;
   ElsIf (NOT ((bitflag001 IS NULL))) AND (Coalesce(bitflag001, 0) = 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_WBS_A_DEPEND', 136+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_WBS_A_DEPEND(137) : dependencies.sql(2271) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      OPEN depCur003 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.SUCC_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.PARENT_ID IS Null THEN 0 ELSE 1 END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE, TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM DEPENDENCIES DEP LEFT OUTER JOIN TMT_WBS TW ON DEP.SUCC_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.PRED_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 161+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(162) : dependencies.sql(2296) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur003;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_S_WBS_A_DEPEND', 166+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_S_WBS_A_DEPEND(167) : dependencies.sql(2301) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      OPEN depCur004 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.PRED_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.PARENT_ID IS Null THEN 0 ELSE 1 END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DT AS START_DATE, TW.FINISH_DT AS FINISH_DATE, Trunc(TW.MILESTONE_PERCENT) AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW.MINUTE_PER_DAY, 18, 2), 18, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 18, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT, TW.CONSTRAINT_TYPE AS CONSTRAINT_TYPE, TW.CONSTRAINT_DT AS CONSTRAINT_DATE, TW.TRANSFER_FLAG
      FROM DEPENDENCIES DEP LEFT OUTER JOIN TMT_WBS TW ON DEP.PRED_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.SUCC_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_A_DEPEND', 191+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_A_DEPEND(192) : dependencies.sql(2326) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur004;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 200+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(201) : dependencies.sql(2335) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_A_DEPEND', 212+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_A_DEPEND(213) : dependencies.sql(2347) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WBS_A_DEPEND;
ALTER FUNCTION SP_S_WBS_A_DEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_DEPEND_MSP ==
CREATE OR REPLACE FUNCTION SP_DEPEND_MSP
(
     id VARCHAR2
   , action_type PLS_INTEGER
   , successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , ieflag PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_dep_str VARCHAR2(8192);
   h_pred_start_dt TIMESTAMP;
   h_pred_finish_dt TIMESTAMP;
   h_succ_start_dt TIMESTAMP;
   h_succ_finish_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_DEPEND_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_DEPEND_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_DEPEND_MSP(' || 
       '''' || id || ''''
          || ', ' || COALESCE(TO_CHAR(action_type), 'NULL')
          || ', ' || '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(ieflag), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DEPEND_MSP', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_DEPEND_MSP(44) : dependencies.sql(2407) : ' || SYSTIMESTAMP);
   END IF; 

   --Local host variable
   
   CASE action_type
      WHEN 1 THEN
         --Insert Dependency
         h_id := SYS_GUID();
         h_succ_id := successor_id;
         
         BEGIN
            SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT
            INTO h_succ_project_id, h_succ_type_id, h_succ_start_dt, h_succ_finish_dt
            FROM TMT_WBS WHERE ELEMENT_ID = h_succ_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 64+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(65) : dependencies.sql(2428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT PROJECT_ID, TYPE_ID, START_DT, FINISH_DT
            INTO h_pred_project_id, h_pred_type_id, h_pred_start_dt, h_pred_finish_dt
            FROM TMT_WBS WHERE ELEMENT_ID = predecessor_id/**predecessor_id*/;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(80) : dependencies.sql(2443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO DEPENDENCIES (
            DEPEND_ID,
            SUCC_ID,
            SUCC_PROJECT_ID,
            SUCC_OBJECT_TYPE,
            PRED_ID,
            PRED_PROJECT_ID,
            PRED_OBJECT_TYPE,
            DEP_TYPE,
            LEAD_OR_LAG_TYPE,
            AMOUNT,
            LAG_DISPLAY_UNIT,
            REC_USER,
            REC_STATUS,
            PRED_START_DT,
            PRED_FINISH_DT,
            SUCC_START_DT,
            SUCC_FINISH_DT,
            REC_DATETIME)
            VALUES (
            h_id,
            h_succ_id,
            h_succ_project_id,
            h_succ_type_id,
            predecessor_id/**predecessor_id*/,
            h_pred_project_id,
            h_pred_type_id,
            dep_type001/**dep_type:ind_depend_msp->dep_type*/,
            lead_or_lag_type001/**lead_or_lag_type:ind_depend_msp->lead_or_lag_type*/,
            Trunc(amount001)/**amount:ind_depend_msp->amount*/,
            lag_display_unit001/**lag_display_unit:ind_depend_msp->lag_display_unit*/,
            rec_user001/**rec_user:ind_depend_msp->rec_user*/,
            'U',
            h_pred_start_dt,
            h_pred_finish_dt,
            h_succ_start_dt,
            h_succ_finish_dt,
            SYSTIMESTAMP);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 133+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(134) : dependencies.sql(2497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
      
      WHEN 2 THEN
         --Update Dependency
         h_id := id;
         
         BEGIN
            SELECT SUCC_ID INTO h_succ_id
            FROM DEPENDENCIES WHERE DEPEND_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(153) : dependencies.sql(2516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE DEPENDENCIES SET
            DEP_TYPE = dep_type001/**dep_type:ind_depend_msp->dep_type*/,
            LEAD_OR_LAG_TYPE = lead_or_lag_type001/**lead_or_lag_type:ind_depend_msp->lead_or_lag_type*/,
            AMOUNT = Trunc(amount001)/**amount:ind_depend_msp->amount*/,
            LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_depend_msp->lag_display_unit*/,
            REC_USER = rec_user001/**rec_user:ind_depend_msp->rec_user*/,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP
            WHERE DEPEND_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(178) : dependencies.sql(2541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      
      ELSE
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_DEPEND_MSP', 184+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_DEPEND_MSP(185) : dependencies.sql(2548) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_DEPEND_MSP', 187+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_DEPEND_MSP(188) : dependencies.sql(2551) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   END CASE;
   
   PMO_STPU.packDependencies(h_succ_id, h_dep_str, 8193);
   
   UPDATE TMT_WBS SET
           DEPENDENCIES = NULL
      WHERE ELEMENT_ID = H_SUCC_ID;

   BEGIN
      UPDATE TMT_WBS SET DEPENDENCIES = h_dep_str WHERE ELEMENT_ID = h_succ_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 210+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(211) : dependencies.sql(2574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_DEPEND_MSP', 216+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_DEPEND_MSP(217) : dependencies.sql(2580) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 223+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(224) : dependencies.sql(2587) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_DEPEND_MSP', 235+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_DEPEND_MSP(236) : dependencies.sql(2599) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_DEPEND_MSP;
ALTER FUNCTION SP_DEPEND_MSP COMPILE DEBUG;

/**************************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_A_CRIDEPEND ==
CREATE OR REPLACE FUNCTION SP_A_CRIDEPEND
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_element_id VARCHAR2(32);
   h_table PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_COUNT1 IS
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_pred_id
         AND ((SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')) OR RANK LIKE h_succ_rank || '%');

      CURSOR C_COUNT2 IS
         SELECT ELEMENT_ID
         FROM TMT_CRI
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_succ_id
         AND ((SUBSTR(h_pred_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_pred_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_pred_rank, 1, 8) || '%')) OR RANK LIKE h_pred_rank || '%');

      CURSOR C_COUNT3 IS
         SELECT PRED_ID
         FROM CRIDEPENDENCIES
         WHERE  ROWNUM <= 1 AND  PRED_ID = h_pred_id AND SUCC_ID = h_succ_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_CRIDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_CRIDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_CRIDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_CRIDEPEND(51) : dependencies.sql(2668) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If ((predecessor_id IS NULL)) OR ((successor_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 57+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(58) : dependencies.sql(2675) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(61) : dependencies.sql(2678) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate successor_id
   h_succ_id := successor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK, REC_STATUS
      INTO h_succ_project_id, h_succ_type_id, h_succ_id, h_succ_rank, h_rec_status
      FROM TMT_CRI WHERE ELEMENT_ID = successor_id/**successor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(81) : dependencies.sql(2698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 87+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(88) : dependencies.sql(2705) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 90+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(91) : dependencies.sql(2708) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(97) : dependencies.sql(2714) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(100) : dependencies.sql(2717) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id
            , True);
   End If;
   
   -- validate predecessor_id
   h_pred_id := predecessor_id;
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, ELEMENT_ID, RANK
      INTO h_pred_project_id, h_pred_type_id, h_pred_id, h_pred_rank
      FROM TMT_CRI WHERE ELEMENT_ID = predecessor_id/**predecessor_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(118) : dependencies.sql(2735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 124+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(125) : dependencies.sql(2742) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_pred_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 127+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(128) : dependencies.sql(2745) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_pred_id, True);
   End If;
   
   -- validate parent child relationship
   -- using two statements to avoid table scan
   
   OPEN C_COUNT1;
   
   FETCH C_COUNT1 INTO h_element_id;
   IF C_COUNT1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         CLOSE C_COUNT1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(154) : dependencies.sql(2771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 158+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(159) : dependencies.sql(2776) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 161+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(162) : dependencies.sql(2779) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP, True);
   End If;
   BEGIN
      CLOSE C_COUNT1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(174) : dependencies.sql(2791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_COUNT2;
   
   FETCH C_COUNT2 INTO h_element_id;
   IF C_COUNT2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         CLOSE C_COUNT2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 196+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(197) : dependencies.sql(2814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 201+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(202) : dependencies.sql(2819) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 204+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(205) : dependencies.sql(2822) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_ASSIGN_PARENT_CHILD_DEP, True);
   End If;
   BEGIN
      CLOSE C_COUNT2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(217) : dependencies.sql(2834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- validate for record existence (2 ways predecessor_id/successor_id or successor_id/predecessor_id as PRED_ID, SUCC_ID)
   
   OPEN C_COUNT3;
   
   FETCH C_COUNT3 INTO h_element_id;
   IF C_COUNT3%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         CLOSE C_COUNT3 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 241+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(242) : dependencies.sql(2859) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_CRIDEPEND', 246+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_CRIDEPEND(247) : dependencies.sql(2864) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DEPENDENCY_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 249+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(250) : dependencies.sql(2867) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.DEPENDENCY_ALREADY_EXISTS, True);
   End If;
   BEGIN
      CLOSE C_COUNT3 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 261+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(262) : dependencies.sql(2879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- !!!!! The following code is for temparary use. When GUI is fixed, we have to modify these code.
   --  if(CircularCRIDependencyCheck(h_succ_id, h_pred_id) != 0)
   If CircularCheck_CRI(h_table, h_succ_id, h_pred_id) = 0 Then
      -- Insert
      BEGIN
         INSERT INTO CRIDEPENDENCIES (DEPEND_ID,PRED_PROJECT_ID, PRED_OBJECT_TYPE, PRED_ID, SUCC_PROJECT_ID, SUCC_OBJECT_TYPE, SUCC_ID, AMOUNT, REC_USER)
         VALUES(h_uniqueID,h_pred_project_id, h_pred_type_id, h_pred_id, h_succ_project_id, h_succ_type_id, h_succ_id, 0, rec_user001/**rec_user:ind_i_depend->rec_user*/);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 283+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(284) : dependencies.sql(2901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_A_CRIDEPEND', 290+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_A_CRIDEPEND(291) : dependencies.sql(2908) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_CRIDEPEND', 293+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_A_CRIDEPEND(294) : dependencies.sql(2911) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_uniqueID, True);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_CRIDEPEND', 300+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_CRIDEPEND(301) : dependencies.sql(2918) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 308+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(309) : dependencies.sql(2926) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_CRIDEPEND', 320+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_CRIDEPEND(321) : dependencies.sql(2938) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_CRIDEPEND;
ALTER FUNCTION SP_A_CRIDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_CRIDEPEND ==
CREATE OR REPLACE FUNCTION SP_U_CRIDEPEND
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_amount PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CRIDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CRIDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CRIDEPEND(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CRIDEPEND(31) : dependencies.sql(2985) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If (dep_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(37) : dependencies.sql(2991) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDEPEND(40) : dependencies.sql(2994) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   If ((lead_or_lag_type001 IS NULL)) OR ((lag_display_unit001 IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 45+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(46) : dependencies.sql(3000) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDEPEND(49) : dependencies.sql(3003) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   BEGIN
      SELECT PRED_ID, SUCC_ID, SUCC_PROJECT_ID INTO h_pred_id, h_succ_id, h_succ_project_id
      FROM CRIDEPENDENCIES WHERE DEPEND_ID = dep_id/**dep_id*/;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(66) : dependencies.sql(3020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 72+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(73) : dependencies.sql(3027) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 75+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDEPEND(76) : dependencies.sql(3030) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_CRI WHERE ELEMENT_ID = h_succ_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(89) : dependencies.sql(3043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRIDEPEND', 94+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRIDEPEND(95) : dependencies.sql(3049) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDEPEND(98) : dependencies.sql(3052) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_succ_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CRIDEPEND', 103+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CRIDEPEND(104) : dependencies.sql(3058) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_succ_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 106+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDEPEND(107) : dependencies.sql(3061) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_succ_id
            , True);
   End If;
   
   BEGIN
      SELECT MINUTE_PER_DAY INTO h_mpd
      FROM TMT_WBS WHERE ELEMENT_ID = h_succ_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(122) : dependencies.sql(3076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CRIDEPEND', 128+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CRIDEPEND(129) : dependencies.sql(3083) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CRIDEPEND', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CRIDEPEND(132) : dependencies.sql(3086) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   If Coalesce(lag_display_unit001, 0) = 0 Then
      h_amount := Trunc(Coalesce(amount001, 0) * Coalesce(h_mpd, 0));
   Else
      h_amount := Trunc(Coalesce(amount001, 0) * 60);
   End If;
   
   -- Update
   BEGIN
      UPDATE CRIDEPENDENCIES SET
      DEP_TYPE = dep_type001/**dep_type:ind_u_depend->dep_type*/,
      LEAD_OR_LAG_TYPE = lead_or_lag_type001 /**lead_or_lag_type:ind_u_depend->lead_or_lag_type*/,
      AMOUNT = h_amount,
      LAG_DISPLAY_UNIT = lag_display_unit001/**lag_display_unit:ind_u_depend->lag_display_unit*/,
      REC_USER = rec_user001/**rec_user:ind_u_depend->rec_user*/,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE DEPEND_ID = dep_id/**dep_id*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(164) : dependencies.sql(3118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CRIDEPEND', 169+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CRIDEPEND(170) : dependencies.sql(3124) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 176+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(177) : dependencies.sql(3131) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CRIDEPEND', 188+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CRIDEPEND(189) : dependencies.sql(3143) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CRIDEPEND;
ALTER FUNCTION SP_U_CRIDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_CRIDEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_CRIDEPEND
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_depend_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_CRIDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_CRIDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_CRIDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CRIDEPEND', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_CRIDEPEND(20) : dependencies.sql(3179) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_succ_id, SC_H_ID);
   --SC_LONG(h_count);
   --SC_CHAR(h_pred_id, SC_H_ID);
   
   If ((dep_id IS NULL)) OR ((successor_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_CRIDEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_CRIDEPEND(30) : dependencies.sql(3189) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CRIDEPEND', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_CRIDEPEND(33) : dependencies.sql(3192) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- validate for record existence
   h_depend_id := dep_id;
   --InitializeHost(SC_PARAM(h_succ_id), successor_id, ind_ua_depend->successor_id);
   
   -- validate for record existence
   --BEGIN_SQL
   --  SELECT COUNT(*) INTO HOST(h_count) FROM CRIDEPENDENCIES WHERE DEPEND_ID = HOST(h_depend_id) AND SUCC_ID = HOST(h_succ_id) ;
   --END_SQL;
   
   --if (h_count == 0) { RETURN_INVALID(RECORD_NOT_FOUND); }
   
   --BEGIN_SQL
   --  SELECT PRED_ID INTO HOST(h_pred_id) FROM CRIDEPENDENCIES WHERE DEPEND_ID = HOST(h_depend_id) AND SUCC_ID = HOST(h_succ_id) ;
   --END_SQL;
   
   -- Delete
   BEGIN
      DELETE FROM CRIDEPENDENCIES WHERE DEPEND_ID = dep_id/*HOST(h_depend_id)*/ AND SUCC_ID = successor_id/*HOST(h_succ_id)*/;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CRIDEPEND', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CRIDEPEND(66) : dependencies.sql(3225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_CRIDEPEND', 72+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_CRIDEPEND(73) : dependencies.sql(3232) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_CRIDEPEND', 75+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_CRIDEPEND(76) : dependencies.sql(3235) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_CRIDEPEND', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_CRIDEPEND(82) : dependencies.sql(3241) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CRIDEPEND', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CRIDEPEND(89) : dependencies.sql(3248) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_CRIDEPEND', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_CRIDEPEND(101) : dependencies.sql(3260) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_CRIDEPEND;
ALTER FUNCTION SP_UA_CRIDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_CRI_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_CRI_A_DEPEND
(
     id VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_rank VARCHAR2(200);
   h_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      depCur005 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur006 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur007 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      depCur008 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_CRI_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_CRI_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_CRI_A_DEPEND(' || 
       '''' || id || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_CRI_A_DEPEND(33) : dependencies.sql(3309) : ' || SYSTIMESTAMP);
   END IF; 

   --bitflag 3 = Reverse lookup for Successor
   --bitflag 2 = Reverse lookup for Predecessor
   --bitflag 1 = Successors
   --bitflag 0 = Predecessors
   
   If (id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_CRI_A_DEPEND', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_CRI_A_DEPEND(43) : dependencies.sql(3319) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(46) : dependencies.sql(3322) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := id;
   
   If (NOT ((bitflag001 IS NULL))) AND (Coalesce(bitflag001, 0) = 3) Then
      BEGIN
         SELECT CTW.RANK INTO h_temp_rank
         FROM CRIDEPENDENCIES DEP, TMT_CRI CTW
         WHERE DEP.SUCC_ID = CTW.ELEMENT_ID AND
         DEPEND_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_DEPEND', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_DEPEND(67) : dependencies.sql(3343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN depCur005 FOR SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID,  CASE WHEN TW.LEVEL_ID >= 2 THEN TW.LEVEL_ID - 2  ELSE 0 END AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE,
      TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT
      FROM TMT_CRI TW JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE (SUBSTR(h_temp_rank, 1, CASE WHEN LENGTH(TW.RANK) > LENGTH(h_temp_rank) THEN 1 ELSE LENGTH(TW.RANK) END) = TW.RANK 
      AND (TW.RANK LIKE SUBSTR(h_temp_rank, 1, 8) || '%')) AND
      TW.TYPE_ID <> 0 AND
      TW.LEVEL_ID > 1
      ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(86) : dependencies.sql(3362) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur005;
   ElsIf (NOT ((bitflag001 IS NULL))) AND (Coalesce(bitflag001, 0) = 2) Then
      --      trace_printf("22222222\n");
      
      OPEN depCur006 FOR SELECT TW.ELEMENT_ID AS ELEMENT_ID, TW.TYPE_ID AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, TW.LEVEL_ID AS LEVEL_ID, CASE WHEN TW.LEVEL_ID >= 2 THEN TW.LEVEL_ID - 2  ELSE 0 END AS CHILD_COUNT, TW.ELEMENT_ID AS ORIGINAL_ID,
      TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME, TW.START_DATETIME AS START_DATE,
      TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED, TW.CREATED_BY AS CREATED_BY_ID,
      RES2.FULL_NAME AS CREATED_BY_NAME, 0 AS DEPENDENCY_TYPE, 0 AS LEAD_OR_LAG_TYPE, 0 AS AMOUNT, 0 AS LAG_DISPLAY_UNIT
      FROM TMT_CRI TW JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE ((TW.RANK >= SUBSTR(
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id), 1, 8) AND TW.RANK <= 
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id)) 
      AND SUBSTR(
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id),1, CASE WHEN LENGTH(TW.RANK) > LENGTH(
      (SELECT CTW.RANK FROM CRIDEPENDENCIES DEP1 JOIN TMT_CRI CTW ON DEP1.PRED_ID = CTW.ELEMENT_ID
      WHERE DEPEND_ID = h_id)) THEN 1 ELSE LENGTH(TW.RANK) END ) = TW.RANK)  AND TW.TYPE_ID <> 0 AND TW.LEVEL_ID > 1 ORDER BY ELEMENT_RANK DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 110+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(111) : dependencies.sql(3387) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur006;
   ElsIf (NOT ((bitflag001 IS NULL))) AND (Coalesce(bitflag001, 0) = 1) Then
      --trace_printf("333333333333\n");
      
      OPEN depCur007 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.SUCC_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.LEVEL_ID = 2  THEN 0  ELSE 1  END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DATETIME AS START_DATE, TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW2.MINUTE_PER_DAY, 5, 2), 5, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 5, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT
      FROM CRIDEPENDENCIES DEP JOIN TMT_CRI TW ON DEP.SUCC_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.PRED_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 130+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(131) : dependencies.sql(3407) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur007;
   Else
      --      trace_printf("4444444444444444444\n");
      
      OPEN depCur008 FOR SELECT DEP.DEPEND_ID AS ELEMENT_ID, DEP.PRED_OBJECT_TYPE AS TYPE_ID, TW.ELEMENT_NAME AS ELEMENT_NAME,
      TW.RANK AS ELEMENT_RANK, 0 AS LEVEL_ID, CASE WHEN TW.LEVEL_ID = 2  THEN 0  ELSE 1  END AS CHILD_COUNT,
      TW.ELEMENT_ID AS ORIGINAL_ID, TW2.ELEMENT_NAME AS PROJECT_NAME,
      SUBSTR(TW.ASSIGN_NAMES,1,CASE WHEN InStr(TW.ASSIGN_NAMES, ';')> 0 THEN InStr(TW.ASSIGN_NAMES, ';') -1 ELSE 1 END) AS RESPONSIBLE_NAME,
      TW.START_DATETIME AS START_DATE, TW.FINISH_DATETIME AS FINISH_DATE, 0 AS PERCENT_COMPLETED,
      TW.CREATED_BY AS CREATED_BY_ID, RES2.FULL_NAME AS CREATED_BY_NAME, DEP.DEP_TYPE AS DEPENDENCY_TYPE,
      DEP.LEAD_OR_LAG_TYPE AS LEAD_OR_LAG_TYPE,
      CASE WHEN DEP.LAG_DISPLAY_UNIT = 0 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/PMO_ORASTD.TODECIMAL(TW2.MINUTE_PER_DAY, 5, 2), 5, 2) WHEN DEP.LAG_DISPLAY_UNIT = 1 THEN PMO_ORASTD.TODECIMAL(DEP.AMOUNT/60.00, 5, 2) ELSE DEP.AMOUNT END AS AMOUNT,
      DEP.LAG_DISPLAY_UNIT AS LAG_DISPLAY_UNIT
      FROM CRIDEPENDENCIES DEP JOIN TMT_CRI TW ON DEP.PRED_ID = TW.ELEMENT_ID
      JOIN TMT_WBS TW2 ON TW.PROJECT_ID = TW2.ELEMENT_ID
      JOIN RESOURCES RES2 ON TW.CREATED_BY = RES2.RESOURCE_ID
      WHERE DEP.SUCC_ID = h_id ORDER BY FINISH_DATE DESC;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_CRI_A_DEPEND', 150+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_CRI_A_DEPEND(151) : dependencies.sql(3427) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN depCur008;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_DEPEND', 158+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_DEPEND(159) : dependencies.sql(3435) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_CRI_A_DEPEND', 170+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_CRI_A_DEPEND(171) : dependencies.sql(3447) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_CRI_A_DEPEND;
ALTER FUNCTION SP_S_CRI_A_DEPEND COMPILE DEBUG;

/*******************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_A_REQDEPEND ==
CREATE OR REPLACE FUNCTION SP_A_REQDEPEND
(
     successor_id VARCHAR2
   , predecessor_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_type_id PLS_INTEGER := 0;
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_type_id PLS_INTEGER := 0;
   h_succ_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_element_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_REQDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_REQDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_A_REQDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || predecessor_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_REQDEPEND', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_REQDEPEND(31) : dependencies.sql(3496) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If ((predecessor_id IS NULL)) OR ((successor_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_REQDEPEND', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_REQDEPEND(38) : dependencies.sql(3503) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_REQDEPEND', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_REQDEPEND(41) : dependencies.sql(3506) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Get a unique id
   h_uniqueID := SYS_GUID();
   
   -- validate successor_id
   h_succ_id := successor_id;
   -- commented by paria because we don't have tmt_requirement table anymore 11/18/2002
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_REQDEPEND', 54+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_REQDEPEND(55) : dependencies.sql(3520) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_REQDEPEND', 61+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_REQDEPEND(62) : dependencies.sql(3527) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_REQDEPEND', 73+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_REQDEPEND(74) : dependencies.sql(3539) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_REQDEPEND;
ALTER FUNCTION SP_A_REQDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_REQDEPEND ==
CREATE OR REPLACE FUNCTION SP_U_REQDEPEND
(
     dep_id VARCHAR2
   , dep_type001 PLS_INTEGER
   , lead_or_lag_type001 PLS_INTEGER
   , amount001 NUMBER
   , lag_display_unit001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pred_id VARCHAR2(32);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_amount PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_REQDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_REQDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_U_REQDEPEND(' || 
       '''' || dep_id || ''''
          || ', ' || COALESCE(TO_CHAR(dep_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lead_or_lag_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(amount001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(lag_display_unit001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_REQDEPEND', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_REQDEPEND(31) : dependencies.sql(3586) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate parameters
   If (dep_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_REQDEPEND', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_REQDEPEND(37) : dependencies.sql(3592) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_REQDEPEND', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_REQDEPEND(40) : dependencies.sql(3595) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   If ((lead_or_lag_type001 IS NULL)) OR ((lag_display_unit001 IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_REQDEPEND', 45+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_REQDEPEND(46) : dependencies.sql(3601) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_REQDEPEND', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_REQDEPEND(49) : dependencies.sql(3604) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   -- validate for record existence
   -- commented by paria because we don't have tmt_requirement table anymore 11/18/2002
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_REQDEPEND', 60+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_REQDEPEND(61) : dependencies.sql(3616) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || dep_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, dep_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REQDEPEND', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REQDEPEND(68) : dependencies.sql(3623) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_REQDEPEND', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_REQDEPEND(80) : dependencies.sql(3635) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_REQDEPEND;
ALTER FUNCTION SP_U_REQDEPEND COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UA_REQDEPEND ==
CREATE OR REPLACE FUNCTION SP_UA_REQDEPEND
(
     successor_id VARCHAR2
   , dep_id VARCHAR2
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_succ_id VARCHAR2(32);
   h_depend_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UA_REQDEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UA_REQDEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_UA_REQDEPEND(' || 
       '''' || successor_id || ''''
          || ', ' || '''' || dep_id || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_REQDEPEND', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UA_REQDEPEND(21) : dependencies.sql(3672) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_LONG(h_count);
   --SC_CHAR(h_pred_id, SC_H_ID);
   
   If ((dep_id IS NULL)) OR ((successor_id IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UA_REQDEPEND', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UA_REQDEPEND(30) : dependencies.sql(3681) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UA_REQDEPEND', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UA_REQDEPEND(33) : dependencies.sql(3684) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- validate for record existence
   h_depend_id := dep_id;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UA_REQDEPEND', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UA_REQDEPEND(43) : dependencies.sql(3694) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_depend_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_depend_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_REQDEPEND', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_REQDEPEND(50) : dependencies.sql(3701) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UA_REQDEPEND', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UA_REQDEPEND(62) : dependencies.sql(3713) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UA_REQDEPEND;
ALTER FUNCTION SP_UA_REQDEPEND COMPILE DEBUG;

/****************************************************************************************/

--bitflag 3 = Reverse lookup for Successor

--bitflag 2 = Reverse lookup for Predecessor

--bitflag 1 = Successors

--bitflag 0 = Predecessors

/****************************************************************************************/

Prompt == FUNCTION SP_S_REQ_A_DEPEND ==
CREATE OR REPLACE FUNCTION SP_S_REQ_A_DEPEND
(
     id VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_REQ_A_DEPEND') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_REQ_A_DEPEND'), '-- ' || SYSTIMESTAMP, ':r := SP_S_REQ_A_DEPEND(' || 
       '''' || id || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_REQ_A_DEPEND', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_REQ_A_DEPEND(19) : dependencies.sql(3758) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_REQ_A_DEPEND', 26+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_REQ_A_DEPEND(27) : dependencies.sql(3766) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_REQ_A_DEPEND', 38+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_REQ_A_DEPEND(39) : dependencies.sql(3778) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_REQ_A_DEPEND;
ALTER FUNCTION SP_S_REQ_A_DEPEND COMPILE DEBUG;

-- Find circular list

Prompt == FUNCTION FC_FIND_CIRCULAR ==
CREATE OR REPLACE FUNCTION FC_FIND_CIRCULAR
(
     h_succ_id IN OUT NOCOPY VARCHAR2
   , h_pred_id IN OUT NOCOPY VARCHAR2
   , h_succ_rank IN OUT NOCOPY VARCHAR2
   , h_pred_rank IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   j PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_CIRCULAR3 IS
         SELECT RANK
         FROM PMO_DEPEND
         WHERE FLAG = 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIND_CIRCULAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIND_CIRCULAR'), '-- ' || SYSTIMESTAMP, ':r := FC_FIND_CIRCULAR(' || 
       '''' || h_succ_id || ''''
          || ', ' || '''' || h_pred_id || ''''
          || ', ' || '''' || h_succ_rank || ''''
          || ', ' || '''' || h_pred_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_CIRCULAR', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIND_CIRCULAR(28) : dependencies.sql(3822) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_SUCC_C_P';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PRED_C';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      SELECT PRED_ID, 0
      FROM PMO_CIRCULAR_WBS
      WHERE (PRED_RANK LIKE h_succ_rank || '%' OR (SUBSTR(h_succ_rank, 1, CASE WHEN LENGTH(PRED_RANK) > LENGTH(h_succ_rank) THEN 1 ELSE LENGTH(PRED_RANK) END) = PRED_RANK 
      AND (PRED_RANK LIKE SUBSTR(h_succ_rank, 1, 8) || '%')));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(59) : dependencies.sql(3853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PRED_C (ELEMENT_ID, FLAG)
      SELECT PRED_ID, 0
      FROM PMO_CIRCULAR_WBS
      WHERE PRED_RANK LIKE h_pred_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(79) : dependencies.sql(3873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   LOOP
      j := j + 1;
      If j > 100 Then
         --trace_printf("\nToo Many Steps!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(S.ELEMENT_ID) INTO h_count
         FROM PMO_SUCC_C_P S, PMO_PRED_C P
         WHERE S.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(102) : dependencies.sql(3896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT01: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      --      BEGIN_SQL
      --          INSERT INTO session.PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
      --          SELECT D.SUCC_ID, W.PRED_RANK, 0
      --          FROM session.PMO_CIRCULAR_DEPEND D, session.PMO_CIRCULAR_WBS W
      --          WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM session.PMO_SUCC_C_P WHERE FLAG = 0)
      --              AND D.SUCC_ID = W.PRED_ID
      --              AND NOT EXISTS (SELECT P.ELEMENT_ID FROM session.PMO_DEPEND P
      --                  WHERE P.ELEMENT_ID = D.SUCC_ID);
      --      END_SQL;
      
      -- add new pred's succs
      BEGIN
         INSERT INTO PMO_DEPEND (ELEMENT_ID, RANK, FLAG)
         SELECT D.SUCC_ID, D.SUCC_RANK, 0
         FROM PMO_CIRCULAR_DEPEND D
         WHERE D.PRED_ID IN (SELECT ELEMENT_ID FROM PMO_SUCC_C_P WHERE FLAG = 0)
         AND NOT EXISTS (SELECT P.ELEMENT_ID FROM PMO_DEPEND P
         WHERE P.ELEMENT_ID = D.SUCC_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(141) : dependencies.sql(3935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_DEPEND
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 155+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(156) : dependencies.sql(3950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT02: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         SELECT COUNT(D.ELEMENT_ID) INTO h_count
         FROM PMO_DEPEND D, PMO_PRED_C P
         WHERE D.FLAG = 0 AND D.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(177) : dependencies.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT03: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := 500;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_SUCC_C_P SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 199+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(200) : dependencies.sql(3994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_CIRCULAR3;
      
      LOOP
         FETCH C_CIRCULAR3 INTO h_rank;
         IF C_CIRCULAR3%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
            SELECT W.PRED_ID, 0
            FROM PMO_CIRCULAR_WBS W
            WHERE W.PRED_RANK LIKE h_rank || '%'
            AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.PRED_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 234+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(235) : dependencies.sql(4029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_SUCC_C_P (ELEMENT_ID, FLAG)
            SELECT W.PRED_ID, 0
            FROM PMO_CIRCULAR_WBS W
            WHERE W.PRED_RANK <= h_rank
            AND SUBSTR(h_rank, 1, CASE WHEN LENGTH(h_rank) <= LENGTH(W.PRED_RANK) THEN 1
            ELSE LENGTH(W.PRED_RANK) END) = W.PRED_RANK
            AND NOT EXISTS (SELECT S.ELEMENT_ID FROM PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.PRED_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 257+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(258) : dependencies.sql(4052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      BEGIN
         CLOSE C_CIRCULAR3 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 270+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(271) : dependencies.sql(4065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --      BEGIN_SQL
      --          INSERT INTO session.PMO_SUCC_C_P (ELEMENT_ID, FLAG)
      --          SELECT W.PRED_ID, 0
      --          FROM session.PMO_CIRCULAR_WBS W, session.PMO_DEPEND D
      --          WHERE D.FLAG = 0
      --              AND ((SUBSTR(W.PRED_RANK, 1, CASE WHEN LENGTH(W.PRED_RANK) < LENGTH(D.RANK) THEN 1
      --                      ELSE LENGTH(D.RANK) END) = D.RANK
      --                  AND D.RANK >= SUBSTR(W.PRED_RANK, 1, 8) AND D.RANK <= W.PRED_RANK)
      --                  OR (SUBSTR(D.RANK, 1, CASE WHEN LENGTH(D.RANK) <= LENGTH(W.PRED_RANK) THEN 1
      --                      ELSE LENGTH(W.PRED_RANK) END) = W.PRED_RANK
      --                  AND W.PRED_RANK >= SUBSTR(D.RANK, 1, 8) AND W.PRED_RANK <= D.RANK))
      --              AND NOT EXISTS (SELECT S.ELEMENT_ID FROM session.PMO_SUCC_C_P S WHERE S.ELEMENT_ID = W.PRED_ID);
      --      END_SQL;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_SUCC_C_P
         WHERE FLAG = 0;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 299+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(300) : dependencies.sql(4094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("COUNT04: %d\n", h_count);
      
      If Coalesce(h_count, 0) = 0 Then
         PMO_DB2M.SC_STATE := 0;
         EXIT;
      End If;
      
      BEGIN
         UPDATE PMO_DEPEND SET FLAG = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_CIRCULAR', 322+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_CIRCULAR(323) : dependencies.sql(4117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_CIRCULAR', 329+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_CIRCULAR(330) : dependencies.sql(4124) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_CIRCULAR', 334+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_CIRCULAR(335) : dependencies.sql(4129) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIND_CIRCULAR;
ALTER FUNCTION FC_FIND_CIRCULAR COMPILE DEBUG;

-- Find circular list

Prompt == FUNCTION SP_FIND_CIRCULAR ==
CREATE OR REPLACE FUNCTION SP_FIND_CIRCULAR
(
     id VARCHAR2
   , bitflag001 PLS_INTEGER
   , rec_user001 VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_pred_id VARCHAR2(32);
   h_pred_project_id VARCHAR2(32);
   h_pred_rank VARCHAR2(200);
   h_succ_id VARCHAR2(32);
   h_succ_project_id VARCHAR2(32);
   h_succ_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   isFound PLS_INTEGER NOT NULL := 0;
   t_count PLS_INTEGER NOT NULL := 0;
   d_count PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_CIRCULAR1 IS
         SELECT PRED_ID, SUCC_ID, PRED_RANK, SUCC_RANK
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_RANK > SUCC_RANK
         ORDER BY PRED_RANK;

      CURSOR C_CIRCULAR2 IS
         SELECT PRED_ID, SUCC_ID, PRED_RANK, SUCC_RANK
         FROM PMO_CIRCULAR_DEPEND
         WHERE SUCC_RANK > PRED_RANK
         ORDER BY PRED_RANK;

      -- Resultset Cursor Declaration
      C_FOUND PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND_CIRCULAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND_CIRCULAR'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND_CIRCULAR(' || 
       '''' || id || ''''
          || ', ' || COALESCE(TO_CHAR(bitflag001), 'NULL')
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_CIRCULAR', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND_CIRCULAR(47) : dependencies.sql(4186) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_FIND_CIRCULAR', 53+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_FIND_CIRCULAR(54) : dependencies.sql(4193) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_CIRCULAR', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_CIRCULAR(57) : dependencies.sql(4196) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- validate successor_id
   h_project_id := id;
   h_project_id := id;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CIRCULAR_WBS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CIRCULAR_DEPEND';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CIRCULAR_DEPEND1';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(88) : dependencies.sql(4227) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_FIND_CIRCULAR', 94+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_FIND_CIRCULAR(95) : dependencies.sql(4234) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_CIRCULAR', 97+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_CIRCULAR(98) : dependencies.sql(4237) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_project_id, True);
   End If;
   
   --trace_printf("Read WBS\n");
   --trace_flush();
   BEGIN
      INSERT INTO PMO_CIRCULAR_WBS
      SELECT ELEMENT_ID, RANK, 'W', 0
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 119+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(120) : dependencies.sql(4259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("Read Dependencies\n");
   --trace_flush();
   BEGIN
      INSERT INTO PMO_CIRCULAR_DEPEND
      SELECT D.PRED_ID, D.SUCC_ID, P.RANK, S.RANK, 0
      FROM TMT_WBS P, TMT_WBS S, DEPENDENCIES D
      WHERE P.RANK LIKE h_rank || '%'
      AND S.RANK LIKE h_rank || '%'
      AND D.PRED_ID = P.ELEMENT_ID
      AND D.SUCC_ID = S.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(145) : dependencies.sql(4284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(*) INTO h_count
      FROM PMO_CIRCULAR_DEPEND
      WHERE PRED_RANK = SUCC_RANK;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(160) : dependencies.sql(4299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      BEGIN
         INSERT INTO PMO_CIRCULAR_DEPEND1
         SELECT PRED_ID, SUCC_ID, PRED_RANK, SUCC_RANK, 1
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_ID = SUCC_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(181) : dependencies.sql(4320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_RANK > SUCC_RANK;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 195+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(196) : dependencies.sql(4335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      t_count := Coalesce(h_count, 0);
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM PMO_CIRCULAR_DEPEND
         WHERE PRED_RANK < SUCC_RANK;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 212+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(213) : dependencies.sql(4352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("Total dependencies: %d\n", (t_count + h_count));
      If Coalesce(h_count, 0) > t_count Then
         --trace_printf("Dependencies will be processed: %d\n", t_count);
         --trace_printf("Declare Cursor1\n");
         --trace_flush();
         
         --trace_printf("Open Cursor1\n");
         --trace_flush();
         OPEN C_CIRCULAR1;
      Else
         --trace_printf("Dependencies will be processed: %d\n", h_count);
         --trace_printf("Declare Cursor2\n");
         --trace_flush();
         
         --trace_printf("Open Cursor2\n");
         --trace_flush();
         OPEN C_CIRCULAR2;
      End If;
      
      LOOP
         If Coalesce(h_count, 0) > t_count Then
            FETCH C_CIRCULAR1 INTO h_pred_id, h_succ_id, h_pred_rank, h_succ_rank;
            IF C_CIRCULAR1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         Else
            FETCH C_CIRCULAR2 INTO h_pred_id, h_succ_id, h_pred_rank, h_succ_rank;
            IF C_CIRCULAR2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         End If;
         
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         d_count := d_count + 1;
         
         --trace_printf("Processing %d dependency\n", d_count);
         --trace_flush();
         BEGIN
            DELETE FROM PMO_CIRCULAR_DEPEND
            WHERE PRED_ID = h_pred_id AND SUCC_ID = h_succ_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 274+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(275) : dependencies.sql(4414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_FIND_CIRCULAR(h_succ_id, h_pred_id, h_succ_rank, h_pred_rank);
         
         If PMO_DB2M.SC_STATE = 500 Then
            BEGIN
               INSERT INTO PMO_CIRCULAR_DEPEND
               VALUES(h_pred_id, h_succ_id, h_pred_rank, h_succ_rank, 0);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 295+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(296) : dependencies.sql(4435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_CIRCULAR_DEPEND1
               VALUES(h_pred_id, h_succ_id, h_pred_rank, h_succ_rank, 1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 313+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(314) : dependencies.sql(4453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            isFound := 1;
            EXIT;
         End If;
         --          else
         --          {
         --              BEGIN_SQL
         --                  INSERT INTO session.PMO_CIRCULAR_DEPEND
         --                  VALUES(HOST(h_pred_id), HOST(h_succ_id), HOST(h_pred_rank), HOST(h_succ_rank), 0);
         --              END_SQL;
         --          }
      END LOOP;
      
      --trace_printf("Close Cursor\n");
      --trace_flush();
      If Coalesce(h_count, 0) > t_count Then
         BEGIN
            CLOSE C_CIRCULAR1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(342) : dependencies.sql(4481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE C_CIRCULAR2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 354+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(355) : dependencies.sql(4494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --trace_printf("Declare Final Cursor\n");
   --trace_flush();
   
   --trace_printf("Return Final Cursor\n");
   --trace_flush();
   OPEN C_FOUND FOR SELECT P.ELEMENT_NAME AS PRED_NAME, S.ELEMENT_NAME AS SUCC_NAME,
   P.ELEMENT_ID AS PRED_ID, S.ELEMENT_ID AS SUCC_ID
   FROM PMO_CIRCULAR_DEPEND1 D, TMT_WBS P, TMT_WBS S
   WHERE D.CIRCULAR > 0
   AND D.PRED_ID = P.ELEMENT_ID
   AND D.SUCC_ID = S.ELEMENT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_CIRCULAR', 373+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_CIRCULAR(374) : dependencies.sql(4513) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_FOUND;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 381+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(382) : dependencies.sql(4521) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_CIRCULAR', 393+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_CIRCULAR(394) : dependencies.sql(4533) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND_CIRCULAR;
ALTER FUNCTION SP_FIND_CIRCULAR COMPILE DEBUG;

