Prompt == FUNCTION FC_I_DOC_RES ==
CREATE OR REPLACE FUNCTION FC_I_DOC_RES
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_RES(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_RES(49) : doc_func.sql(50) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'RES';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(71) : doc_func.sql(72) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(78) : doc_func.sql(79) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(86) : doc_func.sql(87) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(105) : doc_func.sql(106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(112) : doc_func.sql(113) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(132) : doc_func.sql(133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(168) : doc_func.sql(169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_RESOURCE_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_RESOURCE_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(193) : doc_func.sql(194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(212) : doc_func.sql(213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(229) : doc_func.sql(230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_RESOURCE_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(349) : doc_func.sql(350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_RESOURCE_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(366) : doc_func.sql(367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(383) : doc_func.sql(384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_RES', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_RES(414) : doc_func.sql(415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(421) : doc_func.sql(422) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_RES', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_RES(425) : doc_func.sql(426) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_RES;
ALTER FUNCTION FC_I_DOC_RES COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_POOL ==
CREATE OR REPLACE FUNCTION FC_I_DOC_POOL
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_POOL(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_POOL(49) : doc_func.sql(483) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'POL';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(71) : doc_func.sql(505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(78) : doc_func.sql(512) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(86) : doc_func.sql(520) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_POOLS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(105) : doc_func.sql(539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(112) : doc_func.sql(546) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_POOLS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(132) : doc_func.sql(566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(168) : doc_func.sql(602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_POOL_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_POOL_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(193) : doc_func.sql(627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(212) : doc_func.sql(646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(229) : doc_func.sql(663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_POOL_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_POOL_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(349) : doc_func.sql(783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_POOL_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(366) : doc_func.sql(800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(383) : doc_func.sql(817) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_POOL', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_POOL(414) : doc_func.sql(848) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(421) : doc_func.sql(855) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_POOL', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_POOL(425) : doc_func.sql(859) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_POOL;
ALTER FUNCTION FC_I_DOC_POOL COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_ASSET ==
CREATE OR REPLACE FUNCTION FC_I_DOC_ASSET
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_ASSET'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_ASSET(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_ASSET(49) : doc_func.sql(916) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'AST';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(71) : doc_func.sql(938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(78) : doc_func.sql(945) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(86) : doc_func.sql(953) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_ASSETS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(105) : doc_func.sql(972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(112) : doc_func.sql(979) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_ASSETS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(132) : doc_func.sql(999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(168) : doc_func.sql(1035) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_ASSET_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_ASSET_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(193) : doc_func.sql(1060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(212) : doc_func.sql(1079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(229) : doc_func.sql(1096) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_ASSET_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_ASSET_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(349) : doc_func.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_ASSET_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(366) : doc_func.sql(1233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(383) : doc_func.sql(1250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_ASSET', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_ASSET(414) : doc_func.sql(1281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(421) : doc_func.sql(1288) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_ASSET', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_ASSET(425) : doc_func.sql(1292) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_ASSET;
ALTER FUNCTION FC_I_DOC_ASSET COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_VENDOR ==
CREATE OR REPLACE FUNCTION FC_I_DOC_VENDOR
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_VENDOR(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_VENDOR(49) : doc_func.sql(1349) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'VDR';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(71) : doc_func.sql(1371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(78) : doc_func.sql(1378) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(86) : doc_func.sql(1386) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(105) : doc_func.sql(1405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(112) : doc_func.sql(1412) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_VENDORS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(132) : doc_func.sql(1432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(168) : doc_func.sql(1468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDOR_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_VENDOR_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(193) : doc_func.sql(1493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(212) : doc_func.sql(1512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(229) : doc_func.sql(1529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_VENDOR_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_VENDOR_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(349) : doc_func.sql(1649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_VENDOR_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(366) : doc_func.sql(1666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(383) : doc_func.sql(1683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_VENDOR', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_VENDOR(414) : doc_func.sql(1714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(421) : doc_func.sql(1721) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_VENDOR', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_VENDOR(425) : doc_func.sql(1725) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_VENDOR;
ALTER FUNCTION FC_I_DOC_VENDOR COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_CLIENT ==
CREATE OR REPLACE FUNCTION FC_I_DOC_CLIENT
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_CLIENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_CLIENT'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_CLIENT(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_CLIENT(49) : doc_func.sql(1782) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CLN';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(71) : doc_func.sql(1804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(78) : doc_func.sql(1811) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(86) : doc_func.sql(1819) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_CLIENTS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(105) : doc_func.sql(1838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(112) : doc_func.sql(1845) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CLIENTS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(132) : doc_func.sql(1865) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(168) : doc_func.sql(1901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_CLIENT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_CLIENT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(193) : doc_func.sql(1926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(212) : doc_func.sql(1945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(229) : doc_func.sql(1962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_CLIENT_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_CLIENT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(349) : doc_func.sql(2082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_CLIENT_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(366) : doc_func.sql(2099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(383) : doc_func.sql(2116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CLIENT', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CLIENT(414) : doc_func.sql(2147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(421) : doc_func.sql(2154) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CLIENT', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CLIENT(425) : doc_func.sql(2158) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_CLIENT;
ALTER FUNCTION FC_I_DOC_CLIENT COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_I_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_DOC(49) : doc_func.sql(2215) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(71) : doc_func.sql(2237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(78) : doc_func.sql(2244) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(86) : doc_func.sql(2252) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(105) : doc_func.sql(2271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(112) : doc_func.sql(2278) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET DELETED_COUNT = DELETED_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(132) : doc_func.sql(2298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(168) : doc_func.sql(2334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(193) : doc_func.sql(2359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(212) : doc_func.sql(2378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(229) : doc_func.sql(2395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 348+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(349) : doc_func.sql(2515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(366) : doc_func.sql(2532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(383) : doc_func.sql(2549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_DOC', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_DOC(414) : doc_func.sql(2580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 420+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(421) : doc_func.sql(2587) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_DOC', 424+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_DOC(425) : doc_func.sql(2591) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_DOC;
ALTER FUNCTION FC_I_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_WBS ==
CREATE OR REPLACE FUNCTION FC_I_DOC_WBS
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_WBS(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 48+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_WBS(49) : doc_func.sql(2648) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'WBS';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(71) : doc_func.sql(2670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_parent_id: %s, h_rec_status: %s\n", SC_STATE,h_parent_id,h_rec_status);
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(79) : doc_func.sql(2678) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(87) : doc_func.sql(2686) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID
         INTO h_parent_rank, h_parent_type_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_foreign_id AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(106) : doc_func.sql(2705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 112+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(113) : doc_func.sql(2712) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_WBS
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(133) : doc_func.sql(2732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(170) : doc_func.sql(2769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(195) : doc_func.sql(2794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(214) : doc_func.sql(2813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 230+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(231) : doc_func.sql(2830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 350+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(351) : doc_func.sql(2950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 367+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(368) : doc_func.sql(2967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 384+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(385) : doc_func.sql(2984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_WBS', 415+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_WBS(416) : doc_func.sql(3015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 422+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(423) : doc_func.sql(3022) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_WBS', 426+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_WBS(427) : doc_func.sql(3026) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_WBS;
ALTER FUNCTION FC_I_DOC_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_I_DOC_CRI ==
CREATE OR REPLACE FUNCTION FC_I_DOC_CRI
(
     sh_h_host_table PLS_INTEGER
   , sh_h_foreign_table PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_foreign_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_foreign_table PLS_INTEGER := sh_h_foreign_table;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_assign_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_history_id VARCHAR2(32);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_parent_rank VARCHAR2(200);
   h_parent_type_id PLS_INTEGER := 0;
   h_prefix VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_stage_id PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_private VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_scope_rank_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_DOC_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_DOC_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_DOC_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_foreign_table), 'NULL')
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_foreign_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_DOC_CRI(50) : doc_func.sql(3084) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare local variables
   
   h_element_id := h_parent_id;
   h_prefix := 'CRI';
   h_stage_id := 4953;
   h_private := 'N';
   h_scope_rank_id := 729;
   
   BEGIN
      SELECT PARENT_RANK, RANK, PROJECT_ID, LEVEL_ID + 1, TYPE_ID, REC_STATUS
      INTO h_parent_rank, h_rank, h_project_id, h_level_id, h_parent_type_id, h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;-- AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(72) : doc_func.sql(3106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(79) : doc_func.sql(3113) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.PARENT_IS_LOCKED;
   End If;
   
   If NOT ((SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'O') 
         OR (SubStr(h_rec_status, 1, 1) = 'U')) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(87) : doc_func.sql(3121) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --if (!SC_SUCCESS)
   --  return RECORD_NOT_FOUND;
   
   If Coalesce(h_host_table, 0) <> Coalesce(h_foreign_table, 0) Then
      h_wbs_id := '';
      
      BEGIN
         SELECT h_prefix || '#' || RANK, TYPE_ID, WBS_ID
         INTO h_parent_rank, h_parent_type_id, h_wbs_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_foreign_id
         AND REC_STATUS IN ('I', 'O', 'U', 'L');
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(109) : doc_func.sql(3143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 115+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(116) : doc_func.sql(3150) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      -- update attachment count
      BEGIN
         UPDATE TMT_CRI
         SET DOC_COUNT = DOC_COUNT + 1
         WHERE ELEMENT_ID = h_foreign_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(136) : doc_func.sql(3170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_wbs_id IS NOT NULL)) AND (PMO_ORASTD.strcmp(h_wbs_id, h_foreign_id) = 0) Then
         BEGIN
            UPDATE TMT_WBS
            SET DOC_COUNT = DOC_COUNT + 1
            WHERE ELEMENT_ID = h_foreign_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(156) : doc_func.sql(3190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   h_uniqueID := SYS_GUID();
   h_element_id := h_uniqueID;
   h_full_name := NULL;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
      h_blob_id := NULL;
      h_private := 'N';
   Else
      h_blob_id := '';
      h_blob_id := SYS_GUID();
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
         h_stage_id := 5438;
      End If;
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES Then
      h_scope_rank_id := 500;
   Else
      h_scope_rank_id := 729;
   End If;
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(194) : doc_func.sql(3228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_DOCUMENTS', h_parent_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_DOCUMENTS
      (PARENT_ID, BLOB_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
      AUTHOR_ID, PARENT_TYPE_ID, REC_USER, RANK, PARENT_RANK, PROJECT_ID, STAGE_ID, ASSIGN_NAMES,PRIVATE,SCOPE_RANK_ID)
      VALUES(h_parent_id, h_blob_id, h_uniqueID, h_name, h_type_id,
      h_level_id, h_rec_user, h_parent_type_id, h_rec_user,
      h_rank || h_rankBase64, h_parent_rank, h_project_id, h_stage_id, h_full_name,h_private,h_scope_rank_id);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 218+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(219) : doc_func.sql(3253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET REC_STATUS = 'U' WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 237+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(238) : doc_func.sql(3272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            INSERT INTO DOCUMENT_BLOBS(ELEMENT_ID) VALUES(h_blob_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(255) : doc_func.sql(3289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_history_id := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID  ,
            LEVEL_ID        ,
            TYPE_ID         ,
            MAX_RANK        ,
            CHILD_COUNT     ,
            DELETED_COUNT   ,
            ELEMENT_ID      ,
            ELEMENT_NAME    ,
            ELEMENT_NUMBER  ,
            PROJECT_ID      ,
            BLOB_ID         ,
            PARENT_ID       ,
            PARENT_TYPE_ID  ,
            AUTHOR_ID       ,
            CREATION_DATE   ,
            APPROVED_DATE   ,
            REF_NUMBER      ,
            AUTHOR_CHECKOUT ,
            PUBLISHED_DT    ,
            MINOR_REVISION  ,
            MAJOR_REVISION  ,
            MAX_REVISION    ,
            MAX_REV_REACHED ,
            ATTACHED_ID     ,
            LAST_WF_TYPE    ,
            LAST_WF_BY      ,
            LAST_WF_DT      ,
            REC_USER        ,
            REC_STATUS      ,
            REC_DATETIME    ,
            RANK            ,
            PARENT_RANK     ,
            KEYWORDS        ,
            LAST_CHECKIN    ,
            REVISION_TYPE   ,
            REVISION_IMPACT ,
            REVISION_HISTORY,
            SCORECARD_ID    ,
            SCORE           ,
            WEIGHT          ,
            CONVERTED_SCORE ,
            CONVERTED_WEIGHT,
            ACTIVE          ,
            LOCAL_FOLDER    ,
            RTF_BITS        ,
            PRIORITY        ,
            SCOPE_RANK_ID   ,
            STAGE_ID        ,
            ATTACHEMENT ,
            BLOB_DATA   )
            SELECT h_blob_id,
            D.LEVEL_ID        ,
            D.TYPE_ID         ,
            D.MAX_RANK        ,
            D.CHILD_COUNT     ,
            D.DELETED_COUNT   ,
            D.ELEMENT_ID      ,
            D.ELEMENT_NAME    ,
            D.ELEMENT_NUMBER  ,
            D.PROJECT_ID      ,
            D.BLOB_ID         ,
            D.PARENT_ID       ,
            D.PARENT_TYPE_ID  ,
            D.AUTHOR_ID       ,
            D.CREATION_DATE   ,
            D.APPROVED_DATE   ,
            D.REF_NUMBER      ,
            D.AUTHOR_CHECKOUT ,
            D.PUBLISHED_DT    ,
            D.MINOR_REVISION  ,
            D.MAJOR_REVISION  ,
            D.MAX_REVISION    ,
            D.MAX_REV_REACHED ,
            D.ATTACHED_ID     ,
            D.LAST_WF_TYPE    ,
            D.LAST_WF_BY      ,
            D.LAST_WF_DT      ,
            D.REC_USER        ,
            D.REC_STATUS      ,
            D.REC_DATETIME    ,
            D.RANK            ,
            D.PARENT_RANK     ,
            D.KEYWORDS        ,
            D.LAST_CHECKIN    ,
            D.REVISION_TYPE   ,
            D.REVISION_IMPACT ,
            D.REVISION_HISTORY,
            D.SCORECARD_ID    ,
            D.SCORE           ,
            D.WEIGHT          ,
            D.CONVERTED_SCORE ,
            D.CONVERTED_WEIGHT,
            D.ACTIVE          ,
            D.LOCAL_FOLDER    ,
            D.RTF_BITS        ,
            D.PRIORITY        ,
            D.SCOPE_RANK_ID   ,
            D.STAGE_ID        ,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS D LEFT OUTER JOIN DOCUMENT_BLOBS B ON D.BLOB_ID = B.ELEMENT_ID
            WHERE D.ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 374+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(375) : doc_func.sql(3409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_DOCUMENTS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_blob_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 391+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(392) : doc_func.sql(3426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 408+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(409) : doc_func.sql(3443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --          trace_printf("--------h_type_id:%d\n",h_type_id);
         PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
      End If;
      h_temp_sc_state := GetSecurityID(Coalesce(h_host_table, 0), Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
      h_assign_id := SYS_GUID();
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS(
         RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE, RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         RESOURCE_TYPE, REC_USER,TABLE_TYPE)
         VALUES(
         h_assign_id, h_project_id, h_uniqueID, h_type_id, h_rec_user,
         PMO_CNST.SC_DOCUMENT_RESPONSIBLE ,
         h_security_id ,
         '0', h_rec_user,h_host_table);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_DOC_CRI', 439+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_DOC_CRI(440) : doc_func.sql(3474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 446+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(447) : doc_func.sql(3481) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_DOC_CRI', 450+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_DOC_CRI(451) : doc_func.sql(3485) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_DOC_CRI;
ALTER FUNCTION FC_I_DOC_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTd PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_DOC(23) : doc_func.sql(3516) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTd FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_DOC(30) : doc_func.sql(3523) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTd;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_DOC(38) : doc_func.sql(3531) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_DOC(50) : doc_func.sql(3543) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_DOC;
ALTER FUNCTION FC_ISOUT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTr PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_RES_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_RES_DOC(23) : doc_func.sql(3580) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTr FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_RESOURCE_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_RES_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_RES_DOC(30) : doc_func.sql(3587) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTr;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_RES_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_RES_DOC(38) : doc_func.sql(3595) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_RES_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_RES_DOC(50) : doc_func.sql(3607) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_RES_DOC;
ALTER FUNCTION FC_ISOUT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTp PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_POL_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_POL_DOC(23) : doc_func.sql(3644) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTp FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_POOL_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_POL_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_POL_DOC(30) : doc_func.sql(3651) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTp;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_POL_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_POL_DOC(38) : doc_func.sql(3659) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_POL_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_POL_DOC(50) : doc_func.sql(3671) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_POL_DOC;
ALTER FUNCTION FC_ISOUT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTa PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_AST_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_AST_DOC(23) : doc_func.sql(3708) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTa FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_ASSET_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_AST_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_AST_DOC(30) : doc_func.sql(3715) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTa;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_AST_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_AST_DOC(38) : doc_func.sql(3723) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_AST_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_AST_DOC(50) : doc_func.sql(3735) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_AST_DOC;
ALTER FUNCTION FC_ISOUT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTv PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_VDR_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_VDR_DOC(23) : doc_func.sql(3772) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTv FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_VENDOR_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_VDR_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_VDR_DOC(30) : doc_func.sql(3779) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTv;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_VDR_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_VDR_DOC(38) : doc_func.sql(3787) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_VDR_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_VDR_DOC(50) : doc_func.sql(3799) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_VDR_DOC;
ALTER FUNCTION FC_ISOUT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_ISOUT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_ISOUT_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
-- Declare Cursors
      -- Resultset Cursor Declaration
      ISOUTc PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ISOUT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ISOUT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_ISOUT_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_CLN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ISOUT_CLN_DOC(23) : doc_func.sql(3836) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN ISOUTc FOR SELECT ELEMENT_ID, REC_STATUS, REC_USER
   FROM TMT_CLIENT_DOCUMENTS
   WHERE ELEMENT_ID = h_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ISOUT_CLN_DOC', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ISOUT_CLN_DOC(30) : doc_func.sql(3843) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN ISOUTc;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_CLN_DOC', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_CLN_DOC(38) : doc_func.sql(3851) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ISOUT_CLN_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ISOUT_CLN_DOC(50) : doc_func.sql(3863) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_ISOUT_CLN_DOC;
ALTER FUNCTION FC_ISOUT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_DOC(24) : doc_func.sql(3901) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_DOC(37) : doc_func.sql(3914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(44) : doc_func.sql(3921) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(51) : doc_func.sql(3928) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(58) : doc_func.sql(3935) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_DOC(79) : doc_func.sql(3956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_DOC(85) : doc_func.sql(3962) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_DOC;
ALTER FUNCTION FC_CHECK_OUT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_RES_DOC(24) : doc_func.sql(3994) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_RES_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_RES_DOC(37) : doc_func.sql(4007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(44) : doc_func.sql(4014) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(51) : doc_func.sql(4021) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(58) : doc_func.sql(4028) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_RES_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_RES_DOC(79) : doc_func.sql(4049) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_RES_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_RES_DOC(85) : doc_func.sql(4055) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_RES_DOC;
ALTER FUNCTION FC_CHECK_OUT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_POL_DOC(24) : doc_func.sql(4087) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_POL_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_POL_DOC(37) : doc_func.sql(4100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(44) : doc_func.sql(4107) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(51) : doc_func.sql(4114) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(58) : doc_func.sql(4121) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_POL_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_POL_DOC(79) : doc_func.sql(4142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_POL_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_POL_DOC(85) : doc_func.sql(4148) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_POL_DOC;
ALTER FUNCTION FC_CHECK_OUT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_AST_DOC(24) : doc_func.sql(4180) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_AST_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_AST_DOC(37) : doc_func.sql(4193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(44) : doc_func.sql(4200) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(51) : doc_func.sql(4207) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(58) : doc_func.sql(4214) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_AST_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_AST_DOC(79) : doc_func.sql(4235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_AST_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_AST_DOC(85) : doc_func.sql(4241) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_AST_DOC;
ALTER FUNCTION FC_CHECK_OUT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_VDR_DOC(24) : doc_func.sql(4273) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_VDR_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_VDR_DOC(37) : doc_func.sql(4286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(44) : doc_func.sql(4293) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(51) : doc_func.sql(4300) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(58) : doc_func.sql(4307) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_VDR_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_VDR_DOC(79) : doc_func.sql(4328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_VDR_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_VDR_DOC(85) : doc_func.sql(4334) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_VDR_DOC;
ALTER FUNCTION FC_CHECK_OUT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_OUT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_OUT_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_last_checkin IN OUT NOCOPY TIMESTAMP
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_OUT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_OUT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_OUT_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_OUT_CLN_DOC(24) : doc_func.sql(4366) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LAST_CHECKIN,REC_STATUS INTO h_last_checkin,h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_CLN_DOC', 36+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_CLN_DOC(37) : doc_func.sql(4379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(44) : doc_func.sql(4386) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(51) : doc_func.sql(4393) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_OUT;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(58) : doc_func.sql(4400) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ITEM_IS_LOCKED;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET     REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_OUT_CLN_DOC', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_OUT_CLN_DOC(79) : doc_func.sql(4421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_OUT_CLN_DOC', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_OUT_CLN_DOC(85) : doc_func.sql(4427) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_OUT_CLN_DOC;
ALTER FUNCTION FC_CHECK_OUT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKINd IS
         SELECT MINOR_REVISION
         FROM HISTORY_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_DOC(38) : doc_func.sql(4473) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS, BLOB_ID, LINK_DOC
      INTO h_type_id, h_rank, h_status_id, h_max_revision,
      h_rec_status, h_blob_id, h_link_doc
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(53) : doc_func.sql(4488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(60) : doc_func.sql(4495) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(67) : doc_func.sql(4502) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINd;
   
   FETCH CKINd INTO h_min_revision;
   IF CKINd%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CKINd ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(96) : doc_func.sql(4531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(118) : doc_func.sql(4553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINd ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(131) : doc_func.sql(4566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(156) : doc_func.sql(4591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(179) : doc_func.sql(4614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(201) : doc_func.sql(4636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 345+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(346) : doc_func.sql(4781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 369+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(370) : doc_func.sql(4805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If ((h_blob_id IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_link_doc, 'P', 1) = 0) Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET (APPROVED_DATE, REF_NUMBER, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION,
            ATTACHED_ID, KEYWORDS, SUMMARY, LAST_CHECKIN,
            AUTHOR_CHECKOUT, ACTIVE, PRIORITY, SCOPE_RANK_ID, STAGE_ID,
            DOCUMENT_SIZE, COMPRESSED_SIZE, PRIVATE, VISIBLE_AT_PARENT,
            REVISION_TYPE, REVISION_IMPACT, REVISION_HISTORY,
            REC_DATETIME) =
            (SELECT APPROVED_DATE, REF_NUMBER, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION,
            ATTACHED_ID, KEYWORDS, SUMMARY, LAST_CHECKIN,
            AUTHOR_CHECKOUT, ACTIVE, PRIORITY, SCOPE_RANK_ID, STAGE_ID,
            DOCUMENT_SIZE, COMPRESSED_SIZE, PRIVATE, VISIBLE_AT_PARENT,
            REVISION_TYPE, REVISION_IMPACT, REVISION_HISTORY,
            REC_DATETIME
            FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_id)
            WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_DOC', 401+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_DOC(402) : doc_func.sql(4837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 408+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(409) : doc_func.sql(4844) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_DOC', 412+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_DOC(413) : doc_func.sql(4848) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINr IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_RES_DOC(35) : doc_func.sql(4891) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(49) : doc_func.sql(4905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(56) : doc_func.sql(4912) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(63) : doc_func.sql(4919) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINr;
   
   FETCH CKINr INTO h_min_revision;
   IF CKINr%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CKINr ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(92) : doc_func.sql(4948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(114) : doc_func.sql(4970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINr ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(127) : doc_func.sql(4983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(152) : doc_func.sql(5008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(175) : doc_func.sql(5031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(197) : doc_func.sql(5053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_RESOURCE_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(342) : doc_func.sql(5198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_RESOURCE_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_RES_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_RES_DOC(366) : doc_func.sql(5222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(372) : doc_func.sql(5228) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_RES_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_RES_DOC(376) : doc_func.sql(5232) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_RES_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINp IS
         SELECT MINOR_REVISION
         FROM HISTORY_POOL_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_POL_DOC(35) : doc_func.sql(5275) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(49) : doc_func.sql(5289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(56) : doc_func.sql(5296) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(63) : doc_func.sql(5303) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINp;
   
   FETCH CKINp INTO h_min_revision;
   IF CKINp%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CKINp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(92) : doc_func.sql(5332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(114) : doc_func.sql(5354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINp ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(127) : doc_func.sql(5367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(152) : doc_func.sql(5392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(175) : doc_func.sql(5415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(197) : doc_func.sql(5437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_POOL_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_POOL_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(342) : doc_func.sql(5582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_POOL_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_POL_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_POL_DOC(366) : doc_func.sql(5606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(372) : doc_func.sql(5612) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_POL_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_POL_DOC(376) : doc_func.sql(5616) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_POL_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINa IS
         SELECT MINOR_REVISION
         FROM HISTORY_ASSET_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_AST_DOC(35) : doc_func.sql(5659) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(49) : doc_func.sql(5673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(56) : doc_func.sql(5680) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(63) : doc_func.sql(5687) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINa;
   
   FETCH CKINa INTO h_min_revision;
   IF CKINa%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CKINa ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(92) : doc_func.sql(5716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(114) : doc_func.sql(5738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINa ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(127) : doc_func.sql(5751) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(152) : doc_func.sql(5776) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(175) : doc_func.sql(5799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(197) : doc_func.sql(5821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_ASSET_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_ASSET_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(342) : doc_func.sql(5966) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_ASSET_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_AST_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_AST_DOC(366) : doc_func.sql(5990) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(372) : doc_func.sql(5996) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_AST_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_AST_DOC(376) : doc_func.sql(6000) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_AST_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINv IS
         SELECT MINOR_REVISION
         FROM HISTORY_VENDOR_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_VDR_DOC(35) : doc_func.sql(6043) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(49) : doc_func.sql(6057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(56) : doc_func.sql(6064) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(63) : doc_func.sql(6071) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINv;
   
   FETCH CKINv INTO h_min_revision;
   IF CKINv%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CKINv ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(92) : doc_func.sql(6100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(114) : doc_func.sql(6122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINv ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(127) : doc_func.sql(6135) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(152) : doc_func.sql(6160) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(175) : doc_func.sql(6183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(197) : doc_func.sql(6205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_VENDOR_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_VENDOR_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(342) : doc_func.sql(6350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_VENDOR_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_VDR_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_VDR_DOC(366) : doc_func.sql(6374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(372) : doc_func.sql(6380) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_VDR_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_VDR_DOC(376) : doc_func.sql(6384) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_VDR_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHECK_IN_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_uniqueID VARCHAR2(32);
   h_tableName VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_status_id VARCHAR2(1);
   h_max_revision PLS_INTEGER := 0;
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR CKINc IS
         SELECT MINOR_REVISION
         FROM HISTORY_CLIENT_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN_DOC_CLN_DOC(35) : doc_func.sql(6427) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, RANK, MAX_REV_REACHED, MAX_REVISION, REC_STATUS
      INTO h_type_id, h_rank, h_status_id, h_max_revision, h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(49) : doc_func.sql(6441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(56) : doc_func.sql(6448) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(63) : doc_func.sql(6455) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
   End If;
   
   -- **************************************************************************************
   -- bitflag  = 0 MINOR_REVISION = MINOR_REVISION + 1
   --      = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --      = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKINc;
   
   FETCH CKINc INTO h_min_revision;
   IF CKINc%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CKINc ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(92) : doc_func.sql(6484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET PUBLISHED_DT = NuLL,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         LAST_CHECKIN = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(114) : doc_func.sql(6506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CKINc ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(127) : doc_func.sql(6519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(152) : doc_func.sql(6544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 174+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(175) : doc_func.sql(6567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 196+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(197) : doc_func.sql(6589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      h_uniqueID := h_uniqueID;
      BEGIN
         INSERT INTO HISTORY_CLIENT_DOCUMENTS (
         HISTORY_ID,
         LEVEL_ID,
         TYPE_ID,
         MAX_RANK,
         CHILD_COUNT,
         DELETED_COUNT,
         ELEMENT_ID,
         ELEMENT_NAME,
         ELEMENT_NUMBER,
         PROJECT_ID,
         BLOB_ID,
         PARENT_ID,
         PARENT_TYPE_ID,
         AUTHOR_ID,
         CREATION_DATE,
         APPROVED_DATE,
         REF_NUMBER,
         AUTHOR_CHECKOUT,
         PUBLISHED_DT,
         MINOR_REVISION,
         MAJOR_REVISION,
         MAX_REVISION,
         MAX_REV_REACHED,
         ATTACHED_ID,
         LAST_WF_TYPE,
         LAST_WF_BY,
         LAST_WF_DT,
         REC_USER,
         REC_STATUS,
         REC_DATETIME,
         RANK,
         PARENT_RANK,
         KEYWORDS,
         LAST_CHECKIN,
         REVISION_TYPE,
         REVISION_IMPACT,
         REVISION_HISTORY,
         SCORECARD_ID,
         SCORE,
         WEIGHT,
         CONVERTED_SCORE,
         CONVERTED_WEIGHT,
         ACTIVE,
         LOCAL_FOLDER ,
         RTF_BITS ,
         PRIORITY ,
         SCOPE_RANK_ID ,
         TEMP_FOLDER ,
         LOCAL_MACHINE ,
         DOCUMENT_SIZE ,
         COMPRESSED_SIZE ,
         PUBLISHED ,
         ASSIGN_NAMES ,
         SUMMARY ,
         PREVIOUS_WKF_STEP ,
         PRIVATE ,
         VISIBLE_AT_PARENT ,
         ATTACHEMENT,
         BLOB_DATA,
         STAGE_ID)
         SELECT
         h_uniqueID,
         A.LEVEL_ID,
         A.TYPE_ID,
         A.MAX_RANK,
         A.CHILD_COUNT,
         A.DELETED_COUNT,
         A.ELEMENT_ID,
         A.ELEMENT_NAME,
         A.ELEMENT_NUMBER,
         A.PROJECT_ID,
         A.BLOB_ID,
         A.PARENT_ID,
         A.PARENT_TYPE_ID,
         A.AUTHOR_ID,
         A.CREATION_DATE,
         A.APPROVED_DATE,
         A.REF_NUMBER,
         A.AUTHOR_CHECKOUT,
         A.PUBLISHED_DT,
         A.MINOR_REVISION,
         A.MAJOR_REVISION,
         A.MAX_REVISION,
         A.MAX_REV_REACHED,
         A.ATTACHED_ID,
         A.LAST_WF_TYPE,
         A.LAST_WF_BY,
         A.LAST_WF_DT,
         A.REC_USER,
         A.REC_STATUS,
         A.REC_DATETIME,
         A.RANK,
         A.PARENT_RANK,
         A.KEYWORDS,
         A.LAST_CHECKIN,
         A.REVISION_TYPE,
         A.REVISION_IMPACT,
         A.REVISION_HISTORY,
         A.SCORECARD_ID,
         A.SCORE,
         A.WEIGHT,
         A.CONVERTED_SCORE,
         A.CONVERTED_WEIGHT,
         A.ACTIVE,
         A.LOCAL_FOLDER ,
         A.RTF_BITS ,
         A.PRIORITY ,
         A.SCOPE_RANK_ID ,
         A.TEMP_FOLDER ,
         A.LOCAL_MACHINE ,
         A.DOCUMENT_SIZE ,
         A.COMPRESSED_SIZE ,
         A.PUBLISHED ,
         A.ASSIGN_NAMES ,
         A.SUMMARY ,
         A.PREVIOUS_WKF_STEP ,
         A.PRIVATE ,
         A.VISIBLE_AT_PARENT ,
         B.ATTACHEMENT,
         B.BLOB_DATA,
         A.STAGE_ID
         FROM TMT_CLIENT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B ON A.BLOB_ID = B.ELEMENT_ID
         WHERE A.ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(342) : doc_func.sql(6734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 4;
      h_tableName := 'HISTORY_CLIENT_DOCUMENTS';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_tableName);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS D
         SET D.REVISION_HISTORY = Null,
         D.COMPRESSED_SIZE = COALESCE((SELECT LENGTH(BLOB_DATA) FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = D.BLOB_ID), 0)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN_DOC_CLN_DOC', 365+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN_DOC_CLN_DOC(366) : doc_func.sql(6758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 371+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(372) : doc_func.sql(6764) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN_DOC_CLN_DOC', 375+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN_DOC_CLN_DOC(376) : doc_func.sql(6768) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN_DOC_CLN_DOC;
ALTER FUNCTION FC_CHECK_IN_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_DOC(21) : doc_func.sql(6797) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(34) : doc_func.sql(6810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(42) : doc_func.sql(6818) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(48) : doc_func.sql(6824) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(63) : doc_func.sql(6839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(71) : doc_func.sql(6847) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_DOC(90) : doc_func.sql(6866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(96) : doc_func.sql(6872) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_DOC(100) : doc_func.sql(6876) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_DOC;
ALTER FUNCTION FC_A_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_RES_DOC(21) : doc_func.sql(6905) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(34) : doc_func.sql(6918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(42) : doc_func.sql(6926) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(48) : doc_func.sql(6932) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(63) : doc_func.sql(6947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(71) : doc_func.sql(6955) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_RESOURCE_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_RES_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_RES_DOC(90) : doc_func.sql(6974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(96) : doc_func.sql(6980) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_RES_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_RES_DOC(100) : doc_func.sql(6984) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_RES_DOC;
ALTER FUNCTION FC_A_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_POL_DOC(21) : doc_func.sql(7013) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(34) : doc_func.sql(7026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(42) : doc_func.sql(7034) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(48) : doc_func.sql(7040) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(63) : doc_func.sql(7055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(71) : doc_func.sql(7063) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_POOL_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_POL_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_POL_DOC(90) : doc_func.sql(7082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(96) : doc_func.sql(7088) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_POL_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_POL_DOC(100) : doc_func.sql(7092) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_POL_DOC;
ALTER FUNCTION FC_A_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_AST_DOC(21) : doc_func.sql(7121) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(34) : doc_func.sql(7134) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(42) : doc_func.sql(7142) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(48) : doc_func.sql(7148) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(63) : doc_func.sql(7163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(71) : doc_func.sql(7171) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_ASSET_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_AST_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_AST_DOC(90) : doc_func.sql(7190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(96) : doc_func.sql(7196) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_AST_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_AST_DOC(100) : doc_func.sql(7200) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_AST_DOC;
ALTER FUNCTION FC_A_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_VDR_DOC(21) : doc_func.sql(7229) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(34) : doc_func.sql(7242) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(42) : doc_func.sql(7250) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(48) : doc_func.sql(7256) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(63) : doc_func.sql(7271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(71) : doc_func.sql(7279) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_VENDOR_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_VDR_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_VDR_DOC(90) : doc_func.sql(7298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(96) : doc_func.sql(7304) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_VDR_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_VDR_DOC(100) : doc_func.sql(7308) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_VDR_DOC;
ALTER FUNCTION FC_A_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_A_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_A_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_A_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_A_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_A_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_A_DOC_CLN_DOC(21) : doc_func.sql(7337) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id AND NOT REC_STATUS = 'S';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(34) : doc_func.sql(7350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' OR SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 41+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(42) : doc_func.sql(7358) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.MARKED_AS_UNAVAILABLE;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(48) : doc_func.sql(7364) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(63) : doc_func.sql(7379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(71) : doc_func.sql(7387) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET (ATTACHED_ID, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, REC_STATUS) =
         (SELECT h_parent_id, BLOB_ID, AUTHOR_ID, APPROVED_DATE, REF_NUMBER, AUTHOR_CHECKOUT, PUBLISHED_DT, MINOR_REVISION, MAJOR_REVISION, KEYWORDS, 'S' FROM TMT_CLIENT_DOCUMENTS p WHERE p.ELEMENT_ID = h_parent_id)
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_A_DOC_CLN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_A_DOC_CLN_DOC(90) : doc_func.sql(7406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 95+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(96) : doc_func.sql(7412) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_A_DOC_CLN_DOC', 99+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_A_DOC_CLN_DOC(100) : doc_func.sql(7416) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_A_DOC_CLN_DOC;
ALTER FUNCTION FC_A_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rup_link IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rup_link || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_DOC(29) : doc_func.sql(7453) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      RUP_LINK = h_rup_link,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(52) : doc_func.sql(7476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(67) : doc_func.sql(7491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 86+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(87) : doc_func.sql(7511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            REF_NUMBER = h_ref_number,
            AUTHOR_CHECKOUT = h_author_checkout,
            PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE BLOB_ID = h_BLOB_ID AND LINK_DOC = 'Y';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_DOC', 109+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_DOC(110) : doc_func.sql(7534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 118+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_DOC(119) : doc_func.sql(7543) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_DOC', 122+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_DOC(123) : doc_func.sql(7547) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_DOC;
ALTER FUNCTION FC_U_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_RES_DOC(27) : doc_func.sql(7582) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(49) : doc_func.sql(7604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(64) : doc_func.sql(7619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_RES_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_RES_DOC(84) : doc_func.sql(7639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_RES_DOC(93) : doc_func.sql(7648) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_RES_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_RES_DOC(97) : doc_func.sql(7652) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_RES_DOC;
ALTER FUNCTION FC_U_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_POL_DOC(27) : doc_func.sql(7687) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(49) : doc_func.sql(7709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(64) : doc_func.sql(7724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_POL_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_POL_DOC(84) : doc_func.sql(7744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_POL_DOC(93) : doc_func.sql(7753) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_POL_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_POL_DOC(97) : doc_func.sql(7757) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_POL_DOC;
ALTER FUNCTION FC_U_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_AST_DOC(27) : doc_func.sql(7792) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(49) : doc_func.sql(7814) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(64) : doc_func.sql(7829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_AST_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_AST_DOC(84) : doc_func.sql(7849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_AST_DOC(93) : doc_func.sql(7858) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_AST_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_AST_DOC(97) : doc_func.sql(7862) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_AST_DOC;
ALTER FUNCTION FC_U_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_VDR_DOC(27) : doc_func.sql(7897) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(49) : doc_func.sql(7919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(64) : doc_func.sql(7934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_VDR_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_VDR_DOC(84) : doc_func.sql(7954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_VDR_DOC(93) : doc_func.sql(7963) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_VDR_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_VDR_DOC(97) : doc_func.sql(7967) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_VDR_DOC;
ALTER FUNCTION FC_U_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_attach IN OUT NOCOPY VARCHAR2
   , h_ref_number IN OUT NOCOPY VARCHAR2
   , h_author_checkout IN OUT NOCOPY VARCHAR2
   , h_published IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_BLOB_ID VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_attach || ''''
          || ', ' || '''' || h_ref_number || ''''
          || ', ' || '''' || h_author_checkout || ''''
          || ', ' || '''' || h_published || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_DOC_CLN_DOC(27) : doc_func.sql(8002) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET REF_NUMBER = h_ref_number,
      ATTACHED_ID = h_id,
      AUTHOR_CHECKOUT = h_author_checkout,
      PUBLISHED_DT = CASE WHEN h_published = 'Y' THEN SYSTIMESTAMP ELSE PUBLISHED_DT END,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(49) : doc_func.sql(8024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT BLOB_ID INTO h_BLOB_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(64) : doc_func.sql(8039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         BEGIN
            UPDATE DOCUMENT_BLOBS
            SET ATTACHEMENT = h_attach
            WHERE ELEMENT_ID = h_BLOB_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_DOC_CLN_DOC', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_DOC_CLN_DOC(84) : doc_func.sql(8059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_CLN_DOC(93) : doc_func.sql(8068) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_DOC_CLN_DOC', 96+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_DOC_CLN_DOC(97) : doc_func.sql(8072) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_DOC_CLN_DOC;
ALTER FUNCTION FC_U_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_DOC(23) : doc_func.sql(8103) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_DOC(27) : doc_func.sql(8107) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_DOC(48) : doc_func.sql(8128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(56) : doc_func.sql(8136) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_DOC(75) : doc_func.sql(8155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(80) : doc_func.sql(8160) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_DOC(84) : doc_func.sql(8164) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_RES_DOC(23) : doc_func.sql(8195) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_RES_DOC(27) : doc_func.sql(8199) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_RESOURCE_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_RESOURCE_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_RES_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_RES_DOC(48) : doc_func.sql(8220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(56) : doc_func.sql(8228) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_RES_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_RES_DOC(75) : doc_func.sql(8247) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(80) : doc_func.sql(8252) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_RES_DOC(84) : doc_func.sql(8256) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_RES_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_POL_DOC(23) : doc_func.sql(8287) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_POL_DOC(27) : doc_func.sql(8291) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOL_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_POOL_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_POL_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_POL_DOC(48) : doc_func.sql(8312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(56) : doc_func.sql(8320) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_POL_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_POL_DOC(75) : doc_func.sql(8339) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(80) : doc_func.sql(8344) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_POL_DOC(84) : doc_func.sql(8348) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_POL_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_AST_DOC(23) : doc_func.sql(8379) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_AST_DOC(27) : doc_func.sql(8383) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSET_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSET_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST_DOC(48) : doc_func.sql(8404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(56) : doc_func.sql(8412) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_AST_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_AST_DOC(75) : doc_func.sql(8431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(80) : doc_func.sql(8436) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_AST_DOC(84) : doc_func.sql(8440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_AST_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_VDR_DOC(23) : doc_func.sql(8471) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_VDR_DOC(27) : doc_func.sql(8475) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDOR_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDOR_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_VDR_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_VDR_DOC(48) : doc_func.sql(8496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(56) : doc_func.sql(8504) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_VDR_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_VDR_DOC(75) : doc_func.sql(8523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(80) : doc_func.sql(8528) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_VDR_DOC(84) : doc_func.sql(8532) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_VDR_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ITEM_NAME_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ITEM_NAME_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ITEM_NAME_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ITEM_NAME_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ITEM_NAME_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ITEM_NAME_CLN_DOC(23) : doc_func.sql(8563) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_ITEM_NAME_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_ITEM_NAME_CLN_DOC(27) : doc_func.sql(8567) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN_DOC', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN_DOC(48) : doc_func.sql(8588) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(56) : doc_func.sql(8596) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_ITEM_NAME_CLN_DOC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_ITEM_NAME_CLN_DOC(75) : doc_func.sql(8615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(80) : doc_func.sql(8620) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ITEM_NAME_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ITEM_NAME_CLN_DOC(84) : doc_func.sql(8624) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ITEM_NAME_CLN_DOC;
ALTER FUNCTION FC_U_ITEM_NAME_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_DOC(25) : doc_func.sql(8657) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_DOC(29) : doc_func.sql(8661) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_DOC(50) : doc_func.sql(8682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(58) : doc_func.sql(8690) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_DOC(78) : doc_func.sql(8710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(83) : doc_func.sql(8715) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_DOC(87) : doc_func.sql(8719) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_DOC;
ALTER FUNCTION FC_U_PRIVATE_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_RES_DOC(25) : doc_func.sql(8752) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_RES_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_RES_DOC(29) : doc_func.sql(8756) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_RESOURCE_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_RESOURCE_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_RES_DOC(50) : doc_func.sql(8777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(58) : doc_func.sql(8785) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_RES_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_RES_DOC(78) : doc_func.sql(8805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(83) : doc_func.sql(8810) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_RES_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_RES_DOC(87) : doc_func.sql(8814) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_RES_DOC;
ALTER FUNCTION FC_U_PRIVATE_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_POL_DOC(25) : doc_func.sql(8847) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_POL_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_POL_DOC(29) : doc_func.sql(8851) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_POOL_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_POOL_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_POL_DOC(50) : doc_func.sql(8872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(58) : doc_func.sql(8880) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_POL_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_POL_DOC(78) : doc_func.sql(8900) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(83) : doc_func.sql(8905) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_POL_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_POL_DOC(87) : doc_func.sql(8909) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_POL_DOC;
ALTER FUNCTION FC_U_PRIVATE_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_AST_DOC(25) : doc_func.sql(8942) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_AST_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_AST_DOC(29) : doc_func.sql(8946) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_ASSET_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_ASSET_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_AST_DOC(50) : doc_func.sql(8967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(58) : doc_func.sql(8975) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_AST_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_AST_DOC(78) : doc_func.sql(8995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(83) : doc_func.sql(9000) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_AST_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_AST_DOC(87) : doc_func.sql(9004) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_AST_DOC;
ALTER FUNCTION FC_U_PRIVATE_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_VDR_DOC(25) : doc_func.sql(9037) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_VDR_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_VDR_DOC(29) : doc_func.sql(9041) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDOR_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDOR_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_VDR_DOC(50) : doc_func.sql(9062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(58) : doc_func.sql(9070) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_VDR_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_VDR_DOC(78) : doc_func.sql(9090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(83) : doc_func.sql(9095) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_VDR_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_VDR_DOC(87) : doc_func.sql(9099) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_VDR_DOC;
ALTER FUNCTION FC_U_PRIVATE_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PRIVATE_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PRIVATE_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_private IN OUT NOCOPY VARCHAR2
   , h_visible_at_parent IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PRIVATE_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PRIVATE_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PRIVATE_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_private || ''''
          || ', ' || '''' || h_visible_at_parent || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PRIVATE_CLN_DOC(25) : doc_func.sql(9132) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PRIVATE_CLN_DOC', 28+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PRIVATE_CLN_DOC(29) : doc_func.sql(9136) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CLIENT_DOCUMENTS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CLIENT_DOCUMENTS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id, False); 
   END;
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CLN_DOC(50) : doc_func.sql(9157) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(58) : doc_func.sql(9165) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET  PRIVATE = h_private,
      VISIBLE_AT_PARENT = h_visible_at_parent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PRIVATE_CLN_DOC', 77+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PRIVATE_CLN_DOC(78) : doc_func.sql(9185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 82+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(83) : doc_func.sql(9190) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PRIVATE_CLN_DOC', 86+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PRIVATE_CLN_DOC(87) : doc_func.sql(9194) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PRIVATE_CLN_DOC;
ALTER FUNCTION FC_U_PRIVATE_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_DOC(27) : doc_func.sql(9229) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_DOC(47) : doc_func.sql(9249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(54) : doc_func.sql(9256) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(60) : doc_func.sql(9262) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_DOC(64) : doc_func.sql(9266) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_RES_DOC(27) : doc_func.sql(9301) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_RES_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_RES_DOC(47) : doc_func.sql(9321) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(54) : doc_func.sql(9328) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(60) : doc_func.sql(9334) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_RES_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_RES_DOC(64) : doc_func.sql(9338) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_RES_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_POL_DOC(27) : doc_func.sql(9373) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_POL_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_POL_DOC(47) : doc_func.sql(9393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(54) : doc_func.sql(9400) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(60) : doc_func.sql(9406) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_POL_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_POL_DOC(64) : doc_func.sql(9410) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_POL_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_AST_DOC(27) : doc_func.sql(9445) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_AST_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_AST_DOC(47) : doc_func.sql(9465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(54) : doc_func.sql(9472) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(60) : doc_func.sql(9478) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_AST_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_AST_DOC(64) : doc_func.sql(9482) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_AST_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_VDR_DOC(27) : doc_func.sql(9517) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_VDR_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_VDR_DOC(47) : doc_func.sql(9537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(54) : doc_func.sql(9544) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(60) : doc_func.sql(9550) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_VDR_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_VDR_DOC(64) : doc_func.sql(9554) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_local_machine IN OUT NOCOPY VARCHAR2
   , h_local_folder IN OUT NOCOPY VARCHAR2
   , sh_h_document_size PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_document_size PLS_INTEGER := sh_h_document_size;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_LOCAL_FOLDER_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_LOCAL_FOLDER_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_LOCAL_FOLDER_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_local_machine || ''''
          || ', ' || '''' || h_local_folder || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_document_size), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_LOCAL_FOLDER_CLN_DOC(27) : doc_func.sql(9589) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET LOCAL_MACHINE = h_local_machine,
      LOCAL_FOLDER = h_local_folder,
      DOCUMENT_SIZE = h_document_size
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_LOCAL_FOLDER_CLN_DOC', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_LOCAL_FOLDER_CLN_DOC(47) : doc_func.sql(9609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(54) : doc_func.sql(9616) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(60) : doc_func.sql(9622) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_LOCAL_FOLDER_CLN_DOC', 63+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_LOCAL_FOLDER_CLN_DOC(64) : doc_func.sql(9626) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC;
ALTER FUNCTION FC_U_LOCAL_FOLDER_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
   h_link_doc VARCHAR2(1);
   h_blob_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_DOC(37) : doc_func.sql(9671) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS, BLOB_ID, LINK_DOC
      INTO h_rec_status, h_blob_id, h_link_doc
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(52) : doc_func.sql(9686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(60) : doc_func.sql(9694) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(85) : doc_func.sql(9719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(92) : doc_func.sql(9726) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   ElsIf ((h_blob_id IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_link_doc, 'P', 1) = 0) Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET (REVISION_IMPACT,REVISION_TYPE,REVISION_HISTORY,STAGE_ID,REC_DATETIME,REC_USER) =
         (SELECT REVISION_IMPACT,REVISION_TYPE,REVISION_HISTORY,STAGE_ID,REC_DATETIME,REC_USER
         FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_id)
         WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'Y';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_DOC', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_DOC(111) : doc_func.sql(9745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 117+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(118) : doc_func.sql(9752) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_DOC', 121+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_DOC(122) : doc_func.sql(9756) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_DOC;
ALTER FUNCTION FC_U_REVISION_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_RES_DOC(35) : doc_func.sql(9799) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_RES_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_RES_DOC(49) : doc_func.sql(9813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(57) : doc_func.sql(9821) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_RES_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_RES_DOC(82) : doc_func.sql(9846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(89) : doc_func.sql(9853) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(94) : doc_func.sql(9858) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_RES_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_RES_DOC(98) : doc_func.sql(9862) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_RES_DOC;
ALTER FUNCTION FC_U_REVISION_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_POL_DOC(35) : doc_func.sql(9905) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_POL_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_POL_DOC(49) : doc_func.sql(9919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(57) : doc_func.sql(9927) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_POL_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_POL_DOC(82) : doc_func.sql(9952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(89) : doc_func.sql(9959) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(94) : doc_func.sql(9964) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_POL_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_POL_DOC(98) : doc_func.sql(9968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_POL_DOC;
ALTER FUNCTION FC_U_REVISION_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_AST_DOC(35) : doc_func.sql(10011) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_AST_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_AST_DOC(49) : doc_func.sql(10025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(57) : doc_func.sql(10033) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_AST_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_AST_DOC(82) : doc_func.sql(10058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(89) : doc_func.sql(10065) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(94) : doc_func.sql(10070) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_AST_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_AST_DOC(98) : doc_func.sql(10074) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_AST_DOC;
ALTER FUNCTION FC_U_REVISION_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_VDR_DOC(35) : doc_func.sql(10117) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_VDR_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_VDR_DOC(49) : doc_func.sql(10131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(57) : doc_func.sql(10139) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_VDR_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_VDR_DOC(82) : doc_func.sql(10164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(89) : doc_func.sql(10171) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(94) : doc_func.sql(10176) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_VDR_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_VDR_DOC(98) : doc_func.sql(10180) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_VDR_DOC;
ALTER FUNCTION FC_U_REVISION_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_REVISION_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_REVISION_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , sh_h_rev_impact PLS_INTEGER
   , sh_h_rev_type PLS_INTEGER
   , h_rev_history IN OUT NOCOPY VARCHAR2
   , sh_h_stage_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rev_impact PLS_INTEGER := sh_h_rev_impact;
   h_rev_type PLS_INTEGER := sh_h_rev_type;
   h_stage_id PLS_INTEGER := sh_h_stage_id;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_REVISION_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_REVISION_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_REVISION_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_rev_type), 'NULL')
          || ', ' || '''' || h_rev_history || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_stage_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_REVISION_CLN_DOC(35) : doc_func.sql(10223) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_CLN_DOC', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_CLN_DOC(49) : doc_func.sql(10237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(57) : doc_func.sql(10245) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET REVISION_IMPACT  = h_rev_impact,
      REVISION_TYPE    = h_rev_type,
      REVISION_HISTORY = h_rev_history,
      STAGE_ID         = h_stage_id,
      REC_DATETIME     = SYSTIMESTAMP,
      REC_USER         = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_REVISION_CLN_DOC', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_REVISION_CLN_DOC(82) : doc_func.sql(10270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(89) : doc_func.sql(10277) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(94) : doc_func.sql(10282) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_REVISION_CLN_DOC', 97+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_REVISION_CLN_DOC(98) : doc_func.sql(10286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_REVISION_CLN_DOC;
ALTER FUNCTION FC_U_REVISION_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_DOC IS
         SELECT a.ELEMENT_ID FROM TMT_DOCUMENTS a, TMT_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_DOC IS
         SELECT MINOR_REVISION
         FROM HISTORY_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_DOC(36) : doc_func.sql(10330) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_DOC;
   
   LOOP
      FETCH CKALL1_DOC INTO h_current_id;
      IF CKALL1_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      OPEN CKALL2_DOC;
      
      FETCH CKALL2_DOC INTO h_min_revision;
      IF CKALL2_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CKALL2_DOC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(76) : doc_func.sql(10370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(98) : doc_func.sql(10392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_DOC ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(111) : doc_func.sql(10405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(136) : doc_func.sql(10430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(160) : doc_func.sql(10454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(182) : doc_func.sql(10476) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(297) : doc_func.sql(10591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(315) : doc_func.sql(10609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_DOC(330) : doc_func.sql(10624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_DOC(336) : doc_func.sql(10630) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_DOC(340) : doc_func.sql(10634) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_RES IS
         SELECT a.ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS a, TMT_RESOURCE_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_RES IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_RES_DOC(36) : doc_func.sql(10678) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_RES;
   
   LOOP
      FETCH CKALL1_RES INTO h_current_id;
      IF CKALL1_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      OPEN CKALL2_RES;
      
      FETCH CKALL2_RES INTO h_min_revision;
      IF CKALL2_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CKALL2_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(76) : doc_func.sql(10718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(98) : doc_func.sql(10740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_RES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(111) : doc_func.sql(10753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(136) : doc_func.sql(10778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(160) : doc_func.sql(10802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_RESOURCE_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(182) : doc_func.sql(10824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_RESOURCE_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_RESOURCE_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(297) : doc_func.sql(10939) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(315) : doc_func.sql(10957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_RES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_RES_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_RES_DOC(330) : doc_func.sql(10972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_RES_DOC(336) : doc_func.sql(10978) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_RES_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_RES_DOC(340) : doc_func.sql(10982) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_RES_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_POL IS
         SELECT a.ELEMENT_ID FROM TMT_POOL_DOCUMENTS a, TMT_POOL_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_POL IS
         SELECT MINOR_REVISION
         FROM HISTORY_POOL_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_POL_DOC(36) : doc_func.sql(11026) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_POL;
   
   LOOP
      FETCH CKALL1_POL INTO h_current_id;
      IF CKALL1_POL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      OPEN CKALL2_POL;
      
      FETCH CKALL2_POL INTO h_min_revision;
      IF CKALL2_POL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CKALL2_POL ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(76) : doc_func.sql(11066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(98) : doc_func.sql(11088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_POL ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(111) : doc_func.sql(11101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(136) : doc_func.sql(11126) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(160) : doc_func.sql(11150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_POOL_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(182) : doc_func.sql(11172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_POOL_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_POOL_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(297) : doc_func.sql(11287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(315) : doc_func.sql(11305) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_POL ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_POL_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_POL_DOC(330) : doc_func.sql(11320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_POL_DOC(336) : doc_func.sql(11326) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_POL_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_POL_DOC(340) : doc_func.sql(11330) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_POL_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_AST IS
         SELECT a.ELEMENT_ID FROM TMT_ASSET_DOCUMENTS a, TMT_ASSET_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_AST IS
         SELECT MINOR_REVISION
         FROM HISTORY_ASSET_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_AST_DOC(36) : doc_func.sql(11374) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_AST;
   
   LOOP
      FETCH CKALL1_AST INTO h_current_id;
      IF CKALL1_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      OPEN CKALL2_AST;
      
      FETCH CKALL2_AST INTO h_min_revision;
      IF CKALL2_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CKALL2_AST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(76) : doc_func.sql(11414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(98) : doc_func.sql(11436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_AST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(111) : doc_func.sql(11449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(136) : doc_func.sql(11474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(160) : doc_func.sql(11498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_ASSET_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(182) : doc_func.sql(11520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_ASSET_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_ASSET_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(297) : doc_func.sql(11635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(315) : doc_func.sql(11653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_AST ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_AST_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_AST_DOC(330) : doc_func.sql(11668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_AST_DOC(336) : doc_func.sql(11674) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_AST_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_AST_DOC(340) : doc_func.sql(11678) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_AST_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_VDR IS
         SELECT a.ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS a, TMT_VENDOR_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_VDR IS
         SELECT MINOR_REVISION
         FROM HISTORY_VENDOR_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_VDR_DOC(36) : doc_func.sql(11722) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_VDR;
   
   LOOP
      FETCH CKALL1_VDR INTO h_current_id;
      IF CKALL1_VDR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      OPEN CKALL2_VDR;
      
      FETCH CKALL2_VDR INTO h_min_revision;
      IF CKALL2_VDR%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CKALL2_VDR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(76) : doc_func.sql(11762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(98) : doc_func.sql(11784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_VDR ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(111) : doc_func.sql(11797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(136) : doc_func.sql(11822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(160) : doc_func.sql(11846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_VENDOR_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(182) : doc_func.sql(11868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_VENDOR_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_VENDOR_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(297) : doc_func.sql(11983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(315) : doc_func.sql(12001) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_VDR ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_VDR_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_VDR_DOC(330) : doc_func.sql(12016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_VDR_DOC(336) : doc_func.sql(12022) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_VDR_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_VDR_DOC(340) : doc_func.sql(12026) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_VDR_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CKIN_ALL_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CKIN_ALL_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CKALL1_CLN IS
         SELECT a.ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS a, TMT_CLIENT_DOCUMENTS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O' AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

      CURSOR CKALL2_CLN IS
         SELECT MINOR_REVISION
         FROM HISTORY_CLIENT_DOCUMENTS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_current_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CKIN_ALL_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CKIN_ALL_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CKIN_ALL_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CKIN_ALL_DOC_CLN_DOC(36) : doc_func.sql(12070) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag          = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CKALL1_CLN;
   
   LOOP
      FETCH CKALL1_CLN INTO h_current_id;
      IF CKALL1_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      OPEN CKALL2_CLN;
      
      FETCH CKALL2_CLN INTO h_min_revision;
      IF CKALL2_CLN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CKALL2_CLN ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(76) : doc_func.sql(12110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            PUBLISHED_DT = NuLL,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(98) : doc_func.sql(12132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CKALL2_CLN ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 110+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(111) : doc_func.sql(12145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 135+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(136) : doc_func.sql(12170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 159+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(160) : doc_func.sql(12194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_CLIENT_DOCUMENTS SET
               PUBLISHED_DT = NuLL,
               REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 181+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(182) : doc_func.sql(12216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         BEGIN
            INSERT INTO HISTORY_CLIENT_DOCUMENTS (
            HISTORY_ID,
            LEVEL_ID,
            TYPE_ID,
            MAX_RANK,
            CHILD_COUNT,
            DELETED_COUNT,
            ELEMENT_ID,
            ELEMENT_NAME,
            ELEMENT_NUMBER,
            PROJECT_ID,
            BLOB_ID,
            PARENT_ID,
            PARENT_TYPE_ID,
            AUTHOR_ID,
            CREATION_DATE,
            APPROVED_DATE,
            REF_NUMBER,
            AUTHOR_CHECKOUT,
            PUBLISHED_DT,
            MINOR_REVISION,
            MAJOR_REVISION,
            MAX_REVISION,
            MAX_REV_REACHED,
            ATTACHED_ID,
            LAST_WF_TYPE,
            LAST_WF_BY,
            LAST_WF_DT,
            REC_USER,
            REC_STATUS,
            REC_DATETIME,
            RANK,
            PARENT_RANK,
            KEYWORDS,
            LAST_CHECKIN,
            REVISION_TYPE,
            REVISION_IMPACT,
            REVISION_HISTORY,
            SCORECARD_ID,
            SCORE,
            WEIGHT,
            CONVERTED_SCORE,
            CONVERTED_WEIGHT,
            ACTIVE,
            ATTACHEMENT,
            BLOB_DATA )
            SELECT
            h_uniqueID,
            A.LEVEL_ID,
            A.TYPE_ID,
            A.MAX_RANK,
            A.CHILD_COUNT,
            A.DELETED_COUNT,
            A.ELEMENT_ID,
            A.ELEMENT_NAME,
            A.ELEMENT_NUMBER,
            A.PROJECT_ID,
            A.BLOB_ID,
            A.PARENT_ID,
            A.PARENT_TYPE_ID,
            A.AUTHOR_ID,
            A.CREATION_DATE,
            A.APPROVED_DATE,
            A.REF_NUMBER,
            A.AUTHOR_CHECKOUT,
            A.PUBLISHED_DT,
            A.MINOR_REVISION,
            A.MAJOR_REVISION,
            A.MAX_REVISION,
            A.MAX_REV_REACHED,
            A.ATTACHED_ID,
            A.LAST_WF_TYPE,
            A.LAST_WF_BY,
            A.LAST_WF_DT,
            A.REC_USER,
            A.REC_STATUS,
            A.REC_DATETIME,
            A.RANK,
            A.PARENT_RANK,
            A.KEYWORDS,
            A.LAST_CHECKIN,
            A.REVISION_TYPE,
            A.REVISION_IMPACT,
            A.REVISION_HISTORY,
            A.SCORECARD_ID,
            A.SCORE,
            A.WEIGHT,
            A.CONVERTED_SCORE,
            A.CONVERTED_WEIGHT,
            A.ACTIVE,
            B.ATTACHEMENT,
            B.BLOB_DATA
            FROM TMT_CLIENT_DOCUMENTS A LEFT OUTER JOIN DOCUMENT_BLOBS B
            ON A.BLOB_ID = B.ELEMENT_ID
            WHERE A.ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 296+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(297) : doc_func.sql(12331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET REVISION_HISTORY = Null
            WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 314+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(315) : doc_func.sql(12349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CKALL1_CLN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CKIN_ALL_DOC_CLN_DOC', 329+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CKIN_ALL_DOC_CLN_DOC(330) : doc_func.sql(12364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 335+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_CLN_DOC(336) : doc_func.sql(12370) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CKIN_ALL_DOC_CLN_DOC', 339+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CKIN_ALL_DOC_CLN_DOC(340) : doc_func.sql(12374) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CKIN_ALL_DOC_CLN_DOC;
ALTER FUNCTION FC_CKIN_ALL_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_DOC(24) : doc_func.sql(12406) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_DOC(40) : doc_func.sql(12422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(48) : doc_func.sql(12430) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_DOC(74) : doc_func.sql(12456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(80) : doc_func.sql(12462) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_DOC(84) : doc_func.sql(12466) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_DOC;
ALTER FUNCTION FC_UNDO_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_RES_DOC(24) : doc_func.sql(12498) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_RES_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_RES_DOC(40) : doc_func.sql(12514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(48) : doc_func.sql(12522) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_RES_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_RES_DOC(74) : doc_func.sql(12548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(80) : doc_func.sql(12554) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_RES_DOC(84) : doc_func.sql(12558) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_RES_DOC;
ALTER FUNCTION FC_UNDO_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_POL_DOC(24) : doc_func.sql(12590) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_POL_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_POL_DOC(40) : doc_func.sql(12606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(48) : doc_func.sql(12614) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_POL_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_POL_DOC(74) : doc_func.sql(12640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(80) : doc_func.sql(12646) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_POL_DOC(84) : doc_func.sql(12650) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_POL_DOC;
ALTER FUNCTION FC_UNDO_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_AST_DOC(24) : doc_func.sql(12682) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_AST_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_AST_DOC(40) : doc_func.sql(12698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(48) : doc_func.sql(12706) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_AST_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_AST_DOC(74) : doc_func.sql(12732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(80) : doc_func.sql(12738) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_AST_DOC(84) : doc_func.sql(12742) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_AST_DOC;
ALTER FUNCTION FC_UNDO_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_VDR_DOC(24) : doc_func.sql(12774) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_VDR_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_VDR_DOC(40) : doc_func.sql(12790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(48) : doc_func.sql(12798) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_VDR_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_VDR_DOC(74) : doc_func.sql(12824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(80) : doc_func.sql(12830) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_VDR_DOC(84) : doc_func.sql(12834) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_VDR_DOC;
ALTER FUNCTION FC_UNDO_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_UNDO_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_UNDO_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_DOC_CLN_DOC(24) : doc_func.sql(12866) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_CLN_DOC', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_CLN_DOC(40) : doc_func.sql(12882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(48) : doc_func.sql(12890) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME)
      FROM HISTORY_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_DOC_CLN_DOC', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_DOC_CLN_DOC(74) : doc_func.sql(12916) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(80) : doc_func.sql(12922) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_DOC_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_DOC_CLN_DOC(84) : doc_func.sql(12926) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_DOC_CLN_DOC;
ALTER FUNCTION FC_UNDO_DOC_CLN_DOC COMPILE DEBUG;

/**************************************************************************************/

Prompt == FUNCTION FC_D_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_blob_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_published VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
   h_link_doc VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
   null_return LONG;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DEL_BLOB IS
         SELECT BLOB_ID, LINK_DOC
         FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC IN ('Y', 'P');

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 61+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_DOC(62) : doc_func.sql(12998) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(69) : doc_func.sql(13005) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS, TYPE_ID
      INTO h_doc_rec_status, h_parent_type_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(87) : doc_func.sql(13023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_doc_rec_status: %s, h_parent_id: %d %s\n",SC_STATE,h_doc_rec_status,h_parent_id_Ind,h_parent_id);
   
   If (Coalesce(h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) OR (Coalesce(
             h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER0) Then
      If (h_id IS NULL) Then
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE T_PARENT_ID = ''' 
               || h_parent_id || '''';
      Else
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
               || h_id || ''' AND T_PARENT_ID = ''' || h_parent_id || '''';
      End If;
   Else
      If (h_id IS NULL) Then
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE PARENT_ID = ''' 
               || h_parent_id || '''';
      Else
         h_xsql := 
               'SELECT ELEMENT_ID, RANK, REC_STATUS, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED, TYPE_ID FROM TMT_DOCUMENTS WHERE ELEMENT_ID = ''' 
               || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
      End If;
   End If;
   
   h_xsql := SubStr(h_xsql || '  ', 1, 4999);
   --trace_printf("\n%s\n",(char *) h_xsql);
   
   OPEN DELD_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_DOC
      INTO h_element_id, h_rank, h_rec_status, h_t_parent_id, h_parent_type_id, h_published, h_type_id;
      IF DELD_DOC
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_DOC;
      
      LOOP
         FETCH DELAT_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 162+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(163) : doc_func.sql(13099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(179) : doc_func.sql(13115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 211+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(212) : doc_func.sql(13148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If (SubStr(h_doc_rec_status, 1, 1) = 'D') OR (Coalesce(
            h_parent_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 235+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(236) : doc_func.sql(13172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --trace_printf("\n h_parent_id:%s", h_parent_id);
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 257+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(258) : doc_func.sql(13194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_DOCUMENTS SET
               DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 276+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(277) : doc_func.sql(13213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("\n SC_STATE:%s", SC_STATE);
      End If;
      --trace_printf("SC_STATE: %d, h_rank: %s, h_parent_id: %s, h_doc_rec_status: %s\n", SC_STATE,h_rank,h_parent_id,h_doc_rec_status);
      
      If (SubStr(h_published, 1, 1) = 'Y') AND (Coalesce(
            h_parent_type_id, 0) <> PMO_CNST.SC_TMP_FOLDER1) Then
         BEGIN
            UPDATE TMT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_t_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 302+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(303) : doc_func.sql(13239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("SC_STATE: %d, h_t_parent_id: %s, h_parent_type_id: %d, h_published: %s\n", SC_STATE,h_t_parent_id,h_parent_type_id, h_published);
      
      COMMIT;
      
      -- delete blob_documents
      
      OPEN DEL_BLOB;
      
      LOOP
         FETCH DEL_BLOB INTO h_blob_id, h_link_doc;
         IF DEL_BLOB%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         h_count := 0;
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE BLOB_ID = h_blob_id
            AND RANK NOT LIKE h_rank || '%';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 338+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(339) : doc_func.sql(13275) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("DEL_BLOB: SC_STATE: %d, h_blob_id: %s, h_count: %d\n", SC_STATE,h_blob_id,h_count);
         
         If Coalesce(h_count, 0) = 0 Then
            BEGIN
               DELETE FROM DOCUMENT_BLOBS WHERE ELEMENT_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(358) : doc_func.sql(13294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_DOCUMENTS WHERE BLOB_ID = h_blob_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 374+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(375) : doc_func.sql(13311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf (Coalesce(h_count, 0) = 1) AND (PMO_ORASTD.strncmp(h_link_doc, 'Y', 1) = 0) Then
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET LINK_DOC = 'N'
               WHERE BLOB_ID = h_blob_id AND LINK_DOC = 'P';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 393+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(394) : doc_func.sql(13330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE DEL_BLOB ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(409) : doc_func.sql(13345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 429+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(430) : doc_func.sql(13366) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%'
         AND LINK_DOC = 'N');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 450+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(451) : doc_func.sql(13387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 471+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(472) : doc_func.sql(13408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_table_type := PMO_CNST.SC_TABLE_DOC;
      null_return := FC_DECREASE_WBS_CHILD_COUNT(Coalesce(h_table_type, 0), h_rank);
      
      null_return := FC_DELETE_ATTACHED_WKF(h_table_type, h_element_id, h_rank, h_rec_user);
      
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 493+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(494) : doc_func.sql(13430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 509+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(510) : doc_func.sql(13446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_DOC', 527+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_DOC(528) : doc_func.sql(13464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 534+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(535) : doc_func.sql(13471) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_DOC', 538+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_DOC(539) : doc_func.sql(13475) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_DOC;
ALTER FUNCTION FC_D_DOC_DOC COMPILE DEBUG;

/******************************************************************************************/

Prompt == FUNCTION FC_D_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_RES_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_RES_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_RES_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_RES_DOC(55) : doc_func.sql(13540) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(62) : doc_func.sql(13547) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(80) : doc_func.sql(13565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_RESOURCE_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 
            'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := SubStr(h_xsql || '  ', 1, 4999);
   
   OPEN DELD_RES_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_RES_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_RES_DOC;
      
      LOOP
         FETCH DELAT_RES_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(139) : doc_func.sql(13624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(155) : doc_func.sql(13640) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(186) : doc_func.sql(13671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 208+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(209) : doc_func.sql(13694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 227+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(228) : doc_func.sql(13713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(249) : doc_func.sql(13734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(269) : doc_func.sql(13754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_RES_DOC;
      
      LOOP
         FETCH DELW_RES_DOC INTO h_cur_rank;
         IF DELW_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 317+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(318) : doc_func.sql(13803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(338) : doc_func.sql(13823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 352+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(353) : doc_func.sql(13838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 370+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(371) : doc_func.sql(13856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_RESOURCE_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 387+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(388) : doc_func.sql(13873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 403+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(404) : doc_func.sql(13889) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_RESOURCE_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_RES_DOC', 421+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_RES_DOC(422) : doc_func.sql(13907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 428+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(429) : doc_func.sql(13914) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_RES_DOC', 432+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_RES_DOC(433) : doc_func.sql(13918) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_RES_DOC;
ALTER FUNCTION FC_D_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_POL_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_POL_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_POL_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_POL_DOC(55) : doc_func.sql(13981) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(62) : doc_func.sql(13988) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(80) : doc_func.sql(14006) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_POOL_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := SubStr(h_xsql || '  ', 1, 4999);
   
   OPEN DELD_POL_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_POL_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_POL_DOC;
      
      LOOP
         FETCH DELAT_POL_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(137) : doc_func.sql(14063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(153) : doc_func.sql(14079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(184) : doc_func.sql(14110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(207) : doc_func.sql(14133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(226) : doc_func.sql(14152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(249) : doc_func.sql(14175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_POOL_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(269) : doc_func.sql(14195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_POL_DOC;
      
      LOOP
         FETCH DELW_POL_DOC INTO h_cur_rank;
         IF DELW_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 317+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(318) : doc_func.sql(14244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(338) : doc_func.sql(14264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 352+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(353) : doc_func.sql(14279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 371+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(372) : doc_func.sql(14298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_POOL_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 388+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(389) : doc_func.sql(14315) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 404+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(405) : doc_func.sql(14331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_POOL_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_POL_DOC', 422+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_POL_DOC(423) : doc_func.sql(14349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 429+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(430) : doc_func.sql(14356) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_POL_DOC', 433+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_POL_DOC(434) : doc_func.sql(14360) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_POL_DOC;
ALTER FUNCTION FC_D_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_AST_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_AST_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_AST_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_AST_DOC(55) : doc_func.sql(14423) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(62) : doc_func.sql(14430) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(80) : doc_func.sql(14448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_ASSET_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := SubStr(h_xsql || '  ', 1, 4999);
   
   OPEN DELD_AST_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_AST_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_AST_DOC;
      
      LOOP
         FETCH DELAT_AST_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(137) : doc_func.sql(14505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(153) : doc_func.sql(14521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(184) : doc_func.sql(14552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(207) : doc_func.sql(14575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(226) : doc_func.sql(14594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(249) : doc_func.sql(14617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_ASSET_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(269) : doc_func.sql(14637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_AST_DOC;
      
      LOOP
         FETCH DELW_AST_DOC INTO h_cur_rank;
         IF DELW_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 317+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(318) : doc_func.sql(14686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(338) : doc_func.sql(14706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 352+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(353) : doc_func.sql(14721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 371+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(372) : doc_func.sql(14740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_ASSET_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 388+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(389) : doc_func.sql(14757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 404+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(405) : doc_func.sql(14773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_ASSET_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_AST_DOC', 422+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_AST_DOC(423) : doc_func.sql(14791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 429+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(430) : doc_func.sql(14798) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_AST_DOC', 433+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_AST_DOC(434) : doc_func.sql(14802) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_AST_DOC;
ALTER FUNCTION FC_D_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_VDR_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_VDR_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_VDR_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_VDR_DOC(55) : doc_func.sql(14865) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(62) : doc_func.sql(14872) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(80) : doc_func.sql(14890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_VENDOR_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := SubStr(h_xsql || '  ', 1, 4999);
   
   OPEN DELD_VDR_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_VDR_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_VDR_DOC;
      
      LOOP
         FETCH DELAT_VDR_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(137) : doc_func.sql(14947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(153) : doc_func.sql(14963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(184) : doc_func.sql(14994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(207) : doc_func.sql(15017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(226) : doc_func.sql(15036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(249) : doc_func.sql(15059) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(269) : doc_func.sql(15079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_VDR_DOC;
      
      LOOP
         FETCH DELW_VDR_DOC INTO h_cur_rank;
         IF DELW_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 317+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(318) : doc_func.sql(15128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(338) : doc_func.sql(15148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 352+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(353) : doc_func.sql(15163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 371+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(372) : doc_func.sql(15182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_VENDOR_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 388+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(389) : doc_func.sql(15199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 404+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(405) : doc_func.sql(15215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_VENDOR_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_VDR_DOC', 422+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_VDR_DOC(423) : doc_func.sql(15233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 429+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(430) : doc_func.sql(15240) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_VDR_DOC', 433+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_VDR_DOC(434) : doc_func.sql(15244) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_VDR_DOC;
ALTER FUNCTION FC_D_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_D_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_D_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_attr_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_doc_rec_status VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(4999);
   h_count PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_current_date TIMESTAMP;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      DELD_CLN_DOC PMO_DB2M.REF_CURSOR;

      CURSOR DELAT_CLN_DOC IS
         SELECT PARENT_ID, COUNT(*)
         FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%')
         GROUP BY PARENT_ID;

      CURSOR DELW_CLN_DOC IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND LAST_WF_DT IS NOT NuLL)
         AND TYPE_ID IN (PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_DOC_NOTIFICATION);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_D_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_DOC_CLN_DOC(55) : doc_func.sql(15307) : ' || SYSTIMESTAMP);
   END IF; 

   -- physicaly delete
   
   If (h_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(62) : doc_func.sql(15314) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ELEMENT_ID_REQUIRED;
   End If;
   
   --strcpy(h_parent_id, parent_id);
   
   BEGIN
      SELECT REC_STATUS
      INTO h_doc_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_parent_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(80) : doc_func.sql(15332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_id IS NULL) Then
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_CLIENT_DOCUMENTS WHERE PARENT_ID = ''' 
            || h_parent_id || '''';
   Else
      h_xsql := 'SELECT RANK, REC_STATUS, PARENT_TYPE_ID FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = ''' 
            || h_id || ''' AND PARENT_ID = ''' || h_parent_id || '''';
   End If;
   
   h_xsql := SubStr(h_xsql || '  ', 1, 4999);
   
   OPEN DELD_CLN_DOC FOR h_xsql;
   
   LOOP
      FETCH DELD_CLN_DOC INTO h_rank, h_rec_status, h_parent_type_id;
      IF DELD_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- update and delete tmt_document_attributes
      
      OPEN DELAT_CLN_DOC;
      
      LOOP
         FETCH DELAT_CLN_DOC INTO h_attr_parent_id, h_count;
         IF DELAT_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_DOCUMENT_ATTRIBUTES SET
            CHILD_COUNT = CHILD_COUNT - h_count
            WHERE ELEMENT_ID = h_attr_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(137) : doc_func.sql(15389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE DELAT_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(153) : doc_func.sql(15405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_DOCUMENT_ATTRIBUTES
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(184) : doc_func.sql(15436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- parent in tmt_documents
      If SubStr(h_doc_rec_status, 1, 1) = 'D' Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 206+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(207) : doc_func.sql(15459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS SET
            DELETED_COUNT = DELETED_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(226) : doc_func.sql(15478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      COMMIT;
      
      BEGIN
         DELETE FROM DOCUMENT_BLOBS
         WHERE ELEMENT_ID IN (SELECT BLOB_ID
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(249) : doc_func.sql(15501) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      BEGIN
         DELETE FROM HISTORY_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 268+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(269) : doc_func.sql(15521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
      
      -- delete related workflows
      
      OPEN DELW_CLN_DOC;
      
      LOOP
         FETCH DELW_CLN_DOC INTO h_cur_rank;
         IF DELW_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_cur_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_cur_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
         	End If; 
         END;
         BEGIN
            DELETE FROM WORKFLOW_REPLIES
            WHERE ELEMENT_ID IN
            (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 317+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(318) : doc_func.sql(15570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
         
         BEGIN
            DELETE FROM TMT_WORKFLOWS
            WHERE RANK LIKE h_cur_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 337+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(338) : doc_func.sql(15590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE DELW_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 352+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(353) : doc_func.sql(15605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 371+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(372) : doc_func.sql(15624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_CLIENT_DOCUMENTS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 388+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(389) : doc_func.sql(15641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   END LOOP;
   
   BEGIN
      CLOSE DELD_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 404+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(405) : doc_func.sql(15657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_id IS NULL)) AND (Coalesce(h_host_table, 0) <> PMO_CNST.SC_TABLE_DOC) Then
      BEGIN
         DELETE FROM TMT_CLIENT_DOCUMENTS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_DOC_CLN_DOC', 422+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_DOC_CLN_DOC(423) : doc_func.sql(15675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 429+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(430) : doc_func.sql(15682) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_DOC_CLN_DOC', 433+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_DOC_CLN_DOC(434) : doc_func.sql(15686) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_DOC_CLN_DOC;
ALTER FUNCTION FC_D_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_DOC(27) : doc_func.sql(15721) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_DOC(41) : doc_func.sql(15735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(49) : doc_func.sql(15743) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_DOC(71) : doc_func.sql(15765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(79) : doc_func.sql(15773) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(84) : doc_func.sql(15778) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_DOC(88) : doc_func.sql(15782) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_RES_DOC(27) : doc_func.sql(15817) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_RES_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_RES_DOC(41) : doc_func.sql(15831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(49) : doc_func.sql(15839) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_RES_DOC(71) : doc_func.sql(15861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(79) : doc_func.sql(15869) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(84) : doc_func.sql(15874) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_RES_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_RES_DOC(88) : doc_func.sql(15878) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_RES_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_POL_DOC(27) : doc_func.sql(15913) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_POL_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_POL_DOC(41) : doc_func.sql(15927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(49) : doc_func.sql(15935) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_POL_DOC(71) : doc_func.sql(15957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(79) : doc_func.sql(15965) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(84) : doc_func.sql(15970) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_POL_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_POL_DOC(88) : doc_func.sql(15974) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_POL_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_AST_DOC(27) : doc_func.sql(16009) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_AST_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_AST_DOC(41) : doc_func.sql(16023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(49) : doc_func.sql(16031) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_AST_DOC(71) : doc_func.sql(16053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(79) : doc_func.sql(16061) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(84) : doc_func.sql(16066) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_AST_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_AST_DOC(88) : doc_func.sql(16070) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_AST_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_VDR_DOC(27) : doc_func.sql(16105) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_VDR_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_VDR_DOC(41) : doc_func.sql(16119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(49) : doc_func.sql(16127) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_VDR_DOC(71) : doc_func.sql(16149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(79) : doc_func.sql(16157) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(84) : doc_func.sql(16162) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_VDR_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_VDR_DOC(88) : doc_func.sql(16166) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_VDR_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PR_RNK_DOC_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PR_RNK_DOC_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_scope_rank_id PLS_INTEGER
   , sh_h_priority PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_error_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_scope_rank_id PLS_INTEGER := sh_h_scope_rank_id;
   h_priority PLS_INTEGER := sh_h_priority;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PR_RNK_DOC_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PR_RNK_DOC_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PR_RNK_DOC_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_scope_rank_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_priority), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_error_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PR_RNK_DOC_CLN_DOC(27) : doc_func.sql(16201) : ' || SYSTIMESTAMP);
   END IF; 

   --VALIDATE_RECORD
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_CLN_DOC', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_CLN_DOC(41) : doc_func.sql(16215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(49) : doc_func.sql(16223) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      PRIORITY      = h_priority,
      SCOPE_RANK_ID = h_scope_rank_id,
      REC_STATUS    = 'U',
      REC_DATETIME  = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PR_RNK_DOC_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PR_RNK_DOC_CLN_DOC(71) : doc_func.sql(16245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_error_id := h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(79) : doc_func.sql(16253) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(84) : doc_func.sql(16258) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PR_RNK_DOC_CLN_DOC', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PR_RNK_DOC_CLN_DOC(88) : doc_func.sql(16262) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PR_RNK_DOC_CLN_DOC;
ALTER FUNCTION FC_U_PR_RNK_DOC_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_t_parent_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_published VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_DOC(40) : doc_func.sql(16310) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK, T_PARENT_ID, PARENT_TYPE_ID, PUBLISHED
      INTO h_parent_id, h_rank, h_t_parent_id, h_parent_type_id, h_published
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(54) : doc_func.sql(16324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(70) : doc_func.sql(16340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 76+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(77) : doc_func.sql(16347) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(94) : doc_func.sql(16364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 100+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(101) : doc_func.sql(16371) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(128) : doc_func.sql(16398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 146+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(147) : doc_func.sql(16417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(186) : doc_func.sql(16456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(209) : doc_func.sql(16479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 228+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(229) : doc_func.sql(16499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (SubStr(h_published, 1, 1) = 'Y') AND ((h_t_parent_id IS NOT NULL)) Then
      BEGIN
         UPDATE TMT_DOCUMENTS SET
         CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID = h_t_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(249) : doc_func.sql(16519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_DOC;
      
      LOOP
         FETCH C_TMP_DEL_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 278+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(279) : doc_func.sql(16549) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 301+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(302) : doc_func.sql(16572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 320+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(321) : doc_func.sql(16591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 334+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(335) : doc_func.sql(16605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 354+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(355) : doc_func.sql(16625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_DOC', 371+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_DOC(372) : doc_func.sql(16642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 378+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(379) : doc_func.sql(16649) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_DOC', 382+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_DOC(383) : doc_func.sql(16653) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_RES_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_RES_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_RES_DOC(37) : doc_func.sql(16698) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(50) : doc_func.sql(16711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(66) : doc_func.sql(16727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(73) : doc_func.sql(16734) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(90) : doc_func.sql(16751) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(97) : doc_func.sql(16758) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_RES_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_RES_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(124) : doc_func.sql(16785) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(143) : doc_func.sql(16804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(182) : doc_func.sql(16843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(205) : doc_func.sql(16866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(225) : doc_func.sql(16886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_RES_DOC;
      
      LOOP
         FETCH C_TMP_DEL_RES_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_RES_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_RES_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(254) : doc_func.sql(16915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 276+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(277) : doc_func.sql(16938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 295+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(296) : doc_func.sql(16957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 309+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(310) : doc_func.sql(16971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 329+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(330) : doc_func.sql(16991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_RES_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_RES_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_RES_DOC(347) : doc_func.sql(17008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 353+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(354) : doc_func.sql(17015) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_RES_DOC', 357+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_RES_DOC(358) : doc_func.sql(17019) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_RES_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_POL_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_POL_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_POL_DOC(37) : doc_func.sql(17064) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(50) : doc_func.sql(17077) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(66) : doc_func.sql(17093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(73) : doc_func.sql(17100) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(90) : doc_func.sql(17117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(97) : doc_func.sql(17124) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_POL_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_POL_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(124) : doc_func.sql(17151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(143) : doc_func.sql(17170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(182) : doc_func.sql(17209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(205) : doc_func.sql(17232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(225) : doc_func.sql(17252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_POL_DOC;
      
      LOOP
         FETCH C_TMP_DEL_POL_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_POL_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_POL_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(254) : doc_func.sql(17281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 276+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(277) : doc_func.sql(17304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 295+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(296) : doc_func.sql(17323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 309+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(310) : doc_func.sql(17337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 329+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(330) : doc_func.sql(17357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_POL_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_POL_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_POL_DOC(347) : doc_func.sql(17374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 353+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(354) : doc_func.sql(17381) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_POL_DOC', 357+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_POL_DOC(358) : doc_func.sql(17385) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_POL_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_AST_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_AST_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_AST_DOC(37) : doc_func.sql(17430) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(50) : doc_func.sql(17443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(66) : doc_func.sql(17459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(73) : doc_func.sql(17466) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(90) : doc_func.sql(17483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(97) : doc_func.sql(17490) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_AST_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_AST_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(124) : doc_func.sql(17517) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(143) : doc_func.sql(17536) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(182) : doc_func.sql(17575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(205) : doc_func.sql(17598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(225) : doc_func.sql(17618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_AST_DOC;
      
      LOOP
         FETCH C_TMP_DEL_AST_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_AST_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_AST_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(254) : doc_func.sql(17647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 276+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(277) : doc_func.sql(17670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 295+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(296) : doc_func.sql(17689) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 309+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(310) : doc_func.sql(17703) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 329+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(330) : doc_func.sql(17723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_AST_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_AST_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_AST_DOC(347) : doc_func.sql(17740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 353+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(354) : doc_func.sql(17747) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_AST_DOC', 357+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_AST_DOC(358) : doc_func.sql(17751) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_AST_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_VDR_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_VDR_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_VDR_DOC(37) : doc_func.sql(17796) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(50) : doc_func.sql(17809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(66) : doc_func.sql(17825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(73) : doc_func.sql(17832) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(90) : doc_func.sql(17849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(97) : doc_func.sql(17856) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_VDR_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_VDR_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(124) : doc_func.sql(17883) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(143) : doc_func.sql(17902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(182) : doc_func.sql(17941) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(205) : doc_func.sql(17964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(225) : doc_func.sql(17984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_VDR_DOC;
      
      LOOP
         FETCH C_TMP_DEL_VDR_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_VDR_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_VDR_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(254) : doc_func.sql(18013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 276+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(277) : doc_func.sql(18036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 295+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(296) : doc_func.sql(18055) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 309+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(310) : doc_func.sql(18069) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 329+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(330) : doc_func.sql(18089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_VDR_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_VDR_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_VDR_DOC(347) : doc_func.sql(18106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 353+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(354) : doc_func.sql(18113) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_VDR_DOC', 357+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_VDR_DOC(358) : doc_func.sql(18117) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_VDR_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_CHANGE_STATUS_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_CHANGE_STATUS_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_parent_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_wbs_id VARCHAR2(32);
   h_source_parent_rank VARCHAR2(200);
   h_source_parent_id VARCHAR2(32);
   h_parent_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_parent_rec_status VARCHAR2(1);
   h_level_id PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TMP_DEL_CLN_DOC IS
         SELECT PARENT_RANK, PARENT_ID, LEVEL_ID
         FROM PMO_TMP_DEL_CLN_DOC
         WHERE RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_STATUS_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_STATUS_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_STATUS_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_STATUS_CLN_DOC(37) : doc_func.sql(18162) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID, RANK INTO h_parent_id, h_rank
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(50) : doc_func.sql(18175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'U' Then
      BEGIN
         SELECT REC_STATUS INTO h_parent_rec_status
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(66) : doc_func.sql(18191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_parent_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(73) : doc_func.sql(18198) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_RESTORE_IF_PARENT_IS_DE;
      End If;
      
      h_doc_count := 1;
   Else
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(90) : doc_func.sql(18215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(97) : doc_func.sql(18222) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_DELETE_IF_LOCKED;
      End If;
      
      h_doc_count := -1;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_CLN_DOC';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_DEL_CLN_DOC
         SELECT LEVEL_ID, RANK, ELEMENT_ID, PARENT_ID, PARENT_RANK, REC_STATUS FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_rank,1,LENGTH(h_rank) - 4) || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(124) : doc_func.sql(18249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         BEGIN
            DELETE FROM PMO_TMP_DEL_DOC
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(143) : doc_func.sql(18268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
   	End If; 
   END;
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS SET
         REC_STATUS = h_rec_status,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 181+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(182) : doc_func.sql(18307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS SET
         REC_STATUS = CASE WHEN h_parent_rec_status = 'L' THEN 'L' ELSE h_rec_status END,
         CHILD_COUNT = CHILD_COUNT + DELETED_COUNT,
         DELETED_COUNT = 0,
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 204+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(205) : doc_func.sql(18330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS SET
      CHILD_COUNT = CHILD_COUNT + h_doc_count,
      DELETED_COUNT = DELETED_COUNT - h_doc_count
      WHERE ELEMENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(225) : doc_func.sql(18350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_DOC Then
      OPEN C_TMP_DEL_CLN_DOC;
      
      LOOP
         FETCH C_TMP_DEL_CLN_DOC INTO h_source_parent_rank,h_source_parent_id, h_level_id;
         IF C_TMP_DEL_CLN_DOC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT PARENT_RANK INTO h_parent_rank
            FROM PMO_TMP_DEL_CLN_DOC
            WHERE ELEMENT_ID = h_source_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(254) : doc_func.sql(18379) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --if first level of element(wbs/cri) update doc_count
         If (Coalesce(h_level_id, 0) = 2) OR (PMO_ORASTD.strcmp(h_source_parent_rank
               , h_parent_rank) <> PMO_CNST.SC_MATCH) Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 276+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(277) : doc_func.sql(18402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = PMO_CNST.SC_MATCH Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + h_doc_count
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 295+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(296) : doc_func.sql(18421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT WBS_ID, ELEMENT_ID INTO h_wbs_id, h_source_id FROM TMT_CRI
                  WHERE RANK = SUBSTR(h_source_parent_rank,5);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 309+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(310) : doc_func.sql(18435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_ORASTD.strcmp(h_wbs_id, h_source_id) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + h_doc_count
                     WHERE ELEMENT_ID = h_wbs_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 329+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(330) : doc_func.sql(18455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TMP_DEL_CLN_DOC ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_STATUS_CLN_DOC', 346+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_STATUS_CLN_DOC(347) : doc_func.sql(18472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 353+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(354) : doc_func.sql(18479) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_STATUS_CLN_DOC', 357+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_STATUS_CLN_DOC(358) : doc_func.sql(18483) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_STATUS_CLN_DOC;
ALTER FUNCTION FC_CHANGE_STATUS_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_DOC(28) : doc_func.sql(18519) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(44) : doc_func.sql(18535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(52) : doc_func.sql(18543) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(59) : doc_func.sql(18550) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(74) : doc_func.sql(18565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(81) : doc_func.sql(18572) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(115) : doc_func.sql(18606) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(130) : doc_func.sql(18621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(137) : doc_func.sql(18628) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(172) : doc_func.sql(18663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_DOC', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_DOC(193) : doc_func.sql(18684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_DOC', 200+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_DOC(201) : doc_func.sql(18692) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_DOC;
ALTER FUNCTION FC_LOCK_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_RES_DOC(28) : doc_func.sql(18728) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(44) : doc_func.sql(18744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(52) : doc_func.sql(18752) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(59) : doc_func.sql(18759) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(74) : doc_func.sql(18774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(81) : doc_func.sql(18781) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(115) : doc_func.sql(18815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(130) : doc_func.sql(18830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(137) : doc_func.sql(18837) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(172) : doc_func.sql(18872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_RES_DOC', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_RES_DOC(193) : doc_func.sql(18893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_RES_DOC', 200+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_RES_DOC(201) : doc_func.sql(18901) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_RES_DOC;
ALTER FUNCTION FC_LOCK_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_POL_DOC(28) : doc_func.sql(18937) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(44) : doc_func.sql(18953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(52) : doc_func.sql(18961) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(59) : doc_func.sql(18968) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(74) : doc_func.sql(18983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(81) : doc_func.sql(18990) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(115) : doc_func.sql(19024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(130) : doc_func.sql(19039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(137) : doc_func.sql(19046) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(172) : doc_func.sql(19081) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_POL_DOC', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_POL_DOC(193) : doc_func.sql(19102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_POL_DOC', 200+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_POL_DOC(201) : doc_func.sql(19110) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_POL_DOC;
ALTER FUNCTION FC_LOCK_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_AST_DOC(28) : doc_func.sql(19146) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(44) : doc_func.sql(19162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(52) : doc_func.sql(19170) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(59) : doc_func.sql(19177) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(74) : doc_func.sql(19192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(81) : doc_func.sql(19199) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(115) : doc_func.sql(19233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(130) : doc_func.sql(19248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(137) : doc_func.sql(19255) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(172) : doc_func.sql(19290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_AST_DOC', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_AST_DOC(193) : doc_func.sql(19311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_AST_DOC', 200+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_AST_DOC(201) : doc_func.sql(19319) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_AST_DOC;
ALTER FUNCTION FC_LOCK_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_VDR_DOC(28) : doc_func.sql(19355) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(44) : doc_func.sql(19371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(52) : doc_func.sql(19379) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(59) : doc_func.sql(19386) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(74) : doc_func.sql(19401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(81) : doc_func.sql(19408) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(115) : doc_func.sql(19442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(130) : doc_func.sql(19457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(137) : doc_func.sql(19464) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(172) : doc_func.sql(19499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_VDR_DOC', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_VDR_DOC(193) : doc_func.sql(19520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_VDR_DOC', 200+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_VDR_DOC(201) : doc_func.sql(19528) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_VDR_DOC;
ALTER FUNCTION FC_LOCK_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_LOCK_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_LOCK_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , sh_h_active PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_active PLS_INTEGER := sh_h_active;
   h_parent_id VARCHAR2(32);
   h_prev_rec_status VARCHAR2(1);
   h_prev_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_CLN_DOC(28) : doc_func.sql(19564) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, REC_STATUS, PARENT_ID, REC_USER
      INTO h_rank, h_prev_rec_status, h_parent_id, h_prev_rec_user
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(44) : doc_func.sql(19580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      If PMO_ORASTD.strcmp(h_rec_status, h_prev_rec_status) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 51+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(52) : doc_func.sql(19588) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_ALLREADY_LOCKED;
      End If;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 58+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(59) : doc_func.sql(19595) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_DELETED;
      End If;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'O';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(74) : doc_func.sql(19610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 80+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(81) : doc_func.sql(19617) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_LOCK_IF_CHECKOUT;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET REC_STATUS = h_rec_status,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS NOT IN ('D','L');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(115) : doc_func.sql(19651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_prev_rec_status
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(130) : doc_func.sql(19666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_prev_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(137) : doc_func.sql(19673) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_IS_LOCKED;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      If Coalesce(h_active, 0) = 1 Then
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(172) : doc_func.sql(19708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET REC_STATUS = h_rec_status,
            REC_DATETIME = SYSTIMESTAMP,
            REC_USER = h_rec_user
            WHERE RANK LIKE h_rank || '%' AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_CLN_DOC', 192+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_CLN_DOC(193) : doc_func.sql(19729) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_CLN_DOC', 200+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_CLN_DOC(201) : doc_func.sql(19737) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_CLN_DOC;
ALTER FUNCTION FC_LOCK_CLN_DOC COMPILE DEBUG;

