Prompt == FUNCTION FC_U_ATTACHMENT_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_DOC(24) : doc_move_func.sql(25) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_DOC(28) : doc_move_func.sql(29) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_DOC(32) : doc_move_func.sql(33) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_RES_DOC(24) : doc_move_func.sql(65) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_RES_DOC(28) : doc_move_func.sql(69) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_RES_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_RES_DOC(32) : doc_move_func.sql(73) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_RES_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_POL_DOC(24) : doc_move_func.sql(105) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_POL_DOC(28) : doc_move_func.sql(109) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_POL_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_POL_DOC(32) : doc_move_func.sql(113) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_POL_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_AST_DOC(24) : doc_move_func.sql(145) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_AST_DOC(28) : doc_move_func.sql(149) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_AST_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_AST_DOC(32) : doc_move_func.sql(153) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_AST_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_VDR_DOC(24) : doc_move_func.sql(185) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_VDR_DOC(28) : doc_move_func.sql(189) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_VDR_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_VDR_DOC(32) : doc_move_func.sql(193) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_VDR_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_ATTACHMENT_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_ATTACHMENT_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , sh_h_len PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_len PLS_INTEGER := sh_h_len;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_ATTACHMENT_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_ATTACHMENT_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_ATTACHMENT_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_len), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_ATTACHMENT_CLN_DOC(24) : doc_move_func.sql(225) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 27+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CLN_DOC(28) : doc_move_func.sql(229) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_ATTACHMENT_CLN_DOC', 31+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_ATTACHMENT_CLN_DOC(32) : doc_move_func.sql(233) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_ATTACHMENT_CLN_DOC;
ALTER FUNCTION FC_U_ATTACHMENT_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_DOC(31) : doc_move_func.sql(272) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(47) : doc_move_func.sql(288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(67) : doc_move_func.sql(308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(89) : doc_move_func.sql(330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(108) : doc_move_func.sql(349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(132) : doc_move_func.sql(373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(151) : doc_move_func.sql(392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(174) : doc_move_func.sql(415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(193) : doc_move_func.sql(434) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(219) : doc_move_func.sql(460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_DOC(238) : doc_move_func.sql(479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_DOC(248) : doc_move_func.sql(489) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_DOC(252) : doc_move_func.sql(493) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_RES_DOC(31) : doc_move_func.sql(532) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(47) : doc_move_func.sql(548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(67) : doc_move_func.sql(568) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(89) : doc_move_func.sql(590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(108) : doc_move_func.sql(609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(132) : doc_move_func.sql(633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(151) : doc_move_func.sql(652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(174) : doc_move_func.sql(675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(193) : doc_move_func.sql(694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(219) : doc_move_func.sql(720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_RES_DOC(238) : doc_move_func.sql(739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_RES_DOC(248) : doc_move_func.sql(749) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_RES_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_RES_DOC(252) : doc_move_func.sql(753) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_POL_DOC(31) : doc_move_func.sql(792) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(47) : doc_move_func.sql(808) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(67) : doc_move_func.sql(828) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(89) : doc_move_func.sql(850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(108) : doc_move_func.sql(869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(132) : doc_move_func.sql(893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(151) : doc_move_func.sql(912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(174) : doc_move_func.sql(935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(193) : doc_move_func.sql(954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(219) : doc_move_func.sql(980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_POL_DOC(238) : doc_move_func.sql(999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_POL_DOC(248) : doc_move_func.sql(1009) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_POL_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_POL_DOC(252) : doc_move_func.sql(1013) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_AST_DOC(31) : doc_move_func.sql(1052) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(47) : doc_move_func.sql(1068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(67) : doc_move_func.sql(1088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(89) : doc_move_func.sql(1110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(108) : doc_move_func.sql(1129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(132) : doc_move_func.sql(1153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(151) : doc_move_func.sql(1172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(174) : doc_move_func.sql(1195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(193) : doc_move_func.sql(1214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(219) : doc_move_func.sql(1240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_AST_DOC(238) : doc_move_func.sql(1259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_AST_DOC(248) : doc_move_func.sql(1269) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_AST_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_AST_DOC(252) : doc_move_func.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_VDR_DOC(31) : doc_move_func.sql(1312) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(47) : doc_move_func.sql(1328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(67) : doc_move_func.sql(1348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(89) : doc_move_func.sql(1370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(108) : doc_move_func.sql(1389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(132) : doc_move_func.sql(1413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(151) : doc_move_func.sql(1432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(174) : doc_move_func.sql(1455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(193) : doc_move_func.sql(1474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(219) : doc_move_func.sql(1500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_VDR_DOC(238) : doc_move_func.sql(1519) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_VDR_DOC(248) : doc_move_func.sql(1529) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_VDR_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_VDR_DOC(252) : doc_move_func.sql(1533) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC
(
     sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_parent_rank IN OUT NOCOPY VARCHAR2
   , h_source_parent_rank IN OUT NOCOPY VARCHAR2
   , h_target_parent_id IN OUT NOCOPY VARCHAR2
   , h_source_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_source_parent_parent_rank VARCHAR2(200);
   h_new_target_parent_rank VARCHAR2(200);
   h_new_target_level PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PARENT_AFTER_MOVE_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PARENT_AFTER_MOVE_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PARENT_AFTER_MOVE_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_parent_rank || ''''
          || ', ' || '''' || h_source_parent_rank || ''''
          || ', ' || '''' || h_target_parent_id || ''''
          || ', ' || '''' || h_source_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PARENT_AFTER_MOVE_CLN_DOC(31) : doc_move_func.sql(1572) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_bitflag, 0) = 1 Then
      h_new_target_level := Coalesce(h_target_level, 0) - 1;
      
      BEGIN
         SELECT PARENT_RANK INTO h_new_target_parent_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_target_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 46+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(47) : doc_move_func.sql(1588) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_new_target_parent_rank := h_target_parent_rank;
      h_new_target_level := h_target_level;
   End If;
   
   If Coalesce(h_source_level, 0) > 2 Then
      BEGIN
         SELECT PARENT_RANK INTO h_source_parent_parent_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE ELEMENT_ID = h_source_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 66+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(67) : doc_move_func.sql(1608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_new_target_level, 0) = 1 Then
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 88+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(89) : doc_move_func.sql(1630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT + 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 107+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(108) : doc_move_func.sql(1649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         If PMO_ORASTD.strcmp(h_source_parent_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) <> 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 131+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(132) : doc_move_func.sql(1673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT + 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 150+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(151) : doc_move_func.sql(1692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
               If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 173+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(174) : doc_move_func.sql(1715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
                  BEGIN
                     UPDATE TMT_CRI
                     SET DOC_COUNT = DOC_COUNT - 1
                     WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 192+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(193) : doc_move_func.sql(1734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   Else
      If Coalesce(h_new_target_level, 0) > 1 Then
         If PMO_ORASTD.strcmp(h_new_target_parent_rank, h_source_parent_rank) = 0 Then
            If PMO_ORASTD.strncmp(h_source_parent_rank, 'WBS', 3) = 0 Then
               BEGIN
                  UPDATE TMT_WBS
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 218+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(219) : doc_move_func.sql(1760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_source_parent_rank, 'CRI', 3) = 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET DOC_COUNT = DOC_COUNT - 1
                  WHERE RANK  = SUBSTR(h_source_parent_rank, 5, LENGTH(h_source_parent_rank)-4);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PARENT_AFTER_MOVE_CLN_DOC(238) : doc_move_func.sql(1779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 247+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CLN_DOC(248) : doc_move_func.sql(1789) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PARENT_AFTER_MOVE_CLN_DOC', 251+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PARENT_AFTER_MOVE_CLN_DOC(252) : doc_move_func.sql(1793) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC;
ALTER FUNCTION FC_U_PARENT_AFTER_MOVE_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_DOC IS
         SELECT RANK
         FROM TMT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_DOC(36) : doc_move_func.sql(1837) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(50) : doc_move_func.sql(1851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_DOC INTO h_cur_rank;
      IF MVUP_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                         , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(104) : doc_move_func.sql(1905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(119) : doc_move_func.sql(1920) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_DOC(152) : doc_move_func.sql(1953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_DOC(158) : doc_move_func.sql(1959) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_DOC(162) : doc_move_func.sql(1963) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_DOC;
ALTER FUNCTION FC_MOVE_UP_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_RES_DOC IS
         SELECT RANK
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_RES_DOC(36) : doc_move_func.sql(2007) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(50) : doc_move_func.sql(2021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_RES_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_RES_DOC INTO h_cur_rank;
      IF MVUP_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(104) : doc_move_func.sql(2075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(119) : doc_move_func.sql(2090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_RES_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_RES_DOC(152) : doc_move_func.sql(2123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_RES_DOC(158) : doc_move_func.sql(2129) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_RES_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_RES_DOC(162) : doc_move_func.sql(2133) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_RES_DOC;
ALTER FUNCTION FC_MOVE_UP_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_POL_DOC IS
         SELECT RANK
         FROM TMT_POOL_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_POL_DOC(36) : doc_move_func.sql(2177) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(50) : doc_move_func.sql(2191) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_POL_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_POL_DOC INTO h_cur_rank;
      IF MVUP_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(104) : doc_move_func.sql(2245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(119) : doc_move_func.sql(2260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_POL_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_POL_DOC(152) : doc_move_func.sql(2293) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_POL_DOC(158) : doc_move_func.sql(2299) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_POL_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_POL_DOC(162) : doc_move_func.sql(2303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_POL_DOC;
ALTER FUNCTION FC_MOVE_UP_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_AST_DOC IS
         SELECT RANK
         FROM TMT_ASSET_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_AST_DOC(36) : doc_move_func.sql(2347) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(50) : doc_move_func.sql(2361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_AST_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_AST_DOC INTO h_cur_rank;
      IF MVUP_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(104) : doc_move_func.sql(2415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(119) : doc_move_func.sql(2430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_AST_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_AST_DOC(152) : doc_move_func.sql(2463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_AST_DOC(158) : doc_move_func.sql(2469) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_AST_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_AST_DOC(162) : doc_move_func.sql(2473) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_AST_DOC;
ALTER FUNCTION FC_MOVE_UP_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_VDR_DOC IS
         SELECT RANK
         FROM TMT_VENDOR_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_VDR_DOC(36) : doc_move_func.sql(2517) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(50) : doc_move_func.sql(2531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_VDR_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_VDR_DOC INTO h_cur_rank;
      IF MVUP_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(104) : doc_move_func.sql(2585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(119) : doc_move_func.sql(2600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_VDR_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_VDR_DOC(152) : doc_move_func.sql(2633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_VDR_DOC(158) : doc_move_func.sql(2639) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_VDR_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_VDR_DOC(162) : doc_move_func.sql(2643) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_VDR_DOC;
ALTER FUNCTION FC_MOVE_UP_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_UP_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_UP_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVUP_CLN_DOC IS
         SELECT RANK
         FROM TMT_CLIENT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_target_rank AND h_source_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_UP_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_UP_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_UP_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_UP_CLN_DOC(36) : doc_move_func.sql(2687) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(50) : doc_move_func.sql(2701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVUP_CLN_DOC;
   
   h_next_rank := h_source_rank;
   
   LOOP
      FETCH MVUP_CLN_DOC INTO h_cur_rank;
      IF MVUP_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_cur_rank
                                             , h_next_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_next_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_next_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_next_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET RANK =
         CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_cur_rank)
          || h_extend_rank
         ELSE RTRIM(h_cur_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank)  AND RANK LIKE h_next_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(104) : doc_move_func.sql(2755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVUP_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(119) : doc_move_func.sql(2770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank, 1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_UP_CLN_DOC', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_UP_CLN_DOC(152) : doc_move_func.sql(2803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CLN_DOC(158) : doc_move_func.sql(2809) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_UP_CLN_DOC', 161+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_UP_CLN_DOC(162) : doc_move_func.sql(2813) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_UP_CLN_DOC;
ALTER FUNCTION FC_MOVE_UP_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_DOC IS
         SELECT RANK
         FROM TMT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_DOC(36) : doc_move_func.sql(2857) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(50) : doc_move_func.sql(2871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_DOC INTO h_cur_rank;
      IF MVDOWN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                         , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(102) : doc_move_func.sql(2923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(117) : doc_move_func.sql(2938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_DOC(150) : doc_move_func.sql(2971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_DOC(156) : doc_move_func.sql(2977) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_DOC(160) : doc_move_func.sql(2981) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_DOC;
ALTER FUNCTION FC_MOVE_DOWN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_RES_DOC IS
         SELECT RANK
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_RES_DOC(36) : doc_move_func.sql(3025) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(50) : doc_move_func.sql(3039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_RES_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_RES_DOC INTO h_cur_rank;
      IF MVDOWN_RES_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(102) : doc_move_func.sql(3091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_RES_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(117) : doc_move_func.sql(3106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_RES_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_RES_DOC(150) : doc_move_func.sql(3139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_RES_DOC(156) : doc_move_func.sql(3145) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_RES_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_RES_DOC(160) : doc_move_func.sql(3149) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_RES_DOC;
ALTER FUNCTION FC_MOVE_DOWN_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_POL_DOC IS
         SELECT RANK
         FROM TMT_POOL_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_POL_DOC(36) : doc_move_func.sql(3193) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(50) : doc_move_func.sql(3207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_POL_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_POL_DOC INTO h_cur_rank;
      IF MVDOWN_POL_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(102) : doc_move_func.sql(3259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_POL_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(117) : doc_move_func.sql(3274) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_POL_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_POL_DOC(150) : doc_move_func.sql(3307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_POL_DOC(156) : doc_move_func.sql(3313) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_POL_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_POL_DOC(160) : doc_move_func.sql(3317) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_POL_DOC;
ALTER FUNCTION FC_MOVE_DOWN_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_AST_DOC IS
         SELECT RANK
         FROM TMT_ASSET_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_AST_DOC(36) : doc_move_func.sql(3361) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(50) : doc_move_func.sql(3375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_AST_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_AST_DOC INTO h_cur_rank;
      IF MVDOWN_AST_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(102) : doc_move_func.sql(3427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_AST_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(117) : doc_move_func.sql(3442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_AST_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_AST_DOC(150) : doc_move_func.sql(3475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_AST_DOC(156) : doc_move_func.sql(3481) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_AST_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_AST_DOC(160) : doc_move_func.sql(3485) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_AST_DOC;
ALTER FUNCTION FC_MOVE_DOWN_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_VDR_DOC IS
         SELECT RANK
         FROM TMT_VENDOR_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_VDR_DOC(36) : doc_move_func.sql(3529) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(50) : doc_move_func.sql(3543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_VDR_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_VDR_DOC INTO h_cur_rank;
      IF MVDOWN_VDR_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(102) : doc_move_func.sql(3595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_VDR_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(117) : doc_move_func.sql(3610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_VDR_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_VDR_DOC(150) : doc_move_func.sql(3643) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_VDR_DOC(156) : doc_move_func.sql(3649) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_VDR_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_VDR_DOC(160) : doc_move_func.sql(3653) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_VDR_DOC;
ALTER FUNCTION FC_MOVE_DOWN_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_DOWN_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_DOWN_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR MVDOWN_CLN_DOC IS
         SELECT RANK
         FROM TMT_CLIENT_DOCUMENTS
         WHERE LEVEL_ID = h_target_level
         AND RANK BETWEEN h_source_rank AND h_target_rank
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_DOWN_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_DOWN_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_DOWN_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_DOWN_CLN_DOC(36) : doc_move_func.sql(3697) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   BEGIN
      SELECT '/' || SUBSTR(TO_CHAR(SYSTIMESTAMP), 21, 3) INTO h_extend_rank
      FROM DUAL
      WHERE 1 = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(50) : doc_move_func.sql(3711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN MVDOWN_CLN_DOC;
   
   h_next_rank := h_target_rank;
   LOOP
      FETCH MVDOWN_CLN_DOC INTO h_cur_rank;
      IF MVDOWN_CLN_DOC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_next_rank
                                             , h_cur_rank, h_len, h_rec_user);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_cur_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_cur_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET RANK = CASE WHEN LENGTH(RANK) = h_len THEN RTRIM(h_next_rank)
          || h_extend_rank
         ELSE RTRIM(h_next_rank)
          || SUBSTR(RANK, h_len +1, LENGTH(RANK)-h_len) || h_extend_rank END
         WHERE (SUBSTR(RANK, LENGTH(RANK)- 3, 4 ) <> h_extend_rank) AND RANK LIKE h_cur_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(102) : doc_move_func.sql(3763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_next_rank := h_cur_rank;
   END LOOP;
   BEGIN
      CLOSE MVDOWN_CLN_DOC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(117) : doc_move_func.sql(3778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET RANK = SUBSTR(RANK, 1, LENGTH(RANK) - 4)
      WHERE RANK LIKE SUBSTR(h_target_rank,1, LENGTH(h_target_rank) -4) || '%'
      AND SUBSTR(RANK, LENGTH(RANK) - 3, 4) = h_extend_rank;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_DOWN_CLN_DOC', 149+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_DOWN_CLN_DOC(150) : doc_move_func.sql(3811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 155+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CLN_DOC(156) : doc_move_func.sql(3817) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_DOWN_CLN_DOC', 159+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_DOWN_CLN_DOC(160) : doc_move_func.sql(3821) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_DOWN_CLN_DOC;
ALTER FUNCTION FC_MOVE_DOWN_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_DOC(46) : doc_move_func.sql(3875) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(107) : doc_move_func.sql(3936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(127) : doc_move_func.sql(3956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(142) : doc_move_func.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = CASE WHEN T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(193) : doc_move_func.sql(4022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                         , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = CASE WHEN REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_DOC(224) : doc_move_func.sql(4053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_DOC(231) : doc_move_func.sql(4060) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_DOC', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_DOC(235) : doc_move_func.sql(4064) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_DOC;
ALTER FUNCTION FC_MOVE_APPEND_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_RES_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_RES_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_RES_DOC(46) : doc_move_func.sql(4118) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(107) : doc_move_func.sql(4179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_RESOURCE_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(127) : doc_move_func.sql(4199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(142) : doc_move_func.sql(4214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = CASE WHEN T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(193) : doc_move_func.sql(4265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_RES_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = CASE WHEN REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_RES_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_RES_DOC(224) : doc_move_func.sql(4296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_RES_DOC(231) : doc_move_func.sql(4303) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_RES_DOC', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_RES_DOC(235) : doc_move_func.sql(4307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_RES_DOC;
ALTER FUNCTION FC_MOVE_APPEND_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_POL_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_POL_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_POL_DOC(46) : doc_move_func.sql(4361) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(107) : doc_move_func.sql(4422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_POOL_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(127) : doc_move_func.sql(4442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(142) : doc_move_func.sql(4457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(193) : doc_move_func.sql(4508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_POL_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_POL_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_POL_DOC(224) : doc_move_func.sql(4539) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_POL_DOC(231) : doc_move_func.sql(4546) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_POL_DOC', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_POL_DOC(235) : doc_move_func.sql(4550) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_POL_DOC;
ALTER FUNCTION FC_MOVE_APPEND_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_AST_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_AST_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_AST_DOC(46) : doc_move_func.sql(4604) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(107) : doc_move_func.sql(4665) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_ASSET_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(127) : doc_move_func.sql(4685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(142) : doc_move_func.sql(4700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(193) : doc_move_func.sql(4751) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_AST_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_AST_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_AST_DOC(224) : doc_move_func.sql(4782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_AST_DOC(231) : doc_move_func.sql(4789) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_AST_DOC', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_AST_DOC(235) : doc_move_func.sql(4793) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_AST_DOC;
ALTER FUNCTION FC_MOVE_APPEND_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_VDR_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_VDR_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_VDR_DOC(46) : doc_move_func.sql(4847) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(107) : doc_move_func.sql(4908) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_VENDOR_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(127) : doc_move_func.sql(4928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(142) : doc_move_func.sql(4943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(193) : doc_move_func.sql(4994) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_VDR_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_VDR_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_VDR_DOC(224) : doc_move_func.sql(5025) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_VDR_DOC(231) : doc_move_func.sql(5032) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_VDR_DOC', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_VDR_DOC(235) : doc_move_func.sql(5036) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_VDR_DOC;
ALTER FUNCTION FC_MOVE_APPEND_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_MOVE_APPEND_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_MOVE_APPEND_CLN_DOC
(
     h_target_project_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_level PLS_INTEGER
   , sh_h_source_level PLS_INTEGER
   , h_target_rank IN OUT NOCOPY VARCHAR2
   , h_source_rank IN OUT NOCOPY VARCHAR2
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_target_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_target_level PLS_INTEGER := sh_h_target_level;
   h_source_level PLS_INTEGER := sh_h_source_level;
   h_target_type_id PLS_INTEGER := sh_h_target_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_cur_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_extend_rank VARCHAR2(200);
   h_len PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(200);
   h_temp_rank VARCHAR2(200);
   isAttribute PLS_INTEGER NOT NULL := 1;
   withDependencies PLS_INTEGER NOT NULL := 2;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_MOVE_APPEND_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_MOVE_APPEND_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_MOVE_APPEND_CLN_DOC(' || 
       '''' || h_target_project_id || ''''
          || ', ' || '''' || h_source_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_level), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_source_level), 'NULL')
          || ', ' || '''' || h_target_rank || ''''
          || ', ' || '''' || h_source_rank || ''''
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_target_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_MOVE_APPEND_CLN_DOC(46) : doc_move_func.sql(5090) : ' || SYSTIMESTAMP);
   END IF; 

   h_len := Coalesce(Length(h_source_rank), 0);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_target_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_target_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_target_rank, False); 
   	End If; 
   END;
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If (BITAND(Coalesce(h_bitflag, 0), withDependencies)) > 0 Then
      -- REMOVE EXTERNAL DEPENDENCIES
      BEGIN
         DELETE FROM CRIDEPENDENCIES
         WHERE (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_target_rank || '%'))
         OR (PRED_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND SUCC_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'))
         OR (SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%')
         AND PRED_ID NOT IN (SELECT ELEMENT_ID FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_source_rank || '%'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 106+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(107) : doc_move_func.sql(5151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_CLIENT_DOCUMENTS
      SET MAX_RANK = MAX_RANK + 1, CHILD_COUNT = CHILD_COUNT + 1
      WHERE ELEMENT_ID = h_target_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 126+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(127) : doc_move_func.sql(5171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MAX_RANK INTO h_max_rank
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(142) : doc_move_func.sql(5186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   -- update the level, rec_user, rec_datetime, rec_status, rank
   If (BITAND(Coalesce(h_bitflag, 0), isAttribute)) > 0 Then
      BEGIN
         UPDATE TMT_DOCUMENT_ATTRIBUTES T1
         SET T1.LEVEL_ID = T1.LEVEL_ID + (h_target_level - h_source_level) + 1,
         T1.REC_USER = case when T1.REC_STATUS = 'L' then T1.REC_USER else h_rec_user end,
         T1.REC_DATETIME = SYSTIMESTAMP,
         T1.REC_STATUS = 'U',
         T1.PARENT_ID = CASE WHEN T1.ELEMENT_ID = h_source_id THEN h_target_id
         ELSE T1.PARENT_ID END,
         T1.RANK = RTRIM(h_target_rank) || h_rankBase64 || CASE WHEN LENGTH(T1.RANK) = h_len THEN ''
         ELSE SUBSTR(T1.RANK, h_len +1, LENGTH(T1.RANK)-h_len) END,
         T1.TYPE_ID = CASE WHEN T1.TYPE_ID IN (15, 144) THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN 15 ELSE 144 END)
         ELSE T1.TYPE_ID END,
         T1.MULTI_SELECT = CASE WHEN T1.TYPE_ID IN (15, 144)
         THEN (CASE WHEN (SELECT T2.TYPE_ID
         FROM TMT_DOCUMENT_ATTRIBUTES T2
         WHERE T2.ELEMENT_ID = T1.PARENT_ID) = 55 THEN '0' ELSE '1' END)
         ELSE T1.MULTI_SELECT END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 192+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(193) : doc_move_func.sql(5237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_temp_rank := h_target_rank;
      h_temp_rank := SubStr(h_temp_rank || h_rankBase64, 1, 200);
      h_rankBase64 := h_temp_rank;
      PMO_DB2M.SC_STATE := FC_U_ATTACHMENT_CLN_DOC(h_target_project_id, h_source_project_id, h_rankBase64
                                             , h_source_rank, h_len, h_rec_user);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET LEVEL_ID = LEVEL_ID + (h_target_level - h_source_level) + 1,
         REC_USER = case when REC_STATUS = 'L' then REC_USER else h_rec_user end,
         REC_DATETIME = SYSTIMESTAMP,
         PARENT_ID = CASE WHEN ELEMENT_ID = h_source_id THEN h_target_id
         ELSE PARENT_ID END,
         RANK = h_rankBase64 || CASE WHEN LENGTH(RANK) = h_len THEN ''
         ELSE SUBSTR(RANK, h_len+1, LENGTH(RANK)-h_len) END
         WHERE LENGTH(h_source_rank) > 7 AND RANK LIKE h_source_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_MOVE_APPEND_CLN_DOC', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_MOVE_APPEND_CLN_DOC(224) : doc_move_func.sql(5268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CLN_DOC(231) : doc_move_func.sql(5275) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_MOVE_APPEND_CLN_DOC', 234+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_MOVE_APPEND_CLN_DOC(235) : doc_move_func.sql(5279) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_MOVE_APPEND_CLN_DOC;
ALTER FUNCTION FC_MOVE_APPEND_CLN_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_source_stage_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_DOC(51) : doc_move_func.sql(5338) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(72) : doc_move_func.sql(5359) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 79+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(80) : doc_move_func.sql(5367) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(88) : doc_move_func.sql(5375) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   h_source_stage_id := 0;
   h_source_type_id := 0;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID, STAGE_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id, h_source_stage_id
      FROM TMT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(111) : doc_move_func.sql(5398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 118+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(119) : doc_move_func.sql(5406) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If IsDOCSystemFolder(Coalesce(h_source_type_id, 0), Coalesce(h_source_stage_id, 0)) = 1 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 125+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(126) : doc_move_func.sql(5413) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_MOVE_SYSTEM_FOLDER;
   End If;
   
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 135+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(136) : doc_move_func.sql(5423) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 143+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(144) : doc_move_func.sql(5431) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_source_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_source_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_source_rank, False); 
   	End If; 
   END;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 175+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(176) : doc_move_func.sql(5463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 191+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(192) : doc_move_func.sql(5479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 209+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(210) : doc_move_func.sql(5497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(226) : doc_move_func.sql(5513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 233+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(234) : doc_move_func.sql(5521) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 249+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(250) : doc_move_func.sql(5537) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(268) : doc_move_func.sql(5555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 283+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(284) : doc_move_func.sql(5571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 291+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(292) : doc_move_func.sql(5579) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 305+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(306) : doc_move_func.sql(5593) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 312+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(313) : doc_move_func.sql(5600) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 325+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(326) : doc_move_func.sql(5613) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_DOC(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_DOC(h_project_id, h_source_project_id, h_target_level
                                      , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 354+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(355) : doc_move_func.sql(5642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank
                                        , h_target_parent_id, h_source_id, h_target_type_id
                                        , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_DOC(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
         
         BEGIN
            UPDATE TMT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 382+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(383) : doc_move_func.sql(5670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 399+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(400) : doc_move_func.sql(5687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 414+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(415) : doc_move_func.sql(5702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_DOC(h_project_id, h_source_project_id, h_target_level, h_target_rank
                                    , h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_source_level, h_target_rank, h_source_rank, h_target_id
                                        , h_source_id, h_target_type_id, h_rec_user, h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_DOC(h_target_level, h_source_level, h_target_parent_rank
                                                , h_source_parent_rank, h_target_parent_id
                                                , h_source_parent_id, h_bitflag);
      
      BEGIN
         UPDATE TMT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_DOC', 449+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_DOC(450) : doc_move_func.sql(5737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 460+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(461) : doc_move_func.sql(5748) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_DOC', 464+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_DOC(465) : doc_move_func.sql(5752) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_DOC;
ALTER FUNCTION FC_M_ATTACH_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_RES_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_RES_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_RES_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_RES_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_RES_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_RES_DOC(50) : doc_move_func.sql(5810) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(71) : doc_move_func.sql(5831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(79) : doc_move_func.sql(5839) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(87) : doc_move_func.sql(5847) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_RESOURCE_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(107) : doc_move_func.sql(5867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(115) : doc_move_func.sql(5875) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(124) : doc_move_func.sql(5884) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(132) : doc_move_func.sql(5892) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(151) : doc_move_func.sql(5911) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_RESOURCE_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(167) : doc_move_func.sql(5927) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(185) : doc_move_func.sql(5945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(201) : doc_move_func.sql(5961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(209) : doc_move_func.sql(5969) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(225) : doc_move_func.sql(5985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(243) : doc_move_func.sql(6003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_RESOURCE_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(259) : doc_move_func.sql(6019) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(267) : doc_move_func.sql(6027) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(281) : doc_move_func.sql(6041) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(288) : doc_move_func.sql(6048) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(301) : doc_move_func.sql(6061) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(330) : doc_move_func.sql(6090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_RES_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_RESOURCE_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(359) : doc_move_func.sql(6119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(376) : doc_move_func.sql(6136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_RESOURCE_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(391) : doc_move_func.sql(6151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_RES_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_RES_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_RESOURCE_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_RES_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_RES_DOC(428) : doc_move_func.sql(6188) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(439) : doc_move_func.sql(6199) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_RES_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_RES_DOC(443) : doc_move_func.sql(6203) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_RES_DOC;
ALTER FUNCTION FC_M_ATTACH_RES_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_POL_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_POL_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_POL_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_POL_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_POL_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_POL_DOC(50) : doc_move_func.sql(6261) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(71) : doc_move_func.sql(6282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(79) : doc_move_func.sql(6290) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(87) : doc_move_func.sql(6298) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_POOL_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(107) : doc_move_func.sql(6318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(115) : doc_move_func.sql(6326) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(124) : doc_move_func.sql(6335) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(132) : doc_move_func.sql(6343) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(151) : doc_move_func.sql(6362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_POOL_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(167) : doc_move_func.sql(6378) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(185) : doc_move_func.sql(6396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(201) : doc_move_func.sql(6412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(209) : doc_move_func.sql(6420) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_POOL_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(225) : doc_move_func.sql(6436) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_POOL_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(243) : doc_move_func.sql(6454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_POOL_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(259) : doc_move_func.sql(6470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(267) : doc_move_func.sql(6478) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(281) : doc_move_func.sql(6492) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(288) : doc_move_func.sql(6499) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(301) : doc_move_func.sql(6512) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(330) : doc_move_func.sql(6541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_POL_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_POOL_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(359) : doc_move_func.sql(6570) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(376) : doc_move_func.sql(6587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_POOL_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(391) : doc_move_func.sql(6602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_POL_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_POL_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_POOL_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_POL_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_POL_DOC(428) : doc_move_func.sql(6639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(439) : doc_move_func.sql(6650) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_POL_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_POL_DOC(443) : doc_move_func.sql(6654) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_POL_DOC;
ALTER FUNCTION FC_M_ATTACH_POL_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_AST_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_AST_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_AST_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_AST_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_AST_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_AST_DOC(50) : doc_move_func.sql(6712) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(71) : doc_move_func.sql(6733) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(79) : doc_move_func.sql(6741) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(87) : doc_move_func.sql(6749) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_ASSET_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(107) : doc_move_func.sql(6769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(115) : doc_move_func.sql(6777) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(124) : doc_move_func.sql(6786) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(132) : doc_move_func.sql(6794) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(151) : doc_move_func.sql(6813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_ASSET_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(167) : doc_move_func.sql(6829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(185) : doc_move_func.sql(6847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(201) : doc_move_func.sql(6863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(209) : doc_move_func.sql(6871) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_ASSET_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(225) : doc_move_func.sql(6887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_ASSET_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(243) : doc_move_func.sql(6905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_ASSET_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(259) : doc_move_func.sql(6921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(267) : doc_move_func.sql(6929) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(281) : doc_move_func.sql(6943) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(288) : doc_move_func.sql(6950) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(301) : doc_move_func.sql(6963) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(330) : doc_move_func.sql(6992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_AST_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_ASSET_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(359) : doc_move_func.sql(7021) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(376) : doc_move_func.sql(7038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_ASSET_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(391) : doc_move_func.sql(7053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_AST_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_AST_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_ASSET_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_AST_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_AST_DOC(428) : doc_move_func.sql(7090) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(439) : doc_move_func.sql(7101) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_AST_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_AST_DOC(443) : doc_move_func.sql(7105) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_AST_DOC;
ALTER FUNCTION FC_M_ATTACH_AST_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_VDR_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_VDR_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_VDR_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_VDR_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_VDR_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_VDR_DOC(50) : doc_move_func.sql(7163) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(71) : doc_move_func.sql(7184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(79) : doc_move_func.sql(7192) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(87) : doc_move_func.sql(7200) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_VENDOR_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(107) : doc_move_func.sql(7220) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(115) : doc_move_func.sql(7228) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(124) : doc_move_func.sql(7237) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(132) : doc_move_func.sql(7245) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(151) : doc_move_func.sql(7264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_VENDOR_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(167) : doc_move_func.sql(7280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(185) : doc_move_func.sql(7298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(201) : doc_move_func.sql(7314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(209) : doc_move_func.sql(7322) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_VENDOR_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(225) : doc_move_func.sql(7338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_VENDOR_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(243) : doc_move_func.sql(7356) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_VENDOR_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(259) : doc_move_func.sql(7372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(267) : doc_move_func.sql(7380) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(281) : doc_move_func.sql(7394) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(288) : doc_move_func.sql(7401) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(301) : doc_move_func.sql(7414) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(330) : doc_move_func.sql(7443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_VDR_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_VENDOR_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(359) : doc_move_func.sql(7472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(376) : doc_move_func.sql(7489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_VENDOR_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(391) : doc_move_func.sql(7504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_VDR_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_VDR_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_VENDOR_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_VDR_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_VDR_DOC(428) : doc_move_func.sql(7541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(439) : doc_move_func.sql(7552) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_VDR_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_VDR_DOC(443) : doc_move_func.sql(7556) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_VDR_DOC;
ALTER FUNCTION FC_M_ATTACH_VDR_DOC COMPILE DEBUG;

Prompt == FUNCTION FC_M_ATTACH_CLN_DOC ==
CREATE OR REPLACE FUNCTION FC_M_ATTACH_CLN_DOC
(
     sh_h_host_table PLS_INTEGER
   , h_target_id IN OUT NOCOPY VARCHAR2
   , h_source_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_source_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_target_level PLS_INTEGER := 0;
   h_source_level PLS_INTEGER := 0;
   h_len PLS_INTEGER := 0;
   h_target_rank VARCHAR2(200);
   h_source_rank VARCHAR2(200);
   h_target_parent_id VARCHAR2(32);
   h_source_parent_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_cur_date TIMESTAMP;
   h_max_rank PLS_INTEGER := 0;
   h_target_parent_rank VARCHAR2(200);
   h_source_parent_rank VARCHAR2(200);
   h_target_type_id PLS_INTEGER := 0;
   h_target_parent_type_id PLS_INTEGER := 0;
   h_source_type_id PLS_INTEGER := 0;
   h_extend_rank VARCHAR2(200);
   h_next_rank VARCHAR2(200);
   h_wbs_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   hasTransfer PLS_INTEGER NOT NULL := 4;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_M_ATTACH_CLN_DOC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_M_ATTACH_CLN_DOC'), '-- ' || SYSTIMESTAMP, ':r := FC_M_ATTACH_CLN_DOC(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_target_id || ''''
          || ', ' || '''' || h_source_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_source_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_M_ATTACH_CLN_DOC(50) : doc_move_func.sql(7614) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_element_id, SC_H_ID);
   
   h_target_rank := '';
   h_target_parent_id := '';
   h_source_parent_id := '';
   
   BEGIN
      SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID, BLOB_ID, PROJECT_ID
      INTO h_target_rank, h_target_level, h_target_parent_id,
      h_target_parent_rank, h_target_type_id, h_wbs_id, h_project_id
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_target_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(71) : doc_move_func.sql(7635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 78+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(79) : doc_move_func.sql(7643) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_target_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(87) : doc_move_func.sql(7651) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   BEGIN
      SELECT RANK, LENGTH(RANK), LEVEL_ID, PARENT_ID, TYPE_ID, PARENT_RANK,
      CASE WHEN LENGTH(RANK) < LENGTH(h_target_rank)
      THEN SUBSTR(h_target_rank, 1, LENGTH(RANK)) ELSE '' END,
      BLOB_ID
      INTO h_source_rank,h_len, h_source_level, h_source_parent_id,
      h_source_type_id, h_source_parent_rank, h_cur_rank, h_wbs_id
      FROM TMT_CLIENT_DOCUMENTS
      WHERE ELEMENT_ID = h_source_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(107) : doc_move_func.sql(7671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(115) : doc_move_func.sql(7679) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   End If;
   If PMO_ORASTD.strncmp(h_source_parent_rank, h_target_parent_rank
         , Coalesce(Length(h_target_parent_rank), 0)) <> PMO_CNST.SC_MATCH Then
      If NOT ((Coalesce(h_host_table, 0) = 0) AND (Coalesce(h_target_type_id, 0) = 145)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 123+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(124) : doc_move_func.sql(7688) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_ATTACHMENT_MOVE;
      End If;
   End If;
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) AND ((h_wbs_id IS NOT NULL)) Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 131+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(132) : doc_move_func.sql(7696) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CAN_NOT_MOVE_TRANSFERED_CRI;
   End If;
   
   If ((BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0) Then
      -- varify assigned and response deliverable and task
      BEGIN
         SELECT MIN(RANK) INTO h_current_rank
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE SUBSTR(h_source_rank, 1, 16) || '%'
         AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_source_rank, 1, 8) AND RANK <= h_source_rank) 
         AND SUBSTR(h_source_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_source_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(151) : doc_move_func.sql(7715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT COUNT(*) INTO h_count
         FROM TMT_CLIENT_DOCUMENTS
         WHERE RANK LIKE h_current_rank || '%'
         AND BLOB_ID IS NOT Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(167) : doc_move_func.sql(7731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         BEGIN
            SELECT MIN(RANK) INTO h_current_rank
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
            AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
            AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(185) : doc_move_func.sql(7749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(201) : doc_move_func.sql(7765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_element_id := h_source_id;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 208+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(209) : doc_move_func.sql(7773) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
         End If;
      Else
         BEGIN
            SELECT COUNT(*) INTO h_count
            FROM TMT_CLIENT_DOCUMENTS
            WHERE RANK LIKE h_current_rank || '%' AND BLOB_ID IS Null
            AND TYPE_ID IN (PMO_CNST.SC_CRI_DELIVERABLE, PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_SUMMARY_TASK);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 224+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(225) : doc_move_func.sql(7789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            BEGIN
               SELECT MIN(RANK) INTO h_current_rank
               FROM TMT_CLIENT_DOCUMENTS
               WHERE RANK LIKE SUBSTR(h_target_rank, 1, 16) || '%'
               AND TYPE_ID <> PMO_CNST.SC_FOLDER AND ((RANK >= SUBSTR(h_target_rank, 1, 8) AND RANK <= h_target_rank) 
               AND SUBSTR(h_target_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_target_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 242+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(243) : doc_move_func.sql(7807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(*) INTO h_count
               FROM TMT_CLIENT_DOCUMENTS
               WHERE RANK LIKE h_current_rank || '%'
               AND BLOB_ID IS NOT Null;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(259) : doc_move_func.sql(7823) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               h_element_id := h_source_id;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(267) : doc_move_func.sql(7831) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_MIX_ASSIGN_TRANSFER;
            End If;
         End If;
      End If;
      
      If (Coalesce(Length(h_source_rank), 0) > 16) AND (PMO_ORASTD.strcmp(h_target_parent_rank
            , h_source_parent_rank) <> PMO_CNST.SC_MATCH) AND ((Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_DELIVERABLE) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_TASK) OR (Coalesce(
            h_source_type_id, 0) = PMO_CNST.SC_CRI_SUMMARY_TASK)) Then
         h_element_id := h_source_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 280+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(281) : doc_move_func.sql(7845) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.DIFFERENT_PARENT_RANK;
      End If;
      If isTask(Coalesce(h_target_type_id, 0)) <> 0 AND (Coalesce(h_bitflag, 0) = 0) Then
         h_element_id := h_target_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 287+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(288) : doc_move_func.sql(7852) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      h_count := PMO_CNST.SC_SET_ALL_BITS;
   Else
      h_count := 0;
   End If;
   
   -- Is not allowed to move a parent under his child
   If PMO_ORASTD.strcmp(h_cur_rank, h_source_rank) = 0 Then
      h_element_id := h_source_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 300+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(301) : doc_move_func.sql(7865) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_COPY_PARENT_UNDER_CHILD;
   End If;
   
   --h_bitflag = 0, the target is the new parent for the source, copy the source as last child of the target
   --h_bitflag = 1, insert the source to the target position, new source's parent is the target's parent
   If Coalesce(h_bitflag, 0) = 1 Then
      -- target and source have the same parent
      If PMO_ORASTD.strcmp(h_target_parent_id, h_source_parent_id) = PMO_CNST.SC_MATCH Then
         If PMO_ORASTD.strcmp(h_source_rank, h_target_rank) > 0 Then
            PMO_DB2M.SC_STATE := FC_MOVE_UP_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         Else
            PMO_DB2M.SC_STATE := FC_MOVE_DOWN_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                          , h_target_rank, h_source_rank, h_rec_user);
         End If;
      Else
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_rank, h_target_type_id
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 329+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(330) : doc_move_func.sql(7894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_parent_id, h_source_id, h_target_type_id
                                            , h_rec_user, h_host_table);
         
         PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CLN_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
         
         BEGIN
            UPDATE TMT_CLIENT_DOCUMENTS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
            WHERE ELEMENT_ID = h_source_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 358+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(359) : doc_move_func.sql(7923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK, LEVEL_ID, PARENT_ID, PARENT_RANK, TYPE_ID
            INTO h_target_rank, h_target_level, h_target_parent_id,
            h_target_parent_rank, h_target_type_id
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 375+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(376) : doc_move_func.sql(7940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT RANK INTO h_source_rank
            FROM TMT_CLIENT_DOCUMENTS
            WHERE ELEMENT_ID = h_source_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 390+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(391) : doc_move_func.sql(7955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_MOVE_UP_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                        , h_target_rank, h_source_rank, h_rec_user);
         
         If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
            PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         End If;
      End If;
   Else
      PMO_DB2M.SC_STATE := FC_MOVE_APPEND_CLN_DOC(h_project_id, h_source_project_id, h_target_level
                                            , h_source_level, h_target_rank, h_source_rank
                                            , h_target_id, h_source_id, h_target_type_id, h_rec_user
                                            , h_host_table);
      
      PMO_DB2M.SC_STATE := FC_U_PARENT_AFTER_MOVE_CLN_DOC(h_target_level, h_source_level
                                                    , h_target_parent_rank, h_source_parent_rank
                                                    , h_target_parent_id, h_source_parent_id
                                                    , h_bitflag);
      
      BEGIN
         UPDATE TMT_CLIENT_DOCUMENTS
         SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + h_count
         WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_M_ATTACH_CLN_DOC', 427+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_M_ATTACH_CLN_DOC(428) : doc_move_func.sql(7992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (BITAND(Coalesce(h_host_table, 0), hasTransfer)) > 0 Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(439) : doc_move_func.sql(8003) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_M_ATTACH_CLN_DOC', 442+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_M_ATTACH_CLN_DOC(443) : doc_move_func.sql(8007) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_M_ATTACH_CLN_DOC;
ALTER FUNCTION FC_M_ATTACH_CLN_DOC COMPILE DEBUG;

