-- Planned work -> menas -> proposed work

-- sched work -> means -> planned work

-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

--SC_SQL_API SP_PVT_DEMAND_SUPPLY

Prompt == FUNCTION SP_RESOURCE_PIVOT ==
CREATE OR REPLACE FUNCTION SP_RESOURCE_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPDS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RESOURCE_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RESOURCE_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_RESOURCE_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RESOURCE_PIVOT(32) : pivots.sql(43) : ' || SYSTIMESTAMP);
   END IF; 

   --PMO_BEGIN_FUNCTION(SP_PVT_DEMAND_SUPPLY);
   
   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_RESOURCE_PIVOT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_RESOURCE_PIVOT(39) : pivots.sql(50) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_RESOURCE_PIVOT(42) : pivots.sql(53) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROFILES(h_init_type, h_ids, h_start_date, h_finish_date
                                          , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_PRF;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   If (h_finish_date IS NULL) Then
      BEGIN
         SELECT TO_DATE(SYSDATE), MAX(COALESCE(TO_DATE(SubStr(FINISH_DT, 1, 10)),TO_DATE(SYSDATE)))
         INTO h_start_date, h_finish_date
         FROM PMO_PVT_ASSIGNMENTS;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT', 81+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT(82) : pivots.sql(93) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_COMPET;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPDS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   0 AS RESOURCE_WORK_LOCATION,
   0 AS RESOURCE_STATUS1,
   0 AS RESOURCE_STATUS2,
   R.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.PROFILE_NAME AS DEFAULT_NAME__T,
   R.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   R.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_PROFILES R
   ON R.PROFILE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   2 AS TYPE_ID,
   R.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
   R.STATUS1_ID AS RESOURCE_STATUS1,
   R.STATUS2_ID AS RESOURCE_STATUS2,
   C.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.FULL_NAME AS DEFAULT_NAME__T,
   C.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   C.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROF_RES_IDS C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   LEFT JOIN (	PMO_PVT_PROJECTS P
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID )
   ON P.ELEMENT_ID = M.PROJECT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_RESOURCE_PIVOT(198) : pivots.sql(209) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPDS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT', 205+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT(206) : pivots.sql(217) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT', 217+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT(218) : pivots.sql(229) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RESOURCE_PIVOT;
ALTER FUNCTION SP_RESOURCE_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL ==
CREATE OR REPLACE FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPDSL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_DEMAND_SUPPLY_LEVEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_DEMAND_SUPPLY_LEVEL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_DEMAND_SUPPLY_LEVEL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_DEMAND_SUPPLY_LEVEL(32) : pivots.sql(277) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_DEMAND_SUPPLY_LEVEL(37) : pivots.sql(282) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_DEMAND_SUPPLY_LEVEL(40) : pivots.sql(285) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROFILES(h_init_type, h_ids, h_start_date, h_finish_date
                                          , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_PRF;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   If (h_finish_date IS NULL) Then
      BEGIN
         SELECT TO_DATE(SYSDATE), MAX(COALESCE(TO_DATE(SubStr(FINISH_DT, 1, 10)),TO_DATE(SYSDATE)))
         INTO h_start_date, h_finish_date
         FROM PMO_PVT_ASSIGNMENTS;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 79+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_DEMAND_SUPPLY_LEVEL(80) : pivots.sql(325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_COMPET;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_LEV_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPDSL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   0 AS RESOURCE_WORK_LOCATION,
   0 AS RESOURCE_STATUS1,
   0 AS RESOURCE_STATUS2,
   R.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.PROFILE_NAME AS DEFAULT_NAME__T,
   R.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   R.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_PROFILES R
   ON R.PROFILE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   2 AS TYPE_ID,
   R.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
   R.STATUS1_ID AS RESOURCE_STATUS1,
   R.STATUS2_ID AS RESOURCE_STATUS2,
   C.ROLE_ID AS DEFAULT0_ROLE_ID,
   R.FULL_NAME AS DEFAULT_NAME__T,
   C.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   C.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEOGRAPHY_NAME AS RESOURCE_GEO_NAME__T,
   R.ORGANIZATION_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER_NAME AS RESOURCE_POOL_MANAGER__T,
   P.ELEMENT_NAME AS RESOURCE_PROJECT__T,
   P.ELEMENT_ID AS PROJECT_ID,
   P.REF_CODE AS PROJECT_REF_NUMBER,
   P.CURRENCY_ID AS PROJECT_CURRENCY,
   P.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(P.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   P.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   P.MANAGER_NAME AS PROJECT_MANAGER,
   TO_CHAR(P.PRIORITY) AS STATUS_PRIORITY,
   P.STAGE_ID AS STATUS_STAGE,
   P.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN P.BASELINE1_EFFORT > 0 THEN ((P.WORK_TODATE*10000)/P.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   M.FISCAL_YEAR AS RESOURCE_YEAR_YY,
   (CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END) AS RESOURCE_QUARTER_QQ,
   M.FISCAL_MONTH AS RESOURCE_MONTH_MM,
   M.AVAILABLE_MIN/60 AS RESOURCE_CALENDAR_HOURS__D,
   M.PLANNED_MIN/60 AS RESOURCE_PLANNED_HOURS__D,
   M.SCHED_MIN/60 AS RESOURCE_SCHED_HOURS__D,
   ATTR.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PVT_UTILIZATION M
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   JOIN PMO_PVT_PROF_RES_IDS C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR ATTR
   ON ATTR.PROJECT_ID = P.ELEMENT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 195+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_DEMAND_SUPPLY_LEVEL(196) : pivots.sql(441) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPDSL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 203+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_DEMAND_SUPPLY_LEVEL(204) : pivots.sql(449) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_DEMAND_SUPPLY_LEVEL', 215+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_DEMAND_SUPPLY_LEVEL(216) : pivots.sql(461) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL;
ALTER FUNCTION SP_PVT_DEMAND_SUPPLY_LEVEL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTILIZATION_POOL ==
CREATE OR REPLACE FUNCTION SP_UTILIZATION_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPOOLS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTILIZATION_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTILIZATION_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_UTILIZATION_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTILIZATION_POOL(32) : pivots.sql(509) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UTILIZATION_POOL', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UTILIZATION_POOL(38) : pivots.sql(515) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_POOL(41) : pivots.sql(518) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(75) : pivots.sql(552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(95) : pivots.sql(572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPRUPOOLS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   COALESCE(R.RESOURCE_ID,'')				AS RESOURCE_ID, 
   COALESCE(R.FULL_NAME,'')				AS RESOURCE_NAME,
   COALESCE(R.WORK_LOCATION,0)				AS RESOURCE_WORK_LOCATION,
   COALESCE(R.STATUS1_ID,0)				AS RESOURCE_STATUS1, /* WORK STATUS */
   COALESCE(R.STATUS2_ID,0)				AS RESOURCE_STATUS2,  /* EMPLOYEE STATUS */
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'')	AS RESOURCE_COMPETENCY,
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY,
   COALESCE(R.GEOGRAPHY_NAME,'')			AS RESOURCE_GEO,
   COALESCE(R.ORGANIZATION_NAME,'')		AS RESOURCE_ORG,
   COALESCE(R.POOL_NAME,'')				AS RESOURCE_POOL,				
   COALESCE(R.POOL_MANAGER_NAME,'')		AS RESOURCE_POOL_MANAGER,
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ID,
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME,
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_REF_NUMBER,
   COALESCE(P.REF_CODE,'') AS PROJECT_REF_CODE,
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY,
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_START_DT,
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_FINISH_DT,
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER,
   COALESCE(P.PRIORITY,0) AS STATUS_PRIORITY,
   COALESCE(P.STAGE_ID,0) AS STATUS_STAGE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS STATUS_PERCENT_COMPLETE,
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS STATUS_PERCENT_SPENT,
   COALESCE(M.FISCAL_YEAR,0) AS RESOURCE_YEAR,
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
   COALESCE(M.FISCAL_MONTH,0) AS RESOURCE_MONTH,
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS RESOURCE_CALENDAR,
   COALESCE(M.PLANNED_MIN,0)/60.0 AS RESOURCE_PROPOSED,
   COALESCE(M.SCHED_MIN,0)/60.0 AS RESOURCE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_ACTUAL,
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS RESOURCE_BILLABLE_PROPOSED,
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS RESOURCE_BILLABLE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_BILLABLE_ACTUAL,
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS ATTRIBUTES,   
   
   COALESCE(R.NICK_NAME,'')				AS RESOURCE_NICK_NAME, 
   COALESCE(R.LOGON_NAME,'')				AS RESOURCE_LOGON_NAME, 
   COALESCE(R.FIRST_NAME,'')				AS RESOURCE_FIRST_NAME, 
   COALESCE(R.MIDDLE_NAME,'')				AS RESOURCE_MIDDLE_NAME, 
   COALESCE(R.LAST_NAME,'')				AS RESOURCE_LAST_NAME, 
   COALESCE(R.E_MAIL_ADDRESS,'')			AS RESOURCE_E_MAIL,				
   TO_DATE(SubStr(COALESCE(R.EFFECTIVE_DATE, TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS RESOURCE_EFFECTIVE_DATE,	
   COALESCE(R.MAXDAYHRS,0)					AS RESOURCE_MAX_DAILY_HOURS,
   COALESCE(R.FS_CODE, '')					AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE, '')			AS RESOURCE_COUNTRY_CODE,
   COALESCE(R.COMPANY_CODE, '')			AS RESOURCE_COMPANY_CODE,
   COALESCE(R.DIVISION_CODE, '')			AS RESOURCE_DIVISION_CODE,
   COALESCE(R.DEPARTMENT_CODE, '')			AS RESOURCE_DEPARTMENT_CODE,
   COALESCE(R.EMPLOYEE_CODE, '')			AS RESOURCE_EMPLOYEE_CODE,
   COALESCE(R.CUSTOM_01, '')				AS RESOURCE_CUSTOM_01,
   COALESCE(R.CUSTOM_02, '')				AS RESOURCE_CUSTOM_02,
   COALESCE(R.CUSTOM_03, '')				AS RESOURCE_CUSTOM_03,
   COALESCE(R.CUSTOM_04, '')				AS RESOURCE_CUSTOM_04,
   COALESCE(R.CUSTOM_05, '')				AS RESOURCE_CUSTOM_05,
   COALESCE(R.CURRENCY_ID, 0)				AS RESOURCE_CURRENCY_ID,
   COALESCE(R.POOL_ID, '')					AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_MANAGER_ID, '')			AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.ORGANIZATION_ID, '')			AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.GEOGRAPHY_ID, '')			AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_ID, '')	AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_PROFICIENCY_ID, '')	AS RESOURCE_PROFICIENCY_ID
   FROM PMO_PVT_UTILIZATION M 
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID 
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY	RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL', 191+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_POOL(192) : pivots.sql(669) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPOOLS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 199+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(200) : pivots.sql(677) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL', 211+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL(212) : pivots.sql(689) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTILIZATION_POOL;
ALTER FUNCTION SP_UTILIZATION_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_POOL_M ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_POOL_M
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPOOLM PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_POOL_M') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_POOL_M'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_POOL_M(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL_M', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_POOL_M(32) : pivots.sql(737) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_POOL_M', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_POOL_M(38) : pivots.sql(743) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL_M', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_POOL_M(41) : pivots.sql(746) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(75) : pivots.sql(780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(95) : pivots.sql(800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(115) : pivots.sql(820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPOOLM FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(M.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(M.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(M.FISCAL_MONTH_START,TO_DATE('1899-01-01')) AS TIME_MONTH_START, /*Month Start*/
   COALESCE(M.FISCAL_MONTH_FINISH,TO_DATE('1899-01-01')) AS TIME_MONTH_FINISH, /*Month Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS MONTH_AVAILABLE, /*Available*/
   COALESCE(M.BASELINE_MIN,0)/60.0 AS MONTH_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(M.SCHED_MIN,0)/60.0 AS MONTH_PLANNED_WORK, /*Plan*/
   COALESCE(M.PLANNED_MIN,0)/60.0 AS MONTH_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS MONTH_ACTUAL_WORK, /*Actual*/
   (COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/60.0 AS MONTH_REMAINING_WORK, /*Remaining*/
   
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS MONTH_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS MONTH_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS MONTH_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION M 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = M.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = M.TSK_ASSIGNMENT_ID 
   
   ORDER BY R.FULL_NAME, M.FISCAL_MONTH_START, P.RANK, T.RANK, A.START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL_M', 362+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_POOL_M(363) : pivots.sql(1068) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPOOLM;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 370+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(371) : pivots.sql(1076) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL_M', 382+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL_M(383) : pivots.sql(1088) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_POOL_M;
ALTER FUNCTION SP_PVT_RES_UTIL_POOL_M COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_POOL ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPOOL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_POOL(32) : pivots.sql(1136) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_POOL', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_POOL(38) : pivots.sql(1142) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_POOL(41) : pivots.sql(1145) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(75) : pivots.sql(1179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(95) : pivots.sql(1199) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 114+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(115) : pivots.sql(1219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PTA;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPOOL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.BILLABLE_PLANNED_MIN,0)/60.0 AS WEEK_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(W.BILLABLE_SCHED_MIN,0)/60.0 AS WEEK_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.BILLABLE_ACTUAL_MIN,0)/60.0 AS WEEK_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID 
   
   ORDER BY R.FULL_NAME, W.FISCAL_WEEK_START, P.RANK, T.RANK, A.START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_POOL', 363+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_POOL(364) : pivots.sql(1468) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPOOL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 371+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(372) : pivots.sql(1476) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_POOL', 383+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_POOL(384) : pivots.sql(1488) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_POOL;
ALTER FUNCTION SP_PVT_RES_UTIL_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTILIZATION_PROJECT ==
CREATE OR REPLACE FUNCTION SP_UTILIZATION_PROJECT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPRJS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTILIZATION_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTILIZATION_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_UTILIZATION_PROJECT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTILIZATION_PROJECT(32) : pivots.sql(1536) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UTILIZATION_PROJECT', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UTILIZATION_PROJECT(38) : pivots.sql(1542) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_PROJECT(41) : pivots.sql(1545) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(75) : pivots.sql(1579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(99) : pivots.sql(1603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPRUPRJS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID, 
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME,
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION,
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_STATUS1,
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_STATUS2,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_COMPETENCY,
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEO,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORG,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER,
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ID,
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME,
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_REF_NUMBER,
   COALESCE(P.REF_CODE,'') AS PROJECT_REF_CODE,
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY,
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_START_DT,
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_FINISH_DT,
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER,
   COALESCE(P.PRIORITY,0) AS STATUS_PRIORITY,
   COALESCE(P.STAGE_ID,0) AS STATUS_STAGE,
   COALESCE(P.MILESTONE_PERCENT,0)/*/100.0*/ AS STATUS_PERCENT_COMPLETE,
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(COALESCE(P.WORK_TODATE,0),18,2)*10000)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2) END AS STATUS_PERCENT_SPENT,
   COALESCE(M.FISCAL_YEAR,0) AS RESOURCE_YEAR,
   Trunc((COALESCE(M.FISCAL_MONTH,0)-1)/3+1) AS RESOURCE_QUARTER,
   COALESCE(M.FISCAL_MONTH,0) AS RESOURCE_MONTH,
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS RESOURCE_CALENDAR,
   COALESCE(M.PLANNED_MIN,0)/60.0 AS RESOURCE_PROPOSED,
   COALESCE(M.SCHED_MIN,0)/60.0 AS RESOURCE_SCHEDULED,
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS RESOURCE_ACTUAL,
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS RESOURCE_BILLABLE_PROPOSED,
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS RESOURCE_BILLABLE_SCHEDULED,
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS RESOURCE_BILLABLE_ACTUAL,
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS ATTRIBUTES,
   
   COALESCE(R.NICK_NAME,'')				AS RESOURCE_NICK_NAME, 
   COALESCE(R.LOGON_NAME,'')				AS RESOURCE_LOGON_NAME, 
   COALESCE(R.FIRST_NAME,'')				AS RESOURCE_FIRST_NAME, 
   COALESCE(R.MIDDLE_NAME,'')				AS RESOURCE_MIDDLE_NAME, 
   COALESCE(R.LAST_NAME,'')				AS RESOURCE_LAST_NAME, 
   COALESCE(R.E_MAIL_ADDRESS,'')			AS RESOURCE_E_MAIL,				
   TO_DATE(SubStr(COALESCE(R.EFFECTIVE_DATE, TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS RESOURCE_EFFECTIVE_DATE,	
   COALESCE(R.MAXDAYHRS,0)					AS RESOURCE_MAX_DAILY_HOURS,
   COALESCE(R.FS_CODE, '')					AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE, '')			AS RESOURCE_COUNTRY_CODE,
   COALESCE(R.COMPANY_CODE, '')			AS RESOURCE_COMPANY_CODE,
   COALESCE(R.DIVISION_CODE, '')			AS RESOURCE_DIVISION_CODE,
   COALESCE(R.DEPARTMENT_CODE, '')			AS RESOURCE_DEPARTMENT_CODE,
   COALESCE(R.EMPLOYEE_CODE, '')			AS RESOURCE_EMPLOYEE_CODE,
   COALESCE(R.CUSTOM_01, '')				AS RESOURCE_CUSTOM_01,
   COALESCE(R.CUSTOM_02, '')				AS RESOURCE_CUSTOM_02,
   COALESCE(R.CUSTOM_03, '')				AS RESOURCE_CUSTOM_03,
   COALESCE(R.CUSTOM_04, '')				AS RESOURCE_CUSTOM_04,
   COALESCE(R.CUSTOM_05, '')				AS RESOURCE_CUSTOM_05,
   COALESCE(R.CURRENCY_ID, 0)				AS RESOURCE_CURRENCY_ID,
   COALESCE(R.POOL_ID, '')					AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_MANAGER_ID, '')			AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.ORGANIZATION_ID, '')			AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.GEOGRAPHY_ID, '')			AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_ID, '')	AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_PROFICIENCY_ID, '')	AS RESOURCE_PROFICIENCY_ID
   
   FROM PMO_PVT_UTILIZATION M 
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID 
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY	RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID,
   PROJECT_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT', 197+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_PROJECT(198) : pivots.sql(1702) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPRJS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 205+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(206) : pivots.sql(1710) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT', 217+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT(218) : pivots.sql(1722) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTILIZATION_PROJECT;
ALTER FUNCTION SP_UTILIZATION_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_PROJECT_M ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_PROJECT_M
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPRJM PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_PROJECT_M') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_PROJECT_M'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_PROJECT_M(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT_M', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_PROJECT_M(32) : pivots.sql(1770) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_PROJECT_M', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_PROJECT_M(38) : pivots.sql(1776) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT_M', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_PROJECT_M(41) : pivots.sql(1779) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(75) : pivots.sql(1813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(99) : pivots.sql(1837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(119) : pivots.sql(1857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPRJM FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(M.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(M.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(M.FISCAL_MONTH_START,TO_DATE('1899-01-01')) AS TIME_MONTH_START, /*Month Start*/
   COALESCE(M.FISCAL_MONTH_FINISH,TO_DATE('1899-01-01')) AS TIME_MONTH_FINISH, /*Month Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS MONTH_AVAILABLE, /*Available*/
   COALESCE(M.BASELINE_MIN,0)/60.0 AS MONTH_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(M.SCHED_MIN,0)/60.0 AS MONTH_PLANNED_WORK, /*Plan*/
   COALESCE(M.PLANNED_MIN,0)/60.0 AS MONTH_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS MONTH_ACTUAL_WORK, /*Actual*/
   (COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/60.0 AS MONTH_REMAINING_WORK, /*Remaining*/
   
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS MONTH_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS MONTH_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS MONTH_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_SCHED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(M.AVAILABLE_MIN,0)) END AS MONTH_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION M 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = M.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = M.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = M.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = M.TSK_ASSIGNMENT_ID 
   
   ORDER BY P.RANK, T.RANK, A.START_DT, R.FULL_NAME, M.FISCAL_MONTH_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT_M', 366+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_PROJECT_M(367) : pivots.sql(2105) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPRJM;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 374+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(375) : pivots.sql(2113) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT_M', 386+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT_M(387) : pivots.sql(2125) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_PROJECT_M;
ALTER FUNCTION SP_PVT_RES_UTIL_PROJECT_M COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_RES_UTIL_PROJECT ==
CREATE OR REPLACE FUNCTION SP_PVT_RES_UTIL_PROJECT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRUPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_RES_UTIL_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_RES_UTIL_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_RES_UTIL_PROJECT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_RES_UTIL_PROJECT(32) : pivots.sql(2173) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_RES_UTIL_PROJECT', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_RES_UTIL_PROJECT(38) : pivots.sql(2179) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_PROJECT(41) : pivots.sql(2182) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(75) : pivots.sql(2216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID, PARENT_ID) VALUES(' ', ' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(99) : pivots.sql(2240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PARENTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PARENTS (PARENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(119) : pivots.sql(2260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(139) : pivots.sql(2280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PTA;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPRUPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(TP.PARENT_NAME,'') AS PARENT_NAME, /*Parent*/
   COALESCE(TP.PARENT_ID,'') AS PARENT_ID, /*Parent ID*/
   TO_DATE(SubStr(COALESCE(TP.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PARENT_QS_START,
   TO_DATE(SubStr(COALESCE(TP.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PARENT_QS_FINISH,
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.BILLABLE_SCHED_MIN,0)/60.0 AS WEEK_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(W.BILLABLE_PLANNED_MIN,0)/60.0 AS WEEK_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.BILLABLE_ACTUAL_MIN,0)/60.0 AS WEEK_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE (PMO_ORASTD.TODECIMAL(COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0), 18, 2)/PMO_ORASTD.TODECIMAL(COALESCE(W.AVAILABLE_MIN,0), 18, 2))*100 END AS WEEK_REMAINING_RATIO, 
   
   
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_SCHED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_PLANNED_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(W.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(W.BILLABLE_ACTUAL_MIN,0)*100)/COALESCE(W.AVAILABLE_MIN,0)) END AS WEEK_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_UTILIZATION W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_PARENTS TP
   ON TP.PARENT_ID = T.PARENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID 
   
   ORDER BY P.RANK, T.RANK, A.START_DT, R.FULL_NAME, W.FISCAL_WEEK_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_RES_UTIL_PROJECT', 396+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_RES_UTIL_PROJECT(397) : pivots.sql(2538) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRUPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 404+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(405) : pivots.sql(2546) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_RES_UTIL_PROJECT', 416+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_RES_UTIL_PROJECT(417) : pivots.sql(2558) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_RES_UTIL_PROJECT;
ALTER FUNCTION SP_PVT_RES_UTIL_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_TIMESHEET_POOL ==
CREATE OR REPLACE FUNCTION SP_PVT_TIMESHEET_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPTSPOOL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_TIMESHEET_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_TIMESHEET_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_TIMESHEET_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_TIMESHEET_POOL(32) : pivots.sql(2606) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_TIMESHEET_POOL', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_TIMESHEET_POOL(38) : pivots.sql(2612) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_POOL', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_TIMESHEET_POOL(41) : pivots.sql(2615) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_POOLS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_ID;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TIMESHEETS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TIMESHEETS_WEEKLY(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPTSPOOL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.TIMECODE_1_ID,'') AS TIMESHEET_TIMECODE_1_ID,
   COALESCE(W.TIMECODE_1_NAME,'') AS TIMESHEET_TIMECODE_1, /*Timecode 1*/
   COALESCE(W.TIMECODE_2_ID,'') AS TIMESHEET_TIMECODE_2_ID,
   COALESCE(W.TIMECODE_2_NAME,'') AS TIMESHEET_TIMECODE_2, /*Timecode 2*/
   COALESCE(W.WEEK_STATUS_DATE,TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS TIMESHEET_LAST_UPDATE_ON, /*Last Updated On*/
   COALESCE(W.WEEK_MANAGER_ID,'') AS TIMESHEET_LAST_UPDATE_BY_ID,
   COALESCE(W.WEEK_MANAGER_NAME,'') AS TIMESHEET_LAST_UPDATE_BY, /*Last Updated By*/
   COALESCE(W.WEEK_MY_STATUS,0) AS TIMESHEET_TM_STATUS, /*!!! Team Member Status*/
   COALESCE(W.WEEK_MANAGER_STATUS,0) AS TIMESHEET_MGR_STATUS, /*!!! Manager Status*/
   COALESCE(W.NOTES,'') AS TIMESHEET_NOTES, /*Notes*/
   
   COALESCE(W.SUNDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_REGULAR+W.MONDAY_REGULAR+W.TUESDAY_REGULAR+W.WEDNESDAY_REGULAR+W.THURSDAY_REGULAR+W.FRIDAY_REGULAR+W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TOTAL, /*Regular Total*/
   
   COALESCE(W.SUNDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_SPECIAL+W.MONDAY_SPECIAL+W.TUESDAY_SPECIAL+W.WEDNESDAY_SPECIAL+W.THURSDAY_SPECIAL+W.FRIDAY_SPECIAL+W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TOTAL /*Special Total*/
   
   FROM PMO_PVT_TIMESHEETS W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID 
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID 
   
   ORDER BY R.FULL_NAME, W.FISCAL_WEEK_START, P.RANK, T.RANK, A.START_DT;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_POOL', 327+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_TIMESHEET_POOL(328) : pivots.sql(2902) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPTSPOOL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_POOL', 335+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_POOL(336) : pivots.sql(2910) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_POOL', 347+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_POOL(348) : pivots.sql(2922) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_TIMESHEET_POOL;
ALTER FUNCTION SP_PVT_TIMESHEET_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_TIMESHEET_PROJECT ==
CREATE OR REPLACE FUNCTION SP_PVT_TIMESHEET_PROJECT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPTSPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_TIMESHEET_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_TIMESHEET_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_TIMESHEET_PROJECT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_PROJECT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_TIMESHEET_PROJECT(32) : pivots.sql(2970) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_start_date IS NULL) OR (p_finish_date IS NULL) 
         OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_TIMESHEET_PROJECT', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_TIMESHEET_PROJECT(38) : pivots.sql(2976) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_PROJECT', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_TIMESHEET_PROJECT(41) : pivots.sql(2979) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_TIMESHEETS;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_WEEKLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TIMESHEETS_WEEKLY(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_PRED();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_TSK_SUCC();
   
   OPEN COPTSPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(T.ELEMENT_NAME,'') AS TASK_NAME, /*Task*/
   
   COALESCE(W.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(W.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(W.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(W.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(W.FISCAL_WEEK,0) AS TIME_WEEK, /*Week*/
   COALESCE(W.FISCAL_WEEK_START,TO_DATE('1899-01-01')) AS TIME_WEEK_START, /*Week Start*/
   COALESCE(W.FISCAL_WEEK_FINISH,TO_DATE('1899-01-01')) AS TIME_WEEK_FINISH, /*Week Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(T.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(T.WBS_CODE,''), 3)) END) AS TASK_WBS_CODE, /*WBS ID*/
   COALESCE(T.ELEMENT_ID,'') AS TASK_ELEMENT_ID,
   COALESCE(T.MILESTONE_PERCENT,0)/100.0 AS TASK_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(T.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(T.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(T.SCHED_EFFORT,0),18,2)) END AS TASK_WORK_PERCENT, /*%W*/
   COALESCE(T.PRIORITY,0) AS TASK_RANK, /*Rank*/
   COALESCE(T.STAGE_ID,0) AS TASK_STATE, /*State*/
   COALESCE(T.REFERENCE_NUMBER,0) AS TASK_ID,
   COALESCE(T.REF_CODE,'') AS TASK_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(TPRED.TASK_PREDESSESOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_PREDECESSORS, /*Predecessors*/
   COALESCE(TSUCC.TASK_SUCCESSOR,(SELECT CLOB_DATA FROM EMPTYLOB)) AS TASK_SUCCESSORS, /*Successors*/
   
   TO_DATE(SubStr(COALESCE(T.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_START,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_START, /*Actual*/
   
   TO_DATE(SubStr(COALESCE(T.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_QS_FINISH,
   TO_DATE(SubStr(COALESCE(T.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(T.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(T.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(T.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(T.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS TASK_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(T.BASELINE1_EFFORT,0)/60.0 AS TASK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(T.BASELINE3_EFFORT,0)/60.0 AS TASK_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(T.SCHED_EFFORT,0)/60.0 AS TASK_PLANNED_WORK, /*Plan*/
   COALESCE(T.PLANNED_EFFORT,0)/60.0 AS TASK_PROPOSED_WORK, /*Proposed*/
   COALESCE(T.WORK_TODATE,0)/60.0 AS TASK_ACTUAL_WORK, /*Actual*/
   COALESCE(T.TD_BASELINE_MIN,0)/60.0 AS TASK_CUM_BASELINE_L, /*Baseline (L) from task start to selected start DATE*/
   COALESCE(T.TD_SCHED_MIN,0)/60.0 AS TASK_CUM_PLANNED, /*Planned from task start to selected start DATE*/
   COALESCE(T.TD_PLANNED_MIN,0)/60.0 AS TASK_CUM_PROPOSED, /*Proposed from task start to selected start DATE*/
   COALESCE(T.TD_ACTUAL_MIN,0)/60.0 AS TASK_CUM_ACTUAL, /*Actual from task start to selected start DATE*/
   COALESCE(T.YTD_BASELINE_MIN,0)/60.0 AS TASK_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(T.YTD_SCHED_MIN,0)/60.0 AS TASK_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(T.YTD_PLANNED_MIN,0)/60.0 AS TASK_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(T.YTD_ACTUAL_MIN,0)/60.0 AS TASK_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(W.AVAILABLE_MIN,0)/60.0 AS WEEK_AVAILABLE, /*Available*/
   COALESCE(W.BASELINE_MIN,0)/60.0 AS WEEK_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(W.SCHED_MIN,0)/60.0 AS WEEK_PLANNED_WORK, /*Plan*/
   COALESCE(W.PLANNED_MIN,0)/60.0 AS WEEK_PROPOSED_WORK, /*Proposed*/
   COALESCE(W.ACTUAL_MIN,0)/60.0 AS WEEK_ACTUAL_WORK, /*Actual*/
   (COALESCE(W.SCHED_MIN,0)+COALESCE(W.PLANNED_MIN,0)-COALESCE(W.ACTUAL_MIN,0))/60.0 AS WEEK_REMAINING_WORK, /*Remaining*/
   
   COALESCE(W.TIMECODE_1_ID,'') AS TIMESHEET_TIMECODE_1_ID,
   COALESCE(W.TIMECODE_1_NAME,'') AS TIMESHEET_TIMECODE_1, /*Timecode 1*/
   COALESCE(W.TIMECODE_2_ID,'') AS TIMESHEET_TIMECODE_2_ID,
   COALESCE(W.TIMECODE_2_NAME,'') AS TIMESHEET_TIMECODE_2, /*Timecode 2*/
   COALESCE(W.WEEK_STATUS_DATE,TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS TIMESHEET_LAST_UPDATE_ON, /*Last Updated On*/
   COALESCE(W.WEEK_MANAGER_ID,'') AS TIMESHEET_LAST_UPDATE_BY_ID,
   COALESCE(W.WEEK_MANAGER_NAME,'') AS TIMESHEET_LAST_UPDATE_BY, /*Last Updated By*/
   COALESCE(W.WEEK_MY_STATUS,0) AS TIMESHEET_TM_STATUS, /*!!! Team Member Status*/
   COALESCE(W.WEEK_MANAGER_STATUS,0) AS TIMESHEET_MGR_STATUS, /*!!! Manager Status*/
   COALESCE(W.NOTES,'') AS TIMESHEET_NOTES, /*Notes*/
   
   COALESCE(W.SUNDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_REGULAR+W.MONDAY_REGULAR+W.TUESDAY_REGULAR+W.WEDNESDAY_REGULAR+W.THURSDAY_REGULAR+W.FRIDAY_REGULAR+W.SATURDAY_REGULAR,0)/60.0 AS TIMESHEET_REGULAR_TOTAL, /*Regular Total*/
   
   COALESCE(W.SUNDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SUNDAY, /*Sunday*/
   COALESCE(W.MONDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_MONDAY, /*Monday*/
   COALESCE(W.TUESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TUESDAY, /*Tuesday*/
   COALESCE(W.WEDNESDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_WEDNESDAY, /*Wednesday*/
   COALESCE(W.THURSDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_THURSDAY, /*Thursday*/
   COALESCE(W.FRIDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_FRIDAY, /*Friday*/
   COALESCE(W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_SATURDAY, /*Saturday*/
   COALESCE(W.SUNDAY_SPECIAL+W.MONDAY_SPECIAL+W.TUESDAY_SPECIAL+W.WEDNESDAY_SPECIAL+W.THURSDAY_SPECIAL+W.FRIDAY_SPECIAL+W.SATURDAY_SPECIAL,0)/60.0 AS TIMESHEET_SPECIAL_TOTAL /*Special Total*/
   
   FROM PMO_PVT_TIMESHEETS W 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = W.RESOURCE_ID
   
   JOIN PMO_PVT_PROJECTS P
   ON P.ELEMENT_ID = W.PROJECT_ID 
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_TASKS T
   ON T.ELEMENT_ID = W.TASK_ID
   
   JOIN PMO_PVT_FLAT_TSK_PRED TPRED
   ON TPRED.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_TSK_SUCC TSUCC
   ON TSUCC.TASK_ID = T.ELEMENT_ID
   
   JOIN PMO_PVT_ASSIGNMENTS A
   ON A.TSK_ASSIGNMENT_ID = W.TSK_ASSIGNMENT_ID
   
   ORDER BY P.RANK, T.RANK, A.START_DT, R.FULL_NAME, W.FISCAL_WEEK_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_TIMESHEET_PROJECT', 331+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_TIMESHEET_PROJECT(332) : pivots.sql(3270) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPTSPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_PROJECT', 339+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_PROJECT(340) : pivots.sql(3278) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_TIMESHEET_PROJECT', 351+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_TIMESHEET_PROJECT(352) : pivots.sql(3290) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_TIMESHEET_PROJECT;
ALTER FUNCTION SP_PVT_TIMESHEET_PROJECT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_RTF ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_RTF
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRTFPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_RTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_RTF'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_RTF(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RTF', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_RTF(32) : pivots.sql(3338) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_RTF', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_RTF(37) : pivots.sql(3343) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RTF', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_RTF(40) : pivots.sql(3346) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   OPEN COPRTFPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   1 AS TYPE_ID,
   1 AS REF_TYPE,
   
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF01, 
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF02, 
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF03, 
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF04, 
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF05, 
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF06, 
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF07, 
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF08, 
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF09, 
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF10, 
   COALESCE(RTF11.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF11, 
   COALESCE(RTF12.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF12, 
   COALESCE(RTF13.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF13, 
   COALESCE(RTF14.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF14, 
   COALESCE(RTF15.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF15, 
   COALESCE(RTF16.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF16, 
   COALESCE(RTF17.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF17, 
   COALESCE(RTF18.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF18, 
   COALESCE(RTF19.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF19, 
   COALESCE(RTF20.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB) ) AS RTF20 
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = P.ELEMENT_ID AND RTF01.ELEMENT_ID = P.ELEMENT_ID AND RTF01.BIT_FLAG = 1 
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = P.ELEMENT_ID AND RTF02.ELEMENT_ID = P.ELEMENT_ID AND RTF02.BIT_FLAG = 2 
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = P.ELEMENT_ID AND RTF03.ELEMENT_ID = P.ELEMENT_ID AND RTF03.BIT_FLAG = 4 
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = P.ELEMENT_ID AND RTF04.ELEMENT_ID = P.ELEMENT_ID AND RTF04.BIT_FLAG = 8 
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = P.ELEMENT_ID AND RTF05.ELEMENT_ID = P.ELEMENT_ID AND RTF05.BIT_FLAG = 16 
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = P.ELEMENT_ID AND RTF06.ELEMENT_ID = P.ELEMENT_ID AND RTF06.BIT_FLAG = 32 
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = P.ELEMENT_ID AND RTF07.ELEMENT_ID = P.ELEMENT_ID AND RTF07.BIT_FLAG = 64 
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = P.ELEMENT_ID AND RTF08.ELEMENT_ID = P.ELEMENT_ID AND RTF08.BIT_FLAG = 128 
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = P.ELEMENT_ID AND RTF09.ELEMENT_ID = P.ELEMENT_ID AND RTF09.BIT_FLAG = 256 
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = P.ELEMENT_ID AND RTF10.ELEMENT_ID = P.ELEMENT_ID AND RTF10.BIT_FLAG = 512 
   LEFT JOIN WBS_RTF RTF11 ON RTF11.PARENT_ID = P.ELEMENT_ID AND RTF11.ELEMENT_ID = P.ELEMENT_ID AND RTF11.BIT_FLAG = 1024 
   LEFT JOIN WBS_RTF RTF12 ON RTF12.PARENT_ID = P.ELEMENT_ID AND RTF12.ELEMENT_ID = P.ELEMENT_ID AND RTF12.BIT_FLAG = 2048 
   LEFT JOIN WBS_RTF RTF13 ON RTF13.PARENT_ID = P.ELEMENT_ID AND RTF13.ELEMENT_ID = P.ELEMENT_ID AND RTF13.BIT_FLAG = 4096 
   LEFT JOIN WBS_RTF RTF14 ON RTF14.PARENT_ID = P.ELEMENT_ID AND RTF14.ELEMENT_ID = P.ELEMENT_ID AND RTF14.BIT_FLAG = 8192 
   LEFT JOIN WBS_RTF RTF15 ON RTF15.PARENT_ID = P.ELEMENT_ID AND RTF15.ELEMENT_ID = P.ELEMENT_ID AND RTF15.BIT_FLAG = 16384 
   LEFT JOIN WBS_RTF RTF16 ON RTF16.PARENT_ID = P.ELEMENT_ID AND RTF16.ELEMENT_ID = P.ELEMENT_ID AND RTF16.BIT_FLAG = 32768 
   LEFT JOIN WBS_RTF RTF17 ON RTF17.PARENT_ID = P.ELEMENT_ID AND RTF17.ELEMENT_ID = P.ELEMENT_ID AND RTF17.BIT_FLAG = 65536 
   LEFT JOIN WBS_RTF RTF18 ON RTF18.PARENT_ID = P.ELEMENT_ID AND RTF18.ELEMENT_ID = P.ELEMENT_ID AND RTF18.BIT_FLAG = 131072 
   LEFT JOIN WBS_RTF RTF19 ON RTF19.PARENT_ID = P.ELEMENT_ID AND RTF19.ELEMENT_ID = P.ELEMENT_ID AND RTF19.BIT_FLAG = 262144 
   LEFT JOIN WBS_RTF RTF20 ON RTF20.PARENT_ID = P.ELEMENT_ID AND RTF20.ELEMENT_ID = P.ELEMENT_ID AND RTF20.BIT_FLAG = 524288 
   
   ORDER BY P.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RTF', 173+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_RTF(174) : pivots.sql(3480) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRTFPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RTF', 181+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RTF(182) : pivots.sql(3488) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RTF', 193+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RTF(194) : pivots.sql(3500) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_RTF;
ALTER FUNCTION SP_PVT_PROJECT_RTF COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_CLIENTS ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_CLIENTS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPCLNPRJ PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_CLIENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_CLIENTS'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_CLIENTS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_CLIENTS', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_CLIENTS(32) : pivots.sql(3548) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_CLIENTS', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_CLIENTS(37) : pivots.sql(3553) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_CLIENTS', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_CLIENTS(40) : pivots.sql(3556) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_PROJECTS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(74) : pivots.sql(3590) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      INSERT INTO PMO_PVT_TASKS (ELEMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(98) : pivots.sql(3614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   BEGIN
      INSERT INTO PMO_PVT_ASSIGNMENTS (TSK_ASSIGNMENT_ID) VALUES(' ');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(118) : pivots.sql(3634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_MONTHLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_UTILIZATION;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   h_init_type := PMO_CNST.SC_INI_GROUP_PTA;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_UTIL_MONTHLY(h_init_type, h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_TD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_WORK_YTD(h_start_date, h_finish_date);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_PRJ_ATTR();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_CLIENTS();
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FLAT_CLIENT_ATTR();
   
   OPEN COPCLNPRJ FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_CLIENTS AS TYPE_ID,
   1 AS REF_TYPE,
   
   COALESCE(P.ELEMENT_NAME,'') AS PROJECT_NAME, /*Project*/
   COALESCE(C.CLIENT_NAME,'') AS CLIENT_NAME, /*Client*/
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   
   COALESCE(M.FISCAL_YEAR,0) AS TIME_YEAR, /*Year*/
   CASE WHEN COALESCE(M.FISCAL_MONTH,0) < 4 THEN 1 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 4 AND 6 THEN 2 WHEN COALESCE(M.FISCAL_MONTH,0) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS TIME_QUARTER, /*Quarter*/
   COALESCE(M.FISCAL_MONTH,0) AS TIME_MONTH, /*Month*/
   COALESCE(M.FISCAL_MONTH_START,TO_DATE('1899-01-01')) AS TIME_MONTH_START, /*Month Start*/
   COALESCE(M.FISCAL_MONTH_FINISH,TO_DATE('1899-01-01')) AS TIME_MONTH_FINISH, /*Month Finish*/
   
   (CASE WHEN P.WBS_CODE IS NULL THEN '0.0' WHEN PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(COALESCE(P.WBS_CODE,''), PMO_ORASTD.LOCATE('.', COALESCE(P.WBS_CODE,''), 3)) END) AS PROJECT_WBS_CODE, /*WBS ID*/
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   COALESCE(P.PROJECT_TYPE,0) AS PROJECT_TYPE,
   COALESCE(P.MILESTONE_PERCENT,0)/100.0 AS PROJECT_DC_PERCENT, /*%DC*/
   CASE WHEN COALESCE(P.SCHED_EFFORT,0) = 0 THEN 0 ELSE ((COALESCE(P.WORK_TODATE,0)*100)/PMO_ORASTD.TODECIMAL(COALESCE(P.SCHED_EFFORT,0),18,2)) END AS PROJECT_WORK_PERCENT, /*%W*/
   COALESCE(P.PRIORITY,0) AS PROJECT_RANK, /*Rank*/
   COALESCE(P.STAGE_ID,0) AS PROJECT_STATE, /*State*/
   COALESCE(P.BUBBLE_COLOR,0) AS PROJECT_HEALTH, /*Health Color*/
   COALESCE(P.REFERENCE_NUMBER,0) AS PROJECT_ID, /*Project ID*/
   COALESCE(P.REF_CODE,'') AS PROJECT_REFERENCE_NUMBER, /*Reference Number*/
   COALESCE(P.FS_CODE,'') AS PROJECT_FS_CODE, /*PBFS Code*/
   COALESCE(P.OPPORTUNITY_NAME,'') AS PROJECT_CLIENT, /*Client*/
   COALESCE(P.CURRENCY_ID,0) AS PROJECT_CURRENCY, /*Currency*/
   COALESCE(P.MANAGER_ID,'') AS PROJECT_MANAGER_ID,
   COALESCE(P.MANAGER_NAME,'') AS PROJECT_MANAGER, /*Manager*/
   COALESCE(PAT.PROJECT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_ATTRIBUTES, /*...*/
   
   COALESCE(P.START_FINISH_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_START, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_START,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_START, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_START, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_START,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_START, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_START, /*Actual*/
   
   COALESCE(P.FINISH_START_DATE,TO_DATE('1899-01-01')) AS PROJECT_ESTIMATED_FINISH, /*Estimate*/
   TO_DATE(SubStr(COALESCE(P.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(P.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_L_FINISH, /*Baseline (Latest)*/
   TO_DATE(SubStr(COALESCE(P.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_BASELINE_I_FINISH, /*Baseline (Initial)*/
   TO_DATE(SubStr(COALESCE(P.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_EXPECTED_FINISH,
   TO_DATE(SubStr(COALESCE(P.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_SCHEDULE_FINISH, /*Schedule*/
   TO_DATE(SubStr(COALESCE(P.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS PROJECT_ACTUAL_FINISH, /*Actual*/
   
   COALESCE(P.WS_BASELINE1_EFFORT,0) AS PROJECT_WS_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.WS_BASELINE3_EFFORT,0) AS PROJECT_WS_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.WS_ESTIMATED_EFFORT,0) AS PROJECT_WS_ESTIMATED_WORK, /*Estimate*/
   COALESCE(P.WS_ACTUAL_EFFORT,0) AS PROJECT_WS_ACTUAL_WORK, /*Actual*/
   COALESCE(P.WS_ETC_EFFORT,0) AS PROJECT_WS_ETC_WORK, /*ETC*/
   
   COALESCE(P.BASELINE1_EFFORT,0)/60.0 AS PROJECT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(P.BASELINE3_EFFORT,0)/60.0 AS PROJECT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(P.SCHED_EFFORT,0)/60.0 AS PROJECT_PLANNED_WORK, /*Plan*/
   COALESCE(P.PLANNED_EFFORT,0)/60.0 AS PROJECT_PROPOSED_WORK, /*Proposed*/
   COALESCE(P.WORK_TODATE,0)/60.0 AS PROJECT_ACTUAL_WORK, /*Actual*/
   COALESCE(P.TD_BASELINE_MIN,0)/60.0 AS PROJECT_CUM_BASELINE_L, /*Baseline (L) from project start to selected start DATE*/
   COALESCE(P.TD_SCHED_MIN,0)/60.0 AS PROJECT_CUM_PLANNED, /*Planned from project start to selected start DATE*/
   COALESCE(P.TD_PLANNED_MIN,0)/60.0 AS PROJECT_CUM_PROPOSED, /*Proposed from project start to selected start DATE*/
   COALESCE(P.TD_ACTUAL_MIN,0)/60.0 AS PROJECT_CUM_ACTUAL, /*Actual from project start to selected start DATE*/
   COALESCE(P.YTD_BASELINE_MIN,0)/60.0 AS PROJECT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(P.YTD_SCHED_MIN,0)/60.0 AS PROJECT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(P.YTD_PLANNED_MIN,0)/60.0 AS PROJECT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(P.YTD_ACTUAL_MIN,0)/60.0 AS PROJECT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(C.CLIENT_ID,'') AS CLIENT_ELEMENT_ID, 
   COALESCE(C.BENEFIT_PERCENT,0) AS CLIENT_BENEFIT_PERCENT, 
   COALESCE(C.BENEFIT_AMOUNT,0.00) AS CLIENT_BENEFIT_AMOUNT, 
   COALESCE(C.BENEFIT_FLAG,0) AS CLIENT_BENEFIT_FLAG, 
   COALESCE(C.PAID_TODATE,0.00) AS CLIENT_PAID_TODATE, 
   COALESCE(CAT.CLIENT_ATTRIBUTES,(SELECT CLOB_DATA FROM EMPTYLOB)) AS CLIENT_ATTRIBUTES, /*...*/
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY, /*Proficiency*/
   
   COALESCE(A.BILLABLE,0) AS ASSGINMENT_BILLABLE, /*Billable*/
   COALESCE(A.SECURITY_ID,'') AS ASSIGNMENT_SECURITY_ID,
   COALESCE(A.SECURITY_NAME,'') AS ASSIGNMENT_SECURITY, /*Security Level*/
   COALESCE(A.REGULAR_COST,0.00) AS ASSIGNMENT_REGULAR_COST, /*Regular Cost*/
   COALESCE(A.REGULAR_RATE,0.00) AS ASSIGNMENT_REGULAR_RATE, /*Regular Rate*/
   COALESCE(A.SPECIAL_COST,0.00) AS ASSIGNMENT_SPECIAL_COST, /*Special Cost*/
   COALESCE(A.SPECIAL_RATE,0.00) AS ASSIGNMENT_SPECIAL_RATE, /*Special Rate*/
   TO_DATE(SubStr(COALESCE(A.START_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_START,
   TO_DATE(SubStr(COALESCE(A.FINISH_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_QS_FINISH,
   TO_DATE(SubStr(COALESCE(A.BASELINE1_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_START, /*Baseline (L) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE1_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_L_FINISH, /*Baseline (L) Finish*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_START, /*Baseline (I) Start*/
   TO_DATE(SubStr(COALESCE(A.BASELINE3_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_BASELINE_I_FINISH, /*Baseline (I) Finish*/
   TO_DATE(SubStr(COALESCE(A.PROPOSED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_START,
   TO_DATE(SubStr(COALESCE(A.PROPOSED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_PROPOSED_FINISH,
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_START, /*Schedule Start*/
   TO_DATE(SubStr(COALESCE(A.UNRESOLVED_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_SCHEDULE_FINISH, /*Schedule Finish*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_START,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_START, /*Actual Start*/
   TO_DATE(SubStr(COALESCE(A.ACTUAL_FINISH,TO_TIMESTAMP('1899-01-01 12:00:00.000000')), 1, 10)) AS ASSIGNMENT_ACTUAL_FINISH, /*Actual Finish*/
   
   COALESCE(A.BASELINE1_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(A.BASELINE3_WORK,0)/60.0 AS ASSIGNMENT_BASELINE_I_WORK, /*Baseline (Initial)*/
   COALESCE(A.SCHED_WORK,0)/60.0 AS ASSIGNMENT_PLANNED_WORK, /*Plan*/
   COALESCE(A.PLANNED_WORK,0)/60.0 AS ASSIGNMENT_PROPOSED_WORK, /*Proposed*/
   COALESCE(A.WORK_TODATE,0)/60.0 AS ASSIGNMENT_ACTUAL_WORK, /*Actual*/
   COALESCE(A.TD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_CUM_BASELINE_L, /*Baseline (L) from assignment start to selected start DATE*/
   COALESCE(A.TD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PLANNED, /*Planned from assignment start to selected start DATE*/
   COALESCE(A.TD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_CUM_PROPOSED, /*Proposed from assignment start to selected start DATE*/
   COALESCE(A.TD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_CUM_ACTUAL, /*Actual from assignment start to selected start DATE*/
   COALESCE(A.YTD_BASELINE_MIN,0)/60.0 AS ASSIGNMENT_YTD_BASELINE_L, /*Baseline (L) year to DATE*/
   COALESCE(A.YTD_SCHED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PLANNED, /*Planned year to DATE*/
   COALESCE(A.YTD_PLANNED_MIN,0)/60.0 AS ASSIGNMENT_YTD_PROPOSED, /*Proposed year to DATE*/
   COALESCE(A.YTD_ACTUAL_MIN,0)/60.0 AS ASSIGNMENT_YTD_ACTUAL, /*Actual year to DATE*/
   
   COALESCE(M.AVAILABLE_MIN,0)/60.0 AS MONTH_AVAILABLE, /*Available*/
   COALESCE(M.BASELINE_MIN,0)/60.0 AS MONTH_BASELINE_L_WORK, /*Baseline (Latest)*/
   COALESCE(M.SCHED_MIN,0)/60.0 AS MONTH_PLANNED_WORK, /*Plan*/
   COALESCE(M.PLANNED_MIN,0)/60.0 AS MONTH_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.ACTUAL_MIN,0)/60.0 AS MONTH_ACTUAL_WORK, /*Actual*/
   (COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/60.0 AS MONTH_REMAINING_WORK, /*Remaining*/
   
   COALESCE(M.BILLABLE_PLANNED_MIN,0)/60.0 AS MONTH_BILLABLE_PLANNED_WORK, /*Plan*/
   COALESCE(M.BILLABLE_SCHED_MIN,0)/60.0 AS MONTH_BILLABLE_PROPOSED_WORK, /*Proposed*/
   COALESCE(M.BILLABLE_ACTUAL_MIN,0)/60.0 AS MONTH_BILLABLE_ACTUAL_WORK, /*Actual*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.PLANNED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.ACTUAL_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_ACTUAL_RATIO, /*Actual*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.SCHED_MIN,0)+COALESCE(M.PLANNED_MIN,0)-COALESCE(M.ACTUAL_MIN,0))/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_REMAINING_RATIO, /*Remaining*/
   
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_SCHED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_BILLABLE_PLANNED_RATIO, /*Plan*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_PLANNED_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_BILLABLE_PROPOSED_RATIO, /*Proposed*/
   CASE WHEN COALESCE(M.AVAILABLE_MIN,0) = 0 THEN 0 ELSE ((COALESCE(M.BILLABLE_ACTUAL_MIN,0)*100)/ABS(COALESCE(M.AVAILABLE_MIN,0))) END AS MONTH_BILLABLE_ACTUAL_RATIO /*Actual*/
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_FLAT_PRJ_ATTR PAT
   ON PAT.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_CLIENTS C
   ON C.PROJECT_ID = P.ELEMENT_ID
   
   JOIN PMO_PVT_FLAT_CLIENT_ATTR CAT
   ON CAT.PROJECT_ID = C.PROJECT_ID
   AND CAT.CLIENT_ID = C.CLIENT_ID
   
   LEFT JOIN (	PMO_PVT_ASSIGNMENTS A 
   JOIN PMO_PVT_UTILIZATION M 
   ON M.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID 
   JOIN PMO_PVT_RESOURCES R 
   ON R.RESOURCE_ID = M.RESOURCE_ID ) 
   ON A.PROJECT_ID = P.ELEMENT_ID 
   
   ORDER BY P.RANK, C.CLIENT_NAME, R.FULL_NAME, M.FISCAL_MONTH_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_CLIENTS', 329+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_CLIENTS(330) : pivots.sql(3846) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPCLNPRJ;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 337+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(338) : pivots.sql(3854) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_CLIENTS', 349+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_CLIENTS(350) : pivots.sql(3866) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_CLIENTS;
ALTER FUNCTION SP_PVT_PROJECT_CLIENTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_RESOURCES ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_RESOURCES
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRJRES PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_RESOURCES(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RESOURCES', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_RESOURCES(32) : pivots.sql(3914) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_RESOURCES', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_RESOURCES(37) : pivots.sql(3919) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RESOURCES', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_RESOURCES(40) : pivots.sql(3922) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   OPEN COPRJRES FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_RESOURCE AS TYPE_ID,
   1 AS REF_TYPE,
   
   COALESCE(P.ELEMENT_ID,'') AS PROJECT_ELEMENT_ID,
   
   COALESCE(S.ELEMENT_ID,'') AS PROJECT_RESOURCE_ROLE_ID, 
   COALESCE(S.ELEMENT_NAME,'') AS PROJECT_RESOURCE_ROLE, 
   
   COALESCE(R.RESOURCE_ID,'') AS RESOURCE_ID,
   COALESCE(R.FULL_NAME,'') AS RESOURCE_NAME, /*Resource*/
   COALESCE(R.NICK_NAME,'') AS RESOURCE_NICK_NAME, /*Nick Name*/
   COALESCE(R.LOGON_NAME,'') AS RESOURCE_LOGON_NAME, /*Logon Name*/
   COALESCE(R.FIRST_NAME,'') AS RESOURCE_FIRST_NAME, /*First Name*/
   COALESCE(R.MIDDLE_NAME,'') AS RESOURCE_MIDDLE_NAME, /*Middle Name*/
   COALESCE(R.LAST_NAME,'') AS RESOURCE_LAST_NAME, /*Last Name*/
   COALESCE(R.E_MAIL_ADDRESS,'') AS RESOURCE_E_MAIL, /*E-mail Address*/
   COALESCE(R.EFFECTIVE_DATE,TO_DATE('1899-01-01')) AS RESOURCE_EFFECTIVE_DATE, /*Effective DATE*/
   COALESCE(R.WORK_LOCATION,0) AS RESOURCE_WORK_LOCATION, /*Work Location*/
   COALESCE(R.STATUS1_ID,0) AS RESOURCE_WORKING_STATUS, /*Working Status*/
   COALESCE(R.STATUS2_ID,0) AS RESOURCE_EMPLOYEE_STATUS, /*Employee Status*/
   COALESCE(R.MAXDAYHRS,0) AS RESOURCE_MAX_WEEKLY_HOURS,  /*Weekly Max Hours*/
   COALESCE(R.FS_CODE,'') AS RESOURCE_FS_CODE,
   COALESCE(R.COUNTRY_CODE,'') AS RESOURCE_COUNTRY_CODE, /*Country Code*/
   COALESCE(R.COMPANY_CODE,'') AS RESOURCE_COMPANY_CODE, /*Company Code*/
   COALESCE(R.DIVISION_CODE,'') AS RESOURCE_DIVISION_CODE, /*Division Code*/
   COALESCE(R.DEPARTMENT_CODE,'') AS RESOURCE_DEPARTMENT_CODE, /*Department Code*/
   COALESCE(R.EMPLOYEE_CODE,'') AS RESOURCE_EMPLOYEE_CODE, /*Employee Code*/
   COALESCE(R.CUSTOM_01,'') AS RESOURCE_CUSTOM_01, /*Custom field 1*/
   COALESCE(R.CUSTOM_02,'') AS RESOURCE_CUSTOM_02, /*Custom field 2*/
   COALESCE(R.CUSTOM_03,'') AS RESOURCE_CUSTOM_03, /*Custom field 3*/
   COALESCE(R.CUSTOM_04,'') AS RESOURCE_CUSTOM_04, /*Custom field 4*/
   COALESCE(R.CUSTOM_05,'') AS RESOURCE_CUSTOM_05, /*Custom field 5*/
   COALESCE(R.CURRENCY_ID,0) AS RESOURCE_CURRENCY_ID, /*Currency*/
   COALESCE(R.POOL_ID,'') AS RESOURCE_POOL_ID,
   COALESCE(R.POOL_NAME,'') AS RESOURCE_POOL_NAME, /*Pool*/
   COALESCE(R.POOL_MANAGER_ID,'') AS RESOURCE_POOL_MANAGER_ID,
   COALESCE(R.POOL_MANAGER_NAME,'') AS RESOURCE_POOL_MANAGER, /*Resource Manager*/
   COALESCE(R.ORGANIZATION_ID,'') AS RESOURCE_ORGANIZATION_ID,
   COALESCE(R.ORGANIZATION_NAME,'') AS RESOURCE_ORGANIZATION_NAME, /*Organaization*/
   COALESCE(R.GEOGRAPHY_ID,'') AS RESOURCE_GEOGRAPHY_ID,
   COALESCE(R.GEOGRAPHY_NAME,'') AS RESOURCE_GEOGRAPHY_NAME, /*Geographical Location*/
   COALESCE(R.PRIMARY_COMPETENCY_ID,'') AS RESOURCE_DEFAULT_COMPETENCY_ID,
   COALESCE(R.PRIMARY_COMPETENCY_NAME,'') AS RESOURCE_DEFAULT_COMPETENCY, /*Competency*/
   COALESCE(R.PRIMARY_PROFICIENCY_ID,'') AS RESOURCE_PROFICIENCY_ID, /*Proficiency*/
   COALESCE(R.PRIMARY_PROFICIENCY_NAME,'') AS RESOURCE_PROFICIENCY /*Proficiency*/
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN RESOURCE_ASSIGNMENTS RA 
   ON RA.ELEMENT_ID = P.ELEMENT_ID 
   
   JOIN TMT_GLOBAL_SECURITY S 
   ON S.ELEMENT_ID = RA.SECURITY_ID 
   
   JOIN PMO_PVT_RESOURCES R
   ON R.RESOURCE_ID = RA.RESOURCE_ID
   
   ORDER BY P.RANK, R.FULL_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_RESOURCES', 127+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_RESOURCES(128) : pivots.sql(4010) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRJRES;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RESOURCES', 135+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RESOURCES(136) : pivots.sql(4018) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_RESOURCES', 147+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_RESOURCES(148) : pivots.sql(4030) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_RESOURCES;
ALTER FUNCTION SP_PVT_PROJECT_RESOURCES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_SCORECARDS ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_SCORECARDS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRJSCD PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_SCORECARDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_SCORECARDS'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_SCORECARDS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_SCORECARDS', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_SCORECARDS(32) : pivots.sql(4078) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_SCORECARDS', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_SCORECARDS(37) : pivots.sql(4083) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_SCORECARDS', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_SCORECARDS(40) : pivots.sql(4086) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   OPEN COPRJSCD FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_SCORECARD AS TYPE_ID,
   
   1 AS REF_TYPE,
   P.RANK AS PROJECT_RANK, 
   SCD.RANK AS SCORECARD_RANK, 
   
   P.ELEMENT_ID AS PROJECT_ELEMENT_ID,
   
   SCD.ELEMENT_ID AS SCORECARD_ID, 
   SCD.ELEMENT_NAME AS SCORECARD, 
   
   SCD.ORIGINAL_ID, 
   SCD.ELEMENT_ID AS CATEGORY_ID, 
   SCD.ELEMENT_NAME AS CATEGORY, 
   SCD.DESCRIPTION AS DESCRIPTION, 
   '' AS ANSWER_COMMENT, 
   R.FULL_NAME AS AUTHOR, 
   HPS.REC_DATETIME AS REC_DATETIME,  
   
   HPS.MAJOR_REVISION AS SCORECARD_VERSION, 
   SUM(HPS.CONVERTED_SCORE) AS SCORE, 
   SCD.CONVERTED_WEIGHT AS WEIGHT, 
   CASE WHEN SCD.CONVERTED_WEIGHT = 0.00 THEN 0 ELSE ((PMO_ORASTD.TODECIMAL(SUM(HPS.CONVERTED_SCORE),18,2)/SCD.CONVERTED_WEIGHT)*10000) END AS RATING_SCORE,
   P.ELEMENT_NAME AS PROJECT_NAME
   
   FROM PMO_PVT_PROJECTS P
   JOIN HISTORY_PUBLISHED_SCORECARDS HPS 
   ON HPS.PROJECT_ID = P.ELEMENT_ID 
   AND HPS.SELECTED_ANSWER = 'Y'
   JOIN TMT_PUBLISHED_SCORECARDS SCD 
   ON SCD.ELEMENT_ID = HPS.SCORECARD_ID 
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = SCD.REC_USER  
   GROUP BY    P.RANK, 
   P.ELEMENT_ID, 
   P.ELEMENT_NAME,
   SCD.RANK, 
   SCD.ORIGINAL_ID, 
   SCD.ELEMENT_ID, 
   SCD.ELEMENT_NAME, 
   SCD.CONVERTED_WEIGHT, 
   SCD.REC_DATETIME, 
   SCD.DESCRIPTION, 
   R.FULL_NAME, 
   HPS.MAJOR_REVISION ,
   HPS.REC_DATETIME
   
   UNION ALL 
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   PMO_CNST.SC_SCORECARD AS TYPE_ID,
   
   2 AS REF_TYPE,
   P.RANK AS PROJECT_RANK, 
   SCG.RANK AS SCORECARD_RANK, 
   
   P.ELEMENT_ID AS PROJECT_ELEMENT_ID,
   
   SCD.ELEMENT_ID AS SCORECARD_ID, 
   SCD.ELEMENT_NAME AS SCORECARD, 
   
   SCG.ORIGINAL_ID, 
   SCG.ELEMENT_ID AS CATEGORY_ID, 
   SCG.ELEMENT_NAME AS CATEGORY, 
   SCG.DESCRIPTION AS DESCRIPTION, 
   COALESCE(HPS.DESCRIPTION,'') AS ANSWER_COMMENT, 
   R.FULL_NAME AS AUTHOR, 
   HPS.REC_DATETIME AS REC_DATETIME,  
   
   HPS.MAJOR_REVISION AS SCORECARD_VERSION, 
   SUM(HPS.CONVERTED_SCORE) AS SCORE, 
   SCG.CONVERTED_WEIGHT AS WEIGHT, 
   CASE WHEN SCG.CONVERTED_WEIGHT = 0.00 THEN 0 ELSE ((PMO_ORASTD.TODECIMAL(SUM(HPS.CONVERTED_SCORE),18,2)/SCG.CONVERTED_WEIGHT)*10000) END AS RATING_SCORE,
   P.ELEMENT_NAME AS PROJECT_NAME
   
   FROM PMO_PVT_PROJECTS P
   JOIN HISTORY_PUBLISHED_SCORECARDS HPS 
   ON HPS.PROJECT_ID = P.ELEMENT_ID 
   AND HPS.SELECTED_ANSWER = 'Y'
   JOIN TMT_PUBLISHED_SCORECARDS SCD 
   ON SCD.ELEMENT_ID = HPS.SCORECARD_ID 
   JOIN TMT_PUBLISHED_SCORECARDS SCG 
   ON SCG.ELEMENT_ID = HPS.CATEGORY_ID 
   LEFT JOIN TMT_PUBLISHED_SCORECARDS SCQ 
   ON SCQ.SCORECARD_ID = HPS.SCORECARD_ID 
   AND SCQ.CATEGORY_ID = HPS.CATEGORY_ID 
   AND SCQ.REPORT_FLAG = 1 
   LEFT JOIN TMT_PUBLISHED_SCORECARDS SCA 
   ON SCA.SCORECARD_ID = SCQ.SCORECARD_ID 
   AND SCA.CATEGORY_ID = SCQ.CATEGORY_ID 
   AND SCA.PARENT_ID = SCQ.ELEMENT_ID 
   AND SCA.SELECTED_ANSWER = 'Y'    
   JOIN RESOURCES R 
   ON R.RESOURCE_ID = SCG.REC_USER 
   GROUP BY    P.RANK, 
   P.ELEMENT_ID, 
   P.ELEMENT_NAME,
   SCD.RANK, 
   SCG.RANK, 
   SCD.ELEMENT_ID, 
   SCG.ORIGINAL_ID, 
   SCG.ELEMENT_ID, 
   SCD.ELEMENT_NAME, 
   SCG.ELEMENT_NAME, 
   SCG.CONVERTED_WEIGHT, 
   SCG.REC_DATETIME, 
   SCG.DESCRIPTION, 
   SCA.DESCRIPTION, 
   R.FULL_NAME, 
   HPS.MAJOR_REVISION ,
   HPS.REC_DATETIME,
   HPS.DESCRIPTION
   ORDER BY	PROJECT_RANK, 
   SCORECARD_RANK,
   SCORECARD_VERSION, 
   REF_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_SCORECARDS', 183+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_SCORECARDS(184) : pivots.sql(4230) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRJSCD;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_SCORECARDS', 191+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_SCORECARDS(192) : pivots.sql(4238) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_SCORECARDS', 203+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_SCORECARDS(204) : pivots.sql(4250) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_SCORECARDS;
ALTER FUNCTION SP_PVT_PROJECT_SCORECARDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_PROJECT_FINANCIAL ==
CREATE OR REPLACE FUNCTION SP_PVT_PROJECT_FINANCIAL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      COPRJFIN PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_PROJECT_FINANCIAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_PROJECT_FINANCIAL'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_PROJECT_FINANCIAL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_FINANCIAL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_PROJECT_FINANCIAL(32) : pivots.sql(4298) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_PROJECT_FINANCIAL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_PROJECT_FINANCIAL(37) : pivots.sql(4303) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_FINANCIAL', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_FINANCIAL(40) : pivots.sql(4306) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FINANCIAL();
   
   OPEN COPRJFIN FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   1 AS TYPE_ID,
   1 AS REF_TYPE,
   
   P.ELEMENT_ID AS PROJECT_ELEMENT_ID,  
   
   PF.ROW_TYPE, 
   PF.C_FT_BASELINE_I, 
   PF.C_FT_BASELINE_L, 
   PF.C_FT_ESTIMATE, 
   PF.C_FT_ACTUAL, 
   PTB.C_TOTAL_ETC AS C_FT_ETC, 
   PTB.C_TOTAL_EAC AS C_FT_EAC, 
   
   PF.C_WS_BASELINE_I, 
   PF.C_WS_BASELINE_L, 
   PF.C_WS_ESTIMATE, 
   PF.C_WS_ACTUAL, 
   PB.C_ESTIMATED_ETC AS C_WS_ETC, 
   PB.C_ESTIMATED_ETC + PB.C_ESTIMATED_ACTUAL AS C_WS_EAC,  
   
   PF.C_WBS_BASELINE_I, 
   PF.C_WBS_BASELINE_L, 
   PF.C_WBS_ESTIMATE, 
   PF.C_WBS_ACTUAL, 
   PB.C_ETC AS C_WBS_ETC, 
   PB.C_ETC + PB.C_ACTUAL AS C_WBS_EAC,  
   
   PF.R_FT_BASELINE_I, 
   PF.R_FT_BASELINE_L1, 
   PF.R_FT_ESTIMATE2, 
   PF.R_FT_ACTUAL3, 
   PTB.R_TOTAL_ETC AS R_FT_ETC, 
   PTB.R_TOTAL_EAC AS R_FT_EAC, 
   
   PF.R_WS_BASELINE_I, 
   PF.R_WS_BASELINE_L, 
   PF.R_WS_ESTIMATE, 
   PF.R_WS_ACTUAL, 
   PB.R_ESTIMATED_ETC AS R_WS_ETC, 
   PB.R_ESTIMATED_ETC + PB.R_ESTIMATED_ACTUAL AS R_WS_EAC,  
   
   PF.R_WBS_BASELINE_I, 
   PF.R_WBS_BASELINE_L, 
   PF.R_WBS_ESTIMATE, 
   PF.R_WBS_ACTUAL, 
   PB.R_ETC AS R_WBS_ETC, 
   PB.R_ETC + PB.R_ACTUAL AS R_WBS_EAC,
   
   PTB.H_C_TOTAL_ETC AS H_C_FT_ETC, 
   PTB.H_C_TOTAL_EAC AS H_C_FT_EAC, 
   PTB.H_R_TOTAL_ETC AS H_R_FT_ETC, 
   PTB.H_R_TOTAL_EAC AS H_R_FT_EAC, 
   
   PF.H_C_WS_ESTIMATE AS H_C_WS_ESTIMATE,
   PF.H_C_WS_ACTUAL,				
   PB.H_C_ESTIMATED_ETC AS H_C_WS_ETC,
   PB.H_C_ESTIMATED_ETC + PB.H_C_ESTIMATED_ACTUAL AS H_C_WS_EAC,
   
   PF.H_R_WS_ACTUAL,
   PF.H_R_WS_ESTIMATE,
   PB.H_R_ESTIMATED_ETC AS H_R_WS_ETC,
   PB.H_R_ESTIMATED_ETC + PB.H_R_ESTIMATED_ACTUAL AS H_R_WS_EAC,
   
   PF.H_C_WBS_ACTUAL,
   PF.H_C_WBS_ESTIMATE,
   PB.H_C_ETC AS H_C_WBS_ETC,
   PB.H_C_ETC + PB.H_C_ACTUAL AS H_C_WBS_EAC,
   
   PF.H_R_WBS_ACTUAL,
   PF.H_R_WBS_ESTIMATE,
   PB.H_R_ETC AS H_R_WBS_ETC,
   PB.H_R_ETC + PB.H_R_ACTUAL AS H_R_WBS_EAC
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_PROJECT_BUDGET PB 
   ON PB.PROJECT_ID = P.ELEMENT_ID 
   JOIN PMO_PVT_PROJECT_TOTAL_BUDGET PTB 
   ON PTB.PROJECT_ID = P.ELEMENT_ID
   JOIN PMO_PVT_FINANCIAL PF 
   ON PF.PROJECT_ID = P.ELEMENT_ID 
   ORDER BY P.ELEMENT_ID, PF.ROW_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_PROJECT_FINANCIAL', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_PROJECT_FINANCIAL(149) : pivots.sql(4415) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COPRJFIN;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_FINANCIAL', 156+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_FINANCIAL(157) : pivots.sql(4423) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_PROJECT_FINANCIAL', 168+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_PROJECT_FINANCIAL(169) : pivots.sql(4435) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_PROJECT_FINANCIAL;
ALTER FUNCTION SP_PVT_PROJECT_FINANCIAL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_ASSIGNMENT_EV ==
CREATE OR REPLACE FUNCTION SP_PVT_ASSIGNMENT_EV
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR COASSIGNEV1 IS
         SELECT COALESCE(FISCAL_WEEK_START, h_start_date) 
         FROM PMO_PVT_FISCAL_CALENDAR
         WHERE FISCAL_WEEK_START <= h_start_date
         ORDER BY FISCAL_WEEK_START;

      CURSOR COASSIGNEV2 IS
         SELECT COALESCE(FISCAL_WEEK_FINISH, h_finish_date) 
         FROM PMO_PVT_FISCAL_CALENDAR
         WHERE FISCAL_WEEK_FINISH >= h_finish_date
         ORDER BY FISCAL_WEEK_FINISH;

      -- Resultset Cursor Declaration
      COASSIGNEV PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_ASSIGNMENT_EV') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_ASSIGNMENT_EV'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_ASSIGNMENT_EV(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_ASSIGNMENT_EV', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_ASSIGNMENT_EV(44) : pivots.sql(4495) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_ASSIGNMENT_EV', 48+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_ASSIGNMENT_EV(49) : pivots.sql(4500) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_ASSIGNMENT_EV', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_ASSIGNMENT_EV(52) : pivots.sql(4503) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   h_init_type := PMO_CNST.SC_INI_TSK_REENT_NO;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_TASKS(h_init_type);
   
   BEGIN
      SELECT MIN(TO_DATE(SubStr(COALESCE(BASELINE1_START,START_DT), 1, 10))), MAX(TO_DATE(SubStr(COALESCE(BASELINE1_FINISH,FINISH_DT), 1, 10)))
      INTO h_start_date, h_finish_date
      FROM PMO_PVT_TASKS;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_ASSIGNMENT_EV', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_ASSIGNMENT_EV(87) : pivots.sql(4538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_FC_WEEKLY;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_FISCAL_CALENDAR(h_init_type, h_start_date, h_finish_date);
   
   /* DB2 V8
   	// get the week start
       BEGIN_SQL
           SELECT COALESCE(FISCAL_WEEK_START, HOST(h_start_date)) 
           INTO HOST(h_start_date)
           FROM SESSION.PMO_PVT_FISCAL_CALENDAR
   		WHERE FISCAL_WEEK_START <= HOST(h_start_date)
   		ORDER BY FISCAL_WEEK_START 
   		FETCH FIRST 1 ROWS ONLY;
       END_SQL;
   
   	// get the week finish
       BEGIN_SQL
           SELECT COALESCE(FISCAL_WEEK_FINISH, HOST(h_finish_date)) 
           INTO HOST(h_finish_date)
           FROM SESSION.PMO_PVT_FISCAL_CALENDAR
   		WHERE FISCAL_WEEK_FINISH >= HOST(h_finish_date)
   		ORDER BY FISCAL_WEEK_FINISH  
   		FETCH FIRST 1 ROWS ONLY;
       END_SQL;
   	*/
   
   -- get the week start
   
   OPEN COASSIGNEV1;
   
   FETCH COASSIGNEV1 INTO h_start_date;
   IF COASSIGNEV1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE COASSIGNEV1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_ASSIGNMENT_EV', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_ASSIGNMENT_EV(136) : pivots.sql(4587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- get the week finish
   
   OPEN COASSIGNEV2;
   
   FETCH COASSIGNEV2 INTO h_finish_date;
   IF COASSIGNEV2%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE COASSIGNEV2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_ASSIGNMENT_EV', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_ASSIGNMENT_EV(160) : pivots.sql(4611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_init_type := PMO_CNST.SC_INI_RES_BY_PRJ;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_RESOURCES(h_init_type, h_ids, h_start_date, h_finish_date
                                           , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_ASG_BY_RES;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_ASSIGNMENTS(h_init_type, h_start_date, h_finish_date);
   
   OPEN COASSIGNEV FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   1 AS TYPE_ID,
   1 AS REF_TYPE,
   
   h_start_date AS RANGE_START, 
   h_finish_date AS RANGE_FINISH, 
   
   P.OPPORTUNITY_NAME AS CLIENT,
   P.ELEMENT_NAME AS PROJECT,
   CASE WHEN D.ELEMENT_ID = P.ELEMENT_ID THEN '' ELSE D.ELEMENT_NAME END AS DELIVERABLE,
   T.ELEMENT_NAME AS TASK,
   T.ELEMENT_ID AS TASK_ID,
   R.POOL_NAME AS POOL,
   R.FULL_NAME AS RESOURCE_FULLNAME,
   COALESCE(ST.WEEK_OF, TO_DATE('1899-12-30')) AS WEEK_OF,
   COALESCE(ST.BAC, 0.00) AS BAC,
   COALESCE(ST.EAC, 0.00) AS EAC,
   COALESCE((ST.BAC - ST.EAC), 0.00) AS VAC,
   COALESCE(ST.BCWS, 0.00) AS BCWS,
   COALESCE(ST.BCWP, 0.00) AS BCWP,
   COALESCE(ST.ACWP, 0.00) AS ACWP,
   COALESCE((ST.BCWP - ST.ACWP), 0.00) AS CV,
   COALESCE((ST.BCWP - ST.BCWS), 0.00) AS SV,
   CASE WHEN ST.ACWP > 0.00 THEN PMO_ORASTD.TODECIMAL((ST.BCWP / ST.ACWP), 18, 2) ELSE 0.00 END AS CPI,
   CASE WHEN ST.BCWS > 0.00 THEN PMO_ORASTD.TODECIMAL((ST.BCWP / ST.BCWS), 18, 2) ELSE 0.00 END AS SPI,
   PMO_ORASTD.TODECIMAL((CASE WHEN ST.ACWP > 0.00 THEN PMO_ORASTD.TODECIMAL((ST.BCWP / ST.ACWP), 18, 2) ELSE 0.00 END)*(CASE WHEN ST.BCWS > 0.00 THEN PMO_ORASTD.TODECIMAL((ST.BCWP / ST.BCWS), 18, 2) ELSE 0.00 END), 18, 2) AS CRITICAL_RATIO,
   COALESCE(CASE WHEN ST.EV_ETC > 0.00 THEN ST.EV_ETC ELSE ST.EAC - ST.ACWP END, 0.00) AS EV_ETC
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN PMO_PVT_TASKS T
   ON T.PROJECT_ID = P.ELEMENT_ID 
   
   JOIN TMT_WBS D 
   ON D.PROJECT_ID = T.PROJECT_ID 
   AND D.RANK = PMO_ORASTD.LEFT(T.RANK,LENGTH(T.RANK)-4) 
   
   JOIN PMO_PVT_ASSIGNMENTS A 
   ON A.TASK_ID = T.ELEMENT_ID 
   
   JOIN SUMMARY_TIMESHEETS ST  
   ON ST.PROJECT_ID = A.PROJECT_ID 
   AND ST.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID 
   
   JOIN PMO_PVT_RESOURCES R  
   ON R.RESOURCE_ID = A.RESOURCE_ID 
   
   ORDER BY P.RANK, T.RANK, R.FULL_NAME, ST.WEEK_OF;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_ASSIGNMENT_EV', 222+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_ASSIGNMENT_EV(223) : pivots.sql(4674) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COASSIGNEV;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_ASSIGNMENT_EV', 230+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_ASSIGNMENT_EV(231) : pivots.sql(4682) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_ASSIGNMENT_EV', 242+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_ASSIGNMENT_EV(243) : pivots.sql(4694) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_ASSIGNMENT_EV;
ALTER FUNCTION SP_PVT_ASSIGNMENT_EV COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PVT_WBS_EV ==
CREATE OR REPLACE FUNCTION SP_PVT_WBS_EV
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_init_type PLS_INTEGER := 0;
   h_init_type_str VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      COWBSEV PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PVT_WBS_EV') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PVT_WBS_EV'), '-- ' || SYSTIMESTAMP, ':r := SP_PVT_WBS_EV(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_WBS_EV', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PVT_WBS_EV(33) : pivots.sql(4743) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PVT_WBS_EV', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PVT_WBS_EV(38) : pivots.sql(4748) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_WBS_EV', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_WBS_EV(41) : pivots.sql(4751) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_init_type_str := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PIVOT();
   
   h_init_type := h_type;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECT_IDS(h_init_type, h_ids, h_start_date, h_finish_date
                                             , h_rec_user);
   
   h_init_type := PMO_CNST.SC_INI_PRJ_BY_RANK;
   PMO_DB2M.SC_STATE := FC_PVT_INIT_PROJECTS(h_init_type);
   
   BEGIN
      SELECT Trunc(h_init_type_str) INTO h_init_type FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_WBS_EV', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_WBS_EV(72) : pivots.sql(4782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN COWBSEV FOR SELECT  T.ELEMENT_ID AS ELEMENT_ID,
   T.ELEMENT_NAME AS ELEMENT_NAME,
   T.LEVEL_ID AS LEVEL_ID,
   T.TYPE_ID AS TYPE_ID,
   1 AS REF_TYPE,
   
   CASE WHEN T.MILESTONE_PERCENT = 0 THEN 3 WHEN T.MILESTONE_PERCENT = 10000 THEN 2 ELSE 1 END AS R_STATUS,
   T.WBS_CODE,
   T.START_DT,
   T.FINISH_DT,
   T.BASELINE1_START,
   T.BASELINE1_FINISH,
   T.PROPOSED_START,
   T.PROPOSED_FINISH,
   T.SCHED_START,
   T.SCHED_FINISH,
   T.ACTUAL_START,
   T.ACTUAL_FINISH,
   T.MILESTONE_PERCENT,
   T.BASELINE1_EFFORT,
   T.WORK_TODATE,
   CASE WHEN T.BASELINE1_EFFORT = 0 THEN 0 ELSE Trunc((PMO_ORASTD.TODECIMAL(T.WORK_TODATE,18,2)/T.BASELINE1_EFFORT)*10000) END AS PERCENT_SPENT,
   T.BAC, 
   T.BASELINE1_DURATION AS SAC, 
   T.BCWS, 
   T.BCWP, 
   T.ACWP, 
   T.EV_ETC, 
   T.EAC, 
   T.TIME_VARIANCE AS TV,  
   (T.BAC - T.EAC) AS VAC, 
   (T.BCWP - T.ACWP) AS CV, 
   (T.BCWP - T.BCWS) AS SV, 
   CASE WHEN T.BAC = 0.00 THEN 0 ELSE (T.BCWP/T.BAC)*100 END AS PC, 
   CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END AS CPI, 
   CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END AS SPI, 
   PMO_ORASTD.TODECIMAL((CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END)*(CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END), 18, 2) AS CRITICAL_RATIO, 
   CASE WHEN (T.BAC-T.ACWP) = 0 THEN 0 ELSE (T.BAC-T.BCWP)/(T.BAC-T.ACWP) END AS TCPI, 
   T.BAC*((CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END) - 1) AS SVAC_SPI, 
   T.BAC*((PMO_ORASTD.TODECIMAL(((CASE WHEN T.ACWP = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.ACWP), 18, 2) END)*(CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END)), 18, 2)) - 1) AS SVAC_CR, 
   CASE WHEN T.BASELINE1_DURATION = 0 THEN 0 ELSE T.BASELINE1_DURATION - (CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END) END AS TEAC, 
   CASE WHEN T.BASELINE1_DURATION = 0 THEN 0 ELSE T.BASELINE1_DURATION - (T.BASELINE1_DURATION - (CASE WHEN T.BCWS = 0.00 THEN 0.00 ELSE PMO_ORASTD.TODECIMAL((T.BCWP / T.BCWS), 18, 2) END)) END AS TVAC, 
   T.BASELINE1_FINISH AS ECD 
   
   FROM PMO_PVT_PROJECTS P
   
   JOIN TMT_WBS T 
   ON T.PROJECT_ID = P.ELEMENT_ID 
   AND T.LEVEL_ID <= P.LEVEL_ID + h_init_type
   AND T.BASELINE1_EFFORT > 0
   
   ORDER BY R_STATUS, T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PVT_WBS_EV', 129+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PVT_WBS_EV(130) : pivots.sql(4840) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN COWBSEV;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_WBS_EV', 137+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_WBS_EV(138) : pivots.sql(4848) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PVT_WBS_EV', 149+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PVT_WBS_EV(150) : pivots.sql(4860) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PVT_WBS_EV;
ALTER FUNCTION SP_PVT_WBS_EV COMPILE DEBUG;

