/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_CAL ==
CREATE OR REPLACE FUNCTION SP_U_RES_CAL
(
     p_resource_id VARCHAR2
   , p_calendar_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_var PLS_INTEGER := 0;
   h_calendar_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_effective_date DATE;
   h_discontinue_date DATE;
   h_end_year PLS_INTEGER := 0;
   h_end_month PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_mpw PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_fiscal_finish_year PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_CAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_CAL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_CAL(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_calendar_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAL', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_CAL(38) : resource.sql(41) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_calendar_id IS NULL) OR (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_CAL', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_CAL(44) : resource.sql(47) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAL', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAL(47) : resource.sql(50) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   --Start
   --Finish
   -- effective date
   -- effective date
   
   h_calendar_id := p_calendar_id;
   
   BEGIN
      SELECT MINUTES_PER_DAY, MINUTES_PER_WEEK INTO h_mpd, h_mpw
      FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(69) : resource.sql(72) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_resource_id := p_resource_id;
   
   BEGIN
      SELECT COALESCE(EFFECTIVE_DATE,TO_DATE(SYSDATE)), DISCONTINUE_DATE, REC_STATUS INTO h_effective_date, h_discontinue_date, h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(85) : resource.sql(88) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAL', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAL(92) : resource.sql(95) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAL', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAL(95) : resource.sql(98) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_CAL', 100+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_CAL(101) : resource.sql(104) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_ACTIVE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAL', 103+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAL(104) : resource.sql(107) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RESOURCE_NOT_ACTIVE, True);
   Else
      BEGIN
         UPDATE RESOURCES SET
         CALENDAR_ID = h_resource_id,
         MAXDAYHRS = h_mpw/60,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 123+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(124) : resource.sql(127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET
         CALENDAR_ID = h_resource_id,
         MINUTE_PER_DAY = h_mpd,
         MINUTE_PER_WEEK = h_mpw,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 145+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(146) : resource.sql(149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_SD := h_effective_date;
      
      If (h_discontinue_date IS NOT NULL) Then
         h_FD := h_discontinue_date;
      Else
         BEGIN
            SELECT Add_Months(TO_DATE(SubStr(h_effective_date, 1, 10)), 3 * 12) INTO h_FD
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 164+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(165) : resource.sql(168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_end_year := 0;
         BEGIN
            BEGIN
               SELECT FISCAL_YEAR, FISCAL_MONTH INTO h_end_year, h_end_month 
                       FROM FISCAL_CALENDAR WHERE h_FD BETWEEN START_DATE AND FINISH_DATE;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 180+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(181) : resource.sql(184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAL', 186+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAL(187) : resource.sql(190) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR), 'NULL'));
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAL', 189+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAL(190) : resource.sql(193) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR, h_FD, True);
            End If;
         END;
         
         If Coalesce(h_end_year, 0) <> 0 Then
            BEGIN
               SELECT FINISH_DATE INTO h_FD FROM FISCAL_CALENDAR WHERE FISCAL_YEAR = h_end_year AND FISCAL_MONTH = 12;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 204+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(205) : resource.sql(208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --trace_printf("("h_SD: %s, h_FD: %s\n", h_SD,h_SD);
      End If;
      
      --trace_printf("("***, h_SD: %s, h_FD: %s\n", h_SD,h_FD);
      BEGIN
         SELECT TO_DATE(SubStr(h_SD, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_SD) - 6)     ,
         TO_DATE(SubStr(h_FD, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_FD) + 1)     
         INTO h_SD, h_FD
         FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 224+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(225) : resource.sql(228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("("SC_STATE: %d, h_SD: %s, h_FD: %s\n", SC_STATE,h_SD,h_FD);
      
      h_temp_var := 0;
      h_temp_sc_state := PROJECT_CALENDAR(h_resource_id, h_calendar_id, h_SD, h_FD, h_temp_var);
   End If;
   
   If Coalesce(h_temp_sc_state, 0) = 0 Then
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK) || '0001'
         INTO h_project_id, h_rank
         FROM TMT_WBS
         WHERE POOL_ID = h_resource_id
         AND TYPE_ID = PMO_CNST.SC_RESOURCE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 247+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(248) : resource.sql(251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, CHILD_COUNT
         INTO h_parent_id, h_count
         FROM TMT_WBS
         WHERE RANK = h_rank;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 263+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(264) : resource.sql(267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET
         CALENDAR_ID = h_resource_id,
         START_DT = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SD, 1, 10)), PMO_ORASTD.TIME('08:00')),
         FINISH_DT = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SD, 1, 10)), PMO_ORASTD.TIME('17:00')),
         PLANNED_START = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SD, 1, 10)), PMO_ORASTD.TIME('08:00')),
         PLANNED_FINISH = PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SD, 1, 10)), PMO_ORASTD.TIME('17:00')),
         DURATION = 0,
         START_FINISH_DATE = h_SD,
         MINUTE_PER_DAY = h_mpd,
         MINUTE_PER_WEEK = h_mpw,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 291+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(292) : resource.sql(295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(h_count, 0) = 0) Then
         h_rec_user := h_resource_id;
         PMO_DB2M.SC_STATE := FC_POPULATE_RES_AT(h_resource_id, h_parent_id, h_project_id, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_CAL', 303+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_CAL(304) : resource.sql(307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 310+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(311) : resource.sql(314) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAL', 322+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAL(323) : resource.sql(326) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_CAL;
ALTER FUNCTION SP_U_RES_CAL COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_CKOUT_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_CKOUT_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_id2 VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_RESOURCE(21) : resource.sql(363) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 25+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(26) : resource.sql(368) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_RESOURCE(29) : resource.sql(371) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 34+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(35) : resource.sql(377) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_RESOURCE(38) : resource.sql(380) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_rec_user, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT RESOURCE_ID, REC_STATUS
      INTO h_id2, h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(55) : resource.sql(397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(62) : resource.sql(404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_RESOURCE(65) : resource.sql(407) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 71+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(72) : resource.sql(414) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_RESOURCE(75) : resource.sql(417) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_OUT, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(82) : resource.sql(424) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_RESOURCE(85) : resource.sql(427) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_RESOURCE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_RESOURCE(92) : resource.sql(434) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_RESOURCE', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_RESOURCE(95) : resource.sql(437) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id2, True);
   End If;
   
   --Execute UPDATE Statement; REC_STATUS = 'O' is checked out
   BEGIN
      UPDATE RESOURCES SET
      REC_STATUS = 'O',
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(117) : resource.sql(459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_RESOURCE', 122+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_RESOURCE(123) : resource.sql(465) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 129+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(130) : resource.sql(472) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_RESOURCE', 141+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_RESOURCE(142) : resource.sql(484) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_RESOURCE;
ALTER FUNCTION SP_CKOUT_RESOURCE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_CKIN_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_CKIN_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
   h_bitflag PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = p_resource_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_RESOURCE(29) : resource.sql(529) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 33+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(34) : resource.sql(534) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_RESOURCE(37) : resource.sql(537) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(51) : resource.sql(551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 57+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(58) : resource.sql(558) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_RESOURCE(61) : resource.sql(561) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_resource_id, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_id), p_resource_id, ind_ckout_res->p_resource_id);
   h_id := p_resource_id;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 70+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(71) : resource.sql(571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 73+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_RESOURCE(74) : resource.sql(574) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'I' OR SubStr(h_rec_status, 1, 1) = 'U' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 80+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(81) : resource.sql(581) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_RESOURCE(84) : resource.sql(584) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_IN, h_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' OR SubStr(h_rec_status, 1, 1) = 'A' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_RESOURCE', 90+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_RESOURCE(91) : resource.sql(591) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_RESOURCE', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_RESOURCE(94) : resource.sql(594) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id, True);
   End If;
   
   -- **************************************************************************************
   -- h_max_revision   = 0 MINOR_REVISION = MINOR_REVISION + 1
   --          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --          = 2 check in as the same revision
   -- **************************************************************************************
   --SC_LONG(h_bitflag);
   --InitializeHost(SC_PARAM(h_bitflag), *p_bitflag, ind_ckout_res->p_bitflag);
   h_bitflag := p_bitflag;
   
   OPEN CH1;
   
   FETCH CH1 INTO h_min_revision;
   IF CH1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(126) : resource.sql(626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         UPDATE RESOURCES SET
         VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
         VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 146+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(147) : resource.sql(647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 159+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(160) : resource.sql(660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_bitflag, 0) = 0 Then
         BEGIN
            UPDATE RESOURCES SET
            VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
            VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
            MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
            WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 183+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(184) : resource.sql(684) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         BEGIN
            UPDATE RESOURCES SET
            VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
            VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            MAJOR_REVISION = MAJOR_REVISION + 1,
            MINOR_REVISION = 0
            WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 207+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(208) : resource.sql(708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         BEGIN
            UPDATE RESOURCES SET
            VERIFIED_1 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_1 END,
            VERIFIED_2 = CASE WHEN RTRIM(p_resource_id) = RTRIM(p_rec_user) THEN NuLL ELSE VERIFIED_2 END,
            REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = p_resource_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 229+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(230) : resource.sql(730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_id := SYS_GUID();
      BEGIN
         INSERT INTO HISTORY_RESOURCES SELECT h_id, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 250+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(251) : resource.sql(751) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE RESOURCES SET
         REVISION_HISTORY = Null
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 269+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(270) : resource.sql(770) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --InitializeHost(SC_PARAM(h_id), p_resource_id, ind_ckout_res->p_resource_id);
      h_id := p_resource_id;
      --paria
      h_bitflag := 5;
      h_table_name := 'HISTORY_RESOURCES';
      PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_table_name);
      --SC_STATE = FC_D_REVISION(h_id, 5, "HISTORY_RESOURCES");
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_RESOURCE', 284+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_RESOURCE(285) : resource.sql(785) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 291+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(292) : resource.sql(792) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_RESOURCE', 303+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_RESOURCE(304) : resource.sql(804) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_RESOURCE;
ALTER FUNCTION SP_CKIN_RESOURCE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_RESOURCE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_RESOURCE(20) : resource.sql(840) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_RESOURCE', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_RESOURCE(25) : resource.sql(845) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_RESOURCE', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_RESOURCE(28) : resource.sql(848) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(43) : resource.sql(863) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_RESOURCE', 49+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_RESOURCE(50) : resource.sql(870) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_RESOURCE', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_RESOURCE(53) : resource.sql(873) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE RESOURCES SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME
         FROM HISTORY_RESOURCES
         WHERE RESOURCE_ID = p_resource_id
         AND REC_DATETIME =(SELECT MAX(REC_DATETIME) FROM HISTORY_RESOURCES WHERE RESOURCE_ID = p_resource_id)
         )
         WHERE RESOURCE_ID = p_resource_id
         AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(78) : resource.sql(898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_RESOURCE', 83+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_RESOURCE(84) : resource.sql(904) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_RESOURCE', 86+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_RESOURCE(87) : resource.sql(907) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_UNDO_CHECKOUT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_RESOURCE', 92+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_RESOURCE(93) : resource.sql(913) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 99+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(100) : resource.sql(920) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_RESOURCE', 111+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_RESOURCE(112) : resource.sql(932) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_RESOURCE;
ALTER FUNCTION SP_UCKOUT_RESOURCE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_ISOUT_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_ISOUT_RESOURCE
(
     p_resource_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C6667 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISOUT_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISOUT_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_ISOUT_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_RESOURCE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISOUT_RESOURCE(20) : resource.sql(968) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   --SC_CHAR(myStmt, SC_H_V_LONG_DESC);
   
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), resource_id, 0);
   
   --Return a resultset
   
   OPEN C6667 FOR SELECT RESOURCE_ID, REC_STATUS, REC_USER
   FROM RESOURCES
   WHERE RESOURCE_ID = p_resource_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_RESOURCE', 35+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_RESOURCE(36) : resource.sql(984) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C6667;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_RESOURCE', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_RESOURCE(44) : resource.sql(992) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_RESOURCE', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_RESOURCE(56) : resource.sql(1004) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISOUT_RESOURCE;
ALTER FUNCTION SP_ISOUT_RESOURCE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_S_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_S_RESOURCE
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RESOURCE(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESOURCE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RESOURCE(20) : resource.sql(1040) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RESOURCE', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RESOURCE(25) : resource.sql(1045) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESOURCE', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RESOURCE(28) : resource.sql(1048) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_RESOURCE_001';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_RESOURCE_001
      SELECT H.RESOURCE_ID, H.REVISION_TYPE, H.REVISION_IMPACT
      FROM HISTORY_RESOURCES H
      WHERE H.RESOURCE_ID = p_resource_id
      AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_RESOURCES WHERE RESOURCE_ID = H.RESOURCE_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESOURCE', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESOURCE(53) : resource.sql(1073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- the left joins inside the following select can be modified : please review it
   
   OPEN C66671 FOR SELECT R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, R.FIRST_NAME, R.MIDDLE_NAME, R.LAST_NAME,
   R.E_MAIL_ADDRESS, R.LOGON_NAME, PMO_ORASTD.PMO_DECRYPT(R.LOGON_PASSWORD, R.RESOURCE_ID) AS LOGON_PASSWORD, R.LOGON_REMINDER, R.MULTIPLE_LOGINS, R.PASSWORD_EXPIRES,
   R.WEBSITE, R.PRIMARY_ROLE, R.TITLE, R.ADDRESS1, R.ADDRESS2, R.ZIP_AREA_CODE, R.CITIZENSHIP, R.CALENDAR_ID,
   C.ELEMENT_NAME AS CALENDAR_NAME, R.CURRENCY_ID, --R.SIN_NUMBER,
   R.ACTIVE, R.EFFECTIVE_DATE, R.DISCONTINUE_DATE, R.STATUS1_ID, R.STATUS2_ID,
   R.CREATED_DATE, R.CREATED_BY, R.CHARGE_CODE, R.MAXDAYHRS, R.MINDAYHRS, Trunc(R.PERCENT_TO_ASSIGN) AS PERCENT_TO_ASSIGN,
   R.RATE_ID, R.HOME_OFFICE, R.WORK_LOCATION, R.LANGUAGE_ISO_CODE,
   R.WORK_PHONE, R.ALTERNATE_PHONE, R.FAX_NUMBER, R.CELL_NUMBER, R.PAGER_NUMBER,
   A.REGULAR_COST, A.REGULAR_SALE, A.SPECIAL_COST, A.SPECIAL_SALE,
   R.ICQ_MESSAGING, R.NOTES_MAIL_ID, R.NOTES_ID, R.ASSIGN_STATUS, R.EXPERIENCE_ID, R.ALIAS, R.LAST_USED, R.EXEC_LEVEL,
   R.VERIFIED_1, R1.FULL_NAME AS VERIFIED_1_NAME, R.VERIFIED_2, R2.FULL_NAME AS VERIFIED_2_NAME,
   R.WILLING_RELOC, R.RELOC_DURATION, COALESCE(R.WORK_RELOC_1,'2725') AS WORK_RELOC_1, COALESCE(R.WORK_RELOC_2,'2725') AS WORK_RELOC_2, COALESCE(R.WORK_RELOC_3,'2725') AS WORK_RELOC_3,
   R.WILLING_TRAVEL, R.TRAVEL_DURATION, COALESCE(R.TRAVEL_DEST_1,'2725') AS TRAVEL_DEST_1, COALESCE(R.TRAVEL_DEST_2,'2725') AS TRAVEL_DEST_2, COALESCE(R.TRAVEL_DEST_3,'2725') AS TRAVEL_DEST_3,
   R.PASPORT_VALID, R.PASPORT_EXPIRATION, COALESCE(R.COUNTRY_VISA_1,'2725') AS COUNTRY_VISA_1, R.VISA_EXPIRES_1, COALESCE(R.COUNTRY_VISA_2,'2725') AS COUNTRY_VISA_2, R.VISA_EXPIRES_2, COALESCE(R.COUNTRY_VISA_3,'2725') AS COUNTRY_VISA_3, R.VISA_EXPIRES_3,
   R.EXPERIENCE_TXT, R.ACHIVEMENTS, R.PASSIONS, R.SUMMARY_SKILLS,R.MISCELLANEOUS,
   R.REC_STATUS, R.REC_USER, R3.FULL_NAME AS REC_USER_NAME, R.REC_DATETIME, R.LAST_LOGIN, '' AS RES_BLOB,
   '' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT,
   R.CLEARANCE_LEVEL_1, R.CLEARANCE_LEVEL_2, R.CLEARANCE_LEVEL_3, R.CLEARANCE_LEVEL_4, R.CLEARANCE_LEVEL_5,
   R.FS_CODE
   FROM RESOURCES R LEFT JOIN PMO_TMP_RESOURCE_001 H ON H.RESOURCE_ID = R.RESOURCE_ID LEFT JOIN TMT_CALENDARS C ON C.ELEMENT_ID = R.CALENDAR_ID
   LEFT JOIN RATES A ON R.RATE_ID = A.RATE_ID LEFT JOIN RESOURCES R1 ON R1.RESOURCE_ID = R.VERIFIED_1
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = R.VERIFIED_2 JOIN RESOURCES R3 ON R3.RESOURCE_ID = R.REC_USER
   WHERE R.RESOURCE_ID = p_resource_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RESOURCE', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RESOURCE(84) : resource.sql(1104) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66671;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESOURCE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESOURCE(92) : resource.sql(1112) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RESOURCE', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RESOURCE(104) : resource.sql(1124) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RESOURCE;
ALTER FUNCTION SP_S_RESOURCE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_S_RES ==
CREATE OR REPLACE FUNCTION SP_S_RES
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C66671a PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RES'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RES(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RES(22) : resource.sql(1162) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES(27) : resource.sql(1167) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES(30) : resource.sql(1170) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES', 36+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES(37) : resource.sql(1177) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES(40) : resource.sql(1180) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_rec_user, True);
   End If;
   
   OPEN C66671a FOR SELECT
   R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, R.FIRST_NAME, R.MIDDLE_NAME, R.LAST_NAME,
   R.E_MAIL_ADDRESS, R.LOGON_NAME, PMO_ORASTD.PMO_DECRYPT(R.LOGON_PASSWORD, R.RESOURCE_ID) AS LOGON_PASSWORD, R.LOGON_REMINDER, R.MULTIPLE_LOGINS, R.PASSWORD_EXPIRES,
   R.WEBSITE, R.PRIMARY_ROLE, R.TITLE, R.ADDRESS1, R.ADDRESS2, R.ZIP_AREA_CODE, R.CITIZENSHIP, R.CALENDAR_ID,
   C.ELEMENT_NAME AS CALENDAR_NAME, R.CURRENCY_ID, R.EXTERNAL_ID, 
   R.ACTIVE, R.EFFECTIVE_DATE, R.DISCONTINUE_DATE, R.STATUS1_ID, R.STATUS2_ID,
   R.CREATED_DATE, R.CREATED_BY, R.CHARGE_CODE, R.MAXDAYHRS, R.MINDAYHRS, Trunc(R.PERCENT_TO_ASSIGN) AS PERCENT_TO_ASSIGN,
   R.RATE_ID, R.HOME_OFFICE, R.WORK_LOCATION, R.LANGUAGE_ISO_CODE,
   R.WORK_PHONE, R.ALTERNATE_PHONE, R.FAX_NUMBER, R.CELL_NUMBER, R.PAGER_NUMBER,
   A.REGULAR_COST, A.REGULAR_SALE, A.SPECIAL_COST, A.SPECIAL_SALE,
   R.ICQ_MESSAGING, R.NOTES_MAIL_ID, R.NOTES_ID, R.ASSIGN_STATUS, R.EXPERIENCE_ID, R.ALIAS, R.LAST_USED, R.EXEC_LEVEL,
   R.VERIFIED_1, R1.FULL_NAME AS VERIFIED_1_NAME, R.VERIFIED_2, R2.FULL_NAME AS VERIFIED_2_NAME,
   R.WILLING_RELOC, R.RELOC_DURATION, COALESCE(R.WORK_RELOC_1,'2725') AS WORK_RELOC_1, COALESCE(R.WORK_RELOC_2,'2725') AS WORK_RELOC_2, COALESCE(R.WORK_RELOC_3,'2725') AS WORK_RELOC_3,
   R.WILLING_TRAVEL, R.TRAVEL_DURATION, COALESCE(R.TRAVEL_DEST_1,'2725') AS TRAVEL_DEST_1, COALESCE(R.TRAVEL_DEST_2,'2725') AS TRAVEL_DEST_2, COALESCE(R.TRAVEL_DEST_3,'2725') AS TRAVEL_DEST_3,
   R.PASPORT_VALID, R.PASPORT_EXPIRATION, COALESCE(R.COUNTRY_VISA_1,'2725') AS COUNTRY_VISA_1, R.VISA_EXPIRES_1, COALESCE(R.COUNTRY_VISA_2,'2725') AS COUNTRY_VISA_2, R.VISA_EXPIRES_2, COALESCE(R.COUNTRY_VISA_3,'2725') AS COUNTRY_VISA_3, R.VISA_EXPIRES_3,
   R.EXPERIENCE_TXT, R.ACHIVEMENTS, R.PASSIONS, R.SUMMARY_SKILLS,R.MISCELLANEOUS,
   R.REC_STATUS, R.REC_USER, R3.FULL_NAME AS REC_USER_NAME, R.REC_DATETIME, R.LAST_LOGIN, '' AS RES_BLOB,
   R.COUNTRY_CODE, R.COMPANY_CODE, R.DIVISION_CODE, R.DEPARTMENT_CODE, R.EMPLOYEE_CODE, R.CUSTOM_01, R.CUSTOM_02, R.CUSTOM_03, R.CUSTOM_04, R.CUSTOM_05,
   '' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT,
   R.USER_GROUP_ID, COALESCE((SELECT ELEMENT_NAME FROM TMT_POOLS WHERE ELEMENT_ID = R.USER_GROUP_ID),'') AS USER_GROUP_NAME,
   R.CLEARANCE_LEVEL_1, R.CLEARANCE_LEVEL_2, R.CLEARANCE_LEVEL_3, R.CLEARANCE_LEVEL_4, R.CLEARANCE_LEVEL_5,
   CASE WHEN EXISTS(
   SELECT RA.RESOURCE_ID
   FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS P, TMT_POOLS C
   WHERE RA.RESOURCE_ID = p_rec_user
   AND ELEMENT_TYPE = 11 AND RA.ELEMENT_ID = P.ELEMENT_ID AND C.ELEMENT_ID = p_resource_id
   AND P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK
   AND SUBSTR(C.RANK, 1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH (P.RANK)END) = P.RANK)
   THEN 'Y' ELSE 'N' END AS CAN_CHECKOUT, R.FS_CODE, R.NICK_NAME, R.PORTAL_PAGE, R.DASHBOARD,P.MASK_EMPLOYEE_INFO,
   R.MY_PORTAL_URL_1, R.MY_PORTAL_URL_2, R.MY_PORTAL_URL_3, R.MY_PORTAL_URL_4, R.MY_PORTAL_URL_5,
   R.OVERWRITEFILE, R.EXECUTIVE_SECURITY, S.ELEMENT_NAME AS EXECUTIVE_SECURITY_NAME, R.ASSIGNED_PLUGINS
   FROM RESOURCES R
   JOIN TMT_POOLS P
   ON P.ELEMENT_ID = R.RESOURCE_ID
   JOIN HISTORY_RESOURCES H
   ON H.RESOURCE_ID = R.RESOURCE_ID
   JOIN RATES A
   ON R.RATE_ID = A.RATE_ID
   LEFT JOIN TMT_CALENDARS C ON C.ELEMENT_ID = R.CALENDAR_ID
   LEFT JOIN RESOURCES R1
   ON R1.RESOURCE_ID = R.VERIFIED_1
   LEFT JOIN RESOURCES R2
   ON R2.RESOURCE_ID = R.VERIFIED_2
   JOIN RESOURCES R3 ON R3.RESOURCE_ID = R.REC_USER
   LEFT JOIN TMT_GLOBAL_SECURITY S ON R.EXECUTIVE_SECURITY = S.ELEMENT_ID
   WHERE R.RESOURCE_ID = p_resource_id
   and H.RESOURCE_ID = p_resource_id
   AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_RESOURCES WHERE RESOURCE_ID = H.RESOURCE_ID);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES', 93+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES(94) : resource.sql(1234) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C66671a;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES(102) : resource.sql(1242) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES(114) : resource.sql(1254) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RES;
ALTER FUNCTION SP_S_RES COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_NAME ==
CREATE OR REPLACE FUNCTION SP_U_RES_NAME
(
     p_resource_id VARCHAR2
   , p_first_name VARCHAR2
   , p_middle_name VARCHAR2
   , p_last_name VARCHAR2
   , p_nick_name VARCHAR2
   , p_email_address VARCHAR2
   , p_alias VARCHAR2
   , p_sin_number VARCHAR2
   , p_external_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_old_nick_name VARCHAR2(100);
   h_rec_status VARCHAR2(1);
   h_table PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_element_type PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_first_name VARCHAR2(35);
   h_last_name VARCHAR2(35);
   h_middle_name VARCHAR2(35);
   h_new_nick_name VARCHAR2(100);
   h_email_address VARCHAR2(255);
   h_alias VARCHAR2(80);
   h_sin_number VARCHAR2(50);
   h_external_id VARCHAR2(50);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
      CURSOR C_res_ass IS
         SELECT ELEMENT_ID, ELEMENT_TYPE, TABLE_TYPE
         FROM RESOURCE_ASSIGNMENTS
         WHERE RESOURCE_ID = h_resource_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_NAME(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_first_name || ''''
          || ', ' || '''' || p_middle_name || ''''
          || ', ' || '''' || p_last_name || ''''
          || ', ' || '''' || p_nick_name || ''''
          || ', ' || '''' || p_email_address || ''''
          || ', ' || '''' || p_alias || ''''
          || ', ' || '''' || p_sin_number || ''''
          || ', ' || '''' || p_external_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_NAME', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_NAME(54) : resource.sql(1324) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_NAME', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_NAME(59) : resource.sql(1329) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_NAME', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_NAME(62) : resource.sql(1332) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_resource_id;
   h_first_name := p_first_name;
   h_last_name := p_last_name;
   h_middle_name := p_middle_name;
   h_new_nick_name := p_nick_name;
   h_email_address := p_email_address;
   h_alias := p_alias;
   h_sin_number := p_sin_number;
   h_external_id := p_external_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT REC_STATUS, NICK_NAME
      INTO h_rec_status, h_old_nick_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(91) : resource.sql(1361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_NAME', 97+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_NAME(98) : resource.sql(1368) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_NAME', 100+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_NAME(101) : resource.sql(1371) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, h_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_NAME', 106+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_NAME(107) : resource.sql(1377) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_NAME', 109+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_NAME(110) : resource.sql(1380) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_resource_id, True);
   End If;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES
      SET FIRST_NAME      = h_first_name,
      LAST_NAME       = h_last_name,
      MIDDLE_NAME     = h_middle_name,
      NICK_NAME       = (CASE WHEN (h_new_nick_name is Null) OR LENGTH(RTRIM(h_new_nick_name))=0 THEN FULL_NAME ELSE h_new_nick_name END),
      E_MAIL_ADDRESS  = h_email_address,
      ALIAS           = h_alias,
      FS_CODE         = h_sin_number,
      EXTERNAL_ID		= h_external_id,
      REC_USER        = h_rec_user,
      REC_DATETIME    = SYSTIMESTAMP
      WHERE RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(139) : resource.sql(1409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_ORASTD.strcmp(h_new_nick_name, h_old_nick_name) <> PMO_CNST.SC_MATCH) 
         AND ((h_new_nick_name IS NOT NULL)) Then
      OPEN C_res_ass;
      
      LOOP
         FETCH C_res_ass INTO h_id, h_element_type, h_table_type;
         IF C_res_ass%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If Coalesce(h_element_type, 0) = PMO_CNST.SC_FOLDER Then
            h_table := Coalesce(h_table_type, 0);
         ElsIf Coalesce(h_element_type, 0) = PMO_CNST.SC_RESOURCE Then
            h_table := PMO_CNST.SC_TABLE_WBS;
         Else
            h_table := GetTable(Coalesce(h_element_type, 0));
         End If;
         
         If Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_WBS Then
            BEGIN
               UPDATE TMT_WBS
               SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_nick_name, h_new_nick_name )
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 182+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(183) : resource.sql(1453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_CRI Then
            BEGIN
               UPDATE TMT_CRI
               SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_nick_name, h_new_nick_name )
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 201+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(202) : resource.sql(1472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_table, 0) = PMO_CNST.SC_TABLE_DOC Then
            BEGIN
               UPDATE TMT_DOCUMENTS
               SET ASSIGN_NAMES = REPLACE (ASSIGN_NAMES, h_old_nick_name, h_new_nick_name )
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 220+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(221) : resource.sql(1491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_res_ass ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 235+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(236) : resource.sql(1506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_NAME', 242+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_NAME(243) : resource.sql(1513) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 249+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(250) : resource.sql(1520) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_NAME', 261+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_NAME(262) : resource.sql(1532) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_NAME;
ALTER FUNCTION SP_U_RES_NAME COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_ASSIGNED_PLUGINS ==
CREATE OR REPLACE FUNCTION SP_U_RES_ASSIGNED_PLUGINS
(
     p_resource_id VARCHAR2
   , p_assigned_plugins PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_resource_id VARCHAR2(32);
   h_assigned_plugins PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_ASSIGNED_PLUGINS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_ASSIGNED_PLUGINS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_ASSIGNED_PLUGINS(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_assigned_plugins), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_ASSIGNED_PLUGINS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_ASSIGNED_PLUGINS(22) : resource.sql(1570) : ' || SYSTIMESTAMP);
   END IF; 

   h_resource_id := p_resource_id;
   h_assigned_plugins := p_assigned_plugins;
   h_rec_user := p_rec_user;
   
   If (h_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_ASSIGNED_PLUGINS', 30+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_ASSIGNED_PLUGINS(31) : resource.sql(1579) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_ASSIGNED_PLUGINS', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_ASSIGNED_PLUGINS(34) : resource.sql(1582) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, h_resource_id, True);
   End If;
   
   BEGIN
      UPDATE RESOURCES
      SET ASSIGNED_PLUGINS = h_assigned_plugins,
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ASSIGNED_PLUGINS', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ASSIGNED_PLUGINS(55) : resource.sql(1603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_ASSIGNED_PLUGINS', 60+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_ASSIGNED_PLUGINS(61) : resource.sql(1609) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ASSIGNED_PLUGINS', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ASSIGNED_PLUGINS(68) : resource.sql(1616) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ASSIGNED_PLUGINS', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ASSIGNED_PLUGINS(80) : resource.sql(1628) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_ASSIGNED_PLUGINS;
ALTER FUNCTION SP_U_RES_ASSIGNED_PLUGINS COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_LOGON ==
CREATE OR REPLACE FUNCTION SP_U_RES_LOGON
(
     p_resource_id VARCHAR2
   , p_logon VARCHAR2
   , p_reminder VARCHAR2
   , p_multiple_logins VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_LOGON') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_LOGON'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_LOGON(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_logon || ''''
          || ', ' || '''' || p_reminder || ''''
          || ', ' || '''' || p_multiple_logins || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_LOGON', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_LOGON(24) : resource.sql(1668) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_LOGON', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_LOGON(29) : resource.sql(1673) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_LOGON', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_LOGON(32) : resource.sql(1676) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   --SC_CHAR(h_resource_id, SC_H_ID);
   
   --InitializeHost(SC_PARAM(h_resource_id), resource_id, ind_u_res_logon->resource_id);
   
   BEGIN
      SELECT COUNT(RESOURCE_ID) INTO h_count
      FROM RESOURCES
      WHERE LOGON_NAME = RTRIM(LTRIM(p_logon))
      AND RESOURCE_ID <> p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(53) : resource.sql(1697) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_LOGON', 59+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_LOGON(60) : resource.sql(1704) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LOGON_NOT_UNIQUE), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_LOGON', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_LOGON(63) : resource.sql(1707) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.LOGON_NOT_UNIQUE, True);
   End If;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES SET
      LOGON_NAME = p_logon,
      LOGON_REMINDER = p_reminder,
      MULTIPLE_LOGINS = p_multiple_logins,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(87) : resource.sql(1731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_LOGON', 92+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_LOGON(93) : resource.sql(1737) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 99+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(100) : resource.sql(1744) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_LOGON', 111+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_LOGON(112) : resource.sql(1756) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_LOGON;
ALTER FUNCTION SP_U_RES_LOGON COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_PASSWORD ==
CREATE OR REPLACE FUNCTION SP_U_RES_PASSWORD
(
     p_resource_id VARCHAR2
   , p_password VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_psw_expires PLS_INTEGER := 0;
   h_psw_versions PLS_INTEGER := 0;
   h_temp_str VARCHAR2(255);
   h_temp_str2 VARCHAR2(255);
   h_count PLS_INTEGER := 0;
   h_xcount PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_new_password VARCHAR2(16);
   h_logon_name VARCHAR2(100);
   h_full_name VARCHAR2(100);
   h_nick_name VARCHAR2(100);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_PASSWORD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_PASSWORD'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_PASSWORD(' || 
       '''' || p_resource_id || ''''
          || ', ' || CASE WHEN p_password IS NULL THEN '''''' ELSE '''*******''' END
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_PASSWORD(31) : resource.sql(1803) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(36) : resource.sql(1808) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASSWORD(39) : resource.sql(1811) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_resource_id), resource_id, ind_u_res_password->resource_id);
   
   BEGIN
      SELECT PMO_ORASTD.PMO_DECRYPT(KEY_HISTORY, RESOURCE_ID), REC_STATUS, UPPER(LOGON_NAME), UPPER(FULL_NAME), UPPER(NICK_NAME), UPPER(p_password)
      INTO h_temp_str, h_rec_status, h_logon_name, h_full_name, h_nick_name, h_new_password
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(58) : resource.sql(1830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 63+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(64) : resource.sql(1836) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASSWORD(67) : resource.sql(1839) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 73+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(74) : resource.sql(1846) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASSWORD(77) : resource.sql(1849) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_ORASTD.strcmp(h_new_password, h_logon_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(
         h_new_password, h_full_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(h_new_password
         , h_nick_name) = PMO_CNST.SC_MATCH) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(86) : resource.sql(1858) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASSWORD(89) : resource.sql(1861) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD, p_resource_id
            , True);
   End If;
   
   --Reset password
   If (p_password IS NOT NULL) Then
      h_new_password := p_password;
   Else
      h_new_password := '';
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_psw_versions
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'PASSWORD_MASK'
      AND RTRIM(DESCRIPTION) = UPPER(h_new_password);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(113) : resource.sql(1885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASSWORD', 119+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASSWORD(120) : resource.sql(1892) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(300112), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 122+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASSWORD(123) : resource.sql(1895) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(300112, p_resource_id, True);
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(137) : resource.sql(1909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_psw_versions, 0) = 0 Then
      --keep 0 version, so nullify history
      BEGIN
         UPDATE RESOURCES SET
         KEY_HISTORY = NULL
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 157+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(158) : resource.sql(1930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_str := '';
      
      h_xcount := 0;
   Else
      h_psw_versions := Coalesce(h_psw_versions, 0) + 1;
      
      If (h_temp_str IS NOT NULL) Then
         --h_psw_versions MUST > 0
         --history has at least 1 version
         h_count := 1;
         
         --find existing version of password history
         --and synchronize history max version with system setting
         
         h_temp_str2 := h_temp_str;
         
         h_bitflag := 1;
         WHILE Coalesce(h_bitflag, 0) > 0 LOOP
            BEGIN
               SELECT  InStr(h_temp_str2, ';;')
               INTO h_bitflag
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 190+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(191) : resource.sql(1963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_bitflag, 0) > 0 Then
               h_count := Coalesce(h_count, 0) + 1;
               BEGIN
                  SELECT SUBSTR( h_temp_str2, InStr(h_temp_str2, ';;') + 1, LENGTH(h_temp_str2) - InStr(h_temp_str2, ';;'))
                  INTO h_temp_str2
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 207+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(208) : resource.sql(1980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         
         --remember the h_count
         If Coalesce(h_count, 0) > Coalesce(h_psw_versions, 0) Then
            h_count := Coalesce(h_count, 0) - Coalesce(h_psw_versions, 0);
            
            WHILE Coalesce(h_count, 0) > 0 LOOP
               h_count := Coalesce(h_count, 0) - 1;
               
               BEGIN
                  SELECT  InStr(h_temp_str, ';;')
                  INTO h_bitflag
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 231+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(232) : resource.sql(2004) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag, 0) > 0 Then
                  BEGIN
                     SELECT  SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
                     INTO h_temp_str
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 247+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(248) : resource.sql(2020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  h_count := 0;
               End If;
            END LOOP;
            
            h_xcount := Coalesce(h_psw_versions, 0);
         Else
            h_xcount := Coalesce(h_count, 0);
         End If;
         
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
            WHERE RESOURCE_ID = p_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 275+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(276) : resource.sql(2048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --(h_psw_versions > 1)  (h_temp_str == null)
         BEGIN
            SELECT ';' || PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) || ';'
            INTO h_temp_str
            FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 291+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(292) : resource.sql(2064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (h_temp_str IS NULL) Then
            h_temp_str := '';
         End If;
         
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
            WHERE RESOURCE_ID = p_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(314) : resource.sql(2086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_xcount := 1;
      End If;
   End If;
   
   --do the test
   h_count := 0;
   BEGIN
      SELECT InStr( RTRIM(h_temp_str), ';' || h_new_password || ';' )
      INTO h_count
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 334+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(335) : resource.sql(2107) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_PASSWORD', 340+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_PASSWORD(341) : resource.sql(2113) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PASSWORD_REUSED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASSWORD', 343+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASSWORD(344) : resource.sql(2116) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PASSWORD_REUSED, True);
   End If;
   
   If Coalesce(h_xcount, 0) > 0 Then
      If Coalesce(h_xcount, 0) = Coalesce(h_psw_versions, 0) Then
         BEGIN
            SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
            INTO h_temp_str
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 360+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(361) : resource.sql(2133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         UPDATE RESOURCES SET
         KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str || ';' || h_new_password || ';', RESOURCE_ID, '')
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 380+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(381) : resource.sql(2153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_psw_expires FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'PASSWORD_EXPIRATION';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 395+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(396) : resource.sql(2168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES SET
      LOGON_PASSWORD = PMO_ORASTD.PMO_ENCRYPT(h_new_password, RESOURCE_ID, ''),
      PASSWORD_EXPIRES = CASE
      WHEN p_resource_id = p_rec_user
      THEN TO_DATE(SYSDATE) + h_psw_expires    
      ELSE TO_DATE(SYSDATE) - 1    
      END,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 422+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(423) : resource.sql(2195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_PASSWORD', 428+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_PASSWORD(429) : resource.sql(2201) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 435+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(436) : resource.sql(2208) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASSWORD', 447+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASSWORD(448) : resource.sql(2220) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_PASSWORD;
ALTER FUNCTION SP_U_RES_PASSWORD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_U_RES_FULLNAME ==
CREATE OR REPLACE FUNCTION FC_U_RES_FULLNAME
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_RES_FULLNAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_RES_FULLNAME'), '-- ' || SYSTIMESTAMP, ':r := FC_U_RES_FULLNAME(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RES_FULLNAME', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_RES_FULLNAME(19) : resource.sql(2255) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE RESOURCES SET FULL_NAME = h_full_name,
      NICK_NAME = CASE WHEN NICK_NAME = 'Resource' THEN h_full_name ELSE NICK_NAME END
      WHERE RESOURCE_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RES_FULLNAME', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RES_FULLNAME(36) : resource.sql(2272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_host_table := PMO_CNST.SC_TABLE_RES;
   PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_RES_DOC(h_host_table, h_resource_id, h_full_name, h_rec_user
                                            , h_error_id);
   
   --Execute Update Resource
   BEGIN
      UPDATE TMT_WBS SET
      ELEMENT_NAME = RTRIM(LTRIM(h_full_name)),
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RES_FULLNAME', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RES_FULLNAME(61) : resource.sql(2297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_POOLS
      SET ELEMENT_NAME = RTRIM(LTRIM(h_full_name)),
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = h_rec_user
      WHERE ELEMENT_ID = h_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_RES_FULLNAME', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_RES_FULLNAME(83) : resource.sql(2319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_RES_FULLNAME', 92+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_RES_FULLNAME(93) : resource.sql(2329) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_RES_FULLNAME;
ALTER FUNCTION FC_U_RES_FULLNAME COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_FULLNAME ==
CREATE OR REPLACE FUNCTION SP_U_RES_FULLNAME
(
     p_resource_id VARCHAR2
   , p_full_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_full_name VARCHAR2(100);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_FULLNAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_FULLNAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_FULLNAME(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_full_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FULLNAME', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_FULLNAME(23) : resource.sql(2362) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FULLNAME', 29+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FULLNAME(30) : resource.sql(2369) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FULLNAME', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_FULLNAME(33) : resource.sql(2372) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FULLNAME', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FULLNAME(48) : resource.sql(2387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FULLNAME', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FULLNAME(55) : resource.sql(2394) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FULLNAME', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_FULLNAME(58) : resource.sql(2397) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FULLNAME', 64+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FULLNAME(65) : resource.sql(2404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FULLNAME', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_FULLNAME(68) : resource.sql(2407) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   h_resource_id := p_resource_id;
   h_full_name := p_full_name;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_U_RES_FULLNAME(h_resource_id, h_full_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_FULLNAME', 79+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_FULLNAME(80) : resource.sql(2419) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FULLNAME', 86+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FULLNAME(87) : resource.sql(2426) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FULLNAME', 98+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FULLNAME(99) : resource.sql(2438) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_FULLNAME;
ALTER FUNCTION SP_U_RES_FULLNAME COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_RES_SECURITY
(
     p_resource_id VARCHAR2
   , p_int_security_1 PLS_INTEGER
   , p_int_security_2 PLS_INTEGER
   , p_int_security_3 PLS_INTEGER
   , p_int_security_4 PLS_INTEGER
   , p_int_security_5 PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_SECURITY(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_int_security_1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_3), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_4), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_int_security_5), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_SECURITY', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_SECURITY(28) : resource.sql(2482) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_SECURITY', 32+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_SECURITY(33) : resource.sql(2487) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_SECURITY', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_SECURITY(36) : resource.sql(2490) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(53) : resource.sql(2507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_SECURITY', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_SECURITY(60) : resource.sql(2514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_SECURITY', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_SECURITY(63) : resource.sql(2517) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_SECURITY', 68+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_SECURITY(69) : resource.sql(2523) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_SECURITY', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_SECURITY(72) : resource.sql(2526) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         CLEARANCE_LEVEL_1 = p_int_security_1,
         CLEARANCE_LEVEL_2 = p_int_security_2,
         CLEARANCE_LEVEL_3 = p_int_security_3,
         CLEARANCE_LEVEL_4 = p_int_security_4,
         CLEARANCE_LEVEL_5 = p_int_security_5,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 98+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(99) : resource.sql(2553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_SECURITY', 105+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_SECURITY(106) : resource.sql(2560) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 112+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(113) : resource.sql(2567) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_SECURITY', 124+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_SECURITY(125) : resource.sql(2579) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_SECURITY;
ALTER FUNCTION SP_U_RES_SECURITY COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_EXECUTIVE_SECURITY ==
CREATE OR REPLACE FUNCTION SP_U_EXECUTIVE_SECURITY
(
     p_resource_id VARCHAR2
   , p_security_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EXECUTIVE_SECURITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EXECUTIVE_SECURITY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EXECUTIVE_SECURITY(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_security_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXECUTIVE_SECURITY', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EXECUTIVE_SECURITY(19) : resource.sql(2614) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXECUTIVE_SECURITY', 23+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXECUTIVE_SECURITY(24) : resource.sql(2619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXECUTIVE_SECURITY', 26+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXECUTIVE_SECURITY(27) : resource.sql(2622) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   BEGIN
      UPDATE RESOURCES
      SET EXECUTIVE_SECURITY = p_security_id
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXECUTIVE_SECURITY', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXECUTIVE_SECURITY(46) : resource.sql(2641) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EXECUTIVE_SECURITY', 52+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EXECUTIVE_SECURITY(53) : resource.sql(2648) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EXECUTIVE_SECURITY', 55+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EXECUTIVE_SECURITY(56) : resource.sql(2651) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EXECUTIVE_SECURITY', 61+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EXECUTIVE_SECURITY(62) : resource.sql(2657) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXECUTIVE_SECURITY', 68+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXECUTIVE_SECURITY(69) : resource.sql(2664) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EXECUTIVE_SECURITY', 80+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EXECUTIVE_SECURITY(81) : resource.sql(2676) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EXECUTIVE_SECURITY;
ALTER FUNCTION SP_U_EXECUTIVE_SECURITY COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_COMPANY_INFO ==
CREATE OR REPLACE FUNCTION SP_U_COMPANY_INFO
(
     p_resource_id VARCHAR2
   , p_website VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COMPANY_INFO') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COMPANY_INFO'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COMPANY_INFO(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_INFO', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COMPANY_INFO(20) : resource.sql(2712) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_INFO', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_INFO(25) : resource.sql(2717) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_INFO', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_COMPANY_INFO(28) : resource.sql(2720) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(45) : resource.sql(2737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_INFO', 51+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_INFO(52) : resource.sql(2744) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_INFO', 54+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_COMPANY_INFO(55) : resource.sql(2747) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_INFO', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_INFO(61) : resource.sql(2753) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_INFO', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_COMPANY_INFO(64) : resource.sql(2756) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         WEBSITE = p_website,
         REC_USER = p_rec_user,
         REC_DATETIME=SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(87) : resource.sql(2779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COMPANY_INFO', 93+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COMPANY_INFO(94) : resource.sql(2786) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 100+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(101) : resource.sql(2793) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_INFO', 112+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_INFO(113) : resource.sql(2805) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COMPANY_INFO;
ALTER FUNCTION SP_U_COMPANY_INFO COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_WORK_SPEC ==
CREATE OR REPLACE FUNCTION SP_U_WORK_SPEC
(
     p_resource_id VARCHAR2
   , p_role_id VARCHAR2
   , p_title VARCHAR2
   , p_address1 VARCHAR2
   , p_address2 VARCHAR2
   , p_zip VARCHAR2
   , p_citizenship PLS_INTEGER
   , p_country_code VARCHAR2
   , p_company_code VARCHAR2
   , p_division_code VARCHAR2
   , p_department_code VARCHAR2
   , p_employee_code VARCHAR2
   , p_custom_01 VARCHAR2
   , p_custom_02 VARCHAR2
   , p_custom_03 VARCHAR2
   , p_custom_04 VARCHAR2
   , p_custom_05 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WORK_SPEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WORK_SPEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WORK_SPEC(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_role_id || ''''
          || ', ' || '''' || p_title || ''''
          || ', ' || '''' || p_address1 || ''''
          || ', ' || '''' || p_address2 || ''''
          || ', ' || '''' || p_zip || ''''
          || ', ' || COALESCE(TO_CHAR(p_citizenship), 'NULL')
          || ', ' || '''' || p_country_code || ''''
          || ', ' || '''' || p_company_code || ''''
          || ', ' || '''' || p_division_code || ''''
          || ', ' || '''' || p_department_code || ''''
          || ', ' || '''' || p_employee_code || ''''
          || ', ' || '''' || p_custom_01 || ''''
          || ', ' || '''' || p_custom_02 || ''''
          || ', ' || '''' || p_custom_03 || ''''
          || ', ' || '''' || p_custom_04 || ''''
          || ', ' || '''' || p_custom_05 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WORK_SPEC', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WORK_SPEC(50) : resource.sql(2871) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WORK_SPEC', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WORK_SPEC(55) : resource.sql(2876) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WORK_SPEC', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WORK_SPEC(58) : resource.sql(2879) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(75) : resource.sql(2896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WORK_SPEC', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WORK_SPEC(82) : resource.sql(2903) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WORK_SPEC', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WORK_SPEC(85) : resource.sql(2906) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WORK_SPEC', 90+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WORK_SPEC(91) : resource.sql(2912) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WORK_SPEC', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WORK_SPEC(94) : resource.sql(2915) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         PRIMARY_ROLE = p_role_id,
         TITLE = p_title,
         REC_USER = p_rec_user,
         ADDRESS1 = p_address1,
         ADDRESS2 = p_address2,
         ZIP_AREA_CODE = p_zip,
         CITIZENSHIP = p_citizenship,
         COUNTRY_CODE = p_country_code,
         COMPANY_CODE = p_company_code,
         DIVISION_CODE = p_division_code,
         DEPARTMENT_CODE = p_department_code,
         EMPLOYEE_CODE = p_employee_code,
         CUSTOM_01 = p_custom_01,
         CUSTOM_02 = p_custom_02,
         CUSTOM_03 = p_custom_03,
         CUSTOM_04 = p_custom_04,
         CUSTOM_05 = p_custom_05,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(132) : resource.sql(2953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WORK_SPEC', 138+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WORK_SPEC(139) : resource.sql(2960) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 145+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(146) : resource.sql(2967) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WORK_SPEC', 157+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WORK_SPEC(158) : resource.sql(2979) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WORK_SPEC;
ALTER FUNCTION SP_U_WORK_SPEC COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_EMPLOYEE_SPEC ==
CREATE OR REPLACE FUNCTION SP_U_EMPLOYEE_SPEC
(
     p_resource_id VARCHAR2
   , p_home_office VARCHAR2
   , p_work_loc_id PLS_INTEGER
   , p_work_phone VARCHAR2
   , p_alt_phone VARCHAR2
   , p_cell_phone VARCHAR2
   , p_status1 PLS_INTEGER
   , p_status2 PLS_INTEGER
   , p_experience PLS_INTEGER
   , p_maxdayhours PLS_INTEGER
   , p_mindayhours PLS_INTEGER
   , p_percent_assign NUMBER
   , p_icq_id VARCHAR2
   , p_pager_num VARCHAR2
   , p_fax_num VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_EMPLOYEE_SPEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_EMPLOYEE_SPEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_EMPLOYEE_SPEC(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_home_office || ''''
          || ', ' || COALESCE(TO_CHAR(p_work_loc_id), 'NULL')
          || ', ' || '''' || p_work_phone || ''''
          || ', ' || '''' || p_alt_phone || ''''
          || ', ' || '''' || p_cell_phone || ''''
          || ', ' || COALESCE(TO_CHAR(p_status1), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_status2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_experience), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_maxdayhours), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_mindayhours), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_percent_assign), 'NULL')
          || ', ' || '''' || p_icq_id || ''''
          || ', ' || '''' || p_pager_num || ''''
          || ', ' || '''' || p_fax_num || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLOYEE_SPEC', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_EMPLOYEE_SPEC(46) : resource.sql(3041) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLOYEE_SPEC', 50+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLOYEE_SPEC(51) : resource.sql(3046) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLOYEE_SPEC', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EMPLOYEE_SPEC(54) : resource.sql(3049) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(71) : resource.sql(3066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLOYEE_SPEC', 77+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLOYEE_SPEC(78) : resource.sql(3073) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLOYEE_SPEC', 80+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EMPLOYEE_SPEC(81) : resource.sql(3076) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_EMPLOYEE_SPEC', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_EMPLOYEE_SPEC(87) : resource.sql(3082) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_EMPLOYEE_SPEC', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_EMPLOYEE_SPEC(90) : resource.sql(3085) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         HOME_OFFICE = p_home_office,
         WORK_LOCATION = p_work_loc_id,
         WORK_PHONE = p_work_phone,
         ALTERNATE_PHONE = p_alt_phone,
         CELL_NUMBER = p_cell_phone,
         STATUS1_ID = p_status1,
         STATUS2_ID = p_status2,
         EXPERIENCE_ID = p_experience,
         MAXDAYHRS = p_maxdayhours,
         MINDAYHRS = p_mindayhours,
         PERCENT_TO_ASSIGN = p_percent_assign,
         ICQ_MESSAGING = p_icq_id,
         PAGER_NUMBER = p_pager_num,
         FAX_NUMBER = p_fax_num,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(126) : resource.sql(3121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_EMPLOYEE_SPEC', 132+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_EMPLOYEE_SPEC(133) : resource.sql(3128) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 139+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(140) : resource.sql(3135) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_EMPLOYEE_SPEC', 151+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_EMPLOYEE_SPEC(152) : resource.sql(3147) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_EMPLOYEE_SPEC;
ALTER FUNCTION SP_U_EMPLOYEE_SPEC COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_COMPANY_SPEC ==
CREATE OR REPLACE FUNCTION SP_U_COMPANY_SPEC
(
     p_resource_id VARCHAR2
   , p_exec_level VARCHAR2
   , p_effective_date VARCHAR2
   , p_discontinue_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_effective_date DATE;
   h_discontinue_date DATE;
   h_FD DATE;
   h_SD DATE;
   h_resource_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_COMPANY_SPEC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_COMPANY_SPEC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_COMPANY_SPEC(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_exec_level || ''''
          || ', ' || '''' || p_effective_date || ''''
          || ', ' || '''' || p_discontinue_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_SPEC', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_COMPANY_SPEC(31) : resource.sql(3194) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- effective date
   -- effective date
   --Finish
   --Start
   
   If (p_effective_date IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_SPEC', 42+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_SPEC(43) : resource.sql(3206) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_effective_date || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_SPEC', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_COMPANY_SPEC(46) : resource.sql(3209) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_effective_date, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_SD), p_effective_date, ind_u_comp_spec->p_effective_date);
   h_effective_date := p_effective_date;
   
   --InitializeHost(SC_PARAM(h_resource_id), p_resource_id, ind_u_comp_spec->p_resource_id);
   h_resource_id := p_resource_id;
   h_type_id := PMO_CNST.SC_RESOURCE;
   
   h_SD := NULL;
   h_FD := NULL;
   
   --Get CALENDAR_DAY_OF_YEAR start date
   BEGIN
      SELECT MIN(DAY_YEAR) - 1     , MAX(DAY_YEAR) + 1      INTO h_SD,h_FD
      FROM CALENDAR_DAY_OF_YEAR
      WHERE ELEMENT_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(72) : resource.sql(3235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((h_SD IS NOT NULL)) AND ((h_FD IS NOT NULL)) Then
      If (p_discontinue_date IS NOT NULL) Then
         h_discontinue_date := p_discontinue_date;
         If PMO_ORASTD.strncmp(h_discontinue_date, h_effective_date, 10) < 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_COMPANY_SPEC', 81+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_COMPANY_SPEC(82) : resource.sql(3245) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_discontinue_date || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_COMPANY_SPEC', 84+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_COMPANY_SPEC(85) : resource.sql(3248) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_discontinue_date, True);
         End If;
         
         BEGIN
            SELECT TO_DATE(SubStr(h_effective_date, 1, 10)) +   (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_effective_date) - 6)       ,
            TO_DATE(SubStr(h_discontinue_date, 1, 10)) + (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_discontinue_date) + 1)     
            INTO h_effective_date, h_discontinue_date
            FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 100+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(101) : resource.sql(3264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT TO_DATE(SubStr(h_effective_date, 1, 10)) +   (SETTING_VALUE - PMO_ORASTD.DAYOFWEEK(h_effective_date) - 6)       
            INTO h_effective_date
            FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 115+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(116) : resource.sql(3279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("("h_effective_date: %s, h_SD: %s\n",h_effective_date,h_SD);
      --trace_printf("("h_discontinue_date: %s, h_FD: %s\n",h_discontinue_date,h_FD);
      
      If PMO_ORASTD.strncmp(h_effective_date, h_SD, 10) < 0 Then
         BEGIN
            SELECT TO_DATE(SubStr(h_SD, 1, 10)) - 1      INTO h_SD FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 132+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(133) : resource.sql(3296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_temp_var := 0;
         h_temp_sc_state := POPULATE_CALENDAR(h_resource_id, h_type_id, h_effective_date, h_SD, h_temp_var);
      Else
         BEGIN
            SELECT TO_DATE(SubStr(h_FD, 1, 10)) + 1      INTO h_FD FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(148) : resource.sql(3311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_temp_var := 0;
         If ((p_discontinue_date IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_discontinue_date, h_FD
               , 10) > 0) Then
            h_temp_sc_state := POPULATE_CALENDAR(h_resource_id, h_type_id, h_FD, h_discontinue_date, h_temp_var);
         ElsIf PMO_ORASTD.strncmp(h_effective_date, h_FD, 10) > 0 Then
            h_temp_sc_state := POPULATE_CALENDAR(h_resource_id, h_type_id, h_FD, h_effective_date, h_temp_var);
         End If;
      End If;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE RESOURCES
      SET EXEC_LEVEL = p_exec_level,
      EFFECTIVE_DATE = p_effective_date,
      DISCONTINUE_DATE = p_discontinue_date
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 178+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(179) : resource.sql(3342) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_COMPANY_SPEC', 184+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_COMPANY_SPEC(185) : resource.sql(3348) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 191+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(192) : resource.sql(3355) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_COMPANY_SPEC', 203+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_COMPANY_SPEC(204) : resource.sql(3367) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_COMPANY_SPEC;
ALTER FUNCTION SP_U_COMPANY_SPEC COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_VERIFIED_BY ==
CREATE OR REPLACE FUNCTION SP_U_VERIFIED_BY
(
     p_resource_id VARCHAR2
   , p_verified_by1 VARCHAR2
   , p_verified_by2 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VERIFIED_BY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VERIFIED_BY'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VERIFIED_BY(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_verified_by1 || ''''
          || ', ' || '''' || p_verified_by2 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VERIFIED_BY', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VERIFIED_BY(22) : resource.sql(3405) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VERIFIED_BY', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VERIFIED_BY(27) : resource.sql(3410) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VERIFIED_BY', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VERIFIED_BY(30) : resource.sql(3413) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(47) : resource.sql(3430) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VERIFIED_BY', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VERIFIED_BY(54) : resource.sql(3437) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VERIFIED_BY', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VERIFIED_BY(57) : resource.sql(3440) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VERIFIED_BY', 62+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VERIFIED_BY(63) : resource.sql(3446) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VERIFIED_BY', 65+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VERIFIED_BY(66) : resource.sql(3449) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE RESOURCES SET
         VERIFIED_1 = p_verified_by1,
         VERIFIED_2 = p_verified_by2
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(87) : resource.sql(3470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VERIFIED_BY', 93+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VERIFIED_BY(94) : resource.sql(3477) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 100+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(101) : resource.sql(3484) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VERIFIED_BY', 112+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VERIFIED_BY(113) : resource.sql(3496) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VERIFIED_BY;
ALTER FUNCTION SP_U_VERIFIED_BY COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_UNVERIFIED_BY ==
CREATE OR REPLACE FUNCTION SP_UNVERIFIED_BY
(
     p_resource_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UNVERIFIED_BY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UNVERIFIED_BY'), '-- ' || SYSTIMESTAMP, ':r := SP_UNVERIFIED_BY(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNVERIFIED_BY', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UNVERIFIED_BY(18) : resource.sql(3530) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNVERIFIED_BY', 22+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNVERIFIED_BY(23) : resource.sql(3535) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNVERIFIED_BY', 25+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UNVERIFIED_BY(26) : resource.sql(3538) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM RESOURCES
      WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(43) : resource.sql(3555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNVERIFIED_BY', 49+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNVERIFIED_BY(50) : resource.sql(3562) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNVERIFIED_BY', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UNVERIFIED_BY(53) : resource.sql(3565) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNVERIFIED_BY', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNVERIFIED_BY(59) : resource.sql(3571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNVERIFIED_BY', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UNVERIFIED_BY(62) : resource.sql(3574) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE RESOURCES SET
         VERIFIED_1 = NULL, VERIFIED_2 = NULL,
         REC_USER = p_rec_user
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(83) : resource.sql(3595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UNVERIFIED_BY', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UNVERIFIED_BY(90) : resource.sql(3602) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(97) : resource.sql(3609) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNVERIFIED_BY', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNVERIFIED_BY(109) : resource.sql(3621) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UNVERIFIED_BY;
ALTER FUNCTION SP_UNVERIFIED_BY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_RES_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_RES_REVISION
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_REVISION(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_REVISION(27) : resource.sql(3664) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_REVISION(33) : resource.sql(3670) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_REVISION(36) : resource.sql(3673) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_resource_id;
   BEGIN 
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_id; 
      IF SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') THEN 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True); 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE RESOURCES SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE RESOURCE_ID = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_REVISION', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_REVISION(68) : resource.sql(3705) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_REVISION', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_REVISION(74) : resource.sql(3711) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_REVISION', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_REVISION(81) : resource.sql(3718) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_REVISION', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_REVISION(93) : resource.sql(3730) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_REVISION;
ALTER FUNCTION SP_U_RES_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (RESOURCES)
*                           id = RESOURCE_ID in RESOURCES table, select from HISTORY_POOLS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = RESOURCE_ID in HISTORY_POOLS table, select from HISTORY_POOLS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = RESOURCE_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_RES_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_RES_REVISION
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_sql VARCHAR2(2048);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_RES_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_RES_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_RES_REVISION(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_RES_REVISION(22) : resource.sql(3777) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES_REVISION', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES_REVISION(27) : resource.sql(3782) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(30) : resource.sql(3785) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_resource_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(50) : resource.sql(3805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES_REVISION', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES_REVISION(57) : resource.sql(3812) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(60) : resource.sql(3815) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      -- the left joins inside the following select can be modified : please review it
      
      -- h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, REVISION_TYPE, REC_DATETIME, AUTHOR, CYCLE_NAME FROM( "
      h_sql := 
            'SELECT * FROM (SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, ''0000'' || B.RESOURCE_ID AS RANK, B.RESOURCE_ID AS PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, B.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.REC_DATETIME, C.FULL_NAME AS AUTHOR, '''' AS CYCLE_NAME '
             || 'FROM HISTORY_RESOURCES T LEFT JOIN RESOURCES B ON T.RESOURCE_ID = B.RESOURCE_ID JOIN RESOURCES C ON C.RESOURCE_ID = T.REC_USER WHERE T.RESOURCE_ID = ''' 
                  || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RESOURCE_ID INTO h_parent_id FROM HISTORY_RESOURCES WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(84) : resource.sql(3839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_RES_REVISION', 90+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_RES_REVISION(91) : resource.sql(3846) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 93+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(94) : resource.sql(3849) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
      End If;
      
      --  h_sql.sprintf("SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, REVISION_TYPE, REC_DATETIME, AUTHOR, CYCLE_NAME FROM( "
      
      -- the left joins inside the following select can be modified : please review it
      
      h_sql := 
            'SELECT * FROM (SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, ''0000'' || B.RESOURCE_ID AS RANK, B.RESOURCE_ID AS PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, B.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, T.REC_DATETIME, C.FULL_NAME AS AUTHOR, '''' AS CYCLE_NAME '
             || 'FROM HISTORY_RESOURCES T LEFT JOIN RESOURCES B ON T.RESOURCE_ID = B.RESOURCE_ID JOIN RESOURCES C ON C.RESOURCE_ID = T.REC_USER WHERE T.HISTORY_ID = ''' 
                  || h_parent_id || ''' '
             || ' ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 111+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(112) : resource.sql(3867) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_RES_REVISION', 114+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_RES_REVISION(115) : resource.sql(3870) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 122+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(123) : resource.sql(3878) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_RES_REVISION', 134+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_RES_REVISION(135) : resource.sql(3890) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_RES_REVISION;
ALTER FUNCTION SP_S_RES_REVISION COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_FIND_RESOURCE ==
CREATE OR REPLACE FUNCTION SP_FIND_RESOURCE
(
     p_first_name VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_last_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_first_name VARCHAR2(100);
   h_name VARCHAR2(100);
   h_last_name VARCHAR2(100);
   h_resource_id VARCHAR2(32);
   myStmt VARCHAR2(4000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FIND_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FIND_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := SP_FIND_RESOURCE(' || 
       '''' || p_first_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_last_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_RESOURCE', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FIND_RESOURCE(26) : resource.sql(3932) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT REPLACE( p_first_name, '*', '%' ) INTO h_name
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(40) : resource.sql(3946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT REPLACE(h_name, '''', '''''' ) INTO h_name
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(54) : resource.sql(3960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Return a resultset
   --myStmt.strcpy("SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, '0000' || R.RESOURCE_ID AS RANK, '' AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 0 AS DELETED_COUNT, R.REC_STATUS, '' AS DESCRIPTION, ");
   myStmt := 
          'SELECT R.RESOURCE_ID AS ELEMENT_ID, R.RESOURCE_ID AS ORIGINAL_ID, R.FULL_NAME AS ELEMENT_NAME, 0 AS CHILD_COUNT, 13 AS TYPE_ID, R.REC_STATUS, '''' AS DESCRIPTION, ';
   myStmt := myStmt || 
                    '(SELECT DOMAIN_ID FROM TMT_POOLS WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_POOLS WHERE ELEMENT_ID = R.RESOURCE_ID)) AS DOMAIN_ID, ';
   myStmt := myStmt || 
                    '(SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = (SELECT DOMAIN_ID FROM TMT_POOLS WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_POOLS WHERE ELEMENT_ID = R.RESOURCE_ID))) AS DOMAIN_NAME, ';
   myStmt := myStmt || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT MANAGER_ID FROM TMT_POOLS WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_POOLS WHERE ELEMENT_ID = R.RESOURCE_ID))) AS RESPONSIBLE, ';
   myStmt := myStmt || 
                    '((SELECT CASE WHEN RTRIM(ELEMENT_NAME) IS NOT NULL THEN RTRIM(ELEMENT_NAME) || '', '' ELSE NuLL END FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
   myStmt := myStmt || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
   myStmt := myStmt || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = R.RESOURCE_ID AND ';
   myStmt := myStmt || 'PARENT_ID = R.PRIMARY_ROLE)))  || ';
   myStmt := myStmt || '(SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
   myStmt := myStmt || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = R.RESOURCE_ID AND ';
   myStmt := myStmt || 'PARENT_ID = R.PRIMARY_ROLE))) AS COMPETENCY, ';
   myStmt := myStmt || 'R.TITLE, R.FIRST_NAME, R.LAST_NAME, R.REC_USER ';
   myStmt := myStmt || 'FROM RESOURCES R ';
   
   If (BITAND(Coalesce(p_bitflag, 0), 2)) = 2 Then
      h_resource_id := p_rec_user;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_POOLS_1';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_POOLS_2';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_MY_RESOURCES';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_MY_POOLS_1( ELEMENT_ID, RANK )
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM RESOURCE_ASSIGNMENTS RA
         JOIN TMT_POOLS P
         ON P.ELEMENT_ID = RA.ELEMENT_ID
         WHERE RA.RESOURCE_ID = h_resource_id
         AND ELEMENT_TYPE = PMO_CNST.SC_POOLS
         UNION ALL
         SELECT P.ELEMENT_ID, RTRIM(P.RANK)
         FROM TMT_POOLS P
         WHERE P.PUBLIC_FLAG = '1';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(117) : resource.sql(4023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_MY_POOLS_2
         SELECT M.ELEMENT_ID, M.RANK
         FROM PMO_MY_POOLS_1 M
         WHERE NOT EXISTS (
         SELECT B.ELEMENT_ID
         FROM PMO_MY_POOLS_1 A, PMO_MY_POOLS_1 B
         WHERE A.RANK < B.RANK
         AND SUBSTR(B.RANK, 1, LENGTH(A.RANK)) = A.RANK
         AND M.ELEMENT_ID = B.ELEMENT_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(142) : resource.sql(4048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_MY_RESOURCES
         SELECT P.ELEMENT_ID
         FROM TMT_POOLS P, PMO_MY_POOLS_2 MP
         WHERE P.RANK >= MP.RANK
         AND SUBSTR(P.RANK, 1, LENGTH(MP.RANK)) = MP.RANK
         AND P.TYPE_ID = PMO_CNST.SC_RESOURCE;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(164) : resource.sql(4070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      myStmt := myStmt || 'JOIN PMO_MY_RESOURCES MR ON MR.RESOURCE_ID = R.RESOURCE_ID ';
   End If;
   
   /*
       Safwan: (Emergency fix) I've added a condition AND RESOURCE_ID  <> LOGON_NAME to check for deleted records.  It seems that that the existing records
           are neither STATUS='D' nor ACTIVE='0'.
       */
   
   If (p_bitflag IS NOT NULL) AND ((BITAND(Coalesce(p_bitflag, 0), 1)) = 1) Then
      If (h_name IS NOT NULL) Then
         h_first_name := h_name;
         h_first_name := SubStr(h_first_name || '%%'')', 1, 100);
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.FULL_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_first_name;
      ElsIf (p_last_name IS NOT NULL) Then
         h_last_name := p_last_name;
         h_last_name := SubStr(h_last_name || '%%'')', 1, 100);
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.FULL_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_last_name;
      Else
         myStmt := myStmt || 'WHERE 1 = 2 ';
      End If;
   Else
      If (h_name IS NOT NULL) Then
         h_first_name := h_name;
         h_first_name := SubStr(h_first_name || '%%'')', 1, 100);
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.FIRST_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_first_name;
         
         If (p_last_name IS NOT NULL) Then
            h_last_name := p_last_name;
            h_last_name := SubStr(h_last_name || '%%'')', 1, 100);
            myStmt := myStmt || 
                    'AND R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.LAST_NAME) LIKE UPPER(''';
            myStmt := myStmt || h_last_name;
         End If;
      ElsIf (p_last_name IS NOT NULL) Then
         h_last_name := p_last_name;
         h_last_name := SubStr(h_last_name || '%%'')', 1, 100);
         myStmt := myStmt || 
                    'WHERE R.CALENDAR_ID IS NOT NuLL AND ACTIVE <> ''0'' AND (DISCONTINUE_DATE IS NULL OR DISCONTINUE_DATE >= TO_DATE(SYSDATE)) AND R.EFFECTIVE_DATE <= TO_DATE(SYSDATE) AND UPPER(R.LAST_NAME) LIKE UPPER(''';
         myStmt := myStmt || h_last_name;
      Else
         myStmt := myStmt || 'WHERE 1 = 2 ';
      End If;
   End If;
   
   If (BITAND(Coalesce(p_bitflag, 0), 8)) = 8 Then
      --      myStmt.strcat(" AND EXISTS (SELECT 1 FROM RESOURCE_ASSIGNMENTS RA WHERE RA.RESOURCE_ID = R.RESOURCE_ID AND RA.ELEMENT_TYPE = 11 AND RA.SECURITY_ID = 'SCRESOURCEMANAGER') ");
      myStmt := myStmt || 
                    ' AND EXISTS (SELECT 1 FROM RESOURCE_ASSIGNMENTS RA WHERE RA.RESOURCE_ID = R.RESOURCE_ID AND RA.ELEMENT_TYPE = 11) ';
   End If;
   
   --trace_printf("%s\n",(char *) myStmt);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_RESOURCE', 227+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_RESOURCE(228) : resource.sql(4134) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FIND_RESOURCE', 230+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_FIND_RESOURCE(231) : resource.sql(4137) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(myStmt);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 238+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(239) : resource.sql(4145) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FIND_RESOURCE', 250+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FIND_RESOURCE(251) : resource.sql(4157) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FIND_RESOURCE;
ALTER FUNCTION SP_FIND_RESOURCE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_U_RES_RATES ==
CREATE OR REPLACE FUNCTION SP_U_RES_RATES
(
     p_resource_id VARCHAR2
   , p_currency_id PLS_INTEGER
   , p_regular_cost NUMBER
   , p_regular_sale NUMBER
   , p_special_cost NUMBER
   , p_special_sale NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rate_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_exchange_rate NUMBER := 0.000;
   h_prj_rate NUMBER := 0.000;
   h_res_rate NUMBER := 0.000;
   h_currency_id PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_pa_timephase VARCHAR2(1);
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_old_reg_cost NUMBER := 0;
   h_old_reg_rate NUMBER := 0;
   h_rates_edited PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TARATES IS
         SELECT TW.PROJECT_ID, TW.CURRENCY_ID
         FROM TMT_WBS TW
         WHERE TW.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND EXISTS(SELECT * FROM TASK_ASSIGNMENTS TA
         WHERE TW.ELEMENT_ID = TA.PROJECT_ID AND TA.RESOURCE_ID = h_id);

      CURSOR C_TA_TP IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID, TASK_ID, RATES_EDITED,
         TO_DATE(SubStr(PROPOSED_START, 1, 10)), TO_DATE(SubStr(PROPOSED_FINISH, 1, 10)), BILLABLE, CAPITAL_EXPENSE,
         REGULAR_COST, REGULAR_RATE
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_id
         AND MILESTONE_PERCENT < 10000
         AND RATES_EDITED < 3;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_RATES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_RATES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_RATES(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_currency_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_regular_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_regular_sale), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_special_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_special_sale), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_RATES', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_RATES(65) : resource.sql(4238) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) OR (p_currency_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_RATES', 69+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_RATES(70) : resource.sql(4243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_RATES', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_RATES(73) : resource.sql(4246) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_id), p_resource_id, ind_u_res_rates->p_resource_id);
   h_id := p_resource_id;
   
   BEGIN 
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_id; 
      IF SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') THEN 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True); 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT RATE_ID INTO h_rate_id FROM RESOURCES WHERE RESOURCE_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(100) : resource.sql(4273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RATES
      SET REGULAR_COST = p_regular_cost,
      REGULAR_SALE = p_regular_sale,
      SPECIAL_COST = p_special_cost,
      SPECIAL_SALE = p_special_sale
      WHERE RATE_ID = h_rate_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(122) : resource.sql(4295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RESOURCES
      SET CURRENCY_ID = p_currency_id
      WHERE RESOURCE_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(141) : resource.sql(4314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --update TASK_ASSIGNMENTS
   
   OPEN C_TARATES;
   
   LOOP
      FETCH C_TARATES INTO h_project_id, h_currency_id;
      IF C_TARATES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      BEGIN
         SELECT PMO_ORASTD.TODECIMAL(COALESCE(ELEMENT_NAME, '1.000'), 18, 3)
         INTO h_res_rate
         FROM TMT_DATAFIELDS
         WHERE ELEMENT_ID = p_currency_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(172) : resource.sql(4345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT PMO_ORASTD.TODECIMAL(COALESCE(ELEMENT_NAME, '1.000'), 18, 3)
         INTO h_prj_rate
         FROM TMT_DATAFIELDS
         WHERE ELEMENT_ID = h_currency_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(188) : resource.sql(4361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_res_rate, 0) = 0.000 Then
         h_exchange_rate := 1.000;
      Else
         h_exchange_rate := Coalesce(h_prj_rate, 0) / Coalesce(h_res_rate, 0);
      End If;
      
      BEGIN
         SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(209) : resource.sql(4382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_TA_TP;
      
      LOOP
         FETCH C_TA_TP INTO h_tsk_assignment_id, h_prj_assignment_id,
         h_task_id, h_rates_edited,
         h_SD, h_FD, h_billable, h_capital_expense,
         h_old_reg_cost, h_old_reg_rate;
         IF C_TA_TP%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If ((h_prj_assignment_id IS NULL)) OR (SubStr(h_pa_timephase, 1, 1) = 'Y') Then
            h_tph_delete := -2;
            PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_SD, h_FD
                                            , h_old_reg_cost, h_old_reg_rate, h_tph_delete
                                            , h_capital_expense, h_billable);
            
            h_tph_delete := 0;
            If (BITAND(Coalesce(h_rates_edited, 0), 1)) <> 1 Then
               h_old_reg_cost := p_regular_cost;
            End If;
            
            If (BITAND(Coalesce(h_rates_edited, 0), 2)) <> 2 Then
               h_old_reg_rate := p_regular_sale;
            End If;
            
            PMO_DB2M.SC_STATE := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_task_id, h_tsk_assignment_id, h_SD, h_FD
                                            , h_old_reg_cost, h_old_reg_rate, h_tph_delete
                                            , h_capital_expense, h_billable);
         End If;
      END LOOP;
      BEGIN
         CLOSE C_TA_TP ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 257+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(258) : resource.sql(4431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update regular_cost and special_cost when nobody changed them manually in assignment
      -- the 1st bit of RATES_EDITED field means the cost values changed
      -- the 2rd bit of RATES_EDITED field means the rate values changed
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET REGULAR_COST = CASE WHEN BITAND(RATES_EDITED, 1)<>1 THEN p_regular_cost * h_exchange_rate ELSE REGULAR_COST END,
         SPECIAL_COST = CASE WHEN BITAND(RATES_EDITED, 1)<>1 THEN p_special_cost * h_exchange_rate ELSE SPECIAL_COST END,
         REGULAR_RATE = CASE WHEN BITAND(RATES_EDITED, 2)<>2 THEN p_regular_sale * h_exchange_rate ELSE REGULAR_RATE END,
         SPECIAL_RATE = CASE WHEN BITAND(RATES_EDITED, 2)<>2 THEN p_special_sale * h_exchange_rate ELSE SPECIAL_RATE END,
         ROLLUP_BITS =  PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_LABOR_BIT)
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_id
         AND MILESTONE_PERCENT < 10000;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 285+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(286) : resource.sql(4459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         --trace_printf("Project_id: %s\n", h_project_id);
         h_temp_sc_state := FC_Rollup(h_project_id);
      End If;
   END LOOP;
   BEGIN
      CLOSE C_TARATES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 303+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(304) : resource.sql(4477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_RATES', 309+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_RATES(310) : resource.sql(4483) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 316+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(317) : resource.sql(4490) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_RATES', 328+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_RATES(329) : resource.sql(4502) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_RATES;
ALTER FUNCTION SP_U_RES_RATES COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_ACTIVE ==
CREATE OR REPLACE FUNCTION SP_U_RES_ACTIVE
(
     p_resource_id VARCHAR2
   , p_active VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active VARCHAR2(1);
   h_calendar_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_ACTIVE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_ACTIVE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_ACTIVE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_active || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_ACTIVE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_ACTIVE(21) : resource.sql(4539) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_ACTIVE', 25+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_ACTIVE(26) : resource.sql(4544) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_ACTIVE', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_ACTIVE(29) : resource.sql(4547) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ACTIVE, CALENDAR_ID
      INTO h_active, h_calendar_id
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id
      AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(47) : resource.sql(4565) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_ACTIVE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_ACTIVE(54) : resource.sql(4572) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_ACTIVE', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_ACTIVE(57) : resource.sql(4575) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         ACTIVE = p_active,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(78) : resource.sql(4596) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_ACTIVE', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_ACTIVE(85) : resource.sql(4603) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(92) : resource.sql(4610) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_ACTIVE', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_ACTIVE(104) : resource.sql(4622) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_ACTIVE;
ALTER FUNCTION SP_U_RES_ACTIVE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_FS_LABOR_CODE ==
CREATE OR REPLACE FUNCTION SP_U_RES_FS_LABOR_CODE
(
     p_resource_id VARCHAR2
   , p_fs_labor_code VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active VARCHAR2(1);
   h_calendar_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_FS_LABOR_CODE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_FS_LABOR_CODE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_FS_LABOR_CODE(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_fs_labor_code || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FS_LABOR_CODE', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_FS_LABOR_CODE(21) : resource.sql(4659) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FS_LABOR_CODE', 25+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FS_LABOR_CODE(26) : resource.sql(4664) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FS_LABOR_CODE', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_FS_LABOR_CODE(29) : resource.sql(4667) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ACTIVE, CALENDAR_ID
      INTO h_active, h_calendar_id
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id
      AND REC_STATUS <> 'D';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(47) : resource.sql(4685) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_FS_LABOR_CODE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_FS_LABOR_CODE(54) : resource.sql(4692) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_FS_LABOR_CODE', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_FS_LABOR_CODE(57) : resource.sql(4695) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         FS_LABOR_CODE = p_fs_labor_code,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(78) : resource.sql(4716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_FS_LABOR_CODE', 84+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_FS_LABOR_CODE(85) : resource.sql(4723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 91+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(92) : resource.sql(4730) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_FS_LABOR_CODE', 103+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_FS_LABOR_CODE(104) : resource.sql(4742) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_FS_LABOR_CODE;
ALTER FUNCTION SP_U_RES_FS_LABOR_CODE COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_PASS_EXP ==
CREATE OR REPLACE FUNCTION SP_U_RES_PASS_EXP
(
     p_username VARCHAR2
   , p_old_password VARCHAR2
   , p_new_password VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_resource_id VARCHAR2(32);
   h_psw_expires PLS_INTEGER := 0;
   h_psw_versions PLS_INTEGER := 0;
   h_temp_str VARCHAR2(255);
   h_temp_str2 VARCHAR2(255);
   h_count PLS_INTEGER := 0;
   h_xcount PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_logon_name VARCHAR2(100);
   h_full_name VARCHAR2(100);
   h_nick_name VARCHAR2(100);
   h_new_password VARCHAR2(16);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_PASS_EXP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_PASS_EXP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_PASS_EXP(' || 
       '''' || p_username || ''''
          || ', ' || CASE WHEN p_old_password IS NULL THEN '''''' ELSE '''*******''' END
          || ', ' || CASE WHEN p_new_password IS NULL THEN '''''' ELSE '''*******''' END || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_PASS_EXP(31) : resource.sql(4789) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_username IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(36) : resource.sql(4794) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_username || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASS_EXP(39) : resource.sql(4797) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_username, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT RESOURCE_ID, PMO_ORASTD.PMO_DECRYPT(KEY_HISTORY, RESOURCE_ID), UPPER(LOGON_NAME), UPPER(FULL_NAME), UPPER(NICK_NAME), UPPER(p_new_password)
      INTO h_resource_id, h_temp_str, h_logon_name, h_full_name, h_nick_name, h_new_password
      FROM RESOURCES
      WHERE LOGON_NAME = p_username
      AND (LOGON_PASSWORD = PMO_ORASTD.PMO_ENCRYPT(p_old_password, RESOURCE_ID, '')
      OR PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) = p_old_password);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(59) : resource.sql(4817) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 64+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(65) : resource.sql(4823) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PASSWORD), 'NULL') || ' ID: ' || '''' || p_username || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASS_EXP(68) : resource.sql(4826) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PASSWORD, p_username, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If (PMO_ORASTD.strcmp(h_new_password, h_logon_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(
            h_new_password, h_full_name) = PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(h_new_password
            , h_nick_name) = PMO_CNST.SC_MATCH) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 75+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(76) : resource.sql(4834) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD), 'NULL') || ' ID: ' || '''' || p_username || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 78+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASS_EXP(79) : resource.sql(4837) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD, p_username
               , True);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'PASSWORD_MASK'
         AND RTRIM(DESCRIPTION) = UPPER(h_new_password);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(96) : resource.sql(4854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_PASS_EXP', 102+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_PASS_EXP(103) : resource.sql(4861) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(300112), 'NULL') || ' ID: ' || '''' || p_username || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 105+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASS_EXP(106) : resource.sql(4864) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(300112, p_username, True);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 119+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(120) : resource.sql(4878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_psw_versions, 0) = 0 Then
         --keep 0 version, so nullify history
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = NULL
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(141) : resource.sql(4899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_str := '';
         
         h_xcount := 0;
      Else
         h_psw_versions := Coalesce(h_psw_versions, 0) + 1;
         --(h_psw_versions > 1)  (h_temp_str != null)
         
         -- Commented by amir: ( ( h_temp_str_Ind == 0 )  ( strlen(h_temp_str) > 0 ) )
         If (h_temp_str IS NOT NULL) Then
            --h_psw_versions MUST > 0
            --history has at least 1 version
            h_count := 1;
            
            --find existing version of password history
            --and synchronize history max version with system setting
            
            h_temp_str2 := h_temp_str;
            
            h_bitflag := 1;
            WHILE Coalesce(h_bitflag, 0) > 0 LOOP
               BEGIN
                  SELECT InStr(h_temp_str2, ';;')  INTO h_bitflag
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 174+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(175) : resource.sql(4933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag, 0) > 0 Then
                  h_count := Coalesce(h_count, 0) + 1;
                  BEGIN
                     SELECT SUBSTR( h_temp_str2, InStr(h_temp_str2, ';;') + 1, LENGTH(h_temp_str2) - InStr(h_temp_str2, ';;'))
                     INTO h_temp_str2
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 191+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(192) : resource.sql(4950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            
            --remember the h_count
            If Coalesce(h_count, 0) > Coalesce(h_psw_versions, 0) Then
               h_count := Coalesce(h_count, 0) - Coalesce(h_psw_versions, 0);
               
               WHILE Coalesce(h_count, 0) > 0 LOOP
                  h_count := Coalesce(h_count, 0) - 1;
                  
                  BEGIN
                     SELECT InStr(h_temp_str, ';;')
                     INTO h_bitflag
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 215+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(216) : resource.sql(4974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_bitflag, 0) > 0 Then
                     BEGIN
                        SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
                        INTO h_temp_str
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 231+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(232) : resource.sql(4990) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_count := 0;
                  End If;
               END LOOP;
               
               h_xcount := Coalesce(h_psw_versions, 0);
            Else
               h_xcount := Coalesce(h_count, 0);
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = h_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 259+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(260) : resource.sql(5018) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --(h_psw_versions > 1)  (h_temp_str == null)
            BEGIN
               SELECT ';' || PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) || ';'
               INTO h_temp_str
               FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 275+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(276) : resource.sql(5034) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_temp_str IS NULL) Then
               h_temp_str := '';
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = h_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 298+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(299) : resource.sql(5057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_xcount := 1;
         End If;
      End If;
      
      --do the test
      h_count := 0;
      BEGIN
         SELECT InStr( RTRIM(h_temp_str), ';' || p_new_password || ';')
         INTO h_count
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 319+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(320) : resource.sql(5078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_PASS_EXP', 325+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_PASS_EXP(326) : resource.sql(5084) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PASSWORD_REUSED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_PASS_EXP', 328+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_PASS_EXP(329) : resource.sql(5087) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PASSWORD_REUSED, True);
      End If;
      
      If Coalesce(h_xcount, 0) > 0 Then
         If Coalesce(h_xcount, 0) = Coalesce(h_psw_versions, 0) Then
            BEGIN
               SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
               INTO h_temp_str
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 345+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(346) : resource.sql(5104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str || ';' || p_new_password || ';', RESOURCE_ID, '')
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 365+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(366) : resource.sql(5124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_expires FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'PASSWORD_EXPIRATION';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 380+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(381) : resource.sql(5139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Execute Update Resource
      BEGIN
         UPDATE RESOURCES SET
         LOGON_PASSWORD = PMO_ORASTD.PMO_ENCRYPT(p_new_password, RESOURCE_ID, ''),
         PASSWORD_EXPIRES = TO_DATE(SubStr(TO_DATE(SYSDATE) + h_psw_expires     , 1, 10)),
         REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = h_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(403) : resource.sql(5161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = 0 Then
         -- user changed his password correctly set MAX_PASSWORD_FAILURE field to zero
         BEGIN
            UPDATE RESOURCES
            SET MAX_PASSWORD_FAILURE = 0
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 423+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(424) : resource.sql(5182) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_PASS_EXP', 431+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_PASS_EXP(432) : resource.sql(5190) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_username || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_username, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 438+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(439) : resource.sql(5197) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_PASS_EXP', 450+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_PASS_EXP(451) : resource.sql(5209) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_PASS_EXP;
ALTER FUNCTION SP_U_RES_PASS_EXP COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_VERIFY_PASSWORD ==
CREATE OR REPLACE FUNCTION SP_VERIFY_PASSWORD
(
     p_resource_id VARCHAR2
   , p_password VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_psw_versions PLS_INTEGER := 0;
   h_temp_str VARCHAR2(255);
   h_temp_str2 VARCHAR2(255);
   h_count PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_full_name VARCHAR2(100);
   h_new_password VARCHAR2(16);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_VERIFY_PASSWORD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_VERIFY_PASSWORD'), '-- ' || SYSTIMESTAMP, ':r := SP_VERIFY_PASSWORD(' || 
       '''' || p_resource_id || ''''
          || ', ' || CASE WHEN p_password IS NULL THEN '''''' ELSE '''*******''' END || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VERIFY_PASSWORD', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_VERIFY_PASSWORD(24) : resource.sql(5249) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_resource_id IS NULL) OR (p_password IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(29) : resource.sql(5254) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VERIFY_PASSWORD', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_VERIFY_PASSWORD(32) : resource.sql(5257) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_resource_id, True);
   End If;
   
   -- Declare host variables
   
   h_new_password := p_password;
   
   BEGIN
      SELECT PMO_ORASTD.PMO_DECRYPT(KEY_HISTORY, RESOURCE_ID), FULL_NAME
      INTO h_temp_str, h_full_name
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(51) : resource.sql(5276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 57+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(58) : resource.sql(5283) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VERIFY_PASSWORD', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_VERIFY_PASSWORD(61) : resource.sql(5286) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If PMO_ORASTD.strcmp(h_new_password, h_full_name) = PMO_CNST.SC_MATCH Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 66+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(67) : resource.sql(5292) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VERIFY_PASSWORD', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_VERIFY_PASSWORD(70) : resource.sql(5295) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.FULL_NAME_CANNOT_BE_PASSWORD, p_resource_id
               , True);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'PASSWORD_MASK'
         AND RTRIM(DESCRIPTION) = UPPER(h_new_password);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(87) : resource.sql(5312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_VERIFY_PASSWORD', 93+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_VERIFY_PASSWORD(94) : resource.sql(5319) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(300112), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_VERIFY_PASSWORD', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_VERIFY_PASSWORD(97) : resource.sql(5322) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(300112, p_resource_id, True);
      End If;
      
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(111) : resource.sql(5336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_psw_versions, 0) = 0 Then
         --keep 0 version, so nullify history
         BEGIN
            UPDATE RESOURCES SET
            KEY_HISTORY = NULL
            WHERE RESOURCE_ID = p_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 131+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(132) : resource.sql(5357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_str := '';
      Else
         h_psw_versions := Coalesce(h_psw_versions, 0) + 1;
         
         If (h_temp_str IS NOT NULL) Then
            --h_psw_versions MUST > 0
            --history has at least 1 version
            h_count := 1;
            
            --find existing version of password history
            --and synchronize history max version with system setting
            
            h_temp_str2 := h_temp_str;
            
            h_bitflag := 1;
            WHILE Coalesce(h_bitflag, 0) > 0 LOOP
               BEGIN
                  SELECT  InStr(h_temp_str2, ';;')  INTO h_bitflag
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 161+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(162) : resource.sql(5387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_bitflag, 0) > 0 Then
                  h_count := Coalesce(h_count, 0) + 1;
                  BEGIN
                     SELECT SUBSTR( h_temp_str2, InStr(h_temp_str2, ';;') + 1, LENGTH(h_temp_str2) - InStr(h_temp_str2, ';;'))
                     INTO h_temp_str2
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 178+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(179) : resource.sql(5404) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            END LOOP;
            
            If Coalesce(h_count, 0) > Coalesce(h_psw_versions, 0) Then
               h_count := Coalesce(h_count, 0) - Coalesce(h_psw_versions, 0);
               WHILE Coalesce(h_count, 0) > 0 LOOP
                  h_count := Coalesce(h_count, 0) - 1;
                  
                  BEGIN
                     SELECT PMO_ORASTD.LOCATE(h_temp_str, ';;')
                     INTO h_bitflag
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 200+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(201) : resource.sql(5426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_bitflag, 0) > 0 Then
                     BEGIN
                        SELECT SUBSTR( h_temp_str, InStr(h_temp_str, ';;') + 1, LENGTH(h_temp_str) - InStr(h_temp_str, ';;'))
                        INTO h_temp_str
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 216+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(217) : resource.sql(5442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     h_count := 0;
                  End If;
               END LOOP;
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = p_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 240+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(241) : resource.sql(5466) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --(h_psw_versions > 1)  (h_temp_str == null)
            BEGIN
               SELECT ';' || PMO_ORASTD.PMO_DECRYPT(LOGON_PASSWORD, RESOURCE_ID) || ';'
               INTO h_temp_str
               FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 256+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(257) : resource.sql(5482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            If (h_temp_str IS NULL) Then
               h_temp_str := '';
            End If;
            
            BEGIN
               UPDATE RESOURCES SET
               KEY_HISTORY = PMO_ORASTD.PMO_ENCRYPT(h_temp_str, RESOURCE_ID, '')
               WHERE RESOURCE_ID = p_resource_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 278+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(279) : resource.sql(5504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      --do the test
      h_count := 0;
      BEGIN
         SELECT InStr(RTRIM(h_temp_str), ';' || p_password || ';')
         INTO h_count
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 297+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(298) : resource.sql(5523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_count, 0) > 0 Then
         PMO_DB2M.SC_STATE := PMO_CNST.PASSWORD_REUSED;
      Else
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = 0 Then
      -- user changed his password correctly set MAX_PASSWORD_FAILURE field to zero
      BEGIN
         UPDATE RESOURCES
         SET MAX_PASSWORD_FAILURE = 0
         WHERE RESOURCE_ID = p_resource_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 324+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(325) : resource.sql(5550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_VERIFY_PASSWORD', 331+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_VERIFY_PASSWORD(332) : resource.sql(5557) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 338+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(339) : resource.sql(5564) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_VERIFY_PASSWORD', 350+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_VERIFY_PASSWORD(351) : resource.sql(5576) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_VERIFY_PASSWORD;
ALTER FUNCTION SP_VERIFY_PASSWORD COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RES_CAPTION ==
CREATE OR REPLACE FUNCTION SP_U_RES_CAPTION
(
     p_resource_id VARCHAR2
   , p_portal_page VARCHAR2
   , p_dashboard VARCHAR2
   , p_portal_url1 VARCHAR2
   , p_portal_url2 VARCHAR2
   , p_portal_url3 VARCHAR2
   , p_portal_url4 VARCHAR2
   , p_portal_url5 VARCHAR2
   , p_overwritefile VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RES_CAPTION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RES_CAPTION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RES_CAPTION(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_portal_page || ''''
          || ', ' || '''' || p_dashboard || ''''
          || ', ' || '''' || p_portal_url1 || ''''
          || ', ' || '''' || p_portal_url2 || ''''
          || ', ' || '''' || p_portal_url3 || ''''
          || ', ' || '''' || p_portal_url4 || ''''
          || ', ' || '''' || p_portal_url5 || ''''
          || ', ' || '''' || p_overwritefile || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAPTION', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RES_CAPTION(34) : resource.sql(5626) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RES_CAPTION', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RES_CAPTION(40) : resource.sql(5632) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAPTION', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAPTION(43) : resource.sql(5635) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT REC_STATUS
      INTO h_rec_status
      FROM RESOURCES WHERE RESOURCE_ID = p_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(58) : resource.sql(5650) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAPTION', 64+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAPTION(65) : resource.sql(5657) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RESOURCE_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAPTION', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAPTION(68) : resource.sql(5660) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RESOURCE_NOT_FOUND, p_resource_id, True);
   End If;
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RES_CAPTION', 73+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RES_CAPTION(74) : resource.sql(5666) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RES_CAPTION', 76+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RES_CAPTION(77) : resource.sql(5669) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, p_resource_id, True);
   End If;
   
   --Execute Update Resource
   BEGIN
      UPDATE RESOURCES SET
      PORTAL_PAGE = p_portal_page,
      DASHBOARD = p_dashboard,
      OVERWRITEFILE = p_overwritefile,
      MY_PORTAL_URL_1 = p_portal_url1,
      MY_PORTAL_URL_2 = p_portal_url2,
      MY_PORTAL_URL_3 = p_portal_url3,
      MY_PORTAL_URL_4 = p_portal_url4,
      MY_PORTAL_URL_5 = p_portal_url5
      WHERE RESOURCE_ID  = p_resource_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(104) : resource.sql(5696) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RES_CAPTION', 109+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RES_CAPTION(110) : resource.sql(5702) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_resource_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_resource_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 116+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(117) : resource.sql(5709) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RES_CAPTION', 128+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RES_CAPTION(129) : resource.sql(5721) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RES_CAPTION;
ALTER FUNCTION SP_U_RES_CAPTION COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_A_RES_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_A_RES_COST_CENTER
(
     p_resource_id VARCHAR2
   , p_cost_center_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_var PLS_INTEGER := 0;
   h_cost_center_id VARCHAR2(32);
   h_last_cost_center_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_week_of DATE;
   h_min_SD DATE;
   h_max_SD DATE;
   h_min_FD DATE;
   h_max_FD DATE;
   h_current_date DATE;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_RES_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_RES_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_A_RES_COST_CENTER(' || 
       '''' || p_resource_id || ''''
          || ', ' || '''' || p_cost_center_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_RES_COST_CENTER', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_RES_COST_CENTER(34) : resource.sql(5771) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_resource_id IS NULL) OR (p_cost_center_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_RES_COST_CENTER', 39+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_RES_COST_CENTER(40) : resource.sql(5777) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_RES_COST_CENTER', 42+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_RES_COST_CENTER(43) : resource.sql(5780) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_resource_id;
   h_cost_center_id := p_cost_center_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT START_DATE INTO h_current_date
      FROM FISCAL_CALENDAR
      WHERE TO_DATE(SYSDATE) BETWEEN START_DATE AND FINISH_DATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(64) : resource.sql(5801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT MIN(START_DATE), MAX(START_DATE), MIN(FINISH_DATE), MAX(FINISH_DATE)
      INTO h_min_SD, h_max_SD, h_min_FD, h_max_FD
      FROM RESOURCE_COST_CENTERS
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(80) : resource.sql(5817) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COST_CENTER_ID, ELEMENT_ID INTO h_last_cost_center_id, h_id
      FROM RESOURCE_COST_CENTERS
      WHERE RESOURCE_ID = h_resource_id
      AND START_DATE = h_max_SD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(96) : resource.sql(5833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_ORASTD.strcmp(h_cost_center_id, h_last_cost_center_id) <> 0 Then
      h_count := 0;
      BEGIN
         SELECT MAX(S.WEEK_OF), COUNT(S.WEEK_OF) INTO h_week_of, h_count
         FROM TASK_ASSIGNMENTS TA, SUMMARY_TIMESHEETS S
         WHERE TA.RESOURCE_ID = h_resource_id AND TA.WORK_TODATE > 0
         AND TA.TSK_ASSIGNMENT_ID = S.TSK_ASSIGNMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(114) : resource.sql(5851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- get the start date of the new cost center
      If Coalesce(h_count, 0) = 0 Then
         If PMO_ORASTD.strncmp(h_max_SD, h_current_date, 10) < 0 Then
            h_start_date := h_current_date;
         Else
            BEGIN
               SELECT MIN(START_DATE) INTO h_start_date
               FROM FISCAL_CALENDAR
               WHERE START_DATE > TO_DATE(SubStr(h_max_SD, 1, 10));
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 133+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(134) : resource.sql(5871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         BEGIN
            SELECT MIN(START_DATE) INTO h_start_date
            FROM FISCAL_CALENDAR
            WHERE START_DATE > (TO_DATE(SubStr(h_week_of, 1, 10)) + 6     );
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 149+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(150) : resource.sql(5887) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strncmp(h_max_SD, h_start_date, 10) < 0 Then
            If PMO_ORASTD.strncmp(h_start_date, h_current_date, 10) < 0 Then
               h_start_date := h_current_date;
            End If;
         Else
            If PMO_ORASTD.strncmp(h_max_SD, h_current_date, 10) < 0 Then
               h_start_date := h_current_date;
            Else
               BEGIN
                  SELECT MIN(START_DATE) INTO h_start_date
                  FROM FISCAL_CALENDAR
                  WHERE START_DATE > TO_DATE(SubStr(h_max_SD, 1, 10));
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 172+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(173) : resource.sql(5910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      BEGIN
         UPDATE RESOURCE_COST_CENTERS
         SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1    
         WHERE RESOURCE_ID = h_resource_id
         AND START_DATE = h_max_SD;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 194+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(195) : resource.sql(5932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_id := SYS_GUID();
      h_id := h_id;
      BEGIN
         INSERT INTO RESOURCE_COST_CENTERS (ELEMENT_ID, RESOURCE_ID, COST_CENTER_ID, START_DATE, FINISH_DATE)
         VALUES (h_id, h_resource_id, h_cost_center_id, h_start_date, h_max_FD);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 214+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(215) : resource.sql(5952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_RES_COST_CENTER', 221+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_RES_COST_CENTER(222) : resource.sql(5959) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 228+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(229) : resource.sql(5966) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_RES_COST_CENTER', 240+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_RES_COST_CENTER(241) : resource.sql(5978) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_RES_COST_CENTER;
ALTER FUNCTION SP_A_RES_COST_CENTER COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_S_A_RES_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_S_A_RES_COST_CENTER
(
     p_resource_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_var PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CSRESCC PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_A_RES_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_A_RES_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_S_A_RES_COST_CENTER(' || 
       '''' || p_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_RES_COST_CENTER', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_A_RES_COST_CENTER(25) : resource.sql(6019) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_resource_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_A_RES_COST_CENTER', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_A_RES_COST_CENTER(31) : resource.sql(6025) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_RES_COST_CENTER', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_RES_COST_CENTER(34) : resource.sql(6028) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_resource_id := p_resource_id;
   h_rec_user := p_rec_user;
   
   OPEN CSRESCC FOR SELECT 0 AS LEVEL_ID, PMO_CNST.SC_CLIENTS AS TYPE_ID, h_resource_id AS PARENT_ID,
   RCC.ELEMENT_ID, 0 AS CHILD_COUNT, CC.ELEMENT_NAME, RCC.COST_CENTER_ID,
   RCC.START_DATE,
   CASE WHEN RCC.FINISH_DATE = TO_DATE(SubStr(TO_DATE('2300-12-30'), 1, 10)) THEN NuLL ELSE RCC.FINISH_DATE END AS FINISH_DATE
   FROM RESOURCE_COST_CENTERS RCC, TMT_CLIENTS CC
   WHERE RCC.RESOURCE_ID = h_resource_id
   AND CC.ELEMENT_ID = RCC.COST_CENTER_ID
   ORDER BY RCC.START_DATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_A_RES_COST_CENTER', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_A_RES_COST_CENTER(53) : resource.sql(6047) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CSRESCC;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_RES_COST_CENTER', 59+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_RES_COST_CENTER(60) : resource.sql(6054) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_A_RES_COST_CENTER', 71+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_A_RES_COST_CENTER(72) : resource.sql(6066) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_A_RES_COST_CENTER;
ALTER FUNCTION SP_S_A_RES_COST_CENTER COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_U_RCC_START ==
CREATE OR REPLACE FUNCTION SP_U_RCC_START
(
     p_id VARCHAR2
   , p_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_var PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_start_date DATE;
   h_old_start_date DATE;
   h_min_SD DATE;
   h_max_SD DATE;
   h_min_FD DATE;
   h_max_FD DATE;
   h_rec_user VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_last_cost_center_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_RCC_START') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_RCC_START'), '-- ' || SYSTIMESTAMP, ':r := SP_U_RCC_START(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_RCC_START(32) : resource.sql(6114) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_id IS NULL) OR (p_start_date IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_RCC_START', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_RCC_START(38) : resource.sql(6120) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(41) : resource.sql(6123) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_start_date := p_start_date;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT START_DATE, RESOURCE_ID INTO h_old_start_date, h_resource_id
      FROM RESOURCE_COST_CENTERS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(62) : resource.sql(6144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RCC_START', 68+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RCC_START(69) : resource.sql(6151) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(72) : resource.sql(6154) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      SELECT START_DATE INTO h_start_date
      FROM FISCAL_CALENDAR
      WHERE TO_DATE(SubStr(h_start_date, 1, 10)) BETWEEN START_DATE AND FINISH_DATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(87) : resource.sql(6169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   BEGIN
      SELECT MAX(START_DATE), COUNT(RESOURCE_ID) INTO h_max_SD, h_count
      FROM RESOURCE_COST_CENTERS
      WHERE RESOURCE_ID = h_resource_id
      AND START_DATE < TO_DATE(SubStr(h_old_start_date, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(104) : resource.sql(6186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RCC_START', 110+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RCC_START(111) : resource.sql(6193) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 113+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(114) : resource.sql(6196) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If PMO_ORASTD.strncmp(h_start_date, h_old_start_date, 10) < 0 Then
      BEGIN
         SELECT COUNT(RESOURCE_ID) INTO h_count
         FROM SUMMARY_TIMESHEETS
         WHERE RESOURCE_ID = h_resource_id
         AND WEEK_OF BETWEEN h_start_date AND h_old_start_date;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(131) : resource.sql(6213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RCC_START', 137+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RCC_START(138) : resource.sql(6220) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 140+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(141) : resource.sql(6223) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ELEMENT_IS_USED, h_id, True);
      End If;
      
      If PMO_ORASTD.strncmp(h_start_date, h_max_SD, 10) > 0 Then
         BEGIN
            UPDATE RESOURCE_COST_CENTERS
            SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1    
            WHERE RESOURCE_ID = h_resource_id
            AND START_DATE = h_max_SD;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(162) : resource.sql(6244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCE_COST_CENTERS
            SET START_DATE = TO_DATE(SubStr(h_start_date, 1, 10))
            WHERE RESOURCE_ID = h_resource_id
            AND START_DATE = TO_DATE(SubStr(h_old_start_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(182) : resource.sql(6264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         /*
                     // rollup project_cost_centers
                     BEGIN_SQL
                         UPDATE SUMMARY_TIMESHEETS
                         SET COST_CENTER_BITS = 1
                         WHERE RESOURCE_ID = HOST(h_resource_id)
                             AND (WEEKLY_REGULAR_TOTAL + WEEKLY_SPECIAL_TOTAL) > 0
                             AND (WEEK_OF BETWEEN DATE(HOST(h_start_date)) AND DATE(HOST(h_old_start_date))
                             OR (WEEK_OF + 6 DAY) BETWEEN DATE(HOST(h_start_date)) AND DATE(HOST(h_old_start_date)));
                     END_SQL;
         
                     if (SC_NODATA)
                     {
                         SC_STATE = 0;
                     }
         */
      Else
         --          RETURN_ERROR(CURESCC03, "new start date is too small", h_id);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RCC_START', 204+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RCC_START(205) : resource.sql(6287) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DUPLICATED_COST_CENTER), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 207+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(208) : resource.sql(6290) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DUPLICATED_COST_CENTER, h_id, True);
      End If;
   ElsIf PMO_ORASTD.strncmp(h_start_date, h_old_start_date, 10) > 0 Then
      BEGIN
         SELECT COUNT(RESOURCE_ID) INTO h_count
         FROM SUMMARY_TIMESHEETS
         WHERE RESOURCE_ID = h_resource_id
         AND WEEK_OF BETWEEN h_old_start_date AND h_start_date;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(224) : resource.sql(6306) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RCC_START', 230+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RCC_START(231) : resource.sql(6313) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 233+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(234) : resource.sql(6316) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ELEMENT_IS_USED, h_id, True);
      End If;
      
      h_count := 0;
      BEGIN
         SELECT MIN(START_DATE), COUNT(RESOURCE_ID) INTO h_min_SD, h_count
         FROM RESOURCE_COST_CENTERS
         WHERE RESOURCE_ID = h_resource_id
         AND START_DATE > TO_DATE(SubStr(h_old_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 250+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(251) : resource.sql(6333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR (Coalesce(h_count, 0) = 0) 
            OR (PMO_ORASTD.strncmp(h_start_date, h_min_SD, 10) < 0) Then
         BEGIN
            UPDATE RESOURCE_COST_CENTERS
            SET FINISH_DATE = TO_DATE(SubStr(h_start_date, 1, 10)) - 1    
            WHERE RESOURCE_ID = h_resource_id
            AND START_DATE = TO_DATE(SubStr(h_max_SD, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(273) : resource.sql(6355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCE_COST_CENTERS
            SET START_DATE = TO_DATE(SubStr(h_start_date, 1, 10))
            WHERE RESOURCE_ID = h_resource_id
            AND START_DATE = TO_DATE(SubStr(h_old_start_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 292+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(293) : resource.sql(6375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         /*
                     // rollup project_cost_centers
                     BEGIN_SQL
                         UPDATE SUMMARY_TIMESHEETS
                         SET COST_CENTER_BITS = 1
                         WHERE RESOURCE_ID = HOST(h_resource_id)
                             AND (WEEKLY_REGULAR_TOTAL + WEEKLY_SPECIAL_TOTAL) > 0
                             AND (WEEK_OF BETWEEN DATE(HOST(h_old_start_date)) AND DATE(HOST(h_start_date))
                             OR (WEEK_OF + 6 DAY) BETWEEN DATE(HOST(h_old_start_date)) AND DATE(HOST(h_start_date)));
                     END_SQL;
         
                     if (SC_NODATA)
                     {
                         SC_STATE = 0;
                     }
         */
      ElsIf PMO_ORASTD.strncmp(h_start_date, h_min_SD, 10) >= 0 Then
         --          RETURN_ERROR(CURESCC03, "new start date is too big", h_id);
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_RCC_START', 315+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_RCC_START(316) : resource.sql(6398) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DUPLICATED_COST_CENTER), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_RCC_START', 318+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_RCC_START(319) : resource.sql(6401) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.DUPLICATED_COST_CENTER, h_id, True);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_RCC_START', 325+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_RCC_START(326) : resource.sql(6408) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 332+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(333) : resource.sql(6415) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_RCC_START', 344+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_RCC_START(345) : resource.sql(6427) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_RCC_START;
ALTER FUNCTION SP_U_RCC_START COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION SP_D_RES_COST_CENTER ==
CREATE OR REPLACE FUNCTION SP_D_RES_COST_CENTER
(
     p_id VARCHAR2
   , p_resource_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_var PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_cost_center_id VARCHAR2(32);
   h_start_date DATE;
   h_finish_date DATE;
   h_old_start_date DATE;
   h_min_SD DATE;
   h_max_SD DATE;
   h_min_FD DATE;
   h_max_FD DATE;
   h_rec_user VARCHAR2(32);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_RES_COST_CENTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_RES_COST_CENTER'), '-- ' || SYSTIMESTAMP, ':r := SP_D_RES_COST_CENTER(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RES_COST_CENTER', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_RES_COST_CENTER(32) : resource.sql(6475) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate target  source id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_RES_COST_CENTER', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_RES_COST_CENTER(38) : resource.sql(6481) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RES_COST_CENTER', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_RES_COST_CENTER(41) : resource.sql(6484) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_resource_id := p_resource_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT START_DATE, FINISH_DATE, RESOURCE_ID, COST_CENTER_ID
      INTO h_start_date, h_finish_date, h_resource_id, h_cost_center_id
      FROM RESOURCE_COST_CENTERS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(63) : resource.sql(6506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_RES_COST_CENTER', 69+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_RES_COST_CENTER(70) : resource.sql(6513) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RES_COST_CENTER', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_RES_COST_CENTER(73) : resource.sql(6516) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   BEGIN
      SELECT COUNT(RESOURCE_ID) INTO h_count
      FROM SUMMARY_TIMESHEETS
      WHERE RESOURCE_ID = h_resource_id
      AND WEEK_OF BETWEEN h_start_date AND h_finish_date;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(89) : resource.sql(6532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_RES_COST_CENTER', 95+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_RES_COST_CENTER(96) : resource.sql(6539) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_IS_USED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RES_COST_CENTER', 98+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_RES_COST_CENTER(99) : resource.sql(6542) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ELEMENT_IS_USED, h_id, True);
   End If;
   
   --trace_printf("h_start_date: %d, %s\n", h_start_date_Ind, h_start_date);
   BEGIN
      SELECT MAX(START_DATE) INTO h_max_SD
      FROM RESOURCE_COST_CENTERS
      WHERE RESOURCE_ID = h_resource_id
      AND START_DATE < TO_DATE(SubStr(h_start_date, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(116) : resource.sql(6559) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d\n", SC_STATE);
   --trace_printf("h_max_SD: %d, %s\n", h_max_SD_Ind, h_max_SD);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR ((h_max_SD IS NULL)) Then
      BEGIN
         SELECT MIN(START_DATE) INTO h_min_SD
         FROM RESOURCE_COST_CENTERS
         WHERE RESOURCE_ID = h_resource_id
         AND START_DATE > TO_DATE(SubStr(h_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(135) : resource.sql(6578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d\n", SC_STATE);
      --trace_printf("h_min_SD: %d, %s\n", h_min_SD_Ind, h_min_SD);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR ((h_min_SD IS NULL)) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_RES_COST_CENTER', 143+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_RES_COST_CENTER(144) : resource.sql(6587) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_RES_COST_CENTER', 146+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_RES_COST_CENTER(147) : resource.sql(6590) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
      End If;
      
      BEGIN
         UPDATE RESOURCE_COST_CENTERS
         SET START_DATE = TO_DATE(SubStr(h_start_date, 1, 10))
         WHERE RESOURCE_ID = h_resource_id
         AND START_DATE = h_min_SD;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(167) : resource.sql(6610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_COST_CENTERS WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(184) : resource.sql(6627) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE RESOURCE_COST_CENTERS
         SET FINISH_DATE = TO_DATE(SubStr(h_finish_date, 1, 10))
         WHERE RESOURCE_ID = h_resource_id
         AND START_DATE = h_max_SD;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 203+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(204) : resource.sql(6647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM RESOURCE_COST_CENTERS WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(221) : resource.sql(6664) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   /*
       InitializeHost(SC_PARAM(h_count), 0);
       BEGIN_SQL
           SELECT COUNT(RESOURCE_ID) INTO HOST(h_count)
           FROM RESOURCE_COST_CENTERS
           WHERE RESOURCE_ID = HOST(h_resource_id)
               AND COST_CENTER_ID = HOST(h_cost_center_id);
       END_SQL;
   
       if (h_count == 0)
       {
           BEGIN_SQL
               UPDATE PROJECT_COST_CENTERS
               SET ACTUAL_COST = 0.00,
                   ACTUAL_REVENUE = 0.00
               WHERE RESOURCE_ID = HOST(h_resource_id)
                   AND COST_CENTER_ID = HOST(h_cost_center_id);
           END_SQL;
       }
   
       // rollup project_cost_centers
       BEGIN_SQL
           UPDATE SUMMARY_TIMESHEETS
           SET COST_CENTER_BITS = 1
           WHERE RESOURCE_ID = HOST(h_resource_id)
               AND (WEEKLY_REGULAR_TOTAL + WEEKLY_SPECIAL_TOTAL) > 0
               AND (WEEK_OF BETWEEN DATE(HOST(h_start_date)) AND DATE(HOST(h_finish_date))
               OR (WEEK_OF + 6 DAY) BETWEEN DATE(HOST(h_start_date)) AND DATE(HOST(h_finish_date)));
       END_SQL;
   */
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_RES_COST_CENTER', 260+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_RES_COST_CENTER(261) : resource.sql(6704) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 267+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(268) : resource.sql(6711) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_RES_COST_CENTER', 279+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_RES_COST_CENTER(280) : resource.sql(6723) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_RES_COST_CENTER;
ALTER FUNCTION SP_D_RES_COST_CENTER COMPILE DEBUG;

