Prompt == FUNCTION FC_I_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_WBS
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_WBS(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_WBS(27) : sc_def_func.sql(28) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_WBS', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_WBS (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_WBS WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(64) : sc_def_func.sql(65) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(79) : sc_def_func.sql(80) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(85) : sc_def_func.sql(86) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_WBS', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(105) : sc_def_func.sql(106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_WBS (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_WBS WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_WBS', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_WBS(152) : sc_def_func.sql(153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(159) : sc_def_func.sql(160) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_WBS', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_WBS(163) : sc_def_func.sql(164) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_WBS;
ALTER FUNCTION FC_I_SC_DEF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_CRI
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_CRI(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_CRI(27) : sc_def_func.sql(199) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_CRI', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_CRI (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_CRI WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(64) : sc_def_func.sql(236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(79) : sc_def_func.sql(251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(85) : sc_def_func.sql(257) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_CRI', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(105) : sc_def_func.sql(277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_CRI (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_CRI WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_CRI', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_CRI(152) : sc_def_func.sql(324) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(159) : sc_def_func.sql(331) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_CRI', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_CRI(163) : sc_def_func.sql(335) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_CRI;
ALTER FUNCTION FC_I_SC_DEF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_RES
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_RES(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_RES(27) : sc_def_func.sql(370) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_RES', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_RES (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_RES WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(64) : sc_def_func.sql(407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(79) : sc_def_func.sql(422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(85) : sc_def_func.sql(428) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_RES', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(105) : sc_def_func.sql(448) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_RES (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_RES WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_RES', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_RES(152) : sc_def_func.sql(495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(159) : sc_def_func.sql(502) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_RES', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_RES(163) : sc_def_func.sql(506) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_RES;
ALTER FUNCTION FC_I_SC_DEF_RES COMPILE DEBUG;

Prompt == FUNCTION FC_I_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_I_SC_DEF_AST
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rec_status VARCHAR2(1);
   h_max_rank PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_I_SC_DEF_AST(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_SC_DEF_AST(27) : sc_def_func.sql(541) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_parent_id IS NULL) Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_SCORECARDS_DEF_AST', h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_AST (
         RANK,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER)
         SELECT
         RTRIM(RANK) || h_rankBase64,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         0,
         0,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_AST WHERE ELEMENT_ID IS NULL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(64) : sc_def_func.sql(578) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(79) : sc_def_func.sql(593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 84+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(85) : sc_def_func.sql(599) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.RECORD_NOT_FOUND;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_SCORECARDS_DEF_AST', h_parent_id, h_max_rank);
      h_count := 1;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE Then
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = h_parent_id
            AND DEFAULT_ANSWER = 'Y';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 104+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(105) : sc_def_func.sql(619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            h_count := 0;
         End If;
      End If;
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         INSERT INTO TMT_SCORECARDS_DEF_AST (
         RANK,
         PROBABILITY_TYPE,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         DEFAULT_ANSWER,
         WEIGHT,
         CONVERTED_WEIGHT,
         REC_USER )
         SELECT
         RTRIM(COALESCE(RANK, '')) || h_rankBase64,
         PROBABILITY_TYPE,
         h_parent_id,
         h_uniqueID,
         h_name,
         h_type_id,
         LEVEL_ID + 1,
         CASE WHEN h_count = 1 THEN 'N' ELSE 'Y' END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         CASE WHEN h_type_id = PMO_CNST.SC_SYSTEM_ATTRIBUTE THEN 0 ELSE 1 END,
         h_rec_user
         FROM TMT_SCORECARDS_DEF_AST WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_SC_DEF_AST', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_SC_DEF_AST(152) : sc_def_func.sql(666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 158+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(159) : sc_def_func.sql(673) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_SC_DEF_AST', 162+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_SC_DEF_AST(163) : sc_def_func.sql(677) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_SC_DEF_AST;
ALTER FUNCTION FC_I_SC_DEF_AST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_WBS
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_WBS IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_WBS(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_WBS(41) : sc_def_func.sql(728) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(57) : sc_def_func.sql(744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(64) : sc_def_func.sql(751) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(90) : sc_def_func.sql(777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(114) : sc_def_func.sql(801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(150) : sc_def_func.sql(837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(188) : sc_def_func.sql(875) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_WBS;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         FETCH C_ans_WBS INTO h_description;
         IF C_ans_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := SubStr(h_ans_description || h_description, 1, 4000);
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 224+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(225) : sc_def_func.sql(912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_WBS', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_WBS(244) : sc_def_func.sql(931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 250+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(251) : sc_def_func.sql(938) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_WBS', 255+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_WBS(256) : sc_def_func.sql(943) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_WBS;
ALTER FUNCTION FC_U_SC_DEF_WBS COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_CRI
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_CRI IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_CRI(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_CRI(41) : sc_def_func.sql(994) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(57) : sc_def_func.sql(1010) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(64) : sc_def_func.sql(1017) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 89+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(90) : sc_def_func.sql(1043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 113+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(114) : sc_def_func.sql(1067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(150) : sc_def_func.sql(1103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(188) : sc_def_func.sql(1141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_CRI;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         FETCH C_ans_CRI INTO h_description;
         IF C_ans_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := SubStr(h_ans_description || h_description, 1, 4000);
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 224+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(225) : sc_def_func.sql(1178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_CRI', 243+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_CRI(244) : sc_def_func.sql(1197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 250+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(251) : sc_def_func.sql(1204) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_CRI', 255+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_CRI(256) : sc_def_func.sql(1209) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_CRI;
ALTER FUNCTION FC_U_SC_DEF_CRI COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_RES
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_RES IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_RES(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_RES(41) : sc_def_func.sql(1260) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(57) : sc_def_func.sql(1276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(63) : sc_def_func.sql(1282) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(89) : sc_def_func.sql(1308) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(113) : sc_def_func.sql(1332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(149) : sc_def_func.sql(1368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(187) : sc_def_func.sql(1406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_RES;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         FETCH C_ans_RES INTO h_description;
         IF C_ans_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := SubStr(h_ans_description || h_description, 1, 4000);
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(224) : sc_def_func.sql(1443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_RES', 242+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_RES(243) : sc_def_func.sql(1462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 249+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(250) : sc_def_func.sql(1469) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_RES', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_RES(255) : sc_def_func.sql(1474) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_RES;
ALTER FUNCTION FC_U_SC_DEF_RES COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_U_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_U_SC_DEF_AST
(
     sh_h_host_table PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_description IN OUT NOCOPY VARCHAR2
   , sh_h_probability_type PLS_INTEGER
   , sh_h_report_flag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_host_table PLS_INTEGER := sh_h_host_table;
   h_probability_type PLS_INTEGER := sh_h_probability_type;
   h_report_flag PLS_INTEGER := sh_h_report_flag;
   h_ans_description VARCHAR2(4000);
   h_question_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_cur_probability_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ans_AST IS
         SELECT '  ' || COALESCE(ELEMENT_NAME,'') || ' - ' || COALESCE(DESCRIPTION,'') || CHR(10) || CHR(13)
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_question_rank || '%'
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_DEF_AST(' || 
       COALESCE(TO_CHAR(sh_h_host_table), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_description || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_probability_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_report_flag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_DEF_AST(41) : sc_def_func.sql(1525) : ' || SYSTIMESTAMP);
   END IF; 

   h_ans_description := '';
   
   BEGIN
      SELECT RANK, SUBSTR(RANK,1,20), LEVEL_ID, PROBABILITY_TYPE, TYPE_ID
      INTO h_rank, h_question_rank, h_level_id, h_cur_probability_type, h_type_id
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(57) : sc_def_func.sql(1541) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(63) : sc_def_func.sql(1547) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If Coalesce(h_host_table, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         PROBABILITY_TYPE = h_probability_type,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(89) : sc_def_func.sql(1573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         ELEMENT_NAME = h_name,
         DESCRIPTION = h_description,
         REPORT_FLAG = h_report_flag,
         REC_STATUS = 'U',
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(113) : sc_def_func.sql(1597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Probability of all children
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_SCORECARD Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET PROBABILITY_TYPE = h_probability_type
         WHERE RANK LIKE h_rank || '%'
         AND PROBABILITY_TYPE_CHANGED = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(149) : sc_def_func.sql(1633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_CATEGORY1 Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET PROBABILITY_TYPE = h_probability_type,
         PROBABILITY_TYPE_CHANGED = 1
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(187) : sc_def_func.sql(1671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If Coalesce(h_level_id, 0) > 1 Then
      OPEN C_ans_AST;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         FETCH C_ans_AST INTO h_description;
         IF C_ans_AST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If (h_description IS NOT NULL) Then
            h_ans_description := SubStr(h_ans_description || h_description, 1, 4000);
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_ans_AST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(224) : sc_def_func.sql(1708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST
         SET ANSWER_DESCRIPTION = SUBSTR(h_ans_description,2)
         WHERE RANK = h_question_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_DEF_AST', 242+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_DEF_AST(243) : sc_def_func.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 249+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(250) : sc_def_func.sql(1734) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_DEF_AST', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_DEF_AST(255) : sc_def_func.sql(1739) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_DEF_AST;
ALTER FUNCTION FC_U_SC_DEF_AST COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_D_SC_DEF_WBS ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DWBS IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_WBS IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_WBS(47) : sc_def_func.sql(1796) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(64) : sc_def_func.sql(1813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(70) : sc_def_func.sql(1819) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(75) : sc_def_func.sql(1824) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(93) : sc_def_func.sql(1842) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(113) : sc_def_func.sql(1862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(119) : sc_def_func.sql(1868) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(133) : sc_def_func.sql(1882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(167) : sc_def_func.sql(1916) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(189) : sc_def_func.sql(1938) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(208) : sc_def_func.sql(1957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(229) : sc_def_func.sql(1978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(248) : sc_def_func.sql(1997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DWBS;
         
         FETCH C_DWBS INTO h_answer_id;
         IF C_DWBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(280) : sc_def_func.sql(2029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DWBS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(294) : sc_def_func.sql(2043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(303) : sc_def_func.sql(2052) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(323) : sc_def_func.sql(2072) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(342) : sc_def_func.sql(2091) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(356) : sc_def_func.sql(2105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_WBS SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(390) : sc_def_func.sql(2139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(409) : sc_def_func.sql(2158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(427) : sc_def_func.sql(2176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_WBS;
      
      LOOP
         FETCH C_D_WBS INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(463) : sc_def_func.sql(2212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(488) : sc_def_func.sql(2237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(511) : sc_def_func.sql(2260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_WBS TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_WBS
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(536) : sc_def_func.sql(2285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_WBS', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_WBS(551) : sc_def_func.sql(2300) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(558) : sc_def_func.sql(2307) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_WBS', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_WBS(562) : sc_def_func.sql(2311) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_WBS;
ALTER FUNCTION FC_D_SC_DEF_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_CRI ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DCRI IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_CRI IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_CRI(47) : sc_def_func.sql(2366) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(64) : sc_def_func.sql(2383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(70) : sc_def_func.sql(2389) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(75) : sc_def_func.sql(2394) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(93) : sc_def_func.sql(2412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(113) : sc_def_func.sql(2432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(119) : sc_def_func.sql(2438) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(133) : sc_def_func.sql(2452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(167) : sc_def_func.sql(2486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(189) : sc_def_func.sql(2508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(208) : sc_def_func.sql(2527) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(229) : sc_def_func.sql(2548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(248) : sc_def_func.sql(2567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DCRI;
         
         FETCH C_DCRI INTO h_answer_id;
         IF C_DCRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(280) : sc_def_func.sql(2599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DCRI ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(294) : sc_def_func.sql(2613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(303) : sc_def_func.sql(2622) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(323) : sc_def_func.sql(2642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(342) : sc_def_func.sql(2661) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(356) : sc_def_func.sql(2675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_CRI SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(390) : sc_def_func.sql(2709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(409) : sc_def_func.sql(2728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(427) : sc_def_func.sql(2746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_CRI;
      
      LOOP
         FETCH C_D_CRI INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(463) : sc_def_func.sql(2782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(488) : sc_def_func.sql(2807) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(511) : sc_def_func.sql(2830) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_CRI TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_CRI
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(536) : sc_def_func.sql(2855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_CRI', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_CRI(551) : sc_def_func.sql(2870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(558) : sc_def_func.sql(2877) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_CRI', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_CRI(562) : sc_def_func.sql(2881) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_CRI;
ALTER FUNCTION FC_D_SC_DEF_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_RES ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DRES IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_RES
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_RES IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_RES(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_RES(47) : sc_def_func.sql(2936) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(64) : sc_def_func.sql(2953) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(70) : sc_def_func.sql(2959) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(75) : sc_def_func.sql(2964) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(93) : sc_def_func.sql(2982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(113) : sc_def_func.sql(3002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(119) : sc_def_func.sql(3008) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(133) : sc_def_func.sql(3022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(167) : sc_def_func.sql(3056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(189) : sc_def_func.sql(3078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(208) : sc_def_func.sql(3097) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(229) : sc_def_func.sql(3118) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(248) : sc_def_func.sql(3137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DRES;
         
         FETCH C_DRES INTO h_answer_id;
         IF C_DRES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(280) : sc_def_func.sql(3169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DRES ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(294) : sc_def_func.sql(3183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(303) : sc_def_func.sql(3192) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(323) : sc_def_func.sql(3212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(342) : sc_def_func.sql(3231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(356) : sc_def_func.sql(3245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_RES SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(390) : sc_def_func.sql(3279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_RES
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(409) : sc_def_func.sql(3298) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(427) : sc_def_func.sql(3316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_RES;
      
      LOOP
         FETCH C_D_RES INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_RES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(463) : sc_def_func.sql(3352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_RES
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(488) : sc_def_func.sql(3377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(511) : sc_def_func.sql(3400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_RES TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_RES
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(536) : sc_def_func.sql(3425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_RES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_RES', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_RES(551) : sc_def_func.sql(3440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(558) : sc_def_func.sql(3447) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_RES', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_RES(562) : sc_def_func.sql(3451) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_RES;
ALTER FUNCTION FC_D_SC_DEF_RES COMPILE DEBUG;

Prompt == FUNCTION FC_D_SC_DEF_AST ==
CREATE OR REPLACE FUNCTION FC_D_SC_DEF_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_del_flag IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_answer_id VARCHAR2(32);
   h_check_rank VARCHAR2(200);
   h_current_datetime TIMESTAMP;
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_uflag PLS_INTEGER := 0;
   h_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_DAST IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_SCORECARDS_DEF_AST
         WHERE PARENT_ID = h_parent_id
         ORDER BY RANK
         ) WHERE ROWNUM<=1;

      CURSOR C_D_AST IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_SC_DEF_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_SC_DEF_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_D_SC_DEF_AST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_del_flag || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_SC_DEF_AST(47) : sc_def_func.sql(3506) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_rec_status := h_del_flag;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id AND REC_STATUS NOT IN ('L', 'D');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(64) : sc_def_func.sql(3523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 69+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(70) : sc_def_func.sql(3529) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL;
   ElsIf (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(75) : sc_def_func.sql(3534) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   --get element rank
   If (h_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_id AND PARENT_ID IS NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(93) : sc_def_func.sql(3552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rec_status := '';
      h_check_rank := h_rank;
   Else
      --InitializeHost(SC_PARAM(h_parent_id), p_parent_id, ind_d_scorecard->p_parent_id);
      BEGIN
         SELECT RANK, REC_STATUS, TYPE_ID, CASE WHEN DEFAULT_ANSWER = 'Y' THEN 1 ELSE 0 END
         INTO h_rank, h_rec_status, h_type_id, h_uflag
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_id AND PARENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 112+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(113) : sc_def_func.sql(3572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(119) : sc_def_func.sql(3578) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      --RANK LENGTH =< 12 ==> SCORECARD TYPE AND HIGHER
      BEGIN
         SELECT ( CASE WHEN LENGTH(h_rank) > 12 THEN SUBSTR(h_rank, 1, 12) ELSE h_rank END )  INTO  h_check_rank FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 132+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(133) : sc_def_func.sql(3592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_del_flag, 1, 1) = 'X' Then
      --Physical DELETE
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(167) : sc_def_func.sql(3626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Update the parent child_count or deleted count
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(189) : sc_def_func.sql(3648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DELETED_COUNT = DELETED_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(208) : sc_def_func.sql(3667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If (h_parent_id IS NULL) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 228+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(229) : sc_def_func.sql(3688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 247+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(248) : sc_def_func.sql(3707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_type_id, 0) = PMO_CNST.SC_SYSTEM_ATTRIBUTE) AND (Coalesce(h_uflag, 0) = 1) Then
         OPEN C_DAST;
         
         FETCH C_DAST INTO h_answer_id;
         IF C_DAST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST
               SET DEFAULT_ANSWER = 'Y'
               WHERE ELEMENT_ID = h_answer_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 279+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(280) : sc_def_func.sql(3739) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            CLOSE C_DAST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(294) : sc_def_func.sql(3753) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --Logical DELETE
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 302+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(303) : sc_def_func.sql(3762) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      End If;
      
      If (h_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NULL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 322+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(323) : sc_def_func.sql(3782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST
            SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 341+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(342) : sc_def_func.sql(3801) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         SELECT (SYSTIMESTAMP)  INTO  h_current_datetime FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 355+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(356) : sc_def_func.sql(3815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_SCORECARDS_DEF_AST SET
         REC_STATUS = h_del_flag,
         REC_DATETIME = h_current_datetime,
         REC_USER = h_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('I', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 389+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(390) : sc_def_func.sql(3849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
      BEGIN
         SELECT RTRIM(RANK)
         INTO h_rank
         FROM TMT_SCORECARDS_DEF_AST
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 408+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(409) : sc_def_func.sql(3868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID, RTRIM(RANK)
         INTO h_scorecard_id, h_scorecard_rank
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(427) : sc_def_func.sql(3886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_D_AST;
      
      LOOP
         FETCH C_D_AST INTO h_element_id, h_type_id, h_rank, h_weight;
         IF C_D_AST%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
            --Question level
            
            --update Answer level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST SET
               CONVERTED_WEIGHT = WEIGHT * h_weight
               WHERE PARENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 462+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(463) : sc_def_func.sql(3922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight at Question level
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_AST
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 487+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(488) : sc_def_func.sql(3947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Scorecard and Category level
            
            --update children hierarchy
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST SET
               CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
               WHERE RANK LIKE h_rank || '%'
               AND ELEMENT_ID <> h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(511) : sc_def_func.sql(3970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --update converted weight
            BEGIN
               UPDATE TMT_SCORECARDS_DEF_AST TS SET
               TS.CONVERTED_WEIGHT =
               (
               SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
               FROM TMT_SCORECARDS_DEF_AST
               WHERE PARENT_ID = TS.ELEMENT_ID
               )
               WHERE TS.ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(536) : sc_def_func.sql(3995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_AST ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_SC_DEF_AST', 550+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_SC_DEF_AST(551) : sc_def_func.sql(4010) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 557+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(558) : sc_def_func.sql(4017) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_SC_DEF_AST', 561+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_SC_DEF_AST(562) : sc_def_func.sql(4021) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_SC_DEF_AST;
ALTER FUNCTION FC_D_SC_DEF_AST COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_WBS ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_WBS(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_WBS(18) : sc_def_func.sql(4047) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(32) : sc_def_func.sql(4061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(38) : sc_def_func.sql(4067) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(57) : sc_def_func.sql(4086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_WBS', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_WBS(79) : sc_def_func.sql(4108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(85) : sc_def_func.sql(4114) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_WBS', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_WBS(89) : sc_def_func.sql(4118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_WBS;
ALTER FUNCTION FC_SET_SC_DEFAULT_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_CRI ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_CRI(18) : sc_def_func.sql(4144) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(32) : sc_def_func.sql(4158) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(38) : sc_def_func.sql(4164) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(57) : sc_def_func.sql(4183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_CRI', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_CRI(79) : sc_def_func.sql(4205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(85) : sc_def_func.sql(4211) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_CRI', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_CRI(89) : sc_def_func.sql(4215) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_CRI;
ALTER FUNCTION FC_SET_SC_DEFAULT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_RES ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_RES(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_RES(18) : sc_def_func.sql(4241) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(32) : sc_def_func.sql(4255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(38) : sc_def_func.sql(4261) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(57) : sc_def_func.sql(4280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_RES', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_RES(79) : sc_def_func.sql(4302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(85) : sc_def_func.sql(4308) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_RES', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_RES(89) : sc_def_func.sql(4312) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_RES;
ALTER FUNCTION FC_SET_SC_DEFAULT_RES COMPILE DEBUG;

Prompt == FUNCTION FC_SET_SC_DEFAULT_AST ==
CREATE OR REPLACE FUNCTION FC_SET_SC_DEFAULT_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_default_answer IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_parent_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SET_SC_DEFAULT_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SET_SC_DEFAULT_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_SET_SC_DEFAULT_AST(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_default_answer || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SET_SC_DEFAULT_AST(18) : sc_def_func.sql(4338) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PARENT_ID
      INTO h_parent_id
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 31+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(32) : sc_def_func.sql(4352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(38) : sc_def_func.sql(4358) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST
      SET DEFAULT_ANSWER = 'N'
      WHERE PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 56+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(57) : sc_def_func.sql(4377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST SET
      DEFAULT_ANSWER = 'Y',
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SET_SC_DEFAULT_AST', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SET_SC_DEFAULT_AST(79) : sc_def_func.sql(4399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(85) : sc_def_func.sql(4405) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SET_SC_DEFAULT_AST', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SET_SC_DEFAULT_AST(89) : sc_def_func.sql(4409) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SET_SC_DEFAULT_AST;
ALTER FUNCTION FC_SET_SC_DEFAULT_AST COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_WBS ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_WBS
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_WBS IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_WBS
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_WBS(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_WBS(30) : sc_def_func.sql(4447) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(46) : sc_def_func.sql(4463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(52) : sc_def_func.sql(4469) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_WBS SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(75) : sc_def_func.sql(4492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_WBS
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(94) : sc_def_func.sql(4511) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_WBS;
   
   LOOP
      FETCH C_WBS INTO h_id, h_type_id, h_rank, h_weight;
      IF C_WBS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(130) : sc_def_func.sql(4547) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(155) : sc_def_func.sql(4572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(191) : sc_def_func.sql(4608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_WBS TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_WBS
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(216) : sc_def_func.sql(4633) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_WBS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_WBS', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_WBS(231) : sc_def_func.sql(4648) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(237) : sc_def_func.sql(4654) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_WBS', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_WBS(241) : sc_def_func.sql(4658) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_WBS;
ALTER FUNCTION FC_U_SC_WEIGHT_WBS COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_CRI ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_CRI
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CRI IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_CRI
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_CRI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_CRI'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_CRI(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_CRI(30) : sc_def_func.sql(4696) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(46) : sc_def_func.sql(4712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(52) : sc_def_func.sql(4718) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_CRI SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(75) : sc_def_func.sql(4741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_CRI
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(94) : sc_def_func.sql(4760) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_CRI;
   
   LOOP
      FETCH C_CRI INTO h_id, h_type_id, h_rank, h_weight;
      IF C_CRI%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(130) : sc_def_func.sql(4796) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(155) : sc_def_func.sql(4821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(191) : sc_def_func.sql(4857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_CRI TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_CRI
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(216) : sc_def_func.sql(4882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_CRI ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_CRI', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_CRI(231) : sc_def_func.sql(4897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(237) : sc_def_func.sql(4903) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_CRI', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_CRI(241) : sc_def_func.sql(4907) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_CRI;
ALTER FUNCTION FC_U_SC_WEIGHT_CRI COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_RES ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_RES
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_RES IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_RES
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_RES(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_RES(30) : sc_def_func.sql(4945) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_RES
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(46) : sc_def_func.sql(4961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(52) : sc_def_func.sql(4967) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_RES SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(75) : sc_def_func.sql(4990) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_RES
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(94) : sc_def_func.sql(5009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_RES;
   
   LOOP
      FETCH C_RES INTO h_id, h_type_id, h_rank, h_weight;
      IF C_RES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(130) : sc_def_func.sql(5045) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(155) : sc_def_func.sql(5070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(191) : sc_def_func.sql(5106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_RES TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_RES
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(216) : sc_def_func.sql(5131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_RES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_RES', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_RES(231) : sc_def_func.sql(5146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(237) : sc_def_func.sql(5152) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_RES', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_RES(241) : sc_def_func.sql(5156) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_RES;
ALTER FUNCTION FC_U_SC_WEIGHT_RES COMPILE DEBUG;

Prompt == FUNCTION FC_U_SC_WEIGHT_AST ==
CREATE OR REPLACE FUNCTION FC_U_SC_WEIGHT_AST
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_weight PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_weight PLS_INTEGER := sh_h_weight;
   h_rank VARCHAR2(200);
   h_scorecard_id VARCHAR2(32);
   h_scorecard_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_AST IS
         SELECT ELEMENT_ID, TYPE_ID, RANK, WEIGHT
         FROM TMT_SCORECARDS_DEF_AST
         WHERE RANK LIKE h_scorecard_rank || '%'
         AND TYPE_ID NOT IN (PMO_CNST.SC_SYSTEM_ATTRIBUTE)
         ORDER BY RANK DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SC_WEIGHT_AST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SC_WEIGHT_AST'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SC_WEIGHT_AST(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_weight), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SC_WEIGHT_AST(30) : sc_def_func.sql(5194) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_SCORECARDS_DEF_AST
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(46) : sc_def_func.sql(5210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(52) : sc_def_func.sql(5216) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   BEGIN
      UPDATE TMT_SCORECARDS_DEF_AST SET
      WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      CONVERTED_WEIGHT = CASE WHEN TYPE_ID IN (PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CATEGORY1, PMO_CNST.SC_CLASSIFICATION) AND h_weight < 1 THEN 1 ELSE h_weight END,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER = h_rec_user
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(75) : sc_def_func.sql(5239) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --assuming the client not allow the user edit the weight on nodes that are higher than scorecard
   BEGIN
      SELECT ELEMENT_ID, RTRIM(RANK)
      INTO h_scorecard_id, h_scorecard_rank
      FROM TMT_SCORECARDS_DEF_AST
      WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
      AND SUBSTR(h_rank, 1, LENGTH(RANK)) = RANK
      AND TYPE_ID = PMO_CNST.SC_SCORECARD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(94) : sc_def_func.sql(5258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_AST;
   
   LOOP
      FETCH C_AST INTO h_id, h_type_id, h_rank, h_weight;
      IF C_AST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_CLASSIFICATION Then
         --Question level
         
         --update Answer level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST SET
            CONVERTED_WEIGHT = WEIGHT * h_weight
            WHERE PARENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 129+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(130) : sc_def_func.sql(5294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight at Question level
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( MAX(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(155) : sc_def_func.sql(5319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Scorecard and Category level
         
         --update children hierarchy
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST SET
            CONVERTED_WEIGHT = CONVERTED_WEIGHT * h_weight
            WHERE RANK LIKE h_rank || '%'
            AND ELEMENT_ID <> h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(191) : sc_def_func.sql(5355) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --update converted weight
         BEGIN
            UPDATE TMT_SCORECARDS_DEF_AST TS SET
            TS.CONVERTED_WEIGHT =
            (
            SELECT COALESCE( SUM(CONVERTED_WEIGHT), 1 )
            FROM TMT_SCORECARDS_DEF_AST
            WHERE PARENT_ID = TS.ELEMENT_ID
            )
            WHERE TS.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(216) : sc_def_func.sql(5380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_AST ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SC_WEIGHT_AST', 230+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SC_WEIGHT_AST(231) : sc_def_func.sql(5395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 236+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(237) : sc_def_func.sql(5401) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SC_WEIGHT_AST', 240+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SC_WEIGHT_AST(241) : sc_def_func.sql(5405) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SC_WEIGHT_AST;
ALTER FUNCTION FC_U_SC_WEIGHT_AST COMPILE DEBUG;

