/****************************************************************************************/

Prompt == FUNCTION FC_ASSIGN_TEAMMEMBER ==
CREATE OR REPLACE FUNCTION FC_ASSIGN_TEAMMEMBER
(
     x_prj_id IN OUT NOCOPY VARCHAR2
   , x_start_date IN OUT NOCOPY TIMESTAMP
   , sh_x_effort PLS_INTEGER
   , sh_x_consider_planned_sched PLS_INTEGER
   , x_pool_id IN OUT NOCOPY VARCHAR2
   , x_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   x_effort PLS_INTEGER := sh_x_effort;
   x_consider_planned_sched PLS_INTEGER := sh_x_consider_planned_sched;
   h_temp_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_and_roles VARCHAR2(8000);
   h_and_skills VARCHAR2(8000);
   h_shw_roles VARCHAR2(8000);
   h_shw_skills VARCHAR2(8000);
   h_and_role VARCHAR2(8000);
   h_and_skill VARCHAR2(8000);
   h_shw_role VARCHAR2(8000);
   h_shw_skill VARCHAR2(8000);
   h_res_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_dayofyear DATE;
   h_start_date TIMESTAMP;
   h_start_DT TIMESTAMP;
   h_finish_DT TIMESTAMP;
   h_task_start_DT TIMESTAMP;
   h_task_finish_DT TIMESTAMP;
   h_work_loc VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_assign_id VARCHAR2(32);
   h_role_id VARCHAR2(32);
   h_skill_id VARCHAR2(32);
   h_full_name VARCHAR2(255);
   h_rec_status VARCHAR2(1);
   h_bitflag PLS_INTEGER := 0;
   h_exists PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_update PLS_INTEGER := 0;
   h_work_type PLS_INTEGER := 0;
   h_work_location PLS_INTEGER := 0;
   h_cri PLS_INTEGER := 0;
   h_max_rows PLS_INTEGER := 0;
   h_work PLS_INTEGER := 0;
   h_occurrence PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_eunit PLS_INTEGER := 0;
   h_unit PLS_INTEGER := 0;
   h_consider PLS_INTEGER := 0;
   h_contour PLS_INTEGER := 0;
   h_every PLS_INTEGER := 0;
   h_per_day PLS_INTEGER := 0;
   h_per_week PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_bit_minutes PLS_INTEGER := 0;
   h_number PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_days PLS_INTEGER := 0;
   h_res_cost NUMBER := 0;
   h_rate_echange NUMBER := 0;
   h_total PLS_INTEGER := 0;
   h_pool_type PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_julian_day PLS_INTEGER := 0;
   h_j_efective_date PLS_INTEGER := 0;
   h_j_disconti_date PLS_INTEGER := 0;
   h_week PLS_INTEGER := 0;
   h_active VARCHAR2(1);
   h_task_type PLS_INTEGER := 0;
   h_sched_work PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   stmt VARCHAR2(7999);
   stwhere VARCHAR2(2999);
   h_temp_stmt VARCHAR2(7999);
   h_table_type PLS_INTEGER := 0;
   h_temp_participant PLS_INTEGER := 0;
   h_temp_security_id VARCHAR2(32);
   h_cri_security_id VARCHAR2(32);
   h_temp_var PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_continue_01 PLS_INTEGER := 0;
   i PLS_INTEGER NOT NULL := 1;
   i_row PLS_INTEGER NOT NULL := 0;
   i_return PLS_INTEGER NOT NULL := 0;
   iSF PLS_INTEGER NOT NULL := 0;
   token VARCHAR2(32);
   i_noskill PLS_INTEGER NOT NULL := 0;
   numItems PLS_INTEGER;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      C12 PMO_DB2M.REF_CURSOR;

      CURSOR C42 IS
         SELECT PROJECT_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id AND RESOURCE_ID = h_res_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ASSIGN_TEAMMEMBER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ASSIGN_TEAMMEMBER'), '-- ' || SYSTIMESTAMP, ':r := FC_ASSIGN_TEAMMEMBER(' || 
       '''' || x_prj_id || ''''
          || ', ' || COALESCE(NULLIF('''' || x_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_x_effort), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_x_consider_planned_sched), 'NULL')
          || ', ' || '''' || x_pool_id || ''''
          || ', ' || '''' || x_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 115+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ASSIGN_TEAMMEMBER(116) : statenotifyconfig.sql(119) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --to contain work location passed to function when null then 265
   
   -- Parse parameters to local variables
   h_project_id := x_prj_id;
   h_start_date := x_start_date;
   h_finish_DT := NULL;
   h_and_skills := NULL;
   h_and_roles := NULL;
   h_shw_roles := NULL;
   h_shw_skills := NULL;
   h_rec_user := x_rec_user;
   h_effort := 15;
   h_work := 0;
   h_occurrence := 0;
   h_max_rows := 50;
   h_eunit := 0;
   h_consider := 16;
   h_unit := 0;
   h_type := 1073741827;
   h_bitflag := 0;
   h_contour := 0;
   h_update := 0;
   h_work_type := 0;
   
   h_task_type := 0;
   h_sched_work := 0;
   --local variables
   --iSF == 0 when finish_date is null
   
   h_work_location := 265;
   
   h_start_DT := h_start_date;
   
   h_pool_type := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_type, 0), PMO_CNST.SC_C0000000)), 30);
   -- consider CRI  WBS
   h_type := BITAND(Coalesce(h_type, 0), PMO_CNST.SC_1FFFFFFF);
   
   h_cri := PMO_FUNC.ShiftRight((BITAND(Coalesce(h_consider, 0), PMO_CNST.SC_C0000000)), 30);
   -- consider CRI  WBS
   h_consider := BITAND(Coalesce(h_consider, 0), PMO_CNST.SC_1FFFFFFF);
   
   If Coalesce(h_type, 0) > 0 Then
      h_temp_var := 0;
      BEGIN
         SELECT LEVEL_LOCK INTO h_temp_var
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 172+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(173) : statenotifyconfig.sql(176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_temp_var, 0) > 0 Then
         BEGIN
            SELECT REC_STATUS INTO h_rec_status
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(189) : statenotifyconfig.sql(192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strcmp(h_rec_status, 'L') = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 195+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(196) : statenotifyconfig.sql(199) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.LEV_LOCKED_BY_COPY;
         End If;
      End If;
      
      h_table_type := GetTable(Coalesce(h_type, 0));
      If Coalesce(h_table_type, 0) = 0 Then
         h_type := GetAssnType(Coalesce(h_type, 0));
         If Coalesce(h_type, 0) = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 206+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(207) : statenotifyconfig.sql(210) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_PARAMS;
         End If;
         h_table_type := PMO_CNST.SC_TABLE_WBS;
      End If;
      h_task_id := h_project_id;
      
      h_res_id := x_pool_id;
      
      If Coalesce(h_type, 0) > 0 Then
         If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            BEGIN
               SELECT B.TASK_TYPE, B.UNRESOLVED_START, B.UNRESOLVED_FINISH, B.PROJECT_ID,
               COALESCE(A.MINUTE_PER_DAY, 480), COALESCE(A.MINUTE_PER_WEEK, 2400), A.PRIORITY, B.PLANNED_EFFORT + B.SCHED_EFFORT
               INTO h_task_type, h_task_start_DT, h_task_finish_DT, h_project_id,
               h_per_day, h_per_week, h_priority, h_sched_work
               FROM TMT_WBS A, TMT_WBS B
               WHERE B.ELEMENT_ID = h_task_id
               AND A.ELEMENT_ID = B.PROJECT_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 232+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(233) : statenotifyconfig.sql(236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 239+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(240) : statenotifyconfig.sql(243) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.RECORD_NOT_FOUND;
            End If;
         End If;
         BEGIN
            SELECT NICK_NAME, PMO_ORASTD.JULIAN_DAY(h_start_DT), ACTIVE, COALESCE(PMO_ORASTD.JULIAN_DAY(EFFECTIVE_DATE),0),COALESCE(PMO_ORASTD.JULIAN_DAY(DISCONTINUE_DATE),0)
            INTO h_full_name, h_julian_day, h_active, h_j_efective_date, h_j_disconti_date
            FROM RESOURCES
            WHERE RESOURCE_ID = h_res_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 255+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(256) : statenotifyconfig.sql(259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 262+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(263) : statenotifyconfig.sql(266) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.RECORD_NOT_FOUND;
         ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            If (SubStr(h_active, 1, 1) = '0') OR ((Coalesce(h_j_disconti_date, 0) > 0) AND (Coalesce(
                  h_julian_day, 0) > Coalesce(h_j_disconti_date, 0))) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 269+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(270) : statenotifyconfig.sql(273) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.RESOURCE_NOT_ACTIVE;
            Else
               h_res_type := '0';
            End If;
         End If;
      End If;
   End If;
   
   h_work := 0;
   
   If iSF = 0 Then
      h_start_DT := x_start_date;
      h_finish_DT := NULL;
      
      h_temp_var := FC_CALC_DURATION(h_start_DT, h_finish_DT, Coalesce(h_eunit, 0), Coalesce(h_unit, 0)
                               , Coalesce(h_consider, 0), Coalesce(h_bitflag, 0), Coalesce(
                               h_contour, 0), Coalesce(h_occurrence, 0), Coalesce(h_per_day, 0)
                               , Coalesce(h_per_week, 0), h_work, h_effort, h_duration);
      
      If Coalesce(h_temp_var, 0) = PMO_CNST.INVALID_PARAMS Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 292+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(293) : statenotifyconfig.sql(296) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      ElsIf Coalesce(h_temp_var, 0) <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 297+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(298) : statenotifyconfig.sql(301) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN Coalesce(h_temp_var, 0);
      End If;
      
      h_finish_DT := h_finish_DT;
      If (h_finish_DT IS NULL) Then
         h_finish_DT := '';
      End If;
   ElsIf (Coalesce(h_work, 0) > 0) AND (Coalesce(h_unit, 0) <> 100) Then
      If (Coalesce(h_unit, 0) = 1) OR (Coalesce(h_unit, 0) = 2) Then
         h_eunit := 2;
      ElsIf Coalesce(h_unit, 0) = 0 Then
         h_eunit := 1;
      ElsIf (Coalesce(h_unit, 0) = 3) OR (Coalesce(h_unit, 0) = 4) Then
         h_eunit := 1;
      ElsIf Coalesce(h_unit, 0) = 5 Then
         h_work := Coalesce(h_per_week, 0) * Coalesce(h_work, 0);
         h_eunit := 3;
      End If;
   End If;
   
   If (iSF = 0) AND (Coalesce(h_duration, 0) = 0) AND (Coalesce(Length(h_finish_DT), 0) > 0) Then
      BEGIN
         SELECT COUNT(DAY_YEAR)
         INTO h_duration
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_DT, 1, 10)) AND TO_DATE(SubStr(h_finish_DT, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 332+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(333) : statenotifyconfig.sql(336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_temp_sc_state := FC_DECLARE_PMO_TMP_SEARCH();
   
   If Coalesce(h_max_rows, 0) = 0 Then
      h_max_rows := PMO_CNST.SC_MAX_ROWS;
   End If;
   
   stmt := '';
   stwhere := '';
   If Coalesce(h_type, 0) > 0 Then
      If Coalesce(h_consider, 0) = 10 Then
         stmt := 
               'SELECT r.RESOURCE_ID FROM RESOURCE_ASSIGNMENTS ra JOIN TASK_ASSIGNMENTS ta ON ra.ELEMENT_ID=''';
         stmt := stmt || h_project_id;
         stmt := stmt || ''' AND ra.RESOURCE_ID=''';
         stmt := stmt || h_res_id;
         stmt := stmt || ''' AND ra.TSK_ASSIGNMENT_ID=ta.TSK_ASSIGNMENT_ID '
                || 'JOIN RESOURCES r ON ra.RESOURCE_ID=r.RESOURCE_ID';
      Else
         stmt := 
               'SELECT r.RESOURCE_ID FROM RESOURCES r WHERE r.CALENDAR_ID IS NOT NuLL AND r.RESOURCE_ID = ''';
         stmt := stmt || h_res_id;
         stmt := stmt || '''';
      End If;
   Else
      If (Coalesce(h_consider, 0) <> PMO_CNST.SC_SRCH_PROFILE) AND (Coalesce(
             h_consider, 0) <> PMO_CNST.SC_SRCH_FROM_PROJECT) Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CPLN_0007';
         PMO_DB2M.SC_STATE := 0;
         
         h_res_id := x_pool_id;
         
         BEGIN
            INSERT INTO PMO_TMP_CPLN_0007
            SELECT RANK FROM TMT_POOLS
            WHERE ELEMENT_ID = h_res_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 384+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(385) : statenotifyconfig.sql(388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      If Coalesce(h_consider, 0) = 10 Then
         stmt := 
               'SELECT r.RESOURCE_ID FROM RESOURCES r JOIN RESOURCE_ASSIGNMENTS ra ON BITAND(ra.PARTICIPANT,4096)>0 AND ra.ELEMENT_ID=''';
         stmt := stmt || h_project_id;
         stmt := stmt || ''' AND ra.RESOURCE_ID=r.RESOURCE_ID';
         stwhere := ' WHERE';
      Else
         stmt := stmt || 'SELECT DISTINCT r.RESOURCE_ID FROM TMT_POOLS TP, PMO_TMP_CPLN_0007 MP, RESOURCES r';
         stwhere := ' WHERE TP.ELEMENT_ID=R.RESOURCE_ID '
                || ' AND (MP.RANK >= SUBSTR(TP.RANK, 1, 8) AND MP.RANK <= TP.RANK '
                || ' AND  substr(TP.RANK, 1, case when length(MP.RANK) > length(TP.RANK) then 1 else length(MP.RANK) end) = MP.RANK) '
                || ' AND r.CALENDAR_ID IS NOT NuLL';
      End If;
      
      If Coalesce(h_consider, 0) <> PMO_CNST.SC_SRCH_PROFILE Then
         If (x_pool_id IS NOT NULL) Then
            BEGIN
               SELECT RANK INTO h_rank FROM TMT_POOLS WHERE ELEMENT_ID = x_pool_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 413+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(414) : statenotifyconfig.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               stmt := SubStr(stmt || ',TMT_POOLS p', 1, 7999);
               If Length(stwhere) > 7 Then
                  stwhere := SubStr(stwhere || 
                             ' AND r.RESOURCE_ID=p.ELEMENT_ID AND SUBSTR(p.RANK, 1, CASE WHEN LENGTH('''
                             , 1, 2999);
               Else
                  stwhere := SubStr(stwhere || ' r.RESOURCE_ID=p.ELEMENT_ID AND SUBSTR(p.RANK, 1, CASE WHEN LENGTH('''
                             , 1, 2999);
               End If;
               stwhere := stwhere || h_rank;
               stwhere := stwhere || ''') > LENGTH(p.RANK) THEN 1 ELSE LENGTH(''';
               stwhere := stwhere || h_rank;
               stwhere := stwhere || ''') END) = ''';
               stwhere := stwhere || h_rank;
               stwhere := stwhere || '''';
               stwhere := stwhere || 'AND (p.RANK LIKE SUBSTR(''';
               stwhere := stwhere || h_rank;
               stwhere := stwhere || ''', 1, 8) || ''%'') ';
            Else
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 439+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(440) : statenotifyconfig.sql(443) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.INVALID_PARAMS;
            End If;
         End If;
      End If;
      
      token := SubStr(token, 1, PMO_CNST.SC_H_ID - 1);
      
      If Length(stwhere) > 7 Then
         stmt := stmt || stwhere;
      End If;
   End If;
   
   h_temp_stmt := ' ORDER BY r.RESOURCE_ID  ';
   stmt := stmt || h_temp_stmt;
   
   OPEN C12 FOR stmt;
   
   LOOP
      h_continue_01 := 1;
      -- reset continue variables for this iteration
      
      FETCH C12 INTO h_res_id;
      IF C12%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If (Coalesce(h_type, 0) = 0) AND ((Coalesce(h_consider, 0) <> PMO_CNST.SC_SRCH_PARTICIPANT) 
             AND (Coalesce(h_consider, 0) <> PMO_CNST.SC_SRCH_FROM_PROJECT) AND ((Coalesce(
             h_consider, 0) <> PMO_CNST.SC_SRCH_PROFILE) OR ((x_pool_id IS NULL)))) Then
         OPEN C42;
         
         FETCH C42 INTO h_uniqueID;
         IF C42%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               CLOSE C42 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 492+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(493) : statenotifyconfig.sql(496) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_continue_01 := 0;
         Else
            BEGIN
               CLOSE C42 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 506+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(507) : statenotifyconfig.sql(510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If Coalesce(h_continue_01, 0) = 1 Then
         If Coalesce(h_type, 0) > 0 Then
            If SubStr(h_res_type, 1, 1) = '1' Then
               --Get a unique ID
               h_assign_id := SYS_GUID();
               h_exists := 0;
            Else
               BEGIN
                  SELECT RES_ASSIGNMENT_ID, PARTICIPANT INTO h_assign_id, h_number FROM RESOURCE_ASSIGNMENTS
                  WHERE ELEMENT_ID = h_task_id AND RESOURCE_TYPE = h_res_type AND RESOURCE_ID = h_res_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 529+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(530) : statenotifyconfig.sql(533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
                  --Get a unique ID
                  h_assign_id := SYS_GUID();
                  h_exists := 0;
               ElsIf (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (isNotProjectType(Coalesce(
                     h_type, 0))) <> 0 AND ((BITAND(Coalesce(
                     h_number, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER) Then
                  BEGIN
                     CLOSE C12 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 549+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(550) : statenotifyconfig.sql(553) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 555+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(556) : statenotifyconfig.sql(559) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_CNST.RECORD_ALREADY_ASSIGNED;
               Else
                  h_exists := 1;
               End If;
            End If;
            
            If Coalesce(h_exists, 0) = 0 Then
               If isTask(Coalesce(h_type, 0)) <> 0 OR isChangeToTask(Coalesce(h_type, 0)) <> 0 Then
                  If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
                     BEGIN
                        UPDATE TMT_WBS SET ASSIGN_NAMES = ASSIGN_NAMES || h_full_name || ';'  WHERE ELEMENT_ID = h_task_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 578+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(579) : statenotifyconfig.sql(582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  h_temp_sc_state := GetSecurityID(Coalesce(h_table_type, 0), Coalesce(h_type, 0)
                                 , PMO_CNST.SC_TEAMMEMBER_GROUP, h_temp_security_id);
                  
                  h_temp_participant := PMO_CNST.SC_TEAMMEMBER;
                  h_temp_bitflag := 1;
                  
                  h_temp_sc_state := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_res_id, h_type, h_temp_participant
                                          , h_temp_security_id, h_res_type, h_temp_bitflag);
                  
                  h_temp_sc_state := FC_GET_CRI_SECURITY_ID(h_task_id, h_type, h_temp_security_id, h_cri_security_id);
                  
                  BEGIN
                     INSERT INTO RESOURCE_ASSIGNMENTS(RES_ASSIGNMENT_ID, PROJECT_ID, ELEMENT_ID, ELEMENT_TYPE,
                     RESOURCE_TYPE, WORK_LOCATION, RESOURCE_ID, PARTICIPANT,SECURITY_ID, CRI_SECURITY_ID, REC_USER, REC_DATETIME, TABLE_TYPE)
                     VALUES (h_assign_id, h_project_id, h_task_id, h_type,
                     h_res_type, h_work_location, h_res_id, PMO_CNST.SC_TEAMMEMBER, h_temp_security_id, h_cri_security_id, x_rec_user, SYSTIMESTAMP, h_table_type);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 610+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(611) : statenotifyconfig.sql(614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
            
            i_return := FC_SEARCH_2(h_assign_id, h_project_id, h_task_id, h_res_id, h_res_cost, h_type
                        , h_and_roles, h_and_skills, h_shw_roles, h_shw_skills, h_start_DT
                        , h_finish_DT, h_duration, h_effort, h_work, h_eunit, h_unit, h_cri
                        , h_consider, h_res_type, h_work_type, h_bitflag, h_contour, h_occurrence
                        , h_update, h_per_day, h_priority, h_rec_user, Coalesce(h_per_day, 0), 0
                        , 0.00, 0.00);
            
            If i_return <> 0 Then
               BEGIN
                  CLOSE C12 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 633+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(634) : statenotifyconfig.sql(637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If i_return < 200000 Then
                  i_return := PMO_CNST.TASK_ASSIGNMENT_ERROR;
               End If;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 643+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(644) : statenotifyconfig.sql(647) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN i_return;
            End If;
            
            EXIT;
         Else
            i_return := FC_SEARCH_2(h_assign_id, h_project_id, h_task_id, h_res_id, h_res_cost, h_type
                        , h_and_roles, h_and_skills, h_shw_roles, h_shw_skills, h_start_DT
                        , h_finish_DT, h_duration, h_effort, h_work, h_eunit, h_unit, h_cri
                        , h_consider, h_res_type, h_work_type, h_bitflag, h_contour, h_occurrence
                        , h_update, h_per_day, h_priority, h_rec_user, 0, 0, 0.00, 0.00);
            
            If i_return = 0 Then
               i_row := i_row + 1;
            End If;
            
            If i_row = Coalesce(h_max_rows, 0) Then
               EXIT;
            End If;
         End If;
      End If;
   END LOOP;
   -- end of while
   
   BEGIN
      CLOSE C12 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ASSIGN_TEAMMEMBER', 676+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ASSIGN_TEAMMEMBER(677) : statenotifyconfig.sql(680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ASSIGN_TEAMMEMBER', 682+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ASSIGN_TEAMMEMBER(683) : statenotifyconfig.sql(686) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ASSIGN_TEAMMEMBER;
ALTER FUNCTION FC_ASSIGN_TEAMMEMBER COMPILE DEBUG;

/************************************************************************/

Prompt == FUNCTION GetDataFieldTypeID ==
CREATE OR REPLACE FUNCTION GetDataFieldTypeID
(
     sh_h_bitflag PLS_INTEGER
   , h_type_id IN OUT NOCOPY PLS_INTEGER
   , h_name IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('GetDataFieldTypeID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('GetDataFieldTypeID'), '-- ' || SYSTIMESTAMP, ':r := GetDataFieldTypeID(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_type_id), 'NULL')
          || ', ' || '''' || h_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetDataFieldTypeID', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: GetDataFieldTypeID(18) : statenotifyconfig.sql(714) : ' || SYSTIMESTAMP);
   END IF; 

   CASE h_bitflag
      WHEN PMO_CNST.SC_PROJECT THEN
         h_type_id := 12;
         h_name := 'Project';
         
      
      WHEN PMO_CNST.SC_PROPOSAL THEN
         h_type_id := 12;
         h_name := 'Project';
         
      
      WHEN PMO_CNST.SC_PROJ_TYPE1 THEN
         h_type_id := 12;
         h_name := 'Project';
         
      
      WHEN PMO_CNST.SC_PROJ_TYPE2 THEN
         h_type_id := 12;
         h_name := 'Project';
         
      
      WHEN PMO_CNST.SC_PROJ_TYPE3 THEN
         h_type_id := 12;
         h_name := 'Project';
         
      
      WHEN PMO_CNST.SC_DELIVERABLE THEN
         h_type_id := 119;
         h_name := 'Deliverable';
         
      
      WHEN PMO_CNST.SC_TASK THEN
         h_type_id := 120;
         h_name := 'Task';
         
      
      WHEN PMO_CNST.SC_CRI_CHANGE_REQUEST THEN
         h_type_id := 19;
         h_name := 'Change Request';
         
      
      WHEN PMO_CNST.SC_CRI_RISK THEN
         h_type_id := 99;
         h_name := 'Risk';
         
      
      WHEN PMO_CNST.SC_CRI_ISSUE THEN
         h_type_id := 106;
         h_name := 'Issue';
         
      
      WHEN PMO_CNST.SC_DOCUMENT THEN
         h_type_id := 108;
         h_name := 'Document';
         
      
      WHEN PMO_CNST.SC_NOTE_MINUTES THEN
         h_type_id := 118;
         h_name := 'Note/Minutes';
         
      
      WHEN PMO_CNST.SC_CRI_REQUIREMENT THEN
         h_type_id := 105;
         h_name := 'Requirement';
         
      
      WHEN PMO_CNST.SC_CRI_DEFECT THEN
         h_type_id := 115;
         h_name := 'Defects';
         
      
      WHEN PMO_CNST.SC_CRI_SERVICE_REQUEST THEN
         h_type_id := 116;
         h_name := 'Service Requests';
         
      
      WHEN PMO_CNST.SC_SCORECARD THEN
         h_type_id := 121;
         h_name := 'Scorecard';
         
      
      WHEN PMO_CNST.SC_CRI_ACTION_ITEM THEN
         h_type_id := 136;
         h_name := 'Actions';
         
      
      WHEN PMO_CNST.SC_ALERT_GROUP THEN
         h_type_id := PMO_CNST.SC_ALERT_GROUP;
         h_name := 'Alert';
         
      
      ELSE
         h_type_id := 0;
         h_name := '';
   END CASE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetDataFieldTypeID', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: GetDataFieldTypeID(117) : statenotifyconfig.sql(813) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetDataFieldTypeID', 120+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: GetDataFieldTypeID(121) : statenotifyconfig.sql(817) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION GetDataFieldTypeID;
ALTER FUNCTION GetDataFieldTypeID COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_NEXT_STATE_CNFG ==
CREATE OR REPLACE FUNCTION SP_U_NEXT_STATE_CNFG
(
     p_project_id VARCHAR2
   , p_current_state PLS_INTEGER
   , p_state_id PLS_INTEGER
   , p_positive_response PLS_INTEGER
   , p_negative_response PLS_INTEGER
   , p_priority PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_current_state PLS_INTEGER := 0;
   h_state_id PLS_INTEGER := 0;
   h_positive_response PLS_INTEGER := 0;
   h_negative_response PLS_INTEGER := 0;
   h_priority PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_NEXT_STATE_CNFG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_NEXT_STATE_CNFG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_NEXT_STATE_CNFG(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_current_state), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_state_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_positive_response), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_negative_response), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NEXT_STATE_CNFG', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_NEXT_STATE_CNFG(34) : statenotifyconfig.sql(861) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_state_id := p_state_id;
   h_current_state := p_current_state;
   h_positive_response := p_positive_response;
   h_negative_response := p_negative_response;
   h_priority := p_priority;
   h_rec_user := p_rec_user;
   
   If (h_project_id IS NULL) OR (h_state_id IS NULL) OR (h_current_state IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_NEXT_STATE_CNFG', 46+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_NEXT_STATE_CNFG(47) : statenotifyconfig.sql(874) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NEXT_STATE_CNFG', 49+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_NEXT_STATE_CNFG(50) : statenotifyconfig.sql(877) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   BEGIN
      UPDATE STATE_TASK_NEXT_STATE_CNFG
      SET POSITIVE_RESPONSE = h_positive_response,
      NEGATIVE_RESPONSE = h_negative_response,
      PRIORITY = h_priority,
      REC_USER = h_rec_user
      WHERE PROJECT_ID = h_project_id
      AND STAGE_ID = h_current_state
      AND NEXT_STAGE_ID = h_state_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NEXT_STATE_CNFG', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NEXT_STATE_CNFG(74) : statenotifyconfig.sql(901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_NEXT_STATE_CNFG', 80+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_NEXT_STATE_CNFG(81) : statenotifyconfig.sql(908) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_NEXT_STATE_CNFG', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_NEXT_STATE_CNFG(84) : statenotifyconfig.sql(911) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_NEXT_STATE_CNFG', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_NEXT_STATE_CNFG(90) : statenotifyconfig.sql(917) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NEXT_STATE_CNFG', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NEXT_STATE_CNFG(97) : statenotifyconfig.sql(924) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_NEXT_STATE_CNFG', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_NEXT_STATE_CNFG(109) : statenotifyconfig.sql(936) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_NEXT_STATE_CNFG;
ALTER FUNCTION SP_U_NEXT_STATE_CNFG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ASSIGNED_NEXT_STATE_CNFG ==
CREATE OR REPLACE FUNCTION SP_S_ASSIGNED_NEXT_STATE_CNFG
(
     p_project_id VARCHAR2
   , p_current_state PLS_INTEGER
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_current_state PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      state_cnfg PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ASSIGNED_NEXT_STATE_CNFG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ASSIGNED_NEXT_STATE_CNFG'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ASSIGNED_NEXT_STATE_CNFG(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_current_state), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSIGNED_NEXT_STATE_CNFG', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ASSIGNED_NEXT_STATE_CNFG(28) : statenotifyconfig.sql(980) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_current_state := p_current_state;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   If (h_project_id IS NULL) OR (h_current_state IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ASSIGNED_NEXT_STATE_CNFG', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ASSIGNED_NEXT_STATE_CNFG(38) : statenotifyconfig.sql(990) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSIGNED_NEXT_STATE_CNFG', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSIGNED_NEXT_STATE_CNFG(41) : statenotifyconfig.sql(993) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   OPEN state_cnfg FOR SELECT 0  AS LEVEL_ID, 0 AS TYPE_ID, '' AS RANK, '' AS PARENT_ID, S.NEXT_STAGE_ID AS ELEMENT_ID, TD.DESCRIPTION AS ELEMENT_NAME, 0 AS CHILD_COUNT,
   S.PROJECT_ID, S.STAGE_ID, S.POSITIVE_RESPONSE, S.NEGATIVE_RESPONSE, S.PRIORITY
   FROM STATE_TASK_NEXT_STATE_CNFG S, TMT_DATAFIELDS TD
   WHERE S.PROJECT_ID = h_project_id
   AND S.STAGE_ID = h_current_state
   AND TD.ELEMENT_ID = S.NEXT_STAGE_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ASSIGNED_NEXT_STATE_CNFG', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ASSIGNED_NEXT_STATE_CNFG(53) : statenotifyconfig.sql(1005) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN state_cnfg;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSIGNED_NEXT_STATE_CNFG', 60+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSIGNED_NEXT_STATE_CNFG(61) : statenotifyconfig.sql(1013) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ASSIGNED_NEXT_STATE_CNFG', 72+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ASSIGNED_NEXT_STATE_CNFG(73) : statenotifyconfig.sql(1025) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ASSIGNED_NEXT_STATE_CNFG;
ALTER FUNCTION SP_S_ASSIGNED_NEXT_STATE_CNFG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_NEXT_STATE_CNFG ==
CREATE OR REPLACE FUNCTION SP_D_NEXT_STATE_CNFG
(
     p_project_id VARCHAR2
   , p_current_state PLS_INTEGER
   , p_state_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_current_state PLS_INTEGER := 0;
   h_state_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_NEXT_STATE_CNFG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_NEXT_STATE_CNFG'), '-- ' || SYSTIMESTAMP, ':r := SP_D_NEXT_STATE_CNFG(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_current_state), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_state_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NEXT_STATE_CNFG', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_NEXT_STATE_CNFG(25) : statenotifyconfig.sql(1066) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_current_state := p_current_state;
   h_state_id := p_state_id;
   h_rec_user := p_rec_user;
   
   If (h_project_id IS NULL) OR (h_state_id IS NULL) OR (h_current_state IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_NEXT_STATE_CNFG', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_NEXT_STATE_CNFG(35) : statenotifyconfig.sql(1076) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NEXT_STATE_CNFG', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_NEXT_STATE_CNFG(38) : statenotifyconfig.sql(1079) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   BEGIN
      DELETE FROM STATE_TASK_NEXT_STATE_CNFG
      WHERE PROJECT_ID = h_project_id
      AND STAGE_ID = h_current_state
      AND NEXT_STAGE_ID = h_state_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NEXT_STATE_CNFG', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NEXT_STATE_CNFG(58) : statenotifyconfig.sql(1099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_NEXT_STATE_CNFG', 64+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_NEXT_STATE_CNFG(65) : statenotifyconfig.sql(1106) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_NEXT_STATE_CNFG', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_NEXT_STATE_CNFG(68) : statenotifyconfig.sql(1109) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_NEXT_STATE_CNFG', 73+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_NEXT_STATE_CNFG(74) : statenotifyconfig.sql(1115) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NEXT_STATE_CNFG', 80+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NEXT_STATE_CNFG(81) : statenotifyconfig.sql(1122) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_NEXT_STATE_CNFG', 92+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_NEXT_STATE_CNFG(93) : statenotifyconfig.sql(1134) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_NEXT_STATE_CNFG;
ALTER FUNCTION SP_D_NEXT_STATE_CNFG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_A_NEXT_STATE_CNFG ==
CREATE OR REPLACE FUNCTION SP_A_NEXT_STATE_CNFG
(
     p_project_id VARCHAR2
   , p_current_state PLS_INTEGER
   , p_new_state PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_current_state PLS_INTEGER := 0;
   h_new_state PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_exists PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_A_NEXT_STATE_CNFG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_A_NEXT_STATE_CNFG'), '-- ' || SYSTIMESTAMP, ':r := SP_A_NEXT_STATE_CNFG(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_current_state), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_new_state), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_NEXT_STATE_CNFG', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_A_NEXT_STATE_CNFG(26) : statenotifyconfig.sql(1176) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_current_state := p_current_state;
   h_new_state := p_new_state;
   h_rec_user := p_rec_user;
   
   If (h_project_id IS NULL) OR (h_new_state IS NULL) OR (h_current_state IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_NEXT_STATE_CNFG', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_NEXT_STATE_CNFG(36) : statenotifyconfig.sql(1186) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_NEXT_STATE_CNFG', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_NEXT_STATE_CNFG(39) : statenotifyconfig.sql(1189) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_exists := 0;
   BEGIN
      SELECT 1
      INTO h_exists
      FROM DUAL
      WHERE EXISTS(SELECT PROJECT_ID FROM STATE_TASK_NEXT_STATE_CNFG
      WHERE PROJECT_ID = h_project_id
      AND STAGE_ID = h_current_state
      AND NEXT_STAGE_ID = h_new_state);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_NEXT_STATE_CNFG', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_NEXT_STATE_CNFG(59) : statenotifyconfig.sql(1209) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(h_exists, 0) = 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_A_NEXT_STATE_CNFG', 65+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_A_NEXT_STATE_CNFG(66) : statenotifyconfig.sql(1216) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_A_NEXT_STATE_CNFG', 68+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_A_NEXT_STATE_CNFG(69) : statenotifyconfig.sql(1219) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, True);
   Else
      BEGIN
         INSERT INTO STATE_TASK_NEXT_STATE_CNFG(PROJECT_ID, STAGE_ID, NEXT_STAGE_ID, REC_USER)
         VALUES(h_project_id, h_current_state, h_new_state, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_NEXT_STATE_CNFG', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_NEXT_STATE_CNFG(86) : statenotifyconfig.sql(1236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_A_NEXT_STATE_CNFG', 92+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_A_NEXT_STATE_CNFG(93) : statenotifyconfig.sql(1243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_NEXT_STATE_CNFG', 99+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_NEXT_STATE_CNFG(100) : statenotifyconfig.sql(1250) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_A_NEXT_STATE_CNFG', 111+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_A_NEXT_STATE_CNFG(112) : statenotifyconfig.sql(1262) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_A_NEXT_STATE_CNFG;
ALTER FUNCTION SP_A_NEXT_STATE_CNFG COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_ELEMENT_NEXT_STATE ==
CREATE OR REPLACE FUNCTION SP_S_ELEMENT_NEXT_STATE
(
     p_project_id VARCHAR2
   , p_current_state PLS_INTEGER
   , p_element_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_type PLS_INTEGER := 0;
   h_current_state PLS_INTEGER := 0;
   h_datafield_type_id PLS_INTEGER := 0;
   h_name VARCHAR2(100);
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_state_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      next_state_set PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_ELEMENT_NEXT_STATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_ELEMENT_NEXT_STATE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_ELEMENT_NEXT_STATE(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_current_state), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_element_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ELEMENT_NEXT_STATE', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_ELEMENT_NEXT_STATE(32) : statenotifyconfig.sql(1310) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_type := p_element_type;
   h_current_state := p_current_state;
   h_rec_user := p_rec_user;
   
   If (h_project_id IS NULL) OR (h_element_type IS NULL) OR (h_current_state IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_ELEMENT_NEXT_STATE', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_ELEMENT_NEXT_STATE(42) : statenotifyconfig.sql(1320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ELEMENT_NEXT_STATE', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_ELEMENT_NEXT_STATE(45) : statenotifyconfig.sql(1323) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_datafield_type_id := 0;
   h_name := '';
   null_return := GetDataFieldTypeID(Coalesce(h_element_type, 0), h_datafield_type_id, h_name);
   
   OPEN next_state_set FOR SELECT 0 AS LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, DESCRIPTION AS ELEMENT_NAME, 0 AS CHILD_COUNT
   FROM TMT_DATAFIELDS DF
   WHERE DF.TYPE_ID = h_datafield_type_id
   AND DF.LEVEL_ID = 2
   AND ELEMENT_ID <> h_current_state
   AND ELEMENT_ID NOT IN (SELECT NEXT_STAGE_ID FROM STATE_TASK_NEXT_STATE_CNFG WHERE PROJECT_ID = h_project_id AND STAGE_ID = h_current_state)
   AND DESCRIPTION IS NOT Null
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_ELEMENT_NEXT_STATE', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_ELEMENT_NEXT_STATE(63) : statenotifyconfig.sql(1341) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN next_state_set;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ELEMENT_NEXT_STATE', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ELEMENT_NEXT_STATE(71) : statenotifyconfig.sql(1349) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_ELEMENT_NEXT_STATE', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_ELEMENT_NEXT_STATE(83) : statenotifyconfig.sql(1361) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_ELEMENT_NEXT_STATE;
ALTER FUNCTION SP_S_ELEMENT_NEXT_STATE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_STATE_TASK_WBS_PARENT ==
CREATE OR REPLACE FUNCTION SP_S_STATE_TASK_WBS_PARENT
(
     p_id VARCHAR2
   , p_element_name VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_del_count PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      wbs_parent_set PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_STATE_TASK_WBS_PARENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_STATE_TASK_WBS_PARENT'), '-- ' || SYSTIMESTAMP, ':r := SP_S_STATE_TASK_WBS_PARENT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_element_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_TASK_WBS_PARENT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_STATE_TASK_WBS_PARENT(29) : statenotifyconfig.sql(1406) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_element_name := p_element_name;
   h_bitflag := p_bitflag;
   h_rec_user := p_rec_user;
   
   If (h_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_STATE_TASK_WBS_PARENT', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_STATE_TASK_WBS_PARENT(39) : statenotifyconfig.sql(1416) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_TASK_WBS_PARENT', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_TASK_WBS_PARENT(42) : statenotifyconfig.sql(1419) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_del_count := 0;
   BEGIN
      SELECT 1
      INTO h_del_count
      FROM DUAL
      WHERE EXISTS (
      SELECT d.ELEMENT_ID
      FROM TMT_WBS d
      WHERE d.PROJECT_ID = h_id
      AND d.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_STATE_TASK_WBS_PARENT', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_STATE_TASK_WBS_PARENT(63) : statenotifyconfig.sql(1440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_del_count := 0;
   End If;
   
   OPEN wbs_parent_set FOR SELECT 0 AS LEVEL_ID, W.TYPE_ID, W.RANK, W.PARENT_ID, W.ELEMENT_ID, W.ELEMENT_NAME, h_del_count AS CHILD_COUNT
   FROM TMT_WBS W
   WHERE W.ELEMENT_ID = h_id
   
   UNION
   
   SELECT 1 AS LEVEL_ID, TYPE_ID, RANK, PROJECT_ID AS PARENT_ID, ELEMENT_ID,  ELEMENT_NAME, 0 AS CHILD_COUNT
   FROM TMT_WBS
   WHERE PROJECT_ID = h_id
   AND TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM)
   AND (h_bitflag=0 OR UPPER(ELEMENT_NAME) LIKE '%%' || UPPER(h_element_name) || '%%')
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_TASK_WBS_PARENT', 84+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_TASK_WBS_PARENT(85) : statenotifyconfig.sql(1462) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN wbs_parent_set;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_STATE_TASK_WBS_PARENT', 92+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_STATE_TASK_WBS_PARENT(93) : statenotifyconfig.sql(1470) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_STATE_TASK_WBS_PARENT', 104+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_STATE_TASK_WBS_PARENT(105) : statenotifyconfig.sql(1482) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_STATE_TASK_WBS_PARENT;
ALTER FUNCTION SP_S_STATE_TASK_WBS_PARENT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_D_STATE_TASK ==
CREATE OR REPLACE FUNCTION SP_D_STATE_TASK
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(64);
   h_del_flag VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_state_id_str VARCHAR2(32);
   h_state_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_STATE_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_STATE_TASK'), '-- ' || SYSTIMESTAMP, ':r := SP_D_STATE_TASK(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_STATE_TASK', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_STATE_TASK(28) : statenotifyconfig.sql(1526) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_parent_id := p_parent_id;
   h_del_flag := p_del_flag;
   h_rec_user := p_rec_user;
   
   If Coalesce(Length(h_parent_id), 0) > 32 Then
      h_project_id := SubStr(h_project_id || SubStr(h_parent_id, 1, 32), 1, 32);
      h_project_id := h_project_id;
      
      -- Vladimir Schneider, vladimir@winpte.com
      -- September 30, 2004
      -- TOTEST: changed to make it work same way as in oracle but not sure about the strlen(h_parent_id) - SC_H_ID
      --strnpcat(h_state_id_str, sizeof(h_state_id_str), strstr(h_parent_id, ".") + 1, strlen(h_parent_id) - SC_H_ID);
      h_state_id_str := PMO_STPU.strnpcat(h_state_id_str, 32, -1, InStr(h_parent_id, '.')+1, h_parent_id);
      h_state_id_str := h_state_id_str;
      
      h_state_id := TO_NUMBER(h_state_id_str);
      h_state_id := Coalesce(h_state_id, 0);
      
      BEGIN
         SELECT ELEMENT_ID
         INTO h_parent_id
         FROM PROJECT_STATE_DEF
         WHERE PROJECT_ID = h_project_id AND
         STAGE_ID = h_state_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_STATE_TASK', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_STATE_TASK(62) : statenotifyconfig.sql(1560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PROJECT_STATE_DEF
      WHERE ELEMENT_ID = h_id
      AND PARENT_ID = h_parent_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_STATE_TASK', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_STATE_TASK(82) : statenotifyconfig.sql(1580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_STATE_TASK', 88+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_STATE_TASK(89) : statenotifyconfig.sql(1587) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_STATE_TASK', 91+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_STATE_TASK(92) : statenotifyconfig.sql(1590) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE PROJECT_STATE_DEF
         SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE element_id = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_STATE_TASK', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_STATE_TASK(112) : statenotifyconfig.sql(1610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --***********************************CLEAN NEXT STATE TABLE
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_STATE_TASK', 120+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_STATE_TASK(121) : statenotifyconfig.sql(1619) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_STATE_TASK', 127+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_STATE_TASK(128) : statenotifyconfig.sql(1626) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_STATE_TASK', 139+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_STATE_TASK(140) : statenotifyconfig.sql(1638) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_STATE_TASK;
ALTER FUNCTION SP_D_STATE_TASK COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_GET_TYPE_ID_FROM_STAGE_ID ==
CREATE OR REPLACE FUNCTION FC_GET_TYPE_ID_FROM_STAGE_ID
(
     sh_h_state_id PLS_INTEGER
   , h_parent_type_id IN OUT NOCOPY PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_state_id PLS_INTEGER := sh_h_state_id;
   h_data_field_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_TYPE_ID_FROM_STAGE_ID') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_TYPE_ID_FROM_STAGE_ID'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_TYPE_ID_FROM_STAGE_ID(' || 
       COALESCE(TO_CHAR(sh_h_state_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_parent_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_TYPE_ID_FROM_STAGE_ID', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_TYPE_ID_FROM_STAGE_ID(17) : statenotifyconfig.sql(1671) : ' || SYSTIMESTAMP);
   END IF; 

   h_data_field_type_id := 0;
   h_parent_type_id := 0;
   
   BEGIN
      SELECT TYPE_ID
      INTO h_data_field_type_id
      FROM TMT_DATAFIELDS
      WHERE ELEMENT_ID = h_state_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_TYPE_ID_FROM_STAGE_ID', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_TYPE_ID_FROM_STAGE_ID(34) : statenotifyconfig.sql(1688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_PROJECT_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_PROJECT;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_CHANGE_REQUEST_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_CHANGE_REQUEST;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_RISK_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_RISK;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_REQUIREMENT_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_REQUIREMENT;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_DOCUMENT_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_DOCUMENT;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_DEFECT_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_DEFECT;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_ISSUE_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_ISSUE;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_SERVICE_REQUEST_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_SERVICE_REQUEST;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_NOTE_MINUTES_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_NOTE_MINUTES;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_DELIVERABLE_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_DELIVERABLE;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_TASK_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_TASK;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_SCORECARD_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_SCORECARD;
   ElsIf Coalesce(h_data_field_type_id, 0) = PMO_CNST.SC_ACTION_STATE_TYPE Then
      h_parent_type_id := PMO_CNST.SC_CRI_ACTION_ITEM;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_TYPE_ID_FROM_STAGE_ID', 67+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_TYPE_ID_FROM_STAGE_ID(68) : statenotifyconfig.sql(1722) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_TYPE_ID_FROM_STAGE_ID;
ALTER FUNCTION FC_GET_TYPE_ID_FROM_STAGE_ID COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_STATE_TASK ==
CREATE OR REPLACE FUNCTION SP_I_STATE_TASK
(
     p_element_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_name VARCHAR2(255);
   h_parent_id VARCHAR2(64);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_unique_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_state_element_id VARCHAR2(32);
   h_state_id_str VARCHAR2(32);
   h_state_id PLS_INTEGER := 0;
   h_parent_type_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_STATE_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_STATE_TASK'), '-- ' || SYSTIMESTAMP, ':r := SP_I_STATE_TASK(' || 
       '''' || p_element_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_STATE_TASK', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_STATE_TASK(32) : statenotifyconfig.sql(1764) : ' || SYSTIMESTAMP);
   END IF; 

   -- for state tasks the element_name stores in subject field
   -- it is a combination of project_id and stage_id
   
   h_element_name := p_element_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   
   If Coalesce(Length(h_parent_id), 0) > 32 Then
      h_project_id := SubStr(h_project_id || SubStr(h_parent_id, 1, 32), 1, 32);
      h_project_id := h_project_id;
      
      -- Vladimir Schneider, vladimir@winpte.com
      -- September 30, 2004
      -- TOTEST: changed to make it work same way as in oracle but not sure about the strlen(h_parent_id) - SC_H_ID
      --strnpcat(h_state_id_str, sizeof(h_state_id_str), strstr(h_parent_id, ".") + 1, strlen(h_parent_id) - SC_H_ID);
      h_state_id_str := PMO_STPU.strnpcat(h_state_id_str, 32, -1, InStr(h_parent_id, '.')+1, h_parent_id);
      h_state_id_str := h_state_id_str;
      
      h_state_id := TO_NUMBER(h_state_id_str);
      h_state_id := Coalesce(h_state_id, 0);
      
      null_return := FC_GET_TYPE_ID_FROM_STAGE_ID(h_state_id, h_parent_type_id);
   Else
      BEGIN
         SELECT PROJECT_ID, STAGE_ID, ELEMENT_TYPE
         INTO h_project_id, h_state_id, h_parent_type_id
         FROM PROJECT_STATE_DEF
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(70) : statenotifyconfig.sql(1802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- check the existence of the record
   BEGIN
      SELECT ELEMENT_ID
      INTO h_state_element_id
      FROM PROJECT_STATE_DEF
      WHERE PROJECT_ID = h_project_id AND
      STAGE_ID = h_state_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 88+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(89) : statenotifyconfig.sql(1821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      -- first insert parent record
      h_unique_id := SYS_GUID();
      
      BEGIN
         INSERT INTO PROJECT_STATE_DEF (ELEMENT_ID, PROJECT_ID, ELEMENT_TYPE, STAGE_ID)
         VALUES(h_unique_id, h_project_id, h_parent_type_id, h_state_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(111) : statenotifyconfig.sql(1843) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_parent_id := h_unique_id;
      
      h_unique_id := SYS_GUID();
      BEGIN
         INSERT INTO PROJECT_STATE_DEF (ELEMENT_ID, PROJECT_ID, PARENT_ID, ELEMENT_TYPE, STAGE_ID, SUBJECT)
         VALUES(h_unique_id, h_project_id, h_parent_id, PMO_CNST.SC_STATE_NOTIFICATION_TASK, PMO_CNST.SC_STATE_NOTIFICATION_TASK_STA, h_element_name);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(132) : statenotifyconfig.sql(1864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      h_unique_id := SYS_GUID();
      
      BEGIN
         INSERT INTO PROJECT_STATE_DEF
         (ELEMENT_ID, PROJECT_ID, PARENT_ID, ELEMENT_TYPE, STAGE_ID,
         ASSIGN_FLAG, GROUP_IDS, PARTICIPANT_IDS, SECURITY_IDS,
         SUBJECT, MESSAGE, GROUP_NAMES, PARTICIPANT_NAMES,
         SECURITY_NAMES, VARIANCE, EXPIRE_DAYS)
         SELECT  h_unique_id, PROJECT_ID, h_state_element_id, PMO_CNST.SC_STATE_NOTIFICATION_TASK, PMO_CNST.SC_STATE_NOTIFICATION_TASK_STA,
         ASSIGN_FLAG, GROUP_IDS, PARTICIPANT_IDS, SECURITY_IDS,
         h_element_name, MESSAGE, GROUP_NAMES, PARTICIPANT_NAMES,
         SECURITY_NAMES, VARIANCE, EXPIRE_DAYS
         FROM PROJECT_STATE_DEF
         WHERE ELEMENT_ID = h_state_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(161) : statenotifyconfig.sql(1893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n step04 \n");
      
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         UPDATE PROJECT_STATE_DEF
         SET CHILD_COUNT = CHILD_COUNT + 1
         WHERE PROJECT_ID = h_project_id
         AND STAGE_ID = h_state_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 185+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(186) : statenotifyconfig.sql(1918) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_STATE_TASK', 192+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_STATE_TASK(193) : statenotifyconfig.sql(1925) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_unique_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_unique_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 199+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(200) : statenotifyconfig.sql(1932) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_STATE_TASK', 211+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_STATE_TASK(212) : statenotifyconfig.sql(1944) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_STATE_TASK;
ALTER FUNCTION SP_I_STATE_TASK COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_STATE_DEF ==
CREATE OR REPLACE FUNCTION SP_S_STATE_DEF
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_child_type PLS_INTEGER := 0;
   h_name VARCHAR2(100);
   h_bitflag PLS_INTEGER := 0;
   h_state_name VARCHAR2(255);
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CSDEF0 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      state_ref_set PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      state_task_set PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CSDEF2 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CSDEF1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_STATE_DEF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_STATE_DEF'), '-- ' || SYSTIMESTAMP, ':r := SP_S_STATE_DEF(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_DEF', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_STATE_DEF(40) : statenotifyconfig.sql(2000) : ' || SYSTIMESTAMP);
   END IF; 

   h_bitflag := p_bitflag;
   h_id := p_id;
   
   h_parent_id := TO_CHAR(Coalesce(h_bitflag, 0));
   
   h_child_type := 243;
   
   null_return := GetDataFieldTypeID(Coalesce(h_bitflag, 0), h_type_id, h_name);
   
   If Coalesce(h_bitflag, 0) = 0 Then
      -- First Level of Project State Notification Configuration View
      
      OPEN CSDEF0 FOR SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, TO_CHAR(TYPE_ID) AS ELEMENT_ID, ELEMENT_NAME, 1 AS CHILD_COUNT, 0 AS POSITION, 0 AS STAGE_ID, h_id AS PROJECT_ID,
      '0' AS ASSIGN_FLAG, '' AS GROUP_IDS, '' AS GROUP_NAMES, '' AS PARTICIPANT_IDS, '' AS PARTICIPANT_NAMES, '' AS SECURITY_IDS, '' AS SECURITY_NAMES, '' AS SUBJECT, '' AS MESSAGE, '0' AS FLAG, 0 AS VARIANCE,
      0 AS EXPIRE_DAYS, '' AS WBS_PARENT_ID, '' AS WBS_PARENT_NAME
      FROM TMT_WORKFLOW_CYCLES
      WHERE LEVEL_ID = 0
      AND REC_STATUS<>'D'
      AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_DELIVERABLE, PMO_CNST.SC_TASK, PMO_CNST.SC_CHANGE_REQUEST, PMO_CNST.SC_RISK, PMO_CNST.SC_ISSUE, PMO_CNST.SC_DOCUMENT, PMO_CNST.SC_NOTE_MINUTES, PMO_CNST.SC_REQUIREMENT, PMO_CNST.SC_SERVICE_REQUEST, PMO_CNST.SC_DEFECT, PMO_CNST.SC_SCORECARD, PMO_CNST.SC_CRI_ACTION_ITEM, PMO_CNST.SC_ALERT_GROUP)
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_DEF', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_DEF(64) : statenotifyconfig.sql(2024) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CSDEF0;
   ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_STAGE_TASK_REFRESH Then
      OPEN state_ref_set FOR SELECT 3 LEVEL_ID,
      PMO_CNST.SC_STATE_NOTIFICATION_TASK AS TYPE_ID,
      SD.PROJECT_ID || SD.ELEMENT_ID AS RANK,
      SD.PARENT_ID AS PARENT_ID,
      SD.ELEMENT_ID AS ELEMENT_ID,
      SD.SUBJECT AS ELEMENT_NAME,
      0 AS CHILD_COUNT,
      0 AS POSITION,
      SD.STAGE_ID AS STAGE_ID,
      SD.PROJECT_ID AS PROJECT_ID,
      COALESCE(SD.ASSIGN_FLAG,'0') AS ASSIGN_FLAG,
      SD.GROUP_IDS,
      SD.GROUP_NAMES,
      SD.PARTICIPANT_IDS,
      SD.PARTICIPANT_NAMES,
      SD.SECURITY_IDS,
      SD.SECURITY_NAMES,
      '' AS SUBJECT,
      '' AS MESSAGE,
      CASE WHEN SD.STAGE_ID IS NuLL THEN '0' ELSE '1' END AS FLAG,
      SD.VARIANCE,
      SD.EXPIRE_DAYS AS EXPIRE_DAYS,
      SD.WBS_PARENT_ID, (SELECT W.ELEMENT_NAME FROM TMT_WBS W WHERE W.ELEMENT_ID = SD.WBS_PARENT_ID) AS WBS_PARENT_NAME
      FROM PROJECT_STATE_DEF SD
      WHERE ELEMENT_ID = h_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_DEF', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_DEF(94) : statenotifyconfig.sql(2054) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN state_ref_set;
   ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_STATE_NOTIFICATION_TASK Then
      BEGIN
         SELECT DESCRIPTION
         INTO h_state_name
         FROM TMT_DATAFIELDS DF, PROJECT_STATE_DEF SD
         WHERE SD.ELEMENT_ID = h_id
         AND DF.ELEMENT_ID = SD.STAGE_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_STATE_DEF', 109+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_STATE_DEF(110) : statenotifyconfig.sql(2070) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN state_task_set FOR SELECT case when SD.ELEMENT_ID =  h_id THEN 2 else 3 END As LEVEL_ID,
      PMO_CNST.SC_STATE_NOTIFICATION_TASK AS TYPE_ID,
      case when SD.ELEMENT_ID =  h_id THEN SD.PROJECT_ID else SD.PROJECT_ID || SD.ELEMENT_ID END AS RANK,
      case when SD.ELEMENT_ID =  h_id THEN TO_CHAR(SD.ELEMENT_TYPE) else SD.PARENT_ID end AS PARENT_ID,
      SD.ELEMENT_ID AS ELEMENT_ID,
      case when SD.ELEMENT_ID =  h_id then
      h_state_name else SD.SUBJECT end AS ELEMENT_NAME,
      SD.CHILD_COUNT AS CHILD_COUNT,
      0 AS POSITION,
      SD.STAGE_ID AS STAGE_ID,
      SD.PROJECT_ID AS PROJECT_ID,
      COALESCE(SD.ASSIGN_FLAG,'0') AS ASSIGN_FLAG,
      SD.GROUP_IDS,
      SD.GROUP_NAMES,
      SD.PARTICIPANT_IDS,
      SD.PARTICIPANT_NAMES,
      SD.SECURITY_IDS,
      SD.SECURITY_NAMES,
      case when SD.ELEMENT_ID =  h_id THEN SD.SUBJECT else '' end AS SUBJECT,
      case when SD.ELEMENT_ID =  h_id THEN RTRIM(SD.MESSAGE) else '' end AS MESSAGE,
      CASE WHEN SD.STAGE_ID IS NuLL THEN '0' ELSE '1' END AS FLAG,
      SD.VARIANCE,
      SD.EXPIRE_DAYS AS EXPIRE_DAYS,
      SD.WBS_PARENT_ID, W.ELEMENT_NAME AS WBS_PARENT_NAME
      FROM PROJECT_STATE_DEF SD
      LEFT JOIN TMT_WBS W ON W.ELEMENT_ID = SD.WBS_PARENT_ID
      WHERE SD.ELEMENT_ID = h_id OR SD.PARENT_ID = h_id
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_DEF', 143+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_DEF(144) : statenotifyconfig.sql(2104) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN state_task_set;
   Else
      If Coalesce(h_bitflag, 0) = PMO_CNST.SC_ALERT_GROUP Then
         --  for alert messages we use alert type_id as stage_id
         
         OPEN CSDEF2 FOR SELECT DISTINCT 2 AS LEVEL_ID, h_child_type AS TYPE_ID, '0000' || TO_CHAR(msg.TYPE_ID) AS RANK,
         h_parent_id AS PARENT_ID, h_parent_id || '.' || TO_CHAR(msg.TYPE_ID) AS ELEMENT_ID,
         msg.ALERT_NAME AS ELEMENT_NAME,
         case when SD.ELEMENT_ID IS Null then 0 else SD.CHILD_COUNT end AS CHILD_COUNT, 0 AS POSITION, msg.TYPE_ID AS STAGE_ID, h_id AS PROJECT_ID,
         COALESCE(ASSIGN_FLAG,'0') AS ASSIGN_FLAG, GROUP_IDS, GROUP_NAMES, PARTICIPANT_IDS, PARTICIPANT_NAMES,
         SD.SECURITY_IDS, SD.SECURITY_NAMES, SUBJECT, RTRIM(MESSAGE) AS MESSAGE,
         CASE WHEN SD.STAGE_ID IS NuLL THEN '0' ELSE '1' END AS FLAG, SD.VARIANCE,
         0 AS EXPIRE_DAYS, SD.WBS_PARENT_ID, '' AS WBS_PARENT_NAME
         FROM ALERT_MESSAGES msg
         LEFT JOIN PROJECT_STATE_DEF SD
         ON SD.PROJECT_ID = h_id
         AND SD.STAGE_ID = msg.TYPE_ID
         WHERE msg.ALERT_TYPE = 1
         AND msg.ALERT_BIT = 1
         UNION ALL
         SELECT 1 AS LEVEL_ID, h_type_id AS TYPE_ID, '0000' AS RANK, '' AS PARENT_ID,
         h_parent_id AS ELEMENT_ID, h_name AS ELEMENT_NAME, 1 AS CHILD_COUNT, 0 AS POSITION, 0 AS STAGE_ID,
         h_id AS PROJECT_ID, '0' AS ASSIGN_FLAG, '' AS GROUP_IDS, '' AS GROUP_NAMES, '' AS PARTICIPANT_IDS,
         '' AS PARTICIPANT_NAMES, '' AS SECURITY_IDS, '' AS SECURITY_NAMES, '' AS SUBJECT, '' AS MESSAGE, '0' AS FLAG, 0 AS VARIANCE,
         0 AS EXPIRE_DAYS, '' AS WBS_PARENT_ID, '' AS WBS_PARENT_NAME
         FROM TMT_WORKFLOW_CYCLES
         WHERE TYPE_ID = h_type_id
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_DEF', 174+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_DEF(175) : statenotifyconfig.sql(2135) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CSDEF2;
      Else
         OPEN CSDEF1 FOR SELECT DF.LEVEL_ID, h_child_type AS TYPE_ID, DF.RANK, h_parent_id AS PARENT_ID,
         case when SD.ELEMENT_ID is Null then  h_id || '.' || TO_CHAR(DF.ELEMENT_ID)
         else SD.ELEMENT_ID end AS ELEMENT_ID,
         DF.DESCRIPTION AS ELEMENT_NAME,
         case when SD.ELEMENT_ID IS Null then 0 else SD.CHILD_COUNT end AS CHILD_COUNT, DF.POSITION, DF.ELEMENT_ID AS STAGE_ID, h_id AS PROJECT_ID,
         COALESCE(ASSIGN_FLAG,'0') AS ASSIGN_FLAG, GROUP_IDS, GROUP_NAMES, PARTICIPANT_IDS, PARTICIPANT_NAMES, SD.SECURITY_IDS, SD.SECURITY_NAMES, SUBJECT, RTRIM(MESSAGE) AS MESSAGE,
         CASE WHEN SD.STAGE_ID IS NuLL THEN '0' ELSE '1' END AS FLAG, SD.VARIANCE,
         SD.EXPIRE_DAYS AS EXPIRE_DAYS, SD.WBS_PARENT_ID, '' AS WBS_PARENT_NAME
         FROM TMT_DATAFIELDS DF
         LEFT JOIN PROJECT_STATE_DEF SD ON SD.STAGE_ID = DF.ELEMENT_ID
         AND SD.PROJECT_ID = h_id
         WHERE DF.TYPE_ID = h_type_id
         AND DF.LEVEL_ID = 2
         UNION ALL
         SELECT DF.LEVEL_ID, h_bitflag AS TYPE_ID, DF.RANK, '' AS PARENT_ID,
         h_parent_id AS ELEMENT_ID, h_name AS ELEMENT_NAME, DF.CHILD_COUNT, DF.POSITION, DF.ELEMENT_ID AS STAGE_ID, h_id AS PROJECT_ID,
         '0' AS ASSIGN_FLAG, '' AS GROUP_IDS, '' AS GROUP_NAMES, '' AS PARTICIPANT_IDS, '' AS PARTICIPANT_NAMES, '' AS SECURITY_IDS, '' AS SECURITY_NAMES, '' AS SUBJECT, '' AS MESSAGE, '0' AS FLAG, 0 AS VARIANCE,
         0 AS EXPIRE_DAYS, '' AS WBS_PARENT_ID, '' AS WBS_PARENT_NAME
         FROM TMT_DATAFIELDS DF
         WHERE DF.TYPE_ID = h_type_id
         AND DF.LEVEL_ID = 1
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_STATE_DEF', 201+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_STATE_DEF(202) : statenotifyconfig.sql(2162) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CSDEF1;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_STATE_DEF', 211+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_STATE_DEF(212) : statenotifyconfig.sql(2172) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_STATE_DEF', 223+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_STATE_DEF(224) : statenotifyconfig.sql(2184) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_STATE_DEF;
ALTER FUNCTION SP_S_STATE_DEF COMPILE DEBUG;

/*********************************************************************/

Prompt == FUNCTION SP_U_STATE_DEF ==
CREATE OR REPLACE FUNCTION SP_U_STATE_DEF
(
     p_element_id VARCHAR2
   , p_project_id VARCHAR2
   , p_element_type VARCHAR2
   , p_stage_id PLS_INTEGER
   , p_assign_flag VARCHAR2
   , p_group_ids VARCHAR2
   , p_participant_ids VARCHAR2
   , p_security_ids VARCHAR2
   , p_subject VARCHAR2
   , p_message VARCHAR2
   , p_group_names VARCHAR2
   , p_participant_names VARCHAR2
   , p_security_names VARCHAR2
   , p_variance PLS_INTEGER
   , p_expire_days PLS_INTEGER
   , p_wbs_parent_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(64);
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_element_type PLS_INTEGER := 0;
   h_state_id PLS_INTEGER := 0;
   h_assign_flag VARCHAR2(1);
   h_group_ids VARCHAR2(4000);
   h_participant_ids VARCHAR2(4000);
   h_security_ids VARCHAR2(2048);
   h_subject VARCHAR2(255);
   h_message VARCHAR2(2048);
   h_participant_names VARCHAR2(4000);
   h_group_names VARCHAR2(2048);
   h_security_names VARCHAR2(4000);
   h_variance PLS_INTEGER := 0;
   h_temp_project_id VARCHAR2(32);
   h_expire_days PLS_INTEGER := 0;
   h_unique_id VARCHAR2(32);
   h_wbs_parent_id VARCHAR2(32);
   h_state_id_str VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_STATE_DEF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_STATE_DEF'), '-- ' || SYSTIMESTAMP, ':r := SP_U_STATE_DEF(' || 
       '''' || p_element_id || ''''
          || ', ' || '''' || p_project_id || ''''
          || ', ' || '''' || p_element_type || ''''
          || ', ' || COALESCE(TO_CHAR(p_stage_id), 'NULL')
          || ', ' || '''' || p_assign_flag || ''''
          || ', ' || '''' || p_group_ids || ''''
          || ', ' || '''' || p_participant_ids || ''''
          || ', ' || '''' || p_security_ids || ''''
          || ', ' || '''' || p_subject || ''''
          || ', ' || '''' || p_message || ''''
          || ', ' || '''' || p_group_names || ''''
          || ', ' || '''' || p_participant_names || ''''
          || ', ' || '''' || p_security_names || ''''
          || ', ' || COALESCE(TO_CHAR(p_variance), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_expire_days), 'NULL')
          || ', ' || '''' || p_wbs_parent_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_STATE_DEF', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_STATE_DEF(65) : statenotifyconfig.sql(2265) : ' || SYSTIMESTAMP);
   END IF; 

   -- this element_id may be more than 32 character, it is a combination of project_id and stage_id that are unique in project_state_def table
   
   h_element_id := p_element_id;
   h_project_id := p_project_id;
   h_id := p_element_type;
   h_state_id := p_stage_id;
   h_assign_flag := p_assign_flag;
   h_group_ids := p_group_ids;
   h_participant_ids := p_participant_ids;
   h_security_ids := p_security_ids;
   h_subject := p_subject;
   h_message := p_message;
   h_group_names := p_group_names;
   h_participant_names := p_participant_names;
   h_security_names := p_security_names;
   h_variance := p_variance;
   h_expire_days := p_expire_days;
   h_wbs_parent_id := p_wbs_parent_id;
   
   h_element_type := TO_NUMBER(h_id);
   -- element type is integer
   h_element_type := Coalesce(h_element_type, 0);
   
   -- ALGORITHM:
   -- 1- check the existence of a record in the PROJECT_STATE_DEF with using (ELEMENT_ID) key
   -- 2- if the record not found then insert a new record
   -- 3- if the record found update the row with new data
   
   If Coalesce(h_element_type, 0) = PMO_CNST.SC_ALERT_GROUP Then
      -- check the existence of the record
      BEGIN
         SELECT PROJECT_ID
         INTO h_temp_project_id
         FROM PROJECT_STATE_DEF
         WHERE PROJECT_ID = h_project_id AND
         ELEMENT_TYPE = h_element_type AND
         STAGE_ID = h_state_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(111) : statenotifyconfig.sql(2311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         -- insert a new record into the PROJECT_STATE_DEF table
         h_unique_id := SYS_GUID();
         
         BEGIN
            INSERT INTO PROJECT_STATE_DEF (ELEMENT_ID, PROJECT_ID, ELEMENT_TYPE, STAGE_ID, ASSIGN_FLAG, GROUP_IDS, PARTICIPANT_IDS, SECURITY_IDS,
            SUBJECT, MESSAGE, GROUP_NAMES, PARTICIPANT_NAMES, SECURITY_NAMES, VARIANCE, EXPIRE_DAYS)
            VALUES(h_unique_id, h_project_id, h_element_type, h_state_id, h_assign_flag, h_group_ids, h_participant_ids, h_security_ids,
            h_subject, h_message, h_group_names, h_participant_names, h_security_names, h_variance, h_expire_days);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(135) : statenotifyconfig.sql(2335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_element_id := h_unique_id;
      Else
         -- update the existence record with using new data
         BEGIN
            UPDATE PROJECT_STATE_DEF
            SET ASSIGN_FLAG = h_assign_flag,
            GROUP_IDS = h_group_ids,
            PARTICIPANT_IDS = h_participant_ids,
            SECURITY_IDS = h_security_ids,
            SUBJECT = h_subject,
            MESSAGE = h_message,
            GROUP_NAMES = h_group_names,
            PARTICIPANT_NAMES = h_participant_names,
            SECURITY_NAMES = h_security_names,
            VARIANCE = h_variance
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_TYPE = h_element_type
            AND STAGE_ID = h_state_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(168) : statenotifyconfig.sql(2368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If Coalesce(Length(h_element_id), 0) > 32 Then
         -- inactive state is updating
         h_project_id := SubStr(h_project_id || SubStr(h_element_id, 1, 32), 1, 32);
         h_project_id := h_project_id;
         
         -- Vladimir Schneider, vladimir@winpte.com
         -- September 30, 2004
         -- TOTEST: changed to make it work same way as in oracle but not sure about the strlen(h_parent_id) - SC_H_ID
         --strnpcat(h_state_id_str, sizeof(h_state_id_str), strstr(h_element_id, ".") + 1, strlen(h_element_id) - SC_H_ID);
         h_state_id_str := PMO_STPU.strnpcat(h_state_id_str, 32, -1, InStr(h_element_id, '.')+1, 
                                                                  h_element_id);
         h_state_id_str := h_state_id_str;
         
         h_state_id := TO_NUMBER(h_state_id_str);
         h_state_id := Coalesce(h_state_id, 0);
         
         BEGIN
            SELECT ELEMENT_ID, ELEMENT_TYPE
            INTO h_element_id, h_element_type
            FROM PROJECT_STATE_DEF
            WHERE PROJECT_ID = h_project_id
            AND STAGE_ID = h_state_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 201+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(202) : statenotifyconfig.sql(2402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               UPDATE PROJECT_STATE_DEF
               SET ASSIGN_FLAG = case when h_assign_flag is Null then  ASSIGN_FLAG else h_assign_flag end,
               GROUP_IDS = h_group_ids,
               PARTICIPANT_IDS = h_participant_ids,
               SECURITY_IDS = h_security_ids,
               SUBJECT = h_subject,
               MESSAGE = h_message,
               GROUP_NAMES = h_group_names,
               PARTICIPANT_NAMES = h_participant_names,
               SECURITY_NAMES = h_security_names,
               VARIANCE = h_variance,
               EXPIRE_DAYS = h_expire_days
               WHERE PROJECT_ID = h_project_id
               AND STAGE_ID = h_state_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 232+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(233) : statenotifyconfig.sql(2433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            -- insert a new record into the PROJECT_STATE_DEF table
            
            -- ***** the element_type can be one of the following:
            -- SC_PROJECT              --> used as a group type for : SC_PROJECT, SC_PROPOSAL
            -- SC_DELIVERABLE          --> used as a group type for : SC_DELIVREABLE, SC_WORK_PRODUCT, SC_SUMMARY_TASK, SC_WBS_CHANGE_REQUEST, SC_WBS_ACTION_ITEM, SC_WBS_RISK, SC_WBS_ISSUE, SC_WBS_REQUIREMENT, SC_WBS_DEFECT, SC_WBS_SERVICE_REQUEST
            -- SC_TASK                 --> used as a group type for : SC_TASK, SC_MILESTONE, SC_WBS_CHANGE_REQUEST_TASK, SC_WBS_ACTION_ITEM_TASK, SC_WBS_RISK_TASK, SC_WBS_ISSUE_TASK, SC_WBS_REQUIREMENT_TASK, SC_WBS_DEFECT_TASK, SC_WBS_SERVICE_REQUEST_TASK
            -- SC_CRI_CHANGE_REQUEST   --> used as a group type for : SC_CRI_CHANGE_REQUEST, SC_CRI_CHANGE_REQUEST_TASK
            -- SC_CRI_ACTION_ITEM      --> used as a group type for : SC_CRI_ACTION_ITEM, SC_CRI_ACTION_ITEM_TASK
            -- SC_CRI_RISK             --> used as a group type for : SC_CRI_RISK, SC_CRI_RISK_TASK
            -- SC_CRI_ISSUE            --> used as a group type for : SC_CRI_ISSUE, SC_CRI_ISSUE_TASK
            -- SC_CRI_REQUIREMENT      --> used as a group type for : SC_CRI_REQUIREMENT, SC_CRI_REQUIREMENT_TASK
            -- SC_CRI_DEFECT           --> used as a group type for : SC_CRI_DEFECT, SC_CRI_DEFECT_TASK
            -- SC_CRI_SERVICE_REQUEST  --> used as a group type for : SC_CRI_SERVICE_REQUEST_TASK
            -- SC_DOCUMENT             --> used as a group type for : SC_WORK_INPUT, SC_WP_LINK, SC_SOFTWARE, SC_LINK
            -- SC_NOTE_MINUTES         --> used as a group type for : SC_NOTE_MINUTES
            -- SC_SCORECARD            --> used as a group type for : SC_SCORECARD
            
            -- for each group we will have the same SUBJECT and MESSAGE data, for this reason for each group
            -- insert one record in PROJECT_STATE_DEF
            h_unique_id := SYS_GUID();
            
            BEGIN
               INSERT INTO PROJECT_STATE_DEF (ELEMENT_ID, PROJECT_ID, ELEMENT_TYPE, STAGE_ID, ASSIGN_FLAG, GROUP_IDS, PARTICIPANT_IDS, SECURITY_IDS,
               SUBJECT, MESSAGE, GROUP_NAMES, PARTICIPANT_NAMES, SECURITY_NAMES, VARIANCE, EXPIRE_DAYS)
               VALUES(h_unique_id, h_project_id, h_element_type, h_state_id, h_assign_flag, h_group_ids, h_participant_ids, h_security_ids,
               h_subject, h_message, h_group_names, h_participant_names, h_security_names, h_variance, h_expire_days);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 273+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(274) : statenotifyconfig.sql(2474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_element_id := h_unique_id;
         End If;
      Else
         BEGIN
            SELECT PROJECT_ID, STAGE_ID, ELEMENT_TYPE
            INTO h_project_id, h_state_id, h_element_type
            FROM PROJECT_STATE_DEF
            WHERE ELEMENT_ID = h_element_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 292+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(293) : statenotifyconfig.sql(2493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            If (Coalesce(h_element_type, 0) = PMO_CNST.SC_STATE_NOTIFICATION_TASK) AND (Coalesce(
                  h_state_id, 0) = PMO_CNST.SC_STATE_NOTIFICATION_TASK_STA) Then
               BEGIN
                  UPDATE PROJECT_STATE_DEF
                  SET ASSIGN_FLAG = case when h_assign_flag is Null then  ASSIGN_FLAG else h_assign_flag end,
                  GROUP_IDS = h_group_ids,
                  PARTICIPANT_IDS = h_participant_ids,
                  SECURITY_IDS = h_security_ids,
                  GROUP_NAMES = h_group_names,
                  PARTICIPANT_NAMES = h_participant_names,
                  SECURITY_NAMES = h_security_names,
                  WBS_PARENT_ID = h_wbs_parent_id,
                  SUBJECT = case when h_subject is Null then SUBJECT else h_subject end
                  WHERE ELEMENT_ID = h_element_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 322+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(323) : statenotifyconfig.sql(2523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PROJECT_STATE_DEF
                  SET ASSIGN_FLAG = case when h_assign_flag is Null then  ASSIGN_FLAG else h_assign_flag end,
                  GROUP_IDS = h_group_ids,
                  PARTICIPANT_IDS = h_participant_ids,
                  SECURITY_IDS = h_security_ids,
                  SUBJECT = h_subject,
                  MESSAGE = h_message,
                  GROUP_NAMES = h_group_names,
                  PARTICIPANT_NAMES = h_participant_names,
                  SECURITY_NAMES = h_security_names,
                  VARIANCE = h_variance,
                  EXPIRE_DAYS = h_expire_days
                  WHERE ELEMENT_ID = h_element_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 351+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(352) : statenotifyconfig.sql(2552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_STATE_DEF', 358+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_STATE_DEF(359) : statenotifyconfig.sql(2559) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL'));
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_STATE_DEF', 361+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_STATE_DEF(362) : statenotifyconfig.sql(2562) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.RECORD_NOT_FOUND, True);
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_STATE_DEF', 369+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_STATE_DEF(370) : statenotifyconfig.sql(2570) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_element_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_element_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 376+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(377) : statenotifyconfig.sql(2577) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_STATE_DEF', 388+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_STATE_DEF(389) : statenotifyconfig.sql(2589) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_STATE_DEF;
ALTER FUNCTION SP_U_STATE_DEF COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_BUILD_STATE_TASK_RES_LIST ==
CREATE OR REPLACE FUNCTION FC_BUILD_STATE_TASK_RES_LIST
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_state_id PLS_INTEGER
   , h_state_task_id IN OUT NOCOPY VARCHAR2
   , h_assign_flag IN OUT NOCOPY VARCHAR2
   , h_group_ids IN OUT NOCOPY VARCHAR2
   , h_participant_ids IN OUT NOCOPY VARCHAR2
   , h_security_ids IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_contact_list IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_state_id PLS_INTEGER := sh_h_state_id;
   h_length PLS_INTEGER := 0;
   h_loc PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_security_id CHAR(32);
   h_group_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_email_address VARCHAR2(100);
   h_temp_security_ids VARCHAR2(2048);
   h_table_type PLS_INTEGER := 0;
   h_security_group_id VARCHAR2(32);
   h_security_rank VARCHAR2(200);
   h_contact_list_cnt PLS_INTEGER := 0;
   h_exists PLS_INTEGER := 0;
   h_idx PLS_INTEGER := 0;
   eos PLS_INTEGER;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BUILD_STATE_TASK_RES_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BUILD_STATE_TASK_RES_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_BUILD_STATE_TASK_RES_LIST(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_state_id), 'NULL')
          || ', ' || '''' || h_state_task_id || ''''
          || ', ' || '''' || h_assign_flag || ''''
          || ', ' || '''' || h_group_ids || ''''
          || ', ' || '''' || h_participant_ids || ''''
          || ', ' || '''' || h_security_ids || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_contact_list || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_STATE_TASK_RES_LIST', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BUILD_STATE_TASK_RES_LIST(50) : statenotifyconfig.sql(2655) : ' || SYSTIMESTAMP);
   END IF; 

   
   h_length := 0;
   h_loc := 0;
   h_contact_list_cnt := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_STATE_TASK_RES_LIST';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_STATE_TASK_RES_LIST';
   PMO_DB2M.SC_STATE := 0;
   
   -- add participants to contacts list
   If (h_participant_ids IS NOT NULL) Then
      h_length := Coalesce(Length(h_participant_ids), 0);
      h_loc := 1;
      
      WHILE Coalesce(h_loc, 0) < Coalesce(h_length, 0) LOOP
         BEGIN
            SELECT SUBSTR(h_participant_ids, h_loc, 32)
            INTO h_resource_id
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 81+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(82) : statenotifyconfig.sql(2687) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_loc := Coalesce(h_loc, 0) + 33;
         
         BEGIN
            INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
            SELECT RESOURCE_ID, E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
            FROM RESOURCES
            WHERE RESOURCE_ID = h_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(104) : statenotifyconfig.sql(2709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
   End If;
   
   -- add resources in groups to the contact list
   If (h_group_ids IS NOT NULL) Then
      h_length := Coalesce(Length(h_group_ids), 0);
      h_loc := 1;
      WHILE Coalesce(h_loc, 0) < Coalesce(h_length, 0) LOOP
         BEGIN
            SELECT SUBSTR(h_group_ids, h_loc, 32)
            INTO h_group_id
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 125+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(126) : statenotifyconfig.sql(2731) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_loc := Coalesce(h_loc, 0) + 33;
         
         BEGIN
            SELECT RANK
            INTO h_rank
            FROM TMT_CONTACTS
            WHERE ELEMENT_ID = h_group_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 143+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(144) : statenotifyconfig.sql(2749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
            SELECT DISTINCT R.RESOURCE_ID, R.E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
            FROM TMT_CONTACTS T
            JOIN RESOURCES R ON T.ELEMENT_ID = R.RESOURCE_ID
            WHERE T.TYPE_ID = PMO_CNST.SC_RESOURCE
            AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 165+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(166) : statenotifyconfig.sql(2771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
   End If;
   
   -- add resources with specified security_id to contact list
   If (h_security_ids IS NOT NULL) Then
      h_temp_security_ids := h_security_ids;
      eos := 1;
      h_loc := 0;
      WHILE eos = 1 LOOP
         BEGIN
            SELECT PMO_ORASTD.LOCATE(',', h_temp_security_ids)
            INTO h_loc
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(189) : statenotifyconfig.sql(2794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_loc, 0) = 0 Then
            h_security_id := SubStr(h_temp_security_ids, 1, 32);
            eos := 0;
         Else
            BEGIN
               SELECT substr(h_temp_security_ids, 1, h_loc-1), substr(h_temp_security_ids, h_loc + 1, length(h_temp_security_ids) - h_loc)
               INTO h_security_id, h_temp_security_ids
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(208) : statenotifyconfig.sql(2813) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_loc := Coalesce(h_loc, 0) + 1;
         End If;
         
         -- get security_id parent
         BEGIN
            SELECT RANK
            INTO h_security_rank
            FROM TMT_GLOBAL_SECURITY
            WHERE ELEMENT_ID = h_security_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 227+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(228) : statenotifyconfig.sql(2833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT ELEMENT_ID
            INTO h_security_group_id
            FROM TMT_GLOBAL_SECURITY
            WHERE RANK = SUBSTR(h_security_rank, 1, 8);
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 243+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(244) : statenotifyconfig.sql(2849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_ORASTD.strncmp(h_security_group_id, 'SCPROJECTGROUP', 14) <> 0 Then
            BEGIN
               INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
               SELECT DISTINCT R.RESOURCE_ID, R.E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
               FROM RESOURCE_ASSIGNMENTS RA, RESOURCES R
               WHERE RA.PROJECT_ID = h_project_id
               AND RA.RESOURCE_ID = R.RESOURCE_ID
               AND RA.SECURITY_ID = h_security_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 266+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(267) : statenotifyconfig.sql(2872) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_table_type := GetTable(Coalesce(h_type_id, 0));
            
            If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
               BEGIN
                  SELECT RANK
                  INTO h_rank
                  FROM TMT_WBS
                  WHERE ELEMENT_ID = h_element_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 285+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(286) : statenotifyconfig.sql(2891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
                  SELECT DISTINCT R.RESOURCE_ID, R.E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
                  FROM TMT_WBS W, RESOURCE_ASSIGNMENTS RA, RESOURCES R
                  WHERE W.PROJECT_ID = h_project_id
                  AND SUBSTR(h_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK
                  AND RA.PROJECT_ID = h_project_id
                  AND RA.ELEMENT_ID = W.ELEMENT_ID
                  AND RA.RESOURCE_ID = R.RESOURCE_ID
                  AND RA.SECURITY_ID = h_security_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 310+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(311) : statenotifyconfig.sql(2916) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
               BEGIN
                  SELECT RANK
                  INTO h_rank
                  FROM TMT_DOCUMENTS
                  WHERE ELEMENT_ID = h_element_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 326+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(327) : statenotifyconfig.sql(2932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
                  SELECT DISTINCT R.RESOURCE_ID, R.E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
                  FROM TMT_DOCUMENTS D, RESOURCE_ASSIGNMENTS RA, RESOURCES R
                  WHERE D.PROJECT_ID = h_project_id
                  AND SUBSTR(h_rank, 1, CASE WHEN LENGTH(D.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(D.RANK) END) = D.RANK
                  AND RA.PROJECT_ID = h_project_id
                  AND RA.ELEMENT_ID = D.ELEMENT_ID
                  AND RA.RESOURCE_ID = R.RESOURCE_ID
                  AND RA.SECURITY_ID = h_security_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 351+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(352) : statenotifyconfig.sql(2957) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
               BEGIN
                  SELECT RANK
                  INTO h_rank
                  FROM TMT_CRI
                  WHERE ELEMENT_ID = h_element_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 367+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(368) : statenotifyconfig.sql(2973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
                  SELECT DISTINCT R.RESOURCE_ID, R.E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
                  FROM TMT_CRI C, RESOURCE_ASSIGNMENTS RA, RESOURCES R
                  WHERE C.PROJECT_ID = h_project_id
                  AND SUBSTR(h_rank, 1, CASE WHEN LENGTH(C.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(C.RANK) END) = C.RANK
                  AND RA.PROJECT_ID = h_project_id
                  AND RA.ELEMENT_ID = C.ELEMENT_ID
                  AND RA.RESOURCE_ID = R.RESOURCE_ID
                  AND RA.SECURITY_ID = h_security_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 392+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(393) : statenotifyconfig.sql(2998) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      END LOOP;
   End If;
   
   If SubStr(h_assign_flag, 1, 1) = '1' Then
      BEGIN
         INSERT INTO PMO_TMP_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
         SELECT DISTINCT R.RESOURCE_ID, R.E_MAIL_ADDRESS, PMO_CNST.SCTASKTEAMMEMBER_DB2_STR
         FROM RESOURCE_ASSIGNMENTS RA, RESOURCES R
         WHERE RA.PROJECT_ID = h_project_id
         AND RA.ELEMENT_ID = h_element_id
         AND RA.RESOURCE_ID = R.RESOURCE_ID
         AND RESOURCE_TYPE = '0';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 420+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(421) : statenotifyconfig.sql(3026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Remove duplicate rows
   BEGIN
      INSERT INTO PMO_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
      SELECT DISTINCT RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID
      FROM PMO_TMP_STATE_TASK_RES_LIST;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 441+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(442) : statenotifyconfig.sql(3047) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_exists := 0;
   
   -- modify task responsible
   BEGIN
      SELECT 1
      INTO h_exists
      FROM DUAL
      WHERE EXISTS(SELECT RESOURCE_ID FROM PMO_STATE_TASK_RES_LIST WHERE RESOURCE_ID = h_rec_user);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 460+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(461) : statenotifyconfig.sql(3066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(h_exists, 0) = 1) Then
      BEGIN
         UPDATE PMO_STATE_TASK_RES_LIST
         SET SECURITY_ID = PMO_CNST.SCTASKRESPONSIBLE_DB2_STR
         WHERE RESOURCE_ID = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 480+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(481) : statenotifyconfig.sql(3086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_STATE_TASK_RES_LIST(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
         SELECT RESOURCE_ID, E_MAIL_ADDRESS, PMO_CNST.SCTASKRESPONSIBLE_DB2_STR
         FROM RESOURCES
         WHERE RESOURCE_ID = h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 500+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(501) : statenotifyconfig.sql(3106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT COUNT(*)
      INTO h_contact_list_cnt
      FROM PMO_STATE_TASK_RES_LIST;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BUILD_STATE_TASK_RES_LIST', 516+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BUILD_STATE_TASK_RES_LIST(517) : statenotifyconfig.sql(3122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_STATE_TASK_RES_LIST', 522+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_STATE_TASK_RES_LIST(523) : statenotifyconfig.sql(3128) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN Coalesce(h_contact_list_cnt, 0);
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BUILD_STATE_TASK_RES_LIST', 526+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BUILD_STATE_TASK_RES_LIST(527) : statenotifyconfig.sql(3132) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BUILD_STATE_TASK_RES_LIST;
ALTER FUNCTION FC_BUILD_STATE_TASK_RES_LIST COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_SEND_CHANGE_STATE_WKF ==
CREATE OR REPLACE FUNCTION FC_SEND_CHANGE_STATE_WKF
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_attachment_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_state_id PLS_INTEGER
   , h_active_state_element_id IN OUT NOCOPY VARCHAR2
   , h_wkf_sender_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_state_id PLS_INTEGER := sh_h_state_id;
   h_table_type PLS_INTEGER := 0;
   h_contact_list VARCHAR2(4000);
   h_contact_list_cnt PLS_INTEGER := 0;
   h_variance PLS_INTEGER := 0;
   h_assign_flag VARCHAR2(1);
   h_subject VARCHAR2(255);
   h_message VARCHAR2(2048);
   h_wkf_def_id VARCHAR2(32);
   h_revision VARCHAR2(16);
   h_workflow_id VARCHAR2(32);
   h_null VARCHAR2(1);
   h_flag_no_alert PLS_INTEGER := 0;
   h_temp_id VARCHAR2(32);
   h_temp_id2 VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_group_ids VARCHAR2(2048);
   h_temp_sc_state PLS_INTEGER;
   h_temp_length PLS_INTEGER;
   h_idx PLS_INTEGER;
-- Declare Cursors
      CURSOR res_2_notify IS
         SELECT RESOURCE_ID
         FROM PMO_STATE_TASK_WKF_CONTACTS;

      CURSOR C_H_WBS2 IS
         SELECT * FROM (SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION))
         FROM HISTORY_WBS
         WHERE ELEMENT_ID = h_attachment_id
         AND TYPE_ID = h_type_id
         AND STAGE_ID = h_state_id
         ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=1;

      CURSOR C_H_CRI2 IS
         SELECT * FROM (SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION))
         FROM HISTORY_CRI
         WHERE ELEMENT_ID = h_attachment_id
         AND TYPE_ID = h_type_id
         AND STAGE_ID = h_state_id
         ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=1;

      CURSOR C_H_DOC2 IS
         SELECT * FROM (SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION))
         FROM HISTORY_DOCUMENTS
         WHERE ELEMENT_ID = h_attachment_id
         AND TYPE_ID = h_type_id
         AND STAGE_ID = h_state_id
         ORDER BY REC_DATETIME DESC ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SEND_CHANGE_STATE_WKF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SEND_CHANGE_STATE_WKF'), '-- ' || SYSTIMESTAMP, ':r := FC_SEND_CHANGE_STATE_WKF(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_attachment_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_state_id), 'NULL')
          || ', ' || '''' || h_active_state_element_id || ''''
          || ', ' || '''' || h_wkf_sender_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SEND_CHANGE_STATE_WKF', 72+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SEND_CHANGE_STATE_WKF(73) : statenotifyconfig.sql(3215) : ' || SYSTIMESTAMP);
   END IF; 

   h_null := NULL;
   h_flag_no_alert := -2;
   h_group_ids := NULL;
   h_revision := '0.1';
   
   h_table_type := GetTable(Coalesce(h_type_id, 0));
   
   h_contact_list := '';
   -- build a comma seperated list of persons who shoul be notified
   
   OPEN res_2_notify;
   
   h_contact_list_cnt := 0;
   LOOP
      FETCH res_2_notify INTO h_resource_id;
      IF res_2_notify%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If Coalesce(h_contact_list_cnt, 0) > 0 Then
         h_contact_list := SubStr(h_contact_list || ',', 1, 4000);
      End If;
      h_contact_list := SubStr(h_contact_list || h_resource_id, 1, 4000);
      h_contact_list_cnt := Coalesce(h_contact_list_cnt, 0) + 1;
   END LOOP;
   
   BEGIN
      CLOSE res_2_notify ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(116) : statenotifyconfig.sql(3258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_contact_list_cnt, 0) > 0 Then
      BEGIN
         SELECT VARIANCE, ASSIGN_FLAG, SUBJECT, MESSAGE
         INTO h_variance, h_assign_flag, h_subject, h_message
         FROM PROJECT_STATE_DEF
         WHERE PROJECT_ID = h_project_id
         AND STAGE_ID = h_state_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 133+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(134) : statenotifyconfig.sql(3276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ELEMENT_ID
         INTO h_wkf_def_id
         FROM TMT_WORKFLOW_CYCLES
         WHERE PARENT_ID = 'NOTIFICATION';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(150) : statenotifyconfig.sql(3292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_workflow_id := '';
      
      h_temp_sc_state := FC_A_NOTIFICATION(h_table_type, h_attachment_id, h_wkf_def_id, h_type_id
                                     , h_wkf_sender_id, h_workflow_id);
      
      If h_temp_sc_state = 0 Then
         -- mark workflow as a state task workflow
         BEGIN
            UPDATE TMT_WORKFLOWS
            SET STATE_CHANGE_WKF = h_active_state_element_id
            where ELEMENT_ID = h_workflow_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(176) : statenotifyconfig.sql(3318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_id := NULL;
         h_temp_id2 := NULL;
         
         If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            OPEN C_H_WBS2;
            
            FETCH C_H_WBS2 INTO h_revision;
            IF C_H_WBS2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            BEGIN
               CLOSE C_H_WBS2 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 201+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(202) : statenotifyconfig.sql(3344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
            OPEN C_H_CRI2;
            
            FETCH C_H_CRI2 INTO h_revision;
            IF C_H_CRI2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            BEGIN
               CLOSE C_H_CRI2 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 223+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(224) : statenotifyconfig.sql(3366) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
            OPEN C_H_DOC2;
            
            FETCH C_H_DOC2 INTO h_revision;
            IF C_H_DOC2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            BEGIN
               CLOSE C_H_DOC2 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 245+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(246) : statenotifyconfig.sql(3388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --          //remove sender from receiver list
         --          BEGIN_SQL
         --              SELECT REPLACE(HOST(h_contact_list)||',',HOST(h_wkf_sender_id)||',','') INTO HOST(h_contact_list) FROM DUAL;
         --          END_SQL;
         
         h_temp_length := Coalesce(Length(h_contact_list), 0);
         
         If ((h_contact_list IS NOT NULL)) AND (h_temp_length > 1) Then
            --trace_printf("\n 1-h_contact_list:%s", h_contact_list);
            
            h_contact_list := SubStr(h_contact_list, 1, h_temp_length);
            
            --trace_printf("\n 2-h_contact_list:%s", h_contact_list);
            
            h_temp_sc_state := FC_U_WORKFLOW(h_workflow_id, h_revision, h_contact_list_cnt, h_contact_list_cnt
                                 , h_null, h_contact_list_cnt, h_subject, h_message, h_contact_list
                                 , h_group_ids, h_assign_flag, h_flag_no_alert, h_temp_id
                                 , h_temp_id2, h_wkf_sender_id);
         End If;
      End If;
      
      -- link workflow to state task
      BEGIN
         UPDATE TMT_WBS
         SET POOL_ID = h_workflow_id
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMP_STATE_TASK_ID);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SEND_CHANGE_STATE_WKF', 288+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SEND_CHANGE_STATE_WKF(289) : statenotifyconfig.sql(3431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SEND_CHANGE_STATE_WKF', 294+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SEND_CHANGE_STATE_WKF(295) : statenotifyconfig.sql(3437) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SEND_CHANGE_STATE_WKF;
ALTER FUNCTION FC_SEND_CHANGE_STATE_WKF COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_FIND_WBS_DIRECT_PARENT ==
CREATE OR REPLACE FUNCTION FC_FIND_WBS_DIRECT_PARENT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_wbs_parent_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
-- Declare Cursors
      CURSOR direct_parent IS
         SELECT * FROM (SELECT ELEMENT_ID
         FROM TMT_WBS W
         WHERE PROJECT_ID = h_project_id
         AND SUBSTR(h_rank, 1, CASE WHEN LENGTH(W.RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(W.RANK) END) = W.RANK
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM)
         ORDER BY LEVEL_ID DESC
         ) WHERE ROWNUM<=1;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FIND_WBS_DIRECT_PARENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FIND_WBS_DIRECT_PARENT'), '-- ' || SYSTIMESTAMP, ':r := FC_FIND_WBS_DIRECT_PARENT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_wbs_parent_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_WBS_DIRECT_PARENT', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FIND_WBS_DIRECT_PARENT(28) : statenotifyconfig.sql(3475) : ' || SYSTIMESTAMP);
   END IF; 

   -- find the direct parent of task
   BEGIN
      SELECT RANK
      INTO h_rank
      FROM TMT_WBS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_WBS_DIRECT_PARENT', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_WBS_DIRECT_PARENT(44) : statenotifyconfig.sql(3491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN direct_parent;
   
   FETCH direct_parent INTO h_wbs_parent_id;
   IF direct_parent%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   BEGIN
      CLOSE direct_parent ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FIND_WBS_DIRECT_PARENT', 65+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FIND_WBS_DIRECT_PARENT(66) : statenotifyconfig.sql(3513) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FIND_WBS_DIRECT_PARENT', 74+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FIND_WBS_DIRECT_PARENT(75) : statenotifyconfig.sql(3522) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FIND_WBS_DIRECT_PARENT;
ALTER FUNCTION FC_FIND_WBS_DIRECT_PARENT COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_I_STATE_TASK_RESPONSIBLE ==
CREATE OR REPLACE FUNCTION FC_I_STATE_TASK_RESPONSIBLE
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_current_week_of IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_task_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_finish_DT TIMESTAMP;
   h_res_assignment_id VARCHAR2(32);
   h_start_DT TIMESTAMP;
   h_uniqueID VARCHAR2(32);
   h_total PLS_INTEGER := 0;
   h_ieflag PLS_INTEGER := 0;
   h_temp_state PLS_INTEGER := 0;
   h_start_time VARCHAR2(8);
   h_finish_time VARCHAR2(8);
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   null_return LONG;
-- Declare Cursors
      CURSOR CDY_SD0 IS
         SELECT MIN(d.DAY_YEAR)
         FROM CALENDAR_DAY_OF_YEAR d
         LEFT OUTER JOIN PMO_TMP_CPLNF_0001 ta ON ta.DAY_YEAR = d.DAY_YEAR
         WHERE d.ELEMENT_ID = h_rec_user
         AND d.DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10))
         AND (d.AVAILABLE_MIN - COALESCE(ta.SCHED_MIN,0)) >= 15;

      CURSOR CDY_SD01 IS
         SELECT PMO_ORASTD.DB2TIMESTAMP( TO_DATE(SubStr(h_start_DT, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)) )
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_rec_user
         AND DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10));

      CURSOR CDY_SD1 IS
         SELECT PMO_ORASTD.DB2TIMESTAMP( (DAY_YEAR), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)) )
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_rec_user
         AND DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10));

      CURSOR CDY_SD2 IS
         SELECT PMO_ORASTD.DB2TIMESTAMP( (DAY_YEAR), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)) )
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_rec_user AND DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_STATE_TASK_RESPONSIBLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_STATE_TASK_RESPONSIBLE'), '-- ' || SYSTIMESTAMP, ':r := FC_I_STATE_TASK_RESPONSIBLE(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_current_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_task_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_STATE_TASK_RESPONSIBLE', 64+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_STATE_TASK_RESPONSIBLE(65) : statenotifyconfig.sql(3597) : ' || SYSTIMESTAMP);
   END IF; 

   h_ieflag := 0;
   h_temp_state := FC_I_WBS_MSP(h_name, h_parent_id, h_type_id, h_rec_user, h_ieflag, h_uniqueID);
   
   If Coalesce(h_temp_state, 0) = 0 Then
      h_task_id := h_uniqueID;
      
      BEGIN
         SELECT RES_ASSIGNMENT_ID
         INTO h_res_assignment_id
         FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID  = h_project_id
         AND ELEMENT_ID  = h_uniqueID
         AND RESOURCE_ID = h_rec_user;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(87) : statenotifyconfig.sql(3619) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CPLNF_0001';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CPLNF_0001
            SELECT tdy.DAY_YEAR, SUM(tdy.SCHED_MIN)
            FROM TASK_DAY_OF_YEAR tdy
            WHERE tdy.PROJECT_ID = h_project_id
            AND tdy.RESOURCE_ID = h_rec_user
            AND tdy.DAY_YEAR >= TO_DATE(SubStr(h_current_week_of, 1, 10))
            AND tdy.TASK_ID IN (
            SELECT ELEMENT_ID
            FROM TMT_WBS
            WHERE PROJECT_ID = h_project_id
            AND TYPE_ID = h_type_id)
            GROUP BY tdy.DAY_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(120) : statenotifyconfig.sql(3652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            OPEN CDY_SD0;
            
            FETCH CDY_SD0 INTO h_start_DT;
            IF CDY_SD0%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            h_temp_state := PMO_DB2M.SC_STATE;
            
            BEGIN
               CLOSE CDY_SD0 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 144+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(145) : statenotifyconfig.sql(3677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_temp_state, 0) <> 0) AND ((h_start_DT IS NULL)) Then
               BEGIN
                  SELECT MAX(DAY_YEAR) + 1    
                  INTO h_start_DT
                  FROM PMO_TMP_CPLNF_0001;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 160+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(161) : statenotifyconfig.sql(3693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               OPEN CDY_SD01;
               
               FETCH CDY_SD01 INTO h_start_DT;
               IF CDY_SD01%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               BEGIN
                  CLOSE CDY_SD01 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 182+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(183) : statenotifyconfig.sql(3715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  SELECT SCHED_MIN INTO h_total
                  FROM PMO_TMP_CPLNF_0001
                  WHERE DAY_YEAR = h_start_DT;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 197+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(198) : statenotifyconfig.sql(3730) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT PMO_ORASTD.DB2TIMESTAMP( TO_DATE(SubStr(h_start_DT, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.TIME_AFTER_SCHED(h_total, BIT_SCHED)) )
                  INTO h_start_DT FROM CALENDAR_DAY_OF_YEAR
                  WHERE ELEMENT_ID = h_rec_user
                  AND DAY_YEAR = TO_DATE(SubStr(h_start_DT, 1, 10));
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 213+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(214) : statenotifyconfig.sql(3746) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            OPEN CDY_SD1;
            
            FETCH CDY_SD1 INTO h_start_DT;
            IF CDY_SD1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               h_finish_DT := NULL;
               h_start_DT := h_current_week_of;
               h_total := 100;
               If EXTEND_PRCAL(h_rec_user, h_start_DT, h_finish_DT, h_total, 3) <> 0 Then
                  BEGIN
                     CLOSE CDY_SD1 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 241+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(242) : statenotifyconfig.sql(3774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_STATE_TASK_RESPONSIBLE', 246+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_I_STATE_TASK_RESPONSIBLE(247) : statenotifyconfig.sql(3779) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_CNST.TASK_ASSIGNMENT_ERROR;
               End If;
               
               h_start_DT := NULL;
               
               OPEN CDY_SD2;
               
               FETCH CDY_SD2 INTO h_start_DT;
               IF CDY_SD2%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  BEGIN
                     CLOSE CDY_SD2 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 271+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(272) : statenotifyconfig.sql(3804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     CLOSE CDY_SD1 ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 284+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(285) : statenotifyconfig.sql(3817) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_STATE_TASK_RESPONSIBLE', 289+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_I_STATE_TASK_RESPONSIBLE(290) : statenotifyconfig.sql(3822) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_CNST.TASK_ASSIGNMENT_ERROR;
               End If;
               
               BEGIN
                  CLOSE CDY_SD2 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 302+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(303) : statenotifyconfig.sql(3835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               CLOSE CDY_SD1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 316+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(317) : statenotifyconfig.sql(3849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(h_start_DT) + 15 MINUTES INTO h_finish_DT
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(332) : statenotifyconfig.sql(3864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --Get a unique id
         h_tsk_assignment_id := SYS_GUID();
         h_tsk_assignment_id := h_tsk_assignment_id;
         
         BEGIN
            INSERT INTO TASK_ASSIGNMENTS(TSK_ASSIGNMENT_ID,RES_ASSIGNMENT_ID,TASK_ID,PROJECT_ID,
            SD, FD, START_DT, FINISH_DT, DURATION,
            PROPOSED_START, PROPOSED_FINISH, PROPOSED_WORK,
            SCHED_START, SCHED_FINISH, SCHED_WORK, BEST, BIT_FLAG, ETC,
            BAK_START_DT, BAK_FINISH_DT, BAK_WORK, RESOURCE_ID, RESOURCE_TYPE,
            PROJECT_ASSIGNMENT_ID, ASSIGN_STRING, BAK_ASSIGN_STRING, TABLE_TYPE )
            VALUES(h_tsk_assignment_id, h_res_assignment_id, h_uniqueID, h_project_id,
            PMO_CNST.SC_SS, PMO_CNST.SC_SF, h_start_DT, h_finish_DT, 15,
            h_start_DT, h_finish_DT, 15,
            h_start_DT, h_finish_DT, 15, 15, '2', 15,
            h_start_DT, h_finish_DT, 15, h_rec_user,'0',
            NULL, '15', '15', 1);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 363+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(364) : statenotifyconfig.sql(3896) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_bitID := PMO_CNST.SC_ZERO_BIT;
            
            BEGIN
               SELECT PMO_ORASTD.TIME(h_start_DT), PMO_ORASTD.TIME(h_finish_DT)
               INTO h_start_time, h_finish_time
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 381+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(382) : statenotifyconfig.sql(3914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            PMO_STPU.filldayStruct(h_start_time, h_finish_time, h_bitID);
            
            BEGIN
               INSERT INTO TASK_DAY_OF_YEAR (PROJECT_ID, TASK_ID, RESOURCE_ID, TSK_ASSIGNMENT_ID, PARENT_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED, BIT_FLAG)
               VALUES(h_project_id, h_uniqueID, h_rec_user, h_tsk_assignment_id, h_tsk_assignment_id, TO_DATE(SubStr(h_start_DT, 1, 10)), 15, h_bitID, '2');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 401+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(402) : statenotifyconfig.sql(3934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         null_return := FC_Rollup(h_project_id);
      End If;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET TYPE_ID = PMO_CNST.SC_STATE_TASK
      WHERE TYPE_ID = PMO_CNST.SC_PERSONAL_TASK
      AND PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 426+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(427) : statenotifyconfig.sql(3959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS
      SET ELEMENT_TYPE = PMO_CNST.SC_STATE_TASK
      WHERE ELEMENT_TYPE = PMO_CNST.SC_PERSONAL_TASK
      AND PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK_RESPONSIBLE', 446+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK_RESPONSIBLE(447) : statenotifyconfig.sql(3979) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_STATE_TASK_RESPONSIBLE', 451+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_STATE_TASK_RESPONSIBLE(452) : statenotifyconfig.sql(3984) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_STATE_TASK_RESPONSIBLE;
ALTER FUNCTION FC_I_STATE_TASK_RESPONSIBLE COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_I_WBS_STATE_TASK ==
CREATE OR REPLACE FUNCTION FC_I_WBS_STATE_TASK
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_state_id PLS_INTEGER
   , h_active_state_element_id IN OUT NOCOPY VARCHAR2
   , h_task_name IN OUT NOCOPY VARCHAR2
   , h_wbs_parent_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_state_id PLS_INTEGER := sh_h_state_id;
   h_table_type PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_parent_rank VARCHAR2(200);
   h_wbs_type_id PLS_INTEGER := 0;
   h_wbs_element_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_email_address VARCHAR2(100);
   h_security_id VARCHAR2(32);
   h_state_task_type_id PLS_INTEGER := 0;
   h_current_week_of DATE;
   h_task_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_workflow_id VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_effort PLS_INTEGER := 0;
   h_consider PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   null_return LONG;
-- Declare Cursors
      CURSOR tesk_resources IS
         SELECT RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID
         FROM PMO_STATE_TASK_RES_LIST res
         ORDER BY RES.SECURITY_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_WBS_STATE_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_WBS_STATE_TASK'), '-- ' || SYSTIMESTAMP, ':r := FC_I_WBS_STATE_TASK(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_state_id), 'NULL')
          || ', ' || '''' || h_active_state_element_id || ''''
          || ', ' || '''' || h_task_name || ''''
          || ', ' || '''' || h_wbs_parent_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_STATE_TASK', 53+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_WBS_STATE_TASK(54) : statenotifyconfig.sql(4048) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE)
      INTO h_current_week_of
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(67) : statenotifyconfig.sql(4061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_wbs_parent_id IS NULL) Then
      h_table_type := GetTable(Coalesce(h_type_id, 0));
      If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
         If isWBSTask(Coalesce(h_type_id, 0)) <> 0 Then
            null_return := FC_FIND_WBS_DIRECT_PARENT(h_project_id, h_element_id, h_wbs_parent_id);
         Else
            h_wbs_parent_id := h_element_id;
         End If;
      ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_CRI Then
         BEGIN
            SELECT W.TYPE_ID, W.ELEMENT_ID
            INTO h_wbs_type_id, h_wbs_element_id
            FROM TMT_CRI C, TMT_WBS W
            WHERE C.PROJECT_ID = h_project_id
            AND C.ELEMENT_ID = h_element_id
            AND 'WBS#' || W.RANK= C.PARENT_RANK
            AND W.PROJECT_ID = C.PROJECT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 94+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(95) : statenotifyconfig.sql(4089) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If isWBSTask(Coalesce(h_wbs_type_id, 0)) <> 0 Then
            null_return := FC_FIND_WBS_DIRECT_PARENT(h_project_id, h_wbs_element_id, h_wbs_parent_id);
         Else
            h_wbs_parent_id := h_wbs_element_id;
         End If;
         
      ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_DOC Then
         BEGIN
            SELECT PARENT_RANK
            INTO h_parent_rank
            FROM TMT_DOCUMENTS
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 118+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(119) : statenotifyconfig.sql(4113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- function PMO_InStr was changed to return 0 not found, else 1 based index for the character
         -- TOTEST: Vladimir Schneider, vladimir@winpte.com
         If InStr(h_parent_rank, 'WBS#') <> 0 Then
            BEGIN
               SELECT W.TYPE_ID, W.ELEMENT_ID
               INTO h_wbs_type_id, h_wbs_element_id
               FROM TMT_WBS W
               WHERE 'WBS#' || W.RANK= h_parent_rank;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 137+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(138) : statenotifyconfig.sql(4132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT W.TYPE_ID, W.ELEMENT_ID
               INTO h_wbs_type_id, h_wbs_element_id
               FROM TMT_CRI C, TMT_WBS W
               WHERE C.PROJECT_ID = h_project_id
               AND C.RANK = SUBSTR(h_parent_rank, 5, LENGTH(h_parent_rank)- 4)
               AND W.RANK = SUBSTR(C.PARENT_RANK, 5, LENGTH(C.PARENT_RANK)- 4)
               AND W.PROJECT_ID = C.PROJECT_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 156+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(157) : statenotifyconfig.sql(4151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If isWBSTask(Coalesce(h_wbs_type_id, 0)) <> 0 Then
            null_return := FC_FIND_WBS_DIRECT_PARENT(h_project_id, h_wbs_element_id, h_wbs_parent_id);
         Else
            h_wbs_parent_id := h_wbs_element_id;
         End If;
      End If;
   End If;
   
   If (h_wbs_parent_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_STATE_TASK', 172+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_I_WBS_STATE_TASK(173) : statenotifyconfig.sql(4167) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.INVALID_PARAMS;
   Else
      OPEN tesk_resources;
      
      h_task_id := NULL;
      h_tsk_assignment_id := NULL;
      LOOP
         FETCH tesk_resources
         INTO h_resource_id, h_email_address, h_security_id;
         IF tesk_resources
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_state_task_type_id := PMO_CNST.SC_PERSONAL_TASK;
         
         If PMO_ORASTD.strncmp(h_security_id, 'SCTASKRESPONSIBLE', 17) = 0 Then
            PMO_DB2M.SC_STATE := FC_I_STATE_TASK_RESPONSIBLE(h_task_name, h_project_id, h_wbs_parent_id
                                                 , h_state_task_type_id, h_current_week_of
                                                 , h_resource_id, h_task_id, h_tsk_assignment_id);
            
            If PMO_DB2M.SC_STATE = 0 Then
               BEGIN
                  INSERT INTO TMP_STATE_TASK_ID(ELEMENT_ID)
                  VALUES(h_task_id);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 215+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(216) : statenotifyconfig.sql(4210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf (h_task_id IS NOT NULL) Then
            BEGIN
               SELECT h_current_week_of || ' 00:00:00'
               INTO h_start_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(232) : statenotifyconfig.sql(4226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_effort := 15;
            h_consider := 16;
            
            null_return := FC_ASSIGN_TEAMMEMBER(h_task_id, h_start_date, h_effort, h_consider, h_resource_id
                                    , h_rec_user);
         End If;
      END LOOP;
      BEGIN
         CLOSE tesk_resources ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_STATE_TASK', 251+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_STATE_TASK(252) : statenotifyconfig.sql(4246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_bitflag := 2;
      null_return := FC_COMMIT(h_task_id, h_bitflag);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_STATE_TASK', 261+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_WBS_STATE_TASK(262) : statenotifyconfig.sql(4256) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_WBS_STATE_TASK;
ALTER FUNCTION FC_I_WBS_STATE_TASK COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_I_STATE_TASK ==
CREATE OR REPLACE FUNCTION FC_I_STATE_TASK
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_state_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_state_id PLS_INTEGER := sh_h_state_id;
   h_root_id VARCHAR2(32);
   h_state_task_id VARCHAR2(32);
   h_participant_ids VARCHAR2(4000);
   h_security_ids VARCHAR2(2048);
   h_group_ids VARCHAR2(4000);
   h_assign_flag VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_contact_list_cnt PLS_INTEGER := 0;
   h_active_state_element_id VARCHAR2(32);
   h_workflow_id VARCHAR2(32);
   h_wbs_parent_id VARCHAR2(32);
   h_contact_list VARCHAR2(4000);
   h_is_active PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR task_state_set IS
         SELECT ELEMENT_ID, PARENT_ID, WBS_PARENT_ID, SUBJECT/*for state tasks subject is element_name or task name*/,
         ASSIGN_FLAG, GROUP_IDS, PARTICIPANT_IDS, SECURITY_IDS
         FROM PROJECT_STATE_DEF
         WHERE PROJECT_ID = h_project_id
         AND PARENT_ID = h_root_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_STATE_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_STATE_TASK'), '-- ' || SYSTIMESTAMP, ':r := FC_I_STATE_TASK(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_state_id), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_STATE_TASK', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_STATE_TASK(45) : statenotifyconfig.sql(4311) : ' || SYSTIMESTAMP);
   END IF; 

   h_root_id := NULL;
   h_state_task_id := NULL;
   h_participant_ids := NULL;
   h_security_ids := NULL;
   h_group_ids := NULL;
   h_assign_flag := NULL;
   h_workflow_id := NULL;
   h_contact_list := NULL;
   
   -- select the root node of state configuration
   BEGIN
      SELECT ELEMENT_ID
      INTO h_root_id
      FROM PROJECT_STATE_DEF
      WHERE PROJECT_ID = h_project_id
      AND STAGE_ID = h_state_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK(70) : statenotifyconfig.sql(4336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_is_active := 0;
   BEGIN
      SELECT COUNT(*) INTO h_is_active
      FROM STATE_TASK_NEXT_STATE_CNFG
      WHERE PROJECT_ID = h_project_id
      AND STAGE_ID = h_state_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK(87) : statenotifyconfig.sql(4353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (h_root_id IS NOT NULL) AND Coalesce(
         h_is_active, 0) > 0 Then
      -- select all state tasks configurations
      
      OPEN task_state_set;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_STATE_TASK_WKF_CONTACTS';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM TMP_STATE_TASK_ID';
      PMO_DB2M.SC_STATE := 0;
      
      LOOP
         FETCH task_state_set
         INTO h_state_task_id, h_active_state_element_id, h_wbs_parent_id, h_element_name, h_assign_flag, h_group_ids, h_participant_ids, h_security_ids;
         IF task_state_set
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> 0 Then
            EXIT;
         End If;
         
         h_contact_list_cnt := FC_BUILD_STATE_TASK_RES_LIST(h_project_id, h_element_id, h_type_id, h_state_id
                                                   , h_state_task_id, h_assign_flag, h_group_ids
                                                   , h_participant_ids, h_security_ids, h_rec_user
                                                   , h_contact_list);
         
         If Coalesce(h_contact_list_cnt, 0) > 0 Then
            -- create state change tasks for all resources
            null_return := FC_I_WBS_STATE_TASK(h_project_id, h_element_id, h_type_id, h_state_id
                                   , h_active_state_element_id, h_element_name, h_wbs_parent_id
                                   , h_rec_user);
            
            BEGIN
               INSERT INTO PMO_STATE_TASK_WKF_CONTACTS(RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID)
               SELECT DISTINCT RESOURCE_ID, EMAIL_ADDRESS, SECURITY_ID
               FROM PMO_STATE_TASK_RES_LIST
               WHERE RESOURCE_ID NOT IN (SELECT RESOURCE_ID FROM PMO_STATE_TASK_WKF_CONTACTS);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK', 145+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK(146) : statenotifyconfig.sql(4412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE task_state_set;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_STATE_TASK', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_STATE_TASK(161) : statenotifyconfig.sql(4427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- send workflow to contact list
      null_return := FC_SEND_CHANGE_STATE_WKF(h_project_id, h_element_id, h_type_id, h_state_id
                                        , h_active_state_element_id, h_rec_user);
   End If;
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_STATE_TASK', 173+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_STATE_TASK(174) : statenotifyconfig.sql(4440) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_STATE_TASK;
ALTER FUNCTION FC_I_STATE_TASK COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION SP_I_WBS_STATE_TASK ==
CREATE OR REPLACE FUNCTION SP_I_WBS_STATE_TASK
(
     p_project_id VARCHAR2
   , p_element_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_state_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_state_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_WBS_STATE_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_WBS_STATE_TASK'), '-- ' || SYSTIMESTAMP, ':r := SP_I_WBS_STATE_TASK(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_state_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_WBS_STATE_TASK', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_WBS_STATE_TASK(28) : statenotifyconfig.sql(4478) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_element_id := p_element_id;
   h_type_id := p_type_id;
   h_state_id := p_state_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_I_STATE_TASK(h_project_id, h_element_id, h_type_id, h_state_id, h_rec_user);
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_WBS_STATE_TASK', 43+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_WBS_STATE_TASK(44) : statenotifyconfig.sql(4494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_WBS_STATE_TASK', 50+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_WBS_STATE_TASK(51) : statenotifyconfig.sql(4501) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_WBS_STATE_TASK', 62+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_WBS_STATE_TASK(63) : statenotifyconfig.sql(4513) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_WBS_STATE_TASK;
ALTER FUNCTION SP_I_WBS_STATE_TASK COMPILE DEBUG;

/*************************************************************************************************/

Prompt == FUNCTION FC_COMPLETE_STATE_TASKS ==
CREATE OR REPLACE FUNCTION FC_COMPLETE_STATE_TASKS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_workflow_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_tsk_assignment_id VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_sched_work PLS_INTEGER := 0;
   h_planned_work PLS_INTEGER := 0;
   h_new_work_percent PLS_INTEGER := 0;
   h_units PLS_INTEGER := 0;
   h_actual PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      CURSOR res_assign_set IS
         SELECT TA.TSK_ASSIGNMENT_ID, TA.SCHED_WORK, TA.PLANNED_WORK
         FROM TASK_ASSIGNMENTS TA, TMT_WBS W
         WHERE W.POOL_ID = h_workflow_id
         AND TA.TASK_ID = W.ELEMENT_ID
         AND TA.PROJECT_ID = W.PROJECT_ID
         AND TA.RESOURCE_ID = h_resource_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COMPLETE_STATE_TASKS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COMPLETE_STATE_TASKS'), '-- ' || SYSTIMESTAMP, ':r := FC_COMPLETE_STATE_TASKS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_workflow_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMPLETE_STATE_TASKS', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COMPLETE_STATE_TASKS(32) : statenotifyconfig.sql(4561) : ' || SYSTIMESTAMP);
   END IF; 

   OPEN res_assign_set;
   
   LOOP
      FETCH res_assign_set INTO h_tsk_assignment_id, h_sched_work, h_planned_work;
      IF res_assign_set%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> 0 Then
         EXIT;
      End If;
      
      h_new_work_percent := 10000;
      h_new_work_percent := Coalesce(h_new_work_percent, 0);
      h_units := 10000;
      h_units := Coalesce(h_units, 0);
      h_actual := Coalesce(h_sched_work, 0) + Coalesce(h_planned_work, 0);
      h_actual := Coalesce(h_actual, 0);
      -- compelet assignment
      
      null_return := FC_U_WP_ACTUAL(h_tsk_assignment_id, h_new_work_percent, h_actual, h_units
                              , h_resource_id, h_error_id);
   END LOOP;
   
   BEGIN
      CLOSE res_assign_set ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMPLETE_STATE_TASKS', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMPLETE_STATE_TASKS(69) : statenotifyconfig.sql(4598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMPLETE_STATE_TASKS', 74+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COMPLETE_STATE_TASKS(75) : statenotifyconfig.sql(4604) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COMPLETE_STATE_TASKS;
ALTER FUNCTION FC_COMPLETE_STATE_TASKS COMPILE DEBUG;

/***************************************************************************************************************************/

Prompt == FUNCTION SP_S_WKF_STATE_TASKS ==
CREATE OR REPLACE FUNCTION SP_S_WKF_STATE_TASKS
(
     p_workflow_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_workflow_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      wkf_tasks PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WKF_STATE_TASKS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WKF_STATE_TASKS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WKF_STATE_TASKS(' || 
       '''' || p_workflow_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WKF_STATE_TASKS', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WKF_STATE_TASKS(22) : statenotifyconfig.sql(4636) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   h_workflow_id := p_workflow_id;
   h_resource_id := p_rec_user;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_VIEW';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_POOL_VIEW (PROJECT_ID, RANK, ELEMENT_ID, PARENT_ID, LEVEL_ID,
      PROJECT_NAME, MINUTE_PER_DAY, EFFORT_DRIVEN, CURRENCY_ID,
      PARTICIPANT, SECURITY_ID, MILESTONE_PERCENT, STAGE_ID, SCHED_START)
      SELECT T.PROJECT_ID, T.RANK, T.ELEMENT_ID, T.PARENT_ID, T.LEVEL_ID,
      PRJ.ELEMENT_NAME, PRJ.MINUTE_PER_DAY, PRJ.EFFORT_DRIVEN, PRJ.CURRENCY_ID,
      RA.PARTICIPANT, RA.SECURITY_ID, T.MILESTONE_PERCENT, T.STAGE_ID, T.SCHED_START
      FROM TMT_WBS T
      JOIN TMT_WBS PRJ ON PRJ.PROJECT_ID = T.PROJECT_ID
      AND PRJ.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCE_ASSIGNMENTS RA ON T.PROJECT_ID = RA.PROJECT_ID
      AND RA.ELEMENT_ID = T.ELEMENT_ID
      AND RA.RESOURCE_ID = h_resource_id
      JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = T.PROJECT_ID
      AND A.TASK_ID = T.ELEMENT_ID
      AND A.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
      WHERE T.POOL_ID = h_workflow_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_STATE_TASKS', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_STATE_TASKS(61) : statenotifyconfig.sql(4675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN wkf_tasks FOR SELECT 0 AS LEVEL_ID,
   PMO_CNST.SC_TASK_ASSN AS TYPE_ID,
   T.RANK,
   T.PARENT_ID,
   A.TSK_ASSIGNMENT_ID AS ELEMENT_ID,
   T.ELEMENT_NAME,
   ' ' AS ACTIVE,
   T.CHILD_COUNT,
   T.DELETED_COUNT,
   T.REC_STATUS,
   T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY,
   T.ELEMENT_ID AS ORIGINAL_ID,
   A.SD AS SD,
   A.START_DT AS START_DT,
   case when T.FD = PMO_CNST.SC_AF then T.FD else A.FD end as FD,
   A.FINISH_DT AS FINISH_DT,
   TMP.MINUTE_PER_DAY,
   A.DURATION as DURATION,
   T.PUBLISHED,
   T.CONSTRAINT_TYPE,
   T.CONSTRAINT_DT,
   A.BASELINE1_START  AS BASELINE_START,
   A.BASELINE1_FINISH  AS BASELINE_FINISH,
   A.BASELINE1_WORK    AS BASELINE_EFFORT,
   A.PLANNED_START     AS PLANNED_START,
   A.PLANNED_FINISH    AS PLANNED_FINISH,
   A.PLANNED_WORK      AS PLANNED_EFFORT,
   A.PROPOSED_START    AS PROPOSED_START,
   A.PROPOSED_FINISH   AS PROPOSED_FINISH,
   A.PROPOSED_WORK     AS PROPOSED_EFFORT,
   A.SCHED_START       AS SCHED_START,
   A.SCHED_FINISH      AS SCHED_FINISH,
   A.SCHED_WORK        AS SCHED_EFFORT,
   A.FORECAST_START    AS FORECAST_START,
   A.FORECAST_FINISH   AS FORECAST_FINISH,
   A.ETC                  AS ETC,
   A.WORK_TODATE + A.ETC  AS FORECAST_EFFORT,
   A.ACTUAL_START         AS ACTUAL_START,
   A.ACTUAL_FINISH        AS ACTUAL_FINISH,
   A.ACTUAL_DURATION      AS ACTUAL_DURATION,
   A.WORK_TODATE          AS ACTUAL_EFFORT,
   (A.REGULAR_TODATE) AS REGULAR_TODATE,
   (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE as REMAINING_EFFORT,
   ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) as ETC_RED_FLAG,
   -1 AS MILESTONE_PERCENT,
   A.MILESTONE_PERCENT as WORK_PERCENT,
   A.PLANNED_WORK + A.SCHED_WORK as WORK,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
   A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
   A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   A.REGULAR_COST AS REG_COST,
   A.SPECIAL_COST AS SPEC_COST,
   0.00 AS X_R_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
   A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
   A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   case WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
   A.SPECIAL_RATE AS SPEC_RATE,
   A.ASSIGN_STRING,
   T.PROJECT_ID,
   T.TYPE_ID AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,
   T.REFERENCE_NUMBER, 0 AS MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   COALESCE(A.RESOURCE_TYPE,'0') AS RESOURCE_TYPE,
   COALESCE(A.RESOURCE_ID,h_resource_id) AS RESOURCE_ID,
   TMP.PARTICIPANT,
   TMP.SECURITY_ID,
   T.ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   T.LAST_CHECKIN AS LAST_CHECKIN,
   A.TSK_ASSIGNMENT_ID,
   T.FS_CODE, T.STAGE_ID,
   T.FS_LABOR_CODE,
   TMP.CURRENCY_ID, TMP.EFFORT_DRIVEN ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0 AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
   A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
   A.LEVEL_START AS LEVEL_START,
   A.LEVEL_FINISH AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0 AS ESTIMATED_BASELINE1_EFFORT,
   0.00 AS ESTIMATED_BASELINE1_COST,
   0.00 AS ESTIMATED_BASELINE1_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   0 AS BUBBLE_COLOR, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT,
   COALESCE(A.UNITS_MSP,0) AS UNITS_PERCENT,
   TMP.PROJECT_NAME,
   COALESCE(COALESCE(A.REC_DATETIME, T.MP_STATUS_DT),
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
   
   A.REC_STATUS AS EDIT_FLAG,
   
   case when (T.SCHED_EFFORT > 0 AND COALESCE(A.PLANNED_WORK, T.PLANNED_EFFORT) = 0) OR
   ((T.PLANNED_EFFORT + T.SCHED_EFFORT) = 0 AND COALESCE(A.SCHED_START,T.SCHED_START) IS NOT NuLL)
   then '2' else '1' end AS BIT_FLAG,
   
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
   
   FROM PMO_POOL_VIEW TMP
   JOIN TMT_WBS T ON TMP.PROJECT_ID = T.PROJECT_ID
   AND TMP.ELEMENT_ID = T.ELEMENT_ID
   JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
   JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = T.PROJECT_ID
   AND A.TASK_ID = T.ELEMENT_ID
   AND A.RESOURCE_ID = h_resource_id
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WKF_STATE_TASKS', 215+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_WKF_STATE_TASKS(216) : statenotifyconfig.sql(4830) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN wkf_tasks;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_STATE_TASKS', 223+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_STATE_TASKS(224) : statenotifyconfig.sql(4838) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WKF_STATE_TASKS', 235+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WKF_STATE_TASKS(236) : statenotifyconfig.sql(4850) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WKF_STATE_TASKS;
ALTER FUNCTION SP_S_WKF_STATE_TASKS COMPILE DEBUG;

/*******************************************************************************************************/

Prompt == FUNCTION FC_AUOMATIC_STATE_CHANGE ==
CREATE OR REPLACE FUNCTION FC_AUOMATIC_STATE_CHANGE
(
     h_workflow_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_expires_date TIMESTAMP;
   h_current_date DATE;
   h_positive_votes PLS_INTEGER := 0;
   h_positive_votes_percent PLS_INTEGER := 0;
   h_negative_votes PLS_INTEGER := 0;
   h_incomplete_votes PLS_INTEGER := 0;
   h_number_of_voters PLS_INTEGER := 0;
   h_number_of_legal_voters PLS_INTEGER := 0;
   h_attachement_type_id PLS_INTEGER := 0;
   h_attachement_id VARCHAR2(32);
   h_configuration_id VARCHAR2(32);
   h_state_id PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_next_stage_id PLS_INTEGER := 0;
   h_cnfg_positive_percent PLS_INTEGER := 0;
   h_cnfg_voters_percent PLS_INTEGER := 0;
   h_cnfg_voters_expired_percent PLS_INTEGER := 0;
   h_final_stage PLS_INTEGER := 0;
   h_voters_percent PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_found PLS_INTEGER;
   h_positive_votes_delta PLS_INTEGER;
   h_number_of_voters_delta PLS_INTEGER;
   stmt VARCHAR2(7999);
-- Declare Cursors
      CURSOR cnfg_set IS
         SELECT NEXT_STAGE_ID, POSITIVE_RESPONSE, NEGATIVE_RESPONSE, PRIORITY
         FROM STATE_TASK_NEXT_STATE_CNFG
         WHERE PROJECT_ID = h_project_id
         AND STAGE_ID = h_state_id
         ORDER BY REC_DATETIME;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_AUOMATIC_STATE_CHANGE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_AUOMATIC_STATE_CHANGE'), '-- ' || SYSTIMESTAMP, ':r := FC_AUOMATIC_STATE_CHANGE(' || 
       '''' || h_workflow_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AUOMATIC_STATE_CHANGE', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_AUOMATIC_STATE_CHANGE(47) : statenotifyconfig.sql(4913) : ' || SYSTIMESTAMP);
   END IF; 

   h_positive_votes := 0;
   h_negative_votes := 0;
   h_incomplete_votes := 0;
   h_number_of_voters := 0;
   h_number_of_legal_voters := 0;
   h_final_stage := 0;
   
   BEGIN
      SELECT TO_DATE(SYSDATE)
      INTO h_current_date
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(67) : statenotifyconfig.sql(4933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PARENT_TYPE, PARENT_ID, STATE_CHANGE_WKF, STAGE_ID, EXPIRES_DATE
      INTO h_attachement_type_id, h_attachement_id, h_configuration_id, h_state_id, h_expires_date
      FROM TMT_WORKFLOWS
      WHERE ELEMENT_ID = h_workflow_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 82+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(83) : statenotifyconfig.sql(4949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(WKF_REPLY_ID),
      SUM(case when COMPLETED = '1' then 1 else 0 end),
      SUM(case when COMPLETED = '2' then 1 else 0 end),
      SUM(case when COMPLETED = '0' then 1 else 0 end)
      INTO h_number_of_legal_voters, h_positive_votes, h_negative_votes, h_incomplete_votes
      FROM WORKFLOW_REPLIES
      WHERE ELEMENT_ID = h_workflow_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 101+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(102) : statenotifyconfig.sql(4968) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_number_of_voters := Coalesce(h_positive_votes, 0) + Coalesce(h_negative_votes, 0);
   
   -- calculte percentage of positive_votes, positive_votes + negative_votes, expired_votes
   If Coalesce(h_number_of_legal_voters, 0) > 0 Then
      h_positive_votes_percent := Trunc((Coalesce(h_positive_votes, 0) * 10000) / Coalesce(
                                            h_number_of_legal_voters, 0));
      h_voters_percent := Trunc((Coalesce(h_number_of_voters, 0) * 10000) / Coalesce(
                                    h_number_of_legal_voters, 0));
   End If;
   
   --trace_printf("\n h_number_of_legal_voters:%d", h_number_of_legal_voters);
   --trace_printf("\n h_number_of_voters:%d", h_number_of_voters);
   --trace_printf("\n h_positive_votes:%d", h_positive_votes);
   --trace_printf("\n h_negative_votes:%d", h_negative_votes);
   --trace_printf("\n h_positive_votes_percent:%d", h_positive_votes_percent);
   --trace_printf("\n h_voters_percent:%d", h_voters_percent);
   --trace_printf("\n h_incomplete_votes:%d", h_incomplete_votes);
   
   BEGIN
      SELECT PROJECT_ID, STAGE_ID
      INTO h_project_id, h_state_id
      FROM PROJECT_STATE_DEF
      WHERE ELEMENT_ID = h_configuration_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(136) : statenotifyconfig.sql(5002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN cnfg_set;
   
   h_found := 0;
   h_positive_votes_delta := 20000;
   h_number_of_voters_delta := 20000;
   h_final_stage := 0;
   
   WHILE (h_found = 0) LOOP
      FETCH cnfg_set
      INTO h_next_stage_id, h_cnfg_positive_percent, h_cnfg_voters_percent, h_cnfg_voters_expired_percent;
      IF cnfg_set
      %FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      --trace_printf("\n h_next_stage_id:%d", h_next_stage_id);
      --trace_printf("\n h_cnfg_positive_percent:%d", h_cnfg_positive_percent);
      --trace_printf("\n h_cnfg_voters_percent:%d", h_cnfg_voters_percent);
      --trace_printf("\n h_cnfg_voters_expired_percent:%d", h_cnfg_voters_expired_percent);
      
      -- find appropriate stage
      If (Coalesce(h_cnfg_positive_percent, 0) <= Coalesce(h_positive_votes_percent, 0)) AND (Coalesce(
                                                     h_cnfg_voters_percent, 0) <= Coalesce(
                                                     h_voters_percent, 0)) Then
         If Coalesce(h_cnfg_voters_expired_percent, 0) = 10000 Then
            If PMO_ORASTD.strncmp(h_current_date, h_expires_date, 10) = 0 Then
               If h_positive_votes_delta > Coalesce(h_positive_votes_percent, 0) - Coalesce(
                                     h_cnfg_positive_percent, 0) Then
                  h_positive_votes_delta := Coalesce(h_positive_votes_percent, 0) - Coalesce(
                                   h_cnfg_positive_percent, 0);
                  h_final_stage := Coalesce(h_next_stage_id, 0);
                  h_found := 1;
               ElsIf h_number_of_voters_delta > Coalesce(h_voters_percent, 0) - Coalesce(
                                          h_cnfg_voters_percent, 0) Then
                  h_number_of_voters_delta := Coalesce(h_voters_percent, 0) - Coalesce(h_cnfg_voters_percent, 0);
                  h_final_stage := Coalesce(h_next_stage_id, 0);
                  h_found := 1;
               End If;
            End If;
         Else
            --trace_printf("\n h_positive_votes_delta:%d", h_positive_votes_delta);
            --trace_printf("\n h_positive_votes_percent - h_cnfg_positive_percent:%d", h_positive_votes_percent - h_cnfg_positive_percent);
            
            --trace_printf("\n h_number_of_voters_delta:%d", h_number_of_voters_delta);
            --trace_printf("\n h_voters_percent - h_cnfg_voters_percent:%d", h_voters_percent - h_cnfg_voters_percent);
            
            If h_positive_votes_delta > Coalesce(h_positive_votes_percent, 0) - Coalesce(
                                     h_cnfg_positive_percent, 0) Then
               h_positive_votes_delta := Coalesce(h_positive_votes_percent, 0) - Coalesce(
                                   h_cnfg_positive_percent, 0);
               h_final_stage := Coalesce(h_next_stage_id, 0);
               h_found := 1;
            ElsIf h_number_of_voters_delta > Coalesce(h_voters_percent, 0) - Coalesce(
                                          h_cnfg_voters_percent, 0) Then
               h_number_of_voters_delta := Coalesce(h_voters_percent, 0) - Coalesce(h_cnfg_voters_percent, 0);
               h_final_stage := Coalesce(h_next_stage_id, 0);
               h_found := 1;
            End If;
         End If;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE cnfg_set;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 216+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(217) : statenotifyconfig.sql(5083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_found:%d", h_found);
   
   If h_found = 1 Then
      -- force item to the next stage, close current workflow
      --trace_printf("\n h_final_stage:%d", h_final_stage);
      h_table_type := GetTable(Coalesce(h_attachement_type_id, 0));
      PMO_DB2M.SC_STATE := FC_U_STAGE_ID(h_attachement_id, h_table_type, h_final_stage, h_rec_user);
      
      BEGIN
         UPDATE TMT_WORKFLOWS
         SET OUTCOME_ID = 0 ,
         END_CYCLE = '1',
         CLOSED_DATE = SYSTIMESTAMP,
         REC_STATUS = 'U',
         REC_USER = h_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_workflow_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 248+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(249) : statenotifyconfig.sql(5115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE WORKFLOW_REPLIES
         SET REC_DATETIME = SYSTIMESTAMP,
         MARKED_READ = '0'
         WHERE ELEMENT_ID = h_workflow_id
         AND RESOURCE_ID <> h_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AUOMATIC_STATE_CHANGE', 269+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AUOMATIC_STATE_CHANGE(270) : statenotifyconfig.sql(5136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AUOMATIC_STATE_CHANGE', 280+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_AUOMATIC_STATE_CHANGE(281) : statenotifyconfig.sql(5147) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_AUOMATIC_STATE_CHANGE;
ALTER FUNCTION FC_AUOMATIC_STATE_CHANGE COMPILE DEBUG;


