/****************************************************************************************/

Prompt == FUNCTION SP_U_PBB ==
CREATE OR REPLACE FUNCTION SP_U_PBB
(
     p_project_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_chargecode_id VARCHAR2
   , p_budget_type PLS_INTEGER
   , p_month_01_amount NUMBER
   , p_month_02_amount NUMBER
   , p_month_03_amount NUMBER
   , p_month_04_amount NUMBER
   , p_month_05_amount NUMBER
   , p_month_06_amount NUMBER
   , p_month_07_amount NUMBER
   , p_month_08_amount NUMBER
   , p_month_09_amount NUMBER
   , p_month_10_amount NUMBER
   , p_month_11_amount NUMBER
   , p_month_12_amount NUMBER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_chargecode_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_total_amount NUMBER := 0;
   h_pa_timephase VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PBB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PBB'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PBB(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_01_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_02_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_03_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_04_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_05_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_06_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_07_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_08_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_09_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_10_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_11_amount), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_month_12_amount), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PBB', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PBB(56) : timephase.sql(59) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_project_id IS NULL) OR (p_budget_year IS NULL) OR (p_chargecode_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PBB', 60+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PBB(61) : timephase.sql(64) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PBB', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PBB(64) : timephase.sql(67) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_element_id := p_project_id;
   h_budget_year := p_budget_year;
   h_chargecode_id := p_chargecode_id;
   
   -- timephase project/deliverable
   BEGIN
      SELECT PROJECT_ID INTO h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(86) : timephase.sql(89) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         SELECT PROJECT_ID INTO h_project_id
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(102) : timephase.sql(105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PBB', 108+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PBB(109) : timephase.sql(112) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PBB', 111+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_PBB(112) : timephase.sql(115) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_project_id, True);
      End If;
   End If;
   
   BEGIN
      SELECT CAPITAL_EXPENSE INTO h_capital_expense
      FROM BUDGETS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_chargecode_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 129+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(130) : timephase.sql(133) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   If (Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR) AND (Coalesce(
             p_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET) Then
      If PMO_ORASTD.strcmp(h_project_id, h_element_id) = 0 Then
         BEGIN
            SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
            FROM PROJECT_DETAILS
            WHERE PROJECT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 148+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(149) : timephase.sql(152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (PMO_ORASTD.strncmp(h_pa_timephase, 'Y'
               , 1) = 0) Then
            BEGIN
               SELECT COUNT(TSK_ASSIGNMENT_ID) INTO h_count
               FROM TASK_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id
               AND TASK_ID = PROJECT_ID;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 166+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(167) : timephase.sql(170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(h_count, 0) > 0) Then
               h_count := 1;
            Else
               h_count := 0;
            End If;
         End If;
      End If;
   End If;
   
   If Coalesce(h_count, 0) = 0 Then
      If (Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_AVERAGE_COST) OR (Coalesce(
             h_capital_expense, 0) = PMO_CNST.SC_CAPITAL_AVERAGE_COST) OR (Coalesce(
             h_capital_expense, 0) = PMO_CNST.SC_BENEFIT_AVERAGE_COST) Then
         h_total_amount := (Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                            p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                            p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                            p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                            p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                            p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0)) / 12;
      Else
         h_total_amount := Coalesce(p_month_01_amount, 0) + Coalesce(p_month_02_amount, 0) + Coalesce(
                           p_month_03_amount, 0) + Coalesce(p_month_04_amount, 0) + Coalesce(
                           p_month_05_amount, 0) + Coalesce(p_month_06_amount, 0) + Coalesce(
                           p_month_07_amount, 0) + Coalesce(p_month_08_amount, 0) + Coalesce(
                           p_month_09_amount, 0) + Coalesce(p_month_10_amount, 0) + Coalesce(
                           p_month_11_amount, 0) + Coalesce(p_month_12_amount, 0);
      End If;
      
      BEGIN
         UPDATE PROJECT_BUDGET_BREAKDOWN SET
         MONTH_01_AMOUNT = p_month_01_amount,
         MONTH_02_AMOUNT = p_month_02_amount,
         MONTH_03_AMOUNT = p_month_03_amount,
         MONTH_04_AMOUNT = p_month_04_amount,
         MONTH_05_AMOUNT = p_month_05_amount,
         MONTH_06_AMOUNT = p_month_06_amount,
         MONTH_07_AMOUNT = p_month_07_amount,
         MONTH_08_AMOUNT = p_month_08_amount,
         MONTH_09_AMOUNT = p_month_09_amount,
         MONTH_10_AMOUNT = p_month_10_amount,
         MONTH_11_AMOUNT = p_month_11_amount,
         MONTH_12_AMOUNT = p_month_12_amount,
         TOTAL_AMOUNT = h_total_amount
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND BUDGET_YEAR = h_budget_year
         AND CHARGECODE_ID = h_chargecode_id
         AND BUDGET_TYPE = p_budget_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 229+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(230) : timephase.sql(233) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN (
            ELEMENT_ID,
            PROJECT_ID,
            BUDGET_YEAR,
            CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT,
            MONTH_02_AMOUNT,
            MONTH_03_AMOUNT,
            MONTH_04_AMOUNT,
            MONTH_05_AMOUNT,
            MONTH_06_AMOUNT,
            MONTH_07_AMOUNT,
            MONTH_08_AMOUNT,
            MONTH_09_AMOUNT,
            MONTH_10_AMOUNT,
            MONTH_11_AMOUNT,
            MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            VALUES (
            h_element_id,
            h_project_id,
            h_budget_year,
            h_chargecode_id,
            p_budget_type,
            p_month_01_amount,
            p_month_02_amount,
            p_month_03_amount,
            p_month_04_amount,
            p_month_05_amount,
            p_month_06_amount,
            p_month_07_amount,
            p_month_08_amount,
            p_month_09_amount,
            p_month_10_amount,
            p_month_11_amount,
            p_month_12_amount,
            h_total_amount
            );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 285+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(286) : timephase.sql(289) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(p_budget_type, 0) = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET Then
         BEGIN
            UPDATE BUDGETS
            SET COST_CENTER_BITS = PMO_STPU.BIT_OR(COST_CENTER_BITS, PMO_CNST.SC_UPDATE_ESTIMATED_ACTUAL_BIT)
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_element_id
            AND CHARGECODE_ID = h_chargecode_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 308+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(309) : timephase.sql(312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PBB', 316+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PBB(317) : timephase.sql(320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 323+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(324) : timephase.sql(327) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PBB', 335+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PBB(336) : timephase.sql(339) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PBB;
ALTER FUNCTION SP_U_PBB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_PBB ==
CREATE OR REPLACE FUNCTION SP_S_PBB
(
     p_project_id VARCHAR2
   , p_budget_year PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_table_type PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_PBBA PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_DBBA PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_DBBA_CRI PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_PBB PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_DBB PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      C_DBB_CRI PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PBB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PBB'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PBB(' || 
       '''' || p_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_year), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PBB(41) : timephase.sql(396) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_project_id;
   h_table_type := PMO_CNST.SC_TABLE_WBS;
   
   If (p_project_id IS NULL) OR (p_budget_year IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_PBB', 48+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_PBB(49) : timephase.sql(404) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(52) : timephase.sql(407) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   BEGIN
      SELECT PROJECT_ID, ELEMENT_ID, RANK
      INTO h_project_id, h_element_id, h_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 67+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(68) : timephase.sql(423) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      h_table_type := PMO_CNST.SC_TABLE_CRI;
      BEGIN
         SELECT PROJECT_ID, ELEMENT_ID, RANK
         INTO h_project_id, h_element_id, h_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(86) : timephase.sql(441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_PBB', 92+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_PBB(93) : timephase.sql(448) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_project_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 95+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(96) : timephase.sql(451) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_project_id, True);
      End If;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
   PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
   
   BEGIN
      DELETE FROM TIMEPHASED_PROJECT
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(118) : timephase.sql(473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(p_budget_year, 0) = 0 Then
      If PMO_ORASTD.strcmp(h_project_id, h_element_id) = 0 Then
         OPEN C_PBBA FOR SELECT
         (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
         AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
         CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
         PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, CC.CAPITAL_EXPENSE,
         CC.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
         PBB.ELEMENT_ID AS ASSOCIATE_ID,
         CASE WHEN B.ASSOCIATE_BUDGET_ID IS NULL THEN 0 ELSE
         (SELECT ABC.CAPITAL_EXPENSE FROM BUDGETS AB, TMT_CHARGECODES ABC
         WHERE AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID AND AB.PROJECT_ID = B.PROJECT_ID
         AND AB.ELEMENT_ID = B.ELEMENT_ID AND ABC.ELEMENT_ID = AB.CHARGECODE_ID) END
         AS ASSOCIATE_CAPITAL_EXPENSE,
         B.AUTO_FLAG,
         PBB.MONTH_01_AMOUNT,
         PBB.MONTH_02_AMOUNT,PBB.MONTH_03_AMOUNT,
         PBB.MONTH_04_AMOUNT,PBB.MONTH_05_AMOUNT,
         PBB.MONTH_06_AMOUNT,PBB.MONTH_07_AMOUNT,
         PBB.MONTH_08_AMOUNT,PBB.MONTH_09_AMOUNT,
         PBB.MONTH_10_AMOUNT,PBB.MONTH_11_AMOUNT,
         PBB.MONTH_12_AMOUNT,PBB.TOTAL_AMOUNT
         FROM PROJECT_BUDGET_BREAKDOWN PBB
         JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
         JOIN BUDGETS B ON B.PROJECT_ID = PBB.PROJECT_ID AND B.CHARGECODE_ID = PBB.CHARGECODE_ID AND B.ELEMENT_ID = PBB.ELEMENT_ID
         WHERE PBB.PROJECT_ID = h_project_id
         AND PBB.PROJECT_ID = PBB.ELEMENT_ID
         ORDER BY PBB.BUDGET_YEAR, CC.CAPITAL_EXPENSE, CC.RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 151+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(152) : timephase.sql(507) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C_PBBA;
      Else
         If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            OPEN C_DBBA FOR SELECT
            (h_element_id || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE,
            B.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            h_element_id AS ASSOCIATE_ID,
            AB.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            B.AUTO_FLAG,
            SUM(PBB.MONTH_01_AMOUNT) AS MONTH_01_AMOUNT,
            SUM(PBB.MONTH_02_AMOUNT) AS MONTH_02_AMOUNT,
            SUM(PBB.MONTH_03_AMOUNT) AS MONTH_03_AMOUNT,
            SUM(PBB.MONTH_04_AMOUNT) AS MONTH_04_AMOUNT,
            SUM(PBB.MONTH_05_AMOUNT) AS MONTH_05_AMOUNT,
            SUM(PBB.MONTH_06_AMOUNT) AS MONTH_06_AMOUNT,
            SUM(PBB.MONTH_07_AMOUNT) AS MONTH_07_AMOUNT,
            SUM(PBB.MONTH_08_AMOUNT) AS MONTH_08_AMOUNT,
            SUM(PBB.MONTH_09_AMOUNT) AS MONTH_09_AMOUNT,
            SUM(PBB.MONTH_10_AMOUNT) AS MONTH_10_AMOUNT,
            SUM(PBB.MONTH_11_AMOUNT) AS MONTH_11_AMOUNT,
            SUM(PBB.MONTH_12_AMOUNT) AS MONTH_12_AMOUNT,
            SUM(PBB.TOTAL_AMOUNT) AS TOTAL_AMOUNT
            FROM TMT_WBS W
            JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.PROJECT_ID = W.PROJECT_ID
            AND PBB.ELEMENT_ID = W.ELEMENT_ID
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            JOIN BUDGETS B ON B.PROJECT_ID = PBB.PROJECT_ID
            AND B.CHARGECODE_ID = PBB.CHARGECODE_ID AND B.ELEMENT_ID = PBB.ELEMENT_ID
            LEFT JOIN BUDGETS AB ON AB.PROJECT_ID = B.PROJECT_ID
            AND AB.ELEMENT_ID = B.ELEMENT_ID AND AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
            WHERE W.PROJECT_ID = h_project_id
            AND W.RANK LIKE h_rank || '%'
            AND (W.ELEMENT_ID = h_element_id OR W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK))
            GROUP BY CC.ELEMENT_ID, CC.ELEMENT_NAME, PBB.BUDGET_TYPE, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE, B.BILLABLE,
            B.AUTO_FLAG, AB.CAPITAL_EXPENSE, CC.RANK
            UNION ALL
            SELECT
            (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, CC.CAPITAL_EXPENSE,
            CC.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            PBB.ELEMENT_ID AS ASSOCIATE_ID,
            PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            PMO_CNST.SC_AUTO_REV_NONE AS AUTO_FLAG,
            PBB.MONTH_01_AMOUNT,
            PBB.MONTH_02_AMOUNT,PBB.MONTH_03_AMOUNT,
            PBB.MONTH_04_AMOUNT,PBB.MONTH_05_AMOUNT,
            PBB.MONTH_06_AMOUNT,PBB.MONTH_07_AMOUNT,
            PBB.MONTH_08_AMOUNT,PBB.MONTH_09_AMOUNT,
            PBB.MONTH_10_AMOUNT,PBB.MONTH_11_AMOUNT,
            PBB.MONTH_12_AMOUNT,PBB.TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN PBB
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            WHERE PBB.PROJECT_ID = h_project_id
            AND PBB.PROJECT_ID = PBB.ELEMENT_ID
            AND CC.CAPITAL_EXPENSE = PMO_CNST.SC_TIMEPHASE_CALENDAR;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 215+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(216) : timephase.sql(571) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_DBBA;
         Else
            OPEN C_DBBA_CRI FOR SELECT
            (h_element_id || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE,
            B.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            h_element_id AS ASSOCIATE_ID,
            AB.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            B.AUTO_FLAG,
            SUM(PBB.MONTH_01_AMOUNT) AS MONTH_01_AMOUNT,
            SUM(PBB.MONTH_02_AMOUNT) AS MONTH_02_AMOUNT,
            SUM(PBB.MONTH_03_AMOUNT) AS MONTH_03_AMOUNT,
            SUM(PBB.MONTH_04_AMOUNT) AS MONTH_04_AMOUNT,
            SUM(PBB.MONTH_05_AMOUNT) AS MONTH_05_AMOUNT,
            SUM(PBB.MONTH_06_AMOUNT) AS MONTH_06_AMOUNT,
            SUM(PBB.MONTH_07_AMOUNT) AS MONTH_07_AMOUNT,
            SUM(PBB.MONTH_08_AMOUNT) AS MONTH_08_AMOUNT,
            SUM(PBB.MONTH_09_AMOUNT) AS MONTH_09_AMOUNT,
            SUM(PBB.MONTH_10_AMOUNT) AS MONTH_10_AMOUNT,
            SUM(PBB.MONTH_11_AMOUNT) AS MONTH_11_AMOUNT,
            SUM(PBB.MONTH_12_AMOUNT) AS MONTH_12_AMOUNT,
            SUM(PBB.TOTAL_AMOUNT) AS TOTAL_AMOUNT
            FROM TMT_CRI W
            JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.PROJECT_ID = W.PROJECT_ID
            AND PBB.ELEMENT_ID = W.ELEMENT_ID
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            JOIN BUDGETS B ON B.PROJECT_ID = PBB.PROJECT_ID
            AND B.CHARGECODE_ID = PBB.CHARGECODE_ID AND B.ELEMENT_ID = PBB.ELEMENT_ID
            LEFT JOIN BUDGETS AB ON AB.PROJECT_ID = B.PROJECT_ID
            AND AB.ELEMENT_ID = B.ELEMENT_ID AND AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
            WHERE W.PROJECT_ID = h_project_id
            AND W.RANK LIKE h_rank || '%'
            AND (W.ELEMENT_ID = h_element_id OR W.TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,PMO_CNST.SC_CRI_ACTION_ITEM_TASK,PMO_CNST.SC_CRI_RISK_TASK,PMO_CNST.SC_CRI_ISSUE_TASK,PMO_CNST.SC_CRI_REQUIREMENT_TASK,PMO_CNST.SC_CRI_DEFECT_TASK,PMO_CNST.SC_SERVICE_REQUEST_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE))
            GROUP BY CC.ELEMENT_ID, CC.ELEMENT_NAME, PBB.BUDGET_TYPE, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE, B.BILLABLE,
            B.AUTO_FLAG, AB.CAPITAL_EXPENSE, CC.RANK
            UNION ALL
            SELECT
            (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, CC.CAPITAL_EXPENSE,
            CC.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            PBB.ELEMENT_ID AS ASSOCIATE_ID,
            PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            PMO_CNST.SC_AUTO_REV_NONE AS AUTO_FLAG,
            PBB.MONTH_01_AMOUNT,
            PBB.MONTH_02_AMOUNT,PBB.MONTH_03_AMOUNT,
            PBB.MONTH_04_AMOUNT,PBB.MONTH_05_AMOUNT,
            PBB.MONTH_06_AMOUNT,PBB.MONTH_07_AMOUNT,
            PBB.MONTH_08_AMOUNT,PBB.MONTH_09_AMOUNT,
            PBB.MONTH_10_AMOUNT,PBB.MONTH_11_AMOUNT,
            PBB.MONTH_12_AMOUNT,PBB.TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN PBB
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            WHERE PBB.PROJECT_ID = h_project_id
            AND PBB.PROJECT_ID = PBB.ELEMENT_ID
            AND CC.CAPITAL_EXPENSE = PMO_CNST.SC_TIMEPHASE_CALENDAR;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 278+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(279) : timephase.sql(634) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_DBBA_CRI;
         End If;
      End If;
   Else
      If PMO_ORASTD.strcmp(h_project_id, h_element_id) = 0 Then
         OPEN C_PBB FOR SELECT
         (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
         AS ELEMENT_ID,
         CC.ELEMENT_ID AS ORIGINAL_ID,
         CC.ELEMENT_NAME,
         PBB.BUDGET_TYPE AS TYPE_ID,
         PBB.PROJECT_ID,
         PBB.BUDGET_YEAR,
         PBB.CHARGECODE_ID,
         CC.CAPITAL_EXPENSE,
         CC.BILLABLE,
         CC.ELEMENT_NAME AS CHARGECODE_NAME,
         PBB.ELEMENT_ID AS ASSOCIATE_ID,
         CASE WHEN B.ASSOCIATE_BUDGET_ID IS NULL THEN 0 ELSE
         (SELECT ABC.CAPITAL_EXPENSE FROM BUDGETS AB, TMT_CHARGECODES ABC
         WHERE AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID AND AB.PROJECT_ID = B.PROJECT_ID
         AND AB.ELEMENT_ID = B.ELEMENT_ID AND ABC.ELEMENT_ID = AB.CHARGECODE_ID) END
         AS ASSOCIATE_CAPITAL_EXPENSE,
         B.AUTO_FLAG,
         PBB.MONTH_01_AMOUNT,
         PBB.MONTH_02_AMOUNT,
         PBB.MONTH_03_AMOUNT,
         PBB.MONTH_04_AMOUNT,
         PBB.MONTH_05_AMOUNT,
         PBB.MONTH_06_AMOUNT,
         PBB.MONTH_07_AMOUNT,
         PBB.MONTH_08_AMOUNT,
         PBB.MONTH_09_AMOUNT,
         PBB.MONTH_10_AMOUNT,
         PBB.MONTH_11_AMOUNT,
         PBB.MONTH_12_AMOUNT,
         PBB.TOTAL_AMOUNT
         FROM PROJECT_BUDGET_BREAKDOWN PBB ,TMT_CHARGECODES CC , BUDGETS B
         WHERE PBB.ELEMENT_ID = p_project_id
         AND PBB.BUDGET_YEAR = p_budget_year
         AND CC.ELEMENT_ID = PBB.CHARGECODE_ID
         AND B.PROJECT_ID = PBB.PROJECT_ID
         AND B.ELEMENT_ID = PBB.PROJECT_ID
         AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
         ORDER BY CC.CAPITAL_EXPENSE, CC.RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 326+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(327) : timephase.sql(682) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN C_PBB;
      Else
         If Coalesce(h_table_type, 0) = PMO_CNST.SC_TABLE_WBS Then
            OPEN C_DBB FOR SELECT
            (h_element_id || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE,
            B.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            h_element_id AS ASSOCIATE_ID,
            AB.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            B.AUTO_FLAG,
            SUM(PBB.MONTH_01_AMOUNT) AS MONTH_01_AMOUNT,
            SUM(PBB.MONTH_02_AMOUNT) AS MONTH_02_AMOUNT,
            SUM(PBB.MONTH_03_AMOUNT) AS MONTH_03_AMOUNT,
            SUM(PBB.MONTH_04_AMOUNT) AS MONTH_04_AMOUNT,
            SUM(PBB.MONTH_05_AMOUNT) AS MONTH_05_AMOUNT,
            SUM(PBB.MONTH_06_AMOUNT) AS MONTH_06_AMOUNT,
            SUM(PBB.MONTH_07_AMOUNT) AS MONTH_07_AMOUNT,
            SUM(PBB.MONTH_08_AMOUNT) AS MONTH_08_AMOUNT,
            SUM(PBB.MONTH_09_AMOUNT) AS MONTH_09_AMOUNT,
            SUM(PBB.MONTH_10_AMOUNT) AS MONTH_10_AMOUNT,
            SUM(PBB.MONTH_11_AMOUNT) AS MONTH_11_AMOUNT,
            SUM(PBB.MONTH_12_AMOUNT) AS MONTH_12_AMOUNT,
            SUM(PBB.TOTAL_AMOUNT) AS TOTAL_AMOUNT
            FROM TMT_WBS W
            JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.PROJECT_ID = W.PROJECT_ID
            AND PBB.ELEMENT_ID = W.ELEMENT_ID
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            JOIN BUDGETS B ON B.PROJECT_ID = PBB.PROJECT_ID
            AND B.CHARGECODE_ID = PBB.CHARGECODE_ID AND B.ELEMENT_ID = PBB.ELEMENT_ID
            LEFT JOIN BUDGETS AB ON AB.PROJECT_ID = B.PROJECT_ID
            AND AB.ELEMENT_ID = B.ELEMENT_ID AND AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
            WHERE W.PROJECT_ID = h_project_id
            AND W.RANK LIKE h_rank || '%'
            AND (W.ELEMENT_ID = h_element_id OR W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK))
            AND PBB.BUDGET_YEAR = p_budget_year
            GROUP BY CC.ELEMENT_ID, CC.ELEMENT_NAME, PBB.BUDGET_TYPE, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE, B.BILLABLE,
            B.AUTO_FLAG, AB.CAPITAL_EXPENSE, CC.RANK
            UNION ALL
            SELECT
            (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, CC.CAPITAL_EXPENSE,
            CC.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            PBB.ELEMENT_ID AS ASSOCIATE_ID,
            PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            PMO_CNST.SC_AUTO_REV_NONE AS AUTO_FLAG,
            PBB.MONTH_01_AMOUNT,
            PBB.MONTH_02_AMOUNT,PBB.MONTH_03_AMOUNT,
            PBB.MONTH_04_AMOUNT,PBB.MONTH_05_AMOUNT,
            PBB.MONTH_06_AMOUNT,PBB.MONTH_07_AMOUNT,
            PBB.MONTH_08_AMOUNT,PBB.MONTH_09_AMOUNT,
            PBB.MONTH_10_AMOUNT,PBB.MONTH_11_AMOUNT,
            PBB.MONTH_12_AMOUNT,PBB.TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN PBB
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            WHERE PBB.PROJECT_ID = h_project_id
            AND PBB.PROJECT_ID = PBB.ELEMENT_ID
            AND PBB.BUDGET_YEAR = p_budget_year
            AND CC.CAPITAL_EXPENSE = PMO_CNST.SC_TIMEPHASE_CALENDAR;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 392+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(393) : timephase.sql(748) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_DBB;
         Else
            OPEN C_DBB_CRI FOR SELECT
            (h_element_id || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE,
            B.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            h_element_id AS ASSOCIATE_ID,
            AB.CAPITAL_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            B.AUTO_FLAG,
            SUM(PBB.MONTH_01_AMOUNT) AS MONTH_01_AMOUNT,
            SUM(PBB.MONTH_02_AMOUNT) AS MONTH_02_AMOUNT,
            SUM(PBB.MONTH_03_AMOUNT) AS MONTH_03_AMOUNT,
            SUM(PBB.MONTH_04_AMOUNT) AS MONTH_04_AMOUNT,
            SUM(PBB.MONTH_05_AMOUNT) AS MONTH_05_AMOUNT,
            SUM(PBB.MONTH_06_AMOUNT) AS MONTH_06_AMOUNT,
            SUM(PBB.MONTH_07_AMOUNT) AS MONTH_07_AMOUNT,
            SUM(PBB.MONTH_08_AMOUNT) AS MONTH_08_AMOUNT,
            SUM(PBB.MONTH_09_AMOUNT) AS MONTH_09_AMOUNT,
            SUM(PBB.MONTH_10_AMOUNT) AS MONTH_10_AMOUNT,
            SUM(PBB.MONTH_11_AMOUNT) AS MONTH_11_AMOUNT,
            SUM(PBB.MONTH_12_AMOUNT) AS MONTH_12_AMOUNT,
            SUM(PBB.TOTAL_AMOUNT) AS TOTAL_AMOUNT
            FROM TMT_CRI W
            JOIN PROJECT_BUDGET_BREAKDOWN PBB ON PBB.PROJECT_ID = W.PROJECT_ID
            AND PBB.ELEMENT_ID = W.ELEMENT_ID
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            JOIN BUDGETS B ON B.PROJECT_ID = PBB.PROJECT_ID
            AND B.CHARGECODE_ID = PBB.CHARGECODE_ID AND B.ELEMENT_ID = PBB.ELEMENT_ID
            LEFT JOIN BUDGETS AB ON AB.PROJECT_ID = B.PROJECT_ID
            AND AB.ELEMENT_ID = B.ELEMENT_ID AND AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
            WHERE W.PROJECT_ID = h_project_id
            AND W.RANK LIKE h_rank || '%'
            AND (W.ELEMENT_ID = h_element_id OR W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK))
            AND PBB.BUDGET_YEAR = p_budget_year
            GROUP BY CC.ELEMENT_ID, CC.ELEMENT_NAME, PBB.BUDGET_TYPE, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, B.CAPITAL_EXPENSE, B.BILLABLE,
            B.AUTO_FLAG, AB.CAPITAL_EXPENSE, CC.RANK
            UNION ALL
            SELECT
            (PBB.ELEMENT_ID || CC.ELEMENT_ID || TO_CHAR(PBB.BUDGET_YEAR) || TO_CHAR(PBB.BUDGET_TYPE))
            AS ELEMENT_ID, CC.ELEMENT_ID AS ORIGINAL_ID,
            CC.ELEMENT_NAME, PBB.BUDGET_TYPE AS TYPE_ID, PBB.PROJECT_ID,
            PBB.BUDGET_YEAR, PBB.CHARGECODE_ID, CC.CAPITAL_EXPENSE,
            CC.BILLABLE, CC.ELEMENT_NAME AS CHARGECODE_NAME,
            PBB.ELEMENT_ID AS ASSOCIATE_ID,
            PMO_CNST.SC_EXPENSE AS ASSOCIATE_CAPITAL_EXPENSE,
            PMO_CNST.SC_AUTO_REV_NONE AS AUTO_FLAG,
            PBB.MONTH_01_AMOUNT,
            PBB.MONTH_02_AMOUNT,PBB.MONTH_03_AMOUNT,
            PBB.MONTH_04_AMOUNT,PBB.MONTH_05_AMOUNT,
            PBB.MONTH_06_AMOUNT,PBB.MONTH_07_AMOUNT,
            PBB.MONTH_08_AMOUNT,PBB.MONTH_09_AMOUNT,
            PBB.MONTH_10_AMOUNT,PBB.MONTH_11_AMOUNT,
            PBB.MONTH_12_AMOUNT,PBB.TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN PBB
            JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
            WHERE PBB.PROJECT_ID = h_project_id
            AND PBB.PROJECT_ID = PBB.ELEMENT_ID
            AND PBB.BUDGET_YEAR = p_budget_year
            AND CC.CAPITAL_EXPENSE = PMO_CNST.SC_TIMEPHASE_CALENDAR;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PBB', 457+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_S_PBB(458) : timephase.sql(813) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN C_DBB_CRI;
         End If;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 468+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(469) : timephase.sql(824) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PBB', 480+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PBB(481) : timephase.sql(836) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PBB;
ALTER FUNCTION SP_S_PBB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PBB_PIVOT ==
CREATE OR REPLACE FUNCTION SP_PBB_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_chargecode_id VARCHAR2(32);
   h_chargecode_name VARCHAR2(100);
   h_id VARCHAR2(32);
   h_ids VARCHAR2(4000);
   h_project_id VARCHAR2(32);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_month_01_amount NUMBER := 0;
   h_month_02_amount NUMBER := 0;
   h_month_03_amount NUMBER := 0;
   h_month_04_amount NUMBER := 0;
   h_month_05_amount NUMBER := 0;
   h_month_06_amount NUMBER := 0;
   h_month_07_amount NUMBER := 0;
   h_month_08_amount NUMBER := 0;
   h_month_09_amount NUMBER := 0;
   h_month_10_amount NUMBER := 0;
   h_month_11_amount NUMBER := 0;
   h_month_12_amount NUMBER := 0;
   h_budget_year PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PBB1 IS
         SELECT ELEMENT_ID, RANK
         FROM PMO_PBB_PORTFOLIOS
         ORDER BY RANK;

      CURSOR C_PBB2 IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_PBB_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR C_PBB_INSERT IS
         SELECT
         PBB.ELEMENT_ID,
         PPP.ELEMENT_NAME,
         PPP.RANK,
         PBB.CHARGECODE_ID,
         CC.CAPITAL_EXPENSE,
         CC.ELEMENT_NAME,
         BUDGET_YEAR,
         MONTH_01_AMOUNT,
         MONTH_02_AMOUNT,
         MONTH_03_AMOUNT,
         MONTH_04_AMOUNT,
         MONTH_05_AMOUNT,
         MONTH_06_AMOUNT,
         MONTH_07_AMOUNT,
         MONTH_08_AMOUNT,
         MONTH_09_AMOUNT,
         MONTH_10_AMOUNT,
         MONTH_11_AMOUNT,
         MONTH_12_AMOUNT
         FROM PROJECT_BUDGET_BREAKDOWN PBB
         JOIN PMO_PBB_PROJECTS PPP
         ON PPP.ELEMENT_ID = PBB.PROJECT_ID
         JOIN TMT_CHARGECODES CC
         ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
         ORDER BY PPP.RANK, PBB.BUDGET_YEAR, CC.CAPITAL_EXPENSE, CC.ELEMENT_NAME;

      -- Resultset Cursor Declaration
      C_PBB_PIVOT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PBB_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PBB_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_PBB_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 84+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PBB_PIVOT(85) : timephase.sql(937) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_ids IS NULL) OR (p_type IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PBB_PIVOT', 89+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PBB_PIVOT(90) : timephase.sql(942) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 92+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(93) : timephase.sql(945) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   h_type := p_type;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_TMP_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PBB_PIVOT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --PROJECT
   If (Coalesce(h_type, 0) = 1) OR (Coalesce(h_type, 0) = 3) Then
      --PORTFOLIO Type
      h_total := 0;
      h_ids := p_ids;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PBB_PIVOT', 130+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PBB_PIVOT(131) : timephase.sql(983) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 133+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(134) : timephase.sql(986) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);       //   strnpcpy(h_id, sizeof(h_id), h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                       //   h_id[32] = '\0';
         h_id := PMO_STPU.strnpcpy(32, 32, Coalesce(h_count, 0) * 32+1, h_ids);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_PORTFOLIOS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(155) : timephase.sql(1007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_PBB_PORTFOLIOS( ELEMENT_ID, RANK )
            SELECT ELEMENT_ID, RTRIM(RANK)
            FROM TMT_PORTFOLIOS
            WHERE RANK LIKE h_rank || '%'
            AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(176) : timephase.sql(1028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
      
      OPEN C_PBB1;
      
      LOOP
         FETCH C_PBB1 INTO h_c_id, h_c_rank;
         IF C_PBB1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_PBB_TMP_PROJECTS( ELEMENT_ID, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.RANK)
            FROM TMT_PORTFOLIOS P
            JOIN TMT_WBS W
            ON W.ELEMENT_ID = P.ELEMENT_ID
            WHERE P.RANK LIKE h_c_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(214) : timephase.sql(1066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_PBB1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 227+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(228) : timephase.sql(1080) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_PBB2;
      
      LOOP
         FETCH C_PBB2 INTO h_c_id, h_c_rank;
         IF C_PBB2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            INSERT INTO PMO_PBB_PROJECTS( ELEMENT_ID, ELEMENT_NAME, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME), RTRIM(W.RANK)
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_c_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 261+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(262) : timephase.sql(1114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_PBB2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 275+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(276) : timephase.sql(1128) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (Coalesce(h_type, 0) = 2) OR (Coalesce(h_type, 0) = 4) Then
      --PROJECT Type
      h_total := 0;
      h_ids := p_ids;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PBB_PIVOT', 286+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PBB_PIVOT(287) : timephase.sql(1139) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 289+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(290) : timephase.sql(1142) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);   //   strnpcpy(h_id, sizeof(h_id), h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                   //   h_id[32] = '\0';
         h_id := PMO_STPU.strnpcpy(32, 32, Coalesce(h_count, 0) * 32+1, h_ids);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(311) : timephase.sql(1163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_PBB_PROJECTS( ELEMENT_ID, ELEMENT_NAME, RANK )
            SELECT W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME), RTRIM(W.RANK)
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 331+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(332) : timephase.sql(1184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   OPEN C_PBB_INSERT;
   
   LOOP
      FETCH C_PBB_INSERT INTO
      h_project_id,
      h_project_name,
      h_project_rank,
      h_chargecode_id,
      h_capital_expense,
      h_chargecode_name,
      h_budget_year,
      h_month_01_amount,
      h_month_02_amount,
      h_month_03_amount,
      h_month_04_amount,
      h_month_05_amount,
      h_month_06_amount,
      h_month_07_amount,
      h_month_08_amount,
      h_month_09_amount,
      h_month_10_amount,
      h_month_11_amount,
      h_month_12_amount;
      IF C_PBB_INSERT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 1, h_month_01_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(385) : timephase.sql(1237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 2, h_month_02_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 402+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(403) : timephase.sql(1255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 3, h_month_03_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 420+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(421) : timephase.sql(1273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 4, h_month_04_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 438+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(439) : timephase.sql(1291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 5, h_month_05_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 456+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(457) : timephase.sql(1309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 6, h_month_06_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 474+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(475) : timephase.sql(1327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 7, h_month_07_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 492+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(493) : timephase.sql(1345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 8, h_month_08_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 510+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(511) : timephase.sql(1363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 9, h_month_09_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 528+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(529) : timephase.sql(1381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 10, h_month_10_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 546+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(547) : timephase.sql(1399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 11, h_month_11_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 564+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(565) : timephase.sql(1417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PBB_PIVOT (PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT )
         VALUES (h_project_rank, h_project_id, h_project_name, h_chargecode_id, h_capital_expense, h_chargecode_name, h_budget_year, 12, h_month_12_amount);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 582+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(583) : timephase.sql(1435) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_PBB_INSERT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 596+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(597) : timephase.sql(1449) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_PBB_PIVOT FOR SELECT PROJECT_RANK, PROJECT_ID, PROJECT_NAME, CHAGECODE_ID, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH, BUDGET_AMOUNT
   FROM PMO_PBB_PIVOT
   ORDER BY PROJECT_RANK, CHAGECODE_NAME, CAPITAL_EXPENSE, CHAGECODE_NAME, BUDGET_YEAR, BUDGET_MONTH;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PBB_PIVOT', 605+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PBB_PIVOT(606) : timephase.sql(1458) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_PBB_PIVOT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 613+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(614) : timephase.sql(1466) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PBB_PIVOT', 625+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PBB_PIVOT(626) : timephase.sql(1478) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PBB_PIVOT;
ALTER FUNCTION SP_PBB_PIVOT COMPILE DEBUG;

-- {{ Vladimir Schneider, September 21, 2004

-- DELTA:

-- This function is gone, use the GET_FISCAL_DATE macro, which also handles no data

-- condition which requires the involvement of a DBA

-- BOOL_RETURN_CODE FC_FISCAL_DATE

-- }} Vladimir Schneider, September 21, 2004

/*************************************************************************************************
Timephase the amount budget (h_eac) between h_SD and h_FD
    insert in session.PMO_NEW_TIMEPHASE one row per fiscal year
**************************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_AMOUNT ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_AMOUNT
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_total_amount NUMBER
   , h_period_start IN OUT NOCOPY DATE
   , h_period_finish IN OUT NOCOPY DATE
   , sh_h_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_total_amount NUMBER := sh_h_total_amount;
   h_type PLS_INTEGER := sh_h_type;
   h_SD DATE;
   h_FD DATE;
   h_count PLS_INTEGER := 0;
   h_bac NUMBER := 0;
   h_last_year PLS_INTEGER := 0;
   h_last_month PLS_INTEGER := 0;
   h_total_amount_new NUMBER := 0;
   h_total_amount_old NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_AMOUNT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_AMOUNT'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_AMOUNT(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_total_amount), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_period_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_period_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_AMOUNT', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_AMOUNT(35) : timephase.sql(1544) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_total_amount IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_AMOUNT', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_AMOUNT(40) : timephase.sql(1549) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN -1;
   End If;
   
   BEGIN
      SELECT START_DATE INTO h_SD
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_start AND FINISH_DATE >= h_period_start;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(55) : timephase.sql(1564) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT START_DATE, FISCAL_YEAR, FISCAL_MONTH
      INTO h_FD, h_last_year, h_last_month
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_finish AND FINISH_DATE >= h_period_finish;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(71) : timephase.sql(1580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.DAYS(h_period_finish) - PMO_ORASTD.DAYS(h_period_start) + 1 INTO h_count
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(85) : timephase.sql(1594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_bac := Coalesce(h_total_amount, 0) / Coalesce(h_count, 0);
   
   --trace_printf("h_bac: %.2f, h_total_amount: %.2f, h_count: %d\n",h_bac,h_total_amount,h_count);
   BEGIN
      INSERT INTO PMO_NEW_TIMEPHASE ( ELEMENT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_element_id, h_project_id, h_chargecode_id, h_type, FISCAL_YEAR,
      (PMO_ORASTD.DAYS(CASE WHEN MAX(FINISH_DATE) >= h_period_finish THEN h_period_finish ELSE MAX(FINISH_DATE) END) -
      PMO_ORASTD.DAYS(CASE WHEN MIN(START_DATE) <= h_period_start THEN h_period_start ELSE MIN(START_DATE) END) + 1) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 1 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 2 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 3 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 4 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 5 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 6 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 7 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 8 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 9 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 10 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 11 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
      SUM(CASE WHEN FISCAL_MONTH = 12 THEN
      (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
      PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac
      FROM FISCAL_CALENDAR
      WHERE START_DATE >= h_SD AND START_DATE <= h_FD
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 148+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(149) : timephase.sql(1658) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_project_id: %s, h_SD: %s, h_FD: %s\n",SC_STATE,h_project_id,h_SD, h_FD);
   
   BEGIN
      SELECT TOTAL_AMOUNT INTO h_total_amount_old
      FROM PMO_NEW_TIMEPHASE
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type
      AND BUDGET_YEAR = h_last_year;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(169) : timephase.sql(1678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_NEW_TIMEPHASE
      SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_total_amount - (SELECT SUM(TOTAL_AMOUNT)
      FROM PMO_NEW_TIMEPHASE
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type)
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type
      AND BUDGET_YEAR = h_last_year;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 196+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(197) : timephase.sql(1706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT TOTAL_AMOUNT INTO h_total_amount_new
      FROM PMO_NEW_TIMEPHASE
      WHERE ELEMENT_ID = h_element_id
      AND PROJECT_ID = h_project_id
      AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_type
      AND BUDGET_YEAR = h_last_year;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 215+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(216) : timephase.sql(1725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_total_amount_new: %.2f", h_total_amount_new);
   --trace_printf("h_total_amount_old: %.2f", h_total_amount_old);
   If Coalesce(h_total_amount_new, 0) <> Coalesce(h_total_amount_new, 0) Then
      If Coalesce(h_last_month, 0) = 1 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_01_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(243) : timephase.sql(1752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 2 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_02_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 265+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(266) : timephase.sql(1775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 3 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_03_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 288+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(289) : timephase.sql(1798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 4 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_04_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 311+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(312) : timephase.sql(1821) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 5 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_05_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 334+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(335) : timephase.sql(1844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 6 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_06_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 357+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(358) : timephase.sql(1867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 7 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_07_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 380+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(381) : timephase.sql(1890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 8 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_08_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 403+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(404) : timephase.sql(1913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 9 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_09_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 426+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(427) : timephase.sql(1936) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 10 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_10_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 449+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(450) : timephase.sql(1959) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 11 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_11_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 472+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(473) : timephase.sql(1982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_last_month, 0) = 12 Then
         BEGIN
            UPDATE PMO_NEW_TIMEPHASE
            SET MONTH_12_AMOUNT = MONTH_01_AMOUNT + h_total_amount_new - h_total_amount_old
            WHERE ELEMENT_ID = h_element_id
            AND PROJECT_ID = h_project_id
            AND CHARGECODE_ID = h_chargecode_id
            AND BUDGET_TYPE = h_type
            AND BUDGET_YEAR = h_last_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_AMOUNT', 495+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_AMOUNT(496) : timephase.sql(2005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_AMOUNT', 502+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_AMOUNT(503) : timephase.sql(2012) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_AMOUNT;
ALTER FUNCTION FC_TIMEPHASE_AMOUNT COMPILE DEBUG;

/******************************************************************************
  This function insert charge code delta amount to the TIMEPHASED_DELTA table
******************************************************************************/

Prompt == FUNCTION FC_I_TIMEPHASED_DELTA ==
CREATE OR REPLACE FUNCTION FC_I_TIMEPHASED_DELTA
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_budget_type PLS_INTEGER
   , sh_h_delta_amount NUMBER
   , h_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_budget_type PLS_INTEGER := sh_h_budget_type;
   h_delta_amount NUMBER := sh_h_delta_amount;
   h_year PLS_INTEGER := 1;
   h_month PLS_INTEGER := 1;
   h_update_sql VARCHAR2(2048);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_TIMEPHASED_DELTA') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_TIMEPHASED_DELTA'), '-- ' || SYSTIMESTAMP, ':r := FC_I_TIMEPHASED_DELTA(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_budget_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_delta_amount), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_TIMEPHASED_DELTA', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_TIMEPHASED_DELTA(28) : timephase.sql(2052) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      BEGIN
         SELECT FISCAL_YEAR, FISCAL_MONTH INTO h_year, h_month 
                 FROM FISCAL_CALENDAR WHERE h_date BETWEEN START_DATE AND FINISH_DATE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_TIMEPHASED_DELTA', 40+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_TIMEPHASED_DELTA(41) : timephase.sql(2065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_TIMEPHASED_DELTA', 46+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_TIMEPHASED_DELTA(47) : timephase.sql(2071) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_TIMEPHASED_DELTA', 49+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_TIMEPHASED_DELTA(50) : timephase.sql(2074) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR, h_date
               , False);
      End If;
   END;
   --trace_printf("h_date: %d:%s, h_year: %d, h_month: %d\n",h_date_Ind,h_date,h_year, h_month);
   
   h_update_sql := '';
   h_update_sql := 'INSERT INTO TIMEPHASED_DELTA (';
   h_update_sql := h_update_sql || 
                                'PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR, TOTAL_AMOUNT, ';
   
   If Coalesce(h_month, 0) = 1 Then
      h_update_sql := h_update_sql || 'MONTH_01_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 2 Then
      h_update_sql := h_update_sql || 'MONTH_02_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 3 Then
      h_update_sql := h_update_sql || 'MONTH_03_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 4 Then
      h_update_sql := h_update_sql || 'MONTH_04_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 5 Then
      h_update_sql := h_update_sql || 'MONTH_05_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 6 Then
      h_update_sql := h_update_sql || 'MONTH_06_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 7 Then
      h_update_sql := h_update_sql || 'MONTH_07_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 8 Then
      h_update_sql := h_update_sql || 'MONTH_08_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 9 Then
      h_update_sql := h_update_sql || 'MONTH_09_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 10 Then
      h_update_sql := h_update_sql || 'MONTH_10_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 11 Then
      h_update_sql := h_update_sql || 'MONTH_11_AMOUNT, ';
   ElsIf Coalesce(h_month, 0) = 12 Then
      h_update_sql := h_update_sql || 'MONTH_12_AMOUNT, ';
   End If;
   
   h_update_sql := h_update_sql || 'PROCESS_FLAG) VALUES (''';
   h_update_sql := h_update_sql || h_project_id;
   h_update_sql := h_update_sql || ''', ''';
   h_update_sql := h_update_sql || h_element_id;
   h_update_sql := h_update_sql || ''', ''';
   h_update_sql := h_update_sql || h_chargecode_id;
   h_update_sql := h_update_sql || ''', ';
   h_update_sql := h_update_sql || TO_CHAR(h_budget_type);
   h_update_sql := h_update_sql || ', ';
   h_update_sql := h_update_sql || TO_CHAR(h_year);
   h_update_sql := h_update_sql || ', ';
   h_update_sql := h_update_sql || TO_CHAR(h_delta_amount);
   h_update_sql := h_update_sql || 'e0, ';
   h_update_sql := h_update_sql || TO_CHAR(h_delta_amount);
   h_update_sql := h_update_sql || 'e0, ''I'') ';
   
   --trace_printf(h_update_sql); //trace_printf("\n"); //trace_flush();
   
   BEGIN
      EXECUTE IMMEDIATE h_update_sql;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_TIMEPHASED_DELTA', 118+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_TIMEPHASED_DELTA(119) : timephase.sql(2143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || h_update_sql);
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS SET 
      TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT),
      ROLLUP_BITS		= PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ACTUAL_BIT)
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_chargecode_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_TIMEPHASED_DELTA', 140+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_TIMEPHASED_DELTA(141) : timephase.sql(2165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_TIMEPHASED_DELTA', 146+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_TIMEPHASED_DELTA(147) : timephase.sql(2171) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_TIMEPHASED_DELTA;
ALTER FUNCTION FC_I_TIMEPHASED_DELTA COMPILE DEBUG;

/*************************************************************************************************
Timephase estimated_budget at project level when copy project
**************************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_ESTIMATED ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_ESTIMATED
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_chargecode_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_period_start DATE;
   h_period_finish DATE;
   h_type PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_total_amount NUMBER := 0;
   h_bac NUMBER := 0;
-- Declare Cursors
      CURSOR TP_ESTIMATED IS
         SELECT CHARGECODE_ID, ESTIMATED_BUDGET
         FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_project_id
         AND ESTIMATED_BUDGET > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_ESTIMATED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_ESTIMATED'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_ESTIMATED(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_ESTIMATED(30) : timephase.sql(2213) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT START_FINISH_DATE, FINISH_START_DATE
      INTO h_period_start, h_period_finish
      FROM TMT_WBS
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(45) : timephase.sql(2228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_ESTIMATED(52) : timephase.sql(2235) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_period_start IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 58+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_ESTIMATED(59) : timephase.sql(2242) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If (h_period_finish IS NULL) Then
      h_period_finish := h_period_start;
   End If;
   
   h_type := PMO_CNST.SC_ESTIMATED_BUDGET;
   BEGIN
      SELECT START_DATE INTO h_SD
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_start AND FINISH_DATE >= h_period_start;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(79) : timephase.sql(2262) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT START_DATE INTO h_FD
      FROM FISCAL_CALENDAR
      WHERE START_DATE <= h_period_finish AND FINISH_DATE >= h_period_finish;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(94) : timephase.sql(2277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.DAYS(h_period_finish) - PMO_ORASTD.DAYS(h_period_start) + 1 INTO h_count
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(108) : timephase.sql(2291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN TP_ESTIMATED;
   
   LOOP
      FETCH TP_ESTIMATED INTO h_chargecode_id, h_total_amount;
      IF TP_ESTIMATED%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_bac := Coalesce(h_total_amount, 0) / Coalesce(h_count, 0);
      
      --trace_printf("h_bac: %.2f, h_total_amount: %.2f, h_count: %d\n",h_bac,h_total_amount,h_count);
      BEGIN
         INSERT INTO PROJECT_BUDGET_BREAKDOWN (ELEMENT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_TYPE, BUDGET_YEAR, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_project_id, h_chargecode_id, h_type, FISCAL_YEAR,
         (PMO_ORASTD.DAYS(CASE WHEN MAX(FINISH_DATE) >= h_period_finish THEN h_period_finish ELSE MAX(FINISH_DATE) END) -
         PMO_ORASTD.DAYS(CASE WHEN MIN(START_DATE) <= h_period_start THEN h_period_start ELSE MIN(START_DATE) END) + 1) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 1 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 2 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 3 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 4 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 5 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 6 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 7 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 8 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 9 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 10 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 11 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac,
         SUM(CASE WHEN FISCAL_MONTH = 12 THEN
         (PMO_ORASTD.DAYS(CASE WHEN FINISH_DATE >= h_period_finish THEN h_period_finish ELSE FINISH_DATE END) -
         PMO_ORASTD.DAYS(CASE WHEN START_DATE <= h_period_start THEN h_period_start ELSE START_DATE END) + 1) ELSE 0 END) * h_bac
         FROM FISCAL_CALENDAR
         WHERE START_DATE >= h_SD AND START_DATE <= h_FD
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 184+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(185) : timephase.sql(2368) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   BEGIN
      CLOSE TP_ESTIMATED ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_ESTIMATED', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_ESTIMATED(198) : timephase.sql(2381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_ESTIMATED', 203+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_ESTIMATED(204) : timephase.sql(2387) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_ESTIMATED;
ALTER FUNCTION FC_TIMEPHASE_ESTIMATED COMPILE DEBUG;

/*******************************************************************************
Create timephase delta for labor related actual
h_update_bits:
    0:  create positive delta;
    -1: create negative delta
********************************************************************************/

Prompt == FUNCTION FC_TPHASE_ACTUAL_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_TPHASE_ACTUAL_ASSIGN
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_start_DT IN OUT NOCOPY TIMESTAMP
   , h_finish_DT IN OUT NOCOPY TIMESTAMP
   , sh_h_update_bits PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_billable PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_update_bits PLS_INTEGER := sh_h_update_bits;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_billable PLS_INTEGER := sh_h_billable;
   h_new_chargecode_hours VARCHAR2(32);
   h_new_chargecode_labor VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_labor_cost_cc_id VARCHAR2(32);
   h_labor_revenue_cc_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TPHASE_ACTUAL_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TPHASE_ACTUAL_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_TPHASE_ACTUAL_ASSIGN(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_update_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_billable), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_ACTUAL_ASSIGN', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TPHASE_ACTUAL_ASSIGN(35) : timephase.sql(2437) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TPHASE_ACTUAL';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID
      INTO h_labor_cost_cc_id, h_labor_revenue_cc_id
      FROM TASK_ASSIGNMENTS
      WHERE PROJECT_ID = h_project_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(54) : timephase.sql(2456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_ACTUAL_ASSIGN', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_ACTUAL_ASSIGN(61) : timephase.sql(2463) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If ((h_start_DT IS NOT NULL)) AND ((h_finish_DT IS NOT NULL)) Then
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10)) AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10))
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10)) AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(101) : timephase.sql(2503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_start_DT IS NOT NULL) Then
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10))
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0
         AND T.WEEK_OF >= TO_DATE(SubStr(h_start_DT, 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 139+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(140) : timephase.sql(2542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf (h_finish_DT IS NOT NULL) Then
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10))
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0
         AND T.WEEK_OF <= TO_DATE(SubStr(h_finish_DT, 1, 10)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 178+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(179) : timephase.sql(2581) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_TMP_TPHASE_ACTUAL
         (SELECT F1.FISCAL_YEAR, F1.FISCAL_MONTH,
         T.MONTH1_REGULAR_HRS, T.MONTH1_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F1
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F1.START_DATE <= T.WEEK_OF AND F1.FINISH_DATE >= T.WEEK_OF
         AND T.MONTH1_REGULAR_HRS > 0
         UNION ALL
         SELECT F2.FISCAL_YEAR, F2.FISCAL_MONTH,
         T.MONTH2_REGULAR_HRS, T.MONTH2_SPECIAL_HRS,
         T.ACTUAL_REGULAR_COST, T.ACTUAL_SPECIAL_COST,
         T.ACTUAL_REGULAR_RATE, T.ACTUAL_SPECIAL_RATE
         FROM SUMMARY_TIMESHEETS T, FISCAL_CALENDAR F2
         WHERE T.PROJECT_ID = h_project_id
         AND T.TSK_ASSIGNMENT_ID = h_tsk_assignment_id
         AND F2.START_DATE <= (T.WEEK_OF + 6     )
         AND F2.FINISH_DATE >= (T.WEEK_OF + 6     )
         AND T.MONTH2_REGULAR_HRS > 0);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 215+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(216) : timephase.sql(2618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      SELECT CAPITAL_EXPENSE INTO h_capital_expense
      FROM TMT_CHARGECODES
      WHERE ELEMENT_ID = h_labor_cost_cc_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 231+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(232) : timephase.sql(2634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR Then
      h_new_chargecode_hours := 'EXPENSE_HOURS';
      --      InitializeHost(SC_PARAM(h_new_chargecode_labor), "EXPENSE_LABOR");
   Else
      h_new_chargecode_hours := 'CAPITAL_HOURS';
      --      InitializeHost(SC_PARAM(h_new_chargecode_labor), "CAPITAL_LABOR");
   End If;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_new_chargecode_hours, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
      (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 274+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(275) : timephase.sql(2677) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_new_chargecode_hours, FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 309+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(310) : timephase.sql(2712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_labor_cost_cc_id, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
      (-1) * SUM(REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) / 60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 344+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(345) : timephase.sql(2747) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, h_element_id, h_labor_cost_cc_id, FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      (-1) * SUM(REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) / 60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00,
      (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_COST + SPECIAL_HOURS * SPECIAL_COST) ELSE 0 END)/60.00
      FROM PMO_TMP_TPHASE_ACTUAL
      GROUP BY FISCAL_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 379+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(380) : timephase.sql(2782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_new_chargecode_hours;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 399+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(400) : timephase.sql(2802) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE BUDGETS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_labor_cost_cc_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 419+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(420) : timephase.sql(2822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_labor_revenue_cc_id IS NOT NULL) Then
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, 'BENEFIT_HOURS', FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 455+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(456) : timephase.sql(2858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, 'BENEFIT_HOURS', FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
         (-1) * SUM(REGULAR_HOURS + SPECIAL_HOURS)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN REGULAR_HOURS + SPECIAL_HOURS ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 490+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(491) : timephase.sql(2893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, h_labor_revenue_cc_id, FISCAL_YEAR, PMO_CNST.SC_ACTUAL_BUDGET,
         (-1) * SUM(REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) / 60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 525+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(526) : timephase.sql(2928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TIMEPHASED_DELTA (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
         MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
         SELECT h_project_id, h_element_id, h_labor_revenue_cc_id, FISCAL_YEAR, PMO_CNST.SC_SCHED_BUDGET,
         (-1) * SUM(REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) / 60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 1 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 2 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 3 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 4 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 5 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 6 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 7 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 8 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 9 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 10 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 11 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00,
         (-1) * SUM(CASE WHEN FISCAL_MONTH = 12 THEN (REGULAR_HOURS * REGULAR_RATE + SPECIAL_HOURS * SPECIAL_RATE) ELSE 0 END)/60.00
         FROM PMO_TMP_TPHASE_ACTUAL
         GROUP BY FISCAL_YEAR;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 560+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(561) : timephase.sql(2963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 580+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(581) : timephase.sql(2983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE BUDGETS
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_labor_revenue_cc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 600+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(601) : timephase.sql(3003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TMT_WBS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_ACTUAL_DELTA_BIT)
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_ACTUAL_ASSIGN', 620+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_ACTUAL_ASSIGN(621) : timephase.sql(3023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_ACTUAL_ASSIGN', 626+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_ACTUAL_ASSIGN(627) : timephase.sql(3029) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TPHASE_ACTUAL_ASSIGN;
ALTER FUNCTION FC_TPHASE_ACTUAL_ASSIGN COMPILE DEBUG;

-- BEGIN TIMEPHASE

/*****************************************************************************************/

-- Update task timephase based on the delta_timephase records and new timephase records

-- Generate project delta_timephase records

/*****************************************************************************************/

Prompt == FUNCTION FC_Update_Timephase ==
CREATE OR REPLACE FUNCTION FC_Update_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_chargecode_id VARCHAR2(32);
   h_budget_year PLS_INTEGER := 0;
   h_budget_type PLS_INTEGER := 0;
   h_project_id_actual VARCHAR2(32);
   h_id_actual VARCHAR2(32);
   h_chargecode_id_actual VARCHAR2(32);
   h_budget_year_actual PLS_INTEGER := 0;
   h_month_01_actual NUMBER := 0;
   h_month_02_actual NUMBER := 0;
   h_month_03_actual NUMBER := 0;
   h_month_04_actual NUMBER := 0;
   h_month_05_actual NUMBER := 0;
   h_month_06_actual NUMBER := 0;
   h_month_07_actual NUMBER := 0;
   h_month_08_actual NUMBER := 0;
   h_month_09_actual NUMBER := 0;
   h_month_10_actual NUMBER := 0;
   h_month_11_actual NUMBER := 0;
   h_month_12_actual NUMBER := 0;
   h_total_amount_actual NUMBER := 0;
   h_month_01_old NUMBER := 0;
   h_month_02_old NUMBER := 0;
   h_month_03_old NUMBER := 0;
   h_month_04_old NUMBER := 0;
   h_month_05_old NUMBER := 0;
   h_month_06_old NUMBER := 0;
   h_month_07_old NUMBER := 0;
   h_month_08_old NUMBER := 0;
   h_month_09_old NUMBER := 0;
   h_month_10_old NUMBER := 0;
   h_month_11_old NUMBER := 0;
   h_month_12_old NUMBER := 0;
   h_total_amount_old NUMBER := 0;
   h_count_old PLS_INTEGER := 0;
   h_month_01_new NUMBER := 0;
   h_month_02_new NUMBER := 0;
   h_month_03_new NUMBER := 0;
   h_month_04_new NUMBER := 0;
   h_month_05_new NUMBER := 0;
   h_month_06_new NUMBER := 0;
   h_month_07_new NUMBER := 0;
   h_month_08_new NUMBER := 0;
   h_month_09_new NUMBER := 0;
   h_month_10_new NUMBER := 0;
   h_month_11_new NUMBER := 0;
   h_month_12_new NUMBER := 0;
   h_total_amount_new NUMBER := 0;
   h_count_new PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TASK_TP IS
         SELECT DISTINCT CTP.CHARGECODE_ID, CTP.BUDGET_YEAR, CTP.BUDGET_TYPE, CC.CAPITAL_EXPENSE
         FROM PMO_CHANGED_TIMEPHASE CTP, TMT_CHARGECODES CC
         WHERE CTP.PROJECT_ID = h_project_id AND CTP.ELEMENT_ID = h_id
         AND CC.ELEMENT_ID = CTP.CHARGECODE_ID
         ORDER BY CTP.CHARGECODE_ID, CTP.BUDGET_YEAR, CTP.BUDGET_TYPE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Update_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Update_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_Update_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Update_Timephase', 71+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Update_Timephase(72) : timephase.sql(3119) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id_actual := '';
   
   --trace_printf("h_element_id_id: %d;%s\n", h_id_Ind, h_id);
   -- merge PMO_NEW_TIMEPHASE and PMO_DELTA_TIMEPHASE tables
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT * FROM PMO_NEW_TIMEPHASE
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(93) : timephase.sql(3140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add change timephase
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      SELECT DISTINCT PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID
      FROM PMO_DELTA_TIMEPHASE
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(114) : timephase.sql(3161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add all actual timephase if the sched timephase changed
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT PBB.PROJECT_ID, PBB.ELEMENT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE, PBB.CHARGECODE_ID
      FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_CHANGED_TIMEPHASE C, TMT_CHARGECODES CC
      WHERE PBB.PROJECT_ID = h_project_id AND PBB.ELEMENT_ID = h_id
      AND C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.CHARGECODE_ID = PBB.CHARGECODE_ID AND C.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND C.CHARGECODE_ID = CC.ELEMENT_ID
      AND CC.CAPITAL_EXPENSE < PMO_CNST.SC_TIMEPHASE_CALENDAR
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND NOT EXISTS(SELECT CC.ELEMENT_ID FROM PMO_CHANGED_TIMEPHASE CC
      WHERE CC.PROJECT_ID = h_project_id AND CC.ELEMENT_ID = h_id
      AND CC.CHARGECODE_ID = C.CHARGECODE_ID AND CC.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 142+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(143) : timephase.sql(3190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add all sched timephase if the actual timephase changed
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT PBB.PROJECT_ID, PBB.ELEMENT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE, PBB.CHARGECODE_ID
      FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_CHANGED_TIMEPHASE C, TMT_CHARGECODES CC
      WHERE PBB.PROJECT_ID = h_project_id AND PBB.ELEMENT_ID = h_id
      AND C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.CHARGECODE_ID = PBB.CHARGECODE_ID AND C.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND C.CHARGECODE_ID = CC.ELEMENT_ID
      AND CC.CAPITAL_EXPENSE < PMO_CNST.SC_TIMEPHASE_CALENDAR
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND NOT EXISTS(SELECT CC.ELEMENT_ID FROM PMO_CHANGED_TIMEPHASE CC
      WHERE CC.PROJECT_ID = h_project_id AND CC.ELEMENT_ID = h_id
      AND CC.CHARGECODE_ID = C.CHARGECODE_ID AND CC.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 171+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(172) : timephase.sql(3219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add all years of the changed timephase
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT PBB.PROJECT_ID, PBB.ELEMENT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE, PBB.CHARGECODE_ID
      FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_CHANGED_TIMEPHASE C, TMT_CHARGECODES CC
      WHERE PBB.PROJECT_ID = h_project_id AND PBB.ELEMENT_ID = h_id
      AND C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.CHARGECODE_ID = PBB.CHARGECODE_ID AND C.BUDGET_TYPE = PBB.BUDGET_TYPE
      AND C.CHARGECODE_ID = CC.ELEMENT_ID
      AND CC.CAPITAL_EXPENSE < PMO_CNST.SC_TIMEPHASE_CALENDAR
      AND C.BUDGET_YEAR <> PBB.BUDGET_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(198) : timephase.sql(3245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- add sched if actual timephase changed
   BEGIN
      INSERT INTO PMO_CHANGED_TIMEPHASE
      (SELECT C.PROJECT_ID, C.ELEMENT_ID, C.BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET, C.CHARGECODE_ID
      FROM PMO_CHANGED_TIMEPHASE C
      WHERE C.PROJECT_ID = h_project_id AND C.ELEMENT_ID = h_id
      AND C.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND NOT EXISTS(SELECT D.PROJECT_ID FROM PMO_CHANGED_TIMEPHASE D
      WHERE D.PROJECT_ID = C.PROJECT_ID AND D.ELEMENT_ID = C.ELEMENT_ID
      AND D.CHARGECODE_ID = C.CHARGECODE_ID AND D.BUDGET_YEAR = C.BUDGET_YEAR
      AND D.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 223+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(224) : timephase.sql(3271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TASK_TP;
   
   LOOP
      FETCH C_TASK_TP INTO h_chargecode_id, h_budget_year,
      h_budget_type, h_capital_expense;
      IF C_TASK_TP%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      --trace_printf("h_element_id_id: %d;%s\n", h_id_Ind, h_id);
      --trace_printf("h_chargecode_id: %d;%s\n", h_chargecode_id_Ind, h_chargecode_id);
      --trace_printf("h_budget_year: %d;%d\n", h_budget_year_Ind, h_budget_year);
      --trace_printf("h_budget_type: %d;%d\n", h_budget_type_Ind, h_budget_type);
      
      --trace_printf("Actual project_id00: %d;%s\n", h_project_id_actual_Ind, h_project_id_actual);
      If (PMO_ORASTD.strcmp(h_project_id, h_project_id_actual) <> PMO_CNST.SC_MATCH) 
            OR (PMO_ORASTD.strcmp(h_id, h_id_actual) <> PMO_CNST.SC_MATCH) OR (PMO_ORASTD.strcmp(
            h_chargecode_id, h_chargecode_id_actual) <> PMO_CNST.SC_MATCH) OR (Coalesce(
            h_budget_year, 0) <> Coalesce(h_budget_year_actual, 0)) Then
         --trace_printf("Actual project_id11: %d;%s\n", h_project_id_actual_Ind, h_project_id_actual);
         h_month_01_actual := 0.00;
         h_month_02_actual := 0.00;
         h_month_03_actual := 0.00;
         h_month_04_actual := 0.00;
         h_month_05_actual := 0.00;
         h_month_06_actual := 0.00;
         h_month_07_actual := 0.00;
         h_month_08_actual := 0.00;
         h_month_09_actual := 0.00;
         h_month_10_actual := 0.00;
         h_month_11_actual := 0.00;
         h_month_12_actual := 0.00;
      End If;
      
      h_month_01_old := 0.00;
      h_month_02_old := 0.00;
      h_month_03_old := 0.00;
      h_month_04_old := 0.00;
      h_month_05_old := 0.00;
      h_month_06_old := 0.00;
      h_month_07_old := 0.00;
      h_month_08_old := 0.00;
      h_month_09_old := 0.00;
      h_month_10_old := 0.00;
      h_month_11_old := 0.00;
      h_month_12_old := 0.00;
      
      -- read old actual timephase
      BEGIN
         SELECT SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT),
         SUM(MONTH_04_AMOUNT), SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT),
         SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT), SUM(MONTH_09_AMOUNT),
         SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT),
         SUM(TOTAL_AMOUNT), COUNT(*)
         INTO h_month_01_old, h_month_02_old, h_month_03_old,
         h_month_04_old, h_month_05_old, h_month_06_old,
         h_month_07_old, h_month_08_old, h_month_09_old,
         h_month_10_old, h_month_11_old, h_month_12_old,
         h_total_amount_old, h_count_old
         FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID = h_chargecode_id AND BUDGET_YEAR = h_budget_year
         AND BUDGET_TYPE = h_budget_type;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 303+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(304) : timephase.sql(3351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("h_count_old: %d;%d\n", h_count_old_Ind, h_count_old);
      
      -- read delta timephase
      --trace_printf("Read Delta\n");
      BEGIN
         SELECT SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT),
         SUM(MONTH_04_AMOUNT), SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT),
         SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT), SUM(MONTH_09_AMOUNT),
         SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT),
         SUM(TOTAL_AMOUNT), COUNT(*)
         INTO h_month_01_new, h_month_02_new, h_month_03_new,
         h_month_04_new, h_month_05_new, h_month_06_new,
         h_month_07_new, h_month_08_new, h_month_09_new,
         h_month_10_new, h_month_11_new, h_month_12_new,
         h_total_amount_new, h_count_new
         FROM PMO_DELTA_TIMEPHASE
         WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
         AND CHARGECODE_ID = h_chargecode_id AND BUDGET_YEAR = h_budget_year
         AND BUDGET_TYPE = h_budget_type;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 332+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(333) : timephase.sql(3380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count_new, 0) > 0 Then
         --trace_printf("Exists Delta\n");
         If PMO_ORASTD.strcmp(h_project_id, h_id) <> PMO_CNST.SC_MATCH Then
            --trace_printf("Insert Project Delta\n");
            BEGIN
               INSERT INTO PMO_DELTA_TIMEPHASE (
               ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
               MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
               MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               VALUES (
               h_project_id, h_project_id, h_budget_year,
               h_budget_type, h_chargecode_id,
               h_month_01_new,
               h_month_02_new,
               h_month_03_new,
               h_month_04_new,
               h_month_05_new,
               h_month_06_new,
               h_month_07_new,
               h_month_08_new,
               h_month_09_new,
               h_month_10_new,
               h_month_11_new,
               h_month_12_new,
               h_total_amount_new);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 374+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(375) : timephase.sql(3422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_count_old, 0) > 0 Then
            --trace_printf("Exists Actual Timephase\n");
            If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                  , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                  , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                  , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                  h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
               BEGIN
                  UPDATE PROJECT_BUDGET_BREAKDOWN
                  SET MONTH_01_AMOUNT = MONTH_01_AMOUNT + h_month_01_new + h_month_01_actual,
                  MONTH_02_AMOUNT = MONTH_02_AMOUNT + h_month_02_new + h_month_02_actual,
                  MONTH_03_AMOUNT = MONTH_03_AMOUNT + h_month_03_new + h_month_03_actual,
                  MONTH_04_AMOUNT = MONTH_04_AMOUNT + h_month_04_new + h_month_04_actual,
                  MONTH_05_AMOUNT = MONTH_05_AMOUNT + h_month_05_new + h_month_05_actual,
                  MONTH_06_AMOUNT = MONTH_06_AMOUNT + h_month_06_new + h_month_06_actual,
                  MONTH_07_AMOUNT = MONTH_07_AMOUNT + h_month_07_new + h_month_07_actual,
                  MONTH_08_AMOUNT = MONTH_08_AMOUNT + h_month_08_new + h_month_08_actual,
                  MONTH_09_AMOUNT = MONTH_09_AMOUNT + h_month_09_new + h_month_09_actual,
                  MONTH_10_AMOUNT = MONTH_10_AMOUNT + h_month_10_new + h_month_10_actual,
                  MONTH_11_AMOUNT = MONTH_11_AMOUNT + h_month_11_new + h_month_11_actual,
                  MONTH_12_AMOUNT = MONTH_12_AMOUNT + h_month_12_new + h_month_12_actual,
                  TOTAL_AMOUNT = TOTAL_AMOUNT + h_total_amount_new + h_total_amount_actual
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_YEAR = h_budget_year
                  AND BUDGET_TYPE = h_budget_type;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 417+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(418) : timephase.sql(3465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE PROJECT_BUDGET_BREAKDOWN
                  SET MONTH_01_AMOUNT = MONTH_01_AMOUNT + h_month_01_new,
                  MONTH_02_AMOUNT = MONTH_02_AMOUNT + h_month_02_new,
                  MONTH_03_AMOUNT = MONTH_03_AMOUNT + h_month_03_new,
                  MONTH_04_AMOUNT = MONTH_04_AMOUNT + h_month_04_new,
                  MONTH_05_AMOUNT = MONTH_05_AMOUNT + h_month_05_new,
                  MONTH_06_AMOUNT = MONTH_06_AMOUNT + h_month_06_new,
                  MONTH_07_AMOUNT = MONTH_07_AMOUNT + h_month_07_new,
                  MONTH_08_AMOUNT = MONTH_08_AMOUNT + h_month_08_new,
                  MONTH_09_AMOUNT = MONTH_09_AMOUNT + h_month_09_new,
                  MONTH_10_AMOUNT = MONTH_10_AMOUNT + h_month_10_new,
                  MONTH_11_AMOUNT = MONTH_11_AMOUNT + h_month_11_new,
                  MONTH_12_AMOUNT = MONTH_12_AMOUNT + h_month_12_new,
                  TOTAL_AMOUNT = TOTAL_AMOUNT + h_total_amount_new
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id
                  AND BUDGET_YEAR = h_budget_year
                  AND BUDGET_TYPE = h_budget_type;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 452+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(453) : timephase.sql(3500) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
                  h_project_id_actual := h_project_id;
                  h_id_actual := h_id;
                  h_chargecode_id_actual := h_chargecode_id;
                  h_budget_year_actual := h_budget_year;
                  
                  If Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR Then
                     h_month_01_actual := 0.00;
                     h_month_02_actual := 0.00;
                     h_month_03_actual := 0.00;
                     h_month_04_actual := 0.00;
                     h_month_05_actual := 0.00;
                     h_month_06_actual := 0.00;
                     h_month_07_actual := 0.00;
                     h_month_08_actual := 0.00;
                     h_month_09_actual := 0.00;
                     h_month_10_actual := 0.00;
                     h_month_11_actual := 0.00;
                     h_month_12_actual := 0.00;
                     h_total_amount_actual := 0.00;
                  Else
                     If PMO_ORASTD.strcmp(h_project_id, h_id) = PMO_CNST.SC_MATCH Then
                        h_month_01_actual := Coalesce(h_month_01_new, 0);
                        h_month_02_actual := Coalesce(h_month_02_new, 0);
                        h_month_03_actual := Coalesce(h_month_03_new, 0);
                        h_month_04_actual := Coalesce(h_month_04_new, 0);
                        h_month_05_actual := Coalesce(h_month_05_new, 0);
                        h_month_06_actual := Coalesce(h_month_06_new, 0);
                        h_month_07_actual := Coalesce(h_month_07_new, 0);
                        h_month_08_actual := Coalesce(h_month_08_new, 0);
                        h_month_09_actual := Coalesce(h_month_09_new, 0);
                        h_month_10_actual := Coalesce(h_month_10_new, 0);
                        h_month_11_actual := Coalesce(h_month_11_new, 0);
                        h_month_12_actual := Coalesce(h_month_12_new, 0);
                        h_total_amount_actual := Coalesce(h_total_amount_new, 0);
                     Else
                        h_month_01_actual := (Coalesce(h_month_01_new, 0) + Coalesce(h_month_01_old, 0));
                        h_month_02_actual := (Coalesce(h_month_02_new, 0) + Coalesce(h_month_02_old, 0));
                        h_month_03_actual := (Coalesce(h_month_03_new, 0) + Coalesce(h_month_03_old, 0));
                        h_month_04_actual := (Coalesce(h_month_04_new, 0) + Coalesce(h_month_04_old, 0));
                        h_month_05_actual := (Coalesce(h_month_05_new, 0) + Coalesce(h_month_05_old, 0));
                        h_month_06_actual := (Coalesce(h_month_06_new, 0) + Coalesce(h_month_06_old, 0));
                        h_month_07_actual := (Coalesce(h_month_07_new, 0) + Coalesce(h_month_07_old, 0));
                        h_month_08_actual := (Coalesce(h_month_08_new, 0) + Coalesce(h_month_08_old, 0));
                        h_month_09_actual := (Coalesce(h_month_09_new, 0) + Coalesce(h_month_09_old, 0));
                        h_month_10_actual := (Coalesce(h_month_10_new, 0) + Coalesce(h_month_10_old, 0));
                        h_month_11_actual := (Coalesce(h_month_11_new, 0) + Coalesce(h_month_11_old, 0));
                        h_month_12_actual := (Coalesce(h_month_12_new, 0) + Coalesce(h_month_12_old, 0));
                        h_total_amount_actual := (Coalesce(h_total_amount_new, 0) + Coalesce(h_total_amount_old, 0));
                     End If;
                  End If;
               End If;
            End If;
         Else
            If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                  , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                  , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                  , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                  h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                  MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                  MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                  TOTAL_AMOUNT)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, h_chargecode_id,
                  h_month_01_new + h_month_01_actual,
                  h_month_02_new + h_month_02_actual,
                  h_month_03_new + h_month_03_actual,
                  h_month_04_new + h_month_04_actual,
                  h_month_05_new + h_month_05_actual,
                  h_month_06_new + h_month_06_actual,
                  h_month_07_new + h_month_07_actual,
                  h_month_08_new + h_month_08_actual,
                  h_month_09_new + h_month_09_actual,
                  h_month_10_new + h_month_10_actual,
                  h_month_11_new + h_month_11_actual,
                  h_month_12_new + h_month_12_actual,
                  h_total_amount_new + h_total_amount_actual);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 549+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(550) : timephase.sql(3597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                  MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                  MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                  TOTAL_AMOUNT)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, h_chargecode_id,
                  h_month_01_new, h_month_02_new,
                  h_month_03_new, h_month_04_new,
                  h_month_05_new, h_month_06_new,
                  h_month_07_new, h_month_08_new,
                  h_month_09_new, h_month_10_new,
                  h_month_11_new, h_month_12_new,
                  h_total_amount_new);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 581+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(582) : timephase.sql(3629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
                  h_project_id_actual := h_project_id;
                  h_id_actual := h_id;
                  h_chargecode_id_actual := h_chargecode_id;
                  h_budget_year_actual := h_budget_year;
                  
                  If Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR Then
                     h_month_01_actual := 0.00;
                     h_month_02_actual := 0.00;
                     h_month_03_actual := 0.00;
                     h_month_04_actual := 0.00;
                     h_month_05_actual := 0.00;
                     h_month_06_actual := 0.00;
                     h_month_07_actual := 0.00;
                     h_month_08_actual := 0.00;
                     h_month_09_actual := 0.00;
                     h_month_10_actual := 0.00;
                     h_month_11_actual := 0.00;
                     h_month_12_actual := 0.00;
                     h_total_amount_actual := 0.00;
                  Else
                     h_month_01_actual := h_month_01_new;
                     h_month_02_actual := h_month_02_new;
                     h_month_03_actual := h_month_03_new;
                     h_month_04_actual := h_month_04_new;
                     h_month_05_actual := h_month_05_new;
                     h_month_06_actual := h_month_06_new;
                     h_month_07_actual := h_month_07_new;
                     h_month_08_actual := h_month_08_new;
                     h_month_09_actual := h_month_09_new;
                     h_month_10_actual := h_month_10_new;
                     h_month_11_actual := h_month_11_new;
                     h_month_12_actual := h_month_12_new;
                     h_total_amount_actual := h_total_amount_new;
                  End If;
               End If;
            End If;
            
            -- insert average and FTE rows
            If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                  OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS'
                  , 13) = PMO_CNST.SC_MATCH) Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_COST'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 644+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(645) : timephase.sql(3692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 665+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(666) : timephase.sql(3713) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_RATE'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 686+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(687) : timephase.sql(3734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 707+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(708) : timephase.sql(3755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         --trace_printf("No Delta Timephase records\n");
         If (Coalesce(h_capital_expense, 0) < PMO_CNST.SC_TIMEPHASE_CALENDAR) AND (Coalesce(
               h_count_old, 0) > 0) Then
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id
               AND CHARGECODE_ID = h_chargecode_id
               AND BUDGET_YEAR = h_budget_year
               AND BUDGET_TYPE = h_budget_type;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 734+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(735) : timephase.sql(3782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_ORASTD.strcmp(h_project_id, h_id) <> PMO_CNST.SC_MATCH Then
               If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                     , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                     , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                     , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                     h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_actual, h_month_02_actual,
                     h_month_03_actual, h_month_04_actual,
                     h_month_05_actual, h_month_06_actual,
                     h_month_07_actual, h_month_08_actual,
                     h_month_09_actual, h_month_10_actual,
                     h_month_11_actual, h_month_12_actual,
                     h_total_amount_actual);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 772+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(773) : timephase.sql(3820) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_old,
                     h_month_02_old,
                     h_month_03_old,
                     h_month_04_old,
                     h_month_05_old,
                     h_month_06_old,
                     h_month_07_old,
                     h_month_08_old,
                     h_month_09_old,
                     h_month_10_old,
                     h_month_11_old,
                     h_month_12_old,
                     h_total_amount_old);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 810+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(811) : timephase.sql(3858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
                     h_project_id_actual := h_project_id;
                     h_id_actual := h_id;
                     h_chargecode_id_actual := h_chargecode_id;
                     h_budget_year_actual := h_budget_year;
                     
                     h_month_01_actual := h_month_01_old;
                     h_month_02_actual := h_month_02_old;
                     h_month_03_actual := h_month_03_old;
                     h_month_04_actual := h_month_04_old;
                     h_month_05_actual := h_month_05_old;
                     h_month_06_actual := h_month_06_old;
                     h_month_07_actual := h_month_07_old;
                     h_month_08_actual := h_month_08_old;
                     h_month_09_actual := h_month_09_old;
                     h_month_10_actual := h_month_10_old;
                     h_month_11_actual := h_month_11_old;
                     h_month_12_actual := h_month_12_old;
                     h_total_amount_actual := h_total_amount_old;
                  End If;
               End If;
            Else
               If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                     , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                     , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                     , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                     h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_old + h_month_01_actual,
                     h_month_02_old + h_month_02_actual,
                     h_month_03_old + h_month_03_actual,
                     h_month_04_old + h_month_04_actual,
                     h_month_05_old + h_month_05_actual,
                     h_month_06_old + h_month_06_actual,
                     h_month_07_old + h_month_07_actual,
                     h_month_08_old + h_month_08_actual,
                     h_month_09_old + h_month_09_actual,
                     h_month_10_old + h_month_10_actual,
                     h_month_11_old + h_month_11_actual,
                     h_month_12_old + h_month_12_actual,
                     h_total_amount_old + h_total_amount_actual);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 875+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(876) : timephase.sql(3923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                     MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                     MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                     TOTAL_AMOUNT)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, h_chargecode_id,
                     h_month_01_old,
                     h_month_02_old,
                     h_month_03_old,
                     h_month_04_old,
                     h_month_05_old,
                     h_month_06_old,
                     h_month_07_old,
                     h_month_08_old,
                     h_month_09_old,
                     h_month_10_old,
                     h_month_11_old,
                     h_month_12_old,
                     h_total_amount_old);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 913+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(914) : timephase.sql(3961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         Else
            If (Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (PMO_ORASTD.strcmp(h_project_id
                  , h_project_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_id
                  , h_id_actual) = PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(h_chargecode_id
                  , h_chargecode_id_actual) = PMO_CNST.SC_MATCH) AND (Coalesce(
                  h_budget_year, 0) = Coalesce(h_budget_year_actual, 0)) AND (Coalesce(
                  h_total_amount_actual, 0) > 0.0) Then
               BEGIN
                  INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                  ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
                  MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
                  MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
                  TOTAL_AMOUNT)
                  VALUES (
                  h_id, h_project_id, h_budget_year,
                  h_budget_type, h_chargecode_id,
                  h_month_01_actual,
                  h_month_02_actual,
                  h_month_03_actual,
                  h_month_04_actual,
                  h_month_05_actual,
                  h_month_06_actual,
                  h_month_07_actual,
                  h_month_08_actual,
                  h_month_09_actual,
                  h_month_10_actual,
                  h_month_11_actual,
                  h_month_12_actual,
                  h_total_amount_actual);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 959+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(960) : timephase.sql(4007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- insert average and FTE rows
               If (PMO_ORASTD.strncmp(h_chargecode_id, 'EXPENSE_HOURS', 13) = PMO_CNST.SC_MATCH) 
                     OR (PMO_ORASTD.strncmp(h_chargecode_id, 'CAPITAL_HOURS'
                     , 13) = PMO_CNST.SC_MATCH) Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_COST'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 984+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(985) : timephase.sql(4032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1005+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1006) : timephase.sql(4053) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               ElsIf PMO_ORASTD.strncmp(h_chargecode_id, 'BENEFIT_HOURS', 13) = PMO_CNST.SC_MATCH Then
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_AVERAGE_RATE'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1026+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1027) : timephase.sql(4074) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  BEGIN
                     INSERT INTO PROJECT_BUDGET_BREAKDOWN (
                     ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID)
                     VALUES (
                     h_id, h_project_id, h_budget_year,
                     h_budget_type, replace(h_chargecode_id, '_HOURS', '_FULL_TIME_EQUIVALENT'));
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1047+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1048) : timephase.sql(4095) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_TASK_TP;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Update_Timephase', 1064+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Update_Timephase(1065) : timephase.sql(4112) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Update_Timephase', 1070+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Update_Timephase(1071) : timephase.sql(4118) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Update_Timephase;
ALTER FUNCTION FC_Update_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Copy delta timephase from physical table the temporary table

/*****************************************************************************************/

Prompt == FUNCTION FC_C_Delta_Timephase ==
CREATE OR REPLACE FUNCTION FC_C_Delta_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_Delta_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_Delta_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_C_Delta_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_chargecode_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_Delta_Timephase', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_Delta_Timephase(17) : timephase.sql(4149) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TIMEPHASED_DELTA
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND CHARGECODE_ID = h_chargecode_id AND PROCESS_FLAG = 'I';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_Delta_Timephase', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_Delta_Timephase(36) : timephase.sql(4168) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
      MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
      MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND CHARGECODE_ID = h_chargecode_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_Delta_Timephase', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_Delta_Timephase(62) : timephase.sql(4194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND CHARGECODE_ID = h_chargecode_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_Delta_Timephase', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_Delta_Timephase(82) : timephase.sql(4214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_Delta_Timephase', 87+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_Delta_Timephase(88) : timephase.sql(4220) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_Delta_Timephase;
ALTER FUNCTION FC_C_Delta_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Update project timephase after delete tasks.

-- Copy all task timephase marked as 'D' to project delta timephase with reversed value.

-- Delete task timephase

/*****************************************************************************************/

Prompt == FUNCTION FC_D_Task_Timephase ==
CREATE OR REPLACE FUNCTION FC_D_Task_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_Task_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_Task_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_D_Task_Timephase(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_Task_Timephase', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_Task_Timephase(13) : timephase.sql(4251) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'D';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 29+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(30) : timephase.sql(4268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT P1.PROJECT_ID, P1.PROJECT_ID, P1.BUDGET_YEAR, P1.BUDGET_TYPE, P1.CHARGECODE_ID,
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_01_AMOUNT
      ELSE (P1.MONTH_01_AMOUNT - COALESCE(P2.MONTH_01_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_02_AMOUNT
      ELSE (P1.MONTH_02_AMOUNT - COALESCE(P2.MONTH_02_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_03_AMOUNT
      ELSE (P1.MONTH_03_AMOUNT - COALESCE(P2.MONTH_03_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_04_AMOUNT
      ELSE (P1.MONTH_04_AMOUNT - COALESCE(P2.MONTH_04_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_05_AMOUNT
      ELSE (P1.MONTH_05_AMOUNT - COALESCE(P2.MONTH_05_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_06_AMOUNT
      ELSE (P1.MONTH_06_AMOUNT - COALESCE(P2.MONTH_06_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_07_AMOUNT
      ELSE (P1.MONTH_07_AMOUNT - COALESCE(P2.MONTH_07_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_08_AMOUNT
      ELSE (P1.MONTH_08_AMOUNT - COALESCE(P2.MONTH_08_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_09_AMOUNT
      ELSE (P1.MONTH_09_AMOUNT - COALESCE(P2.MONTH_09_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_10_AMOUNT
      ELSE (P1.MONTH_10_AMOUNT - COALESCE(P2.MONTH_10_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_11_AMOUNT
      ELSE (P1.MONTH_11_AMOUNT - COALESCE(P2.MONTH_11_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.MONTH_12_AMOUNT
      ELSE (P1.MONTH_12_AMOUNT - COALESCE(P2.MONTH_12_AMOUNT, 0.00)) END) * (-1),
      (CASE WHEN CC.CAPITAL_EXPENSE >= PMO_CNST.SC_TIMEPHASE_CALENDAR THEN P1.TOTAL_AMOUNT
      ELSE (P1.TOTAL_AMOUNT - COALESCE(P2.TOTAL_AMOUNT, 0.00)) END) * (-1)
      FROM PROJECT_BUDGET_BREAKDOWN P1 JOIN TMT_CHARGECODES CC ON CC.ELEMENT_ID = P1.CHARGECODE_ID
      LEFT JOIN PROJECT_BUDGET_BREAKDOWN P2
      ON P1.PROJECT_ID = P2.PROJECT_ID AND P1.ELEMENT_ID = P2.ELEMENT_ID
      AND P1.CHARGECODE_ID = P2.CHARGECODE_ID AND P1.BUDGET_YEAR = P2.BUDGET_YEAR
      AND P2.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET AND P2.PROCESS_FLAG = 'X'
      WHERE P1.PROJECT_ID = h_project_id AND P1.PROCESS_FLAG = 'X'
      AND P1.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(81) : timephase.sql(4319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1), MONTH_04_AMOUNT * (-1),
      MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1), MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1),
      MONTH_09_AMOUNT * (-1), MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
      TOTAL_AMOUNT * (-1)
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'X' AND BUDGET_TYPE <> PMO_CNST.SC_SCHED_BUDGET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(105) : timephase.sql(4343) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_Task_Timephase', 122+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_Task_Timephase(123) : timephase.sql(4361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_Task_Timephase', 128+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_Task_Timephase(129) : timephase.sql(4367) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_Task_Timephase;
ALTER FUNCTION FC_D_Task_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Transfer a cri task to wbs. Copy existing timephase of the cri task as delta timephase of the project.

/*****************************************************************************************/

Prompt == FUNCTION FC_T_Cri_Timephase ==
CREATE OR REPLACE FUNCTION FC_T_Cri_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_T_Cri_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_T_Cri_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_T_Cri_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_Cri_Timephase', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_T_Cri_Timephase(15) : timephase.sql(4396) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND PROCESS_FLAG = 'T';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(33) : timephase.sql(4414) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
      MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
      MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND PROCESS_FLAG = 'X'
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(62) : timephase.sql(4443) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT S.PROJECT_ID, S.PROJECT_ID, S.BUDGET_YEAR, S.BUDGET_TYPE, S.CHARGECODE_ID,
      S.MONTH_01_AMOUNT - COALESCE(A.MONTH_01_AMOUNT, 0.00),
      S.MONTH_02_AMOUNT - COALESCE(A.MONTH_02_AMOUNT, 0.00),
      S.MONTH_03_AMOUNT - COALESCE(A.MONTH_03_AMOUNT, 0.00),
      S.MONTH_04_AMOUNT - COALESCE(A.MONTH_04_AMOUNT, 0.00),
      S.MONTH_05_AMOUNT - COALESCE(A.MONTH_05_AMOUNT, 0.00),
      S.MONTH_06_AMOUNT - COALESCE(A.MONTH_06_AMOUNT, 0.00),
      S.MONTH_07_AMOUNT - COALESCE(A.MONTH_07_AMOUNT, 0.00),
      S.MONTH_08_AMOUNT - COALESCE(A.MONTH_08_AMOUNT, 0.00),
      S.MONTH_09_AMOUNT - COALESCE(A.MONTH_09_AMOUNT, 0.00),
      S.MONTH_10_AMOUNT - COALESCE(A.MONTH_10_AMOUNT, 0.00),
      S.MONTH_11_AMOUNT - COALESCE(A.MONTH_11_AMOUNT, 0.00),
      S.MONTH_12_AMOUNT - COALESCE(A.MONTH_12_AMOUNT, 0.00),
      S.TOTAL_AMOUNT - COALESCE(A.TOTAL_AMOUNT, 0.00)
      FROM PROJECT_BUDGET_BREAKDOWN S LEFT JOIN PROJECT_BUDGET_BREAKDOWN A
      ON S.PROJECT_ID = A.PROJECT_ID AND S.ELEMENT_ID = A.ELEMENT_ID
      AND S.CHARGECODE_ID = A.CHARGECODE_ID AND S.BUDGET_YEAR = A.BUDGET_YEAR
      AND A.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET AND A.PROCESS_FLAG = 'X'
      WHERE S.PROJECT_ID = h_project_id
      AND S.ELEMENT_ID = h_id AND S.PROCESS_FLAG = 'X'
      AND S.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND S.CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(103) : timephase.sql(4484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'I'
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 122+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(123) : timephase.sql(4504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT ELEMENT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT,
      MONTH_05_AMOUNT, MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT,
      MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(152) : timephase.sql(4533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT S.ELEMENT_ID, S.PROJECT_ID, S.BUDGET_YEAR, S.BUDGET_TYPE, S.CHARGECODE_ID,
      S.MONTH_01_AMOUNT - COALESCE(A.MONTH_01_AMOUNT, 0.00),
      S.MONTH_02_AMOUNT - COALESCE(A.MONTH_02_AMOUNT, 0.00),
      S.MONTH_03_AMOUNT - COALESCE(A.MONTH_03_AMOUNT, 0.00),
      S.MONTH_04_AMOUNT - COALESCE(A.MONTH_04_AMOUNT, 0.00),
      S.MONTH_05_AMOUNT - COALESCE(A.MONTH_05_AMOUNT, 0.00),
      S.MONTH_06_AMOUNT - COALESCE(A.MONTH_06_AMOUNT, 0.00),
      S.MONTH_07_AMOUNT - COALESCE(A.MONTH_07_AMOUNT, 0.00),
      S.MONTH_08_AMOUNT - COALESCE(A.MONTH_08_AMOUNT, 0.00),
      S.MONTH_09_AMOUNT - COALESCE(A.MONTH_09_AMOUNT, 0.00),
      S.MONTH_10_AMOUNT - COALESCE(A.MONTH_10_AMOUNT, 0.00),
      S.MONTH_11_AMOUNT - COALESCE(A.MONTH_11_AMOUNT, 0.00),
      S.MONTH_12_AMOUNT - COALESCE(A.MONTH_12_AMOUNT, 0.00),
      S.TOTAL_AMOUNT - COALESCE(A.TOTAL_AMOUNT, 0.00)
      FROM TIMEPHASED_DELTA S LEFT JOIN TIMEPHASED_DELTA A
      ON S.PROJECT_ID = A.PROJECT_ID AND S.ELEMENT_ID = A.ELEMENT_ID
      AND S.CHARGECODE_ID = A.CHARGECODE_ID AND S.BUDGET_YEAR = A.BUDGET_YEAR
      AND A.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      WHERE S.PROJECT_ID = h_project_id
      AND S.ELEMENT_ID = h_id
      AND S.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_COST%'
      AND S.CHARGECODE_ID NOT LIKE '%_AVERAGE_RATE%'
      AND S.CHARGECODE_ID NOT LIKE '%_FULL_TIME_EQUIVALENT%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 192+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(193) : timephase.sql(4574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_T_Cri_Timephase', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_T_Cri_Timephase(212) : timephase.sql(4593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_T_Cri_Timephase', 217+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_T_Cri_Timephase(218) : timephase.sql(4599) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_T_Cri_Timephase;
ALTER FUNCTION FC_T_Cri_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Update project timephase after delete transferred tasks.

-- Copy all task timephase marked as 'D' to project delta timephase with reversed value.

/*****************************************************************************************/

Prompt == FUNCTION FC_UT_Task_Timephase ==
CREATE OR REPLACE FUNCTION FC_UT_Task_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UT_Task_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UT_Task_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_UT_Task_Timephase(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UT_Task_Timephase', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UT_Task_Timephase(13) : timephase.sql(4628) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE PROJECT_BUDGET_BREAKDOWN
      SET PROCESS_FLAG = 'X'
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'U';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 29+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(30) : timephase.sql(4645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
      MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1), MONTH_04_AMOUNT * (-1),
      MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1), MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1),
      MONTH_09_AMOUNT * (-1), MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
      TOTAL_AMOUNT * (-1)
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(56) : timephase.sql(4671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_DELTA_TIMEPHASE
      SELECT S.PROJECT_ID, S.PROJECT_ID, S.BUDGET_YEAR, S.BUDGET_TYPE, S.CHARGECODE_ID,
      COALESCE(A.MONTH_01_AMOUNT, 0.00) - S.MONTH_01_AMOUNT,
      COALESCE(A.MONTH_02_AMOUNT, 0.00) - S.MONTH_02_AMOUNT,
      COALESCE(A.MONTH_03_AMOUNT, 0.00) - S.MONTH_03_AMOUNT,
      COALESCE(A.MONTH_04_AMOUNT, 0.00) - S.MONTH_04_AMOUNT,
      COALESCE(A.MONTH_05_AMOUNT, 0.00) - S.MONTH_05_AMOUNT,
      COALESCE(A.MONTH_06_AMOUNT, 0.00) - S.MONTH_06_AMOUNT,
      COALESCE(A.MONTH_07_AMOUNT, 0.00) - S.MONTH_07_AMOUNT,
      COALESCE(A.MONTH_08_AMOUNT, 0.00) - S.MONTH_08_AMOUNT,
      COALESCE(A.MONTH_09_AMOUNT, 0.00) - S.MONTH_09_AMOUNT,
      COALESCE(A.MONTH_10_AMOUNT, 0.00) - S.MONTH_10_AMOUNT,
      COALESCE(A.MONTH_11_AMOUNT, 0.00) - S.MONTH_11_AMOUNT,
      COALESCE(A.MONTH_12_AMOUNT, 0.00) - S.MONTH_12_AMOUNT,
      COALESCE(A.TOTAL_AMOUNT, 0.00) - S.TOTAL_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN S LEFT JOIN PROJECT_BUDGET_BREAKDOWN A
      ON S.PROJECT_ID = A.PROJECT_ID AND S.ELEMENT_ID = A.ELEMENT_ID
      AND S.CHARGECODE_ID = A.CHARGECODE_ID AND S.BUDGET_YEAR = A.BUDGET_YEAR
      AND A.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET AND A.PROCESS_FLAG = 'X'
      WHERE S.PROJECT_ID = h_project_id
      AND S.PROCESS_FLAG = 'X'
      AND S.BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(94) : timephase.sql(4709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  BEGIN_SQL
   --      UPDATE PROJECT_BUDGET_BREAKDOWN
   --      SET PROCESS_FLAG = 'I'
   --      WHERE PROJECT_ID = HOST(h_project_id) AND PROCESS_FLAG = 'X';
   --  END_SQL;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id AND PROCESS_FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UT_Task_Timephase', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UT_Task_Timephase(118) : timephase.sql(4733) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UT_Task_Timephase', 123+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UT_Task_Timephase(124) : timephase.sql(4739) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UT_Task_Timephase;
ALTER FUNCTION FC_UT_Task_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Delete physical delta timephase when actual_edit flag is 1 (edit actual budget in budget view)

/*****************************************************************************************/

Prompt == FUNCTION FC_Delete_Delta ==
CREATE OR REPLACE FUNCTION FC_Delete_Delta
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Delete_Delta') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Delete_Delta'), '-- ' || SYSTIMESTAMP, ':r := FC_Delete_Delta(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_chargecode_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Delete_Delta', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Delete_Delta(17) : timephase.sql(4770) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      DELETE FROM TIMEPHASED_DELTA
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND CHARGECODE_ID = h_chargecode_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Delete_Delta', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Delete_Delta(34) : timephase.sql(4787) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Delete_Delta', 39+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Delete_Delta(40) : timephase.sql(4793) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Delete_Delta;
ALTER FUNCTION FC_Delete_Delta COMPILE DEBUG;

/*****************************************************************************************/

-- Copy timephase record to delta table with reversed values and delete from timephase table

-- when actual edit is 0 (input in expense view) with update_bit on

/*****************************************************************************************/

Prompt == FUNCTION FC_C_D_Timephase ==
CREATE OR REPLACE FUNCTION FC_C_D_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_chargecode_id IN OUT NOCOPY VARCHAR2
   , sh_h_budget_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_budget_type PLS_INTEGER := sh_h_budget_type;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_C_D_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_C_D_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_C_D_Timephase(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_chargecode_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_budget_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_D_Timephase', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_C_D_Timephase(20) : timephase.sql(4829) : ' || SYSTIMESTAMP);
   END IF; 

   If Coalesce(h_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET Then
      BEGIN
         INSERT INTO PMO_DELTA_TIMEPHASE
         SELECT P1.PROJECT_ID, P1.PROJECT_ID, P1.BUDGET_YEAR, P1.BUDGET_TYPE, P1.CHARGECODE_ID,
         (P1.MONTH_01_AMOUNT - COALESCE(P2.MONTH_01_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_02_AMOUNT - COALESCE(P2.MONTH_02_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_03_AMOUNT - COALESCE(P2.MONTH_03_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_04_AMOUNT - COALESCE(P2.MONTH_04_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_05_AMOUNT - COALESCE(P2.MONTH_05_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_06_AMOUNT - COALESCE(P2.MONTH_06_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_07_AMOUNT - COALESCE(P2.MONTH_07_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_08_AMOUNT - COALESCE(P2.MONTH_08_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_09_AMOUNT - COALESCE(P2.MONTH_09_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_10_AMOUNT - COALESCE(P2.MONTH_10_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_11_AMOUNT - COALESCE(P2.MONTH_11_AMOUNT, 0.00))  * (-1),
         (P1.MONTH_12_AMOUNT - COALESCE(P2.MONTH_12_AMOUNT, 0.00))  * (-1),
         (P1.TOTAL_AMOUNT - COALESCE(P2.TOTAL_AMOUNT, 0.00))  * (-1)
         FROM PROJECT_BUDGET_BREAKDOWN P1 LEFT JOIN PROJECT_BUDGET_BREAKDOWN P2
         ON P1.PROJECT_ID = P2.PROJECT_ID AND P1.ELEMENT_ID = P2.ELEMENT_ID
         AND P1.CHARGECODE_ID = P2.CHARGECODE_ID AND P1.BUDGET_YEAR = P2.BUDGET_YEAR
         AND P2.BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
         WHERE P1.PROJECT_ID = h_project_id
         AND P1.ELEMENT_ID = h_id AND P1.CHARGECODE_ID = h_chargecode_id
         AND P1.BUDGET_TYPE = h_budget_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_D_Timephase', 56+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_D_Timephase(57) : timephase.sql(4866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         INSERT INTO PMO_DELTA_TIMEPHASE
         SELECT PROJECT_ID, PROJECT_ID, BUDGET_YEAR, BUDGET_TYPE, CHARGECODE_ID,
         MONTH_01_AMOUNT * (-1), MONTH_02_AMOUNT * (-1), MONTH_03_AMOUNT * (-1), MONTH_04_AMOUNT * (-1),
         MONTH_05_AMOUNT * (-1), MONTH_06_AMOUNT * (-1), MONTH_07_AMOUNT * (-1), MONTH_08_AMOUNT * (-1),
         MONTH_09_AMOUNT * (-1), MONTH_10_AMOUNT * (-1), MONTH_11_AMOUNT * (-1), MONTH_12_AMOUNT * (-1),
         TOTAL_AMOUNT * (-1)
         FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_id AND CHARGECODE_ID = h_chargecode_id
         AND BUDGET_TYPE = h_budget_type;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_D_Timephase', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_D_Timephase(83) : timephase.sql(4892) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_id AND CHARGECODE_ID = h_chargecode_id
      AND BUDGET_TYPE = h_budget_type;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_C_D_Timephase', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_C_D_Timephase(104) : timephase.sql(4913) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_C_D_Timephase', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_C_D_Timephase(110) : timephase.sql(4919) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_C_D_Timephase;
ALTER FUNCTION FC_C_D_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Rollup Task TimePhase to Project TimePhase

/*****************************************************************************************/

Prompt == FUNCTION FC_Timephase_CRI_Task ==
CREATE OR REPLACE FUNCTION FC_Timephase_CRI_Task
(
     h_p_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_column_type PLS_INTEGER := 0;
   h_timephase_bits PLS_INTEGER := 0;
   h_budget_timephase_bits PLS_INTEGER := 0;
   h_unresolved_start TIMESTAMP;
   h_unresolved_finish TIMESTAMP;
   h_chargecode_id VARCHAR2(32);
   h_current_budget NUMBER := 0;
   h_actual_budget NUMBER := 0;
   h_actual_edited PLS_INTEGER := 0;
   h_previous_project_id VARCHAR2(32);
   h_timephase_flag PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      CURSOR C_CRITASK IS
         SELECT W1.PROJECT_ID, W1.ELEMENT_ID, W1.TIMEPHASED_BITS,
         TO_DATE(SubStr(W1.UNRESOLVED_START, 1, 10)), TO_DATE(SubStr(W1.UNRESOLVED_FINISH, 1, 10))
         FROM TMT_CRI W1
         WHERE W1.PROJECT_ID = h_project_id
         AND WBS_ID IS NuLL AND W1.TIMEPHASED_BITS > 0 AND W1.LEVEL_ID > 1
         AND TYPE_ID IN (PMO_CNST.SC_CRI_CHANGE_REQUEST_TASK,PMO_CNST.SC_CRI_ACTION_ITEM_TASK,PMO_CNST.SC_CRI_RISK_TASK,PMO_CNST.SC_CRI_ISSUE_TASK,PMO_CNST.SC_CRI_REQUIREMENT_TASK,PMO_CNST.SC_CRI_DEFECT_TASK,PMO_CNST.SC_SERVICE_REQUEST_TASK,PMO_CNST.SC_CRI_TASK,PMO_CNST.SC_CRI_MILESTONE)
         ORDER BY W1.PROJECT_ID;

      CURSOR C_CRIBUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS, CC.CAPITAL_EXPENSE
         FROM BUDGETS B, TMT_CHARGECODES CC
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID = h_id
         AND CC.ELEMENT_ID = B.CHARGECODE_ID;

      CURSOR C_U_CRIBUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS, CC.CAPITAL_EXPENSE
         FROM BUDGETS B, TMT_CHARGECODES CC
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID = h_id AND B.TIMEPHASED_BITS > 0
         AND CC.ELEMENT_ID = B.CHARGECODE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Timephase_CRI_Task') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Timephase_CRI_Task'), '-- ' || SYSTIMESTAMP, ':r := FC_Timephase_CRI_Task(' || 
       '''' || h_p_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Timephase_CRI_Task', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Timephase_CRI_Task(50) : timephase.sql(4983) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := h_p_project_id;
   h_previous_project_id := '';
   
   -- select all (dirty) projects under the current rank
   
   OPEN C_CRITASK;
   
   LOOP
      FETCH C_CRITASK INTO h_project_id, h_id, h_timephase_bits,
      h_unresolved_start, h_unresolved_finish;
      IF C_CRITASK%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         EXIT;
      End If;
      
      If PMO_ORASTD.strcmp(h_previous_project_id, h_project_id) <> PMO_CNST.SC_MATCH Then
         h_previous_project_id := h_project_id;
         
         If PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH Then
            COMMIT;
         End If;
      End If;
      
      If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_UPDATE_DATE_BIT)) > 0 Then
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_CRIBUDGETS;
         
         LOOP
            FETCH C_CRIBUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited,
            h_budget_timephase_bits, h_capital_expense;
            IF C_CRIBUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               EXIT;
            End If;
            
            If Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            Else
               If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) > 0.0 Then
                  h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                  h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                  --                      h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
               End If;
               
               If Coalesce(h_actual_edited, 0) = 1 Then
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                     h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
                  End If;
                  
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                  --if (h_actual_budget > 0)
                  --{
                  --                          h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_actual_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                  --}
               Else
                  --                      InitializeHost(SC_PARAM(h_column_type), SC_ACTUAL_BUDGET);
                  --                      if ((h_budget_timephase_bits  SC_UPDATE_ACTUAL_BUDGET_BIT) > 0)
                  --                      {
                  --                          h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                  --                      }
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            End If;
            
            If Coalesce(h_budget_timephase_bits, 0) > 0 Then
               BEGIN
                  UPDATE BUDGETS
                  SET TIMEPHASED_BITS = 0
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 152+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(153) : timephase.sql(5086) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE C_CRIBUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 166+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(167) : timephase.sql(5100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         
         BEGIN
            UPDATE TMT_CRI SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 186+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(187) : timephase.sql(5120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_U_CRIBUDGETS;
         
         LOOP
            FETCH C_U_CRIBUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited,
            h_budget_timephase_bits, h_capital_expense;
            IF C_U_CRIBUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               EXIT;
            End If;
            
            If Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR Then
               h_actual_edited := 0;
            End If;
            
            If Coalesce(h_actual_edited, 0) = 1 Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
               End If;
               
               If (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT)) > 0 Then
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  --if (h_actual_budget != 0.00)
                  --{
                  --                          h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_actual_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                  --}
                  
                  If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                     h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                     h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                     --                          h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                  End If;
               End If;
            Else
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               Else
                  h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                  h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
               End If;
            End If;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = 0
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
               AND CHARGECODE_ID = h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 259+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(260) : timephase.sql(5193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         BEGIN
            CLOSE C_U_CRIBUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 272+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(273) : timephase.sql(5206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         
         BEGIN
            UPDATE TMT_CRI SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 292+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(293) : timephase.sql(5226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_CRITASK ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Timephase_CRI_Task', 306+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Timephase_CRI_Task(307) : timephase.sql(5240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Timephase_CRI_Task', 312+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Timephase_CRI_Task(313) : timephase.sql(5246) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Timephase_CRI_Task;
ALTER FUNCTION FC_Timephase_CRI_Task COMPILE DEBUG;

/*****************************************************************************************/

-- Rollup Task TimePhase to Project TimePhase

/*****************************************************************************************/

Prompt == FUNCTION FC_Rollup_Timephase ==
CREATE OR REPLACE FUNCTION FC_Rollup_Timephase
(
     h_p_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_previous_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_column_type PLS_INTEGER := 0;
   h_timephase_bits PLS_INTEGER := 0;
   h_budget_timephase_bits PLS_INTEGER := 0;
   h_start_finish_date DATE;
   h_finish_start_date DATE;
   h_unresolved_start TIMESTAMP;
   h_unresolved_finish TIMESTAMP;
   h_previous_project_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_current_budget NUMBER := 0;
   h_actual_budget NUMBER := 0;
   h_actual_edited PLS_INTEGER := 0;
   h_timephase_flag PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      CURSOR C_TIMEPHASE IS
         SELECT W1.PROJECT_ID, W1.TYPE_ID, W1.ELEMENT_ID, W1.TIMEPHASED_BITS,
         TO_DATE(SubStr(W1.UNRESOLVED_START, 1, 10)), TO_DATE(SubStr(W1.UNRESOLVED_FINISH, 1, 10)),
         TO_DATE(SubStr(W1.START_FINISH_DATE, 1, 10)), TO_DATE(SubStr(W1.FINISH_START_DATE, 1, 10))
         FROM TMT_WBS W1
         WHERE W1.PROJECT_ID = h_project_id AND W1.TIMEPHASED_BITS > 0
         ORDER BY PROJECT_ID, W1.RANK DESC;

      CURSOR C_BUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS, CC.CAPITAL_EXPENSE
         FROM BUDGETS B, TMT_CHARGECODES CC
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID = h_id
         AND CC.ELEMENT_ID = B.CHARGECODE_ID;

      CURSOR C_U_BUDGETS IS
         SELECT B.BUDGET, B.ACTUAL, B.CHARGECODE_ID, B.ACTUAL_EDITED, B.TIMEPHASED_BITS, CC.CAPITAL_EXPENSE
         FROM BUDGETS B, TMT_CHARGECODES CC
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_id
         AND B.TIMEPHASED_BITS > 0
         AND CC.ELEMENT_ID = B.CHARGECODE_ID;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Rollup_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Rollup_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_Rollup_Timephase(' || 
       '''' || h_p_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rollup_Timephase', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Rollup_Timephase(55) : timephase.sql(5315) : ' || SYSTIMESTAMP);
   END IF; 

   h_previous_project_id := '';
   h_project_id := h_p_project_id;
   
   --trace_printf("***** h_project_id = %d:%s *****\n",h_project_id_Ind,h_project_id);
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NEW_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_DELTA_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CHANGED_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- select all (dirty) projects under the current rank
   
   OPEN C_TIMEPHASE;
   
   LOOP
      FETCH C_TIMEPHASE INTO h_project_id, h_type, h_id, h_timephase_bits,
      h_unresolved_start, h_unresolved_finish,
      h_start_finish_date, h_finish_start_date;
      IF C_TIMEPHASE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         If PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH Then
            If PMO_ORASTD.strcmp(h_previous_project_id, h_previous_id) <> PMO_CNST.SC_MATCH Then
               h_temp_sc_state := FC_Update_Timephase(h_previous_project_id, h_previous_project_id);
            End If;
            
            /*              BEGIN_SQL
                                DELETE FROM SESSION.PMO_NEW_TIMEPHASE;
                            END_SQL;
            
                            BEGIN_SQL
                                DELETE FROM SESSION.PMO_DELTA_TIMEPHASE;
                            END_SQL;
            
                            BEGIN_SQL
                                DELETE FROM SESSION.PMO_CHANGED_TIMEPHASE;
                            END_SQL;
            */
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_FLAG = 0
               WHERE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID) IN
               (SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND CHARGECODE_ID NOT LIKE '%_AVERAGE%'
               GROUP BY PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               HAVING SUM(TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 125+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(126) : timephase.sql(5386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND (ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE)
               IN (SELECT PBB.ELEMENT_ID, PBB.CHARGECODE_ID, PBB.BUDGET_TYPE
               FROM PROJECT_BUDGET_BREAKDOWN PBB, TMT_CHARGECODES CC
               WHERE PBB.PROJECT_ID = h_previous_project_id
               AND PBB.CHARGECODE_ID = CC.ELEMENT_ID
               AND CC.CAPITAL_EXPENSE < PMO_CNST.SC_TIMEPHASE_CALENDAR
               AND BUDGET_TYPE NOT IN (PMO_CNST.SC_ACTUAL_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET)
               GROUP BY PBB.ELEMENT_ID, PBB.CHARGECODE_ID, PBB.BUDGET_TYPE
               HAVING SUM(PBB.TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 152+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(153) : timephase.sql(5413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         EXIT;
      End If;
      
      --trace_printf("***** h_project_id = %d:%s *****\n",h_project_id_Ind,h_project_id);
      --trace_printf("***** h_element_id = %d:%s *****\n",h_id_Ind,h_id);
      --trace_printf("***** h_timephase_bits = %d:%d *****\n",h_timephase_bits_Ind,h_timephase_bits);
      --trace_printf("***** h_type = %d:%d *****\n",h_type_Ind,h_type);
      --trace_printf("***** h_unresolved_start = %d:%s *****\n",h_unresolved_start_Ind,h_unresolved_start);
      --trace_printf("***** h_unresolved_finish = %d:%s *****\n",h_unresolved_finish_Ind,h_unresolved_finish);
      --trace_printf("***** h_start_finish_date = %d:%s *****\n",h_start_finish_date_Ind,h_start_finish_date);
      --trace_printf("***** h_finish_start_date = %d:%s *****\n",h_finish_start_date_Ind,h_finish_start_date);
      If PMO_ORASTD.strcmp(h_project_id, h_previous_project_id) <> PMO_CNST.SC_MATCH Then
         If (PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH) AND (PMO_ORASTD.strcmp(
               h_previous_project_id, h_previous_id) <> PMO_CNST.SC_MATCH) Then
            h_temp_sc_state := FC_Update_Timephase(h_previous_project_id, h_previous_project_id);
            
            BEGIN
               DELETE FROM PMO_NEW_TIMEPHASE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 185+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(186) : timephase.sql(5446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PMO_DELTA_TIMEPHASE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 202+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(203) : timephase.sql(5463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PMO_CHANGED_TIMEPHASE;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 219+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(220) : timephase.sql(5480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_FLAG = 0
               WHERE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID) IN
               (SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND CHARGECODE_ID NOT LIKE '%_AVERAGE%'
               GROUP BY PROJECT_ID, ELEMENT_ID, CHARGECODE_ID
               HAVING SUM(TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 244+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(245) : timephase.sql(5505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_previous_project_id
               AND (ELEMENT_ID, CHARGECODE_ID, BUDGET_TYPE)
               IN (SELECT PBB.ELEMENT_ID, PBB.CHARGECODE_ID, PBB.BUDGET_TYPE
               FROM PROJECT_BUDGET_BREAKDOWN PBB, TMT_CHARGECODES CC
               WHERE PBB.PROJECT_ID = h_previous_project_id
               AND PBB.CHARGECODE_ID = CC.ELEMENT_ID
               AND CC.CAPITAL_EXPENSE < PMO_CNST.SC_TIMEPHASE_CALENDAR
               GROUP BY PBB.ELEMENT_ID, PBB.CHARGECODE_ID, PBB.BUDGET_TYPE
               HAVING SUM(PBB.TOTAL_AMOUNT) = 0.00);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 270+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(271) : timephase.sql(5531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If PMO_ORASTD.strcmp(h_previous_project_id, '') <> PMO_CNST.SC_MATCH Then
            COMMIT;
         End If;
         
         h_previous_project_id := h_project_id;
      End If;
      h_previous_id := h_id;
      
      If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_UPDATE_DATE_BIT)) > 0 Then
         --trace_printf("Dates changed\n");
         -- transferred a cri task to wbs,
         -- set flag in timephase table to T if the original flag is not 'U' else set to null
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_TRANSFERRED_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_T_Cri_Timephase(h_project_id, h_id);
         End If;
         
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_BUDGETS;
         
         LOOP
            FETCH C_BUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited,
            h_budget_timephase_bits, h_capital_expense;
            IF C_BUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               EXIT;
            End If;
            
            --trace_printf("***** h_current_budget = %d:%f *****\n",h_current_budget_Ind,h_current_budget);
            --trace_printf("***** h_actual_budget = %d:%f *****\n",h_actual_budget_Ind,h_actual_budget);
            --trace_printf("***** h_chargecode_id = %d:%s *****\n",h_chargecode_id_Ind,h_chargecode_id);
            --trace_printf("***** h_actual_edited = %d:%d *****\n",h_actual_edited_Ind,h_actual_edited);
            --trace_printf("***** h_timephase_bits = %d:%d *****\n",h_timephase_bits_Ind,h_timephase_bits);
            If Coalesce(h_capital_expense, 0) >= PMO_CNST.SC_TIMEPHASE_CALENDAR Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            Else
               h_column_type := PMO_CNST.SC_SCHED_BUDGET;
               h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
               If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                  h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                  h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                  h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
               End If;
               
               If Coalesce(h_actual_edited, 0) = 1 Then
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                     h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
                  End If;
                  
                  h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                  h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                  If Coalesce(h_actual_budget, 0) <> 0.00 Then
                     BEGIN
                        UPDATE BUDGETS
                        SET COST_CENTER_BITS = PMO_STPU.BIT_OR(COST_CENTER_BITS, PMO_CNST.SC_UPDATE_DATE_BIT)
                        WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
                        AND CHARGECODE_ID = h_chargecode_id;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 357+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(358) : timephase.sql(5618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                  End If;
               Else
                  --                      InitializeHost(SC_PARAM(h_column_type), SC_ACTUAL_BUDGET);
                  --                      if ((h_budget_timephase_bits  SC_UPDATE_ACTUAL_BUDGET_BIT) > 0)
                  --                      {
                  --                          h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                  --                      }
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            End If;
            
            If Coalesce(h_budget_timephase_bits, 0) > 0 Then
               BEGIN
                  UPDATE BUDGETS
                  SET TIMEPHASED_BITS = 0
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
                  AND CHARGECODE_ID = h_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 391+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(392) : timephase.sql(5652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         BEGIN
            CLOSE C_BUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 405+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(406) : timephase.sql(5666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         
         BEGIN
            UPDATE TMT_WBS SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 425+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(426) : timephase.sql(5686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- transferred a cri task to wbs,
         -- set flag in timephase table to T if the original flag is not 'U' else set to null
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_TRANSFERRED_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_T_Cri_Timephase(h_project_id, h_id);
            
            h_budget_timephase_bits := PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT;
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = h_budget_timephase_bits
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 451+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(452) : timephase.sql(5712) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_DELETE_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_D_Task_Timephase(h_project_id);
         End If;
         
         -- delete a transferred task from wbs,
         -- set flag in timephase table to U if the original flag is not 'T' else set to 'I'
         If (BITAND(Coalesce(h_timephase_bits, 0), PMO_CNST.SC_DELETE_TRANSFERRED_TASK_BIT)) > 0 Then
            h_temp_sc_state := FC_UT_Task_Timephase(h_project_id);
         End If;
         
         -- select all chargecodes (except labor, hours, ...) in budgets
         
         OPEN C_U_BUDGETS;
         
         LOOP
            FETCH C_U_BUDGETS INTO h_current_budget, h_actual_budget,
            h_chargecode_id, h_actual_edited,
            h_budget_timephase_bits, h_capital_expense;
            IF C_U_BUDGETS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               EXIT;
            End If;
            
            --trace_printf("***** h_current_budget = %d:%f *****\n",h_current_budget_Ind,h_current_budget);
            --trace_printf("***** h_actual_budget = %d:%f *****\n",h_actual_budget_Ind,h_actual_budget);
            --trace_printf("***** h_chargecode_id = %d:%s *****\n",h_chargecode_id_Ind,h_chargecode_id);
            --trace_printf("***** h_actual_edited = %d:%d *****\n",h_actual_edited_Ind,h_actual_edited);
            --trace_printf("***** h_timephase_bits = %d:%d *****\n",h_timephase_bits_Ind,h_timephase_bits);
            
            If Coalesce(h_capital_expense, 0) > PMO_CNST.SC_TIMEPHASE_CALENDAR Then
               If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                     OR ((BITAND(Coalesce(
                     h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                  h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
               End If;
            Else
               If Coalesce(h_actual_edited, 0) = 1 Then
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0) Then
                     --                          h_temp_sc_state = FC_C_Delta_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id));
                     h_temp_sc_state := FC_Delete_Delta(h_project_id, h_id, h_chargecode_id);
                  End If;
                  
                  --                      if ((h_budget_timephase_bits  SC_UPDATE_ACTUAL_BUDGET_BIT) > 0)
                  If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT)) > 0) 
                        OR ((BITAND(Coalesce(
                        h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT)) > 0) Then
                     --trace_printf("Actual Changed\n");
                     If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_finish_start_date, h_column_type);
                        End If;
                        --                              else if (h_current_budget == 0.00)
                        --                              {
                        --                                  InitializeHost(SC_PARAM(h_column_type), SC_SCHED_BUDGET);
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                        
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If Coalesce(h_actual_budget, 0) <> 0.00 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_finish_start_date, h_column_type);
                        End If;
                        --                              else
                        --                              {
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                     Else
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                        --                              else if (h_current_budget == 0.00)
                        --                              {
                        --                                  InitializeHost(SC_PARAM(h_column_type), SC_SCHED_BUDGET);
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                        
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        --                              if ((h_budget_timephase_bits  SC_ACTUAL_DELTA_BIT) == 0)
                        --                              {
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        --                              }
                        
                        If Coalesce(h_actual_budget, 0) <> 0.00 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                        --                              else
                        --                              {
                        --                                  h_temp_sc_state = FC_C_D_Timephase(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_column_type));
                        --                              }
                     End If;
                  ElsIf (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT)) > 0 Then
                     --trace_printf("Sched Changed\n");
                     If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        
                        --trace_printf("h_current_budget: %d;%f\n", h_current_budget_Ind, h_current_budget);
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                        
                        If Coalesce(h_actual_budget, 0) <> 0.00 Then
                           h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                           h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                           
                           If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                           Else
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                           End If;
                        End If;
                     ElsIf Coalesce(h_current_budget, 0) = 0.00 Then
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                     Else
                        h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                        h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                        
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        --                              if (isProjectType(h_type))
                        --                                  h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_start_finish_date), SC_PARAM(h_start_finish_date), SC_PARAM(h_column_type));
                        --                              else
                        --                                  h_temp_sc_state = FC_TIMEPHASE_AMOUNT(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_chargecode_id), SC_PARAM(h_current_budget), SC_PARAM(h_unresolved_start), SC_PARAM(h_unresolved_finish), SC_PARAM(h_column_type));
                        
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                     End If;
                  End If;
               Else
                  --trace_printf("Auto edit actual\n");
                  If (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_ACTUAL_DELTA_BIT)) > 0 Then
                     h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
                     
                     h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                     h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                     If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                        h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                     End If;
                  ElsIf (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_SCHED_DELTA_BIT)) > 0 Then
                     h_temp_sc_state := FC_C_Delta_Timephase(h_project_id, h_id, h_chargecode_id);
                  Else
                     --trace_printf("Changed\n");
                     If ((BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_ACTUAL_BUDGET_BIT)) > 0) 
                           AND (Coalesce(h_actual_budget, 0) <> 0.00) Then
                        --trace_printf("Actual Changed\n");
                        h_column_type := PMO_CNST.SC_ACTUAL_BUDGET;
                        h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                        If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                        Else
                           h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_actual_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                        End If;
                     End If;
                     
                     If (BITAND(Coalesce(h_budget_timephase_bits, 0), PMO_CNST.SC_UPDATE_SCHED_BUDGET_BIT)) > 0 Then
                        --trace_printf("Sched Changed\n");
                        If (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0)) <> 0.00 Then
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                           h_current_budget := (Coalesce(h_current_budget, 0) - Coalesce(h_actual_budget, 0));
                           If isProjectType(Coalesce(h_type, 0)) <> 0 Then
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_start_finish_date, h_start_finish_date, h_column_type);
                           Else
                              h_temp_sc_state := FC_TIMEPHASE_AMOUNT(h_project_id, h_id, h_chargecode_id, h_current_budget
                                       , h_unresolved_start, h_unresolved_finish, h_column_type);
                           End If;
                        Else
                           h_column_type := PMO_CNST.SC_SCHED_BUDGET;
                           If NOT isProjectType(Coalesce(h_type, 0)) <> 0 Then
                              h_temp_sc_state := FC_C_D_Timephase(h_project_id, h_id, h_chargecode_id, h_column_type);
                           End If;
                        End If;
                     End If;
                  End If;
               End If;
            End If;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = 0
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id
               AND CHARGECODE_ID = h_chargecode_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 693+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(694) : timephase.sql(5954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         BEGIN
            CLOSE C_U_BUDGETS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 706+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(707) : timephase.sql(5967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_Update_Timephase(h_project_id, h_id);
         BEGIN
            UPDATE TMT_WBS SET TIMEPHASED_BITS = 0
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 725+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(726) : timephase.sql(5986) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   BEGIN
      CLOSE C_TIMEPHASE ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rollup_Timephase', 739+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rollup_Timephase(740) : timephase.sql(6000) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rollup_Timephase', 745+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Rollup_Timephase(746) : timephase.sql(6006) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Rollup_Timephase;
ALTER FUNCTION FC_Rollup_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- Rollup TimePhase to Project TimePhase

/*****************************************************************************************/

Prompt == FUNCTION SP_ROLLUP_TIMEPHASE ==
CREATE OR REPLACE FUNCTION SP_ROLLUP_TIMEPHASE
(
     p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TP_PROJECT IS
         SELECT PROJECT_ID
         FROM TIMEPHASED_PROJECT
         WHERE FLAG = 'X';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ROLLUP_TIMEPHASE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ROLLUP_TIMEPHASE'), '-- ' || SYSTIMESTAMP, ':r := SP_ROLLUP_TIMEPHASE(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ROLLUP_TIMEPHASE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ROLLUP_TIMEPHASE(24) : timephase.sql(6044) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_project_id := p_project_id;
   
   If (h_project_id IS NULL) Then
      BEGIN
         UPDATE TIMEPHASED_PROJECT
         SET FLAG = 'X'
         WHERE FLAG = 'I';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 45+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(46) : timephase.sql(6066) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_TP_PROJECT;
      
      LOOP
         FETCH C_TP_PROJECT INTO h_project_id;
         IF C_TP_PROJECT%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         --trace_printf("h_project_id: %d;%s\n", h_project_id_Ind, h_project_id);
         PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
         PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
         
         COMMIT;
      END LOOP;
      BEGIN
         CLOSE C_TP_PROJECT ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(79) : timephase.sql(6099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TIMEPHASED_PROJECT WHERE FLAG = 'X';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(96) : timephase.sql(6116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --trace_printf("h_project_id: %d;%s\n", h_project_id_Ind, h_project_id);
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
      
      BEGIN
         DELETE FROM TIMEPHASED_PROJECT
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(118) : timephase.sql(6138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      COMMIT;
   End If;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ROLLUP_TIMEPHASE', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ROLLUP_TIMEPHASE(130) : timephase.sql(6150) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(137) : timephase.sql(6157) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP_TIMEPHASE', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP_TIMEPHASE(149) : timephase.sql(6169) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ROLLUP_TIMEPHASE;
ALTER FUNCTION SP_ROLLUP_TIMEPHASE COMPILE DEBUG;

-- END TIMEPHASE

/*****************************************************************************************/

-- rebuild sched timephase records for labor related chargecodes from task_day_of_year

/*****************************************************************************************/

Prompt == FUNCTION FC_Rebuild_Labor_Timephase ==
CREATE OR REPLACE FUNCTION FC_Rebuild_Labor_Timephase
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_timephase_flag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_Rebuild_Labor_Timephase') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_Rebuild_Labor_Timephase'), '-- ' || SYSTIMESTAMP, ':r := FC_Rebuild_Labor_Timephase(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rebuild_Labor_Timephase', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_Rebuild_Labor_Timephase(14) : timephase.sql(6205) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
   PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM Lev_delta_tmy';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- expense
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'EXPENSE_HOURS', TA.LABOR_COST_CC_ID,
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN), SUM(TDY.SCHED_MIN * TA.REGULAR_COST)/(60.00)
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id AND TDY.ACTUAL_FLAG = 0
      AND TA.PROJECT_ID = h_project_id
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_EXPENSE_LABOR
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(50) : timephase.sql(6241) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- capital
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'CAPITAL_HOURS', TA.LABOR_COST_CC_ID,
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN), SUM(TDY.SCHED_MIN * TA.REGULAR_COST)/(60.00)
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id AND TDY.ACTUAL_FLAG = 0
      AND TA.PROJECT_ID = h_project_id
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.CAPITAL_EXPENSE = PMO_CNST.SC_CAPITAL_LABOR
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(77) : timephase.sql(6268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- benefits
   BEGIN
      INSERT INTO Lev_delta_tmy
      SELECT TA.TASK_ID, 'BENEFIT_HOURS', TA.LABOR_REVENUE_CC_ID,
      PMO_ORASTD.YEAR(TDY.DAY_YEAR) AS BUDGET_YEAR, PMO_ORASTD.MONTH(TDY.DAY_YEAR) AS BUDGET_MONTH,
      SUM(TDY.SCHED_MIN), SUM(TDY.SCHED_MIN * TA.REGULAR_COST)/(60.00)
      FROM TASK_DAY_OF_YEAR TDY, TASK_ASSIGNMENTS TA
      WHERE TDY.PROJECT_ID = h_project_id AND TDY.ACTUAL_FLAG = 0
      AND TA.PROJECT_ID = h_project_id
      AND TA.TSK_ASSIGNMENT_ID = TDY.TSK_ASSIGNMENT_ID
      AND TA.BILLABLE = PMO_CNST.SC_BILLABLE_YES
      GROUP BY TA.TASK_ID, TDY.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(104) : timephase.sql(6295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_timephase_flag := 0;
   BEGIN
      SELECT SETTING_VALUE + 1 INTO h_timephase_flag
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_PERIOD';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 119+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(120) : timephase.sql(6311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- for latest version we have to join to fiscal calendar table to fix year and month!!!!!!!!!
   If Coalesce(h_timephase_flag, 0) > 1 Then
      BEGIN
         UPDATE Lev_delta_tmy
         SET BUDGET_YEAR = CASE WHEN BUDGET_MONTH < h_timephase_flag THEN (BUDGET_YEAR - 1) ELSE BUDGET_YEAR END,
         BUDGET_MONTH = CASE WHEN BUDGET_MONTH >= h_timephase_flag
         THEN (BUDGET_MONTH - h_timephase_flag + 1)
         ELSE (BUDGET_MONTH + 12 - h_timephase_flag + 1) END
         WHERE 1 = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(144) : timephase.sql(6335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_CHARGECODES
      WHERE CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE_HOUR, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_HOUR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_BENEFIT_HOUR, PMO_CNST.SC_BENEFIT_LABOR));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 165+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(166) : timephase.sql(6357) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_TIMEPHASE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, TASK_ID, CHARGECODE_ID, BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      SUM(BUDGET_HOURS)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 1 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 2 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 3 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 4 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 5 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 6 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 7 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 8 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 9 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 10 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 11 THEN BUDGET_HOURS ELSE 0 END)/60.00,
      SUM(CASE WHEN BUDGET_MONTH = 12 THEN BUDGET_HOURS ELSE 0 END)/60.00
      FROM Lev_delta_tmy
      GROUP BY TASK_ID, CHARGECODE_ID, BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 200+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(201) : timephase.sql(6392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_TIMEPHASE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT h_project_id, TASK_ID,
      LABOR_CC_ID,
      BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET,
      SUM(BUDGET_AMOUNT),
      SUM(CASE WHEN BUDGET_MONTH = 1 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 2 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 3 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 4 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 5 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 6 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 7 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 8 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 9 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 10 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 11 THEN BUDGET_AMOUNT ELSE 0 END),
      SUM(CASE WHEN BUDGET_MONTH = 12 THEN BUDGET_AMOUNT ELSE 0 END)
      FROM Lev_delta_tmy
      GROUP BY TASK_ID, LABOR_CC_ID, BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 237+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(238) : timephase.sql(6429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_TIMEPHASE (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, PMO_CNST.SC_SCHED_BUDGET, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND PROJECT_ID <> ELEMENT_ID
      AND BUDGET_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
      AND CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_CHARGECODES
      WHERE CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE_HOUR, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_HOUR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_BENEFIT_HOUR, PMO_CNST.SC_BENEFIT_LABOR));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 265+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(266) : timephase.sql(6457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      (SELECT PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE,
      SUM(TOTAL_AMOUNT),
      SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT), SUM(MONTH_04_AMOUNT),
      SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT), SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT),
      SUM(MONTH_09_AMOUNT), SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT)
      FROM PMO_TMP_TIMEPHASE
      GROUP BY PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 291+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(292) : timephase.sql(6483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN (PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
      MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
      (SELECT PROJECT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE,
      SUM(TOTAL_AMOUNT),
      SUM(MONTH_01_AMOUNT), SUM(MONTH_02_AMOUNT), SUM(MONTH_03_AMOUNT), SUM(MONTH_04_AMOUNT),
      SUM(MONTH_05_AMOUNT), SUM(MONTH_06_AMOUNT), SUM(MONTH_07_AMOUNT), SUM(MONTH_08_AMOUNT),
      SUM(MONTH_09_AMOUNT), SUM(MONTH_10_AMOUNT), SUM(MONTH_11_AMOUNT), SUM(MONTH_12_AMOUNT)
      FROM PROJECT_BUDGET_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND PROJECT_ID != ELEMENT_ID
      AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
      AND CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_CHARGECODES
      WHERE CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE_HOUR, PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_HOUR, PMO_CNST.SC_CAPITAL_LABOR, PMO_CNST.SC_BENEFIT_HOUR, PMO_CNST.SC_BENEFIT_LABOR))
      GROUP BY PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_Rebuild_Labor_Timephase', 322+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_Rebuild_Labor_Timephase(323) : timephase.sql(6514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_Rebuild_Labor_Timephase', 328+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_Rebuild_Labor_Timephase(329) : timephase.sql(6520) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_Rebuild_Labor_Timephase;
ALTER FUNCTION FC_Rebuild_Labor_Timephase COMPILE DEBUG;

/*****************************************************************************************/

-- rebuild sched timephase records for labor related chargecodes from task_day_of_year

/*****************************************************************************************/

Prompt == FUNCTION SP_REBUILD_LABOR_TIMEPHASE ==
CREATE OR REPLACE FUNCTION SP_REBUILD_LABOR_TIMEPHASE
(
     p_project_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_REBUILD_LABOR_TIMEPHASE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_REBUILD_LABOR_TIMEPHASE'), '-- ' || SYSTIMESTAMP, ':r := SP_REBUILD_LABOR_TIMEPHASE(' || 
       '''' || p_project_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_REBUILD_LABOR_TIMEPHASE', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_REBUILD_LABOR_TIMEPHASE(18) : timephase.sql(6552) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If (p_project_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_REBUILD_LABOR_TIMEPHASE', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_REBUILD_LABOR_TIMEPHASE(25) : timephase.sql(6559) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_REBUILD_LABOR_TIMEPHASE', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_REBUILD_LABOR_TIMEPHASE(28) : timephase.sql(6562) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_project_id, True);
   End If;
   
   h_project_id := p_project_id;
   PMO_DB2M.SC_STATE := FC_Rebuild_Labor_Timephase(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_REBUILD_LABOR_TIMEPHASE', 36+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_REBUILD_LABOR_TIMEPHASE(37) : timephase.sql(6571) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_project_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_project_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(44) : timephase.sql(6578) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_REBUILD_LABOR_TIMEPHASE', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_REBUILD_LABOR_TIMEPHASE(56) : timephase.sql(6590) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_REBUILD_LABOR_TIMEPHASE;
ALTER FUNCTION SP_REBUILD_LABOR_TIMEPHASE COMPILE DEBUG;

/*******************************************************************************
********************************************************************************/

Prompt == FUNCTION FC_TPHASE_SCHED_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_TPHASE_SCHED_ASSIGN
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_task_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_start_DT IN OUT NOCOPY TIMESTAMP
   , h_finish_DT IN OUT NOCOPY TIMESTAMP
   , sh_h_reg_cost NUMBER
   , sh_h_reg_sale NUMBER
   , sh_h_update PLS_INTEGER
   , sh_h_capital_expense PLS_INTEGER
   , sh_h_billable PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_reg_cost NUMBER := sh_h_reg_cost;
   h_reg_sale NUMBER := sh_h_reg_sale;
   h_update PLS_INTEGER := sh_h_update;
   h_capital_expense PLS_INTEGER := sh_h_capital_expense;
   h_billable PLS_INTEGER := sh_h_billable;
   h_cc_id VARCHAR2(32);
   h_labor_cost_cc_id VARCHAR2(32);
   h_labor_revenue_cc_id VARCHAR2(32);
   h_FD DATE;
   h_SD DATE;
   h_pa_timephase VARCHAR2(1);
   h_cur_year PLS_INTEGER := 0;
   h_budget_type PLS_INTEGER := 0;
   h_rollup_bits PLS_INTEGER := 0;
   h_01 NUMBER := 0;
   h_02 NUMBER := 0;
   h_03 NUMBER := 0;
   h_04 NUMBER := 0;
   h_05 NUMBER := 0;
   h_06 NUMBER := 0;
   h_07 NUMBER := 0;
   h_08 NUMBER := 0;
   h_09 NUMBER := 0;
   h_10 NUMBER := 0;
   h_11 NUMBER := 0;
   h_12 NUMBER := 0;
   h_total_h NUMBER := 0;
   h_d_total NUMBER := 0;
   h_d_01 NUMBER := 0;
   h_d_02 NUMBER := 0;
   h_d_03 NUMBER := 0;
   h_d_04 NUMBER := 0;
   h_d_05 NUMBER := 0;
   h_d_06 NUMBER := 0;
   h_d_07 NUMBER := 0;
   h_d_08 NUMBER := 0;
   h_d_09 NUMBER := 0;
   h_d_10 NUMBER := 0;
   h_d_11 NUMBER := 0;
   h_d_12 NUMBER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   stmt VARCHAR2(7999);
   l_actual_flag PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      -- Dynamic Cursor Declaration
      CTPH01 PMO_DB2M.REF_CURSOR;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TPHASE_SCHED_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TPHASE_SCHED_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_TPHASE_SCHED_ASSIGN(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_task_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_DT || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_reg_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_reg_sale), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_update), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_capital_expense), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_billable), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_SCHED_ASSIGN', 77+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TPHASE_SCHED_ASSIGN(78) : timephase.sql(6685) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_LONG(h_type);
   --  SC_LONG(h_end_year);
   --  SC_LONG(h_start_month);
   --  SC_LONG(h_end_month);
   
   h_SD := SubStr(h_start_DT, 1, 10);
   h_FD := SubStr(h_finish_DT, 1, 10);
   --trace_printf("h_update: %d, h_billable: %d, h_capital_expense: %d, h_reg_cost: %.2f, h_reg_sale: %.2f, h_SD: %s, h_FD: %s\n",h_update,h_billable,h_capital_expense,h_reg_cost,h_reg_sale,h_SD,h_FD);
   --trace_printf("h_project_id: %d:%s, h_task_id: %d:%s\n",h_project_id_Ind,h_project_id,h_task_id_Ind,h_task_id);
   
   If (Coalesce(Length(h_start_DT), 0) = 0) OR ((h_start_DT IS NULL)) 
         OR (Coalesce(Length(h_finish_DT), 0) = 0) OR ((h_finish_DT IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_SCHED_ASSIGN', 93+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_SCHED_ASSIGN(94) : timephase.sql(6701) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If Coalesce(h_billable, 0) >= PMO_CNST.SC_BIT_30 Then
      l_actual_flag := 1;
      h_billable := (BITAND(Coalesce(h_billable, 0), PMO_CNST.SC_BIT_NOT_30));
      -- remove actual flag
   End If;
   
   BEGIN
      SELECT LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID, CAPITAL_EXPENSE
      INTO h_labor_cost_cc_id, h_labor_revenue_cc_id, h_capital_expense
      FROM TASK_ASSIGNMENTS
      WHERE PROJECT_ID = h_project_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(117) : timephase.sql(6724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_SCHED_ASSIGN', 123+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_SCHED_ASSIGN(124) : timephase.sql(6731) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE Then
      h_capital_expense := PMO_CNST.SC_EXPENSE_LABOR;
   End If;
   
   If Coalesce(h_update, 0) < 0 Then
      h_update := -1;
   Else
      h_update := 1;
   End If;
   
   h_rollup_bits := PMO_CNST.SC_SCHED_DELTA_BIT;
   If PMO_ORASTD.strcmp(h_project_id, h_task_id) = 0 Then
      BEGIN
         SELECT TIMEPHASE_PROJECT_ASSIGNMENT INTO h_pa_timephase
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 150+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(151) : timephase.sql(6758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("1_* h_pa_timephase: %s\n", h_pa_timephase);
      
      If SubStr(h_pa_timephase, 1, 1) = 'Y' Then
         h_budget_type := PMO_CNST.SC_ESTIMATED_BUDGET;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_SCHED_ASSIGN', 160+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_SCHED_ASSIGN(161) : timephase.sql(6768) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN 0;
      End If;
   ElsIf l_actual_flag = 1 Then
      h_budget_type := PMO_CNST.SC_ACTUAL_BUDGET;
      --      h_rollup_bits = h_rollup_bits | SC_ACTUAL_DELTA_BIT;
      h_rollup_bits := PMO_CNST.SC_ACTUAL_DELTA_BIT;
   Else
      h_budget_type := PMO_CNST.SC_SCHED_BUDGET;
   End If;
   
   --  GET_FISCAL_DATE(h_SD, h_cur_year, h_start_month);
   --  GET_FISCAL_DATE(h_FD, h_end_year, h_end_month);
   
   --trace_printf("h_tsk_assignment_id: %s, l_actual_flag: %d, h_cur_year: %d, h_end_year: %d, h_budget_type: %d\n", h_tsk_assignment_id,l_actual_flag, h_cur_year, h_end_year, h_budget_type);
   
   stmt := '';
   If Coalesce(h_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
      stmt := 'SELECT FY.FISCAL_YEAR, '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 1)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 2)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 3)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 4)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 5)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 6)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 7)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 8)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 9)))), '
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 10)))),'
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 11)))),'
             || 'SUM(tdy.SCHED_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 12)))) '
             || 'FROM TASK_DAY_OF_YEAR tdy JOIN FISCAL_CALENDAR fy '
             || 'ON tdy.DAY_YEAR BETWEEN fy.START_DATE AND fy.FINISH_DATE '
             || 'WHERE tdy.PROJECT_ID = ''' || h_project_id || ''' AND tdy.PARENT_ID = ''' 
                  || h_tsk_assignment_id || ''' '
             || 'GROUP BY FY.FISCAL_YEAR ';
   ElsIf l_actual_flag = 1 Then
      stmt := 'SELECT FY.FISCAL_YEAR, '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 1)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 2)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 3)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 4)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 5)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 6)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 7)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 8)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 9)))), '
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 10)))),'
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 11)))),'
             || 'SUM(tdy.ACTUAL_MIN * (1 - ABS(SIGN(fy.FISCAL_MONTH - 12)))) '
             || 'FROM TASK_DAY_OF_YEAR tdy JOIN FISCAL_CALENDAR fy '
             || 'ON tdy.DAY_YEAR BETWEEN fy.START_DATE AND fy.FINISH_DATE '
             || 'WHERE tdy.PROJECT_ID = ''' || h_project_id 
                  || ''' AND tdy.ACTUAL_FLAG = 1 AND tdy.TSK_ASSIGNMENT_ID = ''' 
                  || h_tsk_assignment_id || ''' '
             || 'GROUP BY FY.FISCAL_YEAR ';
   Else
      stmt := 'SELECT FY.FISCAL_YEAR, '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 1)))), '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 2)))), '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 3)))), '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 4)))),  '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 5)))),  '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 6)))),  '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 7)))),  '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 8)))),  '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 9)))),  '
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 10)))),'
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 11)))),'
             || 'SUM(CASE WHEN tdy.ACTUAL_FLAG = 0 THEN tdy.SCHED_MIN ELSE tdy.SCHED_MIN - tdy.ACTUAL_MIN END * (1 - ABS(SIGN(fy.FISCAL_MONTH - 12))))  '
             || 'FROM TASK_DAY_OF_YEAR tdy JOIN FISCAL_CALENDAR fy '
             || 'ON tdy.DAY_YEAR BETWEEN fy.START_DATE AND fy.FINISH_DATE '
             || 'WHERE tdy.PROJECT_ID = ''' || h_project_id || ''' AND tdy.TSK_ASSIGNMENT_ID = ''' 
                  || h_tsk_assignment_id || ''' '
             || 'GROUP BY FY.FISCAL_YEAR ';
   End If;
   --trace_printf("%s\n",(char *) stmt); //trace_flush();
   
   OPEN CTPH01 FOR stmt;
   
   LOOP
      FETCH CTPH01 INTO h_cur_year, h_01, h_02, h_03, h_04, h_05, h_06, h_07, h_08, h_09, h_10, h_11, h_12;
      IF CTPH01%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("FETCH: SC_STATE: %d, h_cur_year: %d, h_01: %d:%.2f\n", SC_STATE,h_cur_year,h_01_Ind,h_01);
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) OR ((h_01 IS NULL)) Then
         EXIT;
      End If;
      
      h_01 := (Coalesce(h_01, 0) / 60.00) * Coalesce(h_update, 0);
      h_02 := (Coalesce(h_02, 0) / 60.00) * Coalesce(h_update, 0);
      h_03 := (Coalesce(h_03, 0) / 60.00) * Coalesce(h_update, 0);
      h_04 := (Coalesce(h_04, 0) / 60.00) * Coalesce(h_update, 0);
      h_05 := (Coalesce(h_05, 0) / 60.00) * Coalesce(h_update, 0);
      h_06 := (Coalesce(h_06, 0) / 60.00) * Coalesce(h_update, 0);
      h_07 := (Coalesce(h_07, 0) / 60.00) * Coalesce(h_update, 0);
      h_08 := (Coalesce(h_08, 0) / 60.00) * Coalesce(h_update, 0);
      h_09 := (Coalesce(h_09, 0) / 60.00) * Coalesce(h_update, 0);
      h_10 := (Coalesce(h_10, 0) / 60.00) * Coalesce(h_update, 0);
      h_11 := (Coalesce(h_11, 0) / 60.00) * Coalesce(h_update, 0);
      h_12 := (Coalesce(h_12, 0) / 60.00) * Coalesce(h_update, 0);
      
      h_total_h := Coalesce(h_01, 0) + Coalesce(h_02, 0) + Coalesce(h_03, 0) + Coalesce(h_04, 0) 
                      + Coalesce(h_05, 0) + Coalesce(h_06, 0) + Coalesce(h_07, 0) + Coalesce(
                      h_08, 0) + Coalesce(h_09, 0) + Coalesce(h_10, 0) + Coalesce(h_11, 0) 
                      + Coalesce(h_12, 0);
      --trace_printf("h_total_h: %.2f, h_01: %.2f, h_02: %.2f, h_03: %.2f, h_04: %.2f, h_05: %.2f, h_06: %.2f, h_07: %.2f, h_08: %.2f, h_09: %.2f, h_10: %.2f, h_11: %.2f, h_12: %.2f\n", h_total_h,h_01,h_02,h_03,h_04,h_05,h_06,h_07,h_08,h_09,h_10,h_12,h_12);
      
      If Coalesce(h_total_h, 0) <> 0.0 Then
         If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR Then
            h_cc_id := 'EXPENSE_HOURS';
         Else
            h_cc_id := 'CAPITAL_HOURS';
         End If;
         
         BEGIN
            INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
            MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
            VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, h_total_h,
            h_01, h_02, h_03, h_04, h_05, h_06,
            h_07, h_08, h_09, h_10, h_11, h_12);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 297+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(298) : timephase.sql(6905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("EXPENSE_CAPITAL_HOURS: SC_STATE: %d, h_cc_id: %s, h_cur_year: %d, h_total_h: %.2f\n", SC_STATE,h_cc_id,h_cur_year,h_total_h);
         
         If l_actual_flag = 1 Then
            BEGIN
               INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
               VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, -1 * h_total_h,
               -1 * h_01, -1 * h_02, -1 * h_03, -1 * h_04, -1 * h_05, -1 * h_06,
               -1 * h_07, -1 * h_08, -1 * h_09, -1 * h_10, -1 * h_11, -1 * h_12);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 321+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(322) : timephase.sql(6929) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE BUDGETS
            SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,h_rollup_bits)
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id
            AND CHARGECODE_ID = h_cc_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 342+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(343) : timephase.sql(6950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_reg_cost, 0) <> 0.00 Then
            h_cc_id := h_labor_cost_cc_id;
            
            h_d_01 := Coalesce(h_01, 0) * Coalesce(h_reg_cost, 0);
            h_d_02 := Coalesce(h_02, 0) * Coalesce(h_reg_cost, 0);
            h_d_03 := Coalesce(h_03, 0) * Coalesce(h_reg_cost, 0);
            h_d_04 := Coalesce(h_04, 0) * Coalesce(h_reg_cost, 0);
            h_d_05 := Coalesce(h_05, 0) * Coalesce(h_reg_cost, 0);
            h_d_06 := Coalesce(h_06, 0) * Coalesce(h_reg_cost, 0);
            h_d_07 := Coalesce(h_07, 0) * Coalesce(h_reg_cost, 0);
            h_d_08 := Coalesce(h_08, 0) * Coalesce(h_reg_cost, 0);
            h_d_09 := Coalesce(h_09, 0) * Coalesce(h_reg_cost, 0);
            h_d_10 := Coalesce(h_10, 0) * Coalesce(h_reg_cost, 0);
            h_d_11 := Coalesce(h_11, 0) * Coalesce(h_reg_cost, 0);
            h_d_12 := Coalesce(h_12, 0) * Coalesce(h_reg_cost, 0);
            
            h_d_total := Coalesce(h_d_01, 0) + Coalesce(h_d_02, 0) + Coalesce(h_d_03, 0) + Coalesce(h_d_04, 0) 
                      + Coalesce(h_d_05, 0) + Coalesce(h_d_06, 0) + Coalesce(h_d_07, 0) + Coalesce(
                      h_d_08, 0) + Coalesce(h_d_09, 0) + Coalesce(h_d_10, 0) + Coalesce(h_d_11, 0) 
                      + Coalesce(h_d_12, 0);
            
            BEGIN
               INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
               VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, h_d_total,
               h_d_01, h_d_02, h_d_03, h_d_04, h_d_05, h_d_06,
               h_d_07, h_d_08, h_d_09, h_d_10, h_d_11, h_d_12);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 385+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(386) : timephase.sql(6993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("LABOR_COST: SC_STATE: %d, h_cur_year: %d, h_d_total: %.2f\n", SC_STATE,h_cur_year,h_d_total);
            
            If l_actual_flag = 1 Then
               BEGIN
                  INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
                  MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
                  VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, -1 * h_d_total,
                  -1 * h_d_01, -1 * h_d_02, -1 * h_d_03, -1 * h_d_04, -1 * h_d_05, -1 * h_d_06,
                  -1 * h_d_07, -1 * h_d_08, -1 * h_d_09, -1 * h_d_10, -1 * h_d_11, -1 * h_d_12);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 409+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(410) : timephase.sql(7017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,h_rollup_bits)
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id
               AND CHARGECODE_ID = h_cc_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 430+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(431) : timephase.sql(7038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_billable, 0) = PMO_CNST.SC_BILLABLE_YES Then
            h_cc_id := 'BENEFIT_HOURS';
            
            BEGIN
               INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
               MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
               VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, h_total_h,
               h_01, h_02, h_03, h_04, h_05, h_06,
               h_07, h_08, h_09, h_10, h_11, h_12);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 456+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(457) : timephase.sql(7064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("BILLABLE_HOURS: SC_STATE: %d, h_cur_year: %d, h_total_h: %.2f\n", SC_STATE,h_cur_year,h_total_h);
            
            If l_actual_flag = 1 Then
               BEGIN
                  INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
                  MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
                  VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, -1 * h_total_h,
                  -1 * h_01, -1 * h_02, -1 * h_03, -1 * h_04, -1 * h_05, -1 * h_06,
                  -1 * h_07, -1 * h_08, -1 * h_09, -1 * h_10, -1 * h_11, -1 * h_12);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 480+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(481) : timephase.sql(7088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,h_rollup_bits)
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id
               AND CHARGECODE_ID = h_cc_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 501+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(502) : timephase.sql(7109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_reg_sale, 0) <> 0.00 Then
               h_d_01 := Coalesce(h_01, 0) * Coalesce(h_reg_sale, 0);
               h_d_02 := Coalesce(h_02, 0) * Coalesce(h_reg_sale, 0);
               h_d_03 := Coalesce(h_03, 0) * Coalesce(h_reg_sale, 0);
               h_d_04 := Coalesce(h_04, 0) * Coalesce(h_reg_sale, 0);
               h_d_05 := Coalesce(h_05, 0) * Coalesce(h_reg_sale, 0);
               h_d_06 := Coalesce(h_06, 0) * Coalesce(h_reg_sale, 0);
               h_d_07 := Coalesce(h_07, 0) * Coalesce(h_reg_sale, 0);
               h_d_08 := Coalesce(h_08, 0) * Coalesce(h_reg_sale, 0);
               h_d_09 := Coalesce(h_09, 0) * Coalesce(h_reg_sale, 0);
               h_d_10 := Coalesce(h_10, 0) * Coalesce(h_reg_sale, 0);
               h_d_11 := Coalesce(h_11, 0) * Coalesce(h_reg_sale, 0);
               h_d_12 := Coalesce(h_12, 0) * Coalesce(h_reg_sale, 0);
               
               h_d_total := Coalesce(h_d_01, 0) + Coalesce(h_d_02, 0) + Coalesce(h_d_03, 0) + Coalesce(h_d_04, 0) 
                      + Coalesce(h_d_05, 0) + Coalesce(h_d_06, 0) + Coalesce(h_d_07, 0) + Coalesce(
                      h_d_08, 0) + Coalesce(h_d_09, 0) + Coalesce(h_d_10, 0) + Coalesce(h_d_11, 0) 
                      + Coalesce(h_d_12, 0);
               
               h_cc_id := h_labor_revenue_cc_id;
               BEGIN
                  INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
                  MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
                  MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
                  VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, h_d_total,
                  h_d_01, h_d_02, h_d_03, h_d_04, h_d_05, h_d_06,
                  h_d_07, h_d_08, h_d_09, h_d_10, h_d_11, h_d_12);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 543+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(544) : timephase.sql(7151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("LABOR_REVENU: SC_STATE: %d, h_cur_year: %d, h_d_total: %.2f\n", SC_STATE,h_cur_year,h_d_total);
               
               If l_actual_flag = 1 Then
                  BEGIN
                     INSERT INTO TIMEPHASED_DELTA ( PROJECT_ID, ELEMENT_ID, CHARGECODE_ID, BUDGET_YEAR, BUDGET_TYPE, TOTAL_AMOUNT,
                     MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
                     MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
                     VALUES(h_project_id, h_task_id, h_cc_id, h_cur_year, h_budget_type, -1 * h_d_total,
                     -1 * h_d_01, -1 * h_d_02, -1 * h_d_03, -1 * h_d_04, -1 * h_d_05, -1 * h_d_06,
                     -1 * h_d_07, -1 * h_d_08, -1 * h_d_09, -1 * h_d_10, -1 * h_d_11, -1 * h_d_12);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 567+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(568) : timephase.sql(7175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               BEGIN
                  UPDATE BUDGETS
                  SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,h_rollup_bits)
                  WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_task_id
                  AND CHARGECODE_ID = h_cc_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 588+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(589) : timephase.sql(7196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   END LOOP;
   BEGIN
      CLOSE CTPH01 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 604+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(605) : timephase.sql(7212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS
      SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,h_rollup_bits)
      WHERE ELEMENT_ID = h_task_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 623+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(624) : timephase.sql(7231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("TMT_WBS: SC_STATE: %d, h_rollup_bits: %d\n", SC_STATE,h_rollup_bits);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         UPDATE TMT_CRI
         SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,h_rollup_bits)
         WHERE ELEMENT_ID = h_task_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TPHASE_SCHED_ASSIGN', 644+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TPHASE_SCHED_ASSIGN(645) : timephase.sql(7252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TPHASE_SCHED_ASSIGN', 651+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TPHASE_SCHED_ASSIGN(652) : timephase.sql(7259) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TPHASE_SCHED_ASSIGN;
ALTER FUNCTION FC_TPHASE_SCHED_ASSIGN COMPILE DEBUG;

/******************************************************************************/

Prompt == FUNCTION FC_UPDATE_LABOR_BUDGET ==
CREATE OR REPLACE FUNCTION FC_UPDATE_LABOR_BUDGET
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_element_id IN OUT NOCOPY VARCHAR2
   , h_tsk_assignment_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_resource_id VARCHAR2(32);
   h_labor_cost_cc_id VARCHAR2(32);
   h_chargecode_id VARCHAR2(32);
   h_labor_revenue_cc_id VARCHAR2(32);
   h_capital_expense PLS_INTEGER := 0;
   h_billable PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UPDATE_LABOR_BUDGET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UPDATE_LABOR_BUDGET'), '-- ' || SYSTIMESTAMP, ':r := FC_UPDATE_LABOR_BUDGET(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_element_id || ''''
          || ', ' || '''' || h_tsk_assignment_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_LABOR_BUDGET', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UPDATE_LABOR_BUDGET(25) : timephase.sql(7294) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID, CAPITAL_EXPENSE, RESOURCE_ID
      INTO h_labor_cost_cc_id, h_labor_revenue_cc_id, h_capital_expense, h_resource_id
      FROM TASK_ASSIGNMENTS
      WHERE PROJECT_ID = h_project_id
      AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(40) : timephase.sql(7309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_LABOR_BUDGET', 46+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_LABOR_BUDGET(47) : timephase.sql(7316) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If (h_labor_cost_cc_id IS NULL) Then
      BEGIN
         SELECT LABOR_COST_CC_ID, LABOR_REVENUE_CC_ID, 
         CAPITAL_EXPENSE, BILLABLE
         INTO h_labor_cost_cc_id, h_labor_revenue_cc_id, 
         h_capital_expense, h_billable
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND DEFAULT_LABOR_FLAG = 'Y';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 67+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(68) : timephase.sql(7337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            SELECT ASSIGNMENT_BILLABLE_FLAG INTO h_billable
            FROM PROJECT_DETAILS 
            WHERE PROJECT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 83+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(84) : timephase.sql(7353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_labor_cost_cc_id := 'EXPENSE_LABOR';
         If Coalesce(h_billable, 0) = PMO_CNST.SC_BILLABLE_YES Then
            h_labor_revenue_cc_id := 'BILLABLE_BENEFIT_LABOR';
         Else
            h_labor_revenue_cc_id := NULL;
         End If;
         h_capital_expense := PMO_CNST.SC_EXPENSE_LABOR;
      End If;
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET LABOR_COST_CC_ID = h_labor_cost_cc_id,
         LABOR_REVENUE_CC_ID = h_labor_revenue_cc_id,
         CAPITAL_EXPENSE = h_capital_expense,
         BILLABLE = h_billable
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(116) : timephase.sql(7385) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE Then
      h_capital_expense := PMO_CNST.SC_EXPENSE_LABOR;
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS
         SET CAPITAL_EXPENSE = h_capital_expense
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_tsk_assignment_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 139+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(140) : timephase.sql(7409) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE BUDGETS
      SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576),
      TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
      WHERE PROJECT_ID = h_project_id
      AND ELEMENT_ID = h_element_id
      AND CHARGECODE_ID = h_labor_cost_cc_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(163) : timephase.sql(7432) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
         CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
         VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
         h_labor_cost_cc_id, h_capital_expense, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(184) : timephase.sql(7453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- update hour/average/fte chargecodes
   If Coalesce(h_capital_expense, 0) = PMO_CNST.SC_EXPENSE_LABOR Then
      --EXPENSE_HOURS
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 208+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(209) : timephase.sql(7478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'EXPENSE_HOURS', PMO_CNST.SC_EXPENSE_HOUR, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 229+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(230) : timephase.sql(7499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --EXPENSE_AVERAGE_COST
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_AVERAGE_COST';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 252+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(253) : timephase.sql(7522) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'EXPENSE_AVERAGE_COST', PMO_CNST.SC_EXPENSE_AVERAGE_COST, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 273+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(274) : timephase.sql(7543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --EXPENSE_FULL_TIME_EQUIVALENT
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'EXPENSE_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 296+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(297) : timephase.sql(7566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'EXPENSE_FULL_TIME_EQUIVALENT', PMO_CNST.SC_EXPENSE_FTE, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 317+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(318) : timephase.sql(7587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      --CAPITAL_HOURS
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 340+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(341) : timephase.sql(7610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'CAPITAL_HOURS', PMO_CNST.SC_CAPITAL_HOUR, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 361+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(362) : timephase.sql(7631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --CAPITAL_AVERAGE_COST
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_AVERAGE_COST';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(385) : timephase.sql(7654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'CAPITAL_AVERAGE_COST', PMO_CNST.SC_CAPITAL_AVERAGE_COST, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 405+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(406) : timephase.sql(7675) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --CAPITAL_FULL_TIME_EQUIVALENT
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'CAPITAL_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 428+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(429) : timephase.sql(7698) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'CAPITAL_FULL_TIME_EQUIVALENT', PMO_CNST.SC_CAPITAL_FTE, PMO_CNST.SC_BILLABLE_NO, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 449+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(450) : timephase.sql(7719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (h_labor_revenue_cc_id IS NOT NULL) Then
      --BENEFIT_LABOR
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = h_labor_revenue_cc_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 474+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(475) : timephase.sql(7744) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            h_labor_revenue_cc_id, PMO_CNST.SC_BENEFIT_LABOR, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 495+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(496) : timephase.sql(7765) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --BENEFIT_HOURS
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_HOURS';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 518+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(519) : timephase.sql(7788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'BENEFIT_HOURS', PMO_CNST.SC_BENEFIT_HOUR, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 539+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(540) : timephase.sql(7809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --BENEFIT_AVERAGE_RATE
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_AVERAGE_RATE';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 562+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(563) : timephase.sql(7832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'BENEFIT_AVERAGE_RATE', PMO_CNST.SC_BENEFIT_AVERAGE_COST, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 583+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(584) : timephase.sql(7853) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --BENEFIT_FULL_TIME_EQUIVALENT
      BEGIN
         UPDATE BUDGETS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, 1048576), TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_SCHED_DELTA_BIT)
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID = h_element_id
         AND CHARGECODE_ID = 'BENEFIT_FULL_TIME_EQUIVALENT';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 606+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(607) : timephase.sql(7876) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY,
            CHARGECODE_ID, CAPITAL_EXPENSE, BILLABLE, ROLLUP_BITS, TIMEPHASED_BITS, REC_USER)
            VALUES(SYS_GUID(), h_project_id, h_element_id, 31, h_rec_user,
            'BENEFIT_FULL_TIME_EQUIVALENT', PMO_CNST.SC_BENEFIT_FTE, PMO_CNST.SC_BILLABLE_YES, 1048576, PMO_CNST.SC_SCHED_DELTA_BIT, h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UPDATE_LABOR_BUDGET', 627+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UPDATE_LABOR_BUDGET(628) : timephase.sql(7897) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UPDATE_LABOR_BUDGET', 634+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UPDATE_LABOR_BUDGET(635) : timephase.sql(7904) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UPDATE_LABOR_BUDGET;
ALTER FUNCTION FC_UPDATE_LABOR_BUDGET COMPILE DEBUG;

/****************************************************************************************/

--BOOL_RETURN_CODE FC_TIMEPHASE_LEVELED_EX

--(

--)

--{

--    PMO_BEGIN_FUNCTION(FC_TIMEPHASE_LEVELED_EX);

--

--    //=====================================================================

--    // Declare Temporary Table

--    //=====================================================================

--    BEGIN_SQL

--        DECLARE GLOBAL TEMPORARY TABLE PMO_NEW_TIMEPHASE (

--            ELEMENT_ID          CHAR(32),

--            PROJECT_ID          CHAR(32),

--            BUDGET_YEAR         SMALLINT,

--            BUDGET_TYPE         SMALLINT,

--            CHARGECODE_ID       CHAR(32),

--            MONTH_01_AMOUNT     DECIMAL(18,2),

--            MONTH_02_AMOUNT     DECIMAL(18,2),

--            MONTH_03_AMOUNT     DECIMAL(18,2),

--            MONTH_04_AMOUNT     DECIMAL(18,2),

--            MONTH_05_AMOUNT     DECIMAL(18,2),

--            MONTH_06_AMOUNT     DECIMAL(18,2),

--            MONTH_07_AMOUNT     DECIMAL(18,2),

--            MONTH_08_AMOUNT     DECIMAL(18,2),

--            MONTH_09_AMOUNT     DECIMAL(18,2),

--            MONTH_10_AMOUNT     DECIMAL(18,2),

--            MONTH_11_AMOUNT     DECIMAL(18,2),

--            MONTH_12_AMOUNT     DECIMAL(18,2),

--            TOTAL_AMOUNT        DECIMAL(18,2)

--        ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED IN USRTS32K;

--    END_SQL_NOCHECK;

--

-- BEGIN_SQL

--        DECLARE GLOBAL TEMPORARY TABLE PMO_LABOR_BUDGETS (

--   FISCAL_YEAR     SMALLINT,

--   FISCAL_MONTH    SMALLINT,

--   PROJECT_ID     CHAR(32),

--          TASK_ID      CHAR(32),

--   CAPITAL_EXPENSE    SMALLINT,

--   BILLABLE     SMALLINT,

--   LABOR_COST     DECIMAL(18,2) WITH DEFAULT 0.00,

--   LABOR_RATE     DECIMAL(18,2) WITH DEFAULT 0.00

--  ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED IN USRTS32K;

--  END_SQL_NOCHECK;

-- //=====================================================================

--

-- SC_CHAR(h_project_id,SC_H_ID);

-- SC_CHAR(h_element_id,SC_H_ID);

--  SC_LONG(h_type_id);

--    SC_CHAR(h_SD, SC_H_DATE);

--    SC_CHAR(h_FD, SC_H_DATE);

--    SC_CHAR(h_period_start, SC_H_DATE);

--    SC_CHAR(h_period_finish, SC_H_DATE);

-- SC_CHAR(h_chargecode_id,SC_H_ID);

--    SC_LONG(h_type);

--    SC_LONG(h_year);

--    SC_LONG(h_month);

--    SC_DOUBLE(h_total_amount);

-- SC_LONG(h_month_01_flag);

--    SC_LONG(h_month_02_flag);

--    SC_LONG(h_month_03_flag);

--    SC_LONG(h_month_04_flag);

--    SC_LONG(h_month_05_flag);

--    SC_LONG(h_month_06_flag);

--    SC_LONG(h_month_07_flag);

--    SC_LONG(h_month_08_flag);

--    SC_LONG(h_month_09_flag);

--    SC_LONG(h_month_10_flag);

--    SC_LONG(h_month_11_flag);

--    SC_LONG(h_month_12_flag);

--

--    BEGIN_SQL

--        DECLARE CTPLF_A1 CURSOR WITH HOLD FOR

--        SELECT PROJECT_ID,

--    ELEMENT_ID,

--    TYPE_ID,

--                DATE(UNRESOLVED_START),

--                DATE(UNRESOLVED_FINISH),

--    DATE(LEVEL_START),

--    DATE(LEVEL_FINISH)

--        FROM SESSION.LEV_TMT_WBS

--  WHERE LEVEL_START IS NOT SC_NULL

--  AND LEVEL_FINISH IS NOT SC_NULL

--  ORDER BY PROJECT_ID, RANK DESC

--  FOR READ ONLY;

--    END_SQL_NOCHECK;

--

--    BEGIN_SQL

--        OPEN CTPLF_A1;

--    END_SQL;

--

--    while (1 == 1)

--    {

--        BEGIN_SQL

--            FETCH CTPLF_A1 INTO HOST(h_project_id),

--        HOST(h_element_id),

--        HOST(h_type_id),

--        HOST(h_SD),

--        HOST(h_FD),

--        HOST(h_period_start),

--        HOST(h_period_finish);

--        END_SQL;

--        if (SC_NOSUCCESS) break;

--

--//AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

--  // Non-Labor Charge Codes

--  BEGIN_SQL

--   DECLARE CTPLF_A2 CURSOR WITH HOLD FOR

--   SELECT CHARGECODE_ID, (BUDGET-ACTUAL)

--   FROM BUDGETS

--   WHERE PROJECT_ID = HOST(h_project_id)

--   AND ELEMENT_ID = HOST(h_element_id)

--   AND CHARGECODE_ID NOT IN ( SELECT ELEMENT_ID

--          FROM TMT_CHARGECODES

--          WHERE RANK < '0000' )

--   FOR READ ONLY;

--  END_SQL_NOCHECK;

--

--  BEGIN_SQL

--   OPEN CTPLF_A2;

--  END_SQL;

--

--  while (1 == 1)

--  {

--   BEGIN_SQL

--    FETCH CTPLF_A2 INTO HOST(h_chargecode_id), HOST(h_total_amount);

--   END_SQL;

--   if (SC_NOSUCCESS) break;

--

--   if (isTask(h_type_id))

--   {

--    // time-phase WBS remaining

--    InitializeHost(SC_PARAM(h_type), SC_WBS_LEVELED_BUDGET);

--   }

--   else //if (!(isTask(h_type)))

--   {

--    BEGIN_SQL

--     DECLARE CTPLF_A3 CURSOR WITH HOLD FOR

--     SELECT BUDGET_TYPE,

--       BUDGET_YEAR,

--       SIGN(MONTH_01_AMOUNT),

--       SIGN(MONTH_02_AMOUNT),

--       SIGN(MONTH_03_AMOUNT),

--       SIGN(MONTH_04_AMOUNT),

--       SIGN(MONTH_05_AMOUNT),

--       SIGN(MONTH_06_AMOUNT),

--       SIGN(MONTH_07_AMOUNT),

--       SIGN(MONTH_08_AMOUNT),

--       SIGN(MONTH_09_AMOUNT),

--       SIGN(MONTH_10_AMOUNT),

--       SIGN(MONTH_11_AMOUNT),

--       SIGN(MONTH_12_AMOUNT)

--     FROM PROJECT_BUDGET_BREAKDOWN

--     WHERE PROJECT_ID = HOST(h_project_id)

--     AND ELEMENT_ID = HOST(h_element_id)

--     AND CHARGECODE_ID = HOST(h_chargecode_id)

--     AND BUDGET_TYPE = SC_ESTIMATED_ACTUAL_BUDGET

--     AND TOTAL_AMOUNT > 0

--     ORDER BY BUDGET_YEAR DESC

--     FOR READ ONLY;

--    END_SQL_NOCHECK;

--

--    BEGIN_SQL

--     OPEN CTPLF_A3;

--    END_SQL;

--

--    BEGIN_SQL

--     FETCH CTPLF_A3 INTO HOST(h_type),

--          HOST(h_year),

--          HOST(h_month_01_flag),

--          HOST(h_month_02_flag),

--          HOST(h_month_03_flag),

--          HOST(h_month_04_flag),

--          HOST(h_month_05_flag),

--          HOST(h_month_06_flag),

--          HOST(h_month_07_flag),

--          HOST(h_month_08_flag),

--          HOST(h_month_09_flag),

--          HOST(h_month_10_flag),

--          HOST(h_month_11_flag),

--          HOST(h_month_12_flag);

--    END_SQL;

--

--    if (SC_SUCCESS)

--    {

--     BEGIN_SQL

--      SELECT MONTH_01_AMOUNT*HOST(h_month_01_flag)+

--        MONTH_02_AMOUNT*HOST(h_month_02_flag)+

--        MONTH_03_AMOUNT*HOST(h_month_03_flag)+

--        MONTH_04_AMOUNT*HOST(h_month_04_flag)+

--        MONTH_05_AMOUNT*HOST(h_month_05_flag)+

--        MONTH_06_AMOUNT*HOST(h_month_06_flag)+

--        MONTH_07_AMOUNT*HOST(h_month_07_flag)+

--        MONTH_08_AMOUNT*HOST(h_month_08_flag)+

--        MONTH_09_AMOUNT*HOST(h_month_09_flag)+

--        MONTH_10_AMOUNT*HOST(h_month_10_flag)+

--        MONTH_11_AMOUNT*HOST(h_month_11_flag)+

--        MONTH_12_AMOUNT*HOST(h_month_12_flag)

--      INTO HOST(h_total_amount)

--      FROM PROJECT_BUDGET_BREAKDOWN

--      WHERE PROJECT_ID = HOST(h_project_id)

--      AND ELEMENT_ID = HOST(h_element_id)

--      AND CHARGECODE_ID = HOST(h_chargecode_id)

--      AND BUDGET_TYPE = SC_ESTIMATED_BUDGET

--      AND BUDGET_YEAR = HOST(h_year);

--     END_SQL;

--

--     BEGIN_SQL

--      SELECT SUM(TOTAL_AMOUNT) + HOST(h_total_amount)

--      INTO HOST(h_total_amount)

--      FROM PROJECT_BUDGET_BREAKDOWN

--      WHERE PROJECT_ID = HOST(h_project_id)

--      AND ELEMENT_ID = HOST(h_element_id)

--      AND CHARGECODE_ID = HOST(h_chargecode_id)

--      AND BUDGET_TYPE = SC_ESTIMATED_BUDGET

--      AND BUDGET_YEAR > HOST(h_year);

--     END_SQL;

--    }

--    else //if (strcmp(h_project_id,h_element_id) != SC_MATCH)

--    {

--     BEGIN_SQL

--      SELECT COALESCE(SUM(TOTAL_AMOUNT),0)

--      INTO HOST(h_total_amount)

--      FROM PROJECT_BUDGET_BREAKDOWN

--      WHERE PROJECT_ID = HOST(h_project_id)

--      AND ELEMENT_ID = HOST(h_element_id)

--      AND CHARGECODE_ID = HOST(h_chargecode_id)

--      AND BUDGET_TYPE = SC_ESTIMATED_BUDGET;

--     END_SQL;

--    }

--

--    BEGIN_SQL

--     CLOSE CTPLF_A3 WITH RELEASE;

--    END_SQL;

--

--    // time-phase WS remaining

--    InitializeHost(SC_PARAM(h_type), SC_WS_LEVELED_BUDGET);

--   }

--

--   // Go time-phase

--   if (h_total_amount > 0)

--   {

--    SC_STATE = FC_TIMEPHASE_AMOUNT( SC_PARAM(h_project_id),

--            SC_PARAM(h_element_id),

--            SC_PARAM(h_chargecode_id),

--            SC_PARAM(h_total_amount),

--            SC_PARAM(h_period_start),

--            SC_PARAM(h_period_finish),

--            SC_PARAM(h_type) );

--   }

--  }

--

--  BEGIN_SQL

--   CLOSE CTPLF_A2 WITH RELEASE;

--  END_SQL;

--

--//BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB

--  // Labor Charge Codes

--  if (isTask(h_type_id) || isProjectType(h_type_id))

--  {

--   BEGIN_SQL

--    INSERT INTO SESSION.PMO_LABOR_BUDGETS

--    SELECT  FC.FISCAL_YEAR,

--      FC.FISCAL_MONTH,

--      TDY.PROJECT_ID,

--      TA.TASK_ID,

--      TA.CAPITAL_EXPENSE,

--      TA.BILLABLE,

--      (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_COST AS LABOR_COST,

--      (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_RATE AS LABOR_RATE

--    FROM TASK_ASSIGNMENTS TA

--    JOIN LEVEL_TASK_DAY_OF_YEAR TDY

--     ON TDY.PROJECT_ID = TA.PROJECT_ID

--     AND TDY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID

--    JOIN FISCAL_CALENDAR FC

--     ON TDY.DAY_YEAR BETWEEN FC.START_DATE AND FC.FINISH_DATE

--    WHERE TA.PROJECT_ID = HOST(h_project_id)

--    AND TA.TASK_ID = HOST(h_element_id)

--    GROUP BY FC.FISCAL_YEAR,

--       FC.FISCAL_MONTH,

--       TDY.PROJECT_ID,

--       TA.TASK_ID,

--       TA.CAPITAL_EXPENSE,

--       TA.BILLABLE,

--       TA.REGULAR_COST,

--       TA.REGULAR_RATE;

--   END_SQL;

--

--   BEGIN_SQL

--    INSERT INTO SESSION.PMO_NEW_TIMEPHASE (

--      PROJECT_ID,

--      ELEMENT_ID,

--      CHARGECODE_ID,

--      BUDGET_YEAR,

--      BUDGET_TYPE,

--      MONTH_01_AMOUNT,

--      MONTH_02_AMOUNT,

--      MONTH_03_AMOUNT,

--      MONTH_04_AMOUNT,

--      MONTH_05_AMOUNT,

--      MONTH_06_AMOUNT,

--      MONTH_07_AMOUNT,

--      MONTH_08_AMOUNT,

--      MONTH_09_AMOUNT,

--      MONTH_10_AMOUNT,

--      MONTH_11_AMOUNT,

--      MONTH_12_AMOUNT,

--      TOTAL_AMOUNT )

--    SELECT PROJECT_ID,

--      TASK_ID,

--      CASE WHEN CAPITAL_EXPENSE = 0 THEN 'EXPENSE_LABOR'

--       WHEN CAPITAL_EXPENSE = 1 THEN 'CAPITAL_LABOR'

--       WHEN CAPITAL_EXPENSE = 2 THEN 'BENEFIT_LABOR' END,

--      FISCAL_YEAR,

--      CASE WHEN PROJECT_ID = TASK_ID THEN SC_WS_LEVELED_BUDGET ELSE SC_WBS_LEVELED_BUDGET END,

--      SUM(CASE WHEN FISCAL_MONTH =  1 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  2 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  3 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  4 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  5 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  6 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  7 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  8 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH =  9 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH = 10 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH = 11 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN FISCAL_MONTH = 12 THEN CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END ELSE 0.00 END),

--      SUM(CASE WHEN CAPITAL_EXPENSE = 2 THEN LABOR_RATE ELSE LABOR_COST END)

--    FROM SESSION.PMO_LABOR_BUDGETS

--    GROUP BY PROJECT_ID,

--       TASK_ID,

--       CAPITAL_EXPENSE,

--       FISCAL_YEAR;

--   END_SQL;

--  }

--

--  if (!(isTask(h_type_id)))

--  {

--   BEGIN_SQL

--    INSERT INTO SESSION.PMO_NEW_TIMEPHASE (

--      PROJECT_ID,

--      ELEMENT_ID,

--      CHARGECODE_ID,

--      BUDGET_YEAR,

--      BUDGET_TYPE,

--      MONTH_01_AMOUNT,

--      MONTH_02_AMOUNT,

--      MONTH_03_AMOUNT,

--      MONTH_04_AMOUNT,

--      MONTH_05_AMOUNT,

--      MONTH_06_AMOUNT,

--      MONTH_07_AMOUNT,

--      MONTH_08_AMOUNT,

--      MONTH_09_AMOUNT,

--      MONTH_10_AMOUNT,

--      MONTH_11_AMOUNT,

--      MONTH_12_AMOUNT,

--      TOTAL_AMOUNT )

--    SELECT HOST(h_project_id),

--      HOST(h_element_id),

--      F.CHARGECODE_ID,

--      F.BUDGET_YEAR,

--      F.BUDGET_TYPE,

--      SUM(F.MONTH_01_AMOUNT),

--      SUM(F.MONTH_02_AMOUNT),

--      SUM(F.MONTH_03_AMOUNT),

--      SUM(F.MONTH_04_AMOUNT),

--      SUM(F.MONTH_05_AMOUNT),

--      SUM(F.MONTH_06_AMOUNT),

--      SUM(F.MONTH_07_AMOUNT),

--      SUM(F.MONTH_08_AMOUNT),

--      SUM(F.MONTH_09_AMOUNT),

--      SUM(F.MONTH_10_AMOUNT),

--      SUM(F.MONTH_11_AMOUNT),

--      SUM(F.MONTH_12_AMOUNT),

--      SUM(F.TOTAL_AMOUNT)

--    FROM TMT_WBS W

--    JOIN TMT_WBS T

--     ON W.RANK < T.RANK

--     AND LENGTH(W.RANK) < LENGTH(T.RANK)

--     AND (LENGTH(T.RANK)-LENGTH(W.RANK)) = 4

--     AND LEFT(T.RANK,LENGTH(W.RANK)) = W.RANK

--    JOIN SESSION.PMO_NEW_TIMEPHASE F

--     ON F.PROJECT_ID = T.PROJECT_ID

--     AND F.ELEMENT_ID = T.ELEMENT_ID

--     AND F.BUDGET_TYPE = SC_WBS_LEVELED_BUDGET

--    WHERE W.PROJECT_ID = HOST(h_project_id)

--    AND W.ELEMENT_ID = HOST(h_element_id)

--    GROUP BY F.CHARGECODE_ID,

--       F.BUDGET_YEAR,

--       F.BUDGET_TYPE;

--   END_SQL;

--  }

--

--  BEGIN_SQL

--   DELETE FROM PROJECT_BUDGET_BREAKDOWN

--   WHERE PROJECT_ID = HOST(h_project_id)

--   AND ELEMENT_ID = HOST(h_element_id)

--   AND BUDGET_TYPE IN (SC_WS_LEVELED_BUDGET, SC_WBS_LEVELED_BUDGET);

--  END_SQL;

-- }

--

--    BEGIN_SQL

--        CLOSE CTPLF_A1 WITH RELEASE;

--    END_SQL;

--

--    BEGIN_SQL

--        INSERT INTO PROJECT_BUDGET_BREAKDOWN (

--    PROJECT_ID,

--    ELEMENT_ID,

--    CHARGECODE_ID,

--    BUDGET_YEAR,

--    BUDGET_TYPE,

--    MONTH_01_AMOUNT,

--    MONTH_02_AMOUNT,

--    MONTH_03_AMOUNT,

--    MONTH_04_AMOUNT,

--    MONTH_05_AMOUNT,

--    MONTH_06_AMOUNT,

--    MONTH_07_AMOUNT,

--    MONTH_08_AMOUNT,

--    MONTH_09_AMOUNT,

--    MONTH_10_AMOUNT,

--    MONTH_11_AMOUNT,

--    MONTH_12_AMOUNT,

--    TOTAL_AMOUNT,

--    PROCESS_FLAG )

--  SELECT  PROJECT_ID,

--    ELEMENT_ID,

--    CHARGECODE_ID,

--    BUDGET_YEAR,

--    BUDGET_TYPE,

--    SUM(MONTH_01_AMOUNT),

--    SUM(MONTH_02_AMOUNT),

--    SUM(MONTH_03_AMOUNT),

--    SUM(MONTH_04_AMOUNT),

--    SUM(MONTH_05_AMOUNT),

--    SUM(MONTH_06_AMOUNT),

--    SUM(MONTH_07_AMOUNT),

--    SUM(MONTH_08_AMOUNT),

--    SUM(MONTH_09_AMOUNT),

--    SUM(MONTH_10_AMOUNT),

--    SUM(MONTH_11_AMOUNT),

--    SUM(MONTH_12_AMOUNT),

--    SUM(TOTAL_AMOUNT),

--    'I'

--  FROM SESSION.PMO_NEW_TIMEPHASE

--  GROUP BY PROJECT_ID,

--     ELEMENT_ID,

--     CHARGECODE_ID,

--     BUDGET_YEAR,

--     BUDGET_TYPE;

--    END_SQL;

--

-- PMO_END_FUNCTION;

--}

/****************************************************************************************/

-- last updated date:December 24, 2004

-- AmirA:In this function the following temporary table are used:

-- LEV_TMT_WBS : contains all wbs elements that should be considered for leveling

Prompt == FUNCTION FC_TIMEPHASE_LEVELED ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_LEVELED RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_SD DATE;
   h_FD DATE;
   h_period_start DATE;
   h_period_finish DATE;
   h_first_year PLS_INTEGER := 0;
   h_first_month PLS_INTEGER := 0;
   h_timephase_start DATE;
   h_chargecode_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_total_amount NUMBER := 0;
   h_month_01_flag PLS_INTEGER := 0;
   h_month_02_flag PLS_INTEGER := 0;
   h_month_03_flag PLS_INTEGER := 0;
   h_month_04_flag PLS_INTEGER := 0;
   h_month_05_flag PLS_INTEGER := 0;
   h_month_06_flag PLS_INTEGER := 0;
   h_month_07_flag PLS_INTEGER := 0;
   h_month_08_flag PLS_INTEGER := 0;
   h_month_09_flag PLS_INTEGER := 0;
   h_month_10_flag PLS_INTEGER := 0;
   h_month_11_flag PLS_INTEGER := 0;
   h_month_12_flag PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_labor_flag PLS_INTEGER := 0;
   h_date_new DATE;
   h_date_old DATE;
-- Declare Cursors
      CURSOR CTPLF_B1 IS
         SELECT	PROJECT_ID, 
         ELEMENT_ID, 
         TYPE_ID, 
         TO_DATE(SubStr(UNRESOLVED_START, 1, 10)),
         TO_DATE(SubStr(UNRESOLVED_FINISH, 1, 10)),
         TO_DATE(SubStr(LEVEL_START, 1, 10)), 
         TO_DATE(SubStr(LEVEL_FINISH, 1, 10))  
         FROM LEV_TMT_WBS 
         WHERE LEVEL_START IS NOT NULL 
         AND LEVEL_FINISH IS NOT NULL 
         ORDER BY PROJECT_ID, RANK DESC;

      CURSOR CTPLF_B2 IS
         SELECT B.CHARGECODE_ID, (B.BUDGET-B.ACTUAL), SIGN(InStr(C.RANK, '!!!!'))
         FROM BUDGETS B 
         JOIN TMT_CHARGECODES C 
         ON C.ELEMENT_ID = B.CHARGECODE_ID 
         WHERE B.PROJECT_ID = h_project_id 
         AND B.ELEMENT_ID = h_element_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_LEVELED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_LEVELED'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_LEVELED();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_LEVELED', 61+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_LEVELED(62) : timephase.sql(8896) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_MONTH_FLAGS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_BUDGETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_NEW_TIMEPHASE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_LABOR_BUDGETS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   -- Populate monthly flag utility table
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(1,1,0,0,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(98) : timephase.sql(8932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(2,0,1,0,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(114) : timephase.sql(8948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(3,0,0,1,0,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 129+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(130) : timephase.sql(8964) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(4,0,0,0,1,0,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(146) : timephase.sql(8980) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(5,0,0,0,0,1,0,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(162) : timephase.sql(8996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(6,0,0,0,0,0,1,0,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(178) : timephase.sql(9012) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(7,0,0,0,0,0,0,1,0,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(194) : timephase.sql(9028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(8,0,0,0,0,0,0,0,1,0,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(210) : timephase.sql(9044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(9,0,0,0,0,0,0,0,0,1,0,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 225+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(226) : timephase.sql(9060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(10,0,0,0,0,0,0,0,0,0,1,0,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 241+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(242) : timephase.sql(9076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(11,0,0,0,0,0,0,0,0,0,0,1,0);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 257+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(258) : timephase.sql(9092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   BEGIN
      INSERT INTO PMO_MONTH_FLAGS VALUES(12,0,0,0,0,0,0,0,0,0,0,0,1);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 273+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(274) : timephase.sql(9108) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CTPLF_B1;
   
   LOOP
      FETCH CTPLF_B1 INTO	h_project_id, 
      h_element_id, 
      h_type_id, 
      h_SD, 
      h_FD, 
      h_period_start, 
      h_period_finish;
      IF CTPLF_B1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      -- Non-Labor Charge Codes
      
      OPEN CTPLF_B2;
      
      LOOP
         FETCH CTPLF_B2 INTO h_chargecode_id, h_total_amount, h_labor_flag;
         IF CTPLF_B2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         If isTask(Coalesce(h_type_id, 0)) <> 0 Then
            If (Coalesce(h_total_amount, 0) > 0.0) AND (Coalesce(h_labor_flag, 0) = 0) Then
               -- time-phase WBS remaining
               h_type := PMO_CNST.SC_WBS_LEVELED_BUDGET;
               
               -- Go time-phase
               PMO_DB2M.SC_STATE := FC_TIMEPHASE_AMOUNT(h_project_id, h_element_id, h_chargecode_id, h_total_amount
                                         , h_period_start, h_period_finish, h_type);
            End If;
         Else
            If Coalesce(h_labor_flag, 0) = 1 Then
               BEGIN
                  SELECT COUNT(TSK_ASSIGNMENT_ID) 
                  INTO h_labor_flag 
                  FROM TASK_ASSIGNMENTS 
                  WHERE PROJECT_ID = h_project_id
                  AND TASK_ID = h_element_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 335+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(336) : timephase.sql(9170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            If Coalesce(h_labor_flag, 0) = 0 Then
               -- time-phase WS remaining
               h_type := PMO_CNST.SC_WS_LEVELED_BUDGET;
               
               -- fetch time-phase data into monthly rows
               BEGIN
                  INSERT INTO PMO_BUDGETS 
                  SELECT	PBB.PROJECT_ID, 
                  PBB.ELEMENT_ID, 
                  PBB.CHARGECODE_ID, 
                  PBB.BUDGET_YEAR, 
                  MF.MID, 
                  SUM(
                  (CASE WHEN PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET THEN 1 ELSE 0 END) * (
                  PBB.MONTH_01_AMOUNT*MF.M01+PBB.MONTH_02_AMOUNT*MF.M02+PBB.MONTH_03_AMOUNT*MF.M03+ 
                  PBB.MONTH_04_AMOUNT*MF.M04+PBB.MONTH_05_AMOUNT*MF.M05+PBB.MONTH_06_AMOUNT*MF.M06+  
                  PBB.MONTH_07_AMOUNT*MF.M07+PBB.MONTH_08_AMOUNT*MF.M08+PBB.MONTH_09_AMOUNT*MF.M09+ 
                  PBB.MONTH_10_AMOUNT*MF.M10+PBB.MONTH_11_AMOUNT*MF.M11+PBB.MONTH_12_AMOUNT*MF.M12
                  )) AS MONTHLY_ESTIMATE,  
                  SUM(
                  (CASE WHEN PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET THEN 1 ELSE 0 END) * (
                  PBB.MONTH_01_AMOUNT*MF.M01+PBB.MONTH_02_AMOUNT*MF.M02+PBB.MONTH_03_AMOUNT*MF.M03+ 
                  PBB.MONTH_04_AMOUNT*MF.M04+PBB.MONTH_05_AMOUNT*MF.M05+PBB.MONTH_06_AMOUNT*MF.M06+  
                  PBB.MONTH_07_AMOUNT*MF.M07+PBB.MONTH_08_AMOUNT*MF.M08+PBB.MONTH_09_AMOUNT*MF.M09+ 
                  PBB.MONTH_10_AMOUNT*MF.M10+PBB.MONTH_11_AMOUNT*MF.M11+PBB.MONTH_12_AMOUNT*MF.M12
                  )) AS MONTHLY_ACTUAL,  
                  0 AS MONTHLY_AMOUNT
                  FROM PROJECT_BUDGET_BREAKDOWN PBB, PMO_MONTH_FLAGS MF 
                  WHERE PBB.PROJECT_ID = h_project_id 
                  AND PBB.ELEMENT_ID = h_element_id
                  AND PBB.CHARGECODE_ID = h_chargecode_id 
                  AND PBB.BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET) 
                  GROUP BY    PBB.PROJECT_ID, 
                  PBB.ELEMENT_ID, 
                  PBB.CHARGECODE_ID, 
                  PBB.BUDGET_YEAR, 
                  MF.MID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 388+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(389) : timephase.sql(9223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- get the difference between the old and new dates
               BEGIN
                  SELECT	PMO_ORASTD.LEFT(h_period_start, 8) || '01',  
                  PMO_ORASTD.LEFT(h_SD, 8) || '01' 
                  INTO	h_date_new, 
                  h_date_old 
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 406+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(407) : timephase.sql(9241) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT	CASE 
                  WHEN h_date_new >= h_date_old 
                  THEN PMO_ORASTD.DB2TIMESTAMPDIFF(64, TO_DATE(SubStr(h_date_new, 1, 10)), TO_DATE(SubStr(h_date_old, 1, 10))) 
                  ELSE PMO_ORASTD.DB2TIMESTAMPDIFF(64, TO_DATE(SubStr(h_date_new, 1, 10)), TO_DATE(SubStr(h_date_old, 1, 10))) 
                  END
                  INTO	h_diff 
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 425+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(426) : timephase.sql(9260) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- trace_printf("h_date_new: %s; h_date_old: %s; h_diff: %d\n", h_date_new, h_date_old, h_diff);
               -- update SESSION.PMO_BUDGETS using the difference
               BEGIN
                  UPDATE PMO_BUDGETS SET 
                  BUDGET_YEAR		=   BUDGET_YEAR + (
                  CASE 
                  WHEN (BUDGET_MONTH+h_diff) > 12 THEN (BUDGET_MONTH+h_diff)/12
                  WHEN (BUDGET_MONTH+h_diff) BETWEEN 1 AND 12 THEN 0 
                  WHEN (BUDGET_MONTH+h_diff) < 0 THEN ((BUDGET_MONTH+h_diff)/12) - 1 
                  END), 
                  BUDGET_MONTH	=	CASE 
                  WHEN (BUDGET_MONTH+h_diff) > 12 THEN MOD((BUDGET_MONTH+h_diff),12) 
                  WHEN (BUDGET_MONTH+h_diff) BETWEEN 1 AND 12 THEN (BUDGET_MONTH+h_diff)
                  WHEN (BUDGET_MONTH+h_diff) < 0 THEN 12+(BUDGET_MONTH+h_diff)
                  END, 
                  MONTHLY_AMOUNT	=	CASE WHEN (MONTHLY_ESTIMATE - MONTHLY_ACTUAL) < 0 THEN 0 ELSE (MONTHLY_ESTIMATE - MONTHLY_ACTUAL) END 
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 459+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(460) : timephase.sql(9294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- pivot back into the 12 months per record format
               BEGIN
                  INSERT INTO PMO_NEW_TIMEPHASE 
                  SELECT  B.PROJECT_ID, 
                  B.ELEMENT_ID, 
                  B.BUDGET_YEAR, 
                  h_type, 
                  B.CHARGECODE_ID, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-1)))*B.MONTHLY_AMOUNT), -- AS MONTH_01_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-2)))*B.MONTHLY_AMOUNT), -- AS MONTH_02_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-3)))*B.MONTHLY_AMOUNT), -- AS MONTH_03_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-4)))*B.MONTHLY_AMOUNT), -- AS MONTH_04_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-5)))*B.MONTHLY_AMOUNT), -- AS MONTH_05_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-6)))*B.MONTHLY_AMOUNT), -- AS MONTH_06_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-7)))*B.MONTHLY_AMOUNT), -- AS MONTH_07_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-8)))*B.MONTHLY_AMOUNT), -- AS MONTH_08_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-9)))*B.MONTHLY_AMOUNT), -- AS MONTH_09_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-10)))*B.MONTHLY_AMOUNT), -- AS MONTH_10_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-11)))*B.MONTHLY_AMOUNT), -- AS MONTH_11_AMOUNT, 
                  SUM((1-ABS(SIGN(BUDGET_MONTH-12)))*B.MONTHLY_AMOUNT), -- AS MONTH_12_AMOUNT, 
                  SUM(B.MONTHLY_AMOUNT)
                  FROM PMO_BUDGETS B 
                  WHERE PROJECT_ID = h_project_id 
                  AND ELEMENT_ID = h_element_id
                  AND CHARGECODE_ID = h_chargecode_id 
                  GROUP BY    B.PROJECT_ID, 
                  B.ELEMENT_ID, 
                  B.CHARGECODE_ID, 
                  B.BUDGET_YEAR;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 503+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(504) : timephase.sql(9338) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE CTPLF_B2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 519+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(520) : timephase.sql(9354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
      -- Labor Charge Codes
      If isTask(Coalesce(h_type_id, 0)) <> 0 OR isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         BEGIN
            INSERT INTO PMO_LABOR_BUDGETS 
            SELECT  FC.FISCAL_YEAR, 
            FC.FISCAL_MONTH, 
            TDY.PROJECT_ID, 
            TA.TASK_ID, 
            TA.LABOR_COST_CC_ID,
            TA.LABOR_REVENUE_CC_ID,
            TA.CAPITAL_EXPENSE, 
            TA.BILLABLE, 
            (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_COST AS LABOR_COST, 
            (SUM(TDY.SCHED_MIN)/60.0)*TA.REGULAR_RATE AS LABOR_RATE  
            FROM TASK_ASSIGNMENTS TA 
            JOIN LEVEL_TASK_DAY_OF_YEAR TDY 
            ON TDY.PROJECT_ID = TA.PROJECT_ID 
            AND TDY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID 
            JOIN FISCAL_CALENDAR FC 
            ON TDY.DAY_YEAR BETWEEN FC.START_DATE AND FC.FINISH_DATE  
            WHERE TA.PROJECT_ID = h_project_id 
            AND TA.TASK_ID = h_element_id 
            GROUP BY	FC.FISCAL_YEAR, 
            FC.FISCAL_MONTH, 
            TDY.PROJECT_ID, 
            TA.TASK_ID, 
            TA.CAPITAL_EXPENSE,
            TA.LABOR_COST_CC_ID,
            TA.LABOR_REVENUE_CC_ID,
            TA.BILLABLE, 
            TA.REGULAR_COST, 
            TA.REGULAR_RATE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 567+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(568) : timephase.sql(9402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Expense and Capital
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	PROJECT_ID, 
            TASK_ID,
            LABOR_COST_CC_ID,
            FISCAL_YEAR, 
            CASE WHEN PROJECT_ID = TASK_ID THEN PMO_CNST.SC_WS_LEVELED_BUDGET ELSE PMO_CNST.SC_WBS_LEVELED_BUDGET END, 
            SUM(CASE WHEN FISCAL_MONTH =  1 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  2 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  3 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  4 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  5 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  6 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  7 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  8 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  9 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN LABOR_COST ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN LABOR_COST ELSE 0.00 END), 
            SUM(LABOR_COST) 
            FROM PMO_LABOR_BUDGETS 
            WHERE PROJECT_ID = h_project_id 
            AND TASK_ID = h_element_id 
            GROUP BY	PROJECT_ID, 							
            TASK_ID, 
            LABOR_COST_CC_ID,
            CAPITAL_EXPENSE, 
            FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 629+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(630) : timephase.sql(9464) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Benefit
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	PROJECT_ID, 
            TASK_ID,
            LABOR_REVENUE_CC_ID,
            FISCAL_YEAR, 
            CASE WHEN PROJECT_ID = TASK_ID THEN PMO_CNST.SC_WS_LEVELED_BUDGET ELSE PMO_CNST.SC_WBS_LEVELED_BUDGET END, 
            SUM(CASE WHEN FISCAL_MONTH =  1 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  2 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  3 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  4 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  5 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  6 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  7 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  8 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH =  9 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 10 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 11 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(CASE WHEN FISCAL_MONTH = 12 THEN LABOR_RATE ELSE 0.00 END), 
            SUM(LABOR_RATE) 
            FROM PMO_LABOR_BUDGETS 
            WHERE PROJECT_ID = h_project_id 
            AND TASK_ID = h_element_id 
            AND LABOR_RATE > 0
            GROUP BY	PROJECT_ID, 
            TASK_ID, 
            LABOR_REVENUE_CC_ID,
            FISCAL_YEAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 691+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(692) : timephase.sql(9526) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If NOT (isTask(Coalesce(h_type_id, 0))) <> 0 Then
         BEGIN
            INSERT INTO PMO_NEW_TIMEPHASE ( 
            PROJECT_ID, 
            ELEMENT_ID, 
            CHARGECODE_ID, 
            BUDGET_YEAR, 
            BUDGET_TYPE, 
            MONTH_01_AMOUNT, 
            MONTH_02_AMOUNT, 
            MONTH_03_AMOUNT, 
            MONTH_04_AMOUNT, 
            MONTH_05_AMOUNT, 
            MONTH_06_AMOUNT, 
            MONTH_07_AMOUNT, 
            MONTH_08_AMOUNT, 
            MONTH_09_AMOUNT, 
            MONTH_10_AMOUNT, 
            MONTH_11_AMOUNT, 
            MONTH_12_AMOUNT, 
            TOTAL_AMOUNT ) 
            SELECT	h_project_id, 
            h_element_id, 
            F.CHARGECODE_ID, 
            F.BUDGET_YEAR, 
            F.BUDGET_TYPE, 
            SUM(F.MONTH_01_AMOUNT), 
            SUM(F.MONTH_02_AMOUNT), 
            SUM(F.MONTH_03_AMOUNT), 
            SUM(F.MONTH_04_AMOUNT), 
            SUM(F.MONTH_05_AMOUNT), 
            SUM(F.MONTH_06_AMOUNT), 
            SUM(F.MONTH_07_AMOUNT), 
            SUM(F.MONTH_08_AMOUNT), 
            SUM(F.MONTH_09_AMOUNT), 
            SUM(F.MONTH_10_AMOUNT), 
            SUM(F.MONTH_11_AMOUNT), 
            SUM(F.MONTH_12_AMOUNT), 
            SUM(F.TOTAL_AMOUNT) 
            FROM TMT_WBS W 
            JOIN TMT_WBS T
            ON W.RANK < T.RANK
            AND LENGTH(W.RANK) < LENGTH(T.RANK) 
            AND (LENGTH(T.RANK)-LENGTH(W.RANK)) = 4
            AND PMO_ORASTD.LEFT(T.RANK,LENGTH(W.RANK)) = W.RANK 
            JOIN PMO_NEW_TIMEPHASE F 
            ON F.PROJECT_ID = T.PROJECT_ID	
            AND F.ELEMENT_ID = T.ELEMENT_ID 
            AND F.BUDGET_TYPE = PMO_CNST.SC_WBS_LEVELED_BUDGET
            WHERE W.PROJECT_ID = h_project_id 
            AND W.ELEMENT_ID = h_element_id 
            GROUP BY	F.CHARGECODE_ID, 
            F.BUDGET_YEAR, 
            F.BUDGET_TYPE;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 761+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(762) : timephase.sql(9596) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN 
         WHERE PROJECT_ID = h_project_id 
         AND ELEMENT_ID = h_element_id 
         AND BUDGET_TYPE IN (PMO_CNST.SC_WS_LEVELED_BUDGET, PMO_CNST.SC_WBS_LEVELED_BUDGET);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 782+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(783) : timephase.sql(9617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CTPLF_B1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 796+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(797) : timephase.sql(9631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Update Physical Table
   BEGIN
      INSERT INTO PROJECT_BUDGET_BREAKDOWN ( 
      PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE, 
      MONTH_01_AMOUNT, 
      MONTH_02_AMOUNT, 
      MONTH_03_AMOUNT, 
      MONTH_04_AMOUNT, 
      MONTH_05_AMOUNT, 
      MONTH_06_AMOUNT, 
      MONTH_07_AMOUNT, 
      MONTH_08_AMOUNT, 
      MONTH_09_AMOUNT, 
      MONTH_10_AMOUNT, 
      MONTH_11_AMOUNT, 
      MONTH_12_AMOUNT, 
      TOTAL_AMOUNT,
      PROCESS_FLAG ) 
      SELECT 	PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE, 
      SUM(MONTH_01_AMOUNT), 
      SUM(MONTH_02_AMOUNT), 
      SUM(MONTH_03_AMOUNT), 
      SUM(MONTH_04_AMOUNT), 
      SUM(MONTH_05_AMOUNT), 
      SUM(MONTH_06_AMOUNT), 
      SUM(MONTH_07_AMOUNT), 
      SUM(MONTH_08_AMOUNT), 
      SUM(MONTH_09_AMOUNT), 
      SUM(MONTH_10_AMOUNT), 
      SUM(MONTH_11_AMOUNT), 
      SUM(MONTH_12_AMOUNT), 
      SUM(TOTAL_AMOUNT), 
      'I' 
      FROM PMO_NEW_TIMEPHASE
      GROUP BY	PROJECT_ID, 
      ELEMENT_ID, 
      CHARGECODE_ID, 
      BUDGET_YEAR, 
      BUDGET_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_LEVELED', 858+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_LEVELED(859) : timephase.sql(9693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_LEVELED', 864+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_LEVELED(865) : timephase.sql(9699) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_LEVELED;
ALTER FUNCTION FC_TIMEPHASE_LEVELED COMPILE DEBUG;

