/****************************************************************************************/

Prompt == FUNCTION FC_I_FS_VENDOR ==
CREATE OR REPLACE FUNCTION FC_I_FS_VENDOR
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_parm_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_res_id IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_parm_type_id PLS_INTEGER := sh_h_parm_type_id;
   h_ra_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_rate_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_root_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_currency_id PLS_INTEGER := 0;
   h_clearance_level_1 PLS_INTEGER := 0;
   h_clearance_level_2 PLS_INTEGER := 0;
   h_clearance_level_3 PLS_INTEGER := 0;
   h_clearance_level_4 PLS_INTEGER := 0;
   h_clearance_level_5 PLS_INTEGER := 0;
   h_psw_versions PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_FS_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_FS_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := FC_I_FS_VENDOR(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_parm_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_res_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_FS_VENDOR', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_FS_VENDOR(46) : vendors.sql(49) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_type_id := h_parm_type_id;
   
   If (h_res_id IS NULL) Then
      h_uniqueID := SYS_GUID();
   Else
      h_uniqueID := h_res_id;
   End If;
   
   BEGIN 
      SELECT REC_STATUS INTO h_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_rec_user; 
      IF SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') THEN 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, False); 
      END IF; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_rec_user, False); 
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RES_FS Then
      h_bitflag := 1;
      -- FS resource
      h_type_id := PMO_CNST.SC_RESOURCE;
      /*p_type_id = SC_RESOURCE;*/
   End If;
   
   If ((h_type_id IS NOT NULL)) AND (Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_psw_versions FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'MAX_PASSWORD_BACKUP_VERSIONS';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(86) : vendors.sql(89) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --tjtjtjtjtjtj
      BEGIN
         SELECT SETTING_VALUE INTO h_currency_id
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = 'SYSTEM_DEFAULT_CURRENCY';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(102) : vendors.sql(105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --res defalut security (tudor)
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_1 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_1';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(116) : vendors.sql(119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_2 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_2';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 127+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(128) : vendors.sql(131) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_3 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_3';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 139+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(140) : vendors.sql(143) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_4 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_4';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 151+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(152) : vendors.sql(155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      BEGIN
         SELECT SETTING_VALUE INTO h_clearance_level_5 FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CLEARANCE_LEVEL_5';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 163+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(164) : vendors.sql(167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rate_id := SYS_GUID();
      
      --Check whether Full name is unique in the Database
      BEGIN
         SELECT COUNT(RESOURCE_ID) INTO h_count
         FROM RESOURCES
         WHERE LOGON_NAME = RTRIM(LTRIM(h_name))
         OR FULL_NAME = RTRIM(LTRIM(h_name));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 182+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(183) : vendors.sql(186) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'FC_I_FS_VENDOR', 189+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: FC_I_FS_VENDOR(190) : vendors.sql(193) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LOGON_NOT_UNIQUE), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_FS_VENDOR', 192+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_I_FS_VENDOR(193) : vendors.sql(196) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.LOGON_NOT_UNIQUE, False);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_I_FS_VENDOR', 198+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_I_FS_VENDOR(199) : vendors.sql(202) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, False); 
      END;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_parent_id, h_max_rank);
      
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      --Execute Insert Statement
      BEGIN
         SELECT
         RTRIM(Rank) || h_rankBase64,
         LEVEL_ID + 1
         INTO
         h_rank,
         h_level_id
         FROM TMT_VENDORS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 228+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(229) : vendors.sql(232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_VENDORS(
         RANK,
         PARENT_ID,
         ELEMENT_ID,
         ELEMENT_NAME,
         TYPE_ID,
         LEVEL_ID,
         MANAGER_ID,
         REC_USER)
         VALUES (
         h_rank,
         h_parent_id,
         h_uniqueID,
         RTRIM(LTRIM(h_name)),
         PMO_CNST.SC_RESOURCE,
         h_level_id,
         h_rec_user,
         h_rec_user);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(263) : vendors.sql(266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO RESOURCES(
         RESOURCE_ID,
         FULL_NAME,
         CREATED_BY,
         ACTIVE,
         LOGON_NAME,
         LOGON_PASSWORD,
         KEY_HISTORY,
         PASSWORD_EXPIRES,
         FS_LABOR_CODE,
         MULTIPLE_LOGINS,
         CURRENCY_ID,
         RATE_ID,
         REC_USER,
         CITIZENSHIP,
         EFFECTIVE_DATE,
         EXPERIENCE_ID,
         WORK_LOCATION,
         CLEARANCE_LEVEL_1,
         CLEARANCE_LEVEL_2,
         CLEARANCE_LEVEL_3,
         CLEARANCE_LEVEL_4,
         CLEARANCE_LEVEL_5,
         STATUS1_ID,
         STATUS2_ID,
         MAXDAYHRS)
         VALUES ( 
         h_uniqueID,
         RTRIM(LTRIM(h_name)),
         h_rec_user,
         '1',
         RTRIM(LTRIM(h_name)),
         PMO_ORASTD.PMO_ENCRYPT(PMO_CNST.SC_DEFAULT_PWD_DB2_STR, h_uniqueID, ''),
         case WHEN h_psw_versions = 0 THEN NULL ELSE PMO_ORASTD.PMO_ENCRYPT(PMO_CNST.SC_PWD_KEY_HISTORY_DB2_STR, h_uniqueID, '') END,
         (TO_DATE(SYSDATE) - 1    ),
         PMO_CNST.SC_DEFAULT_PWD_DB2_STR,
         'Y',
         h_currency_id,
         h_rate_id,
         h_rec_user,
         2726,
         TO_DATE(SYSDATE),
         2771,
         265,
         h_clearance_level_1,
         h_clearance_level_2,
         h_clearance_level_3,
         h_clearance_level_4,
         h_clearance_level_5,
         312,
         318,
         40);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 330+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(331) : vendors.sql(334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO RATES (
         RATE_ID,
         REGULAR_COST,
         REGULAR_SALE,
         SPECIAL_COST,
         SPECIAL_SALE,
         REC_USER,
         REC_DATETIME)
         VALUES(
         h_rate_id,
         0.00,
         0.00,
         0.00,
         0.00,
         h_rec_user,
         SYSTIMESTAMP);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 362+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(363) : vendors.sql(366) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_id := h_rate_id;
      
      h_rate_id := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_RESOURCES SELECT h_rate_id, A.* FROM RESOURCES A
         WHERE A.RESOURCE_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(385) : vendors.sql(388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_RESOURCES SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 401+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(402) : vendors.sql(405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE RESOURCES SET REVISION_HISTORY = Null WHERE RESOURCE_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 418+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(419) : vendors.sql(422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_WBS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --Execute Insert Statement
         BEGIN
            SELECT
            RTRIM(p.Rank) || h_rankBase64,
            LEVEL_ID + 1
            INTO
            h_rank,
            h_level_id
            FROM TMT_WBS p WHERE p.ELEMENT_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 442+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(443) : vendors.sql(446) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO TMT_WBS (
            PROJECT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            TYPE_ID,
            LEVEL_ID,
            CREATED_BY,
            REC_USER,
            RANK)
            VALUES(
            h_uniqueID,
            h_uniqueID,
            RTRIM(LTRIM(h_name)),
            PMO_CNST.SC_RESOURCE,
            h_level_id,
            h_rec_user,
            h_rec_user,
            h_rank);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 476+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(477) : vendors.sql(480) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_ra_id := SYS_GUID();
      
      -- Validate parent_id
      If (h_parent_id IS NULL) Then
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_VENDORS', h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --Execute Insert Statement
         BEGIN
            SELECT
            RTRIM(COALESCE(RANK, '')) || h_rankBase64,
            LEVEL_ID + 1
            INTO
            h_rank,
            h_level_id
            FROM TMT_VENDORS WHERE ELEMENT_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 504+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(505) : vendors.sql(508) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO TMT_VENDORS(
            RANK,
            PARENT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            TYPE_ID,
            LEVEL_ID,
            MANAGER_ID,
            REC_USER)
            VALUES(
            h_rank,
            h_parent_id,
            h_uniqueID,
            h_name,
            h_type_id,
            h_level_id,
            h_rec_user,
            h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 538+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(539) : vendors.sql(542) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_root_id := h_uniqueID;
      Else
         --Validate Vendor
         BEGIN
            SELECT RANK INTO h_rank
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 555+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(556) : vendors.sql(559) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_FS_VENDOR', 562+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_FS_VENDOR(563) : vendors.sql(566) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_FS_VENDOR', 565+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_I_FS_VENDOR(566) : vendors.sql(569) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, False);
         End If;
         
         --Retrieve Vendor Root id
         BEGIN
            SELECT ELEMENT_ID INTO h_root_id FROM TMT_VENDORS
            WHERE RANK = SUBSTR( h_rank, 1, 8)
            AND PARENT_ID IS NuLL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 581+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(582) : vendors.sql(585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_FS_VENDOR', 588+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_FS_VENDOR(589) : vendors.sql(592) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_FS_VENDOR', 591+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_I_FS_VENDOR(592) : vendors.sql(595) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, False);
         End If;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_parent_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         
         --Execute Insert Statement
         BEGIN
            SELECT
            RTRIM(Rank) || h_rankBase64,
            LEVEL_ID + 1
            INTO
            h_rank,
            h_level_id
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 614+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(615) : vendors.sql(618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n2- SP_I_FS_VENDOR h_rank=%s,h_rank_Ind=%d, h_uniqueID=%s,h_uniqueID_Ind=%d,h_level_id=%d,h_level_id_Ind=%d,h_rec_user=%s,h_rec_user_Ind=%d\n",h_rank,h_rank_Ind, h_uniqueID,h_uniqueID_Ind,h_level_id,h_level_id_Ind,h_rec_user,h_rec_user_Ind);
         --trace_flush();
         
         BEGIN
            INSERT INTO TMT_VENDORS(
            RANK,
            PARENT_ID,
            ELEMENT_ID,
            ELEMENT_NAME,
            TYPE_ID,
            LEVEL_ID,
            MANAGER_ID,
            REC_USER)
            VALUES (
            h_rank,
            h_parent_id,
            h_uniqueID,
            h_name,
            h_type_id,
            h_level_id,
            h_rec_user,
            h_rec_user);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 651+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(652) : vendors.sql(655) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_rate_id := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_VENDORS SELECT h_rate_id, A.* FROM TMT_VENDORS A
         WHERE A.ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 672+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(673) : vendors.sql(676) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_VENDORS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_rate_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 689+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(690) : vendors.sql(693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_VENDORS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 706+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(707) : vendors.sql(710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO RESOURCE_ASSIGNMENTS (
         RES_ASSIGNMENT_ID,
         PROJECT_ID,
         ELEMENT_ID,
         ELEMENT_TYPE,
         RESOURCE_TYPE,
         RESOURCE_ID,
         PARTICIPANT,
         SECURITY_ID,
         REC_USER,
         REC_DATETIME,TABLE_TYPE)
         VALUES (
         h_ra_id,
         h_root_id,
         h_uniqueID,
         PMO_CNST.SC_VENDORS,
         '0',
         h_rec_user,
         PMO_CNST.SC_RESOURCE_MANAGER,
         'SCRESOURCEMANAGER',
         h_rec_user,
         SYSTIMESTAMP,PMO_CNST.SC_TABLE_VDR);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 744+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(745) : vendors.sql(748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = 0) AND (Coalesce(h_bitflag, 0) = 1) Then
      h_rec_user := h_uniqueID;
      h_parent_id := h_id;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'FC_I_FS_VENDOR', 756+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: FC_I_FS_VENDOR(757) : vendors.sql(760) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, False);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 763+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(764) : vendors.sql(767) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_FS_VENDOR', 775+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_FS_VENDOR(776) : vendors.sql(779) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_I_FS_VENDOR;
ALTER FUNCTION FC_I_FS_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_I_VENDOR ==
CREATE OR REPLACE FUNCTION SP_I_VENDOR
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(100);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_res_id VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_I_VENDOR(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_VENDOR', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_VENDOR(26) : vendors.sql(821) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_parent_id := p_parent_id;
   h_rec_user := p_rec_user;
   
   h_type_id := p_type;
   
   h_res_id := NULL;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_VENDOR', 37+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_I_VENDOR(38) : vendors.sql(833) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN FC_I_FS_VENDOR(h_name, h_parent_id, h_type_id, h_rec_user, h_res_id);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_VENDOR', 45+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_VENDOR(46) : vendors.sql(841) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_VENDOR', 57+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_VENDOR(58) : vendors.sql(853) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_VENDOR;
ALTER FUNCTION SP_I_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_NAME ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_NAME', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_NAME(24) : vendors.sql(893) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_NAME', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_NAME(32) : vendors.sql(901) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_NAME', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_NAME(35) : vendors.sql(904) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_NAME', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_NAME(43) : vendors.sql(912) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT TYPE_ID INTO h_type_id FROM TMT_VENDORS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(62) : vendors.sql(931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT COUNT(RESOURCE_ID) INTO h_count
         FROM RESOURCES WHERE FULL_NAME = RTRIM(LTRIM(p_name))
         AND RESOURCE_ID <> p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(78) : vendors.sql(947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_NAME', 84+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_NAME(85) : vendors.sql(954) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LOGON_NOT_UNIQUE), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_NAME', 87+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_NAME(88) : vendors.sql(957) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.LOGON_NOT_UNIQUE, True);
      End If;
      
      BEGIN
         UPDATE RESOURCES SET
         FULL_NAME = RTRIM(LTRIM(p_name)),
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER = p_rec_user
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(109) : vendors.sql(978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_VENDOR_NAME', 115+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_VENDOR_NAME(116) : vendors.sql(985) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_NAME', 118+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_NAME(119) : vendors.sql(988) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, p_id, True);
      End If;
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS
      SET ELEMENT_NAME = RTRIM(LTRIM(p_name)),
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(142) : vendors.sql(1011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT CASE
         WHEN EXISTS(SELECT ELEMENT_ID FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         ELSE 0 END
         into h_update
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 160+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(161) : vendors.sql(1030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_NAME', 167+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_NAME(168) : vendors.sql(1037) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 174+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(175) : vendors.sql(1044) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_NAME', 186+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_NAME(187) : vendors.sql(1056) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_NAME;
ALTER FUNCTION SP_U_VENDOR_NAME COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_DESC ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_DESC
(
     p_id VARCHAR2
   , p_label VARCHAR2
   , p_description VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_DESC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_DESC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_DESC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_label || ''''
          || ', ' || '''' || p_description || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_DESC', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_DESC(24) : vendors.sql(1096) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_DESC', 31+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_DESC(32) : vendors.sql(1104) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_DESC', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_DESC(35) : vendors.sql(1107) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_DESC', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_DESC(43) : vendors.sql(1115) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      LABEL        = p_label,
      DESCRIPTION  = p_description,
      REC_DATETIME = SYSTIMESTAMP,
      REC_USER     = p_rec_user
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(72) : vendors.sql(1144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT CASE
         WHEN EXISTS(SELECT ELEMENT_ID FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         ELSE 0 END
         INTO h_update
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 91+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(92) : vendors.sql(1164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_DESC', 98+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_DESC(99) : vendors.sql(1171) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 105+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(106) : vendors.sql(1178) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_DESC', 117+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_DESC(118) : vendors.sql(1190) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_DESC;
ALTER FUNCTION SP_U_VENDOR_DESC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_PUBLIC ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_PUBLIC
(
     p_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_PUBLIC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_PUBLIC'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_PUBLIC(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_PUBLIC', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_PUBLIC(19) : vendors.sql(1225) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   --SC_CHAR(h_id, SC_H_ID);
   --SC_CHAR(h_rec_status, SC_H_FLAG);
   --SC_LONG(h_update);
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_PUBLIC', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_PUBLIC(30) : vendors.sql(1236) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_PUBLIC', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_PUBLIC(33) : vendors.sql(1239) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      PUBLIC_FLAG = p_del_flag,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_PUBLIC', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_PUBLIC(55) : vendors.sql(1261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_PUBLIC', 60+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_PUBLIC(61) : vendors.sql(1267) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_PUBLIC', 67+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_PUBLIC(68) : vendors.sql(1274) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_PUBLIC', 79+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_PUBLIC(80) : vendors.sql(1286) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_PUBLIC;
ALTER FUNCTION SP_U_VENDOR_PUBLIC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_CIE ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_CIE
(
     p_id VARCHAR2
   , p_domain_id VARCHAR2
   , p_company_name VARCHAR2
   , p_address VARCHAR2
   , p_phone VARCHAR2
   , p_fax VARCHAR2
   , p_website VARCHAR2
   , p_other_location VARCHAR2
   , p_year_in_business PLS_INTEGER
   , p_client_more_100_employees PLS_INTEGER
   , p_client_more_1000_employees PLS_INTEGER
   , p_client_more_10000_employees PLS_INTEGER
   , p_number_employees PLS_INTEGER
   , p_contact_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_CIE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_CIE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_CIE(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_domain_id || ''''
          || ', ' || '''' || p_company_name || ''''
          || ', ' || '''' || p_address || ''''
          || ', ' || '''' || p_phone || ''''
          || ', ' || '''' || p_fax || ''''
          || ', ' || '''' || p_website || ''''
          || ', ' || '''' || p_other_location || ''''
          || ', ' || COALESCE(TO_CHAR(p_year_in_business), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_100_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_1000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_client_more_10000_employees), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_number_employees), 'NULL')
          || ', ' || '''' || p_contact_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_CIE', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_CIE(46) : vendors.sql(1348) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_CIE', 53+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_CIE(54) : vendors.sql(1356) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_CIE', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_CIE(57) : vendors.sql(1359) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_CIE', 64+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_CIE(65) : vendors.sql(1367) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      DOMAIN_ID = p_domain_id,
      COMPANY_NAME = p_company_name,
      ADDRESS = p_address,
      PHONE = p_phone,
      FAX = p_fax,
      WEBSITE = p_website,
      OTHER_LOCATION = p_other_location,
      YEAR_IN_BUSINESS = p_year_in_business,
      CLIENT_MORE_100_EMPLOYEES = p_client_more_100_employees,
      CLIENT_MORE_1000_EMPLOYEES = p_client_more_1000_employees,
      CLIENT_MORE_10000_EMPLOYEES = p_client_more_10000_employees,
      NUMBER_EMPLOYEES = p_number_employees,
      CONTACT_NAME = p_contact_name,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(105) : vendors.sql(1407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_VENDORS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 122+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(123) : vendors.sql(1425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_CIE', 129+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_CIE(130) : vendors.sql(1432) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 136+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(137) : vendors.sql(1439) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_CIE', 148+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_CIE(149) : vendors.sql(1451) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_CIE;
ALTER FUNCTION SP_U_VENDOR_CIE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_BKG ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_BKG
(
     p_id VARCHAR2
   , p_annual_revenues NUMBER
   , p_billing_address VARCHAR2
   , p_billing_phone VARCHAR2
   , p_billing_fax VARCHAR2
   , p_billing_email VARCHAR2
   , p_equal_opportunity VARCHAR2
   , p_company_background VARCHAR2
   , p_ownership VARCHAR2
   , p_services_offered VARCHAR2
   , p_services_specialized VARCHAR2
   , p_industries_served VARCHAR2
   , p_highlight VARCHAR2
   , p_location_served VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_update PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_BKG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_BKG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_BKG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_annual_revenues), 'NULL')
          || ', ' || '''' || p_billing_address || ''''
          || ', ' || '''' || p_billing_phone || ''''
          || ', ' || '''' || p_billing_fax || ''''
          || ', ' || '''' || p_billing_email || ''''
          || ', ' || '''' || p_equal_opportunity || ''''
          || ', ' || '''' || p_company_background || ''''
          || ', ' || '''' || p_ownership || ''''
          || ', ' || '''' || p_services_offered || ''''
          || ', ' || '''' || p_services_specialized || ''''
          || ', ' || '''' || p_industries_served || ''''
          || ', ' || '''' || p_highlight || ''''
          || ', ' || '''' || p_location_served || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_BKG', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_BKG(46) : vendors.sql(1513) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_BKG', 53+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_BKG(54) : vendors.sql(1521) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_BKG', 56+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_BKG(57) : vendors.sql(1524) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_BKG', 63+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_BKG(64) : vendors.sql(1531) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_VENDORS SET
      ANNUAL_REVENUES = p_annual_revenues,
      BILLING_ADDRESS = p_billing_address,
      BILLING_PHONE = p_billing_phone,
      BILLING_FAX = p_billing_fax,
      BILLING_EMAIL = p_billing_email,
      EQUAL_OPPORTUNITY = p_equal_opportunity,
      COMPANY_BACKGROUND = p_company_background,
      OWNERSHIP = p_ownership,
      SERVICES_OFFERED = p_services_offered,
      SERVICES_SPECIALIZED = p_services_specialized,
      INDUSTRIES_SERVED = p_industries_served,
      HIGHLIGHT = p_highlight,
      LOCATION_SERVED = p_location_served,
      REC_USER = p_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(104) : vendors.sql(1571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT
         case WHEN EXISTS( SELECT ELEMENT_ID FROM TMT_VENDORS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL) THEN 1
         else 0 END
         into h_update
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(122) : vendors.sql(1589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_BKG', 128+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_BKG(129) : vendors.sql(1596) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 135+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(136) : vendors.sql(1603) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_BKG', 147+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_BKG(148) : vendors.sql(1615) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_BKG;
ALTER FUNCTION SP_U_VENDOR_BKG COMPILE DEBUG;

/***************************************************************************************************
Rules for deleting vendors and Resources:
    if exists(resource assignments)
        cannot delete vendors
        cannot delete resource
    else
        do delete vendors and resources
***************************************************************************************************/

Prompt == FUNCTION SP_D_VENDOR ==
CREATE OR REPLACE FUNCTION SP_D_VENDOR
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_del_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_element_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_temp_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 11;
-- Declare Cursors
      CURSOR C_DEL IS
         SELECT ELEMENT_ID, TYPE_ID
         FROM TMT_VENDORS
         WHERE RANK LIKE h_rank || '%';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_D_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_del_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_VENDOR(34) : vendors.sql(1672) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_VENDOR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_VENDOR(39) : vendors.sql(1677) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_VENDOR(42) : vendors.sql(1680) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Local Variables
   
   h_rec_user := p_rec_user;
   
   --get RANK
   If (p_parent_id IS NULL) Then
      BEGIN
         SELECT RANK, REC_STATUS INTO h_rank, h_rec_status
         FROM TMT_VENDORS WHERE ELEMENT_ID = p_id AND PARENT_ID IS NuLL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 61+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(62) : vendors.sql(1700) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT RANK, REC_STATUS INTO h_rank, h_rec_status
         FROM TMT_VENDORS
         WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(77) : vendors.sql(1715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_VENDOR', 84+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_VENDOR(85) : vendors.sql(1723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 87+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_VENDOR(88) : vendors.sql(1726) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   BEGIN
      SELECT COUNT( RES_ASSIGNMENT_ID)  INTO h_count
      FROM TMT_VENDORS TP JOIN RESOURCE_ASSIGNMENTS RA ON RA.RESOURCE_ID = TP.ELEMENT_ID
      WHERE TP.TYPE_ID = PMO_CNST.SC_RESOURCE AND TP.RANK LIKE h_rank || '%';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(103) : vendors.sql(1741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_VENDOR', 109+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_VENDOR(110) : vendors.sql(1748) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_DEL_ACTUAL_EXISTS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 112+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_VENDOR(113) : vendors.sql(1751) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_DEL_ACTUAL_EXISTS, p_id, True);
   End If;
   If SubStr(p_del_flag, 1, 1) = '?' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_D_VENDOR', 118+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_D_VENDOR(119) : vendors.sql(1757) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(0), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 121+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_D_VENDOR(122) : vendors.sql(1760) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(0, p_id, True);
   End If;
   
   If SubStr(p_del_flag, 1, 1) = 'X' Then
      OPEN C_DEL;
      
      LOOP
         FETCH C_DEL INTO h_element_id, h_type_id;
         IF C_DEL%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
            BEGIN
               DELETE FROM CALENDAR_DAY_OF_YEAR
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 155+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(156) : vendors.sql(1794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CALENDARS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (
               SELECT PARENT_ID FROM TMT_CALENDARS
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 176+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(177) : vendors.sql(1815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_CALENDARS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 194+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(195) : vendors.sql(1833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_PORTFOLIOS SET
               CHILD_COUNT = CHILD_COUNT - (
               SELECT COUNT(*)
               FROM TMT_PORTFOLIOS
               WHERE PARENT_ID = h_element_id)
               WHERE ELEMENT_ID IS NULL;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(217) : vendors.sql(1855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT RTRIM(RANK) INTO h_temp_rank
               FROM TMT_PORTFOLIOS
               WHERE ELEMENT_ID = h_element_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 231+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(232) : vendors.sql(1870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_temp_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_temp_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_temp_rank, True); 
            	End If; 
            END;
            BEGIN
               DELETE FROM TMT_PORTFOLIOS
               WHERE RANK LIKE h_temp_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 262+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(263) : vendors.sql(1901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RATES
               WHERE RATE_ID IN (SELECT RATE_ID FROM RESOURCES WHERE RESOURCE_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(281) : vendors.sql(1919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_RESOURCES
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 298+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(299) : vendors.sql(1937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_EDUCATION
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 316+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(317) : vendors.sql(1955) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_EMPLOYMENT_HISTORY
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 334+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(335) : vendors.sql(1973) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_INDUSTRY_EXPERIENCE
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 352+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(353) : vendors.sql(1991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_PROJECT_HISTORY
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 370+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(371) : vendors.sql(2009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_READINESS
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 388+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(389) : vendors.sql(2027) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_COMPETENCIES SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_COMPETENCIES
               WHERE RESOURCE_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 408+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(409) : vendors.sql(2047) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_COMPETENCIES
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 426+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(427) : vendors.sql(2065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_id := NULL;
            --SC_STATE = FC_DELETE_DOC(h_id, h_element_id, h_rec_user);
            PMO_DB2M.SC_STATE := FC_DELETE_DOC(h_id, h_element_id, h_rec_user);
            
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               BEGIN
                  CLOSE C_DEL ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 444+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(445) : vendors.sql(2083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_VENDOR', 449+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_VENDOR(450) : vendors.sql(2088) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL'));
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 452+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_D_VENDOR(453) : vendors.sql(2091) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID_SP(PMO_DB2M.SC_STATE, True);
            End If;
            
            BEGIN
               UPDATE TMT_GEOGRAPHIES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_GEOGRAPHIES
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 472+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(473) : vendors.sql(2111) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_GEOGRAPHIES
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 490+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(491) : vendors.sql(2129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_ORGANIZATIONS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_ORGANIZATIONS
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(511) : vendors.sql(2149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_ORGANIZATIONS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 528+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(529) : vendors.sql(2167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CONTACTS SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (
               SELECT PARENT_ID FROM TMT_CONTACTS
               WHERE ELEMENT_ID = h_element_id)
               AND RANK LIKE '0000' || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 550+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(551) : vendors.sql(2189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_CONTACTS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 568+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(569) : vendors.sql(2207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_WBS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 586+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(587) : vendors.sql(2225) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE RESOURCES
               SET CALENDAR_ID = h_element_id,
               LOGON_NAME = RESOURCE_ID
               WHERE RESOURCE_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 606+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(607) : vendors.sql(2245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               DELETE FROM RESOURCE_ASSIGNMENTS
               WHERE PROJECT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 624+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(625) : vendors.sql(2263) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_VENDOR_ATTRIBUTES SET
               CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_VENDOR_ATTRIBUTES
               WHERE ELEMENT_ID = h_element_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 644+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(645) : vendors.sql(2283) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_VENDOR_ATTRIBUTES
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 662+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(663) : vendors.sql(2301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM HISTORY_VENDORS
               WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 680+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(681) : vendors.sql(2319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM VENDOR_REFERENCES
               WHERE VENDOR_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 698+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(699) : vendors.sql(2337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_DEL ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 713+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(714) : vendors.sql(2352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         DELETE FROM TMT_VENDORS WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 743+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(744) : vendors.sql(2382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (p_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_VENDORS SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 762+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(763) : vendors.sql(2401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDORS SET
            CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = p_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 781+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(782) : vendors.sql(2420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_D_VENDOR', 789+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_D_VENDOR(790) : vendors.sql(2428) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_MARKED_AS_DELETED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_VENDOR', 792+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_D_VENDOR(793) : vendors.sql(2431) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_MARKED_AS_DELETED, True);
      End If;
      
      If (p_parent_id IS NULL) Then
         BEGIN
            UPDATE TMT_VENDORS SET
            CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID IS NuLL;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 813+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(814) : vendors.sql(2452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_VENDORS SET
            CHILD_COUNT = CHILD_COUNT - 1,
            DELETED_COUNT = DELETED_COUNT + 1
            WHERE ELEMENT_ID = p_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 833+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(834) : vendors.sql(2472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_VENDORS SET
         REC_STATUS   = p_del_flag,
         REC_DATETIME = SYSTIMESTAMP,
         REC_USER     = p_rec_user
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ( 'I', 'O', 'U');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 868+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(869) : vendors.sql(2507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_VENDOR', 875+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_VENDOR(876) : vendors.sql(2514) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 882+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(883) : vendors.sql(2521) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_VENDOR', 894+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_VENDOR(895) : vendors.sql(2533) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_VENDOR;
ALTER FUNCTION SP_D_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_VENDOR_CPLAN ==
CREATE OR REPLACE FUNCTION SP_S_VENDOR_CPLAN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      -- Resultset Cursor Declaration
      SCP661a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661aa PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      SCP661bb PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_VENDOR_CPLAN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_VENDOR_CPLAN'), '-- ' || SYSTIMESTAMP, ':r := SP_S_VENDOR_CPLAN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_VENDOR_CPLAN(33) : vendors.sql(2582) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate rec_user id
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_S_VENDOR_CPLAN', 40+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_S_VENDOR_CPLAN(41) : vendors.sql(2590) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 43+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(44) : vendors.sql(2593) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If ((p_id IS NULL)) Then
      If Coalesce(p_bitflag, 0) = 1 Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0001';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0001
            SELECT RANK, ELEMENT_ID
            FROM TMT_VENDORS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_VENDORS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND RA.ELEMENT_TYPE = 11 AND RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 73+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(74) : vendors.sql(2623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_VND_0001 O
            WHERE NOT EXISTS (
            SELECT B.ELEMENT_ID
            FROM PMO_TMP_VND_0001 A, PMO_TMP_VND_0001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(104) : vendors.sql(2653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661a FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE,
         0 AS REVISION_IMPACT,T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_VENDORS T
         JOIN  PMO_TMP_VND_0002 ASS ON ASS.ELEMENT_ID=T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0, 13) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 125+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(126) : vendors.sql(2675) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661a;
      Else
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0001';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0001
            SELECT RANK, ELEMENT_ID
            FROM TMT_VENDORS
            WHERE PUBLIC_FLAG = '1'
            UNION ALL
            SELECT TP.RANK, TP.ELEMENT_ID
            FROM TMT_VENDORS TP
            JOIN RESOURCE_ASSIGNMENTS RA ON TP.ELEMENT_ID = RA.ELEMENT_ID AND
            RA.ELEMENT_TYPE = 11 AND
            RA.RESOURCE_ID = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 154+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(155) : vendors.sql(2704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VND_0002';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VND_0002
            SELECT O.ELEMENT_ID
            FROM PMO_TMP_VND_0001 O
            WHERE NOT EXISTS (SELECT B.ELEMENT_ID
            FROM PMO_TMP_VND_0001 A, PMO_TMP_VND_0001 B
            WHERE A.RANK < B.RANK
            AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
            AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
            AND O.ELEMENT_ID = A.ELEMENT_ID);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 183+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(184) : vendors.sql(2733) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         OPEN SCP661aa FOR SELECT
         0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         '' AS TITLE,
         ''  AS COMPETENCY,
         (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE
         FROM TMT_VENDORS T JOIN PMO_TMP_VND_0002 ASS ON ASS.ELEMENT_ID = T.ELEMENT_ID
         WHERE T.TYPE_ID NOT IN (0) AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 205+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(206) : vendors.sql(2755) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661aa;
      End If;
   Else
      h_id := p_id;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR_CPLAN', 213+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR_CPLAN(214) : vendors.sql(2763) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      If Coalesce(p_bitflag, 0) = 1 Then
         OPEN SCP661b FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
         T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = 13 THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = 13 THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = 13 THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_VENDORS T
         WHERE T.TYPE_ID NOT IN (0, 13)
         AND (T.PARENT_ID = h_id OR T.ELEMENT_ID = h_id)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 256+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(257) : vendors.sql(2806) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661b;
      Else
         OPEN SCP661bb FOR SELECT
         T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT,
         T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID,
         (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME,
         T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS,
         T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES,
         T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX,
         T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED,
         T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         T.REC_USER, (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME,
         CASE WHEN T.TYPE_ID = 13 THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '' END AS TITLE,
         CASE WHEN T.TYPE_ID = 13 THEN
         (PMO_ORASTD.StringConcat(PMO_ORASTD.StringConcat((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID AND
         PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))
         , ', '), (SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID =
         (SELECT PARENT_ID FROM TMT_COMPETENCIES
         WHERE RESOURCE_ID = T.ELEMENT_ID
         AND PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES
         WHERE RESOURCE_ID = T.ELEMENT_ID))))) ELSE '' END AS COMPETENCY,
         CASE WHEN T.TYPE_ID = 13 THEN '' ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) END AS RESPONSIBLE
         FROM TMT_VENDORS T
         WHERE T.TYPE_ID NOT IN (0)
         AND (T.PARENT_ID = h_id OR T.ELEMENT_ID = h_id)
         AND T.REC_STATUS <> 'D'
         ORDER BY RANK;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_CPLAN', 290+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_CPLAN(291) : vendors.sql(2840) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN SCP661bb;
      End If;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 299+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(300) : vendors.sql(2849) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_CPLAN', 311+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_CPLAN(312) : vendors.sql(2861) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_VENDOR_CPLAN;
ALTER FUNCTION SP_S_VENDOR_CPLAN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_S_VENDOR ==
CREATE OR REPLACE FUNCTION SP_S_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_default_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_xsql VARCHAR2(8000);
   h_is_static PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_S_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_VENDOR(23) : vendors.sql(2900) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 4) Then
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 30+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(31) : vendors.sql(2908) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
   ElsIf ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 3) Then
      h_id := p_id;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 44+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(45) : vendors.sql(2922) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      h_xsql := 
            'WITH TMP AS (SELECT H.ELEMENT_ID, H.REVISION_TYPE, H.REVISION_IMPACT FROM HISTORY_VENDORS H WHERE H.ELEMENT_ID = ''';
      h_xsql := h_xsql || h_id;
      h_xsql := h_xsql || 
                    ''' AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_VENDORS WHERE ELEMENT_ID = H.ELEMENT_ID)) ';
      h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.ELEMENT_NAME END AS ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT, CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS, T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES, T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX, T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED, T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, ';
      h_xsql := h_xsql || ''''' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_USER END AS REC_USER, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 
                    'FROM TMT_VENDORS T LEFT OUTER JOIN TMP H ON H.ELEMENT_ID = T.ELEMENT_ID WHERE T.ELEMENT_ID = ''';
      h_xsql := h_xsql || h_id;
      h_xsql := h_xsql || ''' AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
   ElsIf ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 2) Then
      h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
      h_xsql := h_xsql || 
                    'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_CONTACTS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT, ';
      h_xsql := h_xsql || 'T.DELETED_COUNT, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, ';
      h_xsql := h_xsql || 'T.DESCRIPTION, ';
      h_xsql := h_xsql || 
                    'T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, ';
      h_xsql := h_xsql || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.MANAGER_ID) AS RESPONSIBLE, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT TITLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE '''' END AS TITLE, ';
      
      h_xsql := h_xsql || 'CASE WHEN T.TYPE_ID = 13 THEN ';
      h_xsql := h_xsql || '((SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
      h_xsql := h_xsql || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
      h_xsql := h_xsql || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = T.ELEMENT_ID AND ';
      h_xsql := h_xsql || 
                    'PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)))) || '', '' || ';
      h_xsql := h_xsql || '(SELECT RTRIM(ELEMENT_NAME) FROM TMT_COMPETENCIES WHERE ELEMENT_ID = ';
      h_xsql := h_xsql || '(SELECT PARENT_ID FROM TMT_COMPETENCIES WHERE RESOURCE_ID = T.ELEMENT_ID AND ';
      h_xsql := h_xsql || 
                    'PARENT_ID = (SELECT PRIMARY_ROLE FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)))) ';
      h_xsql := h_xsql || 'ELSE '''' END AS COMPETENCY, T.REC_USER, ';
      
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 'FROM TMT_VENDORS T ';
      
      -- Validate id
      If ((p_id IS NULL)) Then
         h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
         h_xsql := h_xsql || 'AND T.TYPE_ID <> 0 ';
      Else
         h_id := p_id;
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 108+1) THEN 
            LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(109) : vendors.sql(2986) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
         END IF; 
         BEGIN 
            EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
               INTO h_rec_status 
               Using h_id; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
         END;
         
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
      End If;
      h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
      h_xsql := h_xsql || ' ORDER BY RANK ';
   ElsIf ((p_bitflag IS NOT NULL)) AND (Coalesce(p_bitflag, 0) = 1) Then
      h_xsql := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, ';
      h_xsql := h_xsql || 'T.ELEMENT_NAME, ';
      h_xsql := h_xsql || 
                    'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT, ';
      h_xsql := h_xsql || 'T.DELETED_COUNT, T.REC_STATUS, ';
      h_xsql := h_xsql || 'T.DEFAULT_FLAG, T.DESCRIPTION, ';
      h_xsql := h_xsql || 
                    'T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, ';
      h_xsql := h_xsql || 
                    'T.OTHER_LOCATION, T.YEAR_IN_BUSINESS, T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, ';
      h_xsql := h_xsql || 'T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES, ';
      --T.NUMBER_VENDORS, T.NUMBER_CLIENTS, ");
      h_xsql := h_xsql || 
                    'T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX, T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, ';
      h_xsql := h_xsql || 
                    'T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED, T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, '''' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, ';
      h_xsql := h_xsql || 'T.REC_USER, ';
      h_xsql := h_xsql || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 'FROM TMT_VENDORS T ';
      
      -- Execute Select Statement
      If ((p_id IS NULL)) Then
         BEGIN
            SELECT RANK, ELEMENT_ID INTO h_rank, h_default_id FROM TMT_VENDORS
            WHERE DEFAULT_FLAG = 'Y' AND REC_STATUS NOT in ('D', 'L', 'A');
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(162) : vendors.sql(3039) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_xsql := 'WITH TEMP1( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TMT_VENDORS WHERE (substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, case when length(RANK) > length(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''') then 1 else length(RANK) end) = RANK) and (RANK like substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, len) || ''%'') AND TYPE_ID IN (0, 13)), ';
            h_xsql := h_xsql || 'TEMP2( ELEMENT_ID) AS (SELECT TG.ELEMENT_ID FROM TMT_VENDORS TG, TEMP1 TT ';
            h_xsql := h_xsql || 'WHERE TG.PARENT_ID = TT.ELEMENT_ID AND TG.PARENT_ID <> ''';
            h_xsql := h_xsql || h_default_id;
            h_xsql := h_xsql || 
                    '''), TEMP3( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TEMP1 UNION SELECT ELEMENT_ID FROM TEMP2 UNION SELECT ELEMENT_ID FROM TMT_VENDORS WHERE PARENT_ID IS NULL) ';
            h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ';
            h_xsql := h_xsql || 
                    'T.CHILD_COUNT - (SELECT COUNT(ELEMENT_ID) FROM TMT_VENDORS WHERE PARENT_ID = T.ELEMENT_ID AND TYPE_ID = 13) AS CHILD_COUNT, ';
            h_xsql := h_xsql || 'T.DELETED_COUNT, T.REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.REC_USER, ';
            h_xsql := h_xsql || 
                    '(SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) AS REC_USER_NAME, T.PUBLIC_FLAG ';
            h_xsql := h_xsql || 'FROM TMT_VENDORS T WHERE T.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TEMP3) ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || 'ORDER BY T.RANK ';
         Else
            h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
            h_xsql := h_xsql || 'AND T.TYPE_ID NOT IN (0, 13) ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || ' ORDER BY RANK ';
         End If;
      Else
         h_id := p_id;
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 199+1) THEN 
            LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(200) : vendors.sql(3077) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
         END IF; 
         BEGIN 
            EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
               INTO h_rec_status 
               Using h_id; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
         END;
         
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
         h_xsql := h_xsql || 'AND T.TYPE_ID NOT IN (0, 13) ';
         h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         h_xsql := h_xsql || ' ORDER BY RANK ';
      End If;
   Else
      h_id := p_id;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_S_VENDOR', 223+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_S_VENDOR(224) : vendors.sql(3101) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
      END;
      
      h_xsql := 
            'WITH TMP AS (SELECT H.ELEMENT_ID, H.REVISION_TYPE, H.REVISION_IMPACT FROM HISTORY_VENDORS H WHERE H.ELEMENT_ID = ''';
      h_xsql := h_xsql || h_id;
      h_xsql := h_xsql || 
                    ''' AND H.REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_VENDORS WHERE ELEMENT_ID = H.ELEMENT_ID)) ';
      
      h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.ELEMENT_NAME END AS ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT, CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, T.DEFAULT_FLAG, T.DESCRIPTION, T.DOMAIN_ID, (SELECT ELEMENT_NAME FROM TMT_DOMAINS WHERE ELEMENT_ID = T.DOMAIN_ID) AS DOMAIN_NAME, T.COMPANY_NAME, T.ADDRESS, T.PHONE, T.FAX, T.WEBSITE, T.CONTACT_NAME, T.OTHER_LOCATION, T.YEAR_IN_BUSINESS, T.CLIENT_MORE_100_EMPLOYEES, T.CLIENT_MORE_1000_EMPLOYEES, T.CLIENT_MORE_10000_EMPLOYEES, T.NUMBER_EMPLOYEES, T.ANNUAL_REVENUES, T.BILLING_ADDRESS, T.BILLING_PHONE, T.BILLING_FAX, T.BILLING_EMAIL, T.EQUAL_OPPORTUNITY, T.COMPANY_BACKGROUND, T.OWNERSHIP, T.SERVICES_OFFERED, T.SERVICES_SPECIALIZED, T.INDUSTRIES_SERVED, T.HIGHLIGHT, T.LOCATION_SERVED, T.LABEL, ';
      h_xsql := h_xsql || ''''' AS REVISION_HISTORY, H.REVISION_TYPE, H.REVISION_IMPACT, ';
      h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_USER END AS REC_USER, CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
      h_xsql := h_xsql || 'FROM TMT_VENDORS T LEFT OUTER JOIN TMP H ON H.ELEMENT_ID = T.ELEMENT_ID ';
      
      -- Execute Select Statement
      If ((p_id IS NULL)) Then
         BEGIN
            SELECT RANK, ELEMENT_ID INTO h_rank, h_default_id FROM TMT_VENDORS
            WHERE DEFAULT_FLAG = 'Y' AND REC_STATUS NOT in ('D', 'L', 'A');
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 258+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(259) : vendors.sql(3136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            h_xsql := 'WITH TEMP1( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TMT_VENDORS WHERE (substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, case when length(RANK) > length(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''') then 1 else length(RANK) end) = RANK) and (RANK like substr(''';
            h_xsql := h_xsql || h_rank;
            h_xsql := h_xsql || ''', 1, len) || ''%'') AND TYPE_ID <> 0), ';
            h_xsql := h_xsql || 'TEMP2( ELEMENT_ID) AS (SELECT TG.ELEMENT_ID FROM TMT_VENDORS TG, TEMP1 TT ';
            h_xsql := h_xsql || 'WHERE TG.PARENT_ID = TT.ELEMENT_ID AND TG.PARENT_ID <> ''';
            h_xsql := h_xsql || h_default_id;
            h_xsql := h_xsql || 
                    '''), TEMP3( ELEMENT_ID) AS (SELECT ELEMENT_ID FROM TEMP1 UNION SELECT ELEMENT_ID FROM TEMP2 UNION SELECT ELEMENT_ID FROM TMT_VENDORS WHERE PARENT_ID IS NULL) ';
            h_xsql := h_xsql || 
                    'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.CHILD_COUNT, T.DELETED_COUNT, ';
            h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_STATUS FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_STATUS END AS REC_STATUS, ';
            h_xsql := h_xsql || 'T.DEFAULT_FLAG, T.DESCRIPTION, ';
            h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID) ELSE T.REC_USER END AS REC_USER, ';
            h_xsql := h_xsql || 
                    'CASE WHEN T.TYPE_ID = 13 THEN (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = (SELECT REC_USER FROM RESOURCES WHERE RESOURCE_ID = T.ELEMENT_ID)) ELSE (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = T.REC_USER) END AS REC_USER_NAME, T.PUBLIC_FLAG ';
            h_xsql := h_xsql || 'FROM TMT_VENDORS T WHERE T.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TEMP3) ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || 'ORDER BY T.RANK ';
         Else
            h_xsql := h_xsql || 'WHERE T.PARENT_ID IS NULL ';
            h_xsql := h_xsql || 'AND T.TYPE_ID <> 0 ';
            h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
            h_xsql := h_xsql || ' ORDER BY RANK ';
         End If;
      Else
         h_xsql := h_xsql || 'WHERE (T.PARENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''' ';
         h_xsql := h_xsql || 'OR T.ELEMENT_ID = ''';
         h_xsql := h_xsql || h_id;
         h_xsql := h_xsql || ''') ';
         h_xsql := h_xsql || 'AND T.REC_STATUS NOT in (''D'', ''L'', ''A'') ';
         h_xsql := h_xsql || ' ORDER BY RANK ';
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR', 307+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR(308) : vendors.sql(3185) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR', 310+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR(311) : vendors.sql(3188) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 317+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(318) : vendors.sql(3195) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR', 329+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR(330) : vendors.sql(3207) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_VENDOR;
ALTER FUNCTION SP_S_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKOUT_VENDOR ==
CREATE OR REPLACE FUNCTION SP_CKOUT_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id2 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKOUT_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKOUT_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_CKOUT_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKOUT_VENDOR(22) : vendors.sql(3245) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(27) : vendors.sql(3250) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_VENDOR(30) : vendors.sql(3253) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 35+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(36) : vendors.sql(3259) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_rec_user || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_VENDOR(39) : vendors.sql(3262) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_rec_user, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT ELEMENT_ID, TYPE_ID, REC_STATUS
      INTO h_id2, h_type_id, h_rec_status
      FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(56) : vendors.sql(3279) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 61+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(62) : vendors.sql(3285) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 64+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_VENDOR(65) : vendors.sql(3288) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id2, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT RESOURCE_ID, REC_STATUS
         INTO h_id2, h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(79) : vendors.sql(3302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 86+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(87) : vendors.sql(3310) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 89+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_VENDOR(90) : vendors.sql(3313) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_OUT, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 96+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(97) : vendors.sql(3320) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 99+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_VENDOR(100) : vendors.sql(3323) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKOUT_VENDOR', 106+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKOUT_VENDOR(107) : vendors.sql(3330) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKOUT_VENDOR', 109+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKOUT_VENDOR(110) : vendors.sql(3333) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id2, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         UPDATE RESOURCES SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE RESOURCE_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(130) : vendors.sql(3353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDORS SET
         REC_STATUS = 'O', REC_USER = p_rec_user, REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(149) : vendors.sql(3372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKOUT_VENDOR', 155+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKOUT_VENDOR(156) : vendors.sql(3379) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 162+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(163) : vendors.sql(3386) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKOUT_VENDOR', 174+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKOUT_VENDOR(175) : vendors.sql(3398) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKOUT_VENDOR;
ALTER FUNCTION SP_CKOUT_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CKIN_VENDOR ==
CREATE OR REPLACE FUNCTION SP_CKIN_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_bitflag_revision PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_min_revision PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_RESOURCES
         WHERE  ROWNUM <= 1 AND  RESOURCE_ID = p_id;

      CURSOR CH1P IS
         SELECT MINOR_REVISION
         FROM HISTORY_VENDORS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = p_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CKIN_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CKIN_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_CKIN_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CKIN_VENDOR(37) : vendors.sql(3451) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 41+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(42) : vendors.sql(3456) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 44+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_VENDOR(45) : vendors.sql(3459) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   
   BEGIN
      SELECT TYPE_ID, REC_STATUS INTO h_type_id, h_rec_status
      FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(63) : vendors.sql(3477) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 68+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(69) : vendors.sql(3483) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 71+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_VENDOR(72) : vendors.sql(3486) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   ElsIf Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM RESOURCES WHERE RESOURCE_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 84+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(85) : vendors.sql(3499) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 92+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(93) : vendors.sql(3507) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 95+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_VENDOR(96) : vendors.sql(3510) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'I') OR (SubStr(h_rec_status, 1, 1) = 'U') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 102+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(103) : vendors.sql(3517) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_IN), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 105+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_VENDOR(106) : vendors.sql(3520) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_IN, h_id, True);
   End If;
   
   If (SubStr(h_rec_status, 1, 1) = 'L') OR (SubStr(h_rec_status, 1, 1) = 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CKIN_VENDOR', 112+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CKIN_VENDOR(113) : vendors.sql(3527) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CKIN_VENDOR', 115+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CKIN_VENDOR(116) : vendors.sql(3530) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id, True);
   End If;
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := p_bitflag;
      
      OPEN CH1;
      
      FETCH CH1 INTO h_min_revision;
      IF CH1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 146+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(147) : vendors.sql(3561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 164+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(165) : vendors.sql(3579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 177+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(178) : vendors.sql(3592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 198+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(199) : vendors.sql(3613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 216+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(217) : vendors.sql(3631) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE RESOURCES SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE RESOURCE_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 234+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(235) : vendors.sql(3649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_RESOURCES SELECT h_uniqueID, A.* FROM RESOURCES A WHERE A.RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 256+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(257) : vendors.sql(3671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE RESOURCES SET REVISION_HISTORY = Null WHERE RESOURCE_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 273+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(274) : vendors.sql(3688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 5;
         h_table_name := 'HISTORY_RESOURCES';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   Else
      -- **************************************************************************************
      -- h_max_revision = 0 MINOR_REVISION = MINOR_REVISION + 1
      --                          = 1 MAJOR_REVISION = MAJOR_REVISION + 1
      --                          = 2 check in as the same revision
      -- **************************************************************************************
      h_bitflag := p_bitflag;
      
      OPEN CH1P;
      
      FETCH CH1P INTO h_min_revision;
      IF CH1P%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 308+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(309) : vendors.sql(3723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 326+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(327) : vendors.sql(3741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            CLOSE CH1P ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 339+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(340) : vendors.sql(3754) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_bitflag, 0) = 0 Then
            BEGIN
               UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MAJOR_REVISION ELSE MAJOR_REVISION + 1 END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION < 99 THEN MINOR_REVISION + 1 ELSE 0 END
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 360+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(361) : vendors.sql(3775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 378+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(379) : vendors.sql(3793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf Coalesce(h_bitflag, 0) = 2 Then
            BEGIN
               UPDATE TMT_VENDORS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 396+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(397) : vendors.sql(3811) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_VENDORS SELECT h_uniqueID, A.* FROM TMT_VENDORS A WHERE A.ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 418+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(419) : vendors.sql(3833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_VENDORS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 435+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(436) : vendors.sql(3850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_bitflag_revision := 0;
         h_table_name := 'HISTORY_VENDORS';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag_revision, h_table_name);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CKIN_VENDOR', 447+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CKIN_VENDOR(448) : vendors.sql(3862) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 454+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(455) : vendors.sql(3869) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CKIN_VENDOR', 466+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CKIN_VENDOR(467) : vendors.sql(3881) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CKIN_VENDOR;
ALTER FUNCTION SP_CKIN_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UCKOUT_VENDOR ==
CREATE OR REPLACE FUNCTION SP_UCKOUT_VENDOR
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UCKOUT_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UCKOUT_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_UCKOUT_VENDOR(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_VENDOR', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UCKOUT_VENDOR(20) : vendors.sql(3917) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_VENDOR', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_VENDOR(25) : vendors.sql(3922) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_VENDOR', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_VENDOR(28) : vendors.sql(3925) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status FROM TMT_VENDORS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(43) : vendors.sql(3940) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UCKOUT_VENDOR', 48+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UCKOUT_VENDOR(49) : vendors.sql(3946) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_VENDOR', 51+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_VENDOR(52) : vendors.sql(3949) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      --Execute Insert Statement
      BEGIN
         UPDATE TMT_VENDORS SET (REC_STATUS, REC_USER, REC_DATETIME) =
         (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_VENDORS
         WHERE ELEMENT_ID = p_id AND REC_DATETIME =
         (SELECT MAX(REC_DATETIME) FROM HISTORY_VENDORS WHERE ELEMENT_ID = p_id))
         WHERE ELEMENT_ID = p_id AND REC_USER = p_rec_user;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(75) : vendors.sql(3972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UCKOUT_VENDOR', 80+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UCKOUT_VENDOR(81) : vendors.sql(3978) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UNDO_CHECKOUT), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UCKOUT_VENDOR', 83+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UCKOUT_VENDOR(84) : vendors.sql(3981) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_UNDO_CHECKOUT, True);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UCKOUT_VENDOR', 89+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UCKOUT_VENDOR(90) : vendors.sql(3987) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 96+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(97) : vendors.sql(3994) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UCKOUT_VENDOR', 108+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UCKOUT_VENDOR(109) : vendors.sql(4006) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UCKOUT_VENDOR;
ALTER FUNCTION SP_UCKOUT_VENDOR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_U_VENDOR_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_VENDOR_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_VENDOR_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_VENDOR_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_VENDOR_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_VENDOR_REVISION(27) : vendors.sql(4049) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_VENDOR_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_VENDOR_REVISION(33) : vendors.sql(4055) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_VENDOR_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_VENDOR_REVISION(36) : vendors.sql(4058) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_VENDOR_REVISION', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_VENDOR_REVISION(43) : vendors.sql(4065) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_VENDORS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_VENDORS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      UPDATE TMT_VENDORS SET
      REVISION_IMPACT = p_rev_impact,
      REVISION_TYPE = p_rev_type,
      REVISION_HISTORY = p_rev_history
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_REVISION', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_REVISION(70) : vendors.sql(4092) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_VENDOR_REVISION', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_VENDOR_REVISION(76) : vendors.sql(4098) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_REVISION', 82+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_REVISION(83) : vendors.sql(4105) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_VENDOR_REVISION', 94+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_VENDOR_REVISION(95) : vendors.sql(4117) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_VENDOR_REVISION;
ALTER FUNCTION SP_U_VENDOR_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_VENDORS)
*                           id = ELEMENT_ID in TMT_VENDORS table, select from HISTORY_VENDORS where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this is (only the first level)
*                           id = ELEMENT_ID in HISTORY_VENDORS table, select from HISTORY_VENDORS  TMT_WORKFLOWS
*
* h_bitflag == 2    returns next level for WORKFLOW_ID
*                           id = ELEMENT_ID in TMT_WORKFLOWS table, select from TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_VENDOR_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_VENDOR_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_sql VARCHAR2(2048);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_VENDOR_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_VENDOR_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_VENDOR_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_VENDOR_REVISION(24) : vendors.sql(4166) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 28+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(29) : vendors.sql(4171) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(32) : vendors.sql(4174) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS ';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(53) : vendors.sql(4195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 58+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(59) : vendors.sql(4201) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 61+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(62) : vendors.sql(4204) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      h_sql := 
            'SELECT * FROM (SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, '
             || 'REVISION_TYPE, REC_DATETIME, AUTHOR FROM(SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_VENDORS T JOIN RESOURCES B ON T.REC_USER = B.RESOURCE_ID WHERE ELEMENT_ID = ''' 
                  || h_id || ''') '
             || 'AS A ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 1 Then
      BEGIN
         SELECT RANK, LEVEL_ID, ELEMENT_ID INTO h_rank, h_level_id, h_parent_id FROM HISTORY_VENDORS WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 85+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(86) : vendors.sql(4228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 91+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(92) : vendors.sql(4234) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 94+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(95) : vendors.sql(4237) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 
            'SELECT * FROM (SELECT LEVEL_ID, TYPE_ID, RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, DELETED_COUNT, REVISION, REVISION_IMPACT, REVISION_HISTORY, '
             || 'REVISION_TYPE, REC_DATETIME, AUTHOR FROM(SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR FROM HISTORY_VENDORS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' 
                  || h_rank 
                  || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.PARENT_ID = ''' 
                  || h_parent_id || ''') AS D ORDER BY RANK) WHERE ROWNUM<=' || TO_CHAR(Coalesce(
                  h_app_revision, 0));
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT A.ELEMENT_ID INTO h_parent_id
         FROM TMT_WORKFLOWS A, TMT_WORKFLOWS B
         WHERE B.ELEMENT_ID = h_id
         AND A.LEVEL_ID > -1
         AND A.PARENT_ID IS NuLL
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
         AND A.RANK LIKE '0000' || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(131) : vendors.sql(4273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 136+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(137) : vendors.sql(4279) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 139+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(140) : vendors.sql(4282) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      BEGIN
         SELECT RANK, LEVEL_ID INTO h_rank, h_level_id FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(153) : vendors.sql(4295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_VENDOR_REVISION', 158+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_VENDOR_REVISION(159) : vendors.sql(4301) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 161+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(162) : vendors.sql(4304) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      h_sql := 'SELECT * FROM (SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) 
            || ' + A.LEVEL_ID) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
            || ''' || A.RANK) AS RANK, A.PARENT_ID, A.ELEMENT_ID, A.ELEMENT_NAME, A.CHILD_COUNT, A.DELETED_COUNT, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.REC_DATETIME, C.FULL_NAME AS AUTHOR '
             || 'FROM TMT_WORKFLOWS A LEFT JOIN RESOURCES C ON A.AUTHOR_ID=C.RESOURCE_ID WHERE A.ELEMENT_ID = ''' 
                  || h_id || ''' OR A.PARENT_ID = ''' || h_id || ''' ORDER BY RANK) WHERE ROWNUM<=' 
                  || TO_CHAR(Coalesce(h_app_revision, 0));
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(177) : vendors.sql(4319) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_VENDOR_REVISION', 179+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_VENDOR_REVISION(180) : vendors.sql(4322) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_sql);
   --return PROC_STATE;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 187+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(188) : vendors.sql(4330) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_VENDOR_REVISION', 199+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_VENDOR_REVISION(200) : vendors.sql(4342) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_VENDOR_REVISION;
ALTER FUNCTION SP_S_VENDOR_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_M_VENDOR ==
CREATE OR REPLACE FUNCTION SP_M_VENDOR
(
     p_target VARCHAR2
   , p_source VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_cid VARCHAR2(32);
   h_cr VARCHAR2(200);
   h_r VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(8);
   h_source_parent_id VARCHAR2(32);
   h_target_id VARCHAR2(32);
   h_target_parent_id VARCHAR2(32);
   h_target_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_target_level_id PLS_INTEGER := 0;
   h_target_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_VENDOR2 IS
         SELECT ELEMENT_ID, RANK FROM TMT_VENDORS
         WHERE RANK > h_r OR RANK = h_r ORDER BY RANK DESC;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_M_VENDOR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_M_VENDOR'), '-- ' || SYSTIMESTAMP, ':r := SP_M_VENDOR(' || 
       '''' || p_target || ''''
          || ', ' || '''' || p_source || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_M_VENDOR(38) : vendors.sql(4396) : ' || SYSTIMESTAMP);
   END IF; 

   If ((p_source IS NULL)) OR ((p_bitflag IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR(43) : vendors.sql(4401) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(46) : vendors.sql(4404) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   ElsIf (Coalesce(p_bitflag, 0) < 0) OR (Coalesce(p_bitflag, 0) > 1) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR', 50+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR(51) : vendors.sql(4409) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 53+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(54) : vendors.sql(4412) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --Local host variables
   
   --validate source
   BEGIN
      SELECT PARENT_ID INTO h_source_parent_id
      FROM TMT_VENDORS WHERE ELEMENT_ID = p_source;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(71) : vendors.sql(4429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 77+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(78) : vendors.sql(4436) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_source || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 80+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(81) : vendors.sql(4439) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_source, True);
   End If;
   
   If Coalesce(p_bitflag, 0) = 1 Then
      If (p_target IS NOT NULL) Then
         BEGIN
            SELECT PARENT_ID, RANK
            INTO h_target_parent_id, h_r
            FROM TMT_VENDORS
            WHERE ELEMENT_ID = p_target;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 98+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(99) : vendors.sql(4457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 105+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(106) : vendors.sql(4464) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_target || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 108+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(109) : vendors.sql(4467) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_target, True);
         End If;
         
         h_target_id := h_target_parent_id;
         
         BEGIN
            SELECT TYPE_ID, LEVEL_ID, RTRIM(RANK)
            INTO h_target_type_id, h_target_level_id, h_target_rank
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 125+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(126) : vendors.sql(4484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 132+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(133) : vendors.sql(4491) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_target_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 135+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(136) : vendors.sql(4494) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_target_id, True);
         End If;
         PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_target_id, h_max_rank);
         
         --push all siblings
         
         OPEN C_VENDOR2;
         
         LOOP
            FETCH C_VENDOR2 INTO h_cid, h_cr;
            IF C_VENDOR2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            PMO_STPU.incrBase64(h_cr, Coalesce(h_target_level_id, 0) + 2);
            
            BEGIN
               UPDATE TMT_VENDORS SET RANK = h_cr WHERE ELEMENT_ID = h_cid;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 170+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(171) : vendors.sql(4529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         
         BEGIN
            CLOSE C_VENDOR2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(185) : vendors.sql(4543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_level_id := Coalesce(h_target_level_id, 0) + 1;
         h_rank := h_r;
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_M_VENDOR', 193+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_M_VENDOR(194) : vendors.sql(4552) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 196+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(197) : vendors.sql(4555) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
   Else
      If (p_target IS NOT NULL) Then
         h_target_id := p_target;
         
         BEGIN
            SELECT TYPE_ID, LEVEL_ID, RTRIM(RANK)
            INTO h_target_type_id, h_target_level_id, h_target_rank
            FROM TMT_VENDORS WHERE ELEMENT_ID = h_target_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 214+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(215) : vendors.sql(4573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_M_VENDOR', 221+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_M_VENDOR(222) : vendors.sql(4580) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_target_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_M_VENDOR', 224+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_M_VENDOR(225) : vendors.sql(4583) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_target_id, True);
         End If;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_VENDORS', h_target_id, h_max_rank);
      Else
         h_target_id := '';
         h_target_type_id := 0;
         h_target_level_id := -1;
         h_target_rank := '0000';
         PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_VENDORS', h_max_rank);
      End If;
      
      h_level_id := Coalesce(h_target_level_id, 0) + 1;
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      h_rank := h_target_rank;
      h_rank := h_rankBase64;
   End If;
   
   --update source hierarchy
   If (h_source_parent_id IS NULL) Then
      BEGIN
         UPDATE TMT_VENDORS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID IS NuLL;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 258+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(259) : vendors.sql(4617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_VENDORS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_source_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 275+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(276) : vendors.sql(4634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Update Vendor
   BEGIN
      UPDATE TMT_VENDORS SET
      PARENT_ID = h_target_id,
      LEVEL_ID = h_level_id,
      RANK = h_rank,
      REC_USER = p_rec_user,
      REC_STATUS = 'U',
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_source;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 301+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(302) : vendors.sql(4660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_M_VENDOR', 307+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_M_VENDOR(308) : vendors.sql(4666) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_source || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_source, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 314+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(315) : vendors.sql(4673) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_M_VENDOR', 326+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_M_VENDOR(327) : vendors.sql(4685) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_M_VENDOR;
ALTER FUNCTION SP_M_VENDOR COMPILE DEBUG;

