/***************************************************************************************************
SC_CHAR(h_element_id, SC_H_ID);

Modification needed in other .cpps:
VIEWS
    CALENDAR_NAME ==>
    SELECT ELEMENT_NAME
    FROM TMT_CALENDARS T1 LEFT OUTER JOIN TMT_CALENDARS T2 ON T1.ELEMENT_ID = T2.PARENT_ID
    WHERE T2.ELEMENT_ID = HOST(h_id) ;
RESOURCE
    CALENDAR_NAME ==>
    SELECT ELEMENT_NAME
    FROM TMT_CALENDARS T1 LEFT OUTER JOIN TMT_CALENDARS T2 ON T1.ELEMENT_ID = T2.PARENT_ID
    WHERE T2.ELEMENT_ID = HOST(h_resource_id) ;

***************************************************************************************************/

Prompt == FUNCTION POPULATE_CALENDAR ==
CREATE OR REPLACE FUNCTION POPULATE_CALENDAR
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , sh_h_duration PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_duration PLS_INTEGER := sh_h_duration;
   h_current_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_friday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_monday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_saturday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_sunday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_thursday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_tuesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_wednesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_FD DATE;
   h_SD DATE;
   h_temp_FD DATE;
   h_exception_date DATE;
   h_dayofyear DATE;
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_current_daynumber PLS_INTEGER := 0;
   h_current_min PLS_INTEGER := 0;
   h_current_weekday PLS_INTEGER := 0;
   h_friday_min PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_monday_min PLS_INTEGER := 0;
   h_saturday_min PLS_INTEGER := 0;
   h_sunday_min PLS_INTEGER := 0;
   h_thursday_min PLS_INTEGER := 0;
   h_tuesday_min PLS_INTEGER := 0;
   h_wednesday_min PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_end_month PLS_INTEGER := 0;
   h_week_iso PLS_INTEGER := 0;
   h_month_iso PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_fiscal_month PLS_INTEGER := 0;
   iSF PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C_EXCEPTS IS
         SELECT EXCEPTION_DATE, EXCEPTION_MIN, EXCEPTION_BIT
         FROM CALENDAR_EXCEPTIONS
         WHERE CALENDAR_ID IN
         (
         SELECT ELEMENT_ID FROM TMT_CALENDARS
         WHERE RANK LIKE SUBSTR(h_rank, 1, 8) || '%'
         AND ((RANK >= SUBSTR(h_rank, 1, 8) AND RANK <= h_rank) 
         AND SUBSTR(h_rank,1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END ) = RANK)
         )
         AND EXCEPTION_DATE BETWEEN TO_DATE(SubStr(TO_DATE(SubStr(h_SD, 1, 10)), 1, 10)) AND TO_DATE(SubStr(TO_DATE(SubStr(h_FD, 1, 10)), 1, 10));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('POPULATE_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('POPULATE_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := POPULATE_CALENDAR(' || 
       '''' || h_element_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_duration), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_CALENDAR', 68+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: POPULATE_CALENDAR(69) : wbs.sql(87) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If ((h_start_date IS NULL)) OR (Coalesce(Length(h_start_date), 0) = 0) Then
      BEGIN
         SELECT TO_DATE(SubStr(SYSTIMESTAMP, 1, 10)) INTO h_SD FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(83) : wbs.sql(101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT Add_Months(TO_DATE(SYSDATE), -25 * 12) INTO h_dayofyear FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(96) : wbs.sql(114) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strncmp(h_start_date, h_dayofyear, 10) < 0 Then
         h_start_date := SubStr(h_dayofyear, 1, 10);
      End If;
      
      h_SD := SubStr(h_start_date, 1, 10);
   End If;
   
   If ((h_finish_date IS NULL)) OR (Coalesce(Length(h_finish_date), 0) = 0) Then
      h_finish_date := '2100-01-01';
      BEGIN
         SELECT TO_DATE(SubStr(h_SD, 1, 10)) + (h_duration + 400)      INTO h_FD FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(118) : wbs.sql(136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT Add_Months(TO_DATE(SYSDATE), 25 * 12) INTO h_dayofyear FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 130+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(131) : wbs.sql(149) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strncmp(h_dayofyear, h_finish_date, 10) < 0 Then
         h_finish_date := SubStr(h_dayofyear, 1, 10);
      End If;
      
      h_FD := SubStr(h_finish_date, 1, 10);
      iSF := 1;
   End If;
   --trace_printf("h_start_date: %d:%s, h_finish_date: %d:%s, h_duration: %d\n", h_start_date_Ind,h_start_date,h_finish_date_Ind,h_finish_date,h_duration);
   
   If Coalesce(h_type_id, 0) = PMO_CNST.SC_PROJECT Then
      -- Just try to get the fiscal date, if you can't then DBA needs to get involved.
      BEGIN
         BEGIN
            SELECT FISCAL_YEAR, FISCAL_MONTH INTO h_end_year, h_temp_fiscal_month 
                    FROM FISCAL_CALENDAR WHERE h_FD BETWEEN START_DATE AND FINISH_DATE;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 156+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(157) : wbs.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'POPULATE_CALENDAR', 162+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: POPULATE_CALENDAR(163) : wbs.sql(181) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR), 'NULL'));
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_CALENDAR', 165+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: POPULATE_CALENDAR(166) : wbs.sql(184) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR, h_FD, False);
         End If;
      END;
      
      BEGIN
         SELECT TO_DATE(SubStr(h_FD, 1, 10)) + 365      INTO h_temp_FD FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 179+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(180) : wbs.sql(198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Just try to get the fiscal date, if you can't then DBA needs to get involved.
      BEGIN
         BEGIN
            SELECT FISCAL_YEAR, FISCAL_MONTH INTO h_end_year, h_temp_fiscal_month 
                    FROM FISCAL_CALENDAR WHERE h_temp_FD BETWEEN START_DATE AND FINISH_DATE;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 195+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(196) : wbs.sql(214) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'POPULATE_CALENDAR', 201+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: POPULATE_CALENDAR(202) : wbs.sql(220) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR), 'NULL'));
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_CALENDAR', 204+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: POPULATE_CALENDAR(205) : wbs.sql(223) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR, h_temp_FD
                  , False);
         End If;
      END;
      
      -- No extending of calendars, they are extended automatically
      --h_temp_sc_state = FC_EXTEND_FISCAL_CALENDAR(SC_PARAM(h_end_year), SC_PARAM(h_temp_fiscal_finish_year));
   End If;
   --trace_printf("h_temp_sc_state: %d, h_end_year: %d\n", h_temp_sc_state,h_end_year);
   
   If (Coalesce(h_duration, 0) = 0) AND (iSF = 0) Then
      BEGIN
         SELECT SETTING_VALUE INTO h_duration FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CPLAN_PROJECT_CALENDAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 225+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(226) : wbs.sql(244) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_duration IS NULL) Then
         h_duration := 365;
      End If;
   End If;
   
   BEGIN
      SELECT
      RTRIM(RANK),
      MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN,
      MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT
      INTO
      h_rank,
      h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min,
      h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit
      FROM TMT_CALENDARS WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 251+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(252) : wbs.sql(270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         SELECT
         RTRIM(RANK),
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT
         INTO
         h_rank,
         h_monday_min, h_tuesday_min, h_wednesday_min, h_thursday_min, h_friday_min, h_saturday_min, h_sunday_min,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit
         FROM TMT_CALENDARS WHERE ELEMENT_ID = 'DEFAULT_CALENDAR';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 273+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(274) : wbs.sql(292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- Insert records day by day
   -- ********************************************************************
   -- IMPORTANT SETTING, PMOv4 SETS SUNDAY AS THE FIRST DAY OF THE WEEK
   -- ********************************************************************
   
   -- Get start_date (weekday value)
   BEGIN
      SELECT PMO_ORASTD.DAYOFWEEK(TO_DATE(SubStr(h_SD, 1, 10))) INTO h_current_weekday FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 293+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(294) : wbs.sql(312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("0_* iSF: %d, h_SD: %d:%s, h_FD %d:%s, h_duration: %d:%d\n", iSF, h_SD_Ind,h_SD, h_FD_Ind,h_FD, h_duration_Ind,h_duration);
   -- Get total_day_count
   If (Coalesce(h_duration, 0) = 0) AND (iSF = 1) Then
      -- Assuming the start_date and finish_date are in good format
      BEGIN
         SELECT PMO_ORASTD.DAYS(TO_DATE(SubStr(h_FD, 1, 10))) - PMO_ORASTD.DAYS(TO_DATE(SubStr(h_SD, 1, 10))) INTO h_duration FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 310+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(311) : wbs.sql(329) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_duration, 0) < 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_CALENDAR', 317+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: POPULATE_CALENDAR(318) : wbs.sql(336) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.F_DATE_EARLIER_THAN_S_DATE;
      End If;
   End If;
   
   If Coalesce(h_duration, 0) = 0 Then
      h_duration := 365;
   End If;
   
   h_current_daynumber := 0;
   h_count := 0;
   --trace_printf("1_* h_SD: %d:%s, h_FD %d:%s, h_duration: %d:%d\n", h_SD_Ind,h_SD, h_FD_Ind,h_FD, h_duration_Ind,h_duration);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_RES_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   LOOP
      CASE h_current_weekday
         WHEN 1 THEN
            h_current_bit := h_sunday_bit;
            h_current_min := Coalesce(h_sunday_min, 0);
         
         WHEN 2 THEN
            h_current_bit := h_monday_bit;
            h_current_min := Coalesce(h_monday_min, 0);
         
         WHEN 3 THEN
            h_current_bit := h_tuesday_bit;
            h_current_min := Coalesce(h_tuesday_min, 0);
         
         WHEN 4 THEN
            h_current_bit := h_wednesday_bit;
            h_current_min := Coalesce(h_wednesday_min, 0);
         
         WHEN 5 THEN
            h_current_bit := h_thursday_bit;
            h_current_min := Coalesce(h_thursday_min, 0);
         
         WHEN 6 THEN
            h_current_bit := h_friday_bit;
            h_current_min := Coalesce(h_friday_min, 0);
         
         WHEN 7 THEN
            h_current_bit := h_saturday_bit;
            h_current_min := Coalesce(h_saturday_min, 0);
         ELSE
            NULL;
      END CASE;
      
      BEGIN
         SELECT  TO_DATE(SubStr(h_SD, 1, 10)) + h_current_daynumber      INTO h_FD
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 377+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(378) : wbs.sql(396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("h_count: %d, h_current_min: %d,h_finish_date: %s, h_FD: %s\n",h_count,h_current_min,h_finish_date,h_FD);
      
      If PMO_ORASTD.strncmp(h_finish_date, h_FD, 10) < 0 Then
         EXIT;
      End If;
      
      -- insert into DayOfYear Table
      If Coalesce(h_current_min, 0) > 0 Then
         /*          BEGIN_SQL
                         UPDATE CALENDAR_DAY_OF_YEAR SET
                             AVAILABLE_MIN = HOST(h_current_min),
                             BIT_SCHED = HOST(h_current_bit),
                             REC_STATUS = 'U'
                         WHERE ELEMENT_ID = HOST(h_element_id) AND DAY_YEAR = DATE(HOST(h_FD));
                     END_SQL;
         */
         --          if( SC_NODATA )
         --          {
         BEGIN
            SELECT PMO_ORASTD.WEEK_ISO(h_FD), PMO_ORASTD.MONTH(h_FD)
            INTO h_week_iso, h_month_iso
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 409+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(410) : wbs.sql(428) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
            BEGIN
               INSERT INTO PMO_RES_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS,WEEK_OF,MONTH_OF,YEAR_OF)
               VALUES(h_element_id, h_FD, h_current_weekday, h_current_min, h_current_bit, 'I',PMO_ORASTD.WEEK_ISO(h_FD), 1, PMO_ORASTD.YEAR(h_FD)+1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 428+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(429) : wbs.sql(447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
            BEGIN
               INSERT INTO PMO_RES_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS,WEEK_OF,MONTH_OF,YEAR_OF)
               VALUES(h_element_id, h_FD, h_current_weekday, h_current_min, h_current_bit, 'I',PMO_ORASTD.WEEK_ISO(h_FD), 12, PMO_ORASTD.YEAR(h_FD)-1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 446+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(447) : wbs.sql(465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               INSERT INTO PMO_RES_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS,WEEK_OF,MONTH_OF,YEAR_OF)
               VALUES(h_element_id, h_FD, h_current_weekday, h_current_min, h_current_bit, 'I',PMO_ORASTD.WEEK_ISO(h_FD), PMO_ORASTD.MONTH(h_FD), PMO_ORASTD.YEAR(h_FD));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 464+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(465) : wbs.sql(483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --          }
         
         If (iSF = 0) AND (Coalesce(h_count, 0) >= Coalesce(h_duration, 0)) Then
            --trace_printf("1_ h_finish_date: %d:%s, h_FD: %d:%s\n",h_finish_date_Ind,h_finish_date,h_FD_Ind,h_FD);
            BEGIN
               BEGIN
                  SELECT FISCAL_YEAR, FISCAL_MONTH INTO h_end_year, h_end_month 
                          FROM FISCAL_CALENDAR WHERE h_FD BETWEEN START_DATE AND FINISH_DATE;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 483+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(484) : wbs.sql(502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'POPULATE_CALENDAR', 489+1) THEN 
                     LFILE.FPUT('AllTrace', '        RETURN_ERROR: POPULATE_CALENDAR(490) : wbs.sql(508) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR), 'NULL'));
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_CALENDAR', 492+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: POPULATE_CALENDAR(493) : wbs.sql(511) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.DATE_NOT_IN_FISCAL_CALENDAR, h_FD, False);
               End If;
            END;
            
            BEGIN
               SELECT FINISH_DATE INTO h_finish_date FROM FISCAL_CALENDAR WHERE FISCAL_YEAR = h_end_year AND FISCAL_MONTH = 12;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 506+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(507) : wbs.sql(525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_duration := Coalesce(h_duration, 0) + 400;
            --trace_printf("2_ h_finish_date: %d:%s, h_FD: %d:%s\n",h_finish_date_Ind,h_finish_date,h_FD_Ind,h_FD);
         End If;
         
         h_count := Coalesce(h_count, 0) + 1;
      End If;
      
      h_current_weekday := Coalesce(h_current_weekday, 0) + 1;
      
      If Coalesce(h_current_weekday, 0) = 8 Then
         h_current_weekday := 1;
      End If;
      
      h_current_daynumber := Coalesce(h_current_daynumber, 0) + 1;
   END LOOP;
   --trace_printf("2_* h_SD: %d:%s, h_FD %d:%s, h_duration: %d:%d\n", h_SD_Ind,h_SD, h_FD_Ind,h_FD, h_duration_Ind,h_duration);
   
   -- ********************************************************************
   -- Insert exceptions
   -- ********************************************************************
   If Coalesce(Length(h_FD), 0) = 0 Then
      BEGIN
         SELECT  TO_DATE(SubStr(h_SD, 1, 10)) + h_duration      INTO h_FD
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 541+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(542) : wbs.sql(560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- if there are exception...
   
   OPEN C_EXCEPTS;
   
   LOOP
      FETCH C_EXCEPTS INTO h_exception_date, h_current_min, h_current_bit;
      IF C_EXCEPTS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      If Coalesce(h_current_min, 0) > 0 Then
         BEGIN
            UPDATE PMO_RES_CDY SET
            AVAILABLE_MIN = h_current_min,
            BIT_SCHED = h_current_bit,
            REC_STATUS = 'U'
            WHERE ELEMENT_ID = h_element_id
            AND DAY_YEAR = TO_DATE(SubStr(h_exception_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 580+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(581) : wbs.sql(599) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               SELECT PMO_ORASTD.WEEK_ISO(h_exception_date), PMO_ORASTD.MONTH(h_exception_date)
               INTO h_week_iso, h_month_iso
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 596+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(597) : wbs.sql(615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_week_iso, 0) = 1) AND (Coalesce(h_month_iso, 0) = 12) Then
               BEGIN
                  INSERT INTO PMO_RES_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS,WEEK_OF,MONTH_OF,YEAR_OF)
                  VALUES(h_element_id, h_exception_date, PMO_ORASTD.DAYOFWEEK(h_exception_date), h_current_min, h_current_bit, 'I',PMO_ORASTD.WEEK_ISO(h_exception_date), 1, PMO_ORASTD.YEAR(h_exception_date)+1);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 615+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(616) : wbs.sql(634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf (Coalesce(h_week_iso, 0) = 53) AND (Coalesce(h_month_iso, 0) = 1) Then
               BEGIN
                  INSERT INTO PMO_RES_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS,WEEK_OF,MONTH_OF,YEAR_OF)
                  VALUES(h_element_id, h_exception_date, PMO_ORASTD.DAYOFWEEK(h_exception_date), h_current_min, h_current_bit, 'I',PMO_ORASTD.WEEK_ISO(h_exception_date), 12, PMO_ORASTD.YEAR(h_exception_date)-1);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 633+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(634) : wbs.sql(652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO PMO_RES_CDY(ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, REC_STATUS,WEEK_OF,MONTH_OF,YEAR_OF)
                  VALUES(h_element_id, h_exception_date, PMO_ORASTD.DAYOFWEEK(h_exception_date), h_current_min, h_current_bit, 'I',PMO_ORASTD.WEEK_ISO(h_exception_date), PMO_ORASTD.MONTH(h_exception_date), PMO_ORASTD.YEAR(h_FD));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 651+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(652) : wbs.sql(670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      ElsIf Coalesce(h_current_min, 0) = 0 Then
         BEGIN
            DELETE FROM PMO_RES_CDY
            WHERE ELEMENT_ID = h_element_id
            AND DAY_YEAR = TO_DATE(SubStr(h_exception_date, 1, 10));
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 672+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(673) : wbs.sql(691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_EXCEPTS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 687+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(688) : wbs.sql(706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO CALENDAR_DAY_OF_YEAR SELECT * FROM PMO_RES_CDY WHERE DAY_YEAR BETWEEN TO_DATE(SubStr(h_SD, 1, 10)) AND TO_DATE(SubStr(h_FD, 1, 10)) AND DAY_YEAR NOT IN (
      SELECT DAY_YEAR FROM CALENDAR_DAY_OF_YEAR WHERE ELEMENT_ID = h_element_id AND DAY_YEAR BETWEEN TO_DATE(SubStr(h_SD, 1, 10)) AND TO_DATE(SubStr(h_FD, 1, 10)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'POPULATE_CALENDAR', 705+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: POPULATE_CALENDAR(706) : wbs.sql(724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'POPULATE_CALENDAR', 711+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: POPULATE_CALENDAR(712) : wbs.sql(730) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION POPULATE_CALENDAR;
ALTER FUNCTION POPULATE_CALENDAR COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION PROJECT_CALENDAR ==
CREATE OR REPLACE FUNCTION PROJECT_CALENDAR
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , h_calendar_id IN OUT NOCOPY VARCHAR2
   , h_start IN OUT NOCOPY DATE
   , h_finish IN OUT NOCOPY DATE
   , sh_h_duration PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_duration PLS_INTEGER := sh_h_duration;
   h_FD DATE;
   h_SD DATE;
   h_c1_1 VARCHAR2(1);
   h_c1_2 VARCHAR2(1);
   h_c1_3 VARCHAR2(1);
   h_c1_4 VARCHAR2(1);
   h_c1_5 VARCHAR2(1);
   h_c1_6 VARCHAR2(1);
   h_c1_7 VARCHAR2(1);
   h_c32 VARCHAR2(32);
   h_c50 VARCHAR2(50);
   h_old_calendar VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_level PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_mpw PLS_INTEGER := 0;
   h_n1 PLS_INTEGER := 0;
   h_n2 PLS_INTEGER := 0;
   h_n3 PLS_INTEGER := 0;
   h_n4 PLS_INTEGER := 0;
   h_n5 PLS_INTEGER := 0;
   h_n6 PLS_INTEGER := 0;
   h_n7 PLS_INTEGER := 0;
   h_n8 PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_friday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_monday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_saturday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_sunday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_thursday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_tuesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_wednesday_bit RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('PROJECT_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('PROJECT_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := PROJECT_CALENDAR(' || 
       '''' || h_element_id || ''''
          || ', ' || '''' || h_calendar_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_duration), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'PROJECT_CALENDAR', 56+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: PROJECT_CALENDAR(57) : wbs.sql(797) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT PARENT_ID INTO h_old_calendar FROM TMT_CALENDARS WHERE ELEMENT_ID = h_element_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'PROJECT_CALENDAR', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: PROJECT_CALENDAR(70) : wbs.sql(810) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_element_id: %s, h_start: %d:%s, h_finish: %d:%s\n", SC_STATE,h_element_id,h_start_Ind,h_start,h_finish_Ind,h_finish);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If PMO_ORASTD.strcmp(h_old_calendar, h_calendar_id) <> 0 Then
         -- if calendar is changed
         BEGIN
            UPDATE TMT_CALENDARS SET CHILD_COUNT = CHILD_COUNT - 1  WHERE ELEMENT_ID = h_old_calendar;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'PROJECT_CALENDAR', 90+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: PROJECT_CALENDAR(91) : wbs.sql(831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               DELETE FROM TMT_CALENDARS WHERE ELEMENT_ID = h_element_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'PROJECT_CALENDAR', 108+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: PROJECT_CALENDAR(109) : wbs.sql(849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   If ((h_old_calendar IS NULL)) OR (PMO_ORASTD.strcmp(h_old_calendar, h_calendar_id) <> 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'PROJECT_CALENDAR', 118+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: PROJECT_CALENDAR(119) : wbs.sql(859) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_CALENDARS' || '''' || ' ID: ' || '''' || h_calendar_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_CALENDARS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_calendar_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_calendar_id, False); 
      END;
      
      BEGIN
         SELECT TYPE_ID INTO h_type_id FROM TMT_WBS WHERE ELEMENT_ID = h_element_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'PROJECT_CALENDAR', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: PROJECT_CALENDAR(138) : wbs.sql(878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d, h_type_id: %d\n", SC_STATE,h_type_id);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         h_type_id := PMO_CNST.SC_RESOURCE;
      End If;
      
      PMODEFINES.PMO_GET_MAX_RANK('TMT_CALENDARS', h_calendar_id, h_max_rank);
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         SELECT
         RTRIM(Rank) || h_rankBase64, ELEMENT_NAME, LEVEL_ID + 1, REC_USER,
         CASE
         WHEN MONDAY_STATUS = '0' THEN '0'
         WHEN MONDAY_STATUS = '1' THEN '1'
         WHEN MONDAY_STATUS = '3' THEN '3'
         WHEN MONDAY_STATUS = '4' THEN '4'
         WHEN MONDAY_STATUS = '5' THEN '3'
         WHEN MONDAY_STATUS = '6' THEN '4'
         end,
         CASE
         WHEN TUESDAY_STATUS = '0' THEN '0'
         WHEN TUESDAY_STATUS = '1' THEN '1'
         WHEN TUESDAY_STATUS = '3' THEN '3'
         WHEN TUESDAY_STATUS = '4' THEN '4'
         WHEN TUESDAY_STATUS = '5' THEN '3'
         WHEN TUESDAY_STATUS = '6' THEN '4'
         end,
         CASE
         WHEN WEDNESDAY_STATUS = '0' THEN '0'
         WHEN WEDNESDAY_STATUS = '1' THEN '1'
         WHEN WEDNESDAY_STATUS = '3' THEN '3'
         WHEN WEDNESDAY_STATUS = '4' THEN '4'
         WHEN WEDNESDAY_STATUS = '5' THEN '3'
         WHEN WEDNESDAY_STATUS = '6' THEN '4'
         end,
         CASE
         WHEN THURSDAY_STATUS = '0' THEN '0'
         WHEN THURSDAY_STATUS = '1' THEN '1'
         WHEN THURSDAY_STATUS = '3' THEN '3'
         WHEN THURSDAY_STATUS = '4' THEN '4'
         WHEN THURSDAY_STATUS = '5' THEN '3'
         WHEN THURSDAY_STATUS = '6' THEN '4'
         end,
         CASE
         WHEN FRIDAY_STATUS = '0' THEN '0'
         WHEN FRIDAY_STATUS = '1' THEN '1'
         WHEN FRIDAY_STATUS = '3' THEN '3'
         WHEN FRIDAY_STATUS = '4' THEN '4'
         WHEN FRIDAY_STATUS = '5' THEN '3'
         WHEN FRIDAY_STATUS = '6' THEN '4'
         end,
         CASE
         WHEN SATURDAY_STATUS = '0' THEN '0'
         WHEN SATURDAY_STATUS = '1' THEN '1'
         WHEN SATURDAY_STATUS = '3' THEN '3'
         WHEN SATURDAY_STATUS = '4' THEN '4'
         WHEN SATURDAY_STATUS = '5' THEN '3'
         WHEN SATURDAY_STATUS = '6' THEN '4'
         end,
         CASE
         WHEN SUNDAY_STATUS = '0' THEN '0'
         WHEN SUNDAY_STATUS = '1' THEN '1'
         WHEN SUNDAY_STATUS = '3' THEN '3'
         WHEN SUNDAY_STATUS = '4' THEN '4'
         WHEN SUNDAY_STATUS = '5' THEN '3'
         WHEN SUNDAY_STATUS = '6' THEN '4'
         end,
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN, WEEKLY_MIN,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT,
         MINUTES_PER_DAY, MINUTES_PER_WEEK
         INTO
         h_rank, h_c50, h_level, h_c32, h_c1_1, h_c1_2, h_c1_3, h_c1_4, h_c1_5, h_c1_6, h_c1_7,
         h_n1, h_n2, h_n3, h_n4, h_n5, h_n6, h_n7, h_n8,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit,
         h_mpd, h_mpw
         FROM TMT_CALENDARS WHERE ELEMENT_ID = h_calendar_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'PROJECT_CALENDAR', 224+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: PROJECT_CALENDAR(225) : wbs.sql(965) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO TMT_CALENDARS(
         RANK, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID, REC_USER,
         MONDAY_STATUS, TUESDAY_STATUS, WEDNESDAY_STATUS, THURSDAY_STATUS, FRIDAY_STATUS, SATURDAY_STATUS, SUNDAY_STATUS,
         MONDAY_DEFAULT_MIN, TUESDAY_DEFAULT_MIN, WEDNESDAY_DEFAULT_MIN, THURSDAY_DEFAULT_MIN, FRIDAY_DEFAULT_MIN, SATURDAY_DEFAULT_MIN, SUNDAY_DEFAULT_MIN, WEEKLY_DEFAULT_MIN,
         MONDAY_MIN, TUESDAY_MIN, WEDNESDAY_MIN, THURSDAY_MIN, FRIDAY_MIN, SATURDAY_MIN, SUNDAY_MIN, WEEKLY_MIN,
         MONDAY_DEFAULT_BIT, TUESDAY_DEFAULT_BIT, WEDNESDAY_DEFAULT_BIT, THURSDAY_DEFAULT_BIT, FRIDAY_DEFAULT_BIT, SATURDAY_DEFAULT_BIT, SUNDAY_DEFAULT_BIT,
         MONDAY_BIT, TUESDAY_BIT, WEDNESDAY_BIT, THURSDAY_BIT, FRIDAY_BIT, SATURDAY_BIT, SUNDAY_BIT,
         MINUTES_PER_DAY, MINUTES_PER_WEEK)
         VALUES(h_rank, h_calendar_id, h_element_id, h_c50, h_type_id, h_level, h_c32,
         h_c1_1, h_c1_2, h_c1_3, h_c1_4, h_c1_5, h_c1_6, h_c1_7,
         h_n1, h_n2, h_n3, h_n4, h_n5, h_n6, h_n7, h_n8,
         h_n1, h_n2, h_n3, h_n4, h_n5, h_n6, h_n7, h_n8,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit,
         h_monday_bit, h_tuesday_bit, h_wednesday_bit, h_thursday_bit, h_friday_bit, h_saturday_bit, h_sunday_bit,
         h_mpd, h_mpw);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'PROJECT_CALENDAR', 255+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: PROJECT_CALENDAR(256) : wbs.sql(996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("h_start: %d:%s, h_finish: %d:%s,h_type_id: %d\n", h_start_Ind,h_start,h_finish_Ind,h_finish,h_type_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'PROJECT_CALENDAR', 263+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: PROJECT_CALENDAR(264) : wbs.sql(1004) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN POPULATE_CALENDAR(h_element_id, h_type_id, h_start, h_finish, h_duration);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'PROJECT_CALENDAR', 268+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: PROJECT_CALENDAR(269) : wbs.sql(1009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION PROJECT_CALENDAR;
ALTER FUNCTION PROJECT_CALENDAR COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_WBS_MSP ==
CREATE OR REPLACE FUNCTION SP_I_WBS_MSP
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
   , p_ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_ieflag PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_WBS_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_WBS_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_I_WBS_MSP(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(p_ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_WBS_MSP', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_WBS_MSP(29) : wbs.sql(1048) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type := p_type;
   h_rec_user := p_rec_user;
   h_ieflag := p_ieflag;
   
   PMO_DB2M.SC_STATE := FC_I_WBS_MSP(h_name, h_parent_id, h_type, h_rec_user, h_ieflag, h_uniqueID);
   
   --if ( (SC_STATE == 0)  (h_ieflag == 9) )
   --{
   --  strnpcpy((char *) p_rec_user + 2, sizeof((char *) p_rec_user + 2), h_uniqueID);
   --}
   --else
   --{
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_WBS_MSP', 46+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_WBS_MSP(47) : wbs.sql(1066) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   --}
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_WBS_MSP', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_WBS_MSP(55) : wbs.sql(1074) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_WBS_MSP', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_WBS_MSP(67) : wbs.sql(1086) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_WBS_MSP;
ALTER FUNCTION SP_I_WBS_MSP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_S_FTE ==
CREATE OR REPLACE FUNCTION SP_S_FTE
(
     p_type PLS_INTEGER
   , p_id VARCHAR2
   , p_ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_SS VARCHAR2(26);
   h_SF VARCHAR2(26);
   h_start_finish_date VARCHAR2(26);
   h_finish_start_date VARCHAR2(26);
   h_current_date VARCHAR2(26);
   h_start_date VARCHAR2(26);
   h_min_per_day PLS_INTEGER := 0;
   h_est_remaining_duration PLS_INTEGER := 0;
   h_remaining_duration PLS_INTEGER := 0;
   x_duration PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_S_TFE PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_FTE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_FTE'), '-- ' || SYSTIMESTAMP, ':r := SP_S_FTE(' || 
       COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FTE', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_FTE(33) : wbs.sql(1135) : ' || SYSTIMESTAMP);
   END IF; 

   
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_FTE', 38+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_FTE(39) : wbs.sql(1141) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FTE', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FTE(42) : wbs.sql(1144) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(p_type, 0) = PMO_CNST.SC_TABLE_WBS Then
      BEGIN
         SELECT PROJECT_ID, UNRESOLVED_START, UNRESOLVED_FINISH
         INTO h_project_id, h_SS, h_SF
         FROM TMT_WBS
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 58+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(59) : wbs.sql(1161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PROJECT_ID, UNRESOLVED_START, UNRESOLVED_FINISH
         INTO h_project_id, h_SS, h_SF
         FROM TMT_CRI
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(75) : wbs.sql(1177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_FTE', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_FTE(82) : wbs.sql(1184) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FTE', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FTE(85) : wbs.sql(1187) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   BEGIN
      SELECT (RTRIM(TO_CHAR(TO_DATE(SYSDATE))) || ' 08:00:00'),
      CASE WHEN START_FINISH_DATE IS NULL THEN NULL ELSE (RTRIM(TO_CHAR(START_FINISH_DATE)) || ' 08:00:00') END,
      CASE WHEN FINISH_START_DATE IS NULL THEN NULL ELSE (RTRIM(TO_CHAR(FINISH_START_DATE)) || ' 17:00:00') END,
      MINUTE_PER_DAY
      INTO h_current_date, h_start_finish_date, h_finish_start_date, h_min_per_day
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 103+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(104) : wbs.sql(1206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_SD: %s, h_FD: %s, h_SF: %s\n", SC_STATE, h_SD, h_FD, h_SF);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_FTE', 111+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_FTE(112) : wbs.sql(1214) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FTE', 114+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_FTE(115) : wbs.sql(1217) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   -- Load Calendar
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_MIN_MAX';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_CDY
      SELECT ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF
      FROM CALENDAR_DAY_OF_YEAR
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 143+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(144) : wbs.sql(1246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_MIN_MAX
      SELECT MIN(DAY_YEAR), MAX(DAY_YEAR), h_min_per_day, TO_TIMESTAMP('1899-12-30 8:00:00'),TO_TIMESTAMP('1899-12-30 8:00:00'), 0
      FROM PMO_TMP_CDY;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(163) : wbs.sql(1265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_est_remaining_duration := 0;
   If ((h_finish_start_date IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_finish_start_date, h_current_date
         , 10) > 0) Then
      If PMO_ORASTD.strncmp(h_start_finish_date, h_current_date, 10) >= 0 Then
         h_start_date := SubStr(h_start_finish_date, 1, 26);
      Else
         BEGIN
            SELECT (RTRIM(TO_CHAR(MIN(DAY_YEAR))) || ' 08:00:00') INTO h_start_date
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND TO_DATE(SubStr(h_finish_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(185) : wbs.sql(1287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      x_duration := 0;
      h_est_remaining_duration := GET_FD_DURATION(h_project_id, h_start_date, h_finish_start_date
                                            , x_duration);
   End If;
   
   If Coalesce(h_est_remaining_duration, 0) = 0 Then
      h_est_remaining_duration := Coalesce(h_min_per_day, 0);
   End If;
   
   h_remaining_duration := 0;
   If PMO_ORASTD.strncmp(h_SF, h_current_date, 10) > 0 Then
      If PMO_ORASTD.strncmp(h_SS, h_current_date, 10) >= 0 Then
         h_start_date := SubStr(h_SS, 1, 26);
      Else
         BEGIN
            SELECT (RTRIM(TO_CHAR(MIN(DAY_YEAR))) || ' 08:00:00') INTO h_start_date
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR BETWEEN TO_DATE(SubStr(TO_DATE(SYSDATE), 1, 10)) AND TO_DATE(SubStr(h_SF, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(216) : wbs.sql(1318) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      x_duration := 0;
      h_remaining_duration := GET_FD_DURATION(h_project_id, h_start_date, h_SF, x_duration);
   End If;
   
   If Coalesce(h_remaining_duration, 0) = 0 Then
      h_remaining_duration := Coalesce(h_min_per_day, 0);
   End If;
   
   OPEN C_S_TFE FOR SELECT h_est_remaining_duration AS EST_REMAINING, h_remaining_duration AS SCHED_REMAINING
   FROM DUAL;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_FTE', 232+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_FTE(233) : wbs.sql(1335) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_S_TFE;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 240+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(241) : wbs.sql(1343) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_FTE', 252+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_FTE(253) : wbs.sql(1355) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_FTE;
ALTER FUNCTION SP_S_FTE COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_I_PORTF ==
CREATE OR REPLACE FUNCTION SP_I_PORTF
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type_id PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_PORTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_PORTF'), '-- ' || SYSTIMESTAMP, ':r := SP_I_PORTF(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type_id), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PORTF', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_PORTF(26) : wbs.sql(1397) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_I_PORTF', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_I_PORTF(31) : wbs.sql(1402) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_PORTF', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_PORTF(34) : wbs.sql(1405) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --Declare local variables
   
   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type_id := p_type_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_I_PORTF(h_name, h_parent_id, h_type_id, h_rec_user, h_uniqueID);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_PORTF', 48+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_PORTF(49) : wbs.sql(1420) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PORTF', 55+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PORTF(56) : wbs.sql(1427) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_PORTF', 67+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_PORTF(68) : wbs.sql(1439) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_PORTF;
ALTER FUNCTION SP_I_PORTF COMPILE DEBUG;

/********************************************************************************/

Prompt == FUNCTION SP_I_WBS ==
CREATE OR REPLACE FUNCTION SP_I_WBS
(
     p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_day_year DATE;
   h_name VARCHAR2(255);
   h_object_parent_id VARCHAR2(32);
   h_object_project_id VARCHAR2(32);
   h_object_rank VARCHAR2(200);
   h_object_transfer_flag VARCHAR2(1);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_ieflag PLS_INTEGER := 0;
   h_object_assign_count PLS_INTEGER := 0;
   h_object_child_count PLS_INTEGER := 0;
   h_object_table PLS_INTEGER := 0;
   h_object_type PLS_INTEGER := 0;
   h_transfered_object_type PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_I_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_I_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_I_WBS(' || 
       '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_WBS', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_I_WBS(39) : wbs.sql(1494) : ' || SYSTIMESTAMP);
   END IF; 

   h_name := p_name;
   h_parent_id := p_parent_id;
   h_type := p_type;
   h_rec_user := p_rec_user;
   
   -- Validate inserting child under a node ---> this validation is for concurrent environment only
   -- get selected element table and type
   PMO_DB2M.SC_STATE := FC_GET_ELEMENT_INFO(h_parent_id, h_object_rank, h_object_project_id
                                         , h_object_parent_id, h_object_table, h_object_type
                                         , h_transfered_object_type, h_object_assign_count
                                         , h_object_child_count, h_object_transfer_flag);
   
   -- This function validate inserting a child under a node according to the following conditions
   -- 1- a node that already assigned an effort can not accept any children.
   -- 2- in CRI the types (SC_CRI_RISK_TASK, SC_CRI_ISSUE_TASK, SC_CRI_CHANGE_REQUEST_TASK) can not accept children
   -- 3- in WBS the types (SC_WBS_RISK_TASK, SC_WBS_ISSUE_TASK, SC_WBS_CHANGE_REQUEST_TASK) can not accept children
   -- 4- in REQ the types (SC_WBS_REQUIREMENT_TASK) can not accept children
   -- h_object_table == 1   -->  element is in TMT_WBS
   -- h_object_table == 2   -->  element is in TMT_CRI
   -- h_object_table == 3   -->  element is in TMT_REQUIREMENTS
   
   If (Coalesce(h_object_table, 0) = 20) OR (Coalesce(h_object_table, 0) = 30) Then
      h_object_table := 1;
   End If;
   
   PMO_DB2M.SC_STATE := FC_IS_VALID_INSERT_CHILD(h_object_table, h_parent_id);
   If PMO_DB2M.SC_STATE = PMO_CNST.CANNOT_ASSIGN_CHILDREN Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_I_WBS', 69+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_I_WBS(70) : wbs.sql(1525) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_I_WBS', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_I_WBS(73) : wbs.sql(1528) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, h_parent_id, True);
   End If;
   
   If Coalesce(p_type, 0) = PMO_CNST.SC_FOLDER Then
      --return SP_I_PORTF(p_name, p_parent_id, p_type, p_rec_user, nullIndicator);
      PMO_DB2M.SC_STATE := FC_I_PORTF(h_name, h_parent_id, h_type, h_rec_user, h_uniqueID);
      --      RETURN_STATUS(SC_STATE, h_uniqueID);
   Else
      h_ieflag := 0;
      PMO_DB2M.SC_STATE := FC_I_WBS_MSP(h_name, h_parent_id, h_type, h_rec_user, h_ieflag, h_uniqueID);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_I_WBS', 87+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_I_WBS(88) : wbs.sql(1543) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_uniqueID || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_uniqueID, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_WBS', 94+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_WBS(95) : wbs.sql(1550) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_I_WBS', 106+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_I_WBS(107) : wbs.sql(1562) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_I_WBS;
ALTER FUNCTION SP_I_WBS COMPILE DEBUG;

/*************************************************************************/

Prompt == FUNCTION SP_U_WBS_START_FINISH_DATES ==
CREATE OR REPLACE FUNCTION SP_U_WBS_START_FINISH_DATES
(
     p_id VARCHAR2
   , p_start_finish_date VARCHAR2
   , p_finish_start_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_start_finish_date DATE;
   h_finish_start_date DATE;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_START_FINISH_DATES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_START_FINISH_DATES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_START_FINISH_DATES(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_finish_date || ''''
          || ', ' || '''' || p_finish_start_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_START_FINISH_DATES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_START_FINISH_DATES(24) : wbs.sql(1602) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_START_FINISH_DATES', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_START_FINISH_DATES(30) : wbs.sql(1608) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_START_FINISH_DATES', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_START_FINISH_DATES(33) : wbs.sql(1611) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_start_finish_date := p_start_finish_date;
   h_finish_start_date := p_finish_start_date;
   
   BEGIN
      UPDATE TMT_WBS SET
      START_FINISH_DATE = h_start_finish_date,
      FINISH_START_DATE = h_finish_start_date,
      ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_START_FINISH_BIT)
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_START_FINISH_DATES', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_START_FINISH_DATES(58) : wbs.sql(1636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_START_FINISH_DATES', 63+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_START_FINISH_DATES(64) : wbs.sql(1642) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_START_FINISH_DATES', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_START_FINISH_DATES(71) : wbs.sql(1649) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_START_FINISH_DATES', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_START_FINISH_DATES(83) : wbs.sql(1661) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_START_FINISH_DATES;
ALTER FUNCTION SP_U_WBS_START_FINISH_DATES COMPILE DEBUG;

/*************************************************************************/

Prompt == FUNCTION SP_U_WBS_TIMECODES ==
CREATE OR REPLACE FUNCTION SP_U_WBS_TIMECODES
(
     p_id VARCHAR2
   , p_timecode_1_id VARCHAR2
   , p_timecode_2_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_TIMECODES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_TIMECODES'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_TIMECODES(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_timecode_1_id || ''''
          || ', ' || '''' || p_timecode_2_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TIMECODES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_TIMECODES(24) : wbs.sql(1701) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TIMECODES', 29+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TIMECODES(30) : wbs.sql(1707) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TIMECODES', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TIMECODES(33) : wbs.sql(1710) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   BEGIN
      SELECT PROJECT_ID, RTRIM(RANK)
      INTO h_project_id, h_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TIMECODES', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TIMECODES(51) : wbs.sql(1728) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TIMECODES', 56+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TIMECODES(57) : wbs.sql(1734) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TIMECODES', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TIMECODES(60) : wbs.sql(1737) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE TASK_ASSIGNMENTS SET
      TIMECODE_1_ID = p_timecode_1_id,
      TIMECODE_2_ID = p_timecode_2_id
      WHERE PROJECT_ID = h_project_id
      AND TASK_ID IN (
      SELECT ELEMENT_ID
      FROM TMT_WBS
      WHERE RANK LIKE h_rank || '%'
      AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
      AND TIMECODE_1_ID IS NULL
      AND TIMECODE_2_ID IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TIMECODES', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TIMECODES(100) : wbs.sql(1777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS SET
      TIMECODE_1_ID = p_timecode_1_id,
      TIMECODE_2_ID = p_timecode_2_id
      WHERE RANK LIKE h_rank || '%'
      AND TIMECODE_1_ID IS NULL
      AND TIMECODE_2_ID IS NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TIMECODES', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TIMECODES(122) : wbs.sql(1799) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS SET
      TIMECODE_1_ID = p_timecode_1_id,
      TIMECODE_2_ID = p_timecode_2_id
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TIMECODES', 141+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TIMECODES(142) : wbs.sql(1819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_TIMECODES', 147+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_TIMECODES(148) : wbs.sql(1825) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TIMECODES', 154+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TIMECODES(155) : wbs.sql(1832) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TIMECODES', 166+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TIMECODES(167) : wbs.sql(1844) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_TIMECODES;
ALTER FUNCTION SP_U_WBS_TIMECODES COMPILE DEBUG;

/******************************************************************************
* start_finish_flag  = '0' start
*                           = '1' finish
*******************************************************************************/

Prompt == FUNCTION SP_U_WBS_REQUEST ==
CREATE OR REPLACE FUNCTION SP_U_WBS_REQUEST
(
     p_id VARCHAR2
   , p_start_finish_flag VARCHAR2
   , p_buffer_percent PLS_INTEGER
   , p_reporting_freq PLS_INTEGER
   , p_start_time VARCHAR2
   , p_end_time VARCHAR2
   , p_minute_per_day PLS_INTEGER
   , p_calendar_id VARCHAR2
   , p_currency_id PLS_INTEGER
   , p_request_descr VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   stmt VARCHAR2(4000);
   h_F TIMESTAMP;
   h_FD DATE;
   h_S TIMESTAMP;
   h_SD DATE;
   h_calendar_id VARCHAR2(32);
   h_end_time VARCHAR2(8);
   h_start_finish_date DATE;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_finish_start_date DATE;
   h_id VARCHAR2(32);
   h_old_calendar VARCHAR2(32);
   h_pf_date TIMESTAMP;
   h_project_id VARCHAR2(32);
   h_ps_date TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_start_finish_flag VARCHAR2(1);
   h_start_time VARCHAR2(8);
   h_child_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_cur_year PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_mpd PLS_INTEGER := 0;
   h_mpw PLS_INTEGER := 0;
   h_start_year PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   iCal PLS_INTEGER;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_REQUEST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_REQUEST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_REQUEST(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_finish_flag || ''''
          || ', ' || COALESCE(TO_CHAR(p_buffer_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_reporting_freq), 'NULL')
          || ', ' || '''' || p_start_time || ''''
          || ', ' || '''' || p_end_time || ''''
          || ', ' || COALESCE(TO_CHAR(p_minute_per_day), 'NULL')
          || ', ' || '''' || p_calendar_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_currency_id), 'NULL')
          || ', ' || '''' || p_request_descr || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_REQUEST', 66+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_REQUEST(67) : wbs.sql(1930) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_REQUEST', 71+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_REQUEST(72) : wbs.sql(1935) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_REQUEST', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_REQUEST(75) : wbs.sql(1938) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   h_id := p_id;
   h_calendar_id := p_calendar_id;
   
   BEGIN
      SELECT  RANK, PROJECT_ID, TYPE_ID,
      CALENDAR_ID, START_FINISH_DATE, FINISH_START_DATE,
      REC_STATUS, CHILD_COUNT
      INTO    h_rank, h_project_id, h_type,
      h_old_calendar, h_start_finish_date, h_finish_start_date,
      h_rec_status, h_child_count
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(99) : wbs.sql(1962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_REQUEST', 104+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_REQUEST(105) : wbs.sql(1968) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_REQUEST', 107+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_REQUEST(108) : wbs.sql(1971) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   BEGIN
      SELECT MINUTES_PER_DAY, MINUTES_PER_WEEK
      INTO h_mpd, h_mpw
      FROM TMT_CALENDARS
      WHERE ELEMENT_ID = h_calendar_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(124) : wbs.sql(1987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_REQUEST', 129+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_REQUEST(130) : wbs.sql(1993) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_calendar_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_REQUEST', 132+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_REQUEST(133) : wbs.sql(1996) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_calendar_id, True);
   End If;
   
   If isProjectType(Coalesce(h_type, 0)) <> 0 Then
      If (p_start_finish_flag IS NULL) Then
         h_start_finish_flag := '0';
      Else
         h_start_finish_flag := p_start_finish_flag;
      End If;
      
      iCal := 0;
      
      If (h_old_calendar IS NULL) Then
         iCal := 1;
      Else
         iCal := PMO_ORASTD.strcmp(h_old_calendar, h_calendar_id);
      End If;
      
      If iCal <> 0 Then
         If (h_finish_start_date IS NULL) Then
            BEGIN
               SELECT SETTING_VALUE INTO h_duration FROM TMT_SETTINGS WHERE ELEMENT_ID = 'CPLAN_PROJECT_CALENDAR';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 162+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(163) : wbs.sql(2026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If ((h_duration IS NULL)) OR (Coalesce(h_duration, 0) = 0) Then
               h_duration := 365;
            End If;
            
            BEGIN
               SELECT TO_DATE(SubStr(h_start_finish_date, 1, 10)) + h_duration      INTO h_finish_start_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 180+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(181) : wbs.sql(2044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("2_** h_finish_start_date: %d:%s\n",h_finish_start_date_Ind,h_finish_start_date);
         End If;
         
         h_start_date := h_start_finish_date;
         h_finish_date := h_finish_start_date;
         h_temp_sc_state := FC_FISCAL_SF_DATE(h_start_finish_date, h_finish_start_date);
         
         h_temp_var := 0;
         h_temp_sc_state := PROJECT_CALENDAR(h_id, h_calendar_id, h_start_finish_date, h_finish_start_date
                                    , h_temp_var);
         h_temp_sc_state := FC_TIMEPHASE_CALENDAR(h_id, h_start_finish_date, h_finish_start_date);
      End If;
      
      -- Execute Update Statement
      If Coalesce(h_child_count, 0) = 0 Then
         BEGIN
            SELECT
            PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_start_date, 1, 10)),PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))),
            PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_finish_date, 1, 10)),PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED)))
            INTO
            h_ps_date,
            h_pf_date
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_id
            AND DAY_YEAR = TO_DATE(SubStr(h_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 215+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(216) : wbs.sql(2079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            BEGIN
               SELECT
               PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_start_date, 1, 10)),'08:00:00'),
               PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_finish_date, 1, 10)),'17:00:00')
               INTO
               h_ps_date,
               h_pf_date
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(236) : wbs.sql(2099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE TMT_WBS SET
            CALENDAR_ID         = h_id,
            MINUTE_PER_DAY      = h_mpd,
            MINUTE_PER_WEEK     = h_mpw,
            CURRENCY_ID     = p_currency_id,
            TOOLTIP_DESCR       = p_request_descr,
            BUFFER_PERCENT      = p_buffer_percent,
            START_FINISH_FLAG   = p_start_finish_flag,
            PLANNED_START       = h_ps_date,
            PLANNED_DURATION    = h_mpd
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 263+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(264) : wbs.sql(2127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS SET
            CALENDAR_ID         = h_id,
            MINUTE_PER_DAY      = h_mpd,
            MINUTE_PER_WEEK     = h_mpw,
            CURRENCY_ID     = p_currency_id,
            TOOLTIP_DESCR       = p_request_descr,
            BUFFER_PERCENT      = p_buffer_percent,
            START_FINISH_FLAG   = p_start_finish_flag
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 288+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(289) : wbs.sql(2152) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      -- Execute Update Statement
      BEGIN
         UPDATE TMT_WBS SET
         CALENDAR_ID     = h_project_id,
         MINUTE_PER_DAY  = h_mpd,
         MINUTE_PER_WEEK = h_mpw,
         CURRENCY_ID = p_currency_id,
         TOOLTIP_DESCR   = p_request_descr,
         BUFFER_PERCENT  = p_buffer_percent
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 314+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(315) : wbs.sql(2178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- New Rollup
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_REQUEST', 324+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_REQUEST(325) : wbs.sql(2188) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 331+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(332) : wbs.sql(2195) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REQUEST', 343+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REQUEST(344) : wbs.sql(2207) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_REQUEST;
ALTER FUNCTION SP_U_WBS_REQUEST COMPILE DEBUG;

/********************************************************************************/

Prompt == FUNCTION SP_U_WBS_METHOD ==
CREATE OR REPLACE FUNCTION SP_U_WBS_METHOD
(
     p_id VARCHAR2
   , p_method PLS_INTEGER
   , p_effort_driven PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_source_id VARCHAR2(32);
   h_error_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_default_project VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_element_name VARCHAR2(255);
   h_effort_driven PLS_INTEGER := 0;
   h_ieflag PLS_INTEGER;
   h_bitflag PLS_INTEGER;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_METHOD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_METHOD'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_METHOD(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_method), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_effort_driven), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_METHOD', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_METHOD(32) : wbs.sql(2255) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_METHOD', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_METHOD(38) : wbs.sql(2261) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_METHOD', 40+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_METHOD(41) : wbs.sql(2264) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   h_effort_driven := p_effort_driven;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_U_WBS_METHOD', 51+1) THEN 
      LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_U_WBS_METHOD(52) : wbs.sql(2275) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT RTRIM(RANK),ELEMENT_NAME INTO h_rank,h_element_name FROM TMT_WBS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_METHOD', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_METHOD(71) : wbs.sql(2294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Update Statement
   /*  BEGIN_SQL
           UPDATE TMT_WBS SET
               METHOD=HOST_DB(p_method,ind_u_wbs_method)
           WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_wbs_method);
       END_SQL;
   
       BEGIN_SQL
           UPDATE TMT_WBS SET
               EFFORT_DRIVEN = HOST_DB(p_effort_driven,ind_u_wbs_method)
           WHERE RANK LIKE HOST(h_rank) || '%';
       END_SQL;
   */
   BEGIN
      UPDATE TMT_WBS SET
      EFFORT_DRIVEN = h_effort_driven
      WHERE RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_METHOD', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_METHOD(103) : wbs.sql(2326) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (Coalesce(p_method, 0) = 1) OR (Coalesce(p_method, 0) = 100) Then
      h_ieflag := 100;
      
      h_bitflag := 2;
      
      If Coalesce(p_method, 0) = 100 Then
         h_bitflag := 102;
      End If;
      
      h_error_id := h_id;
      h_default_project := PMO_CNST.SC_DEFAULT_PROJECT;
      
      BEGIN
         SELECT RTRIM(ELEMENT_NAME) INTO h_source_id
         FROM TMT_SETTINGS
         WHERE ELEMENT_ID = h_default_project;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_METHOD', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_METHOD(130) : wbs.sql(2353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (h_source_id IS NOT NULL) Then
         PMO_DB2M.SC_STATE := FC_C_WBS_MSP(h_id, h_source_id, h_bitflag, h_rec_user, h_ieflag, h_error_id);
         
         BEGIN
            UPDATE TMT_WBS
            SET ELEMENT_NAME = h_element_name
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_METHOD', 151+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_METHOD(152) : wbs.sql(2375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_METHOD', 159+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_METHOD(160) : wbs.sql(2383) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_METHOD', 166+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_METHOD(167) : wbs.sql(2390) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_METHOD', 178+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_METHOD(179) : wbs.sql(2402) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_METHOD;
ALTER FUNCTION SP_U_WBS_METHOD COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION SP_U_WBS_OPPORTUN ==
CREATE OR REPLACE FUNCTION SP_U_WBS_OPPORTUN
(
     p_id VARCHAR2
   , p_opportunity_name VARCHAR2
   , p_est_cost NUMBER
   , p_est_revenue NUMBER
   , p_est_payback_period PLS_INTEGER
   , p_est_payback_month PLS_INTEGER
   , p_pursuit_start VARCHAR2
   , p_pursuit_finish VARCHAR2
   , p_forecast_closed VARCHAR2
   , p_opportunity_tracking_number VARCHAR2
   , p_opportunity_owner VARCHAR2
   , p_contract_type VARCHAR2
   , p_contact_number VARCHAR2
   , p_customer_number VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_opportunity_name VARCHAR2(255);
   h_est_cost NUMBER := 0;
   h_est_revenue NUMBER := 0;
   h_est_margin NUMBER := 0;
   h_est_payback_period PLS_INTEGER := 0;
   h_est_payback_month PLS_INTEGER := 0;
   h_pursuit_start DATE;
   h_pursuit_finish DATE;
   h_forecast_closed DATE;
   h_opportunity_tracking_number VARCHAR2(255);
   h_opportunity_owner VARCHAR2(255);
   h_contract_type VARCHAR2(255);
   h_contact_number VARCHAR2(255);
   h_customer_number VARCHAR2(255);
   h_expected_margin_amount NUMBER := 0;
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_transfer_flag VARCHAR2(1);
   h_a_cri_count PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_fd PLS_INTEGER := 0;
   h_effort_driven PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_OPPORTUN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_OPPORTUN'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_OPPORTUN(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_opportunity_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_est_cost), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_est_revenue), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_est_payback_period), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_est_payback_month), 'NULL')
          || ', ' || '''' || p_pursuit_start || ''''
          || ', ' || '''' || p_pursuit_finish || ''''
          || ', ' || '''' || p_forecast_closed || ''''
          || ', ' || '''' || p_opportunity_tracking_number || ''''
          || ', ' || '''' || p_opportunity_owner || ''''
          || ', ' || '''' || p_contract_type || ''''
          || ', ' || '''' || p_contact_number || ''''
          || ', ' || '''' || p_customer_number || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_OPPORTUN', 65+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_OPPORTUN(66) : wbs.sql(2484) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_opportunity_name := p_opportunity_name;
   h_est_cost := p_est_cost;
   h_est_revenue := p_est_revenue;
   h_est_payback_period := p_est_payback_period;
   h_est_payback_month := p_est_payback_month;
   h_pursuit_start := p_pursuit_start;
   h_pursuit_finish := p_pursuit_finish;
   h_forecast_closed := p_forecast_closed;
   h_opportunity_tracking_number := p_opportunity_tracking_number;
   h_opportunity_owner := p_opportunity_owner;
   h_contract_type := p_contract_type;
   h_contact_number := p_contact_number;
   h_customer_number := p_customer_number;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT TRANSFER_FLAG, A_CRI_COUNT, TYPE_ID, FD, PROJECT_ID, PLANNED_EFFORT + SCHED_EFFORT
      INTO h_transfer_flag, h_a_cri_count ,h_type_id, h_fd, h_project_id, h_effort_driven
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_OPPORTUN', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_OPPORTUN(96) : wbs.sql(2514) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_OPPORTUN', 102+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_OPPORTUN(103) : wbs.sql(2521) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_OPPORTUN', 105+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_OPPORTUN(106) : wbs.sql(2524) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If Coalesce(h_fd, 0) = PMO_CNST.SC_AF Then
      BEGIN
         UPDATE TMT_WBS
         SET FD = PMO_CNST.SC_UAF,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_OPPORTUN', 126+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_OPPORTUN(127) : wbs.sql(2545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_DETAILS
         SET OPPORTUNITY_NAME = h_opportunity_name,
         EXPECTED_COST = h_est_cost,
         EXPECTED_REVENUE = h_est_revenue,
         EXPECTED_PAYBACK_PERIOD = h_est_payback_period,
         EXPECTED_PAYBACK_MONTH = h_est_payback_month,
         PURSUIT_START = h_pursuit_start,
         FORECAST_CLOSED = h_forecast_closed,
         PURSUIT_FINISH = h_pursuit_finish,
         OPPORTUNITY_TRACKING_NUMBER = h_opportunity_tracking_number,
         OPPORTUNITY_OWNER = h_opportunity_owner,
         CONTRACT_TYPE = h_contract_type,
         CONTACT_NUMBER = h_contact_number,
         CUSTOMER_NUMBER = h_customer_number
         WHERE PROJECT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_OPPORTUN', 157+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_OPPORTUN(158) : wbs.sql(2576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE PROJECT_DETAILS
         SET OPPORTUNITY_NAME = h_opportunity_name,
         EXPECTED_COST = h_est_cost,
         EXPECTED_REVENUE = h_est_revenue,
         EXPECTED_PAYBACK_PERIOD = h_est_payback_period,
         EXPECTED_PAYBACK_MONTH = h_est_payback_month,
         PURSUIT_START = h_pursuit_start,
         FORECAST_CLOSED = h_forecast_closed,
         PURSUIT_FINISH = h_pursuit_finish,
         OPPORTUNITY_TRACKING_NUMBER = h_opportunity_tracking_number,
         OPPORTUNITY_OWNER = h_opportunity_owner,
         CONTRACT_TYPE = h_contract_type,
         CONTACT_NUMBER = h_contact_number,
         CUSTOMER_NUMBER = h_customer_number
         WHERE PROJECT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_OPPORTUN', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_OPPORTUN(189) : wbs.sql(2607) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_OPPORTUN', 195+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_OPPORTUN(196) : wbs.sql(2614) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_OPPORTUN', 202+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_OPPORTUN(203) : wbs.sql(2621) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_OPPORTUN', 214+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_OPPORTUN(215) : wbs.sql(2633) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_OPPORTUN;
ALTER FUNCTION SP_U_WBS_OPPORTUN COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION SP_U_DESCRIPTION ==
CREATE OR REPLACE FUNCTION SP_U_DESCRIPTION
(
     p_id VARCHAR2
   , p_ref_code VARCHAR2
   , p_external_id VARCHAR2
   , p_priority PLS_INTEGER
   , p_probability PLS_INTEGER
   , p_type PLS_INTEGER
   , p_planning_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_transfer_flag VARCHAR2(1);
   h_a_cri_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DESCRIPTION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DESCRIPTION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DESCRIPTION(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_ref_code || ''''
          || ', ' || '''' || p_external_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_probability), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_planning_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DESCRIPTION', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DESCRIPTION(33) : wbs.sql(2682) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_DESCRIPTION', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_DESCRIPTION(39) : wbs.sql(2688) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DESCRIPTION', 41+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DESCRIPTION(42) : wbs.sql(2691) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_id), id, ind_u_deliv->id);
   h_id := p_id;
   
   BEGIN
      SELECT TRANSFER_FLAG, A_CRI_COUNT INTO h_transfer_flag, h_a_cri_count
      FROM TMT_WBS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DESCRIPTION', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DESCRIPTION(62) : wbs.sql(2711) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Execute Update Statement
   BEGIN
      UPDATE TMT_WBS 
      SET REF_CODE = p_ref_code,
      EXTERNAL_ID = p_external_id,
      PRIORITY = p_priority,
      CALC_PRIORITY=p_priority,
      PROBABILITY = p_probability
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DESCRIPTION', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DESCRIPTION(86) : wbs.sql(2735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_transfer_flag IS NOT NULL) Then
      BEGIN
         UPDATE TMT_CRI
         SET PRIORITY=p_priority
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DESCRIPTION', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DESCRIPTION(106) : wbs.sql(2755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_a_cri_count, 0) > 0 Then
      BEGIN
         UPDATE TMT_CRI
         SET PRIORITY=p_priority
         WHERE WBS_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DESCRIPTION', 124+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DESCRIPTION(125) : wbs.sql(2774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DESCRIPTION', 131+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DESCRIPTION(132) : wbs.sql(2781) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DESCRIPTION', 138+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DESCRIPTION(139) : wbs.sql(2788) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DESCRIPTION', 150+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DESCRIPTION(151) : wbs.sql(2800) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DESCRIPTION;
ALTER FUNCTION SP_U_DESCRIPTION COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_CONSTRAINT ==
CREATE OR REPLACE FUNCTION SP_U_CONSTRAINT
(
     p_id VARCHAR2
   , p_constraint_dt VARCHAR2
   , p_constraint_type PLS_INTEGER
   , p_task_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_constraint_dt TIMESTAMP;
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_AS TIMESTAMP;
   h_rec_status VARCHAR2(1);
   h_planned_start TIMESTAMP;
   h_planned_finish TIMESTAMP;
   h_FF TIMESTAMP;
   h_day_year DATE;
   h_constraint_type PLS_INTEGER := 0;
   h_assign_count PLS_INTEGER := 0;
   h_sd PLS_INTEGER := 0;
   h_task_type PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_old_type_id PLS_INTEGER := 0;
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   iSD PLS_INTEGER NOT NULL := 0;
   i_SF PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR GET_SD1 IS
         SELECT DAY_YEAR, AVAILABLE_MIN, BIT_SCHED
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR <= TO_DATE(SubStr(h_constraint_dt, 1, 10))
         ORDER BY DAY_YEAR DESC;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_CONSTRAINT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_CONSTRAINT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_CONSTRAINT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_constraint_dt || ''''
          || ', ' || COALESCE(TO_CHAR(p_constraint_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_task_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CONSTRAINT', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_CONSTRAINT(55) : wbs.sql(2871) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CONSTRAINT', 60+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CONSTRAINT(61) : wbs.sql(2877) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CONSTRAINT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CONSTRAINT(64) : wbs.sql(2880) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_id), id, ind_u_constraint->id);
   h_id := p_id;
   h_constraint_dt := p_constraint_dt;
   h_constraint_type := p_constraint_type;
   
   BEGIN
      SELECT PROJECT_ID, UNRESOLVED_START, UNRESOLVED_FINISH, UNRESOLVED_DURATION, ASSIGN_COUNT, MINUTE_PER_DAY,
      COALESCE(PLANNED_START,SCHED_START), SD, ACTUAL_START, TASK_TYPE, TYPE_ID, CONSTRAINT_TYPE, CONSTRAINT_DT
      INTO h_project_id, h_S, h_F, h_duration, h_assign_count, h_min_per_day,
      h_planned_start, h_sd, h_AS, h_task_type, h_type_id, h_old_type_id, h_FF
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 87+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(88) : wbs.sql(2904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_CONSTRAINT', 93+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_CONSTRAINT(94) : wbs.sql(2910) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CONSTRAINT', 96+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_CONSTRAINT(97) : wbs.sql(2913) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   If Coalesce(h_task_type, 0) <> Coalesce(p_task_type, 0) Then
      If Coalesce(p_task_type, 0) = 1 Then
         h_task_type := PMO_CNST.SC_FIXED_UNITS;
      ElsIf Coalesce(p_task_type, 0) = 2 Then
         h_task_type := PMO_CNST.SC_FD_EFFORT_DRIVEN;
         If Coalesce(h_assign_count, 0) > 0 Then
            h_bitflag := 0;
            BEGIN
               SELECT COUNT('X') INTO h_bitflag FROM DUAL
               WHERE EXISTS (SELECT 'X' FROM TASK_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id AND TASK_ID = h_id AND PROJECT_ASSIGNMENT_ID IS NOT NuLL);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 118+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(119) : wbs.sql(2935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_bitflag, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_CONSTRAINT', 125+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_CONSTRAINT(126) : wbs.sql(2942) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_CHANGE_TYPE_PROJECT_AFF), 'NULL'));
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_CONSTRAINT', 128+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_CONSTRAINT(129) : wbs.sql(2945) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_CHANGE_TYPE_PROJECT_AFF, True);
            End If;
         End If;
      ElsIf Coalesce(p_task_type, 0) = 3 Then
         h_task_type := PMO_CNST.SC_FIXED_DURATION;
      ElsIf Coalesce(p_task_type, 0) = 4 Then
         h_task_type := PMO_CNST.SC_FW_EFFORT_DRIVEN;
      Else
         h_task_type := PMO_CNST.SC_FU_EFFORT_DRIVEN;
      End If;
   End If;
   
   --trace_printf("h_constraint_type: %d, h_constraint_dt: %s\nh_S: %s, h_F: %s, h_duration: %d\n",h_constraint_type,h_constraint_dt,h_S,h_F,h_duration);
   If (Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
             h_constraint_type, 0) = PMO_CNST.SC_ALAP) Then
      h_constraint_dt := NULL;
   ElsIf ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
                 h_constraint_type, 0) = PMO_CNST.SC_SNLT) OR (Coalesce(
                 h_constraint_type, 0) = PMO_CNST.SC_MSO)) Then
      i_SF := 1;
      If (h_constraint_dt IS NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_S, 1, 10)), PMO_ORASTD.TIME('08:00'))
            INTO h_constraint_dt
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 161+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(162) : wbs.sql(2978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT BIT_SCHED INTO h_bitID
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id AND DAY_YEAR = TO_DATE(SubStr(h_constraint_dt, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 176+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(177) : wbs.sql(2993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_constraint_dt, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(h_bitID)))
               INTO h_constraint_dt
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 192+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(193) : wbs.sql(3009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_constraint_dt, 1, 10)), PMO_ORASTD.TIME('08:00'))
               INTO h_constraint_dt
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 207+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(208) : wbs.sql(3024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (Coalesce(h_assign_count, 0) = 0) AND ((h_AS IS NULL)) AND (PMO_ORASTD.strncmp(h_planned_start
               , h_constraint_dt, 10) <> 0) Then
            If Coalesce(h_constraint_type, 0) <> PMO_CNST.SC_SNLT Then
               h_planned_start := h_constraint_dt;
               iSD := 1;
            ElsIf PMO_ORASTD.strncmp(h_planned_start, h_constraint_dt, 10) > 0 Then
               h_planned_start := h_constraint_dt;
               iSD := 1;
            End If;
         End If;
      End If;
   ElsIf ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_FNET) OR (Coalesce(
                 h_constraint_type, 0) = PMO_CNST.SC_FNLT) OR (Coalesce(
                 h_constraint_type, 0) = PMO_CNST.SC_MFO)) Then
      i_SF := 2;
      If (h_constraint_dt IS NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_F, 1, 10)), PMO_ORASTD.TIME('17:00'))
            INTO h_constraint_dt
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 239+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(240) : wbs.sql(3056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT BIT_SCHED INTO h_bitID
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id AND DAY_YEAR = TO_DATE(SubStr(h_constraint_dt, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 254+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(255) : wbs.sql(3071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_constraint_dt, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(h_bitID)))
               INTO h_constraint_dt
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 270+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(271) : wbs.sql(3087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_constraint_dt, 1, 10)), PMO_ORASTD.TIME('17:00'))
               INTO h_constraint_dt
               FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 285+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(286) : wbs.sql(3102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_planned_finish := h_F;
         h_day_min := 0;
         h_total := 0;
         
         --trace_printf("h_assign_count: %d, h_planned_finish: %s, h_constraint_dt: %s\n",h_assign_count,h_planned_finish, h_constraint_dt);
         If (Coalesce(h_assign_count, 0) = 0) AND ((h_AS IS NULL)) AND (PMO_ORASTD.strncmp(h_planned_finish
               , h_constraint_dt, 10) <> 0) AND ((Coalesce(
               h_constraint_type, 0) <> PMO_CNST.SC_FNLT) OR (PMO_ORASTD.strncmp(h_planned_finish
               , h_constraint_dt, 10) > 0)) Then
            OPEN GET_SD1;
            
            LOOP
               FETCH GET_SD1 INTO h_day_year, h_day_min, h_bitID;
               IF GET_SD1%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               --trace_printf("SC_STATE: %d, h_day_min: %d, h_total: %d, h_day_year: %s\n", SC_STATE,h_day_min,h_total,h_day_year);
               
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               If (Coalesce(h_total, 0) = 0) AND (PMO_ORASTD.strncmp(h_day_year, h_constraint_dt, 10) <> 0) Then
                  -- Non Working day
                  If Coalesce(h_min_per_day, 0) = 0 Then
                     BEGIN
                        SELECT MINUTE_PER_DAY INTO h_min_per_day
                        FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 327+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(328) : wbs.sql(3144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
                  
                  h_total := Coalesce(h_total, 0) + Coalesce(h_min_per_day, 0);
                  
                  If Coalesce(h_total, 0) >= Coalesce(h_duration, 0) Then
                     BEGIN
                        SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_constraint_dt, 1, 10)), PMO_ORASTD.TIME('08:00'))
                        INTO h_planned_start
                        FROM DUAL;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 346+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(347) : wbs.sql(3163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     EXIT;
                  End If;
               End If;
               
               h_total := Coalesce(h_total, 0) + Coalesce(h_day_min, 0);
               
               If Coalesce(h_total, 0) >= Coalesce(h_duration, 0) Then
                  BEGIN
                     SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_day_year, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(h_bitID)))
                     INTO h_planned_start
                     FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 368+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(369) : wbs.sql(3185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  EXIT;
               End If;
            END LOOP;
            
            BEGIN
               CLOSE GET_SD1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 385+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(386) : wbs.sql(3202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_planned_finish := h_constraint_dt;
            iSD := 1;
         End If;
      End If;
   End If;
   --trace_printf("iSD: %d, i_SF: %d, h_planned_start: %s, h_planned_finish: %s\n",iSD,i_SF,h_planned_start,h_planned_finish);
   --trace_printf("h_AS: %d:%s, h_constraint_type: %d, h_constraint_dt: %s\n", h_AS_Ind,h_AS,h_constraint_type,h_constraint_dt);
   
   If (isWBSTask(Coalesce(h_type_id, 0))) <> 0 AND (Coalesce(h_old_type_id, 0) = PMO_CNST.SC_FNET) 
         AND (Coalesce(h_constraint_type, 0) <> Coalesce(h_old_type_id, 0)) Then
      BEGIN
         UPDATE PROJECT_DETAILS SET CALCULATE_FLAG = 0 WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 412+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(413) : wbs.sql(3229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TASK_ASSIGNMENTS SET CONSIDER = 6
         WHERE PROJECT_ID = h_project_id AND TASK_ID = h_id
         AND CONSIDER = 7 AND TO_DATE(SubStr(SCHED_FINISH, 1, 10)) = TO_DATE(SubStr(h_FF, 1, 10));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 431+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(432) : wbs.sql(3248) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Execute Update Statement
   If iSD = 1 Then
      If i_SF = 1 Then
         If Coalesce(h_sd, 0) = PMO_CNST.SC_SS Then
            BEGIN
               UPDATE TMT_WBS SET
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT   = h_constraint_dt,
               SCHED_START     = h_planned_start,
               SCHED_FINISH    = NuLL,
               TASK_TYPE       = h_task_type,
               REC_DATETIME    = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 460+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(461) : wbs.sql(3277) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT   = h_constraint_dt,
               PLANNED_START   = h_planned_start,
               PLANNED_FINISH  = NuLL,
               TASK_TYPE       = h_task_type,
               REC_DATETIME    = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 484+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(485) : wbs.sql(3301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf i_SF = 2 Then
         If Coalesce(h_sd, 0) = PMO_CNST.SC_SS Then
            BEGIN
               UPDATE TMT_WBS SET
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT   = h_constraint_dt,
               SCHED_START     = h_planned_start,
               SCHED_FINISH    = h_planned_finish,
               TASK_TYPE       = h_task_type,
               REC_DATETIME    = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 510+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(511) : wbs.sql(3327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT   = h_constraint_dt,
               PLANNED_START   = h_planned_start,
               PLANNED_FINISH  = h_planned_finish,
               TASK_TYPE       = h_task_type,
               REC_DATETIME    = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 534+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(535) : wbs.sql(3351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   Else
      BEGIN
         UPDATE TMT_WBS SET
         CONSTRAINT_TYPE = h_constraint_type,
         CONSTRAINT_DT   = h_constraint_dt,
         TASK_TYPE       = h_task_type,
         REC_DATETIME    = SYSTIMESTAMP
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 560+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(561) : wbs.sql(3377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_CONSTRAINT', 567+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_CONSTRAINT(568) : wbs.sql(3384) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 574+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(575) : wbs.sql(3391) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_CONSTRAINT', 586+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_CONSTRAINT(587) : wbs.sql(3403) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_CONSTRAINT;
ALTER FUNCTION SP_U_CONSTRAINT COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_WBS_NAME_MSP ==
CREATE OR REPLACE FUNCTION SP_U_WBS_NAME_MSP
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
   , p_ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_name VARCHAR2(255);
   h_ieflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_NAME_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_NAME_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_NAME_MSP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(p_ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_NAME_MSP', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_NAME_MSP(26) : wbs.sql(3445) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_NAME_MSP', 33+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_NAME_MSP(34) : wbs.sql(3453) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_NAME_MSP', 36+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_NAME_MSP(37) : wbs.sql(3456) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   h_ieflag := p_ieflag;
   
   PMO_DB2M.SC_STATE := FC_U_WBS_NAME_MSP(h_id, h_name, h_rec_user, h_ieflag);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_NAME_MSP', 49+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_NAME_MSP(50) : wbs.sql(3469) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_NAME_MSP', 56+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_NAME_MSP(57) : wbs.sql(3476) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_NAME_MSP', 68+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_NAME_MSP(69) : wbs.sql(3488) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_NAME_MSP;
ALTER FUNCTION SP_U_WBS_NAME_MSP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_PORTF_NAME1 ==
CREATE OR REPLACE FUNCTION SP_U_PORTF_NAME1
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PORTF_NAME1') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PORTF_NAME1'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PORTF_NAME1(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PORTF_NAME1', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PORTF_NAME1(24) : wbs.sql(3528) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_name := p_name;
   h_rec_status := p_rec_user;
   
   h_temp_sc_state := FC_U_PORTF_NAME1(h_id, h_name, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PORTF_NAME1', 35+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PORTF_NAME1(36) : wbs.sql(3540) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(Coalesce(h_temp_sc_state, 0), h_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PORTF_NAME1', 43+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PORTF_NAME1(44) : wbs.sql(3548) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PORTF_NAME1', 55+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PORTF_NAME1(56) : wbs.sql(3560) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PORTF_NAME1;
ALTER FUNCTION SP_U_PORTF_NAME1 COMPILE DEBUG;

/********************************************/

Prompt == FUNCTION SP_U_WBS_NAME ==
CREATE OR REPLACE FUNCTION SP_U_WBS_NAME
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_name VARCHAR2(255);
   h_rec_user VARCHAR2(32);
   h_ieflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_NAME') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_NAME'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_NAME(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_NAME', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_NAME(23) : wbs.sql(3599) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_NAME', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_NAME(28) : wbs.sql(3604) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_NAME', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_NAME(31) : wbs.sql(3607) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_name := p_name;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT ELEMENT_ID INTO  h_id
      FROM TMT_PORTFOLIOS
      WHERE TYPE_ID = PMO_CNST.SC_FOLDER AND ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_NAME', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_NAME(50) : wbs.sql(3626) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      PMO_DB2M.SC_STATE := FC_U_PORTF_NAME1(h_id, h_name, h_rec_user);
   Else
      h_ieflag := 0;
      PMO_DB2M.SC_STATE := FC_U_WBS_NAME_MSP(h_id, h_name, h_rec_user, h_ieflag);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_NAME', 62+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_NAME(63) : wbs.sql(3639) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_NAME', 69+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_NAME(70) : wbs.sql(3646) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_NAME', 81+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_NAME(82) : wbs.sql(3658) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_NAME;
ALTER FUNCTION SP_U_WBS_NAME COMPILE DEBUG;

/*****************************************************/

-- archive or unarchive a proj and all his descendants

/*****************************************************/

Prompt == FUNCTION SP_U_WBS_STATUS ==
CREATE OR REPLACE FUNCTION SP_U_WBS_STATUS
(
     p_id VARCHAR2
   , p_rec_status VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_parent_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_ARCH IS
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_STATUS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_STATUS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_STATUS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_status || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_STATUS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_STATUS(30) : wbs.sql(3708) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_STATUS', 34+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_STATUS(35) : wbs.sql(3713) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_STATUS', 37+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_STATUS(38) : wbs.sql(3716) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   If (p_rec_status IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_STATUS', 44+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_STATUS(45) : wbs.sql(3723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_STATUS', 47+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_STATUS(48) : wbs.sql(3726) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   BEGIN
      SELECT RANK, PARENT_ID INTO h_rank, h_parent_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(63) : wbs.sql(3741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_STATUS', 69+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_STATUS(70) : wbs.sql(3748) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_STATUS', 72+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_STATUS(73) : wbs.sql(3751) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      BEGIN
         SELECT REC_STATUS INTO h_rec_status
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(89) : wbs.sql(3767) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_STATUS', 95+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_STATUS(96) : wbs.sql(3774) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.PARENT_IS_LOCKED), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_STATUS', 98+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_STATUS(99) : wbs.sql(3777) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.PARENT_IS_LOCKED, True);
      End If;
   End If;
   
   h_rec_status := p_rec_status;
   h_rec_user := p_rec_user;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      
      OPEN C_ARCH;
      
      FETCH C_ARCH INTO h_id;
      IF C_ARCH%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      WHILE (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) LOOP
         h_temp_sc_state := FC_ARCHIVE_WBS(h_id, h_rec_user);
         
         FETCH C_ARCH INTO h_id;
         IF C_ARCH%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      END LOOP;
      BEGIN
         CLOSE C_ARCH ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 149+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(150) : wbs.sql(3828) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS
         SET CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID = (
         SELECT PARENT_ID FROM TMT_WBS
         WHERE ELEMENT_ID = p_id)
         AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(172) : wbs.sql(3850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS
         SET REC_STATUS = p_rec_status,
         REC_USER = p_rec_user,
         REC_DATETIME = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 205+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(206) : wbs.sql(3884) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --      BEGIN_SQL
      --          SELECT RANK INTO HOST(h_rank) FROM TMT_PORTFOLIOS
      --          WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_wbs_status);
      --      END_SQL;
      
      --      if (SC_SUCCESS)
      --      {
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET REC_STATUS = p_rec_status
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 231+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(232) : wbs.sql(3910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET CHILD_COUNT = CHILD_COUNT + 1
         WHERE ELEMENT_ID IN (
         SELECT PARENT_ID
         FROM TMT_PORTFOLIOS
         WHERE ELEMENT_ID = p_id)
         AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 254+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(255) : wbs.sql(3933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --      }
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   If (h_parent_id IS NOT NULL) Then
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_CNST.SC_SET_ALL_BITS
         WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 279+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(280) : wbs.sql(3958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_Rollup(h_parent_id);
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_STATUS', 292+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_STATUS(293) : wbs.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 300+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(301) : wbs.sql(3979) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_STATUS', 312+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_STATUS(313) : wbs.sql(3991) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_STATUS;
ALTER FUNCTION SP_U_WBS_STATUS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_WBS_MSP ==
CREATE OR REPLACE FUNCTION SP_D_WBS_MSP
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_status_id VARCHAR2
   , p_rec_user VARCHAR2
   , p_ieflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_status_id VARCHAR2(1);
   h_ieflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_WBS_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_WBS_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_D_WBS_MSP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_status_id || ''''
          || ', ' || '''' || p_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(p_ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_WBS_MSP', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_WBS_MSP(29) : wbs.sql(4036) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_status_id := p_status_id;
   h_rec_user := p_rec_user;
   h_ieflag := p_ieflag;
   
   PMO_DB2M.SC_STATE := FC_D_WBS_MSP(h_id, h_parent_id, h_status_id, h_rec_user, h_ieflag);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_WBS_MSP', 42+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_WBS_MSP(43) : wbs.sql(4050) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_WBS_MSP', 49+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_WBS_MSP(50) : wbs.sql(4057) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_WBS_MSP', 61+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_WBS_MSP(62) : wbs.sql(4069) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_WBS_MSP;
ALTER FUNCTION SP_D_WBS_MSP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_PORTF ==
CREATE OR REPLACE FUNCTION SP_D_PORTF
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_status_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_status_id VARCHAR2(1);
   h_rec_user VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_PORTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_PORTF'), '-- ' || SYSTIMESTAMP, ':r := SP_D_PORTF(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_status_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_PORTF', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_PORTF(25) : wbs.sql(4110) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := p_id;
   h_parent_id := p_parent_id;
   h_status_id := p_status_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_D_PORTF(h_id, h_parent_id, h_status_id, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_PORTF', 38+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_PORTF(39) : wbs.sql(4124) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PORTF', 45+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PORTF(46) : wbs.sql(4131) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_PORTF', 57+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_PORTF(58) : wbs.sql(4143) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_PORTF;
ALTER FUNCTION SP_D_PORTF COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_D_WBS ==
CREATE OR REPLACE FUNCTION SP_D_WBS
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_status_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_status_id VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_temp_return PLS_INTEGER := 0;
   h_ieflag PLS_INTEGER;
-- Declare Cursors
      CURSOR C_PORT IS
         SELECT TYPE_ID
         FROM TMT_PORTFOLIOS
         WHERE ELEMENT_ID = p_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_D_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_D_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_D_WBS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_status_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_D_WBS', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_D_WBS(33) : wbs.sql(4192) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_parent_id := p_parent_id;
   h_status_id := p_status_id;
   h_rec_user := p_rec_user;
   
   h_temp_return := 0;
   
   If (p_parent_id IS NOT NULL) Then
      OPEN C_PORT;
      
      FETCH C_PORT INTO h_type_id;
      IF C_PORT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_FOLDER Then
            PMO_DB2M.SC_STATE := FC_D_PORTF(h_id, h_parent_id, h_status_id, h_rec_user);
            h_temp_return := 1;
         Else
            h_parent_id := NULL;
            NULL;
         End If;
      End If;
      BEGIN
         CLOSE C_PORT;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_WBS', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_WBS(70) : wbs.sql(4229) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_temp_return, 0) = 0 Then
      h_ieflag := 0;
      PMO_DB2M.SC_STATE := FC_D_WBS_MSP(h_id, h_parent_id, h_status_id, h_rec_user, h_ieflag);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_D_WBS', 81+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_D_WBS(82) : wbs.sql(4241) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_WBS', 88+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_WBS(89) : wbs.sql(4248) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_D_WBS', 100+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_D_WBS(101) : wbs.sql(4260) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_D_WBS;
ALTER FUNCTION SP_D_WBS COMPILE DEBUG;

/*##############################################################################*/

Prompt == FUNCTION SP_UN_WBS ==
CREATE OR REPLACE FUNCTION SP_UN_WBS
(
     p_id VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_current_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UN_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UN_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_UN_WBS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UN_WBS', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UN_WBS(24) : wbs.sql(4300) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   --InitializeHost(SC_PARAM(h_id), id, ind_un_wbs->id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_UN_WBS', 31+1) THEN 
      LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_UN_WBS(32) : wbs.sql(4308) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT RANK, REC_DATETIME INTO h_rank, h_current_date FROM TMT_WBS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(51) : wbs.sql(4327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Validate parent id
   --InitializeHost(SC_PARAM(h_parent_id), parent_id, ind_un_wbs->parent_id);
   h_parent_id := p_parent_id;
   If ((p_parent_id IS NULL)) Then
      -- Find Necessary Info
      BEGIN
         SELECT RANK, REC_DATETIME INTO h_rank, h_current_date FROM TMT_WBS
         WHERE ELEMENT_ID = p_id AND PARENT_ID IS Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(70) : wbs.sql(4346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      BEGIN
         UPDATE TMT_WBS SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID IS Null;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 88+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(89) : wbs.sql(4365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(64, 'SP_UN_WBS', 94+1) THEN 
         LFILE.FPUT('AllTrace', '  VALIDATE_EXISTENCE: SP_UN_WBS(95) : wbs.sql(4371) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      BEGIN 
         EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
            INTO h_rec_status 
            Using h_parent_id; 
      EXCEPTION 
         WHEN NO_DATA_FOUND THEN 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
      END;
      
      -- Find Necessary Info
      BEGIN
         SELECT RANK, REC_DATETIME INTO h_rank, h_current_date FROM TMT_WBS
         WHERE ELEMENT_ID = p_id AND PARENT_ID = p_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 115+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(116) : wbs.sql(4392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      BEGIN
         UPDATE TMT_WBS SET CHILD_COUNT = CHILD_COUNT + 1, DELETED_COUNT = DELETED_COUNT - 1
         WHERE ELEMENT_ID = p_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 134+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(135) : wbs.sql(4411) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   DECLARE 
   	nLen pls_integer :=0; 
   BEGIN 
   	If (h_rank IS NOT NULL) Then 
   		nLen := Coalesce(Length(h_rank), 0); 
   		If 0 <> 0 AND nLen <> 0 Then 
   		nLen := nLen - 1; 
   		End If; 
   	End If; 
   	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
   		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
   	End If; 
   END;
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS SET REC_USER = p_rec_user, REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
      WHERE REC_DATETIME = h_current_date AND REC_STATUS IN ('D', 'L') AND RANK LIKE h_rank || '%');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(168) : wbs.sql(4444) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS SET REC_USER = p_rec_user, REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
      WHERE REC_DATETIME = h_current_date AND REC_STATUS IN ('D', 'L') AND RANK LIKE h_rank || '%';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 185+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(186) : wbs.sql(4462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UN_WBS', 191+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UN_WBS(192) : wbs.sql(4468) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 198+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(199) : wbs.sql(4475) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UN_WBS', 210+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UN_WBS(211) : wbs.sql(4487) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UN_WBS;
ALTER FUNCTION SP_UN_WBS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_WBS_TYPE ==
CREATE OR REPLACE FUNCTION SP_U_WBS_TYPE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_current_id VARCHAR2(32);
   h_expense_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_asset_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_AS TIMESTAMP;
   h_current_date TIMESTAMP;
   h_bitflag PLS_INTEGER := 0;
   h_child_count PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_parent_type PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_pr_dur PLS_INTEGER := 0;
   h_transfer_flag VARCHAR2(1);
   h_req_transfer_flag VARCHAR2(1);
   h_change_cri_req_type PLS_INTEGER := 0;
   h_change_wbs_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_change_to_task PLS_INTEGER := 0;
   h_new_cri_type PLS_INTEGER := 0;
   h_old_cri_type PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_wbs_id VARCHAR2(32);
   h_a_cri_count PLS_INTEGER := 0;
   h_notification_type PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
   h_asset_name VARCHAR2(255);
   null_return LONG;
-- Declare Cursors
      CURSOR C_COST IS
         SELECT ELEMENT_ID FROM TMT_WBS WHERE ELEMENT_ID = h_id
         AND (ACTUAL_BUDGET > 0.00 OR R_CURRENT_BUDGET > 0.00 OR S_CURRENT_BUDGET > 0.00);

      CURSOR CAS2 IS
         SELECT PARTICIPANT FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID = p_id FOR UPDATE;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_TYPE'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_TYPE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 63+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_TYPE(64) : wbs.sql(4567) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_bitflag := p_bitflag;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   If ((p_id IS NULL)) OR ((p_bitflag IS NULL)) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TYPE', 74+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TYPE(75) : wbs.sql(4578) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 77+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(78) : wbs.sql(4581) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   --validation
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, PARENT_ID, RANK, CHILD_COUNT, ACTUAL_START,
      REC_STATUS, START_DT, FINISH_DT, DURATION, PROPOSED_EFFORT,
      TRANSFER_FLAG, A_CRI_COUNT, SYSTIMESTAMP,
      ASSET_ID, ASSET_NAME, ASSET_FLAG
      INTO h_project_id, h_type, h_parent_id, h_rank, h_child_count, h_AS,
      h_rec_status, h_S, h_F, h_duration, h_pr_dur,
      h_transfer_flag, h_a_cri_count, h_current_date,
      h_asset_id, h_asset_name, h_asset_flag
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 99+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(100) : wbs.sql(4603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TYPE', 106+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TYPE(107) : wbs.sql(4610) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 109+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(110) : wbs.sql(4613) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If isProjectType(Coalesce(h_bitflag, 0)) <> 0 Then
      PMO_DB2M.SC_STATE := FC_CHANGE_PROJ_TYPE(h_id, h_bitflag, h_type);
      -- Modify Workflows
      If PMO_DB2M.SC_STATE = 0 Then
         h_notification_type := PMO_CNST.SC_WBS_NOTIFICATION;
         PMO_DB2M.SC_STATE := FC_MODIFY_WKF_AFTER_CONV_TYPE(h_notification_type, h_id, h_type, h_bitflag);
      End If;
   ElsIf isWBSTransferedDeliv(Coalesce(h_bitflag, 0)) <> 0 Then
      -- Changing the following type to each other
      -- SC_WBS_CHANGE_REQUEST_TASK --> SC_WBS_CHANGE_REQUEST
      -- SC_WBS_RISK_TASK           --> SC_WBS_RISK
      -- SC_WBS_ISSUE_TASK          --> SC_WBS_ISSUE
      -- SC_WBS_REQUIREMENT_TASK    --> SC_WBS_REQUIREMENT
      h_change_cri_req_type := 1;
      h_change_wbs_type := 1;
      
      h_temp_var := 1;
      PMO_DB2M.SC_STATE := FC_CHANGE_CRI_TYPE(h_bitflag, h_id, h_rec_user, Coalesce(h_temp_var, 0));
      --      SC_STATE = FC_CH_OBJTASK_2_OBJ(SC_PARAM(h_bitflag), SC_PARAM(h_id), SC_PARAM(h_rec_user), SC_PARAM(h_change_cri_req_type), SC_PARAM(h_change_wbs_type));
   ElsIf isWBSTransferedTask(Coalesce(h_bitflag, 0)) <> 0 Then
      -- Changing the following type to each other
      --  SC_WBS_CHANGE_REQUEST  --> SC_WBS_CHANGE_REQUEST_TASK
      --  SC_WBS_RISK            --> SC_WBS_RISK_TASK
      --  SC_WBS_ISSUE           --> SC_WBS_ISSUE_TASK
      --  SC_WBS_REQUIREMENT     --> SC_WBS_REQUIREMENT_TASK
      
      h_change_cri_req_type := 1;
      h_change_wbs_type := 1;
      
      h_temp_var := 1;
      PMO_DB2M.SC_STATE := FC_CHANGE_CRI_TYPE(h_bitflag, h_id, h_rec_user, Coalesce(h_temp_var, 0));
      --      SC_STATE = FC_CH_OBJ_2_OBJTASK(SC_PARAM(h_bitflag), SC_PARAM(h_id), SC_PARAM(h_rec_user), SC_PARAM(h_change_cri_req_type), SC_PARAM(h_change_wbs_type));
   ElsIf isPureWBSTask(Coalesce(h_bitflag, 0)) <> 0 OR isPureWBSDeliv(Coalesce(h_bitflag, 0)) <> 0 Then
      If SubStr(h_rec_status, 1, 1) = 'L' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TYPE', 149+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TYPE(150) : wbs.sql(4653) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 152+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(153) : wbs.sql(4656) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, p_id, True);
      End If;
      
      If (isProjectType(Coalesce(h_type, 0))) <> 0 OR (Coalesce(h_type, 0) = Coalesce(h_bitflag, 0)) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TYPE', 159+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TYPE(160) : wbs.sql(4663) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_TYPE_CONVERSION), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 162+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(163) : wbs.sql(4666) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_TYPE_CONVERSION, True);
      End If;
      
      --      if (h_transfer_flag_Ind == 0  (h_transfer_flag[0] == 'C' || h_transfer_flag[0] == 'R'))
      If (h_transfer_flag IS NOT NULL) AND (SubStr(h_transfer_flag, 1, 1) = 'C' 
            OR SubStr(h_transfer_flag, 1, 1) = 'R') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TYPE', 171+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TYPE(172) : wbs.sql(4675) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_TYPE_CONVERSION), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 174+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(175) : wbs.sql(4678) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_TYPE_CONVERSION, True);
      End If;
      --parent_id must exists
      BEGIN
         SELECT TYPE_ID INTO h_parent_type
         FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 188+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(189) : wbs.sql(4692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TYPE', 195+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TYPE(196) : wbs.sql(4699) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 198+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(199) : wbs.sql(4702) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True);
      End If;
      
      If isPureWBSTask(Coalesce(h_type, 0)) <> 0 Then
         If isPureWBSDeliv(Coalesce(h_bitflag, 0)) <> 0 Then
            --if there are assignments than STOP
            If Coalesce(h_pr_dur, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TYPE', 208+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TYPE(209) : wbs.sql(4712) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS), 'NULL') || ' ID: ' || '''' || h_id || '''');
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 211+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(212) : wbs.sql(4715) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ASSIGNMENT_ALREADY_EXISTS, h_id, True);
            End If;
            
            --Check expenses
            
            OPEN C_COST;
            
            FETCH C_COST INTO h_expense_id;
            IF C_COST%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = 0 Then
               BEGIN
                  CLOSE C_COST ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 236+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(237) : wbs.sql(4740) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TYPE', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TYPE(243) : wbs.sql(4746) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_TYPE_CONVERSION), 'NULL') || ' ID: ' || '''' || h_id || '''');
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 245+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(246) : wbs.sql(4749) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_TYPE_CONVERSION, h_id, True);
            End If;
            
            BEGIN
               CLOSE C_COST ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 258+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(259) : wbs.sql(4762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE DEPENDENCIES
               SET DEP_TYPE = CASE WHEN DEP_TYPE > 1 THEN 0 ELSE DEP_TYPE END
               WHERE SUCC_PROJECT_ID = h_project_id
               AND SUCC_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 278+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(279) : wbs.sql(4782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS SET
               TYPE_ID = h_bitflag,
               BUDGET = 0,
               ACTUAL = 0,
               ETC = 0,
               PAID_TODATE = 0
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 302+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(303) : wbs.sql(4806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --BEGIN_SQL
            --    UPDATE  TMT_WBS_ATTRIBUTES
            --    SET TYPE_ID = SC_DELIVERABLE
            --    WHERE ELEMENT_ID = HOST(h_id)
            --        AND TYPE_ID = SC_TASK;
            --END_SQL;
            
            If (h_asset_id IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_ASSETS
                  SET REC_STATUS = 'D'
                  WHERE ELEMENT_ID = h_id
                  AND PARENT_ID = h_asset_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 330+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(331) : wbs.sql(4834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_asset_id := NULL;
               h_asset_name := NULL;
               h_asset_flag := PMO_CNST.SC_WITHOUT_ASSET;
            End If;
            
            --SC_STATE = FC_A_DEFAULT_ATTRIBUTE(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_bitflag), SC_PARAM(h_rec_user));
            null_return := FC_REASSIGN_ATTRIBUTE(h_project_id, h_id, h_type, h_bitflag, h_rec_user);
         Else
            BEGIN
               UPDATE BUDGETS
               SET TYPE_ID = h_bitflag
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 358+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(359) : wbs.sql(4862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If isPureWBSTask(Coalesce(h_bitflag, 0)) <> 0 Then
            If Coalesce(h_child_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TYPE', 367+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TYPE(368) : wbs.sql(4871) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_TYPE_CONVERSION), 'NULL'));
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 370+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(371) : wbs.sql(4874) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_TYPE_CONVERSION, True);
            End If;
            
            BEGIN
               UPDATE BUDGETS SET
               TYPE_ID = h_bitflag
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 390+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(391) : wbs.sql(4894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            null_return := FC_REASSIGN_ATTRIBUTE(h_project_id, h_id, h_type, h_bitflag, h_rec_user);
            
            --BEGIN_SQL
            --    UPDATE  TMT_WBS_ATTRIBUTES
            --    SET TYPE_ID = SC_TASK
            --    WHERE ELEMENT_ID = HOST(h_id)
            --        AND TYPE_ID = SC_DELIVERABLE ;
            --END_SQL;
            --
            --SC_STATE = FC_A_DEFAULT_ATTRIBUTE(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_bitflag), SC_PARAM(h_rec_user));
         Else
            BEGIN
               UPDATE BUDGETS
               SET TYPE_ID = h_bitflag
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 421+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(422) : wbs.sql(4925) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      --trace_printf("\n h_type:%d", h_type);
      --trace_printf("\n h_duration:%d", h_duration);
      --trace_printf("\n h_pr_dur:%d", h_pr_dur);
      
      If (Coalesce(h_type, 0) = PMO_CNST.SC_MILESTONE) AND (Coalesce(h_duration, 0) = 0) Then
         --trace_printf("\n (1) \n");
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED)) INTO h_F
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id AND DAY_YEAR = h_F;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 444+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(445) : wbs.sql(4948) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --Execute Update Statement
         BEGIN
            UPDATE TMT_WBS SET
            TYPE_ID = h_bitflag,
            LAST_WF_TYPE = Null,
            LAST_WF_BY = Null,
            LAST_WF_DT = Null,
            ASSET_ID = h_asset_id,
            ASSET_NAME = h_asset_name,
            ASSET_FLAG = h_asset_flag,
            FINISH_DT = h_F, DURATION = 480,
            PLANNED_FINISH = h_F, PLANNED_DURATION = 480,
            PROPOSED_FINISH = h_F, PROPOSED_DURATION = 480,
            REC_USER = p_rec_user
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 474+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(475) : wbs.sql(4978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_bitflag, 0) = PMO_CNST.SC_MILESTONE) AND (Coalesce(h_duration, 0) = 480) 
                AND (Coalesce(h_pr_dur, 0) = 0) Then
         --trace_printf("\n (2) \n");
         If (isPureWBSDeliv(Coalesce(h_type, 0))) <> 0 AND (PMO_ORASTD.strncmp(h_current_date, h_S
               , PMO_CNST.SC_H_DATE) > 0) Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_S)) INTO h_S FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 491+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(492) : wbs.sql(4995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_F := h_S;
         
         --Execute Update Statement
         BEGIN
            UPDATE TMT_WBS SET
            TYPE_ID = h_bitflag,
            LAST_WF_TYPE = Null,
            LAST_WF_BY = Null,
            LAST_WF_DT = Null,
            ASSET_ID = h_asset_id,
            ASSET_NAME = h_asset_name,
            ASSET_FLAG = h_asset_flag,
            FINISH_DT = h_F, DURATION = 0,
            PLANNED_FINISH = h_F, PLANNED_DURATION = 0,
            PROPOSED_FINISH = h_F, PROPOSED_DURATION = 0,
            REC_USER = p_rec_user
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 524+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(525) : wbs.sql(5028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --trace_printf("\n (3) \n");
         If (isPureWBSDeliv(Coalesce(h_type, 0))) <> 0 AND (isPureWBSTask(Coalesce(h_bitflag, 0))) <> 0 
               AND (PMO_ORASTD.strncmp(h_current_date, h_S, PMO_CNST.SC_H_DATE) > 0) Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_S)) INTO h_S FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 540+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(541) : wbs.sql(5044) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_F := NULL;
         End If;
         
         --Execute Update Statement
         BEGIN
            UPDATE TMT_WBS SET
            TYPE_ID = h_bitflag,
            LAST_WF_TYPE = Null,
            LAST_WF_BY = Null,
            LAST_WF_DT = Null,
            ASSET_ID = h_asset_id,
            ASSET_NAME = h_asset_name,
            ASSET_FLAG = h_asset_flag,
            START_DT = h_S,
            FINISH_DT = h_F,
            PLANNED_START = h_S,
            PLANNED_FINISH = h_F,
            REC_USER = p_rec_user
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 574+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(575) : wbs.sql(5078) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         --Update RESOURCE_ASSIGNMENTS
         
         OPEN CAS2;
         
         LOOP
            FETCH CAS2 INTO h_participant;
            IF CAS2%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE <> 0 Then
               EXIT;
            End If;
            
            If ((BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TASK_RESPONSIBLE)) > 0) OR ((BITAND(Coalesce(
                     h_participant, 0), PMO_CNST.SC_DLV_MANAGER)) > 0) Then
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET
                  ELEMENT_TYPE = h_bitflag,
                  PARTICIPANT =   CASE
                  WHEN (h_bitflag IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) AND (ELEMENT_TYPE NOT IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) THEN PMO_CNST.SC_TASK_RESPONSIBLE
                  WHEN (h_bitflag IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK)) AND (ELEMENT_TYPE NOT IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK)) THEN PMO_CNST.SC_DLV_MANAGER
                  ELSE PARTICIPANT END,
                  SECURITY_ID =   CASE
                  WHEN (h_bitflag IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) AND (ELEMENT_TYPE NOT IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) THEN 'SCTASKRESPONSIBLE'
                  WHEN (h_bitflag IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK)) AND (ELEMENT_TYPE NOT IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK)) THEN 'SCDELIVERABLEMANAGER'
                  ELSE SECURITY_ID END
                  WHERE CURRENT OF CAS2;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 621+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(622) : wbs.sql(5125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_PARTICIPANT)) > 0 Then
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET
                  ELEMENT_TYPE = h_bitflag,
                  SECURITY_ID = CASE
                  WHEN (h_bitflag IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) AND (ELEMENT_TYPE NOT IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) THEN 'SCTASKPARTICIPANT'
                  WHEN (h_bitflag IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK)) AND (ELEMENT_TYPE NOT IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK)) THEN 'SCDELIVERABLEPARTICIPANT'
                  ELSE SECURITY_ID END
                  WHERE CURRENT OF CAS2;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 644+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(645) : wbs.sql(5148) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_DLV_RESPONSIBLE)) > 0 Then
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET
                  ELEMENT_TYPE = h_bitflag,
                  PARTICIPANT = CASE WHEN (h_bitflag IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) THEN PMO_CNST.SC_PARTICIPANT
                  ELSE PARTICIPANT END,
                  SECURITY_ID = CASE WHEN (h_bitflag IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE)) THEN 'SCTASKPARTICIPANT'
                  ELSE SECURITY_ID END
                  WHERE CURRENT OF CAS2;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 667+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(668) : wbs.sql(5171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET
                  ELEMENT_TYPE = h_bitflag
                  WHERE CURRENT OF CAS2;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 686+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(687) : wbs.sql(5190) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE CAS2 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 701+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(702) : wbs.sql(5205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_sc_state := FC_AFTER_U_RES_ASSIGN_TYPE(h_id, h_type, h_bitflag);
         
         h_notification_type := PMO_CNST.SC_WBS_NOTIFICATION;
         PMO_DB2M.SC_STATE := FC_MODIFY_WKF_AFTER_CONV_TYPE(h_notification_type, h_id, h_type, h_bitflag);
         
         --update DEPENDENCIES
         BEGIN
            UPDATE DEPENDENCIES
            SET SUCC_OBJECT_TYPE = h_bitflag
            WHERE SUCC_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 726+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(727) : wbs.sql(5230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE DEPENDENCIES
            SET PRED_OBJECT_TYPE = h_bitflag
            WHERE PRED_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 745+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(746) : wbs.sql(5249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
      
      If (h_transfer_flag IS NOT NULL) OR Coalesce(h_a_cri_count, 0) > 0 Then
         h_new_cri_type := PMO_CNST.SC_CRI_TASK;
         If Coalesce(h_bitflag, 0) = PMO_CNST.SC_TASK Then
            h_new_cri_type := PMO_CNST.SC_CRI_TASK;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_SUMMARY_TASK Then
            h_new_cri_type := PMO_CNST.SC_CRI_SUMMARY_TASK;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_WORK_PRODUCT Then
            h_new_cri_type := PMO_CNST.SC_CRI_WORK_PRODUCT;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_DELIVERABLE Then
            h_new_cri_type := PMO_CNST.SC_CRI_DELIVERABLE;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_MILESTONE Then
            h_new_cri_type := PMO_CNST.SC_CRI_MILESTONE;
         Else
            h_new_cri_type := Coalesce(h_bitflag, 0);
         End If;
         
         h_old_cri_type := PMO_CNST.SC_CRI_TASK;
         If Coalesce(h_type, 0) = PMO_CNST.SC_TASK Then
            h_old_cri_type := PMO_CNST.SC_CRI_TASK;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_SUMMARY_TASK Then
            h_old_cri_type := PMO_CNST.SC_CRI_SUMMARY_TASK;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_WORK_PRODUCT Then
            h_old_cri_type := PMO_CNST.SC_CRI_WORK_PRODUCT;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_DELIVERABLE Then
            h_old_cri_type := PMO_CNST.SC_CRI_DELIVERABLE;
         ElsIf Coalesce(h_bitflag, 0) = PMO_CNST.SC_MILESTONE Then
            h_old_cri_type := PMO_CNST.SC_CRI_MILESTONE;
         Else
            h_old_cri_type := Coalesce(h_type, 0);
         End If;
         
         h_change_to_task := 0;
         h_wbs_id := '';
         
         If Coalesce(h_a_cri_count, 0) > 0 Then
            h_wbs_id := '1';
         End If;
         
         PMO_DB2M.SC_STATE := FC_UPDATE_CRI_TYPE(h_project_id, h_id, h_new_cri_type, h_old_cri_type
                                        , h_bitflag, h_type, h_change_to_task, h_wbs_id, h_rec_user);
         
         --SC_STATE = FC_UPDATE_CRI_TYPE(SC_PARAM(h_project_id), SC_PARAM(h_id), SC_PARAM(h_new_cri_type),SC_PARAM(h_bitflag),SC_PARAM(h_type), SC_PARAM(h_change_to_task), SC_PARAM(h_wbs_id), SC_PARAM(h_rec_user));
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TYPE', 800+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TYPE(801) : wbs.sql(5304) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TYPE', 803+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TYPE(804) : wbs.sql(5307) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   End If;
   
   If (isWBSTask(Coalesce(h_type, 0))) <> 0 AND (isWBSDeliv(Coalesce(h_bitflag, 0))) <> 0 Then
      h_stage_id := 5470;
   ElsIf (isWBSTask(Coalesce(h_bitflag, 0))) <> 0 AND (isWBSDeliv(Coalesce(h_type, 0))) <> 0 Then
      h_stage_id := 5500;
      
      BEGIN
         UPDATE TMT_WBS
         SET STAGE_ID = h_stage_id,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 828+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(829) : wbs.sql(5332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --type TASK IS CHANGED TO type DELIVERABLE.(h_type is current type - bitflag is the new type)
   If ((isWBSTask(Coalesce(h_type, 0))) <> 0 AND (isWBSDeliv(Coalesce(h_bitflag, 0))) <> 0) 
         OR ((isWBSTask(Coalesce(h_bitflag, 0))) <> 0 AND (isWBSDeliv(Coalesce(
         h_type, 0))) <> 0) Then
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT),
         STAGE_ID    = h_stage_id,
         REC_USER = p_rec_user
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 854+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(855) : wbs.sql(5358) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_TYPE', 863+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_TYPE(864) : wbs.sql(5367) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 870+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(871) : wbs.sql(5374) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TYPE', 882+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TYPE(883) : wbs.sql(5386) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_TYPE;
ALTER FUNCTION SP_U_WBS_TYPE COMPILE DEBUG;

/************************************************************************************************************************************************
* flag = '0' - None
*           '1' - Published to WBS
*           '2' - Published to Template
*           '3' - Partial Published to Template
*************************************************************************************************************************************************/

Prompt == FUNCTION SP_U_PUBLISHED ==
CREATE OR REPLACE FUNCTION SP_U_PUBLISHED
(
     p_id VARCHAR2
   , p_flag VARCHAR2
   , p_parent_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_pub_by VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_stop_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_level_id2 PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_flag VARCHAR2(1);
-- Declare Cursors
      CURSOR CSP IS
         SELECT LEVEL_ID 
         FROM TMT_WBS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND LEVEL_ID > h_level_id
         AND RANK LIKE h_rank || '%'
         AND RANK <> h_rank;

      CURSOR C_TEMP IS
         SELECT T_PARENT_ID, COUNT(*)
         FROM TMT_WBS
         WHERE PUBLISHED='2' 
         AND RANK LIKE h_rank || '%'
         GROUP BY T_PARENT_ID;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PUBLISHED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PUBLISHED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PUBLISHED(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_flag || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 51+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PUBLISHED(52) : wbs.sql(5459) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) OR (p_flag IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PUBLISHED', 56+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PUBLISHED(57) : wbs.sql(5464) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PUBLISHED(60) : wbs.sql(5467) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   Else
      h_rec_status := p_flag;
      If (p_parent_id IS NULL) AND (SubStr(h_rec_status, 1, 1) = '2') Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PUBLISHED', 66+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PUBLISHED(67) : wbs.sql(5474) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 69+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_PUBLISHED(70) : wbs.sql(5477) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      
      --See if published by is null
      BEGIN
         SELECT PUBLISHED_BY, PROJECT_ID 
         INTO h_pub_by, h_project_id
         FROM TMT_WBS 
         WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 86+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(87) : wbs.sql(5494) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PUBLISHED', 93+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PUBLISHED(94) : wbs.sql(5501) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_DELETED), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 96+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_PUBLISHED(97) : wbs.sql(5504) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_DELETED, p_id, True);
      End If;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         h_pub_by := NULL;
      End If;
      If (p_parent_id IS NULL) Then
         BEGIN
            SELECT T_PARENT_ID, LENGTH(RANK),RANK, TYPE_ID, LEVEL_ID,
            CASE WHEN PUBLISHED_BY = p_rec_user THEN 1 ELSE 0 END,
            PUBLISHED, 1
            INTO
            h_id, h_duration, h_rank, h_type, h_level_id,
            h_count,
            h_flag, h_bitflag
            FROM TMT_WBS 
            WHERE ELEMENT_ID = p_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(122) : wbs.sql(5529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            SELECT T_PARENT_ID, LENGTH(RANK), RANK, TYPE_ID, LEVEL_ID,
            CASE WHEN PUBLISHED_BY = p_rec_user THEN 1 ELSE 0 END,
            PUBLISHED,
            CASE WHEN PUBLISHED = p_flag AND PUBLISHED = '2' AND T_PARENT_ID <> p_parent_id THEN 1 ELSE 0 END
            INTO h_id, h_duration, h_rank, h_type, h_level_id,
            h_count,
            h_flag, h_bitflag
            FROM TMT_WBS 
            WHERE ELEMENT_ID = p_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(143) : wbs.sql(5550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (isProjectType(Coalesce(h_type, 0))) <> 0 AND (SubStr(h_rec_status, 1, 1) = '2') Then
         OPEN CSP;
         
         FETCH CSP INTO h_level_id2;
         IF CSP%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               CLOSE CSP ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 167+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(168) : wbs.sql(5575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_PUBLISHED', 173+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_PUBLISHED(174) : wbs.sql(5581) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_TEMPLATE_SUBPROJECTS), 'NULL'));
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 176+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_PUBLISHED(177) : wbs.sql(5584) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.CANNOT_TEMPLATE_SUBPROJECTS, True);
         Else
            BEGIN
               CLOSE CSP ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 188+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(189) : wbs.sql(5596) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (p_parent_id IS NOT NULL) AND (SubStr(h_rec_status, 1, 1) = '2') Then
         BEGIN
            SELECT RANK 
            INTO h_stop_rank 
            FROM TMT_WBS 
            WHERE ELEMENT_ID = p_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 207+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(208) : wbs.sql(5615) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PUBLISHED', 214+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PUBLISHED(215) : wbs.sql(5622) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_DELETED), 'NULL') || ' ID: ' || '''' || p_parent_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 217+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_PUBLISHED(218) : wbs.sql(5625) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_DELETED, p_parent_id
                  , True);
         End If;
         
         h_parent_id := p_parent_id;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS', h_parent_id, h_max_rank);
         
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         If Coalesce(h_bitflag, 0) = 1 Then
            BEGIN
               UPDATE TMT_WBS 
               SET T_PARENT_ID = p_parent_id,
               T_RANK = RTRIM(h_stop_rank) || h_rankBase64
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 244+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(245) : wbs.sql(5652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS 
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 263+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(264) : wbs.sql(5671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PUBLISHED', 269+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PUBLISHED(270) : wbs.sql(5677) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PUBLISHED', 272+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_U_PUBLISHED(273) : wbs.sql(5680) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_DB2M.SC_STATE, p_id, True);
         Else
            BEGIN
               UPDATE TMT_WBS 
               SET PUBLISHED = p_flag,
               PUBLISHED_BY = p_rec_user,
               T_PARENT_ID = p_parent_id,
               T_RANK = RTRIM(h_stop_rank) || h_rankBase64
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 293+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(294) : wbs.sql(5701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         -- if the current WBS element is a PROJECT and the new flag is NONE (0),
         -- then flag all his children to NONE if the old flag is Template (2)
         -- keep all children's flag if the old flag is To Team (1)
         
         If SubStr(h_rec_status, 1, 1) = '0' Then
            If isProjectType(Coalesce(h_type, 0)) <> 0 Then
               If SubStr(h_flag, 1, 1) = '2' Then
                  OPEN C_TEMP;
                  
                  LOOP
                     FETCH C_TEMP INTO h_id, h_count;
                     IF C_TEMP%FOUND THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                     
                     If PMO_DB2M.SC_STATE <> 0 Then
                        EXIT;
                     Else
                        BEGIN
                           UPDATE TMT_WBS 
                           SET CHILD_COUNT = CHILD_COUNT - h_count
                           WHERE ELEMENT_ID = h_id;
                           IF SQL%FOUND = TRUE THEN
                              PMO_DB2M.SC_STATE := 0;
                           ELSE
                              PMO_DB2M.SC_STATE := 100;
                           END IF;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 333+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(334) : wbs.sql(5741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                     End If;
                  END LOOP;
                  
                  BEGIN
                     CLOSE C_TEMP ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 348+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(349) : wbs.sql(5756) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  DECLARE 
                  	nLen pls_integer :=0; 
                  BEGIN 
                  	If (h_rank IS NOT NULL) Then 
                  		nLen := Coalesce(Length(h_rank), 0); 
                  		If 0 <> 0 AND nLen <> 0 Then 
                  		nLen := nLen - 1; 
                  		End If; 
                  	End If; 
                  	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
                  		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
                  	End If; 
                  END;
                  BEGIN
                     UPDATE TMT_WBS 
                     SET PUBLISHED = '0',
                     PUBLISHED_BY = p_rec_user,
                     T_PARENT_ID = Null,
                     T_RANK = Null
                     WHERE PUBLISHED = '2'
                     AND RANK LIKE h_rank || '%';
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 384+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(385) : wbs.sql(5792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               BEGIN
                  UPDATE TMT_WBS 
                  SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 404+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(405) : wbs.sql(5812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            BEGIN
               UPDATE TMT_WBS 
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 424+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(425) : wbs.sql(5832) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --Execute UPDATE current row and all subprojects
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_WBS 
            SET PUBLISHED = p_flag,
            PUBLISHED_BY = p_rec_user,
            T_PARENT_ID = p_parent_id
            WHERE ELEMENT_ID = p_id OR (TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND RANK LIKE h_rank || '%');
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 460+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(461) : wbs.sql(5868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         If SubStr(h_rec_status, 1, 1) = '0' AND ((h_id IS NOT NULL)) Then
            BEGIN
               UPDATE TMT_WBS 
               SET T_PARENT_ID = Null,
               T_RANK = Null
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 483+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(484) : wbs.sql(5891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         -- if the current WBS element is a PROJECT and the new flag is NONE, then flag all his children to NONE
         If (Coalesce(h_type, 0) <> PMO_CNST.SC_NONE) AND (isNotProjectType(Coalesce(h_type, 0))) <> 0 Then
            If SubStr(h_rec_status, 1, 1) = '2' Then
               -- if the current WBS element is not a PROJECT and the new flag is PUBLISH to TEMPLETE, then flag his parent PROJECT to Partialy Templeted
               BEGIN
                  UPDATE TMT_WBS 
                  SET PUBLISHED = '3',
                  PUBLISHED_BY = p_rec_user
                  WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
                  AND PUBLISHED = '0'
                  AND (SUBSTR(h_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
                  AND (RANK LIKE SUBSTR(h_rank, 1, 8) || '%'));
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 511+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(512) : wbs.sql(5919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf SubStr(h_rec_status, 1, 1) = '0' Then
               -- if the current WBS element is not a PROJECT and the new flag is NONE, then look to the parent PROJECT flag
               BEGIN
                  SELECT ELEMENT_ID, PUBLISHED, CASE WHEN EXISTS(SELECT * FROM TMT_WBS WHERE PUBLISHED='2' AND RANK LIKE h_rank || '%') THEN 1 ELSE 0 END
                  INTO h_id, h_rec_status, h_count
                  FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 527+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(528) : wbs.sql(5935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- if the PROJECT is Partialy Templeted and does not exists any children templeted, then flag it to NONE
               If SubStr(h_rec_status, 1, 1) = '3' AND (Coalesce(h_count, 0) = 0) Then
                  BEGIN
                     UPDATE TMT_WBS 
                     SET PUBLISHED = '0'
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 548+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(549) : wbs.sql(5956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PUBLISHED', 563+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PUBLISHED(564) : wbs.sql(5971) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 570+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(571) : wbs.sql(5978) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PUBLISHED', 582+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PUBLISHED(583) : wbs.sql(5990) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PUBLISHED;
ALTER FUNCTION SP_U_PUBLISHED COMPILE DEBUG;

Prompt == FUNCTION SP_U_PLANNED ==
CREATE OR REPLACE FUNCTION SP_U_PLANNED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_planned_effort PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assign_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_constraint_dt TIMESTAMP;
   h_duration PLS_INTEGER := 0;
   h_constraint_type PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PLANNED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PLANNED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PLANNED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_planned_effort), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PLANNED', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PLANNED(40) : wbs.sql(6044) : ' || SYSTIMESTAMP);
   END IF; 

   h_constraint_type := 0;
   BEGIN
      SELECT PROJECT_ID, PLANNED_START, PLANNED_FINISH, PLANNED_DURATION, PLANNED_EFFORT,
      ASSIGN_COUNT, CONSTRAINT_TYPE, CONSTRAINT_DT, TYPE_ID, MINUTE_PER_DAY
      INTO h_project_id, h_start_date, h_finish_date, h_duration, h_effort,
      h_assign_count, h_constraint_type, h_constraint_dt, h_type, h_min_per_day
      FROM TMT_WBS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(56) : wbs.sql(6060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_assign_count: %d, h_project_id: %s", SC_STATE,h_assign_count,h_project_id);
   
   If Coalesce(h_assign_count, 0) = 0 Then
      If (p_start_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 74+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(75) : wbs.sql(6079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            --Should be replace with c function
            BEGIN
               SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME('08:00')))  INTO  h_S FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 89+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(90) : wbs.sql(6094) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --          if ( strncmp(h_S, h_start_date, 10) != 0 )
         If ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_FNET)) AND (PMO_ORASTD.strncmp(h_S, h_start_date
               , 10) <> 0) Then
            h_constraint_type := PMO_CNST.SC_SNET;
            h_constraint_dt := h_S;
         End If;
      Else
         h_S := NULL;
         NULL;
      End If;
      
      If (p_end_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_F
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(121) : wbs.sql(6125) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, h_F: %d %s\n", SC_STATE,h_F_Ind,h_F);
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            --Should be replace with c function
            BEGIN
               SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME('17:00')))  INTO  h_F FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 136+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(137) : wbs.sql(6141) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --          if ( (h_constraint_type == 0)  (strncmp(h_F, h_finish_date, 10) != 0) )
         If ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_FNET)) AND (PMO_ORASTD.strncmp(h_F, h_finish_date
               , 10) <> 0) Then
            h_constraint_type := PMO_CNST.SC_FNET;
            h_constraint_dt := h_F;
         End If;
      Else
         h_F := NULL;
      End If;
      --trace_printf("h_S: %d %s, h_F: %d %s, p_planned_effort: %d, h_effort: %d\n", h_S_Ind,h_S,h_F_Ind,h_F,*p_planned_effort,h_effort);
      
      If Coalesce(p_planned_effort, 0) = Coalesce(h_effort, 0) Then
         If Coalesce(h_constraint_type, 0) = 0 Then
            BEGIN
               UPDATE TMT_WBS SET
               PLANNED_START = h_S,
               PLANNED_FINISH = h_F,
               PLANNED_DURATION = p_bitflag
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 173+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(174) : wbs.sql(6178) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET
               PLANNED_START = h_S,
               PLANNED_FINISH = h_F,
               PLANNED_DURATION = p_bitflag,
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT = h_constraint_dt
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 196+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(197) : wbs.sql(6201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --trace_printf("SC_STATE: %d, h_S: %d %s, h_F: %d %s\n", SC_STATE,h_S_Ind,h_S,h_F_Ind,h_F);
      Else
         If (p_end_date IS NULL) Then
            h_duration := p_bitflag;
            h_id := p_id;
            h_rec_user := p_rec_user;
            --trace_printf("+++ h_duration: %d\n", h_duration);
            
            -- Load Calendar
            -- Temporary Table Declaration has been changed to Truncate
            EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_MIN_MAX';
            PMO_DB2M.SC_STATE := 0;
            
            -- Temporary Table Declaration has been changed to Truncate
            EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CDY';
            PMO_DB2M.SC_STATE := 0;
            
            h_temp_var := 2 * Trunc((Trunc(Coalesce(h_duration, 0) / Coalesce(h_min_per_day, 0))) + 0.5);
            BEGIN
               SELECT TO_DATE(SubStr(h_S, 1, 10)) + h_temp_var      INTO h_F FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 227+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(228) : wbs.sql(6232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("h_duration: %d, h_S: %d %s, h_F: %d %s\n", h_duration,h_S_Ind,h_S,h_F_Ind,h_F);
            
            BEGIN
               INSERT INTO PMO_TMP_CDY
               SELECT ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF
               FROM CALENDAR_DAY_OF_YEAR
               WHERE ELEMENT_ID = h_project_id AND DAY_YEAR BETWEEN TO_DATE(SubStr(h_S, 1, 10)) AND TO_DATE(SubStr(h_F, 1, 10));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 248+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(249) : wbs.sql(6253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_TMP_MIN_MAX
               SELECT MIN(DAY_YEAR), MAX(DAY_YEAR), h_min_per_day, TO_TIMESTAMP('1899-12-30 8:00:00'),TO_TIMESTAMP('1899-12-30 8:00:00'), 0
               FROM PMO_TMP_CDY;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 267+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(268) : wbs.sql(6272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_F := '';
            h_duration := GET_FD_DURATION(h_project_id, h_S, h_F, h_duration);
            --trace_printf("h_duration: %d, h_S: %d %s, h_F: %d %s\n", h_duration,h_S_Ind,h_S,h_F_Ind,h_F);
         End If;
         
         h_effort := p_planned_effort;
         PMO_DB2M.SC_STATE := FC_ASSN_PROFILE(h_project_id, h_id, h_S, h_F, h_duration, h_type, h_min_per_day
                                     , h_effort, h_rec_user);
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PLANNED', 284+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PLANNED(285) : wbs.sql(6289) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 292+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(293) : wbs.sql(6297) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PLANNED', 304+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PLANNED(305) : wbs.sql(6309) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PLANNED;
ALTER FUNCTION SP_U_PLANNED COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_PROPOSED ==
CREATE OR REPLACE FUNCTION SP_U_PROPOSED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assign_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROPOSED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROPOSED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROPOSED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROPOSED', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROPOSED(29) : wbs.sql(6354) : ' || SYSTIMESTAMP);
   END IF; 

   /*  SC_LONG(type);
   
       type = SC_PROPOSED;
   
       return SP_U_TSKDATES(p_id,  type, p_start_date, p_end_date, p_bitflag,  p_rec_user, nullIndicator);*/
   
   BEGIN
      SELECT PROJECT_ID, START_DT, FINISH_DT, ASSIGN_COUNT
      INTO h_project_id, h_start_date, h_finish_date, h_assign_count
      FROM TMT_WBS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(48) : wbs.sql(6373) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_assign_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PROPOSED', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PROPOSED(55) : wbs.sql(6380) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_ALREADY_ASSIGNED), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROPOSED', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROPOSED(58) : wbs.sql(6383) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_ALREADY_ASSIGNED, p_id, True);
   End If;
   
   If (p_start_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(75) : wbs.sql(6400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         --Should be replace with c function
         BEGIN
            SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date)))  INTO  h_S FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 89+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(90) : wbs.sql(6415) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_S := NULL;
      NULL;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_F
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(112) : wbs.sql(6437) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         --Should be replace with c function
         BEGIN
            SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date)))  INTO  h_F FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 126+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(127) : wbs.sql(6452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      h_F := NULL;
      NULL;
   End If;
   
   BEGIN
      UPDATE TMT_WBS SET
      PROPOSED_START = h_S,
      PROPOSED_FINISH = h_F,
      PROPOSED_DURATION = p_bitflag
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 152+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(153) : wbs.sql(6478) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Rollup Moved to Check In
   --if( SC_SUCCESS )
   --{
   --  SC_STATE = FC_Rollup( h_project_id );
   --}
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROPOSED', 164+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROPOSED(165) : wbs.sql(6490) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 172+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(173) : wbs.sql(6498) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROPOSED', 184+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROPOSED(185) : wbs.sql(6510) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROPOSED;
ALTER FUNCTION SP_U_PROPOSED COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_SCHED ==
CREATE OR REPLACE FUNCTION SP_U_SCHED
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assign_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_SF TIMESTAMP;
   h_sd PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_mlst_percent PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_constraint_type PLS_INTEGER := 0;
   h_constraint_dt TIMESTAMP;
   h_mp_status_DT TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_SCHED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_SCHED'), '-- ' || SYSTIMESTAMP, ':r := SP_U_SCHED(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_SCHED', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_SCHED(38) : wbs.sql(6564) : ' || SYSTIMESTAMP);
   END IF; 

   /*  SC_LONG(type);
   
       BEGIN_SQL
           UPDATE TMT_WBS SET
               PLANNED_START = Null,
               PLANNED_FINISH = Null,
               PLANNED_DURATION = 0,
               FORECAST_START = Null,
               FORECAST_FINISH = Null,
               FORECAST_DURATION = 0
           WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_sched);
       END_SQL;
   
       if( !SC_SUCCESS){ return SC_STATE; }
   
       type = SC_SCHEDULE;
   
       return SP_U_TSKDATES(p_id,  type, p_start_date, p_end_date, p_bitflag,  p_rec_user, nullIndicator);*/
   
   BEGIN
      SELECT PROJECT_ID, START_DT, FINISH_DT, ASSIGN_COUNT, ACTUAL_DURATION, MILESTONE_PERCENT,
      SCHED_FINISH, SCHED_DURATION, MINUTE_PER_DAY, CONSTRAINT_TYPE, CONSTRAINT_DT, MP_STATUS_DT
      INTO h_project_id, h_start_date, h_finish_date, h_assign_count, h_duration, h_mlst_percent,
      h_SF, h_sd, h_min_per_day, h_constraint_type, h_constraint_dt, h_mp_status_DT
      FROM TMT_WBS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(72) : wbs.sql(6598) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_assign_count %d, h_project_id: %s, h_SF: %s, h_sd: %d\n",h_assign_count,h_project_id,h_SF,h_sd);//trace_flush();
   If Coalesce(h_assign_count, 0) = 0 Then
      If (p_start_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 90+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(91) : wbs.sql(6617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            --Should be replace with c function
            BEGIN
               SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date)))  INTO  h_S FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 105+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(106) : wbs.sql(6632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --          if ( strncmp(h_S, h_start_date, 10) != 0 )
         If ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_FNET)) AND (PMO_ORASTD.strncmp(h_S, h_start_date
               , 10) <> 0) Then
            h_constraint_type := PMO_CNST.SC_SNET;
            h_constraint_dt := h_S;
         End If;
      Else
         h_S := NULL;
         h_sd := p_bitflag;
      End If;
      
      If (p_end_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_F
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 136+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(137) : wbs.sql(6663) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            --Should be replace with c function
            BEGIN
               SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date)))  INTO  h_F FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 151+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(152) : wbs.sql(6678) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --          if ( (h_constraint_type == 0)  (strncmp(h_F, h_finish_date, 10) != 0) )
         If ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
               h_constraint_type, 0) = PMO_CNST.SC_FNET)) AND (PMO_ORASTD.strncmp(h_F, h_finish_date
               , 10) <> 0) Then
            h_constraint_type := PMO_CNST.SC_FNET;
            h_constraint_dt := h_F;
         End If;
         
         If Coalesce(h_sd, 0) > 0 Then
            h_total := 0;
            If PMO_ORASTD.strcmp(h_F, h_SF) > 0 Then
               BEGIN
                  SELECT COUNT(*) INTO h_total
                  FROM CALENDAR_DAY_OF_YEAR
                  WHERE ELEMENT_ID = h_project_id
                  AND DAY_YEAR BETWEEN TO_DATE(SubStr(h_SF, 1, 10)) AND TO_DATE(SubStr(h_F, 1, 10));
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 180+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(181) : wbs.sql(6707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("h_F > h_SF_* SC_STATE %d, h_F: %s, h_SF: %s, h_total: %d\n",SC_STATE,h_F,h_SF,h_total);//trace_flush();
               
               h_total := (Coalesce(h_total, 0) - 1) * Coalesce(h_min_per_day, 0);
               h_sd := Coalesce(h_sd, 0) + Coalesce(h_total, 0);
            ElsIf PMO_ORASTD.strcmp(h_F, h_SF) < 0 Then
               BEGIN
                  SELECT COUNT(*) INTO h_total
                  FROM CALENDAR_DAY_OF_YEAR
                  WHERE ELEMENT_ID = h_project_id
                  AND DAY_YEAR BETWEEN TO_DATE(SubStr(h_F, 1, 10)) AND TO_DATE(SubStr(h_SF, 1, 10));
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 200+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(201) : wbs.sql(6727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --trace_printf("h_F < h_SF* SC_STATE %d, h_F: %s, h_SF: %s, h_total: %d\n",SC_STATE,h_F,h_SF,h_total);//trace_flush();
               
               h_total := (Coalesce(h_total, 0) - 1) * Coalesce(h_min_per_day, 0);
               If Coalesce(h_total, 0) < Coalesce(h_sd, 0) Then
                  h_sd := Coalesce(h_sd, 0) - Coalesce(h_total, 0);
               Else
                  h_sd := Coalesce(h_duration, 0);
               End If;
            Else
               h_sd := p_bitflag;
            End If;
         Else
            h_sd := p_bitflag;
         End If;
         
         If Coalesce(h_sd, 0) > 0 Then
            If Coalesce(h_sd, 0) > Coalesce(h_duration, 0) Then
               h_mlst_percent := Trunc(Coalesce(h_duration, 0) * 10000 / Coalesce(h_sd, 0));
            Else
               h_mlst_percent := 10000;
            End If;
            
            BEGIN
               SELECT SYSTIMESTAMP INTO h_mp_status_DT FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 234+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(235) : wbs.sql(6761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         h_F := NULL;
         h_sd := p_bitflag;
      End If;
      
      If Coalesce(h_sd, 0) < Coalesce(h_duration, 0) Then
         If Coalesce(h_constraint_type, 0) = 0 Then
            BEGIN
               UPDATE TMT_WBS SET
               SCHED_START         = h_S,
               SCHED_FINISH        = h_F,
               SCHED_DURATION      = h_sd,
               ACTUAL_DURATION     = h_sd,
               MILESTONE_PERCENT   = h_mlst_percent
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 264+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(265) : wbs.sql(6791) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET
               SCHED_START         = h_S,
               SCHED_FINISH        = h_F,
               SCHED_DURATION      = h_sd,
               ACTUAL_DURATION     = h_sd,
               MILESTONE_PERCENT   = h_mlst_percent,
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT = h_constraint_dt
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 289+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(290) : wbs.sql(6816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If Coalesce(h_constraint_type, 0) = 0 Then
            BEGIN
               UPDATE TMT_WBS SET
               SCHED_START         = h_S,
               SCHED_FINISH        = h_F,
               SCHED_DURATION      = h_sd,
               MILESTONE_PERCENT   = h_mlst_percent
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 313+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(314) : wbs.sql(6840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS SET
               SCHED_START         = h_S,
               SCHED_FINISH        = h_F,
               SCHED_DURATION      = h_sd,
               MILESTONE_PERCENT   = h_mlst_percent,
               CONSTRAINT_TYPE = h_constraint_type,
               CONSTRAINT_DT = h_constraint_dt
               WHERE ELEMENT_ID = p_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 337+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(338) : wbs.sql(6864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      --trace_printf("SC_STATE %d, h_S: %s, h_F: %s, h_sd: %d, h_total: %d\n",SC_STATE,h_S,h_F,h_sd,h_total);//trace_flush();
   End If;
   
   --  if( (SC_SUCCESS)  (IsNullSpParam(ind_u_sched, p_end_date))  (h_constraint_type == 0) )
   /*  if( (SC_SUCCESS)  (IsNullSpParam(ind_u_sched, p_end_date))
            ((h_constraint_type == SC_ASAP) || (h_constraint_type == SC_SNET)
               || (h_constraint_type == SC_FNET)) )
       {
           SC_STATE = FC_Rollup( h_project_id );
   
           BEGIN_SQL
               SELECT SCHED_FINISH INTO HOST(h_constraint_dt)
               FROM TMT_WBS WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_sched);
           END_SQL;
   
           if ( strncmp(h_constraint_dt, h_finish_date, 10) != 0 )
           {
               BEGIN_SQL
                   UPDATE TMT_WBS SET
                       CONSTRAINT_TYPE = SC_FNET,
                       CONSTRAINT_DT = HOST(h_constraint_dt)
                   WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_sched);
               END_SQL;
           }
       }
   */
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_SCHED', 370+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_SCHED(371) : wbs.sql(6897) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 377+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(378) : wbs.sql(6904) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_SCHED', 389+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_SCHED(390) : wbs.sql(6916) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_SCHED;
ALTER FUNCTION SP_U_SCHED COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_FORECAST ==
CREATE OR REPLACE FUNCTION SP_U_FORECAST
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_acc_rej_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assign_count PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_FS TIMESTAMP;
   h_FF TIMESTAMP;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_acc_rej_bitflag PLS_INTEGER := 0;
   h_act_duration PLS_INTEGER := 0;
   h_fcst_duration PLS_INTEGER := 0;
   h_mlst_percent PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_sched_duration PLS_INTEGER := 0;
   h_constraint_type PLS_INTEGER := 0;
   h_constraint_dt TIMESTAMP;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_FORECAST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_FORECAST'), '-- ' || SYSTIMESTAMP, ':r := SP_U_FORECAST(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_acc_rej_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FORECAST', 41+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_FORECAST(42) : wbs.sql(6974) : ' || SYSTIMESTAMP);
   END IF; 

   /*  SC_LONG(type);
   
       type = SC_FORECAST;
   
       return SP_U_TSKDATES(p_id,  type, p_start_date, p_end_date, p_bitflag,  p_rec_user, nullIndicator);*/
   
   --bitflag to indicate the right to accept/reject forecast
   
   BEGIN
      SELECT PROJECT_ID, UNRESOLVED_START, UNRESOLVED_FINISH, FORECAST_START, FORECAST_FINISH,
      CASE WHEN FORECAST_DURATION = 0 THEN UNRESOLVED_DURATION ELSE FORECAST_DURATION END,
      CASE WHEN SCHED_START IS NULL THEN 0 ELSE 2 END, CONSTRAINT_TYPE, CONSTRAINT_DT, 
      ASSIGN_COUNT, MILESTONE_PERCENT, ACTUAL_DURATION, MINUTE_PER_DAY, 
      CASE WHEN SCHED_START IS NULL THEN PLANNED_DURATION ELSE SCHED_DURATION END
      INTO h_project_id, h_start_date, h_finish_date, h_FS, h_FF,
      h_fcst_duration, 
      h_type, h_constraint_type, h_constraint_dt,
      h_assign_count, h_mlst_percent, h_act_duration, h_min_per_day, h_sched_duration
      FROM TMT_WBS 
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(71) : wbs.sql(7003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_fcst_duration %d, h_start_date %d %s, h_finish_date %d %s\n",SC_STATE,h_fcst_duration,h_start_date_Ind,h_start_date, h_finish_date_Ind,h_finish_date);
   
   If Coalesce(h_assign_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FORECAST', 78+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FORECAST(79) : wbs.sql(7011) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_DATES_ASSIGNMENT), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FORECAST', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_FORECAST(82) : wbs.sql(7014) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_DATES_ASSIGNMENT, p_id
            , True);
   End If;
   h_acc_rej_bitflag := p_acc_rej_bitflag;
   
   If (p_start_date IS NOT NULL) Then
      If Coalesce(h_mlst_percent, 0) > 0 Then
         -- Actual Start exists
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FORECAST', 92+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FORECAST(93) : wbs.sql(7025) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FORECAST', 95+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_FORECAST(96) : wbs.sql(7028) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(111) : wbs.sql(7043) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         --Should be replace with c function
         BEGIN
            SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date)))  INTO  h_S FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 125+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(126) : wbs.sql(7058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If (h_FF IS NOT NULL) AND (PMO_ORASTD.strncmp(h_FF, h_S, 10) < 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_FORECAST', 133+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_FORECAST(134) : wbs.sql(7066) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FORECAST', 136+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_FORECAST(137) : wbs.sql(7069) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, h_start_date, True);
      End If;
      
      If ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
              h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
              h_constraint_type, 0) = PMO_CNST.SC_FNET)) AND (PMO_ORASTD.strncmp(h_S, h_start_date
              , 10) <> 0) Then
         h_constraint_type := PMO_CNST.SC_SNET;
         h_constraint_dt := h_S;
      End If;
      
      h_start_date := h_S;
   Else
      h_S := NULL;
      If (h_FS IS NOT NULL) Then
         h_start_date := h_FS;
      End If;
   End If;
   
   If (p_end_date IS NOT NULL) Then
      BEGIN
         SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_F
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id
         AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 169+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(170) : wbs.sql(7102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         --Should be replace with c function
         BEGIN
            SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date)))  INTO  h_F FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 184+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(185) : wbs.sql(7117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If PMO_ORASTD.strncmp(h_F, h_start_date, 10) < 0 Then
         -- Don't support backwords rescheduling
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_FORECAST', 193+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_FORECAST(194) : wbs.sql(7126) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_FORECAST', 196+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_FORECAST(197) : wbs.sql(7129) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
      End If;
      
      If ((Coalesce(h_constraint_type, 0) = PMO_CNST.SC_ASAP) OR (Coalesce(
              h_constraint_type, 0) = PMO_CNST.SC_SNET) OR (Coalesce(
              h_constraint_type, 0) = PMO_CNST.SC_FNET)) AND (PMO_ORASTD.strncmp(h_F, h_finish_date
              , 10) <> 0) Then
         h_constraint_type := PMO_CNST.SC_FNET;
         h_constraint_dt := h_F;
      End If;
      
      h_finish_date := h_F;
   Else
      h_F := NULL;
      If (h_FF IS NOT NULL) Then
         h_finish_date := h_FF;
      End If;
   End If;
   
   If Coalesce(p_bitflag, 0) <> -1 Then
      h_fcst_duration := p_bitflag;
   End If;
   
   --trace_printf("h_acc_rej_bitflag %d, h_type %d, h_fcst_duration %d, h_mlst_percent %d\n",h_acc_rej_bitflag,h_type,h_fcst_duration,h_mlst_percent);
   If Coalesce(h_acc_rej_bitflag, 0) = 0 Then
      BEGIN
         UPDATE TMT_WBS SET
         FORECAST_START = h_S,
         FORECAST_FINISH = h_F,
         FORECAST_DURATION = h_fcst_duration
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 239+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(240) : wbs.sql(7172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("1_SC_STATE: %d, h_fcst_duration: %d, h_S %d %s, h_F %d %s\n",SC_STATE,h_fcst_duration,h_S_Ind,h_S, h_F_Ind,h_F);
   ElsIf Coalesce(h_mlst_percent, 0) = 0 Then
      If PMO_ORASTD.strncmp(h_finish_date, h_start_date, 10) < 0 Then
         h_finish_date := NULL;
         h_fcst_duration := Coalesce(h_sched_duration, 0);
         -- if forcast_start set after planned_finish then we keep the original sched_duration
      Else
         h_fcst_duration := 0;
      End If;
      
      If Coalesce(h_type, 0) = 0 Then
         -- planned
         BEGIN
            UPDATE TMT_WBS SET
            PLANNED_START = h_start_date,
            PLANNED_FINISH = h_finish_date,
            PLANNED_DURATION = h_fcst_duration
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 271+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(272) : wbs.sql(7204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         -- sched
         BEGIN
            UPDATE TMT_WBS SET
            SCHED_START = h_start_date,
            SCHED_FINISH = h_finish_date,
            SCHED_DURATION = h_fcst_duration
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(294) : wbs.sql(7226) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("2_SC_STATE: %d, h_fcst_duration %d, h_start_date %d %s, h_finish_date %d %s\n",SC_STATE,h_fcst_duration,h_start_date_Ind,h_start_date, h_finish_date_Ind,h_finish_date);
   Else
      -- Get forecast duration
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_MIN_MAX';
      PMO_DB2M.SC_STATE := 0;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CDY';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_CDY
         SELECT ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF
         FROM CALENDAR_DAY_OF_YEAR
         WHERE ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 324+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(325) : wbs.sql(7257) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_MIN_MAX
         SELECT MIN(DAY_YEAR), MAX(DAY_YEAR), h_min_per_day, TO_TIMESTAMP('1899-12-30 8:00:00'),TO_TIMESTAMP('1899-12-30 8:00:00'), 0
         FROM PMO_TMP_CDY;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(344) : wbs.sql(7276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_fcst_duration := 0;
      h_fcst_duration := GET_FD_DURATION(h_project_id, h_start_date, h_finish_date, h_fcst_duration);
      --trace_printf("h_type: %d, h_mlst_percent: %d, h_fcst_duration: %d, h_start_date: %s, h_finish_date: %s\n", h_type,h_mlst_percent,h_fcst_duration,h_start_date, h_finish_date);
      
      If Coalesce(h_act_duration, 0) = Coalesce(h_fcst_duration, 0) Then
         h_mlst_percent := 10000;
      ElsIf Coalesce(h_act_duration, 0) > Coalesce(h_fcst_duration, 0) Then
         h_mlst_percent := 10000;
         h_act_duration := Coalesce(h_fcst_duration, 0);
      ElsIf Coalesce(h_act_duration, 0) > 0 Then
         h_mlst_percent := Trunc(Coalesce(h_act_duration, 0) * 10000 / Coalesce(h_fcst_duration, 0));
      Else
         h_act_duration := Trunc((Coalesce(h_mlst_percent, 0) / 10000) * Coalesce(h_fcst_duration, 0));
      End If;
      
      --trace_printf("h_act_duration: %d, h_fcst_duration: %d, h_mlst_percent: %d\n", h_act_duration, h_fcst_duration, h_mlst_percent);
      If Coalesce(h_constraint_type, 0) = 0 Then
         BEGIN
            UPDATE TMT_WBS 
            SET MILESTONE_PERCENT = h_mlst_percent,
            SCHED_START = h_start_date, 
            SCHED_FINISH = h_finish_date, 
            SCHED_DURATION = h_fcst_duration,
            ACTUAL_DURATION = CASE WHEN ACTUAL_DURATION = 0 THEN h_act_duration ELSE ACTUAL_DURATION END,
            FORECAST_START = NULL, 
            FORECAST_FINISH = NULL, 
            FORECAST_DURATION = 0,
            ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS,PMO_CNST.SC_PROPOSED_BIT)
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 387+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(388) : wbs.sql(7320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS 
            SET MILESTONE_PERCENT = h_mlst_percent,
            SCHED_START = h_start_date, 
            SCHED_FINISH = h_finish_date, 
            SCHED_DURATION = h_fcst_duration,
            ACTUAL_DURATION = CASE WHEN ACTUAL_DURATION = 0 THEN h_act_duration ELSE ACTUAL_DURATION END,
            FORECAST_START = NULL, 
            FORECAST_FINISH = NULL, 
            FORECAST_DURATION = 0,
            CONSTRAINT_TYPE = h_constraint_type,
            CONSTRAINT_DT = h_constraint_dt,
            ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS,PMO_CNST.SC_PROPOSED_BIT)
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 416+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(417) : wbs.sql(7349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("3_SC_STATE: %d, h_mlst_percent: %d, h_fcst_duration: %d, h_start_date: %s, h_finish_date: %s\n",SC_STATE,h_mlst_percent,h_fcst_duration,h_start_date, h_finish_date);
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) AND (Coalesce(p_bitflag, 0) = -1) Then
      PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_FORECAST', 429+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_FORECAST(430) : wbs.sql(7362) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 437+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(438) : wbs.sql(7370) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_FORECAST', 449+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_FORECAST(450) : wbs.sql(7382) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_FORECAST;
ALTER FUNCTION SP_U_FORECAST COMPILE DEBUG;

--Forward Declaration

/*###########################################*/

Prompt == FUNCTION SP_U_ACTUAL ==
CREATE OR REPLACE FUNCTION SP_U_ACTUAL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_start_date TIMESTAMP
   , p_end_date TIMESTAMP
   , p_mlst_percent PLS_INTEGER
   , p_close_task_right PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_assign_count PLS_INTEGER := 0;
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_S TIMESTAMP;
   h_F TIMESTAMP;
   h_start_date TIMESTAMP;
   h_finish_date TIMESTAMP;
   h_SS TIMESTAMP;
   h_SF TIMESTAMP;
   h_AS TIMESTAMP;
   h_FF TIMESTAMP;
   h_mlst_percent PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_sd PLS_INTEGER := 0;
   h_planned_start TIMESTAMP;
   h_planned_finish TIMESTAMP;
   h_actual_finish TIMESTAMP;
   h_new_actual_finish TIMESTAMP;
   h_mp_status_DT TIMESTAMP;
   h_planned_duration PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_new_actual PLS_INTEGER := 0;
   h_close_stage_id PLS_INTEGER := 0;
   h_completed_stage_id PLS_INTEGER := 0;
   i_old_percent PLS_INTEGER NOT NULL := Coalesce(h_mlst_percent, 0);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_ACTUAL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_ACTUAL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_ACTUAL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || p_end_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_mlst_percent), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_close_task_right), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_ACTUAL', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_ACTUAL(56) : wbs.sql(7456) : ' || SYSTIMESTAMP);
   END IF; 

   h_rec_user := p_rec_user;
   h_new_actual_finish := p_end_date;
   h_actual_finish := '';
   
   BEGIN
      SELECT PROJECT_ID, START_DT, FINISH_DT, SCHED_EFFORT, ETC,
      SCHED_START, SCHED_FINISH, SCHED_DURATION, MP_STATUS_DT,
      PLANNED_START, PLANNED_FINISH, PLANNED_DURATION,
      ACTUAL_START, ACTUAL_FINISH, ACTUAL_DURATION, MILESTONE_PERCENT,
      ASSIGN_COUNT, STAGE_ID, FORECAST_FINISH, MINUTE_PER_DAY, TYPE_ID
      INTO h_project_id, h_start_date, h_finish_date, h_new_actual, h_temp_var,
      h_SS, h_SF, h_sd, h_mp_status_DT,
      h_planned_start, h_planned_finish, h_planned_duration,
      h_AS, h_actual_finish, h_duration, h_mlst_percent,
      h_assign_count, h_stage_id, h_FF, h_min_per_day, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(82) : wbs.sql(7482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_assign_count: %d, h_mlst_percent: %d, h_duration: %d\n",SC_STATE,h_assign_count,h_mlst_percent,h_duration);
   --trace_printf("OLD: h_planned_duration: %d, h_planned_start: %d:%s, h_planned_finish: %d:%s\n",h_planned_duration,h_planned_start_Ind,h_planned_start,h_planned_finish_Ind,h_planned_finish);
   --trace_printf("OLD: h_actual_finish: %d %s\n", h_actual_finish_Ind, h_actual_finish);
   
   If Coalesce(h_assign_count, 0) = 0 Then
      --trace_printf("OLD: h_sd: %d, h_mlst_percent: %d, h_duration: %d, h_SS: %d:%s, h_SF: %d:%s\n",h_sd,h_mlst_percent,h_duration,h_SS_Ind,h_SS,h_SF_Ind,h_SF);
      If (Coalesce(p_mlst_percent, 0) > 0) AND (Coalesce(p_mlst_percent, 0) < 10000) Then
         If Coalesce(p_mlst_percent, 0) <> Coalesce(h_mlst_percent, 0) Then
            -- This is the corect duration
            --              if ( h_duration > 0 )
            --              {
            --                  h_sd = h_duration * 10000 / h_mlst_percent;
            --              }
            
            h_mlst_percent := Coalesce(p_mlst_percent, 0);
            
            If (Coalesce(h_sd, 0) = 0) AND ((h_SS IS NULL)) Then
               h_SS := h_planned_start;
               h_SF := h_planned_finish;
               h_sd := h_planned_duration;
            End If;
            
            If Coalesce(h_sd, 0) = 0 Then
               -- Load Calendar
               -- Temporary Table Declaration has been changed to Truncate
               EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_MIN_MAX';
               PMO_DB2M.SC_STATE := 0;
               
               -- Temporary Table Declaration has been changed to Truncate
               EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CDY';
               PMO_DB2M.SC_STATE := 0;
               
               BEGIN
                  INSERT INTO PMO_TMP_CDY
                  SELECT ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF
                  FROM CALENDAR_DAY_OF_YEAR
                  WHERE ELEMENT_ID = h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 132+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(133) : wbs.sql(7533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_TMP_MIN_MAX
                  SELECT MIN(DAY_YEAR), MAX(DAY_YEAR), h_min_per_day, TO_TIMESTAMP('1899-12-30 8:00:00'),TO_TIMESTAMP('1899-12-30 8:00:00'), 0
                  FROM PMO_TMP_CDY;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 151+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(152) : wbs.sql(7552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --trace_printf("1_h_SS: %d:%s, h_sd: %d, h_SF: %d:%s\n", h_SS_Ind,h_SS,h_sd,h_SF_Ind,h_SF);
               h_sd := GET_FD_DURATION(h_project_id, h_SS, h_SF, h_sd);
            End If;
            
            h_duration := Trunc((Coalesce(h_sd, 0) * (Coalesce(h_mlst_percent, 0) / 10000.0)));
            --trace_printf("2_h_SS: %d:%s, h_sd: %d, h_SF: %d:%s\n", h_SS_Ind,h_SS,h_sd,h_SF_Ind,h_SF);
         End If;
      ElsIf Coalesce(p_mlst_percent, 0) = 10000 Then
         If Coalesce(h_sd, 0) = 0 Then
            h_duration := h_planned_duration;
            h_sd := h_planned_duration;
         Else
            h_duration := h_sd;
         End If;
         h_mlst_percent := 10000;
      End If;
      --trace_printf("NEW: h_sd: %d, h_mlst_percent: %d, h_duration: %d\n",h_sd,h_mlst_percent,h_duration);
      --trace_printf("h_SS: %d %s, h_SF: %d %s\n",h_SS_Ind,h_SS,h_SF_Ind,h_SF);
      
      If (p_start_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_start_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(188) : wbs.sql(7588) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            --Should be replace with c function
            BEGIN
               SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_start_date, 1, 10)), PMO_ORASTD.TIME(h_start_date)))  INTO  h_S FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 202+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(203) : wbs.sql(7603) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(p_mlst_percent, 0) > 0 Then
         If (h_AS IS NOT NULL) Then
            h_S := h_AS;
         ElsIf (h_SS IS NULL) Then
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
               FROM CALENDAR_DAY_OF_YEAR
               WHERE ELEMENT_ID = h_project_id
               AND DAY_YEAR = TO_DATE(SubStr(h_planned_start, 1, 10));
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 222+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(223) : wbs.sql(7623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               --Should be replace with c function
               BEGIN
                  SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_planned_start, 1, 10)), PMO_ORASTD.TIME(h_start_date)))  INTO  h_S FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(238) : wbs.sql(7638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            BEGIN
               SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_S
               FROM CALENDAR_DAY_OF_YEAR
               WHERE ELEMENT_ID = h_project_id
               AND DAY_YEAR = TO_DATE(SubStr(h_SS, 1, 10));
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 254+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(255) : wbs.sql(7655) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               --Should be replace with c function
               BEGIN
                  SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SS, 1, 10)), PMO_ORASTD.TIME(h_start_date)))  INTO  h_S FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 269+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(270) : wbs.sql(7670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      Else
         h_S := NULL;
         h_duration := 0;
         h_mlst_percent := 0;
      End If;
      
      If (p_end_date IS NOT NULL) Then
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(DAY_YEAR, PMO_ORASTD.TIME(PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED))) INTO h_F
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id
            AND DAY_YEAR = TO_DATE(SubStr(p_end_date, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 293+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(294) : wbs.sql(7694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            --Should be replace with c function
            BEGIN
               SELECT  (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(p_end_date, 1, 10)), PMO_ORASTD.TIME(h_finish_date)))  INTO  h_F FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 308+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(309) : wbs.sql(7709) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         h_F := NULL;
         NULL;
      End If;
      
      --trace_printf("p_mlst_percent: %d, h_S: %d:%s, h_SS: %d:%s, h_F: %d:%s\n", *p_mlst_percent,h_S_Ind,h_S,h_SS_Ind,h_SS,h_F_Ind,h_F);
      If ((h_S IS NOT NULL)) AND ((h_F IS NOT NULL)) Then
         If (PMO_ORASTD.strncmp(h_S, h_SS, 10) <> 0) OR (PMO_ORASTD.strncmp(h_F, h_SF, 10) <> 0) Then
            h_sd := 0;
            h_duration := 0;
         End If;
      ElsIf PMO_ORASTD.strncmp(h_S, h_SS, 10) <> 0 Then
         -- Load Calendar
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_MIN_MAX';
         PMO_DB2M.SC_STATE := 0;
         
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_CDY';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_CDY
            SELECT ELEMENT_ID, DAY_YEAR, DAY_WEEK, AVAILABLE_MIN, BIT_SCHED, WEEK_OF, MONTH_OF, YEAR_OF
            FROM CALENDAR_DAY_OF_YEAR
            WHERE ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 349+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(350) : wbs.sql(7750) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_TMP_MIN_MAX
            SELECT MIN(DAY_YEAR), MAX(DAY_YEAR), h_min_per_day, TO_TIMESTAMP('1899-12-30 8:00:00'),TO_TIMESTAMP('1899-12-30 8:00:00'), 0
            FROM PMO_TMP_CDY;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 368+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(369) : wbs.sql(7769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         /*          BEGIN_SQL
                         SELECT COALESCE(HOST(h_SF) , HOST(h_planned_finish)) INTO HOST(h_SF) FROM DUAL;
                     END_SQL;*/
         
         --TJ
         --*** -180 if SS, SF, and AS
         --*** Nullify(SC_PARAM(h_SF)) the duration becomes 1 day
         --*** keeping the h_SF
         --InitializeHost(SC_PARAM(h_SF),"");
         
         -- if duration is zero for example for milestone then we dont need to call GET_FD_DURATION function
         If Coalesce(h_sd, 0) = 0 Then
            h_SF := h_S;
         Else
            h_SF := '';
            --trace_printf("h_S: %d:%s, h_sd: %d, h_SF: %d:%s\n", h_S_Ind,h_S,h_sd,h_SS,h_SF_Ind,h_SF);
            h_planned_duration := GET_FD_DURATION(h_project_id, h_S, h_SF, h_sd);
         End If;
         --trace_printf("***: h_sd: %d, h_duration: %d, h_planned_duration: %d, h_SF: %d:%s\n",h_sd,h_duration,h_planned_duration,h_SF_Ind,h_SF);
         
         /*          if ( h_planned_duration < h_sd )    // push Sched Finish
                     {
                         InitializeHost(SC_PARAM(h_SF),"");
                         h_planned_duration = GET_FD_DURATION(SC_PARAM(h_project_id), SC_PARAM(h_S), SC_PARAM(h_SF), SC_PARAM(h_sd));
         
                         BEGIN_SQL
                             UPDATE TMT_WBS SET
                                 SCHED_START = HOST(h_S),
                                 SCHED_FINISH = HOST(h_SF)
                             WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_actual);
                         END_SQL;
         //trace_printf("***: SC_STATE: %d, h_S: %d:%s, h_SF: %d:%s\n",SC_STATE,h_S_Ind,h_S,h_SF_Ind,h_SF);
         
                         if ( *p_mlst_percent == 10000 )
                         {
                             InitializeHost(SC_PARAM(h_F),SC_PARAM(h_SF));
                         }
                     }*/
      End If;
      
      --trace_printf("p_mlst_percent: %d, p_close_task_right: %d, h_S: %d:%s, h_F: %d:%s, h_FF: %d:%s\n", *p_mlst_percent,*p_close_task_right,h_S_Ind,h_S,h_F_Ind,h_F,h_FF_Ind,h_FF);
      If i_old_percent <> Coalesce(h_mlst_percent, 0) Then
         BEGIN
            SELECT SYSTIMESTAMP INTO h_mp_status_DT FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 423+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(424) : wbs.sql(7824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_close_stage_id := getCloseStage(Coalesce(h_type_id, 0));
      h_completed_stage_id := getTaskCompletedStage(Coalesce(h_type_id, 0));
      --added here on 19/04/2004 because there was no condition to compare the actual finish dates to update correctly tmt_wbs when we remove Actual finish from
      --descriptive view. after removing actual finish it would bring back the actul finish, and %dc
      If ((h_actual_finish IS NOT NULL)) AND ((h_new_actual_finish IS NULL)) Then
         h_stage_id := getTaskDefaultStage(Coalesce(h_type_id, 0));
         
         If (Coalesce(h_mlst_percent, 0) = 10000) AND (Coalesce(p_mlst_percent, 0) = Coalesce(
               h_mlst_percent, 0)) Then
            h_mlst_percent := 100;
            h_duration := Trunc((Coalesce(h_duration, 0) * 0.01));
         Else
            h_mlst_percent := Coalesce(p_mlst_percent, 0);
         End If;
         
         BEGIN
            UPDATE TMT_WBS SET
            MILESTONE_PERCENT = h_mlst_percent,
            STAGE_ID = h_stage_id,
            MP_STATUS_DT = h_mp_status_DT,
            FD = PMO_CNST.SC_SF,
            ACTUAL_DURATION = h_duration,
            ACTUAL_FINISH = NULL
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 463+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(464) : wbs.sql(7864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(p_mlst_percent, 0) = 10000 Then
         If Coalesce(h_stage_id, 0) <> Coalesce(h_close_stage_id, 0) Then
            h_stage_id := getTaskCompletedStage(Coalesce(h_type_id, 0));
            
            If isWBSTransferedTask(Coalesce(h_type_id, 0)) <> 0 Then
               BEGIN
                  UPDATE TMT_CRI
                  SET CHANGE_TO_TASK = 1,
                  STAGE_ID = h_stage_id
                  WHERE ELEMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 487+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(488) : wbs.sql(7888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         BEGIN
            UPDATE TMT_WBS SET
            MILESTONE_PERCENT = p_mlst_percent,
            MP_STATUS_DT = h_mp_status_DT,
            FD = PMO_CNST.SC_UAF,
            STAGE_ID = h_stage_id,
            FORECAST_START = NULL,
            FORECAST_FINISH = NULL,
            FORECAST_DURATION = 0,
            SCHED_START = h_S,
            SCHED_FINISH = h_F,
            SCHED_DURATION = h_sd,
            ACTUAL_START = h_S,
            ACTUAL_FINISH = h_F,
            ACTUAL_DURATION = h_sd
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 520+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(521) : wbs.sql(7921) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("2_* SC_STATE: %d\n", SC_STATE); //trace_flush();
      ElsIf Coalesce(p_mlst_percent, 0) = 0 Then
         BEGIN
            UPDATE TMT_WBS SET
            MILESTONE_PERCENT = 0,
            MP_STATUS_DT = h_mp_status_DT,
            SD = PMO_CNST.SC_SS,
            FD = PMO_CNST.SC_SF,
            ACTUAL_START = NULL,
            ACTUAL_FINISH = NULL,
            ACTUAL_DURATION = 0
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 546+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(547) : wbs.sql(7947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("3_* SC_STATE: %d\n", SC_STATE); //trace_flush();
      ElsIf (Coalesce(h_stage_id, 0) = Coalesce(h_close_stage_id, 0)) OR (Coalesce(
                                          h_stage_id, 0) = Coalesce(h_completed_stage_id, 0)) Then
         h_stage_id := getTaskDefaultStage(Coalesce(h_type_id, 0));
         
         BEGIN
            UPDATE TMT_WBS SET
            MILESTONE_PERCENT = p_mlst_percent,
            MP_STATUS_DT = h_mp_status_DT,
            FD = PMO_CNST.SC_SF,
            STAGE_ID = h_stage_id,
            SCHED_DURATION = h_sd,
            ACTUAL_START = h_S,
            ACTUAL_FINISH = h_F,
            ACTUAL_DURATION = h_duration,
            REC_USER = h_rec_user
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 577+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(578) : wbs.sql(7978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("4_* SC_STATE: %d\n", SC_STATE); //trace_flush();
      ElsIf ((h_FF IS NOT NULL)) AND (PMO_ORASTD.strncmp(h_S, h_FF, 10) > 0) Then
         BEGIN
            UPDATE TMT_WBS SET
            MILESTONE_PERCENT = h_mlst_percent,
            MP_STATUS_DT = h_mp_status_DT,
            FD = PMO_CNST.SC_SF,
            FORECAST_FINISH = NULL,
            SCHED_DURATION = h_sd,
            ACTUAL_START = h_S,
            ACTUAL_FINISH = h_F,
            ACTUAL_DURATION = h_duration
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 604+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(605) : wbs.sql(8005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("5_* SC_STATE: %d\n", SC_STATE); //trace_flush();
      ElsIf PMO_ORASTD.strncmp(h_S, h_AS, 10) <> 0 Then
         --trace_printf("\n h_S:%s:%d", h_S, h_S_Ind);
         --trace_printf("\n h_F:%s:%d", h_F, h_F_Ind);
         --trace_printf("\n h_SF:%s:%d", h_SF, h_SF_Ind);
         
         BEGIN
            UPDATE TMT_WBS
            SET MILESTONE_PERCENT = h_mlst_percent,
            MP_STATUS_DT = h_mp_status_DT,
            FD = PMO_CNST.SC_SF,
            SCHED_START = h_S,
            SCHED_FINISH = h_SF,
            SCHED_DURATION = h_sd,
            ACTUAL_START = h_S,
            ACTUAL_FINISH = h_F,
            ACTUAL_DURATION = h_duration
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 636+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(637) : wbs.sql(8037) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("6_* SC_STATE: %d, h_S: %d:%s, h_F: %d:%s, h_duration: %d, h_SF: %d:%s, h_sd: %d\n", SC_STATE,h_S_Ind,h_S,h_F_Ind,h_F,h_duration,h_SF_Ind,h_SF,h_sd); //trace_flush();
      Else
         BEGIN
            UPDATE TMT_WBS
            SET MILESTONE_PERCENT = h_mlst_percent,
            MP_STATUS_DT = h_mp_status_DT,
            FD = PMO_CNST.SC_SF,
            SCHED_DURATION = h_sd,
            ACTUAL_START = h_S,
            ACTUAL_FINISH = h_F,
            ACTUAL_DURATION = h_duration
            WHERE ELEMENT_ID = p_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 663+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(664) : wbs.sql(8064) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("7_* SC_STATE: %d\n", SC_STATE); //trace_flush();
      End If;
   End If;
   /*else if ( (h_new_actual > 0)  (*p_mlst_percent == 10000)  (h_temp_var > 0) )
       {
           InitializeHost(SC_PARAM(h_id),p_id,ind_u_actual->p_id);
           h_temp_var = FC_U_TASK_PERCENT (
               SC_PARAM(h_project_id),
               SC_PARAM(h_id),
               SC_PARAM(h_new_actual),
               SC_PARAM(h_rec_user), 1);
   
           if(h_stage_id != h_close_stage_id)
           {
               h_stage_id = getTaskCompletedStage(h_type_id);
   
               if (isWBSTransferedTask(h_type_id))
               {
                   BEGIN_SQL
                       UPDATE TMT_CRI
                       SET CHANGE_TO_TASK = 1,
                           STAGE_ID = HOST(h_stage_id)
                       WHERE ELEMENT_ID = HOST(h_id) ;
                   END_SQL;
               }
           }
   
           BEGIN_SQL
               UPDATE TMT_WBS SET
                   MILESTONE_PERCENT = 10000,
                   MP_STATUS_DT = SC_NOW,
                   FD = SC_UAF,
                   STAGE_ID = HOST(h_stage_id),
                   FORECAST_START = SC_NULL,
                   FORECAST_FINISH = SC_NULL,
                   FORECAST_DURATION = 0
               WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_actual);
           END_SQL;
       }*/
   
   h_temp_var := FC_Rollup(h_project_id);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_ACTUAL', 710+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_ACTUAL(711) : wbs.sql(8111) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 717+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(718) : wbs.sql(8118) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_ACTUAL', 729+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_ACTUAL(730) : wbs.sql(8130) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_ACTUAL;
ALTER FUNCTION SP_U_ACTUAL COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_U_MLST_PERCENT ==
CREATE OR REPLACE FUNCTION SP_U_MLST_PERCENT
(
     p_id VARCHAR2
   , p_mlst_percent PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_mlst_percent PLS_INTEGER := 0;
   h_SS TIMESTAMP;
   h_SF TIMESTAMP;
   h_FS TIMESTAMP;
   h_FF TIMESTAMP;
   h_AS TIMESTAMP;
   h_AF TIMESTAMP;
   h_flag_int PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_MLST_PERCENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_MLST_PERCENT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_MLST_PERCENT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_mlst_percent), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_MLST_PERCENT', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_MLST_PERCENT(30) : wbs.sql(8176) : ' || SYSTIMESTAMP);
   END IF; 

   /*  struct ind_u_mlst_percent_struct {
           short p_id;
           short p_mlst_percent;
           short p_rec_user;
       } *ind_u_mlst_percent = (ind_u_mlst_percent_struct *) nullIndicator;
   */
   -- Declare host variables
   --SC_CHAR(h_actual_start, SC_H_TIMESTAMP);
   --SC_CHAR(h_current_date, SC_H_TIMESTAMP);
   --SC_CHAR(h_finish_date, SC_H_TIMESTAMP);
   --SC_CHAR(h_rec_status, SC_H_FLAG);
   --SC_CHAR(h_start_date, SC_H_TIMESTAMP);
   --SC_LONG(h_min_per_day);
   --SC_LONG(h_type);
   
   --InitializeHost(SC_PARAM(h_mlst_percent), *mlst_percent, 0);
   h_mlst_percent := Coalesce(p_mlst_percent, 0);
   --InitializeHost(SC_PARAM(h_id), id, 0);
   h_id := p_id;
   
   --duration based
   BEGIN
      SELECT
      PROJECT_ID,
      SCHED_START, SCHED_FINISH,
      FORECAST_START, FORECAST_FINISH,
      ACTUAL_START, ACTUAL_FINISH
      INTO
      h_project_id,
      h_SS, h_SF,
      h_FS, h_FF,
      h_AS, h_AF
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(72) : wbs.sql(8218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /*
   //trace_printf("\nh_SS: %s, h_SS_Ind: %d", h_SS, h_SS_Ind);
   //trace_printf("\nh_SF: %s, h_SF_Ind: %d", h_SF, h_SF_Ind);
   //trace_printf("\nh_FS: %s, h_FS_Ind: %d", h_FS, h_FS_Ind);
   //trace_printf("\nh_FF: %s, h_FF_Ind: %d", h_FF, h_FF_Ind);
   //trace_printf("\nh_AS: %s, h_AS_Ind: %d", h_AS, h_AS_Ind);
   //trace_printf("\nh_AF: %s, h_AF_Ind: %d", h_AF, h_AF_Ind);
   //trace_printf("\n"); //trace_flush();
   */
   If Coalesce(h_mlst_percent, 0) = 10000 Then
      --      if( (h_AS_Ind + h_AF_Ind) != 0 )
      If (h_AS IS NULL) OR (h_AF IS NULL) Then
         h_flag_int := PMO_CNST.SC_UAF;
         --one, or both of the actual dates is/are missing
         --fix start
         --          if( h_AS_Ind != 0 )
         If (h_AS IS NULL) Then
            --if( h_FS_Ind == 0 )
            If (h_FS IS NULL) Then
               --compare FS and SS, and Current to determine AS
               BEGIN
                  SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_FS) < PMO_ORASTD.DB2TIMESTAMP(h_SS) THEN 1 ELSE 0 END )  INTO  h_count FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 104+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(105) : wbs.sql(8251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_count, 0) = 1 Then
                  --FS is earlier
                  BEGIN
                     SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_FS) > SYSTIMESTAMP
                     THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_FS))
                     ELSE PMO_ORASTD.DB2TIMESTAMP(h_FS)
                     END )
                      INTO  h_AS FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 123+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(124) : wbs.sql(8270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  --SS is earlier
                  BEGIN
                     SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_SS) > SYSTIMESTAMP
                     THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_SS))
                     ELSE PMO_ORASTD.DB2TIMESTAMP(h_SS)
                     END )
                      INTO  h_AS FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 141+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(142) : wbs.sql(8288) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               --compare SS and Current to determine AS
               BEGIN
                  SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_SS) > SYSTIMESTAMP
                  THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_SS))
                  ELSE PMO_ORASTD.DB2TIMESTAMP(h_SS)
                  END )
                   INTO  h_AS FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 160+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(161) : wbs.sql(8307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         --fix finish
         --          if( h_AF_Ind != 0 )
         If (h_AF IS NULL) Then
            --if( h_FF_Ind == 0 )
            If (h_FF IS NULL) Then
               --compare FF and SF, and Current to determine AF
               BEGIN
                  SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_FF) > PMO_ORASTD.DB2TIMESTAMP(h_SF) THEN 1 ELSE 0 END )  INTO  h_count FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 181+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(182) : wbs.sql(8328) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_count, 0) = 1 Then
                  --FS is later
                  BEGIN
                     SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_FF) > SYSTIMESTAMP
                     THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_FF))
                     ELSE PMO_ORASTD.DB2TIMESTAMP(h_FF)
                     END )
                      INTO  h_AF FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 200+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(201) : wbs.sql(8347) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  --SS is later
                  BEGIN
                     SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_SF) > SYSTIMESTAMP
                     THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_SF))
                     ELSE PMO_ORASTD.DB2TIMESTAMP(h_SF)
                     END )
                      INTO  h_AF FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 218+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(219) : wbs.sql(8365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               --compare SF and Current to determine AF
               BEGIN
                  SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_SF) > SYSTIMESTAMP
                  THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_SF))
                  ELSE PMO_ORASTD.DB2TIMESTAMP(h_SF)
                  END )
                   INTO  h_AF FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 237+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(238) : wbs.sql(8384) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         BEGIN
            SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_AS) > PMO_ORASTD.DB2TIMESTAMP(h_AF)
            THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_AS, 1, 10)), PMO_ORASTD.TIME(h_AF))
            ELSE PMO_ORASTD.DB2TIMESTAMP(h_AF)
            END )
             INTO  h_AF FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 256+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(257) : wbs.sql(8403) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_flag_int := PMO_CNST.SC_UAF;
      End If;
      /*
      //trace_printf("\nh_AS: %s, h_AS_Ind: %d", h_AS, h_AS_Ind);
      //trace_printf("\nh_AF: %s, h_AF_Ind: %d", h_AF, h_AF_Ind);
      //trace_printf("\n"); //trace_flush();
      */
   Else
      If Coalesce(h_mlst_percent, 0) = 0 Then
         --          h_AS_Ind = -1;
         h_AS := NULL;
      Else
         --          if( h_AS_Ind != 0 )
         If (h_AS IS NULL) Then
            --if( h_FS_Ind == 0 )
            If (h_FS IS NULL) Then
               --compare FS and SS, and Current to determine AS
               BEGIN
                  SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_FS) < PMO_ORASTD.DB2TIMESTAMP(h_SS) THEN 1 ELSE 0 END )  INTO  h_count FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 286+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(287) : wbs.sql(8433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If Coalesce(h_count, 0) = 1 Then
                  --FS is earlier
                  BEGIN
                     SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_FS) > SYSTIMESTAMP
                     THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_FS))
                     ELSE PMO_ORASTD.DB2TIMESTAMP(h_FS)
                     END )
                      INTO  h_AS FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 305+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(306) : wbs.sql(8452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               Else
                  --SS is earlier
                  BEGIN
                     SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_SS) > SYSTIMESTAMP
                     THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_SS))
                     ELSE PMO_ORASTD.DB2TIMESTAMP(h_SS)
                     END )
                      INTO  h_AS FROM DUAL;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 323+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(324) : wbs.sql(8470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            Else
               --compare SS and Current to determine AS
               BEGIN
                  SELECT ( CASE WHEN PMO_ORASTD.DB2TIMESTAMP(h_SS) > SYSTIMESTAMP
                  THEN PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SYSDATE), PMO_ORASTD.TIME(h_SS))
                  ELSE PMO_ORASTD.DB2TIMESTAMP(h_SS)
                  END )
                   INTO  h_AS FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 342+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(343) : wbs.sql(8489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
      
      --h_AF_Ind = -1;
      h_AF := NULL;
      h_flag_int := 0;
   End If;
   
   BEGIN
      UPDATE TMT_WBS SET
      FD = CASE WHEN h_flag_int > 0 THEN h_flag_int ELSE 0 END,
      SCHED_START = CASE WHEN h_AS IS NOT Null THEN h_AS ELSE SCHED_START END,
      SCHED_FINISH = CASE WHEN h_AF IS NOT Null THEN h_AF ELSE SCHED_FINISH END,
      ACTUAL_START = h_AS,
      ACTUAL_FINISH = h_AF,
      MILESTONE_PERCENT = h_mlst_percent
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 374+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(375) : wbs.sql(8521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS SET
      SCHED_DURATION = PMO_ORASTD.CAL_DURATION( PROJECT_ID, SCHED_START, SCHED_FINISH )
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 393+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(394) : wbs.sql(8540) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Rollup Moved to Check In
   --if( SC_SUCCESS )
   --{
   --  SC_STATE = FC_Rollup( h_project_id );
   --}
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_MLST_PERCENT', 405+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_MLST_PERCENT(406) : wbs.sql(8552) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 412+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(413) : wbs.sql(8559) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_MLST_PERCENT', 424+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_MLST_PERCENT(425) : wbs.sql(8571) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_MLST_PERCENT;
ALTER FUNCTION SP_U_MLST_PERCENT COMPILE DEBUG;

/*******************************************************************************/

Prompt == FUNCTION SP_ISOUT_WBS ==
CREATE OR REPLACE FUNCTION SP_ISOUT_WBS
(
     p_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   myStmt VARCHAR2(8000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ISOUT_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ISOUT_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_ISOUT_WBS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_WBS', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ISOUT_WBS(19) : wbs.sql(8606) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   
   myStmt := 'SELECT ELEMENT_ID, REC_STATUS, REC_USER FROM TMT_WBS WHERE ELEMENT_ID = ''' || h_id 
          || '''';
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_WBS(27) : wbs.sql(8614) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ISOUT_WBS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_ISOUT_WBS(30) : wbs.sql(8617) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(myStmt);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_WBS', 37+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_WBS(38) : wbs.sql(8625) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ISOUT_WBS', 49+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ISOUT_WBS(50) : wbs.sql(8637) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ISOUT_WBS;
ALTER FUNCTION SP_ISOUT_WBS COMPILE DEBUG;

/*******************************************************************************/

Prompt == FUNCTION SP_CHECK_OUT ==
CREATE OR REPLACE FUNCTION SP_CHECK_OUT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_id2 VARCHAR2(32);
   h_last_checkin TIMESTAMP;
   h_rec_status VARCHAR2(1);
   h_cri_rec_status VARCHAR2(1);
   h_transfer_flag VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHECK_OUT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHECK_OUT'), '-- ' || SYSTIMESTAMP, ':r := SP_CHECK_OUT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHECK_OUT(26) : wbs.sql(8679) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHECK_OUT', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHECK_OUT(31) : wbs.sql(8684) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_OUT(34) : wbs.sql(8687) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_CHECK_OUT', 42+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_CHECK_OUT(43) : wbs.sql(8696) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   BEGIN
      SELECT ELEMENT_ID, REC_STATUS, LAST_CHECKIN, TRANSFER_FLAG
      INTO h_id2, h_rec_status, h_last_checkin, h_transfer_flag
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT(65) : wbs.sql(8718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CHECK_OUT', 71+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CHECK_OUT(72) : wbs.sql(8725) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_OUT(75) : wbs.sql(8728) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'O' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CHECK_OUT', 81+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CHECK_OUT(82) : wbs.sql(8735) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ALREADY_CHECKED_OUT), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 84+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_OUT(85) : wbs.sql(8738) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.ALREADY_CHECKED_OUT, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CHECK_OUT', 91+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CHECK_OUT(92) : wbs.sql(8745) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 94+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_OUT(95) : wbs.sql(8748) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id2, True);
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CHECK_OUT', 101+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CHECK_OUT(102) : wbs.sql(8755) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_DELETED), 'NULL') || ' ID: ' || '''' || h_id2 || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 104+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_OUT(105) : wbs.sql(8758) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_DELETED, h_id2, True);
   End If;
   
   If (h_transfer_flag IS NOT NULL) Then
      BEGIN
         SELECT REC_STATUS
         INTO h_cri_rec_status
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT', 121+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT(122) : wbs.sql(8775) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_ORASTD.strncmp(h_cri_rec_status, 'O', 1) = PMO_CNST.SC_MATCH Then
         -- transfered element  is chked out, it can not be checked out again
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CHECK_OUT', 129+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CHECK_OUT(130) : wbs.sql(8783) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_CHECKOUT), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_OUT', 132+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_OUT(133) : wbs.sql(8786) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.MARKED_AS_CHECKOUT, h_id, True);
      Else
         BEGIN
            UPDATE TMT_CRI
            SET REC_STATUS = 'O',
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT', 152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT(153) : wbs.sql(8806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   --Execute Update Statement
   BEGIN
      UPDATE TMT_WBS
      SET REC_STATUS = 'O',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP
      WHERE ELEMENT_ID = h_id
      AND TYPE_ID NOT IN (PMO_CNST.SC_TMP_FOLDER1, PMO_CNST.SC_TMP_FOLDER2,210,211);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT', 177+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT(178) : wbs.sql(8831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHECK_OUT', 183+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHECK_OUT(184) : wbs.sql(8837) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || COALESCE(NULLIF('''' || h_last_checkin || '''',''''''), 'NULL'));
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_last_checkin, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT', 190+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT(191) : wbs.sql(8844) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_OUT', 202+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_OUT(203) : wbs.sql(8856) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHECK_OUT;
ALTER FUNCTION SP_CHECK_OUT COMPILE DEBUG;

/************************************************************************************************/

Prompt == FUNCTION FC_CHECK_IN ==
CREATE OR REPLACE FUNCTION FC_CHECK_IN
(
     sh_h_checked_in_all PLS_INTEGER
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_checked_in_all PLS_INTEGER := sh_h_checked_in_all;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_project_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_rtf_bits PLS_INTEGER := 0;
   h_table_name VARCHAR2(100);
   h_table_type PLS_INTEGER := 0;
   h_converted_score NUMBER(19) := 0;
   h_transfer_flag VARCHAR2(1);
-- Declare Cursors
      CURSOR CH1 IS
         SELECT MINOR_REVISION
         FROM HISTORY_WBS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_IN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_IN'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_IN(' || 
       COALESCE(TO_CHAR(sh_h_checked_in_all), 'NULL')
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 35+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_IN(36) : wbs.sql(8908) : ' || SYSTIMESTAMP);
   END IF; 

   h_table_type := PMO_CNST.SC_TABLE_WBS;
   
   h_transfer_flag := NULL;
   
   BEGIN
      SELECT PROJECT_ID, ELEMENT_ID, REC_STATUS, RTF_BITS, CONVERTED_SCORE, TRANSFER_FLAG
      INTO h_project_id, h_id, h_rec_status, h_rtf_bits, h_converted_score, h_transfer_flag
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(54) : wbs.sql(8926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 60+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN(61) : wbs.sql(8933) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'D' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 67+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN(68) : wbs.sql(8940) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.MARKED_AS_DELETED;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'I' OR SubStr(h_rec_status, 1, 1) = 'U' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 74+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN(75) : wbs.sql(8947) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.ALREADY_CHECKED_IN;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' OR SubStr(h_rec_status, 1, 1) = 'A' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 81+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN(82) : wbs.sql(8954) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD;
   End If;
   
   -- **************************************************************************************
   -- bitflag    = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN CH1;
   
   FETCH CH1 INTO h_min_revision;
   IF CH1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(111) : wbs.sql(8983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_checked_in_all, 0) = 1 Then
         BEGIN
            UPDATE TMT_WBS
            SET REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 132+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(133) : wbs.sql(9005) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE TMT_WBS
            SET REC_STATUS = 'U',
            REC_DATETIME = SYSTIMESTAMP,
            LAST_CHECKIN = SYSTIMESTAMP
            WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 153+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(154) : wbs.sql(9026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      BEGIN
         CLOSE CH1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 167+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(168) : wbs.sql(9040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_bitflag, 0) = 0 Then
         If Coalesce(h_checked_in_all, 0) = 1 Then
            BEGIN
               UPDATE TMT_WBS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 192+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(193) : wbs.sql(9065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,
               MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END
               WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 215+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(216) : wbs.sql(9088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(h_bitflag, 0) = 1 Then
         If Coalesce(h_checked_in_all, 0) = 1 Then
            BEGIN
               UPDATE TMT_WBS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 240+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(241) : wbs.sql(9113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP,
               MAJOR_REVISION = MAJOR_REVISION + 1,
               MINOR_REVISION = 0
               WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 263+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(264) : wbs.sql(9136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         If Coalesce(h_checked_in_all, 0) = 1 Then
            BEGIN
               UPDATE TMT_WBS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 286+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(287) : wbs.sql(9159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_WBS
               SET REC_STATUS = 'U',
               REC_DATETIME = SYSTIMESTAMP,
               LAST_CHECKIN = SYSTIMESTAMP
               WHERE ELEMENT_ID = h_id AND REC_USER = h_rec_user;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 307+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(308) : wbs.sql(9180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   If (Coalesce(h_converted_score, 0) = -1) AND (Coalesce(h_checked_in_all, 0) = 0) Then
      PMO_DB2M.SC_STATE := FC_CHECK_IN_ALL_SC(h_table_type, h_id, h_bitflag, h_rec_user);
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      h_uniqueID := SYS_GUID();
      If Coalesce(h_rtf_bits, 0) > 0 Then
         BEGIN
            INSERT INTO HISTORY_WBS_RTF
            SELECT h_uniqueID, A.*
            FROM WBS_RTF A
            WHERE A.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 339+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(340) : wbs.sql(9212) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         INSERT INTO HISTORY_WBS (
         HISTORY_ID,
         ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,
         BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,
         CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,
         DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,
         EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,
         ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,
         FD, FINISH_DT, FORECAST_BUDGET, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,
         LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,
         MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,
         PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY,
         RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,
         SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,
         TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,
         UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,
         VARIANCE,
         WBS_CODE, WORK_TODATE,
         ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,
         ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,
         ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,
         R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3
         )
         SELECT
         h_uniqueID,
         ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,
         BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,
         CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,
         DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,
         EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,
         ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,
         FD, FINISH_DT, FORECAST_BUDGET, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,
         LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,
         MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,
         PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY,
         RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,
         SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,
         TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,
         UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,
         VARIANCE,
         WBS_CODE, WORK_TODATE,
         ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,
         ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,
         ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,
         R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 403+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(404) : wbs.sql(9276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS
         SET REVISION_HISTORY = Null
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_IN', 422+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_IN(423) : wbs.sql(9295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- paria
      If Coalesce(h_checked_in_all, 0) = 0 Then
         h_bitflag := 1;
         h_table_name := 'HISTORY_WBS';
         PMO_DB2M.SC_STATE := FC_D_REVISION(h_id, h_bitflag, h_table_name);
      End If;
   Else
      PMO_DB2M.SC_STATE := PMO_CNST.ALREADY_CHECKED_IN;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 438+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN(439) : wbs.sql(9311) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_IN', 443+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_IN(444) : wbs.sql(9316) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_IN;
ALTER FUNCTION FC_CHECK_IN COMPILE DEBUG;

/*********************************************************************************************************/

Prompt == FUNCTION SP_CHECK_IN ==
CREATE OR REPLACE FUNCTION SP_CHECK_IN
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_rec_user VARCHAR2(32);
   h_checked_in_all PLS_INTEGER := 0;
   h_transfer_flag VARCHAR2(32);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHECK_IN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHECK_IN'), '-- ' || SYSTIMESTAMP, ':r := SP_CHECK_IN(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_IN', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHECK_IN(24) : wbs.sql(9350) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHECK_IN', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHECK_IN(29) : wbs.sql(9355) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECK_IN', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECK_IN(32) : wbs.sql(9358) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   h_transfer_flag := NULL;
   
   BEGIN
      SELECT TRANSFER_FLAG
      INTO h_transfer_flag
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_IN', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_IN(54) : wbs.sql(9380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_checked_in_all := 0;
   PMO_DB2M.SC_STATE := FC_CHECK_IN(h_checked_in_all, h_id, h_bitflag, h_rec_user);
   
   If (PMO_DB2M.SC_STATE = 0) AND (h_transfer_flag IS NOT NULL) Then
      PMO_DB2M.SC_STATE := FC_CKIN_CRI(h_checked_in_all, h_id, h_bitflag, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHECK_IN', 66+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHECK_IN(67) : wbs.sql(9393) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_IN', 73+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_IN(74) : wbs.sql(9400) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECK_IN', 85+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECK_IN(86) : wbs.sql(9412) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHECK_IN;
ALTER FUNCTION SP_CHECK_IN COMPILE DEBUG;

/************************************************************************************************/

Prompt == FUNCTION SP_CAN_CHECKIN_ALL ==
CREATE OR REPLACE FUNCTION SP_CAN_CHECKIN_ALL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_resource_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CAN_CHECKIN_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CAN_CHECKIN_ALL'), '-- ' || SYSTIMESTAMP, ':r := SP_CAN_CHECKIN_ALL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAN_CHECKIN_ALL', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CAN_CHECKIN_ALL(24) : wbs.sql(9452) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CAN_CHECKIN_ALL', 28+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CAN_CHECKIN_ALL(29) : wbs.sql(9457) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAN_CHECKIN_ALL', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CAN_CHECKIN_ALL(32) : wbs.sql(9460) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   BEGIN
      SELECT RTRIM(RANK) INTO h_rank FROM TMT_WBS WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_CHECKIN_ALL', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_CHECKIN_ALL(45) : wbs.sql(9473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT COUNT(ELEMENT_ID) INTO h_count
         FROM TMT_WBS WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_CHECKIN_ALL', 59+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_CHECKIN_ALL(60) : wbs.sql(9488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If Coalesce(h_count, 0) > 0 Then
         h_temp_sc_state := 1;
      Else
         BEGIN
            SELECT COUNT(ELEMENT_ID) INTO h_count
            FROM TMT_WBS WHERE RANK LIKE h_rank || '%' AND REC_STATUS IN ('O', 'I');
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_CHECKIN_ALL', 75+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_CHECKIN_ALL(76) : wbs.sql(9504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_temp_sc_state := 2;
         Else
            h_temp_sc_state := 0;
         End If;
      End If;
   Else
      -- Folder
      BEGIN
         SELECT RTRIM(RANK) INTO h_rank FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_CHECKIN_ALL', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_CHECKIN_ALL(97) : wbs.sql(9525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_resource_id := p_rec_user;
      h_bitflag := 3;
      h_temp_sc_state := FC_LOCK_UNLOCK(h_rank, h_resource_id, h_bitflag);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CAN_CHECKIN_ALL', 107+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CAN_CHECKIN_ALL(108) : wbs.sql(9536) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(Coalesce(h_temp_sc_state, 0), p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_CHECKIN_ALL', 114+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_CHECKIN_ALL(115) : wbs.sql(9543) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_CHECKIN_ALL', 126+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_CHECKIN_ALL(127) : wbs.sql(9555) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CAN_CHECKIN_ALL;
ALTER FUNCTION SP_CAN_CHECKIN_ALL COMPILE DEBUG;

/**************************************************************************************************/

Prompt == FUNCTION FC_CHECKIN_ALL ==
CREATE OR REPLACE FUNCTION FC_CHECKIN_ALL
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_current_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_min_revision PLS_INTEGER := 0;
   h_checked_in_all PLS_INTEGER := 0;
   h_transfer_flag VARCHAR2(1);
-- Declare Cursors
      CURSOR C21 IS
         SELECT a.PROJECT_ID, a.ELEMENT_ID, a.TRANSFER_FLAG
         FROM TMT_WBS a, TMT_WBS b
         WHERE b.ELEMENT_ID = h_id
         AND a.REC_STATUS = 'O'
         AND ((b.RANK >= SUBSTR(a.RANK, 1, 8) AND b.RANK <= a.RANK) 
         AND SUBSTR(a.RANK,1, CASE WHEN LENGTH(b.RANK) > LENGTH(a.RANK) THEN 1 ELSE LENGTH(b.RANK) END ) = b.RANK);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECKIN_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECKIN_ALL'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECKIN_ALL(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECKIN_ALL', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECKIN_ALL(33) : wbs.sql(9604) : ' || SYSTIMESTAMP);
   END IF; 

   -- **************************************************************************************
   -- bitflag    = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   
   OPEN C21;
   
   h_transfer_flag := NULL;
   
   LOOP
      FETCH C21 INTO h_project_id, h_current_id, h_transfer_flag;
      IF C21%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         EXIT;
      End If;
      
      h_checked_in_all := 1;
      PMO_DB2M.SC_STATE := FC_CHECK_IN(h_checked_in_all, h_current_id, h_bitflag, h_rec_user);
      
      If (PMO_DB2M.SC_STATE = 0) AND ((h_transfer_flag IS NOT NULL)) Then
         PMO_DB2M.SC_STATE := FC_CKIN_CRI(h_checked_in_all, h_id, h_bitflag, h_rec_user);
      End If;
   END LOOP;
   -- end of while
   
   BEGIN
      CLOSE C21 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECKIN_ALL', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECKIN_ALL(75) : wbs.sql(9646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECKIN_ALL', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECKIN_ALL(81) : wbs.sql(9652) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECKIN_ALL', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECKIN_ALL(86) : wbs.sql(9657) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECKIN_ALL;
ALTER FUNCTION FC_CHECKIN_ALL COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_CHECKIN_ALL ==
CREATE OR REPLACE FUNCTION SP_CHECKIN_ALL
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHECKIN_ALL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHECKIN_ALL'), '-- ' || SYSTIMESTAMP, ':r := SP_CHECKIN_ALL(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECKIN_ALL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHECKIN_ALL(22) : wbs.sql(9689) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHECKIN_ALL', 27+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHECKIN_ALL(28) : wbs.sql(9695) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHECKIN_ALL', 30+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CHECKIN_ALL(31) : wbs.sql(9698) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- **************************************************************************************
   -- bitflag    = 0 MINOR_REVISION = MINOR_REVISION + 1
   --              = 1 MAJOR_REVISION = MAJOR_REVISION + 1
   --              = 2 check in as the same revision
   -- **************************************************************************************
   h_bitflag := p_bitflag;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_CHECKIN_ALL(h_id, h_bitflag, h_rec_user);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CHECKIN_ALL', 47+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CHECKIN_ALL(48) : wbs.sql(9715) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECKIN_ALL', 54+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECKIN_ALL(55) : wbs.sql(9722) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHECKIN_ALL', 66+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHECKIN_ALL(67) : wbs.sql(9734) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHECKIN_ALL;
ALTER FUNCTION SP_CHECKIN_ALL COMPILE DEBUG;

/**************************************************************************************************/

Prompt == FUNCTION FC_UNDO_CHECKOUT ==
CREATE OR REPLACE FUNCTION FC_UNDO_CHECKOUT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_UNDO_CHECKOUT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_UNDO_CHECKOUT'), '-- ' || SYSTIMESTAMP, ':r := FC_UNDO_CHECKOUT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_CHECKOUT', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_UNDO_CHECKOUT(18) : wbs.sql(9768) : ' || SYSTIMESTAMP);
   END IF; 

   --Execute Update Statement
   BEGIN
      UPDATE TMT_WBS SET (REC_STATUS, REC_USER, REC_DATETIME) =
      (SELECT REC_STATUS, REC_USER, REC_DATETIME
      FROM HISTORY_WBS
      WHERE ELEMENT_ID = h_id
      AND REC_DATETIME = (SELECT MAX(REC_DATETIME) FROM HISTORY_WBS WHERE ELEMENT_ID = h_id))
      WHERE ELEMENT_ID = h_id
      AND REC_USER = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_UNDO_CHECKOUT', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_UNDO_CHECKOUT(40) : wbs.sql(9790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_CHECKOUT', 45+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_CHECKOUT(46) : wbs.sql(9796) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_UNDO_CHECKOUT', 49+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_UNDO_CHECKOUT(50) : wbs.sql(9800) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_UNDO_CHECKOUT;
ALTER FUNCTION FC_UNDO_CHECKOUT COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_UNDO_CHECKOUT ==
CREATE OR REPLACE FUNCTION SP_UNDO_CHECKOUT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_undo_checkedout_tran_item PLS_INTEGER := 0;
   h_transfer_flag VARCHAR2(1);
   h_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UNDO_CHECKOUT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UNDO_CHECKOUT'), '-- ' || SYSTIMESTAMP, ':r := SP_UNDO_CHECKOUT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNDO_CHECKOUT', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UNDO_CHECKOUT(25) : wbs.sql(9835) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UNDO_CHECKOUT', 30+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UNDO_CHECKOUT(31) : wbs.sql(9841) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNDO_CHECKOUT', 33+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UNDO_CHECKOUT(34) : wbs.sql(9844) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT REC_STATUS, TRANSFER_FLAG
      INTO h_rec_status, h_transfer_flag
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNDO_CHECKOUT', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNDO_CHECKOUT(54) : wbs.sql(9864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNDO_CHECKOUT', 60+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNDO_CHECKOUT(61) : wbs.sql(9871) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNDO_CHECKOUT', 63+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UNDO_CHECKOUT(64) : wbs.sql(9874) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
   End If;
   
   PMO_DB2M.SC_STATE := FC_UNDO_CHECKOUT(h_id, h_bitflag, h_rec_user);
   
   If (PMO_DB2M.SC_STATE = 0) AND ((h_transfer_flag IS NOT NULL)) Then
      BEGIN
         SELECT REC_STATUS
         INTO h_rec_status
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNDO_CHECKOUT', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNDO_CHECKOUT(83) : wbs.sql(9893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_UCKOUT_CRI(h_id, h_rec_status, h_bitflag, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UNDO_CHECKOUT', 91+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UNDO_CHECKOUT(92) : wbs.sql(9902) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNDO_CHECKOUT', 98+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNDO_CHECKOUT(99) : wbs.sql(9909) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNDO_CHECKOUT', 110+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNDO_CHECKOUT(111) : wbs.sql(9921) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UNDO_CHECKOUT;
ALTER FUNCTION SP_UNDO_CHECKOUT COMPILE DEBUG;

/*###########################################*/

--SC_SQL_API SP_CHECK_OUT

--(

--  SC_WCHAR *p_id,

--  SC_LONG_PARAM *p_bitflag,

--  SC_WCHAR *p_rec_user,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(SP_CHECK_OUT);

--

--  struct ind_checkin_struct {

--      short p_id;

--      short p_bitflag;

--      short p_rec_user;

--  } *ind_checkin = (ind_checkin_struct *) nullIndicator;

--

--  // Validate id

--  if(IsNullSpParam(ind_checkin, p_id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  SC_CHAR(h_id, SC_H_ID);

--  SC_CHAR(h_id2, SC_H_ID);

--  SC_CHAR(h_last_checkin, SC_H_TIMESTAMP);

--  SC_CHAR(h_rec_status, SC_H_FLAG);

--  SC_CHAR(h_cri_rec_status, SC_H_FLAG);

--  SC_CHAR(h_transfer_flag, SC_H_FLAG);

--  //SC_LONG(h_bitflag);

--

--  //InitializeHost(SC_PARAM(h_id), id, ind_checkin->id);

--  InitializeHost(SC_PARAM(h_id),p_id,ind_checkin->p_id);

--  VALIDATE_RECORD(TMT_WBS, h_id, h_rec_status);

--

--  BEGIN_SQL

--      SELECT ELEMENT_ID, REC_STATUS, LAST_CHECKIN,  TRANSFER_FLAG

--      INTO HOST(h_id2), HOST(h_rec_status), HOST(h_last_checkin), HOST(h_transfer_flag)

--      FROM TMT_WBS

--      WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--  END_SQL;

--  if(SC_STATE!=0){RETURN_ERROR(RECORD_NOT_FOUND, h_id2);}

--

--  if( checkFlagStatus(h_rec_status, 'O'))

--  {

--      RETURN_ERROR(ALREADY_CHECKED_OUT, h_id2);

--  }

--

--  if( checkFlagStatus(h_rec_status, 'L'))

--  {

--      RETURN_ERROR(CANNOT_UPDATE_LOCKED_RECORD, h_id2);

--  }

--

--  if( checkFlagStatus(h_rec_status, 'D'))

--  {

--      RETURN_ERROR(MARKED_AS_DELETED, h_id2);

--  }

--

--  if (IsNotNullParam(h_transfer_flag))   // transfered element

--  {

--      BEGIN_SQL

--          SELECT REC_STATUS INTO HOST(h_cri_rec_status)

--          FROM TMT_CRI

--          WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--      END_SQL;

--

--      if (strncmp(h_cri_rec_status, "O", 1) == SC_MATCH)

--      {

--          // transfered element  is chked out, it can not be checked out again

--          RETURN_ERROR(MARKED_AS_CHECKOUT, *p_id);

--      }

--  }

--

--  //Execute Update Statement

--  BEGIN_SQL

--      UPDATE TMT_WBS SET REC_STATUS = 'O', REC_USER = HOST_DB(p_rec_user,ind_checkin), REC_DATETIME = SC_NOW

--      WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND TYPE_ID NOT IN (SC_TMP_FOLDER1, SC_TMP_FOLDER2,210,211);

--  END_SQL;

--

--  RETURN_STATUS(SC_STATE, h_last_checkin);

--  PMO_END_FUNCTION;

--}

--

--/*###########################################*/

--SC_SQL_API SP_CHECK_IN

--(

--  SC_WCHAR *p_id,

--  SC_LONG_PARAM *p_bitflag,

--  SC_WCHAR *p_rec_user,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(SP_CHECK_IN);

--

--  struct ind_checkin_struct {

--      short p_id;

--      short p_bitflag;

--      short p_rec_user;

--  } *ind_checkin = (ind_checkin_struct *) nullIndicator;

--

--  // Validate id

--  if( IsNullSpParam(ind_checkin, p_id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  SC_CHAR(h_id, SC_H_ID);

--  SC_CHAR(h_project_id, SC_H_ID);

--  SC_CHAR(h_rec_status, SC_H_FLAG);

--  SC_CHAR(h_uniqueID, SC_H_GUID);

--  SC_LONG(h_bitflag);

--  SC_LONG(h_min_revision);

--  SC_LONG(h_rtf_bits);

--  SC_CHAR(h_table_name, SC_H_NAME);

--  SC_LONG(h_table_type);

--  SC_CHAR(h_rec_user, SC_H_ID);

--  SC_CHAR(h_transfer_flag, SC_H_FLAG);

--  SC_BIGINT(h_converted_score);

--

--  InitializeHost(SC_PARAM(h_table_type), SC_TABLE_WBS);

--  InitializeHost(SC_PARAM(h_rec_user), p_rec_user, ind_checkin->p_rec_user);

--

--  BEGIN_SQL

--      SELECT PROJECT_ID, ELEMENT_ID, REC_STATUS, RTF_BITS,

--          CONVERTED_SCORE, TRANSFER_FLAG

--      INTO HOST(h_project_id), HOST(h_id), HOST(h_rec_status), HOST(h_rtf_bits),

--          HOST(h_converted_score), HOST(h_transfer_flag)

--      FROM TMT_WBS WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--  END_SQL;

--  if(SC_STATE!=0){RETURN_ERROR(RECORD_NOT_FOUND, h_id);}

--

--  if( checkFlagStatus(h_rec_status, 'D'))

--  {

--      RETURN_ERROR(MARKED_AS_DELETED, h_id);

--  }

--

--  if( checkFlagStatus(h_rec_status, 'I') || checkFlagStatus(h_rec_status, 'U'))

--  {

--      RETURN_ERROR(ALREADY_CHECKED_IN, h_id);

--  }

--

--  if( checkFlagStatus(h_rec_status, 'L') || checkFlagStatus(h_rec_status, 'A'))

--  {

--      RETURN_ERROR(CANNOT_UPDATE_LOCKED_RECORD, h_id);

--  }

--

--  // **************************************************************************************

--  // bitflag    = 0 MINOR_REVISION = MINOR_REVISION + 1

--  //              = 1 MAJOR_REVISION = MAJOR_REVISION + 1

--  //              = 2 check in as the same revision

--  // **************************************************************************************

--  //InitializeHost(SC_PARAM(h_bitflag), *bitflag, ind_checkin->bitflag);

--  InitializeHost(SC_PARAM(h_bitflag),*p_bitflag,ind_checkin->p_bitflag);

--

--  BEGIN_SQL

--      DECLARE CH1 CURSOR WITH HOLD FOR SELECT MINOR_REVISION

--      FROM HISTORY_WBS

--      WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin)

--      FETCH FIRST 1 ROWS ONLY;

--  END_SQL_NOCHECK;

--

--  BEGIN_SQL

--      OPEN CH1;

--  END_SQL;

--

--  BEGIN_SQL

--      FETCH CH1 INTO HOST(h_min_revision) ;

--  END_SQL;

--

--  if (SC_NODATA)

--  {

--

--      BEGIN_SQL

--          CLOSE CH1 WITH RELEASE;

--      END_SQL;

--

--      BEGIN_SQL

--          UPDATE TMT_WBS SET REC_STATUS = 'U', REC_DATETIME = SC_NOW, LAST_CHECKIN = SC_NOW

--          WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND REC_USER = HOST_DB(p_rec_user,ind_checkin);

--      END_SQL;

--  }

--  else

--  {

--      BEGIN_SQL

--          CLOSE CH1 WITH RELEASE;

--      END_SQL;

--

--      if ( h_bitflag == 0)

--      {

--          BEGIN_SQL

--              UPDATE TMT_WBS SET

--                  REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--                  LAST_CHECKIN = SC_NOW,

--                  MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,

--                  MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END

--              WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND REC_USER = HOST_DB(p_rec_user,ind_checkin);

--          END_SQL;

--      }

--      else if ( h_bitflag == 1)

--      {

--          BEGIN_SQL

--              UPDATE TMT_WBS SET

--                  REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--                  LAST_CHECKIN = SC_NOW,

--                  MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND REC_USER = HOST_DB(p_rec_user,ind_checkin);

--          END_SQL;

--      }

--      else if ( h_bitflag == 2)

--      {

--          BEGIN_SQL

--              UPDATE TMT_WBS SET REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--              LAST_CHECKIN = SC_NOW

--              WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND REC_USER = HOST_DB(p_rec_user,ind_checkin);

--          END_SQL;

--      }

--  }

--

--  if (IsNotNullParam(h_transfer_flag))

--  {

--      BEGIN_SQL

--          UPDATE TMT_CRI

--          SET REC_STATUS = 'U'

--          WHERE ELEMENT_ID = HOST_DB(p_id, ind_checkin);

--      END_SQL;

--  }

--

--  if (h_converted_score == -1)

--  {

--      SC_STATE = FC_CHECK_IN_ALL_SC( SC_PARAM(h_table_type), SC_PARAM(h_id), SC_PARAM(h_bitflag), SC_PARAM(h_rec_user) );

--  }

--

--  SC_STATE = FC_Rollup(h_project_id);

--

--  if (SC_SUCCESS)

--  {

--      getUniqueID(h_uniqueID);

--      if (h_rtf_bits > 0)

--      {

--          BEGIN_SQL

--              INSERT INTO HISTORY_WBS_RTF

--              SELECT HOST(h_uniqueID), A.* FROM WBS_RTF A WHERE A.ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--          END_SQL;

--      }

--

--      BEGIN_SQL

--          INSERT INTO HISTORY_WBS (

--              HISTORY_ID,

--              ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,

--              BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,

--              CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,

--              DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,

--              EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,

--              EXPECTED_COST, EXPECTED_MARGIN, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH,

--              ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,

--              FD, FINISH_DT, FORECAST_BUDGET, FORECAST_CLOSED, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,

--              LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,

--              MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,

--              OPPORTUNITY_NAME,

--              PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY, PURSUIT_FINISH, PURSUIT_START,

--              RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,

--              SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,

--              TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,

--              UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,

--              VARIANCE,

--              WBS_CODE, WORK_TODATE,

--                ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,

--                ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,

--                ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,

--                R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3

--                )

--          SELECT

--              HOST(h_uniqueID),

--              ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,

--              BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,

--              CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,

--              DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,

--              EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,

--              EXPECTED_COST, EXPECTED_MARGIN, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH,

--              ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,

--              FD, FINISH_DT, FORECAST_BUDGET, FORECAST_CLOSED, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,

--              LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,

--              MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,

--              OPPORTUNITY_NAME,

--              PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY, PURSUIT_FINISH, PURSUIT_START,

--              RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,

--              SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,

--              TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,

--              UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,

--              VARIANCE,

--              WBS_CODE, WORK_TODATE,

--                ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,

--                ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,

--                ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,

--                R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3

--          FROM TMT_WBS

--          WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--      END_SQL;

--

--      BEGIN_SQL

--          UPDATE TMT_WBS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--      END_SQL;

--

--

--        // paria

--      InitializeHost(SC_PARAM(h_bitflag),1);

--      InitializeHost(SC_PARAM(h_table_name),"HISTORY_WBS");

--      SC_STATE = FC_D_REVISION(SC_PARAM(h_id),SC_PARAM(h_bitflag),SC_PARAM(h_table_name));

--

--      //SC_STATE = FC_D_REVISION(h_id,1,"HISTORY_WBS");

--  }

--  else

--  {

--      SC_STATE = ALREADY_CHECKED_IN;

--  }

--

--  RETURN_STATUS(SC_STATE, h_id);

--  PMO_END_FUNCTION;

--}

--/*###########################################*/

--SC_SQL_API CAN_CHECKIN_ALL

--(

--  SC_WCHAR *p_id,

--  SC_LONG_PARAM *p_bitflag,

--  SC_WCHAR *p_rec_user,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(CAN_CHECKIN_ALL);

--

--  struct ind_checkin_struct {

--      short p_id;

--      short p_bitflag;

--      short p_rec_user;

--  } *ind_checkin = (ind_checkin_struct *) nullIndicator;

--  if( IsNullSpParam(ind_checkin, p_id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  SC_CHAR(h_rank, SC_H_FULL_RANK);

--  SC_LONG_INIT(h_count, 0);

--    SC_CHAR(h_resource_id, SC_H_ID);

--  SC_LONG(h_bitflag);

--

--

--    BEGIN_SQL

--      SELECT RTRIM(RANK) INTO HOST(h_rank) FROM TMT_WBS WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--  END_SQL;

--

--  if (SC_SUCCESS)

--  {

--      BEGIN_SQL

--          SELECT COUNT(ELEMENT_ID) INTO HOST(h_count)

--          FROM TMT_WBS WHERE RANK LIKE HOST(h_rank) || '%' AND REC_STATUS = 'L';

--      END_SQL;

--      if( h_count > 0 )

--      {

--          SC_STATE = 1;

--      }

--      else

--      {

--          BEGIN_SQL

--              SELECT COUNT(ELEMENT_ID) INTO HOST(h_count)

--              FROM TMT_WBS WHERE RANK LIKE HOST(h_rank) || '%' AND REC_STATUS IN ('O', 'I');

--          END_SQL;

--

--          if( h_count > 0 )

--              SC_STATE = 2;

--          else

--              SC_STATE = 0;

--      }

--  }

--  else

--  {   // Folder

--      BEGIN_SQL

--          SELECT RTRIM(RANK) INTO HOST(h_rank) FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin);

--      END_SQL;

--

--        InitializeHost(SC_PARAM(h_resource_id), p_rec_user, ind_checkin->p_rec_user);

--        InitializeHost(SC_PARAM(h_bitflag), 3);

--      SC_STATE = FC_LOCK_UNLOCK(SC_PARAM(h_rank), SC_PARAM(h_resource_id), SC_PARAM(h_bitflag));

--

--  }

--

--  RETURN_STATUS(SC_STATE, *p_id);

--  PMO_END_FUNCTION;

--}

--

--/*###########################################*/

--SC_SQL_API SP_CHECKIN_ALL

--(

--  SC_WCHAR *p_id,

--  SC_LONG_PARAM *p_bitflag,

--  SC_WCHAR *p_rec_user,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(SP_CHECKIN_ALL);

--

--  struct ind_checkin_struct {

--      short p_id;

--      short p_bitflag;

--      short p_rec_user;

--  } *ind_checkin = (ind_checkin_struct *) nullIndicator;

--

--  // Validate id

--  if( IsNullSpParam(ind_checkin, p_id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  SC_CHAR(h_id, SC_H_ID);

--  SC_CHAR(h_project_id, SC_H_ID);

--  SC_CHAR(h_uniqueID, SC_H_ID);

--  SC_LONG(h_bitflag);

--  SC_LONG(h_min_revision);

--

--  // **************************************************************************************

--  // bitflag    = 0 MINOR_REVISION = MINOR_REVISION + 1

--  //              = 1 MAJOR_REVISION = MAJOR_REVISION + 1

--  //              = 2 check in as the same revision

--  // **************************************************************************************

--  //InitializeHost(SC_PARAM(h_bitflag), *bitflag, ind_checkin->bitflag);

--  InitializeHost(SC_PARAM(h_bitflag),*p_bitflag,ind_checkin->p_bitflag);

--

--  BEGIN_SQL

--      DECLARE C21 CURSOR WITH HOLD FOR SELECT a.PROJECT_ID, a.ELEMENT_ID FROM TMT_WBS a, TMT_WBS b

--      WHERE b.ELEMENT_ID=HOST_DB(p_id,ind_checkin) AND a.REC_STATUS = 'O' AND PMO_LOCATE(b.RANK, a.RANK);

--  END_SQL_NOCHECK;

--

--  BEGIN_SQL

--      OPEN C21;

--  END_SQL;

--

--  while(1==1)

--  {

--      BEGIN_SQL

--          FETCH C21 INTO HOST(h_project_id), HOST(h_id);

--      END_SQL;

--

--      if (SC_NOSUCCESS) break;

--

--      BEGIN_SQL

--          DECLARE CH2 CURSOR WITH HOLD FOR SELECT MINOR_REVISION FROM HISTORY_WBS WHERE ELEMENT_ID = HOST(h_id) fETCH FIRST 1 ROWS ONLY;

--      END_SQL_NOCHECK;

--

--          BEGIN_SQL

--          OPEN CH2;

--      END_SQL;

--

--          BEGIN_SQL

--          FETCH CH2 INTO HOST(h_min_revision) ;

--      END_SQL;

--

--      if (SC_NODATA)

--      {

--              BEGIN_SQL

--                  CLOSE CH2 WITH RELEASE;

--          END_SQL;

--

--          BEGIN_SQL

--              UPDATE TMT_WBS SET REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--              LAST_CHECKIN = SC_NOW

--              WHERE ELEMENT_ID = HOST(h_id) ;

--          END_SQL;

--      }

--      else

--      {

--              BEGIN_SQL

--                  CLOSE CH2 WITH RELEASE;

--          END_SQL;

--

--          if ( h_bitflag == 0)

--          {

--              BEGIN_SQL

--                  UPDATE TMT_WBS SET

--                      REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--                      LAST_CHECKIN = SC_NOW,

--                      MAJOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN MAJOR_REVISION + 1 ELSE MAJOR_REVISION END,

--                      MINOR_REVISION = CASE WHEN MINOR_REVISION = 99 THEN 0 ELSE MINOR_REVISION + 1 END

--                  WHERE ELEMENT_ID = HOST(h_id) ;

--              END_SQL;

--          }

--          else if ( h_bitflag == 1)

--          {

--              BEGIN_SQL

--                  UPDATE TMT_WBS SET

--                      REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--                      LAST_CHECKIN = SC_NOW,

--                      MAJOR_REVISION = MAJOR_REVISION + 1, MINOR_REVISION = 0 WHERE ELEMENT_ID = HOST(h_id) ;

--              END_SQL;

--          }

--          else if ( h_bitflag == 2)

--          {

--              BEGIN_SQL

--                  UPDATE TMT_WBS SET REC_STATUS = 'U', REC_DATETIME = SC_NOW,

--                  LAST_CHECKIN = SC_NOW

--                  WHERE ELEMENT_ID = HOST(h_id) ;

--              END_SQL;

--          }

--      }

--

--      SC_STATE = FC_Rollup(h_project_id);

--

--      if (SC_SUCCESS)

--      {

--          getUniqueID(h_uniqueID);

--

--          BEGIN_SQL

--              INSERT INTO HISTORY_WBS_RTF

--              SELECT HOST(h_uniqueID), A.* FROM WBS_RTF A WHERE A.ELEMENT_ID = HOST(h_id) ;

--          END_SQL;

--

--          BEGIN_SQL

--              INSERT INTO HISTORY_WBS (

--                  HISTORY_ID,

--                  ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,

--                  BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,

--                  CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,

--                  DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,

--                  EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,

--                  EXPECTED_COST, EXPECTED_MARGIN, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH,

--                  ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,

--                  FD, FINISH_DT, FORECAST_BUDGET, FORECAST_CLOSED, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,

--                  LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,

--                  MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,

--                  OPPORTUNITY_NAME,

--                  PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY, PURSUIT_FINISH, PURSUIT_START,

--                  RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,

--                  SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,

--                  TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,

--                  UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,

--                  VARIANCE,

--                  WBS_CODE, WORK_TODATE,

--                    ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,

--                    ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,

--                    ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,

--                    R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3

--                    )

--              SELECT

--                  HOST(h_uniqueID),

--                  ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,

--                  BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,

--                  CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,

--                  DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,

--                  EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,

--                  EXPECTED_COST, EXPECTED_MARGIN, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH,

--                  ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,

--                  FD, FINISH_DT, FORECAST_BUDGET, FORECAST_CLOSED, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,

--                  LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,

--                  MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,

--                  OPPORTUNITY_NAME,

--                  PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY, PURSUIT_FINISH, PURSUIT_START,

--                  RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,

--                  SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,

--                  TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,

--                  UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,

--                  VARIANCE,

--                  WBS_CODE, WORK_TODATE,

--                    ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,

--                    ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,

--                    ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,

--                    R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3

--              FROM TMT_WBS

--              WHERE ELEMENT_ID = HOST(h_id);

--          END_SQL;

--

--          BEGIN_SQL

--              UPDATE TMT_WBS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = HOST(h_id) ;

--          END_SQL;

--      }

--  } // end of while

--

--  BEGIN_SQL

--      CLOSE C21 WITH RELEASE;

--  END_SQL;

--

--  RETURN_STATUS(SC_STATE, *p_id);

--  PMO_END_FUNCTION;

--}

--/*###########################################*/

--SC_SQL_API SP_UNDO_CHECKOUT

--(

--  SC_WCHAR *p_id,

--  SC_LONG_PARAM *p_bitflag,

--  SC_WCHAR *p_rec_user,

--  SC_LONG_PARAM *nullIndicator

--)

--{

--  PMO_BEGIN_FUNCTION(SP_UNDO_CHECKOUT);

--

--  struct ind_checkin_struct {

--      short p_id;

--      short p_bitflag;

--      short p_rec_user;

--  } *ind_checkin = (ind_checkin_struct *) nullIndicator;

--

--  // Validate id

--  if( IsNullSpParam(ind_checkin, p_id)){RETURN_INVALID(ELEMENT_ID_REQUIRED);}

--

--  SC_CHAR(h_id, SC_H_ID);

--  SC_CHAR(h_rec_status, SC_H_FLAG);

--  //SC_LONG(h_bitflag);

--

--  //InitializeHost(SC_PARAM(h_id), id, ind_checkin->id);

--  InitializeHost(SC_PARAM(h_id),p_id,ind_checkin->p_id);

--  VALIDATE_RECORD(TMT_WBS, h_id, h_rec_status);

--

--  //Execute Update Statement

--  BEGIN_SQL

--      UPDATE TMT_WBS SET (REC_STATUS, REC_USER, REC_DATETIME) =

--          (SELECT REC_STATUS, REC_USER, REC_DATETIME FROM HISTORY_WBS

--          WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND REC_DATETIME =

--              (SELECT MAX(REC_DATETIME) FROM HISTORY_WBS WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin)))

--      WHERE ELEMENT_ID = HOST_DB(p_id,ind_checkin) AND REC_USER = HOST_DB(p_rec_user,ind_checkin);

--  END_SQL;

--

--  RETURN_STATUS(SC_STATE, *p_id);

--  PMO_END_FUNCTION;

--}

--*****************************************************************************************//

Prompt == FUNCTION SP_LOCK_WBS ==
CREATE OR REPLACE FUNCTION SP_LOCK_WBS
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_resource_id VARCHAR2(32);
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rank2 VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CLK1 IS
         SELECT ELEMENT_ID FROM TMT_WBS
         WHERE REC_STATUS IN ('L','O') AND RANK LIKE h_rank || '%';

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_LOCK_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_LOCK_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_LOCK_WBS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_WBS', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_LOCK_WBS(31) : wbs.sql(11184) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_LOCK_WBS', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_LOCK_WBS(37) : wbs.sql(11190) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_WBS', 39+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_LOCK_WBS(40) : wbs.sql(11193) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   h_id := p_id;
   
   BEGIN
      SELECT RANK INTO h_rank FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(55) : wbs.sql(11208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      BEGIN
         SELECT RTRIM(RANK) INTO h_rank FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = h_id AND TYPE_ID = PMO_CNST.SC_FOLDER;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 68+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(69) : wbs.sql(11222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_LOCK_WBS', 75+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_LOCK_WBS(76) : wbs.sql(11229) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_WBS', 78+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_LOCK_WBS(79) : wbs.sql(11232) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True);
      End If;
      --if exists two projects with the same name then return error message
      BEGIN
         SELECT COUNT('X') INTO h_count
         FROM DUAL
         WHERE EXISTS (SELECT W1.ELEMENT_NAME FROM TMT_PORTFOLIOS W1, TMT_PORTFOLIOS W2
         WHERE W1.RANK LIKE h_rank || '%' AND W2.RANK LIKE h_rank || '%'
         AND W1.ELEMENT_NAME = W2.ELEMENT_NAME AND W1.ELEMENT_ID <> W2.ELEMENT_ID);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(96) : wbs.sql(11249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("PORTFOLIO: h_count: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_LOCK_WBS', 104+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_LOCK_WBS(105) : wbs.sql(11258) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.TWO_PROJECTS_WITH_SAME_NAMES), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_WBS', 107+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_LOCK_WBS(108) : wbs.sql(11261) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.TWO_PROJECTS_WITH_SAME_NAMES, h_id, True);
      End If;
      --Execute Update Statement
      h_rank2 := h_rank;
      h_resource_id := p_rec_user;
      h_bitflag := 1;
      PMO_DB2M.SC_STATE := FC_LOCK_UNLOCK(h_rank2, h_resource_id, h_bitflag);
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_PORTFOLIOS SET REC_STATUS = 'L'
         WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 143+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(144) : wbs.sql(11297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --if exists two projects with the same name then return error message
      BEGIN
         SELECT COUNT('X') INTO h_count
         FROM DUAL
         WHERE EXISTS (SELECT W1.ELEMENT_NAME FROM TMT_WBS W1, TMT_WBS W2
         WHERE W1.RANK LIKE h_rank || '%' AND W2.RANK LIKE h_rank || '%'
         AND W1.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND W2.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W1.ELEMENT_NAME = W2.ELEMENT_NAME AND W1.ELEMENT_ID <> W2.ELEMENT_ID);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(163) : wbs.sql(11316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("WBS_h_count: %d\n", h_count);
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_LOCK_WBS', 171+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_LOCK_WBS(172) : wbs.sql(11325) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.TWO_PROJECTS_WITH_SAME_NAMES), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_WBS', 174+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_LOCK_WBS(175) : wbs.sql(11328) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.TWO_PROJECTS_WITH_SAME_NAMES, h_id, True);
      End If;
      
      OPEN CLK1;
      
      FETCH CLK1 INTO h_exists;
      IF CLK1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = 0 Then
         BEGIN
            CLOSE CLK1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(198) : wbs.sql(11351) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_LOCK_WBS', 203+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_LOCK_WBS(204) : wbs.sql(11357) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_exists || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_LOCK_WBS', 206+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_LOCK_WBS(207) : wbs.sql(11360) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_exists
               , True);
      End If;
      
      BEGIN
         CLOSE CLK1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(221) : wbs.sql(11374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Execute Update Statement
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_WBS SET REC_USER=p_rec_user, REC_STATUS = 'L', REC_DATETIME = SYSTIMESTAMP
            WHERE RANK LIKE h_rank || '%' AND REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 253+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(254) : wbs.sql(11407) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_LOCK_WBS', 261+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_LOCK_WBS(262) : wbs.sql(11415) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 268+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(269) : wbs.sql(11422) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_LOCK_WBS', 280+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_LOCK_WBS(281) : wbs.sql(11434) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_LOCK_WBS;
ALTER FUNCTION SP_LOCK_WBS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION SP_UNLOCK_WBS ==
CREATE OR REPLACE FUNCTION SP_UNLOCK_WBS
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_current_date TIMESTAMP;
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rank2 VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UNLOCK_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UNLOCK_WBS'), '-- ' || SYSTIMESTAMP, ':r := SP_UNLOCK_WBS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNLOCK_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UNLOCK_WBS(27) : wbs.sql(11477) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UNLOCK_WBS', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UNLOCK_WBS(33) : wbs.sql(11483) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNLOCK_WBS', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_UNLOCK_WBS(36) : wbs.sql(11486) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_id), id, ind_checkin->id);
   h_id := p_id;
   BEGIN
      SELECT PROJECT_ID, RANK, REC_DATETIME INTO h_project_id, h_rank, h_current_date
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(52) : wbs.sql(11502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      BEGIN
         SELECT REC_USER INTO h_rec_user FROM TMT_WBS WHERE ELEMENT_ID = h_id AND REC_USER =p_rec_user AND REC_STATUS = 'L';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(66) : wbs.sql(11516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If PMO_DB2M.SC_STATE = 100 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_UNLOCK_WBS', 71+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_UNLOCK_WBS(72) : wbs.sql(11522) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_IN_USE), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNLOCK_WBS', 74+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_UNLOCK_WBS(75) : wbs.sql(11525) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_IN_USE, h_id, True);
      End If;
      
      --Execute Update Statement
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_WBS SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE REC_STATUS = 'L' AND RANK LIKE h_rank || '%';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 107+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(108) : wbs.sql(11558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE PROJECT_ID = h_project_id AND LEVEL_ID > 1 AND REC_STATUS = 'L';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 125+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(126) : wbs.sql(11576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
   Else
      -- UNLOCK FOLDER/PORTFOLIO
      BEGIN
         SELECT RANK INTO h_rank FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = h_id AND TYPE_ID = PMO_CNST.SC_FOLDER;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 144+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(145) : wbs.sql(11595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --Execute Update Statement
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_rank2 := h_rank;
         h_rec_user := p_rec_user;
         h_bitflag := 2;
         PMO_DB2M.SC_STATE := FC_LOCK_UNLOCK(h_rank2, h_rec_user, h_bitflag);
         
         DECLARE 
         	nLen pls_integer :=0; 
         BEGIN 
         	If (h_rank IS NOT NULL) Then 
         		nLen := Coalesce(Length(h_rank), 0); 
         		If 0 <> 0 AND nLen <> 0 Then 
         		nLen := nLen - 1; 
         		End If; 
         	End If; 
         	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
         		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
         	End If; 
         END;
         BEGIN
            UPDATE TMT_PORTFOLIOS SET REC_STATUS = 'U' WHERE RANK LIKE h_rank || '%' AND REC_STATUS = 'L';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 181+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(182) : wbs.sql(11632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            PMO_DB2M.SC_STATE := 0;
         End If;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_UNLOCK_WBS', 193+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_UNLOCK_WBS(194) : wbs.sql(11644) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 200+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(201) : wbs.sql(11651) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNLOCK_WBS', 212+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNLOCK_WBS(213) : wbs.sql(11663) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UNLOCK_WBS;
ALTER FUNCTION SP_UNLOCK_WBS COMPILE DEBUG;

/*############################################################################################*/

--  p_bitflag:

--      0:  called from wbs description (including REVISION_IMPACT, REVISION_TYPE and REVISION_HISTORY)

--      1:  called from project bubble view (including REVISION_HISTORY only)

/*############################################################################################*/

Prompt == FUNCTION SP_U_WBS_REVISION ==
CREATE OR REPLACE FUNCTION SP_U_WBS_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
   , p_rev_impact PLS_INTEGER
   , p_rev_type PLS_INTEGER
   , p_rev_history VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_impact), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_rev_type), 'NULL')
          || ', ' || '''' || p_rev_history || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_REVISION', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_REVISION(27) : wbs.sql(11714) : ' || SYSTIMESTAMP);
   END IF; 

   -- Validate id
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_REVISION(33) : wbs.sql(11720) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_REVISION', 35+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_REVISION(36) : wbs.sql(11723) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_id), id, ind_u_rev->id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_WBS_REVISION', 43+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_WBS_REVISION(44) : wbs.sql(11731) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   If Coalesce(p_bitflag, 0) = 1 Then
      BEGIN
         UPDATE TMT_WBS
         SET REVISION_HISTORY = p_rev_history,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REVISION', 70+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REVISION(71) : wbs.sql(11758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS
         SET REVISION_IMPACT = p_rev_impact,
         REVISION_TYPE = p_rev_type,
         REVISION_HISTORY = p_rev_history,
         REC_DATETIME = SYSTIMESTAMP
         WHERE ELEMENT_ID = p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REVISION', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REVISION(93) : wbs.sql(11780) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_REVISION', 99+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_REVISION(100) : wbs.sql(11787) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REVISION', 106+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REVISION(107) : wbs.sql(11794) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_REVISION', 118+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_REVISION(119) : wbs.sql(11806) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_REVISION;
ALTER FUNCTION SP_U_WBS_REVISION COMPILE DEBUG;

/***********************************************************************************************************************************
* h_bitflag == 0    returns all revision on id (TMT_WBS)
*                           id = ELEMENT_ID in TMT_WBS table, select from WBS_HISTORY where ELEMENT_ID = id
*
* h_bitflag == 1    returns WBS_HISTORY id and all WORKFLOWS on this ID (only the first level)
*                           id = ELEMENT_ID in WBS_HISTORY table, select from WBS_HISTORY  TMT_WORKFLOWS
************************************************************************************************************************************/

Prompt == FUNCTION SP_S_WBS_REVISION ==
CREATE OR REPLACE FUNCTION SP_S_WBS_REVISION
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_revision VARCHAR2(32);
   h_app_revision PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   RetSt VARCHAR2(4000);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_WBS_REVISION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_WBS_REVISION'), '-- ' || SYSTIMESTAMP, ':r := SP_S_WBS_REVISION(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_REVISION', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_WBS_REVISION(25) : wbs.sql(11853) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_WBS_REVISION', 29+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_WBS_REVISION(30) : wbs.sql(11858) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_REVISION', 32+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_REVISION(33) : wbs.sql(11861) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- Declare host variables
   
   -- Parse parameters to local variables
   --InitializeHost(SC_PARAM(h_id), id, ind_s_revision->id);
   h_id := p_id;
   --InitializeHost(SC_PARAM(h_bitflag), *bitflag, ind_s_revision->bitflag);
   h_bitflag := p_bitflag;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_app_revision FROM TMT_SETTINGS WHERE ELEMENT_ID = 'MAX_REVISION_VERSIONS';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_REVISION', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_REVISION(54) : wbs.sql(11882) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_WBS_REVISION', 59+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_WBS_REVISION(60) : wbs.sql(11888) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_REVISION', 62+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_REVISION(63) : wbs.sql(11891) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   If Coalesce(h_bitflag, 0) = 0 Then
      RetSt := 
            'SELECT * FROM (SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, '
             || 'T.ELEMENT_NAME, '
             || 'CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS WHERE PARENT_ID=''' || h_id || ''' AND '
             || 'REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 '
             || 'ELSE 0 END AS CHILD_COUNT, T.DELETED_COUNT,  '''' AS CYCLE_NAME, '''' AS DESCRIPTION, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
             || 'T.REVISION_IMPACT, T.REVISION_HISTORY, T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT, T.TRANSFER_FLAG, '''' AS CHECKLIST, '
             || 'DT.DESCRIPTION AS STAGE_NAME , '''' AS END_STAGE_NAME, '''' AS OUTCOME_NAME '
             || 'FROM HISTORY_WBS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID = DT.ELEMENT_ID  '
             || ' WHERE T.ELEMENT_ID = ''' || h_id || ''' '
             || ' ORDER BY REC_DATETIME DESC) WHERE ROWNUM<=' || TO_CHAR(Coalesce(h_app_revision, 0));
   Else
      BEGIN
         SELECT RTRIM(TO_CHAR(MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(MINOR_REVISION)), RANK, LEVEL_ID, ELEMENT_ID
         INTO h_revision, h_rank, h_level_id, h_parent_id
         FROM HISTORY_WBS
         WHERE HISTORY_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_REVISION', 94+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_REVISION(95) : wbs.sql(11923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_WBS_REVISION', 100+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_WBS_REVISION(101) : wbs.sql(11929) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_REVISION', 103+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_REVISION(104) : wbs.sql(11932) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
      End If;
      
      RetSt := 'SELECT T.LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.HISTORY_ID AS ELEMENT_ID, '
             || 'T.ELEMENT_NAME, CASE WHEN EXISTS(SELECT * FROM TMT_WORKFLOWS '
             || 'WHERE PARENT_ID=''' || h_parent_id 
                  || ''' AND REVISION = (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' '
             || '|| RTRIM(TO_CHAR(T.MINOR_REVISION)))) THEN 1 ELSE 0 END AS CHILD_COUNT, '
             || 'T.DELETED_COUNT, '''' AS CYCLE_NAME, '''' AS DESCRIPTION, '
             || '(RTRIM(TO_CHAR(T.MAJOR_REVISION)) || ''.'' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '
             || 'T.REVISION_IMPACT, TO_CLOB(T.REVISION_HISTORY), T.REVISION_TYPE, '
             || 'T.REC_DATETIME, B.FULL_NAME AS AUTHOR, '''' AS SUBJECT, T.TRANSFER_FLAG, '''' AS CHECKLIST, '
             || 'DT.DESCRIPTION AS STAGE_NAME, '''' AS END_STAGE_NAME, '''' AS OUTCOME_NAME    '
             || 'FROM HISTORY_WBS T JOIN RESOURCES B ON T.REC_USER=B.RESOURCE_ID '
             || 'LEFT JOIN TMT_DATAFIELDS DT ON T.STAGE_ID = DT.ELEMENT_ID  '
             || 'WHERE HISTORY_ID = ''' || h_id || ''' UNION ALL '
             || 'SELECT (' || TO_CHAR(Coalesce(h_level_id, 0)) || ' + 1) AS LEVEL_ID, A.TYPE_ID, (''' || h_rank 
                  || ''' || A.RANK) AS RANK, '
             || '(CASE WHEN A.LEVEL_ID = 1 THEN ''' || h_id || ''' ELSE A.PARENT_ID END) AS PARENT_ID, '
             || 'A.ELEMENT_ID, C.ELEMENT_NAME, 0 AS CHILD_COUNT, '
             || 'A.DELETED_COUNT, A.ELEMENT_NAME AS CYCLE_NAME, A.SUBJECT AS DESCRIPTION, '''' AS REVISION, '
             || '0 AS REVISION_IMPACT, A.DESCRIPTION AS REVISION_HISTORY, 0 AS REVISION_TYPE, A.CREATED_DATE AS REC_DATETIME, '
             || 'R.FULL_NAME AS AUTHOR, A.SUBJECT AS SUBJECT, '''' AS TRANSFER_FLAG, C.CHECKLIST, '
             || 'DT.DESCRIPTION AS STAGE_NAME, DT1.DESCRIPTION AS END_STAGE_NAME, A.OUTCOME_NAME  '
             || 'FROM (TMT_WORKFLOWS A LEFT JOIN TMT_WORKFLOW_CYCLES C ON C.ELEMENT_ID=A.WKF_DEF_ID) '
             || 'LEFT JOIN RESOURCES R ON A.AUTHOR_ID=R.RESOURCE_ID '
             || 'LEFT JOIN TMT_DATAFIELDS DT ON A.STAGE_ID = DT.ELEMENT_ID '
             || 'LEFT JOIN TMT_DATAFIELDS DT1 ON A.STAGE_ID = DT1.ELEMENT_ID, TMT_WORKFLOWS B  '
             || 'WHERE B.PARENT_ID = ''' || h_parent_id || ''' AND B.REVISION = ''' || h_revision || ''' AND '
             || ' ( B.RANK>=SUBSTR(A.RANK,1,8) AND B.RANK<=A.RANK AND '
             || ' substr(A.RANK, 1, case when length(B.RANK) > length(A.RANK) then 1 else length(B.RANK) end) = B.RANK ) '
             || 'ORDER BY RANK';
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_REVISION', 140+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_REVISION(141) : wbs.sql(11969) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_WBS_REVISION', 143+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_WBS_REVISION(144) : wbs.sql(11972) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(RetSt);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_REVISION', 151+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_REVISION(152) : wbs.sql(11980) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_WBS_REVISION', 163+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_WBS_REVISION(164) : wbs.sql(11992) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_WBS_REVISION;
ALTER FUNCTION SP_S_WBS_REVISION COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CLEAR_BASELINE ==
CREATE OR REPLACE FUNCTION SP_CLEAR_BASELINE
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_bitflag PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_tsk_assignment_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_rec_user VARCHAR2(32);
   h_cur_id VARCHAR2(32);
   h_baseline3_start TIMESTAMP;
   h_baseline3_finish TIMESTAMP;
   h_baseline3_duration PLS_INTEGER := 0;
   h_baseline3_effort NUMBER := 0;
   h_baseline3_budget NUMBER := 0;
   h_r_baseline3_budget NUMBER := 0;
   h_s_baseline3_budget NUMBER := 0;
   h_baseline3_sch_dt TIMESTAMP;
   h_baseline2_start TIMESTAMP;
   h_baseline2_finish TIMESTAMP;
   h_baseline2_duration PLS_INTEGER := 0;
   h_baseline2_effort NUMBER := 0;
   h_baseline2_budget NUMBER := 0;
   h_r_baseline2_budget NUMBER := 0;
   h_s_baseline2_budget NUMBER := 0;
   h_baseline2_sch_dt TIMESTAMP;
   h_baseline1_start TIMESTAMP;
   h_baseline1_finish TIMESTAMP;
   h_baseline1_duration PLS_INTEGER := 0;
   h_baseline1_effort NUMBER := 0;
   h_baseline1_budget NUMBER := 0;
   h_r_baseline1_budget NUMBER := 0;
   h_s_baseline1_budget NUMBER := 0;
   h_baseline1_sch_dt TIMESTAMP;
   h_baseline1_variance PLS_INTEGER := 0;
   h_bac NUMBER := 0;
   h_eac NUMBER := 0;
   h_eac_forecast NUMBER := 0;
   h_change_flag PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CLEAR_IN_CRI_22 IS
         SELECT  ELEMENT_ID,
         BASELINE3_START, BASELINE3_FINISH, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_BUDGET, R_BASELINE3_BUDGET, S_BASELINE3_BUDGET, BASELINE3_SCH_DT,
         BASELINE2_START, BASELINE2_FINISH, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_BUDGET, R_BASELINE2_BUDGET, S_BASELINE2_BUDGET, BASELINE2_SCH_DT,
         BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_BUDGET, R_BASELINE1_BUDGET, S_BASELINE1_BUDGET, BASELINE1_SCH_DT,
         BASELINE1_VARIANCE, BAC, EAC, EAC_FORECAST
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%'
         AND (TRANSFER_FLAG IS NOT NuLL OR A_CRI_COUNT > 0);

      CURSOR CLEAR_IN_CRI_23 IS
         SELECT  ELEMENT_ID,
         BASELINE3_START, BASELINE3_FINISH, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_BUDGET, R_BASELINE3_BUDGET, S_BASELINE3_BUDGET, BASELINE3_SCH_DT,
         BASELINE2_START, BASELINE2_FINISH, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_BUDGET, R_BASELINE2_BUDGET, S_BASELINE2_BUDGET, BASELINE2_SCH_DT,
         BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_BUDGET, R_BASELINE1_BUDGET, S_BASELINE1_BUDGET, BASELINE1_SCH_DT,
         BASELINE1_VARIANCE, BAC, EAC, EAC_FORECAST
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%'
         AND (TRANSFER_FLAG IS NOT NuLL OR A_CRI_COUNT > 0);

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CLEAR_BASELINE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CLEAR_BASELINE'), '-- ' || SYSTIMESTAMP, ':r := SP_CLEAR_BASELINE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CLEAR_BASELINE', 75+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CLEAR_BASELINE(76) : wbs.sql(12084) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- for copy wbs to cri
   
   -- Parse parameters to local variables
   h_id := p_id;
   h_bitflag := p_bitflag;
   --trace_printf("*** h_bitflag: %d\n",h_bitflag);
   
   BEGIN
      SELECT RANK, PROJECT_ID, TYPE_ID, REC_STATUS
      INTO h_rank, h_project_id, h_type, h_rec_status
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(98) : wbs.sql(12106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d,h_project_id: %s, h_type: %d, h_rank: %s\n", SC_STATE,h_project_id,h_type,h_rank);
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CLEAR_BASELINE', 105+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CLEAR_BASELINE(106) : wbs.sql(12114) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CLEAR_BASELINE', 108+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_CLEAR_BASELINE(109) : wbs.sql(12117) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id, True);
   End If;
   
   If isProjectType(Coalesce(h_type, 0)) <> 0 Then
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
      
      BEGIN
         UPDATE TMT_WBS SET BASELINE_FLAG = 4 WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 129+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(130) : wbs.sql(12138) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_bitflag, 0) = 21 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS
         SET ESTIMATED_BASELINE3_START    = NULL,
         ESTIMATED_BASELINE3_FINISH   = NULL,
         ESTIMATED_BASELINE3_BUDGET   = 0.00,
         R_ESTIMATED_BASELINE3_BUDGET = 0.00,
         S_ESTIMATED_BASELINE3_BUDGET = 0.00,
         ESTIMATED_HOURS_BASELINE3    = 0.00,
         R_ESTIMATED_HOURS_BASELINE3  = 0.00,
         BASELINE3_EST_DT             = NULL,
         ESTIMATED_BASELINE2_START    = NULL,
         ESTIMATED_BASELINE2_FINISH   = NULL,
         ESTIMATED_BASELINE2_BUDGET   = 0.00,
         R_ESTIMATED_BASELINE2_BUDGET = 0.00,
         S_ESTIMATED_BASELINE2_BUDGET = 0.00,
         ESTIMATED_HOURS_BASELINE2    = 0.00,
         R_ESTIMATED_HOURS_BASELINE2  = 0.00,
         BASELINE2_EST_DT             = NULL,
         ESTIMATED_BASELINE1_START    = NULL,
         ESTIMATED_BASELINE1_FINISH   = NULL,
         ESTIMATED_BASELINE1_BUDGET   = 0.00,
         R_ESTIMATED_BASELINE1_BUDGET = 0.00,
         S_ESTIMATED_BASELINE1_BUDGET = 0.00,
         ESTIMATED_HOURS_BASELINE1    = 0.00,
         R_ESTIMATED_HOURS_BASELINE1  = 0.00,
         BASELINE1_EST_DT             = NULL
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 187+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(188) : wbs.sql(12196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --budget changes
      BEGIN
         UPDATE BUDGETS B
         SET B.ESTIMATED_BASELINE3   = 0.00,
         B.ESTIMATED_BASELINE2   = 0.00,
         B.ESTIMATED_BASELINE1   = 0.00,
         BASELINE3_EST_FLAG = 0
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE PROJECT_ID = B.PROJECT_ID AND ELEMENT_ID = B.ELEMENT_ID AND PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(211) : wbs.sql(12219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --insert baseline1
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id AND BUDGET_TYPE IN ( PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_ESTIMATED_BASELINE2, PMO_CNST.SC_ESTIMATED_BASELINE3);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 229+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(230) : wbs.sql(12238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 22 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         BASELINE3_START     = NULL,
         BASELINE3_FINISH    = NULL,
         BASELINE3_DURATION  = 0,
         BASELINE3_EFFORT    = 0,
         BASELINE3_BUDGET    = 0.00,
         R_BASELINE3_BUDGET  = 0.00,
         S_BASELINE3_BUDGET  = 0.00,
         BASELINE3_SCH_DT    = NULL,
         BASELINE3_START_VARIANCE     = 0,
         BASELINE3_FINISH_VARIANCE    = 0,
         
         BASELINE2_START     = NULL,
         BASELINE2_FINISH    = NULL,
         BASELINE2_DURATION  = 0,
         BASELINE2_EFFORT    = 0,
         BASELINE2_BUDGET    = 0.00,
         R_BASELINE2_BUDGET  = 0.00,
         S_BASELINE2_BUDGET  = 0.00,
         BASELINE2_SCH_DT    = NULL,
         
         BASELINE1_START     = NULL,
         BASELINE1_FINISH    = NULL,
         BASELINE1_DURATION  = 0,
         BASELINE1_EFFORT    = 0,
         BASELINE1_BUDGET    = 0.00,
         R_BASELINE1_BUDGET  = 0.00,
         S_BASELINE1_BUDGET  = 0.00,
         BASELINE1_SCH_DT    = NULL,
         BASELINE1_VARIANCE = 0,
         
         BAC = 0.00, 
         BCWS = 0.00, 
         BCWP = 0.00, 
         ACWP = 0.00, 
         EAC = 0.00, 
         EV_ETC = 0.00, 
         TIME_VARIANCE = 0 
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 298+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(299) : wbs.sql(12307) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --budget changes
      BEGIN
         UPDATE BUDGETS B
         SET B.BUDGET_BASELINE3      = 0.00,
         B.BUDGET_BASELINE2      = 0.00,
         B.BUDGET_BASELINE1      = 0.00,
         BASELINE3_SCH_FLAG  = 0
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE PROJECT_ID = B.PROJECT_ID AND ELEMENT_ID = B.ELEMENT_ID AND PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 321+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(322) : wbs.sql(12330) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --project_budget_breakdown
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE2, PMO_CNST.SC_SCHED_BASELINE3)
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 343+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(344) : wbs.sql(12352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --assignment changes
      BEGIN
         UPDATE TASK_ASSIGNMENTS TA
         SET TA.BASELINE1_START          = NULL,
         TA.BASELINE1_FINISH         = NULL,
         TA.BASELINE1_DURATION       = 0,
         TA.BASELINE1_WORK           = 0,
         TA.BASELINE1_LABOR_COST     = 0.00,
         TA.BASELINE1_LABOR_REVENUE  = 0.00,
         TA.BASELINE2_START          = NULL,
         TA.BASELINE2_FINISH         = NULL,
         TA.BASELINE2_DURATION       = 0,
         TA.BASELINE2_WORK           = 0,
         TA.BASELINE2_LABOR_COST     = 0.00,
         TA.BASELINE2_LABOR_REVENUE  = 0.00,
         TA.BASELINE3_START          = NULL,
         TA.BASELINE3_FINISH         = NULL,
         TA.BASELINE3_DURATION       = 0,
         TA.BASELINE3_WORK           = 0,
         TA.BASELINE3_LABOR_COST     = 0.00,
         TA.BASELINE3_LABOR_REVENUE  = 0.00,
         TA.B_REGULAR_COST           = 0.00,
         TA.B_REGULAR_RATE           = 0.00,
         TA.B_SPECIAL_COST           = 0.00,
         TA.B_SPECIAL_RATE           = 0.00,
         TA.BASELINE3_SCH_FLAG       = 0,
         TA.BAC						= 0.00
         WHERE TA.PROJECT_ID = h_project_id AND EXISTS (SELECT T.ELEMENT_ID FROM TMT_WBS T WHERE T.ELEMENT_ID = TA.TASK_ID AND T.PROJECT_ID = h_project_id AND T.RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 386+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(387) : wbs.sql(12395) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_ASSIGNMENTS PA
         SET PA.BASELINE_START         = NULL,
         PA.BASELINE_FINISH        = NULL,
         PA.BASELINE_DURATION      = 0,
         PA.BASELINE_WORK          = 0,
         PA.BASELINE_LABOR_COST    = 0.00,
         PA.BASELINE_LABOR_REVENUE = 0.00
         WHERE PA.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 410+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(411) : wbs.sql(12419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- copy updated wbs columns to cri since this option doesn't turn on any rollup bits
      
      OPEN CLEAR_IN_CRI_22;
      
      LOOP
         FETCH CLEAR_IN_CRI_22 INTO h_cur_id,
         h_baseline3_start, h_baseline3_finish, h_baseline3_duration, h_baseline3_effort, h_baseline3_budget, h_r_baseline3_budget, h_s_baseline3_budget, h_baseline3_sch_dt,
         h_baseline2_start, h_baseline2_finish, h_baseline2_duration, h_baseline2_effort, h_baseline2_budget, h_r_baseline2_budget, h_s_baseline2_budget, h_baseline2_sch_dt,
         h_baseline1_start, h_baseline1_finish, h_baseline1_duration, h_baseline1_effort, h_baseline1_budget, h_r_baseline1_budget, h_s_baseline1_budget, h_baseline1_sch_dt,
         h_baseline1_variance, h_bac, h_eac, h_eac_forecast;
         IF CLEAR_IN_CRI_22%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_CRI
            SET BASELINE3_BUDGET = h_baseline3_budget,
            R_BASELINE3_BUDGET = h_r_baseline3_budget,
            S_BASELINE3_BUDGET = h_s_baseline3_budget,
            BASELINE3_DATETIME = h_baseline3_sch_dt,
            BASELINE2_BUDGET = h_baseline2_budget,
            R_BASELINE2_BUDGET = h_r_baseline2_budget,
            S_BASELINE2_BUDGET = h_s_baseline2_budget,
            BASELINE2_DATETIME = h_baseline2_sch_dt,
            BASELINE1_START  = h_baseline1_start,
            BASELINE1_FINISH = h_baseline1_finish,
            BASELINE1_DURATION = h_baseline1_duration,
            BASELINE1_EFFORT = h_baseline1_effort,
            BASELINE1_BUDGET = h_baseline1_budget,
            R_BASELINE1_BUDGET = h_r_baseline1_budget,
            S_BASELINE1_BUDGET = h_s_baseline1_budget,
            BASELINE1_DATETIME = h_baseline1_sch_dt,
            BASELINE1_VARIANCE = h_baseline1_variance
            WHERE PROJECT_ID = h_project_id AND WBS_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 465+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(466) : wbs.sql(12474) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CLEAR_IN_CRI_22;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 479+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(480) : wbs.sql(12488) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   -- end of if (h_bitflag==22)
   --23  = clear All to Baseline (includes budgets + dates + estimated)
   If Coalesce(h_bitflag, 0) = 23 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS
         SET ESTIMATED_BASELINE3_START    = NULL,
         ESTIMATED_BASELINE3_FINISH   = NULL,
         ESTIMATED_BASELINE3_BUDGET   = 0.00,
         R_ESTIMATED_BASELINE3_BUDGET = 0.00,
         S_ESTIMATED_BASELINE3_BUDGET = 0.00,
         ESTIMATED_HOURS_BASELINE3    = 0.00,
         R_ESTIMATED_HOURS_BASELINE3  = 0.00,
         BASELINE3_EST_DT             = NULL,
         BASELINE3_START              = NULL,
         BASELINE3_FINISH             = NULL,
         BASELINE3_DURATION           = 0,
         BASELINE3_EFFORT             = 0,
         BASELINE3_SCH_DT             = NULL,
         BASELINE3_BUDGET             = 0.00,
         BASELINE3_START_VARIANCE     = 0,
         BASELINE3_FINISH_VARIANCE    = 0,
         R_BASELINE3_BUDGET           = 0.00,
         S_BASELINE3_BUDGET           = 0.00,
         ESTIMATED_BASELINE2_START    = NULL,
         ESTIMATED_BASELINE2_FINISH   = NULL,
         ESTIMATED_BASELINE2_BUDGET   = 0.00,
         R_ESTIMATED_BASELINE2_BUDGET = 0.00,
         S_ESTIMATED_BASELINE2_BUDGET = 0.00,
         ESTIMATED_HOURS_BASELINE2    = 0.00,
         R_ESTIMATED_HOURS_BASELINE2  = 0.00,
         BASELINE2_EST_DT             = NULL,
         BASELINE2_START              = NULL,
         BASELINE2_FINISH             = NULL,
         BASELINE2_DURATION           = 0,
         BASELINE2_EFFORT             = 0,
         BASELINE2_SCH_DT             = NULL,
         BASELINE2_BUDGET             = 0.00,
         R_BASELINE2_BUDGET           = 0.00,
         S_BASELINE2_BUDGET           = 0.00,
         ESTIMATED_BASELINE1_START    = NULL,
         ESTIMATED_BASELINE1_FINISH   = NULL,
         ESTIMATED_BASELINE1_BUDGET   = 0.00,
         R_ESTIMATED_BASELINE1_BUDGET = 0.00,
         S_ESTIMATED_BASELINE1_BUDGET = 0.00,
         ESTIMATED_HOURS_BASELINE1    = 0.00,
         R_ESTIMATED_HOURS_BASELINE1  = 0.00,
         BASELINE1_EST_DT             = NULL,
         BASELINE1_START              = NULL,
         BASELINE1_FINISH             = NULL,
         BASELINE1_DURATION           = 0,
         BASELINE1_EFFORT             = 0,
         BASELINE1_SCH_DT             = NULL,
         BASELINE1_BUDGET             = 0.00,
         R_BASELINE1_BUDGET           = 0.00,
         S_BASELINE1_BUDGET           = 0.00,
         BASELINE1_VARIANCE			 = 0, 
         BAC = 0.00, 
         BCWS = 0.00, 
         BCWP = 0.00, 
         ACWP = 0.00, 
         EAC = 0.00, 
         EV_ETC = 0.00, 
         TIME_VARIANCE = 0 
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 572+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(573) : wbs.sql(12581) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --budget changes
      BEGIN
         UPDATE BUDGETS B
         SET B.ESTIMATED_BASELINE3   = 0.00,
         B.ESTIMATED_BASELINE2   = 0.00,
         B.ESTIMATED_BASELINE1   = 0.00,
         B.BUDGET_BASELINE3      = 0.00,
         B.BUDGET_BASELINE2      = 0.00,
         B.BUDGET_BASELINE1      = 0.00,
         BASELINE3_SCH_FLAG  = 0,
         BASELINE3_EST_FLAG  = 0
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
         WHERE PROJECT_ID = B.PROJECT_ID
         AND ELEMENT_ID = B.ELEMENT_ID
         AND PROJECT_ID = h_project_id
         AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 604+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(605) : wbs.sql(12613) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If isProjectType(Coalesce(h_type, 0)) <> 0 Then
         --project assignment table
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS
            SET ESTIMATED_BASELINE3_START   = NULL ,
            ESTIMATED_BASELINE1_START   = NULL ,
            ESTIMATED_BASELINE3_FINISH  = NULL ,
            ESTIMATED_BASELINE1_FINISH  = NULL ,
            ESTIMATED_BASELINE3_EFFORT  = 0 ,
            ESTIMATED_BASELINE1_EFFORT  = 0 ,
            ESTIMATED_BASELINE3_COST    = 0.00 ,
            ESTIMATED_BASELINE1_COST    = 0.00 ,
            ESTIMATED_BASELINE3_REVENUE = 0.00 ,
            ESTIMATED_BASELINE1_REVENUE = 0.00 ,
            BASELINE_START              = NULL,
            BASELINE_FINISH             = NULL,
            BASELINE_DURATION           = 0,
            BASELINE_WORK               = 0,
            BASELINE_LABOR_COST         = 0.00,
            BASELINE_LABOR_REVENUE      = 0.00
            WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 640+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(641) : wbs.sql(12649) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM PROJECT_BUDGET_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1, PMO_CNST.SC_ESTIMATED_BASELINE2, PMO_CNST.SC_SCHED_BASELINE2, PMO_CNST.SC_ESTIMATED_BASELINE3, PMO_CNST.SC_SCHED_BASELINE3)
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 662+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(663) : wbs.sql(12671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --assignment changes
      BEGIN
         UPDATE TASK_ASSIGNMENTS TA
         SET TA.BASELINE3_START          = NULL,
         TA.BASELINE3_FINISH         = NULL,
         TA.BASELINE3_DURATION       = 0,
         TA.BASELINE3_WORK           = 0,
         TA.BASELINE3_LABOR_COST     = 0.00,
         TA.BASELINE3_LABOR_REVENUE  = 0.00,
         TA.BASELINE2_START          = NULL,
         TA.BASELINE2_FINISH         = NULL,
         TA.BASELINE2_DURATION       = 0,
         TA.BASELINE2_WORK           = 0,
         TA.BASELINE2_LABOR_COST     = 0.00,
         TA.BASELINE2_LABOR_REVENUE  = 0.00,
         TA.BASELINE1_START          = NULL,
         TA.BASELINE1_FINISH         = NULL,
         TA.BASELINE1_DURATION       = 0,
         TA.BASELINE1_WORK           = 0,
         TA.BASELINE1_LABOR_COST     = 0.00,
         TA.BASELINE1_LABOR_REVENUE  = 0.00,
         TA.B_REGULAR_COST           = 0.00,
         TA.B_REGULAR_RATE           = 0.00,
         TA.B_SPECIAL_COST           = 0.00,
         TA.B_SPECIAL_RATE           = 0.00,
         BASELINE3_SCH_FLAG      = 0
         WHERE TA.PROJECT_ID = h_project_id
         AND EXISTS (SELECT T.ELEMENT_ID FROM TMT_WBS T WHERE T.ELEMENT_ID = TA.TASK_ID AND T.PROJECT_ID = h_project_id AND T.RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 705+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(706) : wbs.sql(12714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- copy updated wbs columns to cri since this option doesn't turn on any rollup bits
      
      OPEN CLEAR_IN_CRI_23;
      
      LOOP
         FETCH CLEAR_IN_CRI_23 INTO h_cur_id,
         h_baseline3_start, h_baseline3_finish, h_baseline3_duration, h_baseline3_effort, h_baseline3_budget, h_r_baseline3_budget, h_s_baseline3_budget, h_baseline3_sch_dt,
         h_baseline2_start, h_baseline2_finish, h_baseline2_duration, h_baseline2_effort, h_baseline2_budget, h_r_baseline2_budget, h_s_baseline2_budget, h_baseline2_sch_dt,
         h_baseline1_start, h_baseline1_finish, h_baseline1_duration, h_baseline1_effort, h_baseline1_budget, h_r_baseline1_budget, h_s_baseline1_budget, h_baseline1_sch_dt,
         h_baseline1_variance, h_bac, h_eac, h_eac_forecast;
         IF CLEAR_IN_CRI_23%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_CRI
            SET BASELINE3_BUDGET = h_baseline3_budget,
            R_BASELINE3_BUDGET = h_r_baseline3_budget,
            S_BASELINE3_BUDGET = h_s_baseline3_budget,
            BASELINE3_DATETIME = h_baseline3_sch_dt,
            BASELINE2_BUDGET = h_baseline2_budget,
            R_BASELINE2_BUDGET = h_r_baseline2_budget,
            S_BASELINE2_BUDGET = h_s_baseline2_budget,
            BASELINE2_DATETIME = h_baseline2_sch_dt,
            BASELINE1_START  = h_baseline1_start,
            BASELINE1_FINISH = h_baseline1_finish,
            BASELINE1_DURATION = h_baseline1_duration,
            BASELINE1_EFFORT = h_baseline1_effort,
            BASELINE1_BUDGET = h_baseline1_budget,
            R_BASELINE1_BUDGET = h_r_baseline1_budget,
            S_BASELINE1_BUDGET = h_s_baseline1_budget,
            BASELINE1_DATETIME = h_baseline1_sch_dt,
            BASELINE1_VARIANCE = h_baseline1_variance
            WHERE PROJECT_ID = h_project_id AND WBS_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 760+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(761) : wbs.sql(12769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CLEAR_IN_CRI_23;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 774+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(775) : wbs.sql(12783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 24 Then
      PMO_DB2M.SC_STATE := FC_CLEAR_BASELINE_EX(h_project_id);
   End If;
   
   If (Coalesce(h_bitflag, 0) = 23) OR (Coalesce(h_bitflag, 0) = 22) Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE SUMMARY_TIMESHEETS ST
         SET ST.BASELINE_EFFORT_WEEK = 0,
         ST.BASELINE_WORK_TODATE = 0,
         ST.BASELINE_REGULAR_COST = 0,
         ST.EAC = ST.ACWP,
         ST.EV_ETC = CASE WHEN ST.BAC > ST.ACWP THEN ST.BAC - ST.ACWP ELSE 0 END, 
         ST.BAC = 0.00,
         ST.BCWS = 0.00,
         ST.BCWP = 0.00,
         ST.REC_DATETIME = SYSTIMESTAMP
         WHERE ST.PROJECT_ID = h_project_id
         AND ST.TSK_ASSIGNMENT_ID IN (
         SELECT TA.TSK_ASSIGNMENT_ID
         FROM TMT_WBS W
         JOIN TASK_ASSIGNMENTS TA
         ON TA.PROJECT_ID = W.PROJECT_ID
         AND TA.TASK_ID = W.ELEMENT_ID
         WHERE W.PROJECT_ID = h_project_id
         AND W.RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 826+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(827) : wbs.sql(12835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ENABLE_EV_CALCULATION
         INTO h_change_flag
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 842+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(843) : wbs.sql(12851) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_change_flag, 0) = 1 Then
         h_temp_rec_user := '';
         PMO_DB2M.SC_STATE := FC_GENERATE_TS_NEW(h_project_id, h_rank, h_temp_rec_user);
      End If;
      
      h_change_flag := 0;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CLEAR_BASELINE', 860+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CLEAR_BASELINE(861) : wbs.sql(12869) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 867+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(868) : wbs.sql(12876) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLEAR_BASELINE', 879+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLEAR_BASELINE(880) : wbs.sql(12888) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CLEAR_BASELINE;
ALTER FUNCTION SP_CLEAR_BASELINE COMPILE DEBUG;

/****************************************************************************************
 bitflag:
        1 = Copy Planned  Schedule to Baseline (includes budgets)
        2 = Copy Planned to Schedule
        3 = Copy Proposed to Schedule
        4 = Copy Forecast to Schedule (includes budgets)
        5 = Copy Forecast  Scheduled to Planned

 bussiness rules:
    1. Do not copy date for completed tasks (MILESTONE_PERCENT = 100)
    2. If the task has ACTUAL do not change ETC, WORK_TODATE, SD, FD
    3. When copy Forecast Date to ..., ETC is Forecast Effort, and clear Forcast dates after copy
    4. If both Forcast dates exists ignor forcast start, consider only forcast finish and ETC
    5. Calculated Forecast Start should not be in the past (is >= NOW)
    6. When copy Forcast to and assignments exists forcast rollup wins, and clear Forcast dates after copy
    7. Actual Finish date does not rollup from Assignments to Task
    8. When copy Planned to Schedule clear Planned Dates, Duration  Effort
***************************************************************************************/

Prompt == FUNCTION FC_COMMIT ==
CREATE OR REPLACE FUNCTION FC_COMMIT
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   stmt VARCHAR2(4000);
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_bitID1 RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_F TIMESTAMP;
   h_S TIMESTAMP;
   h_SC DATE;
   h_baseline1_finish TIMESTAMP;
   h_baseline1_sch_dt TIMESTAMP;
   h_baseline1_start TIMESTAMP;
   h_baseline2_finish TIMESTAMP;
   h_baseline2_sch_dt TIMESTAMP;
   h_baseline2_start TIMESTAMP;
   h_baseline3_finish TIMESTAMP;
   h_baseline3_sch_dt TIMESTAMP;
   h_baseline3_start TIMESTAMP;
   h_cur_id VARCHAR2(32);
   h_day_ofyear DATE;
   h_end_time VARCHAR2(8);
   h_finish_date TIMESTAMP;
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_res_id VARCHAR2(32);
   h_start_date TIMESTAMP;
   h_start_time VARCHAR2(8);
   h_ta_id VARCHAR2(32);
   h_temp_rec_user VARCHAR2(32);
   h_tsk_assignment_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_bac NUMBER := 0;
   h_baseline1_budget NUMBER := 0;
   h_baseline1_effort NUMBER := 0;
   h_baseline2_budget NUMBER := 0;
   h_baseline2_effort NUMBER := 0;
   h_baseline3_budget NUMBER := 0;
   h_baseline3_effort NUMBER := 0;
   h_eac NUMBER := 0;
   h_eac_forecast NUMBER := 0;
   h_r_baseline1_budget NUMBER := 0;
   h_r_baseline2_budget NUMBER := 0;
   h_r_baseline3_budget NUMBER := 0;
   h_s_baseline1_budget NUMBER := 0;
   h_s_baseline2_budget NUMBER := 0;
   h_s_baseline3_budget NUMBER := 0;
   h_available PLS_INTEGER := 0;
   h_baseline1_duration PLS_INTEGER := 0;
   h_baseline1_variance PLS_INTEGER := 0;
   h_baseline2_duration PLS_INTEGER := 0;
   h_baseline3_duration PLS_INTEGER := 0;
   h_best PLS_INTEGER := 0;
   h_change_flag PLS_INTEGER := 0;
   h_effort PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_baseline_flag PLS_INTEGER := 0;
   h_day_min PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_pa_timephase VARCHAR2(1);
   commitProject PLS_INTEGER NOT NULL := 0;
   i_save_to_project PLS_INTEGER NOT NULL := 0;
-- Declare Cursors
      CURSOR C27 IS
         SELECT TA.TSK_ASSIGNMENT_ID, TA.RESOURCE_ID
         FROM TASK_ASSIGNMENTS TA
         JOIN TMT_WBS W ON W.PROJECT_ID = TA.PROJECT_ID
         AND W.ELEMENT_ID = TA.TASK_ID
         AND TA.BIT_FLAG = '0'
         AND TA.RESOURCE_TYPE = '0'
         AND TA.PROJECT_ASSIGNMENT_ID IS Null
         WHERE W.PROJECT_ID = h_project_id
         AND W.RANK LIKE h_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);

      CURSOR C27a IS
         SELECT PROJECT_ID, TSK_ASSIGNMENT_ID, RESOURCE_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_uniqueID;

      CURSOR C32 IS
         SELECT RESOURCE_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND RANK like h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
         AND RESOURCE_TYPE = '0'
         AND BIT_FLAG = '2'
         AND PROPOSED_WORK > 0)
         AND BIT_FLAG = '2';

      CURSOR C33 IS
         SELECT RESOURCE_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND RANK like h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) )
         AND RESOURCE_TYPE = '0'
         AND BIT_FLAG = '2'
         AND ETC > 0)
         AND BIT_FLAG = '2';

      CURSOR EST_27aaa IS
         SELECT ELEMENT_ID, TYPE_ID    --, BASELINE3_EST_DT
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND RANK LIKE h_rank || '%';

      CURSOR EST_27aa IS
         SELECT ELEMENT_ID, TYPE_ID  --, BASELINE3_SCH_DT
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';

      CURSOR COPY_TO_CRI_27a IS
         SELECT ELEMENT_ID,
         BASELINE3_START, BASELINE3_FINISH, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_BUDGET, R_BASELINE3_BUDGET, S_BASELINE3_BUDGET, BASELINE3_SCH_DT,
         BASELINE2_START, BASELINE2_FINISH, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_BUDGET, R_BASELINE2_BUDGET, S_BASELINE2_BUDGET, BASELINE2_SCH_DT,
         BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_BUDGET, R_BASELINE1_BUDGET, S_BASELINE1_BUDGET, BASELINE1_SCH_DT,
         BASELINE1_VARIANCE, BAC, EAC, EAC_FORECAST
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%'
         AND (TRANSFER_FLAG IS NOT NuLL OR A_CRI_COUNT > 0) AND PROJECT_ID <> ELEMENT_ID;

      CURSOR EST_27a IS
         SELECT ELEMENT_ID, TYPE_ID FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';

      CURSOR COPY_TO_CRI_27 IS
         SELECT ELEMENT_ID,
         BASELINE3_START, BASELINE3_FINISH, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_BUDGET, R_BASELINE3_BUDGET, S_BASELINE3_BUDGET, BASELINE3_SCH_DT,
         BASELINE2_START, BASELINE2_FINISH, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_BUDGET, R_BASELINE2_BUDGET, S_BASELINE2_BUDGET, BASELINE2_SCH_DT,
         BASELINE1_START, BASELINE1_FINISH, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_BUDGET, R_BASELINE1_BUDGET, S_BASELINE1_BUDGET, BASELINE1_SCH_DT,
         BASELINE1_VARIANCE, BAC, EAC, EAC_FORECAST
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND RANK LIKE h_rank || '%'
         AND (TRANSFER_FLAG IS NOT NuLL OR A_CRI_COUNT > 0);

      CURSOR C29 IS
         SELECT
         TSK_ASSIGNMENT_ID,
         RESOURCE_ID,
         CASE WHEN TA.FORECAST_FINISH IS NOT Null THEN 1 ELSE 0 END,
         COALESCE(TA.FORECAST_START, TA.SCHED_START),
         COALESCE(TA.FORECAST_FINISH, TA.SCHED_FINISH),
         TA.ETC
         FROM TASK_ASSIGNMENTS TA
         WHERE --TA.MILESTONE_PERCENT < 10000 AND
         TA.PROJECT_ID = h_project_id AND TA.RESOURCE_TYPE = '0'
         AND (TA.FORECAST_START IS NOT Null OR TA.FORECAST_FINISH IS NOT Null OR TA.SCHED_WORK<>TA.ETC)
         AND EXISTS (
         SELECT T.ELEMENT_ID
         FROM TMT_WBS T
         WHERE --T.MILESTONE_PERCENT < 10000 AND
         T.PROJECT_ID = h_project_id AND T.ELEMENT_ID = TA.TASK_ID
         AND T.RANK LIKE h_rank || '%');

      -- Dynamic Cursor Declaration
      C10 PMO_DB2M.REF_CURSOR;

      CURSOR C30 IS
         SELECT TSK_ASSIGNMENT_ID, RESOURCE_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND RANK like h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK))
         AND RESOURCE_TYPE = '0'
         AND BIT_FLAG = '1')
         AND BIT_FLAG = '1';

      CURSOR C31 IS
         SELECT TSK_ASSIGNMENT_ID, RESOURCE_ID, DAY_YEAR, SCHED_MIN, BIT_SCHED
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id
         AND RANK like h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK))
         AND RESOURCE_TYPE = '0'
         AND BIT_FLAG = '3')
         AND BIT_FLAG = '3';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COMMIT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COMMIT'), '-- ' || SYSTIMESTAMP, ':r := FC_COMMIT(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT', 229+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COMMIT(230) : wbs.sql(13151) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, PROJECT_ID, TYPE_ID, REC_STATUS, BASELINE_FLAG, BASELINE3_SCH_DT
      INTO h_rank, h_project_id, h_type, h_rec_status, h_baseline_flag, h_baseline3_sch_dt
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 245+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(246) : wbs.sql(13167) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If isProjectType(Coalesce(h_type, 0)) <> 0 Then
      commitProject := 1;
      
      If (h_baseline3_sch_dt IS NULL) Then
         h_baseline_flag := 0;
      Else
         h_baseline_flag := 1;
      End If;
   End If;
   
   If SubStr(h_rec_status, 1, 1) = 'L' Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT', 262+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_COMMIT(263) : wbs.sql(13184) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD;
   End If;
   
   If commitProject = 1 Then
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
      
      BEGIN
         DELETE FROM TIMEPHASED_PROJECT
         WHERE PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(285) : wbs.sql(13206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
         PMO_DB2M.SC_STATE := 0;
      End If;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         SELECT COUNT('X')
         INTO h_count
         FROM DUAL
         WHERE EXISTS (
         SELECT 'X'
         FROM TASK_ASSIGNMENTS TA
         JOIN TMT_WBS W ON W.PROJECT_ID = TA.PROJECT_ID
         AND W.ELEMENT_ID = TA.TASK_ID
         AND TA.BIT_FLAG = '0'
         AND TA.PROJECT_ASSIGNMENT_ID IS NOT Null
         AND TA.PROJECT_ASSIGNMENT_ID <> TA.TSK_ASSIGNMENT_ID
         WHERE W.PROJECT_ID = h_project_id
         AND W.RANK LIKE h_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 314+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(315) : wbs.sql(13236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT', 321+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_COMMIT(322) : wbs.sql(13243) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_COMMIT_PA_PROFILE_EXIST;
      End If;
   ElsIf Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_30 Then
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_NOT_30));
   End If;
   
   If Coalesce(h_bitflag, 0) >= PMO_CNST.SC_BIT_29 Then
      If Coalesce(h_baseline_flag, 0) = 4 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT', 332+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_COMMIT(333) : wbs.sql(13254) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.CANNOT_APPLAY_BASELINE_DELTA;
      End If;
      
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
      
      h_bitflag := (BITAND(Coalesce(h_bitflag, 0), PMO_CNST.SC_BIT_NOT_29));
      i_save_to_project := 1;
   End If;
   
   --UPDATING CALENDAR_DAY_OF_YEAR  TASK_DAY_OF_YEAR
   If Coalesce(h_bitflag, 0) = 2 Then
      OPEN C27;
      
      LOOP
         FETCH C27 INTO h_uniqueID, h_id;
         IF C27%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("SC_STATE: %d, h_uniqueID: %d %s\n", SC_STATE,h_uniqueID_Ind,h_uniqueID);
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TASK_ASSIGNMENTS
            SET BIT_FLAG = '2',
            SCHED_START = COALESCE(PLANNED_START, SCHED_START),
            SCHED_FINISH = COALESCE(PLANNED_FINISH, SCHED_FINISH),
            SCHED_DURATION = CASE WHEN PLANNED_DURATION > 0 THEN PLANNED_DURATION ELSE SCHED_DURATION END,
            SCHED_WORK = PLANNED_WORK,
            ETC = PLANNED_WORK,
            BAK_START_DT = COALESCE(PLANNED_START, SCHED_START),
            BAK_FINISH_DT = COALESCE(PLANNED_FINISH, SCHED_FINISH),
            BAK_WORK = PLANNED_WORK,
            SCHED_LABOR_COST = CASE WHEN PLANNED_LABOR_COST > 0.00 THEN PLANNED_LABOR_COST ELSE SCHED_LABOR_COST END,
            SCHED_LABOR_REVENUE = CASE WHEN PLANNED_LABOR_REVENUE > 0.00 THEN PLANNED_LABOR_REVENUE ELSE SCHED_LABOR_REVENUE END,
            FORECAST_LABOR_COST = CASE WHEN PLANNED_LABOR_COST > 0.00 THEN PLANNED_LABOR_COST ELSE SCHED_LABOR_COST END,
            FORECAST_LABOR_REVENUE = CASE WHEN PLANNED_LABOR_REVENUE > 0.00 THEN PLANNED_LABOR_REVENUE ELSE SCHED_LABOR_REVENUE END,
            PLANNED_START = Null, PLANNED_FINISH = Null, PLANNED_DURATION = 0, PLANNED_WORK = 0,
            FORECAST_START = Null, FORECAST_FINISH = Null, FORECAST_DURATION = 0
            WHERE TSK_ASSIGNMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 388+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(389) : wbs.sql(13310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("UPDATE TASK_ASSIGNMENTS SC_STATE: %d\n", SC_STATE);
         
         OPEN C27a;
         
         LOOP
            FETCH C27a INTO h_project_id, h_uniqueID, h_id, h_day_ofyear, h_day_min, h_bitID1;
            IF C27a%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            --removed the fetching of the BIT_ASSIGND column to a host variable
            
            BEGIN
               UPDATE TASK_DAY_OF_YEAR
               SET BIT_FLAG = '2'
               WHERE PROJECT_ID = h_project_id
               AND TSK_ASSIGNMENT_ID = h_uniqueID
               AND RESOURCE_ID = h_id
               AND DAY_YEAR = h_day_ofyear;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 426+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(427) : wbs.sql(13348) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --removed the if statement with update of column ASSIGNED_MIN and BIT_ASSIGNED
         END LOOP;
         
         BEGIN
            CLOSE C27a ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 441+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(442) : wbs.sql(13363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C27 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 455+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(456) : wbs.sql(13377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      -- THIS CUSOR IS DOING NOTHING, PLEASE REVIEW AND REMOVE IT
      
      -- Put back in CALENDAR_DAY_OF_YEAR the time for all resources in schedule mode.
      
      OPEN C32;
      
      LOOP
         FETCH C32 INTO h_id, h_day_ofyear, h_day_min, h_bitID;
         IF C32%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         --removed the fetching of BIT_ASSIGNED column to a host variable
         PMO_DB2M.SC_STATE := 0;
         --removed the update of ASSIGNED_MIN and BIT_ASSIGNED columns
      END LOOP;
      
      BEGIN
         CLOSE C32 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 490+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(491) : wbs.sql(13412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 4 Then
      -- THIS CUSOR IS DOING NOTHING, PLEASE REVIEW AND REMOVE IT
      
      -- Put back in CALENDAR_DAY_OF_YEAR the time for all resources in schedule mode.
      
      OPEN C33;
      
      LOOP
         FETCH C33 INTO h_id, h_day_ofyear, h_day_min, h_bitID;
         IF C33%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         --removed the fetching of the BIT_ASSIGND column to a host variable
         PMO_DB2M.SC_STATE := 0;
         --removed the update of ASSIGNED_MIN and BIT_ASSIGNED columns
      END LOOP;
      
      BEGIN
         CLOSE C33 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 525+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(526) : wbs.sql(13447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --21  = estimated to Baseline
   If Coalesce(h_bitflag, 0) = 21 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         ESTIMATED_BASELINE3_START = CASE WHEN BASELINE3_EST_DT IS NuLL THEN START_FINISH_DATE ELSE ESTIMATED_BASELINE3_START END,
         ESTIMATED_BASELINE3_FINISH = CASE WHEN BASELINE3_EST_DT IS NuLL THEN FINISH_START_DATE ELSE ESTIMATED_BASELINE3_FINISH END,
         ESTIMATED_BASELINE3_DURATION = CASE WHEN BASELINE3_EST_DT IS NuLL THEN START_FINISH_DURATION ELSE ESTIMATED_BASELINE3_DURATION END,
         ESTIMATED_BASELINE3_BUDGET = CASE WHEN BASELINE3_EST_DT IS NuLL THEN ESTIMATION_BUDGET ELSE ESTIMATED_BASELINE3_BUDGET END,
         R_ESTIMATED_BASELINE3_BUDGET = CASE WHEN BASELINE3_EST_DT IS NuLL THEN R_ESTIMATION_BUDGET ELSE R_ESTIMATED_BASELINE3_BUDGET END,
         S_ESTIMATED_BASELINE3_BUDGET = CASE WHEN BASELINE3_EST_DT IS NuLL THEN S_ESTIMATION_BUDGET ELSE S_ESTIMATED_BASELINE3_BUDGET END,
         ESTIMATED_HOURS_BASELINE3    = CASE WHEN BASELINE3_EST_DT IS NuLL THEN ESTIMATED_HOURS ELSE ESTIMATED_HOURS_BASELINE3 END,
         R_ESTIMATED_HOURS_BASELINE3  = CASE WHEN BASELINE3_EST_DT IS NuLL THEN R_ESTIMATED_HOURS ELSE R_ESTIMATED_HOURS_BASELINE3 END,
         BASELINE3_EST_DT = CASE WHEN BASELINE3_EST_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_EST_DT END,
         ESTIMATED_BASELINE2_START = ESTIMATED_BASELINE1_START,
         ESTIMATED_BASELINE2_FINISH = ESTIMATED_BASELINE1_FINISH,
         ESTIMATED_BASELINE2_DURATION = ESTIMATED_BASELINE1_DURATION,
         ESTIMATED_BASELINE2_BUDGET = ESTIMATED_BASELINE1_BUDGET,
         R_ESTIMATED_BASELINE2_BUDGET = R_ESTIMATED_BASELINE1_BUDGET,
         S_ESTIMATED_BASELINE2_BUDGET = S_ESTIMATED_BASELINE1_BUDGET,
         ESTIMATED_HOURS_BASELINE2 = ESTIMATED_HOURS_BASELINE1,
         R_ESTIMATED_HOURS_BASELINE2 = R_ESTIMATED_HOURS_BASELINE1,
         BASELINE2_EST_DT = BASELINE1_EST_DT,
         ESTIMATED_BASELINE1_START = START_FINISH_DATE,
         ESTIMATED_BASELINE1_FINISH  = FINISH_START_DATE,
         ESTIMATED_BASELINE1_DURATION = START_FINISH_DURATION,
         ESTIMATED_BASELINE1_BUDGET = ESTIMATION_BUDGET,
         R_ESTIMATED_BASELINE1_BUDGET = R_ESTIMATION_BUDGET,
         S_ESTIMATED_BASELINE1_BUDGET = S_ESTIMATION_BUDGET,
         ESTIMATED_HOURS_BASELINE1    = ESTIMATED_HOURS,
         R_ESTIMATED_HOURS_BASELINE1  = R_ESTIMATED_HOURS,
         BASELINE1_EST_DT = SYSTIMESTAMP
         WHERE RANK LIKE h_rank || '%'
         AND PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 588+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(589) : wbs.sql(13510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If commitProject = 1 Then
         -- wbs affected assignments
         /*  BEGIN_SQL
                         UPDATE TMT_WBS SET
                             // Schedule dates, work  cost/budgets
                             BASELINE3_START = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_START ELSE BASELINE3_START END,
                             BASELINE3_FINISH = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_FINISH ELSE BASELINE3_FINISH END,
                             BASELINE3_DURATION = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_DURATION ELSE BASELINE3_DURATION END,
                             BASELINE3_EFFORT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN (SCHED_EFFORT + PLANNED_EFFORT) ELSE BASELINE3_EFFORT END,
                             BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN CURRENT_BUDGET ELSE BASELINE3_BUDGET END,
                             R_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN R_CURRENT_BUDGET ELSE R_BASELINE3_BUDGET END,
                             S_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN S_CURRENT_BUDGET ELSE S_BASELINE3_BUDGET END,
                             BASELINE3_SCH_DT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SC_NOW ELSE BASELINE3_SCH_DT END,
                             // Schedule dates, work  cost/budgets
                             BASELINE2_START = BASELINE1_START,
                             BASELINE2_FINISH = BASELINE1_FINISH,
                             BASELINE2_DURATION = BASELINE1_DURATION,
                             BASELINE2_EFFORT = BASELINE1_EFFORT,
                             BASELINE2_BUDGET = BASELINE1_BUDGET,
                             R_BASELINE2_BUDGET = R_BASELINE1_BUDGET,
                             S_BASELINE2_BUDGET = S_BASELINE1_BUDGET,
                             BASELINE2_SCH_DT = BASELINE1_SCH_DT,
                             // Schedule dates, work  cost/budgets
                             BASELINE1_START = UNRESOLVED_START,
                             BASELINE1_FINISH = UNRESOLVED_FINISH,
                             BASELINE1_DURATION = UNRESOLVED_DURATION,
                             BASELINE1_EFFORT = (SCHED_EFFORT + PLANNED_EFFORT),
                             BASELINE1_BUDGET   = CURRENT_BUDGET,
                             R_BASELINE1_BUDGET = R_CURRENT_BUDGET,
                             S_BASELINE1_BUDGET = S_CURRENT_BUDGET,
                             BASELINE1_SCH_DT = SC_NOW,
                             BASELINE1_VARIANCE = 0
                         WHERE PROJECT_ID = HOST(h_project_id)
                             AND ELEMENT_ID = HOST(h_project_id);
                     END_SQL;*/
         
         --added on 04/08/2004 we commented the previous statement because here we should update only worksheets, not wbs
         --trace_printf("WBS_SCHED: SC_STATE: %d, h_project_id: %s\n", SC_STATE,h_project_id);
         
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS SET
            ESTIMATED_BASELINE3_START   = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN CASE WHEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) < COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) THEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) ELSE COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) END ELSE ESTIMATED_BASELINE3_START END,
            ESTIMATED_BASELINE3_FINISH  = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN CASE WHEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) > COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) THEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) ELSE COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) END ELSE ESTIMATED_BASELINE3_FINISH END,
            ESTIMATED_BASELINE3_EFFORT  = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN ESTIMATED_SCHED_EFFORT + ESTIMATED_PLANNED_EFFORT ELSE ESTIMATED_BASELINE3_EFFORT END,
            ESTIMATED_BASELINE3_COST    = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN ESTIMATED_SCHED_COST + ESTIMATED_PLANNED_COST ELSE ESTIMATED_BASELINE3_COST END,
            ESTIMATED_BASELINE3_REVENUE = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN ESTIMATED_SCHED_REVENUE + ESTIMATED_PLANNED_REVENUE ELSE ESTIMATED_BASELINE3_REVENUE END,
            ESTIMATED_BASELINE2_START   = ESTIMATED_BASELINE1_START,
            ESTIMATED_BASELINE2_FINISH  = ESTIMATED_BASELINE1_FINISH,
            ESTIMATED_BASELINE2_COST    = ESTIMATED_BASELINE1_COST,
            ESTIMATED_BASELINE2_REVENUE = ESTIMATED_BASELINE1_REVENUE,
            ESTIMATED_BASELINE1_START   = CASE WHEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) < COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) THEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) ELSE COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) END,
            ESTIMATED_BASELINE1_FINISH  = CASE WHEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) < COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) THEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) ELSE COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) END,
            ESTIMATED_BASELINE1_EFFORT  = ESTIMATED_SCHED_EFFORT + ESTIMATED_PLANNED_EFFORT,
            ESTIMATED_BASELINE1_COST    = ESTIMATED_SCHED_COST + ESTIMATED_PLANNED_COST,
            ESTIMATED_BASELINE1_REVENUE = ESTIMATED_SCHED_REVENUE + ESTIMATED_PLANNED_REVENUE
            WHERE PROJECT_ID = h_project_id
            AND (ESTIMATED_SCHED_EFFORT + ESTIMATED_PLANNED_EFFORT) > 0;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 660+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(661) : wbs.sql(13582) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TASK_ASSIGNMENTS TA SET
            TA.BASELINE3_START = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN TA.UNRESOLVED_START ELSE TA.BASELINE3_START END,
            TA.BASELINE3_FINISH = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN TA.UNRESOLVED_FINISH ELSE TA.BASELINE3_FINISH END,
            TA.BASELINE3_DURATION = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN COALESCE(TA.UNRESOLVED_DURATION,0) ELSE TA.BASELINE3_DURATION END,
            TA.BASELINE3_WORK = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_WORK + TA.PLANNED_WORK ) ELSE TA.BASELINE3_WORK END,
            TA.BASELINE3_LABOR_COST = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_LABOR_COST + TA.PLANNED_LABOR_COST ) ELSE TA.BASELINE3_LABOR_COST END,
            TA.BASELINE3_LABOR_REVENUE = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_LABOR_REVENUE + TA.PLANNED_LABOR_REVENUE ) ELSE TA.BASELINE3_LABOR_REVENUE END,
            
            TA.BASELINE2_START = TA.BASELINE1_START,
            TA.BASELINE2_FINISH = TA.BASELINE1_FINISH,
            TA.BASELINE2_DURATION = TA.BASELINE1_DURATION,
            TA.BASELINE2_WORK = TA.BASELINE1_WORK,
            TA.BASELINE2_LABOR_COST = TA.BASELINE1_LABOR_COST,
            TA.BASELINE2_LABOR_REVENUE = TA.BASELINE1_LABOR_REVENUE,
            
            TA.BASELINE1_START = TA.UNRESOLVED_START,
            TA.BASELINE1_FINISH = TA.UNRESOLVED_FINISH,
            TA.BASELINE1_DURATION = COALESCE(TA.UNRESOLVED_DURATION,0),
            TA.BASELINE1_WORK = ( TA.SCHED_WORK + TA.PLANNED_WORK ),
            TA.BASELINE1_LABOR_COST = ( TA.SCHED_LABOR_COST + TA.PLANNED_LABOR_COST ),
            TA.BASELINE1_LABOR_REVENUE = ( TA.SCHED_LABOR_REVENUE + TA.PLANNED_LABOR_REVENUE ),
            TA.B_REGULAR_COST = TA.REGULAR_COST, TA.B_REGULAR_RATE = TA.REGULAR_RATE, TA.B_SPECIAL_COST = TA.SPECIAL_COST, TA.B_SPECIAL_RATE = TA.SPECIAL_RATE,
            
            TA.BASELINE3_SCH_FLAG = 1
            WHERE TA.PROJECT_ID = h_project_id
            AND TA.TASK_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 702+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(703) : wbs.sql(13624) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("TA_PA: SC_STATE: %d, h_project_id: %s\n", SC_STATE,h_project_id);
      End If;
      
      OPEN EST_27aaa;
      
      LOOP
         FETCH EST_27aaa INTO h_cur_id, h_type_id;
         IF EST_27aaa%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         If NOT (isWBSTask(Coalesce(h_type_id, 0))) <> 0 Then
            --project_budget_breakdown
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_cur_id
               AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE2);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 740+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(741) : wbs.sql(13662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE PROJECT_BUDGET_BREAKDOWN SET
               BUDGET_TYPE =   CASE
               WHEN BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE1 THEN PMO_CNST.SC_ESTIMATED_BASELINE2
               ELSE BUDGET_TYPE
               END
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_cur_id
               AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 764+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(765) : wbs.sql(13686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PROJECT_BUDGET_BREAKDOWN
               (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
               BUDGET_TYPE,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
               MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT
               PROJECT_ID, PROJECT_ID, BUDGET_YEAR, CHARGECODE_ID,
               PMO_CNST.SC_ESTIMATED_BASELINE1,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
               MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_cur_id
               AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 796+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(797) : wbs.sql(13718) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PROJECT_BUDGET_BREAKDOWN
               (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
               BUDGET_TYPE,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
               MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT)
               SELECT
               PROJECT_ID, PROJECT_ID, BUDGET_YEAR, CHARGECODE_ID,
               PMO_CNST.SC_ESTIMATED_BASELINE3,
               MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
               MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
               TOTAL_AMOUNT
               FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_cur_id
               AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
               AND CHARGECODE_ID IN (
               SELECT B.CHARGECODE_ID
               FROM BUDGETS B
               WHERE B.PROJECT_ID = h_project_id
               AND B.ELEMENT_ID = h_cur_id
               AND B.BASELINE3_EST_FLAG = 0);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 833+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(834) : wbs.sql(13755) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BASELINE3 = CASE WHEN BASELINE3_EST_FLAG = 0 THEN ESTIMATED_BUDGET ELSE ESTIMATED_BASELINE3 END,
            ESTIMATED_BASELINE2 = ESTIMATED_BASELINE1,
            ESTIMATED_BASELINE1 = ESTIMATED_BUDGET,
            BASELINE3_EST_FLAG = 1
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 857+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(858) : wbs.sql(13779) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE EST_27aaa;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 871+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(872) : wbs.sql(13793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 22 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         BASELINE3_START = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_START ELSE BASELINE3_START END,
         BASELINE3_FINISH = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_FINISH ELSE BASELINE3_FINISH END,
         BASELINE3_DURATION = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_DURATION ELSE BASELINE3_DURATION END,
         BASELINE3_EFFORT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN (SCHED_EFFORT + PLANNED_EFFORT) ELSE BASELINE3_EFFORT END,
         BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN CURRENT_BUDGET ELSE BASELINE3_BUDGET END,
         R_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN R_CURRENT_BUDGET ELSE R_BASELINE3_BUDGET END,
         S_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN S_CURRENT_BUDGET ELSE S_BASELINE3_BUDGET END,
         BASELINE3_SCH_DT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
         BASELINE2_START = BASELINE1_START,
         BASELINE2_FINISH = BASELINE1_FINISH,
         BASELINE2_DURATION = BASELINE1_DURATION,
         BASELINE2_EFFORT = BASELINE1_EFFORT,
         BASELINE2_BUDGET = BASELINE1_BUDGET,
         R_BASELINE2_BUDGET = R_BASELINE1_BUDGET,
         S_BASELINE2_BUDGET = S_BASELINE1_BUDGET,
         BASELINE2_SCH_DT = BASELINE1_SCH_DT,
         BASELINE1_START = UNRESOLVED_START,
         BASELINE1_FINISH = UNRESOLVED_FINISH,
         BASELINE1_DURATION = UNRESOLVED_DURATION,
         BASELINE1_EFFORT = (SCHED_EFFORT + PLANNED_EFFORT),
         BASELINE1_BUDGET   = CURRENT_BUDGET,
         R_BASELINE1_BUDGET = R_CURRENT_BUDGET,
         S_BASELINE1_BUDGET = S_CURRENT_BUDGET,
         BASELINE1_SCH_DT = SYSTIMESTAMP,
         BASELINE1_VARIANCE = 0
         WHERE RANK LIKE h_rank || '%'
         AND PROJECT_ID = h_project_id
         AND PROJECT_ID <> ELEMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 930+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(931) : wbs.sql(13852) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If commitProject = 1 Then
         BEGIN
            SELECT MIN(UNRESOLVED_START), MAX(UNRESOLVED_FINISH), MAX(UNRESOLVED_DURATION), COALESCE(SUM(SCHED_EFFORT + PLANNED_EFFORT), 0),
            COALESCE(SUM(CURRENT_BUDGET), 0), COALESCE(SUM(R_CURRENT_BUDGET),0), COALESCE(SUM(S_CURRENT_BUDGET), 0)
            INTO h_baseline3_start, h_baseline3_finish, h_baseline3_duration, h_effort,
            h_baseline3_budget, h_r_baseline3_budget, h_s_baseline3_budget
            FROM TMT_WBS
            WHERE RANK LIKE h_rank || '%' AND PROJECT_ID = h_project_id AND PARENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 949+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(950) : wbs.sql(13871) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS SET
            BASELINE3_START = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_baseline3_start ELSE BASELINE3_START END,
            BASELINE3_FINISH = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_baseline3_finish ELSE BASELINE3_FINISH END,
            BASELINE3_DURATION = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_baseline3_duration ELSE BASELINE3_DURATION END,
            BASELINE3_EFFORT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_effort ELSE BASELINE3_EFFORT END,
            BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_baseline3_budget ELSE BASELINE3_BUDGET END,
            R_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_r_baseline3_budget ELSE R_BASELINE3_BUDGET END,
            S_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN h_s_baseline3_budget ELSE S_BASELINE3_BUDGET END,
            BASELINE3_SCH_DT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
            BASELINE2_START = BASELINE1_START,
            BASELINE2_FINISH = BASELINE1_FINISH,
            BASELINE2_DURATION = BASELINE1_DURATION,
            BASELINE2_EFFORT = BASELINE1_EFFORT,
            BASELINE2_BUDGET = BASELINE1_BUDGET,
            R_BASELINE2_BUDGET = R_BASELINE1_BUDGET,
            S_BASELINE2_BUDGET = S_BASELINE1_BUDGET,
            BASELINE2_SCH_DT = BASELINE1_SCH_DT,
            BASELINE1_START = h_baseline3_start,
            BASELINE1_FINISH = h_baseline3_finish,
            BASELINE1_DURATION = h_baseline3_duration,
            BASELINE1_EFFORT = h_effort,
            BASELINE1_BUDGET   = h_baseline3_budget,
            R_BASELINE1_BUDGET = h_r_baseline3_budget,
            S_BASELINE1_BUDGET = h_s_baseline3_budget,
            BASELINE1_SCH_DT = SYSTIMESTAMP,
            BASELINE1_VARIANCE = 0
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 993+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(994) : wbs.sql(13915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS SET
            BASELINE3_DURATION = CASE WHEN BASELINE3_SCH_DT IS NuLL
            THEN PMO_ORASTD.CAL_DURATION( PROJECT_ID, BASELINE3_START, BASELINE3_FINISH ) ELSE BASELINE3_DURATION END,
            BASELINE1_DURATION = PMO_ORASTD.CAL_DURATION( PROJECT_ID, BASELINE1_START, BASELINE1_FINISH )
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1015+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1016) : wbs.sql(13937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      /*      BEGIN_SQL
                  UPDATE TMT_WBS SET
                      // Project level cost/budgets
                      BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN CURRENT_BUDGET ELSE BASELINE3_BUDGET END,
                      R_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN R_CURRENT_BUDGET ELSE R_BASELINE3_BUDGET END,
                      S_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN S_CURRENT_BUDGET ELSE S_BASELINE3_BUDGET END,
                      BASELINE3_SCH_DT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SC_NOW ELSE BASELINE3_SCH_DT END,
                      // Project level cost/budgets
                      BASELINE2_BUDGET = BASELINE1_BUDGET,
                      R_BASELINE2_BUDGET = R_BASELINE1_BUDGET,
                      S_BASELINE2_BUDGET = S_BASELINE1_BUDGET,
                      BASELINE2_SCH_DT = BASELINE1_SCH_DT,
                      // Project level cost/budgets
                      BASELINE1_BUDGET   = CURRENT_BUDGET,
                      R_BASELINE1_BUDGET = R_CURRENT_BUDGET,
                      S_BASELINE1_BUDGET = S_CURRENT_BUDGET,
                      BASELINE1_SCH_DT = SC_NOW,
                      BASELINE1_VARIANCE = 0
                  WHERE RANK LIKE HOST(h_rank) || '%'
                      AND PROJECT_ID = ELEMENT_ID AND TYPE_ID IN (SC_PROJECT_GROUP_TYPES);
                      AND RANK <> HOST(h_rank);
              END_SQL;
      */
      
      /*      if ( isProjectType(h_type) )
              {
                  //project assignment table
                  BEGIN_SQL
                      UPDATE PROJECT_ASSIGNMENTS SET
                          BASELINE_START = UNRESOLVED_START,
                          BASELINE_FINISH = UNRESOLVED_FINISH,
                          BASELINE_DURATION = COALESCE(UNRESOLVED_DURATION, 0),
                          BASELINE_WORK = ( SCHED_WORK + PLANNED_WORK ),
                          BASELINE_LABOR_COST = (SCHED_LABOR_COST+PLANNED_LABOR_COST),
                          BASELINE_LABOR_REVENUE = (SCHED_LABOR_REVENUE+PLANNED_LABOR_REVENUE)
                      WHERE PROJECT_ID = HOST(h_project_id);
                  END_SQL;
              }
      */
      
      OPEN EST_27aa;
      
      LOOP
         FETCH EST_27aa INTO h_cur_id, h_type_id;
         IF EST_27aa%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         --project_budget_breakdown
         BEGIN
            DELETE FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE IN (PMO_CNST.SC_SCHED_BASELINE2);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1091+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1092) : wbs.sql(14013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET
            BUDGET_TYPE =   CASE
            WHEN BUDGET_TYPE = PMO_CNST.SC_SCHED_BASELINE1 THEN PMO_CNST.SC_SCHED_BASELINE2
            ELSE BUDGET_TYPE
            END
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BASELINE1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1114+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1115) : wbs.sql(14036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN
            (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            SELECT
            PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            PMO_CNST.SC_SCHED_BASELINE1,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1146+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1147) : wbs.sql(14068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN
            (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            SELECT
            PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            PMO_CNST.SC_SCHED_BASELINE3,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
            AND CHARGECODE_ID IN (
            SELECT B.CHARGECODE_ID FROM BUDGETS B
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_cur_id
            AND B.BASELINE3_SCH_FLAG = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1183+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1184) : wbs.sql(14105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --budget changes
         BEGIN
            UPDATE BUDGETS SET
            BUDGET_BASELINE3 = CASE WHEN BASELINE3_SCH_FLAG = 0 THEN BUDGET ELSE BUDGET_BASELINE3 END,
            BUDGET_BASELINE2 = BUDGET_BASELINE1,
            BUDGET_BASELINE1 = BUDGET,
            BASELINE3_SCH_FLAG = 1
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1207+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1208) : wbs.sql(14129) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --assignment changes
         --            if ( (isProjectType(h_type_id)) || (isWBSTask(h_type_id)) ) // Tudor:Bug Ref# 8144
         If isWBSTask(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE TASK_ASSIGNMENTS TA SET
               TA.BASELINE3_START = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN TA.UNRESOLVED_START ELSE TA.BASELINE3_START END,
               TA.BASELINE3_FINISH = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN TA.UNRESOLVED_FINISH ELSE TA.BASELINE3_FINISH END,
               TA.BASELINE3_DURATION = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN COALESCE(TA.UNRESOLVED_DURATION,0) ELSE TA.BASELINE3_DURATION END,
               TA.BASELINE3_WORK = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_WORK + TA.PLANNED_WORK ) ELSE TA.BASELINE3_WORK END,
               TA.BASELINE3_LABOR_COST = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_LABOR_COST + TA.PLANNED_LABOR_COST ) ELSE TA.BASELINE3_LABOR_COST END,
               TA.BASELINE3_LABOR_REVENUE = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_LABOR_REVENUE + TA.PLANNED_LABOR_REVENUE ) ELSE TA.BASELINE3_LABOR_REVENUE END,
               
               TA.BASELINE2_START = TA.BASELINE1_START,
               TA.BASELINE2_FINISH = TA.BASELINE1_FINISH,
               TA.BASELINE2_DURATION = TA.BASELINE1_DURATION,
               TA.BASELINE2_WORK = TA.BASELINE1_WORK,
               TA.BASELINE2_LABOR_COST = TA.BASELINE1_LABOR_COST,
               TA.BASELINE2_LABOR_REVENUE = TA.BASELINE1_LABOR_REVENUE,
               
               TA.BASELINE1_START = TA.UNRESOLVED_START,
               TA.BASELINE1_FINISH = TA.UNRESOLVED_FINISH,
               TA.BASELINE1_DURATION = COALESCE(TA.UNRESOLVED_DURATION,0),
               TA.BASELINE1_WORK = ( TA.SCHED_WORK + TA.PLANNED_WORK ),
               TA.BASELINE1_LABOR_COST = ( TA.SCHED_LABOR_COST + TA.PLANNED_LABOR_COST ),
               TA.BASELINE1_LABOR_REVENUE = ( TA.SCHED_LABOR_REVENUE + TA.PLANNED_LABOR_REVENUE ),
               TA.B_REGULAR_COST = TA.REGULAR_COST, TA.B_REGULAR_RATE = TA.REGULAR_RATE, TA.B_SPECIAL_COST = TA.SPECIAL_COST, TA.B_SPECIAL_RATE = TA.SPECIAL_RATE,
               
               TA.BASELINE3_SCH_FLAG = 1
               WHERE TA.PROJECT_ID = h_project_id
               AND TA.TASK_ID = h_cur_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1252+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1253) : wbs.sql(14174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE EST_27aa;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1267+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1268) : wbs.sql(14189) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If commitProject = 1 Then
         BEGIN
            UPDATE BUDGETS SET
            BUDGET_BASELINE3 = CASE WHEN BASELINE3_SCH_FLAG = 0 THEN BUDGET ELSE BUDGET_BASELINE3 END,
            BUDGET_BASELINE2 = BUDGET_BASELINE1,
            BUDGET_BASELINE1 = BUDGET,
            BASELINE3_SCH_FLAG = 1
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1291+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1292) : wbs.sql(14213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS TW SET
         BAC = COALESCE((SELECT SUM(BUDGET_BASELINE1) FROM BUDGETS WHERE PROJECT_ID = TW.PROJECT_ID AND ELEMENT_ID = TW.ELEMENT_ID AND CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)), 0.00) 
         WHERE TW.PROJECT_ID = h_project_id AND TW.RANK LIKE h_rank || '%' AND PROJECT_ID <> ELEMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1324+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1325) : wbs.sql(14246) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET
         EV_ETC = CASE WHEN ACWP > BAC THEN 0.00 ELSE BAC-ACWP END, 
         EAC = CASE WHEN ACWP > BAC THEN ACWP ELSE BAC END 
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%' AND PROJECT_ID <> ELEMENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1344+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1345) : wbs.sql(14266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- copy updated wbs columns to cri since this option doesn't turn on any rollup bits
      
      OPEN COPY_TO_CRI_27a;
      
      LOOP
         FETCH COPY_TO_CRI_27a INTO h_cur_id,
         h_baseline3_start, h_baseline3_finish, h_baseline3_duration, h_baseline3_effort, h_baseline3_budget, h_r_baseline3_budget, h_s_baseline3_budget, h_baseline3_sch_dt,
         h_baseline2_start, h_baseline2_finish, h_baseline2_duration, h_baseline2_effort, h_baseline2_budget, h_r_baseline2_budget, h_s_baseline2_budget, h_baseline2_sch_dt,
         h_baseline1_start, h_baseline1_finish, h_baseline1_duration, h_baseline1_effort, h_baseline1_budget, h_r_baseline1_budget, h_s_baseline1_budget, h_baseline1_sch_dt,
         h_baseline1_variance, h_bac, h_eac, h_eac_forecast;
         IF COPY_TO_CRI_27a%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_CRI
            SET
            BASELINE3_BUDGET    = h_baseline3_budget,
            R_BASELINE3_BUDGET  = h_r_baseline3_budget,
            S_BASELINE3_BUDGET  = h_s_baseline3_budget,
            BASELINE3_DATETIME  = h_baseline3_sch_dt,
            BASELINE2_BUDGET    = h_baseline2_budget,
            R_BASELINE2_BUDGET  = h_r_baseline2_budget,
            S_BASELINE2_BUDGET  = h_s_baseline2_budget,
            BASELINE2_DATETIME  = h_baseline2_sch_dt,
            BASELINE1_START     = h_baseline1_start,
            BASELINE1_FINISH    = h_baseline1_finish,
            BASELINE1_DURATION  = h_baseline1_duration,
            BASELINE1_EFFORT    = h_baseline1_effort,
            BASELINE1_BUDGET    = h_baseline1_budget,
            R_BASELINE1_BUDGET  = h_r_baseline1_budget,
            S_BASELINE1_BUDGET  = h_s_baseline1_budget,
            BASELINE1_DATETIME  = h_baseline1_sch_dt,
            BASELINE1_VARIANCE  = h_baseline1_variance
            WHERE PROJECT_ID = h_project_id AND WBS_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1400+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1401) : wbs.sql(14322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE COPY_TO_CRI_27a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1414+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1415) : wbs.sql(14336) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 23 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         ESTIMATED_BASELINE3_START = CASE WHEN BASELINE3_EST_DT IS NuLL THEN START_FINISH_DATE ELSE ESTIMATED_BASELINE3_START END,
         ESTIMATED_BASELINE3_FINISH = CASE WHEN BASELINE3_EST_DT IS NuLL THEN FINISH_START_DATE ELSE ESTIMATED_BASELINE3_FINISH END,
         ESTIMATED_BASELINE3_DURATION = CASE WHEN BASELINE3_EST_DT IS NuLL THEN START_FINISH_DURATION ELSE ESTIMATED_BASELINE3_DURATION END,
         ESTIMATED_BASELINE3_BUDGET = CASE WHEN BASELINE3_EST_DT IS NuLL THEN ESTIMATION_BUDGET ELSE ESTIMATED_BASELINE3_BUDGET END,
         R_ESTIMATED_BASELINE3_BUDGET = CASE WHEN BASELINE3_EST_DT IS NuLL THEN R_ESTIMATION_BUDGET ELSE R_ESTIMATED_BASELINE3_BUDGET END,
         S_ESTIMATED_BASELINE3_BUDGET = CASE WHEN BASELINE3_EST_DT IS NuLL THEN S_ESTIMATION_BUDGET ELSE S_ESTIMATED_BASELINE3_BUDGET END,
         ESTIMATED_HOURS_BASELINE3    = CASE WHEN BASELINE3_EST_DT IS NuLL THEN ESTIMATED_HOURS ELSE ESTIMATED_HOURS_BASELINE3 END,
         R_ESTIMATED_HOURS_BASELINE3  = CASE WHEN BASELINE3_EST_DT IS NuLL THEN R_ESTIMATED_HOURS ELSE R_ESTIMATED_HOURS_BASELINE3 END,
         BASELINE3_EST_DT = CASE WHEN BASELINE3_EST_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_EST_DT END,
         BASELINE3_START = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_START ELSE BASELINE3_START END,
         BASELINE3_FINISH = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_FINISH ELSE BASELINE3_FINISH END,
         BASELINE3_DURATION = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN UNRESOLVED_DURATION ELSE BASELINE3_DURATION END,
         BASELINE3_EFFORT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN (SCHED_EFFORT + PLANNED_EFFORT) ELSE BASELINE3_EFFORT END,
         BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN CURRENT_BUDGET ELSE BASELINE3_BUDGET END,
         R_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN R_CURRENT_BUDGET ELSE R_BASELINE3_BUDGET END,
         S_BASELINE3_BUDGET = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN S_CURRENT_BUDGET ELSE S_BASELINE3_BUDGET END,
         BASELINE3_SCH_DT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
         ESTIMATED_BASELINE2_START = ESTIMATED_BASELINE1_START,
         ESTIMATED_BASELINE2_FINISH = ESTIMATED_BASELINE1_FINISH,
         ESTIMATED_BASELINE2_DURATION = ESTIMATED_BASELINE1_DURATION,
         ESTIMATED_BASELINE2_BUDGET = ESTIMATED_BASELINE1_BUDGET,
         R_ESTIMATED_BASELINE2_BUDGET = R_ESTIMATED_BASELINE1_BUDGET,
         S_ESTIMATED_BASELINE2_BUDGET = S_ESTIMATED_BASELINE1_BUDGET,
         ESTIMATED_HOURS_BASELINE2 = ESTIMATED_HOURS_BASELINE1,
         R_ESTIMATED_HOURS_BASELINE2 = R_ESTIMATED_HOURS_BASELINE1,
         BASELINE2_EST_DT = BASELINE1_EST_DT,
         BASELINE2_START = BASELINE1_START,
         BASELINE2_FINISH = BASELINE1_FINISH,
         BASELINE2_DURATION = BASELINE1_DURATION,
         BASELINE2_EFFORT = BASELINE1_EFFORT,
         BASELINE2_BUDGET = BASELINE1_BUDGET,
         R_BASELINE2_BUDGET = R_BASELINE1_BUDGET,
         S_BASELINE2_BUDGET = S_BASELINE1_BUDGET,
         BASELINE2_SCH_DT = BASELINE1_SCH_DT,
         ESTIMATED_BASELINE1_START = START_FINISH_DATE,
         ESTIMATED_BASELINE1_FINISH  = FINISH_START_DATE,
         ESTIMATED_BASELINE1_DURATION = START_FINISH_DURATION,
         ESTIMATED_BASELINE1_BUDGET = ESTIMATION_BUDGET,
         R_ESTIMATED_BASELINE1_BUDGET = R_ESTIMATION_BUDGET,
         S_ESTIMATED_BASELINE1_BUDGET = S_ESTIMATION_BUDGET,
         ESTIMATED_HOURS_BASELINE1    = ESTIMATED_HOURS,
         R_ESTIMATED_HOURS_BASELINE1  = R_ESTIMATED_HOURS,
         BASELINE1_EST_DT = SYSTIMESTAMP,
         BASELINE1_START = UNRESOLVED_START,
         BASELINE1_FINISH = UNRESOLVED_FINISH,
         BASELINE1_DURATION = UNRESOLVED_DURATION,
         BASELINE1_EFFORT = (SCHED_EFFORT + PLANNED_EFFORT),
         BASELINE1_BUDGET   = CURRENT_BUDGET,
         R_BASELINE1_BUDGET = R_CURRENT_BUDGET,
         S_BASELINE1_BUDGET = S_CURRENT_BUDGET,
         BASELINE1_SCH_DT = SYSTIMESTAMP,
         BASELINE1_VARIANCE = 0
         WHERE RANK LIKE h_rank || '%'
         AND PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1499+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1500) : wbs.sql(14421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If commitProject = 1 Then
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS SET
            ESTIMATED_BASELINE3_START   = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN CASE WHEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) < COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) THEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) ELSE COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) END ELSE ESTIMATED_BASELINE3_START END,
            ESTIMATED_BASELINE3_FINISH  = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN CASE WHEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) > COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) THEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) ELSE COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) END ELSE ESTIMATED_BASELINE3_FINISH END,
            ESTIMATED_BASELINE3_EFFORT  = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN ESTIMATED_SCHED_EFFORT + ESTIMATED_PLANNED_EFFORT ELSE ESTIMATED_BASELINE3_EFFORT END,
            ESTIMATED_BASELINE3_COST    = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN ESTIMATED_SCHED_COST + ESTIMATED_PLANNED_COST ELSE ESTIMATED_BASELINE3_COST END,
            ESTIMATED_BASELINE3_REVENUE = CASE WHEN ESTIMATED_BASELINE3_START IS NULL THEN ESTIMATED_SCHED_REVENUE + ESTIMATED_PLANNED_REVENUE ELSE ESTIMATED_BASELINE3_REVENUE END,
            ESTIMATED_BASELINE2_START   = ESTIMATED_BASELINE1_START,
            ESTIMATED_BASELINE2_FINISH  = ESTIMATED_BASELINE1_FINISH,
            ESTIMATED_BASELINE2_COST    = ESTIMATED_BASELINE1_COST,
            ESTIMATED_BASELINE2_REVENUE = ESTIMATED_BASELINE1_REVENUE,
            ESTIMATED_BASELINE1_START   = CASE WHEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) < COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) THEN COALESCE(ESTIMATED_SCHED_START,ESTIMATED_PLANNED_START) ELSE COALESCE(ESTIMATED_PLANNED_START,ESTIMATED_SCHED_START) END,
            ESTIMATED_BASELINE1_FINISH  = CASE WHEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) < COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) THEN COALESCE(ESTIMATED_SCHED_FINISH,ESTIMATED_PLANNED_FINISH) ELSE COALESCE(ESTIMATED_PLANNED_FINISH,ESTIMATED_SCHED_FINISH) END,
            ESTIMATED_BASELINE1_EFFORT  = ESTIMATED_SCHED_EFFORT + ESTIMATED_PLANNED_EFFORT,
            ESTIMATED_BASELINE1_COST    = ESTIMATED_SCHED_COST + ESTIMATED_PLANNED_COST,
            ESTIMATED_BASELINE1_REVENUE = ESTIMATED_SCHED_REVENUE + ESTIMATED_PLANNED_REVENUE,
            BASELINE_START = UNRESOLVED_START,
            BASELINE_FINISH = UNRESOLVED_FINISH,
            BASELINE_DURATION = COALESCE(UNRESOLVED_DURATION, 0),
            BASELINE_WORK = ( SCHED_WORK + PLANNED_WORK ),
            BASELINE_LABOR_COST = (SCHED_LABOR_COST+PLANNED_LABOR_COST),
            BASELINE_LABOR_REVENUE = (SCHED_LABOR_REVENUE+PLANNED_LABOR_REVENUE)
            WHERE PROJECT_ID = h_project_id
            AND SECURITY_ID = 'SCPROJECTASSIGNMENT';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1539+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1540) : wbs.sql(14461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      OPEN EST_27a;
      
      LOOP
         FETCH EST_27a INTO h_cur_id, h_type_id;
         IF EST_27a%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         --trace_printf("h_cur_id: %s, h_type_id: %d\n",h_cur_id,h_type_id);
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         --project_budget_breakdown
         BEGIN
            DELETE FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE2, PMO_CNST.SC_SCHED_BASELINE2);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1576+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1577) : wbs.sql(14498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET
            BUDGET_TYPE =   CASE
            WHEN BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE1 THEN PMO_CNST.SC_ESTIMATED_BASELINE2
            WHEN BUDGET_TYPE = PMO_CNST.SC_SCHED_BASELINE1 THEN PMO_CNST.SC_SCHED_BASELINE2
            ELSE BUDGET_TYPE
            END
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BASELINE1, PMO_CNST.SC_SCHED_BASELINE1);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1601+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1602) : wbs.sql(14523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN
            (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            SELECT
            PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            CASE WHEN BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET THEN PMO_CNST.SC_ESTIMATED_BASELINE1 ELSE PMO_CNST.SC_SCHED_BASELINE1 END,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET, PMO_CNST.SC_SCHED_BUDGET);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1633+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1634) : wbs.sql(14555) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN
            (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            SELECT
            PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            PMO_CNST.SC_ESTIMATED_BASELINE3,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
            AND CHARGECODE_ID IN (
            SELECT B.CHARGECODE_ID FROM BUDGETS B
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_cur_id
            AND BASELINE3_EST_FLAG = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1670+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1671) : wbs.sql(14592) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN
            (PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            BUDGET_TYPE,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT)
            SELECT
            PROJECT_ID, ELEMENT_ID, BUDGET_YEAR, CHARGECODE_ID,
            PMO_CNST.SC_SCHED_BASELINE3,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
            MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
            TOTAL_AMOUNT
            FROM PROJECT_BUDGET_BREAKDOWN
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id
            AND BUDGET_TYPE = PMO_CNST.SC_SCHED_BUDGET
            AND CHARGECODE_ID IN (
            SELECT B.CHARGECODE_ID FROM BUDGETS B
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_cur_id
            AND BASELINE3_SCH_FLAG = 0);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1707+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1708) : wbs.sql(14629) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --budget changes
         BEGIN
            UPDATE BUDGETS SET
            ESTIMATED_BASELINE3 = CASE WHEN BASELINE3_EST_FLAG = 0 THEN ESTIMATED_BUDGET ELSE ESTIMATED_BASELINE3 END,
            ESTIMATED_BASELINE2 = ESTIMATED_BASELINE1,
            ESTIMATED_BASELINE1 = ESTIMATED_BUDGET,
            BASELINE3_EST_FLAG = 1,
            BUDGET_BASELINE3 = CASE WHEN BASELINE3_SCH_FLAG = 0 THEN BUDGET ELSE BUDGET_BASELINE3 END,
            BUDGET_BASELINE2 = BUDGET_BASELINE1,
            BUDGET_BASELINE1 = BUDGET,
            BASELINE3_SCH_FLAG = 1
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1735+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1736) : wbs.sql(14657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --assignment changes
         If (isProjectType(Coalesce(h_type_id, 0))) <> 0 OR (isWBSTask(Coalesce(h_type_id, 0))) <> 0 Then
            BEGIN
               UPDATE TASK_ASSIGNMENTS TA SET
               TA.BASELINE3_START = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN TA.UNRESOLVED_START ELSE TA.BASELINE3_START END,
               TA.BASELINE3_FINISH = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN TA.UNRESOLVED_FINISH ELSE TA.BASELINE3_FINISH END,
               TA.BASELINE3_DURATION = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN COALESCE(TA.UNRESOLVED_DURATION,0) ELSE TA.BASELINE3_DURATION END,
               TA.BASELINE3_WORK = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_WORK + TA.PLANNED_WORK ) ELSE TA.BASELINE3_WORK END,
               TA.BASELINE3_LABOR_COST = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_LABOR_COST + TA.PLANNED_LABOR_COST ) ELSE TA.BASELINE3_LABOR_COST END,
               TA.BASELINE3_LABOR_REVENUE = CASE WHEN TA.BASELINE3_SCH_FLAG = 0 THEN ( TA.SCHED_LABOR_REVENUE + TA.PLANNED_LABOR_REVENUE ) ELSE TA.BASELINE3_LABOR_REVENUE END,
               
               TA.BASELINE2_START = TA.BASELINE1_START,
               TA.BASELINE2_FINISH = TA.BASELINE1_FINISH,
               TA.BASELINE2_DURATION = TA.BASELINE1_DURATION,
               TA.BASELINE2_WORK = TA.BASELINE1_WORK,
               TA.BASELINE2_LABOR_COST = TA.BASELINE1_LABOR_COST,
               TA.BASELINE2_LABOR_REVENUE = TA.BASELINE1_LABOR_REVENUE,
               
               TA.BASELINE1_START = TA.UNRESOLVED_START,
               TA.BASELINE1_FINISH = TA.UNRESOLVED_FINISH,
               TA.BASELINE1_DURATION = COALESCE(TA.UNRESOLVED_DURATION,0),
               TA.BASELINE1_WORK = ( TA.SCHED_WORK + TA.PLANNED_WORK ),
               TA.BASELINE1_LABOR_COST = ( TA.SCHED_LABOR_COST + TA.PLANNED_LABOR_COST ),
               TA.BASELINE1_LABOR_REVENUE = ( TA.SCHED_LABOR_REVENUE + TA.PLANNED_LABOR_REVENUE ),
               TA.B_REGULAR_COST = TA.REGULAR_COST, TA.B_REGULAR_RATE = TA.REGULAR_RATE, TA.B_SPECIAL_COST = TA.SPECIAL_COST, TA.B_SPECIAL_RATE = TA.SPECIAL_RATE,
               
               TA.BASELINE3_SCH_FLAG = 1
               WHERE TA.PROJECT_ID = h_project_id
               AND TA.TASK_ID = h_cur_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1779+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1780) : wbs.sql(14701) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE EST_27a;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1794+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1795) : wbs.sql(14716) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS TW SET
         BAC = COALESCE((SELECT SUM(BUDGET_BASELINE1) FROM BUDGETS WHERE PROJECT_ID = TW.PROJECT_ID AND ELEMENT_ID = TW.ELEMENT_ID AND CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE_LABOR, PMO_CNST.SC_CAPITAL_LABOR)), 0.00)
         WHERE TW.PROJECT_ID = h_project_id AND TW.RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1826+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1827) : wbs.sql(14748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET
         EV_ETC = CASE WHEN ACWP > BAC THEN 0.00 ELSE BAC-ACWP END, 
         EAC = CASE WHEN ACWP > BAC THEN ACWP ELSE BAC END 
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1846+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1847) : wbs.sql(14768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- copy updated wbs columns to cri since this option doesn't turn on any rollup bits
      
      OPEN COPY_TO_CRI_27;
      
      LOOP
         FETCH COPY_TO_CRI_27 INTO h_cur_id,
         h_baseline3_start, h_baseline3_finish, h_baseline3_duration, h_baseline3_effort, h_baseline3_budget, h_r_baseline3_budget, h_s_baseline3_budget, h_baseline3_sch_dt,
         h_baseline2_start, h_baseline2_finish, h_baseline2_duration, h_baseline2_effort, h_baseline2_budget, h_r_baseline2_budget, h_s_baseline2_budget, h_baseline2_sch_dt,
         h_baseline1_start, h_baseline1_finish, h_baseline1_duration, h_baseline1_effort, h_baseline1_budget, h_r_baseline1_budget, h_s_baseline1_budget, h_baseline1_sch_dt,
         h_baseline1_variance, h_bac, h_eac, h_eac_forecast;
         IF COPY_TO_CRI_27%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_CRI
            SET
            BASELINE3_BUDGET    = h_baseline3_budget,
            R_BASELINE3_BUDGET  = h_r_baseline3_budget,
            S_BASELINE3_BUDGET  = h_s_baseline3_budget,
            BASELINE3_DATETIME  = h_baseline3_sch_dt,
            BASELINE2_BUDGET    = h_baseline2_budget,
            R_BASELINE2_BUDGET  = h_r_baseline2_budget,
            S_BASELINE2_BUDGET  = h_s_baseline2_budget,
            BASELINE2_DATETIME  = h_baseline2_sch_dt,
            BASELINE1_START     = h_baseline1_start,
            BASELINE1_FINISH    = h_baseline1_finish,
            BASELINE1_DURATION  = h_baseline1_duration,
            BASELINE1_EFFORT    = h_baseline1_effort,
            BASELINE1_BUDGET    = h_baseline1_budget,
            R_BASELINE1_BUDGET  = h_r_baseline1_budget,
            S_BASELINE1_BUDGET  = h_s_baseline1_budget,
            BASELINE1_DATETIME  = h_baseline1_sch_dt,
            BASELINE1_VARIANCE  = h_baseline1_variance
            WHERE PROJECT_ID = h_project_id
            AND WBS_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1903+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1904) : wbs.sql(14825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE COPY_TO_CRI_27;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1917+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1918) : wbs.sql(14839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 24 AND commitProject = 1 Then
      PMO_DB2M.SC_STATE := FC_COMMIT_BASELINE_EX(h_project_id);
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         TYPE_ID         = CASE WHEN TYPE_ID = PMO_CNST.SC_PROPOSAL THEN PMO_CNST.SC_PROJECT ELSE TYPE_ID END,
         SCHED_START     = COALESCE(PLANNED_START, SCHED_START),
         SCHED_FINISH    = COALESCE(PLANNED_FINISH, SCHED_FINISH),
         SCHED_DURATION  = CASE WHEN PLANNED_DURATION = 0 THEN SCHED_DURATION ELSE PLANNED_DURATION END,
         SCHED_EFFORT    = PLANNED_EFFORT,
         PLANNED_START   = Null,
         PLANNED_FINISH  = Null,
         PLANNED_DURATION = 0,
         FORECAST_START  = Null,
         FORECAST_FINISH = Null,
         FORECAST_EFFORT = PLANNED_EFFORT,
         ETC             = PLANNED_EFFORT,
         FORECAST_DURATION = 0
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND ASSIGN_COUNT = 0 AND WORK_TODATE = 0 AND SCHED_EFFORT = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1964+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1965) : wbs.sql(14886) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET ROLLUP_BITS = PMO_CNST.SC_ASSIGNMENT_BIT
         WHERE PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND ASSIGN_COUNT > 0 AND WORK_TODATE = 0 AND SCHED_EFFORT = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 1982+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(1983) : wbs.sql(14904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         SCHED_START = COALESCE(PROPOSED_START, SCHED_START),
         SCHED_FINISH = COALESCE(PROPOSED_FINISH, SCHED_FINISH),
         SCHED_DURATION = CASE WHEN PROPOSED_DURATION = 0 THEN SCHED_DURATION ELSE PROPOSED_DURATION END,
         SCHED_EFFORT = CASE WHEN PROPOSED_EFFORT = 0 THEN SCHED_EFFORT ELSE PROPOSED_EFFORT END,
         FORECAST_START = Null, FORECAST_FINISH = Null, FORECAST_DURATION = 0
         WHERE /*MILESTONE_PERCENT < 10000 AND*/ PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2019+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2020) : wbs.sql(14941) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --assignment changes
      BEGIN
         UPDATE TASK_ASSIGNMENTS TA SET
         TA.SCHED_START = COALESCE(TA.PROPOSED_START, TA.SCHED_START),
         TA.SCHED_FINISH = COALESCE(TA.PROPOSED_FINISH, TA.SCHED_FINISH),
         TA.SCHED_DURATION = CASE WHEN TA.PROPOSED_DURATION = 0 THEN TA.SCHED_DURATION ELSE TA.FORECAST_DURATION END,
         TA.SCHED_WORK = CASE WHEN TA.PROPOSED_WORK > 0 THEN TA.PROPOSED_WORK ELSE TA.SCHED_WORK END,
         TA.SCHED_LABOR_COST = CASE WHEN TA.PROPOSED_LABOR_COST > 0.00 THEN TA.PROPOSED_LABOR_COST ELSE TA.SCHED_LABOR_COST END,
         TA.SCHED_LABOR_REVENUE = CASE WHEN TA.PROPOSED_LABOR_REVENUE > 0.00 THEN TA.PROPOSED_LABOR_REVENUE ELSE TA.SCHED_LABOR_REVENUE END,
         TA.FORECAST_LABOR_COST = CASE WHEN TA.PROPOSED_LABOR_COST > 0.00 THEN TA.PROPOSED_LABOR_COST ELSE TA.SCHED_LABOR_COST END,
         TA.FORECAST_LABOR_REVENUE = CASE WHEN TA.PROPOSED_LABOR_REVENUE > 0.00 THEN TA.PROPOSED_LABOR_REVENUE ELSE TA.SCHED_LABOR_REVENUE END,
         TA.FORECAST_START = Null, TA.FORECAST_FINISH = Null, TA.FORECAST_DURATION = 0
         WHERE /*TA.MILESTONE_PERCENT < 10000 AND*/ TA.PROJECT_ID = h_project_id AND TA.RESOURCE_TYPE='0' AND EXISTS (SELECT T.ELEMENT_ID FROM TMT_WBS T
         WHERE /*MILESTONE_PERCENT < 10000 AND*/ PROJECT_ID = h_project_id AND ELEMENT_ID = TA.TASK_ID AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2048+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2049) : wbs.sql(14970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_ASSIGNMENTS PA SET
         PA.SCHED_START = COALESCE(PA.PROPOSED_START, PA.SCHED_START),
         PA.SCHED_FINISH = COALESCE(PA.PROPOSED_FINISH, PA.SCHED_FINISH),
         PA.SCHED_DURATION = CASE WHEN PA.PROPOSED_DURATION = 0 THEN PA.SCHED_DURATION ELSE PA.FORECAST_DURATION END,
         PA.SCHED_WORK = CASE WHEN PA.PROPOSED_WORK > 0 THEN PA.PROPOSED_WORK ELSE PA.SCHED_WORK END,
         PA.SCHED_LABOR_COST = CASE WHEN PA.PROPOSED_LABOR_COST > 0.00 THEN PA.PROPOSED_LABOR_COST ELSE PA.SCHED_LABOR_COST END,
         PA.SCHED_LABOR_REVENUE = CASE WHEN PA.PROPOSED_LABOR_REVENUE > 0.00 THEN PA.PROPOSED_LABOR_REVENUE ELSE PA.SCHED_LABOR_REVENUE END,
         PA.FORECAST_LABOR_COST = CASE WHEN PA.PROPOSED_LABOR_COST > 0.00 THEN PA.PROPOSED_LABOR_COST ELSE PA.SCHED_LABOR_COST END,
         PA.FORECAST_LABOR_REVENUE = CASE WHEN PA.PROPOSED_LABOR_REVENUE > 0.00 THEN PA.PROPOSED_LABOR_REVENUE ELSE PA.SCHED_LABOR_REVENUE END,
         PA.FORECAST_START = Null, PA.FORECAST_FINISH = Null, PA.FORECAST_DURATION = 0
         WHERE /*PA.MILESTONE_PERCENT < 10000 AND*/ PA.PROJECT_ID = h_project_id AND PA.RESOURCE_TYPE='0';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2075+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2076) : wbs.sql(14997) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 4 Then
      --budget changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE BUDGETS B SET
         B.BUDGET = B.ACTUAL + B.ETC
         WHERE B.PROJECT_ID = h_project_id AND B.ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE PROJECT_ID = h_project_id AND PROJECT_ID = B.PROJECT_ID AND ELEMENT_ID = B.ELEMENT_ID AND /*MILESTONE_PERCENT < 10000 AND*/ RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2108+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2109) : wbs.sql(15030) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --assignment changes
      h_best := 0;
      h_duration := 0;
      
      OPEN C29;
      
      LOOP
         FETCH C29 INTO h_id, h_res_id, h_type, h_start_date, h_finish_date, h_effort;
         IF C29%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            SELECT (CASE WHEN h_start_date < TO_DATE(SYSDATE) THEN TO_DATE(SYSDATE) ELSE h_start_date END)  INTO  h_start_date FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2139) : wbs.sql(15060) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_type, 0) = 1 Then
            stmt := 
                  'SELECT DAY_YEAR, AVAILABLE_MIN, PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED), PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED) FROM CALENDAR_DAY_OF_YEAR '
                   || 'WHERE ELEMENT_ID = ''' || h_res_id || ''' AND DAY_YEAR BETWEEN TO_DATE(SubStr(''' 
                        || h_start_date || ''', 1, 10)) AND TO_DATE(SubStr(''' || h_finish_date 
                        || ''', 1, 10)) ORDER BY DAY_YEAR DESC ';
         Else
            stmt := 
                  'SELECT DAY_YEAR, AVAILABLE_MIN, PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED), PMO_STPU.LAST_AVAIL_TIME(BIT_SCHED) FROM CALENDAR_DAY_OF_YEAR '
                   || 'WHERE ELEMENT_ID = ''' || h_res_id || ''' AND DAY_YEAR BETWEEN TO_DATE(SubStr(''' 
                        || h_start_date || ''', 1, 10)) AND TO_DATE(SubStr(''' || h_finish_date 
                        || ''', 1, 10)) ORDER BY DAY_YEAR ';
         End If;
         
         OPEN C10 FOR stmt;
         
         LOOP
            FETCH C10 INTO h_SC, h_available, h_start_time, h_end_time;
            IF C10%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
               EXIT;
            End If;
            
            h_duration := Coalesce(h_duration, 0) + 1;
            
            h_best := Coalesce(h_best, 0) + Coalesce(h_available, 0);
            
            If Coalesce(h_best, 0) >= Coalesce(h_effort, 0) Then
               EXIT;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE C10 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2188) : wbs.sql(15109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_type, 0) = 1 Then
            BEGIN
               SELECT (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SC, 1, 10)), PMO_ORASTD.TIME(h_end_time)))  INTO  h_start_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2201+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2202) : wbs.sql(15123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT (PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_SC, 1, 10)), PMO_ORASTD.TIME(h_end_time)))  INTO  h_finish_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2214+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2215) : wbs.sql(15136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE TASK_ASSIGNMENTS SET
            SCHED_START = h_start_date,
            SCHED_FINISH = h_finish_date,
            SCHED_WORK = h_effort,
            SCHED_DURATION = h_duration,
            SCHED_LABOR_COST = CASE WHEN FORECAST_LABOR_COST > 0 THEN FORECAST_LABOR_COST ELSE SCHED_LABOR_COST END,
            SCHED_LABOR_REVENUE = CASE WHEN FORECAST_LABOR_REVENUE > 0 THEN FORECAST_LABOR_REVENUE ELSE SCHED_LABOR_REVENUE END,
            BIT_FLAG = CASE WHEN h_type = 1 THEN '3' ELSE '2' END,
            FORECAST_START = Null,
            FORECAST_FINISH = Null,
            FORECAST_DURATION = 0
            WHERE PROJECT_ID = h_project_id AND TSK_ASSIGNMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2243+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2244) : wbs.sql(15165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      --end of while
      
      BEGIN
         CLOSE C29 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2258+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2259) : wbs.sql(15180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_ASSIGNMENTS SET
         SCHED_START = CASE WHEN FORECAST_START < SCHED_START THEN FORECAST_START ELSE SCHED_START END,
         SCHED_FINISH = CASE WHEN FORECAST_FINISH < SCHED_FINISH THEN FORECAST_FINISH ELSE SCHED_FINISH END,
         SCHED_WORK = CASE WHEN ETC > 0 THEN ETC ELSE SCHED_WORK END,
         SCHED_DURATION = CASE WHEN FORECAST_DURATION > 0 THEN FORECAST_DURATION ELSE FORECAST_DURATION END,
         SCHED_LABOR_COST = CASE WHEN FORECAST_LABOR_COST > 0 THEN FORECAST_LABOR_COST ELSE SCHED_LABOR_COST END,
         SCHED_LABOR_REVENUE = CASE WHEN FORECAST_LABOR_REVENUE > 0 THEN FORECAST_LABOR_REVENUE ELSE SCHED_LABOR_REVENUE END,
         FORECAST_START = Null,
         FORECAST_FINISH = Null,
         FORECAST_DURATION = 0
         WHERE /*MILESTONE_PERCENT < 10000 AND*/ RESOURCE_TYPE = '0' AND PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2285+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2286) : wbs.sql(15207) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --wbs changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         SCHED_START = CASE WHEN SD = PMO_CNST.SC_UFS THEN COALESCE(FORECAST_START, SCHED_START) ELSE SCHED_START END,
         SCHED_FINISH = CASE WHEN FD = PMO_CNST.SC_UFF THEN COALESCE(FORECAST_FINISH, SCHED_FINISH) ELSE SCHED_FINISH END,
         SCHED_DURATION = CASE WHEN SD=PMO_CNST.SC_UFS OR FD=PMO_CNST.SC_UFF THEN SCHED_DURATION
         WHEN FORECAST_DURATION > 0 THEN FORECAST_DURATION ELSE SCHED_DURATION END,
         SCHED_EFFORT = ETC,
         FORECAST_START = Null,
         FORECAST_FINISH = Null,
         FORECAST_DURATION = 0,
         FORECAST_BUDGET = 0,
         R_FORECAST_BUDGET = 0,
         S_FORECAST_BUDGET = 0,
         CURRENT_BUDGET = FORECAST_BUDGET,
         R_CURRENT_BUDGET = R_FORECAST_BUDGET,
         S_CURRENT_BUDGET = S_FORECAST_BUDGET
         WHERE /*MILESTONE_PERCENT < 10000 AND*/ PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2331+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2332) : wbs.sql(15253) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 5 Then
      --assignment changes
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 0 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		return PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_RANK_LIKE, h_rank, False); 
      	End If; 
      END;
      BEGIN
         UPDATE TASK_ASSIGNMENTS TA SET
         TA.PLANNED_START = COALESCE(TA.FORECAST_START, TA.SCHED_START, PLANNED_START),
         TA.PLANNED_FINISH = COALESCE(TA.FORECAST_FINISH, TA.SCHED_FINISH, TA.PLANNED_FINISH),
         TA.PLANNED_DURATION = CASE WHEN TA.FORECAST_DURATION > 0 THEN TA.FORECAST_DURATION WHEN TA.SCHED_DURATION > 0 THEN TA.SCHED_DURATION ELSE TA.PLANNED_DURATION END,
         TA.PLANNED_WORK = CASE WHEN TA.ETC > 0 THEN TA.ETC WHEN TA.SCHED_WORK > 0 THEN TA.SCHED_WORK ELSE TA.PLANNED_WORK END,
         TA.PLANNED_LABOR_COST = CASE WHEN TA.FORECAST_LABOR_COST > 0.00 THEN TA.FORECAST_LABOR_COST WHEN TA.SCHED_LABOR_COST > 0.00 THEN TA.SCHED_LABOR_COST ELSE TA.PLANNED_LABOR_COST END,
         TA.PLANNED_LABOR_REVENUE = CASE WHEN TA.FORECAST_LABOR_REVENUE > 0.00 THEN TA.FORECAST_LABOR_REVENUE  WHEN TA.SCHED_LABOR_REVENUE > 0.00 THEN TA.SCHED_LABOR_REVENUE ELSE TA.PLANNED_LABOR_REVENUE END,
         TA.FORECAST_START = Null,
         TA.FORECAST_FINISH = Null,
         TA.FORECAST_DURATION = 0
         WHERE /*TA.MILESTONE_PERCENT < 10000 AND*/ TA.PROJECT_ID = h_project_id AND TA.RESOURCE_TYPE='0' AND EXISTS (
         SELECT ELEMENT_ID FROM TMT_WBS WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = TA.TASK_ID AND RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2373+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2374) : wbs.sql(15295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE PROJECT_ASSIGNMENTS PA SET
         PA.PLANNED_START = COALESCE(PA.FORECAST_START, PA.SCHED_START, PLANNED_START),
         PA.PLANNED_FINISH = COALESCE(PA.FORECAST_FINISH, PA.SCHED_FINISH, PA.PLANNED_FINISH),
         PA.PLANNED_DURATION = CASE WHEN PA.FORECAST_DURATION > 0 THEN PA.FORECAST_DURATION WHEN PA.SCHED_DURATION > 0 THEN PA.SCHED_DURATION ELSE PA.PLANNED_DURATION END,
         PA.PLANNED_WORK = CASE WHEN PA.ETC > 0 THEN PA.ETC WHEN PA.SCHED_WORK > 0 THEN PA.SCHED_WORK ELSE PA.PLANNED_WORK END,
         PA.PLANNED_LABOR_COST = CASE WHEN PA.FORECAST_LABOR_COST > 0.00 THEN PA.FORECAST_LABOR_COST WHEN PA.SCHED_LABOR_COST > 0.00 THEN PA.SCHED_LABOR_COST ELSE PA.PLANNED_LABOR_COST END,
         PA.PLANNED_LABOR_REVENUE = CASE WHEN PA.FORECAST_LABOR_REVENUE > 0.00 THEN PA.FORECAST_LABOR_REVENUE  WHEN PA.SCHED_LABOR_REVENUE > 0.00 THEN PA.SCHED_LABOR_REVENUE ELSE PA.PLANNED_LABOR_REVENUE END,
         PA.FORECAST_START = Null,
         PA.FORECAST_FINISH = Null,
         PA.FORECAST_DURATION = 0
         WHERE /*PA.MILESTONE_PERCENT < 10000 AND*/ PA.RESOURCE_TYPE='0' AND PA.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2400+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2401) : wbs.sql(15322) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --wbs changes
      BEGIN
         UPDATE TMT_WBS SET
         PLANNED_START = CASE WHEN SD=PMO_CNST.SC_FS AND ASSIGN_COUNT>0 THEN COALESCE(FORECAST_START, PLANNED_START) ELSE COALESCE(SCHED_START, PLANNED_START)  END,
         PLANNED_FINISH = CASE WHEN SD=PMO_CNST.SC_FS AND ASSIGN_COUNT>0 THEN COALESCE(FORECAST_FINISH, PLANNED_FINISH) ELSE COALESCE(SCHED_FINISH, PLANNED_FINISH) END,
         PLANNED_DURATION = CASE WHEN SD=PMO_CNST.SC_FS AND ASSIGN_COUNT>0 AND FORECAST_DURATION > 0 THEN FORECAST_DURATION WHEN SCHED_DURATION > 0 THEN SCHED_DURATION ELSE PLANNED_DURATION END,
         PLANNED_EFFORT = CASE WHEN ETC <> 0 THEN ETC WHEN SCHED_EFFORT <> 0 THEN SCHED_EFFORT ELSE PLANNED_EFFORT END,
         FORECAST_START = Null, FORECAST_FINISH = Null, FORECAST_DURATION = 0
         WHERE /*MILESTONE_PERCENT < 10000 AND*/ PROJECT_ID = h_project_id AND RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2424+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2425) : wbs.sql(15346) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- update the effort  contur
      BEGIN
         UPDATE TASK_DAY_OF_YEAR SET
         SCHED_MIN = PMO_STPU.TOTAL_DAY(BIT_SCHED)
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND TASK_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE RANK like h_rank || '%')
         AND RESOURCE_TYPE = '0')
         AND BIT_FLAG = '2';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2454+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2455) : wbs.sql(15376) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --UPDATING CALENDAR_DAY_OF_YEAR  TASK_DAY_OF_YEAR
   If Coalesce(h_bitflag, 0) = 3 Then
      OPEN C30;
      
      LOOP
         FETCH C30 INTO h_uniqueID, h_id, h_day_ofyear, h_day_min, h_bitID;
         IF C30%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         --removed fetching of BIT_ASSIGNED column into host variable
         PMO_DB2M.SC_STATE := 0;
         
         --removed the update of ASSIGNED_MIN and BIT_ASSIGNED columns
         
         BEGIN
            UPDATE TASK_DAY_OF_YEAR SET
            BIT_FLAG = '2'
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_uniqueID
            AND RESOURCE_ID = h_id
            AND DAY_YEAR = h_day_ofyear;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2497+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2498) : wbs.sql(15419) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C30 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2511+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2512) : wbs.sql(15433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 4 Then
      OPEN C31;
      
      LOOP
         FETCH C31 INTO h_uniqueID, h_id, h_day_ofyear, h_day_min, h_bitID;
         IF C31%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         --removed the fetching od the BIT_ASSIGNED column into a host variable
         PMO_DB2M.SC_STATE := 0;
         
         --removed the update of ASSIGNED_MIN and BIT_ASSIGNED columns
         
         BEGIN
            UPDATE TASK_DAY_OF_YEAR SET
            BIT_FLAG = '2'
            WHERE PROJECT_ID = h_project_id
            AND TSK_ASSIGNMENT_ID = h_uniqueID
            AND RESOURCE_ID = h_id
            AND DAY_YEAR = h_day_ofyear;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2551+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2552) : wbs.sql(15473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C31 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2565+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2566) : wbs.sql(15487) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (Coalesce(h_bitflag, 0) = 21) OR (Coalesce(h_bitflag, 0) = 22) OR (Coalesce(
             h_bitflag, 0) = 23) Then
      If i_save_to_project = 1 Then
         PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_project_id);
         PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_project_id);
         
         PMO_DB2M.SC_STATE := FC_BASELINE_DELTA(h_project_id, h_rank, h_bitflag);
      Else
         -- BASELINE_FLAG State
         --******************************************************************************
         --    BASELINE_FLAG                           *   Calculate
         --******************************************************************************
         --    0 = none                                *   B1prj += B1delv
         --    1 = delta is grayed out and checked     *   B1prj += B1delv - B2delv
         --    2 = first time baseline project         *   B1prj += B1delv - B3delv
         --    3 = second time baseline project        *   B1prj += B1delv - B2delv
         --    4 = delta is grayed out and unchecked (add baseline delta is not available)
         --*******************************************************************************
         
         -- Graph diagram
         --*************************************
         -- old flag ---------------> new flag
         --*************************************
         --  if Project
         --*******************************
         --   0  ------------------> 2
         --   4  first time baseline 2
         --   1  ------------------> 1
         --   2,3 ------------------> 3
         --   4  second time baseline 3
         --*************************************
         --  if not Project
         --*************************************
         --  3,1  ------------------>   4
         --*************************************
         
         -- flag sub-elements, needed when Add Delta to the Project/Parents
         If isProjectType(Coalesce(h_type, 0)) <> 0 Then
            BEGIN
               UPDATE TMT_WBS SET BASELINE_FLAG = 
               CASE WHEN BASELINE_FLAG = 0 THEN 2 
               WHEN BASELINE_FLAG = 4 AND h_baseline_flag = 0 THEN 2 
               WHEN BASELINE_FLAG = 1 THEN 1 
               ELSE 3 END
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2626+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2627) : wbs.sql(15548) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            -- if not Project  BASELINE_FLAG = 3, then Block Add Delta option
            BEGIN
               UPDATE TMT_WBS SET BASELINE_FLAG = CASE WHEN BASELINE_FLAG = 3 OR BASELINE_FLAG = 1 THEN 4 ELSE BASELINE_FLAG END
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2645+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2646) : wbs.sql(15567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   End If;
   
   If (Coalesce(h_bitflag, 0) = 21) OR (Coalesce(h_bitflag, 0) = 23) Then
      BEGIN
         SELECT ENABLE_EV_CALCULATION
         INTO h_change_flag
         FROM PROJECT_DETAILS
         WHERE PROJECT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2665+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2666) : wbs.sql(15587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_change_flag, 0) = 1 Then
         h_temp_rec_user := '';
         PMO_DB2M.SC_STATE := FC_GENERATE_TS_NEW(h_project_id, h_rank, h_temp_rec_user);
      End If;
      
      h_change_flag := 0;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   -- New Rollup
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   BEGIN
      SELECT CASE WHEN (SD <> PMO_CNST.SC_NS) AND (FD <> PMO_CNST.SC_NF) AND (TYPE_ID = PMO_CNST.SC_PROPOSAL) THEN 1 ELSE 0 END
      INTO h_change_flag
      FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT', 2695+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT(2696) : wbs.sql(15617) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_change_flag, 0) = 1 Then
      h_type_id := PMO_CNST.SC_PROPOSAL;
      PMO_DB2M.SC_STATE := FC_CHANGE_PROJ_TYPE(h_project_id, h_change_flag, h_type_id);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT', 2706+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COMMIT(2707) : wbs.sql(15628) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT', 2710+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COMMIT(2711) : wbs.sql(15632) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COMMIT;
ALTER FUNCTION FC_COMMIT COMPILE DEBUG;

/***************************************************************************************/

Prompt == FUNCTION SP_COMMIT ==
CREATE OR REPLACE FUNCTION SP_COMMIT
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_COMMIT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_COMMIT'), '-- ' || SYSTIMESTAMP, ':r := SP_COMMIT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COMMIT', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_COMMIT(20) : wbs.sql(15662) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_bitflag := p_bitflag;
   
   h_temp_sc_state := FC_COMMIT(h_id, h_bitflag);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_COMMIT', 28+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_COMMIT(29) : wbs.sql(15671) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(Coalesce(h_temp_sc_state, 0), h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COMMIT', 35+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COMMIT(36) : wbs.sql(15678) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COMMIT', 47+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COMMIT(48) : wbs.sql(15690) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_COMMIT;
ALTER FUNCTION SP_COMMIT COMPILE DEBUG;

/******************************************************************************
(INSERT)/(UPDATE)
ACTION TYPE
    1   INSERT
    2   UPDATE
    3   delete
NAME
ID
    INSERT IGNORE
    UPDATE
PARENT_ID
TYPE
    -1  DONNOT UPDATE
    else    CHANGE TYPE TO
SUMMARY_FLAG
    1   UPDATE NAME AND CHANGE_TYPE
DATA_FLAG
    0   PLANNED             0
    1   SCHEDULE            1
    2   BASELINE + PLANNED      10
    3   BASELINE + SCHEDULE     11
    4   ACTUAL + PLANNED        100
    5   ACTUAL + SCHEDULE       101
    6   ACTUAL + BASELINE + PLANNED 110
    7   ACTUAL + BAESLINE + SCHEDULE    111
START_DT
    PLANNED OR SCHEDULE
FINISH_DT
    PLANNED OR SCHEDULE
DURATION (integer)
    PLANNED OR SCHEDULE
PERCENT_COMPLETE (integer)
    if DATA_FLAG > 3
    else IGNORE
CONSTRAINT_TYPE (integer)
CONSTRAINT_DATE
PRIORITY (integer)
BASELINE_START
BASELINE_FINISH
BASELINE_DURATION (integer)
ACTUAL_START
ACTUAL_FINISH
ACTUAL_DURATION (integer)
REC_USER
IEFLAG
    ALWAYS 1
******************************************************************************/

Prompt == FUNCTION SP_WBS_MSP ==
CREATE OR REPLACE FUNCTION SP_WBS_MSP
(
     p_id VARCHAR2
   , p_action_type PLS_INTEGER
   , p_name VARCHAR2
   , p_parent_id VARCHAR2
   , p_type PLS_INTEGER
   , p_data_flag PLS_INTEGER
   , p_start_dt VARCHAR2
   , p_finish_dt VARCHAR2
   , p_duration PLS_INTEGER
   , p_percent_complete PLS_INTEGER
   , p_constraint_type PLS_INTEGER
   , p_constraint_date VARCHAR2
   , p_priority PLS_INTEGER
   , p_baseline_start VARCHAR2
   , p_baseline_finish VARCHAR2
   , p_baseline_duration PLS_INTEGER
   , p_baseline_effort PLS_INTEGER
   , p_actual_start VARCHAR2
   , p_actual_finish VARCHAR2
   , p_actual_duration PLS_INTEGER
   , p_msp_id PLS_INTEGER
   , p_ieflag PLS_INTEGER
   , p_task_type PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_full_name VARCHAR2(99);
   h_id VARCHAR2(32);
   h_new_code VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_res_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_uniqueID VARCHAR2(32);
   h_wbs_code VARCHAR2(255);
   h_res_type VARCHAR2(1);
   h_rec_status VARCHAR2(1);
   h_transfer_flag VARCHAR2(1);
   h_start_finish_date TIMESTAMP;
   h_finish_start_date TIMESTAMP;
   h_tmp_flag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_group_type PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_fs_flag PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_WBS_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_WBS_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_WBS_MSP(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_action_type), 'NULL')
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_data_flag), 'NULL')
          || ', ' || '''' || p_start_dt || ''''
          || ', ' || '''' || p_finish_dt || ''''
          || ', ' || COALESCE(TO_CHAR(p_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_percent_complete), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_constraint_type), 'NULL')
          || ', ' || '''' || p_constraint_date || ''''
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || '''' || p_baseline_start || ''''
          || ', ' || '''' || p_baseline_finish || ''''
          || ', ' || COALESCE(TO_CHAR(p_baseline_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_baseline_effort), 'NULL')
          || ', ' || '''' || p_actual_start || ''''
          || ', ' || '''' || p_actual_finish || ''''
          || ', ' || COALESCE(TO_CHAR(p_actual_duration), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_msp_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_ieflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_task_type), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_MSP', 88+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_WBS_MSP(89) : wbs.sql(15841) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_res_type := '0';
   h_res_id := p_rec_user;
   h_type := p_type;
   h_duration := p_duration;
   
   h_full_name := NULL;
   --trace_printf("h_type: %d\n", h_type);
   --to get the default state for each type
   h_temp_sc_state := groupType(Coalesce(h_type, 0), h_group_type);
   
   If Coalesce(h_group_type, 0) = PMO_CNST.SC_PROJECT Then
      h_stage_id := 740;
   ElsIf Coalesce(h_group_type, 0) = PMO_CNST.SC_DELIVERABLE Then
      h_stage_id := 5470;
   ElsIf Coalesce(h_group_type, 0) = PMO_CNST.SC_TASK Then
      h_stage_id := 5500;
   Else
      h_stage_id := 740;
   End If;
   
   BEGIN
      SELECT NICK_NAME || ';' INTO h_full_name FROM RESOURCES WHERE RESOURCE_ID = p_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(122) : wbs.sql(15874) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) OR ((h_full_name IS NULL)) Then
      NULL;
   End If;
   
   If ((p_start_dt IS NOT NULL)) AND ((p_finish_dt IS NOT NULL)) Then
      h_duration := 0;
   End If;
   
   CASE p_action_type
      WHEN 1 THEN
         --Insert WBS element
         If (p_parent_id IS NULL) Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_WBS_MSP', 139+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_WBS_MSP(140) : wbs.sql(15892) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_parent_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_MSP', 142+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_MSP(143) : wbs.sql(15895) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_parent_id, True);
         End If;
         
         h_parent_id := p_parent_id;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_WBS_MSP', 149+1) THEN 
            LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_WBS_MSP(150) : wbs.sql(15902) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
         END IF; 
         BEGIN 
            EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
               INTO h_rec_status 
               Using h_parent_id; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_parent_id, True); 
         END;
         
         PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS', h_parent_id, h_max_rank);
         PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
         h_new_code := TO_CHAR(Coalesce(h_max_rank, 0));
         
         BEGIN
            SELECT PROJECT_ID, LEVEL_ID + 1, RTRIM(RANK) || h_rankBase64, 
            RTRIM(WBS_CODE) || '.' || h_new_code, MINUTE_PER_DAY, TRANSFER_FLAG, 
            START_FINISH_DATE
            INTO h_project_id, h_level_id, h_rank, 
            h_wbs_code, h_min_per_day, h_transfer_flag,
            h_start_finish_date
            FROM TMT_WBS 
            WHERE ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 179+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(180) : wbs.sql(15932) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --created at wbs but the transfer_flag of its parent is not null.
         If (h_transfer_flag IS NOT NULL) Then
            If SubStr(h_transfer_flag, 1, 1) = 'C' OR SubStr(h_transfer_flag, 1, 1) = 'W' Then
               h_transfer_flag := 'W';
            ElsIf SubStr(h_transfer_flag, 1, 1) = 'R' Then
               h_transfer_flag := 'U';
            Else
               h_transfer_flag := NULL;
            End If;
         End If;
         
         BEGIN
            SELECT CASE WHEN LENGTH(FS_CODE) > 0 THEN 1 ELSE 0 END
            INTO h_fs_flag
            FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 205+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(206) : wbs.sql(15958) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_id := SYS_GUID();
         
         If (Coalesce(p_data_flag, 0) > 7) AND (Coalesce(p_data_flag, 0) < 16) Then
            BEGIN
               INSERT INTO TMT_WBS (
               PROJECT_ID, ELEMENT_ID, ELEMENT_NAME, PARENT_ID,
               TYPE_ID, LEVEL_ID, RANK, WBS_CODE,ASSIGN_NAMES, PRIORITY, MSP_ID, BASELINE1_START,
               BASELINE1_FINISH, BASELINE1_DURATION,BASELINE1_EFFORT,MINUTE_PER_DAY, TASK_TYPE,
               CREATED_BY, TRANSFER_FLAG, REC_USER, REC_STATUS, REC_DATETIME,
               STAGE_ID, START_FINISH_DATE)
               VALUES (h_project_id, h_id, p_name,
               p_parent_id,p_type,
               h_level_id, h_rank, h_wbs_code, h_full_name,
               p_priority, p_msp_id,
               p_baseline_start, p_baseline_finish,
               p_baseline_duration, p_baseline_effort,
               h_min_per_day, p_task_type, p_rec_user,
               h_transfer_flag, p_rec_user,'L',SYSTIMESTAMP,
               h_stage_id, h_start_finish_date); --to insert tyhe default stage id for the element;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 239+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(240) : wbs.sql(15992) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            CASE p_data_flag
               WHEN 0 THEN
                  --PLANNED
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_PLANNED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 320+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(321) : wbs.sql(16073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 1 THEN
                  --SCHEDULE
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     SCHED_START,
                     SCHED_FINISH,
                     SCHED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     FORECAST_START,
                     FORECAST_FINISH,
                     FORECAST_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     Null,
                     Null,
                     0,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     Null,
                     Null,
                     0,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_SCHED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 412+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(413) : wbs.sql(16165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 2 THEN
                  --BASELINE + PLANNED
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     BASELINE1_START,
                     BASELINE1_FINISH,
                     BASELINE1_DURATION,
                     BASELINE1_EFFORT,
                     BASELINE1_SCH_DT,
                     
                     BASELINE3_START,
                     BASELINE3_FINISH,
                     BASELINE3_DURATION,
                     BASELINE3_EFFORT,
                     BASELINE3_SCH_DT,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_PLANNED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 515+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(516) : wbs.sql(16268) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 3 THEN
                  --BASELINE + SCHEDULE
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     SCHED_START,
                     SCHED_FINISH,
                     SCHED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     FORECAST_START,
                     FORECAST_FINISH,
                     FORECAST_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     BASELINE1_START,
                     BASELINE1_FINISH,
                     BASELINE1_DURATION,
                     BASELINE1_EFFORT,
                     BASELINE1_SCH_DT,
                     BASELINE3_START,
                     BASELINE3_FINISH,
                     BASELINE3_DURATION,
                     BASELINE3_EFFORT,
                     BASELINE3_SCH_DT,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     Null,
                     Null,
                     0,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     Null,
                     Null,
                     0,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_SCHED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 629+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(630) : wbs.sql(16382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 4 THEN
                  --ACTUAL + PLANNED  ????????
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     SD,
                     ACTUAL_START,
                     ACTUAL_FINISH,
                     ACTUAL_DURATION,
                     MILESTONE_PERCENT,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     CASE WHEN p_actual_start is not null THEN PMO_CNST.SC_UAS END,
                     p_actual_start,
                     p_actual_finish,
                     p_actual_duration,
                     p_percent_complete,
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_ACTUAL_BIT+PMO_CNST.SC_PLANNED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 719+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(720) : wbs.sql(16472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 5 THEN
                  --ACTUAL + SCHEDULE
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     SCHED_START,
                     SCHED_FINISH,
                     SCHED_DURATION,
                     FORECAST_START,
                     FORECAST_FINISH,
                     FORECAST_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     SD,
                     ACTUAL_START,
                     ACTUAL_FINISH,
                     ACTUAL_DURATION,
                     MILESTONE_PERCENT,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     Null,
                     Null,
                     0,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     Null,
                     Null,
                     0,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     CASE WHEN p_actual_start is not null THEN PMO_CNST.SC_UAS END,
                     p_actual_start,
                     p_actual_finish,
                     p_actual_duration,
                     p_percent_complete,
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_ACTUAL_BIT+PMO_CNST.SC_SCHED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 821+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(822) : wbs.sql(16574) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 6 THEN
                  --ACTUAL + BASELINE + PLANNED ????
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     BASELINE1_START,
                     BASELINE1_FINISH,
                     BASELINE1_DURATION,
                     BASELINE1_EFFORT,
                     BASELINE1_SCH_DT,
                     
                     BASELINE3_START,
                     BASELINE3_FINISH,
                     BASELINE3_DURATION,
                     BASELINE3_EFFORT,
                     BASELINE3_SCH_DT,
                     
                     SD,
                     ACTUAL_START,
                     ACTUAL_FINISH,
                     ACTUAL_DURATION,
                     MILESTONE_PERCENT,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     CASE WHEN p_actual_start is not null  THEN PMO_CNST.SC_UAS END,
                     p_actual_start,
                     p_actual_finish,
                     p_actual_duration,
                     p_percent_complete,
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_ACTUAL_BIT+PMO_CNST.SC_PLANNED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 935+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(936) : wbs.sql(16688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 7 THEN
                  --ACTUAL + BAESLINE + SCHEDULE + PROPOSED
                  BEGIN
                     INSERT INTO TMT_WBS (
                     PROJECT_ID,
                     ELEMENT_ID,
                     ELEMENT_NAME,
                     PARENT_ID,
                     TYPE_ID,
                     LEVEL_ID,
                     RANK,
                     WBS_CODE,
                     ASSIGN_NAMES,
                     PLANNED_START,
                     PLANNED_FINISH,
                     PLANNED_DURATION,
                     PROPOSED_START,
                     PROPOSED_FINISH,
                     PROPOSED_DURATION,
                     SCHED_START,
                     SCHED_FINISH,
                     SCHED_DURATION,
                     FORECAST_START,
                     FORECAST_FINISH,
                     FORECAST_DURATION,
                     CONSTRAINT_TYPE,
                     CONSTRAINT_DT,
                     PRIORITY,
                     
                     BASELINE1_START,
                     BASELINE1_FINISH,
                     BASELINE1_DURATION,
                     BASELINE1_EFFORT,
                     BASELINE1_SCH_DT,
                     
                     BASELINE3_START,
                     BASELINE3_FINISH,
                     BASELINE3_DURATION,
                     BASELINE3_EFFORT,
                     BASELINE3_SCH_DT,
                     
                     SD,
                     ACTUAL_START,
                     ACTUAL_FINISH,
                     ACTUAL_DURATION,
                     MILESTONE_PERCENT,
                     MSP_ID,
                     TRANSFER_FLAG,
                     MINUTE_PER_DAY,
                     TASK_TYPE,
                     CREATED_BY,
                     REC_USER,
                     REC_STATUS,
                     REC_DATETIME,
                     ROLLUP_BITS,
                     STAGE_ID,
                     EFFORT_DRIVEN,
                     START_FINISH_DATE)
                     VALUES (
                     h_project_id,
                     h_id,
                     p_name,
                     p_parent_id,
                     p_type,
                     h_level_id,
                     h_rank,
                     h_wbs_code,
                     h_full_name,
                     Null,
                     Null,
                     0,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     p_start_dt,
                     p_finish_dt,
                     h_duration,
                     Null,
                     Null,
                     0,
                     p_constraint_type,
                     p_constraint_date,
                     p_priority,
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     p_baseline_start,
                     p_baseline_finish,
                     p_baseline_duration,
                     p_baseline_effort,
                     SYSTIMESTAMP,
                     
                     CASE WHEN p_actual_start is not null THEN PMO_CNST.SC_UAS END,
                     p_actual_start,
                     p_actual_finish,
                     p_actual_duration,
                     p_percent_complete,
                     p_msp_id,
                     h_transfer_flag,
                     h_min_per_day,
                     p_task_type,
                     p_rec_user,
                     p_rec_user,
                     'L',
                     SYSTIMESTAMP,
                     PMO_CNST.SC_ACTUAL_BIT+PMO_CNST.SC_SCHED_BIT+PMO_CNST.SC_PROPOSED_BIT,
                     h_stage_id, --to insert tyhe default stage id for the element
                     0,
                     h_start_finish_date);
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1062+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1063) : wbs.sql(16815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               ELSE
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_MSP', 1069+1) THEN 
                     LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_MSP(1070) : wbs.sql(16822) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_MSP', 1072+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_MSP(1073) : wbs.sql(16825) : ' || SYSTIMESTAMP);
                  END IF; 
                  PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
            END CASE;
         End If;
         
         If SubStr(h_transfer_flag, 1, 1) = 'W' Then
            h_tmp_flag := 0;
            PMO_DB2M.SC_STATE := FC_INSERT_CRI_AFTER_WBS(h_parent_id, h_id, h_res_id, h_tmp_flag);
         End If;
         
         BEGIN
            SELECT
            CASE
            WHEN p_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_MANAGER
            WHEN p_type IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE) THEN PMO_CNST.SC_TASK_RESPONSIBLE
            ELSE PMO_CNST.SC_DLV_MANAGER
            END,
            CASE
            WHEN p_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 'SCPROJECTMANAGER'
            WHEN p_type IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE) THEN 'SCTASKRESPONSIBLE'
            ELSE 'SCDELIVERABLEMANAGER'
            END
            INTO h_participant, h_security_id
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1104) : wbs.sql(16856) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_temp_var := 1;
         PMO_DB2M.SC_STATE := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_res_id, h_type, h_participant
                                            , h_security_id, h_res_type, h_temp_var);
         
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO RESOURCE_ASSIGNMENTS (
            RES_ASSIGNMENT_ID,
            PROJECT_ID,
            ELEMENT_ID,
            ELEMENT_TYPE,
            RESOURCE_ID,
            PARTICIPANT,
            SECURITY_ID,
            REC_USER,TABLE_TYPE)
            VALUES(
            h_uniqueID,
            h_project_id,
            h_id,
            p_type,
            p_rec_user,
            CASE
            WHEN p_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_MANAGER
            WHEN p_type IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE) THEN PMO_CNST.SC_TASK_RESPONSIBLE
            ELSE PMO_CNST.SC_DLV_MANAGER
            END,
            CASE
            WHEN p_type IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN 'SCPROJECTMANAGER'
            WHEN p_type IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE) THEN 'SCTASKRESPONSIBLE'
            ELSE 'SCDELIVERABLEMANAGER'
            END,
            p_rec_user,
            PMO_CNST.SC_TABLE_WBS);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1152+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1153) : wbs.sql(16905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_uniqueID := SYS_GUID();
         
         BEGIN
            INSERT INTO HISTORY_WBS (
            HISTORY_ID,
            ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,
            BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,
            CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,
            DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,
            EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,
            ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,
            FD, FINISH_DT, FORECAST_BUDGET, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,
            LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,
            MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,
            PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY,
            RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,
            SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,
            TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,
            UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,
            VARIANCE,
            WBS_CODE, WORK_TODATE,
            ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,
            ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,
            ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,
            R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3
            )
            SELECT
            h_uniqueID,
            ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,
            BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,
            CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,
            DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,
            EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,
            ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,
            FD, FINISH_DT, FORECAST_BUDGET, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,
            LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,
            MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,
            PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY,
            RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,
            SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,
            TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,
            UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,
            VARIANCE,
            WBS_CODE, WORK_TODATE,
            ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,
            ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,
            ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,
            R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1217+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1218) : wbs.sql(16970) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE HISTORY_WBS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1234+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1235) : wbs.sql(16987) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If ((p_actual_start IS NOT NULL)) AND ((p_actual_finish IS NOT NULL)) Then
            h_stage_id := getCloseStage(Coalesce(h_type, 0));
            BEGIN
               UPDATE TMT_WBS SET REVISION_HISTORY = Null, STAGE_ID = h_stage_id WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1253+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1254) : wbs.sql(17006) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("SC_STATE: %d, h_type: %d, h_id: %s, h_stage_id: %d\n",SC_STATE,h_type,h_id,h_stage_id);
         Else
            BEGIN
               UPDATE TMT_WBS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1271+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1272) : wbs.sql(17024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If ((h_fs_flag IS NOT NULL)) AND (Coalesce(h_fs_flag, 0) = 1) AND (isPureWBSTask(Coalesce(
               h_type, 0))) <> 0 Then
            PMO_DB2M.SC_STATE := FC_A_WBS_TC(h_id, h_rank, h_type);
         End If;
         
      
      WHEN 2 THEN
         --Update WBS element
         h_id := p_id;
         
         If isProjectType(Coalesce(h_type, 0)) <> 0 Then
            If (BITAND(Coalesce(p_data_flag, 0), 2)) = 2 Then
               BEGIN
                  UPDATE TMT_WBS SET
                  FORECAST_START      = Null,
                  FORECAST_FINISH     = Null,
                  
                  BASELINE3_START = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                  BASELINE3_FINISH = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                  BASELINE3_DURATION = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                  BASELINE3_EFFORT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                  BASELINE3_SCH_DT = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                  
                  BASELINE2_START = BASELINE1_START,
                  BASELINE2_FINISH = BASELINE1_FINISH,
                  BASELINE2_DURATION = BASELINE1_DURATION,
                  BASELINE2_EFFORT = BASELINE1_EFFORT,
                  BASELINE2_SCH_DT = BASELINE1_SCH_DT,
                  
                  BASELINE1_START     = TO_TIMESTAMP(p_baseline_start),
                  BASELINE1_FINISH    = TO_TIMESTAMP(p_baseline_finish),
                  BASELINE1_DURATION  = p_baseline_duration,
                  BASELINE1_EFFORT    = p_baseline_effort,
                  BASELINE1_SCH_DT    = SYSTIMESTAMP,
                  
                  MILESTONE_PERCENT   = p_percent_complete,
                  PRIORITY            = p_priority,
                  MSP_ID          = p_msp_id,
                  TASK_TYPE       = p_task_type,
                  REC_USER            = p_rec_user,
                  REC_STATUS          = 'L',
                  REC_DATETIME        = SYSTIMESTAMP
                  WHERE ELEMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1330+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1331) : wbs.sql(17083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_WBS SET
                  FORECAST_START      = Null,
                  FORECAST_FINISH     = Null,
                  MILESTONE_PERCENT   = p_percent_complete,
                  PRIORITY            = p_priority,
                  MSP_ID          = p_msp_id,
                  TASK_TYPE       = p_task_type,
                  REC_USER            = p_rec_user,
                  REC_STATUS          = 'L',
                  REC_DATETIME        = SYSTIMESTAMP
                  WHERE ELEMENT_ID = h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1357+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1358) : wbs.sql(17110) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            CASE p_data_flag
               WHEN 0 THEN
                  --PLANNED
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1    THEN TYPE_ID ELSE p_type
                     END,
                     PLANNED_START       = p_start_dt,
                     PLANNED_FINISH      = p_finish_dt,
                     PLANNED_DURATION    = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     MSP_ID          = p_msp_id,
                     TASK_TYPE       = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1398+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1399) : wbs.sql(17151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 1 THEN
                  --SCHEDULE
                  BEGIN
                     UPDATE TMT_WBS SET
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = Null,
                     PLANNED_FINISH      = Null,
                     PLANNED_DURATION    = 0,
                     SCHED_START         = p_start_dt,
                     SCHED_FINISH        = p_finish_dt,
                     SCHED_DURATION      = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     FORECAST_DURATION   = 0,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     MSP_ID          = p_msp_id,
                     TASK_TYPE       = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1440+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1441) : wbs.sql(17193) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 2 THEN
                  --BASELINE + PLANNED
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = p_start_dt,
                     PLANNED_FINISH      = p_finish_dt,
                     PLANNED_DURATION    = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     
                     BASELINE3_START     = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                     BASELINE3_FINISH    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                     BASELINE3_DURATION  = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                     BASELINE3_EFFORT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                     BASELINE3_SCH_DT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                     
                     BASELINE2_START     = BASELINE1_START,
                     BASELINE2_FINISH    = BASELINE1_FINISH,
                     BASELINE2_DURATION  = BASELINE1_DURATION,
                     BASELINE2_EFFORT    = BASELINE1_EFFORT,
                     BASELINE2_SCH_DT    = BASELINE1_SCH_DT,
                     
                     BASELINE1_START     = p_baseline_start,
                     BASELINE1_FINISH    = p_baseline_finish,
                     BASELINE1_DURATION  = p_baseline_duration,
                     BASELINE1_EFFORT    = p_baseline_effort,
                     BASELINE1_SCH_DT    = SYSTIMESTAMP,
                     
                     MSP_ID          = p_msp_id,
                     TASK_TYPE       = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1497+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1498) : wbs.sql(17250) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 3 THEN
                  --BASELINE + SCHEDULE
                  BEGIN
                     UPDATE TMT_WBS SET
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = Null,
                     PLANNED_FINISH      = Null,
                     PLANNED_DURATION    = 0,
                     SCHED_START         = p_start_dt,
                     SCHED_FINISH        = p_finish_dt,
                     SCHED_DURATION      = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     FORECAST_DURATION   = 0,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     
                     BASELINE3_START     = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                     BASELINE3_FINISH    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                     BASELINE3_DURATION  = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                     BASELINE3_EFFORT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                     BASELINE3_SCH_DT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                     
                     BASELINE2_START     = BASELINE1_START,
                     BASELINE2_FINISH    = BASELINE1_FINISH,
                     BASELINE2_DURATION  = BASELINE1_DURATION,
                     BASELINE2_EFFORT    = BASELINE1_EFFORT,
                     BASELINE2_SCH_DT    = BASELINE1_SCH_DT,
                     
                     BASELINE1_START     = p_baseline_start,
                     BASELINE1_FINISH    = p_baseline_finish,
                     BASELINE1_DURATION  = p_baseline_duration,
                     BASELINE1_EFFORT    = p_baseline_effort,
                     BASELINE1_SCH_DT    = SYSTIMESTAMP,
                     
                     MSP_ID          = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1558+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1559) : wbs.sql(17311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               
               WHEN 4 THEN
                  --ACTUAL + PLANNED
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = p_start_dt,
                     PLANNED_FINISH      = p_finish_dt,
                     PLANNED_DURATION    = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     SD          = CASE WHEN p_actual_start is null THEN SD ELSE PMO_CNST.SC_UAS END,
                     ACTUAL_START        = p_actual_start,
                     ACTUAL_FINISH       = p_actual_finish,
                     ACTUAL_DURATION     = p_actual_duration,
                     MILESTONE_PERCENT   = p_percent_complete,
                     MSP_ID          = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1601+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1602) : wbs.sql(17354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
               
               WHEN 5 THEN
                  --ACTUAL + SCHEDULE
                  BEGIN
                     UPDATE TMT_WBS SET
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = Null,
                     PLANNED_FINISH      = Null,
                     PLANNED_DURATION    = 0,
                     SCHED_START         = p_start_dt,
                     SCHED_FINISH        = p_finish_dt,
                     SCHED_DURATION      = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     FORECAST_DURATION   = 0,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     SD          = CASE WHEN p_actual_start is null THEN SD ELSE PMO_CNST.SC_UAS END,
                     ACTUAL_START        = p_actual_start,
                     ACTUAL_FINISH       = p_actual_finish,
                     ACTUAL_DURATION     = p_actual_duration,
                     MILESTONE_PERCENT   = p_percent_complete,
                     MSP_ID          = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1649+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1650) : wbs.sql(17402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
               
               WHEN 6 THEN
                  --ACTUAL + BASELINE + PLANNED
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = p_start_dt,
                     PLANNED_FINISH      = p_finish_dt,
                     PLANNED_DURATION    = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     
                     BASELINE3_START     = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                     BASELINE3_FINISH    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                     BASELINE3_DURATION  = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                     BASELINE3_EFFORT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                     BASELINE3_SCH_DT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                     
                     BASELINE2_START     = BASELINE1_START,
                     BASELINE2_FINISH    = BASELINE1_FINISH,
                     BASELINE2_DURATION  = BASELINE1_DURATION,
                     BASELINE2_EFFORT    = BASELINE1_EFFORT,
                     BASELINE2_SCH_DT    = BASELINE1_SCH_DT,
                     
                     BASELINE1_START     = p_baseline_start,
                     BASELINE1_FINISH    = p_baseline_finish,
                     BASELINE1_DURATION  = p_baseline_duration,
                     BASELINE1_EFFORT    = p_baseline_effort,
                     BASELINE1_SCH_DT    = SYSTIMESTAMP,
                     
                     SD          = CASE WHEN p_actual_start is null THEN SD ELSE PMO_CNST.SC_UAS END,
                     ACTUAL_START        = p_actual_start,
                     ACTUAL_FINISH       = p_actual_finish,
                     ACTUAL_DURATION     = p_actual_duration,
                     MILESTONE_PERCENT   = p_percent_complete,
                     MSP_ID          = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1712+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1713) : wbs.sql(17465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
               
               WHEN 7 THEN
                  --ACTUAL + BAESLINE + SCHEDULE
                  BEGIN
                     UPDATE TMT_WBS SET
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN p_type = -1 THEN TYPE_ID ELSE p_type END,
                     PLANNED_START       = Null,
                     PLANNED_FINISH      = Null,
                     PLANNED_DURATION    = 0,
                     SCHED_START         = p_start_dt,
                     SCHED_FINISH        = p_finish_dt,
                     SCHED_DURATION      = h_duration,
                     PROPOSED_START      = p_start_dt,
                     PROPOSED_FINISH     = p_finish_dt,
                     PROPOSED_DURATION   = h_duration,
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     FORECAST_DURATION   = 0,
                     CONSTRAINT_TYPE     = p_constraint_type,
                     CONSTRAINT_DT       = p_constraint_date,
                     PRIORITY            = p_priority,
                     
                     BASELINE3_START     = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                     BASELINE3_FINISH    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                     BASELINE3_DURATION  = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                     BASELINE3_EFFORT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                     BASELINE3_SCH_DT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                     
                     BASELINE2_START     = BASELINE1_START,
                     BASELINE2_FINISH    = BASELINE1_FINISH,
                     BASELINE2_DURATION  = BASELINE1_DURATION,
                     BASELINE2_EFFORT    = BASELINE1_EFFORT,
                     BASELINE2_SCH_DT    = BASELINE1_SCH_DT,
                     
                     BASELINE1_START     = p_baseline_start,
                     BASELINE1_FINISH    = p_baseline_finish,
                     BASELINE1_DURATION  = p_baseline_duration,
                     BASELINE1_EFFORT    = p_baseline_effort,
                     BASELINE1_SCH_DT    = SYSTIMESTAMP,
                     
                     SD          = CASE WHEN p_actual_start is null THEN SD ELSE PMO_CNST.SC_UAS END,
                     ACTUAL_START        = p_actual_start,
                     ACTUAL_FINISH       = p_actual_finish,
                     ACTUAL_DURATION     = p_actual_duration,
                     MILESTONE_PERCENT   = p_percent_complete,
                     MSP_ID          = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1779+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1780) : wbs.sql(17532) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  -- IMPORTANT NOTE: case 8 and case 9 have exactly the same logic, if
                  -- you want to change the logic of case 8 or case 9, please check the other case,
                  -- in oracle we can not have a case statement without any statement.
               
               WHEN 8 THEN
                  --SUMMARY TASK
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN h_type = -1 THEN TYPE_ID ELSE p_type END,
                     PRIORITY            = p_priority,
                     MSP_ID              = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1813+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1814) : wbs.sql(17566) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  -- IMPORTANT NOTE: case 8 and case 9 have exactly the same logic, if
                  -- you want to change the logic of case 8 or case 9, please check the other case,
                  -- in oracle we can not have a case statement without any statement.
               
               WHEN 9 THEN
                  --SUMMARY TASK
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     TYPE_ID             = CASE WHEN h_type = -1 THEN TYPE_ID ELSE p_type END,
                     PRIORITY            = p_priority,
                     MSP_ID              = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1847+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1848) : wbs.sql(17600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  -- IMPORTANT NOTE: case 10 and case 11 have exactly the same logic, if
                  -- you want to change the logic of case 10 or case 11, please check the other case,
                  -- in oracle we can not have a case statement without any statement.
               
               WHEN 10 THEN
                  --SUMMARY TASK + BASELINE
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     PRIORITY            = p_priority,
                     
                     BASELINE3_START     = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                     BASELINE3_FINISH    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                     BASELINE3_DURATION  = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                     BASELINE3_EFFORT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                     BASELINE3_SCH_DT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                     
                     BASELINE2_START     = BASELINE1_START,
                     BASELINE2_FINISH    = BASELINE1_FINISH,
                     BASELINE2_DURATION  = BASELINE1_DURATION,
                     BASELINE2_EFFORT    = BASELINE1_EFFORT,
                     BASELINE2_SCH_DT    = BASELINE1_SCH_DT,
                     
                     BASELINE1_START     = p_baseline_start,
                     BASELINE1_FINISH    = p_baseline_finish,
                     BASELINE1_DURATION  = p_baseline_duration,
                     BASELINE1_EFFORT    = p_baseline_effort,
                     BASELINE1_SCH_DT    = SYSTIMESTAMP,
                     
                     MSP_ID              = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1899+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1900) : wbs.sql(17652) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  -- IMPORTANT NOTE: case 10 and case 11 have exactly the same logic, if
                  -- you want to change the logic of case 10 or case 11, please check the other case,
                  -- in oracle we can not have a case statement without any statement.
               
               WHEN 11 THEN
                  --SUMMARY TASK + BASELINE
                  BEGIN
                     UPDATE TMT_WBS SET
                     FORECAST_START      = Null,
                     FORECAST_FINISH     = Null,
                     ELEMENT_NAME        = p_name,
                     PRIORITY            = p_priority,
                     
                     BASELINE3_START     = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_start) ELSE BASELINE3_START END,
                     BASELINE3_FINISH    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN TO_TIMESTAMP(p_baseline_finish) ELSE BASELINE3_FINISH END,
                     BASELINE3_DURATION  = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_duration ELSE BASELINE3_DURATION END,
                     BASELINE3_EFFORT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN p_baseline_effort ELSE BASELINE3_EFFORT END,
                     BASELINE3_SCH_DT    = CASE WHEN BASELINE3_SCH_DT IS NuLL THEN SYSTIMESTAMP ELSE BASELINE3_SCH_DT END,
                     
                     BASELINE2_START     = BASELINE1_START,
                     BASELINE2_FINISH    = BASELINE1_FINISH,
                     BASELINE2_DURATION  = BASELINE1_DURATION,
                     BASELINE2_EFFORT    = BASELINE1_EFFORT,
                     BASELINE2_SCH_DT    = BASELINE1_SCH_DT,
                     
                     BASELINE1_START     = p_baseline_start,
                     BASELINE1_FINISH    = p_baseline_finish,
                     BASELINE1_DURATION  = p_baseline_duration,
                     BASELINE1_EFFORT    = p_baseline_effort,
                     BASELINE1_SCH_DT    = SYSTIMESTAMP,
                     
                     MSP_ID              = p_msp_id,
                     TASK_TYPE           = p_task_type,
                     REC_USER            = p_rec_user,
                     REC_STATUS          = 'L',
                     REC_DATETIME        = SYSTIMESTAMP
                     WHERE ELEMENT_ID = h_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1951+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1952) : wbs.sql(17704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
               
               ELSE
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_MSP', 1959+1) THEN 
                     LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_MSP(1960) : wbs.sql(17712) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_MSP', 1962+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_MSP(1963) : wbs.sql(17715) : ' || SYSTIMESTAMP);
                  END IF; 
                  PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
            END CASE;
         End If;
      
      ELSE
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_WBS_MSP', 1970+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_WBS_MSP(1971) : wbs.sql(17723) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_WBS_MSP', 1973+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_WBS_MSP(1974) : wbs.sql(17726) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.INVALID_PARAMS, True);
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_WBS_MSP', 1979+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_WBS_MSP(1980) : wbs.sql(17732) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, h_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1986+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1987) : wbs.sql(17739) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_WBS_MSP', 1998+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_WBS_MSP(1999) : wbs.sql(17751) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_WBS_MSP;
ALTER FUNCTION SP_WBS_MSP COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_ROLLUP ==
CREATE OR REPLACE FUNCTION SP_ROLLUP
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_cri_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_bitflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_CNSTR IS
         SELECT PROJECT_ID
         FROM TMT_WBS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND RANK LIKE h_rank
         ORDER BY LEVEL_ID DESC;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_ROLLUP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_ROLLUP'), '-- ' || SYSTIMESTAMP, ':r := SP_ROLLUP(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_ROLLUP', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_ROLLUP(30) : wbs.sql(17797) : ' || SYSTIMESTAMP);
   END IF; 

   h_project_id := p_id;
   
   If (h_project_id IS NULL) Then
      --Process the whole repository
      h_bitflag := 0;
      
      BEGIN
         SELECT '0000' || '%' INTO h_rank
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 47+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(48) : wbs.sql(17815) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      --Process on the selected proposal/project
      h_bitflag := 1;
      
      BEGIN
         SELECT RANK || '%' INTO h_rank
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(66) : wbs.sql(17833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      DECLARE 
      	nLen pls_integer :=0; 
      BEGIN 
      	If (h_rank IS NOT NULL) Then 
      		nLen := Coalesce(Length(h_rank), 0); 
      		If 1 <> 0 AND nLen <> 0 Then 
      		nLen := nLen - 1; 
      		End If; 
      	End If; 
      	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
      		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
      	End If; 
      END;
      BEGIN
         UPDATE TMT_WBS SET
         SCHED_START = FORECAST_START,
         SCHED_FINISH = FORECAST_FINISH,
         FORECAST_START = NULL,
         FORECAST_FINISH = NULL,
         FORECAST_DURATION = 0
         WHERE RANK LIKE h_rank
         AND ( FORECAST_START IS NOT NULL OR FORECAST_FINISH IS NOT NULL )
         AND h_bitflag = 1;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(106) : wbs.sql(17873) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_CNSTR;
      
      LOOP
         FETCH C_CNSTR INTO h_id;
         IF C_CNSTR%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TASK_ASSIGNMENTS SET
            FORECAST_START = NULL,
            FORECAST_FINISH = NULL,
            FORECAST_DURATION = 0
            WHERE PROJECT_ID = h_id
            AND ( FORECAST_START IS NOT NULL OR FORECAST_FINISH IS NOT NULL )
            AND h_bitflag = 1;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 142+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(143) : wbs.sql(17910) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS,PMO_CNST.SC_IGNORE_CONSTRAINT_BIT)
            WHERE PROJECT_ID = h_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(161) : wbs.sql(17928) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := FC_Rollup(h_id);
      END LOOP;
      
      BEGIN
         CLOSE C_CNSTR ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 176+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(177) : wbs.sql(17944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_ROLLUP', 183+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_ROLLUP(184) : wbs.sql(17951) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 190+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(191) : wbs.sql(17958) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_ROLLUP', 202+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_ROLLUP(203) : wbs.sql(17970) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_ROLLUP;
ALTER FUNCTION SP_ROLLUP COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_EXTEND_CAL_MSP ==
CREATE OR REPLACE FUNCTION SP_EXTEND_CAL_MSP
(
     p_id VARCHAR2
   , p_start_dt VARCHAR2
   , p_finish_dt VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_F TIMESTAMP;
   h_S TIMESTAMP;
   h_id VARCHAR2(32);
   h_duration PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_EXTEND_CAL_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_EXTEND_CAL_MSP'), '-- ' || SYSTIMESTAMP, ':r := SP_EXTEND_CAL_MSP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_start_dt || ''''
          || ', ' || '''' || p_finish_dt || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EXTEND_CAL_MSP', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_EXTEND_CAL_MSP(24) : wbs.sql(18010) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_S := p_start_dt;
   h_F := p_finish_dt;
   h_duration := 0;
   
   h_temp_sc_state := EXTEND_PRCAL(h_id, h_S, h_F, h_duration, PMO_CNST.SC_PROJECT);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_EXTEND_CAL_MSP', 34+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_EXTEND_CAL_MSP(35) : wbs.sql(18021) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(h_temp_sc_state), 'NULL') || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(Coalesce(h_temp_sc_state, 0), h_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXTEND_CAL_MSP', 42+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXTEND_CAL_MSP(43) : wbs.sql(18029) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EXTEND_CAL_MSP', 54+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EXTEND_CAL_MSP(55) : wbs.sql(18041) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_EXTEND_CAL_MSP;
ALTER FUNCTION SP_EXTEND_CAL_MSP COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION SP_CLOSE_TASK ==
CREATE OR REPLACE FUNCTION SP_CLOSE_TASK
(
     p_id VARCHAR2
   , p_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_flag VARCHAR2(1);
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_actual_effort PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CLOSE_TASK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CLOSE_TASK'), '-- ' || SYSTIMESTAMP, ':r := SP_CLOSE_TASK(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CLOSE_TASK', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CLOSE_TASK(27) : wbs.sql(18084) : ' || SYSTIMESTAMP);
   END IF; 

   h_id := p_id;
   h_rec_user := p_rec_user;
   h_flag := p_flag;
   
   BEGIN
      SELECT PROJECT_ID, WORK_TODATE, TYPE_ID INTO h_project_id, h_actual_effort, h_type_id
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLOSE_TASK', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLOSE_TASK(43) : wbs.sql(18100) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_stage_id := getCloseStage(Coalesce(h_type_id, 0));
   
   If SubStr(h_flag, 1, 1) = 'Y' Then
      If isWBSTransferedTask(Coalesce(h_type_id, 0)) <> 0 Then
         BEGIN
            UPDATE TMT_CRI
            SET CHANGE_TO_TASK = 1,
            STAGE_ID = h_stage_id
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLOSE_TASK', 66+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLOSE_TASK(67) : wbs.sql(18124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_temp_var := FC_CLOSE_EFFORT(h_id, h_rec_user);
      
      BEGIN
         UPDATE TMT_WBS
         SET FD = PMO_CNST.SC_AF,
         FORECAST_START = Null,
         FORECAST_FINISH = Null,
         FORECAST_DURATION = 0,
         STAGE_ID = h_stage_id,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLOSE_TASK', 93+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLOSE_TASK(94) : wbs.sql(18151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS
         SET FD = PMO_CNST.SC_UAF,
         STAGE_ID = 5500,
         REC_USER = h_rec_user
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLOSE_TASK', 114+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLOSE_TASK(115) : wbs.sql(18172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
   -- New Rollup
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CLOSE_TASK', 124+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CLOSE_TASK(125) : wbs.sql(18182) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLOSE_TASK', 131+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLOSE_TASK(132) : wbs.sql(18189) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CLOSE_TASK', 143+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CLOSE_TASK(144) : wbs.sql(18201) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CLOSE_TASK;
ALTER FUNCTION SP_CLOSE_TASK COMPILE DEBUG;

/********************************************/

Prompt == FUNCTION SP_U_WBS_TOOLTIP ==
CREATE OR REPLACE FUNCTION SP_U_WBS_TOOLTIP
(
     p_id VARCHAR2
   , p_name VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_id VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_TOOLTIP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_TOOLTIP'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_TOOLTIP(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TOOLTIP', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_TOOLTIP(21) : wbs.sql(18238) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_U_WBS_TOOLTIP', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_U_WBS_TOOLTIP(26) : wbs.sql(18243) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TOOLTIP', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TOOLTIP(29) : wbs.sql(18246) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   --InitializeHost(SC_PARAM(h_id), id, ind_u_prj_name->id);
   h_id := p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'SP_U_WBS_TOOLTIP', 36+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: SP_U_WBS_TOOLTIP(37) : wbs.sql(18254) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   BEGIN 
      EXECUTE IMMEDIATE 'SELECT REC_STATUS INTO :r FROM ' || 'TMT_WBS' || ' WHERE ELEMENT_ID = :i' 
         INTO h_rec_status 
         Using h_id; 
   EXCEPTION 
      WHEN NO_DATA_FOUND THEN 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, h_id, True); 
   END;
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_TOOLTIP', 49+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_TOOLTIP(50) : wbs.sql(18267) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_TOOLTIP', 52+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_TOOLTIP(53) : wbs.sql(18270) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_id, True);
   End If;
   
   BEGIN
      UPDATE TMT_WBS SET TOOLTIP_DESCR = p_name WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TOOLTIP', 69+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TOOLTIP(70) : wbs.sql(18287) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_TOOLTIP', 75+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_TOOLTIP(76) : wbs.sql(18293) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TOOLTIP', 83+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TOOLTIP(84) : wbs.sql(18301) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_TOOLTIP', 95+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_TOOLTIP(96) : wbs.sql(18313) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_TOOLTIP;
ALTER FUNCTION SP_U_WBS_TOOLTIP COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_CAN_LOCK ==
CREATE OR REPLACE FUNCTION SP_CAN_LOCK
(
     p_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rank VARCHAR2(200);
   h_uniqueID VARCHAR2(32);
   h_type PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_LCK IS
         SELECT ELEMENT_ID
         FROM TMT_WBS WHERE REC_STATUS = 'L' AND (SUBSTR(h_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_rank, 1, 8) || '%'));

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CAN_LOCK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CAN_LOCK'), '-- ' || SYSTIMESTAMP, ':r := SP_CAN_LOCK(' || 
       '''' || p_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAN_LOCK', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CAN_LOCK(23) : wbs.sql(18352) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   BEGIN
      SELECT RANK, CASE WHEN REC_STATUS IN ('L','D') THEN 1 ELSE 0 END INTO h_rank, h_type
      FROM TMT_WBS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_LOCK', 37+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_LOCK(38) : wbs.sql(18367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If isProjectType(Coalesce(h_type, 0)) <> 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CAN_LOCK', 45+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CAN_LOCK(46) : wbs.sql(18375) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(1), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAN_LOCK', 48+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_CAN_LOCK(49) : wbs.sql(18378) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(1, p_id, True);
      End If;
      
      If Coalesce(Length(h_rank), 0) > 8 Then
         OPEN C_LCK;
         
         FETCH C_LCK INTO h_uniqueID;
         IF C_LCK%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
            BEGIN
               CLOSE C_LCK ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_LOCK', 72+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_LOCK(73) : wbs.sql(18402) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_CAN_LOCK', 77+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_CAN_LOCK(78) : wbs.sql(18407) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(1), 'NULL') || ' ID: ' || '''' || p_id || '''');
            END IF; 
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CAN_LOCK', 80+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_CAN_LOCK(81) : wbs.sql(18410) : ' || SYSTIMESTAMP);
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR_SP(1, p_id, True);
         Else
            BEGIN
               CLOSE C_LCK ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_LOCK', 92+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_LOCK(93) : wbs.sql(18422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_CAN_LOCK', 100+1) THEN 
         LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_CAN_LOCK(101) : wbs.sql(18430) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_LOCK', 109+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_LOCK(110) : wbs.sql(18439) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CAN_LOCK', 121+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CAN_LOCK(122) : wbs.sql(18451) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CAN_LOCK;
ALTER FUNCTION SP_CAN_LOCK COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_PUBLISH_BUBBLE ==
CREATE OR REPLACE FUNCTION SP_PUBLISH_BUBBLE
(
     p_id VARCHAR2
   , p_bubble_color PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PUBLISH_BUBBLE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PUBLISH_BUBBLE'), '-- ' || SYSTIMESTAMP, ':r := SP_PUBLISH_BUBBLE(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bubble_color), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PUBLISH_BUBBLE', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PUBLISH_BUBBLE(19) : wbs.sql(18486) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PUBLISH_BUBBLE', 23+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PUBLISH_BUBBLE(24) : wbs.sql(18491) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PUBLISH_BUBBLE', 26+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PUBLISH_BUBBLE(27) : wbs.sql(18494) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      UPDATE TMT_WBS SET
      BUBBLE_COLOR = p_bubble_color,
      BUBBLE_PUBLISHED_DT = SYSTIMESTAMP
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PUBLISH_BUBBLE', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PUBLISH_BUBBLE(49) : wbs.sql(18516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_PUBLISH_BUBBLE', 54+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_PUBLISH_BUBBLE(55) : wbs.sql(18522) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PUBLISH_BUBBLE', 62+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PUBLISH_BUBBLE(63) : wbs.sql(18530) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PUBLISH_BUBBLE', 74+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PUBLISH_BUBBLE(75) : wbs.sql(18542) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PUBLISH_BUBBLE;
ALTER FUNCTION SP_PUBLISH_BUBBLE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION SP_PUBLISH_PRIORITY ==
CREATE OR REPLACE FUNCTION SP_PUBLISH_PRIORITY
(
     p_id VARCHAR2
   , p_priority PLS_INTEGER
   , p_stage PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PUBLISH_PRIORITY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PUBLISH_PRIORITY'), '-- ' || SYSTIMESTAMP, ':r := SP_PUBLISH_PRIORITY(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_priority), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_stage), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PUBLISH_PRIORITY', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PUBLISH_PRIORITY(21) : wbs.sql(18579) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PUBLISH_PRIORITY', 25+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PUBLISH_PRIORITY(26) : wbs.sql(18584) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.ELEMENT_ID_REQUIRED), 'NULL'));
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PUBLISH_PRIORITY', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_PUBLISH_PRIORITY(29) : wbs.sql(18587) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID_SP(PMO_CNST.ELEMENT_ID_REQUIRED, True);
   End If;
   
   -- Declare host variables
   
   BEGIN
      UPDATE TMT_WBS SET
      PRIORITY = p_priority,
      STAGE_ID = p_stage
      WHERE ELEMENT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PUBLISH_PRIORITY', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PUBLISH_PRIORITY(51) : wbs.sql(18609) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_PUBLISH_PRIORITY', 56+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_PUBLISH_PRIORITY(57) : wbs.sql(18615) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PUBLISH_PRIORITY', 64+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PUBLISH_PRIORITY(65) : wbs.sql(18623) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PUBLISH_PRIORITY', 76+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PUBLISH_PRIORITY(77) : wbs.sql(18635) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PUBLISH_PRIORITY;
ALTER FUNCTION SP_PUBLISH_PRIORITY COMPILE DEBUG;

/****************project details****************/

Prompt == FUNCTION SP_S_PROJ_RTFBITS ==
CREATE OR REPLACE FUNCTION SP_S_PROJ_RTFBITS
(
     p_id VARCHAR2
   , p_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_S_PRJ_RTFBITS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_S_PROJ_RTFBITS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_S_PROJ_RTFBITS'), '-- ' || SYSTIMESTAMP, ':r := SP_S_PROJ_RTFBITS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJ_RTFBITS', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_S_PROJ_RTFBITS(20) : wbs.sql(18671) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_S_PROJ_RTFBITS', 24+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_S_PROJ_RTFBITS(25) : wbs.sql(18676) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJ_RTFBITS', 27+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJ_RTFBITS(28) : wbs.sql(18679) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   OPEN C_S_PRJ_RTFBITS FOR SELECT  PROJECT_ID AS ELEMENT_ID, PROJECT_RTF_BITS, PROJECT_RTF_BITS2, DELIVERABLE_RTF_BITS,WORK_PRODUCT_RTF_BITS,
   SUMMARY_TASK_RTF_BITS,MILESTONE_RTF_BITS,TASK_RTF_BITS,REQUIREMENT_RTF_BITS,
   CHANGE_REQUEST_RTF_BITS,SERVICE_REQUEST_RTF_BITS,
   DEFECT_RTF_BITS,ISSUE_RTF_BITS,RISK_RTF_BITS,
   CRI_DELIVERABLE_RTF_BITS,CRI_SUMMARY_TASK_RTF_BITS,
   CRI_MILESTONE_RTF_BITS,CRI_TASK_RTF_BITS,
   DOCUMENT_RTF_BITS, ACTIONITEM_RTF_BITS,
   URL_1, URL_2, URL_3, URL_4, URL_5, BUDGET_SETTING_BITS, DLV_BUDGET_SETTING_BITS,TIMEPHASE_PROJECT_ASSIGNMENT,
   NOTEMIN_RTF_BITS,SCORECARD_RTF_BITS,ENABLE_EV_CALCULATION,CHARGEBACK_FORMULA,
   ROLLUP_PROJECT_ESTIMATED, ROLLUP_DELIVERABLE_ESTIMATED,
   NOTIFY_TM_REJECTED, NOTIFY_TM_ACCEPTED, NOTIFY_PM_SUBMITTED, NOTIFY_RM_SUBMITTED, NOTIFY_RM_ACCEPTED,
   ASSIGNMENT_BILLABLE_FLAG, LEVEL_START_FINISH_DATE, COPY_CRI_CONSIDER_ASSIGNMENTS, COPY_CRI_ADOPT_PARTICIPANTS, ATTACHMENT_VIEW_BITS, RUP_HOME_PATH
   FROM PROJECT_DETAILS
   WHERE PROJECT_ID = p_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_S_PROJ_RTFBITS', 47+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_S_PROJ_RTFBITS(48) : wbs.sql(18699) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_S_PRJ_RTFBITS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJ_RTFBITS', 55+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJ_RTFBITS(56) : wbs.sql(18707) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_S_PROJ_RTFBITS', 67+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_S_PROJ_RTFBITS(68) : wbs.sql(18719) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_S_PROJ_RTFBITS;
ALTER FUNCTION SP_S_PROJ_RTFBITS COMPILE DEBUG;

/********************************************************/

Prompt == FUNCTION SP_U_PROJ_URL ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_URL
(
     p_id VARCHAR2
   , p_url_1 VARCHAR2
   , p_url_2 VARCHAR2
   , p_url_3 VARCHAR2
   , p_url_4 VARCHAR2
   , p_url_5 VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_URL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_URL'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_URL(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_url_1 || ''''
          || ', ' || '''' || p_url_2 || ''''
          || ', ' || '''' || p_url_3 || ''''
          || ', ' || '''' || p_url_4 || ''''
          || ', ' || '''' || p_url_5 || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_URL', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_URL(27) : wbs.sql(18762) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PROJ_URL', 31+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PROJ_URL(32) : wbs.sql(18767) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_URL', 34+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_URL(35) : wbs.sql(18770) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   BEGIN
      UPDATE  PROJECT_DETAILS
      SET
      URL_1 = p_url_1,
      URL_2 = p_url_2,
      URL_3 = p_url_3,
      URL_4 = p_url_4,
      URL_5 = p_url_5
      WHERE PROJECT_ID =  p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_URL', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_URL(59) : wbs.sql(18794) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_URL', 64+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_URL(65) : wbs.sql(18800) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_URL', 72+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_URL(73) : wbs.sql(18808) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_URL', 84+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_URL(85) : wbs.sql(18820) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_URL;
ALTER FUNCTION SP_U_PROJ_URL COMPILE DEBUG;

/**********************************************/

Prompt == FUNCTION SP_U_PROJ_RTFBITS ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_RTFBITS
(
     p_id VARCHAR2
   , p_project_rtf_bits PLS_INTEGER
   , p_project_rtf_bits2 PLS_INTEGER
   , p_deliverable_rtf_bits PLS_INTEGER
   , p_work_product_rtf_bits PLS_INTEGER
   , p_summary_task_rtf_bits PLS_INTEGER
   , p_milestone_rtf_bits PLS_INTEGER
   , p_task_rtf_bits PLS_INTEGER
   , p_requirement_rtf_bits PLS_INTEGER
   , p_change_request_rtf_bits PLS_INTEGER
   , p_service_request_rtf_bits PLS_INTEGER
   , p_defect_rtf_bits PLS_INTEGER
   , p_issue_rtf_bits PLS_INTEGER
   , p_risk_rtf_bits PLS_INTEGER
   , p_cri_deliverable_rtf_bits PLS_INTEGER
   , p_cri_summary_task_rtf_bits PLS_INTEGER
   , p_cri_milestone_rtf_bits PLS_INTEGER
   , p_cri_task_rtf_bits PLS_INTEGER
   , p_document_rtf_bits PLS_INTEGER
   , p_actionitem_rtf_bits PLS_INTEGER
   , p_noteminute_rtf_bits PLS_INTEGER
   , p_scorecard_rtf_bits PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_RTFBITS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_RTFBITS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_RTFBITS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_project_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_project_rtf_bits2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_deliverable_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_work_product_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_summary_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_milestone_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_requirement_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_change_request_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_service_request_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_defect_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_issue_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_risk_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_deliverable_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_summary_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_milestone_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_document_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actionitem_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_noteminute_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_scorecard_rtf_bits), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_RTFBITS', 58+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_RTFBITS(59) : wbs.sql(18895) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PROJ_RTFBITS', 63+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PROJ_RTFBITS(64) : wbs.sql(18900) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_RTFBITS', 66+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_RTFBITS(67) : wbs.sql(18903) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   BEGIN
      UPDATE  PROJECT_DETAILS
      SET
      PROJECT_RTF_BITS = p_project_rtf_bits,
      PROJECT_RTF_BITS2 = p_project_rtf_bits2,
      DELIVERABLE_RTF_BITS =p_deliverable_rtf_bits,
      WORK_PRODUCT_RTF_BITS = p_work_product_rtf_bits,
      SUMMARY_TASK_RTF_BITS = p_summary_task_rtf_bits,
      MILESTONE_RTF_BITS = p_milestone_rtf_bits,
      TASK_RTF_BITS = p_task_rtf_bits,
      REQUIREMENT_RTF_BITS = p_requirement_rtf_bits,
      CHANGE_REQUEST_RTF_BITS = p_change_request_rtf_bits,
      SERVICE_REQUEST_RTF_BITS = p_service_request_rtf_bits,
      DEFECT_RTF_BITS = p_defect_rtf_bits,
      ISSUE_RTF_BITS = p_issue_rtf_bits,
      RISK_RTF_BITS = p_risk_rtf_bits,
      CRI_DELIVERABLE_RTF_BITS = p_cri_deliverable_rtf_bits,
      CRI_SUMMARY_TASK_RTF_BITS = p_cri_summary_task_rtf_bits,
      CRI_MILESTONE_RTF_BITS = p_cri_milestone_rtf_bits,
      CRI_TASK_RTF_BITS = p_cri_task_rtf_bits,
      DOCUMENT_RTF_BITS = p_document_rtf_bits,
      ACTIONITEM_RTF_BITS = p_actionitem_rtf_bits,
      NOTEMIN_RTF_BITS = p_noteminute_rtf_bits,
      SCORECARD_RTF_BITS = p_scorecard_rtf_bits
      WHERE PROJECT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_RTFBITS', 106+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_RTFBITS(107) : wbs.sql(18943) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_RTFBITS', 112+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_RTFBITS(113) : wbs.sql(18949) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_RTFBITS', 120+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_RTFBITS(121) : wbs.sql(18957) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_RTFBITS', 132+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_RTFBITS(133) : wbs.sql(18969) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_RTFBITS;
ALTER FUNCTION SP_U_PROJ_RTFBITS COMPILE DEBUG;

/********************************************************/

Prompt == FUNCTION SP_U_PROJ_BUDGETBITS ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_BUDGETBITS
(
     p_id VARCHAR2
   , p_budget_setting_bits PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_BUDGETBITS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_BUDGETBITS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_BUDGETBITS(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_budget_setting_bits), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_BUDGETBITS', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_BUDGETBITS(19) : wbs.sql(19004) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PROJ_BUDGETBITS', 23+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PROJ_BUDGETBITS(24) : wbs.sql(19009) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_BUDGETBITS', 26+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_BUDGETBITS(27) : wbs.sql(19012) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   BEGIN
      UPDATE  PROJECT_DETAILS
      SET BUDGET_SETTING_BITS = p_budget_setting_bits
      WHERE PROJECT_ID = p_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BUDGETBITS', 45+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BUDGETBITS(46) : wbs.sql(19031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_BUDGETBITS', 51+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_BUDGETBITS(52) : wbs.sql(19037) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BUDGETBITS', 59+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BUDGETBITS(60) : wbs.sql(19045) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BUDGETBITS', 71+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BUDGETBITS(72) : wbs.sql(19057) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_BUDGETBITS;
ALTER FUNCTION SP_U_PROJ_BUDGETBITS COMPILE DEBUG;

/*********************************************************************/

Prompt == FUNCTION SP_U_DEFAULT_PROJECT ==
CREATE OR REPLACE FUNCTION SP_U_DEFAULT_PROJECT
(
     p_id VARCHAR2
   , p_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_default_project VARCHAR2(32);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_DEFAULT_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_DEFAULT_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_DEFAULT_PROJECT(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEFAULT_PROJECT', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_DEFAULT_PROJECT(24) : wbs.sql(19097) : ' || SYSTIMESTAMP);
   END IF; 

   -- flag
   --1 define as default
   --2 undefine
   --3 change default project
   
   -- Declare host variables
   
   h_default_project := PMO_CNST.SC_DEFAULT_PROJECT;
   h_id := p_id;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT REC_STATUS INTO h_rec_status
      FROM TMT_WBS
      WHERE ELEMENT_ID = p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_PROJECT', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_PROJECT(48) : wbs.sql(19121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_DEFAULT_PROJECT', 54+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_DEFAULT_PROJECT(55) : wbs.sql(19128) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_DEFAULT_PROJECT', 57+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_DEFAULT_PROJECT(58) : wbs.sql(19131) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   BEGIN
      SELECT RTRIM(ELEMENT_NAME) INTO h_project_id
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = h_default_project;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_PROJECT', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_PROJECT(73) : wbs.sql(19146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(p_flag, 0) = 2 Then
      h_id := NULL;
   End If;
   
   BEGIN
      UPDATE TMT_SETTINGS
      SET ELEMENT_NAME  = h_id
      WHERE ELEMENT_ID = h_default_project;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_PROJECT', 95+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_PROJECT(96) : wbs.sql(19169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_DEFAULT_PROJECT', 101+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_DEFAULT_PROJECT(102) : wbs.sql(19175) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_PROJECT', 108+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_PROJECT(109) : wbs.sql(19182) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_DEFAULT_PROJECT', 120+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_DEFAULT_PROJECT(121) : wbs.sql(19194) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_DEFAULT_PROJECT;
ALTER FUNCTION SP_U_DEFAULT_PROJECT COMPILE DEBUG;

/*********************************************************************/

Prompt == FUNCTION SP_U_TIMEPHASE_ASSIGNMENT ==
CREATE OR REPLACE FUNCTION SP_U_TIMEPHASE_ASSIGNMENT
(
     p_id VARCHAR2
   , p_timephase_flag VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_pa_timephase VARCHAR2(1);
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_TIMEPHASE_ASSIGNMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_TIMEPHASE_ASSIGNMENT'), '-- ' || SYSTIMESTAMP, ':r := SP_U_TIMEPHASE_ASSIGNMENT(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_timephase_flag || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_TIMEPHASE_ASSIGNMENT', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_TIMEPHASE_ASSIGNMENT(22) : wbs.sql(19232) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_project_id := p_id;
   h_pa_timephase := p_timephase_flag;
   
   BEGIN
      UPDATE PROJECT_DETAILS
      SET TIMEPHASE_PROJECT_ASSIGNMENT  = p_timephase_flag
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMEPHASE_ASSIGNMENT', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMEPHASE_ASSIGNMENT(44) : wbs.sql(19254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
      If SubStr(h_pa_timephase, 1, 1) = 'N' Then
         BEGIN
            UPDATE BUDGETS SET TIMEPHASED_FLAG = 0, ESTIMATED_BUDGET = 0.00, ESTIMATED_ETC = 0.00
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id
            AND CAPITAL_EXPENSE > PMO_CNST.SC_TIMEPHASE_CALENDAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMEPHASE_ASSIGNMENT', 65+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMEPHASE_ASSIGNMENT(66) : wbs.sql(19276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         /*              BEGIN_SQL
                         DELETE FROM TIMEPHASED_DELTA WHERE PROJECT_ID = HOST(h_project_id) AND ELEMENT_ID = HOST(h_project_id) AND BUDGET_TYPE = SC_ESTIMATED_BUDGET;
                     END_SQL;*/
         
         BEGIN
            DELETE FROM PROJECT_BUDGET_BREAKDOWN WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMEPHASE_ASSIGNMENT', 86+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMEPHASE_ASSIGNMENT(87) : wbs.sql(19297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE BUDGETS SET TIMEPHASED_FLAG = 1
            WHERE PROJECT_ID = h_project_id
            AND ELEMENT_ID = h_project_id
            AND CAPITAL_EXPENSE > PMO_CNST.SC_TIMEPHASE_CALENDAR;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMEPHASE_ASSIGNMENT', 106+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMEPHASE_ASSIGNMENT(107) : wbs.sql(19317) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_TIMEPHASE_ASSIGNMENT', 115+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_TIMEPHASE_ASSIGNMENT(116) : wbs.sql(19326) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMEPHASE_ASSIGNMENT', 122+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMEPHASE_ASSIGNMENT(123) : wbs.sql(19333) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_TIMEPHASE_ASSIGNMENT', 134+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_TIMEPHASE_ASSIGNMENT(135) : wbs.sql(19345) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_TIMEPHASE_ASSIGNMENT;
ALTER FUNCTION SP_U_TIMEPHASE_ASSIGNMENT COMPILE DEBUG;

/******************************************************************************/

Prompt == FUNCTION SP_U_PROJ_BITS ==
CREATE OR REPLACE FUNCTION SP_U_PROJ_BITS
(
     p_id VARCHAR2
   , p_timephase_flag VARCHAR2
   , p_url_1 VARCHAR2
   , p_url_2 VARCHAR2
   , p_url_3 VARCHAR2
   , p_url_4 VARCHAR2
   , p_url_5 VARCHAR2
   , p_project_rtf_bits PLS_INTEGER
   , p_project_rtf_bits2 PLS_INTEGER
   , p_deliverable_rtf_bits PLS_INTEGER
   , p_work_product_rtf_bits PLS_INTEGER
   , p_summary_task_rtf_bits PLS_INTEGER
   , p_milestone_rtf_bits PLS_INTEGER
   , p_task_rtf_bits PLS_INTEGER
   , p_requirement_rtf_bits PLS_INTEGER
   , p_change_request_rtf_bits PLS_INTEGER
   , p_service_request_rtf_bits PLS_INTEGER
   , p_defect_rtf_bits PLS_INTEGER
   , p_issue_rtf_bits PLS_INTEGER
   , p_risk_rtf_bits PLS_INTEGER
   , p_cri_deliverable_rtf_bits PLS_INTEGER
   , p_cri_summary_task_rtf_bits PLS_INTEGER
   , p_cri_milestone_rtf_bits PLS_INTEGER
   , p_cri_task_rtf_bits PLS_INTEGER
   , p_document_rtf_bits PLS_INTEGER
   , p_actionitem_rtf_bits PLS_INTEGER
   , p_noteminute_rtf_bits PLS_INTEGER
   , p_scorecard_rtf_bits PLS_INTEGER
   , p_budget_setting_bits PLS_INTEGER
   , p_enable_ev_calculation PLS_INTEGER
   , p_chargeback_formula PLS_INTEGER
   , p_RollupProjectEstimated PLS_INTEGER
   , p_RollupDeliverableEstimated PLS_INTEGER
   , p_notify_tm_rejected VARCHAR2
   , p_notify_tm_accepted VARCHAR2
   , p_notify_pm_submitted VARCHAR2
   , p_notify_rm_submitted VARCHAR2
   , p_notify_rm_accepted VARCHAR2
   , p_assignment_billable_flag PLS_INTEGER
   , p_def_cri_consider_assign VARCHAR2
   , p_def_cri_adopt_participants VARCHAR2
   , p_dlv_budget_setting_bits PLS_INTEGER
   , p_attachment_view_bits PLS_INTEGER
   , p_rup_home_path VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_pa_timephase VARCHAR2(1);
   h_timephase_flag VARCHAR2(1);
   h_tsk_assignment_id VARCHAR2(32);
   h_FD DATE;
   h_SD DATE;
   h_billable PLS_INTEGER := 0;
   h_capital_expense PLS_INTEGER := 0;
   h_tph_delete PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_reg_cost NUMBER := 0.00;
   h_reg_sale NUMBER := 0.00;
   h_wbs_rollup_project_bit PLS_INTEGER := 0;
   h_wbs_rollup_del_bit PLS_INTEGER := 0;
   h_old_RollupProjectEst PLS_INTEGER := 0;
   h_old_RollupDeliverableEst PLS_INTEGER := 0;
   h_new_RollupProjectEst PLS_INTEGER := 0;
   h_new_RollupDeliverableEst PLS_INTEGER := 0;
   h_attachment_view_bits PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PA IS
         SELECT TSK_ASSIGNMENT_ID, CASE WHEN BIT_FLAG = '2' THEN TO_DATE(SubStr(SCHED_START, 1, 10)) ELSE TO_DATE(SubStr(PLANNED_START, 1, 10)) END,
         CASE WHEN BIT_FLAG = '2' THEN TO_DATE(SubStr(SCHED_FINISH, 1, 10)) ELSE TO_DATE(SubStr(PLANNED_FINISH, 1, 10)) END, BILLABLE, CAPITAL_EXPENSE, REGULAR_COST, REGULAR_RATE
         FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_PROJ_BITS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_PROJ_BITS'), '-- ' || SYSTIMESTAMP, ':r := SP_U_PROJ_BITS(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_timephase_flag || ''''
          || ', ' || '''' || p_url_1 || ''''
          || ', ' || '''' || p_url_2 || ''''
          || ', ' || '''' || p_url_3 || ''''
          || ', ' || '''' || p_url_4 || ''''
          || ', ' || '''' || p_url_5 || ''''
          || ', ' || COALESCE(TO_CHAR(p_project_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_project_rtf_bits2), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_deliverable_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_work_product_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_summary_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_milestone_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_requirement_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_change_request_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_service_request_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_defect_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_issue_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_risk_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_deliverable_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_summary_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_milestone_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_cri_task_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_document_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_actionitem_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_noteminute_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_scorecard_rtf_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_budget_setting_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_enable_ev_calculation), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_chargeback_formula), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_RollupProjectEstimated), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_RollupDeliverableEstimated), 'NULL')
          || ', ' || '''' || p_notify_tm_rejected || ''''
          || ', ' || '''' || p_notify_tm_accepted || ''''
          || ', ' || '''' || p_notify_pm_submitted || ''''
          || ', ' || '''' || p_notify_rm_submitted || ''''
          || ', ' || '''' || p_notify_rm_accepted || ''''
          || ', ' || COALESCE(TO_CHAR(p_assignment_billable_flag), 'NULL')
          || ', ' || '''' || p_def_cri_consider_assign || ''''
          || ', ' || '''' || p_def_cri_adopt_participants || ''''
          || ', ' || COALESCE(TO_CHAR(p_dlv_budget_setting_bits), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_attachment_view_bits), 'NULL')
          || ', ' || '''' || p_rup_home_path || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_BITS', 127+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_PROJ_BITS(128) : wbs.sql(19489) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_PROJ_BITS', 132+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_PROJ_BITS(133) : wbs.sql(19494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_PROJ_BITS', 135+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_PROJ_BITS(136) : wbs.sql(19497) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   -- local variables for ROLLUP_PROJECT_ESTIMATED, ROLLUP_DELIVERABLE_ESTIMATED old values
   
   -- local variables for ROLLUP_PROJECT_ESTIMATED, ROLLUP_DELIVERABLE_ESTIMATED new values
   
   -- copy new values
   h_new_RollupProjectEst := p_RollupProjectEstimated;
   h_new_RollupDeliverableEst := p_RollupDeliverableEstimated;
   h_timephase_flag := p_timephase_flag;
   h_project_id := p_id;
   h_attachment_view_bits := p_attachment_view_bits;
   
   -- fetch RollupProjectEstimated and RollupDeliverableEstimated old values
   BEGIN
      SELECT TIMEPHASE_PROJECT_ASSIGNMENT, ROLLUP_PROJECT_ESTIMATED, ROLLUP_DELIVERABLE_ESTIMATED
      INTO  h_pa_timephase, h_old_RollupProjectEst, h_old_RollupDeliverableEst
      FROM PROJECT_DETAILS
      WHERE PROJECT_ID =  p_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(164) : wbs.sql(19525) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Rule: if the new values of ROLLUP_PROJECT_ESTIMATED, ROLLUP_DELIVERABLE_ESTIMATED or TIMEPHASE_PROJECT_ASSIGNMENT
   -- differes from the old values then set ROLLUP_BITS in TMT_WBS
   h_wbs_rollup_project_bit := PMO_CNST.SC_ASSIGNMENT_BIT;
   h_wbs_rollup_del_bit := PMO_CNST.SC_ASSIGNMENT_BIT;
   
   -- the new and old values are the same , then dont change the value
   If (Coalesce(h_old_RollupProjectEst, 0) = Coalesce(h_new_RollupProjectEst, 0)) 
                                                   AND (PMO_ORASTD.strcmp(h_pa_timephase
                                                   , h_timephase_flag) = PMO_CNST.SC_MATCH) Then
      h_wbs_rollup_project_bit := -1;
   End If;
   -- -1 means dont update TMT_WBS.ROLLUP_BITS field at project level
   
   If Coalesce(h_old_RollupDeliverableEst, 0) = Coalesce(h_new_RollupDeliverableEst, 0) Then
      h_wbs_rollup_del_bit := -1;
   End If;
   -- -1 means dont update TMT_WBS.ROLLUP_BITS field at deliverable level
   
   If PMO_ORASTD.strcmp(h_pa_timephase, h_timephase_flag) <> PMO_CNST.SC_MATCH Then
      h_wbs_rollup_project_bit := PMO_CNST.SC_ASSIGNMENT_BIT;
   End If;
   
   If PMO_ORASTD.strcmp(h_pa_timephase, h_timephase_flag) = PMO_CNST.SC_MATCH Then
      BEGIN
         UPDATE  PROJECT_DETAILS
         SET ATTACHMENT_VIEW_BITS = h_attachment_view_bits,
         RUP_HOME_PATH = p_rup_home_path,
         URL_1 = p_url_1,
         URL_2 = p_url_2,
         URL_3 = p_url_3,
         URL_4 = p_url_4,
         URL_5 = p_url_5,
         PROJECT_RTF_BITS = p_project_rtf_bits,
         PROJECT_RTF_BITS2 = p_project_rtf_bits2,
         DELIVERABLE_RTF_BITS =p_deliverable_rtf_bits,
         WORK_PRODUCT_RTF_BITS = p_work_product_rtf_bits,
         SUMMARY_TASK_RTF_BITS = p_summary_task_rtf_bits,
         MILESTONE_RTF_BITS = p_milestone_rtf_bits,
         TASK_RTF_BITS = p_task_rtf_bits,
         REQUIREMENT_RTF_BITS = p_requirement_rtf_bits,
         CHANGE_REQUEST_RTF_BITS = p_change_request_rtf_bits,
         SERVICE_REQUEST_RTF_BITS = p_service_request_rtf_bits,
         DEFECT_RTF_BITS = p_defect_rtf_bits,
         ISSUE_RTF_BITS = p_issue_rtf_bits,
         RISK_RTF_BITS = p_risk_rtf_bits,
         CRI_DELIVERABLE_RTF_BITS = p_cri_deliverable_rtf_bits,
         CRI_SUMMARY_TASK_RTF_BITS = p_cri_summary_task_rtf_bits,
         CRI_MILESTONE_RTF_BITS = p_cri_milestone_rtf_bits,
         CRI_TASK_RTF_BITS = p_cri_task_rtf_bits,
         DOCUMENT_RTF_BITS = p_document_rtf_bits,
         ACTIONITEM_RTF_BITS = p_actionitem_rtf_bits,
         NOTEMIN_RTF_BITS = p_noteminute_rtf_bits,
         SCORECARD_RTF_BITS = p_scorecard_rtf_bits,
         BUDGET_SETTING_BITS = p_budget_setting_bits,
         ENABLE_EV_CALCULATION = p_enable_ev_calculation,
         CHARGEBACK_FORMULA = p_chargeback_formula,
         ROLLUP_PROJECT_ESTIMATED = h_new_RollupProjectEst,
         ROLLUP_DELIVERABLE_ESTIMATED = h_new_RollupDeliverableEst,
         NOTIFY_TM_REJECTED  = p_notify_tm_rejected,
         NOTIFY_TM_ACCEPTED  = p_notify_tm_accepted,
         NOTIFY_PM_SUBMITTED = p_notify_pm_submitted,
         NOTIFY_RM_SUBMITTED = p_notify_rm_submitted,
         NOTIFY_RM_ACCEPTED = p_notify_rm_accepted,
         COPY_CRI_CONSIDER_ASSIGNMENTS = p_def_cri_consider_assign,
         COPY_CRI_ADOPT_PARTICIPANTS = p_def_cri_adopt_participants,
         ASSIGNMENT_BILLABLE_FLAG = p_assignment_billable_flag,
         DLV_BUDGET_SETTING_BITS = p_dlv_budget_setting_bits
         WHERE PROJECT_ID =  p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 246+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(247) : wbs.sql(19608) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE  PROJECT_DETAILS
         SET ATTACHMENT_VIEW_BITS = h_attachment_view_bits,
         TIMEPHASE_PROJECT_ASSIGNMENT  = p_timephase_flag,
         RUP_HOME_PATH = p_rup_home_path,
         URL_1 = p_url_1,
         URL_2 = p_url_2,
         URL_3 = p_url_3,
         URL_4 = p_url_4,
         URL_5 = p_url_5,
         PROJECT_RTF_BITS = p_project_rtf_bits,
         PROJECT_RTF_BITS2 = p_project_rtf_bits2,
         DELIVERABLE_RTF_BITS =p_deliverable_rtf_bits,
         WORK_PRODUCT_RTF_BITS = p_work_product_rtf_bits,
         SUMMARY_TASK_RTF_BITS = p_summary_task_rtf_bits,
         MILESTONE_RTF_BITS = p_milestone_rtf_bits,
         TASK_RTF_BITS = p_task_rtf_bits,
         REQUIREMENT_RTF_BITS = p_requirement_rtf_bits,
         CHANGE_REQUEST_RTF_BITS = p_change_request_rtf_bits,
         SERVICE_REQUEST_RTF_BITS = p_service_request_rtf_bits,
         DEFECT_RTF_BITS = p_defect_rtf_bits,
         ISSUE_RTF_BITS = p_issue_rtf_bits,
         RISK_RTF_BITS = p_risk_rtf_bits,
         CRI_DELIVERABLE_RTF_BITS = p_cri_deliverable_rtf_bits,
         CRI_SUMMARY_TASK_RTF_BITS = p_cri_summary_task_rtf_bits,
         CRI_MILESTONE_RTF_BITS = p_cri_milestone_rtf_bits,
         CRI_TASK_RTF_BITS = p_cri_task_rtf_bits,
         DOCUMENT_RTF_BITS = p_document_rtf_bits,
         ACTIONITEM_RTF_BITS = p_actionitem_rtf_bits,
         NOTEMIN_RTF_BITS = p_noteminute_rtf_bits,
         SCORECARD_RTF_BITS = p_scorecard_rtf_bits,
         BUDGET_SETTING_BITS = p_budget_setting_bits,
         ENABLE_EV_CALCULATION = p_enable_ev_calculation,
         CHARGEBACK_FORMULA = p_chargeback_formula,
         ROLLUP_PROJECT_ESTIMATED = h_new_RollupProjectEst,
         ROLLUP_DELIVERABLE_ESTIMATED = h_new_RollupDeliverableEst,
         NOTIFY_TM_REJECTED  = p_notify_tm_rejected,
         NOTIFY_TM_ACCEPTED  = p_notify_tm_accepted,
         NOTIFY_PM_SUBMITTED = p_notify_pm_submitted,
         NOTIFY_RM_SUBMITTED = p_notify_rm_submitted,
         COPY_CRI_CONSIDER_ASSIGNMENTS = p_def_cri_consider_assign,
         COPY_CRI_ADOPT_PARTICIPANTS = p_def_cri_adopt_participants,
         ASSIGNMENT_BILLABLE_FLAG = p_assignment_billable_flag,
         DLV_BUDGET_SETTING_BITS = p_dlv_budget_setting_bits
         WHERE PROJECT_ID =  p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 306+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(307) : wbs.sql(19668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
         h_project_id := p_id;
         
         If SubStr(h_timephase_flag, 1, 1) = 'N' Then
            BEGIN
               DELETE FROM TIMEPHASED_DELTA
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id
               AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET)
               AND CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_CHARGECODES
               WHERE CAPITAL_EXPENSE > PMO_CNST.SC_TIMEPHASE_CALENDAR);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 331+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(332) : wbs.sql(19693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM PROJECT_BUDGET_BREAKDOWN
               WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id
               AND BUDGET_TYPE IN (PMO_CNST.SC_ESTIMATED_BUDGET)
               AND CHARGECODE_ID IN (SELECT ELEMENT_ID FROM TMT_CHARGECODES
               WHERE CAPITAL_EXPENSE > PMO_CNST.SC_TIMEPHASE_CALENDAR);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 352+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(353) : wbs.sql(19714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_FLAG = 0,
               ESTIMATED_BUDGET = 0.00,
               ESTIMATED_ETC = 0.00
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_project_id
               AND CAPITAL_EXPENSE > PMO_CNST.SC_TIMEPHASE_CALENDAR;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 375+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(376) : wbs.sql(19737) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE BUDGETS
               SET TIMEPHASED_FLAG = 0
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_project_id
               AND CAPITAL_EXPENSE > PMO_CNST.SC_TIMEPHASE_CALENDAR;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 396+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(397) : wbs.sql(19758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            OPEN C_PA;
            LOOP
               FETCH C_PA INTO h_tsk_assignment_id, h_SD, h_FD, h_billable, h_capital_expense, h_reg_cost, h_reg_sale;
               IF C_PA%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If (PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS) Then
                  EXIT;
               End If;
               
               --trace_printf("SC_STATE: %d, h_tsk_assignment_id = %s, h_reg_cost: %.2f,h_reg_sale: %.2f, h_SD: %s, h_FD: %s\n", SC_STATE,h_tsk_assignment_id,h_reg_cost,h_reg_sale,h_SD,h_FD);
               h_tph_delete := 0;
               h_temp_sc_state := FC_TPHASE_SCHED_ASSIGN(h_project_id, h_project_id, h_tsk_assignment_id, h_SD
                                          , h_FD, h_reg_cost, h_reg_sale, h_tph_delete
                                          , h_capital_expense, h_billable);
            END LOOP;
            BEGIN
               CLOSE C_PA ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 427+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(428) : wbs.sql(19789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TASK_ASSIGNMENTS SET ROLLUP_BITS = PMO_CNST.SC_LABOR_BIT WHERE PROJECT_ID = h_project_id AND TASK_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 444+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(445) : wbs.sql(19806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         PMO_DB2M.SC_STATE := 0;
      End If;
   End If;
   
   -- update TMT_WBS.ROLLUP_BITS at project level (just update master project)
   If Coalesce(h_wbs_rollup_project_bit, 0) <> -1 Then
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_wbs_rollup_project_bit)
         WHERE ELEMENT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 469+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(470) : wbs.sql(19831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   -- update TMT_WBS.ROLLUP_BITS  at deliverable level (update all deliverables under project)
   If Coalesce(h_wbs_rollup_del_bit, 0) <> -1 Then
      -- if there is no deliverable ????
      BEGIN
         UPDATE TMT_WBS
         SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, h_wbs_rollup_del_bit )
         WHERE PROJECT_ID = h_project_id
         AND TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 493+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(494) : wbs.sql(19855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If PMO_DB2M.SC_STATE = 100 Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_PROJ_BITS', 504+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_PROJ_BITS(505) : wbs.sql(19866) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 512+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(513) : wbs.sql(19874) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_PROJ_BITS', 524+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_PROJ_BITS(525) : wbs.sql(19886) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_PROJ_BITS;
ALTER FUNCTION SP_U_PROJ_BITS COMPILE DEBUG;

/*********************************************************************/

Prompt == FUNCTION SP_U_WBS_ASSET ==
CREATE OR REPLACE FUNCTION SP_U_WBS_ASSET
(
     p_id VARCHAR2
   , p_asset_id VARCHAR2
   , p_asset_name VARCHAR2
   , p_financial_category PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_project_id VARCHAR2(32);
   h_rec_user VARCHAR2(32);
   h_id VARCHAR2(32);
   h_element_name VARCHAR2(255);
   h_asset_id VARCHAR2(32);
   h_asset_name VARCHAR2(255);
   h_old_asset_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
   h_financial_category PLS_INTEGER := 0;
   h_old_financial_category PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_transfer_flag VARCHAR2(1);
   h_cur_rank VARCHAR2(200);
   h_cri_count PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_ASSET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_ASSET'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_ASSET(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_asset_id || ''''
          || ', ' || '''' || p_asset_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_financial_category), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_ASSET(40) : wbs.sql(19942) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("PPPPPPPPPPP001a\n");
   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ASSET', 45+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ASSET(46) : wbs.sql(19948) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 48+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ASSET(49) : wbs.sql(19951) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_financial_category := p_financial_category;
   h_id := p_id;
   h_asset_id := p_asset_id;
   h_asset_name := p_asset_name;
   h_rec_user := p_rec_user;
   h_table_type := PMO_CNST.SC_TABLE_WBS;
   
   If (h_asset_name IS NULL) Then
      h_asset_id := NULL;
   End If;
   
   BEGIN
      SELECT PROJECT_ID, RANK, ASSET_ID, ASSET_FLAG, FINANCIAL_CATEGORY, TYPE_ID,
      ELEMENT_NAME, A_CRI_COUNT, TRANSFER_FLAG
      INTO h_project_id, h_rank, h_old_asset_id, h_asset_flag,
      h_old_financial_category, h_type_id,
      h_element_name, h_cri_count, h_transfer_flag
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(79) : wbs.sql(19981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ASSET', 85+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ASSET(86) : wbs.sql(19988) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 88+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ASSET(89) : wbs.sql(19991) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.RECORD_NOT_FOUND, p_id, True);
   End If;
   
   If (h_transfer_flag IS NOT NULL) Then
      BEGIN
         SELECT RANK INTO h_cur_rank
         FROM TMT_CRI
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 104+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(105) : wbs.sql(20007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (h_asset_id IS NOT NULL) Then
      --trace_printf("PPPPPPPPPPP001\n");
      If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_PARENT_HAS_ASSET Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ASSET', 114+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ASSET(115) : wbs.sql(20017) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_ASSET), 'NULL') || ' ID: ' || '''' || p_id || '''');
         END IF; 
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 117+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ASSET(118) : wbs.sql(20020) : ' || SYSTIMESTAMP);
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_ASSET, p_id, True);
      ElsIf Coalesce(h_asset_flag, 0) = PMO_CNST.SC_HAS_ASSET Then
         --trace_printf("PPPPPPPPPPP002\n");
         If Coalesce(h_financial_category, 0) <> Coalesce(h_old_financial_category, 0) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
            	End If; 
            END;
            BEGIN
               UPDATE TMT_WBS
               SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 151+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(152) : wbs.sql(20054) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CRI
               SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
               WHERE RANK LIKE h_rank || '%' AND TRANSFER_FLAG IS NOT NuLL);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 172+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(173) : wbs.sql(20075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If PMO_ORASTD.strcmp(h_old_asset_id, h_asset_id) <> 0 Then
            BEGIN
               UPDATE TMT_WBS
               SET ASSET_ID = h_asset_id,
               ASSET_NAME = h_asset_name,
               REC_USER = h_rec_user,
               REC_DATETIME = SYSTIMESTAMP
               WHERE ELEMENT_ID =  h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 196+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(197) : wbs.sql(20099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (h_transfer_flag IS NOT NULL) Then
               BEGIN
                  UPDATE TMT_CRI
                  SET ASSET_ID = h_asset_id,
                  ASSET_NAME = h_asset_name,
                  REC_USER = h_rec_user,
                  REC_DATETIME = SYSTIMESTAMP
                  WHERE ELEMENT_ID =  h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 219+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(220) : wbs.sql(20122) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'I'
               WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 239+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(240) : wbs.sql(20142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
               PMO_DB2M.SC_STATE := FC_I_ASSET(h_table_type, h_id, h_element_name, h_asset_id, h_type_id
                                , h_rec_user);
            End If;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'D'
               WHERE PARENT_ID = h_old_asset_id AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 263+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(264) : wbs.sql(20166) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'U'
               WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 282+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(283) : wbs.sql(20185) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         --trace_printf("PPPPPPPPPPP003\n");
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            -- there is any asset assigned to cri
            BEGIN
               SELECT 1 INTO h_count
               FROM DUAL
               WHERE EXISTS(SELECT PROJECT_ID FROM TMT_CRI
               WHERE PROJECT_ID = h_project_id
               AND ASSET_FLAG = PMO_CNST.SC_HAS_ASSET);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 303+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(304) : wbs.sql(20206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ASSET', 310+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ASSET(311) : wbs.sql(20213) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_ASSET), 'NULL') || ' ID: ' || '''' || p_id || '''');
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 313+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ASSET(314) : wbs.sql(20216) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_ASSET, p_id, True);
            End If;
            
            BEGIN
               UPDATE TMT_ASSETS
               SET REC_STATUS = 'D'
               WHERE (ELEMENT_ID, PARENT_ID) IN (SELECT ELEMENT_ID, ASSET_ID FROM TMT_WBS
               WHERE PROJECT_ID = h_project_id AND ASSET_ID IS NOT NuLL);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 333+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(334) : wbs.sql(20236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS
               SET ASSET_ID = NuLL,
               ASSET_NAME = NuLL,
               ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET,
               FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE PROJECT_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 356+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(357) : wbs.sql(20259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CRI
               SET ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET
               WHERE PROJECT_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 375+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(376) : wbs.sql(20278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_financial_category, 0) <> Coalesce(h_old_financial_category, 0) Then
               BEGIN
                  UPDATE TMT_CRI
                  SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
                  THEN h_financial_category ELSE FINANCIAL_CATEGORY END
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
                  WHERE PROJECT_ID = h_project_id AND TRANSFER_FLAG IS NOT NuLL);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 398+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(399) : wbs.sql(20301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            If (Coalesce(h_cri_count, 0) > 0) OR (((h_transfer_flag IS NULL)) AND (NOT isTask(Coalesce(
                  h_type_id, 0)) <> 0)) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ASSET', 407+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ASSET(408) : wbs.sql(20310) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_ASSET), 'NULL') || ' ID: ' || '''' || p_id || '''');
               END IF; 
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 410+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ASSET(411) : wbs.sql(20313) : ' || SYSTIMESTAMP);
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_ASSET, p_id, True);
            End If;
            
            If (h_transfer_flag IS NOT NULL) Then
               -- there is any asset assigned to cri
               BEGIN
                  SELECT 1 INTO h_count
                  FROM DUAL
                  WHERE EXISTS(SELECT PROJECT_ID FROM TMT_WBS
                  WHERE RANK LIKE h_rank || '%' AND A_CRI_COUNT > 0);
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 428+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(429) : wbs.sql(20331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS) Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ASSET', 435+1) THEN 
                     LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ASSET(436) : wbs.sql(20338) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_ASSIGN_ASSET), 'NULL') || ' ID: ' || '''' || p_id || '''');
                  END IF; 
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ASSET', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ASSET(439) : wbs.sql(20341) : ' || SYSTIMESTAMP);
                  END IF; 
                  PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.CANNOT_ASSIGN_ASSET, p_id, True);
               End If;
               
               DECLARE 
               	nLen pls_integer :=0; 
               BEGIN 
               	If (h_rank IS NOT NULL) Then 
               		nLen := Coalesce(Length(h_rank), 0); 
               		If 0 <> 0 AND nLen <> 0 Then 
               		nLen := nLen - 1; 
               		End If; 
               	End If; 
               	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
               		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
               	End If; 
               END;
               BEGIN
                  UPDATE TMT_ASSETS
                  SET REC_STATUS = 'D'
                  WHERE (PARENT_ID, ELEMENT_ID) IN (SELECT ASSET_ID, ELEMENT_ID FROM TMT_WBS
                  WHERE RANK LIKE h_rank || '%' AND ASSET_ID IS NOT NuLL);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 471+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(472) : wbs.sql(20374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TMT_WBS
                  SET ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET,
                  ASSET_ID = NuLL,
                  ASSET_NAME = NuLL,
                  FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
                  THEN h_financial_category ELSE FINANCIAL_CATEGORY END
                  WHERE RANK LIKE h_rank || '%';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 494+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(495) : wbs.sql(20397) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               DECLARE 
               	nLen pls_integer :=0; 
               BEGIN 
               	If (h_cur_rank IS NOT NULL) Then 
               		nLen := Coalesce(Length(h_cur_rank), 0); 
               		If 0 <> 0 AND nLen <> 0 Then 
               		nLen := nLen - 1; 
               		End If; 
               	End If; 
               	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
               		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, True); 
               	End If; 
               END;
               BEGIN
                  UPDATE TMT_CRI
                  SET ASSET_FLAG = PMO_CNST.SC_PARENT_HAS_ASSET,
                  ASSET_ID = NuLL,
                  ASSET_NAME = NuLL,
                  FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
                  THEN h_financial_category ELSE FINANCIAL_CATEGORY END
                  WHERE RANK LIKE h_cur_rank || '%';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 530+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(531) : wbs.sql(20433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TMT_CRI
                  SET ASSET_ID = h_asset_id,
                  ASSET_NAME = h_asset_name,
                  ASSET_FLAG = PMO_CNST.SC_HAS_ASSET,
                  FINANCIAL_CATEGORY = h_financial_category,
                  REC_USER = h_rec_user,
                  REC_DATETIME = SYSTIMESTAMP
                  WHERE ELEMENT_ID =  h_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 554+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(555) : wbs.sql(20457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
         
         BEGIN
            UPDATE TMT_WBS
            SET ASSET_ID = h_asset_id,
            ASSET_NAME = h_asset_name,
            ASSET_FLAG = PMO_CNST.SC_HAS_ASSET,
            FINANCIAL_CATEGORY = h_financial_category,
            REC_USER = h_rec_user,
            REC_DATETIME = SYSTIMESTAMP
            WHERE ELEMENT_ID =  h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 580+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(581) : wbs.sql(20483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'I'
            WHERE PARENT_ID = h_asset_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 599+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(600) : wbs.sql(20502) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
            PMO_DB2M.SC_STATE := FC_I_ASSET(h_table_type, h_id, h_element_name, h_asset_id, h_type_id
                                , h_rec_user);
         End If;
      End If;
   Else
      --trace_printf("PPPPPPPPPPP007\n");
      If (Coalesce(h_asset_flag, 0) = PMO_CNST.SC_PARENT_HAS_ASSET) OR (Coalesce(
             h_asset_flag, 0) = PMO_CNST.SC_WITHOUT_ASSET) Then
         If Coalesce(h_financial_category, 0) <> Coalesce(h_old_financial_category, 0) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
            	End If; 
            END;
            If Coalesce(h_asset_flag, 0) = PMO_CNST.SC_WITHOUT_ASSET Then
               BEGIN
                  UPDATE TMT_ASSETS
                  SET REC_STATUS = 'U'
                  WHERE (PARENT_ID, ELEMENT_ID) IN (SELECT ASSET_ID, ELEMENT_ID FROM TMT_WBS
                  WHERE RANK LIKE h_rank || '%' AND ASSET_ID IS NOT NuLL);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 643+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(644) : wbs.sql(20546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               UPDATE TMT_WBS
               SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 664+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(665) : wbs.sql(20567) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CRI
               SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
               WHERE RANK LIKE h_rank || '%' AND TRANSFER_FLAG IS NOT NuLL);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 685+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(686) : wbs.sql(20588) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      Else
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE TMT_WBS
               SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
               FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE PROJECT_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 708+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(709) : wbs.sql(20611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_CRI
               SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET
               WHERE PROJECT_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 727+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(728) : wbs.sql(20630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_financial_category, 0) <> Coalesce(h_old_financial_category, 0) Then
               BEGIN
                  UPDATE TMT_CRI
                  SET FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
                  THEN h_financial_category ELSE FINANCIAL_CATEGORY END
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
                  WHERE PROJECT_ID = h_project_id AND TRANSFER_FLAG IS NOT NuLL);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 750+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(751) : wbs.sql(20653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf (h_transfer_flag IS NOT NULL) Then
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_rank, True); 
            	End If; 
            END;
            BEGIN
               UPDATE TMT_WBS
               SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
               ASSET_ID = NuLL,
               ASSET_NAME = NuLL,
               FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE RANK LIKE h_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 787+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(788) : wbs.sql(20690) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            DECLARE 
            	nLen pls_integer :=0; 
            BEGIN 
            	If (h_cur_rank IS NOT NULL) Then 
            		nLen := Coalesce(Length(h_cur_rank), 0); 
            		If 0 <> 0 AND nLen <> 0 Then 
            		nLen := nLen - 1; 
            		End If; 
            	End If; 
            	If NOT nLen <> 0 OR (nLen MOD 4) <> 0 Then 
            		PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_RANK_LIKE, h_cur_rank, True); 
            	End If; 
            END;
            BEGIN
               UPDATE TMT_CRI
               SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
               ASSET_ID = NuLL,
               ASSET_NAME = NuLL,
               FINANCIAL_CATEGORY = CASE WHEN FINANCIAL_CATEGORY = h_old_financial_category
               THEN h_financial_category ELSE FINANCIAL_CATEGORY END
               WHERE RANK LIKE h_cur_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 823+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(824) : wbs.sql(20726) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            UPDATE TMT_WBS
            SET ASSET_FLAG = PMO_CNST.SC_WITHOUT_ASSET,
            ASSET_ID = NuLL,
            ASSET_NAME = NuLL,
            FINANCIAL_CATEGORY = h_financial_category
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 846+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(847) : wbs.sql(20749) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_ASSETS
            SET REC_STATUS = 'D'
            WHERE PARENT_ID = h_old_asset_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 865+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(866) : wbs.sql(20768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If (PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA) Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_ASSET', 877+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_ASSET(878) : wbs.sql(20780) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 885+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(886) : wbs.sql(20788) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ASSET', 897+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ASSET(898) : wbs.sql(20800) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_ASSET;
ALTER FUNCTION SP_U_WBS_ASSET COMPILE DEBUG;

/***************************************************************************************************************/

Prompt == FUNCTION SP_U_WBS_ELEMENT_FLAG ==
CREATE OR REPLACE FUNCTION SP_U_WBS_ELEMENT_FLAG
(
     p_id VARCHAR2
   , p_element_flag PLS_INTEGER
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_rec_user VARCHAR2(32);
   h_id VARCHAR2(32);
   h_element_flag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_U_WBS_ELEMENT_FLAG') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_U_WBS_ELEMENT_FLAG'), '-- ' || SYSTIMESTAMP, ':r := SP_U_WBS_ELEMENT_FLAG(' || 
       '''' || p_id || ''''
          || ', ' || COALESCE(TO_CHAR(p_element_flag), 'NULL')
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ELEMENT_FLAG', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_U_WBS_ELEMENT_FLAG(22) : wbs.sql(20838) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_id IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'SP_U_WBS_ELEMENT_FLAG', 26+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: SP_U_WBS_ELEMENT_FLAG(27) : wbs.sql(20843) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL') || ' ID: ' || '''' || p_id || '''');
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_U_WBS_ELEMENT_FLAG', 29+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_U_WBS_ELEMENT_FLAG(30) : wbs.sql(20846) : ' || SYSTIMESTAMP);
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR_SP(PMO_CNST.INVALID_PARAMS, p_id, True);
   End If;
   
   h_id := p_id;
   h_rec_user := p_rec_user;
   h_element_flag := p_element_flag;
   
   BEGIN
      UPDATE TMT_WBS
      SET ELEMENT_FLAG = h_element_flag
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ELEMENT_FLAG', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ELEMENT_FLAG(53) : wbs.sql(20869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(4, 'SP_U_WBS_ELEMENT_FLAG', 58+1) THEN 
      LFILE.FPUT('AllTrace', '       RETURN_STATUS: SP_U_WBS_ELEMENT_FLAG(59) : wbs.sql(20875) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || p_id || '''');
   END IF; 
   PMODEFINES.PMO_RETURN_STATUS(PMO_DB2M.SC_STATE, p_id, True);
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ELEMENT_FLAG', 66+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ELEMENT_FLAG(67) : wbs.sql(20883) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_U_WBS_ELEMENT_FLAG', 78+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_U_WBS_ELEMENT_FLAG(79) : wbs.sql(20895) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_U_WBS_ELEMENT_FLAG;
ALTER FUNCTION SP_U_WBS_ELEMENT_FLAG COMPILE DEBUG;

